/**. <pre> 
 *======================================================================
 * Project     : TS
 * Program     : TSUtil.java
 * State       : 00.00.2012 (compare to file-date)
 * Version     : J3.x
 * Modul-ID    : -none-
 *
 * Description : Collection of modules (functions) to administer
 *                a TrainSimulator-Route
 * Remarks     :  -none-
 *
 *======================================================================
 </pre>*/
import java.io.*;
import java.text.*;
//import java.lang.reflect.*;
import java.util.*;
import java.util.zip.*;
import java.util.regex.*;
import java.util.concurrent.*;
import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
/**. <pre>
 *======================================================================
 * Class TSUtil
 * Option-values (max) of 'int': 2,3,5,7,11,13,17,19,23,29
 *   (coded using primenumber-method)
 * ##TSUtil (Eyecatcher)
 *======================================================================
 </pre>*/
public class TSUtil implements Serializable { /* TS-Utility (Basis) */
 /*-------------------------------------------------------------------*/
  protected static final String Version = "3.6.05"; /* curr. version */
  protected static final String SpVers  = "G-20121001"; /* Kennung */
 /*-------------------------------------------------------------------*/
  private static final int[]             TDdx = {0,1,1,0};
  private static final int[]             TDr  = {3,0,2,1};
  private static final String[]          TleP = {"Tile","LO-Tile"};
  private static final String[]          TleS = {".td",".tdl"};
  private static final Runtime           gRE  = Runtime.getRuntime();
  private static final String            DataPath = "TSUtilData";
  private static final String            DataName = "Global.txt";
 /*-------------------------------------------------------------------*/
  protected static final Locale          cLoc = Locale.getDefault();
    /* get 'Locale' for default-language (unmodified) */
  protected static final DecimalFormat   DF2 = new DecimalFormat("00");
  protected static final DecimalFormat   DF3 = new DecimalFormat("000");
  protected static final DecimalFormat   DF4 = new DecimalFormat("0000");
  protected static final String          tx1   = "ffeditc_unicode \"";
  protected static final String          tx2   = "\" /u \"/o:";
  protected static final String          Zif   = "0123456789";
  protected static final String          StDL  = "0123456789+";
  protected static final long            NoVS  = 4294967280L;
  protected static int                   sca   = 376;
  protected static int                   scn   = 40000;
  protected static int                   sha   = 263;
  protected static int                   shn   = 40000;
  protected static TSOpts                PrMsk = new TSOpts(-1); /* all */
  protected static double                dDist = 0.99; /* distance */
 /*-------------------------------------------------------------------*/
  protected static final int             mxLvl = 30; /* max. Iteration */
  protected static final int             TrN_T = 16; /* TrN-Typ(Max) */
  protected static final int             ZL    = 600; /* Zeilenlaenge */
 /*-------------------------------------------------------------------*/
  protected static TSLogg                Lg;     /* Logging-Definition */
  protected static String                CRLF;   /* Line-separator */
  protected static String                OSName; /* OS-Name */
  protected static String                OSVer;  /* OS-Version */
  protected static String                JVName,JVer; /* Java-Version */
  protected static String                Kdo;    /* akt. Kommando */
  protected static String                fn;     /* File-Name */
  protected static String                vn2;    /* Dir.-Name */
  protected static String                vn3;    /* Dir.-Name */
  protected static boolean               EnaW,EnaH; /* errormessages */
  protected static int                   c0,c1,c2,c3,c4,c5; /* Zaehler */
  protected static int                   shl,shh,shd,scl,sch,scd;
  protected static int                   ShA,ScA,ShN,ScN;
 /*-------------------------------------------------------------------*/
  protected static Object                RetVal; /* global return-value */
    /* Field is used as a secondary 'return-value' and set within method:
     * TSUtil.getPos(), TSUtil.chkPos(), TSUtil.getQDir(),
     * TSUtil.getActDef(), TSUtil.getActEv(), TSUtil.getTrfDef(),
     * TSUtil.getTrain(), TSUtil.getTrWgn(),
     * TSUtil.chkPath(), TSUtil.putWrld(), TSUtil.putSnd(),
     * TSRoute.$bFle(), TSTrItm.setIRef(), TSTrItm.setPos(),
     * TSRoute.getFile(),
     * TSView.crVS(), TSActEv.fndTrI(), TSActSZ.setPos()
     * TSStop.fndTrI(),TSStop.chgID(),TSStStp.corrS(),TSStStp.corrT()
     *
     * Attention: This field is ALSO used to support 'TSActEv.crDef()'
     *            with an additional argument.
     */
  protected static File                  pFle; /* curr. file-argument */
  protected static TSData                Fo;   /* function-arguments */
  protected static TSOpts                FoX;  /* ext. function-options */
  protected static TSTemp                gT;   /* tempory definitions */
  protected static File                  gD;   /* tempory directory */
  protected static TSFile                gC;   /* global IO-control (ctl) */
  protected static TSFile                gF;   /* global IO-control (dta) */
  protected static TSByteArrIO           gB;   /* binary IO-buffer */
  protected static TreeSet<String>       gN;   /* global names */
 /*-------------------------------------------------------------------*/
  protected static TSSect[]              ScTab; /* Section-table */
  protected static TSShape[]             ShTab; /* Shape-table */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  public TSUtil() /* Constructor is not explicitely used */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
  }

 /**. <pre>
  *=====================================================================
  * Hauptprogramm TSUtil
  *
  * wird nur der Programmparameter '?' angegeben, wird eine kurze
  *  Bedienungsanleitung ausgegeben
  *
  * AlLgemeine Festlegungen fuer Funktionsoptionen(Var='Fo'):
  *    0..15 - benutzt von aktueller Funktion
  *   16..19 - gemeinsame lokale Optionen
  *       16 : Erweiterte Ausgaben in Datei ('-d')
  *       17 : Ausgangsdateien Ueberschreiben ('-inplace')
  *       18 : Strukturdatendatei reparieren ('-tdrepair')
  *       19 :
  *   20..31 - globale Optionen
  *       20 : Batch-Modus aktiv ('-$B')
  *       21 :
  *       22 : type-marker 1 for local options
  *       23 : type-marker 2 for local options
  *       24 : Sicherungsdatei schreiben ('-s')
  *       25 : Meldungs-Schluessel einschalten ('-k')
  *       26 : Log-Ausgabe an vorhandene Datei anhaengen ('-L')
  *       27 :
  *       28 : Funktion NICHT ausfuehern ('-$Z')
  *       29 : tdb-Datei formatieren ('-$S')
  *       30 : Zeitmessung durchfuehren ('-$T')
  *       31 : Print Debug-Messages ('-$X') (together with 'PrMsk')
  *
  * ##main (Eyecatcher)
  *=====================================================================
  </pre>*/
  public static void main( /* Start des Haupt-Programms */
   String[] args) /* Aufruf-Parameter */
   {
   /*-----------------------------------------------------------------*/
    Properties        sysprop; /* System Properties */
    TSArrList         cL;      /* current data-queue/list */
    TSLogg            cLg;     /* Logging-Definition (temp) */
    TSBuf             cB;      /* current input-buffer */
    TSOpts            Msk;     /* current option-mask */
    TSCopySet         cCpySet; /* temporary 'CopySet' */
    File              dir;     /* temp. directory */
    int               i,j,k;   /* intermediate value */
    double            f;       /* intermediate value */
    char              cc;      /* current command-character */
    boolean           uc;      /* 'Uppercase' if 'true' */
    Pattern           Pt;      /* compiled 'regular expression' */
    String[]          cS;      /* current string-array */
    String            is;      /* intermediate value */
   /*=================================================================*/
    /* Phase --0--: Steuerkonstanten zuruecksetzen */
    sysprop = System.getProperties(); /* get pointer to properties */

    is = TSLogg.getKey("Version"); /* Versions-Kennung holen */
    if(!is.equals(Version)) { /* Message-Datei passt nicht */
      if(is.indexOf("****")>=0) is = "?.?.??"; /* Message fehlt */
      TSLogg.Print("Msg999",Version,is); /* Beschreibung ausgeben */
      System.out.println(); /* Leerzeile hinzufuegen */
    } /* Meldungs-datei passte nicht */

    /* holen der Standard-Definitionen */
    CRLF   = sysprop.getProperty("line.separator");
    OSName = sysprop.getProperty("os.name").toLowerCase();
    OSVer  = sysprop.getProperty("os.version").toLowerCase();
    JVName = sysprop.getProperty("java.vendor").toLowerCase();
    JVer   = sysprop.getProperty("java.version").toLowerCase();

    Lg   = null; /* kein Logging-Objekt */
    Kdo  = "TSUtil"; /* preset current command-line provided */
    Fo   = new TSData(7); /* Parameterspeicher initialisieren
      * Speicher-Queue-Belegung: (Str = String)
      *   0 - (Str) temporaere Nutzung, provisorische Fehler-Tabelle (ETab)
      *   1 - (int) Allocation-map of Shape-Definitions
      *       0    - temporary value (dcpy)
      *       1    - StaticDetailLevel(1) for corrections of SectionIDX-values
      *       2    - StaticDetailLevel(2) for corrections of SectionIDX-values together with filenames
      *       3..  - Allocation-map for Shape-Definitions (2 entries each)
      *   2 - (Str) fix parameter-values:
      *       0..9 - current global path-definitions (e.g. 'Hidewire'-Paths)
      *       10  - (Str/Pattern) - Selection-expression using filenames ('cvrt'-option '-g'/'-G')
      *       11.. - More definitions according to entry 10
      *   3 - HideWire-Zuordnungen('h'/'f'), Dateinamen-Modifikation('m'/'M')
      *       0  - (TSOpts) - Mask of included StaticDetailLevel (Hidewire-process)
      *       1  - (TSOpts) - Mask of included StaticDetailLevel (Filename-modification)
      *       Definitions for StaticDetailLevel '1':
      *       2  - (int) - '-1' if NOT active ( Mode 'h'), Shape-Number if mode 'f' is used,
      *                    Number selecting the 'Common Accesspath' for mode 'h' (0..9)
      *       3  - (Str) - Conditional accesspath, 'null' if not used.
      *       4  - (Str/Pattern) - Selection-expression applied to filenames, 'null' if NOT active
      *       5  - (Str) - Replacement-expression for filenames, 'null' if NOT active
      *       6  - (TSCopySet) - Source-directory for copy of files, 'null' if NOT active (ignored!)
      *       Definitions for StaticDetailLevel '2':
      *       7..11  - Format compare to StaticdetailLevel 1
      *       Definitions for StaticDetailLevel '3':
      *       12..16 - Format compare to StaticdetailLevel 1
      *       More definitions matching StaticDetailLevel '0,4..9' using format:
      *       17 - (TSOpts) - Mask of included StaticDetailLevel (Modus 'm'/'M')
      *       18 - (Str) - Conditional accesspath, 'null' if not used.
      *       19 - (Str/Pattern) - Selection-expression applied to filenames
      *       20 - (Str/Str[]) - Replacement-expression for filenames, 'null' if NOT active
      *       21 - (TSCopySet) - Source-directory for copy of files, 'null' if NOT active (ignored!)
      *       22.. - More definitions according to entry 17..21
      *   4 - Recovery-Assignments (Static->TrkObj) / Additional function-arguments
      *     - Common valid arguments (various options)
      *       0  - (float) - modification-value for 'height of overheadwire'
      *       1  - (Str) - Filename of current 'tsection.dat'-file ('null' if default is used)
      *       2  - (TSOpts) - Type of recovery-definition (set if 'Modification'-mode active)
      *     - Recovery-Definitions (Option 'z'/'Z' of 'cvrt' / 'ichk', 'Hidewire'-mode)
      *       3  - (int) - Number of requested (new) StaticDetailLevel ('Hidewire'-mode)
      *       4  - (Str) - Selection-expression applied to filenames
      *       5  - (Str) - Replacement-expression for filenames, 'null' if NOT active
      *       6.. - More definitions according to entries 3..5
      *     - Recovery-Definitions (Option 'z'/'Z' of 'cvrt' / 'ichk', 'Modification'-mode)
      *       3  - (int) - Number of requested (new) StaticDetailLevel ('Modification'-mode)
      *       4  - (Str/Pattern) - Selection-expression applied to filenames
      *       5  - (Str) - Replacement-expression for filenames, 'null' if NOT active
      *       6.. - More definitions according to entries 3..5
      *   5 - Usage depends on selected function
      *       0  - (TSOpts) - Default-Mask (preset with '0'=TSOpts(0))
      *     a) Function 'cvrt' (Option 'a'/'A')
      *       0  - (TSOpts) - Mask of all included 'StaticDetailLevel's
      *       1  - (TSOpts) - Matching StaticDetailLevel
      *       2  - (Str/Pattern) - Selection-expression applied to filenames
      *       3  - (int) - StaticDetailLevel of target after modification
      *       4  - (Str) - Conditional accesspath, 'null' if not used.
      *       5  - (int) - StaticDetailLevel to be inserted into newly created objects
      *       6  - (TSCopySet) - Source-directory for copy of files 1, 'null' if NOT active
      *       7  - (Str) - Replacement-expression for filenames 1
      *       8  - (TSCopySet) - Source-directory for copy of files 2, 'null' if NOT active
      *       9  - (Str) - Replacement-expression for filenames 2, 'null' if NOT active
      *      10  - (TSCopySet) - Source-directory for copy of files 3, 'null' if NOT active
      *      11  - (Str) - Replacement-expression for filenames 3, 'null' if NOT active
      *      12.. - More definitions according to entries 1..11
      *     b) Function 'world' (Option 'm'/'M', 's'/'S')
      *       0  - (TSOpts) - Mask of NOT included StaticDetailLevel
      *       1  - (Str) - Suffix of created ('s'/'S') or read ('m'/'M') filenames
      *       2.. - More definitions according to entry 1 (Option 'm'/'M')
      *     c) Function 'fcpy' (Option 'm'/'M')
      *       0  - (TSOpts) - Slot is not used.
      *       1  - (Str) - Replacement-expression for filenames, 'null' if NOT active
      *       2  - (Str/Pattern) - Selection-expression applied to line-data/file
      *       3  - (Str) - Replacement-expression for line-data/file
      *       4.. - More definitions according to entries 2..3
      *     d) Function 'chgSig' (Option 'c'/'C').
      *       0  - (TSOpts) - Slot is not used.
      *       1  - (TSCopySet) - Source-directory for copy of files.
      *     d) Function 'mveobj' (Basis + Option 't'/'T')
      *       0  - (TSOpts) - Slot is not used.
      *       1  - (float) - move-distance x (Basis-entry).
      *       2  - (float) - move-distance y/h (Basis-entry).
      *       3  - (float) - move-distance z (Basis-entry).
      *       4  - (TSOpts) - Objectmask for inclusion of additional objects.
      *       5  - (Str/Pattern) - Selection-expression applied to filenames
      *       6.. - More definitions according to entries 4..5
      *   6 - Global directory-assignments of global option 'q'/'Q' etc.
      *       0..9 - (TSCopySet) - assigned source-directories, 'null' if not used.
      *     a) Function 'cvrt' (Option 'o'/'O') (Option 'l'/'L').
      *      10  - (TSOpts) - Selectionmask of objecttypes (inclusiv subfunction-marker).
      *      11  - (Str/Pattern) - Selection-expression applied to filenames
      *      12..13 - Meaning depends on selected subfunction.
      *      Subfunction X'01': Modify 'StaticFlags'-value.
      *      12  - (int) - Modificationmask(OR) of current 'StaticFlags'-value.
      *      13  - (int) - Modificationmask(AND) of current 'StaticFlags'-value.
      *      Subfunction X'02': Change 'StaticDetailLevel'
      *      12  - (TSOpts) - Selectionmask of included 'StaticDetailLevel'(s).
      *      13  - (int) - New value for 'StaticDetailLevel'.
      *      Subfunction X'04': --- still not used ---
      *      12  -
      *      13  -
      *      14.. - Optional more definitions according to entries 10..13
      *             Each subfunction must allocate exactly 4 entries.
      */
    FoX  = new TSOpts(); /* initialize extended function-options */
    pFle = null; /* kein aktiver/aktueller File-Parameter */
    EnaH = EnaW = true; /* Hinweise und Warnungen ausgeben */
    gN   = null; /* no global marker (used within 'getWF()') */

    /* Phase --1--: Argumente analysieren */
    if(Fo.cr$Obj(0,0)) System.exit(98); /* Fehlerliste auf JEDEN Fall erstellen */
    if(args.length==1) chkS:{ /* special requests ? */
      if(args[0].equals("?")) { /* output of syntax requested */
        TSLogg.Print("Msg000"); /* Bedienungshinweis ausgeben */
        System.out.println(); /* Leerzeile hinzufuegen */
        {String[] $={" ","\n",Version};
          TSLogg.Print("Msg101",$); /* Version ausgeben */
          TSLogg.Print("Msg102",$); /* Teil der Message ausgeben */
          TSLogg.Print("Msg103",$); /* Teil der Message ausgeben */
          TSLogg.Print("Msg104",$); /* Teil der Message ausgeben */
        } /* output of syntax is done */
        System.out.println(); /* Leerzeile hinzufuegen */
        return; /* program successfully performed */
      } /* end program -- requested function successfully performed */
      if(args[0].length()<7) break chkS; /* no valid request possible */
      if(args[0].charAt(0)!='=') break chkS; /* no valid request possible */
      is = args[0].substring(1,7); /* get version-identifier */
      if(!Pattern.matches("\\d\\.\\d\\.\\d\\d",is)) break chkS;
        /* provided value has invalid form -- do not check */
      i = is.compareTo(Version); /* compare requested versions */
      if(i<0) return; /* current version is OKAY */
      if(i>0) System.exit(1); /* current version is too less */
      if(args[0].length()==7) return; /* NO additional information available */
      cc = Character.toUpperCase(args[0].charAt(7)); /* get next version-identifier */
      if(!Character.isLetter(cc)) return; /* NO valid letter available -- OKAY */
      if(SpVers.length()<1) System.exit(2); /* current version is too less */
      if(cc>SpVers.charAt(0)) System.exit(2); /* current version is too less */
      return; /* program successfully performed */
    } /* -chkS- special request successfully processed */

    /* preset entries within queues and set default-values */
    if(SpVers.endsWith("@")) try{ System.setErr(new PrintStream("TSUtil.Err"));
      } catch (FileNotFoundException e) {}; /* change destination for error-output */
    Fo.setInt(1,0); /* Marker: StaticDetailLevel(1) of corrections is missing (default-queue(1)) */
    /* Dummy-entry '0' is imlicitely generated although it is (still) not used */
    Fo.setInt(2,0); /* Kennung: StaticDetailLevel(2) of corrections is missing (default-queue(1)) */
    Fo.setDta(2,0,"../../Routes/%0/Shapes/"); /* insert Default-Path */
    Fo.setDta(2,1,"Msg016"); /* set message-id describing second default-path */
      /* The original requested path-name is too short (<8Characters) -- so, a message-id must be used */
    Fo.addObj(3,new TSOpts()); /* add default-control-record (Hidewire) (entry 0) */
    Fo.addObj(3,new TSOpts()); /* add second default-control-record (filename-modification) (entry 1) */
    Fo.addObj(4,new Double(Double.NaN)); /* set marker: value not provided */
    Fo.addObj(4,null); /* Filename of current 'tsection.dat'-file or 'null' if default is used */
    Fo.addObj(4,new TSOpts()); /* add control-record for type of recovery-entry */
    Fo.addObj(5,new TSOpts()); /* Store Default-Mask and create entry '0' */

    /* check and process (global) arguments, which are provided */
    /* add aditional (global) argument if it is requested */
    if((fn=getEnv(DataPath,true))!=null) gip: { /* get global input-path and check existance */
      dir = new File(fn); /* use value as path to data-directory */
      if(!dir.exists()) break gip; /* directory do not exist -- ignore it */
      if(!dir.isDirectory()) break gip; /* no directory available -- ignore it */
      dir = new File(dir,DataName); /* create path to optional optionsfile */
      if(!dir.exists()) break gip; /* optionfile does not exist -- ignore it */
      cS = new String[args.length+1]; /* expand current option-array */
      cS[0] = "-@" + dir.getAbsolutePath(); /* create synthetical argument for call */
      System.arraycopy(args,0,cS,1,args.length); /* copy all other arguments */
      args = cS; /* and activate new argument-set */
    } /* -gip- additional argument was successfully checked */
    /* process all global arguments */
    i = 0; /* init pointer to current global option */
    gF = null; /* no global buffered input used (optionfile is NOT active) */
    /* pruefen auf GLOBALE Optionen */
    while(i<args.length) { /* check all specified 'global options' */
      cB = new TSBuf(chkOFle(args[i],"MsgGZ")); /* use optionfile if active */
      if(gF!=null) i -= 1; /* optionfile is (still) active -- handle pointer
          * Set pointer back to previuos item.
          * Pointer 'i' is NOT increased while optionfile is active. Because it
          * is increased by default is must be decremented again in this case.
          */
      Kdo += cB.getPrnt(); /* add current command for printing */

      uc = false; /* preset: option uses lower case */
      if(cB.length()<2) break; /* Keine Option mehr angegeben */
      if(cB.charAt(true)!='-') break; /* no more options specified */
      switch(cc=cB.charAt(true)) { /* select continuation due to next char */
        case('@'): /* handle request to establish an optionfile as input-source */
          if(actOFle(cB,"MsgGZ",true)) System.exit(15); /* error -- terminate */
          Kdo += CRLF; /* add 'newline' for printing as marker */
          break; /* OK -- command is processed -- continue with next one */
        case('E'): /* Ausgabe erst ab ERROR-Level gefordert */
        case('e'): EnaH = EnaW = false; /* Hinweise und Warnungen unterdruecken */
          break; /* command is processed -- continue with next one */
        case('J'): /* StaticDetailLevel fuer Korrekturen von SectionIDX-Werten */
        case('j'): /* StaticDetailLevel fuer TrkObj- / DynTrack-Objekte */
          j = cB.length(); /* get length of option for checking */
          if(j!=3 && j!=5) { /* invalid length of option - terminate */
            TSLogg.prtMsg("MsgG41",cB.getLne(1),""+j); /* print errormessage */
            break; /* do not activate option */
          } /* invalid length -- do not activate option */
          j = "x123456789".indexOf(cc=cB.charAt(true)); /* convert digit */
          if(j<=0) { /* ungueltiger StaticDetailLevel angegeben */
            TSLogg.prtMsg("MsgG42",cB.getLne(1),""+cc); /* Meldung erstellen */
            break; /* do not activate option */
          } /* invalid StaticDetailLevel -- do not activate option */
          Fo.setInt(1,j); /* 'StaticDetailLevel' speichern und Funktion aktivieren */
          Fo.setInt(2,j); /* set default, if second value missing */
          if((cc=cB.charAt(true))!=':') { /* invalid separator */
            if (cc=='\n') break; /* end of line is allowed here */
            TSLogg.prtMsg("MsgG43",cB.getLne(1),""+cc); /* print error */
            break; /* do not activate option */
          } /* invalid separator -- do not activate option */
          j = "x123456789".indexOf(cc=cB.charAt(true)); /* convert digit */
          if(j<=0) { /* ungueltiger StaticDetailLevel angegeben */
            TSLogg.prtMsg("MsgG44",cB.getLne(1),""+cc); /* Meldung erstellen */
            break; /* do not activate option */
          } /* invalid StaticDetailLevel -- do not activate option */
          Fo.setInt(2,j); /* 2. 'StaticDetailLevel' speichern */
          break; /* command is processed -- continue with next one */
        case('L'): Fo.setMsk(26); /* switch on (Default-)Logging */
        case('l'): if(Lg!=null) break; /* Logging is already activated */
          if(cB.length()>2) Lg = chkLog(cB.getTail(true)); /* check filename for LOG */
          if(Lg==null) Lg = new TSLogg("TSUtil.log"); /* create Def-Logging-Object */
          break; /* command is processed -- continue with next one */
        case('K'): /* Meldungs-Schluessel einschalten */
        case('k'): Fo.setMsk(25); /* Schluesselausgabe veranlassen */
          break; /* command is processed -- continue with next one */
        case('M'): /* alternativer Kennbuchstabe fuer Option */
        case('m'): /* Meldungskennung spezifizieren fuer Unterdrueckung */
          is = cB.getVal(1); /* extract ID of message */
          if(is==null) { /* EOF within data (length-error?) */
            TSLogg.prtMsg("MsgGA1",cB.getLne(1)); /* print errormessage */
            break; /* do not activate option */
          } /* EOF found -- do not activate option */
          if(is.length()>8 || is.length()<1) { /* length of key too large /no key */
            TSLogg.prtMsg("MsgGA2",cB.getLne(1)); /* print errormessage */
            break; /* do not activate option */
          } /* EOF found -- do not activate option */
          if(!TSLogg.setKey(is)) break; /* Schluessel erfolgreich gesetzt -- OK */
          TSLogg.prtMsg("MsgGA3",is); /* Meldung erstellen */
          break; /* command is processed -- continue with next one */
        case('P'): /* alternativer Kennbuchstabe fuer Option */
        case('p'): /* relative Pfad-Definition fuer Track-Objekte definieren */
          k = "\nx23456789".indexOf(cB.charAt(true)); /* convert digit */
          if(k<2) { /* invalid path-number found */
            is = cB.getLne(1); /* get current command */
            if(k==0) TSLogg.prtMsg("MsgG51",is); /* print error */
            else TSLogg.prtMsg("MsgG52",is,""+k); /* print error */
            break; /* do not activate option */
          } /* invalid path-number found -- do not activate option */
          if(cB.charAt(true)!=':') { /* invalid separator */
            TSLogg.prtMsg("MsgG53",cB.getLne(1)); /* print error */
            break; /* do not activate option */
          } /* invalid separator -- do not activate option */
          is = cB.getTail(true); /* get filename to check */
          if(is==null) { /* EOF within data (length-error?) */
            TSLogg.prtMsg("MsgG54",""+k); /* Meldung erstellen */
            break; /* do not activate option */
          } /* EOF within data -- do not activate option */
          is = is.replace('\\','/'); /* replace backslash within filename */
            /* Name fuer Pruefung vorbereiten (Pfad-Zeichen auswechseln '\->/') */
          if(!is.endsWith("/")) is += "/"; /* Pfad korrigieren */
          is = is.trim(); /* zusaetzliche Blanks entfernen (vorne) */
          if(is.length()<9) { /* Pfad nicht nutzbar (wegen TSLogg.getMsg()) */
            TSLogg.prtMsg("MsgG55",is,""+k); /* Meldung erstellen */
            break; /* Pfad nicht speichern */
          } /* ungueltig Meldungskennung */
          Fo.setDta(2,k,is); /* Rest als neuen Pfad setzen */
          break; /* command is processed -- continue with next one */
        case('Q'): /* alternative option-identifier */
        case('q'): /* specify directory for copy-mission */
          k = Zif.indexOf(cc=cB.charAt(true)); /* convert digit */
          if(k<0) { /* invalid directory-number found */
            TSLogg.prtMsg("MsgG61",cB.getLne(1),""+cc); /* print error */
            break; /* do not activate option */
          } /* invalid directory-number found -- do not activate option */
          if(cB.charAt(true)!=':') { /* invalid separator */
            TSLogg.prtMsg("MsgG62",cB.getLne(1)); /* print error */
            break; /* do not activate option */
          } /* invalid separator -- do not activate option */
          is = cB.getTail(true); /* get filename to check */
          if(is==null) { /* EOF within data (length-error?) */
            TSLogg.prtMsg("MsgG63",""+k); /* create message and store it */
            break; /* do not activate option */
          } /* EOF within data -- do not activate option */
          dir = new File(is); /* create file-definition from filename */
          is = cB.getLne(1); /* get current command (in case of error) */
          if(!dir.exists()) { /* directory cannot be found */
            TSLogg.prtMsg("MsgG64",is,dir.getAbsolutePath());
              /* create message and store it */
            break; /* do not activate option */
          } /* directory cannot be found -- do not activate option */
          if(!dir.isDirectory()) { /* target is not a directory */
            TSLogg.prtMsg("MsgG65",is,dir.getAbsolutePath());
              /* create message and store it */
            break; /* do not activate option */
          } /* target is not a directory -- do not activate option */
          cCpySet = new TSCopySet(dir); /* create CopySet-object and */
          Fo.setObj(6,k,cCpySet); /* store object for copy-mission */
          break; /* command is processed -- continue with next one */
        case('S'): /* Sicherungsdatei schreiben */
        case('s'): Fo.setMsk(24); /* Kennung setzen */
          break; /* command is processed -- continue with next one */
        case('W'): /* Ausgabe erst ab Warning-Level gefordert */
        case('w'): EnaH = false; /* Hinweise unterdruecken */
          break; /* command is processed -- continue with next one */
        case('Y'): /* Set new value of overheadwire */
          uc = true; /* mark: control-character was 'Upper'-case */
        case('y'): /* Modify height-value of overheadwire */
          f = cB.getFV(); /* get modification-value */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            TSLogg.prtMsg("MsgGY1",is,cB.getLne(0));
              /* create message and store it */
            break; /* do not activate option */
          } /* error while evaluating -- do not activate option */
          f = Fo.setFlt(4,0,f); /* replace dummy-value and mark existance */
          if(uc) Fo.setMsk(22); /* mark: use addition */
          if(Double.isNaN(f)) break; /* command is processed -- continue with next one */
          is = TSLogg.getMsg("MsgGY2",cB.getLne(0),f); /* create warning-message */
          TSLogg.prtMsg("MsgH00",is); /* and schedule it for printing */
          break; /* command is processed -- continue with next one */
        case('$'): /* HIDDEN: process control-definitions */
          if(cB.length()<3) { /* invalid length of option - terminate */
            TSLogg.prtMsg("MsgG02",cB.getLne(1)); /* print errormessage */
            System.exit(15); /* terminate program */
          } /* length of definition incorrect */
          cB.mark(false); /* save current input-position */
          switch(cc=cB.charAt(true)) { /* branch due to second char */
            case('B'): /* activate 'Batch-Mode' and suppress some messages */
              Fo.setMsk(20); /* switch on 'Batch-Mode', suppress some messages */
              break; /* command is processed -- continue with next one */
            case('C'): /* insert comment into Log-File */
              is = cB.getTail(true); /* extract comment */
              if(is==null) break; /* EOF within data  -- ignore comment */
              TSLogg.prtMsg("MsgGC1",is); /* insert message to log-file */
              break; /* command is processed -- continue with next one */
            case('D'): /* Maske der Default-Werte veraendern */
              if(cB.length()!=16) { /* invalid length of option */
                TSLogg.Print("MsgG31"); /* print errormessage */
                System.exit(15); /* terminate program */
              } /* length of definition incorrect */
              j = cB.getHV(4); /* convert next number (4 Hex-chars) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                TSLogg.Print("MsgG32",cB.getLne(3),j,1); /* print error */
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(16); /* terminate program */
              } /* severe error found */
              if(cB.charAt(true)!=':') { /* invalid separator */
                TSLogg.Print("MsgG33",cB.getLne(3)); /* print error */
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(16); /* terminate program */
              } /* severe error found */
              k = cB.getHV(8); /* convert next number (8 Hex-chars) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                TSLogg.Print("MsgG32",cB.getLne(3),k,2); /* print error */
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(16); /* terminate program */
              } /* severe error found */
              if(k==-1) break; /* Maske wuerde nicht veraendert */
              for(c0=0;c0<16;c0+=1) { /* alle Kennungen auswerten */
                if(!TSOpts.chkMsk(c0,j)) continue; /* Kennung NICHT gesetzt */
                switch(c0) { /* Wert gemaess Kennung veraendern */
                  case( 0): TSTrkObj.mskAdd(k); break;
                  case( 1): TSDynTrk.mskAdd(k); break;
                  case( 2): TSSignal.mskAdd(k); break;
                  case( 3): TSStatic.mskAdd(k); break;
                  case( 4): TSForest.mskAdd(k); break;
                  case( 5): TSPlatform.mskAdd(k); break;
                  case( 6): TSSiding.mskAdd(k); break;
                  case( 7): TSGantry.mskAdd(k); break;
                  case( 8): TSSpeed.mskAdd(k); break;
                  case( 9): TSCarSp.mskAdd(k); break;
                  case(10): TSLevelCr.mskAdd(k); break;
                  case(11): TSHazard.mskAdd(k); break;
                  case(12): TSTransf.mskAdd(k); break;
                  case(13): TSColli.mskAdd(k); break;
                  case(14): TSTelep.mskAdd(k); break;
                  case(15): TSPickup.mskAdd(k); break;
                } /* Default-Wert wurde veraendert */
              } /* alle Kennungen testen */
              break; /* command is processed -- continue with next one */
            case('E'): /* Ausgabedatei fuer Systemfehler auf Datei umleiten */
              if(cB.length()<4) { /* invalid length of option */
                TSLogg.Print("MsgG09",cB.getLne(1)); /* print errormessage */
                System.exit(15); /* terminate program */
              } /* length of definition incorrect */
              is = cB.getTail(true); /* extract filename */
              if(is==null) { /* EOF within data (length-error?) */
                is = "TSUtil.err"; /* set default-name of errorfile */
                TSLogg.prtMsg("MsgG96",cB.getLne(1),is); /* print errormessage */
              } /* replace filename with defaultvalue */
              try{ System.setErr(new PrintStream(is)); /* allocate outputfile */
              } catch (FileNotFoundException e) {
                TSLogg.prtMsg("MsgG99",cB.getLne(1),e.toString()); /* print error */
              }; /* Fehlerausgabe umleiten fuer Weitergabe */
              break; /* command is processed -- continue with next one */
            case('F'): /* set initial bufferlength for binary IO */
              if(cB.length()<4) { /* invalid length of option - terminate */
                TSLogg.prtMsg("MsgG11",cB.getLne(1)); /* print errormessage */
                System.exit(15); /* terminate program */
              } /* length of definition incorrect */
              j = (int)cB.getNV(); /* convert next number */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                TSLogg.Print("MsgG12",cB.getLne(3),j,1); /* print error */
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(16); /* terminate program */
              } /* severe error found */
              if(j<TSFile.OB_Len) break; /* Wert zu klein -- nicht veraendern */
              j = (j + 4095) & ~0x0FFF; /* Zahl auf entsprechende Grenze erweitern */
              TSLogg.prtMsg("MsgG13",""+j); /* Meldung erstellen */
              TSFile.OB_Len = j; /* Konfigurationswert aktivieren */
              break; /* command is processed -- continue with next one */
            case('S'): /* Formatierung der Schienendatenbank einschalten */
              Fo.setMsk(29); /* Formatierung einschalten */
              break; /* command is processed -- continue with next one */
            case('T'): /* Zeitmessung einschalten -- Ausgabe der Werte */
              Fo.setMsk(30); /* Zeitmessung einschalten, Ausgabe der werte veranlassen */
              break; /* command is processed -- continue with next one */
            case('X'): /* Debug-Meldungen ausgeben (soweit hierueber gesteuert) */
              Fo.setMsk(31); /* Debug einschalten, Ausgabe der werte veranlassen */
              break; /* command is processed -- continue with next one */
            case('Z'): /* DO NOT execute function, only syntax-check required */
              Fo.setMsk(28); /* suppress execute of function */
              break; /* command is processed -- continue with next one */
            default: /* weitere Kennwertangaben pruefen */
              if(cB.reset(false)) break; /* reset input-position, 'break' if error */
              is = cB.getKE(true); /* get keyword of option */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) /* EOF within data */
                  TSLogg.prtMsg("MsgG03",cB.getLne(2)); /* print error */
                 else TSLogg.prtMsg("MsgG04",cB.getLne(2),is); /* print error */
                break; /* do not activate option */
              } /* EOF within data -- do not activate option */
              if(is.length()==0) { /* next keword not present */
                TSLogg.Print("MsgG05",cB.getLne(2)); /* print error */
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(16); /* terminate program */
              } /* severe error found */
              if(is.equalsIgnoreCase("$PTol")) { /* 'PTol' = Pfad-Toleranz */
                /* Attention: Usage is '-$$PTol(...)' */
                f = cB.getFV(); /* get value of argument (number) */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  TSLogg.Print("MsgG06","PTol",is,cB.getLne(2)); /* print error */
                  TSLogg.Print("Msg009"); /* print hint of operating */
                  System.exit(16); /* terminate program */
                } /* severe error found */
                if(f<0.05 || f>2.5) { /* Toleranzwert NICHT zulaessig */
                  TSLogg.Print("MsgG07","PTol",""+f,"0.05","2.5",cB.getLne(2));
                  TSLogg.Print("Msg009"); /* print hint of operating */
                  System.exit(16); /* terminate program */
                }
                TSPatPDP.chkTol = f; /* activate new value */
              } else if(is.equalsIgnoreCase("$PrMsk")) { /* Print-Mask */
                /* Attention: Usage is '-$$PrMsk(XXXXXXXX)' */
                j = cB.getHV(8); /* get value of argument (number) */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  TSLogg.Print("MsgG06","PrMsk",is,cB.getLne(2)); /* print error */
                  TSLogg.Print("Msg009"); /* print hint of operating */
                  System.exit(16); /* terminate program */
                } /* severe error found */
                TSUtil.PrMsk.$init(j); /* set new mask for printing */
              } else if(is.equalsIgnoreCase("$Dist")) { /* Junction-Distance */
                /* Attention: Usage is '-$$Dist(...)' */
                f = cB.getFV(); /* get value of argument (number) */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  TSLogg.Print("MsgG06","Dist",is,cB.getLne(2)); /* print error */
                  TSLogg.Print("Msg009"); /* print hint of operating */
                  System.exit(16); /* terminate program */
                } /* severe error found */
                if(f<0.01 || f>10.0) { /* Toleranzwert NICHT zulaessig */
                  TSLogg.Print("MsgG07","Dist",""+f,"0.01","10.0",cB.getLne(2));
                  TSLogg.Print("Msg009"); /* print hint of operating */
                  System.exit(16); /* terminate program */
                }
                TSUtil.dDist = f; /* set new distance-value for junctions */
              } else if(is.equalsIgnoreCase("$TS")) { /* current tsection.dat */
                /* Attention: Usage is '-$$TS(...)' */
                is = cB.getVal(1); /* get value of argument (name) */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    TSLogg.Print("MsgG08","TS",cB.getLne(2)); /* print error */
                    TSLogg.Print("Msg009"); /* print hint of operating */
                    System.exit(16); /* terminate program */
                  } /* severe error found */
                  TSLogg.Print("MsgG06","TS",is,cB.getLne(2)); /* print error */
                  TSLogg.Print("Msg009"); /* print hint of operating */
                  System.exit(16); /* terminate program */
                } /* severe error found */
                Fo.setDta(4,1,is); /* set new 'tsection.dat'-reference */
              } else if(is.equalsIgnoreCase("$ReadL")) { /* specify readLoop-count */
                /* Attention: Usage is '-$$ReadL(...)' */
                j = (int)cB.getNV(); /* get value of argument (number) */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  TSLogg.Print("MsgG06","ReadL",is,cB.getLne(2)); /* print error */
                  TSLogg.Print("Msg009"); /* print hint of operating */
                  System.exit(16); /* terminate program */
                } /* severe error found */
                if(j<10 || j>10000) { /* value is not acceptable */
                  TSLogg.Print("MsgG07","ReadL",""+j,"10","10000",cB.getLne(2));
                  TSLogg.Print("Msg009"); /* print hint of operating */
                  System.exit(16); /* terminate program */
                }
                TSByteArrIO.ReadLoop = j; /* store and activate new value */
              } else TSLogg.prtMsg("MsgG01",cB.getLne(2)+"{"+is+"}");
          } /* Kennbuchstabe/Schlusesselwort */
          break; /* command is processed -- continue with next one */
        default: /* unknown option specified */
          TSLogg.prtMsg("MsgG00",cB.getLne(1)); /* print errormessage */
      }
      i += 1; /* switch to next argument */
    } /* all GLOBAL options have been processed */
    if(gF!=null) { /* reading of the option-file is still active */
      gF.close(); /* close input-file */
      gF = null; /* switch off reading of the file */
    } /* option-file was still active */

    if(i>=args.length) { /* error -- SOLO 'global option's specified */
      TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
      TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
      System.exit(10);
    }

    is = args[i++]; /* save current command. It is already added to 'Kdo' */
    j = 99; /* preset: unknown command */

    /* add aditional (local) argument, if it is requested */
    if((fn=getEnv(DataPath,true))!=null) lip: { /* get local input-path and check existance */
      dir = new File(fn); /* use value as path to data-directory */
      if(!dir.exists()) break lip; /* directory do not exist -- ignore it */
      if(!dir.isDirectory()) break lip; /* no directory available -- ignore it */
      dir = new File(dir,is+".txt"); /* create path to optional optionsfile */
      if(!dir.exists()) break lip; /* optionfile does not exist -- ignore it */
      i -= 1; /* skip back to last, already processed slot */
      args[i] = "-@" + dir.getAbsolutePath(); /* create synthetical argument for call */
        /* overwrite (already processed) current command with new local option */
    } /* -lip- additional argument was successfully checked */

    if(is.equalsIgnoreCase("adjh")) { /* -##adjh- Hoehenanpassung vornehmen */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(args[i]); /* use current command */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('C'): /* Komprimieren der Tile-Dateien */
          case('c'): Fo.setMsk(1); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
        TSLogg.Print("adjh1"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      cB = new TSBuf(args[i++]); /* use current command */
      Kdo += cB.getPrnt(); /* add current command for printing */
      f = cB.getFV(); /* height-value */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        TSLogg.Print("adjh2",is,cB.getLne(0)); /* print error */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found */
      Fo.setObj(4,0,new Double(f)); /* Verschiebungswert speichern */

      if(i<args.length) { /* zusaetzlichen Parameter vorhanden */
        cLg = chkLog(args[i++]); /* Logging-Objekt erstellen */
        if(cLg!=null && Lg==null) Lg = cLg; /* Gueltig -- Logging aktivieren */
      } /* Logging wurde zusaetzlich spezifiziert */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 16; /* select current command */
    } else if(is.equalsIgnoreCase("chgdb")) { /* -##chgdb- Datenbank anpassen */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(args[i]); /* use current command */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* filename of *.tdb-file is requested. It is already added to 'Kdo' */

      if(i<args.length) { /* additional arguments available */
        cB = new TSBuf(args[i++]); /* get next token from line */
        Kdo += cB.getPrnt(); /* add current command for printing */
        shn = (int)cB.getNV(); /* get value: 'shape new' */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          TSLogg.Print("chgdb1",is,cB.getLne(0)); /* print error */
          TSLogg.Print("Msg009"); /* print hint of operating */
          System.exit(15); /* terminate program */
        } /* severe error found */
        if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
          TSLogg.Print("chgdb2"); /* Fehlermeldung ausgeben */
          TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
          System.exit(15);
        }
        cB = new TSBuf(args[i++]); /* get next token from line */
        Kdo += cB.getPrnt(); /* add current command for printing */
        scn = (int)cB.getNV(); /* get value: 'section new' */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          TSLogg.Print("chgdb1",is,cB.getLne(0)); /* print error */
          TSLogg.Print("Msg009"); /* print hint of operating */
          System.exit(15); /* terminate program */
        } /* severe error found */

        if(i<args.length) { /* additional arguments available */
          cB = new TSBuf(args[i++]); /* get next token from line */
          Kdo += cB.getPrnt(); /* add current command for printing */
          sha = (int)cB.getNV(); /* get value: 'shape old' */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            TSLogg.Print("chgdb1",is,cB.getLne(0)); /* print error */
            TSLogg.Print("Msg009"); /* print hint of operating */
            System.exit(15); /* terminate program */
          } /* severe error found */

          if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
            TSLogg.Print("chgdb3"); /* Fehlermeldung ausgeben */
            TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
            System.exit(15);
          }
          cB = new TSBuf(args[i++]); /* get next token from line */
          Kdo += cB.getPrnt(); /* add current command for printing */
          sca = (int)cB.getNV(); /* get value: 'section old' */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            TSLogg.Print("chgdb1",is,cB.getLne(0)); /* print error */
            TSLogg.Print("Msg009"); /* print hint of operating */
            System.exit(15); /* terminate program */
          } /* severe error found */
          if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length);
            /* Zu viele Argumente melden */
        } /* four arguments specified */
      } /* min. two additional arguments available */
      j = 6; /* select current command */
    } else if(is.equalsIgnoreCase("chgSig")) { /* -##chgSig- Signale konvertieren */
      /* Default setzen */
      vn3 = "chgSig.dat"; /* Defaultname der Aenderungsdatei setzen */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"chgSig9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"chgSig9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('C'): /* Copy source-objects (shapefiles) to destination */
          case('c'): /* alternate identifier */
            k = Zif.indexOf(cc=cB.charAt(true)); /* convert digit */
            if(k<0) { /* invalid directory-number found */
              TSLogg.prtMsg("chgSigP2",cB.getLne(1),""+cc); /* print error */
              break; /* do not activate option */
            } /* invalid directory-number -- do not activate option */
            cCpySet = (TSCopySet)Fo.getObj(6,k); /* get referred CopySet-object */
            if(cCpySet==null) { /* File-reference was not found */
              TSLogg.prtMsg("chgSigP3",cB.getLne(1),""+cc); /* print error */
              break; /* do not activate option */
            } /* referenced source was not defined */
            Fo.setObj(5,1,cCpySet); /* store object for copy-mission */
            Fo.setMsk(1); /* and activate action */
            break; /* command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('I'): /* HIDDEN: replace target-file(s) directly */
          case('i'): /* alternate identifier */
            if(cB.getLne(0).equalsIgnoreCase("-inplace")) { Fo.setMsk(17); break; }
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('R'): /* Remove all deleted objects from shape-directory */
          case('r'): Fo.setMsk(2); /* activate action */
            break; /* command is processed -- continue with next one */
          case('S'): /* Definitionsdatei fuer Signalaenderungen */
          case('s'): /* alternate identifier */
            vn3 = cB.getTail(true); /* get pattern to check */
            if(vn3!=null) break; /* command is processed -- continue */
            /* EOF within data (length-error?) */
            TSLogg.Print("chgSigP1"); /* print errormessage */
            System.exit(15); /* terminate program */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      vn2 = args[i++]; /* save requested directory. It is already added to 'Kdo' */
      if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename of signal-controlfile */
      Kdo = getPrnt(Kdo,fn); /* add current name for printing */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 25; /* select current command */
    } else if(is.equalsIgnoreCase("chkup")) { /* -##chkup- 'tsection.dat' pruefen */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"chkup9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"chkup9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('V'): /* Zuordnungen alt-neu manuell herstellen  */
          case('v'): /* alternativer Beginn */
            shd = (int)cB.getNV(); /* convert next number (source) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              if(shd==0) TSLogg.Print("chkup01",cB.getLne(1)); /* print error */
              else TSLogg.Print("chkup02",is,cB.getLne(1)); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n') TSLogg.Print("chkup03",cB.getLne(1)); /* print error */
              else TSLogg.Print("chkup04",cB.getLne(1),""+cc); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            scd = (int)cB.getNV(); /* convert next number (target) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              TSLogg.Print("chkup05",is,cB.getLne(1)); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.addObj(1,new Integer(shd)); /* add new value (source) */
            Fo.addObj(1,new Integer(scd)); /* add second value (target) */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */

      if(i<args.length) { /* zusaetzlichen Parameter vorhanden */
        cLg = chkLog(args[i++]); /* Logging-Objekt erstellen */
        if(cLg!=null && Lg==null) Lg = cLg; /* Gueltig -- Logging aktivieren */
      } /* Logging wurde zusaetzlich spezifiziert */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 15; /* select current command */
    } else if(is.equalsIgnoreCase("clrDB")) { /* -##clrDB- Datenbanken korrigieren */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"clrDB_9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"clrDB_9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('C'): /* HIDDEN: Dateien loeschen bei 'inplace' */
          case('c'): Fo.setMsk(8); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('I'): /* HIDDEN: replace target-file(s) directly */
          case('i'): /* alternate identifier */
            if(cB.getLne(0).equalsIgnoreCase("-inplace")) { Fo.setMsk(17); break; }
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('P'): /* Puffer-Dateien kopieren/bereinigen */
          case('p'): Fo.setMsk(2); /* set Mode */
            break; /* command is processed -- continue with next one */
          case('s'): /* delete unused shapes and textures */
          case('S'): Fo.setMsk(9); /* set Mode */
            break; /* command is processed -- continue with next one */
          case('T'): /* Tile-Dateien kopieren/bereinigen */
          case('t'): Fo.setMsk(1); /* set Mode */
            break; /* command is processed -- continue with next one */
          case('W'): /* create empty world-files where file is missing */
          case('w'): Fo.setMsk(3); /* set Mode */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */

      if(i<args.length) { /* zusaetzlichen Parameter vorhanden */
        cLg = chkLog(args[i++]); /* Logging-Objekt erstellen */
        if(cLg!=null && Lg==null) Lg = cLg; /* Gueltig -- Logging aktivieren */
      } /* Logging wurde zusaetzlich spezifiziert */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 20; /* select current command */
    } else if(is.equalsIgnoreCase("cmkr")) { /* -##cmkr- convert markerfile to TS-format */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(args[i]); /* use current command */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('4'): Fo.setMsk(1); /* Ausgabeformat Version 4 konvertieren */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 4; /* select current command */
    } else if(is.equalsIgnoreCase("cmp")) { /* -##cmp- Datei reduzieren/komprimieren */
      vn2 = ""; /* vorbesetzen: File-Typ noch nicht angegeben */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"redFle9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cc=cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"redFle9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('C'): /* Compress ist erforderlich */
          case('c'): Fo.setMsk(1); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('I'): /* HIDDEN: replace target-file(s) directly */
          case('i'): /* alternate identifier */
            if(cB.getLne(0).equalsIgnoreCase("-inplace")) { Fo.setMsk(17); break; }
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('S'): /* Shape-Dateien reduzieren */
          case('s'): if(vn2.length()==0) { vn2 = "Shape"; break; } /* Typ kennzeichnen */
            TSLogg.prtMsg("redFle01",cB.getLne(1),vn2); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('T'): /* Tile-Dateien reduzieren */
            Fo.setMsk(3); /* setze Kennzeichen fuer LO-Tiles */
          case('t'): if(vn2.length()==0) { vn2 = "Tile"; break; } /* Typ kennzeichnen */
            TSLogg.prtMsg("redFle01",cB.getLne(1),vn2); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('W'): /* World-Dateien reduzieren */
          case('w'): if(vn2.length()==0) { vn2 = "World"; break; } /* Typ kennzeichnen */
            TSLogg.prtMsg("redFle01",cB.getLne(1),vn2); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('X'): /* Vollstaendiges Kopieren gefordert */
          case('x'): Fo.setMsk(2); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('Z'): /* Ziel-Verzeichnis angegeben */
          case('z'): /* Modus fuer externes Ziel aktivieren */
            is = cB.getTail(true); /* get pattern to check */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("MsgG91",""+cc); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* severe error found */
            dir = new File(is); /* create file-definition fron filename */
            if(!dir.exists()) { /* Datei existiert nicht */
              TSLogg.Print("MsgG92",is,dir.getAbsolutePath());
              System.exit(15); /* Aufruf abbrechen */
            } /* Datei existiert nicht */
            if(!dir.isDirectory()) { /* Ziel ist KEIN Verzeichnis */
              TSLogg.Print("MsgG94",is,dir.getAbsolutePath());
              System.exit(15); /* Aufruf abbrechen */
            } /* Referenz ist kein Verzeichnis */
            pFle = dir.getAbsoluteFile(); /* Datei-/Verzeichnis setzen (Schalter aktivieren) */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      if(vn2.length()==0) { /* keinen Datei-Typ angegeben */
        TSLogg.Print("redFle02",vn2); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      if(i<args.length) { /* zusaetzlichen Parameter vorhanden */
        cLg = chkLog(args[i++]); /* Logging-Objekt erstellen */
        if(cLg!=null && Lg==null) Lg = cLg; /* Gueltig -- Logging aktivieren */
      } /* Logging wurde zusaetzlich spezifiziert */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 17; /* select current command */
    } else if(is.equalsIgnoreCase("cmpw")) { /* -##cmpw- W-Datei komprimieren */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(args[i]); /* use current command */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      if(i<args.length) { /* zusaetzlichen Parameter vorhanden */
        cLg = chkLog(args[i++]); /* Logging-Objekt erstellen */
        if(cLg!=null && Lg==null) Lg = cLg; /* Gueltig -- Logging aktivieren */
      } /* Logging wurde zusaetzlich spezifiziert */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 10; /* select current command */
    } else if(is.equalsIgnoreCase("cvrt")) { /* -##cvrt- Strecke konvertieren */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"cvrt9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        uc = false; /* preset: option uses lower case */
        if(cB.length()<2) break; /* no more options possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cc=cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"cvrt9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('A'): /* Schienenbegleitobjekte generieren MIT regulaeren Audruecken */
            uc = true; /* mark: control-character was 'Upper'-case */
          case('a'):  /* Schienenbegleitobjekte generieren OHNE regulaere Audruecke */
            j = StDL.indexOf(cc=cB.charAt(true)); /* check/convert next char/digit */
            if(j<0) { /* number not allowed for StaticDetailLevel */
              if(cc=='\n') TSLogg.Print("cvrt51",cB.getLne(1)); /* print errormessage */
              else TSLogg.Print("cvrt52",cB.getLne(1),""+cc); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n') TSLogg.Print("cvrt53",cB.getLne(1)); /* print errormessage */
              else TSLogg.Print("cvrt54",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */

//            cL = Fo.getQue(5); /* prefetch affected Queue */
            Msk = Fo.getOpt(5,0); /* get current mask of 'StaticDetailLevel' */
              /* Attention: mask(-reference) is valid in every case */
            Msk.setMsk(j); /* mark corresponding level */
            /* The object itself need not to be stored back, because it is not replaced */
            Fo.addObj(5,new TSOpts(1<<j)); /* create corresponding 'StaticdetailLevel' */
            Fo.setMsk(13); /* activate new feature */

            is = cB.getVal(21); /* get filename (source) / expression */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("cvrt55",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(is.length()<1) { /* source-name was not specified */
              TSLogg.Print("cvrt56",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(uc) { /* 'regular expression' follows -- check it */
              Pt = null; /* for compiler */
              try { Pt = Pattern.compile(is,Pattern.CASE_INSENSITIVE);
              } catch (PatternSyntaxException p) { /* error in compile */
                TSLogg.Print("cvrt57",is,p.getDescription());
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(15); /* terminate program */
              } /* Selection-definition contains error(s) */
              Fo.addObj(5,Pt); /* set Pattern as Value-1 */
            } else Fo.addObj(5,is); /* filename -- set as Value-1 */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n') TSLogg.Print("cvrt58",cB.getLne(1)); /* print errormessage */
              else TSLogg.Print("cvrt59",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            shd = Zif.indexOf(cc=cB.charAt(true)); /* check/convert next char/digit */
            if(shd<0) { /* number not allowed for StaticDetailLevel (target) */
              if(cc=='\n') TSLogg.Print("cvrt5A",cB.getLne(1)); /* print errormessage */
              else TSLogg.Print("cvrt5B",cB.getLne(1),""+cc); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.addObj(5,new Integer(shd)); /* store 'StaticdetailLevel' (target) */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n') TSLogg.Print("cvrt5C",cB.getLne(1)); /* print errormessage */
              else TSLogg.Print("cvrt5D",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            j = Zif.indexOf(cB.charAt(false)); /* convert next char (no skip) */
            if(j>=0) { /* path-ID is used and valid -- set it */
              is = Fo.getDta(2,j); /* get specified path (ggf. 'null') */
              Fo.addObj(5,is); /* and add new path-entry */
              if(is==null) TSLogg.prtMsg("cvrt5E",cB.getLne(1),""+j);
                /* (conditional) path is not defined -- write message */
              cB.charAt(true); /* skip valid char */
            } else Fo.addObj(5,null);  /* path-id is NOT used -- add dummy entry */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n') TSLogg.Print("cvrt5F",cB.getLne(1)); /* print errormessage */
              else TSLogg.Print("cvrt5G",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            j = Zif.indexOf(cB.charAt(false)); /* convert next char (no skip) */
            if(j>=0) { /* 'StaticDetailLevel (object)' is used and valid -- set it */
              cB.charAt(true); /* skip valid char */
              shd = j; /* activate new 'StaticDetailLevel' for objects */
            } /* 'StaticDetailLevel' was used */
            Fo.addObj(5,new Integer(shd)); /* store 'StaticDetailLevel' (object) */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n') TSLogg.Print("cvrt5H",cB.getLne(1)); /* print errormessage */
              else TSLogg.Print("cvrt5I",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */

            j = Fo.get$Obj(5) + 1; /* get index-number of next (+1) entry within queue */
            if(Fo.cr$Obj(5,j+3)) throw new /* dummy-elements could not be inserted */
              IllegalStateException(TSLogg.getMsg("Msg905","Fo.Data(5)-cvrt"));

            is = cB.getVal(21); /* get filename (target)(1) */
            if(is==null) { /* EOF within data (no target specified) */
              TSLogg.Print("cvrt5J",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(is.length()<1) { /* target-name was not specified */
              TSLogg.Print("cvrt5K",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(is.length()>2) if(is.charAt(1)=='=') { /* installation-directory found */
              k = Zif.indexOf(cc=is.charAt(0)); /* convert digit */
              if(k<0) { /* invalid directory-number found */
                TSLogg.Print("cvrt5K1",cB.getLne(1),""+cc); /* print errormessage */
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(15); /* terminate program */
              } /* severe error found */
              is = is.substring(2); /* delete number of directory (prefix) */
              cCpySet = (TSCopySet)Fo.getObj(6,k); /* get referenced source-definition */
              if(cCpySet==null) TSLogg.prtMsg("cvrt5K2",cB.getLne(1),""+k); /* print errormessage */
              else Fo.setObj(5,j-1,cCpySet); /* store source-reference */
            } /* installation-directory found and analysed */
            Fo.setObj(5,j,is); /* set string current target-value as Value-2 */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n') break; /* valid EOL found -- command is fully processed */
              TSLogg.Print("cvrt5L",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            is = cB.getVal(21); /* get filename (target)(2) */
            if(is==null) { /* EOF within data (no target specified) */
              TSLogg.Print("cvrt5M",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            j += 2; /* adjust index of slot */
            if(is.length()>0) { /* target specified -- activate it */
              if(is.length()>2) if(is.charAt(1)=='=') { /* installation-directory found */
                k = Zif.indexOf(cc=is.charAt(0)); /* convert digit */
                if(k<0) { /* invalid directory-number found */
                  TSLogg.Print("cvrt5M1",cB.getLne(1),""+cc); /* print errormessage */
                  TSLogg.Print("Msg009"); /* print hint of operating */
                  System.exit(15); /* terminate program */
                } /* severe error found */
                is = is.substring(2); /* delete number of directory (prefix) */
                cCpySet = (TSCopySet)Fo.getObj(6,k); /* get referenced source-definition */
                if(cCpySet==null) TSLogg.prtMsg("cvrt5M2",cB.getLne(1),""+k); /* print errormessage */
                else Fo.setObj(5,j-1,cCpySet); /* store source-reference */
              } /* installation-directory found and analysed */
              Fo.setObj(5,j,is); /* set string current target-value as Value-3 */
            } /* target specified -- activate it */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n') break; /* valid EOL found -- command is fully processed */
              TSLogg.Print("cvrt5N",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            is = cB.getVal(21); /* get filename (target)(3) */
            if(is==null) { /* EOF within data (no target specified) */
              TSLogg.Print("cvrt5O",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(is.length()<1) { /* target-name was not specified */
              TSLogg.Print("cvrt5P",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            j += 2; /* adjust index of slot */
            if(is.length()>2) if(is.charAt(1)=='=') { /* installation-directory found */
              k = Zif.indexOf(cc=is.charAt(0)); /* convert digit */
              if(k<0) { /* invalid directory-number found */
                TSLogg.Print("cvrt5P1",cB.getLne(1),""+cc); /* print errormessage */
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(15); /* terminate program */
              } /* severe error found */
              is = is.substring(2); /* delete number of directory (prefix) */
              cCpySet = (TSCopySet)Fo.getObj(6,k); /* get referenced source-definition */
              if(cCpySet==null) TSLogg.prtMsg("cvrt5P2",cB.getLne(1),""+k); /* print errormessage */
              else Fo.setObj(5,j-1,cCpySet); /* store source-reference */
            } /* installation-directory found and analysed */
            Fo.setObj(5,j,is); /* set string current target-value as Value-4 */
            if((cc=cB.charAt(true))=='\n') break;/* command is processed */
            TSLogg.Print("cvrt5Q",cB.getLne(1),""+cc); /* print errormessage */
            TSLogg.Print("Msg009"); /* print hint of operating */
            System.exit(15); /* terminate program */
          case('B'): /* Vergleichs-"tsection.dat" angegeben */
          case('b'): /* Vergleichs-Modus aktivieren */
            is = cB.getTail(true); /* get filename of original 'tsection.dat' */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("cvrt01",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            dir = new File(is); /* create filedefinition */
            if(!dir.exists()) { /* Datei existiert nicht */
              TSLogg.Print("cvrt02",dir.getAbsolutePath()); /* Fehlermeldung */
              System.exit(15); /* Aufruf abbrechen */
            } /* Datei existiert nicht */
            if(dir.isDirectory()) { /* Ziel ist ein Verzeichnis */
              TSLogg.Print("cvrt03",dir.getAbsolutePath()); /* Fehlermeldung */
              System.exit(15); /* Aufruf abbrechen */
            } /* Referenz ist ein Verzeichnis */
            pFle = dir.getAbsoluteFile(); /* Datei-/Verzeichnis setzen (Schalter aktivieren) */
            break; /* command is processed -- continue with next one */
          case('C'): /* Komprimierung der world-Dateien erzwingen */
          case('c'): Fo.setMsk(3); /* setze Mode */
            Fo.clrMsk(4); /* Alternativen Modus loeschen */
            break; /* command is processed -- continue with next one */
          case('D'): /* HIDDEN: Erweiterte Ausgaben auf LOG-Datei */
          case('d'): Fo.setMsk(16); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('F'): /* Suppress overheadwire using REGULAR EXPRESSIONS */
            uc = true; /* mark: control-character was 'Upper'-case */
          case('f'): /* Suppress overheadwire of track-objects */
//            cL = Fo.getQue(3); /* prefetch affected Queue */
            if(Fo.cr$Obj(3,17)) throw new /* dummy-elements could not be inserted */
              IllegalStateException(TSLogg.getMsg("Msg905","Fo.Data(3)-cvrt(f)"));
              /* control-records (0,1) have been already inserted
               * Now: queue(3) contains at least 16 records, which may be empty ('null') */
            Msk = Fo.getOpt(3,0); /* get current Hidewire-control-record */
              /* Attention: mask(-reference) is valid in every case */
            if((scd=Msk.cntMsk(14))>=3) { /* all detailLevel already set */
              TSLogg.Print("cvrt11",scd); /* Meldung auf BS ausgeben */
              TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
              System.exit(15);
            }
            shd = "\n123".indexOf(cc=cB.charAt(true)); /* check next digit */
            if(shd<1) { /* invalid 'StaticDetailLevel' specified */
              if(shd==0) TSLogg.Print("cvrt12",cB.getLne(1),scd); /* print errormessage */
              else TSLogg.Print("cvrt13",cB.getLne(1),""+cc,""+scd); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(Msk.chkMsk(shd)) { /* new Level is already defined/used */
              TSLogg.Print("cvrt14",shd); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(Fo.getOpt(3,1).chkMsk(shd)) { /* new Level is already used */
              TSLogg.Print("cvrt1I",shd); /* print errormessage */
              break; /* command is processed with error -- continue with next one */
            } /* error found -- ignore option */
            if(cB.charAt(true)!=':') { /* invalid separator */
              TSLogg.Print("cvrt15",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            scd = (int)cB.getNV(); /* convert next number */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              TSLogg.Print("cvrt16",is,cB.getLne(1),""+shd); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(scd<10 || scd>=sha) { /* invalid Shape-ID found */
              /* Achtung: Default-Wert fuer 'sha' konnte noch nicht modifiziert werden */
              TSLogg.Print("cvrt17",""+(sha-1),scd,shd); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.setMsk(10);   /* activate new mode */
            Msk.setMsk(shd); /* and mark corresponding level */
              /* The object itself needs not to be stored back, because it is not replaced */
            shd = shd * 5 - 3; /* compute start-index of data-entries (2,7,12) */
            Fo.setInt(3,shd++,scd); /* insert shape-Number for 'f'-Option */

            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if(cc=='\n') break; /* However: EOL is valid here */
              TSLogg.Print("cvrt18",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            j = Zif.indexOf(cB.charAt(false)); /* convert next char (no skip) */
            if(j>=0) { /* path-ID is used and valid -- set it */
              is = Fo.getDta(2,j); /* get specified path (ggf. 'null') */
              Fo.setDta(3,shd++,is); /* and write it to path-entry */
              cB.charAt(true); /* skip valid char */
            } else shd += 1;  /* path-id is NOT used -- skip entry */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n') TSLogg.Print("cvrt19",cB.getLne(1)); /* print errormessage */
              else TSLogg.Print("cvrt1A",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            is = cB.getVal(21); /* get filename (source) */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("cvrt1B",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(is.length()<1) { /* source-name was not specified */
              TSLogg.Print("cvrt1C",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(uc) { /* 'regular expression' follows -- check it */
              Pt = null; /* for compiler */
              try { Pt = Pattern.compile(is,Pattern.CASE_INSENSITIVE);
              } catch (PatternSyntaxException p) { /* error in compile */
                TSLogg.Print("cvrt1H",is,p.getDescription());
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(15); /* terminate program */
              } /* Selection-definition contains error(s) */
              Fo.setObj(3,shd++,Pt); /* insert new Pattern into entry */
            } else Fo.setDta(3,shd++,is); /* insert new value into entry */
            if((cc=cB.charAt(true))=='\n') { /* valid EOL found -- handle it */
              TSLogg.prtMsg("cvrt1E",cB.getLne(1)); /* print warning */
              Fo.setDta(3,shd,""); /* insert new value into entry */
              break; /* command is fully processed */
            } /* valid EOL handled */
            if(cc!=':') { /* invalid separator */
              TSLogg.Print("cvrt1D",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            is = cB.getVal(21); /* get filename (target) */
            if(is==null) { /* EOF within data (no target specified) */
              TSLogg.Print("cvrt1F",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.setDta(3,shd,is); /* insert new value into entry */
            if((cc=cB.charAt(true))=='\n') break;/* command is processed */
            TSLogg.Print("cvrt1G",cB.getLne(1),""+cc); /* print errormessage */
            TSLogg.Print("Msg009"); /* print hint of operating */
            System.exit(15); /* terminate program */
            /* Attention: Value specifying 'TSCopySet' is NOT replaced (remains 'null') */
          case('G'): /* alternative option-identifier */
            uc = true; /* mark: control-character was 'Upper'-case */
          case('g'): /* change static objects to type 'Gantry' */
            if(Fo.cr$Obj(2,10)) throw new /* dummy-elements could not be inserted */
              IllegalStateException(TSLogg.getMsg("Msg905","Fo.Data(2)-cvrt(g)"));
              /* insert 10 dummy-paths if not already available */
            is = cB.getTail(false); /* get filename (source) (remaining of argument) */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("cvrt81",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(is.length()<1) { /* source-name was not specified */
              TSLogg.Print("cvrt82",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(uc) { /* 'regular expression' follows -- check it */
              Pt = null; /* for compiler */
              try { Pt = Pattern.compile(is,Pattern.CASE_INSENSITIVE);
              } catch (PatternSyntaxException p) { /* error in compile */
                TSLogg.Print("cvrt83",is,p.getDescription());
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(15); /* terminate program */
              } /* Selection-definition contains error(s) */
              Fo.addObj(2,Pt); /* add new Pattern to list of entries */
            } else Fo.addObj(2,is); /* add value to list of entries */
            /* Attention: NO extra option is used to signal this request.
             * The existence of objects within queue 2 marks this feature.
             */
            break; /* command is processed -- continue with next one */
          case('H'): /* Modify track-objects using REGULAR EXPRESSIONS (suppress wire) */
            uc = true; /* mark: control-character was 'Upper'-case */
          case('h'): /* Modify track-objects and suppress overheadwire */
//            cL = Fo.getQue(3); /* prefetch affected Queue */
            if(Fo.cr$Obj(3,17)) throw new /* dummy-elements could not be inserted */
              IllegalStateException(TSLogg.getMsg("Msg905","Fo.Data(3)-cvrt(h)"));
              /* control-records (0,1) have been already inserted
               * Now: queue(3) contains at least 16 records, which may be empty ('null') */
            Msk = Fo.getOpt(3,0); /* get current Hidewire-control-record */
              /* Attention: mask(-reference) is valid in every case */
            if((scd=Msk.cntMsk(14))>=3) { /* all detailLevel already set */
              TSLogg.Print("cvrt21",scd); /* Meldung auf BS ausgeben */
              TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
              System.exit(15);
            }
            shd = "\n123".indexOf(cc=cB.charAt(true)); /* check next digit */
            if(shd<1) { /* invalid 'StaticDetailLevel' specified */
              if(shd==0) TSLogg.Print("cvrt22",cB.getLne(1),scd);
              else TSLogg.Print("cvrt23",cB.getLne(1),""+cc,""+scd);
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(Msk.chkMsk(shd)) { /* new Level is already defined/used */
              TSLogg.Print("cvrt24",shd); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(Fo.getOpt(3,1).chkMsk(shd)) { /* new Level is already used */
              TSLogg.Print("cvrt2I",shd); /* print errormessage */
              break; /* command is processed with error -- continue with next one */
            } /* error found -- ignore option */
            Fo.setMsk(10);   /* activate new mode */
            Msk.setMsk(shd); /* and mark corresponding level */
              /* The object itself needs not to be stored back, because it is not replaced */
            shd = shd * 5 - 3; /* compute start-index of data-entries (2,7,12) */
            Fo.setInt(3,shd,-1); /* set default-ID of 'h'-Option (without path) */

            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if(cc=='\n') break; /* However: EOL is valid here */
              TSLogg.Print("cvrt25",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            cc = cB.charAt(false); /* get next char (path-number) (no skip) */
            if(cc=='\n') break; /* EOL is valid here */
            j = Zif.indexOf(cc); /* convert it to number */
            if(j>=0) { /* path-ID is used and valid -- set it */
              Fo.setInt(3,shd++,j); /* set path-ID for 'h'-Option */
              cB.charAt(true); /* skip valid char */
            } else shd += 1;  /* path-id is NOT used -- skip entry */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if(cc=='\n') break; /* However: EOL is valid here */
              TSLogg.Print("cvrt26",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            cc = cB.charAt(false); /* get next char (path-number) (no skip) */
            if(cc=='\n') break; /* EOL is valid here too */
            j = Zif.indexOf(cc); /* convert it to number */
            if(j>=0) { /* path-ID is used and valid -- set it */
              is = Fo.getDta(2,j); /* get specified path (ggf. 'null') */
              Fo.setDta(3,shd++,is); /* and write it to path-entry */
              cB.charAt(true); /* skip valid char */
            } else shd += 1;  /* path-id is NOT used -- skip entry */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n') TSLogg.Print("cvrt27",cB.getLne(1)); /* print errormessage */
              else TSLogg.Print("cvrt28",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            is = cB.getVal(21); /* get filename (source) */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("cvrt29",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(is.length()<1) { /* source-name was not specified */
              TSLogg.Print("cvrt2A",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(uc) { /* 'regular expression' follows -- check it */
              Pt = null; /* for compiler */
              try { Pt = Pattern.compile(is,Pattern.CASE_INSENSITIVE);
              } catch (PatternSyntaxException p) { /* error in compile */
                TSLogg.Print("cvrt2F",is,p.getDescription());
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(15); /* terminate program */
              } /* Selection-definition contains error(s) */
              Fo.setObj(3,shd++,Pt); /* insert new Pattern into entry */
            } else Fo.setDta(3,shd++,is); /* insert new value into entry */
            if((cc=cB.charAt(true))=='\n') { /* valid EOL found -- handle it */
              TSLogg.prtMsg("cvrt2C",cB.getLne(1)); /* print warning */
              Fo.setDta(3,shd,""); /* insert new value into entry */
              break; /* command is fully processed */
            } /* valid EOL handled */
            if(cc!=':') { /* invalid separator */
              TSLogg.Print("cvrt2B",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            is = cB.getVal(21); /* get filename (target) */
            if(is==null) { /* EOF within data (no target specified) */
              TSLogg.Print("cvrt2D",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.setDta(3,shd,is); /* insert new value into entry */
            if((cc=cB.charAt(true))=='\n') break;/* command is processed */
            TSLogg.Print("cvrt2E",cB.getLne(1),""+cc); /* print errormessage */
            TSLogg.Print("Msg009"); /* print hint of operating */
            System.exit(15); /* terminate program */
            /* Attention: Value specifying 'TSCopySet' is NOT replaced (remains 'null') */
          case('I'): /* HIDDEN: replace target-file(s) directly */
          case('i'): /* alternate identifier */
            if(cB.getLne(0).equalsIgnoreCase("-inplace")) { Fo.setMsk(17); break; }
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('K'): /* Korrektur-Modus fuer World-Dateien einschalten */
          case('k'): Fo.setMsk(5); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('L'): /* alternative option-identifier */
            uc = true; /* mark: control-character was 'Upper'-case */
          case('l'): /* modify StaticDetailLevel of objects */
            if(cB.length()<13) { /* invalid length of option */
              TSLogg.Print("cvrt71",cB.getLne(1)); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* length of definition incorrect */
            if(Fo.cr$Obj(6,10)) throw new /* dummy-elements could not be inserted */
              IllegalStateException(TSLogg.getMsg("Msg905","Fo.Data(6)-cvrt(l)"));
              /* insert 10 dummy-paths if not already available */
            if(cB.charAt(false)==':') j = 3; /* mask-1 is missing -- set default */
            else { /* check if mask-1 is present and correct */
              j = cB.getHV(4); /* convert next hex-number (mask-1) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                TSLogg.Print("cvrt72",cB.getLne(1),j,1); /* print error */
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(16); /* terminate program */
              } /* severe error found */
            } /* mask-1 was successfully processed */
            j |= 0x02000000; /* mark function as 'change StaticDetailLevel' */
            Fo.addObj(6,new TSOpts(j)); /* store first mask (out of 3) */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              TSLogg.Print("cvrt73",cB.getLne(1),""+cc); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(16); /* terminate program */
            } /* severe error found */
            is = cB.getVal(21); /* get filename (source) / expression */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("cvrt74",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(is.length()<1) { /* source-name was not specified */
              TSLogg.Print("cvrt75",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(uc) { /* 'regular expression' follows -- check it */
              Pt = null; /* for compiler */
              try { Pt = Pattern.compile(is,Pattern.CASE_INSENSITIVE);
              } catch (PatternSyntaxException p) { /* error in compile */
                TSLogg.Print("cvrt76",is,p.getDescription());
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(15); /* terminate program */
              } /* Selection-definition contains error(s) */
              Fo.addObj(6,Pt); /* set Pattern as Value-1 */
            } else Fo.addObj(6,is); /* filename -- set as Value-1 */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              TSLogg.Print("cvrt77",cB.getLne(1),""+cc); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(16); /* terminate program */
            } /* severe error found */
            is = cB.getVal(15); /* get StaticDetailLevel-expression */
              /* this value is stored into 'mask-2' (OR) */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("cvrt78",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Msk = getLvlMsk(is); /* convert expression into mask */
            if(Msk.chkMsk(31)) { /* conversion contained error(s) */
              if(Msk.chkMsk(16)) TSLogg.Print("cvrt79",cB.getLne(1),is); /* print it */
              else if(Msk.chkMsk(17)) TSLogg.Print("cvrt7A",cB.getLne(1),is);
              else if(Msk.chkMsk(18)) TSLogg.Print("cvrt7B",cB.getLne(1),is);
              else if(Msk.chkMsk(19)) TSLogg.Print("cvrt7C",cB.getLne(1),is);
              else if(Msk.chkMsk(20)) TSLogg.Print("cvrt7D",cB.getLne(1),is);
              else TSLogg.Print("cvrt7E",cB.getLne(1),is,Msk.prtMsk(0xFFFF0000));
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.addObj(6,Msk); /* store second mask (out of 3) */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              TSLogg.Print("cvrt7F",cB.getLne(1),""+cc); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(16); /* terminate program */
            } /* severe error found */
            j = StDL.indexOf(cc=cB.charAt(true)); /* check/convert next char/digit */
              /* this value is stored into 'mask-3' (AND) */
            if(j<0) { /* number not allowed for StaticDetailLevel */
              if(cc=='\n') TSLogg.Print("cvrt7G",cB.getLne(1)); /* print errormessage */
              else TSLogg.Print("cvrt7H",cB.getLne(1),""+cc); /* print errormessage */
              System.exit(16); /* terminate program */
            } /* severe error found */
            Fo.addObj(6,new Integer(j)); /* store third mask (out of 3) */
            if((cc=cB.charAt(false))!='\n') { /* EOL was NOT found */
              TSLogg.Print("cvrt7I",cB.getLne(1),""+cc); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(16); /* terminate program */
            } /* severe error found */
            Fo.setMsk(15); /* activate operation */
            break; /* command is processed -- continue with next one */
          case('M'): /* Track-Objekte untersuchen und Dateinamen modifizieren */
            uc = true; /* Auswahl kennzeichnen */
          case('m'): /* alternativer Beginn */
//            cL = Fo.getQue(3); /* prefetch affected Queue */
            if(Fo.cr$Obj(3,17)) throw new /* dummy-elements could not be inserted */
              IllegalStateException(TSLogg.getMsg("Msg905","Fo.Data(3)-cvrt(m)"));
              /* control-records (0,1) have been already inserted
               * Now: queue(3) contains at least 16 records, which may be empty ('null') */
            Msk = Fo.getOpt(3,1); /* get current filename-control-record */
              /* Attention: mask(-reference) is valid in every case */
            if(cB.length()<3) { /* no continuation - switch off action */
              if(Fo.chkMsk(11)) { /* action already initiated  -- handle error */
                TSLogg.prtMsg("cvrt41",cB.getLne(1)); /* print errormessage */
                break; /* do not activate option */
              } /* multiple request found */
              if(Fo.chkMsk(12)) { /* change-action is no longer allowwed */
                TSLogg.Print("cvrt42"); /* print errormessage */
                System.exit(15); /* terminate program */
              } /* severe error found */
              Fo.setMsk(11);     /* activate 'reset modifications' */
              Msk.orMsk(0x03F1); /* and use all level */
              if(!Fo.getOpt(3,0).chkMsk(3)) Msk.setMsk(3);
                /* also include level '3' if it is not used with '-h'/'-f' */
              /* Attention: The object itself needs not to be stored back, because it is not replaced */
              break; /* command is processed -- continue with next one */
            } /* no continuation found after 2 char */
            if(Fo.chkMsk(11)) { /* action no longer allowed */
              TSLogg.Print("cvrt43",cB.getLne(1)); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* severe error found */

            shd = "03456789".indexOf(cc=cB.charAt(true)); /* convert next char/digit */
            if(shd<0) { /* number not allowed for StaticDetailLevel */
              if(cc=='\n') TSLogg.Print("cvrt44",cB.getLne(1)); /* print errormessage */
              else TSLogg.Print("cvrt45",cB.getLne(1),""+cc); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(shd>0) shd += 2; /* adjust value */
            if(Fo.getOpt(3,0).chkMsk(shd)) { /* new Level is already used */
              TSLogg.Print("cvrt4Z",shd); /* print errormessage */
              break; /* command is processed with error -- continue with next one */
            } /* error found -- ignore option */

            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n') TSLogg.Print("cvrt46",cB.getLne(1)); /* print errormessage */
              else TSLogg.Print("cvrt47",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.setMsk(12);   /* activate new mode */
            Msk.setMsk(shd); /* and mark corresponding level */
              /* The object itself needs not to be stored back, because it is not replaced */
            Fo.addObj(3,new TSOpts(1<<shd)); /* create corresponding 'StaticdetailLevel' */

            j = Zif.indexOf(cB.charAt(false)); /* convert next char (no skip) */
            if(j>=0) { /* path-ID is used and valid -- set it */
              is = Fo.getDta(2,j); /* get specified path (ggf. 'null') */
              Fo.addObj(3,is); /* and add new path-entry */
              if(is==null) TSLogg.prtMsg("cvrt48",cB.getLne(1),""+j);
                /* (conditional) path is not defined -- write message */
              cB.charAt(true); /* skip valid char */
            } else Fo.addObj(3,null);  /* path-id is NOT used -- add dummy entry */

            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n') TSLogg.Print("cvrt49",cB.getLne(1)); /* print errormessage */
              else TSLogg.Print("cvrt4A",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            is = cB.getVal(21); /* get filename (source) / expression */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("cvrt4B",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(is.length()<1) { /* source-name was not specified */
              TSLogg.Print("cvrt4C",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(uc) { /* 'regular expression' follows -- check it */
              Pt = null; /* for compiler */
              try { Pt = Pattern.compile(is,Pattern.CASE_INSENSITIVE);
              } catch (PatternSyntaxException p) { /* error in compile */
                TSLogg.Print("cvrt4D",is,p.getDescription());
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(15); /* terminate program */
              } /* Selection-definition contains error(s) */
              Fo.addObj(3,Pt); /* set Pattern as Value-1 */
            } else Fo.addObj(3,is); /* filename -- set as Value-1 */

            if((cc=cB.charAt(true))=='\n') { /* valid EOL found -- handle it */
              if(uc) { /* this is NOT allowed if 'regular expression' is used */
                TSLogg.Print("cvrt4F",cB.getLne(1)); /* print errormessage */
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(15); /* terminate program */
              } /* severe error found */
              TSLogg.prtMsg("cvrt4G",cB.getLne(1)); /* print warning */
              Fo.addObj(3,""); /* set 0-string as Value-2 */
              break; /* command is fully processed */
            } /* valid EOL handled */
            if(cc!=':') { /* invalid separator */
              TSLogg.Print("cvrt4E",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            is = cB.getVal(21); /* get filename (target) */
            if(is==null) { /* EOF within data (no target specified) */
              TSLogg.Print("cvrt4H",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if((cc=cB.charAt(true))=='\n') { /* valid EOL found -- handle it */
              Fo.addObj(3,is); /* set current string as Value-2 */
              break; /* command is fully processed */
            } /* valid EOL handled */
            if(cc!=':') { /* invalid separator */
              TSLogg.Print("cvrt4I",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            cS = new String[3]; /* create storage for replacement-values */
            cS[0] = cS[1] = cS[2] = is; /* insert default-value */
            Fo.addObj(3,cS); /* and set string-array as Value-2 */
            cS[1] = cS[2] = is = cB.getVal(21); /* get filename (target-2) */
            if(is==null) { /* EOF within data (no target specified) */
              TSLogg.Print("cvrt4J",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if(cc=='\n') break; /* However: EOL is valid here */
              TSLogg.Print("cvrt4K",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            cS[2] = is = cB.getVal(21); /* get filename (target-3) */
            if(is==null) { /* EOF within data (no target specified) */
              TSLogg.Print("cvrt4L",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if((cc=cB.charAt(true))=='\n') break;/* command is processed */
            TSLogg.Print("cvrt4M",cB.getLne(1),""+cc); /* print errormessage */
            TSLogg.Print("Msg009"); /* print hint of operating */
            System.exit(15); /* terminate program */
          case('N'): /* 'normalize route' -- no longer suppress overheadwire */
          case('n'): /* do not modify objects (delete Hidewire-objects) */
            /* Achtung: Aufbau der 'Hidewire-Queue' vergleiche Definition von 'Fo' */
            Msk = Fo.getOpt(3,0); /* get current Hidewire-control-record */
              /* Attention: mask(-reference) is valid in every case */
            if((j=Msk.cntMsk(14))>0) { /* any detailLevel already set ? */
              TSLogg.Print("cvrt10",is,j); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(cB.length()!=2) TSLogg.prtMsg("cvrt00",cB.getLne(1),""+cc);
              /* invalid cahacter(s) follow -- create message */
            Fo.setMsk(9);  /* activate requested mode */
            Msk.orMsk(14); /* (='0x00E') store: no further requests allowed */
            Fo.setMsk(11); /* mark: undo changes within filenames */
            Fo.setObj(3,1,new TSOpts(14)); /* store: activate (use) all possible levels */
            break; /* command is processed -- continue with next one */
          case('O'): /* alternative option-identifier */
            uc = true; /* mark: control-character was 'Upper'-case */
          case('o'): /* modify object-properties */
            if(cB.length()<17) { /* invalid length of option */
              TSLogg.Print("cvrt61",cB.getLne(1)); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* length of definition incorrect */
            if(Fo.cr$Obj(6,10)) throw new /* dummy-elements could not be inserted */
              IllegalStateException(TSLogg.getMsg("Msg905","Fo.Data(6)-cvrt(o)"));
              /* insert 10 dummy-paths if not already available */
            j = cB.getHV(4); /* convert next hex-number (mask-1) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              TSLogg.Print("cvrt62",cB.getLne(1),j,1); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(16); /* terminate program */
            } /* severe error found */
            j |= 0x01000000; /* mark function as 'modify objects' */
            Fo.addObj(6,new TSOpts(j)); /* store first mask (out of 3) */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              TSLogg.Print("cvrt63",cB.getLne(1),""+cc); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(16); /* terminate program */
            } /* severe error found */
            is = cB.getVal(21); /* get filename (source) / expression */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("cvrt64",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(is.length()<1) { /* source-name was not specified */
              TSLogg.Print("cvrt65",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(uc) { /* 'regular expression' follows -- check it */
              Pt = null; /* for compiler */
              try { Pt = Pattern.compile(is,Pattern.CASE_INSENSITIVE);
              } catch (PatternSyntaxException p) { /* error in compile */
                TSLogg.Print("cvrt66",is,p.getDescription());
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(15); /* terminate program */
              } /* Selection-definition contains error(s) */
              Fo.addObj(6,Pt); /* set Pattern as Value-1 */
            } else Fo.addObj(6,is); /* filename -- set as Value-1 */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              TSLogg.Print("cvrt67",cB.getLne(1),""+cc); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(16); /* terminate program */
            } /* severe error found */
            j = cB.getHV(8); /* convert next hex-number (mask-2) (OR) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              TSLogg.Print("cvrt62",cB.getLne(1),j,3); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(16); /* terminate program */
            } /* severe error found */
            Fo.addObj(6,new Integer(j)); /* store second mask (out of 3) */
            j = -1; /* preset 'mask-3'-value (AND) */
            if((cc=cB.charAt(true))==':') { /* next value follows */
              j = cB.getHV(8); /* convert next hex-number (mask-3) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                TSLogg.Print("cvrt62",cB.getLne(1),j,4); /* print error */
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(16); /* terminate program */
              } /* severe error found */
              cc = cB.charAt(true); /* get next separator */
            } /* third mask was available */
            if(cc!='\n') { /* EOL was NOT found */
              TSLogg.Print("cvrt68",cB.getLne(1),""+cc); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(16); /* terminate program */
            } /* severe error found */
            Fo.addObj(6,new Integer(j)); /* store third mask (out of 3) */
            Fo.setMsk(14); /* activate operation */
            break; /* command is processed -- continue with next one */
          case('P'): /* HIDDEN: Pfad-Definitionen veraendert ausgeben */
          case('p'): Fo.setMsk(8); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('R'): /* REORG der UID's  wird gefordert */
          case('r'): Fo.setMsk(1); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('S'): /* Testen der Shape-Files wird gefordert */
          case('s'): Fo.setMsk(2); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('T'): /* HIDDEN: Strukturdatendatei reparieren */
          case('t'): /* alternativer Beginn */
            if(cB.getLne(0).equalsIgnoreCase("-tdrepair")) { Fo.setMsk(18); break; }
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* Meldung erstellen */
            break; /* command is processed -- continue with next one */
          case('U'): /* Komprimierung der world-Dateien unterdruecken */
          case('u'): Fo.setMsk(4); /* setze Mode */
            Fo.clrMsk(3); /* Alternativen Modus loeschen */
            break; /* command is processed -- continue with next one */
          case('V'): /* Zuordnungen alt-neu manuell herstellen  */
          case('v'): /* alternativer Beginn */
            shd = (int)cB.getNV(); /* convert next number (source) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              TSLogg.Print("cvrt04",is,cB.getLne(1)); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n') TSLogg.Print("cvrt05",cB.getLne(1)); /* print error */
              else TSLogg.Print("cvrt06",cB.getLne(1),""+cc); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            scd = (int)cB.getNV(); /* convert next number (target) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              TSLogg.Print("cvrt07",is,cB.getLne(1)); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.addObj(1,new Integer(shd)); /* add new value (source) */
            Fo.addObj(1,new Integer(scd)); /* add second value (target) */
            break; /* command is processed -- continue with next one */
          case('W'): /* Dummy-World-Dateien erzeugen */
          case('w'): Fo.setMsk(6); /* set Mode */
            break; /* command is processed -- continue with next one */
          case('Z'): /* check Static-objects and change back to 'TrkObj' if needed */
            uc = true; /* mark: control-character was 'Upper'-case */
          case('z'): /* start here using only strings */
            cL = Fo.getQue(4); /* prefetch affected Queue */
            j = 42; /* preset options for processing 'Hidewire'-objects */
            shd = "x123".indexOf(cc=cB.charAt(true)); /* check next digit */
            if(shd>0) { /* 'StaticDetailLevel' is valid for 'Hidewire'-objects */
              cL.add(new Integer(shd)); /* set Value-0 of definition */
              FoX.setMsk(1); /* and activate mode */
              uc = false; /* mark: 'Upper'-case is NOT used here */
            } else { /* continue check with 'modification' */
              shd = "\n0456789+".indexOf(cc); /* check next digit */
              if(shd<1) { /* invalid 'StaticDetailLevel' specified */
                if(shd==0) TSLogg.Print("cvrt31",cB.getLne(1)); /* print errormessage */
                else TSLogg.Print("cvrt32",cB.getLne(1),""+cc); /* print errormessage */
                System.exit(15); /* terminate program */
              } /* severe error found */
              shd += 2; /* compute correct StaticDetailLevel */
              if(shd<4) shd = 0; /* and consider special case */
              j = 21; /* adjust options for processing 'Modifications' */
              cL.getOpt(2).setMsk(cL.size()/3); /* set marker to 'Modification' */
              cL.add(new Integer(shd)); /* set Value-0 of definition */
              FoX.setMsk(2); /* and activate mode */
            } /* version 'Modification' is successfully processed */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n' && j==42) { /* no more arguments found */
                cL.add(null); /* insert dummy-value */
                cL.add(null); /* insert dummy-value */
                break; /* command is processed -- continue with next one */
              } /* valid 'end of command' reached */
              TSLogg.Print("cvrt33",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            is = cB.getVal(j); /* get filename (source) / expression */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("cvrt34",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(is.length()<1) { /* source-name was not specified */
              TSLogg.Print("cvrt35",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(uc) { /* 'regular expression' follows -- check it */
              Pt = null; /* for compiler */
              try { Pt = Pattern.compile(is,Pattern.CASE_INSENSITIVE);
              } catch (PatternSyntaxException p) { /* error in compile */
                TSLogg.Print("cvrt36",is,p.getDescription());
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(15); /* terminate program */
              } /* Selection-definition contains error(s) */
              cL.add(Pt); /* set Pattern as Value-1 */
            } else cL.add(is.toLowerCase()); /* set Value-1 of definition */
            if((cc=cB.charAt(true))=='\n') { /* valid EOL found -- handle it */
              TSLogg.prtMsg("cvrt37",cB.getLne(1)); /* print warning */
              Fo.addObj(4,""); /* set Value-2 of definition */
              break; /* command is fully processed */
            } /* valid EOL handled */
            if(cc!=':') { /* invalid separator */
              TSLogg.Print("cvrt38",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            is = cB.getVal(21); /* get filename (target) */
            if(is==null) { /* EOF within data (no target specified) */
              TSLogg.Print("cvrt39",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            cL.add(is); /* set Value-2 of definition */
            if((cc=cB.charAt(true))=='\n') break;/* command is processed */
            TSLogg.Print("cvrt3A",cB.getLne(1),""+cc); /* print errormessage */
            TSLogg.Print("Msg009"); /* print hint of operating */
            System.exit(15); /* terminate program */
          default: /* unknown option detected */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        }
        i += 1; /* naechstes Argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      if(i<args.length) { /* zusaetzlichen Parameter vorhanden */
        cLg = chkLog(args[i++]); /* Logging-Objekt erstellen */
        if(cLg!=null && Lg==null) Lg = cLg; /* Gueltig -- Logging aktivieren */
      } /* Logging wurde zusaetzlich spezifiziert */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 5; /* select current command */
    } else if(is.equalsIgnoreCase("dcpy")) { /* -##dcpy- World-Datei bearbeiten */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"dCopyP9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"dCopyP9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('A'): /* alle Dateien beachten (auch .bk) */
          case('a'): Fo.setMsk(1); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('O'): /* nur vorhandene Dateien vergleichen */
          case('o'): Fo.setMsk(2); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('T'): /* files use 'time-displacement' (summer/winter) */
          case('t'): /* alternate control-letter */
            if(cB.length()<4) { /* invalid length of option - terminate */
              TSLogg.prtMsg("dCopyP1",cB.getLne(1)); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* length of definition incorrect */
            j = (int)cB.getNV(); /* convert next number */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              TSLogg.Print("dCopyP2",cB.getLne(3),j); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(16); /* terminate program */
            } /* severe error found */
            if(j<-180 || j>180) { /* range-error within time-displacement */
              TSLogg.Print("dCopyP3",cB.getLne(1),j); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(17); /* terminate program */
            } /* length of definition incorrect */
            Fo.setInt(0,j); /* store value for later processing */
            Fo.setMsk(3); /* and set mode */
            break; /* command is processed -- continue with next one */
          default: /* unknown option detected */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        }
        i += 1; /* naechstes Argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if((i+3)>args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn  = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      vn2 = args[i++]; /* Geforderte Datei */
      Kdo = getPrnt(Kdo,vn2); /* add current name for printing */
      vn3 = args[i++]; /* Geforderte Datei */
      Kdo = getPrnt(Kdo,vn3); /* add current name for printing */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 7; /* select current command */
    } else if(is.equalsIgnoreCase("filter")) { /* -##filter- Streckendefinition filtern */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"filter9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"filter9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('C'): /* '.t'-Datei loeschen falls World-Datei nicht vorhanden */
          case('c'): Fo.setMsk(2); /* setze Mode */
            /* '-w'-Option implizit setzen */
          case('W'): /* World-Dateien als Kriterium einbeziehen */
          case('w'): Fo.setMsk(1); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('I'): /* HIDDEN: replace target-file(s) directly */
          case('i'): /* alternate identifier */
            if(cB.getLne(0).equalsIgnoreCase("-inplace")) { Fo.setMsk(17); break; }
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
            break; /* command is processed -- continue with next one */
          default: /* unknown option detected */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        }
        i += 1; /* naechstes Argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(i==args.length) { /* Fehler im Aufruf */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 9; /* select current command */
    } else if(is.equalsIgnoreCase("fcpy")) { /* -##fcpy- copy files and edit them, change file-format */
      fn = null; /* preset: no file-selection-mask specified */
      vn2 = "";  /* preset: file-type is not specified until now */
      Fo.addObj(5,null); /* set second argument, dummy if not used */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"FleCpy9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        uc = false; /* preset: option uses lower case */
        if(cB.length()<2) break; /* no more options possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"FleCpy9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('A'): /* process 'ASCII'-files (Text) */
          case('a'): if(vn2.length()==0) { vn2 = "Ascii"; break; } /* mark type */
            TSLogg.prtMsg("FleCpy01",cB.getLne(1),vn2); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('B'): /* block-mode' should be used to modify file */
          case('b'): Fo.setMsk(9); /* set new mode of processing */
            break; /* command is processed -- continue with next one */
          case('C'): /* 'compress'-mode is requested */
          case('c'): if(Fo.getMsk(22)!=0) { /* output-mode already specified */
              TSLogg.prtMsg("FleCpy02",cB.getLne(1),vn3); /* print errormessage */
              break; /* do not activate option */
            } /* output-mode already specified -- do not activate option */
            vn3 = "Compress"; /* set output-mode (name) */
            Fo.setMsk(3); /* and mark it */
            break; /* command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('E'): /* 'expanded'-mode is requested */
          case('e'): if(Fo.getMsk(28)!=0) { /* output-mode already specified */
              TSLogg.prtMsg("FleCpy02",cB.getLne(1),vn3); /* print errormessage */
              break; /* do not activate option */
            } /* output-mode already specified -- do not activate option */
            vn3 = "Expand"; /* set output-mode (name) */
            Fo.setMsk(1); /* and mark it */
            break; /* command is processed -- continue with next one */
          case('F'): /* file-mask is specified (regular expression) */
          case('f'): /* process file-mask and store it */
            fn = cB.getTail(true); /* get pattern to check */
            if(fn==null) { /* EOF within data (length-error?) */
              TSLogg.Print("FleCpy03"); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.clrMsk(6); /* mark type of mask as 'regular expression' */
            break; /* command is processed -- continue with next one */
          case('I'): /* Target-format 'Inflate'(CT) is selected */
          case('i'): if(Fo.getMsk(14)!=0) { /* output-mode already specified */
              TSLogg.prtMsg("FleCpy02",cB.getLne(1),vn3); /* print errormessage */
              break; /* do not activate option */
            } /* output-mode already specified -- do not activate option */
            vn3 = "Inflate"; /* set output-mode (name) */
            Fo.setMsk(4); /* and mark it */
            break; /* command is processed -- continue with next one */
          case('M'): /* modify contents of data-lines using 'regular expression(s)' */
            uc = true; /* mark: control-character was 'Upper'-case */
          case('m'): /* modify contents of data-lines without 'regular expression(s)' */
            is = cB.getVal(21); /* get source-expression */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("FleCpy11",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(is.length()<1) { /* source-data was not specified */
              TSLogg.Print("FleCpy12",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(uc) { /* 'regular expression' follows -- check it */
              Pt = null; /* compiler needs it */
              try { Pt = Pattern.compile(is,Fo.chkMsk(7)?0:Pattern.CASE_INSENSITIVE);
              } catch (PatternSyntaxException p) { /* error in compile */
                TSLogg.Print("FleCpy13",is,p.getDescription());
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(15); /* terminate program */
              } /* Selection-definition contains error(s) */
              Fo.addObj(5,Pt); /* set Pattern as Value-1 */
            } else { /* source-definition is a 'String'-value */
              if(!Fo.chkMsk(7)) is = is.toLowerCase(); /* not case-sensitive */
              Fo.addObj(5,is); /* store source-string as Value-1 */
            } /* source-string specified -- set it as Value-1 */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n') TSLogg.Print("FleCpy14",cB.getLne(1)); /* print errormessage */
              else TSLogg.Print("FleCpy15",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            is = cB.getVal(21); /* get target-value */
            if(is==null) { /* EOF within data (no target specified) */
              TSLogg.Print("FleCpy16",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(is.length()<1) { /* target-value was not specified */
              TSLogg.Print("FleCpy17",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.addObj(5,is); /* set string-value as Value-2 */
            break; /* command is processed -- continue with next one */
          case('N'): /* file-mask is specified (windows-format) */
          case('n'): /* process file-mask and store it */
            fn = cB.getTail(true); /* get pattern to check */
            if(fn==null) { /* EOF within data (length-error?) */
              TSLogg.Print("FleCpy08"); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.setMsk(6); /* mark type of mask as 'windows' */
            break; /* command is processed -- continue with next one */
          case('O'): /* output-directory may be created */
          case('o'): Fo.setMsk(5); /* register mode */
            break; /* command is processed -- continue with next one */
          case('P'): /* compare has to be 'case-sensitive' (proper/precise) */
          case('p'): Fo.setMsk(7); /* set new comparison-mode */
            break; /* command is processed -- continue with next one */
          case('R'): /* 'reduce'-mode is requested */
          case('r'): if(Fo.getMsk(26)!=0) { /* output-mode already specified */
              TSLogg.prtMsg("FleCpy02",cB.getLne(1),vn3); /* print errormessage */
              break; /* do not activate option */
            } /* output-mode already specified -- do not activate option */
            vn3 = "Reduce"; /* set output-mode (name) */
            Fo.setMsk(2); /* and mark it */
            break; /* command is processed -- continue with next one */
          case('S'): /* process 'shape'-files */
          case('s'): if(vn2.length()==0) { vn2 = "Shape"; break; } /* mark type */
            TSLogg.prtMsg("FleCpy01",cB.getLne(1),vn2); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('T'): /* process 'tile'-files */
          case('t'): if(vn2.length()==0) { vn2 = "Tile"; break; } /* mark type */
            TSLogg.prtMsg("FleCpy01",cB.getLne(1),vn2); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('U'): /* process 'unicode'-files (text) */
          case('u'): if(vn2.length()==0) { vn2 = "Unicode"; break; } /* mark type */
            TSLogg.prtMsg("FleCpy01",cB.getLne(1),vn2); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('W'): /* process 'world'-files */
          case('w'): if(vn2.length()==0) { vn2 = "World"; break; } /* mark type */
            TSLogg.prtMsg("FleCpy01",cB.getLne(1),vn2); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('X'): /* change file-format from ascii to unicode (or vice versa) */
          case('x'): Fo.setMsk(10); /* mark additional conversion */
            break; /* command is processed -- continue with next one */
          case('Z'): /* modification-mask is specified (regular expression) */
          case('z'): /* process -mask and store it */
            is = cB.getTail(true); /* get pattern to check */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("FleCpy09"); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.setObj(5,1,is); /* store modification-string for file-name */
            Fo.setMsk(8); /* mark: modification is present */
            break; /* command is processed -- continue with next one */
          case('$'): /* Additional process control-definitions */
            if(cB.length()<4) { /* invalid length of option - terminate */
              TSLogg.prtMsg("FleCpy21",cB.getLne(1)); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* length of definition incorrect */
            is = cB.getKE(true); /* get keyword of option */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) /* EOF within data */
                TSLogg.prtMsg("FleCpy22",cB.getLne(2)); /* print error */
               else TSLogg.prtMsg("FleCpy23",cB.getLne(2),is); /* print error */
              break; /* do not activate option */
            } /* EOF within data -- do not activate option */
            if(is.length()==0) { /* next keword not present */
              TSLogg.Print("FleCpy24",cB.getLne(2)); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(16); /* terminate program */
            } /* severe error found */
            if(is.equalsIgnoreCase("File")) { /* 'File' = register file-type */
              /* Attention: Usage is '-$File(...)' */
              is = cB.getVal(1); /* get value of argument (name) */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  TSLogg.Print("FleCpy31",cB.getLne(2)); /* print error */
                  TSLogg.Print("Msg009"); /* print hint of operating */
                  System.exit(16); /* terminate program */
                } /* severe error found */
                TSLogg.Print("FleCpy32",is,cB.getLne(2)); /* print error */
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(16); /* terminate program */
              } /* severe error found */
              if(vn2.length()>0) { /* file-type is already specified */
                TSLogg.prtMsg("FleCpy01",cB.getLne(1),vn2); /* print errormessage */
                break; /* command is processed -- continue with next one */
              } /* file-type was already specified */
              vn2 = is; /* register file-type */
            } else TSLogg.prtMsg("FleCpy25",cB.getLne(2)+"{"+is+"}");
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(Fo.getMsk(30)==0) /* no action specified (2**1+2**2+2**3+2**4) */
        TSLogg.prtMsg("FleCpy04"); /* print warning */

      if(vn2.equals("Ascii")) FoX.setMsk(0); /* store file-type (Text-A) */
      else if(vn2.equals("Unicode")) FoX.setMsk(1); /* store file-type (Text-U) */
      else if(vn2.equalsIgnoreCase("Shape")) FoX.setMsk(2); /* store file-type (Shape) */
      else if(vn2.equalsIgnoreCase("World")) FoX.setMsk(3); /* store file-type (World) */
      else if(vn2.equalsIgnoreCase("Tile")) FoX.setMsk(4); /* store file-type (Tile) */
      else if(vn2.equalsIgnoreCase("Route")) FoX.setMsk(5); /* store file-type (trk) */
      else if(vn2.equalsIgnoreCase("GTS")) FoX.setMsk(6); /* store file-type (gts.dat) */
      else if(vn2.equalsIgnoreCase("LTS")) FoX.setMsk(7); /* store file-type (lts.dat) */
      else if(vn2.equalsIgnoreCase("Idx")) FoX.setMsk(8); /* store file-type (idx) */
      else if(vn2.equalsIgnoreCase("WorldSound")) FoX.setMsk(9); /* store file-type (ws) */
      else if(vn2.equalsIgnoreCase("DataBase")) FoX.setMsk(10); /* store file-type (tdb/rdb) */
      else if(vn2.equalsIgnoreCase("ITBase")) FoX.setMsk(11); /* store file-type (tit/rit) */
      else if(vn2.equalsIgnoreCase("Signal")) FoX.setMsk(12); /* store file-type (sigcfg.dat) */
      else if(vn2.equalsIgnoreCase("Activity")) FoX.setMsk(13); /* store file-type (act) */
      else if(vn2.equalsIgnoreCase("Path")) FoX.setMsk(14); /* store file-type (pat) */
      else if(vn2.equalsIgnoreCase("Service")) FoX.setMsk(15); /* store file-type (srv) */
      else if(vn2.equalsIgnoreCase("Traffic")) FoX.setMsk(16); /* store file-type (trf) */
      else if(vn2.equalsIgnoreCase("Sound")) FoX.setMsk(17); /* store file-type (sms) */
      else if(vn2.equalsIgnoreCase("Environment")) FoX.setMsk(18); /* store file-type (env) */
      else if(vn2.equalsIgnoreCase("SoundSource")) FoX.setMsk(19); /* store file-type (ssc) */
      else if(vn2.equalsIgnoreCase("TType")) FoX.setMsk(20); /* store file-type (ttp) */
      else if(vn2.equalsIgnoreCase("CarS")) FoX.setMsk(21); /* store file-type (car) */
      else if(vn2.equalsIgnoreCase("Forest")) FoX.setMsk(22); /* store file-type (for) */
      else if(vn2.equalsIgnoreCase("Gantry")) FoX.setMsk(23); /* store file-type (gty) */
      else if(vn2.equalsIgnoreCase("Speedpost")) FoX.setMsk(24); /* store file-type (spp) */
      else if(vn2.equalsIgnoreCase("Telepole")) FoX.setMsk(25); /* store file-type (tpl) */
      else if(vn2.equalsIgnoreCase("Hazard")) FoX.setMsk(26); /* store file-type (haz) */
      else if(vn2.equalsIgnoreCase("Marker")) FoX.setMsk(27); /* store file-type (mkr) */
      else if(vn2.equalsIgnoreCase("Ref")) FoX.setMsk(28); /* store file-type (ref) */
      else if(vn2.equalsIgnoreCase("Consist")) FoX.setMsk(29); /* store file-type (con) */
      else if(vn2.equalsIgnoreCase("ShapeCtl")) FoX.setMsk(30); /* store file-type (sd) */
      else { /* no or invalid file-type specified */
        TSLogg.Print("FleCpy05",vn2); /* print errormessage */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found -- function terminated */
      if(Fo.cntMsk(32776)==2) { /* 'Compress' of 'Tile' requested (2**15+2**3) */
        TSLogg.Print("FleCpy06"); /* print errormessage */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found -- function terminated */
      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* print errormessage */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found -- function terminated */
      vn2 = args[i++]; /* save path of source-directory. It is already added to 'Kdo' */
      if(i==args.length) { /* required arguments missing */
        TSLogg.Print("Msg011"); /* print errormessage */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found -- function terminated */
      vn3 = args[i++]; /* save path of target-directory */
      Kdo = getPrnt(Kdo,vn3); /* add current name for printing */

      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      if(Fo.chkMsk(10) && Fo.getMsk(6144)==0) /* option has no impact on function */
        TSLogg.prtMsg("FleCpy18",toHex(Fo.getMsk(-1),-8)); /* option has no impact */

      j = 29; /* select current command */
    } else if(is.equalsIgnoreCase("fmgr")) { /* -##fmgr- Dateien bearbeiten (red/exp/comp/uncomp) */
      fn = null; /* vorbesetzen: keine Datei-Maske angegeben */
      vn2 = "";  /* vorbesetzen: File-Typ noch nicht angegeben */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"FleMgr9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"FleMgr9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('C'): /* Compress ist erforderlich */
          case('c'): if(Fo.getMsk(6)!=0) { /* other action already specified */
              TSLogg.prtMsg("FleMgr02",cB.getLne(1),vn3); /* print errormessage */
              break; /* do not activate option */
            } /* other action already specified -- do not activate option */
            vn3 = "Compress"; /* Modus sichtbar festlegen */
            Fo.setMsk(3); /* kennzeichne Mode */
            break; /* command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('E'): /* Expanded ist erforderlich */
          case('e'): if(Fo.getMsk(12)!=0) { /* other action already specified */
              TSLogg.prtMsg("FleMgr02",cB.getLne(1),vn3); /* print errormessage */
              break; /* do not activate option */
            } /* other action already specified -- do not activate option */
            vn3 = "Expand"; /* Modus sichtbar festlegen */
            Fo.setMsk(1); /* kennzeichne Mode */
            break; /* command is processed -- continue with next one */
          case('M'): /* Dateimaske wird spezifiziert */
          case('m'): /* Dateimaske auswerten und speichern */
            fn = cB.getTail(true); /* get pattern to check */
            if(fn==null) { /* EOF within data (length-error?) */
              TSLogg.Print("FleMgr03"); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.clrMsk(6); /* Namenstyp kennzeichnen (Maske) */
            break; /* command is processed -- continue with next one */
          case('N'): /* Dateiname wird spezifiziert */
          case('n'): /* Dateiname auswerten und speichern */
            fn = cB.getTail(true); /* get pattern to check */
            if(fn==null) { /* EOF within data (length-error?) */
              TSLogg.Print("FleMgr08"); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.setMsk(6); /* Namenstyp kennzeichnen (Name) */
            break; /* command is processed -- continue with next one */
          case('O'): /* Ausgabe-Verzeichnis ggf. neu erstellen */
          case('o'): Fo.setMsk(5); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('R'): /* Reduce ist gefordert */
          case('r'): if(Fo.getMsk(10)!=0) { /* other action already specified */
              TSLogg.prtMsg("FleMgr02",cB.getLne(1),vn3); /* print errormessage */
              break; /* do not activate option */
            } /* other action already specified -- do not activate option */
            vn3 = "Reduce"; /* Modus sichtbar festlegen */
            Fo.setMsk(2); /* kennzeichne Mode */
            break; /* command is processed -- continue with next one */
          case('S'): /* Shape-Dateien reduzieren */
          case('s'): if(vn2.length()==0) { vn2 = "Shape"; break; } /* Typ kennzeichnen */
            TSLogg.prtMsg("FleMgr01",cB.getLne(1),vn2); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('T'): /* Tile-Dateien reduzieren */
          case('t'): if(vn2.length()==0) { vn2 = "Tile"; break; } /* Typ kennzeichnen */
            TSLogg.prtMsg("FleMgr01",cB.getLne(1),vn2); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('W'): /* World-Dateien reduzieren */
          case('w'): if(vn2.length()==0) { vn2 = "World"; break; } /* Typ kennzeichnen */
            TSLogg.prtMsg("FleMgr01",cB.getLne(1),vn2); /* print errormessage */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(Fo.getMsk(14)==0) { /* keine Aktion angegeben (2**1+2**2+2**3) */
        TSLogg.Print("FleMgr04"); /* print errormessage */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      }
      if(vn2.equals("Shape")) Fo.setMsk(13); /* setze Typ-Kennzeichen (Shape) */
      else if(vn2.equals("World")) Fo.setMsk(14); /* setze Typ-Kennzeichen (World) */
      else if(vn2.equals("Tile")) Fo.setMsk(15); /* setze Typ-Kennzeichen (Tile) */
      else { /* keinen/falschen Datei-Typ angegeben */
        TSLogg.Print("FleMgr05",vn2); /* print errormessage */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found -- function terminated */
      if(Fo.cntMsk(32776)==2) { /* 'Compress' von 'Tile' gefordert (2**15+2**3) */
        TSLogg.Print("FleMgr06"); /* print errormessage */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found -- function terminated */
      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011");  /* print errormessage */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found -- function terminated */
      vn2 = args[i++];  /* save requested source-path. It is already added to 'Kdo' */
      if(i==args.length) { /* required arguments missing */
        TSLogg.Print("Msg011"); /* print errormessage */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found -- function terminated */
      vn3 = args[i++]; /* zweiten Verzeichnispfad setzen */
      Kdo = getPrnt(Kdo,vn3); /* add current name for printing */

      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 24; /* select current command */
    } else if(is.equalsIgnoreCase("ichk")) { /* -##ichk- Integritaet pruefen */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"ichk9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        uc = false; /* preset: option uses lower case */
        if(cB.length()<2) break; /* no more options possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"ichk9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('K'): /* Simuliere Korrektur-Modus fuer World-Dateien */
          case('k'): Fo.setMsk(5); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('S'): /* Testen der Shape-Files wird gefordert */
            Fo.setMsk(3); /* setze Mode (gesamt) */
          case('s'): Fo.setMsk(2); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('T'): /* HIDDEN: Strukturdatendatei reparieren */
          case('t'): /* alternativer Beginn */
            if(cB.getLne(0).equalsIgnoreCase("-tdrepair")) { Fo.setMsk(18); break; }
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('Z'): /* check Static-objects and change back to 'TrkObj' if needed */
            uc = true; /* mark: control-character was 'Upper'-case */
          case('z'): /* start here using only strings */
            cL = Fo.getQue(4); /* prefetch affected Queue */
            j = 42; /* preset options for processing 'Hidewire'-objects */
            shd = "x123".indexOf(cc=cB.charAt(true)); /* check next digit */
            if(shd>0) { /* 'StaticDetailLevel' is valid for 'Hidewire'-objects */
              cL.add(new Integer(shd)); /* set Value-0 of definition */
              Fo.setMsk(6); /* and activate mode */
              uc = false; /* mark: 'Upper'-case is NOT used here */
            } else { /* continue check with 'modification' */
              shd = "\n0456789+".indexOf(cc); /* check next digit */
              if(shd<1) { /* invalid 'StaticDetailLevel' specified */
                if(shd==0) TSLogg.Print("ichk11",cB.getLne(1));
                else TSLogg.Print("ichk12",cB.getLne(1),""+cc,""+shd);
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(15); /* terminate program */
              } /* severe error found */
              shd += 2; /* compute correct StaticDetailLevel */
              if(shd<4) shd = 0; /* and consider special case */
              j = 21; /* adjust options for processing 'Modifications' */
              cL.getOpt(2).setMsk(cL.size()/3); /* set marker to 'Modification' */
              cL.add(new Integer(shd)); /* set Value-0 of definition */
              Fo.setMsk(7); /* and activate mode */
            } /* version 'Modification' is successfully processed */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n' && j==42) { /* no more arguments found */
                Fo.addObj(4,null); /* insert dummy-value */
                Fo.addObj(4,null); /* insert dummy-value */
                break; /* command is processed -- continue with next one */
              } /* valid 'end of command' reached */
              TSLogg.Print("ichk13",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            is = cB.getVal(j); /* get filename (source) / expression */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("ichk14",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(is.length()<1) { /* source-name was not specified */
              TSLogg.Print("ichk15",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(uc) { /* 'regular expression' follows -- check it */
              Pt = null; /* for compiler */
              try { Pt = Pattern.compile(is,Pattern.CASE_INSENSITIVE);
              } catch (PatternSyntaxException p) { /* error in compile */
                TSLogg.Print("ichk16",is,p.getDescription());
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(15); /* terminate program */
              } /* Selection-definition contains error(s) */
              cL.add(Pt); /* set Pattern as Value-1 */
            } else cL.add(is.toLowerCase()); /* set Value-1 of definition */
            if((cc=cB.charAt(true))=='\n') { /* valid EOL found -- handle it */
              TSLogg.prtMsg("ichk17",cB.getLne(1)); /* print warning */
              Fo.addObj(4,""); /* set Value-2 of definition */
              break; /* command is fully processed */
            } /* valid EOL handled */
            if(cc!=':') { /* invalid separator */
              TSLogg.Print("ichk18",cB.getLne(1),""+cc); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            is = cB.getVal(21); /* get filename (target) */
            if(is==null) { /* EOF within data (no target specified) */
              TSLogg.Print("ichk19",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            cL.add(is); /* set Value-2 of definition */
            if((cc=cB.charAt(true))=='\n') break;/* command is processed */
            TSLogg.Print("ichk20",cB.getLne(1),""+cc); /* print errormessage */
            TSLogg.Print("Msg009"); /* print hint of operating */
            System.exit(15); /* terminate program */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      if(i<args.length) { /* zusaetzlichen Parameter vorhanden */
        cLg = chkLog(args[i++]); /* Logging-Objekt erstellen */
        if(cLg!=null && Lg==null) Lg = cLg; /* Gueltig -- Logging aktivieren */
      } /* Logging wurde zusaetzlich spezifiziert */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 12; /* select current command */
    } else if(is.equalsIgnoreCase("insert")) { /* -##insert- Streckenobjekte zusammenmischen */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"Insrt9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"Insrt9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('H'): /* Track-Objekte modifizieren (OL unterdruecken) */
          case('h'): /* alternativer Beginn */
            shd = "\n123".indexOf(cc=cB.charAt(true)); /* check next digit */
            if(shd<1) { /* invalid 'StaticDetailLevel' specified */
              if(shd==0) TSLogg.Print("Insrt11",cB.getLne(1));
              else TSLogg.Print("Insrt12",cB.getLne(1),""+cc);
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            is = cB.getTail(true); /* get remaining option */
            if(is!=null) TSLogg.Print("Insrt13",is); /* print warning */
            Fo.setMsk(7); /* set mode */
            Fo.setInt(3,0,shd); /* insert StaticDetailLevel */
            break; /* command is processed -- continue with next one */
          case('P'): /* Kopieren der Puffer gefordert */
          case('p'): Fo.setMsk(4); /* setze Mode */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
        TSLogg.Print("Insrt01"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      vn2 = args[i++]; /* save requested filename. */
      Kdo = getPrnt(Kdo,vn2); /* add current name for printing */

      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 98; /* select current command */
    } else if(is.equalsIgnoreCase("merge")) { /* -##merge- Streckendefinitionen mischen */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"Merge9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"Merge9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('H'): /* Track-Objekte modifizieren (OL unterdruecken) */
          case('h'): /* alternativer Beginn */
            shd = "\n123".indexOf(cc=cB.charAt(true)); /* check next digit */
            if(shd<1) { /* invalid 'StaticDetailLevel' specified */
              if(shd==0) TSLogg.Print("Merge11",cB.getLne(1));
              else TSLogg.Print("Merge12",cB.getLne(1),""+cc);
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            is = cB.getTail(true); /* get remaining option */
            if(is!=null) TSLogg.Print("Merge13",is); /* print warning */
            Fo.setMsk(7); /* set mode */
            Fo.setInt(3,0,shd); /* insert StaticDetailLevel */
            break; /* command is processed -- continue with next one */
          case('o'): /* Overlay world-files if present */
          case('O'): Fo.setMsk(9); /* activate feature */
            break; /* command is processed -- continue with next one */
          case('P'): /* Kopieren der Puffer gefordert */
          case('p'): Fo.setMsk(4); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('S'): /* DO NOT merge signaldefinitions */
          case('s'): Fo.setMsk(8); /* set option */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
        TSLogg.Print("Merge01"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      vn2 = args[i++]; /* save requested filename. */
      Kdo = getPrnt(Kdo,vn2); /* add current name for printing */

      if(i<args.length) { /* zusaetzlichen Parameter vorhanden */
        cLg = chkLog(args[i++]); /* Logging-Objekt erstellen */
        if(cLg!=null && Lg==null) Lg = cLg; /* Gueltig -- Logging aktivieren */
      } /* Logging wurde zusaetzlich spezifiziert */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 19; /* select current command */
    } else if(is.equalsIgnoreCase("move")) { /* -##move- Streckendefinition verschieben */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(args[i]); /* use current command */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('C'): /* Komprimieren der Tile-Dateien */
          case('c'): Fo.setMsk(3); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('P'): /* Kopieren der Puffer-Dateien durchfuehren */
          case('p'): Fo.setMsk(4); /* setze Mode */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */

      if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
        TSLogg.Print("move1"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      cB = new TSBuf(args[i++]); /* use current command */
      Kdo += cB.getPrnt(); /* add current command for printing */
      shd = (int)cB.getNV(); /* get shift-value 'east-west' */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        TSLogg.Print("move2",is,cB.getLne(0)); /* print error */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found */
      if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
        TSLogg.Print("move3"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      cB = new TSBuf(args[i++]); /* use current command */
      Kdo += cB.getPrnt(); /* add current command for printing */
      scd = (int)cB.getNV(); /* get shift-value 'north-south' */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        TSLogg.Print("move4",is,cB.getLne(0)); /* print error */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found */

      if(i<args.length) { /* zusaetzlichen Parameter vorhanden */
        cLg = chkLog(args[i++]); /* Logging-Objekt erstellen */
        if(cLg!=null && Lg==null) Lg = cLg; /* Gueltig -- Logging aktivieren */
      } /* Logging wurde zusaetzlich spezifiziert */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 14; /* select current command */
    } else if(is.equalsIgnoreCase("mveobj")) { /* -##mveobj- Streckenobjekte verschieben */
      if(Fo.cr$Obj(5,4)) throw new /* dummy-elements could not be inserted */
          IllegalStateException(TSLogg.getMsg("Msg905","Fo.Data(5)"));
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"mveObj9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        uc = false; /* preset: option uses lower case */
        if((j=cB.length())<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"mveObj9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('G'): /* Fehlende Tile-Definitionen generieren */
          case('g'): Fo.setMsk(1); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('R'): /* Strassendefinitionen (Road) ignorieren */
          case('r'): Fo.setMsk(3); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('T'): /* NUR Track-/Road-Definitionen verschieben */
            uc = true; /* mark: control-character was 'Upper'-case */
          case('t'): Fo.setMsk(2); /* setze Mode */
            if(j<3) break; /* no additional options available -- OK */
            j = cB.getHV(4); /* convert next hex-number (object-mask) */
            if((is=cB.getErr())!=null) ot:{ /* error while evaluating */
              if(j==-1) { j = 8; break ot; } /* optional: use default-value */
              TSLogg.Print("mveObj81",cB.getLne(1),j); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(16); /* terminate program */
            } /* severe error found */
            Fo.addObj(5,new TSOpts(j)); /* store object-mask*/
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              TSLogg.Print("mveObj82",cB.getLne(1),""+cc); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(16); /* terminate program */
            } /* severe error found */
            is = cB.getVal(21); /* get filename (source) / expression */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("mveObj83",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(is.length()<1) { /* source-name was not specified */
              TSLogg.Print("mveObj84",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(uc) { /* 'regular expression' follows -- check it */
              Pt = null; /* for compiler */
              try { Pt = Pattern.compile(is,Pattern.CASE_INSENSITIVE);
              } catch (PatternSyntaxException p) { /* error in compile */
                TSLogg.Print("mveObj85",is,p.getDescription());
                TSLogg.Print("Msg009"); /* print hint of operating */
                System.exit(15); /* terminate program */
              } /* Selection-definition contains error(s) */
              Fo.addObj(5,Pt); /* set Pattern as Value-1 */
            } else Fo.addObj(5,is); /* filename -- set as Value-1 */
            break; /* command is processed -- continue with next one */
          case('V'): /* DO NOT 'Validate' sound-Objects ('clip' NICHT benutzen) */
          case('v'): Fo.setMsk(5); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('W'): /* Fortsetzen wenn Fehler erkannt wurden */
          case('w'): Fo.setMsk(4); /* setze Mode */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */

      if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
        TSLogg.Print("mveObjP1"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      cB = new TSBuf(args[i++]); /* use current command */
      Kdo += cB.getPrnt(); /* add current command for printing */
      f = cB.getFV(); /* get shift-value X */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        TSLogg.Print("mveObjP2",is,cB.getLne(0)); /* print error */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found */
      if(Math.abs(f)>20480.0) { /* Wert NICHT zulaessig (>10 Quadranden) */
        TSLogg.Print("mveObjP7",f); /* Meldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(16);
      }
      Fo.setFlt(5,1,f); /* Verschiebungswert speichern */

      if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
        TSLogg.Print("mveObjP3"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      cB = new TSBuf(args[i++]); /* use current command */
      Kdo += cB.getPrnt(); /* add current command for printing */
      f = cB.getFV(); /* get shift-value Y */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        TSLogg.Print("mveObjP4",is,cB.getLne(0)); /* print error */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found */
      if(Math.abs(f)>1000.0) { /* Wert NICHT zulaessig */
        TSLogg.Print("mveObjP8",f); /* Meldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(16);
      }
      Fo.setFlt(5,2,f); /* Verschiebungswert speichern */

      if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
        TSLogg.Print("mveObjP5"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      cB = new TSBuf(args[i++]); /* use current command */
      Kdo += cB.getPrnt(); /* add current command for printing */
      f = cB.getFV(); /* get shift-value Z */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        TSLogg.Print("mveObjP6",is,cB.getLne(0)); /* print error */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found */
      if(Math.abs(f)>20480.0) { /* Wert NICHT zulaessig (>10 Quadranden) */
        TSLogg.Print("mveObjP9",f); /* Meldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(16);
      }
      Fo.setFlt(5,3,f); /* Verschiebungswert speichern */

      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 27; /* select current command */
    } else if(is.equalsIgnoreCase("rendb")) { /* -##rendb- DB neu nummerieren */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"rendb9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"rendb9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('A'): /* Nicht referenzierte TrItem-Eintraege loeschen */
          case('a'): Fo.setMsk(2); /* setze Mode */
           break; /* command is processed -- continue with next one */
          case('C'): /* Komprimierung der world-Dateien erzwingen */
          case('c'): Fo.setMsk(3); /* setze Mode */
            Fo.clrMsk(4); /* Alternativen Modus loeschen */
            break; /* command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('I'): /* HIDDEN: replace target-file(s) directly */
          case('i'): /* alternate identifier */
            if(cB.getLne(0).equalsIgnoreCase("-inplace")) { Fo.setMsk(17); break; }
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('M'): /* Fehlermarkierungen setzen */
          case('m'): Fo.clrMsk(6); /* Copy-Option loeschen */
            break; /* command is processed -- continue with next one */
          case('O'): /* NUR TrackDB reorganisieren */
          case('o'): Fo.setMsk(5); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('R'): /* Einzelne Datenbank-Referenzen loeschen (TrItem-Eintraege) */
          case('r'): Fo.setMsk(7); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('U'): /* Komprimierung der world-Dateien unterdruecken */
          case('u'): Fo.setMsk(4); /* setze Mode */
            Fo.clrMsk(3); /* Alternativen Modus loeschen */
            break; /* command is processed -- continue with next one */
          case('W'): /* Datenbank auch mit Fehlern erstellen */
          case('w'): Fo.setMsk(1); /* setze Mode */
            Fo.setMsk(6); /* Copy-Option auch setzen */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      if(i<args.length) { /* zusaetzlichen Parameter vorhanden */
        cLg = chkLog(args[i++]); /* Logging-Objekt erstellen */
        if(cLg!=null && Lg==null) Lg = cLg; /* Gueltig -- Logging aktivieren */
      } /* Logging wurde zusaetzlich spezifiziert */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 13; /* select current command */
    } else if(is.equalsIgnoreCase("shftDyn")) { /* -##shftDyn- dynamische Obj. verschieben */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"shfDyn9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"shfDyn9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('C'): /* Komprimierung der world-Dateien erzwingen */
          case('c'): Fo.setMsk(3); /* setze Mode */
            Fo.clrMsk(4); /* Alternativen Modus loeschen */
            break; /* command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('I'): /* HIDDEN: replace target-file(s) directly */
          case('i'): /* alternate identifier */
            if(cB.getLne(0).equalsIgnoreCase("-inplace")) { Fo.setMsk(17); break; }
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('U'): /* Komprimierung der world-Dateien unterdruecken */
          case('u'): Fo.setMsk(4); /* setze Mode */
            Fo.clrMsk(3); /* Alternativen Modus loeschen */
            break; /* command is processed -- continue with next one */
          case('W'): /* Simuliere World-Referenzen fuer dyn-Eintraege */
          case('w'): Fo.setMsk(1); /* setze Mode */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */

      shd = 263; /* Defaultwert setzen */
      scd = 376; /* Defaultwert setzen */

      se:{ /* break-block for system-error */
        if(i<args.length) { /* zusaetzlichen Parameter vorhanden */
          cB = new TSBuf(args[i++]); /* use current command */
          Kdo += cB.getPrnt(); /* add current command for printing */
          cB.mark(false); /* save current input-position */
          is = cB.getVal(1); /* extract argument */
          if(is==null) break se; /* EOF within data (length-error?) */
            /* error is NOT possible: argument exits, first call */
          if(!is.equals("+")) { /* placeholder not found -- try number */
            if(cB.reset(false)) break se; /* reset input-position, 'break' if error */
            shd = (int)cB.getNV(); /* get shift-value 'north-south' */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              TSLogg.Print("shfDyn01",is,cB.getLne(0)); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
        } } /* zusaetzlicher Parameter war vorhanden */
        if(i<args.length) { /* zusaetzlichen Parameter vorhanden */
          cB = new TSBuf(args[i++]); /* use current command */
          Kdo += cB.getPrnt(); /* add current command for printing */
          scd = (int)cB.getNV(); /* get shift-value 'north-south' */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            TSLogg.Print("shfDyn02",is,cB.getLne(0)); /* print error */
            TSLogg.Print("Msg009"); /* print hint of operating */
            System.exit(15); /* terminate program */
          } /* severe error found */
        } /* zusaetzlicher Parameter war vorhanden */
      } /* -se- break-block for system-error */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 22; /* select current command */
    } else if(is.equalsIgnoreCase("shift")) { /* -##shift- ID-Bereiche verschieben */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(args[i]); /* use current command */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('E'): /* Erweiterung der Grenzen ist erlaubt */
          case('e'): Fo.setMsk(1); /* setze Mode */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */

      if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
        TSLogg.Print("shift01"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      cB = new TSBuf(args[i++]); /* use current command */
      Kdo += cB.getPrnt(); /* add current command for printing */
      shl = (int)cB.getNV(); /* get requested number */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        TSLogg.Print("shift02",is,cB.getLne(0)); /* print error */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found */

      if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
        TSLogg.Print("shift03"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      cB = new TSBuf(args[i++]); /* use current command */
      Kdo += cB.getPrnt(); /* add current command for printing */
      shh = (int)cB.getNV(); /* get requested number */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        TSLogg.Print("shift04",is,cB.getLne(0)); /* print error */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found */

      if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
        TSLogg.Print("shift05"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      cB = new TSBuf(args[i++]); /* use current command */
      Kdo += cB.getPrnt(); /* add current command for printing */
      shd = (int)cB.getNV(); /* get requested number */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        TSLogg.Print("shift06",is,cB.getLne(0)); /* print error */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found */

      if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
        TSLogg.Print("shift07"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      cB = new TSBuf(args[i++]); /* use current command */
      Kdo += cB.getPrnt(); /* add current command for printing */
      scl = (int)cB.getNV(); /* get requested number */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        TSLogg.Print("shift08",is,cB.getLne(0)); /* print error */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found */

      if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
        TSLogg.Print("shift09"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      cB = new TSBuf(args[i++]); /* use current command */
      Kdo += cB.getPrnt(); /* add current command for printing */
      sch = (int)cB.getNV(); /* get requested number */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        TSLogg.Print("shift10",is,cB.getLne(0)); /* print error */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found */

      if(i>=args.length) { /* zusaetzlicher Parameter fehlt */
        TSLogg.Print("shift11"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      cB = new TSBuf(args[i++]); /* use current command */
      Kdo += cB.getPrnt(); /* add current command for printing */
      scd = (int)cB.getNV(); /* get requested number */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        TSLogg.Print("shift12",is,cB.getLne(0)); /* print error */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found */

      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 8; /* select current command */
    } else if(is.equalsIgnoreCase("srchSig")) { /* -##srchSig- Signal-Vorkommen untersuchen */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(args[i]); /* use current command */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('T'): /* HIDDEN: repair stucture-definitions (TD) */
          case('t'): /* alternate identifier */
            if(cB.getLne(0).equalsIgnoreCase("-tdrepair")) { Fo.setMsk(18); break; }
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 26; /* select current command */
    } else if(is.equalsIgnoreCase("test")) { /* -##test- Funktion testen */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"TstMod9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"TstMod9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('T'): /* HIDDEN: repair stucture-definitions (TD) */
          case('t'): /* alternate identifier */
            if(cB.getLne(0).equalsIgnoreCase("-tdrepair")) { Fo.setMsk(18); break; }
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = -1; /* select current command */
    } else if(is.equalsIgnoreCase("testSig")) { /* -##testSig- check signal-configuration */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(args[i]); /* use current command */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* print error-message */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested directory. It is already added to 'Kdo' */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many arguments */
      j = 30; /* select current command */
    } else if(is.equalsIgnoreCase("tsconv")) { /* -##tsconv- convert TS-Instances */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"tsconv9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"tsconv9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('S'): /* Testen der Shape-Files wird gefordert */
          case('s'): Fo.setMsk(2); /* Achtung: Kennung wie bei Funktion 'cvrt' */
            break; /* command is processed -- continue with next one */
          case('U'): /* Komprimierung der world-Dateien unterdruecken */
          case('u'): Fo.setMsk(4); /* Achtung: Kennung wie bei Funktion 'cvrt' */
            break; /* command is processed -- continue with next one */
          case('V'): /* Zuordnungen alt-neu manuell herstellen  */
          case('v'): /* alternativer Beginn */
            shd = (int)cB.getNV(); /* convert next number (source) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              if(shd==0) TSLogg.Print("tsconv1",cB.getLne(1)); /* print error */
              else TSLogg.Print("tsconv2",is,cB.getLne(1)); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if((cc=cB.charAt(true))!=':') { /* invalid separator */
              if (cc=='\n') TSLogg.Print("tsconv3",cB.getLne(1)); /* print error */
              else TSLogg.Print("tsconv4",cB.getLne(1),""+cc); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            scd = (int)cB.getNV(); /* convert next number (target) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              TSLogg.Print("tsconv5",is,cB.getLne(1)); /* print error */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.addObj(1,new Integer(shd)); /* add new value (source) */
            Fo.addObj(1,new Integer(scd)); /* add second value (target) */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 11; /* select current command */
    } else if(is.equalsIgnoreCase("unc")) { /* -##unc- Datei dekomprimieren/expandieren */
      vn2 = ""; /* vorbesetzen: File-Typ noch nicht angegeben */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"expFle9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cc=cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"expFle9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('I'): /* HIDDEN: replace target-file(s) directly */
          case('i'): /* alternate identifier */
            if(cB.getLne(0).equalsIgnoreCase("-inplace")) { Fo.setMsk(17); break; }
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('S'): /* Shape-Dateien expandieren */
          case('s'): if(vn2.length()==0) { vn2 = "Shape"; break; } /* Typ kennzeichnen */
            TSLogg.prtMsg("expFle01",cB.getLne(1),vn2); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('T'): /* Tile-Dateien expandieren */
            Fo.setMsk(3); /* setze Kennzeichen fuer LO-Tiles */
          case('t'): if(vn2.length()==0) { vn2 = "Tile"; break; } /* Typ kennzeichnen */
            TSLogg.prtMsg("expFle01",cB.getLne(1),vn2); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('W'): /* World-Dateien expandieren */
          case('w'): if(vn2.length()==0) { vn2 = "World"; break; } /* Typ kennzeichnen */
            TSLogg.prtMsg("expFle01",cB.getLne(1),vn2); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('X'): /* Vollstaendiges Kopieren gefordert */
          case('x'): Fo.setMsk(2); /* setze Mode */
            break; /* command is processed -- continue with next one */
          case('Z'): /* Ziel-Verzeichnis angegeben */
          case('z'): /* Modus fuer externes Ziel aktivieren */
            is = cB.getTail(true); /* get pattern to check */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("MsgG91",""+cc); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* severe error found */
            dir = new File(is); /* create file-definition fron filename */
            if(!dir.exists()) { /* Datei existiert nicht */
              TSLogg.Print("MsgG92",is,dir.getAbsolutePath());
              System.exit(15); /* Aufruf abbrechen */
            } /* Datei existiert nicht */
            if(!dir.isDirectory()) { /* Ziel ist KEIN Verzeichnis */
              TSLogg.Print("MsgG94",is,dir.getAbsolutePath());
              System.exit(15); /* Aufruf abbrechen */
            } /* Referenz ist kein Verzeichnis */
            pFle = dir.getAbsoluteFile(); /* Datei-/Verzeichnis setzen (Schalter aktivieren) */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      if(vn2.length()==0) { /* keinen Datei-Typ angegeben */
        TSLogg.Print("expFle02",vn2); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      if(i<args.length) { /* zusaetzlichen Parameter vorhanden */
        cLg = chkLog(args[i++]); /* Logging-Objekt erstellen */
        if(cLg!=null && Lg==null) Lg = cLg; /* Gueltig -- Logging aktivieren */
      } /* Logging wurde zusaetzlich spezifiziert */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 18; /* select current command */
    } else if(is.equalsIgnoreCase("version")) { /* -##version- Version analysieren */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(args[i]); /* use current command */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */

      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 23; /* select current command */
    } else if(is.equalsIgnoreCase("wcmp")) { /* -##wcmp- World-Datei bearbeiten */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(args[i]); /* use current command */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 2; /* select current command */
    } else if(is.equalsIgnoreCase("wcmpo")) { /* -##wcmpo- World-Datei bearbeiten */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(args[i]); /* use current command */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* Bedienungshinweis ausgeben */
        System.exit(15);
      }
      fn = args[i++]; /* save requested filename. It is already added to 'Kdo' */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 3; /* select current command */
    } else if(is.equalsIgnoreCase("world")) { /* -##world- manage world-files */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(chkOFle(args[i],"WrdFle9")); /* use optionfile if active */
        if(gF!=null) i -= 1; /* still active -- back to previuos item
          * Using this statement, 'i' is NOT incremented while reading of an
          * option-file is active. The pointer 'i' still points after the call-statement
          * of the option-file.
          */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        switch(cc=cB.charAt(true)) { /* select continuation due to next char */
          case('@'): /* handle request to establish an optionfile as input-source */
            if(actOFle(cB,"WrdFle9",false)) System.exit(15); /* error -- terminate */
            Kdo += CRLF; /* add 'newline' for printing as marker */
            break; /* OK -- command is processed -- continue with next one */
          case('C'): /* write files using commpressed format (CB) */
          case('c'): Fo.setMsk(3); /* set output-mode */
            Fo.clrMsk(4); /* clear alternative specification */
            break; /* command is processed -- continue with next one */
          case('D'): /* HIDDEN: Extended output to LOG-file (loaded data) */
          case('d'): Fo.setMsk(16); /* activate output */
            break; /* command is processed -- continue with next one */
          case('H'): /* specify 'StaticDetailLevel' which is NOT included */
          case('h'): /* alternate identifier */
            j = "03456789".indexOf(cc=cB.charAt(true)); /* convert next char/digit */
            if(j<0) { /* number not allowed for StaticDetailLevel */
              if(cc=='\n') TSLogg.Print("WrdFleP1",cB.getLne(1)); /* print errormessage */
              else TSLogg.Print("WrdFleP2",cB.getLne(1),""+cc); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* severe error found */
            if(j>0) j += 2; /* adjust value */
            Msk = Fo.getOpt(5,0); /* get current mask of 'StaticDetailLevel' */
              /* Attention: mask(-reference) is valid in every case */
            Msk.setMsk(j); /* mark corresponding level */
            /* The object itself need not to be stored back, because it is not replaced */
            break; /* command is processed -- continue with next one */
          case('I'): /* HIDDEN: replace target-file(s) directly */
          case('i'): /* alternate identifier */
            if(cB.getLne(0).equalsIgnoreCase("-inplace")) { Fo.setMsk(17); break; }
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
            break; /* command is processed -- continue with next one */
          case('M'): /* specifify 'merge'-function */
          case('m'): if(Fo.chkMsk(1)) { /* function already specified */
              TSLogg.Print("WrdFleP3",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15);
            } /* function was already specified */
            is = cB.getTail(true); /* get 'suffix' of old world-file */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("WrdFleP4",""+cc,cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.addObj(5,is); /* store suffix */
            Fo.setMsk(2); /* activate new function */
            break; /* command is processed -- continue with next one */
          case('Q'): /* Source-directory specified */
          case('q'): /* set source-directory used with 'merge-mode */
            is = cB.getTail(true); /* get pattern to check */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("MsgG91",""+cc); /* print errormessage */
              System.exit(15); /* terminate program */
            } /* severe error found */
            dir = new File(is); /* create file-definition fron filename */
            if(!dir.exists()) { /* directory does not exist */
              TSLogg.Print("MsgG92",is,dir.getAbsolutePath());
              System.exit(15); /* Aufruf abbrechen */
            } /* Datei existiert nicht */
            if(!dir.isDirectory()) { /* source is NOT a directory */
              TSLogg.Print("MsgG94",is,dir.getAbsolutePath());
              System.exit(15); /* Aufruf abbrechen */
            } /* Referenz ist kein Verzeichnis */
            pFle = dir.getAbsoluteFile(); /* activate directory (set switch) */
            break; /* command is processed -- continue with next one */
          case('S'): /* specifify 'split'-function */
          case('s'): if(Fo.chkMsk(2)) { /* function already specified */
              TSLogg.Print("WrdFleP5",cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15);
            } /* function was already specified */
            is = cB.getTail(true); /* get 'suffix' of new world-file */
            if(is==null) { /* EOF within data (length-error?) */
              TSLogg.Print("WrdFleP4",""+cc,cB.getLne(1)); /* print errormessage */
              TSLogg.Print("Msg009"); /* print hint of operating */
              System.exit(15); /* terminate program */
            } /* severe error found */
            Fo.setDta(5,1,is); /* store suffix */
            Fo.setMsk(1); /* activate new function */
            break; /* command is processed -- continue with next one */
          case('U'): /* write files using uncompressed format (UT) */
          case('u'): Fo.setMsk(4); /* set output-mode */
            Fo.clrMsk(3); /* clear alternative specification */
            break; /* command is processed -- continue with next one */
          default: /* unknown option specified */
            TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print errormessage */
        }
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(gF!=null) { /* reading of the option-file is still active */
        gF.close(); /* close input-file */
        gF = null; /* switch off reading of the file */
      } /* option-file was still active */

      if(Fo.getMsk(6)==0) { /* no function selected */
        TSLogg.Print("WrdFleP6"); /* print errormessage */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      } /* severe error found */

      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* print errormessage */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      }
      fn = args[i++]; /* save requested route-reference. It is already added to 'Kdo' */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 28; /* select current command */
    } else if(is.equalsIgnoreCase("wunc")) { /* -##wunc- World-Datei bearbeiten */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(args[i]); /* use current command */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* Fehlermeldung ausgeben */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      }
      fn = args[i++]; /* save requested route-reference. It is already added to 'Kdo' */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 1; /* select current command */
    } else if(is.equalsIgnoreCase("zusi")) { /* -##zusi- ZuSi-Format erstellen */
      /* check current arguments, if LOCAL options are included */
      while(i<args.length) { /* check all local options */
        cB = new TSBuf(args[i]); /* use current command */
        Kdo += cB.getPrnt(); /* add current command for printing */
        if(cB.length()<2) break; /* no more option possible */
        if(cB.charAt(true)!='-') break; /* no more options specified */
        TSLogg.prtMsg("MsgL00",cB.getLne(1)); /* print message */
        i += 1; /* switch to next argument */
      } /* all LOCAL options have been processed */
      if(i==args.length) { /* error -- SOLO 'local option's specified */
        TSLogg.Print("Msg011"); /* print errormessage */
        TSLogg.Print("Msg009"); /* print hint of operating */
        System.exit(15); /* terminate program */
      }
      fn = args[i++]; /* save requested route-reference. It is already added to 'Kdo' */
      if(i<args.length) TSLogg.prtMsg("Msg012",""+i,""+args.length); /* too many */
      j = 21; /* select current command */
    } else { /* unknown command specified */
      TSLogg.Print("Msg006",is); /* print errormessage */
      TSLogg.Print("Msg009"); /* print hint of operating */
      System.exit(10); /* terminate program */
    }

    System.out.println(); /* Leerzeile hinzufuegen */
    {String[] $={"-------> ","\n",Version};
      TSLogg.Print("Msg101",$); /* Version ausgeben */
      TSLogg.Print("Msg102",$); /* Teil der Message ausgeben */
      TSLogg.Print("Msg103",$);} /* Teil der Message ausgeben */
    TSLogg.Print("Msg104",""); /* Einfuehrungszeile */
    System.out.println(); /* Leerzeile hinzufuegen */

    TSLogg.Print("Msg005",Kdo); /* Meldung auf BS ausgeben */
    System.out.println(); /* Leerzeile hinzufuegen */

    /* Phase --2--: Programm ausfuehren */
    /* gemeinsame Initialisierungen (fuer Referenzen) */
    ScTab   = null; /* Tabelle Sections (global) */
    ShTab   = null; /* Tabelle Shapes (global) */

    if(Lg==null) Lg = new TSLogg(); /* Dummy-Objekt erzeugen */
    else Lg.setOpt(Fo.chkMsk(25)); /* Log-Optionen eintragen */

    if(!Fo.chkMsk(31)) PrMsk.resMsk(0xF0000000); /* deactivate ALL debug-groups ##!D*/

    /* Funktion aktivieren */
    i = 0; /* Return-Code initialisieren */
    if(!Fo.chkMsk(28)) switch(j) { /* zugeordnetes Kommando ausfuehren */
      case(-1): i = tstMod(false); /* [-ohne-] Debug-Routine aktivieren */
        break; /* requested command successfully processed */
      case( 1): i = world(false,false,false); /* [1] 'wunc' World-Datei umwandeln */
        break; /* requested command successfully processed */
      case( 2): i = world(true,false,false); /* [2] 'wcmp' World-Datei umwandeln */
        break; /* requested command successfully processed */
      case( 3): i = world(true,true,false); /* [3] 'wcmpo' World-Datei umwandeln */
        break; /* requested command successfully processed */
      case( 4): i = marker(); /* [4] Marker-Datei erstellen */
        break; /* requested command successfully processed */
      case( 5): i = horace(Fo.chkMsk(26)); /* [5] World-Datei bearbeiten */
        break; /* requested command successfully processed */
      case( 6): i = chgTDB(); /* [6] Schienendatenbank aendern */
        break; /* requested command successfully processed */
      case( 7): i = dcopy(Fo.chkMsk(26)); /* [7] Datei-Differenz erstellen */
        break; /* requested command successfully processed */
      case( 8): i = shift(Fo.chkMsk(26)); /* [8] Shape-Bereich verschieben */
        break; /* requested command successfully processed */
      case( 9): i = Filter(Fo.chkMsk(26)); /* [9] Streckendefinition filtern */
        break; /* requested command successfully processed */
      case(10): i = CompW(Fo.chkMsk(26)); /* [10] World-Datei komprimieren (xt) */
        break; /* requested command successfully processed */
      case(11): i = cvrtTS(); /* [11] TS-Instanz konvertieren */
        break; /* requested command successfully processed */
      case(12): i = chkInteg(Fo.chkMsk(26)); /* [12] Integritaet pruefen */
        break; /* requested command successfully processed */
      case(13): i = renDB(Fo.chkMsk(26)); /* [13] Datenbank neu nummerieren */
        break; /* requested command successfully processed */
      case(14): i = move(Fo.chkMsk(26)); /* [14] Streckendefinition verschieben */
        break; /* requested command successfully processed */
      case(15): i = chkUpg(false); /* [15] 'tsection.dat' fuer Upgrade pruefen */
        break; /* requested command successfully processed */
      case(16): i = adjH(Fo.chkMsk(26)); /* [16] Hoehenwerte justieren */
        break; /* requested command successfully processed */
      case(17): i = Reduce(Fo.chkMsk(26)); /* [17] Datei reduzieren und ggf. komprimieren */
        break; /* requested command successfully processed */
      case(18): i = Expand(Fo.chkMsk(26)); /* [18] Datei expandieren und dekomprimieren */
        break; /* requested command successfully processed */
      case(19): i = Merge(Fo.chkMsk(26)); /* [19] Streckendefinitionen mischen */
        break; /* requested command successfully processed */
      case(20): i = clearDB(Fo.chkMsk(26)); /* [20] Strecke reparieren (Versuch) */
        break; /* requested command successfully processed */
      case(21): i = toZuSi(false); /* [21] Strecke in das ZuSi-Format */
        break; /* requested command successfully processed */
      case(22): i = shftDyn(Fo.chkMsk(26)); /* [22] dynamische Schienen verschieben */
        break; /* requested command successfully processed */
      case(23): i = shVer(false); /* [23] Versions-Definition analysieren */
        break; /* requested command successfully processed */
      case(24): i = FleMgr(Fo.chkMsk(26)); /* [24] Dateien flexibel bearbeiten */
        break; /* requested command successfully processed */
      case(25): i = chgSig(Fo.chkMsk(26)); /* [25] Signalobjekte austauschen */
        break; /* requested command successfully processed */
      case(26): i = srchSig(Fo.chkMsk(26)); /* [26] Signalobjekte suchen und protokollieren */
        break; /* requested command successfully processed */
      case(27): i = mveObj(Fo.chkMsk(26)); /* [27] Objekte in einer Strecke verschieben */
        break; /* requested command successfully processed */
      case(28): i = wFile(Fo.chkMsk(26)); /* [28] manage world-files of a route */
        break; /* requested command successfully processed */
      case(29): i = FleCpy(Fo.chkMsk(26)); /* [29] copy and process files */
        break; /* requested command successfully processed */
      case(30): i = tstSig(Fo.chkMsk(26)); /* [30] check signal-configuration */
        break; /* requested command successfully processed */

      case(98): i = Insert(Fo.chkMsk(26)); /* [??] merge route-objects */
        break; /* requested command successfully processed */
      default: /* command is still NOT implemented */
        TSLogg.Print("Msg007",j); /* print errormessage */
    } /* process current command */
    System.out.println(); /* Leerzeile hinzufuegen */
    if(i>0) System.exit(i); /* System mit Fehlercode beenden */

  }

 /**. <pre>
  *=====================================================================
  * Methode "tstMod" (-ohne-) [-1]
  * Sonderfunktionen und Testen -- NUR FUER DEBUG (test)
  * ##tstMod (Eyecatcher)
  * ##test (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int tstMod( /* Sonderfunktionen ausfuehren */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute cRte; /* aktuelle Streckendefinition (Basis) */
    File    dat;  /* Dateidefinitionen */
    int     i;    /* Arbeitswerte */
    String  is;   /* Arbeitswerte */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("tstMod01",fn); /* Vorlauf ausgeben */

    /* Systemdatei lesen und auswerten */
    cRte = getRte(fn,2); /* Streckendefinition auswerten */
    if(cRte==null) return 5; /* Fehler -- Ende */

    /* print current paths */
    Lg.Msg("MsgC01",cRte.getInfo(2)); /* print route-name */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* print system-path */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* print route-path */
    Lg.Skip(true); /* and add empty line */

    /* globale "tsection.dat" bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC05"); /* Aktionsmeldung ausgeben */

    dat = cRte.getFile(-1); /* get reference to file */
    i = getTS(dat,null);    /* and load 'tsection.dat' (global) */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC08",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC11",c3); /* Ergebnis melden */
    Lg.Log("MsgC14",ScN); /* Ergebnis melden */
    Lg.Log("MsgC17",c2); /* Ergebnis melden */
    Lg.Log("MsgC20",ShN); /* Ergebnis melden */
    Lg.Log("MsgC23",c4); /* Ergebnis melden */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(cRte,ScA,ShA); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Marker-Datei (falls vorhanden) syntaktisch pruefen */
    i = getMF(cRte); /* Marker-Datei ueberpruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Referenz der Streckendefinition pruefen */
    i = getRF(cRte,null); /* Ref-Datei ueberpruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    i = getSpp(cRte,null); /* load 'Speedpost.dat' */
    if(i>0) return i; /* error occurred -- terminate function */

    /* zusaetzliche Streckendateien laden */
    i = getType(cRte); /* 'ttype.dat' laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strukturquadrate laden (genaue Ausfuehrung) */
    i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC26",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Strukturquadrate laden (LO-Tiles) */
    i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
    if(i>0) { /* Fehler beim Laden der Strukturquadrate */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC27",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Schienendatenbank laden */
    i = getDBF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    i = getITF(cRte,0); /* Schienendatenbank laden und pruefen (2. Teil) */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strassendatenbank laden */
    i = getDBF(cRte,1); /* Strassendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    if(i==0) { /* Datenbank ist vorhanden */
      i = getITF(cRte,1); /* Strassendatenbank laden und pruefen (2. Teil) */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* Datenbank(teil) ist vorhanden */

    /* World-Dateien laden und syntaktisch pruefen */
    i = getWF(cRte,false); /* World-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */
    /* Sound-Dateien laden und syntaktisch pruefen */
    i = getSF(cRte,false); /* World-Sound-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */

    /* Signal-Definitionen laden und ueberpruefen */
    i = getSCfg(cRte,cRte.getFile(21),null,true); /* load Signal-Configurations */
    if(i==0) /* Laden erfolgreich -- weiter testen */
      i = getSScr(cRte,cRte); /* Signal-Script-Definitionen laden */

    /* Path-Definitionen werden geladen und ueberprueft */
    i = getPatF(cRte,true); /* Path-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Service-Definitionen werden geladen und ueberprueft */
    i = getSrvF(cRte,true); /* Service-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Traffic-Definitionen werden geladen und ueberprueft */
    i = getTrfF(cRte,true); /* Traffic-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Activity-Definitionen werden geladen und ueberprueft */
    i = getActF(cRte,true); /* Activity-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */


    /* all files were loaded -- continue with integrity-check */
    if((is=cRte.chkRte(Fo,true))!=null) { /* check route for integrity -- error found ? */
      if(is.charAt(0)!=' ') { /* error-message returned */
        Lg.Skip(true); /* skip line */
        Lg.Err("getRte23",is); /* print errormessage */
        Lg.Msg("MsgC60"); /* print message: 'terminating' */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* error found -- function terminated */
      if(EnaW) Lg.Log("chkRte00",is); /* Warning found -- print it */
    } /* error/warning found */

    /* "world"-Dateien bearbeiten und neue Integritaet herstellen */
    chkWrld(cRte,null,132); /* World-Dateien erweitert pruefen */
      /* Modus: Aenderungen melden, kein Renum */

    /* Sound-Dateien bearbeiten und neue Integritaet herstellen */
    i = chkSnd(cRte,null,128); /* Sound-Dateien erweitert pruefen */
      /* Modus: Aenderungen melden */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("MsgC33",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC35"); /* Aktionsmeldung ausgeben */
    if(cRte.get$TrN(0)<0) { /* Schienendatenbank NICHT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC36"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datenbank nicht vorhanden */

    i = chkDBTab(cRte,0); /* Schienendatenbank bearbeiten */
    if(i<0) return 5; /* Systemfehler -- Ende */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC37",i); /* Aktionsmeldung */
    Lg.Skip(false); /* Leerzeile loggen */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC39"); /* Aktionsmeldung ausgeben */
      i = chkDBTab(cRte,1); /* Strassendatenbank bearbeiten */
      if(i<0) return 5; /* Systemfehler -- Ende */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("MsgC40",i); /* Aktionsmeldung */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Strassendatenbank vorhanden und geladen */

    /* extended check of local 'tsection.dat'
     * Attention: This method MUST NOT be invoked unless worldfiles AND
     * database (track/road) is stored again (or neither). */
    chkTSL(cRte,ScN,ShN); /* check file and compact it */

    i = chkPat(cRte); /* Pfad-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkSrv(cRte,true); /* Service-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkCon(cRte); /* Consist-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkTrf(cRte,true,true); /* Traffic-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkAct(cRte,true); /* process activity-definitions */
    if(i>0) return 5; /* systemerror occurred -- terminate */


// **********************************************************************

    TreeSet<TSQuad> QDf;  /* alle Quadrat-Definitionen */
    TSQuad          cQDf; /* aktuelle Quadrat-Definition */
    int             j,v,w; /* Arbeitswerte */
    String          js,ks;
    Iterator        cI;   /* common used iterator (TSQuad/TSTile) */
    TSChain         cC;   /* current UID-chain within world */
    TSUiD           cUiD; /* UiD-Elements */
    TSPos           cPos; /* aktuelle (relative) Position */
    TSQDir          cQDir; /* aktuelle Rotationsdefinition (Quaternion) */
    TSView          cVS;  /* current viewsphere */
    ArrayList<String> ETab; /* current message-table */
    TSTexture cT;         /* current texture-file */
    BufferedOutputStream bS; /* write texture */
    File[] fl;
    byte[] buf;
   /*=================================================================*/
    QDf = cRte.chgQDf(null); /* get list of all Quad-definiitons */
    if(QDf==null) throw new IllegalStateException( /* integrity OK? */
      TSLogg.getMsg("Msg908","TreeSet<TSQuad>==null","cvrt(a)",0));

    ETab = new ArrayList<String>(); /* initialize table */
    cI = QDf.iterator(); /* create iterator of Quad-definitions */
    while(cI.hasNext()) { /* more definitions available ? */
      cQDf = (TSQuad)cI.next(); /* get next quad-definition */
      if(cQDf.getInf(2)==null) continue; /* no world-file -- skip it */
      cC = cQDf.chgWTab(null,0); /* get current UID-chain */

      if(cQDf.chg$View(-1)>0) { /* viewsphere-definitions present */
        cVS = cQDf.chgView(null); /* get TSView-chain */
        cVS.prtView(ETab); /* create viewsphere-descriptions */
        Lg.Skip(false); /* print empty line to log-file */
        Lg.Log("getWF$03",cQDf.getInf(2));
        for(String s:ETab) Lg.Log("Msg010",s);
        ETab.clear(); /* clear all messages */
      } /* process viewsphere-definitions */

      for(cUiD=(TSUiD)cC.list(true);cUiD!=null;cUiD=(TSUiD)cC.list(false)) {
        /* UID-Chain may be modified, if 'list'-method is used */
        if(cUiD.isOpt(0)) continue; /* skip dummy-entries */
        if(!(cUiD instanceof TSTrkObj)) continue; /* no track-object -- skip it */
          /* ONLY static tracks are processed here */

        if(!cUiD.chkAnim(false)) continue;


        cPos  = cUiD.crPos();  /* aktuellen Positionswert holen */
        cQDir = cUiD.crQDir(); /* aktuellen Richtungswert holen */

        cQDir.raise(Math.toRadians(5.0)); /* aktuelle QDirection anpassen (Elevation) */
        cPos.toEnd(cQDir,500.0,Math.toRadians(-10.0)); /* Wert fuer UiD berechnen */
        cQDir.turn(Math.toRadians(-10.0)); /* neue QDirection berechnen */
        cQDir.inv(); /* und Richtung wieder 'IN Orientierungsrichtung' setzen */


//        cElv = w; /* neue Elevation merken (fuer naechste UiD) */
//        if(w!=0.0) w = -w; /* Wert korrigieren */
//        cUiD.chgElv(w); /* Elevation speichern */

        cUiD.setPos(cPos); /* neuen Positionswert setzen (Referenz eintragen) */
        cUiD.setQDir(cQDir); /* neue QDirection setzen */


      } /* - for- check all uid-entries */
    } /* -while- process all quad-definitions */

    Lg.Skip(false);
    dat = cRte.getFile(17); /* get source-definitions for textures */
    fl = dat.listFiles((FilenameFilter)(new TSFleMask(false,".*\\.ace")));
    incT:for(File datT : fl) { /* process all files */
      cT = new TSTexture(datT,TSTexture.IN); /* get handle, open file and read ID */
      if((is=cT.getErr())!=null) { /* File cound not be successfully opened. */
        Lg.Err("chkInt37",datT.getPath(),is); /* print message */
        continue incT; /* file-reference is fully processed */
      } /* open of file failed -- skip to next file */
      buf = cT.read(); /* read whole file */
      if(buf==null) { /* file could not be read */
        Lg.Err("chkInt37",dat.getPath(),cT.getErr()); /* print message */
        break incT; /* file-reference is fully processed */
      } /* read-error within file -- skip to next file */
      is = cT.close(); /* close texture-file again */

      dat = cRte.getFile(2,datT.getName());
      try {bS = new BufferedOutputStream(new FileOutputStream(dat)); /* oeffnen */
      } catch (IOException e) { /* IO-Fehler erhalten */
        System.err.println(e.toString());
        bS = null; /* Kennzeichen: Datei nicht genutzt */
        TSLogg.getMsg("TSTleC04",dat.getPath()); /* Fehlermeldung generieren */
        continue incT; /* Erstellen der Daten abbrechen */
      } /* Dateifehler */
      try {bS.write(buf); /* Datenwert schreiben */
      } catch (IOException e) { /* Schreib-Fehler erhalten */
        System.err.println(e.toString());
        TSLogg.getMsg("TSTleC04",dat.getPath()); /* Fehlermeldung generieren */
        try {bS.close();} catch (IOException E) { }
        continue incT; /* Erstellen der Daten abbrechen */
      } /* Fehler beim Schreiben */
      try { bS.close(); /* Ausgabe-Datei wieder schliessen */
      } catch (IOException e) { System.err.println(e.toString()); }
    } /* -incT- for-block */


// **********************************************************************

    /* Process basic file of route (.trk) */
    i = putRte(cRte,null); /* rewrite route-definition */
    if(i>0) return i; /* error found while writing */

    /* Write Route-Object-Reference-File again */
    i = putRF(cRte,null); /* write Ref-file again */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* "world"-Dateien bearbeiten und modifizieren */
    i = putWF(cRte,null,true,false); /* World-Dateien modifiziert schreiben */
      /* Modus: neue UiD's verwenden */
    if(i>0) return i; /* Fehler beim Schreiben -- Ende */
    /* Sound-Dateien bearbeiten und modifizieren */
    i = putSF(cRte,null,true); /* Sound-Dateien modifiziert schreiben */
    if(i>0) return i; /* Fehler beim Schreiben -- Ende */

    /* Schienendatenbank bearbeiten */
    i = 16; if(Fo.chkMsk(29)) i += 64; /* Optionen erstellen */
    i = putDBF(cRte,null,i); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    /* Schienendatenbank (.tit) bearbeiten */
    i = putITF(cRte,null,0,false); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      /* Strassendatenbank bearbeiten */
      i = 17; if(Fo.chkMsk(29)) i += 64; /* Optionen erstellen */
      i = putDBF(cRte,null,i); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */

      /* Strassendatenbank (.rit) bearbeiten */
      i = putITF(cRte,null,1,false); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */
    } /* Strassendatenbank vorhanden und geladen */

    /* "tsection.dat" (lokal) neu erstellen */
    i = putTSL(cRte,cRte,false); /* neue lokale 'tsection.dat' schreiben */
    if(i>0) return i; /* Fehler -- beenden */

    /* Alle Definitionen fuer Activities schreiben */
    i = putPatF(cRte,null,3); /* Path-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */
    i = putSrvF(cRte,null,3); /* Service-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */
    i = putTrfF(cRte,null,3); /* Traffic-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */
    i = putActF(cRte,null,3); /* Write Activitys again (noreplace) */
    if(i>0) return i; /* severe error -- terminate function */

    if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("tstMod05"); /* Ueberschrift Ende-Mitteilung */
    Lg.Msg("tstMod06",ShA); /* Wert ausgeben */
    Lg.Msg("tstMod07",ScA); /* Wert ausgeben */
    Lg.Msg("tstMod08",cRte.get$Sh(true)); /* Wert ausgeben */
    Lg.Msg("tstMod09",cRte.get$Sc(true)); /* Wert ausgeben */
    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "world" (-1-)(-2-)(-3-)
  * World - Dateien umwandeln und ggf. komprimieren
  * ##world (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int world( /* World - Dateien umwandeln */
   boolean comp,  /* World - Dateien komprimieren */
   boolean UTo,   /* nur dekomprimierte komprimieren ? */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute           cRte; /* aktuelle Streckendefinition (Basis) */
    int               i,ix; /* Arbeitswerte */
    String            is,js;
    String[]          fl;   /* File-Liste */
    File              dat,dir;
    FileInputStream   S;    /* binary Reader */
    byte[]            ibuf;
    InputStreamReader R;    /* Unicode-Reader */
    char[]            ichr;
   /*=================================================================*/
    ibuf = new byte[7]; /* Puffer fuer Vergleich */
    ichr = new char[8]; /* Puffer fuer Vergleich */

    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("world01",fn); /* Vorlauf ausgeben */

    /* Systemdatei lesen und auswerten */
    cRte = getRte(fn,3); /* Streckendefinition auswerten */
    if(cRte==null) return 5; /* Fehler -- Ende */

    /* print current paths */
    Lg.Msg("MsgC01",cRte.getInfo(2)); /* print route-name */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* print system-path */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* print route-path */
    Lg.Skip(true); /* and add empty line */

    /* Pfad zum Utility holen */
    dir = cRte.getFile(0,"utils/ffedit"); /* Utility-Pfad holen */
    dat = new File(dir,"ffeditc_unicode.exe"); /* Utility holen */
    if(!dat.exists()) { /* Datei existiert nicht */
      Lg.Msg("MsgC43",dat.getAbsolutePath()); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Utility-Datei nicht gefunden */

    /* Liste der "world"-Dateien erstellen */
    dat = cRte.getFile(10); /* File-Referenz fuer Verzeichnis */
    is = dat.getAbsolutePath(); /* vollstaendiger Name */
    if(!dat.exists()) { /* Referenz nicht vorhanden */
      Lg.Msg("world02",is); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datei existiert nicht */
    fl = dat.list(); /* alle Dateien auflisten */
    if(fl==null) { /* Source-ist kein Verzeichnis */
      Lg.Msg("MsgC51",is); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Dateiliste konnte nicht erstellt werden */

    c0 = c1 = c2 = c3 = c4 = 0;
    for(ix=0;ix<fl.length;ix+=1) { /* alle Dateidefinitionen */
      is = fl[ix]; /* einfache Addressierung */
      if(!is.toLowerCase().endsWith(".w")) continue;
        /* Datei ist keine World-Datei */
      dat = cRte.getFile(40,is); /* vollstaendige Referenz */
      js = dat.getAbsolutePath(); /* Gesamtname (Ziel) erstellen */
      dat = cRte.getFile(10,is); /* vollstaendige Referenz */
      if(dat.isDirectory()) continue; /* nur Dateien beachten */
      c0 += 1; /* Dateidefinition zaehlen */
      fn = dat.getAbsolutePath(); /* Gesamtname erstellen */
      Lg.Log("MsgC53",fn,DF4.format(c0),0); /* Meldung ausgeben */

      try { S = new FileInputStream(dat); /* ASCII lesen */
      } catch (FileNotFoundException E) { /* Datei nicht gefunden */
        System.err.println(E.toString());
        Lg.Skip(false); /* Leerzeile Loggen */
        Lg.Msg("world03"); /* Fehlermeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 25; /* terminate function with errorcode */
      } /* Exception bei OPEN */
      try {i = S.read(ibuf); /* erste Datenzeile lesen */
      } catch (IOException e) { /* Lese-Fehler erster Satz */
       System.err.println(e.toString());  return 20;}
      try { S.close(); /* Binaerdatei schliessen */
      } catch (IOException e) { System.err.println(e.toString()); }
      is = new String(ibuf); /* in String umwandeln */
      if(is.equals("SIMISA@")) { /* kein Unsinn -> Binaerdatei */
        if(UTo) continue; /* gemaess Auftrag: Datei nicht bearbeiten */
        c1 += 1; /* Konvertierung zaehlen */
        is = tx1+fn+tx2+js+"\""; /* Befehl erstellen */
        Lg.Log("world04",is); /* Aktionsmeldung */
        if((i=exec(true,is,dir,Lg))>0) { /* Fehler bei Ausfuehrung */
          Lg.Log("MsgC55",i); /* Fehlermeldung ausgeben */
          c4 += 1; /* Fehler zaehlen */
          continue; /* mit naechster Zeile fortfahren */
        } /* Konvertierung fehLgeschlagen */
      } /* Binaerdatei gefunden */
      /* jetzt liegt auf jeden Fall eine Text-Datei vor */
      try { R = new InputStreamReader( /* unicode lesen */
                new FileInputStream(dat),"UTF-16");
      } catch (FileNotFoundException e) { /* Datei nicht gefunden */
         System.err.println(e.toString());  return 5;}
        catch (UnsupportedEncodingException e) {
         System.err.println(e.toString());  return 5;}
      try {i = R.read(ichr,0,8); /* Datenzeichen lesen */
      } catch (IOException e) { /* Lese-Fehler erhalten */
        System.err.println(e.toString());
        return 25;
      } /* Fehler gefunden */
      try { R.close(); /* Unicode-Datei wieder schliessen */
      } catch (IOException e) { System.err.println(e.toString()); }
      is = new String(ichr); /* in String umwandeln */
      if(!is.equals("SIMISA@@")) { /* komprimiert */
        if(UTo) continue; /* gemaess Auftrag: Datei nicht bearbeiten */
        c2 += 1; /* Konvertierung zaehlen */
        is = tx1+fn+tx2+js+"\""; /* Befehl erstellen */
        Lg.Log("world05",is); /* Aktionsmeldung ausgeben */
        if((i=exec(true,is,dir,Lg))>0) { /* Fehler bei Ausfuehrung */
          Lg.Log("MsgC55",i); /* Fehlermeldung ausgeben */
          c4 += 1; /* Fehler zaehlen */
          continue; /* mit naechster Zeile fortfahren */
        } /* Konvertierung fehLgeschlagen */
      } /* komprimierte Textdatei gefunden */

      /* jetzt kann wieder eine Binaerdatei vorliegen !! */
      try { S = new FileInputStream(dat);
      } catch (FileNotFoundException e) { /* Datei nicht gefunden */
         System.err.println(e.toString());  return 25;}
      try {i = S.read(ibuf); /* erste Datenzeile lesen */
      } catch (IOException e) { /* Lese-Fehler erster Satz */
       System.err.println(e.toString());  return 20;}
      try { S.close(); /* Binaerdatei schliessen */
      } catch (IOException e) { System.err.println(e.toString()); }
      is = new String(ibuf); /* in String umwandeln */
      if(is.equals("SIMISA@")) { /* kein Unsinn -> Binaerdatei */
        if(UTo) continue; /* gemaess Auftrag: Datei nicht bearbeiten */
        c3 += 1; /* Konvertierung zaehlen */
        is = tx1+fn+tx2+js+"\""; /* Befehl erstellen */
        Lg.Log("world06",is); /* Aktionsmeldung ausgeben */
        if((i=exec(true,is,dir,Lg))>0) { /* Fehler bei Ausfuehrung */
          Lg.Log("MsgC55",i); /* Fehlermeldung ausgeben */
          c4 += 1; /* Fehler zaehlen */
          continue; /* mit naechster Zeile fortfahren */
        } /* Konvertierung fehLgeschlagen */
      } /* Binaerdatei gefunden */

      /* Dateiform ist unkomprimierte Textdatei -- ggf komprimieren */
      if(comp) { /* komprimieren gefordert (UTo ist egal) */
        is = tx1+fn+"\" /c \"/o:"+js+"\""; /* Befehl erstellen */
        Lg.Log("world07",is); /* Aktionsmeldung ausgeben */
        if((i=exec(true,is,dir,Lg))>0) { /* Fehler bei Ausfuehrung */
          Lg.Log("MsgC55",i); /* Fehlermeldung ausgeben */
          c4 += 1; /* Fehler zaehlen */
        } /* Konvertierung fehLgeschlagen */
      } /* komprimieren ist ausgefuehrt */

    } /* alle Definitionen bearbeiten */

    Lg.Skip(true); /* Leerzeile Loggen */
    Lg.Log("world08",DF4.format(c0)); /* Abschlussmeldung */
    Lg.Msg("world09",DF4.format(c4)); /* Abschlussmeldung */
    Lg.Msg("world10",c0); /* Abschlussmeldung */
    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "marker" (-4-)
  * Marker-Datei aus Koordinatendatei erstellen
  * Optionen:
  *       1 - Ausgabe-Format Version 4 konvertieren (-4)
  * ##marker (Eyecatcher) (##cmkr)
  *=====================================================================
  </pre>*/
  protected static int marker() /* Marker - Datei erstellen */
   {
   /*-----------------------------------------------------------------*/
    final DecimalFormat dF = new DecimalFormat("##0.00000",
                             new DecimalFormatSymbols(Locale.US));
    File    dat;   /* allgemeine Dateibeschreibung */
    TSFileX cF;    /* Output-file of marker-definitions */
    TSFile  cC;    /* current i/o-control (here: marker-input) */
    TSBuf   cB;    /* current input-buffer */
    double  fx,fz; /* Koordinatenwerte */
    int     i;     /* Arbeitswerte */
    char    cc;    /* comment-character ? */
    String  is,js;
   /*=================================================================*/
    if(fn.endsWith(".coo")) { /* suffix already present */
      is = fn; /* use it as source */
      fn = fn.substring(0,fn.indexOf(".coo")); /* remove suffix */
    } else is = fn + ".coo"; /* filename is now complete */
    dat = new File(is); /* Dateibeschreibung erstellen */
    if(!dat.exists()) { /* Koordinatendatendatei nicht gefunden */
      TSLogg.Print("marker01",dat.getAbsolutePath()); /* Abbruchmeldung */
      return 5; /* System beenden */
    } /* Koordinatendatei nicht gefunden */
    cC = new TSFile(dat); /* locate and define file */
    if((is=cC.open(TSFile.IA))!=null) { /* open file (input,ASCII) -- error ? */
      TSLogg.Print("marker02",is); /* 'is' contains error-message */
      return 5; /* terminate function */
    } /* Error found while 'open' */

    is = fn + ".mkr"; /* Dateiname fuer Ausgabe */
    dat = new File(is); /* Dateibeschreibung erstellen */
    cF = new TSFileX(TSFileX.FT$mkr,dat); /* create input/output-control */
    is = cF.open(TSFile.OUT); /* open file for output and write file-id */
    if(is!=null) { /* open not successful */
      TSLogg.Print("marker02",is); /* Abbruchmeldung */
      cC.close(); /* close input-file too */
      return 5; /* stop function-program */
    } /* error while opening file */

    cB = new TSBuf(cC,null); /* initialize inputbuffer (mode='line') */
    bl: { /* block for error-break */
      while(!cB.getNext(false)) { /* read new line into buffer -- EOF? */
        if((cc=cB.charAt(false))=='\n') continue; /* empty line -- skip it */
        if(cc=='#') continue; /* comment-line -- skip it */
        fx = cB.getFV(); /* convert longitude */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          is = TSLogg.getMsg("marker12",is,cB.getStat(true)); /* create error-msg */
          break bl; /* terminate loop due to error */
        } /* severe error found */
        js = cB.getVal(2); /* get next value within line */
        if(js==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            is = TSLogg.getMsg("marker13",cB.getStat(true)); /* create error-msg */
            break bl; /* terminate evaluation */
          } /* EOF within data -- terminate evaluation */
          is = TSLogg.getMsg("marker14",is,cB.getStat(true)); /* create error-msg */
          break bl; /* terminate evaluation */
        } /* error found within current input -- terminate evaluation */
        if(js.length()==0) { /* value is not present */
          is = TSLogg.getMsg("marker14",is,cB.getStat(true)); /* create error-msg */
          break bl; /* terminate evaluation */
        } /* value is not present -- terminate evaluation */
        if(!js.equals("ost,") && !js.equals("west,")) /* longitude-marker is invalid */
          TSLogg.Print("marker16",js,cB.getStat(true),0); /* print warning */
        if(!js.equals("ost,")) fx = -fx; /* adjust longitude due to marker */

        fz = cB.getFV(); /* convert latitude */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          if(Double.isNaN(fz)) is = TSLogg.getMsg("marker17",cB.getStat(true));
          else is = TSLogg.getMsg("marker18",is,cB.getStat(true)); /* create error-msg */
          break bl; /* terminate loop due to error */
        } /* severe error found */
        js = cB.getVal(2); /* get next value within line */
        if(js==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            is = TSLogg.getMsg("marker19",cB.getStat(true)); /* create error-msg */
            break bl; /* terminate evaluation */
          } /* EOF within data -- terminate evaluation */
          is = TSLogg.getMsg("marker14",is,cB.getStat(true)); /* create error-msg */
          break bl; /* terminate evaluation */
        } /* error found within current input -- terminate evaluation */
        if(js.length()==0) { /* value is not present */
          is = TSLogg.getMsg("marker15",cB.getStat(true)); /* create error-msg */
          break bl; /* terminate evaluation */
        } /* value is not present -- terminate evaluation */
        if(!js.equals("nord") && !js.equals("sued")) /* latitude-marker is invalid */
          TSLogg.Print("marker20",js,cB.getStat(true),0);/* print warning */
        if(!js.equals("nord")) fz = -fz; /* adjust latitude due to marker */

        js = " \""; /* Init for Version '3' */
        if(Fo.chkMsk(1)) { /* line is output-version '4' */
          i = (int)cB.getNV(); /* get Height-value */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            is = TSLogg.getMsg("marker21",is,cB.getStat(true)); /* create error-msg */
            break bl; /* terminate evaluation */
          } /* error while evaluating -- terminate evaluation */
          js = " \"[" + i + "] "; /* create correct version */
        } /* height-value was present */

        is = cB.getTail(true); /* get remaining description of position */
        if(is!=null) js += is + "\" 2 )"; /* create last part of (target-)line */
          else js += "\" 2 )"; /* set empty description */

        js = "Marker ( " + dF.format(fx) + " " + dF.format(fz) + js; /* create Statement */
        if((is=cF.putData(js))!=null) break bl; /* write-error found */
      } /* read all lines from marker-file */
      if((is=cB.getErr())!=null) is = TSLogg.getMsg("marker03",is,cB.getStat(true));
        /* get message if read-error found */
    } /* -bl- break-block used in case of error */
    if(is!=null) { /* errormessage is still not printed */
      TSLogg.Print("marker02",is); /* 'is' contains error-message */
      TSLogg.Print("marker11",cB.getLne(0)); /* print source-line */
    } /* print errormessage */

    is = cF.close(); /* close output-file */
    if(is!=null) TSLogg.Print("marker02",is); /* print close-error */
    cC.close(); /* close inputfile (.coo) */

    System.out.println(); /* Leerzeile hinzufuegen */
    TSLogg.Print("MsgC56",cB.getStat(true)); /* Abschlussmeldung */
    return 0; /* Funktion ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "horace" (-5-)  ('cvrt')
  * World - Dateien bearbeiten und Dynamische Schienen austauschen
  * Options (Fo):
  *       1 - UiD-Nummern reorganisieren (-r)
  *       2 - Shape-Namen auf Existenz testen (-s)
  *       3 - World-Dateien auf JEDEN Fall komprimieren (-c)
  *       4 - World-Dateien NICHT komprimieren (-u)
  *       5 - Korrektur-Modus fuer World-Dateien benutzen (-k)
  *       6 - Dummy-World-Dateien erzeugen falls notwendig (-w)
  *       7 -
  *       8 - Pfad-Definitionen veraendert ausgeben (-p,Hidden)
  *       9 - Hide-Modus inaktiv (Objekte zuruecksetzen) (-n)
  *      10 - Hide-Modus aktiv (-h/-f)
  *      11 - Modifikation der Dateinamen zuruecknehmen (-m)(-n)
  *      12 - Modifikation der Dateinamen gefordert (-m)
  *      13 - Generierung von Schienenbegleitobjekten (-a)
  *      14 - Modify object-definitions (-o)
  *      15 - Modify 'StaticDetailLevel' of object-definitions (-l)
  *      16 - Extended output to LOG (-d,Hidden)
  *      17 - Overwrite original files while writing (-inplace,Hidden)
  *      18 - Strukturdatendatei reparieren falls notwendig (-tdrepair,Hidden)
  *      22 : type-marker 1 for local options (-Y)
  * Extended Options (FoX):
  *       1 - Extended analysis for 'Hidewire'-objects within Static-Def's (-z)
  *       2 - Extended analysis for 'Modifications' within Tracks (-z)
  * ##cvrt (Eyecatcher)
  * ##horace (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int horace( /* World - Dateien bearbeiten */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute           cRte; /* aktuelle Basis-Definition der Route */
    TSShape[]         ShT;  /* benutzt fuer Tabellenkorrelation */
    TSScC[]           ScT;  /* benutzt fuer Tabellenkorrelation */
    TSSect            cSc;  /* aktuelle globale Section */
    TreeSet<TSQuad>   QDf;  /* alle Quadrat-Definitionen */
    TSTile            cTle; /* aktuelle Tile-Definition */
    TSQuad            cQDf; /* aktuelle Quadrat-Definition */
    TSCopySet         cCpy; /* current Copy-mission */
    File              dat;  /* Dateidefinitionen */
    int               i,j,v,w; /* Arbeitswerte */
    String            is,js,ks,s;
    boolean           OK,OV;
    Iterator          cI;   /* common used iterator (TSQuad/TSTile) */
    TSChain           cC;   /* current UID-chain within world */
    TSUiD             cUiD; /* UiD-Elements */
    TSArrList         cL;   /* current comandlist of changes */
    TSOpts            cM;   /* current mask of 'StaticDetailLevel' */
    String[]          cS;   /* current string-array */
    Object            o;    /* comparision-ctl: String/Pattern/null */
    Matcher           m;    /* use regular expression */
    int               cnt1,cnt2,cnt3; /* counter */
    Iterator<String>  LneI;  /* Line-Iterator for output */
    ArrayList<String> LneT;  /* Line-Table for output */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("horace01",fn); /* Vorlauf ausgeben */

    OV = Fo.chkMsk(17); /* 'newRoute'-Directory benoetigt ? */
    /* Systemdatei lesen und auswerten */
    cRte = getRte(fn,OV?1:3); /* Streckendefinition auswerten */
    if(cRte==null) return 5; /* Fehler -- Ende */

    /* Pfade ausgeben */
    is = cRte.getInfo(2); /* vorbesetzen wegen Performance */
    Lg.Msg("MsgC01",is); /* aktuelle Werte */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* aktuelle Werte */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* aktuelle Werte */
    Lg.Skip(true); /* Leerzeile loggen */

    if(OV) { /* ueberschreiben der Dateien aktiv */
      Fo.clrMsk(8); /* DO NOT write modified Path-definitions */

      if(!Fo.chkMsk(20)) askTerm(); /* ask user to REALLY overwrite */
      Lg.Log("MsgC41"); /* Warnung/Hinweis loggen */
      Lg.Skip(true); /* Leerzeile loggen */
    } /* Meldung erzeugen */

    /* globale "tsection.dat" bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC06"); /* Aktionsmeldung ausgeben */

    dat = cRte.getFile(-1); /* get reference to file (default) */
    if(pFle!=null) dat = pFle; /* Referenz auf alternative Datei setzen */
      /* nein -> die gleiche Datei (default) wird zweimal benutzt */
    i = getTS(dat,null); /* 'tsection.dat' (global) laden */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC09",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC11",c3); /* Ergebnis melden */
    Lg.Log("MsgC14",ScN); /* Ergebnis melden */
    Lg.Log("MsgC17",c2); /* Ergebnis melden */
    Lg.Log("MsgC20",ShN); /* Ergebnis melden */
    Lg.Log("MsgC23",c4); /* Ergebnis melden */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(cRte,ScA,ShA); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Vorbereiten des Ladens der ZWEITEN globalen 'tsection.dat' */
    ScT = new TSScC[ScA]; /* Connection-Tabelle erstellen */
      /* Anmerkung: ScA == ScT.length == ScTab.length */
    Arrays.fill(ScT,null); /* Tabelle initialisieren */
    for(i=0,j=1;i<ScA;i+=j) { /* Tabelle umwandeln */
      if(ScTab[i]==null) continue; /* Eintrag nicht belegt */
      cSc = ScTab[i].setScR(null); /* Verkettung loeschen */
      j = cSc.$dIx(0); /* neues Increment holen */
      ScT[i] = new TSScC(cSc); /* neues Connection-Element erstellen */
    } /* alle Connection-Eintraege erstellen */
    ScTab = null; /* Section-Tabelle(alt) frei fuer Tabelle(neu) */
    ShT   = ShTab; /* Shape-Tabelle(alt) sichern */
    ShTab = null;  /* Shape-Tabelle(alt) frei fuer Tabelle(neu) */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC07"); /* Aktionsmeldung ausgeben */

    dat = cRte.getFile(-1); /* Steuerdatei holen */
    i = getTS(dat,Fo.chkMsk(2)?cRte.getFile(-2):null);
      /* 'tsection.dat' (global-neu) laden */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC10",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC13",c3); /* Ergebnis melden */
    Lg.Log("MsgC16",ScN); /* Ergebnis melden */
    Lg.Log("MsgC19",c2); /* Ergebnis melden */
    Lg.Log("MsgC22",ShN); /* Ergebnis melden */
    Lg.Log("MsgC25",c4); /* Ergebnis melden */

    Lg.Skip(true); /* Leerzeile loggen */
    /* Zusammenfuehren der beiden "globalen tsection.dat" */
    /* 1.: Pruefen ob es in der Sectiontabelle(alt) zu jedem Eintrag
     * mindestens auch einen (max. 8) Eintrag in der Tabelle(neu) gibt
     * und diesen in der Zwischetabelle (TSScC) registrieren */
    for(i=0,v=1;i<ScT.length;i+=v) { /* alle globalen Section-Eintraege testen */
      if(ScT[i]==null) continue; /* Section nicht definiert */
      v = ScT[i].$dIx(); /* neuen Abstand merken */
      c0 = 0; /* Zuordnugszaehler initialisieren */
      for(j=0,w=1;j<ScTab.length;j+=w) { /* alle Section-Eintraege testen */
        if(ScTab[j]==null) continue; /* Section nicht definiert */
        w = ScTab[j].$dIx(0); /* neuen Abstand merken */
        if(ScT[i].check(ScTab[j])) c0 += 1; /* Zuordnung erfolgt ? */
      } /* alle Section-Eintraege testen */
      if(c0==0) /* Eintrag wurde nicht zugeordnet */
        Lg.Err("horace02",i); /* Fehlermeldung ausgeben */
    } /* alle Section-Eintraege testen */

    /* 2.: Pruefen ob es in der Shapetabelle(alt) zu jedem Eintrag auch einen
     * Eintrag in der Shapetabelle(neu) gibt. Diesen Eintrag mit dem 'alten'
     * verketten und gleichzeitig registrieren, welche Section-Zuordungen
     * dafuer benutzt wurden. */
    for(i=0,v=1;i<ShT.length;i+=v) { /* alle Shape-Eintraege (alt) testen */
      if(ShT[i]==null) continue; /* Shape nicht definiert */
      v = ShT[i].$dIx(0); /* neuen Abstand merken */
      for(j=0,w=1;j<ShTab.length;j+=w) { /* alle Shape-Eintraege (neu) testen */
        if(ShTab[j]==null) continue; /* Shape nicht definiert */
        w = ShTab[j].$dIx(0); /* neuen Abstand merken */
        if(ShT[i].check(ShTab[j],ScT)) break; /* Korrelation jetzt erfolgt */
        /* Korrelation wird durch die 'check'-Methode auf JEDEN FALL aufgehoben
         * und im Trefferfall wieder hergestellt. */
      } /* alle Shape-Eintraege testen */
      if(ShT[i].getNr(false)<0) shlp:{ /* Eintrag wurde nicht korreliert */
        /* 'getNr()' liefert '-4' wenn keine Verbindung existiert */
        w = ShT[i].getNr(true); /* Nummer des Shapes (Basis) */
        for(j=3;j<Fo.get$Obj(1);j+=2) /* alle Zusatz-Definitionen testen */
          if(Fo.getInt(j)==w) { /* Definition gefunden */
            c5 = Fo.getInt(j+1); /* Zugeordneter Wert holen */
            if(c5>=ShTab.length) continue; /* ignorieren */
            if(c5<0) continue; /* ignorieren */
            if(ShTab[c5]==null) continue; /* ignorieren */
            ShT[i].setShR(ShTab[c5]); /* neue Verbindung erzwingen */
            break shlp; /* Zuordnung ist erfolgt */
          } /* Manuelle Definition erhalten */
        Lg.Err("horace03",ShT[i].chkNme(null),i); /* print error-message */
      } /* -shlp- Eintrag nicht korreliert */
    } /* -for- alle Shape-Eintraege testen */

    /* Section-Referenzen eindeutig zuordnen (mehrfach-Referenzen aufloesen) */
    /* 3.: Wenn aus einer mehrdeutigen Section-Zuordnung EINE Zuordnung bei der
     * Shape-Bearbeitung genutzt wurde, wird diese festgeschrieben. Auch
     * eindeutige Section-Zuordnungen werden jetzt festgeschrieben.
     * Fuer die restlichen MEHRDEUTIGEN Section-Zuordnungen wird geprueft, ob es
     * in der Umgebung (+/- 1) eine eindeutige Zuordnung gibt, die sich auf
     * ahnliche Section-Definitionen bezieht. Wenn ja, wird die aktuelle Section-
     * Zuordnung genauso festgeschrieben. (Umgebung: 99->121 ==> Aktuell: 98->120)
     */
    for(i=0,v=1;i<ScT.length;i+=v) { /* alle globalen Section-Eintraege testen */
      if(ScT[i]==null) continue; /* Section nicht definiert */
      v = ScT[i].doRef(false); /* Index pruefen und setzen */
        /* Routine liefert Abstand wie: 'ScTab[i].$dIx(0)' */
    } /* alle Section-Eintraege testen */
    for(i=0,v=1;i<ScT.length;i+=v) { /* alle globalen Section-Eintraege testen */
      if(ScT[i]==null) continue; /* Section nicht definiert */
      v = ScT[i].$dIx(); /* neuen Abstand merken */
      if(ScT[i].doConn(null)) { /* Zuordnung ist noch nicht eindeutig */
        OK = true; /* noch keine Aenderung erfolgt */
        if(i>0) { /* Pruefung ist moeglich */
          j = i - 1; /* erster Test-Index */
          if(ScT[j]!=null) /* Eintrag ist gultig */
            if(ScT[i].doConn(ScT[j])) OK = false; /* Index erfolgreich gesetzt */
        } /* Pruefung war moeglich */
        if(OK) { /* Index noch nicht gesetzt */
          if(i<(ScT.length-1)) { /* Pruefung ist moeglich */
            j = i + 1; /* zweiter Test-Index */
            if(ScT[j]!=null) /* Eintrag ist gultig */
              if(ScT[i].doConn(ScT[j])) OK = false; /* Index erfolgreich gesetzt */
          } /* Pruefung war moeglich */
        } /* Index -- zweiter Versuch */
        if(OK) /* Index noch nicht gesetzt */
          if(!ScT[i].cmpNr(ScT[i].getScR().getNr(true))) OK = false;
            /* Index erfolgreich gesetzt wenn Nummern gleich */
        if(OK) /* Index konnte nicht gesetzt werden */
          Lg.Err("horace04",i); /* Fehlermeldung ausgeben */
      } /* Index ist bereits / wurde eindeutig */
    } /* -for- alle Section-Eintraege testen */
    for(i=0,v=1;i<ScT.length;i+=v) { /* alle globalen Section-Eintraege testen */
      if(ScT[i]==null) continue; /* Section nicht definiert */
      v = ScT[i].doRef(true); /* Index pruefen und Referenzen setzen */
        /* hier werden die Zuordnungen zwischen den Sectiondefinitionen per Adresse
         * endgueltig hergestellt. Feld 'ScR' wird gesetzt.
         * Routine liefert Abstand wie: 'ScTab[i].$dIx(0)' */
    } /* alle Section-Eintraege testen */

    /* Arbeitstabellen wieder erstellen - Hilfstabellen freigeben */
    Arrays.fill(ScTab,null); /* fuer Speichermanagement */
      /* alle nicht benutzten, neuen Definitionen werden damit geloescht. */
    ScTab = new TSSect[ScT.length]; /* Section-Tabelle neu erstellen */
    for(i=0;i<ScT.length;i+=1) { /* Tabelle umsetzen */
      ScTab[i] = null; /* vorbesetzen: kein Eintrag */
      if(ScT[i]!=null) ScTab[i] = ScT[i].getScR(); /* Eintrag holen */
      ScT[i] = null; /* Connection-Element loeschen */
    } /* -for- alle Connection-Eintraege kopieren */
    ScT   = null; /* Section-Steuerungstabelle nicht mehr benutzt */
    ShTab = ShT;  /* Tabelle(alt) wird aktuelle Shape-Tabelle */
    ShT   = null; /* alte Address-Referenz der Tabelle nicht mehr benutzt */

    /* Hiermit ist die Verbindung der 'alten' und 'neuen' 'tsection.dat' zu je
     * einer gemeinsamen Section-/Shape-Tabelle erfolgt.
     */

    /* zusaetzliche Streckendateien laden */
    i = getType(cRte); /* 'ttype.dat' laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strukturquadrate laden (genaue Ausfuehrung) */
    i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    if(i<0 && Fo.chkMsk(18)) { /* Steuerdatei wurde NICHT gefunden */
      i = creTDCtl(cRte,false); /* Steuerdatei erzeugen */
      if(i!=0) { /* Fehler beim Erzeugen der Steuerdatei (Hi) */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("MsgC69",i); /* Abbruchmeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 15; /* terminate function with errorcode */
      } /* Fehler aufgetreten */
      i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    } /* Steuerdatei erzeugen und neuer Versuch */
    if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC26",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Strukturquadrate laden (LO-Tiles) */
    i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
    if(i<0 && Fo.chkMsk(18)) { /* Steuerdatei wurde NICHT gefunden */
      i = creTDCtl(cRte,true); /* Steuerdatei erzeugen */
      if(i>0) { /* Fehler beim Erzeugen der Steuerdatei (Lo) */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("MsgC69",i); /* Abbruchmeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 15; /* terminate function with errorcode */
      } /* Fehler aufgetreten */
      if(i==0) i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
    } /* Steuerdatei erzeugen und neuer Versuch */
    if(i>0) { /* Fehler beim Laden der Strukturquadrate */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC27",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Schienendatenbank laden */
    i = getDBF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    i = getITF(cRte,0); /* Schienendatenbank laden und pruefen (2. Teil) */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strassendatenbank laden */
    i = getDBF(cRte,1); /* Strassendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    if(i==0) { /* Datenbank ist vorhanden */
      i = getITF(cRte,1); /* Strassendatenbank laden und pruefen (2. Teil) */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* Datenbank(teil) ist vorhanden */

    /* World-Dateien laden und syntaktisch pruefen */
    i = getWF(cRte,Fo.chkMsk(5)); /* World-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */
    /* Sound-Dateien laden und syntaktisch pruefen */
    i = getSF(cRte,Fo.chkMsk(5)); /* World-Sound-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */

    /* Signal-Definitionen laden und ueberpruefen */
    i = getSCfg(cRte,cRte.getFile(21),null,false); /* load Signal-Configurations */
    if(i==0) /* Laden erfolgreich -- weiter testen */
      i = getSScr(cRte,cRte); /* Signal-Script-Definitionen laden */

    /* Path-Definitionen werden geladen und ueberprueft */
    i = getPatF(cRte,!OV); /* Path-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Service-Definitionen werden geladen und ueberprueft */
    i = getSrvF(cRte,!OV); /* Service-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Traffic-Definitionen werden geladen und ueberprueft */
    i = getTrfF(cRte,!OV); /* Traffic-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Activity-Definitionen werden geladen und ueberprueft */
    i = getActF(cRte,!OV); /* Activity-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Hidewire-Bearbeitung falls gefordert (-z) */
    if(FoX.chkMsk(1)) /* zusaetzliche Hidewire-Bearbeitung gefordert */
      i = rcvWrld(cRte,Fo); /* statische Repraesentationen aufloesen */


    /* all files were loaded -- continue with integrity-check */
    if((is=cRte.chkRte(Fo,false))!=null) { /* check route for integrity -- error found ? */
      if(is.charAt(0)!=' ') { /* error-message returned */
        Lg.Skip(true); /* skip line */
        Lg.Err("getRte23",is); /* print errormessage */
        Lg.Msg("MsgC60"); /* print message: 'terminating' */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* error found -- function terminated */
      if(EnaW) Lg.Log("chkRte00",is); /* Warning found -- print it */
    } /* error/warning found */

    /* VOR PRUEFUNG: Dummy-World-Dateien erzeugen falls gefordert. */
    if(Fo.chkMsk(6)) { /* Dummy-World-Dateien erzeugen */
      /* Alle Tile-Definitionen ueberpruefen und bearbeiten */
      QDf = cRte.chgQDf(null); /* alle Quadrat-Definitionen holen */
      cI = cRte.getIt(10); /* Iterator fuer Tile-Definitionen */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
        while((cQDf=cTle.crQuad())!=null) { /* neue Quad-Definition erstellt */
          cQDf.chgTle(cTle); /* Rueckverkettung einfuegen */
          cQDf.chgMde(TSFile.OCB); /* set output-mode of world-file to CB */
          if(!QDf.add(cQDf)) { /* Strukturquadrat in globale Kette einfuegen */
            Lg.Skip(true); /* Leerzeile loggen */
            Lg.Msg("MsgC31",cQDf.getInf(0)); /* Fehlermeldung ausgeben */
            Lg.Close(); /* close output to Log-file */
            return 6; /* terminate function with errorcode */
          } /* Strukturquadrat nicht einfuegbar -- bereits vorhanden */
        } /* neue Quad-Definition wurde erzeugt */
      } /* alle Tile-Definitionen */
    } /* Dummy-World-Dateien wurden erzeugt */

    /* "world"-Dateien bearbeiten und neue Integritaet herstellen */
    i = 4; /* DO NOT modify I/O-mode (IO_app=4 is marker) */
    if(Fo.chkMsk(3)) i = TSFile.OCB; /* Ausgabe-Modus: Binaer, komprimiert */
    if(Fo.chkMsk(4)) i = TSFile.OUT; /* Ausgabe-Modus: Text, expanded */
    if(FoX.chkMsk(2)) i += 256; /* Register option 'recover track-objects' */
    i += 128; /* activate 'report changes' */
    if(Fo.chkMsk(1)) i += 64; /* Register option 'Renum' */
    if(Fo.chkMsk(14)) i += 32; /* Register option 'Modify objects' */
    if(Fo.chkMsk(15)) i += 16; /* Register option 'Change StDL' */
    chkWrld(cRte,null,i); /* World-Dateien erweitert pruefen */
      /* Modus: Aenderungen melden, Renum wird spezifiziert */

    /* Sound-Dateien bearbeiten und neue Integritaet herstellen */
    i = chkSnd(cRte,null,128); /* Sound-Dateien erweitert pruefen */
      /* Modus: Aenderungen melden */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("MsgC33",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC35"); /* Aktionsmeldung ausgeben */
    if(cRte.get$TrN(0)<=0) { /* Schienendatenbank NICHT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC36"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datenbank nicht vorhanden */

    i = chkDBTab(cRte,128); /* Schienendatenbank bearbeiten */
      /* Option (128) aktiv: falsche Referenzen loeschen */
    if(i<0) return 5; /* Systemfehler -- Ende */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC37",i); /* Aktionsmeldung ausgeben */
    Lg.Skip(false); /* Leerzeile loggen */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC39"); /* Aktionsmeldung ausgeben */
      i = chkDBTab(cRte,129); /* Strassendatenbank bearbeiten */
        /* Option (128) aktiv: falsche Referenzen loeschen */
      if(i<0) return 5; /* Systemfehler -- Ende */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("MsgC40",i); /* Aktionsmeldung ausgeben */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Strassendatenbank vorhanden und geladen */

    /* extended check of local 'tsection.dat'
     * Attention: This method MUST NOT be invoked unless worldfiles AND
     * database (track/road) is stored again (or neither). */
    chkTSL(cRte,ScN,ShN); /* check file and compact it */

    i = chkPat(cRte); /* Pfad-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkSrv(cRte,true); /* Service-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkCon(cRte); /* Consist-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkTrf(cRte,true,false); /* Traffic-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkAct(cRte,true); /* process activity-definitions */
    if(i>0) return 5; /* systemerror occurred -- terminate */


    /* establish capability to print error-lines */
    LneT = new ArrayList<String>(10); /* create table for output-line-blocks */
      /* This list is normally empty. After it was filled with output-lines
       * and all lines have been processed, it MUST be cleared again. */

    if(Fo.chkMsk(13)) { /* create 'Schienenbegleitobjekte' */
      Lg.Skip(true); /* print empty line (screen and LOG-file) */
      Lg.Msg("horace31",cRte.getInfo(1)); /* print current action */

      cnt1 = cnt2 = cnt3 = 0; /* initialize counter */
      QDf = cRte.chgQDf(null); /* get list of all Quad-definiitons */
      if(QDf==null) throw new IllegalStateException( /* integrity OK? */
        TSLogg.getMsg("Msg908","TreeSet<TSQuad>==null","cvrt(a)",0));
      cL = Fo.getQue(5); /* prefetch list of change-commands (min. one entry) */
      cM = cL.getOpt(0); /* get Mask of used 'StaticDetailLevel' */
      j = cL.size(); /* get number of definitions */

      cI = QDf.iterator(); /* create iterator of Quad-definitions */
      while(cI.hasNext()) { /* more definitions available ? */
        cQDf = (TSQuad)cI.next(); /* get next quad-definition */
        if(cQDf.getInf(2)==null) continue; /* no world-file -- skip it */
        cC = cQDf.chgWTab(null,0); /* get current UID-chain */
        if(cC==null) continue; /* no elements exist -- skip file */

        for(cUiD=(TSUiD)cC.list(true);cUiD!=null;cUiD=(TSUiD)cC.list(false)) {
          /* UID-Chain may be modified, if 'list'-method is used */
          if(cUiD.isOpt(0)) continue; /* skip dummy-entries */
          if(!(cUiD instanceof TSTrkObj)) continue; /* no track-object -- skip it */
            /* ONLY static tracks are processed here */
          if(!cUiD.chkSL(cM)) continue; /* 'StaticDetailLevel' is not used */
          is = ((TSTrkObj)cUiD).modNme(null); /* get current (original) filename for compare */
          m = null; /* preset: regular expression is NOT used */
          for(i=1;i<j;i+=11) { /* check all action-definitions */
            if(!cUiD.chkSL(cL.getOpt(i))) continue; /* 'StaticDetailLevel' do not match */
            o = cL.get(i+1); /* get selection-definition */
            if(o instanceof Pattern) { /* regular expression found */
              m = ((Pattern)o).matcher(is); /* compare names */
              if(!m.lookingAt()) continue; /* 'match' is NOT successful */
            } else { /* text is compared to beginning of name */
              js = (String)o; /* convert name to compare */
              if(!is.toLowerCase().startsWith(js.toLowerCase())) continue;
              /* 'match' found: 'v,is' no longer needed, 'i' no more incremented */
              v = js.length(); /* length of prefix to delete */
              if(is.length()>v) is = is.substring(v); else is = "";
            } /* selection and process were successful */
            /* formally: last for-loop no longer needed here */
            v = cL.getInt(i+4);  /* get 'StaticDetailLevel' of new objects */
            js = cL.getDta(i+3); /* get conditional path if available */
            if(js!=null) js = TSLogg.getMsg(js,cRte.getParm()); /* modify it */
            /* create first new object in every case */
            ks = (m!=null) ? "" : is; /* set default-value */
            s = cL.getDta(i+6); /* get modification-value of target 1 */
            if(s!=null)  /* modification available use it */
              if(m!=null) ks = m.replaceAll(s); /* create new filename */
              else ks = s + is; /* create filename without regular expr. */
            cCpy = (TSCopySet)cL.get(i+5); /* get installation directory 1 */
            if(cCpy!=null) cCpy.add(ks); /* add name of current file for installation */
            if(js!=null) ks = js + ks; /* compute new (full) filename of object */
            cUiD.crStatic(cC,cQDf,ks,v,null); /* no error/warning is returned */
              /* create new static world-object and sort new object into chain */
            cnt1 += 1; /* count new object */
            /* check if second object must be created */
            if(cUiD.chkAnim(true)) { /* second object is requested -- create it */
              s = cL.getDta(i+8); /* get modification-value of target 2 */
              if(s!=null) { /* modification available use it */
                if(m!=null) ks = m.replaceAll(s); /* create new filename */
                else ks = s + is; /* create filename without regular expr. */
                cCpy = (TSCopySet)cL.get(i+7); /* get installation directory 2 */
                if(cCpy!=null) cCpy.add(ks); /* add name of current file for installation */
                if(js!=null) ks = js + ks; /* compute new filename of object */
                cUiD.crStatic(cC,cQDf,ks,v,null); /* no error/warning is returned */
                  /* create new static world-object and sort new object into chain */
                cnt2 += 1; /* count new object */
              } else Lg.Err("horace32",cQDf.getInf(0),is,cUiD.getUiD(0));
                     /* print message: no filename available */
            } /* second object was requested */
            /* check if third object must be created */
            if(cUiD.chkColl(true)) { /* object is requested -- create it */
              s = cL.getDta(i+10); /* get modification-value of target 3 */
              if(s!=null) { /* modification available use it */
                if(m!=null) ks = m.replaceAll(s); /* create new filename */
                else ks = s + is; /* create filename without regular expr. */
                cCpy = (TSCopySet)cL.get(i+9); /* get installation directory 3 */
                if(cCpy!=null) cCpy.add(ks); /* add name of current file for installation */
                if(js!=null) ks = js + ks; /* compute new filename of object */
                if((ks=cUiD.crStatic(cC,cQDf,ks,v,cRte))!=null) { /* error/warning */
                  if(ks.startsWith("\n")) { /* warning -- object was still created */
                    Lg.Log("horace34",ks.substring(1),cQDf.getInf(0),cUiD.getUiD(0));
                    cnt3 += 1; /* object was created -- count new object */
                  } else Lg.Err("horace35",ks,cQDf.getInf(0),cUiD.getUiD(0));
                } else cnt3 += 1; /* no error -- count new object */
              } else Lg.Err("horace33",cQDf.getInf(0),is,cUiD.getUiD(0));
                     /* print message: no filename available */
            } /* third object was requested */
            /* reset original (source-)object */
            v = cL.getInt(i+2); /* get 'StaticDetailLevel' (target) of source */
            cUiD.setSL(v);   /* and insert it (explicitely) into source-object */
            cC.reSort(cUiD); /* and resort source-element within chain */
            break; /* match found -- all requested objects created */
          } /* - for- check all change-definitions */
        } /* - for- check all uid-entries */
      } /* -while- process all quad-definitions */

      /* Check installation-requirements and do it if needed */
      dat = null; /* destination is NOT used until now */
      for(i=0;i<10;i+=1) { /* check all Copy-missions */
        cCpy = (TSCopySet)Fo.getObj(6,i); /* get definition of Copy-mission */
        if(cCpy==null) continue; /* Copy-mission not specified */
        if(cCpy.size()==0) continue; /* no file(s) to copy -- skip mission */
        if(dat==null) dat = cRte.getFile(OV?15:45); /* get destination for Shape-files */
          /* Attention: 'Destination' is selected due to 'overwrite'-option */
        LneI = cCpy.cpyFle(dat,null,LneT); /* install all Shape-Files */
        if(LneI==null) continue; /* no valid messages -- terminate */
        while(LneI.hasNext()) { /* more message-lines available ? */
          is = LneI.next(); /* get next message-line */
          if(is==null) continue; /* dummy line -- do not write */
          /* Attention: A warning-line must start with ' ' or it is
           *            considered as an error-message */
          if(is.charAt(0)!=' ') Lg.Err("Msg010",is); /* print error-message */
            /* got error-message instead of warning-line */
          else Lg.Log("Msg010",is); /* print warning-line */
            /* NO error-message -- write Warning */
        } /* -while- process all output-lines */
        LneT.clear(); /* all lines written -- delete them */
        LneI = cCpy.cpyFle(dat,"d",LneT); /* install all Shape-Description-Files */
        if(LneI==null) continue; /* no valid messages -- terminate */
        while(LneI.hasNext()) { /* more message-lines available ? */
          is = LneI.next(); /* get next message-line */
          if(is==null) continue; /* dummy line -- do not write */
          if(is.charAt(0)!=' ') Lg.Err("Msg010",is); /* print error-message */
          else Lg.Log("Msg010",is); /* print warning-line */
        } /* -while- process all output-lines */
        LneT.clear(); /* all lines written -- delete them */
      } /* - for- check all Copy-missions */

      Lg.Skip(false); /* print empty line to LOG-file */
      Lg.Log("horace37",cnt1); /* print result of operation */
      Lg.Log("horace38",cnt2); /* print result of operation */
      Lg.Log("horace39",cnt3); /* print result of operation */
      Lg.Skip(false); /* print empty line to LOG-file */
    } /* 'Schienenbegleitobjekte' were created */

    if(Fo.getMsk(0x1E00)!=0) chgTrk(cRte,Fo,9); /* Kng ab Bit 9 */
      /* Modifikation der Track-Objekte gefordert -- ausfuehren */

    /* ***** ab hier beginnen die Ausgaben ***** */
    /* Zwischenfile-Erstellen falls ueberschreiben aktiv. */
    dat = null; /* Annehmen: Dateien NICHT ueberschreiben */
    if(OV) { /* ueberschreiben der Dateien aktiv */
      try { dat = File.createTempFile("TSUtil",".tmp");
      } catch (IOException e) { /* Creation-Fehler Temp-Datei */
       System.err.println(e.toString());  return 5;}
      dat.deleteOnExit(); /* Datei am Ende wieder loeschen */
    } /* ueberschreiben der Dateien aktiv */

    /* Process basic file of route (.trk) */
    i = putRte(cRte,dat); /* rewrite route-definition */
    if(i>0) return i; /* error found while writing */

    /* "world"-Dateien bearbeiten und modifizieren */
    i = putWF(cRte,dat,true,false); /* World-Dateien modifiziert schreiben */
      /* Modus: neue UiD's verwenden */
    if(i>0) return i; /* Fehler beim Schreiben -- Ende */
    /* Sound-Dateien bearbeiten und modifizieren */
    i = putSF(cRte,dat,true); /* Sound-Dateien modifiziert schreiben */
    if(i>0) return i; /* Fehler beim Schreiben -- Ende */

    /* Schienendatenbank bearbeiten */
    i = 16; if(Fo.chkMsk(29)) i += 64; /* Optionen erstellen */
    i = putDBF(cRte,dat,i); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    /* Schienendatenbank (.tit) bearbeiten */
    i = putITF(cRte,dat,0,false); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      /* Strassendatenbank bearbeiten */
      i = 17; if(Fo.chkMsk(29)) i += 64; /* Optionen erstellen */
      i = putDBF(cRte,dat,i); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */

      /* Strassendatenbank (.rit) bearbeiten */
      i = putITF(cRte,dat,1,false); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */
    } /* Strassendatenbank vorhanden und geladen */

    /* "tsection.dat" (lokal) neu erstellen */
    i = putTSL(cRte,cRte,OV); /* neue lokale 'tsection.dat' schreiben */
    if(i>0) return i; /* Fehler -- beenden */

    if(Fo.chkMsk(8)) { /* paths have to be written in 'modified' format */
      i = putPatF(cRte,null,5); /* Path-Definitionen VERAENDERT schreiben */
      if(i>0) return i; /* Fehler -- abbrechen */
    } else { /* write path- and activity-files */
      i = putPatF(cRte,dat,1); /* write path-definitions */
      if(i>0) return i; /* Fehler -- abbrechen */

      i = putSrvF(cRte,dat,1); /* Write Service-Definitions */
      if(i>0) return i; /* severe error -- terminate function */
      i = putTrfF(cRte,dat,1); /* Traffic-Definitions */
      if(i>0) return i; /* severe error -- terminate function */
      i = putActF(cRte,dat,1); /* Write Activitys again */
      if(i>0) return i; /* severe error -- terminate function */
    } /* all path-files were written */

//!!    i = putSCfg(cRte,null); /* Signal-Definitionen schreiben */

    if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("horace11"); /* Ergebnis melden */
    Lg.Msg("horace12"); /* Ergebnis melden */
    Lg.Msg("horace13",ShA); /* Ergebnis melden */
    Lg.Msg("horace14",ScA); /* Ergebnis melden */
    Lg.Msg("horace15",cRte.get$Sh(true)); /* Ergebnis melden */
    Lg.Msg("horace16",cRte.get$Sc(true)); /* Ergebnis melden */
    Lg.Msg("horace17"); /* Ergebnis melden */
    Lg.Msg("horace18",ShN); /* Ergebnis melden */
    Lg.Msg("horace19",ScN); /* Ergebnis melden */
    Lg.Msg("horace20",cRte.get$Sh(false)); /* Ergebnis melden */
    Lg.Msg("horace21",cRte.get$Sc(false)); /* Ergebnis melden */

    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
 }

 /**. <pre>
  *=====================================================================
  * Methode "chgTDB" (-6-)
  * Change Shape- and Section-Numbers of Track-/Road-Database
  * ##chgTDB (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chgTDB() /* Modify Track-/Road-Database */
   {
   /*-----------------------------------------------------------------*/
    TSFileX cR,cW; /* current database-file-control */
    TSBuf   cB;    /* current input-buffer for 'read file' */
    File    dat;   /* current file-definition */
    int     z1,z2,z3; /* counter (zaehler) */
    int     i,v,w; /* intermediate value(s) */
    double  f;     /* intermediate value */
    String  is;    /* intermediate value */
   /*=================================================================*/
    TSLogg.Print("chgTDB01",""+sha,""+shn,""+sca,""+scn);

    /* type-id for database is: 'xdb' (tdb,rdb) */
    dat = new File(fn); /* create file-description */
    cR = new TSFileX(TSFileX.FT$xdb,dat); /* create handle to database-file */
    is = cR.open(false); /* and open file for input */
    if(is!=null) { /* open-error occurred */
      TSLogg.Print("chgTDB02",is);
      return 5; /* stop function-program */
    } /* error while opening of database-file */

    fn = fn + "$";
    dat = new File(fn); /* create file-description */
    cW = new TSFileX(TSFileX.FT$xdb,dat); /* create handle to database-file */
    is = cW.open(true); /* and open file for output */
    if(is!=null) { /* open-error occurred */
      TSLogg.Print("chgTDB02",is);
      cR.close(); /* close input-file again -- ignore message */
      return 6; /* stop function-program */
    } /* error while opening of database-file */
    cB = new TSBuf(cR,cW); /* create inputbuffer (line mode) and init counter */
    z1 = z2 = z3 = 0; /* init counter for valid records */

    bl: { /* block for error-break */
      while(!cB.getNext(false)) { /* read/write all records until EOF or error */
        if(!cB.advPtr("trvectorsections")) continue; /* no keyword -- ignore record */
        z1 += 1; /* count valid record */
        if(cB.getKE(true)==null) { /* error occurred within expression */
          cB.getErr(TSLogg.getKey("chgTDB11")); /* set message if EOF found */
          break bl; /* terminate function */
        } /* error occurred within expression -- terminate function */
        w = (int)cB.getNV(); /* get next number from line */
        if(cB.getErr()!=null) break bl; /* error while evaluating */

        for(v=0;v<w;v+=1) { /* process all entries */
          i = (int)cB.getNV(true); /* get next number from line (section-number) */
          while(cB.getErr()!=null) { /* number not found within line */
            if(i!=0) break bl; /* error while evaluating */
            if(cB.getNext(false)) { /* read/write record has error */
              cB.getErr(TSLogg.getKey("chgTDB12")); /* set message if EOF found */
              break bl; /* terminate function */
            } /* read/write record has error -- terminate function */
            i = (int)cB.getNV(true); /* try to get section-number again */
          } /* repeat until number is available */
          if(i>=sca) { /* dyn. Section */
            z2 += 1; /* count section */
            i += scn - sca; /* compute new index */
            if(cB.modData(""+i)) { /* error during replacement */
              cB.getErr(TSLogg.getKey("chgTDB13")); /* set message to buffer */
              break bl; /* terminate function */
            } /* error during replacement -- terminate function */
          } /* dynamic section is processed */
          i = (int)cB.getNV(true); /* get next number from line (shape-number) */
          while(cB.getErr()!=null) { /* number not found within line */
            if(i!=0) break bl; /* error while evaluating */
            if(cB.getNext(false)) { /* read/write record has error */
              cB.getErr(TSLogg.getKey("chgTDB12")); /* set message if EOF found */
              break bl; /* terminate function */
            } /* read/write record has error -- terminate function */
            i = (int)cB.getNV(true); /* try to get shape-number again */
          } /* repeat until number is available */
          if(i>=sha) { /* dyn. Shape (path) */
            z3 += 1; /* count shape */
            i += shn - sha; /* compute new index */
            if(cB.modData(""+i)) { /* error during replacement */
              cB.getErr(TSLogg.getKey("chgTDB13")); /* set message to buffer */
              break bl; /* terminate function */
            } /* error during replacement -- terminate function */
          } /* dynamic section is processed */

          for(i=0;i<14;i+=1) { /* skip another 14 values */
            f = cB.getFV(); /* get next (float-)number from line */
            while(cB.getErr()!=null) { /* number not found within line */
              if(!Double.isNaN(f)) break bl; /* error while evaluating */
              if(cB.getNext(false)) { /* read/write record has error */
                cB.getErr(TSLogg.getKey("chgTDB12")); /* set message if EOF found */
                break bl; /* terminate function */
              } /* read/write record has error -- terminate function */
              f = cB.getFV(); /* try to get number again */
            } /* repeat until number is available */
            /* number is valid -- skip it and do not process */
          } /* Sub-entry of 'trvectorsection' is processed */
        } /* id 'TrVectorSections' found -- record(s) changed */
      } /* read/write all records until EOF or error */

    } /* -bl- break-block used in case of error */

    if((is=cB.getErr())!=null) TSLogg.Print("chgTDB02",is); /* error -- print it */
    if((is=cW.close())!=null) TSLogg.Print("chgTDB02",is); /* print close-error */
    if((is=cR.close())!=null) TSLogg.Print("chgTDB02",is); /* print close-error */

    TSLogg.Print("MsgC56",z1); /* print actionmessage */
    TSLogg.Print("chgTDB03",null,z2,z3); /* print statistic-message */
    return 0; /* return from function without error */
  }

 /**. <pre>
  *=====================================================================
  * Methode "dcopy" (-7-)
  * Differenz-Dateistruktur erstellen
  * Optionen:
  *       1 - Auch '.bk'-Dateien kopieren
  *       2 - Nur vorhandene Dateien beachten (nur neuere Dateien)
  *       3 - Time-displacement of checked route active
  * ##dcopy (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int dcopy( /* Differenz-Dateien bearbeiten */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    File   dir1,dir2,dir3;
    int    c;
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("dCopy01",fn); /* Vorlauf ausgeben */

    dir1 = new File(fn); /* Directoryobjekt erstellen */
    fn = dir1.getAbsolutePath(); /* Gesamtname erstellen */
    dir1 = new File(fn); /* Directoryobjekt neu erstellen */
    if(!dir1.exists()) { /* Pfad existiert nicht */
      Lg.Msg("dCopy02",fn); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Pfad existiert nicht */
    if(!dir1.isDirectory()) { /* kein Directory spezifiziert */
      Lg.Msg("dCopy03",fn); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* kein Directory */
    dir2 = new File(vn2); /* Directoryobjekt erstellen */
    vn2 = dir2.getAbsolutePath(); /* Gesamtname erstellen */
    dir2 = new File(vn2); /* Directoryobjekt neu erstellen */
    if(!dir2.exists()) { /* Pfad existiert nicht */
      Lg.Msg("dCopy02",vn2); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Pfad existiert nicht */
    if(!dir2.isDirectory()) { /* kein Directory spezifiziert */
      Lg.Msg("dCopy03",vn2); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* kein Directory */
    dir3 = new File(vn3); /* Directoryobjekt erstellen */
    vn3 = dir3.getAbsolutePath(); /* Gesamtname erstellen */
    dir3 = new File(vn3); /* Directoryobjekt neu erstellen */
    if(!dir3.exists()) { /* Pfad existiert nicht */
      Lg.Msg("dCopy02",vn3); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Pfad existiert nicht */
    if(!dir3.isDirectory()) { /* kein Directory spezifiziert */
      Lg.Msg("dCopy03",vn3); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* kein Directory */

    fn  = fn.toLowerCase(); /* umwandeln fuer Vergleich */
    vn2 = vn2.toLowerCase(); /* umwandeln fuer Vergleich */
    vn3 = vn3.toLowerCase(); /* umwandeln fuer Vergleich */
    if(vn3.indexOf(fn)>=0) { /* Pfade ueberlappen -- Fehler */
      Lg.Msg("dCopy04"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Pfade identisch */
    if(vn3.equals(vn2)) { /* Pfade sind identisch -- Fehler */
      Lg.Msg("dCopy05"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Pfade identisch */

    /* Pfade ausgeben */
    Lg.Msg("dCopy06",dir1.getAbsolutePath()); /* Aktionswerte ausgeben */
    Lg.Msg("dCopy07",dir2.getAbsolutePath()); /* Aktionswerte ausgeben */
    Lg.Msg("dCopy08",dir3.getAbsolutePath()); /* Aktionswerte ausgeben */
    Lg.Skip(false); /* Leerzeile loggen */

    c = cpyDat(dir1,dir2,dir3,0); /* Kopiervorgang initiieren */

    Lg.Skip(true); /* Leerzeile hinzufuegen */
    Lg.Msg("dCopy09",c); /* Abschlussmeldung */
    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "shift" (-8-)
  * Shape-Bereich in globaler 'tsection.dat' verschieben
  * Optionen:
  *       1 - Erweiterung der Grenzen erlaubt
  * ##shift (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int shift( /* Shape-Bereich verschieben */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSFileX   R,W; /* Reader, Writer */
    TSSect[]  ScT; /* Zwischentabelle */
    TSShape[] ShT; /* Zwischentabelle */
    TSSect    cSc;   /* Arbeitswert(e) */
    TSShape   cSh;   /* Arbeitswert(e) */
    TSBuf     cB;    /* current input-buffer */
    int       i,j,v; /* Arbeitswert(e) */
    int       z1,z2; /* counter */
    String    is,js; /* Arbeitswert(e) */
    File      dir1,dir2;
    double    f;
    boolean   OK;
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("shftTS01",fn); /* Vorlauf ausgeben */

    dir1 = new File(fn); /* Directoryobjekt erstellen */
    fn = dir1.getAbsolutePath(); /* Gesamtname erstellen */
    dir1 = new File(fn); /* Directoryobjekt neu erstellen */
    if(!dir1.exists()) { /* Pfad existiert nicht */
      Lg.Msg("shftTS02",fn); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Pfade ausgeben */
    Lg.Msg("shftTS03",dir1.getAbsolutePath()); /* Aktionswerte ausgeben */
    Lg.Skip(false); /* Leerzeile ausgeben (nur Log-Datei) */

    /* Haupt-Schleife fuer Fehler */
    R = null; /* init in case of error */
    z1 = z2 = 0; /* initialize counters */
    shift_1: { /* Break Loop */
      /* Shift - Plausibilitaeten pruefen */
      if(shd==0 && scd==0) { /* Verschub-Differenz ungueltig */
        Lg.Err("shftTS04"); /* Aktionsmeldung: Keine Verschiebung */
        break shift_1; /* Bearbeitung abbrechen */
      } /* Plausi-Fehler */
      if(shd==0) /* kein Verschieben gefordert */
        Lg.Msg("shftTS05"); /* Aktionsmeldung: Keine Verschiebung */
      if(scd==0) /* kein Verschieben gefordert */
        Lg.Msg("shftTS06"); /* Aktionsmeldung: Keine Verschiebung */
      if(shd!=0) { /* Funktion aktiviert */
        if(shl>=shh) { /* Shape - Range nicht definiert */
          Lg.Err("shftTS07"); /* Fehlermeldung: Werte-Fehler */
          break shift_1; /* Bearbeitung abbrechen */
        } /* Plausi-Fehler */
        if((shl+shd)<0) { /* Shape-Bereich nicht unterstuetzt */
          Lg.Err("shftTS08"); /* Fehlermeldung: Werte-Fehler */
          break shift_1; /* Bearbeitung abbrechen */
        } /* Plausi-Fehler */
      } /* Funktion aktiviert */
      if(scd!=0) { /* Funktion aktiviert */
        if(scl>=sch) { /* Section - Range nicht definiert */
          Lg.Err("shftTS09"); /* Fehlermeldung: Werte-Fehler */
          break shift_1; /* Bearbeitung abbrechen */
        } /* Plausi-Fehler */
        if((scl+scd)<0) { /* Section-Bereich nicht unterstuetzt */
          Lg.Err("shftTS10"); /* Fehlermeldung: Werte-Fehler */
          break shift_1; /* Bearbeitung abbrechen */
        } /* Plausi-Fehler */
      } /* Funktion aktiviert */

      /* globale "tsection.dat" bearbeiten */
      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("MsgC05"); /* Aktionsmeldung ausgeben */

      i = getTS(dir1,null); /* 'tsection.dat' (global) laden */
      ScA = ScN; ShA = ShN; /* values are again used within local part */

      if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("MsgC08",i); /* Abbruchmeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 15; /* terminate function with errorcode */
      } /* Fehler aufgetreten */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Log("MsgC11",c3); /* Ergebnis melden */

      /* weitere Plausibilitaetsprufungen */
      Lg.Skip(false); /* Leerzeile loggen */
      if(shd!=0) /* Funktion aktiviert */
       if((j=shh+shd)>ShA) { /* Shape-Bereich nicht unterstuetzt */
        if(!Fo.chkMsk(1)) { /* keine Erweiterung erlaubt */
          Lg.Err("shftTS11"); /* Fehlermeldung: Werte-Fehler */
          break shift_1; /* Bearbeitung abbrechen */
        } /* Plausi-Fehler */
        ShT = new TSShape[j]; /* create larger table */
        Arrays.fill(ShT,null); /* and initialize it */
        for(i=0;i<ShA;i+=1) { /* Tabelleneintrag umsetzen (kopieren) */
          ShT[i]   = ShTab[i]; /* kopieren */
          ShTab[i] = null;     /* Eintrag freigeben (Speicherverw.) */
        } /* Tabelleneintrag umsetzen */
        ShTab = ShT; /* Tabelle aktivieren */
        ShA = j;     /* und maximale Anzahl anpassen */
        ScT = null;  /* temp. Tabelle wieder freigeben (Speicherverw.) */
      } /* Shape-Bereich falsch */
      if(scd!=0) /* Funktion aktiviert */
       if((j=sch+scd)>ScA) { /* Section-Bereich nicht unterstuetzt */
        if(!Fo.chkMsk(1)) { /* keine Erweiterung erlaubt */
          Lg.Err("shftTS12"); /* Fehlermeldung: Werte-Fehler */
          break shift_1; /* Bearbeitung abbrechen */
        } /* Plausi-Fehler */
        ScT = new TSSect[j]; /* create larger table */
        Arrays.fill(ScT,null); /* and initialize it */
        for(i=0;i<ScA;i+=1) { /* Tabelleneintrag umsetzen (kopieren) */
          ScT[i]   = ScTab[i]; /* kopieren */
          ScTab[i] = null;     /* Eintrag freigeben (Speicherverw.) */
        } /* Tabelleneintrag umsetzen */
        ScTab = ScT; /* Tabelle aktivieren */
        ScA = j;     /* und maximale Anzahl anpassen */
        ScT = null;  /* temp. Tabelle wieder freigeben (Speicherverw.) */
      } /* Section-Bereich falsch */

      /* Testen der Definitionen der "globalen tsection.dat" */
      OK = false; /* annnehmen: kein Fehler */
      if(scd!=0) /* Funktion aktiviert */
       for(i=0,v=1;i<ScTab.length;i+=v) { /* alle Section-Eintraege testen */
        if((cSc=ScTab[i])==null) continue; /* Section nicht definiert */
        v = cSc.$dIx(0); /* neuen Abstand merken */
        /* Vorraussetzung: Index == Section-Nummer(alt) --- ist gegeben!! */
        if(i<scl) continue; /* Eintrag wird nicht verschoben */
        if(i>=sch) continue; /* Eintrag wird nicht verschoben */
        cSc.setScR(null); /* Zieleintrag entwerten */
        j = i + scd; /* neuen Index/Nummer berechnen */
        if(j>=scl && j<sch) continue; /* Eintrag rutscht in verschobenen Bereich */
        if(ScTab[j]==null) continue; /* Section noch frei */
        OK = Lg.Err("shftTS13",null,j,i); /* Fehlermeldung ausgeben */
        z1 += 1; /* Fehler merken */
      } /* alle Section-Eintraege testen */
      if(shd!=0) /* Funktion aktiviert */
       for(i=0,v=1;i<ShTab.length;i+=v) { /* alle Shape-Eintraege testen */
        if((cSh=ShTab[i])==null) continue; /* Shape nicht definiert */
        v = cSh.$dIx(0); /* neuen Abstand merken */
        /* Vorraussetzung: Index == Shape-Nummer(alt) --- ist gegeben!! */
        if(i<shl) continue; /* Eintrag wird nicht verschoben */
        if(i>=shh) continue; /* Eintrag wird nicht verschoben */
        cSh.setShR(null); /* Zieleintrag entwerten */
        j = i + shd; /* neuen Index/Nummer berechnen */
        if(j>=shl && j<shh) continue; /* Eintrag rutscht in verschobenen Bereich */
        if(ShTab[j]==null) continue; /* Shape noch frei */
        OK = Lg.Err("shftTS14",null,j,i); /* Fehlermeldung ausgeben */
        z2 += 1; /* Fehler merken */
      } /* alle Shape-Eintraege testen */
      if(OK) { /* Fehler wurden gefunden */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Err("shftTS15",z2); /* Fehlermeldung ausgeben */
        Lg.Err("shftTS16",z1); /* Fehlermeldung ausgeben */
        z1 = z2 = 0; /* fuer Abschlussmeldung */
        break shift_1; /* Bearbeitung abbrechen */
      } /* Fehler erkannt */

      /* Definitionen der "globalen tsection.dat" verschieben */
      /* alle Objekte muessen umgehaengt werden, ohne das Objekt selbst
       * neu zu erstellen. Damit bleiben ALLE Referenzen weiterhin gueltig.
       */
      z1 = z2 = 0; /* Zaehler initialisieren */
      if(scd!=0) /* Funktion aktiviert */
       for(i=0,v=1;i<ScTab.length;i+=v) { /* alle Section-Eintraege testen */
        if((cSc=ScTab[i])==null) continue; /* Section nicht definiert */
        v = cSc.$dIx(0); /* neuen Abstand merken */
        /* Vorraussetzung: Index == Section-Nummer(alt) --- ist gegeben!! */
        if(i<scl) continue; /* Eintrag wird nicht verschoben */
        if(i>=sch) continue; /* Eintrag wird nicht verschoben */
        j = i + scd; /* neuen Index/Nummer berechnen */
        ScTab[i] = cSc.setScR(cSc); /* Referenz erneuern und alte aktivieren */
          /* Verkettete Referenz wird nach ScTab[i] gebracht,
           * Basisdefinition wird geliefert */
        cSc.$reNew(j); /* neue Section definieren ohne Wechsel der Adresse */
        if(ScTab[j]==null) ScTab[j] = cSc; /* neue Definition setzen */
        else { /* Definition ist schon vorhanden -- neue anhaengen */
          cSc = ScTab[j].setScR(cSc); /* Definition anhaengen */
          if(cSc!=null) { /* eine NEUE Definition war schon vorhanden */
            Lg.Err("shftTS17",null,j,i); /* Fehlermeldung ausgeben */
            z1 = z2 = 0; /* fuer Abschlussmeldung */
            break shift_1; /* Bearbeitung abbrechen */
          } /* doppelte Belegung darf nicht auftreten */
        } /* neue Definition wurde angehaengt */
        z1 += 1; /* Section wurde verschoben -- zaehlen */
      } /* alle Section-Eintraege verschieben */
      if(shd!=0) /* Funktion aktiviert */
       for(i=0,v=1;i<ShTab.length;i+=v) { /* alle Shape-Eintraege testen */
        if((cSh=ShTab[i])==null) continue; /* Shape nicht definiert */
        v = cSh.$dIx(0); /* neuen Abstand merken */
        /* Vorraussetzung: Index == Shape-Nummer(alt) --- ist gegeben!! */
        if(i<shl) continue; /* Eintrag wird nicht verschoben */
        if(i>=shh) continue; /* Eintrag wird nicht verschoben */
        j = i + shd; /* neuen Index/Nummer berechnen */
        ShTab[i] = cSh.setShR(cSh); /* Referenz erneuern und alte aktivieren */
          /* Verkettete Referenz wird nach ShTab[i] gebracht,
           * Basisdefinition wird geliefert */
        cSh.$reNew(j); /* neuen Shape definieren ohne Wechsel der Adresse */
        if(ShTab[j]==null) ShTab[j] = cSh; /* neue Definition setzen */
        else { /* Definition ist schon vorhanden -- neue anhaengen */
          cSh = ShTab[j].setShR(cSh); /* Definition anhaengen */
          if(cSh!=null) { /* eine NEUE Definition war schon vorhanden */
            Lg.Err("shftTS18",null,j,i); /* Fehlermeldung ausgeben */
            z1 = z2 = 0; /* fuer Abschlussmeldung */
            break shift_1; /* Bearbeitung abbrechen */
          } /* doppelte Belegung darf nicht auftreten */
        } /* neue Definition wurde angehaengt */
        z2 += 1; /* Shape wurde verschoben -- zaehlen */
      } /* alle Shape-Eintraege verschieben */

      /* compute filename for output and report it */
      dir2 = dir1; /* initialize for modification */
      do /* repeat until file-name is unique */
        dir2 = new File(dir2.getAbsolutePath()+"$"); /* create new file-definition */
      while(dir2.exists()); /* repeat if file already exits */
      Lg.Skip(true); /* Leerzeile ausgeben  */
      Lg.Msg("shftTS19",dir2.getName()); /* Aktionsmeldung */

      R = new TSFileX(TSFileX.FT$gts,dir1); /* create input-control */
      is = R.open(false); /* open database for input and check file-id */
      if(is!=null) { /* open not successful */
        Lg.Skip(true); /* Leerzeile ausgeben  */
        Lg.Msg("shftTS99",is); /* Fehlermeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* error while opening 'tsection.dat' */

      W = new TSFileX(TSFileX.FT$gts,dir2); /* create output-control */
      is = W.open(true); /* open database for output and write file-id */
      if(is!=null) { /* open not successful */
        Lg.Skip(true); /* Leerzeile ausgeben  */
        Lg.Msg("shftTS99",is); /* Fehlermeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        R.close(); /* close input-file again */
        return 6; /* terminate function with errorcode */
      } /* error while opening 'tsection.dat' */

      z1 = z2 = 0; /*  neu initialisieren */
      cB = new TSBuf(R,W); /* create buffer-control (input/output) */
        /* line -mode is used so that data may be modified */
      shift_2: { /* Break Loop Datei */
        while(!cB.getNext(false)) /* copy records and search for keyword */
          /* search for section-definitions */
          if(cB.advPtr("tracksections")) break; /* keyword found within current line */
        if((is=cB.getErr())!=null) break shift_2; /* terminate processing */

        while(!cB.getNext(false)) { /* copy all records (read/write) */
          /* search for trackshape-definitions, process section-definitions */
          if(scd!=0) SC:{ /* modification needed */
            if(cB.advPtr("tracksection")) { /* keyword found within current line */
              is = cB.getKE(true); /* get keyword-expression of line */
              if(is==null) break SC; /* not available -- do not process */
              if(!is.equals("tracksection")) break SC; /* requested KW NOT found */
              cB.mark(false); /* mark current position for replace */
              i = (int)cB.getNV(); /* get ID-number */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                is = TSLogg.getMsg("shftTS21",is,cB.getStat(true));
                break shift_2; /* terminate processing */
              } /* error while evaluating -- terminate processing */
              if(i<scl || i>=sch) break SC; /* Id need not to be changed */
              v = i + scd; /* compute new section-id */
              if(cB.modData(" "+v)) { /* error during replacement */
                is = TSLogg.getMsg("shftTS41",cB.getStat(true));
                break shift_2; /* terminate processing */
              } /* error during replacement -- terminate processing */
              z1 += 1; /* count modification */
              if(EnaW) Lg.Log("shftTS22",null,i,v); /* print message */
            } /* keyword found within line -- value changed */
          } /* -SC- SectionId processed */
          if(cB.advPtr("trackshapes")) break; /* keyword found within current line */
        } /* copy records and search for keyword */
        if((is=cB.getErr())!=null) break shift_2; /* terminate processing */

        while(!cB.getNext(false)) { /* copy all records (read/write) */
          /* copy all remaining lines */
          if(shd!=0) SH:{ /* modification needed */
            if(cB.advPtr("trackshape")) { /* keyword found within current line */
              is = cB.getKE(true); /* get keyword-expression of line */
              if(is==null) break SH; /* not available -- do not process */
              if(!is.equals("trackshape")) break SH; /* requested KW NOT found */
              cB.mark(false); /* mark current position for replace */
              i = (int)cB.getNV(); /* get ID-number */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                is = TSLogg.getMsg("shftTS24",is,cB.getStat(true));
                break shift_2; /* terminate processing */
              } /* error while evaluating -- terminate processing */
              if(i<shl || i>=shh) break SH; /* Id need not to be changed */
              v = i + shd; /* compute new shape-id */
              if(cB.modData(" "+v)) { /* error during replacement */
                is = TSLogg.getMsg("shftTS41",cB.getStat(true));
                break shift_2; /* terminate processing */
              } /* error during replacement -- terminate processing */
              z2 += 1; /* count modification */
              if(EnaW) Lg.Log("shftTS23",null,i,v); /* print message */
            } /* keyword found within line -- value changed */
          } /* -SH- ShapeId processed */
          if(scd!=0) SX:{ /* modification needed */
            if(cB.advPtr("sectionidx")) { /* keyword found within current line */
              is = cB.getKE(true); /* get keyword-expression of line */
              if(is==null) break SX; /* not available -- do not process */
              if(!is.equals("sectionidx")) break SX; /* requested KW NOT found */
              j = (int)cB.getNV(); /* get and skip number of sectionreferences */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                is = TSLogg.getMsg("shftTS25",is,cB.getStat(true));
                break shift_2; /* terminate processing */
              } /* error while evaluating -- terminate processing */
              for(i=0;i<4;i+=1) { /* skip offset-values (float) */
                cB.getFV(); /* skip value of argument (number) */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  is = TSLogg.getMsg("shftTS26",is,cB.getStat(true));
                  break shift_2; /* terminate processing */
                } /* error while evaluating -- terminate processing */
              } /* -for- skip offset-values (not modified) */
              do { /* modify all references (number >0 in any case) */
                cB.mark(false); /* mark current position for replace */
                i = (int)cB.getNV(); /* get ID-number */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  is = TSLogg.getMsg("shftTS28",is,cB.getStat(true));
                  break shift_2; /* terminate processing */
                } /* error while evaluating -- terminate processing */
                if(i>=scl && i<sch) i += scd; /* compute new section-id */
                if(cB.modData(" "+i)) { /* error during replacement */
                  is = TSLogg.getMsg("shftTS41",cB.getStat(true));
                  break shift_2; /* terminate processing */
                } /* error during replacement -- terminate processing */
              } while(--j>0); /* adjust all references */
            } /* keyword found within line -- value changed */
          } /* -SX- SectionIdx processed */
        } /* copy records and search for keyword */
        is = cB.getErr(); /* get error-message or clear value (if none) */
      } /* - shift_2 - Break-Loop Datei */
      if(is!=null) Lg.Msg("shftTS99",is); /* 'is' contains error-message */

      is = W.close(); /* close output-file */
      if(is!=null) Lg.Err("shftTS99",is); /* print close-error */
      is = R.close(); /* close input-file */
      if(is!=null) Lg.Err("shftTS99",is); /* print close-error */
    } /* -shift_1- Break-Loop */

    Lg.Skip(true); /* Leerzeile hinzufuegen */
    Lg.Msg("shftTS30",z2); /* Abschlussmeldung */
    Lg.Msg("shftTS31",z1); /* Abschlussmeldung */
    Lg.Skip(true); /* Leerzeile hinzufuegen */
    is = (R!=null) ? ""+R.getStat(true) : "?";
    Lg.Msg("shftTS29",is); /* Abschlussmeldung */
    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Filter" (-9-)
  * Streckendefinition auf ungenutzte Definitionen filtern (filter)
  * Optionen:
  *       1 - World-Dateien als Kriterium benutzen (-w)
  *       2 - '.t'-Datei loeschen falls World-Datei fehlt (-c)
  *      16 - Extended output to LOG (-d,Hidden)
  *      17 - Dateien direkt ueberschreiben (-inplace,Hidden)
  * ##Filter (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int Filter( /* Strecke filtern */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute         cRte; /* aktuelle Routendefinition */
    TreeSet<TSQuad> QDf;  /* Alle Quadrat-Definitionen */
    TSTile          cTle; /* aktuelle Tile/World-Definition */
    TSQuad          cQDf; /* aktuelle Quadrat-Definition */
    File            dat,ddat; /* Dateidefinitionen */
    File[]          dir;  /* Dateiliste */
    int             i;    /* Arbeitswerte */
    String          is;
    boolean         OV;  /* TD-Verzeichnis ueberschreiben */
    boolean         tdl; /* LO_Tiles vorhanden */
    Iterator        cI;  /* allgemeiner Iterator fuer 'TreeSet' */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("Filter01",fn); /* Vorlauf ausgeben */

    OV = Fo.chkMsk(17); /* 'newRoute'-Directory benoetigt ? */
    /* Systemdatei lesen und auswerten */
    cRte = getRte(fn,OV?1:11); /* Streckendefinition auswerten */
    if(cRte==null) return 5; /* Fehler -- Ende */

    /* print current paths */
    Lg.Msg("MsgC01",cRte.getInfo(2)); /* print route-name */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* print system-path */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* print route-path */
    Lg.Skip(true); /* and add empty line */

    if(OV) { /* ueberschreiben der Dateien aktiv */
      if(!Fo.chkMsk(20)) askTerm(); /* ask user to REALLY overwrite */
      Lg.Log("MsgC41"); /* Warnung/Hinweis loggen */
      Lg.Skip(true); /* Leerzeile loggen */
    } /* Meldung erzeugen */

    /* globale "tsection.dat" bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC05"); /* Aktionsmeldung ausgeben */

    dat = cRte.getFile(-1); /* get reference to file */
    i = getTS(dat,null);    /* and load 'tsection.dat' (global) */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC08",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC11",c3); /* Ergebnis melden */
    Lg.Log("MsgC14",ScN); /* Ergebnis melden */
    Lg.Log("MsgC17",c2); /* Ergebnis melden */
    Lg.Log("MsgC20",ShN); /* Ergebnis melden */
    Lg.Log("MsgC23",c4); /* Ergebnis melden */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(cRte,ScA,ShA); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* zusaetzliche Streckendateien laden */
    i = getType(cRte); /* 'ttype.dat' laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strukturquadrate laden (genaue Ausfuehrung) */
    i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC26",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Strukturquadrate laden (LO-Tiles) */
    tdl = true; /* annehmen: Lo_Tiles sind vorhanden */
    i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
    if(i>0) { /* Fehler beim Laden der Strukturquadrate */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC27",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    if(i<0) tdl = false; /* nicht mehr versuchen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("Filter02"); /* Aktionsmeldung ausgeben */
    i = 0; /* Zaehler initialisieren */
    QDf = cRte.chgQDf(null); /* Speicher der Quadrate der Route */
    ddat = cRte.getFile(18); /* get current directory of data-files */
    cI = cRte.getIt(10); /* Iterator fuer Tile-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      /* alle Tile-Definitionen ueberpruefen */
      cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
      if(cTle.getNme(0)==null) { /* Tile-Definition nicht gueltig */
        /* marker says that '.t'-file is missing */
        if(OV) delTDF(cTle,ddat); /* delete remaining files if present */
        cI.remove(); /* Tile-Definition entfernen */
        for(cQDf=cTle.chgQDf(null);cQDf!=null;cQDf=cQDf.chgQDf(null))
          /* auch die zugeordneten Quadrate entfernen */
          if(QDf!=null) QDf.remove(cQDf); /* aus globalem Speicher */
        i += 1; /* augeketteten Tile zaehlen */
        continue; /* naechste Datei pruefen */
      } /* '.t'-file was NOT present */
      /* '.t'-file is present! However, continue check using world-file */
      if(Fo.chkMsk(1)) tl:{ /* World-Datei auch pruefen */
        for(cQDf=cTle.chgQDf(null);cQDf!=null;cQDf=cQDf.chgQDf(null)) {
          is = cQDf.getInf(2); /* Name der World-Datei (Quelle) */
          if(is!=null) break tl; /* min. eine Datei existiert */
        } /* alle moeglichen Dateien pruefen */
        /* keine World-Datei existiert -- Tile loeschen */
        cI.remove(); /* Tile-Definition entfernen */
        i += 1; /* augeketteten Tile zaehlen */
        for(cQDf=cTle.chgQDf(null);cQDf!=null;cQDf=cQDf.chgQDf(null))
          QDf.remove(cQDf); /* Quadrat aus globalem Speicher entfernen */
            /* auch die zugeordneten Quadrate entfernen */
        is = cTle.getNme(2); /* Name der Tile-Datei (Quelle) */
        if(is!=null && Fo.chkMsk(2)) { /* '.t'-Datei vorhanden -- loeschen */
          dat = new File(ddat,is); /* Dateiname '.t'-Datei erst. */
          if(dat.exists()) dat.delete(); /* loeschen wenn Dateiname gultig */
          else Lg.Err("Filter21",is); /* Fehler melden */
        } /* '.t'-Datei soll(te) geloescht werden */
        if(OV) delTDF(cTle,ddat); /* delete remaining files if present */
        continue; /* naechste Datei pruefen */
      } /* -tl- World-Datei musste auch geprueft werden */
    } /* -while- process all tile-definitions */
    Lg.Msg("Filter03",i); /* Ergebnis melden */

    if(tdl) { /* Lo-Tiles existieren */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("Filter04"); /* Aktionsmeldung ausgeben */
      i = 0; /* Zaehler initialisieren */
      ddat = cRte.getFile(19); /* get current directory of data-files */
      cI = cRte.getIt(11); /* Iterator fuer Tile-Definitionen */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        /* alle Tile-Definitionen ueberpruefen */
        cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
        if(cTle.getNme(0)==null) { /* Tile-Definition nicht gueltig */
          /* marker says that '.t'-file is missing */
          cI.remove(); /* Tile-Definition entfernen */
          i += 1; /* augeketteten Tile zaehlen */
          if(OV) delTDF(cTle,ddat); /* delete remaining files if present */
          continue; /* naechste Datei pruefen */
        } /* Quell-Datei ist nicht vorhanden */
      } /* alle Tile-Definitionen */
      Lg.Msg("Filter05",i); /* Ergebnis melden */
    } /* Lo-Tiles sind vorhanden */


    /* all files were loaded -- continue with integrity-check */
    if((is=cRte.chkRte(Fo,true))!=null) { /* check route for integrity -- error found ? */
      if(is.charAt(0)!=' ') { /* error-message returned */
        Lg.Skip(true); /* skip line */
        Lg.Err("getRte23",is); /* print errormessage */
        Lg.Msg("MsgC60"); /* print message: 'terminating' */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* error found -- function terminated */
      if(EnaW) Lg.Log("chkRte00",is); /* Warning found -- print it */
    } /* error/warning found */

    /* ***** ab hier beginnen die Ausgaben ***** */
    if(OV) { /* ueberschreiben der Dateien aktiv */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("Filter06"); /* Aktionsmeldung ausgeben */
      dat = cRte.getFile(4); /* get one ID-file ("..../TD/td_idx.dat") */
      if(dat==null) { /* Systemfehler beim 'Vorbereiten Zugriff' */
        Lg.Skip(true); /* Leerzeile Loggen */
        Lg.Msg("MsgC63",cRte.getInfo(4)); /* Abbruchmeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 7; /* terminate function with errorcode */
      } /* Systemfehler beim Vorbereiten Zugriff */
      dat = dat.getParentFile(); /* Verzeichnis fuer Dateien ("..../TD")*/
      dir = dat.listFiles(); /* alle Dateien des Verzeichnisses */
      if(dir==null) { /* Systemfehler beim 'Holen Dateien' */
        Lg.Skip(true); /* Leerzeile Loggen */
        Lg.Msg("MsgC52",dat.getPath()); /* Fehlermeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 7; /* terminate function with errorcode */
      } /* Systemfehler beim Vorbereiten Zugriff */
      for(i=0;i<dir.length;i+=1) { /* Alle definierten Dateien loeschen */
        if(dir[i].isDirectory()) /* Fehler: weiteres Verzeichnis */
          Lg.Err("Filter22",dir[i].getAbsolutePath()); /* Fehler melden */
        else dir[i].delete(); /* Datei loeschen */
      } /* Alle Dateien loeschen */
    } /* ueberschreiben der Dateien aktiv */

    /* Terrain-Datei(en) bearbeiten */
    dat = cRte.getFile(OV?4:34); /* Ausgabedatei mit Pfad holen */
    i = putTDF(cRte,dat,0); /* Terrain-Datei (HI) erzeugen */
    if(i>0) return i; /* Fehler beim Schreiben */

    if(tdl) { /* Lo-Tiles existieren */
      dat = cRte.getFile(OV?5:35); /* Ausgabedatei mit Pfad holen */
      i = putTDF(cRte,dat,1); /* Terrain-Datei (LO) erzeugen */
      if(i>0) return i; /* Fehler beim Schreiben */
    } /* Lo-Tiles sind vorhanden */

    if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("Filter11"); /* Ergebnis melden */
    Lg.Msg("Filter12",ShA); /* Ergebnis melden */
    Lg.Msg("Filter13",ScA); /* Ergebnis melden */
    Lg.Msg("Filter14",cRte.get$Sh(true)); /* Ergebnis melden */
    Lg.Msg("Filter15",cRte.get$Sc(true)); /* Ergebnis melden */

    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "defTDF"
  * Delete TDF-files if still present.
  * This method iscalled from 'Filter()'
  * ##delTDF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String delTDF( /* delete files if present */
   TSTile cT, /* current Tile where files are referenced */
   File   cD) /* current directory as basis of all files */
   {
   /*-----------------------------------------------------------------*/
    File dat;  /* file-definition of file to be deleted */
   /*=================================================================*/
    dat = new File(cD,cT.getNme(-2)); /* create ref. to '.t'-file */
    if(dat.exists()) dat.delete(); /* delete it, if file exits */
    dat = new File(cD,cT.getNme(-4)); /* create ref. to '_y.raw'-file */
    if(dat.exists()) dat.delete(); /* delete it, if file exits */
    dat = new File(cD,cT.getNme(-6)); /* create ref. to '_f.raw'-file */
    if(dat.exists()) dat.delete(); /* delete it, if file exits */
    dat = new File(cD,cT.getNme(-8)); /* create ref. to '_e.raw'-file */
    if(dat.exists()) dat.delete(); /* delete it, if file exits */
    dat = new File(cD,cT.getNme(-10)); /* create ref. to '_n.raw'-file */
    if(dat.exists()) dat.delete(); /* delete it, if file exits */
    dat = new File(cD,cT.getNme(-12)); /* create ref. to '_c.raw'-file */
    if(dat.exists()) dat.delete(); /* delete it, if file exits */
    dat = new File(cD,cT.getNme(-14)); /* create ref. to '_d.raw'-file */
    if(dat.exists()) dat.delete(); /* delete it, if file exits */
    return null; /* return with marker: no error found */
 }

 /**. <pre>
  *=====================================================================
  * Methode "CompW" (-10-)
  * World - Dateien komprimieren (extended Version)
  * ##CompW (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int CompW( /* World - Dateien dekomprimieren */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute           cRte; /* aktuelle Streckendefinition (Basis) */
    int               i,ix; /* Arbeitswerte */
    String            is,bef;
    String[]          fl;   /* File-Liste */
    File              dat,dir;
    FileInputStream   S;    /* binary Reader */
    byte[]            ibuf;
    InputStreamReader R;    /* Unicode-Reader */
    char[]            ichr;
   /*=================================================================*/
    ibuf = new byte[8]; /* Puffer fuer Vergleich */
    ichr = new char[8]; /* Puffer fuer Vergleich */

    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("CmpW01",fn); /* Vorlauf ausgeben */

    /* Systemdatei lesen und auswerten */
    cRte = getRte(fn,3); /* Streckendefinition auswerten */
    if(cRte==null) return 5; /* Fehler -- Ende */

    /* print current paths */
    Lg.Msg("MsgC01",cRte.getInfo(2)); /* print route-name */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* print system-path */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* print route-path */
    Lg.Skip(true); /* and add empty line */

    /* Pfad zu den Utilities holen */
    dat = cRte.getFile(0,"utils/Comp/Comp.exe"); /* Utility */
    if(!dat.exists()) { /* Datei existiert nicht */
      Lg.Msg("MsgC43",dat.getAbsolutePath()); /* Abbruchmeldung */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Utility-Datei nicht gefunden */
    bef = dat.getAbsolutePath(); /* Name fuer Befehlsaufruf */
    dir = cRte.getFile(0,"utils/ffedit"); /* Utility-Pfad holen */
    dat = new File(dir,"ffeditc_unicode.exe"); /* Utility holen */
    if(!dat.exists()) { /* Datei existiert nicht */
      Lg.Msg("MsgC43",dat.getAbsolutePath()); /* Abbruchmeldung */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Utility-Datei nicht gefunden */

    /* Liste der "world"-Dateien erstellen */
    dat = cRte.getFile(10); /* File-Referenz fuer Verzeichnis */
    is = dat.getAbsolutePath(); /* vollstaendiger Name */
    if(!dat.exists()) { /* Referenz nicht vorhanden */
      Lg.Msg("CmpW08",is); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datei existiert nicht */
    fl = dat.list(); /* alle Dateien auflisten */
    if(fl==null) { /* Source-ist kein Verzeichnis */
      Lg.Msg("MsgC51",is); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Dateiliste konnte nicht erstellt werden */

    c0 = c1 = c2 = 0;
    for(ix=0;ix<fl.length;ix+=1) { /* alle Dateidefinitionen */
      is = fl[ix]; /* einfache Addressierung */
      if(!is.toLowerCase().endsWith(".w")) continue;
        /* Datei ist keine World-Datei */
      dat = cRte.getFile(10,is); /* vollstaendige Referenz */
      if(dat.isDirectory()) continue; /* nur Dateien beachten */
      c0 += 1; /* Satz zaehlen */
      fn = dat.getAbsolutePath(); /* Gesamtname erstellen */
      Lg.Log("MsgC53",fn,DF4.format(c0),0); /* Meldung ausgeben */

      try { S = new FileInputStream(dat); /* ASCII lesen */
      } catch (FileNotFoundException E) { /* Datei nicht gefunden */
        System.err.println(E.toString());
        Lg.Skip(false); /* Leerzeile Loggen */
        Lg.Msg("CmpW09"); /* Fehlermeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 25; /* terminate function with errorcode */
      } /* Exception bei OPEN */
      try {i = S.read(ibuf); /* erste Datenzeile lesen */
      } catch (IOException e) { /* Lese-Fehler erster Satz */
       System.err.println(e.toString());  return 20;}
      try { S.close(); /* Binaerdatei schliessen */
      } catch (IOException e) { System.err.println(e.toString()); }
      is = new String(ibuf); /* in String umwandeln */
      if(is.substring(0,7).equals("SIMISA@")) { /* kein Unsinn -> Binaerdatei */
        if(!is.equals("SIMISA@@")) continue; /* schon komprimiert -- weiter */
        /* UB-Form komprimieren */
        c1 += 1; /* Konvertierung zaehlen */
        /* UB-Dateien werden durch Comp-Programm nicht veraendert!!
         * ==> zuerst nach UT-Form wandeln */
        is = tx1+fn+tx2+fn+"\""; /* Befehl erstellen */
        Lg.Log("CmpW02",is); /* Konvertierungsmeldung */
        if((i=exec(true,is,dir,Lg))>0) { /* Fehler bei Ausfuehrung */
          Lg.Log("MsgC55",i); /* Fehlermeldung ausgeben */
          c2 += 1; /* Fehler zaehlen */
          continue; /* mit naechster Zeile fortfahren */
        } /* Konvertierung fehLgeschlagen */
        /* und dannach komprimieren */
        is = bef+" /w \""+fn+"\" \""+fn+"\" "; /* Befehl erstellen */
        Lg.Log("CmpW03",is); /* Konvertierungsmeldung */
        if((i=exec(false,is,null,Lg))>0) { /* Fehler bei Ausfuehrung */
          Lg.Log("MsgC55",i); /* Fehlermeldung ausgeben */
          c2 += 1; /* Fehler zaehlen */
        } /* Konvertierung fehLgeschlagen */
        continue; /* mit naechster Zeile fortfahren */
      } /* Binaerdatei gefunden */
      /* jetzt liegt auf jeden Fall eine Text-Datei vor */
      try { R = new InputStreamReader( /* unicode lesen */
                new FileInputStream(dat),"UTF-16");
      } catch (FileNotFoundException e) { /* Datei nicht gefunden */
         System.err.println(e.toString());  return 5;}
        catch (UnsupportedEncodingException e) {
         System.err.println(e.toString());  return 5;}
      try {i = R.read(ichr,0,8); /* Datenzeichen lesen */
      } catch (IOException e) { /* Lese-Fehler erhalten */
        System.err.println(e.toString());
        return 25;
      } /* Fehler gefunden */
      try { R.close(); /* Unicode-Datei wieder schliessen */
      } catch (IOException e) { System.err.println(e.toString()); }
      is = new String(ichr); /* in String umwandeln */
      if(!is.equals("SIMISA@@")) continue; /* schon komprimiert -- weiter */
        /* KT-Dateien werden durch Comp-Programm nicht veraendert!! */
      /* UT-Form komprimieren */
      c1 += 1; /* Konvertierung zaehlen */
      is = bef+" /w \""+fn+"\" \""+fn+"\" "; /* Befehl erstellen */
      Lg.Log("CmpW04",is); /* Konvertierungsmeldung */
      if((i=exec(false,is,null,Lg))>0) { /* Fehler bei Ausfuehrung */
        Lg.Log("MsgC55",i); /* Fehlermeldung ausgeben */
        c2 += 1; /* Fehler zaehlen */
      } /* Konvertierung fehLgeschlagen */
    } /* alle Dateidefinitionen bearbeiten */

    Lg.Skip(true); /* Leerzeile Loggen */
    Lg.Log("CmpW05",DF4.format(c1)); /* Abschlussmeldung */
    Lg.Msg("CmpW06",DF4.format(c2)); /* Abschlussmeldung */
    Lg.Msg("CmpW07",c0); /* Abschlussmeldung */
    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "cvrtTS" (-11-)
  * Alle Strecken der TS-Instanz konvertieren
  * Optionen: (belegt wie bei 'cvrt')
  *       2 - Shape-Namen auf Existenz testen
  *       4 - World-Dateien NICHT komprimieren
  * ##cvrtTS (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int cvrtTS() /* TS-Instanz anpassen */
   {
   /*-----------------------------------------------------------------*/
    int     rc,rcM; /* aktueller Return-Code */
    int     StA; /* Anzahl der Streckendefinitionen */
    int     i;   /* intermediate value */
    String  is;
    File    dir0,dir1,dir2,dir3;
    File    StD[]; /* Streckendefinitionen */
   /*=================================================================*/
    Lg.Open(false); /* Log-Datei oeffnen falls moeglich */
    prStart("cvrtTS01",fn); /* Vorlauf ausgeben */

    dir0 = new File(fn); /* Directoryobjekt erstellen */
    fn = dir0.getAbsolutePath(); /* Gesamtname erstellen */
    dir0 = new File(fn); /* Directoryobjekt neu erstellen */
    if(!dir0.exists()) { /* Pfad existiert nicht */
      Lg.Msg("cvrtTS02",fn); /* Fehlermeldung */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    if(!dir0.isDirectory()) { /* kein Directory spezifiziert */
      Lg.Msg("cvrtTS03",fn); /* Fehlermeldung */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    dir1 = new File(dir0,"global/tsection.dat"); /* Steuerdatei */
    if(!dir1.exists()) { /* Datei existiert nicht */
      Lg.Msg("cvrtTS04",fn,dir1.getAbsolutePath()); /* Abbruchmeldung */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    dir1 = new File(dir0,"train.exe"); /* Steuerdatei */
    if(!dir1.exists()) { /* Datei existiert nicht */
      Lg.Msg("cvrtTS05",fn); /* Fehlermeldung */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    dir1 = new File(dir0,"Routes"); /* Streckenverzeichnis */
    if(!dir1.exists()) { /* Datei existiert nicht */
      Lg.Msg("cvrtTS06",fn); /* Fehlermeldung */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    fn = dir1.getAbsolutePath(); /* Gesamtname erstellen */
    if(!dir1.isDirectory()) { /* kein Directory spezifiziert */
      Lg.Msg("cvrtTS07",fn); /* Fehlermeldung */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    dir2 = new File(dir1,"tsection.dat"); /* Steuerdatei */
    if(!dir2.exists()) { /* Datei existiert nicht */
      Lg.Msg("cvrtTS08",fn); /* Fehlermeldung */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Pfade ausgeben */
    Lg.Msg("MsgC02",dir0.getPath()); /* Fehler */
    Lg.Skip(true); /* Leerzeile Loggen */

    StD = dir1.listFiles(); /* alle File-Definitionen holen */
    StA = 0; /* noch keine gueltige Streckendefinition */
    for(i=0;i<StD.length;i+=1) { /* alle Eintraege bearbeiten */
      if(!StD[i].isDirectory()) continue; /* kein Verz. -- keine Strecke */
      is = StD[i].getName(); /* Name der Strecke extrahieren */
      dir3 = new File(StD[i],is+".trk"); /* Dateiname erstellen */
      if(!dir3.exists()) continue; /* keine Datei -- keine Strecke */
      StD[StA] = StD[i]; /* Streckendefinition registrieren */
      StA += 1;          /* und zaehlen */
      Lg.Msg("cvrtTS10",StD[i].getPath()); /* Meldung: Strecke registriert */
    } /* alle Streckendefinitionen suchen */

    Lg.Skip(true); /* Leerzeile Loggen */
    Lg.Msg("cvrtTS11"); /* Meldung zum optischen Trennen */
    Lg.Skip(true); /* Leerzeile Loggen */
    if(StA==0) Lg.Msg("cvrtTS12"); /* Keine Strecken zur Konvertierung */
    else Lg.Msg("cvrtTS13"); /* Zwischenmeldung ausgeben */
    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */

    /* alle Strecken nacheinander konvertieren */
    rcM = 0; /* Gesamt-Return-Code vorbesetzen */
//    Fo.orMsk(0x00020002); /* Umwandlungsoptionen setzen (Standard: -r, -inplace)
    Fo.setMsk(17); /* Umwandlungsoption '-inplace' setzen */
    Fo.setMsk(1); /* Umwandlungsoption '-r' setzen
                   * Optionen -s,-u werden ggf. beachtet */
    for(i=0;i<StA;i+=1) { /* alle definierten Strecken bearbeiten */
      System.out.println(); /* Zeilenabstand erzeugen */
      fn = is = StD[i].getAbsolutePath(); /* Name zur Strecke erstellen */
      pFle = dir2; /* 'tsection.dat'(global)-Referenz setzen (default) */
      dir3 = new File(StD[i],"$tsection.dat"); /* Dateiname erstellen */
      if(dir3.exists()) pFle = dir3.getAbsoluteFile(); /* alternative 'tsection' */
      rc = horace(true); /* Strecke umwandeln */
      rcM = Math.max(rcM,rc); /* Gesamt-Return-Code anpassen */
    } /* alle Streckendefinitionen bearbeiten */
    return rcM; /* Funktion beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkInteg" (-12-)
  * Integritaet einer Streckendefinition pruefen (ichk)
  * Optionen:
  *       2 - Shape-Namen auf Existenz testen (-s)
  *       3 - ALLE benutzten Shape-Namen auf Existenz testen (-S)
  *       5 - Korrektur-Modus fuer World-Dateien benutzen (-k)
  *       6 - Extended analysis for 'Hidewire'-objects within Static-Def's (-z)
  *       7 - Extended analysis for 'Modifications' within Tracks (-z)
  *      16 - Extended output to LOG (-d,Hidden)
  *      18 - Strukturdatendatei reparieren falls notwendig (-tdrepair,Hidden)
  * ##chkInteg (Eyecatcher)
  * ##ichk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chkInteg( /* Streckenintegritaet pruefen */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute   cRte; /* aktuelle Routendefinition */
    TSQuad    cQDf; /* aktuelle Quadrat-Definition */
    TSUiD     cUiD,xUiD; /* UiD-Arbeitswert */
    TSSh      cSh;  /* current shape- / path-reference */
    File      dir,dat,dirx; /* file-definitions */
    File[]    sdl;  /* list of sub-directories (files) */
    int       i,j,c; /* Arbeitswerte */
    String    is,js; /* intermediate values */
    TSNameSet SNme,TNme; /* Shape-,Texture-Names for existence-chk */
    Iterator  cI;   /* allgemeiner Iterator */
    TSTexture cT;   /* current texture-file */
    double    d;    /* distance between nodes */
    TSQPos    cPos,xPos; /* Position of current 'TrJunction'-Node */
    TSVector  cNde; /* current 'TrJunction'-Node */
    ArrayList<TSVector> NdeT; /* current list of 'TrJunction'-Nodes */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("chkInt01",fn); /* Vorlauf ausgeben */

    /* Systemdatei lesen und auswerten */
    cRte = getRte(fn,1); /* Streckendefinition auswerten */
    if(cRte==null) return 5; /* Fehler -- Ende */

    /* Pfade ausgeben */
    is = cRte.getInfo(2); /* vorbesetzen wegen Performance */
    Lg.Msg("MsgC01",is); /* aktuelle Werte */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* aktuelle Werte */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* aktuelle Werte */
    Lg.Skip(true); /* Leerzeile loggen */

    /* globale "tsection.dat" bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC05"); /* Aktionsmeldung ausgeben */

    dat = cRte.getFile(-1); /* Steuerdatei holen */
    i = getTS(dat,Fo.chkMsk(2)?cRte.getFile(-2):null);
      /* 'tsection.dat' (global) laden */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC08",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC11",c3); /* Ergebnis melden */
    Lg.Log("MsgC14",ScN); /* Ergebnis melden */
    Lg.Log("MsgC17",c2); /* Ergebnis melden */
    Lg.Log("MsgC20",ShN); /* Ergebnis melden */
    Lg.Log("MsgC23",c4); /* Ergebnis melden */

    /* initialize list for shape-names if requested */
    SNme = null; /* do not check Shape-Names */
    if(Fo.chkMsk(3)) SNme = new TSNameSet(); /* Pruefen -- Liste init. */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(cRte,ScA,ShA); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Marker-Datei (falls vorhanden) syntaktisch pruefen */
    i = getMF(cRte); /* Marker-Datei ueberpruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Referenz der Streckendefinition pruefen */
    i = getRF(cRte,SNme); /* Ref-Datei ueberpruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* zusaetzliche Streckendateien laden */
    i = getType(cRte); /* load 'ttype.dat' */
    if(i>0) return i; /* error occurred -- terminate function */

    i = getSpp(cRte,SNme); /* load 'Speedpost.dat' */
    if(i>0) return i; /* error occurred -- terminate function */

    /* Strukturquadrate laden (genaue Ausfuehrung) */
    i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    if(i<0 && Fo.chkMsk(18)) { /* Steuerdatei wurde NICHT gefunden */
      i = creTDCtl(cRte,false); /* Steuerdatei erzeugen */
      if(i!=0) { /* Fehler beim Erzeugen der Steuerdatei (Hi) */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("MsgC69",i); /* Abbruchmeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 15; /* terminate function with errorcode */
      } /* Fehler aufgetreten */
      i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    } /* Steuerdatei erzeugen und neuer Versuch */
    if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC26",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Strukturquadrate laden (LO-Tiles) */
    i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
    if(i<0 && Fo.chkMsk(18)) { /* Steuerdatei wurde NICHT gefunden */
      i = creTDCtl(cRte,true); /* Steuerdatei erzeugen */
      if(i>0) { /* Fehler beim Erzeugen der Steuerdatei (Lo) */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("MsgC69",i); /* Abbruchmeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 15; /* terminate function with errorcode */
      } /* Fehler aufgetreten */
      if(i==0) i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
    } /* Steuerdatei erzeugen und neuer Versuch */
    if(i>0) { /* Fehler beim Laden der Strukturquadrate */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC27",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Schienendatenbank laden */
    i = getDBF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    i = getITF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strassendatenbank laden */
    i = getDBF(cRte,1); /* Strassendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    if(i==0) { /* Datenbank ist vorhanden */
      i = getITF(cRte,1); /* Strassendatenbank laden und pruefen */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* Datenbank(teil) ist vorhanden */

    /* World-Dateien laden und syntaktisch pruefen */
    i = getWF(cRte,Fo.chkMsk(5)); /* World-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */
    /* Sound-Dateien laden und syntaktisch pruefen */
    i = getSF(cRte,Fo.chkMsk(5)); /* World-Sound-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */

    /* Signal-Definitionen laden und ueberpruefen */
    i = getSCfg(cRte,cRte.getFile(21),SNme,true); /* load Signal-Configurations */
    if(i==0) /* Laden erfolgreich -- weiter testen */
      i = getSScr(cRte,cRte); /* Signal-Script-Definitionen laden */

    /* Path-Definitionen werden geladen und ueberprueft */
    i = getPatF(cRte,true); /* Path-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Service-Definitionen werden geladen und ueberprueft */
    i = getSrvF(cRte,true); /* Service-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Traffic-Definitionen werden geladen und ueberprueft */
    i = getTrfF(cRte,true); /* Traffic-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Activity-Definitionen werden geladen und ueberprueft */
    i = getActF(cRte,true); /* Activity-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Hidewire-Bearbeitung falls gefordert */
    if(Fo.chkMsk(6)) /* zusaetzliche Hidewire-Bearbeitung gefordert */
      i = rcvWrld(cRte,Fo); /* statische Repraesentationen aufloesen */


    /* all files were loaded -- continue with integrity-check */
    if((is=cRte.chkRte(Fo,true))!=null) { /* check route for integrity -- error found ? */
      if(is.charAt(0)!=' ') { /* error-message returned */
        Lg.Skip(true); /* skip line */
        Lg.Err("getRte23",is); /* print errormessage */
        Lg.Msg("MsgC60"); /* print message: 'terminating' */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* error found -- function terminated */
      if(EnaW) Lg.Log("chkRte00",is); /* Warning found -- print it */
    } /* error/warning found */

    /* check "world"-files and try to create fully integrity */
    i = 4; /* DO NOT modify I/O-mode (IO_app=4 is marker) */
    if(Fo.chkMsk(7)) i += 256; /* Register option 'recover track-objects' */
    chkWrld(cRte,SNme,i); /* extended check of current World-files */
      /* Mode: do not report changes, do not use 'renum' */

    /* Sound-Dateien bearbeiten und neue Integritaet herstellen */
    i = chkSnd(cRte,SNme,0); /* Sound-Dateien erweitert pruefen */
      /* Modus: keine Aenderungen melden */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("MsgC33",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC70"); /* Aktionsmeldung ausgeben */
    if(cRte.get$TrN(0)<=0) { /* Schienendatenbank NICHT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC36"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datenbank nicht vorhanden */

    i = chkDBTab(cRte,0); /* Schienendatenbank bearbeiten */
    if(i<0) return 5; /* Systemfehler -- Ende */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC71"); /* Aktionsmeldung ausgeben */
    Lg.Msg("MsgC38",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC72"); /* Aktionsmeldung ausgeben */

      i = chkDBTab(cRte,1); /* Strassendatenbank bearbeiten */
      if(i<0) return 5; /* Systemfehler -- Ende */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("MsgC73"); /* Aktionsmeldung ausgeben */
      Lg.Msg("MsgC38",i); /* Ergebnis melden */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Strassendatenbank vorhanden und geladen */

    /* extended check of local 'tsection.dat'
     * Attention: This method MUST NOT be invoked unless worldfiles AND
     * database (track/road) is stored again (or neither). */
    chkTSL(cRte,ScN,ShN); /* check file and compact it */

    i = chkPat(cRte); /* Pfad-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkSrv(cRte,false); /* Service-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkCon(cRte); /* Consist-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkTrf(cRte,false,true); /* Traffic-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkAct(cRte,false); /* process activity-definitions (integrity-check) */
    if(i>0) return 5; /* systemerror occurred -- terminate */


    /* check if distances between nodes are sufficient */
    Lg.Skip(true); /* print/display empty line */
    Lg.Msg("chkInt41",""+TSUtil.dDist); /* print message for next action */
    c = 0; /* initialize counter */
    NdeT = cRte.getNdeT(0); /* get table of 'TrJunction'-Nodes */
    for(i=0;i<NdeT.size();i+=1) { /* check all 'TrJunction'-Nodes */
      cNde = NdeT.get(i); /* get current node from list */
      cPos = cNde.crPos(); /* get position of current node */
      if((cUiD=cNde.chgUid(null))==null) is = cPos.getPos(0);
        else is = cUiD.getMsg(4); /* get NodeID from UID-definition */
      for(j=i+1;j<NdeT.size();j+=1) { /* compare to all other nodes */
        cNde = NdeT.get(j); /* get second node from list */
        if((d=cPos.cmpAbs(cNde.crPos()))<TSUtil.dDist) { /* distance too small */
          if((cUiD=cNde.chgUid(null))==null) js = cNde.crPos().getPos(0);
            else js = cUiD.getMsg(4); /* get NodeID from UID-definition */
          Lg.Log("chkInt42",is,js,""+TSUtil.round(d,3));
          c += 1; /* print message and count warning */
        } /* warning condition found */
      } /* compare to all other nodes */
    } /* check all nodes */
    Lg.Skip(false); /* print/display empty line */
    Lg.Log("chkInt43",c); /* print summary */
    Lg.Skip(false); /* print/display empty line */

    /* nicht-referenzierte Track-Objekte melden */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("chkInt23"); /* Aktionsmeldung ausgeben */
    i = j = 0; /* Zaehler initialisieren */
    cI = cRte.getIt(12); /* Iterator fuer Quadrat-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      /* alle Quadrat-Definitionen bearbeiten */
      cQDf = (TSQuad)cI.next(); /* naechste Quadrat-Definition */
      js = cQDf.getInf(0) + " "; /* Quadrantenkennung extrahieren */
      for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
        if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
        if(cUiD.isCtl()) continue; /* kein aktiver UiD-Eintrag */
        if(cUiD.isTrack()) { /* Track-Definition liegt vor -- genutzt? */
          cSh = cUiD.chgShR(null); /* get current shape-reference */
          if((is=cUiD.chkRCnt(cSh))!=null) /* reference missing -- print error */
            Lg.Err(cUiD.isRoad()?"chkInt22":"chkInt21",is,js+cUiD.getUiD(0));
          if(cUiD.incCntC(0)<1) { /* Element nicht referenziert */
            if(cUiD.isRoad()) { /* Strassendefinition liegt vor -- genutzt? */
              if(EnaH) Lg.Log("chkInt25",js+cUiD.getUiD(0)); /* Hinweis */
              j += 1; /* registrieren */
            } else {  /* Track-Definition ist Schiene */
              if(EnaH) Lg.Log("chkInt24",js+cUiD.getUiD(0)); /* Hinweis */
              i += 1; /* registrieren */
            } /* Meldung gemaess Elementtyp */
          } /* Track-Element nicht genutzt */
        } /* object is track */
      } /* alle UiD's pruefen */
    } /* alle Tile-Definitionen bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("chkInt26",i); /* Ergebnis ausgeben */
    Lg.Log("chkInt27",j); /* Ergebnis ausgeben */
    Lg.Skip(false); /* Leerzeile loggen */

    /* Pruefen, ob alle genutzten Shape-Objekte vorhanden sind */
    if(SNme!=null) { /* nur wenn Pruefung gefordert */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("chkInt31",SNme.size()); /* Aktionsmeldung ausgeben */
      i = j = 0; /* initialize counters */
      TNme = new TSNameSet(); /* initialize list of textures */
      dirx = cRte.getFile(-2); /* get source-folder of global shapes */
      dir = cRte.getFile(15); /* get source-folder of shape-definitions */
      cI = SNme.keyIterator(false); /* get iterator for all shape-keys in list */
      while(cI.hasNext()) { /* more filenames present ? */
        is = (String)cI.next(); /* yes -- get name of next shape-file */
        if(is.endsWith(".ace")) { /* Texture-file found -- process it */
          TNme.add(SNme.get(is)); /* add file to list of textures */
          continue; /* file is fully processed */
        } /* Texture-file found */
        if(!is.endsWith(".s")) continue; /* no shape-file -- do not process */
        fn = SNme.get(is); /* get correct notation of name */
        dat = new File(dir,fn); /* create full name of shape-file (source) */
 if(PrMsk.chkMsk(31)) Lg.Log("chkInt91",dat.getAbsolutePath()); // ##!D
        if(!dat.exists()) nfs:{ /* source-file cannot be found */
          dat = new File(dirx,fn); /* create full name of shape-file (source) */
 if(PrMsk.chkMsk(31)) Lg.Log("chkInt92",dat.getAbsolutePath()); // ##!D
          if(dat.exists()) break nfs; /* source-file found -- process it */
          Lg.Log("chkInt32",fn); /* print message: file not found */
          i += 1; /* and count error */
          continue; /* process next file */
        } /* -nfs- shape-file(source) was NOT found */
        if((is=chkShape(dat,TNme))!=null) /* extract image (.ace) */
          Lg.Err("chkInt36",dat.getPath(),is); /* Fehlermeldung */
      } /* process all shape-files */
      SNme.clear(); /* entries are no longer needed */
      dir = cRte.getFile(17); /* get source-definitions for textures */
      sdl = dir.listFiles((FileFilter)(new TSFleMask())); /* get all sub-directories */
      dirx = cRte.getFile(-3); /* get source-folder of global textures */
      cI = TNme.keyIterator(false); /* check all entries of the list */
      while(cI.hasNext()) { /* more entries available ? */
        is = (String)cI.next(); /* get name of next texture-file */
 if(PrMsk.chkMsk(31)) Lg.Log("chkInt93",is); // ##!D
        if(!is.endsWith(".ace")) continue; /* no texture-file -- continue */
        fn = TNme.get(is); /* get correct notation of name */
        dat = new File(dir,fn); /* Dateidefinition der Texturdatei */
 if(PrMsk.chkMsk(31)) Lg.Log("chkInt93",dat.getAbsolutePath()); // ##!D
        if(!dat.exists()) nft:{ /* source-file cannot be found */
          dat = new File(dirx,fn); /* create full name of texture-file (source) */
 if(PrMsk.chkMsk(31)) Lg.Log("chkInt94",dat.getAbsolutePath()); // ##!D
          fn = null; /* set marker: global texture */
          if(dat.exists()) break nft; /* source-file found -- process it */
          Lg.Log("chkInt33",dat.getName()); /* print message: file not found */
          j += 1; /* and count error */
          continue; /* process next file */
        } /* -nft- shape-file(source) was NOT found */
        cT = new TSTexture(dat,TSTexture.IN); /* get handle, open file and read ID */
        if((is=cT.getErr())!=null) { /* File cound not be successfully opened. */
          Lg.Err("chkInt37",dat.getPath(),is); /* print message */
          j += 1; /* and count error */
          continue; /* file-reference is fully processed */
        } /* open-error -- continue with next file */
 if(PrMsk.chkMsk(31)) Lg.Log("chkInt95",dat.getAbsolutePath(),cT.toStr()); // ##!D
        is = cT.close(); /* close texture-file again */
        if(is!=null) Lg.Log("chkInt37",dat.getPath(),is); /* print message */
        if(fn==null ) continue; /* global texture -- do not check sub-dirs */
        /* check other versions of the texture, too (snow,...)
         * Attn: current filename is stored in 'dat' */
        for(File cd : sdl) { /* also check all other versions */
          dat = new File(cd,fn); /* create next pathname of the texture-file */
          if(!dat.exists()) continue; /* Texture-file missing -- do not report */
          cT = new TSTexture(dat,TSTexture.IN); /* get handle, open file and read ID */
          if((is=cT.getErr())!=null) { /* File cound not be successfully opened. */
            Lg.Err("chkInt37",dat.getPath(),is); /* print message */
            j += 1; /* and count error */
            continue; /* file-reference is fully processed */
          } /* open-error -- continue with next file */
 if(PrMsk.chkMsk(31)) Lg.Log("chkInt95",dat.getAbsolutePath(),cT.toStr()); // ##!D
          is = cT.close(); /* close texture-file again */
          if(is!=null) Lg.Log("chkInt37",dat.getPath(),is); /* print message */
        } /* check all other versions */
      } /* -while- process all texture-files */
      TNme.clear(); /* texture-entries are no longer used */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Log("chkInt34",i); /* Ergebnis ausgeben */
      Lg.Log("chkInt35",j); /* Ergebnis ausgeben */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Ausgabe ist gefordert */

    if(Fo.chkMsk(24)) putObj(cRte); /* Objektsicherung erstellen */
    if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("chkInt11"); /* Ergebnis melden */
    Lg.Msg("chkInt12",ShA); /* Ergebnis melden */
    Lg.Msg("chkInt13",ScA); /* Ergebnis melden */
    Lg.Msg("chkInt14",cRte.get$Sh(true)); /* Ergebnis melden */
    Lg.Msg("chkInt15",cRte.get$Sc(true)); /* Ergebnis melden */

    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
 }

 /**. <pre>
  *=====================================================================
  * Method "chkShape"
  * Extract image-names of shape-definitions and store them
  * Attention: directories are NOT supported
  * Method is referenced from 'Merge', 'clearDB' and 'chkInteg'.
  * ##chkShape (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String chkShape( /* check file and extract image */
   File      dat, /* input-file of shape-definition */
   TSNameSet Lst) /* Texture-list for image-names */
   {
   /*-----------------------------------------------------------------*/
    TSFileS cR; /* current file-definitions */
    TSBuf   cB; /* current input-buffer for 'read file' */
    String  is; /* temporary string-value(s) */
   /*=================================================================*/
    cR = new TSFileS(dat); /* create access to input-file */
    if((is=cR.open(TSFile.IN))!=null) return is; /* open-error */

    cB = new TSBuf(cR,null); /* create input-buffer (read only) */
    cl: { /* read-loop (Break-Block) */
      while(!cB.getNext(false)) { /* get all records (read only) */
        is = cB.getKE(true); /* get first keyword-expression of line */
        if(is==null) continue; /* keyword not found, error may occur */
        if(!is.equals("image")) continue; /* REQUESTED keyword NOT found */
        is = cB.getVal(21); /* get (unchanged) file-name */
        if(cB.getErr()!=null) { /* error while evaluating */
          is = TSLogg.getMsg("chkShF1",dat.getPath(),cB.getErr());
          break cl; /* terminate copy of file */
        } /* error while evaluating -- terminate copy of file */
        Lst.add(is); /* file-name is valid -- insert it */
      } /* -while- copy all lines and process them */
      is = cB.getErr(); /* error while reading?  */
    } /* -cl- Break-Block used for terminating read */

    cR.close(); /* close input again */
    return is; /* file processed (without error) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkFile"
  * Open file with 'TSFileX' and extract value due to keyword
  * Method is referenced from 'Merge' exclusively
  * ##chkFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String chkFile( /* Datei pruefen */
   File      dat, /* inputfile */
   int       typ, /* type of inputfile */
   String    kwd, /* Keyword of value */
   TSNameSet Lst) /* List for addind extracted values */
   {
   /*-----------------------------------------------------------------*/
    TSFileX cF; /* current file-definition */
    TSBuf   cB; /* current input-buffer for 'read file' */
    String  is; /* data-line */
   /*=================================================================*/
    cF = new TSFileX(typ,dat); /* create access to input-file */
    if((is=cF.open(false))!=null) return is; /* open-error */

    cB = new TSBuf(cF,null); /* create input-buffer (read only) */
    cl: { /* read-loop (Break-Block) */
      while(!cB.getNext(false)) { /* copy all records (read) */
        while(cB.advPtr(kwd)) { /* keyword found within current line */
          is = cB.getKE(true); /* get keyword-expression of line */
          if(is==null) { /* no data available */
            is = cB.getErr(); /* get errormessage (from TSFileX) */
            if(is==null) is = TSLogg.getMsg("chkFile1",kwd); /* EOF reached */
            else is = TSLogg.getMsg("chkFile2",is); /* create message */
            break cl; /* terminate copy of file */
          } /* data was not available */
          if(!is.equals(kwd)) { /* requested keyword NOT found */
            is = TSLogg.getMsg("chkFile3",is,kwd); /* create message */
            break cl; /* terminate copy of file */
          } /* requested keyword NOT found -- terminate copy of file */
          is = cB.getVal(1); /* get file-name */
          if(cB.getErr()!=null) { /* error while evaluating */
            is = TSLogg.getMsg("chkFile4",dat.getAbsolutePath(),kwd,cB.getErr());
            break cl; /* terminate copy of file */
          } /* error while evaluating -- terminate copy of file */
          Lst.add(is); /* file-name is valid -- insert it */
        } /* keyword found within current line */
      } /* -while- copy all lines and process them */
      is = cB.getErr(); /* error while reading?  */
    } /* -cl- Break-Block used for terminating read */

    cF.close(); /* close input again */
    return is; /* file processed (without error) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "renDB" (-13-)
  * Datenbank neu nummerieren nach loeschen von Elementen
  * Individuelle Optionskennungen (wenn aktiv):
  *    1 - Datenbank auch bei Fehler neu erstellen (w)
  *    2 - nicht referenzierte TrItems loeschen (a)
  *    3 - World-Dateien auf JEDEN Fall komprimieren (c)
  *    4 - World-Dateien NICHT komprimieren (u)
  *    5 - NUR TrackDB reorganisieren (o)
  *    6 - Kopieren der Originaldaten erzwingen (bei Fehler)
  *    7 - Loeschen von einzelnen TrItem-DB-Referenzen (r)
  *   16 - Extended output to LOG (-d,Hidden)
  *   17 - Dateien direkt ueberschreiben (-inplace,Hidden)
  * ##renDB (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int renDB( /* Datenbank neu nummerieren */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute cRte; /* aktuelle Streckendefinition (Basis) */
    File    dat;  /* Dateidefinitionen */
    int     i,j;  /* Arbeitswerte */
    String  is,js;
    boolean OV,lext,wt;
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("renDB01",fn); /* Vorlauf ausgeben */

    OV = Fo.chkMsk(17); /* 'newworld'-Directory benoetigt ? */
    /* Systemdatei lesen und auswerten */
    cRte = getRte(fn,OV?1:2); /* Streckendefinition auswerten */
    if(cRte==null) return 5; /* Fehler -- Ende */

    /* print current paths */
    Lg.Msg("MsgC01",cRte.getInfo(2)); /* print route-name */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* print system-path */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* print route-path */
    Lg.Skip(true); /* and add empty line */

    /* globale "tsection.dat" bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC05"); /* Aktionsmeldung ausgeben */

    dat = cRte.getFile(-1); /* get reference to file */
    i = getTS(dat,null);    /* and load 'tsection.dat' (global) */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC08",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC11",c3); /* Ergebnis melden */
    Lg.Log("MsgC14",ScN); /* Ergebnis melden */
    Lg.Log("MsgC17",c2); /* Ergebnis melden */
    Lg.Log("MsgC20",ShN); /* Ergebnis melden */
    Lg.Log("MsgC23",c4); /* Ergebnis melden */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(cRte,ScA,ShA); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* zusaetzliche Streckendateien laden */
    i = getType(cRte); /* 'ttype.dat' laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    lext = !Fo.chkMsk(5); /* NUR TrackDB reorganisieren? -- Ergebnis merken
                           * Ergebnis ist 'true' wenn NICHT aktiv */
    if(lext) { /* nicht nur TrackDB berarbeiten -> World-Dateien laden */
      /* Strukturquadrate laden (genaue Ausfuehrung) */
      i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
      if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("MsgC26",i); /* Abbruchmeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 15; /* terminate function with errorcode */
      } /* Fehler aufgetreten */

      /* Strukturquadrate laden (LO-Tiles) */
      i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
      if(i>0) { /* Fehler beim Laden der Strukturquadrate */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("MsgC27",i); /* Abbruchmeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 15; /* terminate function with errorcode */
      } /* Fehler aufgetreten */

      /* World-Dateien laden und syntaktisch pruefen */
      i = getWF(cRte,false); /* World-Dateien laden */
      if(i>0) return i; /* Fehler -- Ende */
      /* Sound-Dateien laden und syntaktisch pruefen */
      i = getSF(cRte,false); /* World-Sound-Dateien laden */
      if(i>0) return i; /* Fehler -- Ende */

      /* Path-Definitionen werden geladen und ueberprueft */
      i = getPatF(cRte,!OV); /* Path-Definitionen laden und pruefen */
      if(i>0) return i; /* Fehler -- abbrechen */
      /* Service-Definitionen werden geladen und ueberprueft */
      i = getSrvF(cRte,!OV); /* Service-Definitionen laden und pruefen */
      if(i>0) return i; /* Fehler -- abbrechen */
      /* Traffic-Definitionen werden geladen und ueberprueft */
      i = getTrfF(cRte,!OV); /* Traffic-Definitionen laden und pruefen */
      if(i>0) return i; /* Fehler -- abbrechen */
      /* Activity-Definitionen werden geladen und ueberprueft */
      i = getActF(cRte,!OV); /* Activity-Definitionen laden und pruefen */
      if(i>0) return i; /* Fehler -- abbrechen */
    } /* World-Dateien sind notwendig

    /* Schienendatenbank laden */
    i = getDBF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    i = getITF(cRte,0); /* Schienendatenbank laden und pruefen (2. Teil) */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strassendatenbank laden */
    i = getDBF(cRte,1); /* Strassendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    if(i==0) { /* Datenbank ist vorhanden */
      i = getITF(cRte,1); /* Strassendatenbank laden und pruefen (2. Teil) */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* Datenbank(teil) ist vorhanden */

    if(lext) { /* nicht nur TrackDB berarbeiten -> World-Dateien bearbeiten */
      if((is=cRte.chkRte(Fo,true))!=null) { /* check route for integrity -- error found ? */
        if(is.charAt(0)!=' ') { /* error-message returned */
          Lg.Skip(true); /* skip line */
          Lg.Err("getRte23",is); /* print errormessage */
          Lg.Msg("MsgC60"); /* print message: 'terminating' */
          Lg.Close(); /* close output to Log-file */
          return 5; /* terminate function with errorcode */
        } /* error found -- function terminated */
        if(EnaW) Lg.Log("chkRte00",is); /* Warning found -- print it */
      } /* error/warning found */

      /* "world"-Dateien bearbeiten und neue Integritaet herstellen */
      i = 4; /* DO NOT modify I/O-mode (IO_app=4 is marker) */
      if(Fo.chkMsk(3)) i = TSFile.OCB; /* Ausgabe-Modus: Binaer, komprimiert */
      if(Fo.chkMsk(4)) i = TSFile.OUT; /* Ausgabe-Modus: Text, expanded */
      chkWrld(cRte,null,i); /* World-Dateien erweitert pruefen */
        /* Modus: keine Aenderungen melden, kein Renum */

      /* Sound-Dateien bearbeiten und neue Integritaet herstellen */
      i = chkSnd(cRte,null,0); /* Sound-Dateien erweitert pruefen */
        /* Modus: keine Aenderungen melden */
      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Log("MsgC33",i); /* Ergebnis melden */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* world-Dateien bearbeitet -- Referenzen registriert */

    /* ItemTables der Datenbanken muessen ALLE EXISTIERENDEN Elemente behalten,
     * da Referenzen aus den World-Dateien existieren koennen (z.B.Signal)
     */
    if(lext) { /* Modus fuer Pruefung festlegen */
      j = 4; /* Default-Modus bestimmen */
      if(Fo.chkMsk(2)) j += 2; /* auch TrItem-Eintr. loeschen? -- Modus aendern */
      if(Fo.chkMsk(7)) j += 128; /* auch TrItem-Ref. loeschen? -- Modus aendern */
    } else j = 2; /* only-Option aktiv */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("renDB02"); /* Aktion melden */

    i = chkDBTab(cRte,j); /* Schienendatenbank bearbeiten */
    if(i<0) return 5; /* Systemfehler -- Ende */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("renDB03"); /* Aktion melden */
    Lg.Msg("MsgC38",i); /* Ergebnis melden */
    Lg.Log("renDB04",cRte.getInt(0)); /* Ergebnis melden */
    Lg.Log("renDB05",cRte.get$TrI(0)); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("renDB06"); /* Aktion melden */

      j = chkDBTab(cRte,j+1); /* Strassendatenbank bearbeiten */
      if(j<0) return 5; /* Systemfehler -- Ende */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("renDB07"); /* Aktion melden */
      Lg.Msg("MsgC38",j); /* Ergebnis melden */
      Lg.Log("renDB08",cRte.getInt(1)); /* Ergebnis melden */
      Lg.Log("renDB09",cRte.get$TrI(1)); /* Ergebnis melden */
      Lg.Skip(false); /* Leerzeile loggen */
    } else j = 0; /* Strassendatenbank existiert nicht (ist OK) */
    wt = (i>0 || j>0); /* merke Fehler in der Struktur der Datenbanken */

    if(lext) { /* weitere Dateien auf Integritaet testen */
      /* Dateien fuer Aktivitaeten bearbeiten und neue Integritaet herstellen */
      i = chkPat(cRte); /* Pfad-Definitionen bearbeiten */
      if(i>0) return 5; /* Systemfehler -- Ende */

      i = chkSrv(cRte,true); /* Service-Definitionen bearbeiten */
      if(i>0) return 5; /* Systemfehler -- Ende */

      i = chkTrf(cRte,true,false); /* Traffic-Definitionen bearbeiten */
      if(i>0) return 5; /* Systemfehler -- Ende */

      i = chkAct(cRte,true); /* process activity-definitions (integrity-check) */
      if(i>0) return 5; /* systemerror occurred -- terminate */
    } /* Aktivitaets-Dateien bearbeitet */

    if(!Fo.chkMsk(1)) /* bei Fehlern - beenden */
     if(wt) { /* Fehler in der Struktur der Datenbanken */
      if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("renDB10"); /* Fehler melden */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Funktionsfehler */

    wt = lext && Fo.chkMsk(1); /* Write-Toggle erstellen */
    if(Fo.chkMsk(6)) wt = false; /* Write-Toggle modifizieren */

    /* create intermediate file if 'overwrite original files' is active */
    dat = null; /* preset: DO NOT overwrite original files */
    if(OV) { /* original files must be overwritten */
      /* print message and ask for confirmation */
      System.out.println(); /* insert empty outputline */
      if(!Fo.chkMsk(20)) askTerm(); /* ask user to REALLY overwrite */
      Lg.Log("MsgC41"); /* logg warning/hint */
      Lg.Skip(true); /* insert empty outputline to logfile */
      try { dat = File.createTempFile("TSUtil",".tmp");
      } catch (IOException e) { /* error while creation */
       System.err.println(e.toString());  return 5;}
      dat.deleteOnExit(); /* delete file again when java terminates */
    } /* original files should be overwritten */

    if(lext) { /* nicht nur TrackDB berarbeiten -> World-Dateien schreiben */
      /* "world"-Dateien bearbeiten und modifizieren */
      i = putWF(cRte,dat,false,wt); /* World-Dateien modifiziert schreiben */
      if(i>0) return i; /* Fehler beim Schreiben -- Ende */
      /* Sound-Dateien bearbeiten und modifizieren */
      i = putSF(cRte,dat,false); /* Sound-Dateien modifiziert schreiben */
      if(i>0) return i; /* Fehler beim Schreiben -- Ende */
    } /* Aenderungen in den World-Dateien geschrieben */

    /* Schienendatenbank bearbeiten */
    i = 0; if(wt) i += 32; /* Optionen erstellen */
    i = putDBF(cRte,dat,i); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    /* Schienendatenbank (.tit) bearbeiten */
    i = putITF(cRte,dat,0,wt); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      /* Strassendatenbank bearbeiten */
      i = 1; if(wt) i += 32; /* Optionen erstellen */
      i = putDBF(cRte,dat,i); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */

      /* Strassendatenbank (.rit) bearbeiten */
      i = putITF(cRte,dat,1,wt); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */
    } /* Strassendatenbank vorhanden und geladen */

    if(lext) { /* nicht nur TrackDB berarbeiten -> Dateien schreiben */
      /* Service-Definitionen werden neu geschrieben (TrItems!) */
      i = putSrvF(cRte,dat,1); /* Service-Definitionen neu schreiben */
      if(i>0) return i; /* Fehler -- abbrechen */

      /* Traffic-Definitionen werden neu geschrieben (TrItems!) */
      i = putTrfF(cRte,dat,1); /* Traffic-Definitionen neu schreiben */
      if(i>0) return i; /* Fehler -- abbrechen */

      /* Activity-definitions are written again (several changes) */
      i = putActF(cRte,dat,1); /* Write Activities again */
      if(i>0) return i; /* severe error -- terminate function */
    } /* TrItem-Eintraege wurden veraendert */

    if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */

    Lg.Skip(true); /* Leerzeile Loggen */
    Lg.Msg("renDB11"); /* Ende-Meldung (Erfolg) ausgeben */
    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "move" (-14-)
  * Streckendefinition verschieben
  * Optionen:
  *       3 - Komprimieren der Tile-Dateien
  *       4 - Kopieren der Puffer gefordert
  *      16 - Extended output to LOG (-d,Hidden)
  * ##move (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int move( /* Streckendefinition verschieben */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute  cRte; /* aktuelle Streckendefinition (Basis) */
    TSTile   cTle; /* aktuelle Tile-Definition */
    TSQuad   cQDf; /* aktuelle Quadrat-Definition */
    File     sdir,zdir; /* Dateidefinitionen */
    int      i,j;  /* Arbeitswerte */
    String   is,js;
    boolean  tdl; /* LO_Tiles vorhanden */
    Iterator cI;  /* allgemeiner Iterator fuer 'TreeSet' */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("moveR01",fn); /* Vorlauf ausgeben */

    /* Systemdatei lesen und auswerten */
    cRte = getRte(fn,105); /* (3*5*7) Streckendefinition auswerten */
    if(cRte==null) return 5; /* Fehler -- Ende */

    /* print current paths */
    Lg.Msg("MsgC01",cRte.getInfo(2)); /* print route-name */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* print system-path */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* print route-path */
    Lg.Skip(true); /* and add empty line */

    /* globale "tsection.dat" bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC05"); /* Aktionsmeldung ausgeben */

    sdir = cRte.getFile(-1); /* get reference to file */
    i = getTS(sdir,null);    /* and load 'tsection.dat' (global) */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC08",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC11",c3); /* Ergebnis melden */
    Lg.Log("MsgC14",ScN); /* Ergebnis melden */
    Lg.Log("MsgC17",c2); /* Ergebnis melden */
    Lg.Log("MsgC20",ShN); /* Ergebnis melden */
    Lg.Log("MsgC23",c4); /* Ergebnis melden */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(cRte,ScA,ShA); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* zusaetzliche Streckendateien laden */
    i = getType(cRte); /* 'ttype.dat' laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strukturquadrate laden (genaue Ausfuehrung) */
    i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC26",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Strukturquadrate laden (LO-Tiles) */
    tdl = true; /* annehmen: Lo_Tiles sind vorhanden */
    i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
    if(i>0) { /* Fehler beim Laden der Strukturquadrate */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC27",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    if(i<0) tdl = false; /* nicht mehr versuchen */

    /* maximale Kantenlaenge der Tiles berechnen */
    i = 1; /* default-Laenge setzen */
    cI = cRte.getIt(10); /* Iterator fuer Tile-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      /* alle Tile-Definitionen ueberpruefen */
      cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
      i = cTle.getLen(i); /* maximale Kantenlaenge berechnen */
    } /* alle Tile-Definitionen */
    if(tdl) { /* Lo-Tiles existieren */
      cI = cRte.getIt(11); /* Iterator fuer Tile-Definitionen */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        /* alle Tile-Definitionen ueberpruefen */
        cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
        i = cTle.getLen(i); /* maximale Kantenlaenge berechnen */
      } /* alle Tile-Definitionen */
    } /* Lo-Tiles sind vorhanden */
    if((shd%i)!=0) { /* Fehler im Wertebereich */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("moveR02",i); /* Fehlermeldung ausgeben, Datei schliessen */
      Lg.Close(); /* close output to Log-file */
      return 4; /* terminate function with errorcode */
    } /* invalid specification -- terminate function with errorcode */
    if((scd%i)!=0) { /* Fehler im Wertebereich */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("moveR03",i); /* Fehlermeldung ausgeben, Datei schliessen */
      Lg.Close(); /* close output to Log-file */
      return 4; /* terminate function with errorcode */
    } /* invalid specification -- terminate function with errorcode */

    /* Schienendatenbank laden */
    i = getDBF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    i = getITF(cRte,0); /* Schienendatenbank laden und pruefen (2. Teil) */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strassendatenbank laden */
    i = getDBF(cRte,1); /* Strassendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    if(i==0) { /* Datenbank ist vorhanden */
      i = getITF(cRte,1); /* Strassendatenbank laden und pruefen (2. Teil) */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* Datenbank(teil) ist vorhanden */

    /* World-Dateien laden und syntaktisch pruefen */
    i = getWF(cRte,false); /* World-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */
    /* Sound-Dateien laden und syntaktisch pruefen */
    i = getSF(cRte,false); /* World-Sound-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */

    /* Path-Definitionen werden geladen und ueberprueft */
    i = getPatF(cRte,true); /* Path-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Service-Definitionen werden geladen und ueberprueft */
    i = getSrvF(cRte,true); /* Service-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Traffic-Definitionen werden geladen und ueberprueft */
    i = getTrfF(cRte,true); /* Traffic-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Activity-Definitionen werden geladen und ueberprueft */
    i = getActF(cRte,true); /* Activity-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */


    /* all files were loaded -- continue with integrity-check */
    if((is=cRte.chkRte(Fo,true))!=null) { /* check route for integrity -- error found ? */
      if(is.charAt(0)!=' ') { /* error-message returned */
        Lg.Skip(true); /* skip line */
        Lg.Err("getRte23",is); /* print errormessage */
        Lg.Msg("MsgC60"); /* print message: 'terminating' */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* error found -- function terminated */
      if(EnaW) Lg.Log("chkRte00",is); /* Warning found -- print it */
    } /* error/warning found */

    /* "world"-Dateien bearbeiten und neue Integritaet herstellen */
    chkWrld(cRte,null,4); /* World-Dateien erweitert pruefen */
      /* Modus: keine Aenderungen melden, kein Renum */

    /* Sound-Dateien bearbeiten und neue Integritaet herstellen */
    i = chkSnd(cRte,null,0); /* Sound-Dateien erweitert pruefen */
      /* Modus: keine Aenderungen melden */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("MsgC33",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC35"); /* Aktionsmeldung ausgeben */
    if(cRte.get$TrN(0)<=0) { /* Schienendatenbank NICHT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC36"); /* Fehlermeldung ausgeben, Datei schliessen */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datenbank nicht vorhanden */

    i = chkDBTab(cRte,0); /* Schienendatenbank bearbeiten */
    if(i<0) return 5; /* Systemfehler -- Ende */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC37",i); /* Aktionsmeldung */
    Lg.Skip(false); /* Leerzeile loggen */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC39"); /* Aktionsmeldung ausgeben */
      i = chkDBTab(cRte,1); /* Strassendatenbank bearbeiten */
      if(i<0) return 5; /* Systemfehler -- Ende */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("MsgC40",i); /* Aktionsmeldung */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Strassendatenbank vorhanden und geladen */

    i = chkPat(cRte); /* Pfad-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkSrv(cRte,true); /* Service-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkTrf(cRte,true,false); /* Traffic-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkAct(cRte,true); /* process activity-definitions */
    if(i>0) return 5; /* systemerror occurred -- terminate */

    /* Aktion durchfuehren: Strecke verschieben */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("moveR04",cRte.getInfo(1)); /* Aktionsmeldung ausgeben */
    i = 0; /* Anzahl der Fehler initialisieren */
    cI = cRte.getIt(12); /* Iterator fuer Quad-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      /* alle Quadrat-Definitionen bearbeiten */
      cQDf = (TSQuad)cI.next(); /* naechste Tile-Definition */
      if((is=cQDf.shft(shd,scd))!=null) { /* Groessenfehler */
        Lg.Err("moveR05",is,cQDf.getInf(0)); /* errormessage */
        i += 1; /* Fehler zaehlen */
      } /* Fehler aufgetreten */
    } /* alle Quadratdefinitionen verschieben */
    cI = cRte.getIt(10); /* Iterator fuer Tile-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      /* alle Tile-Definitionen bearbeiten */
      cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
      if((is=cTle.shft(shd,scd))!=null) { /* Groessenfehler */
        Lg.Err("moveR06",is,cTle.getId(true));
        i += 1; /* Fehler zaehlen */
      } /* Fehler aufgetreten */
    } /* alle Tiles verschieben */
    if(tdl) { /* Lo-Tiles existieren */
      cI = cRte.getIt(11); /* Iterator fuer Tile-Definitionen */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        /* alle Tile-Definitionen bearbeiten */
        cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
        if((is=cTle.shft(shd,scd))!=null) { /* Groessenfehler */
          Lg.Err("moveR07",is,cTle.getId(true));
          i += 1; /* Fehler zaehlen */
        } /* Fehler aufgetreten */
      } /* alle Tiles verschieben */
    } /* Lo-Tiles sind vorhanden */
    if(i>0) { /* Groessenfehler sind aufgetreten */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("moveR08",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* ***** ab hier beginnen die Ausgaben ***** */
    /* Process basic file of route (.trk) */
    i = putRte(cRte,null); /* rewrite route-definition */
    if(i>0) { /* error found while writing */
      Lg.Skip(true); /* skip line */
      Lg.Msg("moveR10",i); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* error found -- function terminated */

    /* "world"-Dateien bearbeiten und modifizieren */
    i = putWF(cRte,null,false,false); /* World-Dateien modifiziert schreiben */
    if(i>0) return i; /* Fehler beim Schreiben -- Ende */
    /* Sound-Dateien bearbeiten und modifizieren */
    i = putSF(cRte,null,false); /* Sound-Dateien modifiziert schreiben */
    if(i>0) return i; /* Fehler beim Schreiben -- Ende */

    /* Schienendatenbank bearbeiten */
    i = putDBF(cRte,null,0); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    /* Schienendatenbank (.tit) bearbeiten */
    i = putITF(cRte,null,0,false); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      /* Strassendatenbank bearbeiten */
      i = putDBF(cRte,null,1); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */

      /* Strassendatenbank (.rit) bearbeiten */
      i = putITF(cRte,null,1,false); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */
    } /* Strassendatenbank vorhanden und geladen */

    /* Terrain-Datei(en) bearbeiten */
    i = putTDF(cRte,null,0); /* Terrain-Datei (HI) erzeugen */
    if(i>0) return i; /* Fehler beim Schreiben */

    /* Tile-Definitionen konvertieren */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC44"); /* Aktionsmeldung */
    c4 = 0; /* Zaehler initialisieren */
    sdir = cRte.getFile(18); /* Pfad der Tile-Dateien (Quelle) holen */
    zdir = cRte.getFile(48); /* Pfad der Tile-Dateien (Ziel) holen */
    if(zdir==null) { /* directory not accessible */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC63",cRte.getInfo(48)); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 20; /* directory not accessible -- terminate function with errorcode */
    } /* terminate function with errorcode */
    cI = cRte.getIt(10); /* Iterator fuer Tile-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      /* alle Tile-Definitionen bearbeiten */
      cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
      mveTile(cTle,sdir,zdir,Double.NaN,null,Fo.chkMsk(3),Fo.chkMsk(4));
        /* Tile-Datei mit Datendateien verschieben und ggf. komprimieren.
         * Puffer kopieren falls gefordert. */
    } /* alle Tile-Definitionen verschieben */
    if(tdl) { /* Lo-Tiles existieren */
      i = putTDF(cRte,null,1); /* Terrain-Datei (LO) erzeugen */
      if(i>0) return i; /* Fehler beim Schreiben */
      /* Tile-Definitionen (lo) konvertieren */
      c4 = 0; /* Zaehler initialisieren */
      sdir = cRte.getFile(19); /* Pfad der Lo-Tile-Dateien (Quelle) holen */
      zdir = cRte.getFile(49); /* Pfad der Lo-Tile-Dateien (Ziel) holen */
      if(zdir==null) { /* directory is not accessible */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("MsgC63",cRte.getInfo(49)); /* Abbruchmeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 20; /* terminate function with errorcode */
      } /* directory is not accessible -- terminate function with errorcode */
      cI = cRte.getIt(11); /* Iterator fuer Lo-Tile-Definitionen */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        /* alle Lo-Tile-Definitionen bearbeiten */
        cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
        mveTile(cTle,sdir,zdir,Double.NaN,null,Fo.chkMsk(3),true);
          /* Tile-Datei mit Datendateien verschieben und ggf. komprimieren.
           * Puffer auf jeden Fall kopieren. */
      } /* alle LO-Tile-Definitionen verschieben */
    } /* Lo-Tiles sind vorhanden */

    /* Path-Definitionen werden bearbeitet (Quadrate austauschen) */
    i = putPatF(cRte,null,1); /* Path-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Service-Definitionen werden neu geschrieben (TrItems!) */
    i = putSrvF(cRte,null,1); /* Service-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Traffic-Definitionen werden neu geschrieben (TrItems!) */
    i = putTrfF(cRte,null,1); /* Traffic-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Activity-definitions are written again (several changes) */
    i = putActF(cRte,null,1); /* Write Activities again */
    if(i>0) return i; /* severe error -- terminate function */

    if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("moveR11"); /* Abschlussmeldung ausgeben */

    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkUpg" (-15-)
  * 'tsection.dat' (alt/neu) laden und Upgrade pruefen
  * ##chkUpg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chkUpg( /* 'Upgrade 'tsection.dat' pruefen */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSShape[] ShT;   /* benutzt fuer Tabellenkorrelation */
    TSScC[]   ScT;   /* benutzt fuer Tabellenkorrelation */
    TSSect    cSc;   /* aktuelle Section */
    File      dir1,dir2;
    int       i,j,v,w; /* Arbeitswerte */
    String    is;
    boolean   OK; /* Methode erfolgreich ? */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("chkUpg01",fn); /* Vorlauf ausgeben */

    dir1 = new File(fn); /* Directoryobjekt erstellen */
    fn = dir1.getAbsolutePath(); /* Gesamtname erstellen */
    dir1 = new File(fn); /* Directoryobjekt neu erstellen */
    if(dir1.isDirectory()) { /* Directory statt Datei spezifiziert */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("chkUpg02",fn); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    if(!dir1.exists()) { /* 'tsection.dat'(alt) existiert nicht */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("chkUpg03",fn); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 6; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    dir2 = dir1.getParentFile(); /* Verzeichnisname holen */
    if(dir2==null) { /* Verzeichnis existiert nicht */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("chkUpg04",fn); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 7; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    dir2 = new File(dir2,"tsection.dat"); /* Steuerdatei */
    is = dir2.getAbsolutePath(); /* Gesamtname erstellen */
    if(dir2.isDirectory()) { /* Directory statt Datei spezifiziert */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("chkUpg05",is); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 8; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    if(!dir2.exists()) { /* 'tsection.dat'(neu) existiert nicht */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("chkUpg06",is); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 9; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* globale "tsection.dat" bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC06"); /* Aktionsmeldung ausgeben */

    i = getTS(dir1,null); /* 'tsection.dat' (global-alt) laden */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC09",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15;  /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC12",c3); /* Ergebnis melden */
    Lg.Log("MsgC15",ScA); /* Ergebnis melden */
    Lg.Log("MsgC18",c2); /* Ergebnis melden */
    Lg.Log("MsgC21",ShA); /* Ergebnis melden */
    Lg.Log("MsgC24",c4); /* Ergebnis melden */

    /* Vorbereiten des Ladens der ZWEITEN globalen 'tsection.dat' */
    ScT = new TSScC[ScA]; /* Connection-Tabelle erstellen */
    Arrays.fill(ScT,null); /* Tabelle initialisieren */
    for(i=0,j=1;i<ScA;i+=j) { /* Tabelle umwandeln */
      if(ScTab[i]==null) continue; /* Eintrag nicht belegt */
      cSc = ScTab[i].setScR(null); /* Verkettung loeschen */
      j = cSc.$dIx(0); /* neues Increment holen */
      ScT[i] = new TSScC(cSc); /* neues Connection-Element erstellen */
    } /* -for- alle Connection-Eintraege erstellen */
    ScTab = null; /* Section-Tabelle(alt) frei fuer Tabelle(neu) */
    ShT   = ShTab; /* Shape-Tabelle(alt) sichern */
    ShTab = null;  /* Shape-Tabelle(alt) frei fuer Tabelle(neu) */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC07"); /* Aktionsmeldung ausgeben */

    i = getTS(dir2,null); /* 'tsection.dat' (global-neu) laden */
    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC10",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC13",c3); /* Ergebnis melden */
    Lg.Log("MsgC16",ScN); /* Ergebnis melden */
    Lg.Log("MsgC19",c2); /* Ergebnis melden */
    Lg.Log("MsgC22",ShN); /* Ergebnis melden */
    Lg.Log("MsgC25",c4); /* Ergebnis melden */

    /* Zusammenfuehren der beiden "globalen tsection.dat" */
    /* 1.: Pruefen ob es in der Sectiontabelle(alt) zu jedem Eintrag
     * mindestens auch einen (max. 8) Eintrag in der Tabelle(neu) gibt
     * und diesen in der Zwischetabelle (TSScC) registrieren */
    for(i=0,v=1;i<ScT.length;i+=v) { /* alle globalen Section-Eintraege testen */
      if(ScT[i]==null) continue; /* Section nicht definiert */
      v = ScT[i].$dIx(); /* neuen Abstand merken */
      c0 = 0; /* Zuordnugszaehler initialisieren */
      for(j=0,w=1;j<ScTab.length;j+=w) { /* alle Section-Eintraege testen */
        if(ScTab[j]==null) continue; /* Section nicht definiert */
        w = ScTab[j].$dIx(0); /* neuen Abstand merken */
        if(ScT[i].check(ScTab[j])) c0 += 1; /* Zuordnung erfolgt ? */
      } /* alle Section-Eintraege testen */
      if(c0==0) /* Eintrag wurde nicht zugeordnet */
        Lg.Err("chkUpg07",i); /* Fehlermeldung ausgeben */
    } /* -for- alle Section-Eintraege testen */

    /* 2.: Pruefen ob es in der Shapetabelle(alt) zu jedem Eintrag auch einen
     * Eintrag in der Shapetabelle(neu) gibt. Diesen Eintrag mit dem 'alten'
     * verketten und gleichzeitig registrieren, welche Section-Zuordungen
     * dafuer benutzt wurden. */
    for(i=0,v=1;i<ShT.length;i+=v) { /* alle Shape-Eintraege (alt) testen */
      if(ShT[i]==null) continue; /* Shape nicht definiert */
      v = ShT[i].$dIx(0); /* neuen Abstand merken */
      for(j=0,w=1;j<ShTab.length;j+=w) { /* alle Shape-Eintraege testen */
        if(ShTab[j]==null) continue; /* Shape nicht definiert */
        w = ShTab[j].$dIx(0); /* neuen Abstand merken */
        if(ShT[i].check(ShTab[j],ScT)) break; /* Korrelation jetzt erfolgt */
        /* Korrelation wird durch die 'check'-Methode auf JEDEN FALL aufgehoben
         * und im Trefferfall wieder hergestellt. */
      } /* -for- alle Shape-Eintraege testen */
      if(ShT[i].getNr(false)<0) shlp:{ /* Eintrag wurde nicht korreliert */
        /* 'getnr()' liefert '-4' wenn keine Verbindung existiert */
        w = ShT[i].getNr(true); /* Nummer des Shapes (Basis) */
        for(j=3;j<Fo.get$Obj(1);j+=2) /* alle Definitionen testen */
          if(Fo.getInt(j)==w) { /* Definition gefunden */
            c5 = Fo.getInt(j+1); /* Zugeordneter Wert holen */
            if(c5>=ShTab.length) continue; /* ignorieren */
            if(c5<0) continue; /* ignorieren */
            if(ShTab[c5]==null) continue; /* ignorieren */
            ShT[i].setShR(ShTab[c5]); /* neue Verbindung erzwingen */
            break shlp; /* Zuordnung ist erfolgt */
          } /* Manuelle Definition erhalten */
        Lg.Err("chkUpg08",i); /* Fehlermeldung ausgeben */
      } /* -shlp- Eintrag nicht korreliert */
    } /* -for- alle Shape-Eintraege testen */

    /* Section-Referenzen eindeutig zuordnen (mehrfach-Referenzen aufloesen) */
    /* 3.: Wenn aus einer mehrdeutigen Section-Zuordnung EINE Zuordnung bei der
     * Shape-Bearbeitung genutzt wurde, wird diese festgeschrieben. Auch
     * eindeutige Section-Zuordnungen werden jetzt festgeschrieben.
     * Fuer die restlichen MEHRDEUTIGEN Section-Zuordnungen wird geprueft, ob es
     * in der Umgebung (+/-1) eine eindeutige Zuordnung gibt, die sich auf
     * ahnliche Section-Definitionen bezieht. Wenn ja, wird die aktuelle Section-
     * Zuordnung genauso festgeschrieben. (Umgebnung: 99->121 ==> Aktuell: 98->120)
     */
    for(i=0,v=1;i<ScT.length;i+=v) { /* alle globalen Section-Eintraege testen */
      if(ScT[i]==null) continue; /* Section nicht definiert */
      v = ScT[i].doRef(false); /* Index pruefen und setzen */
        /* Routine liefert Abstand wie: 'ScTab[i].$dIx(0)' */
    } /* -for- alle Section-Eintraege testen */
    for(i=0,v=1;i<ScT.length;i+=v) { /* alle globalen Section-Eintraege testen */
      if(ScT[i]==null) continue; /* Section nicht definiert */
      v = ScT[i].$dIx(); /* neuen Abstand merken */
      if(ScT[i].doConn(null)) { /* Zuordnung ist noch nicht eindeutig */
        OK = true; /* noch keine Aenderung erfolgt */
        if(i>0) { /* Pruefung ist moeglich */
          j = i - 1; /* erster Test-Index */
          if(ScT[j]!=null) /* Eintrag ist gultig */
            if(ScT[i].doConn(ScT[j])) OK = false; /* Index erfolgreich gesetzt */
        } /* Pruefung war moeglich */
        if(OK) { /* Index noch nicht gesetzt */
          if(i<(ScT.length-1)) { /* Pruefung ist moeglich */
            j = i + 1; /* zweiter Test-Index */
            if(ScT[j]!=null) /* Eintrag ist gultig */
              if(ScT[i].doConn(ScT[j])) OK = false; /* Index erfolgreich gesetzt */
          } /* Pruefung war moeglich */
        } /* Index -- zweiter Versuch */
        if(OK) /* Index noch nicht gesetzt */
          if(!ScT[i].cmpNr(ScT[i].getScR().getNr(true))) OK = false;
            /* Index erfolgreich gesetzt wenn Nummern gleich */
        if(OK) /* Index konnte nicht gesetzt werden */
          Lg.Err("chkUpg09",i); /* Fehlermeldung ausgeben */
      } /* Index ist bereits / wurde eindeutig */
    } /* -for- alle Section-Eintraege testen */
    for(i=0,v=1;i<ScT.length;i+=v) { /* alle globalen Section-Eintraege testen */
      if(ScT[i]==null) continue; /* Section nicht definiert */
      v = ScT[i].doRef(true); /* Index pruefen und Referenzen setzen */
        /* hier werden die Zuordnungen zwischen den Sectiondefinitionen per Adresse
         * endgueltig hergestellt. Feld 'ScR' wird gesetzt.
         * Routine liefert Abstand wie: 'ScTab[i].$dIx(0)' */
    } /* -for- alle Section-Eintraege testen */

    /* ACHTUNG: Hier werden die Tabellennamen NICHT wieder zurueckgewechselt!!! */

    if(Fo.chkMsk(16)) { /* Zusaetzliche Definitionen ausgeben */
      prExtD(null); /* Zusaetzliche Definitionen ausgeben */
      if(ShT!=null) { /* Datentabelle ist gefuellt */
        Lg.Log("chkUpg11",ShT.length); /* Fehlermeldung ausgeben */
        for(i=0;i<ShT.length;i+=1) { /* alle Eintraege */
          if(ShT[i]==null) continue; /* nicht ausgeben */
          Lg.Log("chkUpg12",ShT[i].toStr(),i,0); /* Datenzeile */
        } /* alle Eintraege */
        Lg.Skip(false); /* Leerzeile loggen */
      } /* Datentabelle ausgeben */
      if(ScT!=null) { /* Datentabelle ist gefuellt */
        Lg.Log("chkUpg13",ScT.length); /* Fehlermeldung ausgeben */
        for(i=0;i<ScT.length;i+=1) { /* alle Eintraege */
          if(ScT[i]==null) continue; /* nicht ausgeben */
          Lg.Log("chkUpg12",ScT[i].toStr(),i,0); /* Datenzeile */
        } /* alle Eintraege */
        Lg.Skip(false); /* Leerzeile loggen */
      } /* Datentabelle ausgeben */
    } /* zusaetzliche Definitionen wurden geschrieben */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("chkUpg14"); /* Ergebnis ausgeben */
    Lg.Msg("chkUpg15"); /* Ergebnis ausgeben */
    Lg.Msg("chkUpg16",ShT.length); /* Ergebnis ausgeben */
    Lg.Msg("chkUpg17",ScT.length); /* Ergebnis ausgeben */
    Lg.Msg("chkUpg18"); /* Ergebnis ausgeben */
    Lg.Msg("chkUpg19",ShTab.length); /* Ergebnis ausgeben */
    Lg.Msg("chkUpg20",ScTab.length); /* Ergebnis ausgeben */

    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "adjH" (-16-)
  * Hoehenwerte einer Strecke anpassen
  * Individuelle Optionskennungen (wenn aktiv):
  *   1 - Komprimieren der Tile-Dateien (c)
  * ##adjH (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int adjH( /* Hoehenwerte einer Strecke anpassen */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute               cRte;   /* aktuelle Streckendef. (Basis) */
    TSTile                cTle;   /* aktuelle Tile-Definition */
    TSQuad                cQDf;   /* aktuelle Quadrat-Definition */
    TSUiD                 cUiD;   /* aktuelles UiD-Element */
    TSSnd                 cSnd;   /* aktive Sound-Definition */
    TSTrNde               cTrN;   /* aktuelles DB-Element */
    TSVector              cNde;   /* current vector-node */
    TSTrItm               cIt;    /* aktuelles DB-Element (TrItem) */
    ArrayList<TSTrItm01T> TrItD;  /* 'TrSignalDir'-Tabelle (SignalItem) */
    TSTrItm01T            cTrItD; /* 'TrSignalDir'-Eintrag (SignalItem) */
    TSView                cVS;    /* aktuelles ViewSphere-Element */
    TSPath                cPth;   /* aktuelle Pfad-Definition */
    TSPatPDP              cPDP;   /* aktuelle PDP-Definition */
    File                  sdir,zdir; /* Dateidefinitionen */
    int                   i,j,m,v,u; /* Arbeitswerte */
    String                is,js;
    double                dy;  /* Korrekturwert fuer Hoehe */
    boolean               tdl; /* LO_Tiles vorhanden */
    Iterator              cI;  /* allgemeiner Iterator */
    Iterator<TSTrNde>     aI;  /* Iterator fuer TrackNode-Tabelle */
    Iterator<TSPatPDP>    pI;  /* Iterator ueber PDP-Definitionen */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("adjHgt01",fn); /* Vorlauf ausgeben */

    /* Systemdatei lesen und auswerten */
    cRte = getRte(fn,105); /* (3*5*7) Streckendefinition auswerten */
    if(cRte==null) return 5; /* Fehler -- Ende */

    /* print current paths */
    Lg.Msg("MsgC01",cRte.getInfo(2)); /* print route-name */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* print system-path */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* print route-path */
    Lg.Skip(true); /* and add empty line */

    /* globale "tsection.dat" bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC05"); /* Aktionsmeldung ausgeben */

    sdir = cRte.getFile(-1); /* get reference to file */
    i = getTS(sdir,null);    /* and load 'tsection.dat' (global) */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC08",i); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC11",c3); /* Ergebnis melden */
    Lg.Log("MsgC14",ScN); /* Ergebnis melden */
    Lg.Log("MsgC17",c2); /* Ergebnis melden */
    Lg.Log("MsgC20",ShN); /* Ergebnis melden */
    Lg.Log("MsgC23",c4); /* Ergebnis melden */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(cRte,ScA,ShA); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* zusaetzliche Streckendateien laden */
    i = getType(cRte); /* 'ttype.dat' laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strukturquadrate laden (genaue Ausfuehrung) */
    i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC26",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Strukturquadrate laden (LO-Tiles) */
    tdl = true; /* annehmen: Lo_Tiles sind vorhanden */
    i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
    if(i>0) { /* Fehler beim Laden der Strukturquadrate */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC27",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    if(i<0) tdl = false; /* nicht mehr versuchen */

    /* Schienendatenbank laden */
    i = getDBF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    i = getITF(cRte,0); /* Schienendatenbank laden und pruefen  (2. Teil) */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strassendatenbank laden */
    i = getDBF(cRte,1); /* Strassendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    if(i==0) { /* Datenbank ist vorhanden */
      i = getITF(cRte,1); /* Strassendatenbank laden und pruefen (2. Teil) */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* Datenbank(teil) ist vorhanden */

    /* World-Dateien laden und syntaktisch pruefen */
    i = getWF(cRte,false); /* World-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */
    /* Sound-Dateien laden und syntaktisch pruefen */
    i = getSF(cRte,false); /* World-Sound-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */

    /* Path-Definitionen werden geladen und ueberprueft */
    i = getPatF(cRte,true); /* Path-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Service-Definitionen werden geladen und ueberprueft */
    i = getSrvF(cRte,true); /* Service-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Traffic-Definitionen werden geladen und ueberprueft */
    i = getTrfF(cRte,true); /* Traffic-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Activity-Definitionen werden geladen und ueberprueft */
    i = getActF(cRte,true); /* Activity-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */


    /* all files were loaded -- continue with integrity-check */
    if((is=cRte.chkRte(Fo,true))!=null) { /* check route for integrity -- error found ? */
      if(is.charAt(0)!=' ') { /* error-message returned */
        Lg.Skip(true); /* skip line */
        Lg.Err("getRte23",is); /* print errormessage */
        Lg.Msg("MsgC60"); /* print message: 'terminating' */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* error found -- function terminated */
      if(EnaW) Lg.Log("chkRte00",is); /* Warning found -- print it */
    } /* error/warning found */

    /* "world"-Dateien bearbeiten und neue Integritaet herstellen */
    chkWrld(cRte,null,4); /* World-Dateien erweitert pruefen */
      /* Modus: keine Aenderungen melden, kein Renum */

    /* Sound-Dateien bearbeiten und neue Integritaet herstellen */
    i = chkSnd(cRte,null,0); /* Sound-Dateien erweitert pruefen */
      /* Modus: keine Aenderungen melden */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("MsgC33",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC35"); /* Aktionsmeldung ausgeben */
    if(cRte.get$TrN(0)<=0) { /* Schienendatenbank NICHT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC36"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datenbank nicht vorhanden */

    i = chkDBTab(cRte,0); /* Schienendatenbank bearbeiten */
    if(i<0) return 5; /* Systemfehler -- Ende */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC37",i); /* Aktionsmeldung ausgeben */
    Lg.Skip(false); /* Leerzeile loggen */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC39"); /* Aktionsmeldung ausgeben */
      i = chkDBTab(cRte,1); /* Strassendatenbank bearbeiten */
      if(i<0) return 5; /* Systemfehler -- Ende */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("MsgC40",i); /* Aktionsmeldung ausgeben */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Strassendatenbank vorhanden und geladen */

    i = chkPat(cRte); /* Pfad-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkSrv(cRte,true); /* Service-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkTrf(cRte,true,false); /* Traffic-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkAct(cRte,true); /* process activity-definitions */
    if(i>0) return 5; /* systemerror occurred -- terminate */

    /* Aktion durchfuehren: Hoehenwerte anpassen */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("adjHgt03",cRte.getInfo(1)); /* Aktionsmeldung */
    dy = ((Double)Fo.getObj(4,0)).doubleValue(); /* Korrekturwert(Y) holen */

    i = 0; /* Anzahl der Fehler initialisieren */
    cI = cRte.getIt(12); /* Iterator fuer Quadrat-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cQDf = (TSQuad)cI.next(); /* naechste Quadrat-Definition */
      is = cQDf.getInf(4); /* Namen der Sound-Datei */
      if(is!=null) { /* Sound-Datei vorhanden -- bearbeiten */
        for(cSnd=cQDf.getSnd(true);cSnd!=null;cSnd=cQDf.getSnd(false)) {
          /* nicht belegte Sound-Eintraege gibt es nicht */
          if(cSnd.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
          if((js=cSnd.adjHgt(dy))!=null) { /* Hoehenwert veraendern -- Fehler? */
            Lg.Err("adjHgt04",js,is,cSnd.getUiD(0)); /* Fehlermeldung */
            i += 1; /* Fehler zaehlen */
          } /* Fehler beim Justieren aufgetreten */
        } /* alle Sound-Elemente bearbeiten */
      } /* Sound-Eintraege waren vorhanden */
      is = cQDf.getInf(2); /* Namen der World-Datei */
      if(is==null) continue; /* World-Datei fehlt -- nicht bearbeiten */
      /* interne World-Daten bearbeiten */
      for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
        /* nicht belegte UiD-Eintraege gibt es nicht */
        if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
        if(cUiD.isCtl()) continue; /* kein aktiver UiD-Eintrag */
        /* 'adjHgt' veraendert die Hoehe ggf. mehrmals (Objektstruktur) */
        if((js=cUiD.adjHgt(dy))!=null) { /* Fehler aufgetreten */
          Lg.Err("adjHgt05",js,is,""+cUiD.getUiD(0),"0");
          i += 1; /* Fehler zaehlen */
        } /* Fehler beim Justieren aufgetreten */
      } /* alle UiD-Elemente bearbeiten */
      /* alle ViewSphere-Eintraege anpassen */
      m = cQDf.chg$View(-1); /* Maximale ID der ViewSphere-Eintraege */
      for(j=0;j<m;j+=1) { /* alle ViewShpere-Eintraege gemaess ID */
        cVS = cQDf.fndView(j); /* Eintrag gemaess ID suchen */
        if(cVS==null) continue; /* nicht gefunden -- weiter */
        if((js=cVS.adjHgt(dy))!=null) { /* Fehler aufgetreten */
          i += 1; /* Fehler zaehlen */
        } /* Fehler beim Justieren aufgetreten */
      } /* alle VS-Eintraege bearbeiten */
    } /* alle Quad-Definitionen bearbeiten */
    /* Schienen-/Strassendatenbank bearbeiten */
    for(j=0;j<2;j+=1) { /* alle Datenbanken pruefen */
      aI = cRte.getIt(j); /* Iterator fuer TrackNode-Definitionen */
      if(aI==null) continue; /* TrackNode-Tabelle nicht vorhanden */
        /* Situation ist erlaubt -- kein Fehler */
      is = (j==0) ? "adjHgt1" : "adjHgt2"; /* Schienen-DB / Strassen-DB */
      while(aI.hasNext()) { /* Weitere Definitionen vorhanden */
        if((cTrN=aI.next())==null) continue; /* Fehl-Eintrag uebergehen */
        if(cTrN.chkMsk(22)) { /* Node fehlerhaft definiert ('Option 22') */
          v = cTrN.getNr(true); /* aktuelle Node-Kennung holen */
          Lg.Err(is+"1",v); /* Fehlermeldung ausgeben */
          i += 1; /* Fehler zaehlen */
          continue; /* DB-Element nicht weiter bearbeiten */
        } /* Node-Definition ist fehlerhaft */
        m = cTrN.get$Nde(); /* Anzahl der verbundenen Node-Eintraege */
        for(v=0;v<m;v+=1) { /* alle Nodes bearbeiten (TSVector) */
          cNde = cTrN.chgNde(v,null); /* aktuell verkettetes Element */
            /* 'cNde' kann nicht 'null' sein, da sonst 'Option 22' gesetzt ist. */
          if((js=cNde.adjHgt(dy))!=null) { /* Fehler aufgetreten */
            Lg.Err(is+"2",js,cTrN.getNr(true),v); /* Fehlermeldung ausgeben */
            i += 1; /* Fehler zaehlen */
          } /* Fehler beim Justieren aufgetreten */
        } /* alle verketteten Nodes bearbeiten */
      } /* alle DB-Elemente bearbeiten */
    } /* alle Datenbanken bearbeiten */
    /* Schienen-/Strassendatenbank zum zweiten (TrItems) */
    for(j=0;j<2;j+=1) { /* alle Datenbanken pruefen */
      cI = cRte.getIt(2+j); /* Iterator auf TrItem-Tabelle holen */
      if(cI==null) continue; /* DB nicht vorhanden */
      is = (j==0) ? "adjHgt1" : "adjHgt2"; /* Schienen-DB / Strassen-DB */
      while(cI.hasNext()) { /* alle TrItem-Definitionen bearbeiten */
        cIt = (TSTrItm)cI.next(); /* naechste TrItem-Definition */
        if(cIt==null) throw new IllegalStateException( /* Sicherheitsabfrage */
          TSLogg.getMsg("Msg908","TSTrItem==null","adjH",0));
        if((js=cIt.adjHgt(dy))!=null) /* Fehler aufgetreten -- Meldung schreiben */
          if(js.charAt(0)!=' ') { /* Fehler, keine Warnung */
            Lg.Err(is+"3",js,cIt.getNr(true),0); /* Fehlermeldung */
            i += 1; /* Fehler zaehlen */
          } else if(EnaW) Lg.Log(is+"4",js.substring(1),cIt.getNr(true),0);
        if(cIt instanceof TSTrItm01) { /* SignalItem liegt vor -- Position anpassen */
          TrItD = ((TSTrItm01)cIt).getSgD(0); /* Referenztabelle holen */
          if(cIt.chkMsk(22)) /* Signal-Units sind definiert/gueltig */
           for(v=0;v<TrItD.size();v+=1) { /* alle Signal-Units bearb. */
            cTrItD = TrItD.get(v); /* akt. 'TrSignalDir'-Eintrag holen */
            if(cTrItD==null) continue; /* nicht belegt -- nicht bearbeiten */
            if((js=cTrItD.adjHgt(dy))!=null) { /* Fehler aufgetreten */
              Lg.Err(is+"5",js,cIt.getNr(true),v); /* Fehlermeldung */
              i += 1; /* Fehler zaehlen */
            } /* Fehler beim Justieren aufgetreten */
          } /* ALLE TrSignalDir-Eintraege bearbeiten */
        } /* SignalItem bearbeiten */
      } /* alle DB-Elemente bearbeiten */
    } /* alle Datenbanken bearbeiten */

    /* Path-Definitionen anpassen (notwendig fuer NICHT-Junction) */
    cI = cRte.getIt(17); /* Liste der Pfad-Definitionen holen */
    v = 0; /* Laufende Nr. initialisieren */
    while(cI.hasNext()) { /* Weitere Pfad-Definition vorhanden */
      cPth = (TSPath)cI.next(); /* Pfad-Eintrag holen */
      if(cPth==null) throw new IllegalStateException( /* Sicherheitsabfrage */
        TSLogg.getMsg("Msg908","TSPath==null","adjH",1));
      v += 1; /* Eintrag zaehlen */
      if(!cPth.chkMsk(1)) continue; /* KEINE gueltigen PDP-Definitionen vorhanden */
      pI = cPth.getPDP(0).iterator(); /* Alle Tabellenelemente bearbeiten */
        /* Tabelle ist auf jeden Fall vorhanden (chkMsk) */
      j = -1; /* Zaehler initialisieren */
      while(pI.hasNext()) { /* Weitere PDP-Definition vorhanden */
        cPDP = pI.next(); /* aktueller PDP-Eintrag holen */
        if(cPDP==null) continue; /* do not process invalid/unused entries */
        j += 1; /* Definition gueltig -- zaehlen */
        if((js=cPDP.adjHgt(dy))!=null) { /* Fehler aufgetreten */
          Lg.Err("adjHgt31",js,v,j); /* Fehlermeldung */
          i += 1; /* Fehler zaehlen */
        } /* Fehler beim Justieren aufgetreten */
      } /* -while- alle PDP-Definitionen bearbeiten */
    } /* -while- alle Pfad-Definitionen bearbeiten */

    if(i>0) { /* Groessenfehler sind aufgetreten */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("adjHgt06",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* ***** ab hier beginnen die Ausgaben ***** */
    /* "world"-Dateien bearbeiten und modifizieren */
    i = putWF(cRte,null,false,false); /* World-Dateien modifiziert schreiben */
    if(i>0) return i; /* Fehler beim Schreiben -- Ende */
    /* Sound-Dateien bearbeiten und modifizieren */
    i = putSF(cRte,null,false); /* Sound-Dateien modifiziert schreiben */
    if(i>0) return i; /* Fehler beim Schreiben -- Ende */

    /* Schienendatenbank bearbeiten */
    i = putDBF(cRte,null,0); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    /* Schienendatenbank (.tit) bearbeiten */
    i = putITF(cRte,null,0,false); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      /* Strassendatenbank bearbeiten */
      i = putDBF(cRte,null,1); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */

      /* Strassendatenbank (.rit) bearbeiten */
      i = putITF(cRte,null,1,false); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */
    } /* Strassendatenbank vorhanden und geladen */

    /* Tile-Definitionen konvertieren */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC44"); /* Statusmeldung ausgeben */
    c4 = 0; /* Zaehler initialisieren */
    sdir = cRte.getFile(18); /* Pfad der Tile-Dateien (Quelle) holen */
    zdir = cRte.getFile(48); /* Pfad der Tile-Dateien (Ziel) holen */
    if(zdir==null) { /* directory is not accessible */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC63",cRte.getInfo(48)); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 20; /* terminate function with errorcode */
    } /* directory is not accessible -- terminate function with errorcode */
    cI = cRte.getIt(10); /* Iterator fuer Tile-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
      mveTile(cTle,sdir,zdir,dy,null,Fo.chkMsk(1),false);
        /* Tile-Datei mit Datendateien verschieben und ggf. komprimieren.
         * Puffer auf KEINEN Fall kopieren. */
    } /* alle Tile-Definitionen */
    if(tdl) { /* Lo-Tiles existieren */
      /* Tile-Definitionen (lo) konvertieren */
      c4 = 0; /* Zaehler initialisieren */
      sdir = cRte.getFile(19); /* Pfad der Lo-Tile-Dateien (Quelle) holen */
      zdir = cRte.getFile(49); /* Pfad der Lo-Tile-Dateien (Ziel) holen */
      if(zdir==null) { /* directory is not accessible */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("MsgC63",cRte.getInfo(49)); /* Abbruchmeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 20; /* terminate function with errorcode */
      } /* directory is not accessible -- terminate function with errorcode */
      cI = cRte.getIt(11); /* Iterator fuer Tile-Definitionen */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
        mveTile(cTle,sdir,zdir,dy,null,Fo.chkMsk(1),false);
          /* Tile-Datei mit Datendateien verschieben und ggf. komprimieren.
           * Puffer auf KEINEN Fall kopieren. */
      } /* alle LO-Tile-Definitionen */
    } /* Lo-Tiles sind vorhanden */

    /* Path-Definitionen werden neu erstellt */
    i = putPatF(cRte,null,1); /* Path-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */

    if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("adjHgt07"); /* Abschlussmeldung ausgeben */

    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Reduce" (-17-)
  * Shape-, Tile- oder World-Datei reduzieren und ggf. komprimieren
  * Optionen:
  *       1 - Compress ist gefordert
  *       2 - Vollstaendiges Kopieren gefordert
  *       3 - LO-Tiles sollen genutzt werden (-,Hidden)
  *      16 - Extended output to LOG (-d,Hidden)
  *      17 - Dateien direkt ueberschreiben (-inplace,Hidden)
  * ##Reduce/##cmp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int Reduce( /* Dateien reduzieren */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute         cRte; /* current route-definition (Basis) */
    TSFile          cR;   /* current buffered inputfile */
    TSFile          cW;   /* current output-file */
    File            dirS,dirZ,datS,datZ;
    String[]        fl;   /* current file-list */
    String          is,js;   /* intermediate value */
    int             i,z1,z2; /* intermediate values, counter */
    boolean         OV,mrkE; /* overwrite?, error found? */
    FileInputStream S;    /* binary Reader */
    byte[]          ibuf; /* intermediate buffer */
   /*=================================================================*/

    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("redFle10",fn); /* print prefix-message */

    OV = Fo.chkMsk(17); /* 'newRoute'-Directory needed? */
    /* get system-definition and check it */
    cRte = getRte(fn,OV?1:2); /* read route-definition */
    if(cRte==null) return 5; /* error found -- terminate */

    /* print current paths */
    Lg.Msg("MsgC01",cRte.getInfo(2)); /* print route-name */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* print system-path */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* print route-path */
    Lg.Skip(true); /* and add empty line */

    dirS = dirZ = datZ = null; /* Compiler needs it */
    if(vn2.equals("Shape")) { /* reduce of Shape-Files is requested */
      dirS = cRte.getFile(15); /* create reference of appropriate folder */
      js = ".s"; /* register file-suffix of shape-file */
      if(!OV) { /* overwrite is NOT requested */
        dirZ = cRte.getFile(45); /* create reference of appropriate folder */
        if(dirZ==null) { /* error -- directory cannot be accessed */
          Lg.Msg("MsgC63",cRte.getInfo(45)); /* print message: termination */
          Lg.Close(); /* close output to Log-file */
          return 10; /* terminate function with errorcode */
        } /* directory cannot be accessed -- terminate function with errorcode */
      } /* overwrite was NOT requested */
    } else if(vn2.equals("Tile")) { /* reduce of Tile-Files is requested */
      Fo.clrMsk(1); /* this option NOT allowed for 'Tiles' */
      dirS = cRte.getFile(Fo.chkMsk(3)?19:18); /* create reference of appropriate folder */
      js = ".t"; /* register file-suffix of tile-file */
      if(!OV) { /* overwrite is NOT requested */
        dirZ = cRte.getFile(Fo.chkMsk(3)?49:48); /* create reference of appropriate folder */
        if(dirZ==null) { /* error -- directory cannot be accessed */
          Lg.Msg("MsgC63",cRte.getInfo(Fo.chkMsk(3)?49:48));  /* print message */
          Lg.Close(); /* close output to Log-file */
          return 10; /* terminate function with errorcode */
        } /* directory cannot be accessed -- terminate function with errorcode */
      } /* overwrite was NOT requested */
    } else if(vn2.equals("World")) { /* reduce of World-Files is requested */
      dirS = cRte.getFile(10); /* create reference of appropriate folder */
      js = ".w"; /* register file-suffix of world-file */
      if(!OV) { /* overwrite is NOT requested */
        dirZ = cRte.getFile(40); /* create reference of appropriate folder */
        if(dirZ==null) { /* error -- directory cannot be accessed */
          Lg.Msg("MsgC63",cRte.getInfo(40)); /* print message: termination */
          Lg.Close(); /* close output to Log-file */
          return 10; /* terminate function with errorcode */
        } /* directory cannot be accessed -- terminate function with errorcode */
      } /* overwrite was NOT requested */
    } else js = null; /* File-Typ spezifische Bearbeitung */

    fl = dirS.list(); /* create list of all files */
    if(fl==null) { /* Source-reference is NOT a folder */
      Lg.Msg("redFle14",dirS.getAbsolutePath()); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* file-list could not be created */

    if(OV) { /* overwrite of source-files IS requested */
      try { datZ = File.createTempFile("TSUtil",".tmp");
      } catch (IOException e) { /* Creation-error temp-file */
        System.err.println(e.toString());  return 5;}
      datZ.deleteOnExit(); /* delete temp-file when leaving program */
      if(!Fo.chkMsk(20)) askTerm(); /* ask user to REALLY overwrite */
      Lg.Log("MsgC41"); /* print warning/message */
      Lg.Skip(true); /* print empty line to log-file and screen */
    } /* overwrite of sourve-files IS requested */

    z1 = z2 = 0; /* initialize counters (number of files, errors) */
    ibuf = new byte[7]; /* get intermediate buffer for file-type */
    for(String cf:fl) { /* process all file-definitions */
      datS = new File(dirS,cf); /* create full file-reference */
      if(datS.isDirectory()) continue; /* do not process folders */
      if(!cf.toLowerCase().endsWith(js)) { /* type of file (suffix) does not match */
        if(!Fo.chkMsk(2)) continue; /* complete copy is NOT requested */
        if(OV) { /* Overwrite requested -- delete buffer-files */
          if(cf.toLowerCase().endsWith("_e.raw")) datS.delete(); /* delete file */
          if(cf.toLowerCase().endsWith("_n.raw")) datS.delete(); /* delete file */
          continue; /* buffers were successfully deleted -- continue */
        } /* copy is NOT used, if overwrite is requested */
        /* here: 'OV' NOT active -- 'datZ' may be modified */
        datZ = new File(dirZ,cf); /* create full reference to target-file */
        is = "copy \"" + datS.getAbsolutePath() + "\" \"" +
             datZ.getAbsolutePath() + "\" "; /* create copy-command */
        if((i=exec(true,is,null,Lg))>0) /* error during 'execute'? */
          Lg.Log("MsgC49",datZ.getAbsolutePath(),i); /* print errormessage */
        continue; /* file is fully processed -- continue with next one */
      } /* copy file if requested */
      z1 += 1; /* count valid file-definition */
      fn = datS.getAbsolutePath(); /* get full name of source-file */
      if(!OV) datZ = new File(dirZ,cf); /* get full reference of target-file */
      Lg.Log("MsgC53",fn,DF4.format(z1)); /* print message of next actions */
      fn = datS.getName(); /* use file-name only within messages */

      try { S = new FileInputStream(datS); /* read: ASCII */
      } catch (FileNotFoundException E) { /* source-file not found */
        System.err.println(E.toString());
        Lg.Msg("redFle15",fn); /* print errormessage */
        continue; /* process next file */
      } /* Exception with OPEN */
      try {i = S.read(ibuf); /* read first part of first line */
      } catch (IOException e) { /* read-error occurred */
       System.err.println(e.toString());  return 20;}
      try { S.close(); /* close binery-file again */
      } catch (IOException e) { System.err.println(e.toString()); }
      is = new String(ibuf); /* convert input to string and check it */
      if(is.equals("SIMISA@")) { /* file is binary -- do not process */
        Lg.Msg("redFle16",fn); /* print errormessage */
        z2 += 1; /* register and count conversion-error */
        if(!Fo.chkMsk(2)) continue; /* complete copy is NOT requested */
        if(OV) continue; /* Overwrite requested -- do not copy  */
        is = "copy \"" + datS.getAbsolutePath() + "\" \"" +
             datZ.getAbsolutePath() + "\" "; /* create copy-command */
        if((i=exec(true,is,null,Lg))>0) /* error during 'execute'? */
          Lg.Log("MsgC49",datZ.getAbsolutePath(),i); /* print errormessage */
        continue; /* process next file */
      } /* type of file is NOT correct */

      /* file (now) contains unicode text-data in every case [UT] */
      cR = new TSFile(datS); /* locate and define file (UNICODE) */
      if((is=cR.open(TSFile.IU))!=null) { /* open file (input,unicode) -- error ? */
        Lg.Log("redFle17",is,fn); /* print errormessage */
        z2 += 1; /* register and count conversion-error */
        continue; /* process next file */
      } /* Error found while 'open' */

      is = cR.getData(); /* get first line from input (file-ID) */
      if(is==null) { /* error during read -- check message */
        is = cR.getErr(); /* get current error-message */
        if(is==null) is = TSLogg.getKey("redFle13"); /* EOF found */
        Lg.Log("redFle18",is); /* print errormessage */
        cR.close(); /* close inputfile again */
        z2 += 1; /* register and count conversion-error */
        continue; /* process next file */
      } /* read-error occurred */

      cW = null; /* Compiler needs it */
      if(vn2.equals("Shape")) cW = new TSFileS(datZ);
      else if(vn2.equals("Tile")) cW = new TSFileT(datZ);
      else if(vn2.equals("World")) cW = new TSFileW(datZ);
        /* create output-control due to requested file-type */

      /* use output-file to correctly check file-id of input-file */
      if((is=cW.chkFKng(is,false))!=null) { /* invalid File-ID found */
        Lg.Log("redFle19",is); /* print errormessage */
        cR.close(); /* close inputfile again */
        z2 += 1; /* register and count conversion-error */
        continue; /* process next file */
      } /* invalid file-ID */

      is = cW.open(Fo.chkMsk(1)?TSFile.OCB:TSFile.OUB); /* open output too */
      if(is!=null) { /* error found during open of output-file */
        Lg.Log("redFle20",is); /* print errormessage */
        cR.close(); /* close inputfile again */
        z2 += 1; /* register and count conversion-error */
        continue; /* process next file */
      } /* open-error output-file */

      mrkE = false; /* preset: no error, do not terminate */
      while((is=cR.getData())!=null) { /* read and copy all lines */
        is = cW.putData(is); /* rewrite line to output-file */
        if(is!=null) { /* error occurred during write */
          Lg.Log("redFle21",is); /* print errormessage */
          z2 += 1; /* register and count conversion-error */
          mrkE = true; /* set marker to 'error occurred' */
          break; /* terminate copy of lines */
        } /* error during write */
      } /* copy all lines */
      is = cR.getErr(); /* get current error-message (if available) */
      if(is!=null) { /* error during read -- check message */
        Lg.Log("redFle24",is); /* print errormessage */
        mrkE = true; /* register termination-request */
      } /* read-error occurred */

      cR.close(); /* close inputfile again */
      if((is=cR.getErr())!=null) Lg.Log("redFle22",is); /* print error */
      is = cW.close(); /* close output-file, too  */
      if(is!=null) { /* error occurred during close */
        Lg.Log("redFle23",is); /* print errormessage */
        z2 += 1; /* register and count conversion-error */
        continue; /* process next file */
      } /* file-error (close output) */

      if(mrkE) continue; /* error occurred -- continue with next file */
      if(!OV) continue; /* overwrite NOT requested -- next file */
      /* copy back of temporary file if overwrite is requested */
      is = "copy \""+datZ.getAbsolutePath()+"\" \""+
             datS.getAbsolutePath()+"\" "; /* create copy-command */
      if((i=exec(true,is,null,Lg))>0) /* error while exec */
        Lg.Log("MsgC49",datS.getAbsolutePath(),i); /* print errormessage */

    } /* process ALL files within directory */

    Lg.Skip(true); /* print empty line to log-file and screen */
    Lg.Log("redFle27",DF4.format(z1)); /* print result-message */
    Lg.Msg("redFle28",DF4.format(z2)); /* print result-message */
    Lg.Msg("redFle29",z1); /* print result-message */
    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* print Timestamp */
    Lg.Close(); /* close output to Log-file */
    return 0; /* terminate function without error-marker */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Expand" (-18-)
  * Shape-, Tile- oder World-Datei expandieren und ggf. dekomprimieren
  * Optionen:
  *       2 - Vollstaendiges Kopieren gefordert
  *       3 - LO-Tiles sollen genutzt werden (-,Hidden)
  *      16 - Extended output to LOG (-d,Hidden)
  *      17 - Dateien direkt ueberschreiben (-inplace,Hidden)
  * ##Expand/##unc (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int Expand( /* Dateien expandieren */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute         cRte; /* current route-definition (Basis) */
    TSFile          cR;   /* current input-file (compressed/reduced) */
    TSFile          cW;   /* current buffered outputfile unicode */
    File            dirS,dirZ,datS,datZ;
    String[]        fl;   /* current file-list */
    String          is,js;   /* intermediate value */
    int             i,z1,z2; /* intermediate values, counter */
    boolean         OV,mrkE; /* overwrite?, error found? */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("expFle10",fn); /* print prefix-message */

    OV = Fo.chkMsk(17); /* 'newRoute'-Directory needed? */
    /* get system-definition and check it */
    cRte = getRte(fn,OV?1:2); /* read route-definition */
    if(cRte==null) return 5; /* error found -- terminate */

    /* print current paths */
    Lg.Msg("MsgC01",cRte.getInfo(2)); /* print route-name */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* print system-path */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* print route-path */
    Lg.Skip(true); /* and add empty line */

    dirS = dirZ = datZ = null; /* Compiler needs it */
    if(vn2.equals("Shape")) { /* expand of Shape-Files is requested */
      dirS = cRte.getFile(15); /* create reference of appropriate folder */
      js = ".s"; /* register file-suffix of shape-file */
      if(!OV) { /* overwrite is NOT requested */
        dirZ = cRte.getFile(45); /* create reference of appropriate folder */
        if(dirZ==null) { /* error -- directory cannot be accessed */
          Lg.Msg("MsgC63",cRte.getInfo(45)); /* print message: termination */
          Lg.Close(); /* close output to Log-file */
          return 10; /* terminate function with errorcode */
        } /* directory cannot be accessed -- terminate function with errorcode */
      } /* overwrite was NOT requested */
    } else if(vn2.equals("Tile")) { /* expand of Tile-Files is requested */
      dirS = cRte.getFile(Fo.chkMsk(3)?19:18); /* create reference of appropriate folder */
      js = ".t"; /* register file-suffix of tile-file */
      if(!OV) { /* overwrite is NOT requested */
        dirZ = cRte.getFile(Fo.chkMsk(3)?49:48); /* create reference of appropriate folder */
        if(dirZ==null) { /* error -- directory cannot be accessed */
          Lg.Msg("MsgC63",cRte.getInfo(Fo.chkMsk(3)?49:48));  /* print message */
          Lg.Close(); /* close output to Log-file */
          return 10; /* terminate function with errorcode */
        } /* directory cannot be accessed -- terminate function with errorcode */
      } /* overwrite was NOT requested */
    } else if(vn2.equals("World")) { /* reduce of World-Files is requested */
      dirS = cRte.getFile(10); /* create reference of appropriate folder */
      js = ".w"; /* register file-suffix of world-file */
      if(!OV) { /* overwrite is NOT requested */
        dirZ = cRte.getFile(40); /* create reference of appropriate folder */
        if(dirZ==null) { /* error -- directory cannot be accessed */
          Lg.Msg("MsgC63",cRte.getInfo(40)); /* print message: termination */
          Lg.Close(); /* close output to Log-file */
          return 10; /* terminate function with errorcode */
        } /* directory cannot be accessed -- terminate function with errorcode */
      } /* overwrite was NOT requested */
    } else js = null; /* File-Typ spezifische Bearbeitung */

    fl = dirS.list(); /* create list of all files */
    if(fl==null) { /* Source-reference is NOT a folder */
      Lg.Msg("expFle14",dirS.getAbsolutePath()); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* file-list could not be created */

    if(OV) { /* overwrite of source-files IS requested */
      try { datZ = File.createTempFile("TSUtil",".tmp");
      } catch (IOException e) { /* Creation-error temp-file */
        System.err.println(e.toString());  return 5;}
      datZ.deleteOnExit(); /* delete temp-file when leaving program */
      if(!Fo.chkMsk(20)) askTerm(); /* ask user to REALLY overwrite */
      Lg.Log("MsgC41"); /* print warning/message */
      Lg.Skip(true); /* print empty line to log-file and screen */
    } /* overwrite of sourve-files IS requested */

    z1 = z2 = 0; /* initialize counters (number of files, errors) */
    for(String cf:fl) { /* process all file-definitions */
      datS = new File(dirS,cf); /* create full file-reference */
      if(datS.isDirectory()) continue; /* do not process folders */
      if(!cf.toLowerCase().endsWith(js)) { /* type of file (suffix) does not match */
        if(!Fo.chkMsk(2)) continue; /* complete copy is NOT requested */
        if(OV) { /* Overwrite requested -- delete buffer-files */
          if(cf.toLowerCase().endsWith("_e.raw")) datS.delete(); /* delete file */
          if(cf.toLowerCase().endsWith("_n.raw")) datS.delete(); /* delete file */
          continue; /* buffers were successfully deleted -- continue */
        } /* copy is NOT used, if overwrite is requested */
        /* here: 'OV' NOT active -- 'datZ' may be modified */
        datZ = new File(dirZ,cf); /* create full reference to target-file */
        is = "copy \"" + datS.getAbsolutePath() + "\" \"" +
             datZ.getAbsolutePath() + "\" "; /* create copy-command */
        if((i=exec(true,is,null,Lg))>0) /* error during 'execute'? */
          Lg.Log("MsgC49",datZ.getAbsolutePath(),i); /* print errormessage */
        continue; /* file is fully processed -- continue with next one */
      } /* copy file if requested */
      z1 += 1; /* count valid file-definition */
      fn = datS.getAbsolutePath(); /* get full name of source-file */
      if(!OV) datZ = new File(dirZ,cf); /* get full reference of target-file */
      Lg.Log("MsgC53",fn,DF4.format(z1)); /* print message of next actions */
      fn = datS.getName(); /* use file-name only within messages */

      cR = null; /* Compiler needs it */
      if(vn2.equals("Shape")) cR = new TSFileS(datS);
      else if(vn2.equals("Tile")) cR = new TSFileT(datS);
      else if(vn2.equals("World")) cR = new TSFileW(datS);
        /* create input-control due to requested file-type */

      /* open output-file using (buffered) 'unicode'-mode */
      cW = new TSFile(datZ); /* create and define file */
      if((is=cW.open(TSFile.OUT))!=null) { /* open file -- error occurred ? */
        Lg.Log("expFle15",is,fn); /* print errormessage */
        z2 += 1; /* register and count conversion-error */
        continue; /* process next file */
      } /* Error found while 'open' */

      is = cR.chkFKng(null,false); /* File-ID holen fr Ausgabe */
      if((is=cW.putData(is))!=null) { /* write record -- error? */
        Lg.Log("expFle16",is,fn); /* print errormessage */
        cW.close(); /* close output-file again */
        z2 += 1; /* register and count conversion-error */
        continue; /* process next file */
      } /* i/o-error occurred */
      if((is=cW.putData(null))!=null) { /* write CRLF -- error? */
        Lg.Log("expFle17",is,fn); /* print errormessage */
        cW.close(); /* close output-file again */
        z2 += 1; /* register and count conversion-error */
        continue; /* process next file */
      } /* i/o-error occurred */

      is = cR.open(TSFile.IN); /* open input and check type */
      if(is!=null) { /* error found during open of input-file */
        Lg.Log("expFle18",is,fn); /* print errormessage */
        cW.close(); /* close outputfile again */
        z2 += 1; /* register and count conversion-error */
        continue; /* process next file */
      } /* open-error input-file */

      mrkE = false; /* preset: no error, do not terminate */
      while((is=cR.getData())!=null) { /* copy all records of the file */
        if((is=cW.putData(is))!=null) { /* write record -- error? */
          Lg.Log("expFle19",is,fn); /* print errormessage */
          z2 += 1; /* register and count conversion-error */
          mrkE = true; /* set marker to 'error occurred' */
          break; /* terminate copy of lines */
        } /* i/o-error occurred */
      } /* copy all lines */
      is = cR.getErr(); /* get current error-message (if available) */
      if(is!=null) { /* error during read -- check message */
        Lg.Log("expFle20",is,fn); /* print errormessage */
        z2 += 1; /* register and count conversion-error */
        mrkE = true; /* register termination-request */
      } /* read-error occurred */

      cW.close(); /* close outputfile again */
      if((is=cW.getErr())!=null) Lg.Log("expFle22",is); /* print error */
      is = cR.close(); /* close input-file, too  */
      if(is!=null) { /* error occurred during close */
        Lg.Log("expFle21",is); /* print errormessage */
        z2 += 1; /* register and count conversion-error */
        continue; /* process next file */
      } /* file-error (close input) */

      if(mrkE) continue; /* error occurred -- continue with next file */
      if(!OV) continue; /* overwrite NOT requested -- next file */
      /* copy back of temporary file if overwrite is requested */
      is = "copy \""+datZ.getAbsolutePath()+"\" \""+
             datS.getAbsolutePath()+"\" "; /* create copy-command */
      if((i=exec(true,is,null,Lg))>0) /* error while exec */
        Lg.Log("MsgC49",datS.getAbsolutePath(),i); /* print errormessage */
    } /* process ALL files within directory */

    Lg.Skip(true); /* print empty line to log-file and screen */
    Lg.Log("expFle27",DF4.format(z1)); /* print result-message */
    Lg.Msg("expFle28",DF4.format(z2)); /* print result-message */
    Lg.Msg("expFle29",z1); /* print result-message */
    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* print Timestamp */

    Lg.Close(); /* close output to Log-file */
    return 0; /* terminate function without error-marker */
  }

 /**. <pre>
  *=====================================================================
  * Method "Merge" (-19-)
  * Merge two route-definitions and build one common route.
  * Options:
  *       4 - Copy Bufferfiles, too (-p)
  *       7 - Modify 'StaticDetailLevel' to hide overheadwire (-h)
  *       8 - DO NOT merge signaldefinitions (-s)
  *       9 - Overlay world-files (-o)
  *      16 - Extended output to LOG (-d,Hidden)
  * ##Merge (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int Merge( /* Streckendefinitionen mischen */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute              cRte,mRte; /* Streckendefinitionen (Basis) */
    TreeSet<TSTile>      Tle;    /* alle Tile-Definitionen */
    TreeSet<TSQuad>      QDf;    /* alle Quadrat-Definitionen */
    TSTile               cTle;   /* aktuelle Tile-Definitionen */
    TSQuad               cQDf,xQDf; /* current Quad-definitions (basis, merge) */
    TSChain              cC;     /* current chain for insert/resort of items */
    ArrayList<TSTrNde>   TrN;    /* neue TrackNode-DB-Tabelle */
    ArrayList<TSTrItm>   ItT;    /* aktuelle TrItem-Datenbank */
    TSTrNde              cTrN;   /* aktuelles TrackNode-DB-Element */
    TSVector             cNde;   /* current vector-node */
    TSTrItm              cIt;    /* aktuelle TrItem-DB-Element */
    TSTrItm01T           cIt01T; /* 'TrSignalDir'-entry (SignalItem) */
    TSScL                cSc;    /* aktuelle lokale Section */
    TSShL                cSh;    /* aktuellen lokalen Pfad */
    TSUiD                cUiD;   /* aktuelle UiD-Referenz */
    TSSnd                cSnd;   /* aktuelle Sound-Referenz */
    TSView               cVS,nVS; /* ViewSphere-Elements */
    TStType              cTp;    /* aktuelle ttype-Referenz */
    ArrayList<TSSigSh>   SgS;    /* Signal-Shape-Definitionen */
    TSSigSh              cSgS;   /* aktuelle Signal-Shape-Definition */
    ArrayList<TSSigSObj> SgSO;   /* Signal-SubObject-Definitions */
    TSSigSObj            cSgSO;  /* current signal-subobject-definition */
    ArrayList<TSSigTyp>  SgT;    /* Signal-Type-Definitionen */
    TSSigTyp             cSgT,xSgT; /* aktuelle Signal-Type-Definition */
    TSSigSgL             cSgSgL; /* aktuelle SignalLight-Definition */
    ArrayList<TSSigLTx>  SgX;    /* Signal-LightTexture-Definitionen */
    TSSigLTx             cSgX;   /* aktuelle Signal-LightTexture-Definition */
    ArrayList<TSSigLgt>  SgL;    /* Signal-Light-Definitionen */
    TSSigLgt             cSgL,xSgL; /* aktuelle Signal-Light-Definition */
    TSSigFle             cSgF;   /* aktuelle Signalscript-Definition */
    TSPath               cPth;   /* aktuelle (Routen-)Pfad-Definition */
//    TSPatPDP             cPDP;   /* current PDP-entry of path */
    TSSrv                cSrv;   /* aktuelle Service-Definition */
    TSTrf                cTrf;   /* aktuelle Traffic-Definition */
    TSAct                cAct;   /* aktuelle Activity-Definition */
    TSActSZ              cRSZ;   /* current reference-element (RestrictedSpeedZone) */
    File                 sdir,zdir,vdir,adir,dat; /* Dateidefinitionen */
    TSNameSet            TNme,SNme,XNme; /* temporary lists for names */
    LinkedHashMap<String,TSSigFle> SgF; /* Definitionen der Signal-Script-Files */
    TreeMap              FleT;   /* temp. table of file-def's (TSPath,TSServ,TSTrf) */
    int                  i,j,t,v; /* Arbeitswerte */
    String               is,js,RefNme;
    String[]             fl;  /* file-list */
    boolean              tdl1,tdl2; /* LO_Tiles vorhanden */
    Iterator             cI,xI; /* common Iterators */
    Iterator<TSTrNde>    aI;  /* Iterator of TrackNode-Table */
    Iterator<String>     sI;  /* String-Iterator */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("mrgRte01",fn,vn2); /* Vorlauf ausgeben */

    /* Systemdatei 1 lesen und auswerten */
    cRte = getRte(fn,2145); /* (3*5*11*13) process route-definition */
    if(cRte==null) return 5; /* error -- terminate function */
    /* 3='world', 5='tiles', 11='TD', 13='Sound' */
    /* Systemdatei 2 lesen und auswerten */
    mRte = getRte(vn2,1); /* process route-definition (to be merged) */
    if(mRte==null) return 5; /* error -- terminate function */

    if(!cRte.getInfo(0).equalsIgnoreCase(mRte.getInfo(0))) {
      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("mrgRte02"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 10; /* terminate function with errorcode */
    } /* different TS-systems were used */

    if(cRte.getInfo(1).equalsIgnoreCase(is=mRte.getInfo(1))) {
      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("mrgRte91",is); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 10; /* terminate function with errorcode */
    } /* TS-Routen identisch */

    /* Pfade ausgeben */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* aktuelle Werte */
    Lg.Msg("mrgRte03",cRte.getInfo(2)); /* aktuelle Werte */
    Lg.Msg("mrgRte04",cRte.getInfo(1)); /* aktuelle Werte */
    Lg.Msg("mrgRte05",mRte.getInfo(2)); /* aktuelle Werte */
    Lg.Msg("mrgRte06",is); /* aktuelle Werte */
    Lg.Skip(true); /* Leerzeile loggen */

    /* globale "tsection.dat" bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC05"); /* Aktionsmeldung ausgeben */

    dat = cRte.getFile(-1); /* get reference to file */
    i = getTS(dat,null);    /* and load 'tsection.dat' (global) */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC08",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC11",c3); /* Ergebnis melden */
    Lg.Log("MsgC14",ScN); /* Ergebnis melden */
    Lg.Log("MsgC17",c2); /* Ergebnis melden */
    Lg.Log("MsgC20",ShN); /* Ergebnis melden */
    Lg.Log("MsgC23",c4); /* Ergebnis melden */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mrgRte07"); /* Aktion melden */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(cRte,ScA,ShA); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* zusaetzliche Streckendateien laden */
    i = getType(cRte); /* 'ttype.dat' laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strukturquadrate laden (genaue Ausfuehrung) */
    i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC26",i); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Strukturquadrate laden (LO-Tiles) */
    tdl1 = true; /* annehmen: Lo_Tiles sind vorhanden */
    i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
    if(i>0) { /* Fehler beim Laden der Strukturquadrate */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC27",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    if(i<0) tdl1 = false; /* nicht mehr versuchen */

    /* Schienendatenbank laden */
    i = getDBF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    i = getITF(cRte,0); /* Schienendatenbank laden und pruefen (2. Teil) */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strassendatenbank laden */
    i = getDBF(cRte,1); /* Strassendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    if(i==0) { /* Datenbank ist vorhanden */
      i = getITF(cRte,1); /* Strassendatenbank laden und pruefen (2. Teil) */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* Datenbank(teil) ist vorhanden */

    /* World-Dateien laden und syntaktisch pruefen */
    i = getWF(cRte,false); /* World-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */
    /* Sound-Dateien laden und syntaktisch pruefen */
    i = getSF(cRte,false); /* World-Sound-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */

    /* Signal-Definitionen laden und ueberpruefen */
    i = getSCfg(cRte,cRte.getFile(21),null,false); /* load Signal-Configurations */
    if(i==0) /* Laden erfolgreich -- weiter testen */
      i = getSScr(cRte,cRte); /* Signal-Script-Definitionen laden */

    /* Achtung: Wenn keine Definitionen vorhanden ist, wird die Basistabelle beim
     * Mischen erzeugt. Deshalb ist es HIER NICHT zwingend notwendig.
     */
    /* Path-Definitionen werden geladen und ueberprueft */
    i = getPatF(cRte,true); /* Path-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Service-Definitionen werden geladen und ueberprueft */
    i = getSrvF(cRte,true); /* Service-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Traffic-Definitionen werden geladen und ueberprueft */
    i = getTrfF(cRte,true); /* Traffic-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Activity-Definitionen werden geladen und ueberprueft */
    i = getActF(cRte,true); /* Activity-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */


    /* all files were loaded -- continue with integrity-check */
    if((is=cRte.chkRte(Fo,true))!=null) { /* check route for integrity -- error found ? */
      if(is.charAt(0)!=' ') { /* error-message returned */
        Lg.Skip(true); /* skip line */
        Lg.Err("getRte23",is); /* print errormessage */
        Lg.Msg("MsgC60"); /* print message: 'terminating' */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* error found -- function terminated */
      if(EnaW) Lg.Log("chkRte00",is); /* Warning found -- print it */
    } /* error/warning found */

    /* BERFORE CHECKING: create dummy-world-files if requested. */
    if(Fo.chkMsk(9)) { /* overlay-mode is requested which implies this */
      /* Check all tile-definitions and create missing world-files */
      QDf = cRte.chgQDf(null); /* alle Quadrat-Definitionen holen */
      cI = cRte.getIt(10); /* Iterator fuer Tile-Definitionen */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
        while((cQDf=cTle.crQuad())!=null) { /* neue Quad-Definition erstellt */
          cQDf.chgTle(cTle); /* Rueckverkettung einfuegen */
          cQDf.chgMde(TSFile.OCB); /* set output-mode of world-file to CB */
          if(!QDf.add(cQDf)) { /* Strukturquadrat in globale Kette einfuegen */
            Lg.Skip(true); /* Leerzeile loggen */
            Lg.Msg("MsgC31",cQDf.getInf(0)); /* Fehlermeldung ausgeben */
            Lg.Close(); /* close output to Log-file */
            return 6; /* terminate function with errorcode */
          } /* requested quad already exists -- no insert possible */
        } /* -while- neue Quad-Definition wurde erzeugt */
      } /* -while- process all tile-definitions */
    } /* Dummy-world-files were created */

    /* "world"-Dateien bearbeiten und neue Integritaet herstellen */
    chkWrld(cRte,null,132); /* World-Dateien erweitert pruefen (128+4) */
      /* Modus: Aenderungen melden, kein Renum */

    /* Sound-Dateien bearbeiten und neue Integritaet herstellen */
    i = chkSnd(cRte,null,128); /* Sound-Dateien erweitert pruefen */
      /* Modus: Aenderungen melden */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("MsgC33",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC35"); /* Aktionsmeldung ausgeben */
    if(cRte.get$TrN(0)<=0) { /* Schienendatenbank NICHT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC36"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datenbank nicht vorhanden */

    i = chkDBTab(cRte,0); /* Schienendatenbank bearbeiten */
    if(i<0) return 5; /* Systemfehler -- Ende */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC37",i); /* Aktionsmeldung */
    Lg.Skip(false); /* Leerzeile loggen */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC39"); /* Aktionsmeldung ausgeben */
      i = chkDBTab(cRte,1); /* Strassendatenbank bearbeiten */
      if(i<0) return 5; /* Systemfehler -- Ende */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("MsgC40",i); /* Aktionsmeldung */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Strassendatenbank vorhanden und geladen */

    /* extended check of local 'tsection.dat'
     * Attention: This method MUST NOT be invoked unless worldfiles AND
     * database (track/road) is stored again (or neither). */
    chkTSL(cRte,ScN,ShN); /* check file and compact it */

    i = chkPat(cRte); /* Pfad-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkSrv(cRte,true); /* Service-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkTrf(cRte,true,false); /* Traffic-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkAct(cRte,true); /* process activity-definitions */
    if(i>0) return 5; /* systemerror occurred -- terminate */

    /* Basis-Informationen der zu mischende Routendefinition laden */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mrgRte08"); /* Aktion melden */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(mRte,ScA,ShA); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* zusaetzliche Streckendateien laden */
    i = getType(mRte); /* 'ttype.dat' laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strukturquadrate laden (genaue Ausfuehrung) */
    i = getTDF(mRte,0); /* Steuerungsdatei(en) laden */
    if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC26",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Strukturquadrate laden (LO-Tiles) */
    tdl2 = true; /* annehmen: Lo_Tiles sind vorhanden */
    i = getTDF(mRte,1); /* Steuerungsdatei(en) laden */
    if(i>0) { /* Fehler beim Laden der Strukturquadrate */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC27",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    if(i<0) tdl2 = false; /* nicht mehr versuchen */

    /* Basis-Informationen mischen
     * Aus der zu mischenden Route werden doppelte Definitionen entfernt,
     * sodass diese Informationen erst garnicht mitgeladen werden
     */
    /* Pruefen ob Routendefinitionen kompatibel/disjunkt */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mrgRte10"); /* Aktion melden */
    v = 0; /* Anzahl der doppelten Quadranten initialisieren */
    Tle = cRte.getTle(0,false); /* get current Tile-definitions */
    QDf = mRte.chgQDf(null); /* alle Quadrat-Definitionen holen */
    cI = mRte.getIt(10); /* Iterator fuer Tile-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      /* alle Tile-Definitionen der einzumischenden Route bearbeiten */
      cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
      if(Tle.contains(cTle)) { /* Tile ist in beiden Strecken vorhanden */
        if(Fo.chkMsk(9)) { /* overlay-mode is requested */
          cTle.chgFlag(1); /* mark: world-overlay-mode within tile */
          Lg.Log("mrgRte1A",cTle.getId(true)); /* report action */
        } else { /* no overlay -- do not merge tile */
          cI.remove(); /* Tile aus Route entfernen */
          for(cQDf=cTle.chgQDf(null);cQDf!=null;cQDf=cQDf.chgQDf(null))
            /* auch die zugeordneten Quadrate entfernen */
            if(QDf!=null) QDf.remove(cQDf); /* aus globalem Speicher */
          Lg.Err("mrgRte11",cTle.getId(true)); /* Doppelten Tile melden */
        } /* do not merge whole tile */
        v += 1; /* Doppelter Quadrant registrieren */
      } /* tile exists within BOTH routes */
    } /* -while- process all tile-definitions */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("mrgRte12",v); /* Aktion melden */

    /* Auch LO-Tiles pruefen */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mrgRte13"); /* Aktion melden */
    t = 0; /* Anzahl der doppelten Quadranten initialisieren */
    if(tdl1 && tdl2) { /* beide Strecken haben LO-Tiles -- prufen */
      Tle = cRte.getTle(1,false); /* get current LO-Tile-definitions */
      cI = mRte.getIt(11); /* Iterator fuer Tile-Definitionen */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        /* alle Tile-Definitionen der einzumischenden Route bearbeiten */
        cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
        if(Tle.contains(cTle)) { /* Tile ist in beiden Strecken vorhanden */
          /* Attention: 'overlay' has no meaning here */
          cI.remove(); /* Tile aus Route entfernen */
          Lg.Err("mrgRte14",cTle.getId(true)); /* Doppelten Tile melden */
          t += 1; /* Doppelter Quadrant registrieren */
        } /* Tile-Definition war vorhanden */
      } /* -while- alle LO-Tile-Definitionen */
      if(mRte.getTle(1,false).isEmpty()) tdl2 = false; /* no more LO-Tiles */
    } /* maximal EINE Strecke hat LO-Tiles */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("mrgRte15",t); /* Aktion melden */

    /* Mischen noch notwendig ? */
    if(mRte.getTle(0,false).isEmpty()) { /* no more tiles for 'Merge' */
      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("mrgRte28"); /* Aktion melden */
      return 0; /* Funktion abbrechen */
    } /* keine Tiles mehr zum Mischen */

    /* weitere Routendefinitionen (relativ zur NEUEN Basis laden */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mrgRte09"); /* Aktion melden */
    /* Schienendatenbank laden */
    i = getDBF(mRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    i = getITF(mRte,0); /* Schienendatenbank laden und pruefen (2. Teil) */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strassendatenbank laden */
    i = getDBF(mRte,1); /* Strassendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    if(i==0) { /* Datenbank ist vorhanden */
      i = getITF(mRte,1); /* Strassendatenbank laden und pruefen (2. Teil) */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* Datenbank(teil) ist vorhanden */

    /* World-Dateien laden und syntaktisch pruefen */
    i = getWF(mRte,false); /* World-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */
    /* Sound-Dateien laden und syntaktisch pruefen */
    i = getSF(mRte,false); /* World-Sound-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */

    /* Signal-Definitionen laden und ueberpruefen */
    if(Fo.chkMsk(8)) { /* DO NOT MERGE Signal-files -- use original one */
      i = getSCfg(mRte,cRte.getFile(21),null,false); /* load Signal-Configurations */
      if(i==0) /* configuration successfully loaded -- get scripts */
        i = getSScr(mRte,cRte); /* load signal-script-definitionen */
    } else { /* normal: load configuration from merge-route */
      i = getSCfg(mRte,mRte.getFile(21),null,false); /* load Signal-Configurations */
      if(i==0) /* configuration successfully loaded -- get scripts */
        i = getSScr(mRte,mRte); /* load signal-script-definitionen */
    } /* signal-definition has been loaded */

    /* Path-Definitionen werden geladen und ueberprueft */
    i = getPatF(mRte,true); /* Path-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Service-Definitionen werden geladen und ueberprueft */
    i = getSrvF(mRte,true); /* Service-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Traffic-Definitionen werden geladen und ueberprueft */
    i = getTrfF(mRte,true); /* Traffic-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Activity-Definitionen werden geladen und ueberprueft */
    i = getActF(mRte,true); /* Activity-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Alle Merge-Dateien wurden geladen -- Integritaet bearbeiten */

    /* "world"-Dateien bearbeiten und neue Integritaet herstellen */
    chkWrld(mRte,null,132); /* World-Dateien erweitert pruefen (128+4) */
      /* Modus: Aenderungen melden, kein Renum */

    /* Sound-Dateien bearbeiten und neue Integritaet herstellen */
    i = chkSnd(mRte,null,128); /* Sound-Dateien erweitert pruefen */
      /* Modus: Aenderungen melden */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("MsgC33",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC35"); /* Aktionsmeldung ausgeben */
    if(mRte.get$TrN(0)<=0) { /* Schienendatenbank NICHT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC36"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datenbank nicht vorhanden */

    i = chkDBTab(mRte,0); /* Schienendatenbank bearbeiten */
    if(i<0) return 5; /* Systemfehler -- Ende */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC37",i); /* Aktionsmeldung */
    Lg.Skip(false); /* Leerzeile loggen */

    if(mRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC39"); /* Aktionsmeldung ausgeben */
      i = chkDBTab(mRte,1); /* Strassendatenbank bearbeiten */
      if(i<0) return 5; /* Systemfehler -- Ende */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("MsgC40",i); /* Aktionsmeldung */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Strassendatenbank vorhanden und geladen */

    i = chkPat(mRte); /* Pfad-Definitionen der Misch-Route bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkSrv(mRte,true); /* Service-Definitionen der Misch-Route bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkTrf(mRte,true,false); /* Traffic-Definitionen der Misch-Route bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkAct(mRte,true); /* process activity-definitions */
    if(i>0) return 5; /* systemerror occurred -- terminate */

    /* lokale 'tsection.dat' bearbeiten und dann zusammenmischen */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mrgRte16"); /* Aktion melden */

    i = cRte.get$Sc(false); /* naechste freie Section holen */
    j = cRte.get$Sh(false); /* naechsten freien Pfad holen */
    /* zweite lokale 'tsection.dat' pruefen und bearbeiten */
    chkTSL(mRte,i,j); /* Pruefung der Datei durchfuehren */

    /* beide Ausgabe-Ketten miteinander verbinden */
    cSh = cRte.chgShR(null); /* get start of shape-chain */
    if(cSh==null) cRte.chgShR(mRte.chgShR(null)); /* Kette umhaengen */
      /* basic-route do not contains dynamic sections -- use merge-route */
    else { /* lokale 'tsection.dat vorhanden -- verbinden */
      /* BOTH routes contain dynamic sections -- connect them */
      while(cSh.chgShR(null)!=null) cSh = cSh.chgShR(null); /* zum Ende */
      cSh.chgShR(mRte.chgShR(null)); /* Verkettung herstellen */
    } /* lokale 'tsection.dat'-Ketten wurden verbunden */
    cSc = cRte.chgScR(null);/* get start of section-chain */
    if(cSc==null) cRte.chgScR(mRte.chgScR(null)); /* Kette umhaengen */
    else { /* lokale 'tsection.dat vorhanden -- verbinden */
      while(cSc.chgScR(null)!=null) cSc = cSc.chgScR(null); /* zum Ende */
      cSc.chgScR(mRte.chgScR(null)); /* Verkettung herstellen */
    } /* lokale 'tsection.dat'-Ketten wurden verbunden */

    /* Gemeinsame Tile-Kette bilden und Tile-Definitionen kopieren */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mrgRte17"); /* Aktion melden */

    TNme = new TSNameSet(true,".ace"); /* initialize list of Terrtex-Names */
    SNme = new TSNameSet(false,".s"); /* initialize list of Shape-Names */
    XNme = new TSNameSet(false,".wav"); /* initialize list of Names (texture, ...)*/
    /* Mischen der Routendefinitionen durchfuehren */
    c4 = 0; /* Zaehler initialisieren */
    if((is=cpyTile(cRte,false,Fo.chkMsk(4)))!=null) { /* Fehler erhalten */
      /* Verzeichnis konnte nicht erstellt werden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("Msg010",is); /* Abbruchmeldung */
      Lg.Close(); /* close output to Log-file */
      return 20; /* terminate function with errorcode */
    }

    /* Alle Tile-Definitionen der Misch-Strecke kopieren */
    xQDf = null; /* compiler needs it */
    cC   = null; /* compiler needs it */
    Tle = cRte.getTle(0,false); /* get current Tile-definitions */
    QDf = cRte.chgQDf(null); /* alle Quadrat-Definitionen holen */
    cI = mRte.getIt(10); /* get Iterator of ALL Tile-definitions (merge-route) */
    while(cI.hasNext()) { /* More definitions available? */
      cTle = (TSTile)cI.next(); /* get next Tile-definition */
 if(PrMsk.chkMsk(31)) Lg.Msg("Msg010","Reference to Tile(x) = "+(cTle!=null)); // ##!D
      if(!cTle.chgFlag(0)) /* overlay NOT required -- handle it */
        if(!Tle.add(cTle)) throw new /* Tile der Originalstrecke hinzufuegen */
          IllegalStateException(TSLogg.getMsg("Msg905","TSUtil.Merge.cTle("+
            cTle.getNme(0)+")")); /* Abbruch Programm mit Systemfehler */
      /* Zusatz: Fuer jeden zu kopierten Tile sind folgende Aktionen
       * zusaetzlich notwendig:
       *  - hinzufuegen in den globalen Speicher der Original-Route
       *  - Uberpruefen der zugehoerigen World-Datei(en) und File-Namen holen
       *  - Uberpruefen der zugehoerigen Sound-Datei(en) und File-Namen holen
       */
      for(cQDf=cTle.chgQDf(null);cQDf!=null;cQDf=cQDf.chgQDf(null)) {
        /* process all quad-definitions, which are connected to the tile.
         * Normally, this should only be one. */
        if(!cTle.chgFlag(0)) /* overlay NOT required -- handle it */
          if(!QDf.add(cQDf)) throw new /* add quad of merge-route to basis-route */
            IllegalStateException(TSLogg.getMsg("Msg905","TSUtil.Merge.cQDf("+
              cQDf.getInf(0)+")")); /* could not be added -- terminate with error */

        if(Fo.chkMsk(7)) { /* Veraendern des 'StaticDetailLevel gefordert */
          i = Fo.getInt(3,0); /* neue Level-Angabe holen */
          cC = cQDf.chgWTab(null,0); /* get current chain of UiD-objects */
          for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
            if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
            if(!cUiD.isTrack()) continue; /* keine Schienendefinition */
            if(cUiD.getSL()!=0) continue; /* kein gueltiger Level fuer Schienen */
            cUiD.setSL(i); /* insert StaticDetailLevel (explicitely) into source-object */
            cC.reSort(cUiD); /* Element neu einsortieren */
 if(PrMsk.chkMsk(31)) Lg.Log("Msg010",cUiD.toStr()); // ##!D
          } /* -for- alle Eintraege der World-datei bearbeiten */
        } /* Veraendern des 'StaticDetailLevel gefordert */

        if(cTle.chgFlag(0)) { /* get corresponding Quad from basis-route */
          xQDf = cQDf.fndQuad(cRte,0,0); /* search for corresponding Quad */
          if(xQDf==null) /* corresponding quad from basis-route was NOT found */
  ; // Fehlermeldung
          cC = xQDf.chgWTab(null,0); /* get current chain of UiD-objects */
        } /* search for corresponding Quad from basis-route */

        for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
          /* nicht belegte UiD-Eintraege gibt es nicht */
          if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
          if(cUiD.isCtl()) continue; /* kein aktiver UiD-Eintrag */
          if(cTle.chgFlag(0)) { /* insert current UiD into chain of target-quad */
            /* Attention: 'UiD'-chain of merge-quad becomes corrupted, because object
             * is NOT removed from original chain. (source-chain)
             */
            cUiD.$reNew(xQDf.getOId(),xQDf.getWId()); /* definition becomes unambigous */
            cC.add(cUiD); /* and add world-entry to new chain */
            cUiD.chgQDf(xQDf); /* insert back-reference to correct quad-basis-definition */
            /* Attention: ALL data-items, which contain a reference to a Quad must be changed,
             *            so that the original quads (of basis-route) are connected.
             */
            if(cUiD instanceof TSTrkObj) { /* adjust additional references of type 'TrackObj' */
              if(!cUiD.chkMsk(8)) /* valid JNodePosn-Definition found */
                if(((TSTrkObj)cUiD).fndWrld(QDf)==null) /* target-quad could not be assigned */
  ; // Fehlermeldung
            } /* additional types of UID-entry has been adjusted */
          } /* new element is inserted into new chain */
          SNme.add(cUiD.chgNme(null)); /* register Shape-Name if available */
          if(cUiD instanceof TSTrkObj) /* Zusatzbearbeitung: 'TrackObj' */
            SNme.add(((TSTrkObj)cUiD).modNme(null)); /* register original Shape-Name */
          if(cUiD instanceof TSSpeed) /* Zusatzbearbeitung: 'Speedpost' */
            SNme.add(((TSSpeed)cUiD).chgTNme(null)); /* register additional name */
        } /* -for- alle Eintraege der World-datei bearbeiten */
        if(cTle.chgFlag(0)) cC = xQDf.chgSTab(null,0);
          /* get current chain of Snd-objects from basis-route */
        for(cSnd=cQDf.getSnd(true);cSnd!=null;cSnd=cQDf.getSnd(false)) {
          /* nicht belegte Eintraege gibt es nicht */
          if(cSnd.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
          if(cTle.chgFlag(0)) { /* insert current Snd into chain of target-quad */
            /* Attention: 'Snd'-chain of merge-quad becomes corrupted, because object
             * is NOT removed from original chain. (source-chain)
             */
            cSnd.$reNew(xQDf.getOId(),xQDf.getSId()); /* definition becomes unambigous */
            cC.add(cSnd); /* and add world-entry to new chain */
          } /* new element is inserted into new chain */
          SNme.add(cSnd.chgNme(null)); /* register (Shape-)Name if available */
        } /* -for- alle Eintraege der 'Sound'-Datei bearbeiten */

        if(!cTle.chgFlag(0)) continue; /* no overlay required -- do not process viewsphere */
        if((i=xQDf.chg$View(-1))==0) continue; /* no viewsphere must be transfered */
        if(cQDf.chg$View(-1)==0) { /* basis-route contains no viewsphere -- transfer it */
          cQDf.chg$View(i); /* set new number of viewshere-definitions */
          cQDf.chgView(xQDf.chgView(null)); /* transfer viewsphere-definitions */
          continue; /* all viewsphere-definitions have been transfered */
        } /* viewsphere-definitions fully processed */
        /* Now: BOTH viewsphere-definitions are valid -- merge them */
        cVS = cQDf.chgView(null); /* get basis-viewsphere of basis-route */
        if(cVS.mrgVal(xQDf.chgView(null))!=null) /* merge position and radius */
  ; // Fehlermeldung
        xI = xQDf.chgView(null).getIt(); /* get iterator for all child-definitions */
        while(xI.hasNext()) cVS.addVS((TSView)xI.next()); /* add sphere(s) to end of chain */
        i = cVS.renID(0); /* renumber whole chain of viewsphere-definitions and count them */
        cQDf.chg$View(i); /* insert new value of valid definitions */
      } /* -for- process all quad-definitions, which are connected to tile */
      /* '*.t' - Datei analysieren und nach 'newRoute' kopieren */
      if(cTle.chgFlag(0)) continue; /* do not copy marked tiles */
      sdir = mRte.getFile(18); /* Pfad der Tile-Dateien (Quelle) */
      zdir = cRte.getFile(48); /* Pfad der Tile-Dateien (Ziel) */
      mveTile(cTle,sdir,zdir,Double.NaN,TNme,false,Fo.chkMsk(4));
        /* Tile-Datei mit Datendateien kopieren, Dateiformat NICHT
         * aendern. Puffer kopieren falls gefordert.  Terrainnamen
         * registrieren
         */
    } /* -while- process all Tile-definitions */

    /* Auch LO-Tiles mischen und kopieren */
    /* Attention: Lo-Tiles are NOT marked with the overlay-marker. So,
     * this need not be checked and handled. Instead of this, they are
     * already removed from tile-chain.
     */
    c4 = 0; /* Zaehler initialisieren */
    if(tdl1) { /* Basis-Strecke hat LO-Tiles -- kopieren */
      if((is=cpyTile(cRte,true,Fo.chkMsk(4)))!=null) { /* Fehler erhalten */
        /* directory could not be created */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("Msg010",is); /* Abbruchmeldung */
        Lg.Close(); /* close output to Log-file */
        return 20; /* terminate function with errorcode */
      } /* directory could not be created -- terminate function with errorcode */
    } /* Basis-Strecke hat LO-Tile-Definitionen */
    if(tdl2) { /* zu mischende Strecke hat LO-Tiles */
      sdir = mRte.getFile(19); /* Pfad der Tile-Dateien (Quelle) */
      zdir = cRte.getFile(49); /* Pfad der Tile-Dateien (Ziel) */
      if(zdir==null) { /* directory is not accessible */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("MsgC63",cRte.getInfo(49)); /* Abbruchmeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 20;  /* terminate function with errorcode */
      } /* directory is not accessible -- terminate function with errorcode */
      if(tdl1) /* Basis-Strecke hat AUCH LO-Tiles -- mischen */
        Tle = cRte.getTle(1,false); /* get current LO-Tile-definitions */
      else { /* keine LO-Tiles bei Basisstrecke -- umsetzen */
        Tle = cRte.getTle(1,true); /* create LO-Tiles and store them */
        /* copy additional definitions */
        cRte.setInt(9,mRte.getInt(9)); /* Wert uebertragen */
        cRte.setInt(11,mRte.getInt(11)); /* Wert uebertragen */
        tdl1 = true; /* jetzt sind LO-Tiles vorhanden */
      } /* Basistrecke hatte KEINE LO-Tiles */
 if(PrMsk.chkMsk(31)) Lg.Msg("Msg010","Reference to LO-Tiles = "+(Tle!=null)); // ##!D
      cI = mRte.getIt(11); /* Iterator fuer Tile-Definitionen */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
 if(PrMsk.chkMsk(31)) Lg.Msg("Msg010","Reference to LO-Tile(x) = "+(cTle!=null)); // ##!D
        if(!Tle.add(cTle)) /* Tile der Originalstrecke hinzufuegen */
 /* SYSTEMFEHLER -- Meldung fehlt noch */
 if(PrMsk.chkMsk(31)) Lg.Log("Msg010",cTle.toStr()); // ##!D
        mveTile(cTle,sdir,zdir,Double.NaN,null,false,true);
          /* Tile-Datei mit Datendateien kopieren, Dateiformat NICHT
           * aendern. LO-Tile-Puffer immer kopieren.
           */
      } /* alle LO-Tile-Definitionen */
    } /* Zu mischende Strecke hat LO-Tiles */

    /* Schienendatenbank zusammenmischen */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mrgRte18"); /* Aktion melden */

    for(t=0;t<2;t+=1) { /* beide Datenbank-Typen bearbeiten */
      aI = mRte.getIt(t); /* Iterator fuer TrackNode-Definitionen */
      if(aI!=null) { /* Track-Node-DB (aus Merge-Route) ist vorhanden.
        * Falls eine zusaetzliche TrackNode-DB NICHT vorhanden ist, bleibt die
        * originale TrackNode-Datenbank unveraendert.
        */
        TrN = cRte.getTrN(t,0); /* aktuelle TrackNode-Datenbank holen (evtl. 'null') */
        i = mRte.get$TrN(t) + 10; /* neue Groesse der TrackNode-DB */
          /* '10' ist Reserve, die mit 'trimToSize()' wieder freigegeben wird */
        if(TrN==null) TrN = cRte.getTrN(t,i); /* Neue TrackNode-Tabelle erstellen und setzen */
        else TrN.ensureCapacity(TrN.size()+i); /* TrackNode-Tab. wurde neu erstellt/angepasst */
        i = j = TrN.size(); /* Anzahl der bereits vorhandenenen Elemente */
        /* 'i+1' ist neue Start-ID fuer die Erweiterung */
        while(aI.hasNext()) { /* Alle TrackNode-Definitionen bearbeiten */
          if((cTrN=aI.next())==null) continue; /* Fehl-Eintrag uebergehen */
          cTrN.chgIx(++i); /* neue Kennung des TrackNodes eintragen */
          for(v=0;v<cTrN.getTyp();v+=1) /* alle Verkettungen veraendern */
            if(!cTrN.chkMsk(v)) cTrN.chgTrN(v,null).addNr(j); /* Ref-Nr anpassen */
              /* Node-Index erhoehen falls keine NUll-Verkettung vorliegt */
          TrN.add(cTrN); /* neues TrackNode-Element setzen */

          if(!Fo.chkMsk(9)) continue; /* overlay-mode is NOT active */
          /* due to overlay-mode all Quad-references have to be reassigned */
          for(v=0;v<cTrN.get$Nde();v+=1) { /* check/modify all vector-references */
            cNde = cTrN.chgNde(v,null); /* get current vector-object */
            cNde.fndWrld(QDf,true); /* and reassign first quad-reference */
            cNde.fndWrld(QDf,false); /* reassign second quad-reference */
          } /* -for- check/modify all vector-references */
        } /* -while- alle Elemente kopieren */
        TrN.trimToSize(); /* Speicher der TrackNode-Tabelle optimieren */
        cRte.setInt(t,i); /* neue Anzahl der Elemente eintragen */
      } /* TrackNode-DB (Merge) vorhanden */

      j = t + 2; /* Kennung fuer Element-Speicher */
      cI = mRte.getIt(j); /* Iterator auf TrItem-Tabelle holen */
      if(cI!=null) { /* anzuhaengende TrItem-DB ist vorhanden */
        ItT = cRte.getTrI(t,0); /* aktuelle TrItemTabelle holen */
        i = mRte.get$TrI(t) + 10; /* neue Groesse der TrItem-DB */
          /* '10' ist Reserve, die mit 'trimToSize()' wieder freigegeben wird */
        if(ItT==null) ItT = cRte.getTrI(t,i); /* Neue TrItem-Tabelle erstellen und setzen */
        else ItT.ensureCapacity(ItT.size()+i); /* TrItem-Tab. wurde neu erstellt/angepasst */
        i = ItT.size(); /* Anzahl der bereits vorhandenenen Elemente */
        /* 'i' ist neue Start-ID fuer die Erweiterung
         * (vergleiche Kommentar in 'putdb()' warum dies moeglich ist)
         */
        while(cI.hasNext()) { /* alle TrItem-Definitionen bearbeiten */
          cIt = (TSTrItm)cI.next(); /* naechste TrItem-Definition */
          if(cIt==null) continue; /* fehlender Eintrag nicht bearbeiten */
          cIt.setNr(i++); /* neue TrItem-Kennung eintragen und Benutzung zaehlen */
            /* Achtung: Originalnummer ('getNr(true)') bleibt erhalten */
          ItT.add(cIt); /* Element an aktuelle Tabelle anfuegen */

          if(!Fo.chkMsk(9)) continue; /* overlay-mode is NOT active */
          cIt.fndWrld(QDf,0); /* reassign first quad-reference */
          cIt.fndWrld(QDf,1); /* reassign second quad-reference */
          if(!(cIt instanceof TSTrItm01)) continue; /* no more quad-references */
          if(!cIt.chkMsk(22)) continue; /* no (valid) entries within table */
          xI = ((TSTrItm01)cIt).getSgD(0).iterator(); /* get iterator for table */
          while(xI.hasNext()) { /* process all 'TrSignal(R)Dir'-entries */
            cIt01T = (TSTrItm01T)xI.next(); /* get next 'TrSignal(R)Dir'-entry */
            if(cIt01T==null) continue; /* entry not used -- skip it */
            cIt01T.fndWrld(QDf); /* reassign quad-reference */
          } /* -while- process all 'TrSignal(R)Dir'-entries */
        } /* -while- copy all TrItem-definitions */
        ItT.trimToSize(); /* Speicher der TrItem-Tabelle optimieren */
      } /* TrItem-DB vorhanden */
    } /* beide Datenbank-Typen (tdb,rdb) */

    /* Weitere Dateien zusammenmischen */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mrgRte30"); /* Aktion melden */

    j = mRte.set$Type(0); /* Anzahl der ttype-Definitionen */
    if(cRte.set$Type(0)<=0) { /* keine ttype-Definitionen der Basis */
      cRte.set$Type(j); /* neue ttype-Definitionen erstellen */
      for(i=0;i<j;i+=1) { /* alle Definitonen bearbeiten */
        cTp = mRte.chgType(i,null); /* aktuellen Eintrag holen */
        cRte.chgType(i,cTp); /* und neu setzen */
        SNme.add(cTp.getNme(1)); /* Dateiname registrieren */
        SNme.add(cTp.getNme(2)); /* Dateiname registrieren */
      } /* alle ttype-Definitionen kopieren */
    } else { /* ttype-Definitionen muessen hinzugefuegt werden */
      Lg.Skip(false); /* Leerzeile loggen */
      sdir = mRte.getFile(16); /* Basis-Source-Verzeichnis erstellen */
      for(i=0;i<j;i+=1) { /* alle Definitonen bearbeiten */
        cTp = mRte.chgType(i,null); /* aktuellen Eintrag holen */
        if((v=cRte.addType(cTp))>=0) cTp.chgNr(v);
          /* Eintrag schon vorhanden -- ID anpassen */
        else tty:{ /* Eintrag wurde hinzugefuegt -- SMS bearbeiten */
          v = -v - 1; /* aktuellen Index des Eintrags berechnen */
          is = cTp.getNme(1); /* ersten Dateinamen holen */
          if((i=cpySMS(cRte,sdir,is,v))>0) break tty;
          is = cTp.getNme(2); /* zweiten Dateinamen holen */
          if((i=cpySMS(cRte,sdir,is,v))>0) break tty;
        } /* hinzugefuegten Eintrag bearbeiten */
      } /* alle ttype-Definitionen bearbeiten */
    } /* Definitionen mischen */

    Lg.Skip(true); /* add empty line in every case */
    if(Fo.chkMsk(8)) /* DO NOT MERGE Signal-files -- print message */
      Lg.Msg("mrgRte4Z"); /* report action */
    else { /* signal-definitions must be merged -- execute it */
      /* Merge signal-definitions */
      Lg.Msg("mrgRte40"); /* report action */

      if(mRte.get$SgS(false)>0) { /* Signal-Shape-Definitionen sind vorhanden */
        SgS = cRte.getSigS(0); /* aktuelle Signal-Shape-Definitionen holen */
        cI = mRte.getIt(21); /* Iterator ueber Signal-Shape-Definitionen holen */
        i = -1; /* Nummer des Shapes initialisieren */
        while(cI.hasNext()) { /* alle Signal-Shape-Definitionen bearbeiten */
          i += 1; /* Nummer des Shapes fortschreiben */
          if((cSgS=(TSSigSh)cI.next())==null) continue;
          if(cSgS.incCnt(0)==0) continue; /* Shape nicht genutzt */
          is = cSgS.getNme(); /* Shape-Name des Eintrags */
          if(cRte.fndSigS(is)!=null) { /* Eintrag schon definiert */
            if(EnaW) Lg.Log("mrgRte41",is,i); /* Meldung ausgeben */
            continue; /* naechster Eintrag pruefen */
          } /* Eintrag schon definiert -- naechster Eintrag pruefen */
          SgS.add(cSgS); /* Signal-Shape neu hinzufuegen */
          SNme.add(is); /* Shape-Name merken */
          SgSO = cSgS.getSOT(0); /* get current table of Signal-Sub-Objects */
          v = SgSO.size(); /* get number of defined Subobjects */
          for(j=0;j<v;j+=1) { /* alle Subobjekte bearbeiten */
            cSgSO = SgSO.get(j); /* get requested Subobject-definition */
            if(cSgSO==null) continue; /* keine Referenz vorhanden */
            cSgT = cSgSO.chgSigT(null); /* Type-Referenz holen */
            if(cSgT==null) continue; /* keine Referenz vorhanden */
            is = cSgT.getNme(); /* Type-Name des Eintrags */
            if((xSgT=cRte.fndSigT(is))!=null) { /* Eintrag schon definiert */
              Lg.Err("mrgRte43",is,i,j); /* Fehlermeldung ausgeben */
              cSgSO.chgSigT(xSgT); /* neue Type-Referenz einsetzen */
              continue; /* naechster Eintrag pruefen */
            } /* Eintrag schon definiert -- naechster Eintrag pruefen */
            cSgT.setMsk(31); /* Eintrag fuer das Mischen selektieren */
          } /* alle Subobjekte bearbeiten */
        } /* alle Signal-Shape-Definitionen kopieren */
      } /* neue Signal-Shape-Definitionen vorhanden */
      if(mRte.get$SgT(false)>0) { /* Signal-Type-Definitionen sind vorhanden */
        SgT = cRte.getSigT(0); /* aktuelle Signal-Type-Definitionen holen */
        cI = mRte.getIt(22); /* Iterator ueber Signal-Type-Definitionen holen */
        i = -1; /* Nummer des Types initialisieren */
        while(cI.hasNext()) { /* alle Signal-Type-Definitionen bearbeiten */
          i += 1; /* Nummer des Types fortschreiben */
          if((cSgT=(TSSigTyp)cI.next())==null) continue;
          if(!cSgT.chkMsk(31)) continue; /* Signaltype NICHT genutzt */
          SgT.add(cSgT); /* Signal-Type neu hinzufuegen */
          v = cSgT.get$SgL(0); /* Anzahl der verbundenen SignalLights */
          for(j=0;j<v;j+=1) { /* alle SignalLight-Def's bearbeiten */
            cSgSgL = cSgT.chgSgL(j,null); /* aktuelle SignalLight-Def. holen */
            if(cSgSgL==null) continue; /* keine Referenz -- weiter */
            cSgL = cSgSgL.chgLRef(null); /* Light-Referenz des Eintrags */
            if(cSgL==null) continue; /* keine SignalLight-Referenz vorhanden */
            if((xSgL=cRte.isSigL(cSgL))!=null) { /* Eintrag schon definiert */
              if(EnaW) Lg.Log("mrgRte44",null,i,j); /* Fehlermeldung ausgeben */
              cSgSgL.chgLRef(xSgL); /* neue Licht-Referenz einsetzen */
              xSgL.incCnt(1); /* neue Referenz zaehlen */
              continue; /* naechster Eintrag pruefen */
            } /* Eintrag schon definiert -- naechster Eintrag pruefen */
            /* keinen identischen Eintrag gefunden */
            is = js = cSgL.chgNme(null); /* Licht-Referenzname des Eintrags */
            while(cRte.fndSigL(is)!=null) is += "$"; /* Name veraendern */
            if(!js.equals(is)) { /* Name wurde veraendert! */
              if(EnaW) Lg.Log("mrgRte45",js,is,0); /* Meldung ausgeben */
              cSgL.chgNme(is); /* neuen Licht-Referenzname des Eintrags setzen */
            } /* Name angepasst weil mehrfach vorhanden */
            cSgL.setMsk(31); /* Eintrag fuer das Mischen selektieren */
          } /* alle SignalLight's bearbeiten */
          cSgX = cSgT.chgLTx(null); /* aktuelle SignalLight-Texture */
          if(cSgX!=null) { /* Referenz ist vorhanden */
            is = js = cSgX.chgNme(null); /* LichtTexturname des Eintrags */
            if((cSgX=cRte.isSigTx(cSgX))!=null) { /* Eintrag schon definiert */
              if(EnaW) Lg.Log("mrgRte47",i); /* Fehlermeldung ausgeben */
              cSgT.chgLTx(cSgX); /* neue LightTexture-Referenz einsetzen */
              cSgX.incCnt(1); /* neue Referenz zaehlen */
              continue; /* naechster Eintrag pruefen */
            } /* Eintrag schon definiert -- naechster Eintrag pruefen */
            cSgX = cSgT.chgLTx(null); /* Texturreferenz nochmal holen */
            while(cRte.fndSigX(is)!=null) is += "$"; /* Name veraendern */
            if(!js.equals(is)) { /* Name wurde veraendert! */
              if(EnaW) Lg.Log("mrgRte48",js,is,0); /* Meldung */
              cSgX.chgNme(is); /* neuen LichtTexturnamen des Eintrags setzen */
            } /* Name angepasst weil mehrfach vorhanden */
            cSgX.setMsk(31); /* Eintrag fuer das Mischen selektieren */
          } /* Signal-LightTexture-Referenz bearbeitet */
        } /* alle Signal-Type-Definitionen kopieren */
      } /* neue Signal-Type-Definitionen vorhanden */
      cI = mRte.getIt(23); /* Iterator ueber Signal-Light-Definitionen holen */
      if(cI!=null) { /* SignalLight-Definitionen (Tabelle) sind vorhanden */
        SgL = cRte.getSigL(0); /* Aktuelle Signal-Light-Tabelle holen */
        while(cI.hasNext()) { /* alle Signal-Light-Definitionen bearbeiten */
          if((cSgL=(TSSigLgt)cI.next())==null) continue;
          if(!cSgL.chkMsk(31)) continue; /* SignalLight NICHT genutzt */
          SgL.add(cSgL); /* Signal-Light neu hinzufuegen */
        } /* alle Signal-Light-Definitionen kopieren */
        SgL = null; /* Referenz nicht mehr genutzt */
      } /* neue SignalLight-Definitionen vorhanden */
      cI = mRte.getIt(24); /* Iterator ueber Signal-LTexture-Definitionen holen */
      if(cI!=null) { /* SignalLTexture-Definitionen (Tabelle) sind vorhanden */
        SgX = cRte.getSigLTx(0); /* Aktuelle Signal-LTexture-Tabelle holen */
        while(cI.hasNext()) { /* alle Signal-Light-Definitionen bearbeiten */
          if((cSgX=(TSSigLTx)cI.next())==null) continue;
          if(!cSgX.chkMsk(31)) continue; /* LightTexture NICHT genutzt */
          SgX.add(cSgX); /* Signal-LTexture neu hinzufuegen */
          cSgX.incFNme(XNme); /* Texturname in Liste aufnehmen */
        } /* alle Signal-LTexture-Definitionen kopieren */
        SgX = null; /* Referenz nicht mehr genutzt */
      } /* neue SignalLTexture-Definitionen vorhanden */

      SgF = mRte.getSigF(0); /* alle Script-Files (neu) holen */
      if(SgF!=null) if(SgF.size()>0) { /* Script-File-Definitionen sind da */
        cI = SgF.keySet().iterator(); /* Iterator der Script-Files holen */
        SgF = cRte.getSigF(0); /* alle Basis-Script-Files holen */
        while(cI.hasNext()) { /* alle neuen Script-Files bearbeiten */
          is = (String)cI.next(); /* Schluessel des Eintrags holen */
          cSgF = mRte.getSigF(0).get(is); /* Signalscript-Definition */
          dat = cSgF.getFile(mRte,1); /* Dateibeschreibung (Source) erstellen */
          js = dat.getAbsolutePath(); /* gesamter Dateiname (Quelle) erzeugen */
          v = 0; /* Modifikationen zaehlen */
          while(SgF.containsKey(is)) { /* Eintrag gibt es schon */
            is += "$"; /* Name leicht modifizieren */
            v += 1; /* und Veraenderung zaehlen */
          } /* Name ist eindeutig gemacht worden */
          cSgF = new TSSigFle(cSgF,v); /* Kopie mit neuem Namen erstellen */
          SgF.put(is,cSgF); /* und neuen Eintrag hinzufuegen */
          dat = cSgF.getFile(cRte,2); /* Dateibeschreibung (Ziel) erstellen */
          is = dat.getAbsolutePath(); /* gesamter Dateiname (Ziel) erzeugen */
          /* Kopieren der Signalscript-Datei unter (ggf) neuem Namen */
          js = "copy \""+js+"\" \""+is+"\" "; /* copy - Befehl erstellen */
          if((j=exec(true,js,null,null))>0) /* Fehler bei Ausfuehrung */
            Lg.Log("MsgC50",is,j); /* Fehlermeldung ausgeben */
        } /* alle Elemente kopieren */
      } /* neue Script-File-Definitionen vorhanden */

    } /* signal-definitions have been merged as requested */
    Lg.Skip(false); /* add empty line */

    /* Path-definitions are merged */
    cI = mRte.getIt(17); /* get list of Path-definitions */
    if(cI!=null) { /* Min. one Path-Definition (to merge) exists */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("mrgRte50"); /* Aktion melden */
      FleT = cRte.getPath(); /* get list of defined Path-definitions (Basis)
        * If no Path-list exists, it is created as 'empty' */
      while(cI.hasNext()) { /* More Path-definitions available? */
        cPth = (TSPath)cI.next(); /* get next Path-entry */
        if(cPth==null) throw new IllegalStateException( /* valid? */
          TSLogg.getMsg("Msg908","TSPath==null","merge",0));
        if(cPth.incCnt(0)==0) continue; /* definition is no longer used */
        is = cPth.getName(false); /* get name of Path-file (keyform) */
        if(FleT.containsKey(is)) /* Path-file is already present */
          Lg.Err("mrgRte51",cPth.getName(true)); /* print errormessage */
        else ppth:{ /* path should be added to list of paths */
          FleT.put(is,cPth); /* add definition to list of paths */

          if(!Fo.chkMsk(9)) break ppth; /* overlay-mode is NOT active */
          /* examine path-definition and reassign quad-references */
          if(!cPth.chkMsk(0)) break ppth; /* PDP-node-table is NOT stored */
          if(cPth.getPDP(0)==null) break ppth; /* no valid PDP-node exists */
          xI = cPth.getPDP(0).iterator(); /* create iterator for all path-PDP-nodes */
//          while(xI.hasNext()) { /* process all PDP-node-definitions */
//            cPDP = (TSPatPDP)xI.next(); /* get next PDP-node */
//            if(cPDP==null) continue; /* entry not used -- skip it */
//            cPDP.chkPos(QDf); /* reassign quad-reference */
//          } /* -while- process all PDP-node-definitions */
          while(xI.hasNext()) ((TSPatPDP)xI.next()).chkPos(QDf);
            /* for all PDP-nodes: get next PDP-node and reassign quad-reference */
        } /* -ppth- path was added to list of paths */
      } /* -while- process ALL Path-definitions */
      Lg.Log("mrgRte52",FleT.size()); /* print overall number of paths */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Path-definitions must be processed */

    /* Service-definitions are merged */
    cI = mRte.getIt(18); /* get list of Service-definitions */
    if(cI!=null) { /* Min. one Service-Definition (to merge) exists */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("mrgRte60"); /* Aktion melden */
      FleT = cRte.getServ(); /* get list of defined Service-definitions (Basis)
        * If no Service-list exists, it is created as 'empty' */
      while(cI.hasNext()) { /* More Service-definitions available? */
        cSrv = (TSSrv)cI.next(); /* get next Service-entry */
        if(cSrv==null) throw new IllegalStateException( /* valid? */
          TSLogg.getMsg("Msg908","TSSrv==null","merge",0));
//        if(cSrv.incCnt(0)==0) continue; /* definition is no longer used */
        is = cSrv.getName(false); /* get name of service-file (keyform) */
        if(FleT.containsKey(is)) /* Service-file is already present */
          Lg.Err("mrgRte61",cSrv.getName(true)); /* print errormessage */
        else FleT.put(is,cSrv); /* add definition to list of services */
      } /* -while- process ALL Service-definitions */
      Lg.Log("mrgRte62",FleT.size()); /* print overall number of services */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Service-definitions must be processed */

    /* Traffic-definitions are merged */
    cI = mRte.getIt(19); /* get list of Traffic-definitions */
    if(cI!=null) { /* Min. one Traffic-Definition (to merge) exists */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("mrgRte70"); /* Aktion melden */
      FleT = cRte.getTrf(); /* get list of defined Traffic-definitions (Basis)
        * If no Traffic-list exists, it is created as 'empty' */
      while(cI.hasNext()) { /* More Traffic-definitions available? */
        cTrf = (TSTrf)cI.next(); /* get next Traffic-entry */
        if(cTrf==null) throw new IllegalStateException( /* valid? */
          TSLogg.getMsg("Msg908","TSTrf==null","merge",0));
//        if(cTrf.incCnt(0)==0) continue; /* definition is no longer used */
        is = cTrf.getName(false); /* get name of traffic-file (keyform) */
        if(FleT.containsKey(is)) /* Traffic-file is already present */
          Lg.Err("mrgRte71",cTrf.getName(true)); /* print errormessage */
        else FleT.put(is,cTrf); /* add definition to list of traffics */
      }  /* -while- process ALL Traffic-definitions */
      Lg.Log("mrgRte72",FleT.size()); /* print overall number of traffics */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Traffic-definitions must be processed */

    /* Activity-definitions are merged */
    cI = mRte.getIt(16); /* get list of Activity-definitions */
    if(cI!=null) { /* Min. one Activity-Definition (to merge) exists */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("mrgRte80"); /* Aktion melden */
      FleT = cRte.getAct(); /* get list of defined Activity-definitions (Basis)
        * If no Activity-list exists, it is created as 'empty' */
      while(cI.hasNext()) { /* More Activity-definitions available? */
        cAct = (TSAct)cI.next(); /* get next Activity-entry */
        if(cAct==null) throw new IllegalStateException( /* valid? */
          TSLogg.getMsg("Msg908","TSAct==null","merge",0));
//        if(cAct.incCnt(0)==0) continue; /* definition is no longer used */
        is = cAct.getName(false); /* get name of activity-file (keyform) */
        if(FleT.containsKey(is)) /* Activity-file is already present */
          Lg.Err("mrgRte81",cAct.getName(true)); /* print errormessage */
        else pact:{ /* activity should be added to list of activities */
          FleT.put(is,cAct); /* add definition to list of activities */

          if(!Fo.chkMsk(9)) break pact; /* overlay-mode is NOT active */
          /* examine activity-definition and reassign quad-references */
          if(cAct.chkMsk(19)) { /* Event-table is present -- process it */
            xI = cAct.getEvT(false).iterator(); /* create iterator for all entries */
            while(xI.hasNext()) ((TSActEv)xI.next()).fndWrld(QDf);
          } /* Event-table is present and was processed */
          if(cAct.chkMsk(18)) { /* Activity-object-table is present -- process it */
            xI = cAct.getAObj(0).iterator(); /* create iterator for all entries */
            while(xI.hasNext()) ((TSActAO)xI.next()).fndWrld(QDf);
          } /* Activity-object-table is present and was processed */
          if(!cAct.chkMsk(23)) break pact; /* no RestrictedSpeedZone-table is present */
          xI = cAct.getRSZne(0).iterator(); /* create iterator for all entries */
          while(xI.hasNext()) { /* process all RestrictedSpeedZone-definitions */
            cRSZ = (TSActSZ)xI.next(); /* get next definition */
            cRSZ.getPos(0).fndWrld(QDf); /* reassign first quad-reference */
            cRSZ.getPos(1).fndWrld(QDf); /* reassign second quad-reference */
          } /* -while- process all RestrictedSpeedZone-definitions */
        } /* -pact- activity was added to list of activities */
      } /* -while- process ALL Activity-definitions */
      Lg.Log("mrgRte82",FleT.size()); /* print overall number of activities */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Activity-definitions must be processed */

    /* **************** ab hier: Ausgaben **************** */
    /* World-Dateien schreiben */
    i = putWF(cRte,null,true,false); /* World-Dateien schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    /* Sound-Dateien schreiben */
    i = putSF(cRte,null,true); /* Sound-Dateien schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    /* Schienendatenbank bearbeiten */
    i = putDBF(cRte,null,16); /* Schienendatenbank schreiben */
      /* Modus: neue UiD's verwenden */
    if(i>0) return i; /* Fehler beim Schreiben */

    /* Schienendatenbank (.tit) bearbeiten */
    i = putITF(cRte,null,0,false); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      /* Strassendatenbank bearbeiten */
      i = putDBF(cRte,null,17); /* Strassendatenbank schreiben */
        /* Modus: neue UiD's verwenden */
      if(i>0) return i; /* Fehler beim Schreiben */

      /* Strassendatenbank (.rit) bearbeiten */
      i = putITF(cRte,null,1,false); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */
    } /* Strassendatenbank vorhanden und geladen */

    /* "tsection.dat" (lokal) neu erstellen */
    i = putTSL(cRte,mRte,false); /* neue lokale 'tsection.dat' schreiben */
    if(i>0) return i; /* Fehler -- beenden */

    /* zusaetzliche Streckendateien laden */
    i = putType(cRte); /* 'ttype.dat' neu schreiben */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Signal-Definitionen neu schreiben */
    if(!Fo.chkMsk(8)) { /* Signal-files were merged -- write them */
      i = putSCfg(cRte,null); /* Signal-Definitionen schreiben */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* write of signal-files requested */

    /* neue Struktur der besiedelten Quadrate erzeugen und ausgeben */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mrgRte19"); /* Aktion melden */

    i = putTDF(cRte,null,0); /* Terrain-Datei (HI) erzeugen */
    if(i>0) return i; /* Fehler beim Schreiben */
    if(tdl1) { /* Lo-Tiles existieren */
      i = putTDF(cRte,null,1); /* Terrain-Datei (LO) erzeugen */
      if(i>0) return i; /* Fehler beim Schreiben */
    } /* Lo-Tiles sind vorhanden */

    /* Alle gemischten Definitionen fuer Activities schreiben */
    i = putPatF(cRte,null,2); /* Path-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */
    i = putSrvF(cRte,null,2); /* Service-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */
    i = putTrfF(cRte,null,2); /* Traffic-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */
    i = putActF(cRte,null,2); /* Write Activities again (without errors) */
    if(i>0) return i; /* severe error -- terminate function */

    /* Shape-Dateien kopieren,falls noch nicht vorhanden */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mrgRte20",SNme.size()); /* Aktion melden */
    sdir = mRte.getFile(15); /* Quellendefinition der Daten erstellen */
    adir = mRte.getFile(-2); /* alternative Quellendefinition der Daten erstellen */
    vdir = cRte.getFile(15); /* Vergleichsdefinition der Daten erstellen */
    zdir = cRte.getFile(45); /* Dateidefinition fuer Ziel erstellen */
    if(zdir==null) { /* directory not accessible */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC63",cRte.getInfo(45)); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 20;  /* terminate function with errorcode */
    } /* directory not accessible -- terminate function with errorcode */
    c0 = c4 = 0; /* Anzahl der kopierten Dateien initialisieren */
    sI = SNme.keyIterator(true); /* get iterator for all shape-keys in list */
    while(sI.hasNext()) { /* more filenames present ? */
      is = sI.next(); /* yes -- get name of next shape-file */
      if(is.endsWith(".ace")) { /* Texture-file found -- process it */
        XNme.add(SNme.get(is)); /* add file to list of textures */
        sI.remove(); /* file should not be processed again */
        continue; /* file is fully processed */
      } /* Texture-file found */
      if(!is.endsWith(".s")) continue; /* no shape-file -- do not process */
        /* e.g '*.haz'-files are not processsed */
      c4 += 1; /* valid Shape-file -- count it */
      is = SNme.get(is); /* get correct notation of name */
      dat = new File(sdir,is); /* create full name of shape-file (source) */
      if(!dat.exists()) snf:{ /* source-file cannot be found */
        dat = new File(adir,is); /* create full name of shape-file (source) */
        if(dat.exists()) break snf; /* source-file found -- process it */
        Lg.Err("mrgRte31",is); /* print errormessage */
        sI.remove(); /* file-definition processed -- do not use it again */
        continue; /* process next file (do not tra description-file) */
      } /* shape-file(source) was NOT found */
      /* source-file is in a valid directory based on either 'route' or 'global' dir */
      if((js=chkShape(dat,XNme))!=null) /* extract image (.ace) */
        Lg.Err("mrgRte32",dat.getPath(),js); /* Fehlermeldung */
      try {dat = dat.getCanonicalFile();} catch(IOException e) { /* consolidate the path */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("MsgC64",dat.getPath(),e.toString()); /* print termination-message */
        Lg.Close(); /* close output to Log-file */
        return 20;  /* terminate function with errorcode */
      } /* consolidate the path -- terminate function with errorcode */
      if(sdir.equals(dat.getParentFile())) continue; /* file refer to standard shapes-dir -- use it */
      sI.remove(); /* file-definition processed -- do not use it again */
    } /* process all shape-files */
    vn2 = "mrgRteC"; /* set prefix of errormessages */
    c0 = cpyShape(SNme,sdir,zdir,vdir); /* copy all requested shape-files */

    /* Sound-Dateien (.sms) kopieren,falls noch nicht vorhanden */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mrgRte21"); /* Aktion melden */
    sdir = mRte.getFile(16); /* Quellendefinition der Daten erstellen */
    vdir = cRte.getFile(16); /* Vergleichsdefinition der Daten erstellen */
    zdir = cRte.getFile(46); /* Dateidefinition fuer Ziel erstellen */
    if(zdir==null) { /* directory not accessible */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC63",cRte.getInfo(46)); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 20;  /* terminate function with errorcode */
    } /* directory not accessible -- terminate function with errorcode */
    c0 = c4 = 0; /* Anzahl der kopierten Dateien initialisieren */
    sI = SNme.keyIterator(true); /* get iterator for all shape-keys in list */
    while(sI.hasNext()) { /* more filenames present ? */
      is = sI.next(); /* yes -- get name of next shape-file */
      if(!is.endsWith(".sms")) continue; /* no sound-file -- do not process */
        /* e.g '*.haz'-files are not processsed */
      c4 += 1; /* valid Shape-file -- count it */
      is = SNme.get(is); /* get correct notation of name */
      dat = new File(sdir,is); /* create full name of sound-file (source) */
      if(!dat.exists()) { /* source-file cannot be found */
        Lg.Err("mrgRte35",is); /* print errormessage */
        sI.remove(); /* file-definition processed -- do not use it again */
        continue; /* process next file */
      } /* shape-file(source) was NOT found */
      if((js=chkFile(dat,TSFileX.FT$sms,"file",XNme))!=null) /* extract file-name (.wav) */
        Lg.Err("mrgRte37",dat.getPath(),js); /* Fehlermeldung */
    } /* alle Sound-Dateien bearbeiten */
    SNme.setFilter(false,".sms"); /* change FilenameFilter */
    vn2 = "mrgRteS"; /* set prefix of errormessages */
    c0 += cpyFile(SNme,sdir,zdir,vdir); /* copy all requested ('*.sms') files */
    SNme.clear(); /* alle Namenselemente wieder freigeben (Shape,Sound) */

    /* Sound-Dateien (*.wav) kopieren,falls noch nicht vorhanden */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mrgRte22"); /* Aktion melden */
    /* directory-definitions are still valid from last step!!! */
    /* file-selection is already initialized and error-prefix does not change */
    c0 = cpyFile(XNme,sdir,zdir,vdir); /* copy all requested ('*.wav') files */

    /* copy texture-files if not already present */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mrgRte23",XNme.size()); /* Aktion melden */
    sdir = mRte.getFile(17); /* Quellendefinition der Daten erstellen */
    vdir = cRte.getFile(17); /* Vergleichsdefinition der Daten erstellen */
    zdir = cRte.getFile(47); /* Dateidefinition fuer Ziel erstellen */
    if(zdir==null) { /* directory not accessible */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC63",cRte.getInfo(47)); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 20;  /* terminate function with errorcode */
    } /* directory not accessible -- terminate function with errorcode */
    XNme.setFilter(true,".ace"); /* change FilenameFilter */
    vn2 = "mrgRteX"; /* set prefix of errormessages */
    c0 = cpyTree(XNme,sdir,zdir,vdir); /* copy all requested ('*.ace') files recursively */
    XNme.clear(); /* alle Namenselemente wieder freigeben (Texture,...) */

    /* Terrtex-Dateien kopieren,falls noch nicht vorhanden */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mrgRte24",TNme.size()); /* Aktion melden */
    sdir = mRte.getFile(20); /* Quellendefinition der Daten erstellen */
    vdir = cRte.getFile(20); /* Vergleichsdefinition der Daten erstellen */
    zdir = cRte.getFile(50); /* Dateidefinition fuer Ziel erstellen */
    if(zdir==null) { /* directory not accessible */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC63",cRte.getInfo(50)); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 20;  /* terminate function with errorcode */
    } /* directory not accessible -- terminate function with errorcode */
    vn2 = "mrgRteY"; /* set prefix of errormessages */
    c0 = cpyTree(TNme,sdir,zdir,vdir); /* copy all requested ('*.ace') files recursively */
    TNme.clear(); /* alle Namenselemente wieder freigeben (Terrtex) */

    if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */
    if(Fo.chkMsk(16)) prExtD(mRte); /* Zusaetzliche Definitionen ausgeben */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mrgRte29"); /* Abschluss melden */

    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "cpySMS"
  * SMS-Datei fuer 'Soundregion' kopieren und modifizieren
  * Method is referenced from 'Merge' exclusively
  * ##cpySMS (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int cpySMS( /* SMS-Datei modifiziert kopieren */
   TSRoute cRte, /* Routendefinition mit Basisverzeichnis */
   File    dats, /* Directorydefinition des Ausgangverzeichnisses */
   String  nme,  /* Name der SMS-Datei */
   int     nr)   /* Nummer der neuen Track-Kennung */
   {
   /*-----------------------------------------------------------------*/
    File     datz;  /* definition of output-file */
    TSFileX  cR,cW; /* file-reader, file-writer */
    TSBuf    cB;    /* current input-buffer for 'read file' */
    String   is,js; /* intermediate value */
    int      i,c;   /* intermediate value, counter */
    boolean  err;   /* error found if true */
   /*=================================================================*/
    /* verify existence of SMS-file (input) */
    dats = new File(dats,nme); /* create filename of source-file */
    if(dats.isDirectory()) { /* name refers to directory -- error */
      Lg.Msg("mrgRteM1",dats.getAbsolutePath()); /* print errormessage */
      return 11; /* terminate function */
    } /* file-reference points to directory */
    if(!dats.exists()) { /* file not found -- try again */
      dats = cRte.getFile(-5); /* directory of common sound-sources */
      dats = new File(dats,nme); /* create filename of source-file */
      if(dats.isDirectory()) { /* name refers to directory -- error */
        Lg.Msg("mrgRteM1",dats.getAbsolutePath()); /* print errormessage */
        return 12; /* terminate function */
      } /* file-reference points to directory */
      if(!dats.exists()) { /* file not found -- error */
        Lg.Msg("mrgRteM2",nme); /* print errormessage */
        return 13; /* terminate function */
      } /* sms-file could not be found */
    } /* reference to file is not valid */

    datz = cRte.getFile(46); /* get file-reference of target */
    if(datz==null) { /* reference is invalid (not created) */
      Lg.Msg("mrgRteM3",nme); /* print errormessage */
      return 15; /* terminate function */
    } /* directory of target-file does not exist */
    datz = new File(datz,nme);  /* create filename of target-file */
    Lg.Log("mrgRteM4",nme,nr,0); /* print description of next action */

    cR = new TSFileX(TSFileX.FT$sms,dats); /* create input-control of file */
    cW = new TSFileX(TSFileX.FT$sms,datz); /* create output-control of file */

    is = cR.open(false); /* open inputfile and read control-record */
    if(is!=null) { /* error occurred during open */
      Lg.Msg("mrgRteM5",is); /* print errormessage: terminating */
      return 6; /* terminate function */
    } /* error while open */

//    if((is=cW.setST(cR.getST()))!=null) Lg.Err("mrgRteM5",is);
    is = cW.open(true); /* open outputfile and write control-record */
    if(is!=null) { /* error occurred during open */
      cR.close(); /* close inputfile again */
      Lg.Msg("mrgRteM5",is); /* print errormessage: terminating */
      return 8;  /* terminate function */
    } /* error while open */

    c = 0; /* initialize counter (changes) */
    err = true; /* preset: error occurred */
    cB = new TSBuf(cR,cW); /* create buffer-control (input/output) */
      /* line -mode is used so that data may be modified */
    sl: { /* read/write-loop (Break-Block) */
      while(!cB.getNext(false)) { /* copy all records (read/write) */
        if(!cB.advPtr("tracktype")) continue; /* keyword NOT found within current line */
        is = cB.getKE(true); /* get keyword-expression of line */
        if(is==null) { /* no data available */
          is = cB.getErr(); /* get current errormessage */
          if(is==null) is = TSLogg.getKey("mrgRteMC"); /* EOF reached */
          Lg.Err("mrgRteM8",is,cR.getStat(true)); /* print errormessage */
          break sl; /* terminate copy of file */
        } /* data was not available */
        if(!is.equals("tracktype")) { /* requested keyword NOT found */
          Lg.Err("mrgRteM6",cR.getStat(true)); /* print errormessage */
          break sl; /* terminate copy of file */
        } /* requested keyword NOT found -- terminate copy of file */
        cB.mark(false); /* mark current position for replace */
        cB.getNV(); /* skip number of 'TrackType' */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("mrgRteM7",is,cR.getStat(true)); /* print errormessage */
          break sl; /* terminate copy of file */
        } /* error while evaluating -- terminate copy of file */
        if(cB.modData(" "+nr)) { /* error during replacement */
          Lg.Err("mrgRteMD",cR.getStat(true)); /* print errormessage */
          break sl; /* terminate copy of file */
        } /* error during replacement -- terminate copy of file */
        c += 1; /* count change */
      } /* -while- copy all lines and process them */
      if((is=cB.getErr())!=null) /* error while reading/writing */
        Lg.Err("mrgRteM8",is,cR.getStat(true)); /* print errormessage */
      else err = false; /* OK -- no error occurred */
    } /* -sl- Break-Block used for terminating read/write */
    is = cW.close(); /* close outputfile again */
    if(is!=null) Lg.Err("mrgRteM5",is); /* print errormessage */
    is = cR.close(); /* close inputfile again */
    if(is!=null) Lg.Err("mrgRteM5",is); /* print errormessage */

    if(err) Lg.Log("mrgRteM9"); /* print errormessage */
    Lg.Log("mrgRteMA",cR.getStat(true)); /* print number of input-records */
    Lg.Log("mrgRteMB",c); /* print number of changes */

    return 0; /* copy-function successfully processed */
  }

 /**. <pre>
  *=====================================================================
  * Methode "cpyShape"
  * Check and copy shape-definitions within a directory-tree
  * Checkmode: The compare-directory is checked if the same file is
  *            already present within this folder. Also the time/date
  *            of 'lastmodified' is compared. If this file is newer
  *            a message is reported. The source-file is NOT
  *            copied to the target-directory in this case.
  * Attention: If no compare-folder is specified, no check takes place.
  * Method returns number of copied files
  * Method is used within 'Merge' exclusively
  * Attention: 'vn2' must contain 'message-prefix'
  * ##cpyShape (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int cpyShape( /* copy shape-files */
   TSNameSet Lst,  /* List of accepted shape-files */
   File      dirS, /* source-directory for copy */
   File      dirT, /* target-directory for copy */
   File      dirC) /* compare-directory or 'null' */
   {
   /*-----------------------------------------------------------------*/
    File     sdat,cdat; /* intermediate files */
    long     b,v;
    int      i,c; /* intermediate values */
    String[] fl;  /* list of affected files (and directories) */
   /*=================================================================*/
    fl = dirS.list((FilenameFilter)Lst); /* list affected files */
    c = 0; /* initialize number of copied files */
    for(String fn : fl) { /* process all entries */
      sdat = new File(dirS,fn); /* create full source-filename */
      if(sdat.isDirectory()) /* Name refers to directory */
        Lg.Err(vn2+"1",sdat.getAbsolutePath());
      else { /* entry refers to filename -- process it */
        /* Attention: list of filenames is already filtered!! */
        if(dirC!=null) { /* compare with original must be done */
          cdat = new File(dirC,fn); /* create full filename of original */
          if(cdat.exists()) { /* entry (already) exits */
            if(!cdat.isDirectory()) { /* entry refers to file -- check it  */
              b = sdat.lastModified(); /* get date of source-file */
              v = cdat.lastModified(); /* get date of original file */
              if(b!=v) Lg.Err(vn2+"3",sdat.getName()); /* file do not match */
              else if(EnaW) Lg.Log(vn2+"4",sdat.getName()); /* Message */
            } else Lg.Err(vn2+"2",cdat.getAbsolutePath()); /* folder -- error */
            continue; /* do NOT copy file */
        } } /* check was done */
        if(!dirT.exists()) dirT.mkdirs(); /* create target-directory if needed */
        cdat = new File(dirT,fn); /* create target-filename */
        if(cdat.exists()) continue; /* file may exist if check is disabled */
        fn = "copy \"" + sdat.getAbsolutePath() + "\" \"" +
          cdat.getAbsolutePath() + "\" "; /* create copy - command */
        if((i=exec(true,fn,null,null))>0) { /* error occurred during execution */
          Lg.Log(vn2+"5",sdat.getName(),i); /* print error-message */
          continue; /* and continue with next file/directory */
        } /* copy was NOT sucessfull */
        fn = "copy \"" + sdat.getAbsolutePath() + "d\" \"" +
          cdat.getAbsolutePath() + "d\" "; /* create copy - command */
        if((i=exec(true,fn,null,null))>0) { /* error occurred during execution */
          Lg.Log(vn2+"5",sdat.getName()+"d",i); /* print error-message */
          continue; /* and continue with next file/directory */
        } /* copy was NOT sucessfull */
        c += 1; /* count file which was sucessful copied */
      } /* entry was file */
    } /* process all definitions */
    return c; /* return with number of copied files */
  }

 /**. <pre>
  *=====================================================================
  * Methode "cpyFile"
  * Check and copy file-definitions within a directory-tree
  * Checkmode: The compare-directory is checked if the same file is
  *            already present within this folder. Also the time/date
  *            of 'lastmodified' is compared. If this file is newer
  *            a message is reported. The source-file is NOT
  *            copied to the target-directory in this case.
  * Attention: If no compare-folder is specified, no check takes place.
  * Method returns number of copied files
  * Method is used within 'Merge' exclusively
  * Attention: 'vn2' must contain 'message-prefix'
  * ##cpyFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int cpyFile( /* copy several types of files */
   TSNameSet Lst,  /* List of accepted files */
   File      dirS, /* source-directory for copy */
   File      dirT, /* target-directory for copy */
   File      dirC) /* compare-directory or 'null' */
   {
   /*-----------------------------------------------------------------*/
    File     sdat,cdat; /* intermediate files */
    long     b,v;
    int      i,c; /* intermediate values */
    String[] fl;  /* list of affected files (and directories) */
   /*=================================================================*/
    fl = dirS.list((FilenameFilter)Lst); /* list affected files */
    c = 0; /* initialize number of copied files */
    for(String fn : fl) { /* process all entries */
      sdat = new File(dirS,fn); /* create full source-filename */
      if(sdat.isDirectory()) /* Name refers to directory */
        Lg.Err(vn2+"1",sdat.getAbsolutePath());
      else { /* entry refers to filename -- process it */
        /* Attention: list of filenames is already filtered!! */
        if(dirC!=null) { /* compare with original must be done */
          cdat = new File(dirC,fn); /* create full filename of original */
          if(cdat.exists()) { /* entry (already) exits */
            if(!cdat.isDirectory()) { /* entry refers to file -- check it  */
              b = sdat.lastModified(); /* get date of source-file */
              v = cdat.lastModified(); /* get date of original file */
              if(b!=v) Lg.Err(vn2+"3",sdat.getName()); /* file do not match */
              else if(EnaW) Lg.Log(vn2+"4",sdat.getName()); /* Message */
            } else Lg.Err(vn2+"2",cdat.getAbsolutePath()); /* folder -- error */
            continue; /* do NOT copy file */
        } } /* check was done */
        if(!dirT.exists()) dirT.mkdirs(); /* create target-directory if needed */
        cdat = new File(dirT,fn); /* create target-filename */
        if(cdat.exists()) continue; /* file may exist if check is disabled */
        fn = "copy \"" + sdat.getAbsolutePath() + "\" \"" +
          cdat.getAbsolutePath() + "\" "; /* create copy - command */
        if((i=exec(true,fn,null,null))>0) { /* error occurred during execution */
          Lg.Log(vn2+"5",sdat.getName(),i); /* print error-message */
          continue; /* and continue with next file/directory */
        } /* copy was NOT sucessfull */
        c += 1; /* count file which was sucessful copied */
      } /* entry was file */
    } /* process all definitions */
    return c; /* return with number of copied files */
  }

 /**. <pre>
  *=====================================================================
  * Methode "cpyTree"
  * Check and copy definitions within a directory-tree
  * Method is used recursively to copy whole tree
  * Checkmode: The compare-directory is checked if the same file is
  *            already present within this folder. Also the time/date
  *            of 'lastmodified' is compared. If this file is newer
  *            a message is reported. The source-file is NOT
  *            copied to the target-directory in this case.
  * Attention: If no compare-folder is specified, no check takes place.
  * Method returns number of copied files
  * Method is used within 'Merge' and 'clrDB'
  * Attention: 'vn2' must contain 'message-prefix'
  * ##cpyTree (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int cpyTree( /* recursively copy files */
   TSNameSet Lst,  /* List of files */
   File      dirS, /* source-directory for copy */
   File      dirT, /* target-directory for copy */
   File      dirC) /* compare-directory or 'null' */
   {
   /*-----------------------------------------------------------------*/
    File     sdat,cdat; /* intermediate files */
    long     b,v;
    int      i,c; /* intermediate values */
    String[] fl;  /* list of affected files and directories */
   /*=================================================================*/
    fl = dirS.list((FilenameFilter)Lst); /* list affected files */
    c = 0; /* initialize number of copied files */
    for(String fn : fl) { /* process all filelist-entries */
      sdat = new File(dirS,fn); /* create full source-filename */
      if(sdat.isDirectory()) { /* Name refers to directory */
        cdat = (dirC!=null) ? new File(dirC,fn) : null; /* create full directoryname */
        c += cpyTree(Lst,sdat,new File(dirT,fn),cdat); /* process dir recursively */
      } else { /* entry refers to filename -- process it */
        /* Attention: list of filenames is already filtered!! */
        if(dirC!=null) { /* compare with original must be done */
          cdat = new File(dirC,fn); /* create full filename of original */
          if(cdat.exists()) { /* entry (already) exits */
            if(!cdat.isDirectory()) { /* entry refers to file -- check it  */
              b = sdat.lastModified(); /* get date of source-file */
              v = cdat.lastModified(); /* get date of original file */
              if(b!=v) Lg.Err(vn2+"2",sdat.getName()); /* file do not match */
              else if(EnaW) Lg.Log(vn2+"3",sdat.getName()); /* Message */
            } else Lg.Err(vn2+"1",cdat.getAbsolutePath()); /* folder -- error */
            continue; /* do NOT copy file */
        } } /* check was done */
        if(!dirT.exists()) dirT.mkdirs(); /* create target-directory if needed */
        cdat = new File(dirT,fn); /* create target-filename */
        if(cdat.exists()) continue; /* file may exist if check is disabled */
        fn = "copy \"" + sdat.getAbsolutePath() + "\" \""
          + cdat.getAbsolutePath() + "\" "; /* create copy - command */
        if((i=exec(true,fn,null,null))>0) { /* error occurred during execution */
          Lg.Log(vn2+"4",sdat.getName(),i); /* print error-message */
          continue; /* and continue with next file/directory */
        } /* copy was NOT sucessfull */
        c += 1; /* count file which was sucessful copied */
      } /* entry was file */
    } /* process all definitions */
    return c; /* return with number of copied files */
  }


 /**. <pre>
  *=====================================================================
  * Methode "clearDB" (-20-)
  * Korrektur der Datenbanken einer beschaedigten Strecke versuchen
  * Optionen:
  *       1 - benutzte Tile-Dateien kopieren/bereinigen (-t)
  *       2 - Puffer-Dateien fuer Tile kopieren/bereinigen (-p)
  *       3 - Dummy-World-Dateien erzeugen falls notwendig (-w)
  *       8 - ungenutzte World-/Sound-Dateien loeschen (-c,Hidden)
  *       9 - Delete unused Shapes and Textures (-s)
  *      16 - Extended output to LOG (-d,Hidden)
  *      17 - Dateien direkt ueberschreiben (-inplace,Hidden)
  * ##clearDB (Eyecatcher)
  * ##clrDB (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int clearDB( /* Streckendefinition reparieren */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute            cRte; /* aktuelle Routendefinition */
    TreeSet<TSQuad>    QDf;  /* alle Quadrat-Definitionen */
    ArrayList<TSTrNde> TrN;  /* neue TrackNode-DB-Tabelle */
    ArrayList<TSVector> NdeT; /* table of vector-nodes from TrackNode */
    TSNameSet          SNme,TNme; /* Shape-,Texture-Names for existence-chk */
    TSTile             cTle; /* aktuelle Tile-Definition */
    TSQuad             cQDf; /* aktuelle Quadrat-Definition */
    TSUiD              cUiD; /* UiD-Arbeitswert */
    TSTrNde            cTrN; /* aktuelles TrackNode-DB-Element */
    TSTrItm            cIt;  /* aktuelles DB-Element (TrItem) */
    TSTrItm01T         cIt01T; /* 'TrSignal(R)Dir'-entry (SignalItem) */
    TSSigTyp           cSgT; /* Signal-Typ-Element */
    String[]           fl;   /* Dateiliste */
    File               dir,dirz,dat,datz; /* Dateidefinitionen */
    int                i,j,db; /* Arbeitswerte */
    String             is,js;
    boolean            OV,loT,valid;
    Iterator           cI;   /* common Iterator */
    Iterator<String>   sI;   /* String-Iterator (TSNameSet) */
    Iterator<TSTrNde>  aI;   /* Iterator of TrackNode-Table */
    Iterator<TSTrItm01T> iI; /* Iterator of 'TrSignal(R)Dir'-Table */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("clrDB01",fn); /* Vorlauf ausgeben */

    OV = Fo.chkMsk(17); /* 'newRoute'-Directory benoetigt ? */
    /* Systemdatei lesen und auswerten */
    cRte = getRte(fn,OV?1:3); /* Streckendefinition auswerten */
    if(cRte==null) return 5; /* Fehler -- Ende */

    /* print current paths */
    Lg.Msg("MsgC01",cRte.getInfo(2)); /* print route-name */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* print system-path */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* print route-path */
    Lg.Skip(true); /* and add empty line */

    /* globale "tsection.dat" bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC05"); /* Aktionsmeldung ausgeben */

    dat = cRte.getFile(-1); /* get reference to file */
    i = getTS(dat,null);    /* and load 'tsection.dat' (global) */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC08",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC11",c3); /* Ergebnis melden */
    Lg.Log("MsgC14",ScN); /* Ergebnis melden */
    Lg.Log("MsgC17",c2); /* Ergebnis melden */
    Lg.Log("MsgC20",ShN); /* Ergebnis melden */
    Lg.Log("MsgC23",c4); /* Ergebnis melden */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(cRte,ScA,ShA); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* zusaetzliche Streckendateien laden */
    i = getType(cRte); /* 'ttype.dat' laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strukturquadrate laden (genaue Ausfuehrung) */
    i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC26",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Strukturquadrate laden (LO-Tiles) */
    loT = true; /* annehmen: LO-Tiles sind vorhanden */
    i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
    if(i>0) { /* Fehler beim Laden der Strukturquadrate */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC27",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    if(i<0) loT = false; /* LO-Tiles gibt es nicht */

    /* establish shape-mode if appropriate */
    SNme = null; /* preset: do not process shape-definitions */
    if(Fo.chkMsk(9)) SNme = new TSNameSet(false,".s"); /* check -- init list */

    /* Schienendatenbank laden */
    i = getDBF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    i = getITF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strassendatenbank laden */
    i = getDBF(cRte,1); /* Strassendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    if(i==0) { /* Datenbank ist vorhanden */
      i = getITF(cRte,1); /* Strassendatenbank laden und pruefen */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* Datenbank(teil) ist vorhanden */

    /* World-Dateien laden und syntaktisch pruefen */
    if(OV && Fo.chkMsk(8)) gN = new TreeSet<String>(); /* Namensspeicher */
    i = getWF(cRte,false); /* World-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */
    /* Sound-Dateien laden und syntaktisch pruefen */
    i = getSF(cRte,false); /* World-Sound-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */

    /* Signal-Definitionen laden und ueberpruefen */
    i = getSCfg(cRte,cRte.getFile(21),SNme,false); /* load Signal-Configurations */
    if(i==0) /* Laden erfolgreich -- weiter testen */
      i = getSScr(cRte,cRte); /* Signal-Script-Definitionen laden */

    /* Path-Definitionen werden geladen und ueberprueft */
    i = getPatF(cRte,!OV); /* Path-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Service-Definitionen werden geladen und ueberprueft */
    i = getSrvF(cRte,!OV); /* Service-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Traffic-Definitionen werden geladen und ueberprueft */
    i = getTrfF(cRte,!OV); /* Traffic-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Activity-Definitionen werden geladen und ueberprueft */
    i = getActF(cRte,!OV); /* Activity-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */


    /* all files were loaded -- continue with integrity-check */
    if((is=cRte.chkRte(Fo,false))!=null) { /* check route for integrity -- error found ? */
      if(is.charAt(0)!=' ') { /* error-message returned */
        Lg.Skip(true); /* skip line */
        Lg.Err("getRte23",is); /* print errormessage */
        Lg.Msg("MsgC60"); /* print message: 'terminating' */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* error found -- function terminated */
      if(EnaW) Lg.Log("chkRte00",is); /* Warning found -- print it */
    } /* error/warning found */

    /* VOR PRUEFUNG: Dummy-World-Dateien erzeugen falls gefordert. */
    if(Fo.chkMsk(3)) { /* Dummy-World-Dateien erzeugen */
      /* Alle Tile-Definitionen ueberpruefen und bearbeiten */
      QDf = cRte.chgQDf(null); /* alle Quadrat-Definitionen holen */
      cI = cRte.getIt(10); /* Iterator fuer Tile-Definitionen */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
        while((cQDf=cTle.crQuad())!=null) { /* neue Quad-Definition erstellt */
          cQDf.chgTle(cTle); /* Rueckverkettung einfuegen */
          cQDf.chgMde(TSFile.OCB); /* set output-mode of world-file to CB */
          if(!QDf.add(cQDf)) { /* Strukturquadrat in globale Kette einfuegen */
            Lg.Skip(true); /* Leerzeile loggen */
            Lg.Msg("MsgC31",cQDf.getInf(0)); /* Fehlermeldung ausgeben */
            Lg.Close(); /* close output to Log-file */
            return 6; /* terminate function with errorcode */
          } /* Strukturquadrat nicht einfuegbar -- bereits vorhanden */
        } /* neue Quad-Definition wurde erzeugt */
      } /* alle Tile-Definitionen */
    } /* Dummy-World-Dateien wurden erzeugt */

    /* "world"-Dateien bearbeiten und neue Integritaet herstellen */
    chkWrld(cRte,SNme,132); /* World-Dateien erweitert pruefen (128+4) */
      /* Modus: Aenderungen melden, kein Renum */

    /* Sound-Dateien bearbeiten und neue Integritaet herstellen */
    i = chkSnd(cRte,SNme,128); /* Sound-Dateien erweitert pruefen */
      /* Modus: Aenderungen melden */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("MsgC33",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("clrDB04"); /* Aktionsmeldung ausgeben */
    if(cRte.get$TrN(0)<=0) { /* Schienendatenbank NICHT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC36"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datenbank nicht vorhanden */

    i = chkDBTab(cRte,128); /* Schienendatenbank bearbeiten */
      /* Option (128) aktiv: falsche Referenzen loeschen */
    if(i<0) return 5; /* Systemfehler -- Ende */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("clrDB05"); /* Aktionsmeldung ausgeben */
    Lg.Msg("MsgC38",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("clrDB06"); /* Aktionsmeldung ausgeben */

      i = chkDBTab(cRte,129); /* Strassendatenbank bearbeiten */
        /* Option (128) aktiv: falsche Referenzen loeschen */
      if(i<0) return 5; /* Systemfehler -- Ende */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("clrDB07"); /* Aktionsmeldung ausgeben */
      Lg.Msg("MsgC38",i); /* Ergebnis melden */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Strassendatenbank vorhanden und geladen */

    /* gespeicherte Daten ueberpruefen und korrigieren */
    for(db=0;db<2;db+=1) { /* alle Datenbenken bearbeiten */
      i = cRte.get$TrN(db); /* aktuelle Groesse des Track-Node-Speichers */
      if(i<=0) continue; /* Datenbank ist nicht vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("clrDB"+(db+1)+"0"); /* Aktionsmeldung ausgeben */
      /* Datenbank reduzieren wegen nicht vorhandener World-Dateien */
      aI = cRte.getIt(db); /* Iterator fuer TrackNode-Definitionen (alt) */
      TrN = cRte.getTrN(db,i); /* Neue TrackNode-Tabelle erstellen und setzen */
        /* Achtung: Der Iterator muss die ORIGINALE Tabelle verwenden. Deshalb muss er
         * erzeugt werden BEVOR die TrackNode-Tabelle durch die NEUE, (noch) LEERE
         * Tabelle ersetzt wird.
         * 'aI' kann NICHT 'null' sein, da Elemente vorhanden sind (i>0)
         */
      i = 0; /* noch kein neues Element belegt */
      while(aI.hasNext()) { /* Alle TrackNode-Definitionen bearbeiten */
        if((cTrN=aI.next())==null) continue; /* Fehl-Eintrag uebergehen */
        if(cTrN.chkMsk(30)) continue; /* Eintrag ist bereits bearbeitet */
        if(cTrN.getTyp()!=1) continue; /* Kette beginnt bei 'EndNode' */
          /* ACHTUNG: Eine Kette kann AUCH an einer 'TrJunctionNode' enden.
           * Dann SOLLTE aber zumindestens in dieser Kette noch EINE 'TrEndNode'
           * vorhanden sein, an Hand der diese Kette bearbeitet wird. Wenn eine
           * Kette NUR an den gemeinsamen Enden von Weichen terminiert, wird sie
           * NICHT erkannt!
           * d.h.: Wenn ein in sich abgeschlossenes Schienensegment NUR Weichen
           * und Schienenstuecken (z.B. Kreis) enthaelt wird es unterdrueckt.
           */
        /* valid: min. ein Objekt definiert -  'true' - ja, 'false' - nein */
        cTrN.setMsk(30); /* Knoten als bearbeitet markieren (Phase 1) */
        valid = !cTrN.chkMsk(21); /* End-Node-Objekt ist vorhanden wenn 'false' */
        if(cTrN.getTrN(0)==null) valid = false; /* 'Blue Pole' ist ungueltig */
          /* Einzelne Node ist ungueltig auch wenn ein World-Element existiert */
        else valid |= chkRef(cTrN.getTrN(0)); /* Kette pruefen */
        cTrN.setMsk(31); /* Knoten erneut als bearbeitet markieren (Phase 2) */
        if(valid) { /* ein gueltiges Element existiert -- weiter benutzen */
          TrN.add(cTrN); /* Start-Element der Kette eintragen */
          i += 1;        /* und Nutzung (=ID) zaehlen */
          cTrN.chgIx(i); /* neuen Index setzen */
          if(EnaH) Lg.Log("clrDB1"+cTrN.getTyp(), /* Meldung: genutzt */
            TSLogg.getMsg("clrDB22",i),cTrN.getNr(true),0);
          i = cpyRef(i,TrN,cTrN.getTrN(0)); /* Referenzkette kopieren */
        } else { /* Objekt-Kette kann geloescht werden -- nicht kopieren */
          if(EnaH) Lg.Log("clrDB1"+cTrN.getTyp(), /* Meldung: geloescht */
            TSLogg.getKey("clrDB21"),cTrN.getNr(true),0);
          clrRef(cTrN.getTrN(0),cRte); /* Kettenelemente loeschen */
        } /* Objekt-Kette wird NICHT MEHR benutzt */
      } /* alle Track-Nodes bearbeiten */
      TrN.trimToSize(); /* Speicher der TrackNode-Tabelle optimieren */
      cRte.setInt(db,i); /* neue Anzahl der Elemente eintragen */

      NdeT = cRte.getNdeT(db); /* Tabelle fuer die Vektoren holen (TSVector>) */
      if(NdeT.size()>0) NdeT.clear(); /* alle Eintraege entfernen falls notwendig */
      aI = cRte.getIt(db); /* Iterator fuer TrackNode-Definitionen (neu) */
      while(aI.hasNext()) { /* Alle TrackNode-Definitionen bearbeiten */
        if((cTrN=aI.next())==null) continue; /* Fehl-Eintrag uebergehen (tritt nicht auf) */
        cTrN.clrMsk(30); /* Kennzeichnung wieder loeschen (Phase 1) */
        cTrN.clrMsk(31); /* Kennzeichnung wieder loeschen (Phase 2) */
        if(cTrN.getTyp()>2) NdeT.add(cTrN.chgNde(0,null)); /* Node-Referenz aus TrackNode
          * extrahieren und in Tabelle speichern */
      } /* alle Eintraege nacharbeiten */

      /* TrItem-Definitionen bearbeiten */
      cI = cRte.getIt(2+db); /* Iterator auf TrItem-Tabelle holen */
      if(cI==null) continue; /* DB nicht vorhanden */
      i = 0; /* noch kein neues Element vergeben */
      /* Elemente ohne Referenzen loeschen */
      while(cI.hasNext()) { /* alle TrItem-Definitionen bearbeiten */
        cIt = (TSTrItm)cI.next(); /* naechste TrItem-Definition */
        if(cIt.incCnt(0)==0) cIt.setMsk(0); /* Item nicht mehr benutzt */
          /* Dieser Sonderfall wird zusaetzlich beachtet! */
        if(cIt.chkMsk(0)) cI.remove(); /* TrItem aus Tabelle entfernen */
        else { /* TrItem bleibt gueltig -- Struktur korrigieren */
          cIt.setNr(i++); /* neue Nummer vergeben */
          if(cIt instanceof TSTrItm01) it01: { /* SignalItem */
            if(!cIt.chkMsk(22)) break it01; /* Referenzen nicht genutzt */
            iI = ((TSTrItm01)cIt).getSgD(0).iterator(); /* Referenztabelle holen */
            while(iI.hasNext()) { /* alle 'TrSignalDir'-Eintraege bearbeiten */
              cIt01T = iI.next(); /* naechsten 'TrSignal(R)Dir'-Eintrag holen */
              if(cIt01T==null) iI.remove(); /* nicht benutzt -- entfernen */
              else if(cIt01T.chkTrN(TrN)!=null) iI.remove(); /* ungueltig -- entfernen */
            } /* alle 'TrSignal(R)Dir'-Eintraege bearbeiten */
            ((TSTrItm01)cIt).chkSgD(); /* Tabellenintegritaet neu herstellen */
          } /* weiter keine Modifikation */
        } /* TrItem weiterhin gueltig */
      } /* -while- alle Eintraege bearbeiten */
      if(EnaH) Lg.Log("clrDB23",i); /* Anzahl der TrItems melden */
    } /* alle Datenbanken bearbeiten */

    /* extended check of local 'tsection.dat'
     * Attention: This method MUST NOT be invoked unless worldfiles AND
     * database (track/road) is stored again (or neither). */
    chkTSL(cRte,ScN,ShN); /* check file and compact it */

    i = chkPat(cRte); /* Pfad-Definitionen mit neuer Datenbank bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkSrv(cRte,true); /* Service-Definitionen mit neuer Pfad-Definition bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkCon(cRte); /* Consist-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkTrf(cRte,true,false); /* Traffic-Definitionen mit neuer Pfad-Definition bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkAct(cRte,true); /* process activity-definitions */
    if(i>0) return 5; /* systemerror occurred -- terminate */

    /* World-/Sound-Dateien pruefen und ggf. loeschen */
    if(OV && Fo.chkMsk(8)) { /* Datei-Option 'loeschen' ist gefordert */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("clrDB25"); /* Aktionsmeldung ausgeben */
      c3 = c4 = 0; /* Zaehler zuruecksetzen */
      cI = gN.iterator(); /* alle gespeicherten Elemente */
      while(cI.hasNext()) { /* weiterer Dateiname */
        is = (String)cI.next(); /* Dateiname holen */
        dat = cRte.getFile(10,is); /* Datei-Referenz */
        c3 += 1; /* Annehmen: Datei wird geloescht */
        if(dat!=null) dat.delete(); /* World-Datei loeschen */
        else c3 -= 1; /* Datei doch nicht geloescht */
      } /* alle Dateinamen bearbeiten */
      /* Sound-Dateien bearbeiten */
      bb: { /* break-Block fuer Loeschen */
        dir = cRte.getFile(10); /* World-Verzeichnis */
        if(dir==null) break bb; /* Fehler -- nicht loeschen */
        fl = dir.list(); /* alle Dateien auflisten */
        if(fl==null) break bb; /* Source-ist kein Verzeichnis */
        ol:for(i=0;i<fl.length;i+=1) { /* alle Dateidefinitionen */
          js = fl[i]; /* einfache Addressierung */
          if(!js.toLowerCase().endsWith(".ws")) continue;
          dat = new File(dir,js); /* Source-Referenz erzeugen */
          if(dat.isDirectory()) continue; /* nur Dateien beachten */
          cI = cRte.getIt(12); /* Iterator fuer Quadrat-Definitionen */
          while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
            cQDf = (TSQuad)cI.next(); /* naechste Quadrat-Definition */
            is = cQDf.getInf(4); /* Namen der Sound-Datei */
            if(is==null) continue; /* Sound-Datei fehlt -- nicht vergleichen */
            if(is.equalsIgnoreCase(js)) continue ol; /* gefunden naechster Name */
          } /* alle Quadrat-Definitionen vergleichen */
          dat.delete(); /* nicht benutzt -- Sound-Datei loeschen */
          c4 += 1; /* geloeschte datei zaehlen */
        } /* -ol- alle Dateidefinitionen bearbeiten */
      } /* -bb- break-Block fuer Loeschen */
      Lg.Msg("clrDB26",c3); /* Aktionsmeldung ausgeben */
      Lg.Msg("clrDB27",c4); /* Aktionsmeldung ausgeben */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* loeschen der World-/Sound-Dateien gefordert */
    gN = null; /* Namensspeicher auf jeden Fall loeschen */

    /* **************** ab hier: Ausgaben **************** */
    /* Zwischenfile-Erstellen falls ueberschreiben aktiv. */
    dat = null; /* Annehmen: Dateien NICHT ueberschreiben */
    if(OV) { /* ueberschreiben der Dateien aktiv */
      try { dat = File.createTempFile("TSUtil",".tmp");
      } catch (IOException e) { /* Creation-Fehler Temp-Datei */
       System.err.println(e.toString());  return 5;}
      dat.deleteOnExit(); /* Datei am Ende wieder loeschen */
      if(!Fo.chkMsk(20)) askTerm(); /* ask user to REALLY overwrite */
      Lg.Log("MsgC41"); /* Warnung/Hinweis loggen */
      Lg.Skip(true); /* Leerzeile loggen */
    } /* ueberschreiben der Dateien aktiv */

    /* Process basic file of route (.trk) */
    i = putRte(cRte,dat); /* rewrite route-definition */
    if(i>0) return i; /* error found while writing */

    /* "world"-Dateien bearbeiten und modifizieren */
    i = putWF(cRte,dat,true,false); /* World-Dateien modifiziert schreiben */
      /* Modus: neue UiD's verwenden */
    if(i>0) return i; /* Fehler beim Schreiben -- Ende */
    /* Sound-Dateien bearbeiten und modifizieren */
    i = putSF(cRte,dat,true); /* Sound-Dateien modifiziert schreiben */
    if(i>0) return i; /* Fehler beim Schreiben -- Ende */

    /* Schienendatenbank bearbeiten */
    i = putDBF(cRte,dat,16); /* Schienendatenbank schreiben */
      /* Modus: neue UiD's verwenden */
    if(i>0) return i; /* Fehler beim Schreiben */

    /* Schienendatenbank (.tit) bearbeiten */
    i = putITF(cRte,dat,0,false); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      /* Strassendatenbank bearbeiten */
      i = putDBF(cRte,dat,17); /* Strassendatenbank schreiben */
        /* Modus: neue UiD's verwenden */
      if(i>0) return i; /* Fehler beim Schreiben */

      /* Strassendatenbank (.rit) bearbeiten */
      i = putITF(cRte,dat,1,false); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */
    } /* Strassendatenbank vorhanden und geladen */

    /* "tsection.dat" (lokal) neu erstellen */
    i = putTSL(cRte,cRte,OV); /* neue lokale 'tsection.dat' schreiben */
    if(i>0) return i; /* Fehler -- beenden */

    /* Tile-/Puffer-Dateien kopieren falls gefordert */
    if(Fo.chkMsk(1)) { /* kopieren/loeschen der Puffer gefordert */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("clrDB28"); /* Aktionsmeldung ausgeben */
      c4 = 0; /* Zaehler initialisieren */
      if(OV) { /* loeschen aller nicht notwendigen Dateien */
//!!
      } else { /* Kopieren der Dateien notwendig */
        if((is=cpyTile(cRte,false,Fo.chkMsk(2)))!=null) { /* Fehler erhalten */
          /* directory could not be created */
          Lg.Skip(true); /* Leerzeile loggen */
          Lg.Msg("Msg010",is); /* Abbruchmeldung */
          Lg.Close(); /* close output to Log-file */
          return 20;  /* terminate function with errorcode */
        } /* directory could not be created -- terminate function with errorcode */
        if(loT) /* auch LO-Tiles bearbeiten */
         if((is=cpyTile(cRte,true,Fo.chkMsk(2)))!=null) { /* Fehler erhalten */
          /* directory could not be created */
          Lg.Skip(true); /* Leerzeile loggen */
          Lg.Msg("Msg010",is); /* Abbruchmeldung */
          Lg.Close(); /* close output to Log-file */
          return 20;  /* terminate function with errorcode */
        } /* directory could not be created -- terminate function with errorcode */
      } /* Tile-Dateien kopieren */
      Lg.Msg("clrDB29"); /* Aktionsmeldung ausgeben */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* kopieren der Tile-Dateien gefordert */


    /* Path-Definitionen werden bearbeitet (Quadrate austauschen) */
    i = putPatF(cRte,dat,2); /* Path-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Service-Definitionen werden neu geschrieben (TrItems!) */
    i = putSrvF(cRte,dat,2); /* Service-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Traffic-Definitionen werden neu geschrieben (TrItems!) */
    i = putTrfF(cRte,dat,2); /* Traffic-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Activity-definitions are written again (several changes) */
    i = putActF(cRte,dat,2); /* Write Activities again (only) */
    if(i>0) return i; /* severe error -- terminate function */

    /* Process all shape-objects, copy shapes, get textures and copy them, too */
    if(SNme!=null) { /* process only if really requested */
      Lg.Skip(true); /* print empty line to log */
      Lg.Msg("clrDB41",SNme.size()); /* followed by action-message */
      TNme = new TSNameSet(true,".ace"); /* initialize list of textures */
      datz = cRte.getFile(-2); /* get source-folder of global shapes */
      dir = cRte.getFile(15); /* get source-folder of shape-definitions */
      dirz = cRte.getFile(45); /* preset folder for target */
      if(OV) { /* target is teporary folder ('inplace') */
        try { is = File.createTempFile("TSUtil",".tmp").getName();
        } catch (IOException e) { /* Creation-Fehler Temp-folder */
         System.err.println(e.toString());  return 5;}
        dirz = cRte.getFile(1,is); /* create temporary directoryname */
        if(!dirz.exists()) dirz.mkdirs(); /* create directory(ies) if needed */
      } /* 'inplace' was specified */
      if(dirz==null) { /* target cannot be accessed */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("MsgC63",cRte.getInfo(45)); /* print termination-message */
        Lg.Close(); /* close output to Log-file */
        return 20;  /* terminate function with errorcode */
      } /* target cannot be accessed -- terminate function with errorcode */
      sI = SNme.keyIterator(true); /* get iterator for all shape-keys in list */
      while(sI.hasNext()) { /* more filenames present ? */
        is = sI.next(); /* yes -- get name of next shape-file */
        if(is.endsWith(".ace")) { /* Texture-file found -- process it */
          TNme.add(SNme.get(is)); /* add file to list of textures */
          sI.remove(); /* file should not be processed again */
          continue; /* file is fully processed */
        } /* Texture-file found */
        if(!is.endsWith(".s")) continue; /* no shape-file -- do not process */
          /* e.g '*.haz'-files are not processsed */
        is = SNme.get(is); /* get correct notation of name */
        dat = new File(dir,is); /* create full name of shape-file (source) */
        if(!dat.exists()) nf:{ /* source-file cannot be found */
          dat = new File(datz,is); /* create full name of shape-file (source) */
          if(dat.exists()) break nf; /* source-file found -- process it */
          Lg.Err("clrDB42",is); /* print message */
          sI.remove(); /* file-definition processed -- do not use it again */
          continue; /* process next file (do not tra description-file) */
        } /* shape-file(source) was NOT found */
        if((js=chkShape(dat,TNme))!=null) /* extract image (.ace) */
          Lg.Err("clrDB43",dat.getPath(),js); /* Fehlermeldung */
        try {dat = dat.getCanonicalFile();} catch(IOException e) { /* consolidate the path */
          Lg.Skip(true); /* Leerzeile loggen */
          Lg.Msg("MsgC64",dat.getPath(),e.toString()); /* print termination-message */
          Lg.Close(); /* close output to Log-file */
          return 20;  /* terminate function with errorcode */
        } /* consolidate the path -- terminate function with errorcode */
        if(dir.equals(dat.getParentFile())) continue; /* file refer to standard shapes-dir -- use it */
        sI.remove(); /* file-definition processed -- do not use it again */
      } /* process all shape-files */

      Lg.Msg("clrDB49",SNme.size()); /* report remaining shape-definitions */
      fl = dir.list((FilenameFilter)SNme); /* list affected files */
      for(String fn : fl) { /* process all entries */
        dat = new File(dir,fn); /* create full source-filename */
        is = new File(dirz,fn).getAbsolutePath(); /* create target-filename */
        is = "copy \"" + dat.getAbsolutePath() + "\" \"" + is + "\" ";
          /* create copy - command */
        if((i=exec(true,is,null,null))>0) { /* error occurred during execution */
          Lg.Log("clrDB45",dat.getName(),i); /* print error-message */
          continue; /* and continue with next file/directory */
        } /* copy was NOT sucessfull */
        fn += "d"; /* change shape-name to definition-file */
        dat = new File(dir,fn); /* create full name of shape-file (source) */
        if(!dat.exists()) { /* source-file cannot be found */
          Lg.Err("clrDB44",fn); /* print message */
          continue; /* process next file */
        } /* shape-file(source) was NOT found */
        datz = new File(dirz,fn); /* create full name of shape-file (target) */
        is = "copy \""+dat.getAbsolutePath()+"\" \""+
          datz.getAbsolutePath()+"\" "; /* create copy - command */
        if((i=exec(true,is,null,null))>0) /* error during execution */
          Lg.Log("clrDB45",dat.getName(),i); /* print error-message */
      } /* process all shape-files */
      if(OV) { /* target was teporary folder -- rename it ('inplace') */
        is = "RMDir /s /q \""+dir.getAbsolutePath()+"\" "; /* create command */
        if((i=exec(true,is,null,null))>0) /* error during execution */
          Lg.Log("clrDB46",dir.getName(),i); /* print error-message */
        is = "Move /y \""+dirz.getAbsolutePath()+"\" Shapes "; /* create command */
        if((i=exec(true,is,null,null))>0) /* error during execution */
          Lg.Log("clrDB47",dirz.getName(),i); /* print error-message */
      } /* 'inplace' was specified */
      SNme.clear(); /* delete all entries (gc) */

      Lg.Skip(true); /* print empty line to log */
      Lg.Msg("clrDB50",TNme.size()); /* followed by action-message */
      dir = cRte.getFile(17); /* get source-folder of texture-definitions */
      dirz = cRte.getFile(47); /* preset folder for target */
      if(OV) { /* target is teporary folder ('inplace') */
        try { is = File.createTempFile("TSUtil",".tmp").getName();
        } catch (IOException e) { /* Creation-Fehler Temp-folder */
         System.err.println(e.toString());  return 5;}
        dirz = cRte.getFile(1,is); /* create temporary directoryname */
        if(!dirz.exists()) dirz.mkdirs(); /* create directory(ies) if needed */
      } /* 'inplace' was specified */
      if(dirz==null) { /* target cannot be accessed */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("MsgC63",cRte.getInfo(47)); /* print termination-message */
        Lg.Close(); /* close output to Log-file */
        return 20;  /* terminate function with errorcode */
      } /* target cannot be accessed -- terminate function with errorcode */
      vn2 = "clrDB5"; /* set prefix of error-messages */
      i = cpyTree(TNme,dir,dirz,null); /* copy all used texture-files */
      if(OV) { /* target was teporary folder -- rename it ('inplace') */
        is = "RMDir /s /q \""+dir.getAbsolutePath()+"\" "; /* create command */
        if((i=exec(true,is,null,null))>0) /* error during execution */
          Lg.Log("clrDB56",dir.getName(),i); /* print error-message */
        is = "Move /y \""+dirz.getAbsolutePath()+"\" Textures "; /* create command */
        if((i=exec(true,is,null,null))>0) /* error during execution */
          Lg.Log("clrDB57",dirz.getName(),i); /* print error-message */
      } /* 'inplace' was specified */
      TNme.clear(); /* delete all entries (gc) */
    } /* option requests copy of shapes */

    if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("clrDB91"); /* Ergebnis melden */
    Lg.Msg("clrDB92",ShA); /* Ergebnis melden */
    Lg.Msg("clrDB93",ScA); /* Ergebnis melden */
    Lg.Msg("clrDB94",cRte.get$Sh(true)); /* Ergebnis melden */
    Lg.Msg("clrDB95",cRte.get$Sc(true)); /* Ergebnis melden */

    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
 }

 /**. <pre>
  *=====================================================================
  * Methode "chkRef"
  * Referenzkette rekursiv auf fehlende Definitionen analysieren
  * Antwort: min. ein Objekt definiert -  'true' - ja, 'false' - nein
  * Methode wird ausschliesslich in 'clearDB' benutzt
  * ##chkRef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static boolean chkRef( /* Referenzkette analysieren */
   TSTrNde cTrN) /* aktuelles Element der Kette */
   {
   /*-----------------------------------------------------------------*/
    TSTrNde nTrN;  /* naechstes DB-Element */
    int     i;     /* Arbeitswert */
    boolean valid; /* gueltiges Objekt gefunden */
   /*=================================================================*/
    if(cTrN==null) return false; /* kein gueltiges Objekt vorhanden */
    cTrN.setMsk(30); /* Knoten als bearbeitet markieren (Phase 1) */
    valid = !cTrN.chkMsk(21); /* Objekt-Status merken */
    /* Objekt bearbeitet -- weiter in Kette */
    for(i=0;i<cTrN.getTyp();i+=1) { /* alle Sub-Ketten bearbeiten */
      nTrN = cTrN.getTrN(i); /* A.. Verkettungselement */
      if(nTrN==null) continue; /* kein gueltiges Verkettungselement
        * Auch 0-Verkettungen fallen hierunter! */
      if(nTrN.chkMsk(30)) continue; /* schon bearbeitet -- NICHT pruefen */
      valid |= chkRef(nTrN); /* (Teil-)Objekt-Staus bearbeiten */
    } /* alle verkettete Objekte pruefen */
    return valid; /* Status der Teil-Kette liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "cpyRef"
  * Referenzkette rekursiv in neue DB-Definition kopieren
  * Methode liefert den letzten benutzten Index der neuen Tabelle
  * Methode wird ausschliesslich in 'clearDB' benutzt
  * ##cpyRef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int cpyRef( /* Referenzkette kopieren */
   int                ix,   /* letzter belegter Index der neuen Tabelle */
   ArrayList<TSTrNde> TrN,  /* neue Tabelle der *.xdb-Elemente */
   TSTrNde            cTrN) /* aktuelles Element der Kette */
   {
   /*-----------------------------------------------------------------*/
    TSTrNde nTrN; /* naechstes TrackNode-DB-Element */
    int     i;    /* Arbeitswert (index) */
   /*=================================================================*/
    if(cTrN==null) return ix; /* kein Objekt -- Index unveraendert */
    cTrN.setMsk(31); /* Knoten erneut als bearbeitet markieren */
    TrN.add(cTrN);   /* aktuelles Element der Kette eintragen */
    ix += 1;         /* Nutzung (=ID) zaehlen */
    cTrN.chgIx(ix);  /* und neuen Index setzen */
    if(EnaH) Lg.Log("clrDB1"+cTrN.getTyp(), /* Meldung: genutzt */
      TSLogg.getMsg("clrDB22",ix),cTrN.getNr(true),0);
    /* Objekt bearbeitet -- weiter in Kette */
    for(i=0;i<cTrN.getTyp();i+=1) { /* alle Sub-Ketten bearbeiten */
      nTrN = cTrN.getTrN(i); /* A.. Verkettungselement */
      if(nTrN==null) continue; /* kein gueltiges Verkettungselement
        * Auch 0-Verkettungen fallen hierunter! */
      if(nTrN.chkMsk(31)) continue; /* schon bearbeitet -- NICHT nochmal */
      ix = cpyRef(ix,TrN,nTrN); /* Referenzkette rekursiv kopieren */
    } /* alle verkettete Objekte bearbeiten */
    return ix; /* neuen Index liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "clrRef"
  * Werte in Referenzkette rekursiv loeschen
  *   (cTrN-Kette soll entfernt werden)
  * Methode wird ausschliesslich in 'clearDB' benutzt
  * ##clrRef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void clrRef( /* Werte in Referenzkette loeschen */
   TSTrNde cTrN, /* aktuelles Element der Kette */
   TSRoute cRte) /* Definition der aktuellen Route */
   {
   /*-----------------------------------------------------------------*/
    TSVector          cNde; /* current vector-node */
    ArrayList<TSRefC> ItR;  /* Liste der TrItem-Referenzen */
    TSRefC            cRef; /* Aktuelle TrItem-Referenz */
    TSTrItm           cIt;  /* aktuelles TrItem */
    int               i;    /* Arbeitswert */
   /*=================================================================*/
    if(cTrN==null) return; /* kein Objekt -- keine Aktion */
      /* Auch 0-Verkettungen fallen hierunter! */
    if(cTrN.chkMsk(31)) return; /* schon bearbeitet -- NICHT nochmal */
    if(EnaH) Lg.Log("clrDB1"+cTrN.getTyp(), /* Meldung: geloescht */
      TSLogg.getKey("clrDB21"),cTrN.getNr(true),0);
    cTrN.setMsk(31); /* Knoten als bearbeitet markieren (Phase 2) */
    for(i=0;i<cTrN.get$Nde();i+=1) { /* alle Node-Eintraege bearbeiten */
      cNde = cTrN.chgNde(i,null); /* verbundene Node holen */
      cNde.clrS(ShA,cRte); /* Shape/Section-Referenz loeschen */
    } /* Node wurde bearbeitet */
    ItR = cTrN.getItm(0); /* TrItem-Referenzen definiert? */
    if(ItR!=null) { /* TrItem-Referenzen vorhanden -- bearbeiten */
      for(i=0;i<ItR.size();i+=1) { /* alle referenzierten TrItems */
        cRef = ItR.get(i); /* Steuerung der Zuordnung holen */
        if(cRef==null) throw new IllegalStateException( /* Sicherheitsabfrage */
          TSLogg.getMsg("Msg908","TSRefC(TSTrItem)==null","cldDB/clrRef()",0));
        cIt = (TSTrItm)cRef.chgRef(null); /* TrItem-Zuordnung holen */
        if(cIt==null) throw new IllegalStateException( /* Sicherheitsabfrage */
          TSLogg.getMsg("Msg908","TSTrItem==null","cldDB/clrRef()",0));
        cIt.incCnt(-1); /* Referenz um '1' verringern */
        if(cIt.incCnt(0)==0) cIt.setMsk(0); /* Item nicht mehr schreiben */
      } /* TrItem wurde bearbeitet */
      cTrN.chkItm(true); /* Alle TrItem-Referenzen loeschen */
    } /* TrItem-Referenzen sind/waren vorhanden */
    /* Objekt bearbeitet -- weiter in Kette */
    for(i=0;i<cTrN.getTyp();i+=1) /* alle Sub-Ketten bearbeiten */
      clrRef(cTrN.getTrN(i),cRte); /* Referenzkette bearbeiten */
    return; /* aktuelles Element wurde bearbeitet */
  }

 /**. <pre>
  *=====================================================================
  * Methode "toZuSi" (-21-)
  * Streckendaten in das ZuSi-Format konvertieren
  * Optionen:
  * ##toZuSi (Eyecatcher)
  * ##ZuSi (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int toZuSi( /* Streckendefinition konvertieren */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute           cRte; /* aktuelle Routendefinition */
    TSFile            cF;   /* current buffered outputfile */
    ArrayList<TSTemp> NT;   /* Datenbank-Tabelle Track-Nodes */
    TSTemp            cNT,dNT; /* Eintraege in der DB-Tabelle Track-Nodes */
    TSTrNde           cTrN,vTrN,nTrN; /* TrackNode-DB-Elemente */
    TSVector          cNde; /* current vector-node of DB-element */
    TSCoo             cCoo; /* aktuelle Koordinatendefinition */
    File              dir,dat; /* Dateidefinitionen */
    double            cP,zf,zt; /* Positionswert */
    double            cLon,cLat,cHgt,cRad,cAng,cHd; /* Konsolidierungswerte */
    int               i,j,u,t,c,db,cc; /* Arbeitswerte */
    String            is,js,MgK;
    Iterator<TSTrNde> aI; /* Iterator fuer TrackNode-Tabelle */
    Iterator<TSTemp>  cI; /* Iterator fuer Zwischentabelle */
//    boolean   OV,loT;
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("toZuSi01",fn); /* Vorlauf ausgeben */

    /* Systemdatei lesen und auswerten */
    cRte = getRte(fn,2); /* Streckendefinition auswerten */
    if(cRte==null) return 5; /* Fehler -- Ende */

    /* print current paths */
    Lg.Msg("MsgC01",cRte.getInfo(2)); /* print route-name */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* print system-path */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* print route-path */
    Lg.Skip(true); /* and add empty line */

    /* globale "tsection.dat" bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC05"); /* Aktionsmeldung ausgeben */

    dat = cRte.getFile(-1); /* get reference to file */
    i = getTS(dat,null);    /* and load 'tsection.dat' (global) */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC08",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC11",c3); /* Ergebnis melden */
    Lg.Log("MsgC14",ScN); /* Ergebnis melden */
    Lg.Log("MsgC17",c2); /* Ergebnis melden */
    Lg.Log("MsgC20",ShN); /* Ergebnis melden */
    Lg.Log("MsgC23",c4); /* Ergebnis melden */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(cRte,ScA,ShA); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* zusaetzliche Streckendateien laden */
    i = getType(cRte); /* 'ttype.dat' laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strukturquadrate laden (genaue Ausfuehrung) */
    i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC26",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Strukturquadrate laden (LO-Tiles) */
//    loT = true; /* annehmen: LO-Tiles sind vorhanden */
    i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
    if(i>0) { /* Fehler beim Laden der Strukturquadrate */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC27",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
//    if(i<0) loT = false; /* LO-Tiles gibt es nicht */

    /* Schienendatenbank laden */
    i = getDBF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    i = getITF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strassendatenbank laden */
    i = getDBF(cRte,1); /* Strassendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    if(i==0) { /* Datenbank ist vorhanden */
      i = getITF(cRte,1); /* Strassendatenbank laden und pruefen */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* Datenbank(teil) ist vorhanden */

    /* World-Dateien laden und syntaktisch pruefen */
    i = getWF(cRte,false); /* World-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */
    /* Sound-Dateien laden und syntaktisch pruefen */
    i = getSF(cRte,false); /* World-Sound-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */

    /* Signal-Definitionen laden und ueberpruefen */
    i = getSCfg(cRte,cRte.getFile(21),null,false); /* load Signal-Configurations */
    if(i==0) /* Laden erfolgreich -- weiter testen */
      i = getSScr(cRte,cRte); /* Signal-Script-Definitionen laden */

    /* Path-Definitionen werden geladen und ueberprueft */
    i = getPatF(cRte,true); /* Path-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Service-Definitionen werden geladen und ueberprueft */
    i = getSrvF(cRte,true); /* Service-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Traffic-Definitionen werden geladen und ueberprueft */
    i = getTrfF(cRte,true); /* Traffic-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Activity-Definitionen werden geladen und ueberprueft */
    i = getActF(cRte,true); /* Activity-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */


    /* all files were loaded -- continue with integrity-check */
    if((is=cRte.chkRte(Fo,true))!=null) { /* check route for integrity -- error found ? */
      if(is.charAt(0)!=' ') { /* error-message returned */
        Lg.Skip(true); /* skip line */
        Lg.Err("getRte23",is); /* print errormessage */
        Lg.Msg("MsgC60"); /* print message: 'terminating' */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* error found -- function terminated */
      if(EnaW) Lg.Log("chkRte00",is); /* Warning found -- print it */
    } /* error/warning found */

    /* "world"-Dateien bearbeiten und neue Integritaet herstellen */
    chkWrld(cRte,null,4); /* World-Dateien erweitert pruefen */
      /* Modus: keine Aenderungen melden, kein Renum */

    /* Sound-Dateien bearbeiten und neue Integritaet herstellen */
    i = chkSnd(cRte,null,0); /* Sound-Dateien erweitert pruefen */
      /* Modus: keine Aenderungen melden */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("MsgC33",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("toZuSi04"); /* Aktionsmeldung ausgeben */
    if(cRte.get$TrN(0)<=0) { /* Schienendatenbank NICHT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC36"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datenbank nicht vorhanden */

    i = chkDBTab(cRte,128); /* Schienendatenbank bearbeiten */
      /* Option (128) aktiv: falsche Referenzen loeschen */
    if(i<0) return 5; /* Systemfehler -- Ende */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("toZuSi05"); /* Aktionsmeldung ausgeben */
    Lg.Msg("MsgC38",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("toZuSi06"); /* Aktionsmeldung ausgeben */

      i = chkDBTab(cRte,129); /* Strassendatenbank bearbeiten */
        /* Option (128) aktiv: falsche Referenzen loeschen */
      if(i<0) return 5; /* Systemfehler -- Ende */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("toZuSi07"); /* Aktionsmeldung ausgeben */
      Lg.Msg("MsgC38",i); /* Ergebnis melden */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Strassendatenbank vorhanden und geladen */

    /* extended check of local 'tsection.dat'
     * Attention: This method MUST NOT be invoked unless worldfiles AND
     * database (track/road) is stored again (or neither). */
    chkTSL(cRte,ScN,ShN); /* check file and compact it */

    i = chkPat(cRte); /* Pfad-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkSrv(cRte,false); /* Service-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkTrf(cRte,false,false); /* Traffic-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkAct(cRte,false); /* process activity-definitions */
    if(i>0) return 5; /* systemerror occurred -- terminate */

    /* ZUSI-XML-Datei erstellen */
    for(db=0;db<1;db+=1) { /* alle Datenbanken bearbeiten */
      i = cRte.get$TrN(db); /* aktuelle Groesse des Track-Node-Speichers */
      if(i<=0) continue; /* Datenbank ist nicht vorhanden */
      MgK = "toZuSi" + (db+2); /* Message-Kennung (gemeinsamer Teil) erstellen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg(MgK+"0"); /* Aktionsmeldung ausgeben */

      /* Datenbank aufbereiten */
      NT = new ArrayList<TSTemp>(i); /* interne-Speicher-Tabelle */
      is = "Route"+db+".xml"; /* Dateiname erstellen */
      dat = cRte.getFile(2,is); /* Namesdefinition erstellen */
      if(dat==null) { /* Datei nicht erstellbar */
        Lg.Skip(false); /* Leerzeile Loggen */
        Lg.Msg("toZuSi11",is); /* Abbruchmeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 15; /* terminate function with errorcode */
      } /* Dateifehler */
      cF = new TSFile(dat); /* create and define file (ASCII) */
      if((is=cF.open(TSFile.OA))!=null) { /* open file -- error occurred? */
//      cF = new TSFile(dat,TSFile.A); /* create and define file (ASCII) */
//      if((is=cF.open(true,0))!=null) { /* open file -- error occurred? */
        Lg.Skip(false); /* print empty line to log */
        Lg.Msg("toZuSi12",is,dat.getName()); /* print message: terminating */
        Lg.Close(); /* close output to Log-file */
        return 15; /* terminate function with errorcode */
      } /* Error found while 'open' */

      bl: { /* block for error-break */
        is = TSLogg.getKey("toZuSiX0"); /* Datenzeile erstellen */
        cc = 21; /* praeventiver Fehlercode */
        if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
        is = TSLogg.getKey("toZuSiX1"); /* Datenzeile erstellen */
        cc = 22; /* praeventiver Fehlercode */
        if((is=cF.putData(is))!=null) break bl; /* write data -- error? */

        /* 1. Teil 'RoutePoint' definieren und ausgeben */
        c = 0; /* ID-Nummern initialisieren */
        aI = cRte.getIt(db); /* Iterator fuer TrackNode-Definitionen (alt) */
        while(aI.hasNext()) { /* Alle TrackNode-Definitionen bearbeiten */
          if((cTrN=aI.next())==null) continue; /* Fehl-Eintrag uebergehen */
          t = cTrN.getTyp(); /* Aktueller Typ der Node */
          if(t<1 || t==2) continue; /* Node-Typ ist NICHT Beginn einer Kette */
            /* 'TrVectorNodes' werden NOCH nicht bearbeitet */
          for(u=0;u<t;u+=1) { /* alle Positionen pruefen */
            if(cTrN.getTrN(u)==null) continue; /* 'Blue Pole' nicht verwenden */
              /* Einzelne Node ('Blue Pole', 'Red Pole') wird NICHT genutzt.
               * Wenn alle Node-Referenzen nicht genutzt sind (0-Verkettung), ist die
               * Node fehlerhaft und wird NICHT genutzt.
               * Achtung: Durch die Abfrage 'cTrN.getTrN(u)==null' statt
               *          'cTrN.chkMsk(u)' werden auch fehlerhafte Verkettungen als
               *          0-Verkettungen gewertet.
               */
            /* Node ist Anfang/Ende einer gueltigen Kette -- ID vergeben */
            i = ++c;                  /* define new ID-number */
            cNT = new TSTemp(cTrN,i); /* create control-entry */
                                      /* inclusive TrackNode-Reference */
            NT.add(cNT); /* and store it into table as next element */

            cNde = cTrN.chgNde(0,null); /* aktuelle Definition holen */
            cCoo = cNde.crCoo(); /* aktuelle Koordinate definieren */
            if(cCoo==null) { /* Fehler: Position nicht auffindbar */
 Lg.Msg("toZuSi99","3",""+cNT.chgNr(Integer.MIN_VALUE),""+u,""+t);
              break bl; /* Fehler: Position nicht auffindbar */
            } /* Fehler: Position nicht auffindbar */
            cP = cCoo.getLat(); /* Cooitionswert holen (init Umwandlung) */
            if((is=cCoo.getErr())!=null) { /* Umwandlungsfehler */
 Lg.Msg("toZuSi99","4",""+cNT.chgNr(Integer.MIN_VALUE),""+u,""+t,is);
              break bl; /* Umwandlungsfehler */
            } /* Umwandlungsfehler */

            zf = cNde.getDir(1); /* Wert fuer 'Heading' holen */
            if(zf>Math.PI) zf -= TSCoo.PI2; /* Wert konsolidieren */
            is = TSLogg.getMsg("toZuSiX3",""+zf,i,t); /* Datenzeile erstellen */
            cc = 21; /* praeventiver Fehlercode */
            if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
            is = TSLogg.getMsg("toZuSiX4","lat",cP); /* Datenzeile erstellen */
            cc = 21; /* praeventiver Fehlercode */
            if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
            is = TSLogg.getMsg("toZuSiX4","lon",cCoo.getLon()); /* Datenzeile erstellen */
            cc = 21; /* praeventiver Fehlercode */
            if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
            is = TSLogg.getMsg("toZuSiX5","elev",cCoo.getHgt()); /* Datenzeile erstellen */
            cc = 21; /* praeventiver Fehlercode */
            if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
            is = TSLogg.getKey("toZuSiX6"); /* Datenzeile erstellen */
            cc = 21; /* praeventiver Fehlercode */
            if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
            break; /* Positionspruefung abbrechen */
          } /* alle Kettenpositionen pruefen */
        } /* alle Track-Nodes bearbeiten */

        cI = NT.iterator(); /* liefert alle Elemente aus 'NT' */
        while(cI.hasNext()) { /* alle verwendeten TrackNodes bearbeiten */
          if((cNT=cI.next())==null) continue; /* Kette startet hier NICHT */
          cTrN = cNT.chgTrN(null); /* zugeordneten Node-Eintrag holen */

          t = cTrN.getTyp(); /* Aktueller Typ der Node */
          for(u=0;u<t;u+=1) { /* alle moeglichen Ketten-Starts bearbeiten */
            if(cNT.chkMsk(u)) continue; /* Eintrag ist bereits bearbeitet */
            if(cTrN.chgTrN(u,null).chgIx(Integer.MIN_VALUE)==0) continue; /* Verkettung an
              * das HINTERE Ende. Eintrag wird spater erreicht.
              */
            cNT.setMsk(u); /* Knotenposition als bearbeitet markieren */
            vTrN = cTrN.getTrN(u); /* angehaengter Knoten der Kette praeventiv holen */
            if(vTrN==null) continue; /* 0-Verkettung nicht verwenden */

            /* Situation: Eintrag ist an das vordere Ende eines folgende VectorNode's angeb.
             * cTrN - aktueller Node des Kettenbeginns ('Junction', 'End')
             * vTrN - angehaengter Vector-Node
             * nTrN - folgender Node des KettenEndes ('Junction', 'End')
             */
            /* 'vTrN' ist angehaengter VectorNode der Kette */
            if(vTrN.getTyp()!=2) { /* Kettungsfehler -- Ende der Bearbeitung */
 Lg.Msg("toZuSi99","5",""+cNT.chgNr(Integer.MIN_VALUE),""+u,""+t,""+vTrN.getTyp());
              break bl; /* Kettungsfehler -- Ende der Bearbeitung */
            } /* Kettungsfehler -- Ende der Bearbeitung */
            i = 1; /* Index fuer Weiterverkettung (angenommen) */
            if(vTrN.getTrN(0)!=cTrN) { /* Kettungsfehler ? */
              i = 0; /* alternativer Index festhalten */
              if(vTrN.getTrN(1)!=cTrN) { /* Kettungsfehler -- Ende der Bearbeitung */
 Lg.Msg("toZuSi99","6",""+cNT.chgNr(Integer.MIN_VALUE),""+u,""+vTrN.getNr(true));
                break bl; /* Kettungsfehler -- Ende der Bearbeitung */
              } /* Kettungsfehler -- Ende der Bearbeitung */
            } /* Index der Weiterverkettung finden */
            nTrN = vTrN.getTrN(i); /* naechster Node der Kette holen */
            if(nTrN==null) { /* Kettungsfehler (Systemfehler)-- Ende der Bearbeitung */
 Lg.Msg("toZuSi99","7",""+cNT.chgNr(Integer.MIN_VALUE),""+u,"?");
              break bl; /* Kettungsfehler -- Ende der Bearbeitung */
            } /* Kettungsfehler -- Ende der Bearbeitung */
            dNT = null; /* fuer Compiler */
            for(i=0,j=NT.size();i<j;i+=1) /* Originaleintrag der verketten Node suchen */
              if((dNT=NT.get(i)).chgTrN(null)==nTrN) break; /* Eintrag gefunden -- Suche abbrechen */
            if(i>=j) { /* Kettungsfehler -- Ende der Bearbeitung */
              j = nTrN.getNr(true); /* Original Indexnummer des Nodes */
              /* folgender Node des Kettenendes ist KEIN zulaessiger Node (Typ) */
 Lg.Msg("toZuSi99","7",""+cNT.chgNr(Integer.MIN_VALUE),""+u,""+j); /* Provisorische Meldung */
              break bl; /* Kettungsfehler -- Ende der Bearbeitung */
            } /* Kettungsfehler -- Ende der Bearbeitung */
            j = nTrN.getTyp(); /* aktueller Typ der verketteten Node */
            for(i=0;i<j;i+=1) if(nTrN.getTrN(i)==vTrN) dNT.setMsk(i);
              /* Rckverkettung als bearbeitet markieren */
            /* Gesamte Node-Kette ist als bearbeitet markiert */

            i = cNT.chgNr(Integer.MIN_VALUE); /* Start-Referenz holen */
            j = dNT.chgNr(Integer.MIN_VALUE); /* Ziel-Referenz holen */
            if(cTrN.chgTrN(u,null).chgIx(Integer.MIN_VALUE)==1) is = TSLogg.getMsg("toZuSiX7",null,i,j);
            else is = TSLogg.getMsg("toZuSiX7",null,j,i); /* Start und Ziel vertauschen */
              /* Vector-Node kann jetzt IMMER vorwaerts durchlaufen werden */
            cc = 21; /* praeventiver Fehlercode */
            if((is=cF.putData(is))!=null) break bl; /* write data -- error? */

            /* init fuer Konsolidierung */
            cHgt = cLon = cLat = cAng = cRad = cHd = Double.NaN; /* noch nicht konsolidiert */
            c = 0; /* ID-Nummern initialisieren */
            j = vTrN.get$Nde(); /* Anzahl der UiD-Nodes holen (= Sub-Nodes) */
            for(i=0;i<j;i+=1) { /* alle Sub-Eintraege (<RouteSegment>) bearbeiten */
              cNde = vTrN.chgNde(i,null); /* aktuelle Definition holen */
              cCoo = cNde.crCoo(); /* aktuelle Koordinate definieren */
              if(cCoo==null) { /* Fehler: Position nicht auffindbar */
 Lg.Msg("toZuSi99","8",""+cNT.chgNr(Integer.MIN_VALUE),""+u,""+i);
                break bl; /* Fehler: Position nicht auffindbar */
              } /* Fehler: Position nicht auffindbar */
              cP = cCoo.getLat(); /* Cooitionswert holen (init Umwandlung) */
              if((is=cCoo.getErr())!=null) { /* Umwandlungsfehler */
 Lg.Msg("toZuSi99","9",""+cNT.chgNr(Integer.MIN_VALUE),""+u,is);
                break bl; /* Umwandlungsfehler */
              } /* Umwandlungsfehler */
              zt = cNde.getScV(true); /* aktuellen Radius/Laenge in der Section */
              if(Double.isNaN(zt)) { /* Fehler bei Zugriff auf Wert */
 Lg.Msg("toZuSi99","10",""+cNT.chgNr(Integer.MIN_VALUE),""+u,""+i);
                break bl; /* Umwandlungsfehler */
              } /* Umwandlungsfehler */
              zf = cNde.getScV(false);/* aktuellen Winkel in der Section */

              if(!Double.isNaN(cHgt)) KL:{ /* Konsolidieren oder schreiben */
                if(cAng==0.0) { /* Gerade liegt vor */
                  if(zf==0.0) { /* und Gerade folgt */
                    cRad += zt; /* Laengen addieren */
                    cHd = cNde.getDir(1); /* letzten Wert fuer 'Heading' holen */
                    break KL; /* Daten NICHT schreiben */
                  } /* Geraden konsolidiert */
                } else { /* Kurve liegt vor */
                  if(Math.abs(cRad-zt)<0.01) /* Radien (nahezu) gleich */
                   if((zf<0.0 && cAng<0.0) || (zf>0.0 && cAng>0.0)) { /* Richtung identisch */
                    cAng += zf; /* Winkel addieren */
                    cHd = cNde.getDir(1); /* letzten Wert fuer 'Heading' holen */
                    break KL; /* Daten NICHT schreiben */
                  } /* Geraden konsolidiert */
                } /* Konsolidierung NICHT erfolgt ? */
                if(cHd>Math.PI) cHd -= TSCoo.PI2; /* Wert konsolidieren */
                is = TSLogg.getMsg("toZuSiX9",""+cHd,c++); /* Datenzeile erstellen */
                cc = 21; /* praeventiver Fehlercode */
                if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
                is = TSLogg.getMsg("toZuSiXA","lat",cLat); /* Datenzeile erstellen */
                cc = 21; /* praeventiver Fehlercode */
                if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
                is = TSLogg.getMsg("toZuSiXA","lon",cLon); /* Datenzeile erstellen */
                cc = 21; /* praeventiver Fehlercode */
                if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
                is = TSLogg.getMsg("toZuSiXA","elev",cHgt); /* Datenzeile erstellen */
                cc = 21; /* praeventiver Fehlercode */
                if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
                is = TSLogg.getMsg("toZuSiXA","angle",cAng); /* Datenzeile erstellen */
                cc = 21; /* praeventiver Fehlercode */
                if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
                is = TSLogg.getMsg("toZuSiXB","radius",cRad); /* Datenzeile erstellen */
                cc = 21; /* praeventiver Fehlercode */
                if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
                cHgt = Double.NaN; /* Konsolidierungsbasis aufheben */
              } /* -KL- Konsolidierung oder Schreiben erfolgt */
              /* Wenn Schreiben erfolgt -- neue Konsolidierungsbasis erstellen */
              if(Double.isNaN(cHgt)) { /* keine Konsolidierungsbasis -- erstellen */
                cHgt = cCoo.getHgt(); /* Wert festhalten */
                cLon = cCoo.getLon(); /* Wert festhalten */
                cLat = cP; /* Wert festhalten */
                cAng = zf; /* Wert festhalten */
                cRad = zt; /* Wert festhalten */
                cHd = cNde.getDir(1); /* letzten Wert fuer 'Heading' festhalten */
              } /* Konsolidierungsbasis neu erstellt */
            } /* Alle Sub-Nodes bearbeiten */
            if(!Double.isNaN(cHgt)) { /* Letztes Segment auch schreiben */
              if(cHd>Math.PI) cHd -= TSCoo.PI2; /* Wert konsolidieren */
              is = TSLogg.getMsg("toZuSiX9",""+cHd,c); /* Datenzeile erstellen */
              cc = 21; /* praeventiver Fehlercode */
              if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
              is = TSLogg.getMsg("toZuSiXA","lat",cLat); /* Datenzeile erstellen */
              cc = 21; /* praeventiver Fehlercode */
              if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
              is = TSLogg.getMsg("toZuSiXA","lon",cLon); /* Datenzeile erstellen */
              cc = 21; /* praeventiver Fehlercode */
              if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
              is = TSLogg.getMsg("toZuSiXA","elev",cHgt); /* Datenzeile erstellen */
              cc = 21; /* praeventiver Fehlercode */
              if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
              is = TSLogg.getMsg("toZuSiXA","angle",cAng); /* Datenzeile erstellen */
              cc = 21; /* praeventiver Fehlercode */
              if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
              is = TSLogg.getMsg("toZuSiXB","radius",cRad); /* Datenzeile erstellen */
              cc = 21; /* praeventiver Fehlercode */
              if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
            } /* Letztes Segment wurde geschrieben */
            is = TSLogg.getKey("toZuSiX8"); /* Datenzeile erstellen */
            cc = 21; /* praeventiver Fehlercode */
            if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
          } /* alle moeglichen Ketten-Starts bearbeiten */

        } /* alle Track-Nodes bearbeiten */
        is = TSLogg.getKey("toZuSiX2"); /* Datenzeile erstellen */
        cc = 21; /* praeventiver Fehlercode */
        if((is=cF.putData(is))!=null) break bl; /* write data -- error? */
        cc = 0; /* kein Ausgabefehler aufgetreten */
      } /* -bl- break-block used in case of error */
      if(is!=null) Lg.Err("toZuSi18",is,dat.getName()); /* error occurred -- handle it */
      if((is=cF.close())!=null) Lg.Err("toZuSi19",is,dat.getName());
        /* close output-file again -- handle error if present */

      if(cc!=0) Lg.Err(MgK+"9",cc); /* Aktionsmeldung */
      else if(EnaH) Lg.Log(MgK+"8",cF.getStat(true)); /* Aktionsmeldung */
    } /* process both databases */

    if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("toZuSi09"); /* Ergebnis melden */

    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
 }

 /**. <pre>
  *=====================================================================
  * Methode "shftDyn" (-22-)
  * Dynamische Shapes/Sections verschieben
  * Optionen:
  *       1 - Simuliere World-Referenzen fuer dyn-Eintraege
  *       3 - World-Dateien auf JEDEN Fall komprimieren
  *       4 - World-Dateien NICHT komprimieren
  *      16 - Extended output to LOG (-d,Hidden)
  *      17 - Dateien direkt ueberschreiben (-inplace,Hidden)
  * ##shftDyn (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int shftDyn( /* Dynamische Definitionen verschieben */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute           cRte; /* aktuelle Routendefinition */
    TreeSet<TSQuad>   QDf;  /* alle Quadrat-Definitionen */
    TSQuad            cQDf; /* aktuelle/vorangehende Quadrat-Definition */
    TSTrNde           cTrN; /* aktuelles TrackNode-DB-Element */
    TSVector          cNde; /* current/predecessor vector-node */
    TSUiD             cUiD,xUiD; /* UiD-Arbeitswert(e) */
    TSSc              cSc;  /* aktuelle Section (lokal/global) */
    TSScL             cScL; /* aktuelle lokale Section */
    TSShL             cShL; /* aktuellen lokalen Pfad */
    TSQPos            cPos; /* aktuelle (relative) Position */
    TSQDir            cQDir; /* aktuelle Rotationsdefinition (Quaternion) */
    File              dat;  /* Dateidefinitionen */
    int               i,j,m,in,cn; /* Arbeitswerte */
    double            w,cElv; /* Winkel/Speicher fuer Elevation */
    String            is;
    boolean           OV;
    Iterator<TSTrNde> aI;  /* Iterator fuer TrackNode-Tabelle */
    Iterator<TSScL>   sI;  /* Iterator of section-table */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("shftDy01",fn); /* Vorlauf ausgeben */

    OV = Fo.chkMsk(17); /* 'newRoute'-Directory benoetigt ? */
    /* Systemdatei lesen und auswerten */
    cRte = getRte(fn,OV?1:3); /* Streckendefinition auswerten */
    if(cRte==null) return 5; /* Fehler -- Ende */

    /* print current paths */
    Lg.Msg("MsgC01",cRte.getInfo(2)); /* print route-name */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* print system-path */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* print route-path */
    Lg.Skip(true); /* and add empty line */

    /* globale "tsection.dat" bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC05"); /* Aktionsmeldung ausgeben */

    dat = cRte.getFile(-1); /* get reference to file */
    i = getTS(dat,null);    /* and load 'tsection.dat' (global) */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC08",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC11",c3); /* Ergebnis melden */
    Lg.Log("MsgC14",ScN); /* Ergebnis melden */
    Lg.Log("MsgC17",c2); /* Ergebnis melden */
    Lg.Log("MsgC20",ShN); /* Ergebnis melden */
    Lg.Log("MsgC23",c4); /* Ergebnis melden */

    if(scd<1 || scd>=ScA) { /* Wertebereich ungueltig */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("shftDy02",null,scd,ScA); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 4;   /* terminate function with errorcode */
    } /* invalid value -- terminate function with errorcode */
    if(shd<1 || shd>=ShA) { /* Wertebereich ungueltig */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("shftDy03",null,shd,ShA); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 4;   /* terminate function with errorcode */
    } /* invalid value -- terminate function with errorcode */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(cRte,scd,shd); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* pruefen, ob eine Ueberlappung der Tabellen vorliegt. */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("shftDy04"); /* Aktionsmeldung ausgeben */
    m = cRte.get$Sc(true); /* obere Grenze der dynamischen Tabelle */
    m = Math.min(m,ScTab.length); /* maximal pruefbarer Wert */
    for(i=scd;i<m;i+=1) /* alle ueberlappten Eintraege pruefen */
      if(ScTab[i]!=null) if(EnaW) Lg.Log("shftDy05",i);
    m = cRte.get$Sh(true); /* obere Grenze der dynamischen Tabelle */
    m = Math.min(m,ShTab.length); /* maximal pruefbarer Wert */
    for(i=shd;i<m;i+=1) /* alle ueberlappten Eintraege pruefen */
      if(ShTab[i]!=null) if(EnaW) Lg.Log("shftDy06",i);

    /* zusaetzliche Streckendateien laden */
    i = getType(cRte); /* 'ttype.dat' laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strukturquadrate laden (genaue Ausfuehrung) */
    i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC26",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Schienendatenbank laden */
    i = getDBF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    i = getITF(cRte,0); /* Schienendatenbank laden und pruefen (2. Teil) */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strassendatenbank laden */
    i = getDBF(cRte,1); /* Strassendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    if(i==0) { /* Datenbank ist vorhanden */
      i = getITF(cRte,1); /* Strassendatenbank laden und pruefen (2. Teil) */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* Datenbank(teil) ist vorhanden */

    /* World-Dateien laden und syntaktisch pruefen */
    i = getWF(cRte,false); /* World-Dateien laden (ohne Korrekturmodus) */
    if(i>0) return i; /* Fehler -- Ende */
    /* Sound-Dateien laden und syntaktisch pruefen */
    i = getSF(cRte,false); /* World-Sound-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */

    /* Attention: Files are NOT written again (!OV->true) */
    /* Path-Definitionen werden geladen und ueberprueft */
    i = getPatF(cRte,true); /* Path-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Service-Definitionen werden geladen und ueberprueft */
    i = getSrvF(cRte,true); /* Service-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Traffic-Definitionen werden geladen und ueberprueft */
    i = getTrfF(cRte,true); /* Traffic-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Activity-Definitionen werden geladen und ueberprueft */
    i = getActF(cRte,true); /* Activity-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */


    /* all files were loaded -- continue with integrity-check */
    if((is=cRte.chkRte(Fo,true))!=null) { /* check route for integrity -- error found ? */
      if(is.charAt(0)!=' ') { /* error-message returned */
        Lg.Skip(true); /* skip line */
        Lg.Err("getRte23",is); /* print errormessage */
        Lg.Msg("MsgC60"); /* print message: 'terminating' */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* error found -- function terminated */
      if(EnaW) Lg.Log("chkRte00",is); /* Warning found -- print it */
    } /* error/warning found */

    if(Fo.chkMsk(1)) bl:{ /* Erstelle World-Datei-Referenzen fuer dyn-Eintraege */
      if((QDf=cRte.chgQDf(null))==null) break bl; /* Quadrat-Definitionen */

      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("shftDy07"); /* Aktionsmeldung ausgeben */
      Lg.Log("shftDy08"); /* Fortsetzung im Log ausgeben */
      aI = cRte.getIt(0); /* Iterator fuer TrackNode-Definitionen */
      while(aI.hasNext()) { /* Alle TrackNode-Definitionen bearbeiten */
        if((cTrN=aI.next())==null) continue; /* Fehl-Eintrag uebergehen */
        if(cTrN.getTyp()!=2) continue; /* NUR 'TrVectorNode' bearbeiten */

        cQDir = null; /* noch keine gueltige QDirection
          * cQDir zeigt immer 'IN Orientierungsrichtung' d.h mit der Methode 'turn()'
          * kann man die QDir vom Anfang der Section umrechnen auf die QDir vom Ende
          * der Section. Deshalb muss bei einer GEDREHTEN (twisted) Section die
          * INVERTIERTE QDir vom ENDE der Section in die UiD eingetragen werden.
          * Dieser Fall muss auch beruecksichtigt werden, wenn man den aktuellen
          * QDir-Wert aus der Node kopiert.
          * ACHTUNG: Positionsberechnungen sind NUR moeglich, weil KEIN Versatz wie
          * bei statischen Section/Shapes existiert. (Werte aus SectionIdx)
          * ( Die im Objekt eingetragenen Werte fuer Position und QDir beziehen sich
          *   immer auf die aktuelle Lage des Pivot-Punktes.)
          */
        xUiD = null; /* keine gespeicherte UiD als Flag */
        cElv = Double.NaN; /* fuer Compiler */
        cn = cTrN.get$Nde(); /* Anzahl der Sub-Eintraege holen */
        for(in=0;in<cn;in+=1) { /* alle Track-Sections bearbeiten */
          cNde = cTrN.chgNde(in,null); /* aktuell verkettetes Element */
          if(cNde==null) continue; /* 'cNde' kann nicht bearbeitet werden */

          cQDf = cNde.fndWrld(QDf,false); /* World-Referenz(UiD) vorab registrieren und holen */
          if(cQDf==null) { /* World-Datei(UiD) NICHT vorhanden -- Fehler */
            cQDir = null; /* Richtung (nochmal) loeschen */
            continue; /* naechstes Node-Element bearbeiten */
          } /* Fehler aufgetreten -- Gesamter Eintrag nicht nutzbar */

          m = cNde.getUid(); /* Nummer der gesuchten UiD holen */
          /* UiD NICHT vorbesetzen da 'UiD==null' Endekriterium ist */
          for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
            /* Modus 1: UID muss auf Schiene/Strasse zeigen! */
            if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT benutzen */
            if(cUiD.isCtl()) continue; /* kein aktiver UiD-Eintrag */
            if((cUiD=cUiD.chkId(m,0,1))!=null) break; /* UiD-Def. wurde gefunden -- OK */
          } /* nach UiD suchen */

          if(cQDir==null) { /* noch kein gueltiger QDir-Wert -- erstellen */
            if(cUiD==null) { /* kein World-Element -- keine Basis */
              /* pruefen ob Dyntrack-Dummy-Element erzeugt werden muss */
              j = cNde.getSh(true); /* aktuelle Shape-Nummer holen */
              if((cShL=cRte.chgShT(j,null))==null) continue; /* process next node
                * no valid path exists if 'null' is returned */

              /* Dummy-Element erzeugen! */
              cUiD = new TSDynTrk(cQDf.getOId(),0); /* World-Objekt erzeugen */
              cUiD.setUiD(m); /* und Kennnummer (UiD) direkt eintragen */
              cUiD.setOpt(0); /* merken: Dummy-World-Objekt liegt vor */
              /* ACHTUNG: World-Objekt wird VOLLSTAENDIG erstellt */
              i = 0; /* Section-Position innerhalb World-Objekt vorbesetzen */
              sI = cShL.getScR(); /* get iterator for all section-definitions */
              while(sI.hasNext()) { /* another section-definition available ? */
                cScL = sI.next(); /* get current section-entry */
                if(cScL.isCurve()) if(i%2==0) i += 1; /* Index fuer Kurve anpassen */
                if(i>4) break; /* Fehlerabbruch -- ungueltiger Index */
                ((TSDynTrk)cUiD).chgScR(i,false,cScL); /* Tracksection setzen */
                cScL.incCntW(1); /* und Referenz vermerken */
                if(cScL.isCurve()) bl0:{ /* Kurvendefinition liegt vor -- weiter */
                  cScL = cRte.chgScT(cScL.getNr(true)+1,null); /* naechsten Eintrag holen */
                  if(cScL==null) break bl0; /* nicht belegt -- weiter */
                  ((TSDynTrk)cUiD).chgScR(i,true,cScL); /* 2. Tracksection setzen */
                  cScL.incCntW(1); /* und Referenz vermerken */
                } /* -bl0- Kurvendefinition lag vor */
                i += 1; /* Index wurde belegt */
              } /* process all entries within table */
              cUiD.setMsk(1); /* kennzeichnen, dass 'TrackSections' eingetragen wurden */
              ((TSDynTrk)cUiD).chgShR(cShL); /* Shape-Referenz eintragen (hier: Pfad) */
              cShL.incCntW(1); /* und vermerken */
              cUiD.setMsk(2); /* kennzeichnen, dass Pfad-Eintrag vorhanden */
              w = cNde.getDir(0); /* aktueller Elevationwert */
              if(w!=0.0) w = -w; /* Wert korrigieren */
              cUiD.chgElv(w); /* Elevation speichern */
              cUiD.setMsk(3); /* kennzeichnen, dass Elevationwert gesetzt wurde */
              cUiD.chgCoF(535);  /* Eintrag 'CollideFlags' setzen */
              cUiD.setMsk(17); /* kennzeichnen, dass 'CollideFlags' gesetzt wurden */
              cUiD.setStF(0x00100000); /* neuen Wert fuer 'StaticFlags' eintragen */
              cUiD.setMsk(20); /* kennzeichnen, dass 'StaticFlags' gesetzt wurden */
              cPos = cNde.crPos(); /* aktuellen Positionswert holen */
              cUiD.setPos(cPos); /* neuen (Dummy-)Positionswert setzen */
              cUiD.setMsk(21); /* kennzeichnen, dass Positionswert eingetragen wurde */
              cUiD.setMsk(22); /* kennzeichnen, dass 'QDirection' eingetragen wurde */
                /* Hiermit wird eine 'Default-QDirection' (Nord) benutzt */
              cUiD.clrView(14); /* Kennung ViewSphere speichern */
              cUiD.setMsk(25); /* kennzeichnen, dass 'ViewSphere' vorhanden ist */
              cUiD.setMsk(26); /* kennzeichnen, dass 'StaticDetailLevel' gueltig ist */
              cQDf.chgWTab(null,0).add(cUiD); /* UiD-Eintrag sortiert hinzufuegen und speichern */
              cUiD.chgQDf(cQDf); /* neue Rueckverkettung zu Quadranden eintragen */
              xUiD = cUiD; /* aktuelle UID merken: QDir-Wert NICHT nutzbar */

              if(EnaW) Lg.Log("shftDy52",cQDf.getInf(0),cUiD.getUiD(0),in); /* Aktionsmeldung */
              if(cShL.addScR(null)==cn) /* Vektornode besteht NUR aus einem Dyntrack-Element */
                /* (number of vector-sections EQUALS number of Dyntrack-sections) */
                if(EnaW) Lg.Log("shftDy53",null,cTrN.getNr(false),cUiD.getUiD(2));
              continue; /* naechstes Node-Element bearbeiten */
            } /* Pruefung auf Dummy-Element erfolgt */
            if(cUiD==xUiD) continue; /* noch in Fehlerbehandlung -- weiter */

            cQDir = cUiD.crQDir(); /* aktuellen Richtungswert holen */
            cElv = cNde.getDir(0); /* Elevation sichern */
            if(cNde.isT()) cQDir.inv(); /* Richtung invertieren */
              /* Richtung bezieht sich JETZT schon auf das Ende (IN Orientierungsr.) */
            xUiD = cUiD; /* merken aus welcher UID die Richtung erstellt */
            /* Element wird mit Fall 'cUiD==xUiD' weiter bearbeitet */
          } /* gueltiger QDir-Wert erstellt */

          cPos = cNde.crPos(); /* aktuellen Positionswert holen */
          /* hier: Eine Node-Element mit UiD ist bereits bearbeitet */
          if(cUiD!=null) { /* World-Element existiert (noch) */
            if(cUiD==xUiD) { /* gleiche UID wie beim voherigen Element */
              m = cNde.getSc(true); /* aktuelle Section-Nummer holen */
              if(cUiD.isOpt(15)) { /* neues, unvollstaendiges World-Element */
                cScL = null; /* fuer Compiler */
                for(i=0;i<5;i+=1) { /* alle angehaengten Sections pruefen */
                  if(!cUiD.isOpt(i+16)) continue; /* Bearbeitung nicht gefordert */
                  cScL = ((TSDynTrk)cUiD).chgScR(i,false,null); /* Tracksection holen */
                  if(cScL==null) continue; /* nicht belegt -- weiter */
                  if(cScL.getNr(true)==m) break; /* zutreffende Section gefunden */
                  if(cScL.isCurve()) { /* Kurvendefinition liegt vor -- weiter */
                    cScL = ((TSDynTrk)cUiD).chgScR(i,true,null); /* 2. Tracksection holen */
                    if(cScL==null) continue; /* Fehler -- weiter */
                    if(cScL.getNr(true)==m) break; /* zutreffende Section gefunden */
                  } /* Kurvendefinition lag vor */
                } /* alle angehaengten Sections pruefen */
                if(i>4) continue; /* Section nicht gefunden -- nicht weiter bearbeiten */
                cUiD.clrOpt(i+16); /* kennzeichnen: Section 'i' gefunden */
                /* cQDir hat noch die Werte, die es beim Erzeugen des World-
                 * objektes bekommen haben. (oder vom letzten Schritt hier)
                 * cPos enthaelt die aktuelle Node-Position
                 */
                cQDir.turn(cScL.getAng()); /* neue QDirection berechnen */
                if(cNde.isT()) { /* aktuelles World-Objekt ist gedreht */
                  cQDir.inv(); /* und Richtung invertieren (antiparallel) */
                  cUiD.setQDir(new TSQDir(cQDir)); /* neue QDirection setzen */
                  cPos.toEnd(cQDir,-cScL.getLR(),cScL.getAng()); /* Wert fuer UiD berechnen */
                  cUiD.setPos(cPos); /* neuen Positionswert (vom Ende) setzen */
                  cQDir.inv(); /* und Richtung wieder 'IN Orientierungsrichtung' setzen */
                } /* Werte angepasst */
                if(cUiD.getOpt(0x1F0000)==0) cUiD.clrOpt(15); /* Dir-Wert ist korrekt */
                continue; /* Element ist bearbeitet */
              } /* unvollstaendiges World-Objekt bearbeitet */

              if(cNde.isT()) continue; /* Richtung schon OK naechstes Element */
              if((cSc=cRte.chgScT(m,null))==null) /* no valid section-definition (local) found */
               if((cSc=ScTab[m])==null) { /* get global secxtion-entry */
                /* Section not found -- error, do it again from beginning */
                cQDir = null; /* clear current direction and */
                continue; /* process next Node-element */
              } /* Fehler aufgetreten -- UID-nicht nutzbar */
              cQDir.turn(cSc.getAng()); /* neue QDirection berechnen */
              continue; /* Element ist bearbeitet */
            } /* aktuelle QDirection forgeschrieben */

            /* hier: NEUE aber GUELTIGE UiD gefunden -- NEUE cQDir-Sequenz */
            cQDir = cUiD.crQDir(); /* aktuellen Richtungswert holen */
            cElv = cNde.getDir(0); /* Elevation sichern */
            if(cNde.isT()) cQDir.inv(); /* Richtung invertieren */
              /* Richtung bezieht sich JETZT schon auf das Ende */
            xUiD = cUiD; /* merken aus welcher UID die Richtung erstellt */
            continue; /* Element ist bearbeitet */
          } /* World-Objekt existierte (noch) */

          /* hier: World-Objekt existiert nicht -- Dyntrack gefordert? */
          j = cNde.getSh(true); /* aktuelle Shape-Nummer holen */
          if((cShL=cRte.chgShT(j,null))==null) { /* local path defined? */
            cQDir = null; /* clear current direction */
            xUiD = null; /* set: kein aktuelles gueltiges UiD-Element */
            continue; /* process next node-entry */
          } /* Missing element was 'TrackObj' */

          j = cNde.getSc(true); /* aktuelle Section-Nummer holen */
          if(j<0) { /* keine gueltige Section -- Objekt nicht erstellbar */
            cQDir = null; /* Richtung loeschen */
            xUiD = null; /* kein aktuelles gueltiges UiD-Element */
            continue; /* naechstes Node-Element bearbeiten */
          } /* Objekt wegen fehlender gueltiger Section nicht erstellbar */

          cUiD = new TSDynTrk(cQDf.getOId(),0); /* World-Objekt erzeugen */
          cUiD.setUiD(m); /* und Kennnummer (UiD) direkt eintragen */
          cUiD.setOpt(15); /* merken: World-Objekt ist noch nicht vollstaendig */
          i = 0; /* Position fuer World-Objekt */
          sI = cShL.getScR(); /* get iterator for all section-definitions */
          while(sI.hasNext()) { /* another section-definition available ? */
            cScL = sI.next(); /* get current section-entry */
            if(cScL.isCurve()) if(i%2==0) i += 1; /* Index fuer Kurve anpassen */
            if(i>4) break; /* Fehlerabbruch -- ungueltiger Index */
            ((TSDynTrk)cUiD).chgScR(i,false,cScL); /* Tracksection setzen */
            cScL.incCntW(1); /* und Referenz vermerken */
            cUiD.setOpt(i+16); /* merken: Section 'i' gefordert */
            if(cScL.getNr(true)==j) cUiD.clrOpt(i+16); /* Section 'i' gefunden */
            if(cScL.isCurve()) bl1:{ /* Kurvendefinition liegt vor -- weiter */
              cScL = cRte.chgScT(cScL.getNr(true)+1,null); /* naechsten Eintrag holen */
              if(cScL==null) break bl1; /* nicht belegt -- weiter */
              ((TSDynTrk)cUiD).chgScR(i,true,cScL); /* 2. Tracksection setzen */
              cScL.incCntW(1); /* und Referenz vermerken */
              if(cScL.getNr(true)==j) cUiD.clrOpt(i+16); /* Section 'i' gefunden */
            } /* -bl1- Kurvendefinition lag vor */
            i += 1; /* Index wurde belegt */
          } /* process all entries within table */
          cUiD.setMsk(1); /* kennzeichnen, dass 'TrackSections' eingetragen wurden */
          ((TSDynTrk)cUiD).chgShR(cShL); /* Shape-Referenz eintragen (hier: Pfad) */
          cShL.incCntW(1); /* und vermerken */
          cUiD.setMsk(2); /* kennzeichnen, dass Pfad-Eintrag vorhanden */
          w = cNde.getDir(0); /* aktueller Elevationwert */
          cQDir.raise(w-cElv); /* aktuelle QDirection anpassen (Elevation) */
          cElv = w; /* neue Elevation merken (fuer naechste UiD) */
          if(w!=0.0) w = -w; /* Wert korrigieren */
          cUiD.chgElv(w); /* Elevation speichern */
          cUiD.setMsk(3); /* kennzeichnen, dass Elevationwert gesetzt wurde */
          cUiD.chgCoF(535); /* Eintrag 'CollideFlags' setzen */
          cUiD.setMsk(17); /* kennzeichnen, dass 'CollideFlags' gesetzt wurden */
          cUiD.setStF(0x00100000); /* neuen Wert fuer 'StaticFlags' eintragen */
          cUiD.setMsk(20); /* kennzeichnen, dass 'StaticFlags' gesetzt wurden */

          cUiD.setPos(cPos); /* neuen Positionswert setzen (Referenz eintragen) */
          cUiD.setQDir(new TSQDir(cQDir)); /* neue QDirection (praeventiv) setzen */
          /* 'j' enthaelt noch aktuelle Section-Nummer */
          if(cNde.isT()) bl2:{ /* aktuelles World-Objekt ist gedreht */
            if(cRte.isScL(j)) break bl2; /* globale Referenz -- Fehler */
            if((cScL=cRte.chgScT(j,null))==null) break bl2; /* Section nicht definiert */
            cQDir.turn(cScL.getAng()); /* neue QDirection berechnen */
            cQDir.inv(); /* und Richtung invertieren */
            cUiD.setQDir(new TSQDir(cQDir)); /* neue QDirection setzen */
            cPos.toEnd(cQDir,-cScL.getLR(),cScL.getAng()); /* Wert fuer UiD berechnen */
              /* neuer Positionswert (vom Ende) wurde in 'UiD' automatisch veraendert */
            cQDir.inv(); /* und Richtung wieder 'IN Orientierungsrichtung' setzen */
          } /* -bl2- Werte angepasst */

          cUiD.setMsk(21); /* kennzeichnen, dass Positionswert eingetragen wurde */
          if(cUiD.getOpt(0x1F0000)==0) cUiD.clrOpt(15); /* Dir-Wert ist korrekt */
          cUiD.setMsk(22); /* kennzeichnen, dass 'QDirection' eingetragen wurde */
          cUiD.clrView(14); /* Kennung ViewSphere speichern */
          cUiD.setMsk(25); /* kennzeichnen, dass 'ViewSphere' vorhanden ist */
          cUiD.setMsk(26); /* kennzeichnen, dass 'StaticDetailLevel' gueltig ist */
          cQDf.chgWTab(null,0).add(cUiD); /* UiD-Eintrag sortiert hinzufuegen und speichern */
          cUiD.chgQDf(cQDf); /* neue Rueckverkettung zu Quadranden eintragen */
          xUiD = cUiD; /* aktuelle UID merken fuer Ende */
          if(EnaW) Lg.Log("shftDy51",cQDf.getInf(0),cUiD.getUiD(0),0); /* Aktionsmeldung */
        } /* alle Track-Sections bearbeiten */
      } /* alle Track-Nodes pruefen */
    } /* -bl- snthetische World-Datei-Definitionen erstellt */

    /* "world"-Dateien bearbeiten und neue Integritaet herstellen */
    i = 4; /* DO NOT modify I/O-mode (IO_app=4 is marker) */
    if(Fo.chkMsk(3)) i = TSFile.OCB; /* Ausgabe-Modus: Binaer, komprimiert */
    if(Fo.chkMsk(4)) i = TSFile.OUT; /* Ausgabe-Modus: Text, expanded */
    i += 128; /* 'Aenderungen melden' aktivieren */
    chkWrld(cRte,null,i); /* World-Dateien erweitert pruefen */
      /* Modus: Aenderungen melden, kein Renum */

    /* Sound-Dateien bearbeiten und neue Integritaet herstellen */
    i = chkSnd(cRte,null,128); /* Sound-Dateien erweitert pruefen */
      /* Modus: Aenderungen melden */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("MsgC33",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC35"); /* Aktionsmeldung ausgeben */
    if(cRte.get$TrN(0)<=0) { /* Schienendatenbank NICHT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC36"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datenbank nicht vorhanden */

    i = chkDBTab(cRte,128); /* Schienendatenbank bearbeiten */
      /* Option (128) aktiv: falsche Referenzen loeschen */
    if(i<0) return 5; /* Systemfehler -- Ende */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC37",i); /* Aktionsmeldung ausgeben */
    Lg.Skip(false); /* Leerzeile loggen */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC39"); /* Aktionsmeldung ausgeben */
      i = chkDBTab(cRte,129); /* Strassendatenbank bearbeiten */
        /* Option (128) aktiv: falsche Referenzen loeschen */
      if(i<0) return 5; /* Systemfehler -- Ende */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("MsgC40",i); /* Aktionsmeldung ausgeben */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Strassendatenbank vorhanden und geladen */

    ScA = scd; /* neue untere Grenze (section) fuer lokale tsection.dat (old) */
    ShA = shd; /* neue untere Grenze (shape) fuer lokale tsection.dat (old) */
    /* extended check of local 'tsection.dat'
     * Attention: This method MUST NOT be invoked unless worldfiles AND
     * database (track/road) is stored again (or neither). */
    chkTSL(cRte,ScN,ShN); /* check file and compact it */

    i = chkPat(cRte); /* Pfad-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkSrv(cRte,true); /* Service-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkTrf(cRte,true,false); /* Traffic-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkAct(cRte,true); /* process activity-definitions */
    if(i>0) return 5; /* systemerror occurred -- terminate */

    /* ***** ab hier beginnen die Ausgaben ***** */
    /* Zwischenfile-Erstellen falls ueberschreiben aktiv. */
    dat = null; /* Annehmen: Dateien NICHT ueberschreiben */
    if(OV) { /* ueberschreiben der Dateien aktiv */
      try { dat = File.createTempFile("TSUtil",".tmp");
      } catch (IOException e) { /* Creation-Fehler Temp-Datei */
       System.err.println(e.toString());  return 5;}
      dat.deleteOnExit(); /* Datei am Ende wieder loeschen */
      if(!Fo.chkMsk(20)) askTerm(); /* ask user to REALLY overwrite */
      Lg.Log("MsgC41"); /* Warnung/Hinweis loggen */
      Lg.Skip(true); /* Leerzeile loggen */
    } /* ueberschreiben der Dateien aktiv */

    /* "world"-Dateien bearbeiten und modifizieren */
    i = putWF(cRte,dat,true,false); /* World-Dateien modifiziert schreiben */
      /* Modus: neue UiD's verwenden */
    if(i>0) return i; /* Fehler beim Schreiben -- Ende */
    /* Sound-Dateien bearbeiten und modifizieren */
    i = putSF(cRte,dat,true); /* Sound-Dateien modifiziert schreiben */
    if(i>0) return i; /* Fehler beim Schreiben -- Ende */

    /* Schienendatenbank bearbeiten */
    i = putDBF(cRte,dat,16); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    /* Schienendatenbank (.tit) bearbeiten */
    i = putITF(cRte,dat,0,false); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      /* Strassendatenbank bearbeiten */
      i = putDBF(cRte,dat,17); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */

      /* Strassendatenbank (.rit) bearbeiten */
      i = putITF(cRte,dat,1,false); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */
    } /* Strassendatenbank vorhanden und geladen */

    /* "tsection.dat" (lokal) neu erstellen */
    i = putTSL(cRte,cRte,OV); /* neue lokale 'tsection.dat' schreiben */
    if(i>0) return i; /* Fehler -- beenden */

    if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("shftDy11"); /* Ergebnis melden */
    Lg.Msg("shftDy12"); /* Ergebnis melden */
    Lg.Msg("shftDy13",ShA); /* Ergebnis melden */
    Lg.Msg("shftDy14",ScA); /* Ergebnis melden */
    Lg.Msg("shftDy15",cRte.get$Sh(true)); /* Ergebnis melden */
    Lg.Msg("shftDy16",cRte.get$Sc(true)); /* Ergebnis melden */
    Lg.Msg("shftDy17"); /* Ergebnis melden */
    Lg.Msg("shftDy18",ShN); /* Ergebnis melden */
    Lg.Msg("shftDy19",ScN); /* Ergebnis melden */
    Lg.Msg("shftDy20",cRte.get$Sh(false)); /* Ergebnis melden */
    Lg.Msg("shftDy21",cRte.get$Sc(false)); /* Ergebnis melden */

    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
 }

 /**. <pre>
  *=====================================================================
  * Methode "shVer" (-23-)   (##version)
  * Versionsdefinitionen analysieren
  * Optionen:
  *       1 -
  * ##shVer (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int shVer( /* Versionsdefinition analysieren */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("shVer01"); /* Vorlauf ausgeben */

    i = 0; /* Anzahl initialisieren */
    /* Daten ausgeben */
    i += 1; Lg.Msg(TSLogg.getMsg("shVer02","TSUtil"," %'Version' %0",i),SpVers);
    i += 1; Lg.Msg("shVer02","TSLogg",TSLogg.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSOpts",TSOpts.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSData",TSData.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSRefC",TSRefC.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSPos",TSPos.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSQPos",TSQPos.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSQDir",TSQDir.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSCoo",TSCoo.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSc",TSSc.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSh",TSSh.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSect",TSSect.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSScC",TSScC.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSScIdx",TSScIdx.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSShape",TSShape.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSChain",TSChain.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSWrld",TSWrld.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSRoute",TSRoute.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSScL",TSScL.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSShL",TSShL.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTrNde",TSTrNde.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSVector",TSVector.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTrItm",TSTrItm.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTrItm01",TSTrItm01.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTrItm01T",TSTrItm01T.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTrItm02",TSTrItm02.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTrItm03",TSTrItm03.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTrItm04",TSTrItm04.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTrItm08",TSTrItm08.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTrItm09",TSTrItm09.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTrItm10",TSTrItm10.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTile",TSTile.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTileC",TSTileC.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSQuad",TSQuad.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSUiD",TSUiD.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTrkObj",TSTrkObj.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSDynTrk",TSDynTrk.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSignal",TSSignal.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSStatic",TSStatic.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSForest",TSForest.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSPlatform",TSPlatform.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSiding",TSSiding.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSGantry",TSGantry.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSpeed",TSSpeed.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSCarSp",TSCarSp.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSLevelCr",TSLevelCr.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSHazard",TSHazard.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTransf",TSTransf.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSColli",TSColli.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTelep",TSTelep.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSPickup",TSPickup.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSnd",TSSnd.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSRgn",TSSRgn.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSSrc",TSSSrc.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSView",TSView.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSigSh",TSSigSh.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSigSObj",TSSigSObj.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSigTyp",TSSigTyp.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSigSgL",TSSigSgL.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSigDrSt",TSSigDrSt.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSigAsp",TSSigAsp.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSigLTx",TSSigLTx.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSigLgt",TSSigLgt.IdStr,i);
    i += 1; Lg.Msg("shVer02","TStType",TStType.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSAct",TSAct.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSActAO",TSActAO.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSActEv",TSActEv.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSActSZ",TSActSZ.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSPath",TSPath.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSPatPDP",TSPatPDP.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSPatNde",TSPatNde.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSrv",TSSrv.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSStop",TSStop.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTrf",TSTrf.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSXtSrv",TSXtSrv.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSStStp",TSStStp.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTrain",TSTrain.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSigCDef",TSSigCDef.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSSigCDefE",TSSigCDefE.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSObjLst",TSObjLst.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSObjDef",TSObjDef.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSFile",TSFile.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSFileS",TSFileS.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSFileT",TSFileT.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSFileW",TSFileW.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSFileX",TSFileX.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSFile$trk",TSFile$trk.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSFile$td",TSFile$td.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSFleTok",TSFleTok.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSFleStack",TSFleStack.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTexture",TSTexture.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSFleMask",TSFleMask.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSByteArrIO",TSByteArrIO.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSDeCompInputStream",TSDeCompInputStream.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSNameSet",TSNameSet.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSCopySet",TSCopySet.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSBuf",TSBuf.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSTemp",TSTemp.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSUtilDlg",TSUtilDlg.IdStr,i);
    i += 1; Lg.Msg("shVer02","TSFrame",TSFrame.IdStr,i);

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("shVer09",i); /* Ergebnis melden */

    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
 }

 /**. <pre>
  *=====================================================================
  * Methode "FleMgr" (-24-)
  * Datendateien flexibel bearbeiten (compress,expand,reduce,uncomp)
  * Die Kombination der Optionen ist bereits geprueft.
  * Optionen:
  *       1 - geforderte Aktion ist 'Expand'   (e)
  *       2 - geforderte Aktion ist 'Reduce'   (r)
  *       3 - geforderte Aktion ist 'Compress' (c)
  *       5 - Zielverzeichnis ggf. erstellen (o)
  *       6 - Datei-Maske im Windows-Style spezifiziert (n)
  *      13 - Dateityp ist 'Shape' (s)
  *      14 - Dateityp ist 'World' (w)
  *      15 - Dateityp ist 'Tile'  (t)
  *      16 - Extended output to LOG (-d,Hidden)
  * ##FleMgr (Eyecatcher)    (##fmgr)
  *=====================================================================
  </pre>*/
  protected static int FleMgr( /* File-Manager ausfuehren */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSFile          cR;    /* current input-file */
    TSFile          cW;    /* current output-file */
    TSFleMask       cM;    /* current mask to select files */
    File            dirS,dirZ,datS,datZ,datT;
    String[]        fl;    /* file-list */
    String          is;    /* intermediate values */
    int             i,dT;  /* intermediate values */
    int             cf,ce; /* counter */
    boolean         mrkE;  /* error found if true */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("FleMgr11"); /* print prefix of current action(s) */

    /* select appropriate folder for input/output */
    dirS = new File(vn2); /* get input-folder */
    vn2 = dirS.getAbsolutePath(); /* and  set absolute version of name */
    dirS = new File(vn2); /* input-folder is now 'absolute' */
    dirZ = new File(vn3); /* get output-folder */
    vn3 = dirZ.getAbsolutePath(); /* and  set absolute version of name */
    dirZ = new File(vn3);/* output-folder is now 'absolute' */

    if(Fo.chkMsk(13)) { /* 'shapes' are selected */
      if(fn==null) fn = TSLogg.getKey("FleMgrMS"); /* get default-selection */
      is = "Shape"; /* set mode for documentation */
    } else if(Fo.chkMsk(14)) { /* 'worlds' are selected */
      if(fn==null) fn = TSLogg.getKey("FleMgrMW"); /* get default-selection */
      is = "World"; /* set mode for documentation */
    } else if(Fo.chkMsk(15)) { /* 'tiles' are selected */
      if(fn==null) fn = TSLogg.getKey("FleMgrMT"); /* get default-selection */
      is = "Tile";  /* set mode for documentation */
    } else return 20; /* systemerror -- cannot occur */

    /* print current path and selection */
    Lg.Msg("FleMgr12",vn2); /* print input-path */
    Lg.Msg("FleMgr13",vn3); /* print output-path */
    Lg.Msg("FleMgr14",fn);  /* print file-selector */
    Lg.Msg("FleMgr15",is);  /* print object-type */
    Lg.Skip(true); /* print empty line (screen and LOG-file) */

    if(Fo.chkMsk(6)) { /* file-mask uses windows-format -- convert it */
      is = TSFleMask.convert(fn,false); /* try conversion */
      if(is==null) { /* error found within mask */
        is = TSFleMask.convert(fn,true); /* retry conversion and get error */
        Lg.Msg("FleMgr29",is); /* print error-message: terminating */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* current file-mask (windows) contains error(s) */
      fn = is; /* activate valid file-mask */
    } /* file-mask is converted to a regular expression */

    cM = new TSFleMask(false,fn); /* compile current file-mask for input */
    if((is=cM.getErr())!=null) { /* error found within compilation */
      Lg.Skip(true); /* print empty line (screen and LOG-file) */
      Lg.Msg("FleMgr29",is); /* print error-message: terminating */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* selection-expression contains an error */

    /* check all used directories */
    if(!dirS.exists()) { /* Source-directory does not exist */
      Lg.Msg("FleMgr21",vn2); /* print error-message */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* directory does not exists */
    if(!dirS.isDirectory()) { /* Source is NOT a directory */
      Lg.Msg("FleMgr22",vn2); /* print error-message */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Source-object is not a directory */
    if(!dirZ.exists()) { /* Target-directory does not exist */
      if(Fo.chkMsk(5)) dirZ.mkdirs(); /* try to create folder */
      if(!dirZ.exists()) { /* Target-directory still does not exist */
        Lg.Msg("FleMgr23",vn3); /* print error-message */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* directory could not be created */
    } /* directory does not exists */
    if(!dirZ.isDirectory()) { /* Target is NOT a directory */
      Lg.Msg("FleMgr24",vn3); /* print error-message */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Target-object is not a directory */

    /* create output-mode of target-files */
    dT = -1; /* preset: output-mode of target is not specified */
    if(Fo.chkMsk(1)) dT = TSFile.OUT; /* Expand */
    if(Fo.chkMsk(2)) dT = TSFile.OUB; /* Reduce */
    if(Fo.chkMsk(3)) dT = TSFile.OCB; /* Compress */

    /* overwrite-mode is supported -- create temporary-file */
    try { datT = File.createTempFile("TSUtil",".tmp");
    } catch (IOException e) { /* creation of temp-file failed */
      System.err.println(e.toString());
      Lg.Msg("FleMgr25"); /* print error-message */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Temp-Datei konnte nicht angelegt werden */
    datT.deleteOnExit(); /* Datei am Ende wieder loeschen */

    fl = dirS.list((FilenameFilter)cM); /* create list of selected files */
      /* result contains NO directories! */
    if(fl==null) { /* error found: source is no directory */
      Lg.Msg("FleMgr26",vn2); /* print error-message */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* file-list could not be created */

    /* process all requested files */
    cR = null; /* Compiler needs it */
    cW = null; /* Compiler needs it */
    cf = ce = 0; /* init file-counter, conversion errors */
    for(String sf:fl) { /* process all selected file-definitions */
      datS = new File(dirS,sf); /* create full reference to input-file */
      cf += 1; /* and count selected file */
      Lg.Log("FleMgr27",sf,DF4.format(cf),0); /* print state-message */
      datZ = new File(dirZ,sf); /* create full reference to target-file */
      if(datZ.isDirectory()) { /* error: target-object is a folder */
        Lg.Log("FleMgr31",datZ.getPath()); /* print error-message */
        continue; /* error -- do not process input-file -- next one */
      } /* target must not be a foledr*/
      fn = datS.getName(); /* full name used within messages */

      if(Fo.chkMsk(13)) { /* 'shape'-files are processed */
        cR = new TSFileS(datS); /* create input-control */
        cW = new TSFileS(datT); /* create output-control */
      } /* file-type is 'Shape' */
      if(Fo.chkMsk(14)) { /* 'world'-files are processed */
        cR = new TSFileW(datS); /* create input-control */
        cW = new TSFileW(datT); /* create output-control */
      } /* file-type is 'World' */
      if(Fo.chkMsk(15)) { /* 'tile'-files are processed */
        cR = new TSFileT(datS); /* create input-control */
        cW = new TSFileT(datT); /* create output-control */
      } /* file-type is 'Tile' */

      is = cR.open(TSFile.IN); /* open input and check input-type */
      if(is!=null) { /* open-error found */
        Lg.Log("FleMgr33",is); /* print error-message */
        ce += 1; /* count conversion-error */
        continue; /* continue with next file */
      } /* Dateifehler */
      mrkE = false; /* set marker: NO error found */
      bbR: { /* break-Block fuer das Lesen (break-block-read) */
        i = cR.getMode(TSFile.OUT); /* get/mod current IO-mode for output */
        if(dT<0) i = dT; /* requested format NOT specified -- do not change */
        if(i==dT) break bbR; /* file-format does not change -- copy file */

        is = cW.open(dT); /* open file for output and write file-ID */
        if(is!=null) { /* Fehler beim oeffnen aufgetreten */
          Lg.Log("FleMgr34",is); /* print error-message */
          ce += 1; /* count conversion-error */
          mrkE = true; /* set marker: error was registered */
          break bbR; /* Bearbeitung der Datei beenden */
        } /* Dateifehler */

        /* Alle Datenzeilen kopieren */
        while((is=cR.getData())!=null) { /* alle Datensaetze kopieren */
          is = cW.putData(is); /* Datensatz in ensprechender Form ausgeben */
          if(is!=null) { /* Fehler beim Schreiben aufgetreten */
            Lg.Log("FleMgr35",is); /* print error-message */
            ce += 1; /* count conversion-error */
            mrkE = true; /* set marker: error was registered */
            break; /* Kopieren der Daten abbrechen */
          } /* Fehler beim Schreiben */
        } /* alle Datensaetze kopieren */
        if((is=cR.getErr())!=null) { /* Abbruch der Schleife wegen Fehler */
          Lg.Log("FleMgr36",is); /* print error-message */
          ce += 1; /* count conversion-error */
          mrkE = true; /* set marker: error was registered */
        } /* Dateifehler */

        is = cW.close(); /* close output-file again */
        if(is!=null) { /* error found during close */
          Lg.Log("FleMgr38",is); /* print error-message */
          ce += 1; /* count conversion-error */
          mrkE = true; /* set marker: error was registered */
        } /* Dateifehler */
        i = 4; /* marker: DO NOT copy file (file-formats differ) */
      } /* -bbR- break-Block fuer das Lesen */
      is = cR.close(); /* close input-file again */
      if(is!=null) { /* error occurred during close */
        Lg.Log("FleMgr39",is); /* print error-message */
        ce += 1; /* count conversion-error */
        continue; /* error found -- process next file */
      } /* Dateifehler */
      if(mrkE) continue; /* error found -- process next file */

      if(i==dT) { /* no change within file-format -- copy file */
        Lg.Log("FleMgr28",fn); /* print message about copy-action */
        /* Kopieren der Quell-Datei auf die temp.-Datei */
        is = "copy \""+datS.getAbsolutePath()+"\" \""+
             datT.getAbsolutePath()+"\" "; /* copy - Befehl erstellen */
        if((i=exec(true,is,null,Lg))>0) /* 'copy' terminates with error */
          Lg.Log("MsgC49",datT.getAbsolutePath(),i); /* print error-message */
      } /* Datei wurde kopiert */

      /* Kopieren der Ergebnisdatei in das Ziel-Verzeichnis */
      is = "copy \""+datT.getAbsolutePath()+"\" \""+
           datZ.getAbsolutePath()+"\" "; /* copy - Befehl erstellen */
      if((i=exec(true,is,null,Lg))>0) /* 'copy' terminates with error */
        Lg.Log("MsgC49",datZ.getAbsolutePath(),i); /* print error-message */
    } /* -for- process ALL selected files */

    Lg.Skip(true); /* print empty line (screen and LOG-file) */
    Lg.Msg("FleMgr81",cf); /* print result: number of processed files */
    Lg.Msg("FleMgr82",ce); /* print result: number of errors */

    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* print timestamp */

    Lg.Skip(true); /* print empty line (screen and LOG-file) */
    Lg.Msg("FleMgr83",fl.length); /* print statistic-message */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
 }

 /**. <pre>
  *=====================================================================
  * Method "chgSig" (-25-)
  * Replace signal-definitions or signal-objects
  * Options:
  *       1 - Install shape-files(signal/static) (-c)
  *       2 - Remove old shape-files(signal/static) (-r)
  *      16 - Extended output to LOG (-d,Hidden)
  *      17 - Overwrite original files while writing (-inplace,Hidden)
  * Attention: refer to definition of class 'TSSigCDef' for the decription
  *            of the available actions.
  * ##chgSig (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chgSig( /* modify signal-definitions/objects */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute              cRte; /* aktuelle Streckendefinition (Basis) */
    TSRoute              xRte; /* virtuelle Streckendefinition */
    TSFile               cF;   /* current buffered inputfile */
    HashMap<String,String>    ErrLst; /* Liste der Fehlermeldungen */
    HashMap<String,TSSigCDef> SgLst;  /* Liste der Signal-Aenderungen */
    ArrayList<TSSigCDefE>     SgM;    /* list of modification-commands */
    TSSigCDef            cSgD;  /* aktuelle Signal-Aenderung */
    TSSigCDefE           cSgDfE; /* aktueller Signal-Aenderungseintrag */
    TreeSet<TSQuad>      QDf;   /* Quadrat-Definitionen */
    TSQuad               cQDf;  /* aktive Quadrat-Definition */
    ArrayList<TSTrItm>   ItT;   /* Tabelle der TrItem-Eintraege */
    TSTrItm01            cIt;   /* current / new TrItem-entry (Signal) */
    ArrayList<TSRefC>    RfT;   /* table of TrItem-references within db-node */
    TSRefC               cRef;  /* current TrItem-reference-control */
    ArrayList<TSRefC>    SUT;   /* table of new signal-units (sorted) */
                                /* Attention: Finally, the list must contain
                                 *  the elements in increasing order */
    TSUiD                cUiD;  /* current world-entry(common=UiD) */
    TSSignal             cSig;  /* current world-entry (Signal) */
    TSTrNde              cTrN;  /* current database-entry (track-db) */
    TSSigSh              cSgS;  /* NEW Shape-Definition of signal */
    ArrayList<TSSigSObj> SgSO;  /* list of Shape-Subobjects */
    TSSigSObj            cSgSO; /* current Shape-Subobject */
    TSSigTyp             cSgT;  /* current Signal-Type-Definition */
    TSSigFle             cSgF;  /* current Script-File-Definition */
    TSCopySet            cCpyT; /* Installation of new shapefiles */
    TSNameSet            cNmeT; /* Shapefiles to be removed */
    LinkedHashMap<String,TSObjLst> RefT; /* Route-reference-list */
    TSObjLst             cLst;  /* current list of route-reference-objects */
//    TreeMap<String,TSObjDef>       ObjT; /* Route-reference-object-list */
    Iterator<TSObjDef>   ObjI;  /* all Route-reference-object entries */
    TSObjDef             cObj;  /* current route-reference-object */
    TSPos                cPos;  /* current/intermediate position-value */
    TSBuf                cB;    /* current input-buffer */
    char                 cBef;  /* current change-command */
    int                  zNr,sNr,vMsk; /* current change-values */
    String               Nme;   /* common name */
    String               xs;    /* Object-Definition (for printing) */
    boolean              ok,OV; /* Result is OK; overwrite? */
    Iterator             cI;    /* common Iterator of 'TreeSet' */
    int                  i,ms,mz,in,n,ng,cnt,suC,opt_f,opt_b;
    int                  cIx;   /* current index within 'TrItemRef'-list */
    File                 dat;   /* (intermediate) file-definition */
    String               cFn;   /* File-Namen */
    String               is;    /* intermediate value */
    double               ox,oy,oz; /* offset-values for object */
    Iterator<String>     LneI;  /* Line-Iterator for output */
    ArrayList<String>    LneT;  /* Line-Table for output */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("chgSg001",fn); /* Vorlauf ausgeben */

    /* get systemfile (*.trk) and process it */
    OV = Fo.chkMsk(17); /* 'newRoute'-Directory required ? */
    cRte = getRte(fn,OV?1:3); /* process route-definition */
    if(cRte==null) return 5; /* error -- terminate function */

    /* print current paths */
    Lg.Msg("MsgC01",cRte.getInfo(2)); /* print route-name */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* print system-path */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* print route-path */
    Lg.Skip(true); /* and add empty line */

    dat = new File(vn2); /* Pfad des Steuerverzeichnisses holen */
    if(!dat.isAbsolute()) dat = cRte.getFile(1,vn2); /* zweiter versuch */
      /* Name des Steuerverzeichnisses holen (relative Angabe) */
    if(!dat.exists()) { /* Korrektur-Verzeichnis fehlt */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("chgSgF01",dat.getAbsolutePath()); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datei nicht vorhanden */
    if(!dat.isDirectory()) { /* KEIN Verzeichnis */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("chgSgF02",dat.getAbsolutePath()); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datei nicht vorhanden */
    xRte = new TSRoute("",null,dat,null,null); /* virtuelle Route setzen */
    /* Achtung: 'xRte' ist NICHT vollstaendig definiert. Diese virtuelle
     * Route soll die NEUEN Signaldefinitionen verfuegbar machen. (siehe unten)
     * Es werden verschiedene Referenzen ZWISCHEN den Routen erstellt.
     */

    /* Steuerdatei laden, pruefen und umwandeln */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("chgSg002"); /* Aktion melden */

    /* ALTE Signal-Definitionen laden und ueberpruefen */
    i = getSCfg(cRte,cRte.getFile(21),null,true); /* load Signal-Configurations */
    if(i==0) /* Laden erfolgreich -- weiter testen */
      i = getSScr(cRte,cRte); /* Signal-Script-Definitionen laden */

    /* NEUE Signal-Definitionen laden und ueberpruefen */
    i = getSCfg(xRte,xRte.getFile(21),null,true); /* load Signal-Configurations */
    if(i==0) /* Laden erfolgreich -- weiter testen */
      i = getSScr(xRte,xRte); /* Signal-Script-Definitionen laden */

    dat = xRte.getFile(1,vn3); /* Name der Steuerdatei erstellen */
    if(!dat.exists()) { /* Korrektur-Datei fehlt */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("chgSgF03",dat.getAbsolutePath()); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datei nicht vorhanden */

    /* Standard-Meldungen vorbesetzen */
    ErrLst = new HashMap<String,String>(); /* Fehlertabelle anlegen */
    for(i=0;i<100;i+=1) { /* alle Meldungen uebertragen */
      is = DF2.format(i); /* Meldungsnummer aufbereiten */
      Nme = TSLogg.getKey("chgSg*"+is); /* Meldung holen (falls definiert) */
      if(Nme==null) continue; /* message not available */
      for(n=0;n<Nme.length();n+=1) if("!+-/&?*#".indexOf(Nme.charAt(n))<0) break;
      cFn = Nme.substring(0,n) + "%&7 "; /* set first part of message */
      if(n<Nme.length()) cFn += Nme.substring(n); /* add last part of message */
      ErrLst.put("1"+is,cFn); /* insert corrected message */
    } /* alle moeglichen Meldungen laden */

    cF = new TSFile(dat); /* locate and define file */
    if((is=cF.open(TSFile.IA))!=null) { /* open file (input,ASCII) -- error ? */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("chgSgF04",is,dat.getAbsolutePath()); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 7; /* terminate function with errorcode */
    } /* Error found while 'open' */

    RefT = new LinkedHashMap<String,TSObjLst>(); /* create list for *.ref-classes */
    SgLst = new HashMap<String,TSSigCDef>(); /* Speicherbereich anlegen */
    cSgD = null; /* preset: no modification specified */
    cSgS = null; /* Compiler needs it */
    SgSO = null; /* Compiler needs it */
    SgM  = null; /* Compiler needs it */
    cLst = null; /* Compiler needs it */
    ms   = 0; /* fuer Compiler */
    opt_b = 0; /* fuer Compiler: max.Subobjekt-Index (source) */
    opt_f = 0; /* fuer Compiler: max.Subobjekt-Index (target) */
    cB = new TSBuf(cF,null); /* initialize inputbuffer (mode='line') */
    bl:while(!cB.getNext(false)) { /* read alle lines until EOF */
      if(cB.charAt(false)=='#') continue; /* comment use new line */
      is = cB.getVal(1); /* get line-id */
      if(is==null)  continue; /* empty line -- use next one */
      if(is.charAt(0)=='!') { /* errormessage -- load it */
        if((i=cB.length())<4) { /* Syntaxfehler -- Definition falsch */
          Lg.Err("chgSg111",is,i); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* continue with next definition-line */
        } /* continue with next definition-line */
        if(is.length()!=3) { /* syntax-error - illegal keylength */
          Lg.Err("chgSg112",is); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* continue with next definition-line */
        } /* continue with next definition-line */
        if(!Character.isDigit(is.charAt(1))) { /* Ziffer ? */
          Lg.Err("chgSg113",is); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* continue with next definition-line */
        } /* continue with next definition-line */
        if(!Character.isDigit(is.charAt(2))) { /* Ziffer ? */
          Lg.Err("chgSg114",is); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* continue with next definition-line */
        } /* continue with next definition-line */
        if(cB.chkSep(true)) { /* separator is missed */
          Lg.Err("chgSg115",is); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* continue with next definition-line */
        } /* continue with next definition-line */
        Nme = cB.getTail(false); /* get current message */
        if(Nme==null) continue; /* message not available */
        for(i=0;i<Nme.length();i+=1) if("!+-/&?*#".indexOf(Nme.charAt(i))<0) break;
        cFn = Nme.substring(0,i) + "%&7 "; /* set first part of message */
        if(i<Nme.length()) cFn += Nme.substring(i); /* add last part of message */
        Nme = ErrLst.put(is.replace('!','0'),cFn);
          /* insert insert corrected message (rest of line) */
        if(Nme==null) continue; /* process successfully -- OK */
        Lg.Err("chgSg116",is,Nme); /* print errormessage */
        Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
        continue; /* Bearbeitung OK -- mit naechster Zeile fortfahren */
      } /* message-definition successfully processed */

      if(is.charAt(0)=='%') { /* reference-definition found -- load it */
        if(is.length()==1) { /* Class-definition found --process it */
          is = cB.getVal(7); /* get name of class */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("chgSg221"); /* print errormessage */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              break bl; /* terminate evaluation */
            } /* error within current input -- terminate evaluation */
            Lg.Err("chgSg222",is); /* print errormessage */
            Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
            continue; /* continue with next definition-line */
          } /* continue with next definition-line */
          cLst = null; /* no current class-definition available */
          if(is.length()==0) { /* next keword not present */
            Lg.Err("chgSg223"); /* print errormessage */
            Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
            continue; /* continue with next definition-line */
          } /* continue with next definition-line */
          Nme = cB.getVal(1); /* get continuation of line */
          if(Nme!=null) lchk:{ /* more data present
            if(Nme.length()==0) break lchk; /* no valid data -- ignore it */
            if(Nme.charAt(0)=='#') break lchk; /* only coment -- ignore */
            Lg.Err("chgSg224",Nme); /* print errormessage */
            Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          } /* -lchk- rest of line has been ignored */
          Nme = is.toLowerCase(); /* create key-value */
          cLst = RefT.get(Nme); /* get referred Class-definition if already present */
          if(cLst!=null) continue; /* OK -- continue with next definition-line */
          cLst = new TSObjLst(is); /* create new object-class-definition */
          RefT.put(Nme,cLst); /* and insert it to List */
          continue; /* definition has been fully processed */
        } /* continue with next definition-line */

        if(!is.equals("%%")) { /* syntax-error - illegal marker */
          Lg.Err("chgSg230",is); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* continue with next definition-line */
        } /* illegal marker -- continue with next definition-line */
        Nme = cB.getVal(7); /* get filename of object */
        if(Nme==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("chgSg231"); /* print errormessage */
            Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
            break bl; /* terminate evaluation */
          } /* EOF within data -- terminate evaluation */
          Lg.Err("chgSg232",is); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* continue with next definition-line */
        } /* continue with next definition-line */
        if(Nme.length()==0) { /* filename not available */
          Lg.Err("chgSg233"); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* terminate processing */
        } /* terminate processing - continue with next line */
        if(is.charAt(0)=='#') { /* filename not found due to comment */
          Lg.Err("chgSg233"); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* terminate processing */
        } /* terminate processing - continue with next line */
        i = cB.getHV(8); /* get attributes of object */
        if((is=cB.getErr())!=null) { /* error while evaluating number */
          Lg.Err("chgSg234",is); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* terminate processing */
        } /* terminate processing - continue with next line */
        i |= 7; /* activate 'Class', 'Description' and 'Filename' */
        i &= TSObjDef.ObjMsk; /* remove invalid attribute-definitions
          * Attribut-definition: compare to class 'TSObjDef' */
        is = cB.getVal(7); /* get description of object */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("chgSg235"); /* print errormessage */
            Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
            break bl; /* terminate evaluation */
          } /* EOF within data -- terminate evaluation */
          Lg.Err("chgSg236",is); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* continue with next definition-line */
        } /* continue with next definition-line */
        if(is.length()==0) { /* description not available */
          Lg.Err("chgSg237"); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* terminate processing */
        } /* terminate processing - continue with next line */
        if(is.charAt(0)=='#') { /* description not found due to comment */
          Lg.Err("chgSg237",is); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* terminate processing */
        } /* terminate processing - continue with next line */
        if(cLst==null) { /* no class-reference available -- syntax-error */
          Lg.Err("chgSg238",Nme); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* terminate processing */
        } /* terminate processing - continue with next line */
        cObj = new TSObjDef(i,3,Nme,is); /* create new object-reference-definition */
        if(cLst.add(cObj)) continue; /* insert object-reference-definition to classlist */
          /* new object was successfully initialized  -- use next element */

        Lg.Err("chgSg239",Nme); /* print errormessage */
        Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
        continue; /* terminate processing - continue with next line */
      } /* reference-definition successfully processed */

      if(is.charAt(0)!='/') {  /* NO CONTINUATION-line -- process START */
        if((i=is.length())<5) { /* length of name is too short -- report error */
          Lg.Err("chgSg102",i); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* continue with next definition-line */
        } /* continue with next definition-line */
        /* 'is' is file-name of signal-shape (source) / static-object (source) */
        ok = false; /* preset: signal-definition */
        if(is.charAt(0)=='<') { /* old shape-name (src) is a static object (special meaning) */
          if((i=is.indexOf('>'))<3) { /* syntax-error within special name */
            Lg.Err("chgSg201",is); /* print errormessage */
            cSgD = null; /* mark definition as invalid */
            continue; /* terminate processing - do not use definition */
          } /* syntax-error within special name */
          is = is.substring(1,i); /* extract special name */
          ok = true; /* mark: source is static-signal-object */
        } /* static-object-definition is processed (first part */
        xs = is.toLowerCase(); /* create key from line-id */
        if(SgLst.containsKey(xs)) { /* definition already present */
          Lg.Err("chgSg103",is); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          cSgD = null; /* current def. - if present - no longer valid */
          continue; /* processing continues with next line */
        } /* processing continues with next line */
        cSgD = new TSSigCDef(is,ok); /* create change-command */
        if(!ok) { /* Definition refers to signal -- process source-signal */
          cSgS = cRte.fndSigS(is); /* search for signal-definition (source) */
          if(cSgS==null) { /* error: signal-definition not found */
            Lg.Err("chgSg109",is); /* print errormessage */
            cSgD = null; /* current def. - if present - no longer valid */
            continue; /* terminate processing - do not use change-command */
          } /* Signaldefinition nicht gefunden */
          SgSO = cSgS.getSOT(0); /* get list of Signal-Sub-Objects (source) */
          opt_b = SgSO.size(); /* get max. number of subobjects (source) */
        } /* signal-definition(source) found and prepared */
        cB.mark(false); /* remember position for second attempt */
        ox = cB.getFV(); /* try to get offset-value(x) */
        if(cB.getErr()==null) { /* successful -- continue */
          oy = cB.getFV(); /* get offset-value(y) (must be present) */
          if((Nme=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("chgSg10C",Nme,oy); /* print errormessage */
            cSgD = null; /* mark definition as invalid */
            continue; /* terminate processing - do not use definition */
          } /* syntax-error within offset-evaluation */
          oz = cB.getFV(); /* get offset-value(z) (must be present) */
          if((Nme=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("chgSg10D",Nme,oz); /* print errormessage */
            cSgD = null; /* mark definition as invalid */
            continue; /* terminate processing - do not use definition */
          } /* syntax-error within offset-evaluation */
          cSgD.setPos(new TSPos(ox,oy,oz)); /* insert new offset-values */
        } else cB.reset(false); /* go back and try again */
        Nme = cB.getVal(1); /* get new shape-name (optional) */
        if(Nme!=null) nnme:{ /* second filename may be present */
          if(Nme.length()==0) break nnme; /* Shape-Name or comment not available */
          if(Nme.charAt(0)=='#') break nnme; /* new shape-name (dest) not defined */
          if(Nme.charAt(0)=='<') snme:{ /* new shape-name (dest) has special meaning */
            if((i=Nme.indexOf('>'))<1) { /* syntax-error within special name */
              Lg.Err("chgSg10A",Nme); /* print errormessage */
              cSgD = null; /* mark definition as invalid */
              continue; /* terminate processing - do not use definition */
            } /* syntax-error within special name */
            Nme = Nme.substring(1,i); /* extract special name */
            if((i=Nme.length())<1) { /* syntax-error within special name */
              Lg.Err("chgSg10B",Nme,i); /* print errormessage */
              cSgD = null; /* mark definition as invalid */
              continue; /* terminate processing - do not use definition */
            } /* syntax-error within special name */
            if(!Nme.equals("$")) { /* no delete-marker found -- continue */
              if(ok) break snme; /* ignore meaning if static-object used */
              cSgD.setNme(Nme); /* store valid name of new 'static shape' */
              cSgD.getCmdT(1); /* create list of commands as marker */
            } /* special name is processed correctly */
            SgLst.put(xs,cSgD); /* insert command into itemlist */
            cSgD = null; /* invalidate current definition (fully processed) */
            continue; /* terminate processing */
          } /* -snme- special shape-name found and handled */
          cSgD.setNme(Nme); /* shape-name is valid (new dest) -- store it */
          is = Nme; /* set new shape-name for further processing */
        } /* -nnme- new shape-name was defined */
//          else if(ok) if(EnaW) Lg.Log("chgSg???",is); /* print message */
        if(ok) { /* definition is used for static-object */
          cSgD.getCmdT(1); /* create empty list of commands as marker */
          SgLst.put(xs,cSgD); /* insert command into itemlist */
          cSgD = null; /* invalidate current definition (fully processed) */
          continue; /* terminate processing */
        } /* definition found and processed */
        /* Process new filename of the signal, which may be the original one */
        cSgS = xRte.fndSigS(is); /* NEUE Signaldefinition suchen */
        if(cSgS==null) { /* error: signal-definition not found */
          Lg.Err("chgSg110",is); /* print errormessage */
          cSgD = null; /* mark definition as invalid */
          continue; /* terminate processing - do not use change-command */
        } /* signal-definition was not found */
        SgSO = cSgS.getSOT(0); /* get list of Signal-Sub-Objects (target) */
        opt_f = SgSO.size(); /* get max. number of subobjects (target) */
        cSgD.chgSigS(cSgS); /* insert shape-definition (target) */
        SgM = cSgD.getCmdT(10); /* create list of commands */
        SgLst.put(xs,cSgD); /* insert change-command into itemlist */

      } else { /* continuation-line found -- check it */
        if((i=is.length())!=2) /* Syntaxerror -- only use first character '/x' */
          if(i<2) { /* Syntaxerror -- line-command missing */
            Lg.Err("chgSg126",is); /* print errormessage */
            Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
            continue; /* terminate processing - continue with next line */
          } else Lg.Err("chgSg105",is); /* print errormessage */
        if(cSgD==null) { /* no valid change-definition -- sequence error */
          Lg.Err("chgSg106",is); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* terminate processing - continue with next line */
        } /* terminate processing - continue with next line */
        cBef = is.charAt(1); /* get current line-command */
        ok = Character.isUpperCase(cBef); /* Uppercase ? -- OK - set marker */
        cBef = Character.toLowerCase(cBef); /* translate to default-case it needed */
        zNr = (int)cB.getNV(); /* get number of 'new' subobject */
        if((is=cB.getErr())!=null) { /* error while evaluating number */
          Lg.Err("chgSg121",is); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* terminate processing */
        } /* terminate processing - continue with next line */
        if(zNr<0 || zNr>199) { /* range of value is invalid (max possible) */
          Lg.Err("chgSg122",zNr); /* print errormessage */
          Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
          continue; /* terminate processing */
        } /* terminate processing - continue with next line */
        sNr = vMsk = 0; /* preset */
        Nme = null;     /* preset */
        switch(cBef) { /* continue processing due to current line-command */
          case('a'): /* convert 'old' entry to 'new' entry  (alternative command) */
            if(zNr>=opt_f) { /* restrictions not met */
              Lg.Err("chgSg123",""+cBef,zNr,opt_f); /* print errormessage */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              continue; /* terminate processing */
            } /* terminate processing - continue with next line */
            sNr = (int)cB.getNV(); /* get second number of command */
            if((is=cB.getErr())!=null) { /* error while evaluating number */
              Lg.Err("chgSg124",is,""+cBef); /* print errormessage */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              continue; /* terminate processing */
            } /* terminate processing - continue with next line */
            if(sNr<0) { /* command refers to last 'a'/'c' command -- use 'n' command */
              sNr = -sNr + 100; /* convert number to message-ID */
              if(sNr>199) { /* range of value is invalid (max possible) */
                Lg.Err("chgSg128",""+cBef,sNr); /* print errormessage */
                Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
                continue; /* terminate processing */
              } /* terminate processing - continue with next line */
              cBef = 'n'; /* activate correct command-ID */
            } else { /* number refers to subobject */
              if(sNr>=opt_b) { /* value has invalid range */
                Lg.Err("chgSg125",""+cBef,sNr,0,opt_b); /* print errormessage */
                Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
                continue; /* terminate processing */
              } /* terminate processing - continue with next line */
              cBef = 'c'; /* activate correct command-ID */
            } /* check type of 'a'-command */
            Nme = cB.getVal(1); /* get name of 'new' signalscript */
            if(Nme==null) break; /* no more data in line -- OK */
            if(Nme.length()==0) Nme = null; /* NO script/signaltype available */
            else if(Nme.charAt(0)=='#') Nme = null; /* ignore comment */
            break; /* current line-command is processed */
          case('c'): /* convert 'old' entry to 'new' entry */
            if(zNr>=opt_f) { /* restrictions not met */
              Lg.Err("chgSg123",""+cBef,zNr,opt_f); /* print errormessage */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              continue; /* terminate processing */
            } /* terminate processing - continue with next line */
            sNr = (int)cB.getNV(); /* get number of 'old' subobject of signal */
            if((is=cB.getErr())!=null) { /* error while evaluating number */
              Lg.Err("chgSg124",is,""+cBef); /* print errormessage */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              continue; /* terminate processing */
            } /* terminate processing - continue with next line */
            if(sNr<0 || sNr>=opt_b) { /* value has invalid range */
              Lg.Err("chgSg125",""+cBef,sNr,0,opt_b); /* print errormessage */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              continue; /* terminate processing */
            } /* terminate processing - continue with next line */
            Nme = cB.getVal(1); /* get name of 'new' signalscript */
            if(Nme==null) break; /* no more data in line -- OK */
            if(Nme.length()==0) Nme = null; /* NO script/signaltype available */
            else if(Nme.charAt(0)=='#') Nme = null; /* ignore comment */
            break; /* current line-command is processed */
          case('n'): /* create new target-entry from any source-entry */
            if(zNr>=opt_f) { /* restrictions not met */
              Lg.Err("chgSg123",""+cBef,zNr,opt_f); /* print errormessage */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              continue; /* terminate processing */
            } /* terminate processing - continue with next line */
            sNr = (int)cB.getNV(); /* get number of error-message */
            if((is=cB.getErr())!=null) { /* error while evaluating number */
              Lg.Err("chgSg127",is,""+cBef); /* print errormessage */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              continue; /* terminate processing */
            } /* terminate processing - continue with next line */
            if(sNr<0 || sNr>199) { /* range of value is invalid (max possible) */
              Lg.Err("chgSg128",""+cBef,sNr); /* print errormessage */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              continue; /* terminate processing */
            } /* terminate processing - continue with next line */
            Nme = cB.getVal(1); /* get name of 'new' signalscript */
            if(Nme==null) break; /* no more data in line -- OK */
            if(Nme.length()==0) Nme = null; /* NO script/signaltype available */
            else if(Nme.charAt(0)=='#') Nme = null; /* ignore comment */
            ok = false; /* Uppercase character is NOT used/valid */
            break; /* current line-command is processed */
          case('o'): /* check/process line-command of type 'options' */
            Nme = DF3.format(zNr); /* convert to message-id (perhaps needed) */
            vMsk = cB.getHV(8); /* get optionmask from line */
            if((is=cB.getErr())!=null) { /* error while evaluating hex-number */
              Lg.Err("chgSg131",is,""+cBef,1);  /* print errormessage */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              continue; /* terminate processing */
            } /* terminate processing - continue with next line */
            sNr = cB.getHV(8); /* get options (old) from line */
            if((is=cB.getErr())!=null) { /* error while evaluating hex-number */
              Lg.Err("chgSg131",is,""+cBef,2); /* print errormessage */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              continue; /* terminate processing */
            } /* terminate processing - continue with next line */
            zNr = cB.getHV(8); /* get options (new) from line */
            if((is=cB.getErr())!=null) { /* error while evaluating hex-number */
              Lg.Err("chgSg131",is,""+cBef,3); /* print errormessage */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              continue; /* terminate processing */
            } /* terminate processing - continue with next line */
            if(zNr==0 && Nme.equals("000")) { /* no action specified -- remove it */
              Lg.Log("chgSg139",""+cBef); /* print message */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              continue; /* terminate processing */
            } /* terminate processing - continue with next line */
            for(i=0;i<31;i+=1) { /* check all target-options of mask */
              if(!TSOpts.chkMsk(i,zNr)) continue; /* not set -- nothing to do */
              /* if subobject is selected, it must be available */
              if(i>=SgSO.size() || SgSO.get(i)==null) { /* object available ? */
                /* subobject does NOT exist in target-definition */
                Lg.Err("chgSg132",""+cBef,i); /* print errormessage */
                Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
                continue; /* terminate processing */
              } /* terminate processing - continue with next line */
            } /* check all options */
            break; /* current line-command is processed */
          case('d'): /* check/process line-command of type 'delete'(conditional) */
            Nme = DF3.format(zNr); /* convert to message-id (perhaps needed) */
            vMsk = cB.getHV(8); /* get optionmask from line */
            if((is=cB.getErr())!=null) { /* error while evaluating hex-number */
              Lg.Err("chgSg131",is,""+cBef,1);  /* print errormessage */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              continue; /* terminate processing */
            } /* terminate processing - continue with next line */
            sNr = cB.getHV(8); /* get options (old) from line */
            if((is=cB.getErr())!=null) { /* error while evaluating hex-number */
              Lg.Err("chgSg131",is,""+cBef,2); /* print errormessage */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              continue; /* terminate processing */
            } /* terminate processing - continue with next line */
            break; /* current line-command is processed */
          case('b'): /* check/process conditional line-command */
            vMsk = cB.getHV(8); /* get optionmask from line */
            if((is=cB.getErr())!=null) { /* error while evaluating hex-number */
              Lg.Err("chgSg131",is,""+cBef,1); /* print errormessage */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              continue; /* terminate processing */
            } /* terminate processing - continue with next line */
            sNr = cB.getHV(8); /* get options (old) from line */
            if((is=cB.getErr())!=null) { /* error while evaluating hex-number */
              Lg.Err("chgSg131",is,""+cBef,2); /* print errormessage */
              Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
              continue; /* terminate processing */
            } /* terminate processing - continue with next line */
            break; /* current line-command is processed */
          default: /* unknown signal-command */
            Lg.Err("chgSg107",""+cBef,zNr); /* print errormessage */
            Lg.Log("chgSg199",cB.getLne(0),cB.getStat(true)); /* show current line */
            continue; /* terminate processing - continue with next line */
        } /* -break- line-command processed */
        SgM.add(new TSSigCDefE(cBef,zNr,sNr,vMsk,Nme,ok)); /* store new command */
      } /* continuation-line has been processed */
    } /* -while- process all signal-change-commands */
    if((is=cB.getErr())!=null) Lg.Err("chgSgF05",is,dat.getAbsolutePath());
    if((is=cF.close())!=null) Lg.Err("chgSgF06",is,dat.getAbsolutePath());
      /* close control-file again -- handle error if present */

    /* globale "tsection.dat" bearbeiten */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC05"); /* Aktionsmeldung ausgeben */

    dat = cRte.getFile(-1); /* get reference to file */
    i = getTS(dat,null);    /* and load 'tsection.dat' (global) */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC08",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC11",c3); /* Ergebnis melden */
    Lg.Log("MsgC14",ScN); /* Ergebnis melden */
    Lg.Log("MsgC17",c2); /* Ergebnis melden */
    Lg.Log("MsgC20",ShN); /* Ergebnis melden */
    Lg.Log("MsgC23",c4); /* Ergebnis melden */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(cRte,ScA,ShA); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* check reference-definitionfile of the route */
    i = getRF(cRte,null); /* check and load *.ref-file */
    if(i>0) return i; /* severe error found -- terminate function */

    /* zusaetzliche Streckendateien laden */
    i = getType(cRte); /* 'ttype.dat' laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strukturquadrate laden (genaue Ausfuehrung) */
    i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC26",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Strukturquadrate laden (LO-Tiles) */
    i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
    if(i>0) { /* Fehler beim Laden der Strukturquadrate */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC27",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Schienendatenbank laden */
    i = getDBF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    i = getITF(cRte,0); /* Schienendatenbank laden und pruefen (2. Teil) */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strassendatenbank laden */
    i = getDBF(cRte,1); /* Strassendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    if(i==0) { /* Datenbank ist vorhanden */
      i = getITF(cRte,1); /* Strassendatenbank laden und pruefen (2. Teil) */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* Datenbank(teil) ist vorhanden */

    /* World-Dateien laden und syntaktisch pruefen */
    i = getWF(cRte,false); /* World-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */
    /* Sound-Dateien laden und syntaktisch pruefen */
    i = getSF(cRte,false); /* World-Sound-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */

    /* Attention: Files are NOT written again (!OV->true) */
    /* Path-Definitionen werden geladen und ueberprueft */
    i = getPatF(cRte,true); /* Path-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Service-Definitionen werden geladen und ueberprueft */
    i = getSrvF(cRte,true); /* Service-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Traffic-Definitionen werden geladen und ueberprueft */
    i = getTrfF(cRte,true); /* Traffic-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Activity-Definitionen werden geladen und ueberprueft */
    i = getActF(cRte,true); /* Activity-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */


    /* all files were loaded -- continue with integrity-check */
    if((is=cRte.chkRte(Fo,true))!=null) { /* check route for integrity -- error found ? */
      if(is.charAt(0)!=' ') { /* error-message returned */
        Lg.Skip(true); /* skip line */
        Lg.Err("getRte23",is); /* print errormessage */
        Lg.Msg("MsgC60"); /* print message: 'terminating' */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* error found -- function terminated */
      if(EnaW) Lg.Log("chkRte00",is); /* Warning found -- print it */
    } /* error/warning found */

    /* "world"-Dateien bearbeiten und neue Integritaet herstellen */
    chkWrld(cRte,null,132); /* World-Dateien erweitert pruefen (128+4) */
      /* Modus: Aenderungen melden, kein Renum */

    /* Sound-Dateien bearbeiten und neue Integritaet herstellen */
    i = chkSnd(cRte,null,128); /* Sound-Dateien erweitert pruefen */
      /* Modus: Aenderungen melden */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("MsgC33",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC35"); /* Aktionsmeldung ausgeben */
    if(cRte.get$TrN(0)<0) { /* Schienendatenbank NICHT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC36"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datenbank nicht vorhanden */

    i = chkDBTab(cRte,0); /* Schienendatenbank bearbeiten */
    if(i<0) return 5; /* Systemfehler -- Ende */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC37",i); /* Aktionsmeldung */
    Lg.Skip(false); /* Leerzeile loggen */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC39"); /* Aktionsmeldung ausgeben */
      i = chkDBTab(cRte,1); /* Strassendatenbank bearbeiten */
      if(i<0) return 5; /* Systemfehler -- Ende */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("MsgC40",i); /* Aktionsmeldung */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Strassendatenbank vorhanden und geladen */

    /* extended check of local 'tsection.dat'
     * Attention: This method MUST NOT be invoked unless worldfiles AND
     * database (track/road) is stored again (or neither). */
    chkTSL(cRte,ScN,ShN); /* check file and compact it */

    i = chkPat(cRte); /* Pfad-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkSrv(cRte,true); /* Service-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkTrf(cRte,true,false); /* Traffic-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkAct(cRte,true); /* process activity-definitions */
    if(i>0) return 5; /* systemerror occurred -- terminate */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("chgSg003"); /* Aktion melden */

    if(Fo.chkMsk(16)) { /* Zusaetzliche Definitionen ausgeben */
      cI = SgLst.values().iterator(); /* Iterator uber die Eintraege */
      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Log("chgSg090",SgLst.size()); /* Datenfeld ausgeben */
      i = 0; /* Satznummer initialisieren */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        cSgD = (TSSigCDef)cI.next(); /* Eintrag holen */
        if(cSgD==null) continue; /* Datensatz nicht gefuellt */
        i += 1; /* weiterer Satz vorhanden */
        Lg.Log("chgSg091",cSgD.toStr(),i,0); /* Datenfeld ausgeben */
      } /* alle Eintraege */
      cI = ErrLst.keySet().iterator(); /* Iterator fuer Meldungen */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        is = (String)cI.next(); /* Schluessel holen */
        Lg.Log("Msg010","'"+is+"' -> '"+ErrLst.get(is)+"'");
      } /* alle Eintraege */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* zusaetzliche Ausgaben notwendig */

    /* Input and integrity is now completeted -- modify files and copy them */
    cCpyT = null; /* preset: do not install shapefiles */
    if(Fo.chkMsk(1)) cCpyT = (TSCopySet)Fo.getObj(5,1); /* get active copyset */
    cNmeT = new TSNameSet(false,null); /* initialize table of names
      * A entry within this list may be removed from route or *.ref-list */
    cnt = 0; /* World-Zaehler initialisieren */
    ng  = 0; /* Zaehler der Umstellungen initialisieren */
    ItT = cRte.getTrI(0,0); /* get current TrItem-Table (track-version) */
    QDf = cRte.chgQDf(null); /* process all quad-definitions (get list of quads) */
    if(QDf==null) throw new IllegalStateException( /* Sicherheitsabfrage */
      TSLogg.getMsg("Msg908","TreeSet<TSQuad>==null","chgSig",0));
    cI = QDf.iterator(); /* Iterator fuer Quadrat-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cQDf = (TSQuad)cI.next(); /* naechste Quadrat-Definition */
      is = cQDf.getInf(2); /* Namen der World-Datei */
      if(is==null) continue; /* World-Datei fehlt -- nicht bearbeiten */
      cnt += 1; /* Datei zaehlen */
      Lg.Log("chgSg004",is); /* Aktion melden */

      /* interne World-Daten bearbeiten und pruefen */
      n = 0; /* Zaehler der Umstellungen initialisieren */
      wl:for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
        /* nicht belegte UiD-Eintraege gibt es nicht (siehe 'getWF()') */
        if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
        if(cUiD.isCtl()) continue; /* kein aktiver UiD-Eintrag */
        cFn = cUiD.chgNme(null); /* Datei/Shape-Name des Objektes holen */

        if(cUiD instanceof TSStatic) { /* static object -- replace it? */
          if((cSgD=SgLst.get(cFn.toLowerCase()))==null) continue; /* no definition */
          if(!cSgD.isStatic()) continue; /* object is missdefined -- skip it */
          cNmeT.add(cFn); /* shape may be removed from route */
          xs = cUiD.getMsg(1); /* get current position of object */
          if(cSgD.getCmdT(0)==null) { /* marker says: object should be deleted */
            cUiD.setOpt(0); /* mark current object as 'dummy' */
            if(EnaW) Lg.Log("chgSg205",cFn,xs); /* report it as deleted */
            continue; /* continue with next world-object */
          } /* continue with next world-object */
          Nme = cSgD.getNme(false); /* get NEW filename of static-signal-object */
          cUiD.chgNme(Nme); /* and activate (set) it */
          cPos = cSgD.crPos(); /* get offset for new object */
          if(cPos!=null) mod1:{ /* offset is defined -- process it */
            if(cUiD.modPos(cPos)) break mod1; /* justify direction -- error do not modify */
            cPos.modPos(true,cUiD.crPos()); /* add position of original signal */
            if((i=cPos.clipPos())!=0) /* adjust final position within quad */
              if(EnaW) Lg.Log("chgSg207",cFn,xs,TSUtil.toHex(i,-6)); /* report clipping */
            cUiD.setPos(cPos); /* and store it to new object */
          } /* -mod1- offset defined and processed */
          if(EnaW) Lg.Log("chgSg206",cFn,xs,Nme); /* report action */
          if(cCpyT!=null) cCpyT.add(Nme); /* shape should be added to route */
          continue; /* static object was handled -- process next UID */
        } /* static object was handled successfully */

        if(!(cUiD instanceof TSSignal)) continue; /* NUR Signale pruefen */
        xs = cUiD.getMsg(1); /* Positionsbeschreibung holen */
        SUT = null; /* fuer Compiler */

        if((cSgD=SgLst.get(cFn.toLowerCase()))!=null) lp:{ /* Definition vohanden */
          if(cSgD.isStatic()) break; /* object is missdefined -- skip it */
          cSgS = cSgD.chgSigS(null); /* get Shape-Definition of target */
          SgM = cSgD.getCmdT(0); /* get current list of commands (or 'null') */

          if(cSgS==null) { /* marker says: use special procedure */
            if(SgM==null) { /* marker says: signal should be deleted */
              cUiD.setOpt(0); /* mark current object as 'dummy' */
              if(EnaW) Lg.Log("chgSg010",cFn,xs); /* report it as deleted */
              cNmeT.add(cFn); /* shape may be removed from route */
              break lp; /* continue with next world-object */
            } /* continue with next world-object */

            /* now: signal should be changed to 'static' */
            cSig = (TSSignal)cUiD; /* copy and save current object */
            cUiD = new TSStatic(cSig); /* create replacement-object */
            Nme = cSgD.getNme(false); /* get NEW filename of signalobject */
            cUiD.chgNme(Nme); /* and activate (set) it */
            cPos = cSgD.crPos(); /* get offset for new object */
            if(cPos!=null) mod2:{ /* offset is defined -- process it */
              if(cUiD.modPos(cPos)) break mod2; /* justify direction -- error do not modify */
              cPos.modPos(true,cUiD.crPos()); /* add position of original signal */
              if((i=cPos.clipPos())!=0) /* adjust final position within quad */
                if(EnaW) Lg.Log("chgSg024",cFn,xs,TSUtil.toHex(i,-6)); /* report clipping */
              cUiD.setPos(cPos); /* and store it to new object */
            } /* -mod2- offset defined and processed */
            cUiD.chgQDf(cQDf); /* insert back-reference to quad-basis-definition */
            is = cQDf.chgWTab(null,0).replace(cSig,cUiD); /* replace object within chain */
            if(is!=null) Lg.Err("chgSg022",cFn,xs,is); /* print error */
            else if(EnaW) Lg.Log("chgSg021",cFn,xs,Nme); /* report it as changed */
            if(cFn.equalsIgnoreCase(Nme)) break lp; /* continue with next world-object */
            /* Filename has changed -- process both for delete/add */
            cNmeT.add(cFn); /* shape may be removed from route */
            if(cCpyT!=null) cCpyT.add(Nme); /* shape should be added to route */
            break lp; /* fully processed -- continue with next world-object */
          } /* special procedure was executed */

          if(SgM==null) throw new  /* List of command MUST BE allocated now */
            IllegalStateException(TSLogg.getMsg("Msg906","ArrayList<TSSigCDefE>()"));
          if(SgM.size()==0) { /* no modification-command -- rename signal */
            Nme = cSgD.getNme(false); /* get NEW filename of signalobject */
            cUiD.chgNme(Nme); /* and activate (set) it */
            if(EnaW) Lg.Log("chgSg020",cFn,xs,Nme); /* report action */
            if(cFn.equalsIgnoreCase(Nme)) break lp; /* continue with next world-object */
            /* Filename has changed -- process both for delete/add */
            cNmeT.add(cFn); /* shape may be removed from route */
            if(cCpyT!=null) cCpyT.add(Nme); /* shape should be added to route */
            break lp; /* continue with next world-object */
          } /* signal should be renamed */
          suC = cUiD.get$TrI(0); /* max. Anzahl der Definitionen holen */
          ms = ((TSSignal)cUiD).chgMsk(0); /* current mask of subobjects (source) */
          SUT = new ArrayList<TSRefC>(32); /* table of signal-units (new) */
          mz = 0; /* target-mask of subobjects (store-switch) */
          opt_f = 0; /* Optionmask of TrSignalItem (forward) */
          opt_b = 0; /* Optionmask of TrSignalItem (backward) */
          SgSO = cSgS.getSOT(0); /* get list of Signal-Sub-Objects (target) */

          clp:for(i=0,in=0;i<1000;i+=1) { /* process all subcommands */
            if(i<in) continue; /* current command should be skipped */
            if(i>=SgM.size()) break; /* all commands have been processed */
            cSgDfE = SgM.get(i); /* retrieve current command from list */
            if(cSgDfE==null) continue; /* no valid command -- skip it */
            cBef = cSgDfE.getCBef(); /* aktuellen Befehl holen */
            zNr  = cSgDfE.getCzNr(); /* Nummer praeventiv holen */
            sNr  = cSgDfE.getCsNr(); /* Nummer praeventiv holen */
            vMsk = cSgDfE.getCMsk(); /* Nummer praeventiv holen */
            Nme  = cSgDfE.getCNme(); /* Argument praeventiv holen */
            cRef = null; /* compiler needs it */
            switch(cBef) { /* process signal according to current command */
              case('o'): /* Optionen auswerten */
                if(sNr==0) ok = (ms&vMsk)!=0; /* Maske ueberpruefen */
                else ok = (ms&vMsk)==sNr; /* genau vergleichen */
                if(cSgDfE.getOpt()) ok = !ok; /* Bedingung umdrehen, falls '/O' */
                if(!ok) break; /* NICHT OK -- keine weitere Aktion */
                if(!Nme.equals("000")) { /* Message/Warning requested for output */
                  is = ErrLst.get(Nme); /* get line of message/warning */
                  if(is==null) Lg.Err("chgSg011",cFn,xs,Nme); /* print error if message not found */
                  else Lg.Log(is,cFn,xs,TSUtil.toHex(mz,-8),TSUtil.toHex(ms,-8),
                    TSUtil.toHex(vMsk,-8),""+sNr); /* print requested message */
                } /* message has been successfully printed */
                if(zNr!=0) { /* target-option (mask) is available -- insert it */
                  mz |= zNr; /* insert new target-option (mask) */
                  for(sNr=0;sNr<31;sNr+=1) { /* Check consistency of all target-options */
                    if(!TSOpts.chkMsk(sNr,zNr)) continue; /* nicht gesetzt -- weiter */
                    cSgSO = SgSO.get(sNr); /* get connected Signal-Sub-Object */
                    vMsk = cSgSO.chgTyp(-1) + 1; /* aktuellen Subobjekt-Typ holen */
                    if(vMsk<4) continue; /* Typ HIER nicht weiter beachtet */
                    if(cSgSO.isOpt(5)) opt_b = TSOpts.setMsk(vMsk,opt_b); /* back_facing */
                     else opt_f = TSOpts.setMsk(vMsk,opt_f); /* Kennung gezielt einsetzen */
                  } /* Alle einzelnen Optionen uebeprueft */
                } /* target-options fully processed (added) */
                break; /* command is fully processed */
              case('d'): /* conditional delete of whole object */
                if(sNr==0) ok = (ms&vMsk)!=0; /* check mask */
                else ok = (ms&vMsk)==sNr; /* compare exactly */
                if(cSgDfE.getOpt()) ok = !ok; /* invert condition if '/D' */
                if(!ok) break; /* condition MOT matched -- no more to do */
                if(!Nme.equals("000")) { /* Message/Warning requested for output */
                  is = ErrLst.get(Nme); /* get line of message/warning */
                  if(is==null) Lg.Err("chgSg011",cFn,xs,Nme); /* print error if message not found */
                  else Lg.Log(is,cFn,xs,TSUtil.toHex(mz,-8),TSUtil.toHex(ms,-8),
                    TSUtil.toHex(vMsk,-8),""+sNr); /* print requested message */
                } /* message has been successfully printed */
                cUiD.setOpt(0); /* mark current object as 'dummy' */
                if(EnaW) Lg.Log("chgSg023",cFn,xs); /* report it as deleted */
                break lp; /* continue with next world-object */
              case('n'): /* Create new signal-subobject from any source-object */
                is = DF3.format(sNr); /* convert to message-id (perhaps needed) */
                for(sNr=0;sNr<TSSignal.K_MaxIt;sNr+=1) { /* search for valid reference-object */
                  if(!TSOpts.chkMsk(sNr,ms)) continue; /* sub-object is not active */
                  cRef = ((TSSignal)cUiD).fndSU(sNr); /* search for assigned reference-object */
                  if(cRef!=null) break; /* valid object found -- stop search */
                } /* -for- check all subobjects until valid one is found */
                if(sNr>31) { /* no valid sub-object (source) found -- print error */
                  if(is.equals("000")) break; /* no message -- command is fully processed */
                  Nme = ErrLst.get(is); /* get line of message/warning */
                  if(Nme==null) Lg.Err("chgSg011",cFn,xs,is); /* print error if message not found */
                  else Lg.Log(Nme,cFn,xs,TSUtil.toHex(mz,-8),TSUtil.toHex(ms,-8),
                    TSUtil.toHex(vMsk,-8),"?"); /* print requested message */
                  break; /* command is fully processed */
                } /* message has been successfully printed */
                /* continue processing as if command 'c' was found */
              case('c'): /* Create new signal-subobject copying and modifying old one */
                if(cBef=='c') { /* do not execute if cBef=='n' */
                  /* get subobject of master (TSSignal-Reference-element) */
                  cRef = ((TSSignal)cUiD).fndSU(sNr); /* search for assigned reference-object */
                  if(cRef==null) { /* object not found -- error within basic signaldefinition */
                    Lg.Err("chgSg012",cFn,xs,""+sNr,""+suC); /* print error-message and  */
                    break lp; /* terminate -- continue with next world-object */
                  } /* terminate -- continue with next world-object */
                } /*  /* do not execute if cBef=='n' */
                cIt = (TSTrItm01)cRef.chgRef(null); /* extract connected TrItem-entry (signal) */
                if(Nme==null) /* script-definition of current object is not modified -- get original name */
                  Nme = cIt.setSigT(0,0,0.0,null); /* extract original name of signaltype (=signalscript) */
                if((cSgT=xRte.fndSigT(Nme))==null) { /* new entry is missing within target-definition */
                  Lg.Err("chgSg013",cFn,xs,Nme,""+zNr); /* create error-message */
                  break lp; /* terminate -- continue with next world-object */
                } /* valid signaltype-definition was found (and stored into 'cSgT') */
                /* a new TrItem-element is created using this one as a template. This new element must
                 *  also be connected to the TrItem-References. So the old connection must be extracted
                 * to be used as a template, too.
                 */
                cIt.setTrNde(cTrN=cIt.setTrNde(null)); /* get current backchain to 'TSTrNode' */
                RfT = cTrN.getItm(0); /* get table of TrItem-Referenzen (TrItemRefs from *.tdb) */
                if(RfT==null) { /* No TrItem-References available -- error */
                  Lg.Err("chgSg016",cFn,xs,cTrN.getNr(true)); /* print error */
                  continue wl; /* terminate */
                } /* terminate -- continue with next world-object */
                /* search for position of current template-object within list of references */
                for(cIx=0;cIx<RfT.size();cIx+=1) { /* search all references within 'TrItemRefs' */
                  cRef = RfT.get(cIx); /* get (next) reference within list of references */
                  if(cRef==null) throw new IllegalStateException( /* reference must exist */
                      TSLogg.getMsg("Msg908","TSRefC(TSTrItem)==null","chgSig",0));
                  if(cRef.chgRef(null)==cIt) break; /* does reference refers to current object -- OK */
                } /* search for index of reference to current (template-)object */
                if(cIx>=RfT.size()) { /* reference to current object was not found -- integrity-error */
                  Lg.Err("chgSg017",cFn,xs,cTrN.getNr(true)); /* print error */
                  break lp; /* terminate -- continue with next world-object */
                } /* terminate -- continue with next world-object */

                /* TrItemRef-List (RfT) and Position (cIx) reflect the TrItem-Object of this subobject */
                sNr = ItT.size(); /* get overall number of TrItem-entries */
                cIt = new TSTrItm01(cIt,sNr,cSgDfE.getOpt()); /* create new Tritem-entry (max. No. becomes ID) */
                cIt.chgSigT(cSgT); /* insert type-Reference to new signaltype */
                /* Attention: The name of the signalscript is automatically corrected, if the new
                 *            signal-type-reference contains a valid script-name.
                 * Attention: Signaloptions (TrSignalType) are NOT inserted until the WHOLE NEW signal-
                 *            definition is generated.
                 */
                cRef = new TSRefC(sNr,cIt); /* Create new reference-control, too */
                RfT.add(++cIx,cRef); /* and add it as new element to reference-list of track-node. */
                cIt.setTrNde(cTrN); /* Insert back-Pointer to current track-node, */
                cIt.incCnt(1);      /* include new reference within counter */
                ItT.add(cIt);       /* and add new TrItem-entry to list of trItems (*.tdb) */
                cRef.chgIx(zNr); /* insert new subobject-number (target) into new reference */
                SUT.add(cRef);   /* add NEW Signal-Unit to temporary table of objects */
                mz |= 1L << zNr; /* add marker for this subobject due to target-no. and activate it */
                break; /* this command-sequence has been fully processed */
              case('b'): /* Bedingung pruefen und ggf. Ausfuehrung suspendieren */
                if(sNr==0) ok = (ms&vMsk)!=0; /* Maske ueberpruefen */
                else ok = (ms&vMsk)==sNr; /* genau vergleichen */
                /* um WEITERZUMACHEN muss die Bedingung erfuellt sein */
                if(cSgDfE.getOpt()) ok = !ok; /* Bedingung umdrehen, falls '/B' */
                if(ok) break; /* Bedingung erfuellt -- weiter -- keine weitere Aktion */
                if(zNr==0) break clp; /* Sonderfall: Ausfuehrung beenden */
                in = i + zNr + 1; /* neue Fortsetzung berechnen */
                break; /* command is fully processed */
//              case(' '): /* Dummy-Anweisung -- Keine Aktion */
//                break; /* Anweisung vollstaendig bearbeitet */
              default:; /* Keine Aktion bei unbekanntem Befehl */
            } /* -switch- Anweisung bearbeitet */
          } /* -clp- Alle Anweisungen ausfuehren */
          if(mz==0) break lp; /* no modifications done -- use old ones */
          cPos = cSgD.crPos(); /* get offset for new object */
          if(cPos!=null) mod3:{ /* offset is defined -- process it */
            if(cUiD.modPos(cPos)) break mod3; /* error do not modify */
            cPos.modPos(true,cUiD.crPos()); /* add position of original signal */
            if((i=cPos.clipPos())!=0) /* adjust final position within quad */
              if(EnaW) Lg.Log("chgSg019",cFn,xs,TSUtil.toHex(i,-6)); /* report clipping */
            cUiD.setPos(cPos); /* and store it to new object */
          } /* -mod3- offset defined and processed */
          SUT.trimToSize(); /* delete unused space within table */
          for(sNr=0;sNr<SUT.size();sNr+=1) { /* final processing of the new signal-definition */
            cRef = SUT.get(sNr); /* get next definition of the subobject-reference */
            cIt = (TSTrItm01)cRef.chgRef(null); /* get referenced TrItem-definition */
            zNr = cRef.chgIx(Integer.MIN_VALUE); /* get current index-number of subobject-definition */
            if(!TSOpts.chkMsk(zNr,mz)) throw new IllegalStateException( /* subobject is not active */
              TSLogg.getMsg("Msg908","Subobject '"+zNr+"', ("+TSUtil.toHex(mz,-8)+")","chgSig",1));
            cSgSO = SgSO.get(zNr); /* and get connected Signal-Sub-Object-definition */
            if(cSgSO.isOpt(5)) cIt.setSigO(opt_b); /* use 'back_facing' entry */
             else cIt.setSigO(opt_f); /* insert complete signal-options */
            cIt.chgRef(cUiD); /* insert back-reference to World-object */
          } /* -for- process all new signal-unit-references */
          Collections.sort(SUT); /* sort entries within signalunit-array, increasing 'Ix' */
          /* definition is complete -- aktivate it */
          ((TSSignal)cUiD).chgMsk(mz); /* Neue Subobjekt-Maske setzen */
          ((TSSignal)cUiD).setSUTab(SUT); /* neue SU-Tabelle aktivieren */
          Nme = cSgD.getNme(false); /* get NEW filename of signalobject */
          cUiD.chgNme(Nme); /* and activate (set) it */
          n += 1; /* Umstellung zaehlen */
          if(cFn.equalsIgnoreCase(Nme)) break lp; /* signal-object fully processed */
          /* Filename has changed -- process both for delete/add */
          cNmeT.add(cFn); /* shape may be removed from route */
          if(cCpyT!=null) cCpyT.add(Nme); /* shape should be added to route */
        } else Lg.Log("chgSg006",cFn); /* -lp- Aktion melden */
          /* Shapename signalisiert: KEINE Bearbeitung */

      } /* -wl- process all entries from world-file */
      Lg.Log("chgSg007",n); /* Anzahl der Umstellungen melden */
      ng += n; /* Alle umgestellten Objekte addieren */
    } /* alle 'World'-Dateien bearbeiten */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("chgSg008",null,cnt,ng); /* Anzahl der Umstellungen melden */
    Lg.Skip(true); /* Leerzeile loggen */

    /* Remove entries from list of object-references if they are no longer used */
    cI = cRte.getIt(25); /* get reference to stored definitions (*.ref) */
    if(cI!=null) { /* Route-Objectreferences are available -- check them */
      while(cI.hasNext()) { /* handle all class-definitions */
        ObjI = ((TSObjLst)cI.next()).getIt(); /* process next class-definition and
          * get Iterator to current 'Objectreferences' */
        if(ObjI==null) continue; /* no valid objects -- skip 'class' */
        while(ObjI.hasNext()) { /* handle all object-definitions */
          cObj = ObjI.next(); /* get next Objectreference-definition */
          if(cObj==null) continue; /* no valid object -- do not process */
          if(cObj.refers(cNmeT)) continue; /* definition must not be removed */
 if(PrMsk.chkMsk(31)) Lg.Msg("Msg010","Removed:"+cObj.toStr()); // ##!D
          ObjI.remove(); /* delete current entry from objectlist */
        } /* process ALL Object-reference-definitions */
      } /* process ALL classes */
    } /* data was available -- processed successfully */

    /* Insert new entries from list of object-references if available */
    if(RefT.size()>0) { /* new object-references available -- insert them */
      cI = RefT.values().iterator(); /* get iterator for ALL class-definitions */
      while(cI.hasNext()) { /* handle all class-definitions */
        cLst = (TSObjLst)cI.next(); /* get next class-definition (source) */
        ObjI = cLst.getIt(); /* get Iterator to current 'Objectreferences' */
        if(ObjI==null) continue; /* no valid objects -- skip 'class' */
          /* Attention: 'ObjI' points to source-table */
        is = cLst.getName(); /* get Class-name of entry */
        cLst = cRte.addList(is); /* create list of reference-objects for new class.
          * If class is already present, the current class is returned.
          * Attention: 'cLst' points to destination-table */
        while(ObjI.hasNext()) { /* handle all object-definitions (source) */
          cObj = ObjI.next(); /* get next Objectreference-definition */
          if(cObj==null) continue; /* no valid object -- do not process */
          Nme = cObj.getName(); /* get current filename/key of reference-object */
          if(Nme==null) continue; /* entry cannot be added to new list */
          if(cCpyT!=null) cCpyT.add(Nme); /* shape should be added to route */
          if(cLst.add(cObj)) continue; /* insert object-reference-definition to classlist */
            /* new object was successfully initialized  -- go to next entry */

        } /* process ALL Object-reference-definitions */
      } /* process ALL classes */
    } /* object-references were available -- processed successfully */

    /* create intermediate file if 'overwrite original files' is active */
    dat = null; /* preset: DO NOT overwrite original files */
    if(OV) { /* original files must be overwritten */
      /* print message and ask for confirmation */
      System.out.println(); /* insert empty outputline */
      if(!Fo.chkMsk(20)) askTerm(); /* ask user to REALLY overwrite */
      Lg.Log("MsgC41"); /* logg warning/hint */
      Lg.Skip(true); /* insert empty outputline to logfile */
      try { dat = File.createTempFile("TSUtil",".tmp");
      } catch (IOException e) { /* error while creation */
       System.err.println(e.toString());  return 5;}
      dat.deleteOnExit(); /* delete file again when java terminates */
    } /* original files should be overwritten */

    /* "world"-Dateien bearbeiten und modifizieren */
    i = putWF(cRte,dat,true,false); /* World-Dateien modifiziert schreiben */
      /* Modus: neue UiD's verwenden */
    if(i>0) return i; /* Fehler beim Schreiben -- Ende */
    /* Sound-Dateien bearbeiten und modifizieren */
    i = putSF(cRte,dat,true); /* Sound-Dateien modifiziert schreiben */
    if(i>0) return i; /* Fehler beim Schreiben -- Ende */

    /* Schienendatenbank bearbeiten */
    i = 16; if(Fo.chkMsk(29)) i += 64; /* Optionen erstellen */
    i = putDBF(cRte,dat,i); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    /* Schienendatenbank (.tit) bearbeiten */
    i = putITF(cRte,dat,0,false); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      /* Strassendatenbank bearbeiten */
      i = 17; if(Fo.chkMsk(29)) i += 64; /* Optionen erstellen */
      i = putDBF(cRte,dat,i); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */

      /* Strassendatenbank (.rit) bearbeiten */
      i = putITF(cRte,dat,1,false); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */
    } /* Strassendatenbank vorhanden und geladen */

    /* "tsection.dat" (lokal) neu erstellen / ueberschreiben */
    i = putTSL(cRte,cRte,OV); /* neue lokale 'tsection.dat' schreiben */
    if(i>0) return i; /* Fehler -- beenden */

    /* rewrite reference-definitionfile of the route */
    i = putRF(cRte,dat); /* rewrite *.ref-file */
    if(i>0) return i; /* severe error found -- terminate function */

    /* Copy signal-files to new destination */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Log("chgSg041"); /* print next action -- copy signaldefinitions */
    dat = cRte.getFile(OV?21:51); /* get destination for signal-files */
      /* Attention: 'Destination' is selected due to 'overwrite'-option */
    is = dat.getAbsolutePath(); /* and create complete file-path */
    dat = xRte.getFile(21); /* get source of signal-files */
    cFn = "copy \""+dat.getAbsolutePath()+"\" \""+is+"\" ";
      /* create current copy - command */
    if((i=exec(true,cFn,null,Lg))>0) /* Fehler bei Ausfuehrung */
      Lg.Log("MsgC49",is,i); /* Fehlermeldung */
    cI = xRte.getIt(20); /* alle Script-Definitionen kopieren */
    if(cI!=null) /* Script-Dateien registriert -- kopieren */
     while(cI.hasNext()) { /* Weitere Signalscript-Definitionen vorhanden */
      cSgF = (TSSigFle)cI.next(); /* naechste Signalscript-Definition */
      if(cSgF==null) throw new IllegalStateException( /* Sicherheitsabfrage */
        TSLogg.getMsg("Msg908","TSSigFle==null","chgSig",0));
      dat = cSgF.getFile(cRte,OV?1:2); /* vollstaendige Referenz (Ziel) holen */
      if(dat==null) throw new IllegalStateException( /* Sicherheitsabfrage */
        TSLogg.getMsg("Msg908","File==null","chgSig",0));
      is = dat.getAbsolutePath(); /* vollstaendiger Name */
      dat = cSgF.getFile(xRte,1); /* vollstaendige Referenz (Quelle) holen */
      if(dat==null) throw new IllegalStateException( /* Sicherheitsabfrage */
        TSLogg.getMsg("Msg908","File==null","chgSig",1));
      if(dat.isDirectory()) continue; /* es liegt keine Datei vor */
      if(!dat.exists()) continue; /* Datei existiert nicht */
      cFn = "copy \""+dat.getAbsolutePath()+"\" \""+is+"\" ";
        /* create copy-command */
      if((i=exec(true,cFn,null,Lg))>0) /* Fehler bei Ausfuehrung */
        Lg.Log("MsgC49",is,i); /* Fehlermeldung */
    } /* -while- alle Script-Dateien bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */

    if(OV && Fo.chkMsk(2)) delM:{ /* old shapes should be deleted -- execute it */
      if(cNmeT.size()==0) break delM; /* no file(s) to delete -- skip mission */
      Lg.Log("chgSg300",cNmeT.size()); /* print next action */
      i = 0; /* initialize counter */
      cI = cNmeT.keyIterator(false); /* get all records to delete */
      while(cI.hasNext()) { /* more files to delete ? */
        Nme = (String)cI.next(); /* get key of file (equals filename) */
        dat = cRte.getFile(15,Nme); /* get file-definition of shape-files */
        if(dat==null) { /* invalid file-definition */
          Lg.Err("chgSg301",Nme); /* print error-message */
          continue; /* error handled -- continue with next file */
        } /* error handled -- continue with next file */
        if(!dat.exists()) { /* file not found */
          Lg.Err("chgSg302",dat.getAbsolutePath()); /* print error-message */
          continue; /* error handled -- continue with next file */
        } /* error handled -- continue with next file */
        dat.delete(); /* delete shapefile */
        if(EnaH) Lg.Log("chgSg303",dat.getAbsolutePath()); /* print warning-line */
        i += 1; /* count deleted object */
        Nme += "d"; /* change name to descriptionfile */
        dat = cRte.getFile(15,Nme); /* get file-definition of shape-files */
        if(dat==null) { /* invalid file-definition */
          Lg.Err("chgSg301",Nme); /* print error-message */
          continue; /* error handled -- continue with next file */
        } /* error handled -- continue with next file */
        dat.delete(); /* delete description of shapefile */
      } /* process all files to be deleted */
      Lg.Log("chgSg309",i); /* print summary of deleted objects */
      Lg.Skip(true); /* Leerzeile loggen */
    } /* -delM- old signal-shapes have been deleted now */

    if(Fo.chkMsk(1)) cpyM:{ /* new shapes should be installed -- execute it */
      if(cCpyT.size()==0) break cpyM; /* no file(s) to copy -- skip mission */
      /* establish capability to print error-lines */
      LneT = new ArrayList<String>(10); /* create table for output-line-blocks */
        /* This list is normally empty. After it was filled with output-lines
         * and all lines have been processed, it MUST be cleared again. */
      dat = cRte.getFile(OV?15:45); /* get destination for Shape-files */
        /* Attention: 'Destination' is selected due to 'overwrite'-option */
      LneI = cCpyT.cpyFle(dat,null,LneT); /* install all Shape-Files */
      if(LneI!=null) /* messages have been created -- print them */
       while(LneI.hasNext()) { /* more message-lines available ? */
        is = LneI.next(); /* get next message-line */
        if(is==null) continue; /* dummy line -- do not write */
        /* Attention: A warning-line must start with ' ' or it is
         *            considered as an error-message */
        if(is.charAt(0)!=' ') Lg.Err("Msg010",is); /* print error-message */
          /* got error-message instead of warning-line */
        else Lg.Log("Msg010",is); /* print warning-line */
          /* NO error-message -- write Warning */
      } /* -while- process all output-lines */
      LneT.clear(); /* all lines written -- delete them */
      LneI = cCpyT.cpyFle(dat,"d",LneT); /* install all Shape-Description-Files */
      if(LneI==null) break cpyM; /* no valid messages -- terminate */
      while(LneI.hasNext()) { /* more message-lines available ? */
        is = LneI.next(); /* get next message-line */
        if(is==null) continue; /* dummy line -- do not write */
        if(is.charAt(0)!=' ') Lg.Err("Msg010",is); /* print error-message */
        else Lg.Log("Msg010",is); /* print warning-line */
      } /* -while- process all output-lines */
      LneT.clear(); /* all lines written -- delete them */
    } /* -cpyM- new signal-shapes are installed now */

    if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("chgSg009"); /* Ende-Mitteilung */
    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "srchSig" (-26-)
  * Vorkommen von Signaldefinitionen in den World-Dateien suchen und
  *   protokollieren
  * Optionen:
  *      16 - Extended output to LOG (-d,Hidden)
  *      18 - Strukturdatendatei reparieren falls notwendig (-tdrepair,Hidden)
  * ##srchSig (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int srchSig( /* Signaldefinitionen suchen und ausgeben */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute           cRte; /* current route-definition (basis) */
    TSQuad            cQDf; /* current QUAD-definition */
    TSUiD             cUiD; /* currend UID-element */
    TSSigSh           cSgS; /* current signalshape-definition */
    File              dir,dat,ndat; /* file-definitions */
    TSFile            cF;   /* current buffered outputfile (protocol) */
    int               i,j,og;
    String            is,js,xs;
    Iterator<TSQuad>  cI;   /* allgemeiner Tabellen-Iterator */
    Iterator<TSSigSh> sI;   /* signalshape-iterator ('ArrayList') */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("srchS001",fn); /* print prefix-message */

    /* get system-definition and check it */
    cRte = getRte(fn,2); /* read route-definition */
    /* 'newRoute' is used for output of signal-protocoll */
    if(cRte==null) return 5; /* error found -- terminate */

    /* print current paths */
    Lg.Msg("MsgC01",cRte.getInfo(2)); /* print route-name */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* print system-path */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* print route-path */
    Lg.Skip(true); /* and add empty line */

    /* globale "tsection.dat" bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC05"); /* Aktionsmeldung ausgeben */

    dat = cRte.getFile(-1); /* get reference to file */
    i = getTS(dat,null);    /* and load 'tsection.dat' (global) */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC08",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC11",c3); /* Ergebnis melden */
    Lg.Log("MsgC14",ScN); /* Ergebnis melden */
    Lg.Log("MsgC17",c2); /* Ergebnis melden */
    Lg.Log("MsgC20",ShN); /* Ergebnis melden */
    Lg.Log("MsgC23",c4); /* Ergebnis melden */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(cRte,ScA,ShA); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* zusaetzliche Streckendateien laden */
    i = getType(cRte); /* 'ttype.dat' laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strukturquadrate laden (genaue Ausfuehrung) */
    i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    if(i<0 && Fo.chkMsk(18)) { /* Steuerdatei wurde NICHT gefunden */
      i = creTDCtl(cRte,false); /* Steuerdatei erzeugen */
      if(i!=0) { /* Fehler beim Erzeugen der Steuerdatei (Hi) */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("MsgC69",i); /* Abbruchmeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 15; /* terminate function with errorcode */
      } /* Fehler aufgetreten */
      i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    } /* Steuerdatei erzeugen und neuer Versuch */
    if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC26",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Strukturquadrate laden (LO-Tiles) */
    i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
    if(i<0 && Fo.chkMsk(18)) { /* Steuerdatei wurde NICHT gefunden */
      i = creTDCtl(cRte,true); /* Steuerdatei erzeugen */
      if(i>0) { /* Fehler beim Erzeugen der Steuerdatei (Lo) */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("MsgC69",i); /* Abbruchmeldung ausgeben */
        Lg.Close(); /* close output to Log-file */
        return 15; /* terminate function with errorcode */
      } /* Fehler aufgetreten */
      if(i==0) i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
    } /* Steuerdatei erzeugen und neuer Versuch */
    if(i>0) { /* Fehler beim Laden der Strukturquadrate */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC27",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Schienendatenbank laden */
    i = getDBF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    i = getITF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strassendatenbank laden */
    i = getDBF(cRte,1); /* Strassendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    if(i==0) { /* Datenbank ist vorhanden */
      i = getITF(cRte,1); /* Strassendatenbank laden und pruefen */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* Datenbank(teil) ist vorhanden */

    /* World-Dateien laden und syntaktisch pruefen */
    i = getWF(cRte,false); /* World-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */
    /* Sound-Dateien laden und syntaktisch pruefen */
    i = getSF(cRte,false); /* World-Sound-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */

    /* Signal-Definitionen laden und ueberpruefen */
    i = getSCfg(cRte,cRte.getFile(21),null,false); /* load Signal-Configurations */
    if(i==0) /* Laden erfolgreich -- weiter testen */
      i = getSScr(cRte,cRte); /* Signal-Script-Definitionen laden */

    /* Path-Definitionen werden geladen und ueberprueft */
    i = getPatF(cRte,true); /* Path-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */


    /* all files were loaded -- continue with integrity-check */
    if((is=cRte.chkRte(Fo,true))!=null) { /* check route for integrity -- error found ? */
      if(is.charAt(0)!=' ') { /* error-message returned */
        Lg.Skip(true); /* skip line */
        Lg.Err("getRte23",is); /* print errormessage */
        Lg.Msg("MsgC60"); /* print message: 'terminating' */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* error found -- function terminated */
      if(EnaW) Lg.Log("chkRte00",is); /* Warning found -- print it */
    } /* error/warning found */

    /* "world"-Dateien bearbeiten und neue Integritaet herstellen */
    chkWrld(cRte,null,4); /* World-Dateien erweitert pruefen */
      /* Modus: keine Aenderungen melden, kein Renum */

    /* Sound-Dateien bearbeiten und neue Integritaet herstellen */
    i = chkSnd(cRte,null,0); /* Sound-Dateien erweitert pruefen */
      /* Modus: keine Aenderungen melden */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("MsgC33",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    /* Integritaet der Schienendatenbank herstellen */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC70"); /* Aktionsmeldung ausgeben */
    if(cRte.get$TrN(0)<=0) { /* Schienendatenbank NICHT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC36"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datenbank nicht vorhanden */

    i = chkDBTab(cRte,0); /* Schienendatenbank bearbeiten */
    if(i<0) return 5; /* Systemfehler -- Ende */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC71"); /* Aktionsmeldung ausgeben */
    Lg.Msg("MsgC38",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC72"); /* Aktionsmeldung ausgeben */
      i = chkDBTab(cRte,1); /* Strassendatenbank bearbeiten */
      if(i<0) return 5; /* Systemfehler -- Ende */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("MsgC73"); /* Aktionsmeldung ausgeben */
      Lg.Msg("MsgC38",i); /* Ergebnis melden */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Strassendatenbank vorhanden und geladen */

    /* extended check of local 'tsection.dat'
     * Attention: This method MUST NOT be invoked unless worldfiles AND
     * database (track/road) is stored again (or neither). */
    chkTSL(cRte,ScN,ShN); /* check file and compact it */

    i = chkPat(cRte); /* Pfad-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    /* Protokoll-Daten suchen und ausgeben */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("srchS002"); /* Aktionsmeldung ausgeben */

    if((i=cRte.get$SgS(true))<=0) { /* Datentabelle ist NICHT gefuellt */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("srchS011",i); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Fehler -- Keine Signaldaten vorhanden */

    dir = cRte.getFile(2); /* Verzeichnisdefinition des Ausgabe-Verzeichnisses */
    sI = cRte.getIt(21); /* Alle Signal-Shape-Definitionen */
    while (sI.hasNext()) { /* alle Eintraege bearbeiten */
      if((cSgS=sI.next())==null) continue; /* Signal-Shape nicht genutzt */
      is = cSgS.getNme(); /* Dateiname des Shapes holen */
      i = is.lastIndexOf('.'); /* Beginn der Dateiendung ermitteln, */
      if(i<0) continue; /* im Fehlerfall Bearbeitung einstellen */
      is = is.substring(0,i); /* und Endung entfernen */
      dat = new File(dir,is+".txt"); /* filedefinition of new output-file */
      cF = new TSFile(dat); /* create and define file (ASCII) */
      if((xs=cF.open(TSFile.OA))!=null) { /* open file ASCII -- error occurred? */
        Lg.Skip(true); /* print empty line to log and screen */
        Lg.Msg("srchS012",xs,dat.getName()); /* print errormessage */
        Lg.Close(); /* close output to Log-file */
        return 7; /* terminate function */
      } /* Error found while 'open' */

      i = 0; /* Anzahl der Ausgabesaetze */
      cI = cRte.getIt(12); /* Iterator fuer Quadrat-Definitionen */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        /* alle Quadrat-Definitionen bearbeiten */
        cQDf = cI.next(); /* naechste Quadrat-Definition */
        js = cQDf.getInf(2) + "\t" + is + "\tPosition( "; /* Satz vorbereiten */
        for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
          if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
          if(cUiD.isCtl()) continue; /* kein aktiver UiD-Eintrag */
          if(!(cUiD instanceof TSSignal)) continue; /* kein Eintrag vom Typ 'Signal' */
          if(((TSSignal)cUiD).chgSigS(null)!=cSgS) continue; /* Signal passt nicht */
          xs = js + cUiD.getMsg(0) + " )"; /* Datensatz erstellen */
          if((xs=cF.putData(xs))!=null) { /* write record -- error? */
            Lg.Skip(true); /* print empty line to log and screen */
            Lg.Msg("srchS013",xs,dat.getName()); /* print errormessage */
            Lg.Close(); /* close output to Log-file */
            return 8; /* terminate function */
          } /* i/o-error occurred */
          i += 1; /* protokolliertes Signal zaehlen */
        } /* alle UiD's pruefen */
      } /* alle Quad-Definitionen bearbeiten */

      if((xs=cF.close())!=null) Lg.Err("srchS014",xs,dat.getName());
        /* close output-file again -- handle error if present */
      is += "." + DF4.format(i) + ".txt"; /* neuen Dateinamen erstellen */
      ndat = new File(dir,is); /* neue Dateidefinition fuer Ausgabe-Datei */
      dat.renameTo(ndat); /* Dateiname der Ausgabe-Datei aendern */
    } /* alle Signal-Shape-Definitionen bearbeiten */

    if(Fo.chkMsk(24)) putObj(cRte); /* Objektsicherung erstellen */
    if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("srchS009"); /* Ergebnis melden */

    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
 }

 /**. <pre>
  *=====================================================================
  * Methode "mveObj" (-27-)
  * Objekte einer Streckendefinition verschieben (3 Dimensionen)
  * Individuelle Optionskennungen (wenn aktiv):
  *   1 - Tile/Quadranten generieren (-g)
  *   2 - NUR Track-/Road-Objekte verschieben (-t/-T)
  *   3 - Strassenobjekte ignorieren (-r)
  *   4 - Fortsetzen auch wenn Fehler erkannt wurden (-w)
  *   5 - Position von Sound-Objekten NICHT veraendern (no 'clip') (-v)
  *  16 - Extended output to LOG (-d,Hidden)
  * ##mveObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int mveObj( /* Streckenobjekte verschieben */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute            cRte;   /* aktuelle Streckendefinition (Basis) */
    TreeSet<TSTile>    Tle;    /* Tile-Definitionen */
    TSTile             cTle;   /* aktuelle Tile-Definition */
    TreeSet<TSQuad>    QDf;    /* Quadrat-Definitionen */
    TSQuad             cQDf,nQDf; /* aktuelle Quadrat-Definition */
    TSQPos             cQPos;  /* aktuelle erweiterte Positionsdefinition */
    TSPos              cPos;   /* aktuelle Positionsdefinition */
    TSUiD              cUiD,wUiD; /* aktuelles UiD-Element */
    TSSnd              cSnd;   /* aktive Sound-Definition */
    TSChain            cC;     /* Arbeitswert Objektkette */
    TSTrNde[]          TrNdeT; /* aktuelle TrackNode-Tabelle */
    TSTrNde            cTrN;   /* aktuelles DB-Element */
    TSVector           cNde;   /* current vector-node */
    TSTrItm            cIt;    /* aktuelles DB-Element (TrItem) */
    ArrayList<TSTrItm01T> TrItD; /* 'TrSignalDir'-Eintrag (SignalItem) */
    TSTrItm01T         cTrItD; /* 'TrSignalDir'-Eintrag (SignalItem) */
    TSView             cVS,nVS; /* ViewSphere-Element (neue Basis, Aktuell) */
    TSPath             cPth;   /* aktuelle Pfad-Definition */
    TSPatPDP           cPDP;   /* aktuelle PDP-Definition */
    TSOpts             cM;     /* current mask of 'included objects' */
    File               sdir,tdir; /* Dateidefinitionen */
    int                i,u,qx,qz; /* Arbeitswerte */
    int                j,k,m,v; /* Arbeitswerte */
    String             is,js;   /* Arbeitswerte */
    double             dx,dy,dz; /* Korrekturwerte */
    boolean            tdl;     /* LO_Tiles vorhanden */
    boolean            tro,ird; /* verschiebe-Optionen */
    boolean            ctl1,ctl2; /* Steuer-Optionen fuer CTl-Eintraege */
    boolean            newTile; /* Neuer Tile wurde erzeugt */
    Object             o; /* unknown objecttype of filname-pattern */
    ArrayList<String>  ETab; /* Tabelle der Fehlermeldungen (VS) */
    Iterator           cI;  /* common iterator ('TreeSet'/'HashMap') */
    Iterator<TSTrNde>  aI;  /* Iterator of TrackNode-Table */
    Iterator<TSPatPDP> pI;  /* Iterator ueber PDP-Definitionen */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("mveObjC1",fn); /* Vorlauf ausgeben */

    /* Systemdatei lesen und auswerten */
    cRte = getRte(fn,3); /* (world(3)) Streckendefinition auswerten */
    if(cRte==null) return 5; /* Fehler -- Ende */

    /* print current paths */
    Lg.Msg("MsgC01",cRte.getInfo(2)); /* print route-name */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* print system-path */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* print route-path */
    Lg.Skip(true); /* and add empty line */

    /* globale "tsection.dat" bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC05"); /* Aktionsmeldung ausgeben */

    sdir = cRte.getFile(-1); /* get reference to file */
    i = getTS(sdir,null);    /* and load 'tsection.dat' (global) */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC08",i); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC11",c3); /* aktuelle tsection-Daten melden */
    Lg.Log("MsgC14",ScN); /* Ergebnis melden */
    Lg.Log("MsgC17",c2); /* Ergebnis melden */
    Lg.Log("MsgC20",ShN); /* Ergebnis melden */
    Lg.Log("MsgC23",c4); /* Ergebnis melden */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(cRte,ScA,ShA); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* zusaetzliche Streckendateien laden */
    i = getType(cRte); /* 'ttype.dat' laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strukturquadrate laden (genaue Ausfuehrung) */
    i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC26",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Strukturquadrate laden (LO-Tiles) */
    tdl = true; /* annehmen: Lo_Tiles sind vorhanden */
    i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
    if(i>0) { /* Fehler beim Laden der Strukturquadrate */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC27",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    if(i<0) tdl = false; /* nicht mehr versuchen */

    /* Schienendatenbank laden */
    i = getDBF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    i = getITF(cRte,0); /* Schienendatenbank laden und pruefen  (2. Teil) */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strassendatenbank laden */
    i = getDBF(cRte,1); /* Strassendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    if(i==0) { /* Datenbank ist vorhanden */
      i = getITF(cRte,1); /* Strassendatenbank laden und pruefen (2. Teil) */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* Datenbank(teil) ist vorhanden */

    /* World-Dateien laden und syntaktisch pruefen */
    i = getWF(cRte,false); /* World-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */
    /* Sound-Dateien laden und syntaktisch pruefen */
    i = getSF(cRte,false); /* World-Sound-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */

    /* Path-Definitionen werden geladen und ueberprueft */
    i = getPatF(cRte,true); /* Path-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Service-Definitionen werden geladen und ueberprueft */
    i = getSrvF(cRte,true); /* Service-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Traffic-Definitionen werden geladen und ueberprueft */
    i = getTrfF(cRte,true); /* Traffic-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Activity-Definitionen werden geladen und ueberprueft */
    i = getActF(cRte,true); /* Activity-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */


    /* all files were loaded -- continue with integrity-check */
    if((is=cRte.chkRte(Fo,true))!=null) { /* check route for integrity -- error found ? */
      if(is.charAt(0)!=' ') { /* error-message returned */
        Lg.Skip(true); /* skip line */
        Lg.Err("getRte23",is); /* print errormessage */
        Lg.Msg("MsgC60"); /* print message: 'terminating' */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* error found -- function terminated */
      if(EnaW) Lg.Log("chkRte00",is); /* Warning found -- print it */
    } /* error/warning found */

    /* "world"-Dateien bearbeiten und neue Integritaet herstellen */
    chkWrld(cRte,null,4); /* World-Dateien erweitert pruefen */
      /* Modus: keine Aenderungen melden, kein Renum */

    /* Sound-Dateien bearbeiten und neue Integritaet herstellen */
    i = chkSnd(cRte,null,Fo.chkMsk(5)?0:160); /* Sound-Dateien erweitert pruefen */
      /* Modus(160): keine Aenderungen melden, 'clip' Soundsource (+chg) */
      /* Modus(0): keine Aenderungen melden, keine Veraenderung (no 'clip') */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("MsgC33",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC35"); /* Aktionsmeldung ausgeben */
    if(cRte.get$TrN(0)<=0) { /* Schienendatenbank NICHT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC36"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datenbank nicht vorhanden */

    i = chkDBTab(cRte,0); /* Schienendatenbank bearbeiten */
    if(i<0) return 5; /* Systemfehler -- Ende */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC37",i); /* Aktionsmeldung ausgeben */
    Lg.Skip(false); /* Leerzeile loggen */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC39"); /* Aktionsmeldung ausgeben */
      i = chkDBTab(cRte,1); /* Strassendatenbank bearbeiten */
      if(i<0) return 5; /* Systemfehler -- Ende */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("MsgC40",i); /* Aktionsmeldung ausgeben */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Strassendatenbank vorhanden und geladen */

    i = chkPat(cRte); /* Pfad-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkSrv(cRte,true); /* Service-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkTrf(cRte,true,false); /* Traffic-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkAct(cRte,true); /* process activity-definitions */
    if(i>0) return 5; /* systemerror occurred -- terminate */

    /* Aktion vorbereiten: fehlende World-Dateien erstellen */
    newTile = false; /* vorbesetzen: keine neuen Tile-Definitionen erzeugt */
    QDf = cRte.chgQDf(null); /* Alle Quadrat-Definitionen */
    if(QDf==null) throw new IllegalStateException( /* Sicherheitsabfrage */
      TSLogg.getMsg("Msg908","TreeSet<TSQuad>==null","mveObj",0));
    if(Fo.chkMsk(1)) { /* fehlende World-Dateien erzeugen (Dummy) */
      /* Alle Tile-Definitionen ueberpruefen und bearbeiten
       * Durch diese Massnahme gibt es KEINE Tile-Definition mehr,
       * fuer die nicht ALLE Quadrantendefinitionen vorhanden sind;
       * wenn auch die World-Definitonen ggf. leer sind. */
      cI = cRte.getIt(10); /* Iterator fuer Tile-Definitionen */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
        while((cQDf=cTle.crQuad())!=null) { /* neue Quad-Definition erstellt */
          cQDf.chgTle(cTle); /* Rueckverkettung einfuegen */
          cQDf.chgMde(TSFile.OCB); /* set output-mode of world-file to CB */
          if(!QDf.add(cQDf)) { /* Strukturquadrat in globale Kette einfuegen */
            Lg.Skip(true); /* Leerzeile loggen wegen SYSTEMFEHLER */
            Lg.Msg("MsgC31",cQDf.getInf(0)); /* Fehlermeldung ausgeben */
            Lg.Close(); /* close output to Log-file */
            return 6; /* terminate function with errorcode */
          } /* NEUES Strukturquadrat nicht einfuegbar -- bereits vorhanden */
        } /* neue Quad-Definition wurde erzeugt */
      } /* alle Tile-Definitionen */
    } /* ALLE World-Dateien der definierten Tiles wurden erzeugt */

    /* Aktion durchfuehren: Positionswerte anpassen */
    dx = Fo.getFlt(5,1); /* Korrekturwert(X) holen */
    dy = Fo.getFlt(5,2); /* Korrekturwert(Y) holen */
    dz = Fo.getFlt(5,3); /* Korrekturwert(Z) holen */
    tro = Fo.chkMsk(2); /* NUR Track-Objekte verschieben */
    ird = Fo.chkMsk(3); /* Strassenobjekte ignorieren */
    if(!tro) ird = false; /* Strassenobjekte verschieben wenn 'tro' nicht aktiv */
    Tle = cRte.getTle(0,false); /* get current Tile-definitions (HI) */
    tdir = cRte.getFile(48); /* Pfad der Tile-Dateien (Ziel) holen */

    /* Meldung: Aktion wird jetzt durchgefuehrt */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mveObjC2",cRte.getInfo(1)); /* Aktionsmeldung */

    i = 0; /* Anzahl der Fehler initialisieren */
    c2 = c3 = c4 = c5 = 0; /* Zaehler fuer Fehlertypen setzen */
    cI = new ArrayList<TSQuad>(QDf).iterator(); /* Iterator auf Kopie erstellen */
      /* Da die Quadrantenkette waehrend der Aktion modifiziert wird und NUR die
       * Ausgangsquadranten bearbeitet werden duerfen, ist hier als Selektionsbasis
       * eine Kopie der Quadrantenliste verwendet.
       */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cQDf = (TSQuad)cI.next(); /* naechste Quadrandten-Definition */
      Lg.Log("mveObjC3",cQDf.getInf(0)); /* Bearbeitungsmeldung ausgaben */
      /* Quadranten 1. Teil: World-Dateien */
      js = cQDf.getInf(2); /* Namen der World-Datei */
      if(js==null) continue; /* World-Datei fehlt -- nicht bearbeiten */

      /* interne World-Daten bearbeiten */
      nVS  = null; /* noch KEINE Kopie der ersten ViewSphere (Basis) */
      wUiD = null; /* kein Watermark-Eintrag gemerkt */
      ctl1 = false; /* 'ctl1==true' => MINDESTENS ein gueltiger Eintrag existiert
                     * (seit letztem UID-Steuereintrag(Watermark)) */
      for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false),ctl1|=ctl2) {
        /* Achtung: Modifikation von 'ctl1' in der 'for-Anweisung' beachten!!! */
        /* nicht belegte UiD-Eintraege gibt es nicht */
        /* Wenn die 'for'-Anweisung wieder durchlaufen wird, ohne dass 'ctl2'
         * geloescht wurde, bedeutet dies, dass der aktuelle Eintrag im Quadranten
         * verbleibt.
         */
        ctl2 = false; /* Vorbesetzen: aktueller Eintrag ist NICHT gueltig */
        if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
        if(cUiD.isCtl()) { /* UiD-Steuereintrag gefunden -- bearbeiten */
          if(wUiD!=null) /* Vorrangehender UiD-Steuereintrag wurde bereits erkannt */
           if(!ctl1) { /* Seitdem folgen KEINE gueltigen Eintraege -- alter Steuereintrag weg */
            cC = cQDf.chgWTab(null,0);  /* aktuelle Verkettung der World-Elemente holen */
            if((is=cC.remove(wUiD))!=null) { /* Fehler beim Entfernen des Elementes */
              Lg.Err("mveObjU3",is,js,-1); /* Fehlermeldung */
              i += 1; /* Fehler zaehlen */
            } /* Element konnte nicht korrekt entfernt werden */
          } /* Vorrangehender Steuereintrag entfernt */
          wUiD = cUiD; /* neuen Steuereintrag merken */
          ctl1 = false; /* Vorbesetzen: Steuereintrag kann entfernt werden */
          continue; /* naechstes Objekt bearbeiten (for) */
            /* 'ctl1' wird JETZT nicht veraendert, da 'ctl2' noch 'false' ist. */
        } /* UiD-Steuereintrag gefunden -- bearbeiten */
        ctl2 = true; /* Vorbesetzen: Objekt-Eintrag ist gueltig */
        if(cUiD.isOpt(31)) continue; /* Eintrag wurde bereits bearbeitet */
        if(tro & !cUiD.isOpt(7)) /* move restricted to track-objects -- include additional ones? */
          for(j=4;j<Fo.get$Obj(5);j+=2) { /* use all definitions for inclusion */
            cM = Fo.getOpt(5,j); /* get objectmask of additionally included objects */
            if(!cUiD.chkType(cM)) continue; /* current object-type not included in mask */
            is = cUiD.chgNme(null); /* get current filename if available */
            if(is==null) { /* no filename defined -- include object in every case */
              cUiD.setOpt(7); /* mark entry as 'included' */
              break; /* object included -- no further testing */
            } /* no filename was available */
            o = Fo.getObj(5,j+1); /* get object to compare filenames  */
            if(o instanceof Pattern) { /* regular expression found */
              if(!((Pattern)o).matcher(is).lookingAt()) continue; /* no match to expr. */
            } else { /* String must be used to match filenames */
              js = ((String)o).toLowerCase(); /* convert object to string */
              if(!is.toLowerCase().startsWith(js)) continue; /* no match -- next attempt */
            } /* check has been executed */
            /* match found -- object should be included */
            cUiD.setOpt(7); /* mark entry as 'included' */
            break; /* object included -- no further testing */
          } /* check all definitions for inclusion */
        if(tro & !cUiD.isOpt(7)) continue; /* move not requested */
        if(ird & cUiD.isRoad()) continue; /* move not requested */
        cUiD.setOpt(31); /* Eintrag als bearbeitet kennzeichnen */
          /* Wenn dieser Eintrag in einen anderen Quadranten verschoben wird, der noch
           * nicht bearbeitet wurde, kann es sein, dass er NOCH EINMAL verschoben
           * werden soll. Das wird hiermit verhindert.
           */
        u = cUiD.getUiD(0); /* Original UID fuer Fehlermeldungen merken */
        cPos = cUiD.crPos(); /* Kopie der Positionsdefinition holen */
        if(cPos==null) { /* Positionsdefinition nicht gueltig */
          Lg.Err("mveObjU1",js,u); /* Fehlermeldung */
          c5 += 1; /* Fehler vom Typ 5 zaehlen */
          i += 1; /* Fehler zaehlen */
          continue; /* naechstes Objekt bearbeiten */
        } /* Positionsdefinition nicht gueltig */
        qx = cPos.addPosX(dx); /* X-Position anpassen */
        cPos.addPosY(dy); /* Hoehe anpassen -- Kein Korrekturwert */
        qz = cPos.addPosZ(dz); /* Z-Position anpassen */
        if(qx!=0 || qz!=0) { /* neuer Quadrant betroffen */
          nQDf = cQDf.fndQuad(cRte,qx,qz); /* passenden Quadranten suchen */
          if(nQDf==null) { /* Ziel-Quadranten nicht gefunden -- Abbruch ? */
            if(!Fo.chkMsk(1)) { /* Ziel-Quadrand NICHT erzeugen */
              Lg.Err("mveObjU2",cQDf.getMsg(1,null,qx,qz),js,u); /* Fehlermeldung ausgeben */
              c4 += 1; /* Fehler vom Typ 4 zaehlen */
              i += 1; /* Fehler zaehlen */
              continue; /* naechstes Objekt bearbeiten */
            } /* Ziel-Quadrand soll erzeugt werden */
            newTile = true; /* kennzeichnen: neue Tile-Definition wird erzeugt */
            nQDf = new TSQuad(cQDf,qx,qz); /* neuer Quadrand und Tile erstellen */
            cTle = nQDf.chgTle(null); /* Zugeordnete Tile-Definition holen */
            nQDf.chgMde(TSFile.OCB); /* set output-mode of world-file to CB */
            if(!Tle.add(cTle)) { /* Tile-Definition in globale Kette einfuegen */
              Lg.Skip(true); /* Leerzeile loggen wegen SYSTEMFEHLER */
              Lg.Msg("MsgC58",cTle.getId(true),cTle.getNme(0)); /* Fehlermeldung */
              Lg.Close(); /* close output to Log-file */
              return 6; /* terminate function with errorcode */
            } /* NEUE Tile-Definition nicht einfuegbar -- bereits vorhanden */
            if(!QDf.add(nQDf)) { /* Strukturquadrat in globale Kette einfuegen */
              Lg.Skip(true); /* Leerzeile loggen wegen SYSTEMFEHLER */
              Lg.Msg("MsgC31",nQDf.getInf(0)); /* Fehlermeldung ausgeben */
              Lg.Close(); /* close output to Log-file */
              return 7; /* terminate function with errorcode */
            } /* NEUES Strukturquadrat nicht einfuegbar -- bereits vorhanden */
            is = cTle.crTle(tdir,dy); /* Tile-Daten erzeugen */
            if(is!=null) { /* Fehler beim Schreiben der Tile-Daten erhalten */
              Lg.Skip(true); /* Leerzeile loggen wegen SYSTEMFEHLER */
              Lg.Msg("Msg010",is); /* Fehlermeldung ausgeben */
              Lg.Close(); /* close output to Log-file */
              return 8; /* terminate function with errorcode */
            } /* Tile-Daten nicht vollstaendig/korrekt geschrieben */
          } /* Ziel-Quadranten nicht gefunden */
          cC = cQDf.chgWTab(null,0);  /* aktuelle Verkettung der World-Elemente holen */
          if((is=cC.remove(cUiD))!=null) { /* Fehler beim Entfernen des Elementes */
            Lg.Err("mveObjU3",is,js,u); /* Fehlermeldung */
            i += 1; /* Fehler zaehlen */
            continue; /* naechstes Objekt bearbeiten */
          } /* Element konnte nicht korrekt entfernt werden */
          ctl2 = false; /* Eintrag wird aus Quadranten entfernt */
          if((cC=nQDf.chgWTab(null,0))==null) { /* NOCH keine World-Datei vorhanden */
            if(nQDf.setNme(true)) Lg.Log("mveObjU4",nQDf.getInf(0),cUiD.getName(true),u);
            cC = new TSChain(); /* neue, leere Objekt-Kette erzeugen */
            nQDf.chgWTab(cC,0); /* und in Quadranten eintragen */
          } /* Objektkette fuer World-Objekte musste erzeugt werden */
          cUiD.$reNew(nQDf.getOId(),nQDf.getWId()); /* Eindeutige Daten neu setzen */
          cUiD.setPos(cPos); /* neuer Positionswert einsetzen (modifizierte Kopie) */
          cC.add(cUiD); /* World-Eintrag sortiert neu hinzufuegen und speichern */
          cUiD.chgQDf(nQDf); /* neue Rueckverkettung zu Quadranden eintragen */
          /* Objekt-typische Bearbeitung durchfuehren (TSPos-Werte) */
          /* -- keine -- */
          if(!cUiD.chkMsk(25)) /* VDbId-Definition ist vorhanden */
           if((cVS=cUiD.chgView(null))!=null) { /* Explizite ViewSphere-Referenz -- bearbeiten */
            cVS.incCnt(-1); /* Zaehler anpassen */
            cUiD.clrView(cUiD.getVNrDef()); /* Viewsphere-Referenz loeschen und durch 'default' ersetzen */
          } /* Explizite Viewsphere-Referenz musste bearbeitet werden */
        } else cUiD.setPos(cPos); /* kein neuer Quadrant -- neuen Positionswert fixieren */
        /* Objekt-typische Bearbeitung durchfuehren (TSQPos-Werte)
         * (TrItem-Definitionen werden HIER nicht bearbeitet)
         */
        if(cUiD instanceof TSTrkObj) {  /* weitere Pruefung ('TrackObj') */
          if(!cUiD.chkMsk(8)) wo0:{ /* JNodePosn-Definition ist vorhanden */
            cQPos = ((TSTrkObj)cUiD).crNdeP(); /* Definition als Kopie holen */
            if(cQPos==null) { /* Positionsdefinition nicht gueltig */
              Lg.Err("mveObjUA",js,u); /* Fehlermeldung */
              c5 += 1; /* Fehler vom Typ 5 zaehlen */
              i += 1; /* Fehler zaehlen */
              break wo0; /* naechstes Objekt bearbeiten */
            } /* Positionsdefinition nicht gueltig */
            is = cQPos.addPos(cRte,dx,dy,dz); /* Positionen anpassen -- Fehler? */
            if(is!=null) { /* Fehler beim Korrigieren der Werte aufgetreten */
              Lg.Err("mveObjUB",is,js,u); /* Fehlermeldung */
              c4 += 1; /* Fehler vom Typ 4 zaehlen */
              i += 1; /* Fehler zaehlen */
              break wo0; /* naechstes Objekt bearbeiten */
            } /* Fehler wird NUR gemeldet -- Objekt weiterhin nutzbar */
            ((TSTrkObj)cUiD).setNdeP(cQPos); /* OK -- korrigierte Definition setzen */
          } /* -wo0- JNodePosn-Definition gueltig */
        } /* weitere Eintragstypen werden nicht geprueft */
        /* Referenz zu ViewSphere-Definition pruefen */
        if(!cUiD.chkMsk(25)) /* VDbId-Definition ist vorhanden */
         if((cVS=cUiD.chgView(null))!=null) { /* Explizite ViewSphere-Referenz -- bearbeiten */
          /* Achtung: Falls das Objekt aus dem Quadranten geschoben wurde, ist KEINE
           * gueltige explizite Referenz mehr vorhanden. */
          cVS.incCnt(-1); /* Zaehler anpassen fuer ORIGINAL-Viewsphere */
          cVS = cVS.crVS(null,dx,dy,dz); /* Kopie der Viewsphere(-Kette) erzeugen und verschieben */
            /* 'cVS' (again) becomes address of basis-element of (the) new viewsphere-chain */
          if(cVS==null) cUiD.clrView(cUiD.getVNrDef()); /* neue Position ist ausserhalb des Quadranten */
            /* Viewsphere-Referenz loeschen und durch 'default' ersetzen */
          else { /* neue Definition integrieren */
            /* 1. Basiselemente zusammenfuehren */
            if(nVS==null) nVS = cVS; /* NEW viewsphere-chain was build -- establish it */
            if(nVS!=cVS) { /* two DIFFERENT viewsphere-chains NOT allowed -- Systemerror */
              Lg.Skip(true); /* Leerzeile loggen */
              Lg.Msg("mveObjV1","World"); /* Fehlermeldung: Systemfehler */
              Lg.Close(); /* close output to Log-file */
              return 25; /* terminate function with errorcode */
            } /* Systemfehler -- Programm abbrechen */
            /* 2. aktuelles TSView-Element anbinden */
            cVS = (TSView)RetVal; /* oberstes Element ist zutreffendes */
            cVS.incCnt(1); /* Zaehler anpassen */
            cUiD.chgView(cVS); /* neue Definition aktivieren */
          } /* neue Definition passt und muss eingesetzt werden */
        } /* Explizite Viewsphere-Referenz musste bearbeitet werden */
      } /* alle UiD-Elemente bearbeiten */

      if(wUiD!=null) /* Vorrangehender UiD-Steuereintrag wurde bereits erkannt */
       if(!ctl1) { /* Seitdem folgen KEINE gueltigen Eintraege -- Steuereintrag weg */
        cC = cQDf.chgWTab(null,0);  /* aktuelle Verkettung der World-Elemente holen */
        if((is=cC.remove(wUiD))!=null) { /* Fehler beim Entfernen des Elementes */
          Lg.Err("mveObjU3",is,js,-1); /* Fehlermeldung */
          i += 1; /* Fehler zaehlen */
        } /* Element konnte nicht korrekt entfernt werden */
      } /* Vorrangehender Steuereintrag entfernt */

      /* Quadranten 2. Teil: Sound-Dateien */
      js = cQDf.getInf(4); /* Namen der Sound-Datei */
      if(js!=null) { /* Sound-Datei vorhanden -- bearbeiten */
        for(cSnd=cQDf.getSnd(true);cSnd!=null;cSnd=cQDf.getSnd(false)) {
          /* nicht belegte Sound-Eintraege gibt es nicht */
          if(cSnd.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
          if(cSnd.isOpt(31)) continue; /* Eintrag wurde bereits bearbeitet */
          if(tro & !cSnd.isOpt(7)) continue; /* move not requested */
          cSnd.setOpt(31); /* Eintrag als bearbeitet kennzeichnen */
            /* Wenn dieser Eintrag in einen anderen Quadranten verschoben wird, der noch
             * nicht bearbeitet wurde, kann es sein, dass er NOCH EINMAL verschoben
             * werden soll. Das wird hiermit verhindert.
             */
          u = cSnd.getUiD(0); /* Original UID fuer Fehlermeldungen merken */
          cPos = cSnd.crPos(); /* Kopie der Positionsdefinition holen */
          if(cPos==null) { /* Positionsdefinition nicht gueltig */
            Lg.Err("mveObjS1",js,u); /* Fehlermeldung */
            c5 += 1; /* Fehler vom Typ 5 zaehlen */
            i += 1; /* Fehler zaehlen */
            continue; /* naechstes Objekt bearbeiten */
          } /* Positionsdefinition nicht gueltig */
          qx = cPos.addPosX(dx); /* X-Position anpassen */
          cPos.addPosY(dy); /* Hoehe anpassen -- Kein Korrekturwert */
          qz = cPos.addPosZ(dz); /* Z-Position anpassen */
          if(qx!=0 || qz!=0) { /* neuer Quadrant betroffen */
            nQDf = cQDf.fndQuad(cRte,qx,qz); /* passenden Quadranten suchen */
            if(nQDf==null) { /* Ziel-Quadranten nicht gefunden -- Abbruch */
              /* Achtung: Wenn ein Quadrant fuer eine SOUND-Datei fehlt, wird auch
               * eine neue (leere) World-Datei erzeugt.
               */
              if(!Fo.chkMsk(1)) { /* Ziel-Quadrand NICHT erzeugen */
                Lg.Err("mveObjS2",cQDf.getMsg(1,null,qx,qz),js,u); /* Fehlermeldung ausgeben */
                c4 += 1; /* Fehler vom Typ 4 zaehlen */
                i += 1; /* Fehler zaehlen */
                continue; /* naechstes Objekt bearbeiten */
              } /* Ziel-Quadrand soll erzeugt werden */
              newTile = true; /* kennzeichnen: neue Tile-Definition wird erzeugt */
              nQDf = new TSQuad(cQDf,qx,qz); /* neuer Quadrand und Tile erstellen */
              cTle = nQDf.chgTle(null); /* Zugeordnete Tile-Definition holen */
              nQDf.chgMde(TSFile.OCB); /* set output-mode of world-file to CB */
              if(!Tle.add(cTle)) { /* Tile-Definition in globale Kette einfuegen */
                Lg.Skip(true); /* Leerzeile loggen wegen SYSTEMFEHLER */
                Lg.Msg("MsgC58",cTle.getId(true),cTle.getNme(0)); /* Fehlermeldung */
                Lg.Close(); /* close output to Log-file */
                return 6; /* terminate function with errorcode */
              } /* NEUE Tile-Definition nicht einfuegbar -- bereits vorhanden */
              if(!QDf.add(nQDf)) { /* Strukturquadrat in globale Kette einfuegen */
                Lg.Skip(true); /* Leerzeile loggen wegen SYSTEMFEHLER */
                Lg.Msg("MsgC31",nQDf.getInf(0)); /* Fehlermeldung ausgeben */
                Lg.Close(); /* close output to Log-file */
                return 7; /* terminate function with errorcode */
              } /* NEUES Strukturquadrat nicht einfuegbar -- bereits vorhanden */
              is = cTle.crTle(tdir,dy); /* Tile-Daten erzeugen */
              if(is!=null) { /* Fehler beim Schreiben der Tile-Daten erhalten */
                Lg.Skip(true); /* Leerzeile loggen wegen SYSTEMFEHLER */
                Lg.Msg("Msg010",is); /* Fehlermeldung ausgeben */
                Lg.Close(); /* close output to Log-file */
                return 8; /* terminate function with errorcode */
              } /* Tile-Daten nicht vollstaendig/korrekt geschrieben */
              if(nQDf.setNme(true)) Lg.Log("mveObjU4",nQDf.getInf(0),cSnd.getName(true),u);
            } /* Ziel-Quadranten nicht gefunden */
            cC = cQDf.chgSTab(null,0);  /* aktuelle Verkettung der Sound-Elemente holen */
            if((is=cC.remove(cSnd))!=null) { /* Fehler beim Entfernen des Elementes */
              Lg.Err("mveObjS3",is,js,u); /* Fehlermeldung */
              i += 1; /* Fehler zaehlen */
              continue; /* naechstes Objekt bearbeiten */
            } /* Element konnte nicht korrekt entfernt werden */
            if((cC=nQDf.chgSTab(null,0))==null) { /* NOCH keine Sound-Datei vorhanden */
              if(nQDf.setNme(false)) Lg.Log("mveObjS4",nQDf.getInf(0),cSnd.getName(true),u);
              cC = new TSChain(); /* neue, leere Objekt-Kette erzeugen */
              nQDf.chgSTab(cC,0); /* und in Quadranten eintragen */
            } /* Objektkette fuer Sound-Objekte musste erzeugt werden */
            cSnd.$reNew(nQDf.getOId(),nQDf.getSId()); /* Eindeutige Daten neu setzen */
            cSnd.setPos(cPos); /* neuer Positionswert einsetzen (modifizierte Kopie) */
            cC.add(cSnd); /* Sound-Eintrag sortiert neu hinzufuegen und speichern */
            /* KEINE weitere Objekt-typische Bearbeitung notwendig (TSPos-Werte) */
            if(!cSnd.chkMsk(25)) /* VDbId-Definition ist vorhanden */
             if((cVS=cSnd.chgView(null))!=null) { /* Explizite ViewSphere-Referenz -- bearbeiten */
              cVS.incCnt(-1); /* Zaehler anpassen */
              cSnd.clrView(cSnd.getVNrDef()); /* Viewsphere-Referenz loeschen und durch 'default' ers. */
            } /* Explizite Viewsphere-Referenz musste bearbeitet werden */
          } else cSnd.setPos(cPos); /* kein neuer Q. -- neuen Positionswert fixieren */
          /* KEINE weitere Objekt-typische Bearbeitung notwendig (TSQPos-Werte) */
          /* Referenz zu ViewSphere-Definition pruefen */
          if(!cSnd.chkMsk(25)) /* VDbId-Definition ist vorhanden */
           if((cVS=cSnd.chgView(null))!=null) { /* Explizite ViewSphere-Referenz -- bearbeiten */
            cVS.incCnt(-1); /* Zaehler anpassen fuer ORIGINAL-Viewsphere */
            cVS = cVS.crVS(null,dx,dy,dz); /* Kopie der Viewsphere erzeugen und verschieben */
              /* 'cVS' (again) becomes address of basis-element of (the) new viewsphere-chain */
            if(cVS==null) cSnd.clrView(cSnd.getVNrDef()); /* neue Position ist ausserhalb des Quad */
              /* Viewsphere-Referenz loeschen und durch 'default' ersetzen */
            else { /* neue Definition integrieren */
              /* 1. Basiselemente zusammenfuehren */
              if(nVS==null) nVS = cVS; /* NEW viewsphere-chain was build -- establish it */
              if(nVS!=cVS) { /* two DIFFERENT viewsphere-chains NOT allowed -- Systemerror */
                Lg.Skip(true); /* Leerzeile loggen */
                Lg.Msg("mveObjV1","Sound"); /* Fehlermeldung: Systemfehler */
                Lg.Close(); /* close output to Log-file */
                return 25; /* terminate function with errorcode */
              } /* Systemfehler -- Programm abbrechen */
              /* 2. aktuelles TSView-Element anbinden */
              cVS = (TSView)RetVal; /* oberstes Element ist zutreffendes */
              cVS.incCnt(1); /* Zaehler anpassen */
              cSnd.chgView(cVS); /* neue Definition aktivieren */
            } /* neue Definition passt und muss eingesetzt werden */
          } /* Explizite Viewsphere-Referenz musste bearbeitet werden */
        } /* alle Sound-Elemente bearbeiten */
      } /* Sound-Eintraege waren vorhanden (Sound-Datei) */

      /* Quadranten 3. Teil: ViewSphere-Eintraege anpassen */
      if((m=cQDf.chg$View(-1))>0) { /* ViewSphere-Eintraege vorhanden ?
        * NUR wenn in dem unverschobenen Quadrant Viewsphere-Eintraege existierten,
        * koennen neue, veschobene Eintraege erzeugt worden sein.
        */
        cVS = cQDf.chgView(null); /* Aktuelle/alte TSView-Kette holen */
        ETab = Fo.getQue(0); /* Tabelle fuer Fehlermeldungen holen */
        if(cVS.clrView(ETab)) { /* gueltige Viewsphere-Definitionen weiterhin vorhanden */
          /* if 'nVS==null' NO valid new viewsphere-chain of new objects was created */
          if(nVS!=null) { /* weiterer Teil von Viewsphere-Definitionen vorhanden -- mischen */
            cVS = new TSView(nVS); /* create another new viewsphere-entry on top of the */
            cVS.addVS(nVS); /* new chain and connect the chain as a chaild. */
            nVS = cQDf.chgView(cVS); /* Set this new viewchain into quad, get old one */
            cVS.addVS(nVS); /* insert old viewchain as another child into head of new chain */
            /* merge Position and Radius of the two 'old' topmost elements */
            if(cVS.mrgVal(nVS)!=null) { /* Positionen mischen und Radius veraendern */
//Fehlermeldung
            } /* Fehlerbearbeitung beim Mischen Viewsphere */
          } /* ViewShere-chains have been connected */
        } else cQDf.chgView(cVS=nVS); /* Neue Basis setzen, NUR neue Kette */
        /* 'cVS' kann 'null' sein, wenn keine neue ViewSphere-Kette angelegt wurde und ALLE
         * Elemente der alten Kette nicht mehr verwendet werden.
         */
        if(cVS!=null) j = cVS.renID(0); /* ALLE Viewsphere-Definitionen neu numerieren */
        else j = 0; /* KEINE ViewShere-Definitionen mehr vorhanden */
        cQDf.chg$View(j); /* neuen Wert fuer 'gueltige Anzahl' einsetzen */
        for(j=0;j<ETab.size();j+=1) Lg.Err("Msg010",ETab.get(j)); /* Meldung ausgeben */
        ETab.clear(); /* Alle Meldungen loeschen */
      } /* TSView-Definitionen waren vorhanden */
    } /* alle Quad-Definitionen bearbeiten */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mveObjC4",cRte.getInfo(1)); /* Aktionsmeldung */
    /* Schienen-/Strassendatenbank bearbeiten */
    for(j=0;j<2;j+=1) { /* alle Datenbanken pruefen */
      if(ird & j==1) continue; /* Strassendatenbank nicht betroffen */
      aI = cRte.getIt(j); /* Iterator fuer TrackNode-Definitionen */
      if(aI==null) continue; /* TrackNode-Tabelle nicht vorhanden */
        /* Situation ist erlaubt -- kein Fehler */
      is = "mveObj" + j; /* Schienen-DB / Strassen-DB */
      while(aI.hasNext()) { /* Weitere Definitionen vorhanden */
        if((cTrN=aI.next())==null) continue; /* Fehl-Eintrag uebergehen */
        if(cTrN.chkMsk(22)) { /* Node fehlerhaft definiert ('Option 22') */
          v = cTrN.getNr(true); /* aktuelle Node-Kennung holen */
          Lg.Err(is+"1",v); /* Fehlermeldung ausgeben */
          i += 1; /* Fehler zaehlen */
          continue; /* DB-Element nicht weiter bearbeiten */
        } /* Node-Definition ist fehlerhaft */
        m = cTrN.get$Nde(); /* Anzahl der verbundenen Node-Eintraege */
        for(v=0;v<m;v+=1) { /* alle Nodes bearbeiten (TSVector) */
          cNde = cTrN.chgNde(v,null); /* aktuell verkettetes Element */
            /* 'cNde' kann nicht 'null' sein, da sonst 'Option 22' gesetzt ist. */
          cQPos = cNde.crPos(); /* Aktuelle Positionsdefinition holen */
          if(cQPos==null) { /* Positionsdefinition nicht verfuegbar */
            Lg.Err(is+"2",null,cTrN.getNr(true),v); /* Fehlermeldung ausgeben */
            c5 += 1; /* Fehler vom Typ 5 zaehlen */
            i += 1; /* Fehler zaehlen */
            continue; /* naechstes Objekt bearbeiten */
          } /* Positionsdefinition nicht gueltig */
          if((js=cQPos.addPos(cRte,dx,dy,dz))!=null) { /* Fehler aufgetreten */
            Lg.Err(is+"3",js,cTrN.getNr(true),v); /* Fehlermeldung ausgeben */
            c3 += 1; /* Fehler vom Typ 3 zaehlen */
            i += 1; /* Fehler zaehlen */
            continue; /* naechstes Objekt bearbeiten */
          } /* Fehler beim Justieren aufgetreten */
          cNde.setPos(cQPos); /* neuer Positionswert einsetzen (modifizierte Kopie) */
        } /* alle verketteten Nodes bearbeiten */
      } /* alle DB-Elemente bearbeiten */
    } /* alle Datenbanken bearbeiten */
    /* Schienen-/Strassendatenbank zum zweiten (TrItems) */
    for(j=0;j<2;j+=1) { /* alle Datenbanken pruefen */
      if(ird & j==1) continue; /* Strassendatenbank nicht betroffen */
      cI = cRte.getIt(2+j); /* Iterator auf TrItem-Tabelle holen */
      if(cI==null) continue; /* DB nicht vorhanden */
      is = "mveObj" + j; /* Schienen-DB / Strassen-DB */
      while(cI.hasNext()) { /* alle TrItem-Definitionen bearbeiten */
        cIt = (TSTrItm)cI.next(); /* naechste TrItem-Definition */
        if(cIt==null) throw new IllegalStateException( /* Sicherheitsabfrage */
          TSLogg.getMsg("Msg908","TSTrItem==null","mveObj",0));
        if(cIt.chkMsk(19)) { /* Positionsdefinition 'TrItemRData' ist vorhanden */
          cQPos = cIt.crPos(0); /* Aktuelle Positionsdefinition holen ('TrItemRData') */
          if(cQPos==null) { /* Positionsdefinition nicht verfuegbar */
            Lg.Err(is+"4",null,"TrItemRData",cIt.getNr(true)); /* Fehlermeldung ausgeben */
            c5 += 1; /* Fehler vom Typ 5 zaehlen */
            i += 1; /* Fehler zaehlen */
            continue; /* naechstes Objekt bearbeiten */
          } /* Positionsdefinition nicht gueltig */
          if((js=cQPos.addPos(cRte,dx,dy,dz))!=null) { /* Fehler aufgetreten */
            Lg.Err(is+"5",js,"TrItemRData",cIt.getNr(true)); /* Fehlermeldung ausgeben */
            c3 += 1; /* Fehler vom Typ 3 zaehlen */
            i += 1; /* Fehler zaehlen */
            continue; /* naechstes Objekt bearbeiten */
          } /* Fehler beim Justieren aufgetreten */
          cIt.setPos(0,cQPos); /* neuer Positionswert einsetzen (modifizierte Kopie) */
        } /* Positionsdefinition vorhanden */
        if(cIt.chkMsk(18)) { /* Positionsdefinition 'TrItemPData' ist vorhanden */
          cQPos = cIt.crPos(1); /* Aktuelle Positionsdefinition holen ('TrItemPData') */
          if(cQPos==null) { /* Positionsdefinition nicht verfuegbar */
            Lg.Err(is+"4",null,"TrItemPData",cIt.getNr(true)); /* Fehlermeldung ausgeben */
            c5 += 1; /* Fehler vom Typ 5 zaehlen */
            i += 1; /* Fehler zaehlen */
            continue; /* naechstes Objekt bearbeiten */
          } /* Positionsdefinition nicht gueltig */
          if((js=cQPos.addPos(cRte,dx,0.0,dz))!=null) { /* Fehler aufgetreten */
            Lg.Err(is+"5",js,"TrItemPData",cIt.getNr(true)); /* Fehlermeldung ausgeben */
            c3 += 1; /* Fehler vom Typ 3 zaehlen */
            i += 1; /* Fehler zaehlen */
          } /* Fehler beim Justieren aufgetreten */
          cIt.setPos(1,cQPos); /* neuer Positionswert einsetzen (modifizierte Kopie) */
        } /* Positionsdefinition vorhanden */
        if(cIt instanceof TSTrItm01) { /* SignalItem liegt vor -- Position anpassen */
          TrItD = ((TSTrItm01)cIt).getSgD(0); /* Referenztabelle holen */
          if(cIt.chkMsk(22)) /* Signal-Units sind definiert/gueltig */
           for(k=0;k<TrItD.size();k+=1) { /* alle Signal-Units bearb. */
            cTrItD = TrItD.get(k); /* aktuelles 'TrSignalDir'-Eintrag holen */
            if(cTrItD==null) continue; /* nicht belegt -- nicht bearbeiten */
            cQPos = cTrItD.crPos(); /* Aktuelle Positionsdefinition holen */
            if(cQPos==null) { /* Positionsdefinition nicht verfuegbar */
              Lg.Err(is+"A",null,cIt.getNr(true),k); /* Fehlermeldung ausgeben */
              c5 += 1; /* Fehler vom Typ 5 zaehlen */
              i += 1; /* Fehler zaehlen */
              continue; /* naechstes Objekt bearbeiten */
            } /* Positionsdefinition nicht gueltig */
            if((js=cQPos.addPos(cRte,dx,dy,dz))!=null) { /* Fehler aufgetreten */
              Lg.Err(is+"B",js,cIt.getNr(true),k); /* Fehlermeldung ausgeben */
              c3 += 1; /* Fehler vom Typ 3 zaehlen */
              i += 1; /* Fehler zaehlen */
              continue; /* naechstes Objekt bearbeiten */
            } /* Fehler beim Justieren aufgetreten */
            cTrItD.setPos(cQPos); /* neuer Positionswert einsetzen (modifizierte Kopie) */
          } /* ALLE TrSignalDir-Eintraege bearbeiten */
        } /* SignalItem bearbeiten */
      } /* alle DB-Elemente bearbeiten */
    } /* alle Datenbanken bearbeiten */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mveObjC5",cRte.getInfo(1)); /* Aktionsmeldung */
    /* Path-Definitionen anpassen (notwendig fuer NICHT-Junction) */
    cI = cRte.getIt(17); /* Liste der Pfad-Definitionen holen */
    v = 0; /* Laufende Nr. initialisieren */
    while(cI.hasNext()) { /* Weitere Pfad-Definition vorhanden */
      cPth = (TSPath)cI.next(); /* Pfad-Eintrag holen */
      if(cPth==null) throw new IllegalStateException( /* Sicherheitsabfrage */
        TSLogg.getMsg("Msg908","TSPath==null","mveObj",0));
      v += 1; /* Eintrag zaehlen */
      if(!cPth.chkMsk(1)) continue; /* KEINE gueltigen PDP-Definitionen vorhanden */
      pI = cPth.getPDP(0).iterator(); /* Alle Tabellenelemente bearbeiten */
        /* Tabelle ist auf jeden Fall vorhanden (chkMsk) */
      j = -1; /* Zaehler initialisieren */
      while(pI.hasNext()) { /* Weitere PDP-Definition vorhanden */
        cPDP = pI.next(); /* aktueller PDP-Eintrag holen */
        if(cPDP==null) continue; /* do not process invalid/unused entries */
        j += 1; /* Definition gueltig -- zaehlen */
        cQPos = cPDP.crPos(); /* Aktuelle Positionsdefinition holen */
        if(cQPos==null) { /* Positionsdefinition nicht verfuegbar */
          Lg.Err("mveObj21",null,v,j); /* Fehlermeldung ausgeben */
          c5 += 1; /* Fehler vom Typ 5 zaehlen */
          i += 1; /* Fehler zaehlen */
          continue; /* naechstes Objekt bearbeiten */
        } /* Positionsdefinition nicht gueltig */
        if((js=cQPos.addPos(cRte,dx,dy,dz))!=null) { /* Fehler aufgetreten */
          Lg.Err("mveObj22",js,v,j); /* Fehlermeldung ausgeben */
          c2 += 1; /* Fehler vom Typ 2 zaehlen */
          i += 1; /* Fehler zaehlen */
          continue; /* naechstes Objekt bearbeiten */
        } /* Fehler beim Justieren aufgetreten */
        cPDP.setPos(cQPos); /* neuer Positionswert einsetzen (modifizierte Kopie) */
      } /* -while- alle PDP-Definitionen bearbeiten */
    } /* -while- alle Pfad-Definitionen bearbeiten */

    /* Verschiebungsstatistik ausgeben */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mveObjCA",i); /* Meldung erstellen */
    if(i>0) { /* Fehler wurden gefunden -- genauer spezifizieren */
      Lg.Msg("mveObjCB",c5); /* Meldung erstellen */
      Lg.Msg("mveObjCC",c4); /* Meldung erstellen */
      Lg.Msg("mveObjCD",c3); /* Meldung erstellen */
      Lg.Msg("mveObjCE",c2); /* Meldung erstellen */
      if(!Fo.chkMsk(4)) { /* Fehlerabbruch durchfuehren */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("mveObjCF"); /* Meldung erstellen */
        Lg.Close(); /* close output to Log-file */
        return 15; /* terminate function with errorcode */
    } } /* Fehler aufgetreten */

    /* ***** ab hier beginnen die Ausgaben ***** */
    /* Process basic file of route (.trk) */
    i = putRte(cRte,null); /* rewrite route-definition */
    if(i>0) return i; /* error found while writing */

    /* "world"-Dateien bearbeiten und modifizieren */
    i = putWF(cRte,null,false,false); /* World-Dateien modifiziert schreiben */
    if(i>0) return i; /* Fehler beim Schreiben -- Ende */
    /* Sound-Dateien bearbeiten und modifizieren */
    i = putSF(cRte,null,false); /* Sound-Dateien modifiziert schreiben */
    if(i>0) return i; /* Fehler beim Schreiben -- Ende */

    /* Schienendatenbank bearbeiten */
    i = putDBF(cRte,null,0); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    /* Schienendatenbank (.tit) bearbeiten */
    i = putITF(cRte,null,0,false); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      /* Strassendatenbank bearbeiten */
      i = putDBF(cRte,null,1); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */

      /* Strassendatenbank (.rit) bearbeiten */
      i = putITF(cRte,null,1,false); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */
    } /* Strassendatenbank vorhanden und geladen */

    /* neue Struktur der besiedelten Quadrate erzeugen und ausgeben */
    if(newTile) { /* neue Tiles wurden erzeugt -- TD schreiben */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("mveObjC8"); /* Aktionsmeldung */

      i = putTDF(cRte,null,0); /* Terrain-Datei (HI) erzeugen */
      if(i>0) return i; /* Fehler beim Schreiben */
      if(tdl) { /* Lo-Tiles existieren */
        i = putTDF(cRte,null,1); /* Terrain-Datei (LO) erzeugen */
        if(i>0) return i; /* Fehler beim Schreiben */
      } /* Lo-Tiles sind vorhanden */
    } /* Dateien wurden ggf erzeugt */

    /* Path-Definitionen werden neu erstellt */
    i = putPatF(cRte,null,1); /* Path-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */

    if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("mveObjC9"); /* Abschlussmeldung ausgeben */

    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Method "wFile" [28]
  * Manage world-files of a route
  *  - 'split' world-files so that 'route-editor' can handle them
  *  - 'merge' world-files from various sources
  * Options:
  *       1 - 'split' world-files (-s)
  *       2 - 'merge' world-files (-m)
  *       3 - compress output-files in any case (-c)
  *       4 - DO NOT compress output-files (-u)
  *      16 - extended output to log-file (-d,Hidden)
  *      17 - overwrite target-files directly (-inplace,Hidden)
  * Attention: option 3 and 4 do not apply to the INTERMEDIATE
  *            world-files.
  * ##wFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int wFile( /* manage world-files */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute           cRte; /* current route-definition (Basis) */
    File              dat,dir; /* files used for input/output */
    TreeSet<TSQuad>   QDf;  /* list of all quad-definitions */
    Iterator<TSQuad>  cI;   /* common used iterator (TSQuad) */
    TSOpts            cM;   /* current mask of 'StaticDetailLevel' */
    TSQuad            cQDf; /* current quad-definition */
    TSChain           cC;   /* current UID-chain within world */
    TSChain           nC;   /* new UID-chain within world */
    TSView            cVS,nVS; /* ViewSphere-Elements */
    TSUiD             cUiD; /* UiD-Elements */
    TSQDef            aQDf; /* current quad-basis */
    int               oid,uid; /* intermediate id-values of entries */
    int               i,j,c,cm;  /* intermediate definitions */
    String            is,js; /* intermediate definitions */
    ArrayList<String> ETab; /* temporary list of error-messages (VS) */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file if possible */
    prStart("WrdFle01",fn); /* and print header */

    /* get system-file (.trk) and check it */
    i = Fo.chkMsk(17) ? 1 : 3; /* create flag if 'newroute' requested */
    if(Fo.chkMsk(1)) i = 3; /* newroute/world IS requested */
    cRte = getRte(fn,i); /* check route-definition */
    if(cRte==null) return 5; /* error -- terminate function */

    /* print current paths */
    Lg.Msg("MsgC01",cRte.getInfo(2)); /* print route-name */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* print system-path */
    Lg.Msg("MsgC03",cRte.getInfo(1)); /* print route-path */
    Lg.Skip(true); /* and add empty line */

    /* get global "tsection.dat" and process it */
    Lg.Skip(false); /* print empty line to screen */
    Lg.Msg("MsgC05"); /* print description of next action */

    dat = cRte.getFile(-1); /* get reference to file */
    i = getTS(dat,null);    /* and load 'tsection.dat' (global) */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* error occurred while loading 'tsection.dat' */
      Lg.Skip(true); /* print empty line to screen and log-file */
      Lg.Msg("MsgC08",i); /* print errormessage: terminating */
      Lg.Close(); /* stop output to log-file and close it */
      return 15; /* terminate function completely */
    } /* severe error occurred */

    Lg.Log("MsgC11",c3);  /* print result */
    Lg.Log("MsgC14",ScN); /* print result */
    Lg.Log("MsgC17",c2);  /* print result */
    Lg.Log("MsgC20",ShN); /* print result */
    Lg.Log("MsgC23",c4);  /* print result */

    /* process local "tsection.dat" */
    i = getTSL(cRte,ScA,ShA); /* load local 'tsection.dat' */
    if(i>0) return i; /* error occurred -- terminate */

    /* load additional files of the route */
    i = getType(cRte); /* load 'ttype.dat' into memory */
    if(i>0) return i; /* error occurred -- terminate */

    /* get current structure of quads (load definitions) */
    i = getTDF(cRte,0); /* get control-file of tiles */
    if(i!=0) { /* error while loading tiles (Hi) */
      Lg.Skip(true); /* print empty line to screen and log-file */
      Lg.Msg("MsgC26",i); /* print errormessage: terminating */
      Lg.Close(); /* stop output to log-file and close it */
      return 15; /* terminate function completely */
    } /* severe error occurred */

    /* get current structure of quads (LO-Tiles) */
    i = getTDF(cRte,1); /* get control-file of tiles */
    if(i>0) { /* error while loading tiles (Lo) */
      Lg.Skip(true); /* print empty line to screen and log-file */
      Lg.Msg("MsgC27",i); /* print errormessage: terminating */
      Lg.Close(); /* stop output to log-file and close it */
      return 15; /* terminate function completely */
    } /* severe error occurred */

    /* load trackdatabase of route */
    i = getDBF(cRte,0); /* load trackdatabase and check it syntactically */
    if(i>0) return i; /* error occurred -- terminate */
    i = getITF(cRte,0); /* add second part of database and check it */
    if(i>0) return i; /* error occurred -- terminate */

    /* load roaddatabase of route */
    i = getDBF(cRte,1); /* load roaddatabase and check it syntactically */
    if(i>0) return i; /* error occurred -- terminate */
    if(i==0) { /* roaddatabase exits (not required) */
      i = getITF(cRte,1); /* add second part of database and check it */
      if(i>0) return i; /* error occurred -- terminate */
    } /* roaddatabase exits (not required) */

    /* load world-files and check them syntactically */
    i = getWF(cRte,false); /* load world-files */
    if(i>0) return i; /* error occurred -- terminate */
    /* load sound-files and check them syntactically */
    i = getSF(cRte,false); /* load sound-files */
    if(i>0) return i; /* error occurred -- terminate */

    /* check signal-definitions (load and check) */
    i = getSCfg(cRte,cRte.getFile(21),null,false); /* load Signal-Configurations */
    if(i==0) /* load was successful -- continue */
      i = getSScr(cRte,cRte); /* load signal-script-definitions */


    /* all files were loaded -- continue with integrity-check */
    if((is=cRte.chkRte(Fo,true))!=null) { /* check route for integrity -- error found ? */
      if(is.charAt(0)!=' ') { /* error-message returned */
        Lg.Skip(true); /* skip line */
        Lg.Err("WrdFle02",is); /* print errormessage */
        Lg.Msg("MsgC60"); /* print message: 'terminating' */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* error found -- function terminated */
      if(EnaW) Lg.Log("chkRte00",is); /* Warning found -- print it */
    } /* error/warning found */

    /* process "world"-files and create integrity between definitions */
//    i = 4; /* DO NOT modify I/O-mode (IO_app=4 is marker) */
//    if(Fo.chkMsk(3)) i = TSFile.OCB; /* set output-mode: binary, compressed */
//    if(Fo.chkMsk(4)) i = TSFile.OUT; /* set output-mode: text, expanded */
//    i += 128; /* activate 'report changes' */
    chkWrld(cRte,null,132); /* world-files are checked (extended): (128+4) */
      /* mode is: report changes, no Renum */

    /* process "sound"-files and create integrity between definitions */
    i = chkSnd(cRte,null,128); /* sound-files are checked (extended): */
      /* mode is: report changes */
    Lg.Skip(false); /* print empty line to screen */
    Lg.Log("MsgC33",i); /* report result worldfile-check */
    Lg.Skip(false); /* print annother empty line to screen */

    Lg.Skip(true); /* print empty line to screen and log-file */
    Lg.Msg("MsgC70"); /* print description of next action */
    if(cRte.get$TrN(0)<0) { /* trackdatabase was NOT found */
      Lg.Skip(true); /* print empty line to screen and log-file */
      Lg.Msg("MsgC36"); /* print message: 'terminating' */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function completely */
    } /* trackdatabase was NOT found */

    i = chkDBTab(cRte,0); /* process trackdatabase */
    if(i<0) return 5; /* systemerror occurred -- terminate */

    Lg.Skip(false); /* print empty line to screen */
    Lg.Msg("MsgC71"); /* print description of next action */
    Lg.Msg("MsgC38",i); /* report result of integrity-check */
    Lg.Skip(false); /* print annother empty line to screen */

    if(cRte.get$TrN(1)>0) { /* roaddatabase exists and is loaded */
      /* 'get$TrN()' gets current 'number of tracknodes' */
      Lg.Skip(true); /* print empty line to screen and log-file */
      Lg.Msg("MsgC72"); /* print description of next action */
      i = chkDBTab(cRte,1); /* process roaddatabase */
      if(i<0) return 5; /* systemerror occurred -- terminate */

      Lg.Skip(false); /* print empty line to screen */
      Lg.Msg("MsgC73"); /* print description of next action */
      Lg.Msg("MsgC38",i); /* report result of integrity-check */
      Lg.Skip(false); /* print annother empty line to screen */
    } /* roaddatabase exists and was loaded */

    /* extended check of local 'tsection.dat'
     * Attention: This method MUST NOT be invoked unless worldfiles AND
     * database (track/road) is stored again (or neither). */
//    chkTSL(cRte,ScN,ShN); /* check file and compact it */

    /* FULL check of route is complete -- execute function */
    QDf = cRte.chgQDf(null); /* get list of all Quad-definiitons */
    if(QDf==null) throw new IllegalStateException( /* integrity OK? */
      TSLogg.getMsg("Msg908","TreeSet<TSQuad>==null","world",0));

    cI = QDf.iterator(); /* create iterator of Quad-definitions */
    c = cm = 0; /* init file-counter of world-files */
    Lg.Skip(true); /* print empty line to screen and log-file */
    if(Fo.chkMsk(1)) { /* 'split'-function requested -- do it */
      cM = Fo.getOpt(5,0); /* get mask of suppressed 'StaticDetailLevel' */
      js = Fo.getDta(5,1); /* get file-suffix of additional world-files */
      Lg.Msg("WrdFle05"); /* print description of next action */
      aQDf = new TSQDef(); /* create world-basis of temporary files */
      aQDf.chgMde(TSFile.OUT); /* set current I/O-Mode of world-files (UT) */
      while(cI.hasNext()) { /* more definitions available ? */
        cQDf = cI.next(); /* get next quad-definition */
        if((cC=cQDf.chgWTab(null,0))==null) continue; /* no world-file -- skip it */
        if(cC.size()==0) continue; /* no elements exist -- skip file */
        c += 1; /* count world-file */
        dat = cRte.getFile(10,cQDf.getInf(2)); /* create complete reference to file */
        Lg.Log("MsgC54",dat.getAbsolutePath(),DF4.format(c)); /* Meldung ausgeben */

        nC = new TSChain(); /* create empty object-chain for new objects */
        nVS = null; /* a copy of the parent viewsphere does not exist (Basis) */
        oid = uid = 0; /* init new id's */
        j = 0; /* initialize counter of objects */
        for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
          if(cUiD.isOpt(0)) continue; /* do not process dummy-entry */
          if(cUiD.isCtl()) continue; /* do not process control-entry */
          if(cUiD.isOpt(7)) continue; /* track-entry -- do not remove */
          if(cUiD.chkSL(cM)) continue; /* do not include level */
          if((is=cC.remove(cUiD))!=null) { /* error removing the definition */
            Lg.Err("WrdFle11",is); /* print errormessage */
            continue; /* process next definition */
          } /* definition could not be removed correctly */
          j += 1; /* count moved object */
          cUiD.$reNew(oid++,uid++); /* reinitialize with dummy-values */
          nC.add(cUiD); /* add world-entry to new chain */
          cUiD.chgQDf(aQDf); /* insert back-reference to new quad-basis-definition */
          if(!cUiD.chkMsk(25)) /* VDbId-reference is active */
           if((cVS=cUiD.chgView(null))!=null) { /* explicit ViewSphere-Reference */
            cVS.incCnt(-1); /* decrement counter -  no more used from this definition */
            cVS = cVS.crVS(null,Double.NaN,0,0); /* create copy of the viewsphere-chain */
            if(nVS==null) nVS = cVS; /* set addresse of upper modified viewsphere */
            if(cVS==null || nVS!=cVS) { /* creation failed with systemerror */
              Lg.Skip(true); /* print empty line to screen and log-file */
              Lg.Msg("WrdFle12"); /* systemerror occurred -- terminate */
              Lg.Close(); /* close output to Log-file */
              return 25; /* terminate function completely */
            } /* systemerror occurred -- terminate program */
            /* insert new viewsphere into current world-object */
            cVS = (TSView)RetVal; /* get appropriate viewsphere-element */
            cVS.incCnt(1); /* increment counter -- viewspere is referenced */
            cUiD.chgView(cVS); /* activate new definition (insert it into world-object) */
          } /* explicite Viewsphere-Reference must be processed */
        } /* -for- process all world-entries */
        if(cQDf.chg$View(-1)>0) { /* original viewsphere-definitions present ? */
          cVS = cQDf.chgView(null); /* get current(old) TSView-chain */
          ETab = Fo.getQue(0); /* use this table to store error-messages */
          if(cVS.clrView(ETab)) i = cVS.renID(0); /* renumber Viewspheres if present */
            /* delete unused viewspheres; true: valid Viewsphere-Definitions are still present */
          else i = 0; /* NO MORE ViewShere-Definitions present */
          cQDf.chg$View(i); /* insert new number of 'valid' viewsphere-definitions */
          for(i=0;i<ETab.size();i+=1) Lg.Err("Msg010",ETab.get(i)); /* print message */
          ETab.clear(); /* and clear all messages afterwards */
        } /* TSView-Definitions were present within world-file */
        Lg.Log("WrdFle18",j); /* print statistical message */
        if(nC.size()<1) continue; /* no world-entries splitted -- do not write file */
        if(nVS!=null) i = nVS.renID(0); /* renumber NEW Viewspheres if present */
        else i = 0; /* NO NEW ViewShere-Definitions present */
        /* insert new data to basis-quad for writing */
        aQDf.chgWTab(nC,uid); /* set new UID-chain */
        aQDf.chg$View(i); /* set new number of ViewSphere-Entries */
        aQDf.chgView(nVS); /* set new TSView-chain (if present) */

        /* all new data is created -- write temporary world-file */
        is = cQDf.getInf(3); /* get name of world-file(target) */
        dat = cRte.getFile(40,is+js); /* and compute full path of target-file */
        Lg.Log("WrdFle19",dat.getName()); /* print filename-message */
        i = putWrld(dat,aQDf,true,false); /* write temporary world-file */
      } /* -while- process all quad-definitions */
    } /* function is fully processed -- continue */

    if(Fo.chkMsk(2)) { /* 'merge'-function requested -- do it */
//      cL = Fo.getQue(5); /* prefetch affected Queue */
      dir = cRte.getFile(40); /* get reference to input-directory */
      if(pFle!=null) dir = pFle; /* special directory specified -- use it */
      Lg.Msg("WrdFle06"); /* print description of next action */
      while(cI.hasNext()) { /* more definitions available ? */
        cQDf = cI.next(); /* get next quad-definition */
        nC = cQDf.chgWTab(null,0); /* get current UID-chain (target) */
        nVS = null; /* preset: no viewsphere-chain present */
        if(cQDf.chg$View(-1)>0) nVS = cQDf.chgView(null);
         /* original viewsphere-definitions present.-- get TSView-chain */
        c += 1; /* count world-file */
        dat = cRte.getFile(10,cQDf.getInf(2)); /* create complete reference to file */
        Lg.Log("MsgC54",dat.getAbsolutePath(),DF4.format(c)); /* Meldung ausgeben */

        /* read all external world-files and merge them */
        for(j=1,js=Fo.getDta(5,1);js!=null;js=Fo.getDta(5,++j)) {
          is = cQDf.getInf(2); /* get name of world-file(source) */
          dat = new File(dir,is+js); /* and compute full path of source-file */
          if(!dat.exists()) continue; /* file not present -- skip it */
          aQDf = new TSQDef(); /* create world-basis of input-file */
          i = getWrld(dat,aQDf,cRte,false); /* read worldfile and check it */
          if(i<0) continue; /* open-error -- do not process file */
          cm += 1; /* count world-file (merge) */
          cC = aQDf.chgWTab(null,0); /* get current UID-chain (source) */

          for(cUiD=aQDf.getUid(true);cUiD!=null;cUiD=aQDf.getUid(false)) {
            /* process ALL world-entries of the temporary files */
            if((is=cC.remove(cUiD))!=null) { /* error removing the definition */
              Lg.Err("WrdFle21",is); /* print errormessage */
              continue; /* process next definition */
            } /* definition could not be removed correctly */
            if(nC==null) { /* world-file is still not created */
              if(cQDf.setNme(true)) Lg.Log("WrdFle22",cQDf.getInf(0));
              nC = new TSChain(); /* create new empty object-chain */
              cQDf.chgWTab(nC,0); /* and insert it into quad-definition */
            } /* object-chain of new world-objects must be created */
            cUiD.$reNew(cQDf.getOId(),cQDf.getWId()); /* reinitialize for new chain */
            nC.add(cUiD); /* add world-entry to new chain */
            cUiD.chgQDf(cQDf); /* insert back-reference to correct quad-basis-definition */
            if(!cUiD.chkMsk(25)) /* VDbId-reference is active */
             if((cVS=cUiD.chgView(null))!=null) { /* explicit ViewSphere-Reference */
              nVS = cVS.conVS(nVS); /* connect Viewsphere-definition-chain */
              cVS = (TSView)RetVal; /* get appropriate viewsphere-element */
              cVS.incCnt(1); /* increment counter -- viewsphere is referenced */
              cUiD.chgView(cVS); /* activate new definition (insert it into world-object) */
            } /* explicite Viewsphere-Reference must be processed */
          } /* -for- process all world-entries */
        } /* -for- read all additional world-files */
        if(nVS!=null) { /* viewsphere-definitions present ? */
          i = nVS.renID(0); /* renumber Viewspheres */
          cQDf.chg$View(i); /* insert new number of viewsphere-definitions */
          cQDf.chgView(nVS); /* insert new viewsphere-chain (may be the same) */
        } else cQDf.chg$View(0); /* NO viewsphere-definitions available */
      } /* -while- process all quad-definitions */
    } /* function is fully processed -- continue */

    Lg.Skip(false); /* print empty line to log-file */
    /* ***** output of new route-definition starts here ***** */
    /* create temporary file if 'overwrite' is requested */
    dat = null; /* preset: 'overwrite' is NOT requested */
    if(Fo.chkMsk(17)) { /* 'overwrite' is requested -- create temp-file */
      try { dat = File.createTempFile("TSUtil",".tmp");
      } catch (IOException e) { /* temp-file could not be created */
       System.err.println(e.toString());  return 5;}
      dat.deleteOnExit(); /* delete file when function terminates */
    } /* 'overwrite' of route-files IS requested */

    /* write-back world-files, modified or unmodified, overwite if requested */
    i = putWF(cRte,dat,true,false); /* write back world-files */
      /* used mode: insert new UID-values */
    if(i>0) return i; /* error occurred while writing -- terminate function */

    if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */

    Lg.Skip(true); /* print empty line to screen and log-file */
    Lg.Msg("WrdFle09",c); /* print message: program successful */
    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* print timestamp */
    Lg.Close(); /* close output to Log-file */
    return 0; /* terminate function without error */
  }

 /**. <pre>
  *=====================================================================
  * Methode "FleCpy" (-29-)
  * Datendateien flexibel bearbeiten (compress,expand,reduce,uncomp)
  * Die Kombination der Optionen ist bereits geprueft.
  * Optionen:
  *       1 - requested action is 'Expand'   (e)
  *       2 - requested action is 'Reduce'   (r)
  *       3 - requested action is 'Compress' (c)
  *       4 - requested action is 'Inflate'  (i)
  *       5 - create target-directory if needed (o)
  *       6 - Datei-Maske im Windows-Style spezifiziert (n)
  *       7 - Datenvergleich beachtet Gross-/Kleinschreibung (p)
  *       8 - Modification-value for filename is present (z)
  *       9 - processing-mode is 'block-mode' (b)
  *      10 - modify filetype from 'Ascii' to 'Unicode' or vice versa
  *      16 - Extended output to LOG (-d,Hidden)
  * Extended Options (FoX):
  *       0 - Filetype is 'Ascii'   (a) (Text-file)
  *       1 - Filetype is 'Unicode' (u) (Text-file)
  *       2 - Filetype is 'Shape'   (s)
  *       3 - Filetype is 'World'   (w)
  *       4 - Filetype is 'Tile'    (t)
  *       5 - Filetype is 'Route'   ($File:Route)
  *       6 - Filetype is 'GTS'     ($File:GTS)
  *       7 - Filetype is 'LTS'     ($File:LTS)
  *       8 - Filetype is 'Idx'     ($File:Idx)
  *       9 - Filetype is 'ws'      ($File:WorldSound)
  *      10 - Filetype is 'TDB'     ($File:DataBase)
  *      11 - Filetype is 'TIT'     ($File:XIT)
  *      12 - Filetype is 'sig'     ($File:Signal)
  *      13 - Filetype is 'act'     ($File:Activity)
  *      14 - Filetype is 'pat'     ($File:Pat)
  *      15 - Filetype is 'srv'     ($File:Srv)
  *      16 - Filetype is 'trf'     ($File:Trf)
  *      17 - Filetype is 'sms'     ($File:Sound)
  *      18 - Filetype is 'env'     ($File:Environment)
  *      19 - Filetype is 'ssc'     ($File:SoundSource)
  *      20 - Filetype is 'ttp'!    ($File:TType)
  *      21 - Filetype is 'car'!    ($File:CarS)
  *      22 - Filetype is 'for'!    ($File:Forests)
  *      23 - Filetype is 'gty'     ($File:Gantry)
  *      24 - Filetype is 'spp'     ($File:Speedpost)
  *      25 - Filetype is 'tpl'     ($File:Telepole)
  *      26 - Filetype is 'haz'     ($File:Hazard)
  *      27 - Filetype is 'mkr'     ($File:Marker)
  *      28 - Filetype is 'ref'     ($File:Ref)
  *      29 - Filetype is 'con'     ($File:Consist)
  * Remark: Files signed with '!' cannot be tokenized
  * ##FleCpy/##fcpy (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int FleCpy( /* copy files/file-groups */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSFile          cR;    /* current input-file */
    TSFile          cW;    /* current output-file */
    TSFleMask       cM;    /* current mask to select files */
    File            dirS,dirZ,datS,datZ,datT;
    BufferedWriter  tW;    /* temporary (memory-)writer */
    BufferedReader  tR;    /* temporary (memory-)reader */
    StringWriter    tS;    /* temporary writer to String */
    String[]        fl;    /* file-list */
    TSArrList       cL;    /* current comandlist of changes */
    Object          o;     /* comparision-ctl: String/Pattern */
    Matcher         m;     /* use regular expression */
    String          is,js,ks; /* intermediate values */
    int             cMdeI,cMdeO,cMdeR; /* current IO-Modes */
    int             i,j,kA,kE; /* intermediate values */
    int             c,cf,ce,cm; /* counter */
    boolean         mrkE;  /* error found if true */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("FleCpy51"); /* print prefix of current action(s) */

    /* select appropriate folder for input/output */
    dirS = new File(vn2); /* get input-folder */
    vn2 = dirS.getAbsolutePath(); /* and  set absolute version of name */
    dirS = new File(vn2); /* input-folder is now 'absolute' */
    dirZ = new File(vn3); /* get output-folder */
    vn3 = dirZ.getAbsolutePath(); /* and  set absolute version of name */
    dirZ = new File(vn3);/* output-folder is now 'absolute' */

    /* create output-mode (requested) of target-files */
    cMdeR = -1; /* preset: output-mode of target is not specified */
    if(Fo.chkMsk(1)) cMdeR = TSFile.OUT; /* Expand */
    if(Fo.chkMsk(2)) cMdeR = TSFile.OUB; /* Reduce */
    if(Fo.chkMsk(3)) cMdeR = TSFile.OCB; /* Compress */
    if(Fo.chkMsk(4)) cMdeR = TSFile.OCT; /* Inflate */
    /* Attention: mode may be changed later (text-files) */

    switch(i=FoX.fndMsk(true)) { /* select due to type-number */
      /* Attention: ONLY ONE bit should be set within FoX-options */
      case( 0): /* bit 0 = 'text'-files (Ascii) are selected */
        if(fn==null) fn = TSLogg.getKey("FleMgrMA"); /* get default-selection */
        is = "Text-A";  /* set mode for documentation */
        cMdeR = TSFile.OA; /* mark: Output-mode is: 'text'-files (Ascii) */
        break; /* file-handles are fully defined */
      case( 1): /* bit 1 = 'text'-files (Unicode) are selected */
        if(fn==null) fn = TSLogg.getKey("FleMgrMU"); /* get default-selection */
        is = "Text-U";  /* set mode for documentation */
        cMdeR = TSFile.OU; /* mark: Output-mode is: 'text'-files (Unicode) */
        break; /* file-handles are fully defined */
      case( 2): /* bit 2 = 'shape'-files are selected */
        if(fn==null) fn = TSLogg.getKey("FleMgrMS"); /* get default-selection */
        is = "Shape"; /* set mode for documentation */
        break; /* file-handles are fully defined */
      case( 3): /* bit 3 = 'world'-files are selected */
        if(fn==null) fn = TSLogg.getKey("FleMgrMW"); /* get default-selection */
        is = "World"; /* set mode for documentation */
        break; /* file-handles are fully defined */
      case( 4): /* bit 4 = 'tile'-files are selected */
        if(fn==null) fn = TSLogg.getKey("FleMgrMT"); /* get default-selection */
        is = "Tile";  /* set mode for documentation */
        break; /* file-handles are fully defined */
      case( 5): /* bit 5 = 'route'-file is selected */
        if(fn==null) fn = TSLogg.getKey("FleCpyT5"); /* get default-selection */
        is = "Route";  /* set mode for documentation */
//        cMdeR = TSFile.OUT; /* mark: Output-mode is: 'uncompressed' (expand) */
        break; /* file-handles are fully defined */
      default: /* all other selections, unknown format should not occur */
        is = TSFileX.getDesc(i,false);  /* set mode for documentation */
//TSUtil.Lg.Msg("Msg010","Return 'TSFileX.getDesc("+i+",false)' -->'"+is+"'");
        if(is==null) throw  /* invalid index/number should not occur */
          new IllegalStateException(TSLogg.getMsg("Msg906","fcpy("+i+")"));
        if(fn!=null) break; /* selection-mask is already valid */
        fn = TSFileX.getDesc(i,true); /* get default-selection */
    } /* -switch- definitions have been fully processed */

    cL = Fo.getQue(5); /* ArrayList of change-commands (initialize) */
    /* print current path and selection */
    Lg.Msg("FleCpy52",vn2); /* print input-path */
    Lg.Msg("FleCpy53",vn3); /* print output-path */
    Lg.Msg("FleCpy54",fn);  /* print file-selector */
    Lg.Msg("FleCpy55",is);  /* print object-type */
    if(Fo.chkMsk(8)) Lg.Msg("FleCpy59",cL.getDta(1));  /* print modification */
    Lg.Skip(true); /* print empty line (screen and LOG-file) */

    if(Fo.chkMsk(6)) { /* file-mask uses windows-format -- convert it */
      is = TSFleMask.convert(fn,false); /* try conversion */
      if(is==null) { /* error found within mask */
        is = TSFleMask.convert(fn,true); /* retry conversion and get error */
        Lg.Msg("FleCpy61",is); /* print error-message: terminating */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* current file-mask (windows) contains error(s) */
      fn = is; /* activate valid file-mask */
    } /* file-mask is converted to a regular expression */

    cM = new TSFleMask(false,fn); /* compile current file-mask for input */
    if((is=cM.getErr())!=null) { /* error found within compilation */
      Lg.Skip(true); /* print empty line (screen and LOG-file) */
      Lg.Msg("FleCpy61",is); /* print error-message: terminating */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* selection-expression contains an error */

    /* check all used directories */
    if(!dirS.exists()) { /* Source-directory does not exist */
      Lg.Msg("FleCpy62",vn2); /* print error-message */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* directory does not exists */
    if(!dirS.isDirectory()) { /* Source is NOT a directory */
      Lg.Msg("FleCpy63",vn2); /* print error-message */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Source-object is not a directory */
    if(!dirZ.exists()) { /* Target-directory does not exist */
      if(Fo.chkMsk(5)) dirZ.mkdirs(); /* try to create folder */
      if(!dirZ.exists()) { /* Target-directory still does not exist */
        Lg.Msg("FleCpy64",vn3); /* print error-message */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* directory could not be created */
    } /* directory does not exists */
    if(!dirZ.isDirectory()) { /* Target is NOT a directory */
      Lg.Msg("FleCpy65",vn3); /* print error-message */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Target-object is not a directory */

    datT = null; /* Compiler needs it */
    if(!Fo.chkMsk(9)) { /* block-mode is NOT permitted -- use file */
      /* overwrite-mode is supported -- create temporary-file */
      try { datT = File.createTempFile("TSUtil",".tmp");
      } catch (IOException e) { /* creation of temp-file failed */
        System.err.println(e.toString());
        Lg.Msg("FleCpy66"); /* print error-message */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* Temp-Datei konnte nicht angelegt werden */
      datT.deleteOnExit(); /* Datei am Ende wieder loeschen */
    } /* block-mode was NOT requested */

    fl = dirS.list((FilenameFilter)cM); /* create list of selected files */
      /* result contains NO directories! */
    if(fl==null) { /* error found: source is no directory */
      Lg.Msg("FleCpy67",vn2); /* print error-message */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* file-list could not be created */

    /* process all requested files */
    tS = null; /* Compiler needs it */
    cR = null; /* Compiler needs it */
    cW = null; /* Compiler needs it */
    cf = ce = 0; /* init file-counter, conversion errors */
    vn2 = cL.getDta(1); /* get replacement-String (or 'null') */
    j = cL.size(); /* get number of definitions */
    for(String sf:fl) { /* process all selected file-definitions */
      datS = new File(dirS,sf); /* create full reference to input-file */
      cf += 1; /* and count selected file */
      Lg.Log("FleCpy68",sf,DF4.format(cf)); /* print state-message */
      if(Fo.chkMsk(8)) { /* filename should be modified */
        is = cM.modify(sf,vn2); /* change pattern of filename */
        if(is==null) Lg.Log("FleCpy6A",sf); /* print error-message */
        else sf = is; /* activate new filename */
      } /* file-name is changed */
      datZ = new File(dirZ,sf); /* create full reference to target-file */
      if(datZ.isDirectory()) { /* error: target-object is a folder */
        Lg.Log("FleCpy71",datZ.getPath()); /* print error-message */
        continue; /* error -- do not process input-file -- next one */
      } /* target must not be a folder */
      fn = datS.getName(); /* full name used within messages */
      cm = 0; /* init modification-counter */
      if(Fo.chkMsk(9)) datT = datZ; /* block-mode uses target for output */

      cMdeI = TSFile.IN; /* create default IO-Mode */
      switch(i=FoX.fndMsk(true)) { /* select due to type-number */
        case( 0): /* bit 0 = 'text'-files (Ascii) */
          cMdeI = Fo.chkMsk(10) ? TSFile.IU : TSFile.IA;
            /* create IO-Mode due to requested input-format */
          cR = new TSFile(datS); /* create input-control */
          cW = new TSFile(datT); /* create output-control */
          break; /* file-handles are fully defined */
        case( 1): /* bit 1 = 'text'-files (Unicode) */
          cMdeI = Fo.chkMsk(10) ? TSFile.IA : TSFile.IU;
            /* create IO-Mode due to requested input-format */
          cR = new TSFile(datS); /* create input-control */
          cW = new TSFile(datT); /* create output-control */
          break; /* file-handles are fully defined */
        case( 2): /* bit 2 = 'shape'-files */
          cR = new TSFileS(datS); /* create input-control */
          cW = new TSFileS(datT); /* create output-control */
          break; /* file-handles are fully defined */
        case( 3): /* bit 3 = 'world'-files */
          cR = new TSFileW(datS); /* create input-control */
          cW = new TSFileW(datT); /* create output-control */
          break; /* file-handles are fully defined */
        case( 4): /* bit 4 = 'tile'-files */
          cR = new TSFileT(datS); /* create input-control */
          cW = new TSFileT(datT); /* create output-control */
          break; /* file-handles are fully defined */
        case( 5): /* bit 5 = 'route'-file */
          cR = new TSFile$trk(datS); /* create input-control */
          cW = new TSFile$trk(datT); /* create output-control */
          break; /* file-handles are fully defined */
        default: /* all other selections, unknown format should not occur */
          cR = new TSFileX(i,datS); /* create input-control */
          cW = new TSFileX(i,datT); /* create output-control */
          if(cR.getTok(1)==null) throw /* invalid format should not occur */
            new IllegalStateException(TSLogg.getMsg("Msg906","FCpy("+i+")"));
      } /* definitions have been fully processed */

      is = cR.open(cMdeI); /* open input and check input-type */
      if(is!=null) { /* open-error found */
        Lg.Log("FleCpy73",is); /* print error-message */
        ce += 1; /* count conversion-error */
        continue; /* continue with next file */
      } /* file-error occurred */

      mrkE = false; /* set marker: NO error found */
      cMdeO = cR.getMode(TSFile.OUT); /* get designated file-mode of output-file */
      if(cMdeR>=0) cMdeO = cMdeR; /* set special output-format if requested */
      cW.setTyp(cR.getTyp()); /* transfer selection-type if possible */
      c = 0; /* init line-counter */
      if(!Fo.chkMsk(9)) bbR: { /* break-Block fuer das Lesen (break-block-read) */
        /* Attention: block-mode is NOT active now */
        is = cW.open(cMdeO); /* Ausgabe oeffnen und Typ-Kng schreiben */
        if(is!=null) { /* open-error found */
          Lg.Log("FleCpy74",is); /* print error-message */
          ce += 1; /* count conversion-error */
          mrkE = true; /* set marker: error was registered */
          break bbR; /* Bearbeitung der Datei beenden */
        } /* file-error occurred */
        if(EnaH) Lg.Log("FleCpy6C",cR.prtMode(),cW.prtMode()); /* print IO-Modes */

        /* copy all lines and modify them if necessary */
        while((is=cR.getData())!=null) { /* get next/all line(s) of file */
          c += 1; /* line successfully read -- count it */
          /* check content of record and change it if needed */
          ks = Fo.chkMsk(7) ? is : is.toLowerCase(); /* involve case-sensitivity */
          for(i=2;i<j;i+=2) { /* check all action-definitions */
            o = cL.get(i); /* get selection-definition */
            if(!(o instanceof String)) { /* regular expression found */
              m = ((Pattern)o).matcher(is); /* compare to data-line */
              if(!m.find()) continue; /* 'match' is NOT successful */
              ks = cL.getDta(i+1); /* get replacement-value */
              is = m.replaceAll(ks); /* modify dataline */
            } else { /* text is compared to dataline */
              js = (String)o; /* convert comparison-value to compare */
              if((kA=ks.indexOf(js))<0) continue; /* 'match' found: replace it */
              ks = is.substring(0,kA) + cL.getDta(i+1);
                /* get replacement-value and build first part of line */
              kA += js.length(); /* compute end-position */
              if(kA<is.length()) ks += is.substring(kA); /* add second part */
              is = ks; /* activate changed record */
            } /* selection and process were successful */
            cm += 1; /* count change */
            ks = Fo.chkMsk(7) ? is : is.toLowerCase(); /* involve case-sensitivity */
          } /* - for- check all change-definitions */

          is = cW.putData(is); /* write back record to (temp.) output */
          if(is!=null) { /* write-error occurred */
            Lg.Log("FleCpy75",is,c); /* print error-message */
            ce += 1; /* count conversion-error */
            mrkE = true; /* set marker: error was registered */
            break; /* terminate copy */
          } /* write-error */
        } /* copy all records */
        if((is=cR.getErr())!=null) { /* loop terminated because of error */
          Lg.Log("FleCpy76",is,c); /* print error-message */
          ce += 1; /* count conversion-error */
          mrkE = true; /* set marker: error was registered */
        } /* Dateifehler */

        is = cW.close(); /* close output-file again */
        if(is!=null) { /* error found during close */
          Lg.Log("FleCpy78",is,c); /* print error-message */
          ce += 1; /* count conversion-error */
          mrkE = true; /* set marker: error was registered */
        } /* Dateifehler */
      } else { /* -bbR- break-Block fuer das Lesen -- now: block-mode */
        tS = new StringWriter(); /* create temporary device */
        tW = new BufferedWriter(tS); /* and extend it to buffered */
        while((is=cR.getData())!=null) { /* get next/all line(s) of file */
          c += 1; /* line successfully read -- count it */
          /* check content of record and change it if needed */
          try { /* write line back to memory-file */
            tW.write(is); /* write data */
            tW.newLine(); /* and skip to next line */
          } catch (IOException e) { /* check if IO-error occurrs */
            Lg.Log("FleCpy81",e.toString(),c); /* print error-message */
            ce += 1; /* count conversion-error */
            mrkE = true; /* set marker: error was registered */
            break; /* -while- terminate copy */
          } /* file-error found -- terminae read */
        } /* copy all records */

        try { tW.close(); /* close buffered part of writer */
        } catch (IOException e) { /* check if IO-error occurrs */
          Lg.Log("FleCpy82",e.toString(),c); /* print error-message */
          ce += 1; /* count conversion-error */
          mrkE = true; /* set marker: error was registered */
        } /* close-error found */
        if((is=cR.getErr())!=null) { /* loop terminated because of error */
          Lg.Log("FleCpy76",is,c); /* print error-message */
          ce += 1; /* count conversion-error */
          mrkE = true; /* set marker: error was registered */
        } /* Dateifehler */
      } /* file has successfully read or read/written */

      is = cR.close(); /* close input-file again */
      if(is!=null) { /* error occurred during close */
        Lg.Log("FleCpy79",is,c); /* print error-message */
        ce += 1; /* count conversion-error */
        continue; /* error found -- process next file */
      } /* Dateifehler */
      if(mrkE) continue; /* error found -- process next file */

      if(Fo.chkMsk(9)) { /* block-mode is used -- continue */
        is = tS.getBuffer().toString(); /* all data from file within one buffer */
        /* modify data if applicable */
        for(i=2;i<j;i+=2) { /* check all action-definitions */
          o = cL.get(i); /* get selection-definition */
          if(!(o instanceof String)) { /* regular expression found */
            m = ((Pattern)o).matcher(is); /* compare to data-line */
            if(!m.find()) continue; /* 'match' is NOT successful */
            js = cL.getDta(i+1); /* get replacement-value */
            is = m.replaceAll(js); /* modify dataline */
            cm += 1; /* count change */
          } else { /* text is compared to dataline */
            js = (String)o; /* convert comparison-value to compare */
            ks = cL.getDta(i+1); /* get replacement-value */
            kE = js.length(); /* length of String to be compared */
            for(kA=0;kE<=is.length();kA+=1,kE+=1) { /* check whole file */
              if(Fo.chkMsk(7)) { if(!is.startsWith(js,kA)) continue;
              } else if(!is.substring(kA,kE).equalsIgnoreCase(js)) continue;
                /* no match found -- continue checking */
              is = is.substring(0,kA) + ks + ((kE<is.length()) ? is.substring(kE) : "");
                /* create result */
              kA += ks.length(); /* skip length of inserted string */
              kE += ks.length(); /* skip length of inserted string */
              cm += 1; /* count change */
            } /* process whole string/file */
          } /* selection and process were successful */
        } /* - for- check all change-definitions */
        bbW: { /* break-Block-write */
          tR = new BufferedReader(new StringReader(is)); /* create temporary device */
          try { /* read first line from line-buffer */
            is = tR.readLine(); /* get first line of file */
          } catch (IOException e) { /* check if IO-error occurrs */
            Lg.Log("FleCpy83",e.toString()); /* print error-message */
            ce += 1; /* count conversion-error */
            mrkE = true; /* set marker: error was registered */
            break bbW; /* terminate processing of file */
          } /* file-error found -- terminate read */
          js = cW.open(cMdeO); /* Ausgabe oeffnen und (ggf.) Typ-Kng schreiben */
          if(js!=null) { /* open-error found */
            Lg.Log("FleCpy74",js); /* print error-message */
            ce += 1; /* count conversion-error */
            mrkE = true; /* set marker: error was registered */
            break bbW; /* terminate processing of file */
          } /* file-error occurred */
          if(EnaH) Lg.Log("FleCpy6C",cR.prtMode(),cW.prtMode()); /* print IO-Modes */

          while(is!=null) { /* process next/all line(s) of file */
            is = cW.putData(is); /* write back record to output */
            if(is!=null) { /* write-error occurred */
              Lg.Log("FleCpy75",is); /* print error-message */
              ce += 1; /* count conversion-error */
              mrkE = true; /* set marker: error was registered */
              break; /* terminate copy */
            } /* write-error */
            try { /* read next line from line-buffer */
              is = tR.readLine(); /* get first line of file */
            } catch (IOException e) { /* check if IO-error occurrs */
              Lg.Log("FleCpy84",e.toString()); /* print error-message */
              ce += 1; /* count conversion-error */
              is = null; /* no data available */
              break; /* terminate processing of file */
            } /* file-error found -- terminate read */
          } /* -while- copy all records */

          is = cW.close(); /* close output-file again */
          if(is!=null) { /* error found during close */
            Lg.Log("FleCpy78",is); /* print error-message */
            ce += 1; /* count conversion-error */
            mrkE = true; /* set marker: error was registered */
          } /* file-error */
        } /* -bbW- break-Block for writeing */

        try { tR.close(); /* close buffered part of reader */
        } catch (IOException e) { /* check if IO-error occurrs */
          Lg.Log("FleCpy85",e.toString()); /* print error-message */
          ce += 1; /* count conversion-error */
          continue; /* error found -- process next file */
        } /* close-error found */
        if(!mrkE) Lg.Log("FleCpy6B",cm); /* print number of changes */
      } else { /* block-mode processed -- complete line-mode */
        Lg.Log("FleCpy69",cm); /* print number of changes */
        /* Kopieren der Ergebnisdatei in das Ziel-Verzeichnis */
        is = "copy \""+datT.getAbsolutePath()+"\" \""+
             datZ.getAbsolutePath()+"\" "; /* create copy-command */
        if((i=exec(true,is,null,Lg))>0) /* 'copy' terminates with error */
          Lg.Log("MsgC49",datZ.getAbsolutePath(),i); /* print error-message */
      } /* target is copied -- file fully processed */
    } /* -for- process ALL selected files */

    Lg.Skip(true); /* print empty line (screen and LOG-file) */
    Lg.Msg("FleCpy56",cf); /* print result: number of processed files */
    Lg.Msg("FleCpy57",ce); /* print result: number of errors */

    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* print timestamp */

    if(Fo.chkMsk(16)) prt:{ /* Zusaetzliche Definitionen ausgeben */
      if(Lg.Skip(true)) break prt; /* skip line -- logging active? */
      Lg.Msg("prExtD01","00000000"); /* Aktionsmeldung ausgeben */
      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Log("prExtD02",Fo.toStr()); /* Datenfeld ausgeben */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* print additional information(s)

    Lg.Skip(true); /* print empty line (screen and LOG-file) */
    Lg.Msg("FleCpy58",fl.length); /* print statistic-message */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
 }

 /**. <pre>
  *=====================================================================
  * Method "tstSig" (-30-)
  * Check configuration of signals-objects
  * Options:
  * ##tstSig (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int tstSig( /* check signalconfiguration */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute              xRte; /* virtual route-definition */
    File                 dat;  /* (intermediate) file-definition */
    int                  i;
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("tstSig01",fn); /* print prefix */

    dat = new File(fn); /* path to signalconfiguration */
    if(!dat.exists()) { /* directory is missing */
      Lg.Skip(true); /* print empty line */
      Lg.Msg("chgSig02",dat.getAbsolutePath()); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* directory not found */
    if(!dat.isDirectory()) { /* name do NOT refer to directory */
      Lg.Skip(true); /* print empty line */
      Lg.Msg("chgSig03",dat.getAbsolutePath()); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* no directory */
    xRte = new TSRoute("",null,dat,null,null); /* create virtual route */
    /* Achtung: 'xRte' ist NICHT vollstaendig definiert. Diese virtuelle
     * Route soll die NEUEN Signaldefinitionen verfuegbar machen.
     */

    /* load Signal-Definitionen and check it */
    i = getSCfg(xRte,xRte.getFile(21),null,true); /* load Signal-Configurations */
    if(i==0) /* configuration load successfully -- continue */
      i = getSScr(xRte,xRte); /* load Signal-Script-Definitions */

    if(Fo.chkMsk(16)) prExtD(xRte); /* print additional structures */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("tstSig09"); /* print last message */
    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* print timestamp */
    Lg.Close(); /* close output to Log-file */
    return 0; /* terminate funktion without error */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Insert" (-??-)
  * Streckenobjekte zusammenmischen
  * Optionen:
  *       4 - Kopieren der Puffer gefordert
  *       7 - 'StaticDetailLevel' modifizieren
  *      16 - Extended output to LOG (-d,Hidden)
  * ##Insert (Eyecatcher)
  * ===> ACHTUNG: Diese Methode befindet sich noch in Entwicklung <===
  *=====================================================================
  </pre>*/
  protected static int Insert( /* Streckenobjekte zusammenmischen */
   boolean Lgapp) /* append data to log-file (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    TSRoute              cRte,mRte; /* Streckendefinitionen (Basis) */
    TreeSet<TSTile>      Tle;    /* alle Tile-Definitionen */
    TreeSet<TSQuad>      QDf;    /* alle Quadrat-Definitionen */
    TSTile               cTle;   /* aktuelle Tile-Definitionen */
    TSQuad               cQDf,bQDf; /* aktuelle Quadrat-Definitionen */
    TSChain              cW,cS;  /* Objekt-Ketten eines Quad */
    ArrayList<TSTrNde>   TrN;    /* aktuelle TrackNode-Tabelle */
    ArrayList<TSTrItm>   ItT;    /* aktuelle TrItem-Datenbank */
    TSTrNde              cTrN;   /* aktuelle Node-DB-Element */
    TSTrItm              cIt;    /* aktuelle TrItem-DB-Element */
    TSScL                cSc;    /* aktuelle lokale Section */
    TSShL                cSh;    /* aktuellen lokalen Pfad */
    TSUiD                cUiD;   /* aktuelle UiD-Referenz */
    TSSnd                cSnd,aSnd;   /* aktuelle Sound-Referenz */
    TStType              cTp;    /* aktuelle ttype-Referenz */
    ArrayList<TSSigSh>   SgS;    /* Signal-Shape-Definitionen */
    TSSigSh              cSgS;   /* aktuelle Signal-Shape-Definition */
    ArrayList<TSSigSObj> SgSO;   /* Signal-SubObject-Definitions */
    TSSigSObj            cSgSO;  /* aktuelle Signal-SubObjekt-Definition */
    ArrayList<TSSigTyp>  SgT;    /* Signal-Type-Definitionen */
    TSSigTyp             cSgT,xSgT; /* aktuelle Signal-Type-Definition */
    TSSigSgL             cSgSgL; /* aktuelle SignalLight-Definition */
    ArrayList<TSSigLTx>  SgX;    /* Signal-LightTexture-Definitionen */
    TSSigLTx             cSgX;   /* aktuelle Signal-LightTexture-Definition */
    ArrayList<TSSigLgt>  SgL;    /* Signal-Light-Definitionen */
    TSSigLgt             cSgL,xSgL; /* aktuelle Signal-Light-Definition */
    TSSigFle             cSgF;   /* aktuelle Signalscript-Definition */
    TSPath               cPth;   /* aktuelle (Routen-)Pfad-Definition */
    TSSrv                cSrv;   /* aktuelle Service-Definition */
    TSTrf                cTrf;   /* aktuelle Traffic-Definition */
//    TSAct               cAct;   /* aktuelle Activity-Definition */
    File                 sdir,zdir,vdir,dat; /* Dateidefinitionen */
    TSNameSet            TNme,SNme,XNme; /* temporary lists for names */
    int                  i,j,c,t,v,w; /* Arbeitswerte */
    LinkedHashMap<String,TSSigFle> SgF; /* Definitionen der Signal-Script-Files */
    TreeMap              FleT;   /* Tabelle fuer Dateidef's (TSPath,TSServ,TSTrf) */
    String               is,js,RefNme;
    boolean              tdl1,tdl2; /* LO_Tiles vorhanden */
    boolean              mix; /* Modus der Bearbeitung */
    Iterator<TSTrNde>    aI;  /* Iterator fuer TrackNode-Tabelle */
    Iterator             cI;  /* allgemeiner Iterator */
   /*=================================================================*/
    Lg.Open(Lgapp); /* open log-file, select output-mode */
    prStart("insrt001",fn,vn2); /* Vorlauf ausgeben */

    /* Systemdatei 1 lesen und auswerten */
    cRte = getRte(fn,2145); /* (3*5*11*13) Streckendefinition auswerten */
    if(cRte==null) return 5; /* Fehler -- Ende */
    /* 3='world', 5='tiles', 11='TD', 13='Sound' */
    /* Systemdatei 2 lesen und auswerten */
    mRte = getRte(vn2,1); /* Streckendefinition auswerten */
    if(mRte==null) return 5; /* Fehler -- Ende */

    if(!cRte.getInfo(0).equalsIgnoreCase(mRte.getInfo(0))) {
      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("insrt002"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 10; /* terminate function with errorcode */
    } /* TS-Pfade nicht identisch */

    if(cRte.getInfo(1).equalsIgnoreCase(is=mRte.getInfo(1))) {
      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("insrt003",is); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 10; /* terminate function with errorcode */
    } /* TS-Routen identisch */

    /* Pfade ausgeben */
    Lg.Msg("MsgC02",cRte.getInfo(0)); /* aktuelle Werte */
    Lg.Msg("insrt006",cRte.getInfo(2)); /* aktuelle Werte */
    Lg.Msg("insrt007",cRte.getInfo(1)); /* aktuelle Werte */
    Lg.Msg("insrt008",mRte.getInfo(2)); /* aktuelle Werte */
    Lg.Msg("insrt009",is); /* aktuelle Werte */
    Lg.Skip(true); /* Leerzeile loggen */

    /* globale "tsection.dat" bearbeiten */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC05"); /* Aktionsmeldung ausgeben */

    dat = cRte.getFile(-1); /* get reference to file */
    i = getTS(dat,null);    /* and load 'tsection.dat' (global) */
    ScA = ScN; ShA = ShN; /* values are again used within local part */

    if(i>0) { /* Fehler beim Laden der 'tsection.dat' */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC08",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    Lg.Log("MsgC11",c3); /* Ergebnis melden */
    Lg.Log("MsgC14",ScN); /* Ergebnis melden */
    Lg.Log("MsgC17",c2); /* Ergebnis melden */
    Lg.Log("MsgC20",ShN); /* Ergebnis melden */
    Lg.Log("MsgC23",c4); /* Ergebnis melden */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("insrt011"); /* Aktion melden */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(cRte,ScA,ShA); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* zusaetzliche Streckendateien laden */
    i = getType(cRte); /* 'ttype.dat' laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strukturquadrate laden (genaue Ausfuehrung) */
    i = getTDF(cRte,0); /* Steuerungsdatei(en) laden */
    if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC26",i); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Strukturquadrate laden (LO-Tiles) */
    tdl1 = true; /* annehmen: Lo_Tiles sind vorhanden */
    i = getTDF(cRte,1); /* Steuerungsdatei(en) laden */
    if(i>0) { /* Fehler beim Laden der Strukturquadrate */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC27",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    if(i<0) tdl1 = false; /* nicht mehr versuchen */

    /* Schienendatenbank laden */
    i = getDBF(cRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    i = getITF(cRte,0); /* Schienendatenbank laden und pruefen (2. Teil) */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strassendatenbank laden */
    i = getDBF(cRte,1); /* Strassendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    if(i==0) { /* Datenbank ist vorhanden */
      i = getITF(cRte,1); /* Strassendatenbank laden und pruefen (2. Teil) */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* Datenbank(teil) ist vorhanden */

    /* World-Dateien laden und syntaktisch pruefen */
    i = getWF(cRte,false); /* World-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */
    /* Sound-Dateien laden und syntaktisch pruefen */
    i = getSF(cRte,false); /* World-Sound-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */

    /* Signal-Definitionen laden und ueberpruefen */
    i = getSCfg(cRte,cRte.getFile(21),null,false); /* load Signal-Configurations */
    if(i==0) /* Laden erfolgreich -- weiter testen */
      i = getSScr(cRte,cRte); /* Signal-Script-Definitionen laden */

    /* Achtung: Wenn keine Definitionen vorhanden ist, wird die Basistabelle beim
     * Mischen erzeugt. Deshalb ist es HIER NICHT zwingend notwendig.
     */
    /* Path-Definitionen werden geladen und ueberprueft */
    i = getPatF(cRte,true); /* Path-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Service-Definitionen werden geladen und ueberprueft */
    i = getSrvF(cRte,true); /* Service-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Traffic-Definitionen werden geladen und ueberprueft */
    i = getTrfF(cRte,true); /* Traffic-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */

    /* Activity-Definitionen werden geladen und ueberprueft */
    i = getActF(cRte,true); /* Activity-Definitionen laden und pruefen */
    if(i>0) return i; /* Fehler -- abbrechen */


    /* all files were loaded -- continue with integrity-check */
    if((is=cRte.chkRte(Fo,true))!=null) { /* check route for integrity -- error found ? */
      if(is.charAt(0)!=' ') { /* error-message returned */
        Lg.Skip(true); /* skip line */
        Lg.Err("getRte23",is); /* print errormessage */
        Lg.Msg("MsgC60"); /* print message: 'terminating' */
        Lg.Close(); /* close output to Log-file */
        return 5; /* terminate function with errorcode */
      } /* error found -- function terminated */
      if(EnaW) Lg.Log("chkRte00",is); /* Warning found -- print it */
    } /* error/warning found */

    /* "world"-Dateien bearbeiten und neue Integritaet herstellen */
    chkWrld(cRte,null,132); /* World-Dateien erweitert pruefen (128+4) */
      /* Modus: Aenderungen melden, kein Renum */

    /* Sound-Dateien bearbeiten und neue Integritaet herstellen */
    i = chkSnd(cRte,null,128); /* Sound-Dateien erweitert pruefen */
      /* Modus: Aenderungen melden */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("MsgC33",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC35"); /* Aktionsmeldung ausgeben */
    if(cRte.get$TrN(0)<=0) { /* Schienendatenbank NICHT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC36"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datenbank nicht vorhanden */

    i = chkDBTab(cRte,0); /* Schienendatenbank bearbeiten */
    if(i<0) return 5; /* Systemfehler -- Ende */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC37",i); /* Aktionsmeldung */
    Lg.Skip(false); /* Leerzeile loggen */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC39"); /* Aktionsmeldung ausgeben */
      i = chkDBTab(cRte,1); /* Strassendatenbank bearbeiten */
      if(i<0) return 5; /* Systemfehler -- Ende */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("MsgC40",i); /* Aktionsmeldung */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Strassendatenbank vorhanden und geladen */

    /* extended check of local 'tsection.dat'
     * Attention: This method MUST NOT be invoked unless worldfiles AND
     * database (track/road) is stored again (or neither). */
    chkTSL(cRte,ScN,ShN); /* check file and compact it */

    i = chkPat(cRte); /* Pfad-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkSrv(cRte,true); /* Service-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkTrf(cRte,true,false); /* Traffic-Definitionen bearbeiten */
    if(i>0) return 5; /* Systemfehler -- Ende */

    i = chkAct(cRte,true); /* process activity-definitions */
    if(i>0) return 5; /* systemerror occurred -- terminate */

    /* Strecken-Definition der zu mischende Routendefinition laden */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("insrt012"); /* Aktion melden */

    /* lokale "tsection.dat" bearbeiten */
    i = getTSL(mRte,ScA,ShA); /* 'tsection.dat' (lokal) laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* zusaetzliche Streckendateien laden */
    i = getType(mRte); /* 'ttype.dat' laden */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strukturquadrate laden (genaue Ausfuehrung) */
    i = getTDF(mRte,0); /* Steuerungsdatei(en) laden */
    if(i!=0) { /* Fehler beim Laden der Strukturquadrate (Hi) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC26",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */

    /* Strukturquadrate laden (LO-Tiles) */
    tdl2 = true; /* annehmen: Lo_Tiles sind vorhanden */
    i = getTDF(mRte,1); /* Steuerungsdatei(en) laden */
    if(i>0) { /* Fehler beim Laden der Strukturquadrate */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC27",i); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Fehler aufgetreten */
    if(i<0) tdl2 = false; /* nicht mehr versuchen */

    /* Schienendatenbank laden */
    i = getDBF(mRte,0); /* Schienendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    i = getITF(mRte,0); /* Schienendatenbank laden und pruefen (2. Teil) */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Strassendatenbank laden */
    i = getDBF(mRte,1); /* Strassendatenbank laden und pruefen */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    if(i==0) { /* Datenbank ist vorhanden */
      i = getITF(mRte,1); /* Strassendatenbank laden und pruefen (2. Teil) */
      if(i>0) return i; /* Fehler aufgetreten -- Abbruch */
    } /* Datenbank(teil) ist vorhanden */

    /* World-Dateien laden und syntaktisch pruefen */
    i = getWF(mRte,false); /* World-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */
    /* Sound-Dateien laden und syntaktisch pruefen */
    i = getSF(mRte,false); /* World-Sound-Dateien laden */
    if(i>0) return i; /* Fehler -- Ende */

    /* Signal-Definitionen laden und ueberpruefen */
    i = getSCfg(mRte,mRte.getFile(21),null,false); /* load Signal-Configurations */
    if(i==0) /* Laden erfolgreich -- weiter testen */
      i = getSScr(mRte,mRte); /* Signal-Script-Definitionen laden */

    /* Alle Insert-Dateien wurden geladen -- Integritaet bearbeiten */

    /* "world"-Dateien bearbeiten und neue Integritaet herstellen */
    chkWrld(mRte,null,132); /* World-Dateien erweitert pruefen (128+4) */
      /* Modus: Aenderungen melden, kein Renum */

    /* Sound-Dateien bearbeiten und neue Integritaet herstellen */
    i = chkSnd(mRte,null,128); /* Sound-Dateien erweitert pruefen */
      /* Modus: Aenderungen melden */
    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("MsgC33",i); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("MsgC35"); /* Aktionsmeldung ausgeben */
    if(mRte.get$TrN(0)<=0) { /* Schienendatenbank NICHT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC36"); /* Fehlermeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datenbank nicht vorhanden */

    i = chkDBTab(mRte,0); /* Schienendatenbank bearbeiten */
    if(i<0) return 5; /* Systemfehler -- Ende */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Msg("MsgC37",i); /* Aktionsmeldung */
    Lg.Skip(false); /* Leerzeile loggen */

    if(mRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("MsgC39"); /* Aktionsmeldung ausgeben */
      i = chkDBTab(mRte,1); /* Strassendatenbank bearbeiten */
      if(i<0) return 5; /* Systemfehler -- Ende */

      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("MsgC40",i); /* Aktionsmeldung */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Strassendatenbank vorhanden und geladen */


    /* BEIDE Routen vollstaendig geladen (Ausname: Dyn-Section)
     * Routen nun zusammenmischen.
     * Weil die dynamischen Section noch nicht geprueft sind, und bei
     * dieser Pruefung direkt die Anpassung vorgenommen wird, wird
     * hiermit begonnen
     */

    /* lokale 'tsection.dat' bearbeiten und dann zusammenmischen */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("insrt015"); /* Aktion melden */

    i = cRte.get$Sc(false); /* naechste freie Section holen */
    j = cRte.get$Sh(false); /* naechsten freien Pfad holen */
    /* zweite lokale 'tsection.dat' pruefen und bearbeiten */
    chkTSL(mRte,i,j); /* Pruefung der Datei durchfuehren */
    /* beide Ausgabe-Ketten miteinander verbinden */
    cSh = cRte.chgShR(null); /* Beginn Kette holen */
    if(cSh==null) cRte.chgShR(mRte.chgShR(null)); /* Kette umhaengen */
    else { /* lokale 'tsection.dat vorhanden -- verbinden */
      while(cSh.chgShR(null)!=null) cSh = cSh.chgShR(null); /* zum Ende */
      cSh.chgShR(mRte.chgShR(null)); /* Verkettung herstellen */
    } /* lokale 'tsection.dat'-Ketten wurden verbunden */
    cSc = cRte.chgScR(null); /* Beginn Kette holen */
    if(cSc==null) cRte.chgScR(mRte.chgScR(null)); /* Kette umhaengen */
    else { /* lokale 'tsection.dat vorhanden -- verbinden */
      while(cSc.chgScR(null)!=null) cSc = cSc.chgScR(null); /* zum Ende */
      cSc.chgScR(mRte.chgScR(null)); /* Verkettung herstellen */
    } /* lokale 'tsection.dat'-Ketten wurden verbunden */

    /* Gemeinsame Tile-Kette bilden und Tile-Definitionen kopieren */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("insrt016"); /* Aktion melden */

    TNme = new TSNameSet(); /* initialize list of Terrtex-Names */
    SNme = new TSNameSet(); /* initialize list of Shape-Names */
    XNme = new TSNameSet(); /* initialize list of Names (texture, ...)*/
    /* Mischen der Routendefinitionen durchfuehren */
    c4 = 0; /* Zaehler initialisieren */
    if((is=cpyTile(cRte,false,Fo.chkMsk(4)))!=null) { /* Fehler erhalten */
      /* directory could not be created */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("Msg010",is); /* Abbruchmeldung */
      Lg.Close(); /* close output to Log-file */
      return 20; /* terminate function with errorcode */
    } /* directory could not be created -- terminate function with errorcode */

    /* Alle World/Sound/Tile-Definitionen der Misch-Strecke zusammenfuehren */
    Tle = cRte.getTle(0,false); /* get current Tile-definitions */
    QDf = cRte.chgQDf(null); /* alle Quadrat-Definitionen holen */
    cI = mRte.getIt(10); /* Iterator fuer Tile-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
      mix = true; /* annnehmen: Modus ist 'Mischen' */
      /* Tile-Definition auf Gueltigkeit pruefen */
      if(cTle.getNme(0)==null) continue; /* Tile-Definition nicht gueltig */
      if(Tle.add(cTle)) { /* Tile war noch nicht in der Basis-Strecke vorhanden */
        sdir = mRte.getFile(18); /* Pfad der Tile-Dateien (Quelle) */
        zdir = cRte.getFile(48); /* Pfad der Tile-Dateien (Ziel) */
        mveTile(cTle,sdir,zdir,Double.NaN,TNme,false,Fo.chkMsk(4));
          /* Tile-Datei mit Datendateien kopieren, Dateiformat NICHT
           * aendern. Puffer kopieren falls gefordert.  Terrainnamen
           * registrieren
           */
        Lg.Log("insrt032",cTle.getId(true)); /* Hinzugefuegten Tile melden */
        mix = false; /* Modus 'Mischen' auf 'Hinzufuegen' aendern */
      } /* Tile-Definition war noch nicht vorhanden */

      for(cQDf=cTle.chgQDf(null);cQDf!=null;cQDf=cQDf.chgQDf(null)) {
        /* alle verketteten Quadrat-Definitionen (normalerweise 1) */
        bQDf = null; /* fuer Compiler */
        cW = null;   /* fuer Compiler */
        cS = null;   /* fuer Compiler */
        if(mix) { /* Modus ist Mischen -- Ziel-Quadrant holen */
          bQDf = cQDf.fndQuad(cRte,0,0); /* GLEICHER Quadrant in Ziel-Route */
          if(bQDf==null) { /* Quadrant wurde nicht gefunden -- Systemfehler */
            Lg.Err("insrt033",cQDf.getMsg(0,"insrt034",0,0)); /* Fehlermeldung ausgeben */
            continue; /* Quadrant NICHT uebertragen -- naechster */
          } /* Systemfehler -- Quadrant nicht gefunden */
          cW = bQDf.chgWTab(null,0); /* aktuelle UiD-Kette holen */
          cS = bQDf.chgSTab(null,0); /* aktuelle Sound-Kette holen */
        } else { /* Hinzufuegen -- Gesamten Quadranten einsetzen */
          if(!QDf.add(cQDf)) throw new /* Quadrat der Basisstrecke hinzufuegen */
            IllegalStateException(TSLogg.getMsg("Msg905","TSUtil.Insert.cQDf("+
              cQDf.getInf(0)+")")); /* Abbruch Programm mit Systemfehler */
        } /* Erste Aktion erfolgreich */
        for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
          /* nicht belegte UiD-Eintraege gibt es nicht */
          if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
          if(cUiD.isCtl()) continue; /* kein aktiver UiD-Eintrag */
          if(mix) { /* Eintrag in Ziel-Datei kopieren */



          } /* UID-Objekt wurde uebertragen */


        } /* alle Eintraege der World-datei bearbeiten */
        for(cSnd=cQDf.getSnd(true);cSnd!=null;cSnd=cQDf.getSnd(false)) {
          /* nicht belegte Eintraege gibt es nicht */
          if(cSnd.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
          if(mix) { /* Eintrag in Ziel-Datei kopieren */




          } /* Sound-Objekt wurde uebertragen */




        } /* alle Eintraege der 'Sound'-Datei bearbeiten */


      } /* alle verketteten Quadranten bearbeiten */





      /* Zusatz: Fuer jeden zu kopierenden Tile sind folgende Aktionen
       * zusaetzlich notwendig:
       *  - hinzufuegen in den globalen Speicher der Original-Route
       *  - Uberpruefen der zugehoerigen World-Datei(en) und File-Namen holen
       *  - Uberpruefen der zugehoerigen Sound-Datei(en) und File-Namen holen
       */
      for(cQDf=cTle.chgQDf(null);cQDf!=null;cQDf=cQDf.chgQDf(null)) {
        /* alle verketteten Quadrat-Definitionen (normalerweise 1) */
        if(!QDf.add(cQDf)) throw new /* Quadrat der Basisstrecke hinzufuegen */
          IllegalStateException(TSLogg.getMsg("Msg905","TSUtil.Merge.cQDf("+
            cQDf.getInf(0)+")")); /* Abbruch Programm mit Systemfehler */
        for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
          /* nicht belegte UiD-Eintraege gibt es nicht */
          if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
          if(cUiD.isCtl()) continue; /* kein aktiver UiD-Eintrag */
          if((is=cUiD.chgNme(null))!=null) /* Dateiname existiert im Eintrag */
            SNme.add(is.toLowerCase()); /* Shape-Name der Objekte eintragen */
          if(cUiD instanceof TSSpeed) /* Zusatzbearbeitung: 'Speedpost' */
            if((is=((TSSpeed)cUiD).chgTNme(null))!=null) SNme.add(is.toLowerCase());
          /* Zusatzbearbeitung: 'Forest' erfolgt mit 'chgNme'*/
        } /* alle Eintraege der World-datei bearbeiten */
        for(cSnd=cQDf.getSnd(true);cSnd!=null;cSnd=cQDf.getSnd(false)) {
          /* nicht belegte Eintraege gibt es nicht */
          if(cSnd.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
          if((is=cSnd.chgNme(null))!=null) /* Dateiname existiert im Eintrag */
            SNme.add(is.toLowerCase()); /* Shape-Name der Objekte eintragen */
        } /* alle Eintraege der 'Sound'-Datei bearbeiten */

        if(Fo.chkMsk(7)) { /* Veraendern des 'StaticDetailLevel gefordert */
          i = Fo.getInt(3,0); /* neue Level-Angabe holen */
          for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
            if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
            if(!cUiD.isTrack()) continue; /* keine Schienendefinition */
            if(cUiD.getSL()!=0) continue; /* kein gueltiger Level fuer Schienen */
            cUiD.setSL(i); /* insert StaticDetailLevel (explicitely) into source-object */
            cQDf.reSortW(cUiD); /* Element neu einsortieren */
 if(PrMsk.chkMsk(31)) Lg.Log("Msg010",cUiD.toStr()); // ##!D
          } /* alle Eintraege der World-datei bearbeiten */
        } /* Veraendern des 'StaticDetailLevel gefordert */
      } /* alle verketteten Quadranten bearbeiten */



    } /* -while- alle Tile-Definitionen bearbeiten/mischen */

    /* Auch LO-Tiles mischen und kopieren */
    c4 = 0; /* Zaehler initialisieren */
    if(tdl1) { /* Basis-Strecke hat LO-Tiles -- kopieren */
      if((is=cpyTile(cRte,true,Fo.chkMsk(4)))!=null) { /* Fehler erhalten */
        /* directory could not be created */
        Lg.Skip(true); /* Leerzeile loggen */
        Lg.Msg("Msg010",is); /* Abbruchmeldung */
        Lg.Close(); /* close output to Log-file */
        return 20; /* terminate function with errorcode */
      } /* directory could not be created -- terminate function with errorcode */
    } /* Basis-Strecke hat LO-Tile-Definitionen */
    if(tdl2) { /* zu mischende Strecke hat LO-Tiles */
      if(tdl1) { /* Basis-Strecke hat AUCH LO-Tiles -- mischen */
        Tle = cRte.getTle(1,false); /* get current LO-Tile-definitions */
        cI = mRte.getIt(11); /* Iterator fuer Tile-Definitionen */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
          if(cTle.getNme(0)==null) continue; /* Tile-Definition fehlt */
          if(!Tle.add(cTle)) continue; /* Tile in Basisstrecke schon vorhanden */
          /* LO-Tile erfolgreich hinzugefuegt -- Dateien kopieren */
          sdir = mRte.getFile(19); /* Pfad der Tile-Dateien (Quelle) */
          zdir = cRte.getFile(49); /* Pfad der Tile-Dateien (Ziel) */
          mveTile(cTle,sdir,zdir,Double.NaN,null,false,true);
            /* Tile-Datei mit Datendateien kopieren, Dateiformat NICHT
             * aendern. LO-Tile-Puffer immer kopieren.
             */
        } /* -while- alle LO-Tile-Definitionen */
      } else { /* keine LO-Tiles bei Basisstrecke */

      } /* Basistrecke hatte KEINE LO-Tiles */
    } /* -tdl2- Zu mischende Strecke hat LO-Tiles */





    /* Schienendatenbank zusammenmischen */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("insrt018"); /* Aktion melden */

    for(t=0;t<2;t+=1) { /* beide Datenbank-Typen bearbeiten */
      aI = mRte.getIt(t); /* Iterator fuer TrackNode-Definitionen */
      if(aI!=null) { /* Track-Node-DB (aus Merge-Route) ist vorhanden
        * Falls eine zusaetzliche TrackNode-DB NICHT vorhanden ist bleibt die
        * originale TrackNode-Datenbank unveraendert. */
        TrN = cRte.getTrN(t,0); /* aktuelle TrackNode-Datenbank holen (evtl. 'null') */
        i = mRte.get$TrN(t) + 10; /* neue Groesse der TrackNode-DB */
          /* '10' ist Reserve, die mit 'trimToSize()' wieder freigegeben wird */
        if(TrN==null) TrN = cRte.getTrN(t,i); /* Neue TrackNode-Tabelle erst. und setzen */
        else TrN.ensureCapacity(TrN.size()+i);
          /* TrackNode-Tabelle wurde neu erstellt/angepasst */
        i = j = TrN.size(); /* Anzahl der bereits vorhandenenen Elemente */
        /* 'i+1' ist neue Start-ID fuer die Erweiterung */
        while(aI.hasNext()) { /* Alle TrackNode-Definitionen bearbeiten */
          if((cTrN=aI.next())==null) continue; /* Fehl-Eintrag uebergehen */
          cTrN.chgIx(++i); /* neue Kennung des TrackNodes eintragen */
          for(v=0;v<cTrN.getTyp();v+=1) /* alle Verkettungen veraendern */
            if(!cTrN.chkMsk(v)) cTrN.chgTrN(v,null).addNr(j); /* Ref-Nr anpassen */
              /* Node-Index erhoehen falls keine NUll-Verkettung vorliegt */
          TrN.add(cTrN); /* neues TrackNode-Element setzen */
        } /* alle Elemente kopieren */
        TrN.trimToSize(); /* Speicher der TrackNode-Tabelle optimieren */
        cRte.setInt(t,i); /* neue Anzahl der Elemente eintragen */
      } /* TrackNode-DB vorhanden */

      j = t + 2; /* Kennung fuer Element-Speicher */
      cI = mRte.getIt(j); /* Iterator auf TrItem-Tabelle holen */
      if(cI!=null) { /* anzuhaengende TrItem-DB ist vorhanden */
        ItT = cRte.getTrI(t,0); /* aktuelle TrItemTabelle holen */
        i = mRte.get$TrI(t) + 10; /* neue Groesse der TrItem-DB */
          /* '10' ist Reserve, die mit 'trimToSize()' wieder freigegeben wird */
        if(ItT==null) ItT = cRte.getTrI(t,i); /* Neue TrItem-Tabelle erstellen und setzen */
        else ItT.ensureCapacity(ItT.size()+i); /* TrItem-Tabelle wurde neu erstellt/angepasst */
        i = ItT.size(); /* Anzahl der bereits vorhandenenen Elemente */
        /* 'i' ist neue Start-ID fuer die Erweiterung
         * (vergleiche Kommentar in 'putdb()' warum dies moeglich ist)
         */
        while(cI.hasNext()) { /* alle TrItem-Definitionen bearbeiten */
          cIt = (TSTrItm)cI.next(); /* naechste TrItem-Definition */
          if(cIt==null) continue; /* fehlender Eintrag nicht bearbeiten */
          cIt.setNr(i++); /* neue TrItem-Kennung eintragen und Benutzung zaehlen */
          ItT.add(cIt); /* Element an aktuelle Tabelle anfuegen */
        } /* alle TrItem-Elemente kopieren */
        ItT.trimToSize(); /* Speicher der TrItem-Tabelle optimieren */
      } /* TrItem-DB vorhanden */
    } /* beide Datenbank-Typen (tdb,rdb) */

    /* Weitere Dateien zusammenmischen */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("insrt030"); /* Aktion melden */

    j = mRte.set$Type(0); /* Anzahl der ttype-Definitionen */
    if(cRte.set$Type(0)<=0) { /* keine ttype-Definitionen der Basis */
      cRte.set$Type(j); /* neue ttype-Definitionen erstellen */
      for(i=0;i<j;i+=1) { /* alle Definitonen bearbeiten */
        cTp = mRte.chgType(i,null); /* aktuellen Eintrag holen */
        cRte.chgType(i,cTp); /* und neu setzen */
        SNme.add(cTp.getNme(1).toLowerCase()); /* Dateiname registrieren */
        SNme.add(cTp.getNme(2).toLowerCase()); /* Dateiname registrieren */
      } /* alle ttype-Definitionen kopieren */
    } else { /* ttype-Definitionen muessen hinzugefuegt werden */
      Lg.Skip(false); /* Leerzeile loggen */
      sdir = mRte.getFile(16); /* Basis-Source-Verzeichnis erstellen */
      for(i=0;i<j;i+=1) { /* alle Definitonen bearbeiten */
        cTp = mRte.chgType(i,null); /* aktuellen Eintrag holen */
        if((v=cRte.addType(cTp))>=0) cTp.chgNr(v);
          /* Eintrag schon vorhanden -- ID anpassen */
        else tty:{ /* Eintrag wurde hinzugefuegt -- SMS bearbeiten */
          v = -v - 1; /* aktuellen Index des Eintrags berechnen */
          is = cTp.getNme(1); /* ersten Dateinamen holen */
          if((i=cpySMS(cRte,sdir,is,v))>0) break tty;
          is = cTp.getNme(2); /* zweiten Dateinamen holen */
          if((i=cpySMS(cRte,sdir,is,v))>0) break tty;
        } /* hinzugefuegten Eintrag bearbeiten */
      } /* alle ttype-Definitionen bearbeiten */
    } /* Definitionen mischen */

    /* Signal-Dateien mischen */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("insrt040"); /* Aktion melden */

    if(mRte.get$SgS(false)>0) { /* Signal-Shape-Definitionen sind vorhanden */
      SgS = cRte.getSigS(0); /* aktuelle Signal-Shape-Definitionen holen */
      cI = mRte.getIt(21); /* Iterator ueber Signal-Shape-Definitionen holen */
      i = -1; /* Nummer des Shapes initialisieren */
      while(cI.hasNext()) { /* alle Signal-Shape-Definitionen bearbeiten */
        i += 1; /* Nummer des Shapes fortschreiben */
        if((cSgS=(TSSigSh)cI.next())==null) continue;
        if(cSgS.incCnt(0)==0) continue; /* Shape nicht genutzt */
        is = cSgS.getNme(); /* Shape-Name des Eintrags */
        if(cRte.fndSigS(is)!=null) { /* entry is already defined */
          if(EnaW) Lg.Log("insrt041",is,i,0); /* Meldung ausgeben */
          continue; /* check next entry */
        } /* entry is already defined -- check next entry */
        SgS.add(cSgS); /* Signal-Shape neu hinzufuegen */
        SNme.add(is.toLowerCase()); /* Shape-Name merken */
        SgSO = cSgS.getSOT(0); /* get current table of Signal-Sub-Objects */
        w = SgSO.size(); /* get number of defined Subobjects */
        for(j=0;j<w;j+=1) { /* alle Subobjekte bearbeiten */
          cSgSO = SgSO.get(j); /* Subobjekt-Definition */
          if(cSgSO==null) continue; /* keine Referenz vorhanden */
          cSgT = cSgSO.chgSigT(null); /* Type-Referenz holen */
          if(cSgT==null) continue; /* keine Referenz vorhanden */
          is = cSgT.getNme(); /* Type-Name des Eintrags */
          if((xSgT=cRte.fndSigT(is))!=null) { /* entry is already defined */
            Lg.Err("insrt043",is,i,j); /* Fehlermeldung ausgeben */
            cSgSO.chgSigT(xSgT); /* neue Type-Referenz einsetzen */
            continue; /* check next entry */
          } /* entry is already defined -- check next entry */
          cSgT.setMsk(31); /* Eintrag fuer das Mischen selektieren */
        } /* alle Subobjekte bearbeiten */
      } /* alle Signal-Shape-Definitionen kopieren */
    } /* neue Signal-Shape-Definitionen vorhanden */
    if(mRte.get$SgT(false)>0) { /* Signal-Type-Definitionen sind vorhanden */
      SgT = cRte.getSigT(0); /* aktuelle Signal-Type-Definitionen holen */
      cI = mRte.getIt(22); /* Iterator ueber Signal-Type-Definitionen holen */
      i = -1; /* Nummer des Types initialisieren */
      while(cI.hasNext()) { /* alle Signal-Type-Definitionen bearbeiten */
        i += 1; /* Nummer des Types fortschreiben */
        if((cSgT=(TSSigTyp)cI.next())==null) continue;
        if(!cSgT.chkMsk(31)) continue; /* Signaltype NICHT genutzt */
        SgT.add(cSgT); /* Signal-Type neu hinzufuegen */
        w = cSgT.get$SgL(0); /* Anzahl der verbundenen SignalLights */
        for(j=0;j<w;j+=1) { /* alle SignalLight-Def's bearbeiten */
          cSgSgL = cSgT.chgSgL(j,null); /* aktuelle SignalLight-Def. holen */
          if(cSgSgL==null) continue; /* keine Referenz -- weiter */
          cSgL = cSgSgL.chgLRef(null); /* Light-Referenz des Eintrags */
          if(cSgL==null) continue; /* keine SignalLight-Referenz vorhanden */
          if((xSgL=cRte.isSigL(cSgL))!=null) { /* entry is already defined */
            if(EnaW) Lg.Log("insrt044",null,i,j); /* Fehlermeldung ausgeben */
            cSgSgL.chgLRef(xSgL); /* neue Licht-Referenz einsetzen */
            xSgL.incCnt(1); /* neue Referenz zaehlen */
            continue; /* check next entry */
          } /* entry is already defined -- check next entry */
          /* keinen identischen Eintrag gefunden */
          is = js = cSgL.chgNme(null); /* Licht-Referenzname des Eintrags */
          while(cRte.fndSigL(is)!=null) is += "$"; /* Name veraendern */
          if(!js.equals(is)) { /* Name wurde veraendert! */
            if(EnaW) Lg.Log("insrt045",js,is,0); /* Meldung ausgeben */
            cSgL.chgNme(is); /* neuen Licht-Referenzname des Eintrags setzen */
          } /* Name angepasst weil mehrfach vorhanden */
          cSgL.setMsk(31); /* Eintrag fuer das Mischen selektieren */
        } /* alle SignalLight's bearbeiten */
        cSgX = cSgT.chgLTx(null); /* aktuelle SignalLight-Texture */
        if(cSgX!=null) { /* Referenz ist vorhanden */
          is = js = cSgX.chgNme(null); /* LichtTexturname des Eintrags */
          if((cSgX=cRte.isSigTx(cSgX))!=null) { /* entry already defined */
            if(EnaW) Lg.Log("insrt047",i); /* Fehlermeldung ausgeben */
            cSgT.chgLTx(cSgX); /* neue LightTexture-Referenz einsetzen */
            cSgX.incCnt(1); /* neue Referenz zaehlen */
            continue; /* check next entry */
          } /* entry already defined -- check next entry */
          cSgX = cSgT.chgLTx(null); /* Texturreferenz nochmal holen */
          while(cRte.fndSigX(is)!=null) is += "$"; /* Name veraendern */
          if(!js.equals(is)) { /* Name wurde veraendert! */
            if(EnaW) Lg.Log("insrt048",js,is,0); /* Meldung */
            cSgX.chgNme(is); /* neuen LichtTexturnamen des Eintrags setzen */
          } /* Name angepasst weil mehrfach vorhanden */
          cSgX.setMsk(31); /* Eintrag fuer das Mischen selektieren */
        } /* Signal-LightTexture-Referenz bearbeitet */
      } /* alle Signal-Type-Definitionen kopieren */
    } /* neue Signal-Type-Definitionen vorhanden */

    cI = mRte.getIt(23); /* Iterator ueber Signal-Light-Definitionen holen */
    if(cI!=null) { /* SignalLight-Definitionen (Tabelle) sind vorhanden */
      SgL = cRte.getSigL(0); /* Aktuelle Signal-Light-Tabelle holen */
      while(cI.hasNext()) { /* alle Signal-Light-Definitionen bearbeiten */
        if((cSgL=(TSSigLgt)cI.next())==null) continue;
        if(!cSgL.chkMsk(31)) continue; /* SignalLight NICHT genutzt */
        SgL.add(cSgL); /* Signal-Light neu hinzufuegen */
      } /* alle Signal-Light-Definitionen kopieren */
      SgL = null; /* Referenz nicht mehr genutzt */
    } /* neue SignalLight-Definitionen vorhanden */
    cI = mRte.getIt(24); /* Iterator ueber Signal-LTexture-Definitionen holen */
    if(cI!=null) { /* SignalLTexture-Definitionen (Tabelle) sind vorhanden */
      SgX = cRte.getSigLTx(0); /* Aktuelle Signal-LTexture-Tabelle holen */
      while(cI.hasNext()) { /* alle Signal-Light-Definitionen bearbeiten */
        if((cSgX=(TSSigLTx)cI.next())==null) continue;
        if(!cSgX.chkMsk(31)) continue; /* LightTexture NICHT genutzt */
        SgX.add(cSgX); /* Signal-LTexture neu hinzufuegen */
        cSgX.incFNme(XNme); /* Texturname in Liste aufnehmen */
      } /* alle Signal-LTexture-Definitionen kopieren */
      SgX = null; /* Referenz nicht mehr genutzt */
    } /* neue SignalLTexture-Definitionen vorhanden */

    SgF = mRte.getSigF(0); /* alle Script-Files (neu) holen */
    if(SgF!=null) if(SgF.size()>0) { /* Script-File-Definitionen sind da */
      cI = SgF.keySet().iterator(); /* Iterator der Script-Files holen */
      SgF = cRte.getSigF(0); /* alle Basis-Script-Files holen */
      while(cI.hasNext()) { /* alle neuen Script-Files bearbeiten */
        is = (String)cI.next(); /* Schluessel des Eintrags holen */
        cSgF = mRte.getSigF(0).get(is); /* Signalscript-Definition */
        dat = cSgF.getFile(mRte,1); /* Dateibeschreibung (Source) erstellen */
        js = dat.getAbsolutePath(); /* gesamter Dateiname (Quelle) erzeugen */
        v = 0; /* Modifikationen zaehlen */
        while(SgF.containsKey(is)) { /* Eintrag gibt es schon */
          is += "$"; /* Name leicht modifizieren */
          v += 1; /* und Veraenderung zaehlen */
        } /* Name ist eindeutig gemacht worden */
        cSgF = new TSSigFle(cSgF,v); /* Kopie mit neuem Namen erstellen */
        SgF.put(is,cSgF); /* und neuen Eintrag hinzufuegen */
        dat = cSgF.getFile(cRte,2); /* Dateibeschreibung (Ziel) erstellen */
        is = dat.getAbsolutePath(); /* gesamter Dateiname (Ziel) erzeugen */
        /* Kopieren der Signalscript-Datei unter (ggf) neuem Namen */
        js = "copy \""+js+"\" \""+is+"\" "; /* copy - Befehl erstellen */
        if((j=exec(true,js,null,null))>0) /* Fehler bei Ausfuehrung */
          Lg.Log("MsgC50",is,j); /* Fehlermeldung ausgeben */
      } /* alle Elemente kopieren */
    } /* neue Script-File-Definitionen vorhanden */
    Lg.Skip(false); /* Leerzeile loggen */

    /* Path-Definitionen werden gemischt */
    cI = mRte.getIt(17); /* Liste der Pfad-Definitionen holen */
    if(cI!=null || cRte.getIt(17)!=null) { /* Pfade sind INSGESAMT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("insrt050"); /* Aktion melden */
      FleT = cRte.getPath(); /* Liste der definierten Pfade holen */
      if(cI!=null) while(cI.hasNext()) { /* Weitere Pfad-Definition vorhanden */
        cPth = (TSPath)cI.next(); /* Pfad-Eintrag holen */
        if(cPth==null) throw new IllegalStateException( /* Sicherheitsabfrage */
          TSLogg.getMsg("Msg908","TSPath==null","insert",0));
        if(cPth.incCnt(0)==0) continue; /* Definition wird NICHT genutzt */
        is = cPth.getName(false); /* Namen der Pfad-Datei holen (Schluessel) */
        if(FleT.containsKey(is)) { /* Definition bereits vorhanden */
          Lg.Err("insrt051",cPth.getName(true)); /* Fehlermeldung ausgeben */
        } else FleT.put(is,cPth); /* Definition hinzufuegen */
      } /* alle Pfad-Definitionen bearbeiten */
      Lg.Log("insrt052",FleT.size()); /* neue Anzahl der Definitionen */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Pfad-Definition mussten bearbeitet werden */
    /* Service-Definitionen werden gemischt */
    cI = mRte.getIt(18); /* Liste der Service-Definitionen holen */
    if(cI!=null || cRte.getIt(18)!=null) { /* Services sind INSGESAMT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("insrt060"); /* Aktion melden */
      FleT = cRte.getServ(); /* Liste der definierten Services holen */
      if(cI!=null) while(cI.hasNext()) { /* Weitere Service-Definition vorhanden */
        cSrv = (TSSrv)cI.next(); /* Service-Eintrag holen */
        if(cSrv==null) throw new IllegalStateException( /* Sicherheitsabfrage */
          TSLogg.getMsg("Msg908","TSSrv==null","insert",0));
//        if(cSrv.incCnt(0)==0) continue; /* Definition wird NICHT genutzt */
        is = cSrv.getName(false); /* Namen der Service-Datei holen (Schluessel) */
        if(FleT.containsKey(is)) { /* Definition bereits vorhanden */
          Lg.Err("insrt061",cSrv.getName(true)); /* Fehlermeldung ausgeben */
        } else FleT.put(is,cSrv); /* Definition hinzufuegen */
      } /* alle Service-Definitionen bearbeiten */
      Lg.Log("insrt062",FleT.size()); /* neue Anzahl der Definitionen */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Service-Definition mussten bearbeitet werden */
    /* Traffic-Definitionen werden gemischt */
    cI = mRte.getIt(19); /* Liste der Traffic-Definitionen holen */
    if(cI!=null || cRte.getIt(19)!=null) { /* Traffic-Defs sind INSGESAMT vorhanden */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("insrt070"); /* Aktion melden */
      FleT = cRte.getTrf(); /* Liste der definierten Traffic's holen */
      if(cI!=null) while(cI.hasNext()) { /* Weitere Service-Definition vorhanden */
        cTrf = (TSTrf)cI.next(); /* Traffic-Eintrag holen */
        if(cTrf==null) throw new IllegalStateException( /* Sicherheitsabfrage */
          TSLogg.getMsg("Msg908","TSTrf==null","insert",0));
//        if(cTrf.incCnt(0)==0) continue; /* Definition wird NICHT genutzt */
        is = cTrf.getName(false); /* Namen der Traffic-Datei holen (Schluessel) */
        if(FleT.containsKey(is)) { /* Definition bereits vorhanden */
          Lg.Err("insrt071",cTrf.getName(true)); /* Fehlermeldung ausgeben */
        } else FleT.put(is,cTrf); /* Definition hinzufuegen */
      } /* alle Traffic-Definitionen bearbeiten */
      Lg.Log("insrt072",FleT.size()); /* neue Anzahl der Definitionen */
      Lg.Skip(false); /* Leerzeile loggen */
    } /* Traffic-Definition mussten bearbeitet werden */

    /* **************** ab hier: Ausgaben **************** */
    /* World-Dateien schreiben */
    i = putWF(cRte,null,true,false); /* World-Dateien schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    /* Sound-Dateien schreiben */
    i = putSF(cRte,null,true); /* Sound-Dateien schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    /* Schienendatenbank bearbeiten */
    i = putDBF(cRte,null,16); /* Schienendatenbank schreiben */
      /* Modus: neue UiD's verwenden */
    if(i>0) return i; /* Fehler beim Schreiben */

    /* Schienendatenbank (.tit) bearbeiten */
    i = putITF(cRte,null,0,false); /* Schienendatenbank schreiben */
    if(i>0) return i; /* Fehler beim Schreiben */

    if(cRte.get$TrN(1)>0) { /* Strassendatenbank vorhanden/geladen */
      /* Strassendatenbank bearbeiten */
      i = putDBF(cRte,null,17); /* Strassendatenbank schreiben */
        /* Modus: neue UiD's verwenden */
      if(i>0) return i; /* Fehler beim Schreiben */

      /* Strassendatenbank (.rit) bearbeiten */
      i = putITF(cRte,null,1,false); /* Strassendatenbank schreiben */
      if(i>0) return i; /* Fehler beim Schreiben */
    } /* Strassendatenbank vorhanden und geladen */

    /* "tsection.dat" (lokal) neu erstellen */
    i = putTSL(cRte,mRte,false); /* neue lokale 'tsection.dat' schreiben */
    if(i>0) return i; /* Fehler -- beenden */

    /* zusaetzliche Streckendateien laden */
    i = putType(cRte); /* 'ttype.dat' neu schreiben */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* Signal-Definitionen neu schreiben */
    i = putSCfg(cRte,null); /* Signal-Definitionen schreiben */
    if(i>0) return i; /* Fehler aufgetreten -- Abbruch */

    /* neue Struktur der besiedelten Quadrate erzeugen und ausgeben */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("insrt019"); /* Aktion melden */

    i = putTDF(cRte,null,0); /* Terrain-Datei (HI) erzeugen */
    if(i>0) return i; /* Fehler beim Schreiben */
    if(tdl1) { /* Lo-Tiles existieren */
      i = putTDF(cRte,null,1); /* Terrain-Datei (LO) erzeugen */
      if(i>0) return i; /* Fehler beim Schreiben */
    } /* Lo-Tiles sind vorhanden */

    /* Alle gemischten Definitionen fuer Activities schreiben */
    i = putPatF(cRte,null,2); /* Path-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */
    i = putSrvF(cRte,null,2); /* Service-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */
    i = putTrfF(cRte,null,2); /* Traffic-Definitionen neu schreiben */
    if(i>0) return i; /* Fehler -- abbrechen */
    i = putActF(cRte,null,2); /* Write Activities again (without errors) */
    if(i>0) return i; /* severe error -- terminate function */

    if(Fo.chkMsk(16)) prExtD(cRte); /* Zusaetzliche Definitionen ausgeben */
    if(Fo.chkMsk(16)) prExtD(mRte); /* Zusaetzliche Definitionen ausgeben */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("insrt029"); /* Abschluss melden */

    if(Fo.chkMsk(30)) Lg.Log("Msg015",getDate(0,true)); /* Timestamp ausgeben */
    Lg.Close(); /* close output to Log-file */
    return 0; /* Funktion ohne Fehler beenden */
  }

 /* ##+ (Eyecatcher)
  * Ende definierten Funktionen -- Unterroutinen folgen */

 /**. <pre>
  *=====================================================================
  * Method "getRte"
  * Analyse and check route-/system-definition
  * Typ:  0 - 'Nme' specifies Systempath
  *       1 - 'Nme' specifies Routepath, kein Zielverzeichnis
  *      >1 - 'Nme' specifies Routepath, Zielverzeichnis gefordert
  *       2 - 'Nme' specifies Routepath, create 'newRoute' ONLY
  * the following values may be multiplied to create multiple folders:
  *       3 - 'Nme' specifies Routepath, add. create 'newRoute/world'
  *       5 - 'Nme' specifies Routepath, add. create 'newRoute/tiles'
  *       7 - 'Nme' specifies Routepath, add. create 'newRoute/lo_tiles'
  *      11 - 'Nme' specifies Routepath, add. create 'newRoute/TD'
  *      13 - 'Nme' specifies Routepath, add. create 'newRoute/Sound'
  * ##getRte (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static TSRoute getRte( /* read and check route-definition */
   String Nme, /* file-/pathname of TS-System/TS-Route */
   int    typ) /* type of file and marker for folders */
   {
   /*-----------------------------------------------------------------*/
    String   TDir = "newRoute"; /* define name of target-directory */
   /*-----------------------------------------------------------------*/
    File       dir0,dir1,dir2,dats,dat; /* file-definitions */
    TSRoute    cRte; /* current route-definition */
    TSFile$trk cF;   /* handle for route-input-file */
    TSBuf      cB;   /* current input-buffer for 'read file' */
    TSQPos     cPos; /* current definiton of 'start-position' */
    int        i,l1;
    double     f;
    String[]   cL;   /* message-array for description */
    String     is;   /* reference to alternate 'tsection.dat' */
    String     Name,fNme,RteID;
    boolean    km,mh; /* Kilometer/Miles aktiv */
    boolean    OK;    /* Systemerror occurred */
   /*=================================================================*/
    typ = Math.max(typ,0); /* NO negative values allowed -- set default */

    /* 1. convert relative filename into absolute one */
    dir0 = new File(Nme); /* create directoryobject */
    dir0 = dir0.getAbsoluteFile(); /* and set new file-definition */
    Nme = dir0.getAbsolutePath(); /* extrace fully qualified pathname */

    /* 2. Process 'name' according to specified type */
    Name = null; /* preset: NO routename defined */
    dir1 = dats = null; /* preset: no route-path defined */
    if(typ>0) { /* pathname of ROUTE is specified */
      dir1 = dir0; /* establish route-definition (dir1) */
      if(!dir1.exists()) { /* routepath DO NOT exist */
        Lg.Skip(false); /* print empty line to logfile */
        Lg.Msg("getRte01",Nme); /* print termination-message */
        Lg.Close(); /* close output to Log-file */
        return null; /* terminate function with errorcode */
      } /* path missing -- terminate function with errorcode */
      if(!dir1.isDirectory()) { /* routepath is NOT a directory */
        Lg.Skip(false); /* print empty line to logfile */
        Lg.Msg("getRte02",Nme); /* print termination-message */
        Lg.Close(); /* close output to Log-file */
        return null; /* terminate function with errorcode */
      } /* routepath misdefined -- terminate function with errorcode */
      Name = dir1.getName(); /* get 'Name' of the route */
      dats = new File(dir1,Name+".trk"); /* and create file-definition */
      if(!dats.exists()) { /* file DOES NOT exist */
        Lg.Skip(false); /* print empty line to logfile */
        Lg.Msg("getRte03",Nme,dats.getName()); /* print termination-message */
        Lg.Close(); /* close output to Log-file */
        return null; /* terminate function with errorcode */
      } /* terminate function with errorcode */
      /* default: delete 'newroute'-directory if it already exits */
      is = "Del /Q /S " + TDir + " "; /* create delete-command */
      if((i=exec(true,is,dir1,null))>0) /* error while executing */
        Lg.Log("MsgC74",TDir,i); /* print error-message */

      i = Nme.toLowerCase().indexOf("\\routes");
      if(i<0) { /* systempath could not be extracted */
        Lg.Skip(false); /* print empty line to logfile */
        Lg.Msg("getRte04",Nme); /* print termination-message */
        Lg.Close(); /* close output to Log-file */
        return null; /* terminate function with errorcode */
      } /* path missing -- terminate function with errorcode */
      dir0 = new File(Nme.substring(0,i)); /* create systempath */
    } /* route-/systempath was checked */

    if(!dir0.exists()) { /* systempath DOES NOT exist */
      Lg.Skip(false); /* print empty line to logfile */
      Lg.Msg("getRte05",Nme); /* print termination-message */
      Lg.Close(); /* close output to Log-file */
      return null; /* terminate function with errorcode */
    } /* terminate function with errorcode */
    if(!dir0.isDirectory()) { /* systempath is NOT a directory */
      Lg.Skip(false); /* print empty line to logfile */
      Lg.Msg("getRte06",Nme); /* print termination-message */
      Lg.Close(); /* close output to Log-file */
      return null; /* terminate function with errorcode */
    } /* terminate function with errorcode */

    dir2 = new File(dir0,"global/tsection.dat");
    if(!dir2.exists()) { /* required file was NOT found */
      Lg.Skip(false); /* print empty line to logfile */
      Lg.Msg("getRte07",dir2.getPath()); /* print termination-message */
      Lg.Close(); /* close output to Log-file */
      return null; /* terminate function with errorcode */
    } /* file missing -- terminate function with errorcode */

    if((is=Fo.getDta(4,1))!=null) { /* different 'tsection.dat' specified */
      dir2 = new File(dir0,is); /* create file-definition for check */
      if(!dir2.exists()) { /* file was NOT found */
        Lg.Log("getRte08",dir2.getPath(),is); /* print message */
        is = null; /* do not use reference to file */
      } /* file was not found and invalidated */
    } /* diffrent 'tsection.dat' was checked */

    dir2 = null; /* preset: target-directory is NOT needed */
    if(typ>1) { /* Targetdirectory needed -- create basis-folder */
      dir2 = new File(dir1,TDir); /* create ref. to target-directory */
      if(!dir2.exists()) { /* Directory do NOT already exist */
        km = dir2.mkdir(); /* create it as requested */
        if(!km) { /* requested directory could not be created */
          Lg.Skip(false); /* print empty line to logfile */
          Lg.Msg("getRte10",Nme); /* print termination-message */
          Lg.Close(); /* close output to Log-file */
          return null; /* terminate function with errorcode */
        } /* directory missing -- terminate function with errorcode */
      } /* Zielverzeichnis wurde erstellt */
      if((typ%3)==0) { /* World-Unterverzeichnis gefordert */
        dat = new File(dir2,"world"); /* Ziel-Verzeichnis */
        if(!dat.exists()) { /* Verzeichnis existiert nicht */
          km = dat.mkdir(); /* Verzeichnis erstellen */
          if(!km) { /* Verzeichnis nicht erstellt */
            Lg.Skip(false); /* print empty line to logfile */
            Lg.Msg("getRte11",Nme); /* print termination-message */
            Lg.Close(); /* close output to Log-file */
            return null; /* terminate function with errorcode */
          } /* directory missing -- terminate function with errorcode */
        } /* gefordertes Unterverzeichnis angelegt */
      } /* bestimmtes Verzeichnis ist gefordert */
      if((typ%5)==0) { /* Tiles-Unterverzeichnis gefordert */
        dat = new File(dir2,"Tiles"); /* Ziel-Verzeichnis */
        if(!dat.exists()) { /* Verzeichnis existiert nicht */
          km = dat.mkdir(); /* Verzeichnis erstellen */
          if(!km) { /* Verzeichnis nicht erstellt */
            Lg.Skip(false); /* print empty line to logfile */
            Lg.Msg("getRte12",Nme); /* print termination-message */
            Lg.Close(); /* close output to Log-file */
            return null; /* terminate function with errorcode */
          } /* directory missing -- terminate function with errorcode */
        } /* gefordertes Unterverzeichnis angelegt */
      } /* bestimmtes Verzeichnis ist gefordert */
      if((typ%7)==0) { /* LO-Tiles-Unterverzeichnis gefordert */
        dat = new File(dir2,"LO_Tiles"); /* Ziel-Verzeichnis */
        if(!dat.exists()) { /* Verzeichnis existiert nicht */
          km = dat.mkdir(); /* Verzeichnis erstellen */
          if(!km) { /* Verzeichnis nicht erstellt */
            Lg.Skip(false); /* print empty line to logfile */
            Lg.Msg("getRte13",Nme); /* print termination-message */
            Lg.Close(); /* close output to Log-file */
            return null; /* terminate function with errorcode */
          } /* directory missing -- terminate function with errorcode */
        } /* gefordertes Unterverzeichnis angelegt */
      } /* bestimmtes Verzeichnis ist gefordert */
      if((typ%11)==0) { /* TD-Unterverzeichnis gefordert */
        dat = new File(dir2,"TD"); /* Ziel-Verzeichnis */
        if(!dat.exists()) { /* Verzeichnis existiert nicht */
          km = dat.mkdir(); /* Verzeichnis erstellen */
          if(!km) { /* Verzeichnis nicht erstellt */
            Lg.Skip(false); /* print empty line to logfile */
            Lg.Msg("getRte14",Nme); /* print termination-message */
            Lg.Close(); /* close output to Log-file */
            return null; /* terminate function with errorcode */
          } /* directory missing -- terminate function with errorcode */
        } /* gefordertes Unterverzeichnis angelegt */
      } /* bestimmtes Verzeichnis ist gefordert */
      if((typ%13)==0) { /* Sound-Unterverzeichnis gefordert */
        dat = new File(dir2,"Sound"); /* Ziel-Verzeichnis */
        if(!dat.exists()) { /* Verzeichnis existiert nicht */
          km = dat.mkdir(); /* Verzeichnis erstellen */
          if(!km) { /* Verzeichnis nicht erstellt */
            Lg.Skip(false); /* print empty line to logfile */
            Lg.Msg("getRte15",Nme); /* print termination-message */
            Lg.Close(); /* close output to Log-file */
            return null; /* terminate function with errorcode */
          } /* directory missing -- terminate function with errorcode */
        } /* gefordertes Unterverzeichnis angelegt */
      } /* bestimmtes Verzeichnis ist gefordert */
    } /* Zielverzeichnis wird benoetigt */

    cRte = new TSRoute(Name,dir0,dir1,dir2,dats); /* create preliminary route-def. */
    if(is!=null) dat = cRte.setTS(is); /* insert alternative 'tsection.dat'-file */
    if(typ==0) return cRte; /* Bearbeitung beendet -- Objekt liefern */

    /* Valid route-definition found -- read and check controlfile */
    cF = new TSFile$trk(dats); /* Eingabe-Steuerung erstellen */
    is = cF.open(TSFile.IN); /* Datei fuer Eingabe oeffnen */
    if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
      Lg.Skip(false); /* print empty line to logfile */
      Lg.Msg("getRte21",is); /* print termination-message */
      Lg.Close(); /* close output to Log-file */
      return null; /* terminate function with errorcode */
    } /* Fehler beim Oeffnen der Datenbank-Datei */
    cB = new TSBuf(cF); /* create inputline and init counter */

    RteID = null; /* vorbelegen: ID nicht gefunden */
    cPos  = null; /* initialize: 'RouteStart' not found */
    cL    = null; /* no description available */
    OK = false; /* Annehmen: Fehler aufgetreten */
    km = mh = false; /* noch keine Festlegung */
    fNme = Name; /* init Default */

    bl: { /* block for error-break */
      is = cB.getKE(true); /* get first controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getRte26"); /* print errormessage */
          break bl; /* terminate evaluation */
        } /* EOF within data -- terminate evaluation */
        Lg.Err("getRte22",is); /* print errormessage */
        break bl; /* terminate evaluation */
      } /* EOF within data -- terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getRte27"); /* print errormessage */
        break bl; /* terminate evaluation */
      } /* next keword not present -- terminate evaluation */
      if(!is.equals("tr_routefile")) { /* file-id is invalid */
        Lg.Err("getRte28",is); /* print errormessage */
        break bl; /* terminate evaluation */
      } /* file-id is invalid -- terminate evaluation */
      /* alle Definitionen der Streckendefinition bearbeiten */
      while(true) { /* alle Definitionen bearbeiten */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getRte29"); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* EOF within data -- terminate evaluation */
          Lg.Err("getRte21",is); /* print errormessage */
          break bl; /* terminate evaluation */
        } /* terminate evaluation */
        if(is.length()==0) break; /* all entries processed */
        l1 = cB.getBrL(); /* current bracket-level for terminate */
        if(is.equals("routeid")) { /* Definition-type: 'RouteID' */
          RteID = cB.getVal(1); /* get value of argument */
          if(RteID==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte30"); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte23",RteID); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if(RteID.length()==0) { /* next keword not present */
            Lg.Err("getRte31"); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* next keword not present -- terminate evaluation */
          if(!RteID.equalsIgnoreCase(Name)) /* incorrect Route-ID */
            Lg.Err("getRte32"); /* print errormessage */
        } else if(is.equals("name")) { /* Definition-type: 'Name' */
          is = cB.getVal(1); /* get value of argument (control-name) */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
               Lg.Err("getRte24","Name",cB.getStat(true)); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte25","Name",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if(is.length()==0) { /* value is not present */
            Lg.Err("getRte96","Name"); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* value is not present -- terminate evaluation */
          if((is=cRte.setDta(0,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","Name",is,0); /* print errormessage */
        } else if(is.equals("description")) { /* Definition-type: 'Description' */
          /* ACHTUNG: Wenn im Beschreibungsfeld eine Null-Kette vorliegt ("")
           * muss diese besonders beachtet werden */
          /* Attention: message may contain MORE than one line */
          cL = cB.getArr(); /* get value of argument  (message-array) */
          if(cL==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte24","Description",cB.getStat(true)); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte25","Description",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          /* message-array 'cL' is now valid */
        } else if(is.equals("graphic")) { /* Definition-type: 'Graphic' */
          /* content of line is not evaluated but stored */
          is = cB.skpVal(); /* get remaining value(s) within brackets */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte24","Graphic",cB.getStat(true)); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte25","Graphic",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if((is=cRte.setDta(1,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","Graphic",is,1); /* print errormessage */
        } else if(is.equals("loadingscreen")) { /* Definition-type: 'LoadingScreen' */
          /* content of line is not evaluated but stored */
          is = cB.skpVal(); /* get remaining value(s) within brackets */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte24","LoadingScreen",cB.getStat(true)); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte25","LoadingScreen",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if((is=cRte.setDta(2,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","LoadingScreen",is,2); /* print errormessage */
        } else if(is.equals("filename")) { /* Definition-type: 'FileName' */
          is = cB.getVal(1); /* get value of argument (control-name) */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte33"); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte23",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if(is.length()==0) { /* name is not present */
            Lg.Err("getRte34"); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* name is not present -- terminate evaluation */
          fNme = is; /* activate new value (control-name) */
        } else if(is.equals("electrified")) { /* Definition-type: 'Electrified' */
          i = cB.getHV(8); /* get value of argument (Hex-number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getRte35",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* error while evaluating -- terminate evaluation */
          if((i=cRte.setInt(2,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
            Lg.Err("getRte95","Electrified",i,102); /* print errormessage */
        } else if(is.equals("mountains")) { /* Definition-type: 'Mountains' */
          i = cB.getHV(8); /* get value of argument (Hex-number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getRte36",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* error while evaluating -- terminate evaluation */
          if((i=cRte.setInt(3,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
            Lg.Err("getRte95","Mountains",i,103); /* print errormessage */
        } else if(is.equals("overheadwireheight")) { /* Definition-type: 'OverheadWireHeight' */
          f = cB.getFV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getRte37",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* error while evaluating -- terminate evaluation */
          if(!Double.isNaN(f=cRte.setFlt(2,2,f))) /* value already set -- replaced */
            Lg.Err("getRte95","OverHeadWireHeight",""+f,200); /* print errormessage */
        } else if(is.equals("passengerruleset")) { /* Definition-type: 'PassengerRuleSet' */
          /* content of line is not evaluated but stored */
          is = cB.skpVal(); /* get remaining value(s) within brackets */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte24","PassengerRuleSet",cB.getStat(true)); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte25","PassengerRuleSet",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if((is=cRte.setDta(10,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","PassengerRuleSet",is,10); /* print errormessage */
        } else if(is.equals("freightruleset")) { /* Definition-type: 'FreightRuleSet' */
          /* content of line is not evaluated but stored */
          is = cB.skpVal(); /* get remaining value(s) within brackets */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte24","FreightRuleSet",cB.getStat(true)); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte25","FreightRuleSet",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if((is=cRte.setDta(11,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","FreightRuleSet",is,11); /* print errormessage */
        } else if(is.equals("signalset")) { /* Definition-type: 'SignalSet' */
          /* content of line is not evaluated but stored */
          is = cB.skpVal(); /* get remaining value(s) within brackets */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte24","SignalSet",cB.getStat(true)); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte25","SignalSet",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if((is=cRte.setDta(12,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","SignalSet",is,12); /* print errormessage */
        } else if(is.equals("gantryset")) { /* Definition-type: 'GantrySet' */
          /* content of line is not evaluated but stored */
          is = cB.skpVal(); /* get remaining value(s) within brackets */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte24","GantrySet",cB.getStat(true)); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte25","GantrySet",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if((is=cRte.setDta(13,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","GantrySet",is,13); /* print errormessage */
        } else if(is.equals("trackgauge")) { /* Definition-type: 'TrackGauge' */
          /* content of line is not evaluated but stored */
          is = cB.skpVal(); /* get remaining value(s) within brackets */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte24","TrackGauge",cB.getStat(true)); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte25","TrackGauge",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if((is=cRte.setDta(14,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","TrackGauge",is,14); /* print errormessage */
        } else if(is.equals("era")) { /* Definition-type: 'Era' */
          /* content of line is not evaluated but stored */
          is = cB.skpVal(); /* get remaining value(s) within brackets */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte24","Era",cB.getStat(true)); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte25","Era",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if((is=cRte.setDta(15,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","Era",is,15); /* print errormessage */
        } else if(is.equals("speedlimit")) { /* Definition-type: 'SpeedLimit' */
          f = cB.getFV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getRte38",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* error while evaluating -- terminate evaluation */
          if(!Double.isNaN(f=cRte.setFlt(2,3,f))) /* value already set -- replaced */
            Lg.Err("getRte95","SpeedLimit",""+f,201); /* print errormessage */
        } else if(is.equals("environment")) { /* Definition-type: 'Environment' */
          while(true) { /* process all (allowed) definition-types */
            is = cB.getKE(true); /* get next controlword */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getRte26"); /* print errormessage */
                break bl; /* terminate evaluation */
              } /* EOF within data -- terminate evaluation */
              Lg.Err("getRte22",is); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* terminate evaluation */
            if(is.length()==0) break; /* all entries processed */
            for(i=0;i<TSRoute.envNme.length;i+=1) /* check keywords */
              if(is.equalsIgnoreCase(TSRoute.envNme[i])) break; /* requested keyword found */
            if(i>=TSRoute.envNme.length) { /* requested keyword not found */
              Lg.Err("getRte22",is); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* requested keyword not found -- terminate evaluation */
            is = cB.skpVal(); /* get remaining value(s) within brackets */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getRte24","Environment-"+TSRoute.envNme[i],cB.getStat(true));
                break bl; /* terminate evaluation */
              } /* EOF within data -- terminate evaluation */
              Lg.Err("getRte25","Environment-"+TSRoute.envNme[i],is); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* terminate evaluation */
            is = TSRoute.envNme[i] + " ( " + is + " )"; /* create line again */
            if((is=cRte.setDta(i+20,is))!=null) /* value already set -- replaced */
              Lg.Err("getRte95","Environment-"+TSRoute.envNme[i],is,i+20); /* print errormessage */
            if(cB.skpFwd()) break bl; /* skip resuming data to new entry -- EOF/error found? */
          } /* alle moeglichen Sub-Definitionen */
        } else if(is.equals("terrainerrorscale")) { /* Definition-type: 'TerrainErrorScale' */
          f = cB.getFV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getRte39",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if(!Double.isNaN(f=cRte.setFlt(2,4,f))) /* value already set -- replaced */
            Lg.Err("getRte95","TerrainErrorScale",""+f,202); /* print errormessage */
        } else if(is.equals("routestart")) { /* Definition-type: 'RouteStart' */
          /* load position-values (qx qz x z) and check them */
          if((is=getPos(cB,false,true))!=null) { /* error within position */
            Lg.Err("getRte25","RouteStart",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* error within position -- terminate evaluation */
          cPos = (TSQPos)RetVal; /* get valid position-definition */
        } else if(is.equals("milepostunitskilometers")) { /* Def.-type: 'MilepostUnitsKilometers' */
          if(mh) Lg.Err("getRte42"); /* Meilen schon spezifiziert -- Fehlermeldung ausgeben */
          km = true; /* merken dass spezifiziert */
        } else if(is.equals("milepostunitsmiles")) { /* Definition-type: 'MilepostUnitsMiles' */
          if(km) Lg.Err("getRte43"); /* Kilometer schon spezifiziert -- Fehlermeldung ausgeben */
          mh = true; /* merken dass spezifiziert */
        } else if(is.equals("maxlinevoltage")) { /* Definition-type: 'MaxLineVoltage' */
          f = cB.getFV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getRte44",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* error while evaluating -- terminate evaluation */
          if(!Double.isNaN(f=cRte.setFlt(2,5,f))) /* value already set -- replaced */
            Lg.Err("getRte95","MaxLineVoltage",""+f,203); /* print errormessage */
        } else if(is.equals("defaultsignalsms")) { /* Definition-type: 'DefaultSignalSMS' */
          is = cB.getVal(1); /* get value of argument */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte45"); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte23",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if(is.length()==0) { /* value is not present */
            Lg.Err("getRte46"); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* value is not present -- terminate evaluation */
          if((is=cRte.setDta(3,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","DefaultSignalSMS",is,3); /* print errormessage */
        } else if(is.equals("defaultcrossingsms")) { /* Definition-type: 'DefaultCrossingSMS' */
          is = cB.getVal(1); /* get value of argument */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte47"); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte23",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if(is.length()==0) { /* value is not present */
            Lg.Err("getRte48"); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* value is not present -- terminate evaluation */
          if((is=cRte.setDta(4,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","DefaultCrossingSMS",is,4); /* print errormessage */
        } else if(is.equals("defaultwatertowersms")) { /* Definition-type: 'DefaultWaterTowerSMS' */
          is = cB.getVal(1); /* get value of argument */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte49"); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte23",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if(is.length()==0) { /* value is not present */
            Lg.Err("getRte50"); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* value is not present -- terminate evaluation */
          if((is=cRte.setDta(5,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","DefaultWaterTowerSMS",is,5); /* print errormessage */
        } else if(is.equals("defaultcoaltowersms")) { /* Definition-type: 'DefaultCoalTowerSMS' */
          is = cB.getVal(1); /* get value of argument */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte51"); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte23",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if(is.length()==0) { /* value is not present */
            Lg.Err("getRte52"); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* value is not present -- terminate evaluation */
          if((is=cRte.setDta(6,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","DefaultCoalTowerSMS",is,6); /* print errormessage */
        } else if(is.equals("defaultdieseltowersms")) { /* Definition-type: 'DefaultDieselTowerSMS' */
          is = cB.getVal(1); /* get value of argument */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte53"); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte23",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if(is.length()==0) { /* value is not present */
            Lg.Err("getRte54"); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* value is not present -- terminate evaluation */
          if((is=cRte.setDta(7,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","DefaultDieselTowerSMS",is,7); /* print errormessage */
        } else if(is.equals("temprestrictedspeed")) { /* Definition-type: 'TempRestrictedSpeed' */
          f = cB.getFV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getRte55",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* error while evaluating -- terminate evaluation */
          if(!Double.isNaN(f=cRte.setFlt(2,6,f))) /* value already set -- replaced */
            Lg.Err("getRte95","TempRestrictedSpeed",""+f,204); /* print errormessage */
        } else if(is.equals("derailscale")) { /* Definition-type: 'DerailScale' */
          /* content of line is not evaluated but stored */
          is = cB.skpVal(); /* get remaining value(s) within brackets */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte24","DerailScale",cB.getStat(true)); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte25","DerailScale",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if((is=cRte.setDta(16,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","DerailScale",is,16); /* print errormessage */
        } else if(is.equals("timetabletollerance")) { /* Definition-type: 'TimetableTollerance' */
          /* content of line is not evaluated but stored */
          is = cB.skpVal(); /* get remaining value(s) within brackets */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte24","TimetableTollerance",cB.getStat(true)); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte25","TimetableTollerance",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if((is=cRte.setDta(17,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","TimetableTollerance",is,17); /* print errormessage */
        } else if(is.equals("gravityscale")) { /* Definition-type: 'GravityScale' */
          /* content of line is not evaluated but stored */
          is = cB.skpVal(); /* get remaining value(s) within brackets */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRte24","GravityScale",cB.getStat(true)); /* print errormessage */
              break bl; /* terminate evaluation */
            } /* EOF within data -- terminate evaluation */
            Lg.Err("getRte25","GravityScale",is); /* print errormessage */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if((is=cRte.setDta(18,is))!=null) /* value already set -- replaced */
            Lg.Err("getRte95","GravityScale",is,18); /* print errormessage */
        } else /* Schluesselwort nicht bearbeiten */
          Lg.Err("getRte98",is); /* Fehlermeldung ausgeben */
        if(cB.skpFwd(l1)) break bl; /* skip resuming data to new entry -- EOF/error found? */
      } /* -while- process all definitions */
      if(cB.skpFwd()) break bl; /* skip resuming data to new entry -- EOF/error found? */
        /* really: no more data skipped here */

      if((i=cRte.setInt(6,cF.getTyp()))!=Integer.MIN_VALUE) /* value already set -- replaced */
        Lg.Err("getRte95","File-ID:*.trk",i,106); /* print errormessage */

      if(!mh) km = true; /* Default nutzen */
      cRte.setVal(fNme,RteID,cL,cPos,km); /* Daten erfolgreich bearbeitet -- Objekt veraendern */
      OK = true; /* Datenpruefung erfolgreich -- Status setzen */
    } /* -bl- break-block used in case of error */

    is = cF.close(); /* Eingabe-Datei schliessen */
    if(is!=null) Lg.Err("getRte21",is); /* Meldung ausgeben */

    if(OK) return cRte; /* Streckendefinition liefern */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("getRte99"); /* Fehlermeldung ausgeben */
    Lg.Close(); /* close output to Log-file */
    return null; /* terminate function completely */
  }

 /**. <pre>
  *=====================================================================
  * Method "putRte"
  * Create and write route-definition-basis-file (.trk)
  * ##putRte (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int putRte( /* create route-definition-file */
   TSRoute cRte, /* current route-definition */
   File    tdat) /* file-definition of intermediate file */
   {
   /*-----------------------------------------------------------------*/
    File       dat;   /* file-definition output */
    TSFile$trk cF;    /* Writer of route-file */
    int        i,cc;  /* current condition-code */
    double     f;     /* intermediate value */
    String     is,js; /* intermediate values */
   /*=================================================================*/
    Lg.Skip(true); /* print empty line to log and screen */
    Lg.Msg("putRte00",cRte.getInfo(1)); /* print description of next action */

    if(tdat==null) { /* explicit target-directory is NOT specified */
      dat = cRte.getFile(32); /* get default target-file */
      if(dat==null) throw new IllegalStateException( /* security-query */
        TSLogg.getMsg("Msg908","File==null","TSUtil.putRte()",1));
    } else dat = tdat; /* target is 'temporary file' */

    if((i=cRte.getInt(6))==Integer.MIN_VALUE) { /* missing subtype */
      Lg.Err("putRte01",dat.getPath()); /* print messaga */
      i = 0; /* use default-value of subtype */
    } /* subtype-number is now valid */
    cF = new TSFile$trk(dat); /* create output-control of file */
    if((is=cF.setTyp(i))!=null) Lg.Err("putRte02",is);

    is = cF.open(TSFile.OUT); /* open file for output */
    if(is!=null) { /* error occured during 'open' */
      Lg.Skip(false); /* print empty line to log-file */
      Lg.Msg("putRte03",is); /* print error-message (terminating) */
      return 5; /* return and terminate program */
    } /* error occured during 'open' */

    bl: { /* Break-Block (used if write-error occurred) */
      is = "Tr_RouteFile ("; /* create first line (Basis) */
      cc = 10; /* preset Condition-Code in case of error */
      if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      is = cRte.chgRte(null); /* get current Route-ID */
      is = "\tRouteID ( " + modStr(is) + " )"; /* create final line */
      cc = 11; /* preset Condition-Code in case of error */
      if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      if((is=cRte.getDta(0))!=null) { /* value available -- write it */
        is = "\tName ( " + modStr(is) + " )"; /* create final line */
        cc = 12; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","Name"); /* print warning */
      for(i=0;i<500;i+=1) { /* write all avalilable lines (max. 500 lines) */
        is = cRte.crDesc(i); /* get Description-line */
        if(is==null) break; /* no more lines -- terminate loop */
        cc = 13; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } /* check all lines and write them */
      if((is=cRte.getDta(1))!=null) { /* value available -- write it */
        is = "\tGraphic (" + is + ")"; /* create final line */
        cc = 14; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","Graphic"); /* print warning */
      if((is=cRte.getDta(2))!=null) { /* value available -- write it */
        is = "\tLoadingScreen (" + is + ")"; /* create final line */
        cc = 15; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","LoadingScreen"); /* print warning */
      is = cRte.crDef(-1); /* get Filename-definition */
      cc = 16; /* preset Condition-Code in case of error */
      if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      if((i=cRte.getInt(2))!=Integer.MIN_VALUE) { /* value available -- write it */
        is = "\tElectrified ( " + TSUtil.toHex(i,-8) + " )"; /* create final line */
        cc = 17; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","Electrified"); /* print warning */
      if((i=cRte.getInt(3))!=Integer.MIN_VALUE) { /* value available -- write it */
        is = "\tMountains ( " + TSUtil.toHex(i,-8) + " )"; /* create final line */
        cc = 18; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","Mountains"); /* print warning */
      if(!Double.isNaN(f=cRte.getFlt(2,2))) { /* value available -- write it */
        is = "\tOverheadWireHeight (" + putFV(f,0) + " )"; /* create final line */
        cc = 19; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","OverheadWireHeight"); /* print warning */
      if((is=cRte.getDta(10))!=null) { /* value available -- write it */
        is = "\tPassengerRuleSet (" + is + ")"; /* create final line */
        cc = 20; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","PassengerRuleSet"); /* print warning */
      if((is=cRte.getDta(11))!=null) { /* value available -- write it */
        is = "\tFreightRuleSet (" + is + ")"; /* create final line */
        cc = 21; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","FreightRuleSet"); /* print warning */
      if((is=cRte.getDta(12))!=null) { /* value available -- write it */
        is = "\tSignalSet (" + is + ")"; /* create final line */
        cc = 22; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","SignalSet"); /* print warning */
      if((is=cRte.getDta(13))!=null) { /* value available -- write it */
        is = "\tGantrySet (" + is + ")"; /* create final line */
        cc = 23; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","GantrySet"); /* print warning */
      if((is=cRte.getDta(14))!=null) { /* value available -- write it */
        is = "\tTrackGauge (" + is + ")"; /* create final line */
        cc = 24; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","TrackGauge"); /* print warning */
      if((is=cRte.getDta(15))!=null) { /* value available -- write it */
        is = "\tEra (" + is + ")"; /* create final line */
        cc = 25; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","Era"); /* print warning */
      if(!Double.isNaN(f=cRte.getFlt(2,3))) { /* value available -- write it */
        is = "\tSpeedLimit (" + putFV(f,0) + " )"; /* create final line */
        cc = 26; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","SpeedLimit"); /* print warning */
      is = "\tEnvironment ("; /* create first line (Basis) */
      cc = 27; /* preset Condition-Code in case of error */
      if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      for(i=0;i<TSRoute.envNme.length;i+=1) /* write all environment-def's */
       if((is=cRte.getDta(i+20))!=null) { /* value available -- write it */
        is = "\t\t" + is; /* create final line */
        cc = 28; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","Environment-"+TSRoute.envNme[i]);
      cc = 29; /* preset Condition-Code in case of error */
      if((is=cF.putData("\t)"))!=null) break bl; /* Write-error - terminate */
      if(!Double.isNaN(f=cRte.getFlt(2,4))) { /* value available -- write it */
        is = "\tTerrainErrorScale (" + putFV(f,0) + " )"; /* create final line */
        cc = 30; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","TerrainErrorScale"); /* print warning */
      is = cRte.crDef(-2); /* get 'RouteStart'-definition */
      cc = 31; /* preset Condition-Code in case of error */
      if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      if(cRte.chkMsk(16)) { /* line is requested -- write it */
        is = "\tMilepostUnitsKilometers ( )"; /* create final line */
        cc = 32; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } /* line was written */
      if(cRte.chkMsk(17)) { /* line is requested -- write it */
        is = "\tMilepostUnitsMiles ( )"; /* create final line */
        cc = 33; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } /* line was written */
      if(!Double.isNaN(f=cRte.getFlt(2,5))) { /* value available -- write it */
        is = "\tMaxLineVoltage (" + putFV(f,0) + " )"; /* create final line */
        cc = 34; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","MaxLineVoltage"); /* print warning */
      if((is=cRte.getDta(3))!=null) { /* value available -- write it */
        is = "\tDefaultSignalSMS ( " + modStr(is) + " )"; /* create final line */
        cc = 35; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","DefaultSignalSMS");  /* print warning */
      if((is=cRte.getDta(4))!=null) { /* value available -- write it */
        is = "\tDefaultCrossingSMS ( " + modStr(is) + " )"; /* create final line */
        cc = 36; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","DefaultCrossingSMS"); /* print warning */
      if((is=cRte.getDta(5))!=null) { /* value available -- write it */
        is = "\tDefaultWaterTowerSMS ( " + modStr(is) + " )"; /* create final line */
        cc = 37; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","DefaultWaterTowerSMS"); /* print warning */
      if((is=cRte.getDta(6))!=null) { /* value available -- write it */
        is = "\tDefaultCoalTowerSMS ( " + modStr(is) + " )"; /* create final line */
        cc = 38; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","DefaultCoalTowerSMS"); /* print warning */
      if((is=cRte.getDta(7))!=null) { /* value available -- write it */
        is = "\tDefaultDieselTowerSMS ( " + modStr(is) + " )"; /* create final line */
        cc = 39; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","DefaultDieselTowerSMS"); /* print warning */
      if(!Double.isNaN(f=cRte.getFlt(2,6))) { /* value available -- write it */
        is = "\tTempRestrictedSpeed (" + putFV(f,0) + " )"; /* create final line */
        cc = 40; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","TempRestrictedSpeed"); /* print warning */
      if((is=cRte.getDta(16))!=null) { /* value available -- write it */
        is = "\tDerailScale (" + is + ")"; /* create final line */
        cc = 41; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","DerailScale"); /* print warning */
      if((is=cRte.getDta(17))!=null) { /* value available -- write it */
        is = "\tTimetableTollerance (" + is + ")"; /* create final line */
        cc = 42; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","TimetableTollerance"); /* print warning */
      if((is=cRte.getDta(18))!=null) { /* value available -- write it */
        is = "\tGravityScale (" + is + ")"; /* create final line */
        cc = 43; /* preset Condition-Code in case of error */
        if((is=cF.putData(is))!=null) break bl; /* Write-error - terminate */
      } else if(EnaW) Lg.Log("putRte04","GravityScale"); /* print warning */
      cc = 44; /* preset Condition-Code in case of error */
      if((is=cF.putData(")"))!=null) break bl; /* Write-error - terminate */
      cc = 49; /* preset position of error */
      is = TSLogg.getMsg("Msg100","Route"); /* create TSUtil-ID-Line */
      if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
      cc = 0; /* signal: no error */
    } /* -bl- break-block used in case of error */
    if(is!=null) Lg.Err("putRte03",is); /* message pending -- print it */

    is = cF.close(); /* close Output-file -- error? */
    if(is!=null) Lg.Err("putRte03",is); /* print error-message */

    /* copy created file if 'overwrite'-mode is requested */
    if(cc>0) return cc; /* error -- do not copy file */
    if(tdat==null) return 0; /* do not overwrite original file */
    is = cRte.getInfo(31); /* filename of source-file (now target) */
    js = "copy \""+tdat.getAbsolutePath()+"\" \""+is+"\" ";
    if((i=exec(true,js,null,Lg))>0) /* error while executing */
      Lg.Log("MsgC49",is,i); /* print error-message */

    return 0; /* function successfully processed */
  }

 /**. <pre>
  *=====================================================================
  * Method "getPos"
  * Check position-definition and create positionobject if successful.
  *   Format of (extended) position is: 'qx qz x z' or 'qx qz x y z'
  * Attention: 'RetVal' will obtain the result-object
  * Attention: Method shares message-IDs with 'chkPos()'-method
  * Methode is referenced within:
  *  'getRte()', 'getWrld()', 'getDBF()', 'getActF()' 'getActEv()',
  *    'getPatF()'
  * ##getPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getPos( /* check position-definition */
   TSBuf   cB,  /* definiton of current input-buffer */
   boolean hgt, /* get height-value if 'true' */
   boolean chk) /* check range of values if 'true' */
   {
   /*-----------------------------------------------------------------*/
    int    qx,qz;    /* intermediate results */
    double fx,fy,fz; /* intermediate results */
    String is;       /* current error-message */
   /*=================================================================*/
    qx = (int)cB.getNV(); /* get X-Quad of position */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getPos1",is);
    qz = (int)cB.getNV(); /* get Z-Quad of position */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getPos2",is);
    fx = cB.getFV(); /* get value of argument (X-position) */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getPos3",is);
    if(chk) { /* check range and terminate if error */
      if(fx< -1024.0) return TSLogg.getMsg("getPos4",fx); /* error */
      if(fx>  1024.0) return TSLogg.getMsg("getPos5",fx); /* error */
    } /* range must be checked */
    if(hgt) { /* height-value is available -- get it */
      fy = cB.getFV(); /* get value of argument (Y-position) */
      if((is=cB.getErr())!=null) return TSLogg.getMsg("getPos6",is);
    } else fy = 0.0; /* height-value not available -- set default */
    fz = cB.getFV(); /* get value of argument (Z-position) */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getPos7",is);
    if(chk) { /* check range and terminate if error */
      if(fz< -1024.0) return TSLogg.getMsg("getPos8",fz); /* error */
      if(fz>  1024.0) return TSLogg.getMsg("getPos9",fz); /* error */
    } /* range must be checked */

    RetVal = new TSQPos(qx,qz,new TSPos(fx,fy,fz)); /* create position */
    return null; /* return with 'no error' */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTS"
  * Laden der Datei 'tsection.dat' (globale Form) in den Speicher
  * 'ShTab' erhaelt Shape-Definitionen
  * 'ScTab' erhaelt Section-Definitionen
  * 'ScN' erhaelt max. Anzahl der Section-Definitionen
  * 'ShN' erhaelt max. Anzahl der Shape-Definitionen
  * 'c3' erhaelt Anzahl der Saetze in der Datei
  * 'c2' erhaelt akuelle Anzahl der Section-Definitionen
  * 'c4' erhaelt aktuelle Anzahl der Shape-Definitionen
  * Beziehungen : ScN = ScTab.length, ShN = ShTab.length
  * Shape-Optionen: 2 - RoadShape()
  *                 3 - TunnelShape()
  *                 5 - ManualJunctionShape()
  *                 7 - CrossoverShape()
  * ##getTS (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getTS( /* globale tsection.dat laden */
   File dat, /* Datei-Beschreibung zum Laden */
   File ShD) /* Shape-Verzeichnis wenn Pruefung gewuenscht */
   {
   /*-----------------------------------------------------------------*/
    File       cFle; /* current shape-file to be checked */
    TSFileX    cF;   /* current input-file */
    TSBuf      cB;   /* current input-buffer for 'read file' */
    TSShape    cSh;  /* current shape-definition */
    TSScIdx[]  ScI;
    TSSect     cSc;  /* current section-definition */
    TSPos[]    ScPt; /* 'CrossoverPoints' */
    int        l1,l2,l3,cc,ec; /* intermediate values */
    int        i,j,k,w,MR;
    double     clr;
    double     f,fx,fy,fz; /* intermediate values */
    String     is;
   /*=================================================================*/
    /* Eingabe-Datei "tsection.dat" oeffnen */
    cF = new TSFileX(TSFileX.FT$gts,dat); /* Eingabe-Steuerung erst. */
    is = cF.open(false); /* Datei fuer Eingabe oeffnen */
    if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("getTS001",is); /* Abbruchmeldung ausgeben */
      Lg.Skip(false); /* Leerzeile Loggen */
      return 5; /* System beenden */
    } /* Fehler beim Oeffnen der Datenbank-Datei */

    cc = 0; /* aktuellen Condition-Code initialisieren */
    ec = 0; /* Zaehler fuer Fehler initialisieren */
    cB = new TSBuf(cF); /* create inputbuffer and init counter */
    bl: { /* Break-Block (used with errors) */
      is = cB.getKE(true); /* get first controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getTS011"); /* print errormessage */
          cc = 4; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getTS012",is); /* print errormessage */
        cc = 5; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getTS013"); /* print errormessage */
        cc = 6; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(!is.equals("tracksections")) {  /* 'TrackSections' not found */
        Lg.Err("getTS014",is); /* print errormessage */
        cc = 7; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      ScN = (int)cB.getNV(); /* get number of tracksections */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        Lg.Err("getTS015",is,cB.getStat(true)); /* print errormessage */
        cc = 8; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(ScN%2!=0) { /* number of definitions must be even */
        Lg.Err("getTS016",ScN); /* Wert muss gerade sein */
        ScN += 1; /* Wert gerade machen */
      } /* number of section-definitions is corrected */
      ScTab = new TSSect[ScN]; /* create table for section-definitions */
      Arrays.fill(ScTab,null); /* initialize table (no valid entries) */

      /* process section-definitions */
      l1 = cB.getBrL(); /* current bracket-level for terminate */
      c2 = 0; /* counter of Track-Sections */
      while(true) { /* process all section-definitions */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getTS051"); /* print errormessage */
            cc = 11; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getTS052",is); /* print errormessage */
          ec += 1; /* count error */
          break; } /* terminate evaluation */
        if(is.length()==0) break; /* no more kewords present */
        if(!is.equals("tracksection")) {  /* 'TrackSection' not found */
          Lg.Err("getTS053",is); /* print errormessage */
          ec += 1; /* count error */
          break; } /* terminate evaluation */
        j = (int)cB.getNV(); /* get id-number of section */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getTS054",is,cB.getStat(true)); /* print errormessage */
          ec += 1; /* count error */
          break; } /* terminate evaluation */
        if(j<0 || j>=ScN) { /* ID-number (index) of section is invalid */
          Lg.Err("getTS055",""+cB.getStat(true),j,ScN); /* print errormessage */
          ec += 1; /* count error */
          break; } /* terminate evaluation */
        if(ScTab[j]!=null) { /* entry of section-table already used */
          Lg.Err("getTS056",j); /* print errormessage */
          ec += 1; /* count error */
          break; } /* terminate evaluation */
        l2 = cB.getBrL(); /* current bracket-level for terminate */
        cSc = null; /* section is NOT defined until now */
        sscl:while(true) { /* process all sub-sections */
          is = cB.getKE(true); /* get next controlword */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getTS061"); /* print errormessage */
              cc = 12; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getTS062",is,j); /* print errormessage */
            ec += 1; /* count error */
            break; } /* terminate evaluation */
          if(is.length()==0) break; /* no more kewords present */
          if(is.equals("sectionsize")) { /* Definition-type: 'SectionSize' */
            fx = cB.getFV(); /* get value of argument (number) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTS071",is,j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            fy = cB.getFV(); /* get next value of argument (number) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTS072",is,j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(cSc!=null) { /* sequence-error: 'SectionSize' already specified */
              Lg.Err("getTS073",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            cSc = new TSSect(j,fx,fy); /* create current section-definition */
          } else if(is.equals("sectioncurve")) { /* Definition-type: 'SectionCurve' */
            fx = cB.getFV(); /* get value of argument (number) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTS075",is,j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            fy = cB.getFV(); /* get next value of argument (number) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTS076",is,j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(cSc==null) { /* sequence-error: 'SectionSize' not specified */
              Lg.Err("getTS077",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if((is=cSc.setCrv(fx,fy))!=null) { /* error within section-definition */
              Lg.Err("getTS078",is,j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
          } else if(is.equals("sectionskew")) { /* Definition-type: 'SectionSkew' */
            f = cB.getFV(); /* get value of argument (number) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTS081",is,j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(cSc==null) { /* sequence-error: 'SectionSize' not specified */
              Lg.Err("getTS082",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if((is=cSc.setSkew(f))!=null) { /* error within section-definition */
              Lg.Err("getTS083",is,j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
          } else if(is.equals("waterscoop")) { /* Definition-type: 'WaterScoop' */
            if(cSc==null) { /* sequence-error: 'SectionSize' not specified */
              Lg.Err("getTS085",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(cSc.chgWS(true)) { /* attribute was already specified */
              Lg.Err("getTS086",j); /* print errormessage */
              ec += 1; /* count error */
            } /* do not terminate evaluation -- just ignore it */
          } else { /* invalid keyword -- do not process */
            Lg.Err("getTS063",is,j); /* print errormessage */
            ec += 1; /* count error */
            break; } /* terminate evaluation */
          if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
            Lg.Err("getTS064",j); /* print errormessage */
            cc = 14; /* set current return-code to error */
            break bl; } /* terminate evaluation */
        } /* -sscl- process all sub-sections */
        if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
          Lg.Err("getTS064",j); /* print errormessage */
          cc = 15; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(cSc==null) continue; /* no valid entry found -- ignore Dummy-entry */
        c2 += 1; /* count valid entry */
        ScTab[j] = cSc; /* and activate new section-definition */
      } /* -while- process all 'TrackSections' */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        cc = 16; /* set current return-code to error */
        break bl; } /* terminate evaluation */

      /* process shape-definitions */
      is = cB.getKE(true); /* get first controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getTS021"); /* print errormessage */
          cc = 21; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getTS022",is); /* print errormessage */
        cc = 22; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getTS023"); /* print errormessage */
        cc = 23; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(!is.equals("trackshapes")) {  /* 'TrackShapes' not found */
        Lg.Err("getTS024",is); /* print errormessage */
        cc = 24; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      ShN = (int)cB.getNV(); /* get number of trackshapes */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        Lg.Err("getTS025",is,cB.getStat(true)); /* print errormessage */
        cc = 25; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      ShTab = new TSShape[ShN]; /* create table for shape-definitions */
      Arrays.fill(ShTab,null); /* initialize table (no valid entries) */

      l1 = cB.getBrL(); /* current bracket-level for terminate */
      c4 = 0; /* counter of Track-Shapes */
      while(true) { /* process all shape-definitions */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getTS101"); /* print errormessage */
            cc = 31; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getTS102",is); /* print errormessage */
          ec += 1; /* count error */
          break; } /* terminate evaluation */
        if(is.length()==0) break; /* no more kewords present */
        if(!is.equals("trackshape")) {  /* 'TrackShape' not found */
          Lg.Err("getTS103",is); /* print errormessage */
          ec += 1; /* count error */
          break; } /* terminate evaluation */
        j = (int)cB.getNV(); /* get id-number of shape */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getTS104",is,cB.getStat(true)); /* print errormessage */
          ec += 1; /* count error */
          break; } /* terminate evaluation */
        if(j>=ShN) { /* ID-number (index) of shape is invalid */
          Lg.Err("getTS105",""+cB.getStat(true),j,ShN); /* print errormessage */
          ec += 1; /* count error */
          break; } /* terminate evaluation */
        if(ShTab[j]!=null) { /* entry of shape-table already used */
          Lg.Err("getTS106",j); /* print errormessage */
          ec += 1; /* count error */
          break; } /* terminate evaluation */
        l2 = cB.getBrL(); /* current bracket-level for terminate */
        cSh  = null; /* new shape is not allocated */
        ScI  = null; /* no references to SectionIdx */
        k    = 0;    /* preset: no SectionIDX-entries processed */
        ScPt = null; /* no Crossover-Points defined */
        MR   = 0;    /* initialize 'MainRoute' to default */
        clr  = 0.0;  /* init clear-distance of crossing */
        ssl:while(true) { /* process all sub-shapes */
          is = cB.getKE(true); /* get next controlword */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getTS107"); /* print errormessage */
              cc = 32; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getTS108",is,j); /* print errormessage */
            ec += 1; /* count error */
            break; } /* terminate evaluation */
          if(is.length()==0) break; /* no more kewords present */
          l3 = cB.getBrL(); /* current bracket-level for terminate */
          if(is.equals("filename")) { /* Definition-type: 'FileName' */
            if(cSh!=null) { /* 'FileName' was already specified */
              Lg.Err("getTS111",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            is = cB.getVal(1); /* get 'FileName' as next argument */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getTS112",j); /* print errormessage */
                cc = 33; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              Lg.Err("getTS113",is,j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(is.length()==0) { /* 'FileName' not found */
              Lg.Err("getTS114",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(ShD!=null) { /* if requested: check if shape exists */
              cFle = new File(ShD,is); /* create file-reference */
              if(!cFle.exists()) /* file not found -- print it */
                Lg.Err("getTS115",is,j); /* print errormessage */
            } /* check if shape exists */
            cSh = new TSShape(j,is); /* mark: 'FileName' found and processed */
          } else if(is.equals("numpaths")) { /* Definition-type: 'NumPaths' */
            i = (int)cB.getNV(); /* get number of paths */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTS121",is,j,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(i<=0 || i>=(TrN_T*4)) {  /* value is implausible */
              Lg.Err("getTS122",""+cB.getStat(true),j,i); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(i>15) if(EnaW) /* value is implausible */
               Lg.Log("getTS123","15",j,i); /* print warning */
            if(ScI!=null) { /* Numpath-Entry already defined */
              Lg.Err("getT124",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            ScI = new TSScIdx[i]; /* initialize SectionIdx-array */
            Arrays.fill(ScI,null); /* and invalidate all entries */
            k = 0; /* initialize current index of SectionIdx-definitions */
          } else if(is.equals("sectionidx")) { /* Definition-type: 'SectionIdx' */
            i = (int)cB.getNV(); /* get number of sections */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTS131",is,j,k); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(i==0 || i>15) { /* value is implausible */
              Lg.Err("getTS132",""+i,j,k); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(ScI==null) { /* 'numpaths' ist still not defined */
              Lg.Err("getTS133",null,j,k); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(k>=ScI.length) { /* more SectionIdx'-values than paths found */
              Lg.Err("getTS134",""+ScI.length,j,k); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            /* load offset-definitions of 'sectionIdx'-value' */
            fx = cB.getFV(); /* get offset-value (x) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTS135",is,j,k); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            fy = cB.getFV(); /* get offset-value (y) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTS136",is,j,k); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            fz = cB.getFV(); /* get offset-value (z) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTS137",is,j,k); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            f = cB.getFV(); /* get offset-value (angle) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTS138",is,j,k); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(cSh==null) { /* 'FileName' missing -- has to be specified first */
              Lg.Err("getTS139",null,j,k); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            cSh.incCntR(i); /* count number of required section-references */
            ScI[k] = new TSScIdx(i,f,new TSPos(fx,fy,fz)); /* create SextionIdx-Object */
            for(w=0;w<ScI[k].get$Sc();w+=1) { /* load Section-References */
              i = (int)cB.getNV(); /* get number(ID) of section */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getTS141",is,j,k,w); /* print errormessage */
                ec += 1; /* count error */
                break ssl; } /* terminate evaluation */
              if(i<0 || i>=ScTab.length) { /* invalid value, too large? */
                Lg.Err("getTS142",""+w,j,k,i); /* print errormessage */
                ec += 1; /* count error */
                break ssl; } /* terminate evaluation */
              if(ScTab[i]==null) { /* requested section is NOT defined */
                Lg.Err("getTS143",""+w,j,k,i); /* print errormessage */
                ec += 1; /* count error */
                break ssl; } /* terminate evaluation */
              cSc = ScTab[i]; /* get current section-reference */
              ScI[k].chgScR(w,cSc); /* and insert it */
              cSh.addSc(cSc); /* add reference for checking (if not still present) */
              if((f=cSc.getAng())!=0) ssc:{ /* section is curve -- second section */
                /* Attention: cSc may reference a 'already twisted' section. In this case
                 * the second number is 'one less' instead of 'one greater'. */
                i += 1; /* compute number(ID) of next section */
                if(f>0) i -= 2; /* 'twisted' -- correct number of sectionindex */
                if(i>=ScTab.length) break ssc; /* error 'chkTS()' will fail */
                if((cSc=ScTab[i])==null) break ssc; /* error 'chkTS()' will fail */
                cSh.addSc(cSc); /* add second reference for checking */
              } /* -ssc- section-reference describes curve */
            } /* get all section-numbers */
            k += 1; /* entry sucessfully processed */
          } else if(is.equals("mainroute")) { /* Definition-type: 'MainRoute' */
            i = (int)cB.getNV(); /* get number of mainroutes */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTS151",is,j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(cSh==null) { /* 'FileName' missing -- has to be specified first */
              Lg.Err("getTS152",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(cSh.chkMsk(16)) { /* 'MainRoute' was already specified */
              Lg.Err("getTS153",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(ScI==null) { /* 'numpaths' ist still not defined */
              Lg.Err("getTS154",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(i<0) { /* value of 'MainRoute' is illegal (too small) */
              Lg.Err("getTS155",null,j,i); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(i>=ScI.length) { /* value of 'MainRoute' is illegal (too large) */
              Lg.Err("getTS155",""+i,j,ScI.length); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            MR = i; /* activate new value for 'MainRoute' */
            cSh.setMsk(16); /* set option: 'MainRoute' found and processed */
          } else if(is.equals("crossovershape")) { /* Definition-type: 'CrossoverShape' */
            if(cSh==null) { /* 'FileName' missing -- has to be specified first */
              Lg.Err("getTS161",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(cSh.chkMsk(7)) { /* keyword was already specified */
              Lg.Err("getTS162",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            cSh.setMsk(7); /* set option: 'CrossoverShape' found and processed */
          } else if(is.equals("xoverpts")) { /* Definition-type: 'XoverPts' */
            i = (int)cB.getNV(); /* get number of 'XoverPts' */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTS171",is,j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(ScPt!=null) { /* 'XoverPts' was already specified */
              Lg.Err("getTS172",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(i<1 || i>4) { /* value is not allowed */
              Lg.Err("getTS173",null,j,i); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            ScPt = new TSPos[i]; /* create storage for 'XoverPts' */
            Arrays.fill(ScPt,null); /* and invalidate all entries */
            for(i=0;i<ScPt.length;i+=1) { /* load XoverPts */
              is = cB.getKE(true); /* get next controlword */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getTS181",""+i,j); /* print errormessage */
                  cc = 34; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getTS182",is,j,i); /* print errormessage */
                ec += 1; /* count error */
                break; } /* terminate evaluation */
              if(is.length()==0) { /* next keword not present */
                Lg.Err("getTS183",null,j,i); /* print errormessage */
                ec += 1; /* count error */
                break; } /* terminate evaluation */
              if(!is.equals("xoverpt")) {  /* 'XoverPt' not found */
                Lg.Err("getTS184",is,j,i); /* print errormessage */
                ec += 1; /* count error */
                break; } /* terminate evaluation */
              fx = cB.getFV(); /* get offset-value (x) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getTS185",is,j,i); /* print errormessage */
                ec += 1; /* count error */
                break; } /* terminate evaluation */
              fy = cB.getFV(); /* get offset-value (y) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getTS186",is,j,i); /* print errormessage */
                ec += 1; /* count error */
                break; } /* terminate evaluation */
              fz = cB.getFV(); /* get offset-value (z) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getTS187",is,j,i); /* print errormessage */
                ec += 1; /* count error */
                break; } /* terminate evaluation */
              if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                Lg.Err("getTS188",null,j,i); /* print errormessage */
                cc = 35; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              ScPt[i] = new TSPos(fx,fy,fz); /* create position and store it */
            } /* load all positions of xover-points */
          } else if(is.equals("tunnelshape")) { /* Definition-type: 'TunnelShape' */
            if(cSh==null) { /* 'FileName' missing -- has to be specified first */
              Lg.Err("getTS163",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(cSh.chkMsk(3)) { /* keyword was already specified */
              Lg.Err("getTS164",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            cSh.setMsk(3); /* set option: 'TunnelShape' found and processed */
          } else if(is.equals("roadshape")) { /* Definition-type: 'RoadShape' */
            if(cSh==null) { /* 'FileName' missing -- has to be specified first */
              Lg.Err("getTS165",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(cSh.chkMsk(2)) { /* keyword was already specified */
              Lg.Err("getTS166",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            cSh.setMsk(2); /* set option: 'RoadShape' found and processed */
          } else if(is.equals("manualjunctionshape")) { /* Def.-type: 'ManualJunctionShape' */
            if(cSh==null) { /* 'FileName' missing -- has to be specified first */
              Lg.Err("getTS167",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(cSh.chkMsk(5)) { /* keyword was already specified */
              Lg.Err("getTS168",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            cSh.setMsk(5); /* set option: 'ManualJunctionShape' found and processed */
          } else if(is.equals("clearancedist")) { /* Definition-type: 'ClearanceDist' */
            if(cSh==null) { /* 'FileName' missing -- has to be specified first */
              Lg.Err("getTS191",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            f = cB.getFV(); /* get clearance-distance */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTS192",is,j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            if(cSh.chkMsk(17)) { /* keyword was already specified */
              Lg.Err("getTS193",j); /* print errormessage */
              ec += 1; /* count error */
              break; } /* terminate evaluation */
            clr = f; /* activate new value for 'ClearanceDist' */
            cSh.setMsk(17); /* set option: 'ClearanceDist' found and processed */
          } else { /* invalid keyword -- do not process */
            Lg.Err("getTS109",is,j); /* print errormessage */
            ec += 1; /* count error */
            break; } /* terminate evaluation */
          if(cB.skpFwd(l3)) { /* skip resuming data to new entry -- EOF/error found? */
            Lg.Err("getTS10A",j); /* print errormessage */
            cc = 36; /* set current return-code to error */
            break bl; } /* terminate evaluation */
        } /* -ssl- process all sub-trackshapes */
        if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
          Lg.Err("getTS10A",j); /* print errormessage */
          cc = 37; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(cSh==null && ScPt==null && k==0) continue; /* no entry found -- Dummy-entry */
        if(cSh==null || k==0) { /* entry is NOT valid */
          Lg.Err("getTS10B",j); /* print errormessage */
          ec += 1; /* count error */
          continue; } /* continue with next section-definition */
        if(ScI.length!=k) { /* 'SectionIdx'-entries are missed */
          Lg.Err("getTS10C",""+j,k,ScI.length); /* print errormessage */
          ec += 1; /* count error */
          continue; } /* continue with next section-definition */
        /* entry is valid -- complete it and save it to table */
        cSh.setVal(MR,clr,ScI,ScPt); /* insert values into definition */
        c4 += 1; /* count valid entry */
        ShTab[j] = cSh; /* and store it into table (validate it) */
      } /* -while- process all 'TrackShapes' */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getTS026"); /* print errormessage */
        cc = 38; /* set current return-code to error */
        break bl; } /* terminate evaluation */

      is = cB.getKE(false); /* try to get next controlword */
      if(is==null) { /* error found within current input */
       if((is=cB.getErr())!=null) { /* error within data */
        Lg.Err("getTS027",is); /* print errormessage */
        ec += 1; /* count error */
        break bl; } /* terminate evaluation */
      /* attention: EOF is OK */
      } else if(is.length()>0) Lg.Err("getTS003",is); /* print errormessage */
          /* something was found although NOT expected. */

    } /* -bl- break-block used in case of error */
    is = cF.close(); /* Eingabe-Datei schliessen */
    if(is!=null) Lg.Err("getTS001",is); /* Meldung ausgeben */
    if(cc!=0) Lg.Log("getTS004",cc); /* Aktionsmeldung */
    else if(ec>0) Lg.Log("getTS005",ec); /* Aktionsmeldung */

    c3 = cB.getStat(true); /* save number of processed inputlines */
    if(cc>0) return cc; /* Laden mit Fehlern beenden */

    /* ---- Tabellenadressierung herstellen ----
     * Adressierungsverkettung fuer Eintraege in den Tabelle
     *  'ScTab' und 'ShTab' herstellen.
     * >Einfache Adressierung fuer grosse Tabellen erstellen<
     */
    j = ScTab.length; /* Basis vorbesetzen */
    for(i=j-1;i>=0;i-=1) { /* alle Eintraege testen */
      if(ScTab[i]==null) continue; /* Section nicht definiert */
      ScTab[i].$dIx(j-i); /* Differenzeintrag setzen */
      j = i; /* neue Ausgangsbasis */
    } /* Adressierung bearbeitet */

    j = ShTab.length; /* Basis vorbesetzen */
    for(i=j-1;i>=0;i-=1) { /* alle Eintraege testen */
      if(ShTab[i]==null) continue; /* Shape nicht definiert */
      ShTab[i].$dIx(j-i); /* Differenzeintrag setzen */
      j = i; /* neue Ausgangsbasis */
    } /* Adressierung bearbeitet */

    return 0; /* ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTSL"
  * Laden der Datei 'tsection.dat' (lokale Form) in die Routendefinition
  *  >Datei oeffnen, Tabele laden und Ergebnis pruefen
  * 'mc'(c1) erhaelt maximale Anzahl der Section-Definitionen (Sc?)
  * 'ac'(c2) erhaelt aktuelle Anzahl der Section-Definitionen
  * 'mp'(c3) erhaelt maximale Anzahl der Pfad-Definitionen (Sh?)
  * 'ap'(c4) erhaelt aktuelle Anzahl der Pfad-Definitionen
  * ##getTSL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getTSL( /* tsection.dat (lokal) laden */
   TSRoute cRte, /* Routendefinition mit Basisverzeichnis */
   int     ScB,  /* ID-BIAS fuer Section-Definitionen */
   int     ShB)  /* ID-BIAS fuer Shape-Definitionen */
   {
   /*-----------------------------------------------------------------*/
    File    dat;   /* Dateibeschreibung */
    TSFileX cF;    /* aktuelle Eingabe-Datei */
    TSBuf   cB;    /* current input-buffer for 'read file' */
    int     cc,i,j,k,l1,l2; /* Arbeitswerte */
    int     mc,ac,mp,ap; /* content: compare to header */
    TSScL[] ScT;   /* Arbeitstabelle */
    TSScL   cSc;   /* current local section */
    TSShL   cSh,xSh; /* (current) local shape (path) */
    double  f1,f2; /* intermediate values (section) */
    String  is;    /* intermediate value */
   /*=================================================================*/
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("getTSL01",null,ScB,ShB); /* Aktionsmeldung ausgeben */

    /* Eingabe-Datei "tsection.dat" (lokal) oeffnen */
    dat = cRte.getFile(3); /* Dateibeschreibung holen */
    if(dat==null) throw new IllegalStateException( /* Sicherheitsabfrage */
      TSLogg.getMsg("Msg908","File==null","TSUtil.getTSL()",0));
    is = dat.getAbsolutePath(); /* Gesamtname erstellen */
    if(dat.isDirectory()) { /* ein Directory spezifiziert */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getTSL02",is); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 11; /* terminate function with errorcode */
    } /* Definition fehlerhaft */
    if(!dat.exists()) { /* Datei existiert nicht */
      Lg.Log("getTSL03"); /* erlaubter Fehler ausgeben */
      if((is=cRte.setScT(0,ScB))!=null) Lg.Err("Msg010",is);
      if((is=cRte.setShT(0,ShB))!=null) Lg.Err("Msg010",is);
      return 0; /* Ergebnis ist erlaubt! */
    } /* 'tsection.dat' nicht vorhanden */

    /* Eingabe-Datei "tsection.dat" oeffnen */
    cF = new TSFileX(TSFileX.FT$lts,dat); /* Eingabe-Steuerung erstellen */
    is = cF.open(false); /* Datei fuer Eingabe oeffnen */
    if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("getTSL04",is); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Fehler beim Oeffnen der Datenbank-Datei */
    cB = new TSBuf(cF); /* create inputbuffer and init counter */

    cc = 0; /* init condition-code */
    mc = ac = mp = ap = 0; /* compiler needs it */
    bl: { /* Break-Block (used with errors) */
      is = cB.getKE(true); /* get first controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getTSL20"); /* print errormessage */
          cc = 24; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getTSL05",is); /* print errormessage */
        cc = 25; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getTSL21"); /* print errormessage */
        cc = 26; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(!is.equals("tracksections")) {  /* 'TrackSections' not found */
        Lg.Err("getTSL22",is); /* print errormessage */
        cc = 27; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      mc = (int)cB.getNV(); /* get number of tracksections */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        Lg.Err("getTSL23",is,cB.getStat(true)); /* print errormessage */
        mc = 0; /* no sections were created */
        cc = 28; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if((is=cRte.setScT(mc,ScB))!=null) Lg.Err("Msg010",is);
        /* create local section-table and init it, print error */

      /* process section-definitions */
      l1 = cB.getBrL(); /* current bracket-level for terminate */
      ac = 0; /* counter of Track-Sections */
      while(true) { /* process all section-definitions */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getTSL31"); /* print errormessage */
            cc = 31; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getTSL05",is); /* print errormessage */
          cc = 32; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) break; /* no more kewords present */
        l2 = cB.getBrL(); /* current bracket-level for terminate */
        tsc: { /* Break-Block (used with errors) */
          if(!is.equals("tracksection")) {  /* 'TrackSection' not found */
            Lg.Err("getTSL32",is); /* print errormessage */
            break tsc; } /* terminate evaluation */
          is = cB.getKE(true); /* get next controlword */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getTSL33"); /* print errormessage */
              cc = 33; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getTSL34",is,cB.getStat(true)); /* print errormessage */
            break tsc; } /* terminate evaluation */
          if(is.length()==0) { /* next keword not present */
            Lg.Err("getTSL35"); /* print errormessage */
            break tsc; } /* terminate evaluation */
          if(!is.equals("sectioncurve")) {  /* 'SectionCurve' not found */
            Lg.Err("getTSL36",is); /* print errormessage */
            break tsc; } /* terminate evaluation */
          i = (int)cB.getNV(); /* get flag if curve */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getTSL37",is,cB.getStat(true)); /* print errormessage */
            break tsc; } /* terminate evaluation */
          if(i<0 || i>1) { /* flag cannot use other value than true/false */
            Lg.Err("getTSL38",i); /* print errormessage */
            break tsc; } /* terminate evaluation */
          if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
            cc = 35; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          j = (int)cB.getNV(); /* get id-number of section */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getTSL41",is,cB.getStat(true)); /* print errormessage */
            break tsc; } /* terminate evaluation */
          if(!cRte.isScL(j)) { /* index of section is no valid local one */
            is = cRte.chkScT(j,Double.NaN,0.0); /* get message due to error */
            Lg.Err("getTSL42",is); /* print errormessage */
            cc = 36; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          f1 = cB.getFV(); /* get first value (length/angle) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getTSL43",is,j); /* print errormessage */
            break tsc; } /* terminate evaluation */
          f2 = cB.getFV(); /* get second value (0/radius) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getTSL44",is,j); /* print errormessage */
            break tsc; } /* terminate evaluation */
          if(f2==0) { /* definition is 'straight' */
            if(i!=0) { /* integrity-problem found */
              Lg.Err("getTSL45",null,j,i); /* print errormessage */
              break tsc; } /* terminate evaluation */
//            if((j%2)!=0) { /* annother integrity-problem */
//              Lg.Err("getTSL47???",j); /* print errormessage */
//              break tsc; } /* terminate evaluation */
          } else if(i!=1) { /* integrity-problem found */
            Lg.Err("getTSL46",null,j,i); /* print errormessage */
            break tsc; } /* terminate evaluation */
          if(f1<0 && (j%2)!=0) { /* annother integrity-problem */
            Lg.Err("getTSL47",j); /* print errormessage */
            break tsc; } /* terminate evaluation */
          ac += 1; /* count valid section-entry */
          cRte.chgScT(j,new TSScL(j,f1,f2)); /* create section-definition */
        } /* -tsc- break-block used in case of errors */
        if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
          cc = 39; /* set current return-code to error */
          break bl; } /* terminate evaluation */
      } /* -while- process all 'TrackSections' */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        cc = 12; /* set current return-code to error */
        break bl; } /* terminate evaluation */

      /* process path-definitions */
      is = cB.getKE(true); /* get first controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getTSL51"); /* print errormessage */
          cc = 41; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getTSL52",is); /* print errormessage */
        cc = 42; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getTSL53"); /* print errormessage */
        cc = 43; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(!is.equals("sectionidx")) {  /* 'SectionIdx' not found */
        Lg.Err("getTSL54",is); /* print errormessage */
        cc = 44; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      mp = (int)cB.getNV(); /* get number of path-definitions */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        Lg.Err("getTSL55",is,cB.getStat(true)); /* print errormessage */
        mp = 0; /* no paths were created */
        cc = 45; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if((is=cRte.setShT(mp,ShB))!=null) Lg.Err("Msg010",is);
        /* create shape(path)-table and init it, signal error */

      l1 = cB.getBrL(); /* current bracket-level for terminate */
      ap = 0; /* counter of path-definitions */
      ScT = null; /* compiler needs it */
      while(true) { /* process all path-definitions */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getTSL61");; /* print errormessage */
            cc = 51; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getTSL62",is); /* print errormessage */
          cc = 52; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) break; /* no more kewords present */
        l2 = cB.getBrL(); /* current bracket-level for terminate */
        tsp: { /* Break-Block (used with errors) */
          if(!is.equals("trackpath")) {  /* 'TrackPath' not found */
            Lg.Err("getTSL71",is); /* print errormessage */
            break tsp; } /* terminate evaluation */
          j = (int)cB.getNV(); /* get id-number of path */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getTSL72",is,cB.getStat(true)); /* print errormessage */
            break tsp; } /* terminate evaluation */
          if((is=cRte.chkShT(j,true))!=null) { /* check if index invalid */
            Lg.Err("getTSL73",is); /* print errormessage */
            cc = 53; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          k = (int)cB.getNV(); /* get number of parts of path */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getTSL74",is,j,cB.getStat(true)); /* print errormessage */
            break tsp; } /* terminate evaluation */
          if(k<1 || k>5) { /* only one to four parts */
            Lg.Err("getTSL75",""+k,j); /* print errormessage */
            break tsp; } /* terminate evaluation */
          cSh = new TSShL(j); /* create new path-definition-object */
          cSh.incCntR(k); /* and count number of required section-references */
          while(true) { /* process all section-references */
            i = (int)cB.getNV(); /* get number of section */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              if(i==-1) break; /* no more entries */
              Lg.Err("getTSL81",is,j,cSh.addScR(null)); /* print errormessage */
              break tsp; } /* terminate evaluation */
            if(cSh.addScR(null)>=k) { /* more references than allowed */
              Lg.Err("getTSL82",""+cSh.addScR(null),j); /* print errormessage */
              break tsp; } /* terminate evaluation */
            if((i%2)!=0) { /* valid section-numbers must be even */
              Lg.Err("getTSL84",""+i,j,cSh.addScR(null)); /* print errormessage */
              break tsp; } /* terminate evaluation */
            if((cSc=cRte.chgScT(i,null))==null) { /* check reference-value */
              /* it is checked if the number refers to a valid section-def. */
              is = cRte.chkScT(i,Double.NaN,0.0); /* get message due to error */
              Lg.Err("getTSL83",is,j,cSh.addScR(null)); /* print errormessage */
              break tsp; } /* terminate evaluation */
            /* check if section is already referenced from annother path-entry */
            if((xSh=cSc.chgShR(cSh))!=null) { /* insert backward-reference */
              /* error: another path already references this section */
              cSc.chgShR(xSh); /* restore old backward-reference */
              Lg.Err("getTSL85",""+i,j,cSh.addScR(null),xSh.getNr(true));
            } /* section was already referenced */
            cSh.addScR(cSc); /* insert section-Reference into path-definition
              * and increase number of defined sections */
            cSh.addSc(cSc); /* add reference for checking */
            if(cSc.isCurve()) ssc:{ /* section is curve -- second section */
              /* Attention: In opposition to static sections 'cSc' CANNOT reference a
               * 'already twisted' section. So the corresponding second section is
               * the next section in every case. */
              i += 1; /* compute number(ID) of next section */
              if((cSc=cRte.chgScT(i,null))==null) break ssc;
              cSh.addSc(cSc); /* add second reference for checking */
            } /* -ssc- section-reference describes curve */
          } /* process all reference-definitions */
          if((i=cSh.addScR(null))!=k) /* some required section-references are missed */
            Lg.Err("getTSL76",""+j,k,i); /* print errormessage */
          cRte.chgShT(j,cSh); /* register new path-definition in table */
          ap += 1; /* and count valid path-entry */

        } /* -tsp- break-block used in case of errors */
        if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
          cc = 59; /* set current return-code to error */
          break bl; /* terminate evaluation */
        } /* terminate evaluation */
      } /* -while- process all path-definitions */
      if(cB.skpFwd(l1)) cc = 13; /* skip resuming data to new entry -- EOF/error found? */
    } /* -bl- break-block used in case of error */

    is = cF.close(); /* Eingabe-Datei schliessen */
    if(is!=null) Lg.Err("getTSL04",is); /* print errormessage */

    Lg.Log("getTSL06",cB.getStat(true)); /* print number of read lines */

    if(cc>0) { /* tsection.dat (local) contains severe error(s) */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getTSL07",cc); /* problems with tsection.dat (local <-> global) */
      Lg.Close(); /* close output to Log-file */
      return cc; /* terminate function with errorcode */
    } /* Definition fehlerhaft */

    Lg.Log("getTSL08",ScB+mc); /* print maximum section-index */
    Lg.Log("getTSL09",ac);     /* print section-count */
    Lg.Log("getTSL10",ShB+mp); /* print maximum path-index */
    Lg.Log("getTSL11",ap);     /* print path-count */

    return 0; /* tsection.dat (local) was successfully loaded */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkTSL"
  * Pruefen der LOKALEN 'tsection.dat' - Definitionen
  * Neben der Pruefung wird auch die neue Nummerierung vergeben.
  * Routine liefert die neue Anzahl der Section-Definitionen oder '0'
  * Die naechsten freien Indices fuer Sections und Shapes werden in
  *  die Route eingetragen (obere Grenzen)
  * ACHTUNG: Tabellen beginnen fest bei Index 'ScA' bzw. 'ShA'
  * Attention: This method MUST NOT be invoked unless worldfiles AND
  * database (track/road) is stored again (or neither).
  * ##chkTSL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chkTSL( /* Dyn. Track-Definitionen pruefen */
   TSRoute cRte, /* Routendefinition mit Basisverzeichnis */
   int     ic,   /* ersten freien (neuen) Index fuer Sections */
   int     ih)   /* ersten freien (neuen) Index fuer Shapes */
   {
   /*-----------------------------------------------------------------*/
    TSScL   cSc1,cSc2,aSc; /* current local section(s) */
    TSShL   cSh,aSh;       /* current local path(s) */
    int     og,i,j,v,c,xih;
    boolean OK;
    Iterator<TSScL> sI;    /* Iterator of section-table */
   /*=================================================================*/
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("chkTSL01"); /* Aktionsmeldung ausgeben */

    c = 0;    /* Zaehler fuer Sections initialisieren */
    xih = ih; /* merken fuer Statistik */
    /* alle Shape-Definitionen pruefen/bearbeiten */
    og = cRte.get$Sh(true); /* aktuelle 'alte' obere Grenze holen */
    if(og<=ShA) { /* eine lokale tsection.dat existiert nicht! */
      cRte.set$TSL(ic,ih); /* obere Grenzen neu eintragen */
      Lg.Log("chkTSL02",og); /* Message: keine Datei vorhanden */
      Lg.Skip(false); /* Leerzeile loggen */
      return 0; /* mit Kennzeichen beenden */
    } /* Hinweis ausgeben */
    aSh = null; /* noch kein Vorgaenger in Kette */
    for(i=ShA;i<og;i+=1) { /* alle Pfad-Definitionen bearbeiten */
      cSh = cRte.chgShT(i,null); /* aktuellen Eintrag holen */
      if(cSh==null) continue; /* nicht benutzt -- weiter */
      cSh.setNr(0); /* neue Nummer ungueltig machen */
      if((v=cSh.getNr(true))!=i) Lg.Err("chkTSL11",null,i,v); /* Systemfehler */
      if(cSh.incCntW(0)==0) { /* Pfad wird nicht mehr benutzt */
        OK = true; /* annehmen: kein Fehler -- Pfad loeschbar */
        if(EnaW) Lg.Log("chkTSL12",i); /* Freien Pfad melden */
        if((v=cSh.incCntS(0))>0) { /* Referenz aus Schienendatenbank */
          Lg.Err("chkTSL13",null,i,v); /* Meldung ausgeben */
          OK = false; } /* und als nicht loeschbar kennzeichnen */
        sI = cSh.getScR(); /* get iterator for all section-definitions */
        while(sI.hasNext()) { /* another section-definition available ? */
          aSc = sI.next(); /* get current section-entry */
          if((v=aSc.incCntS(0))>0) { /* verkettete Section aus SDB referenziert */
            Lg.Err("chkTSL14",""+aSc.getNr(true),i,v);
            OK = false; /* referenziert -- nicht loeschbar */
          } /* Section wird referenziert */
        } /* process all entries within table */
        if(OK) continue; /* naechsten Eintrag falls Pfad loeschbar */
      } /* Pfad ist nicht mehr genutzt */

      /* Pfad genutzt -- Zaehler nochmal pruefen */
      if((v=cSh.incCntW(0))>1) Lg.Err("chkTSL21","1",i,v);
      j = cSh.addScR(null); /* get number of 'expected' section-references */
      if((v=cSh.incCntS(0))!=j) Lg.Err("chkTSL22",""+j,i,v);

      /* Shape-Kette bilden (aus Tabelle) */
      if(aSh==null) cRte.chgShR(cSh); /* Beginn Kette eintragen */
      else aSh.chgShR(cSh); /* Fortsetzung eintragen */
      cSh.setNr(ih); /* neue Shape-Nummer setzen */
      ih += 1; /* und anpassen */
      aSh = cSh; /* letztes Element merken */
    } /* alle Pfad-Definitionen bearbeiten */

    /* alle Section-Definitionen pruefen/bearbeiten */
    og = cRte.get$Sc(true); /* aktuelle 'alte' obere Grenze holen */
    for(i=ScA;i<og;i+=1) { /* alle Section-Definitionen ungueltig machen */
      cSc1 = cRte.chgScT(i,null); /* aktuellen Eintrag holen */
      if(cSc1==null) continue; /* nicht belegt -- weiter */
      cSc1.setNr(0); /* neue Nummer ungueltig machen */
    } /* alle Section-Definitionen bearbeiten */
    aSc = null; /* noch kein Vorgaenger in Kette */
    for(i=ScA;i<og;i+=2) { /* alle Section-Definitionen bearbeiten */
      cSc1 = cRte.chgScT(i,null); /* aktuellen Eintrag holen */
      j = i + 1; /* Index fuer gedrehte Section */
      cSc2 = cRte.chgScT(j,null); /* FoLgeeintrag holen */

      if(cSc1==null) { /* Eintragsgruppe ist nicht belegt */
        if(cSc2==null) continue; /* Belegung OK -- naechste Gruppe */
        if((v=cSc2.getNr(true))!=j) Lg.Err("chkTSL51",null,j,v); /* Systemfehler */
        Lg.Err("chkTSL52",null,j,i); /* fehlerhafte Sectiongruppe melden */
        if((v=cSc2.incCntW(0))>0) Lg.Err("chkTSL53",null,j,v); /* Ref. von World */
        if((v=cSc2.incCntS(0))>0) Lg.Err("chkTSL54",null,j,v); /* Ref. von tdb */
        continue; } /* naechsten Eintrag */
      if((v=cSc1.getNr(true))!=i) Lg.Err("chkTSL51",null,i,v); /* Systemfehler */
      if(!cSc1.isCurve()) { /* es liegt KEINE Kurve vor */
        if(cSc2!=null) { /* Eintragsgruppe ist fehlerhaft belegt */
          Lg.Err("chkTSL55",j); /* fehlerhafte Sectiongruppe melden */
          if((v=cSc2.incCntW(0))>0) Lg.Err("chkTSL56",null,j,v); /* Ref. von World */
          if((v=cSc2.incCntS(0))>0) Lg.Err("chkTSL57",null,j,v); /* Ref. von tdb */
        } /* fehlerhafter Eintrag wird ignoriert */
        cSc2 = cSc1; /* beide Referenzen auf gleichen Eintrag */
      } else if(cSc2==null) { /* Kurve ohne zweiten Eintrag */
        Lg.Err("chkTSL66",null,i,j); /* zweiter Eintrag fuer Kurve fehlt */
        continue; } /* naechsten Eintrag */

      if(cSc1.incCntW(0)==0) tsl:{ /* Section wird nicht mehr benutzt */
        OK = true; /* annehmen: kein Fehler -- Section loeschbar */
        if(EnaW) Lg.Log("chkTSL58",i); /* Freie Section melden */
        if((v=cSc1.incCntS(0))>0) { /* Referenz aus Schienendatenbank */
          Lg.Err("chkTSL59",null,i,v); /* Meldung ausgeben */
          OK = false; } /* und als nicht loeschbar kennzeichnen */
        if(cSc1==cSc2) /* Elementgruppe vollstaendig geprueft */
          if(OK) continue; /* naechsten Eintrag falls Section loeschbar */
          else break tsl; /* Eintrag muss weiterhin benutzt werden */
        if((v=cSc2.incCntW(0))>0) { /* Referenz aus World-Datei */
          Lg.Err("chkTSL60",null,j,v); /* Meldung ausgeben */
          OK = false; } /* und als nicht loeschbar kennzeichnen */
        if((v=cSc2.incCntS(0))>0) { /* Referenz aus Schienendatenbank */
          Lg.Err("chkTSL61",null,j,v); /* Meldung ausgeben */
          OK = false; } /* und als nicht loeschbar kennzeichnen */
        if(OK) continue; /* naechsten Eintrag falls Section loeschbar */
      } /* Section ist nicht mehr genutzt */

      if((v=cSc1.incCntW(0))!=1) Lg.Err("chkTSL62","1",i,v); /* Fehler */
      if(cSc1!=cSc2 && (v=cSc2.incCntW(0))!=1) /* es liegt eine Kurve vor */
        Lg.Err("chkTSL63","1",j,v); /* Fehler */
      v = cSc1.incCntS(0); /* Anzahl der Referenzen aus der Schienendatenbank */
      if(cSc1!=cSc2) { /* es liegt eine Kurve vor */
        v += cSc2.incCntS(0); /* Referenzen aus der SDB (gesamt) */
        if(v!=1) Lg.Err("chkTSL64","1",j,v,i); /* Anzahl falsch */
      } else if(v!=1) Lg.Err("chkTSL65","1",i,v); /* Anzahl falsch */

      /* Section-Kette bilden (aus Tabelle) */
      if(aSc==null) cRte.chgScR(cSc1); /* Beginn Kette eintragen */
      else aSc.chgScR(cSc1); /* Fortsetzung eintragen */
      cSc1.setNr(ic); /* neue Section-Nummer setzen */
      ic += 2; /* und anpassen */
      c += 1;  /* gesetzte Section zaehlen */
      aSc = cSc2; /* letztes Element merken */
      if(cSc1==cSc2) continue; /* naechste Elementgruppe */
      cSc1.chgScR(cSc2); /* Fortsetzung eintragen */
      cSc2.setNr(ic-1); /* neue Section-Nummer setzen */
      c += 1; /* gesetzte Section zaehlen */
    } /* alle Section-Definitionen bearbeiten */

    cRte.set$TSL(ic,ih); /* obere Grenzen eintragen */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("chkTSL91"); /* Ergebnisse melden */
    Lg.Log("chkTSL92",c); /* Ergebnisse melden */
    Lg.Log("chkTSL93",ih-xih); /* Ergebnisse melden */
    Lg.Skip(false); /* Leerzeile loggen */

    return c; /* Daten erfolgreich bearbeitet */
  }

 /**. <pre>
  *=====================================================================
  * Methode "putTSL"
  * Lokale 'tsection-dat'-Datei neu erstellen/schreiben
  * Wenn kein 'Merge' vorliegt sollten 'cRte' und 'rRte' identisch sein!
  * Achtung: Werte fuer 'ScN' und 'ShN' muessen gesetzt sein
  * ##putTSL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int putTSL( /* 'tsection.dat' (lokal) schreiben */
   TSRoute cRte, /* aktuelle Routendefinition mit Basisverzeichnis */
   TSRoute rRte, /* Referenz-Routendefinition fuer Kettenende */
   boolean OV)   /* Originaldatei ueberschreiben wenn 'true' */
   {
   /*-----------------------------------------------------------------*/
    File    dat; /* Dateidefinition fuer Ausgabe */
    TSFileX cF;  /* aktuelle Ausgabe-Datei */
    TSScL   cls; /* aktuelle lokale Section */
    TSShL   clp; /* aktueller lokaler Pfad */
    int     sc,sh,cc,ch,rc; /* Arbeitswerte */
    String  is;  /* Ausgabepuffer */
//    Iterator<String>  LneI;  /* Line-Iterator for output */
//    ArrayList<String> LneT;  /* Line-Table for output */
   /*=================================================================*/
    Lg.Skip(true); /* Leerzeile loggen */
    sc = rRte.get$Sc(false) - ScN; /* Anzahl Sections berechnen */
    sh = rRte.get$Sh(false) - ShN; /* Anzahl Pfade berechnen */
    if(sh<=0) { /* keine Pfade definiert -- Datei nicht schreiben */
      Lg.Msg("putTSL9",null,sc,sh); /* Aktion melden */
      if(!OV) return 0; /* Methode erfolgreich beendet */
      dat = cRte.getFile(3); /* Dateiname fuer Original */
      dat.delete(); /* und Datei loeschen */
      return 0; /* Methode (endgueltig) erfolgreich beendet */
    } /* keine Ausgabe notwendig */

    dat = cRte.getFile(OV?3:33); /* Dateiname fuer neue Steuerdatei */
    Lg.Msg("putTSL1",dat.getAbsolutePath()); /* Aktion melden */
//    LneT = new ArrayList<String>(10); /* create table for output-line-blocks */
//      /* This list is normally empty. After it was filled with output-lines
//       * and all lines have been processed, it MUST be cleared again. */

    /* tsection.dat fuer Ausgabe oeffnen */
    cF = new TSFileX(TSFileX.FT$lts,dat); /* Ausgabe-Steuerung erstellen */
    is = cF.open(true); /* Datei fuer Ausgabe oeffnen */
    if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Msg("putTSL2",is); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 4; /* terminate function with errorcode */
    } /* Fehler beim Oeffnen der World-Datei */

    cc = ch = 0; /* Objektzaehler fuer Datei */
    bl: { /* block for error-break */
      is = "TrackSections ( " + sc; /* Zeile erstellen */
      rc = 13; /* Kennzeichne Fehlerposition (praeventiv) */
      if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
      for(cls=cRte.chgScR(null);cls!=null;cls=cls.chgScR(null)) {
        /* alle gueltigen Section-Definitionen ausgeben */
        is = "\tTrackSection ("; /* Zeile erstellen */
        rc = 21; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
        is = cls.crDef(2); /* Definitionszeile erstellen */
        rc = 22; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
        rc = 23; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData("\t)"))!=null) break bl; /* Schreib-Fehler */
        cc += 1; /* Ausgabe zaehlen */
      } /* alle Sections erstellt */
      rc = 14; /* Kennzeichne Fehlerposition (praeventiv) */
      if((is=cF.putData(")"))!=null) break bl; /* Schreib-Fehler */
      is = "SectionIdx ( " + sh; /* Zeile erstellen */
      rc = 15; /* Kennzeichne Fehlerposition (praeventiv) */
      if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
      for(clp=cRte.chgShR(null);clp!=null;clp=clp.chgShR(null)) {
        /* alle gueltigen Pfad-Definitionen ausgeben */
        is = clp.crDef(1); /* Definitionszeile erstellen */
        rc = 31; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
        ch += 1; /* Ausgabe zaehlen */
      } /* alle Sections erstellt */
      rc = 16; /* Kennzeichne Fehlerposition (praeventiv) */
      if((is=cF.putData(")"))!=null) break bl; /* Schreib-Fehler */
      rc = 19; /* preset position of error */
      is = TSLogg.getMsg("Msg100","TSection(local)"); /* create TSUtil-ID-Line */
      if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
      rc = 0; /* kein Fehler festgestellt */
    } /* -bl- break-block used in case of error */
    if(is!=null) { /* Meldung steht noch aus */
      rc = 5; /* Kennzeichne Fehlerposition */
      Lg.Err("putTSL2",is); /* Meldung ausgeben */
    } /* Meldung musste noch ausgegeben werden */
    if((is=cF.close())!=null) { /* Ausgabe-Datei schliessen -- Fehler? */
      Lg.Err("putTSL2",is); /* Meldung ausgeben */
      rc = 6; /* Kennzeichne Fehlerposition */
    } /* Fehler bei 'close' */

    if(rc!=0) { /* Fehlerabbruch erhalten */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("putTSL3",rc); /* Aktionsmeldung */
      Lg.Close(); /* close output to Log-file */
      return rc; /* terminate function with errorcode */
    } /* Fehler wurde erkannt */

    Lg.Log("putTSL6",cF.getStat(true)); /* Ergebnis melden */
    Lg.Log("putTSL4",cc); /* Ergebnis melden */
    Lg.Log("putTSL5",ch); /* Ergebnis melden */
    Lg.Skip(false); /* Leerzeile loggen */
    return 0; /* Daten erfolgreich geschrieben */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getWF"
  * Load ALL 'World'-files from world-directory and check syntax of
  *   entries.
  * ATTENTION: This method needs 'OLD'-version of 'tsection.dat'-file.
  *           The shape- and the section-table must be loaded. Also,
  *           the number of entries of these tables must be correct.
  *           Variables: ScA,ShA,ShTab
  * ATTENTION: if an error is discovered (syntactical or content)
  *            the object is NOT inserted into the list of world-objects.
  *            So, there is no index-gap within defined world-objects.
  * ATTENTION: Method uses (and modifies) global varaibles: c4, c5
  * ATTENTION: global TreeSet 'gS' is used if defined (NOT 'null'):
  *          File-names of all world-files, which are no longer
  *          used, are added to the list. So they may be deleted.
  * ##getWF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getWF( /* load all world-files and check them */
   TSRoute cRte, /* current route-definition */
   boolean KM)   /* use correction-mode if 'true' */
   {
   /*-----------------------------------------------------------------*/
    File             dat;   /* world-directory, curent file */
    TSQuad           cQDf;  /* current quad-definition */
    int              i,j,c; /* intermediate values, counter */
    String           is;    /* intermediate values */
    String[]         fl;    /* file-list of world-files */
    Iterator<TSQuad> cI;    /* iterator for quad-definitions (TreeSet) */
    TSFleMask        cM;    /* current file-mask */
   /*=================================================================*/
    if(cRte.chgQDf(null)==null) { /* quad-definitions missing */
      Lg.Skip(false); /* print empty line to LOG-file */
      Lg.Msg("getWF$01"); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 4; /* terminate function with errorcode */
    } /* error found -- function terminated */

    Lg.Skip(true); /* print empty line (screen and LOG-file) */
    Lg.Msg("getWF$02",cRte.getInfo(1)); /* print description of next action */

    dat = cRte.getFile(10); /* get file-reference to to world-directory */
    is = dat.getAbsolutePath(); /* create complete path of world-folder */
    if(!dat.exists()) { /* world-directory does not exist -- terminate */
      Lg.Msg("MsgC28",is); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 11; /* terminate function with errorcode */
    } /* world-directory does not exist */
    cM = new TSFleMask(false,".*\\.w"); /* select world-files */
    if((is=cM.getErr())!=null) { /* error within file-mask */
      Lg.Skip(false); /* print empty line to LOG-file */
      Lg.Msg("getWF$03",is); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* error found -- function terminated */
    fl = dat.list((FilenameFilter)cM); /* create list of ALL world-files */
      /* result contains NO directories! */
    if(fl==null) { /* error found: source is no directory */
      Lg.Msg("MsgC29",is); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* file-list could not be created */
    c = 0; /* init counter of world-files */
    ol:for(String fn : fl) { /* check all file-definitions */
      c += 1; /* count world-file */
      cI = cRte.getIt(12); /* get iterator for all quad-definitions */
      while(cI.hasNext()) { /* another quad-definition available? */
        cQDf = cI.next(); /* get next quad-definition */
        is = cQDf.getInf(2); /* and resolve name of connected world-file */
        if(is==null) continue; /* world-file is missing -- do not compare */
        if(is.equalsIgnoreCase(fn)) continue ol; /* found -- check next name */
      } /* compare name to all world-names of the quad-definitions */
      /* file-name 'fn' is no longer used as a world-file -- process it */
      if(gN!=null) gN.add(fn); /* if requested: save file-name to global list */
      ol$: { /* break-Block in case of name(-syntax)-error */
        if(fn.toLowerCase().charAt(0)!='w') break ol$; /* invalid first char */
        if((i=chkNum(fn,1,8))==Integer.MIN_VALUE) break ol$;
        if((j=chkNum(fn,8,15))==Integer.MIN_VALUE) break ol$;
        /* format of file-name is valid -- appropriate tile exists? */
        is = TSTile.getTNme(i,j,1); /* create name of tile */
        dat = cRte.getFile(18,is+".t"); /* and change it to fully referenced name */
        Lg.Err(dat.exists()?"getWF$14":"getWF$04",fn,is); /* print (error)message */
        continue ol; /* unused world-file successfully reported */
      } /* -ol$- error within namestructure of file */
      Lg.Err("getWF$15",fn); /* print errormessage: invalid name-structure */
    } /* -ol-  check all file-definitions */
    Lg.Skip(false); /* print empty line to LOG-file */
    fl = null; /* filelist is no longer used (help gc()) */

    c = 0; /* init counter of world-files */
    cI = cRte.getIt(12); /* get iterator for all quad-definitions */
    while(cI.hasNext()) { /* another quad-definition available? */
      /* process all quad-definitions */
      cQDf = cI.next(); /* get next quad-definition */
      is = cQDf.getInf(2); /* and resolve name of connected world-file */
      if(is==null) continue; /* world-file is missing -- do not process */
      c += 1; /* count world-file */
      dat = cRte.getFile(10,is); /* create complete reference to file */
      is = dat.getAbsolutePath(); /* and extract complete path-name */
      Lg.Log("MsgC54",is,DF4.format(c)); /* print next action (first line) */
      Lg.Log("Msg010",cQDf.getMsg(0,"getWF$05",0,0)); /* print next action */

      i = getWrld(dat,cQDf,cRte,KM); /* load world-file and check objects */
//      if(i<0) continue; /* open-error -- process next file */
    } /* -while- read and load all world-files */

    Lg.Skip(false); /* print empty line to LOG-file */
    Lg.Log("getWF$06",c); /* print number of loaded world-files */
    Lg.Skip(false); /* print empty line to LOG-file */
    return 0; /* method complete -- return successfully */
  }

 /**. <pre>
  *=====================================================================
  * Method "getWrld"
  * Load ONE world-file and check syntax of definition
  * ATTENTION: This method needs 'OLD'-version of 'tsection.dat'-file.
  *           The shape- and the section-table must be loaded. Also,
  *           the number of entries of these tables must be correct.
  *           Variables: ScA,ShA,ShTab
  * ATTENTION: if an error is discovered (syntactical or content)
  *            the object is NOT inserted into the list of world-objects.
  *            So, there is no index-gap within defined world-objects.
  * ATTENTION: Method uses (and modifies) global varaibles: c4, c5
  * ##getWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getWrld( /* load one world-file */
   File    dat,  /* definition of world-file to read */
   TSQDef  cQDf, /* current environment for world-file */
   TSRoute cRte, /* current route-definition (basis-anchor) */
   boolean KM)   /* use correction-mode if 'true' */
   {
   /*-----------------------------------------------------------------*/
    TSFileW          cF;    /* inputfile of world-definition */
    TSBuf            cB;    /* current input-buffer for 'read file' */
    TSUiD            cUiD;  /* current world-entry */
    TSChain          cU;    /* current list of world-objects (chain) */
    TSView           cVS;   /* current ViewSphere-definition */
    TSPos            cPos;  /* current position-object */
    TSQPos           aPos;  /* current position-object (extended) */
    TSQDir           cDir;  /* current direction-object */
    TSShape          cShG;  /* curreng GLOBAL shape-definition */
    TSShL            cShL;  /* current local path-definition */
    TSScL            cSc;   /* current local sectionn */
    double           f1,f2; /* intermeduate values */
    long             l;     /* stores 'unsigned Integer' */
    int              reqMsk,valMsk; /* requested lines, valid lines */
    int              i,j,k,u,w,sc,si,l1,l2,l3,ec,cc; /* intermediate values */
    String           is,ks; /* intermediate value / UID-Value */
    String           Typ;   /* current object-type for error-messages */
   /*=================================================================*/
    /* open world-file for input */
    cF = new TSFileW(dat); /* create input-control of world-file */
    is = cF.open(TSFile.IN); /* and open file for input */
    if(is!=null) { /* error occurred while opening file */
      Lg.Err("getWF001",is); /* print errormessage: terminating */
      return -1; /* terminate method -- use next world-file */
    } /* error while opening world-file */

    cB = new TSBuf(cF); /* create inputbuffer and init counter */
    i = cF.getMode(TSFile.OUT); /* get/mod current access-mode (read-mode) */
    cQDf.chgMde(i); /* and save it to environment */

    /* check world-file and gather data for the world-objects */
    cc = 0; /* preset current Condition-Code */
    ec = 0; /* initialize error-counter (non-terminating) */
    bl: { /* block for error-break */
      is = cB.getKE(true); /* get first controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getWF011"); /* print errormessage */
          cc = 4; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getWF012",is); /* print errormessage */
        cc = 5; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getWF013"); /* print errormessage */
        cc = 6; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(!is.equals("tr_worldfile")) { /* 'Tr_Worldfile' not found */
        Lg.Err("getWF014",is); /* print errormessage */
        cc = 7; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      l1 = cB.getBrL(); /* current bracket-level for terminate */

      /* check if viewsphere-definition present, consider empty file
       * First: check if special yard-cam(s) is/are present */
      yc:do { /* loop until all YARD-CAM-definitions are skipped */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getWF015"); /* print errormessage */
            cc = 8; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getWF016",is); /* print errormessage */
          cc = 9; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) { /* next keword not present */
          if(cB.charAt(false)==')') { /* world-file is empty */
            cQDf.chgWTab(new TSChain(),0); /* insert dummy-values */
            Lg.Log("getWF018"); /* print result */
            break bl; /* file was processed successfully */
          } /* world-file was empty */
          Lg.Err("getWF017"); /* print errormessage */
          cc = 10; /* set current return-code to error */
          break bl; } /* terminate evaluation */

        cB.mark(false); /* mark current position if no (more) Yard-CAM(s) found */
        if(!is.equals("forest")) break yc; /* NO invalid Yard-CAM defined */
        Typ = "Yard-CAM"; /* set objekt-Type to be used for error-messages */
        l2 = cB.getBrL(); /* current bracket-level for terminate */
 if(PrMsk.chkMsk(31)) Lg.Log("Msg010","World-Line(A)='"+cB.getLne(0)+"'"); // ##!D

        ks = cB.getKE(true); /* get next controlword */
        if(ks==null) { /* error found within current input */
          if((ks=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getWF051",Typ); /* print errormessage */
            cc = 501; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getWF052",Typ,ks); /* print errormessage */
          cc = 502; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(ks.length()==0) break yc; /* no entries found --*/
        if(!ks.equals("uid")) break yc; /* NO Sub-Definition: 'UiD' follows */
        l = cB.getNV(); /* get new value of 'UID' */
        if((ks=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getWF061",Typ,ks,cB.getStat(true)); /* print errormessage */
          cc = 503; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(l>=0 && l<NoVS) break yc; /* NO UID for special Yard-CAM found */
        /* OK -- Yard-CAM found skip entry and check next one */
        if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
          Lg.Err("getWF059",Typ,cB.getStat(true)); /* print errormessage */
          cc = 504; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(EnaW) Lg.Log("getWF05A"); /* print message: Yard-CAM was removed */
      } while(true); /* -yc- Yard-CAM defined and processed -- check next one */
      cB.reset(true); /* reset to marked position. Clear current position. */
 if(PrMsk.chkMsk(31)) Lg.Log("Msg010","World-Line(E)='"+cB.getLne(0)+"'"); // ##!D

      if(is.equals("vdbidcount")) { /* viewsphere-definition present */
        /* viewsphere-evaluation uses the following global counters:
         *   c4 - maximum allowed value for viewsphere-ID
         *   c5 - current recursion-level within viewsphere-chain
         */
        c4 = (int)cB.getNV(); /* get value of argument */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getWF021",is,cB.getStat(true)); /* print errormessage */
          cc = 11; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
          cc = 12; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getWF022"); /* print errormessage */
            cc = 13; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getWF023",is); /* print errormessage */
          cc = 14; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) { /* next keword not present */
          Lg.Err("getWF024"); /* print errormessage */
          cc = 15; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(!is.equals("viewdbsphere")) { /* 'ViewDbSphere' not found */
          Lg.Err("getWF025",is); /* print errormessage */
          cc = 16; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        c5 = 1; /* init current recursion-level */
        cVS = getVS(cB); /* and read all viewsphere-definitions (recursive) */
        if(cVS==null) {  /* severe error found while reading */
          cc = 17; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(cQDf.chgView(cVS)!=null) Lg.Err("getWF026",c5); /* print errormessage */
        i = cVS.count(); /* count number of viewspheres */
        if(i!=c4) Lg.Err("getWF027",""+c5,c4,i); /* print errormessage */
        cQDf.chg$View(c4); /* save current number of viewspheres */
        /* viewsphere-brackets are already left now */
        is = cB.getKE(true); /* get next controlword */
          /* error-checking will occur within next loop */
      } else Lg.Log("getWF019"); /* no optional viewsphere found */

      /* process ALL definitions of world-objects */
      u = 0; /* initialize value of 'maximum UID' */
      w = 0; /* initialize 'StaticDetailLevel' */
      cU = new TSChain(); /* create new (sorted) chain for world-objects */
      for(;true;is=cB.getKE(true)) { /* process all definitions */
        /* skip 'getKE()' when entering; init endless loop */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getWF031"); /* print errormessage */
            cc = 21; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getWF032",is); /* print errormessage */
          cc = 22; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) break; /* no more entries found */
        l2 = cB.getBrL(); /* current bracket-level for terminate */
        k  = -1; /* preset UID-value (clear it) */
        ks = "?"; /* and mark UID as unknown (printing) */
        cUiD = null; /* Compiler needs it */
        dtl: { /* block for error-break -- do not store definition */
          /* if an error is discovered (syntactical or content)
           *   the object is NOT inserted into the list of world-objects.
           *   So, there is no index-gap within defined world-objects.
           */
          if(is.equals("trackobj")) { /* Definitionstype: 'TrackObj' */
            cUiD = new TSTrkObj(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "TrackObj"; /* set objekt-Type to be used for error-messages */
          } else if(is.equals("dyntrack")) { /* Definitionstype: 'Dyntrack' */
            cUiD = new TSDynTrk(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "DynTrack"; /* set objekt-Type to be used for error-messages */
          } else if(is.equals("signal")) { /* Definitionstype: 'Signal' */
            cUiD = new TSSignal(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "Signal"; /* set objekt-Type to be used for error-messages */
          } else if(is.equals("static")) { /* Definitionstype: 'Static' */
            cUiD = new TSStatic(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "Static"; /* set objekt-Type to be used for error-messages */
          } else if(is.equals("forest")) { /* Definitionstype: 'Forest' */
            cUiD = new TSForest(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "Forest"; /* set objekt-Type to be used for error-messages */
          } else if(is.equals("platform")) { /* Definitionstype: 'Platform' */
            cUiD = new TSPlatform(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "Platform"; /* set objekt-Type to be used for error-messages */
          } else if(is.equals("siding")) { /* Definitionstype: 'Siding' */
            cUiD = new TSSiding(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "Siding"; /* set objekt-Type to be used for error-messages */
          } else if(is.equals("gantry")) { /* Definitionstype: 'Gantry' */
            cUiD = new TSGantry(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "Gantry"; /* set objekt-Type to be used for error-messages */
          } else if(is.equals("speedpost")) { /* Definitionstype: 'Speedpost' */
            cUiD = new TSSpeed(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "Speedpost"; /* set objekt-Type to be used for error-messages */
          } else if(is.equals("carspawner")) { /* Definitionstype: 'CarSpawner' */
            cUiD = new TSCarSp(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "CarSpawner"; /* set objekt-Type to be used for error-messages */
          } else if(is.equals("levelcr")) { /* Definitionstype: 'LevelCr' */
            cUiD = new TSLevelCr(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "LevelCr"; /* set objekt-Type to be used for error-messages */
          } else if(is.equals("hazard")) { /* Definitionstype: 'Hazard' */
            cUiD = new TSHazard(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "Hazard"; /* set objekt-Type to be used for error-messages */
          } else if(is.equals("transfer")) { /* Definitionstype: 'Transfer' */
            cUiD = new TSTransf(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "Transfer"; /* set objekt-Type to be used for error-messages */
          } else if(is.equals("collideobject")) { /* Definitionstype: 'CollideObject' */
            cUiD = new TSColli(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "CollideObject"; /* set objekt-Type to be used for error-messages */
          } else if(is.equals("telepole")) { /* Definitionstype: 'Telepole' */
            cUiD = new TSTelep(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "Telepole"; /* set objekt-Type to be used for error-messages */
          } else if(is.equals("pickup")) { /* Definitionstype: 'Pickup' */
            cUiD = new TSPickup(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "Pickup"; /* set objekt-Type to be used for error-messages */
          } else if(is.equals("tr_watermark")) { /* Definitionstype: 'Tr_Watermark' */
            /* Attention: This type of entry contains no further definitionlines.
             * Therefore this entry is fully processed now.
             */
            i = (int)cB.getNV(); /* get new value of 'StaticDetailLevel' */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getWF041",is,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl; } /* terminate evaluation */
            if(i<1) { /* invalid range for 'StaticDetailLevel' */
              Lg.Err("getWF042",null,i,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl; } /* terminate evaluation */
            cUiD = new TSUiD(32,i); /* create new control-entry */
            if(cU.isEqual(cUiD)) { /* Watermark-type entry is already present */
              Lg.Err("getWF043",null,i,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl; } /* terminate evaluation */
            cU.add(cUiD); /* insert new entry into object-chain */
            cUiD.chgQDf(cQDf); /* insert back-reference to quad-basis-definition */
            if(i<w) { /* Level-definitions are not correctly sorted. */
              Lg.Err("getWF044",""+cB.getStat(true),i,w); /* print errormessage */
              ec += 1; /* count error */
              break dtl; } /* terminate evaluation */
            w = i; /* establish new value for 'StaticdetailLevel' */
            break dtl; /* entry fully processed now */
          } else { /* unknown keyword of world-type -- do not process */
            Lg.Err("getWF033",is); /* print errormessage */
            ec += 1; /* count error */
            break dtl; } /* terminate evaluation */
          reqMsk = cUiD.getCtl(0); /* mask of 'requested keywords' ('reqMsk') */
          valMsk = cUiD.getCtl(1); /* mask of 'valid keywords' ('valMsk') */

          while(true) { /* process all sub-definitions (definitionlines) */
            /* All definition lines, which follow the type-definition of a world-
             * object, are processed independant from the type of the entry. Then
             * they are assigned to the current valid object-type.
             * 1. part : commonly valid keywords (id = 0,16..31).
             */
            is = cB.getKE(true); /* get next controlword */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getWF051",Typ); /* print errormessage */
                cc = 31; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              Lg.Err("getWF052",Typ,is); /* print errormessage */
              cc = 32; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            if(is.length()==0) break; /* no more entries found */
            if(is.equals("uid")) SD00:{ /* Sub-Definition: 'UiD' */
              i = (int)cB.getNV(); /* get new value of 'UID' */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getWF061",Typ,is,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(i<0) { /* invalid range */
                Lg.Err("getWF062",Typ,i); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if((j=cUiD.setUiD(i))>=0) { /* insert new 'UiD' into object -- already done? */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF063",Typ,j,cB.getStat(true)); /* print warning-message */
                  break SD00; } /* do not further process definitionline */
                Lg.Err("getWF064",Typ,j,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              k = i; /* activate new UID-value */
              u = Math.max(u,i); /* compute maximum of ALL UID-values */
              ks = "" + i; /* convert for printing */
            } else if(is.equals("tritemid")) SD16:{ /* Sub-Definition: 'TrItemId' */
              if(!TSOpts.chkMsk(16,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF071",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD16; } /* do not further process definitionline */
                Lg.Err("getWF072",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              i = (int)cB.getNV(); /* get number of database */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getWF073",Typ,ks,""+cB.getStat(true),is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(i<0 || i>1) { /* invalid range of database-number */
                Lg.Err("getWF074",Typ,k,i); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              j = (int)cB.getNV(); /* get 'TrItem'-number */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getWF075",Typ,ks,""+cB.getStat(true),is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if((j=cUiD.addTrI(i,j))!=0) { /* there are errors in this values */
                if(j<0) Lg.Err("getWF076",Typ,k,j,i); /* print errormessage */
                  /* database-referenece (number) is NOT valid */
                else Lg.Err("getWF077",Typ,ks,j); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(16); /* mark: definitionline is successfully processed */
            } else if(is.equals("collideflags")) SD17:{ /* Sub-Definition: 'CollideFlags' */
              if(cUiD instanceof TSStatic) { /* static object really is a track-object */
                /* 'CollideFlags' is not used with static objects but with track-objects */
                cUiD = new TSTrkObj((TSStatic)cUiD); /* correct object-type of entry */
                reqMsk = cUiD.getCtl(0); /* new mask of 'requested keywords' ('reqMsk') */
                valMsk = cUiD.getCtl(1); /* new mask of 'valid keywords' ('valMsk') */
                Typ = "TrackObj"; /* set objekt-Type to be used for error-messages */
                cUiD.setOpt(9); /* mark object as a converted 'static track'-object */
                cUiD.setOpt(10); /* mark: create 'hidewire'-object when writing */
                valMsk |= cUiD.getCtl(9); /* set additional valid lines */
                if(EnaH) Lg.Log("getWF057","CollideFlags",ks,cB.getStat(true)); /* print warning */
              } /* static object is converted to a track-object */
              if(!TSOpts.chkMsk(17,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF081",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD17; } /* do not further process definitionline */
                Lg.Err("getWF082",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(17)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF083",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD17; } /* do not further process definitionline */
                Lg.Err("getWF084",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              i = (int)cB.getNV(); /* get flag-value */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getWF085",Typ,ks,""+cB.getStat(true),is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.chgCoF(i); /* insert new value for 'CollideFlags' */
              cUiD.setMsk(17); /* mark: definitionline is successfully processed */
            } else if(is.equals("collidefunction")) SD18:{ /* Sub-Definition: 'CollideFunction' */
              if(cUiD instanceof TSStatic) { /* static object really is a track-object */
                /* 'CollideFunction' is not used with static objects but with track-objects */
                cUiD = new TSTrkObj((TSStatic)cUiD); /* correct object-type of entry */
                reqMsk = cUiD.getCtl(0); /* new mask of 'requested keywords' ('reqMsk') */
                valMsk = cUiD.getCtl(1); /* new mask of 'valid keywords' ('valMsk') */
                Typ = "TrackObj"; /* set objekt-Type to be used for error-messages */
                cUiD.setOpt(9); /* mark object as a converted 'static track'-object */
                cUiD.setOpt(10); /* mark: create 'hidewire'-object when writing */
                valMsk |= cUiD.getCtl(9); /* set additional valid lines */
                if(EnaH) Lg.Log("getWF057","CollideFunction",ks,cB.getStat(true)); /* print warning */
              } /* static object is converted to a track-object */
              if(!TSOpts.chkMsk(18,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF091",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD18; } /* do not further process definitionline */
                Lg.Err("getWF092",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(18)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF093",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD18; } /* do not further process definitionline */
                Lg.Err("getWF094",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF095",Typ,ks); /* print errormessage */
                  cc = 37; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF096",Typ,is,ks); /* print errormessage */
                cc = 38; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(2,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF096",Typ,is,ks);
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(18); /* mark: definitionline is successfully processed */
            } else if(is.equals("filename")) SD19:{ /* Sub-Definition: 'FileName' */
              if(!TSOpts.chkMsk(19,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF101",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD19; } /* do not further process definitionline */
                Lg.Err("getWF102",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(19)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF103",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD19; } /* do not further process definitionline */
                Lg.Err("getWF104",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              is = cB.getVal(7); /* get current filename */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF105",Typ,ks); /* print errormessage */
                  cc = 39; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF106",Typ,is,ks); /* print errormessage */
                cc = 40; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(is.length()==0) { /* (length-)value is not present */
                Lg.Err("getWF107",Typ,ks); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              is = is.replace('\\','/'); /* replace backslash within filename (if available) */
                /* filenames should be written using a common form */
              cUiD.chgNme(is); /* insert new filename */
              cUiD.setMsk(19); /* mark: definitionline is successfully processed */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) /* error found within current input */
                if((is=cB.getErr())==null) is = TSLogg.getKey("getWF035"); /* EOF */
                else is = TSLogg.getMsg("getWF036",is); /* error within data */
              if(is.length()>1) { /* additional data found */
                Lg.Err("getWF106",Typ,is,ks);  /* print errormessage */
                ec += 1; /* count error */
              } /* report additional error */
            } else if(is.equals("staticflags")) SD20:{ /* Sub-Definition: 'StaticFlags' */
              if(!TSOpts.chkMsk(20,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF111",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD20; } /* do not further process definitionline */
                Lg.Err("getWF112",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(20)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF113",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD20; } /* do not further process definitionline */
                Lg.Err("getWF114",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              i = cB.getHV(8); /* get value of argument (Hex-number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getWF115",Typ,ks,""+cB.getStat(true),is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setStF(i);  /* insert new value for 'StaticFlags' into current object */
              cUiD.setMsk(20); /* mark: definitionline is successfully processed */
            } else if(is.equals("position")) SD21:{ /* Sub-Definition: 'Position' */
              if(!TSOpts.chkMsk(21,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF121",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD21; } /* do not further process definitionline */
                Lg.Err("getWF122",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(21)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF123",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD21; } /* do not further process definitionline */
                Lg.Err("getWF124",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if((is=chkPos(cB,null,null))!=null) { /* read position values and check them */
                Lg.Err("getWF125",Typ,is,ks); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cPos = (TSPos)RetVal; /* get created position-object */
              if((cPos=cUiD.setPos(cPos))!=null) { /* definition was already set */
                Lg.Err("getWF126",Typ,cPos.getPos(true),ks); /* print warning-message */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(21); /* mark: definitionline is successfully processed */
            } else if(is.equals("qdirection")) SD22:{ /* Sub-Definition: 'QDirection' */
              if(!TSOpts.chkMsk(22,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF131",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD22; } /* do not further process definitionline */
                Lg.Err("getWF132",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(31)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF133",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD22; } /* do not further process definitionline */
                Lg.Err("getWF134",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if((is=getQDir(cB))!=null) { /* read direction values and check them */
                Lg.Err("getWF135",Typ,is,ks); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cDir = (TSQDir)RetVal; /* get created quaternion */
              if((cDir=cUiD.setQDir(cDir))!=null) { /* Quaternion was already set */
                Lg.Err("getWF136",Typ,cDir.getDir(true),ks); /* print warning-message */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(22); /* mark: definitionline is successfully processed */
              cUiD.setMsk(31); /* mark: Quaternion/matrix-definition present */
            } else if(is.equals("matrix3x3")) SD23:{ /* Sub-Definition: 'Matrix3x3' */
              if(!TSOpts.chkMsk(23,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF141",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD23; } /* do not further process definitionline */
                Lg.Err("getWF142",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(31)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF143",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD23; } /* do not further process definitionline */
                Lg.Err("getWF144",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF145",Typ,ks); /* print errormessage */
                  cc = 41; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF146",Typ,is,ks); /* print errormessage */
                cc = 42; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(3,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF146",Typ,is,ks);
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(23); /* mark: definitionline is successfully processed */
              cUiD.setMsk(31); /* mark: Quaternion/matrix-definition present */
              if(EnaW) Lg.Log("getWF147",Typ,ks); /* print warning: matrix-line found */
            } else if(is.equals("maxvisdistance")) SD24:{ /* Sub-Def: 'MaxVisDistance' */
              if(!TSOpts.chkMsk(24,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF151",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD24; } /* do not further process definitionline */
                Lg.Err("getWF152",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(24)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF153",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD24; } /* do not further process definitionline */
                Lg.Err("getWF154",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF155",Typ,ks); /* print errormessage */
                  cc = 43; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF156",Typ,is,ks); /* print errormessage */
                cc = 44; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(4,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF156",Typ,is,ks);
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(24); /* mark: definitionline is successfully processed */
            } else if(is.equals("vdbid")) SD25:{ /* Sub-Definition: 'VDbId' */
              if(!TSOpts.chkMsk(25,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF161",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD25; } /* do not further process definitionline */
                Lg.Err("getWF162",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(25)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF163",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD25; } /* do not further process definitionline */
                Lg.Err("getWF164",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              l = cB.getNV(); /* get specified viewsphere-ID */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getWF165",Typ,ks,""+cB.getStat(true),is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(l<NoVS) { /* ID references valid viewsphere (no dummy-version) */
                i = (int)l; /* convert viewsphere-ID for further processing */
                if((cVS=cQDf.fndView(i))==null) { /* NO viewsphere defined */
                  Lg.Err("getWF166",Typ,ks,i); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                cVS.incCnt(1); /* count reference to viewsphere */
                cUiD.chgView(cVS); /* and insert viewSphere-reference */
              } else cUiD.clrView((int)(l-NoVS)); /* store special ID of viewsphere */
              cUiD.setMsk(25); /* mark: definitionline is successfully processed */
            } else if(is.equals("staticdetaillevel")) SD26:{ /* 'StaticDetailLevel' */
              if(!TSOpts.chkMsk(26,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF171",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD26; } /* do not further process definitionline */
                Lg.Err("getWF172",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(26)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF173",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD26; } /* do not further process definitionline */
                Lg.Err("getWF174",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              i = (int)cB.getNV(); /* get new value for 'StaticDetailLevel' */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getWF175",Typ,ks,""+cB.getStat(true),is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(i<w) Lg.Err("getWF176",Typ,k,i,w); /* Sort-error within levels */
              if(i>=0) { /* valid level register it with object */
                if(i!=w) cUiD.setSL(i); /* insert new level (explicitely) into object */
                w = i; /* new MINIMAL StaticDetailLevel is valid from now */
              } /* value was registered and set */
              cUiD.setMsk(26); /* mark: definitionline is successfully processed */
            } else if(is.equals("signalsubobj")) SD27:{ /* Sub-Definition: 'SignalSubObj' */
              if(!TSOpts.chkMsk(27,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF181",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD27; } /* do not further process definitionline */
                Lg.Err("getWF182",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(27)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF183",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD27; } /* do not further process definitionline */
                Lg.Err("getWF184",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              i = cB.getHV(8); /* convert options to number (8 Hex-chars) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getWF185",Typ,ks,""+cB.getStat(true),is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              ((TSSignal)cUiD).chgMsk(i); /* insert 'SignalSubObj'-Mask to object */
              cUiD.setMsk(27); /* mark: definitionline is successfully processed */
            } else if(is.equals("signalunits")) SD28:{ /* Sub-Definition: 'SignalUnits' */
              if(!TSOpts.chkMsk(28,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF191",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD28; } /* do not further process definitionline */
                Lg.Err("getWF192",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(28)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF193",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD28; } /* do not further process definitionline */
                Lg.Err("getWF194",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              sc = (int)cB.getNV(); /* get number of signalunits */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getWF195",Typ,ks,""+cB.getStat(true),is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              for(si=0;si<sc;si+=1) { /* read exactly 'sc' entry-definitions */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getWF196",ks,si); /* print errormessage */
                    cc = 75; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getWF197",is,ks,si); /* print errormessage */
                  cc = 76; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                if(is.length()==0) { /* next keword not present */
                  Lg.Err("getWF198",ks,si); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if(!is.equals("signalunit")) { /* 'SignalUnit' not found */
                  Lg.Err("getWF199",is,ks,si); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                i = (int)cB.getNV(); /* get number of current signalobject */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  Lg.Err("getWF19A",is,k,si,cB.getStat(true)); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if(!TSOpts.chkMsk(i,((TSSignal)cUiD).chgMsk(0))) { /* invalid connection */
                  /* referred signalsubobject is NOT defined within subobject-mask */
                  Lg.Err("getWF19B",ks,i,si); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                l3 = cB.getBrL(); /* current bracket-level for terminate */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getWF19C",ks,si); /* print errormessage */
                    cc = 77; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getWF19D",is,ks,si); /* print errormessage */
                  cc = 78; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                if(is.length()==0) { /* next keword not present */
                  Lg.Err("getWF19E",ks,si); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if(!is.equals("tritemid")) { /* 'TrItemId' not found */
                  Lg.Err("getWF19F",is,ks,si); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                j = (int)cB.getNV(); /* get number of referred database */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  Lg.Err("getWF19G",is,k,si,cB.getStat(true)); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if(j!=0) { /* invalid database -- only trackdatabase allowed */
                  Lg.Err("getWF19H",ks,j,si); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                j = (int)cB.getNV(); /* get number of TrItemID */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  Lg.Err("getWF19I",is,k,si,cB.getStat(true)); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if((is=((TSSignal)cUiD).addSgI(i,j))!=null) { /* insert TrItemId */
                  Lg.Err("getWF19J",is,ks,si); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if(cB.skpFwd(l3)) { /* skip resuming data to new entry -- EOF/error found? */
                  cc = 79; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
              } /* -sc- check all signalunit-definitions */
              /* all signalunits have been processed successfully -- entry is valid */
              cUiD.setMsk(28); /* mark: definitionline(s) is/are successfully processed */
            } else if(is.equals("nodirlight")) SD29:{ /* Sub-Definition: 'NoDirLight' */
              if(!TSOpts.chkMsk(29,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF201",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD29; } /* do not further process definitionline */
                Lg.Err("getWF202",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(29)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF203",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD29; } /* do not further process definitionline */
                Lg.Err("getWF204",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF205",Typ,ks); /* print errormessage */
                  cc = 99; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF206",Typ,is,ks); /* print errormessage */
                cc = 100; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(0,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF206",Typ,is,ks);
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(29); /* mark: definitionline is successfully processed */
            /* 2. Part : Keywords, which are used more than once within an object-definition, are
             *   processed here. Additional keywords, which are used to represent 'Hidewire'-objects
             *   are also checked within this part.
             */
            } else if(is.equals("sectionidx")) SD01:{ /* Sub-Definition: 'SectionIdx' */
              if(cUiD instanceof TSStatic) { /* static object really is a track-object */
                /* 'SectionIdx' is not used with static objects but with track-objects */
                cUiD = new TSTrkObj((TSStatic)cUiD); /* correct object-type of entry */
                reqMsk = cUiD.getCtl(0); /* new mask of 'requested keywords' ('reqMsk') */
                valMsk = cUiD.getCtl(1); /* new mask of 'valid keywords' ('valMsk') */
                Typ = "TrackObj"; /* set objekt-Type to be used for error-messages */
                cUiD.setOpt(9); /* mark object as a converted 'static track'-object */
                cUiD.setOpt(10); /* mark: create 'hidewire'-object when writing */
                valMsk |= cUiD.getCtl(9); /* set additional valid lines */
                if(EnaH) Lg.Log("getWF057","SectionIdx",ks,cB.getStat(true)); /* print warning */
              } /* static object is converted to a track-object */
              if(!TSOpts.chkMsk(1,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF251",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD01; } /* do not further process definitionline */
                Lg.Err("getWF252",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(2)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF253",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD01; } /* do not further process definitionline */
                Lg.Err("getWF254",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              l = cB.getNV(); /* get number of connected shape-definition */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getWF255",Typ,ks,""+cB.getStat(true),is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(l==NoVS) { /* special case -- SectionIdx is NOT useable */
                /* Attention: It also cannot be found out, if 'Dynatrax' was used
                 * to modify this world-object. */
                cUiD.setOpt(14);  /* mark: correct value has to be found out later */
                cUiD.setMsk(2); /* mark: definitionline is successfully processed */
                Lg.Err("getWF256",Typ,ks); /* print errormessage */
                break SD01; } /* do not further process definitionline */
              i = (int)l; /* all special cases are considered -- convert value */
              /* If the current world-object is a 'hidewire'-object of type 'F', this
               * definition line is preceeded by a 'Config'-definition. In this case, the
               * correct 'SectionIDX'-value is found within this definition and the current
               * value must be replaced.
               */
              if(!cUiD.chkMsk(5)) { /* Definitionsline 'Config' is present */
                if(i<0 || i>=ShA) { /* invalid shape-index defined
                  * the current value does not refer to a global road-object */
                  Lg.Err("getWF257",Typ,k,i,ShA); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if((cShG=ShTab[i])==null) { /* current shape-reference is NOT defined */
                  Lg.Err("getWF258",Typ,ks,i); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if(!cShG.chkMsk(2)) { /* Dummy-SectionIDX-value must refer to a 'Road'-shape */
                  Lg.Err("getWF259",Typ,ks,i); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                /* swap current SectionIDX-Definition with the original value from 'Config' */
                if((i=cUiD.setInt(0,i))==Integer.MIN_VALUE) { /* line is missing */
                  Lg.Err("getWF25A",Typ,ks,cB.getStat(true)); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                cUiD.setOpt(15); /* mark: Hidewire'-object of type 'F' is active */
                if(EnaH) Lg.Log("getWF25B",Typ,ks,cB.getStat(true)); /* print: information: HW-object found */
                /* 'i' now contains 'original' SectionIDX-value */
              } /* consider 'Config'-Definition */
              /* If the current world-object was converted fron 'Dyntrack' to 'TrackObj' using 'DynaTrax',
               * this conversion must be reversed in order to check the object successfully.
               * Before writing, this is again neutralized.
               */
              if(cUiD instanceof TSTrkObj) SD01t:{ /* check definition for 'Trackobj' */
                if(i<ShA) break SD01t; /* shape-index is a valid 'static' shape -- continue */
                if(cUiD.isOpt(8)) break SD01t; /* 'JNodePosn' already defined -- continue */
                  /* 'JNodePosn' cannot be defined with converted objects. */
                cUiD = new TSDynTrk((TSTrkObj)cUiD); /* correct object-type of entry */
                reqMsk = cUiD.getCtl(0); /* new mask of 'requested keywords' ('reqMsk') */
                valMsk = cUiD.getCtl(1); /* new mask of 'valid keywords' ('valMsk') */
                Typ = "DynTrack"; /* set objekt-Type to be used for error-messages */
                cUiD.setOpt(8); /* mark object as a converted object */
                valMsk |= cUiD.getCtl(9); /* set additional valid lines */
                if(EnaH) Lg.Log("getWF058","SectionIdx",ks,cB.getStat(true)); /* print warning */
              } /* -SD01t- process 'TrackObj'-definition -- 'Dynatrax' was used to convert object */
              /* repeat type-check, because type may have changed! */
              if(cUiD instanceof TSTrkObj) { /* current world-object is 'Trackobj' */
                if(i<0) { /* valid shape-index (every case) */
                  Lg.Err("getWF25C",ks,i); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if(i>=ShA) { /* shape-index invald for 'TrackObj'-definitions */
                  Lg.Err("getWF25D",ks,i,ShA); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if((cShG=ShTab[i])==null) { /* shape-reference is NOT defined */
                  Lg.Err("getWF258",Typ,ks,i); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if(cShG.chkMsk(2)) cUiD.setOpt(2); /* copy 'road'-option (if set) */
                if(cShG.chkMsk(16)) cUiD.setOpt(3); /* set 'junction'-option (if applicable) */
                cUiD.chgShR(cShG); /* insert shape-reference to world-object */
                cShG.incCntW(1); /* and count usage */
              } else { /* current world-object is 'Dyntrack' */
                if((is=cRte.chkShT(i,false))!=null) { /* reference to pfad-definition not valid */
                  Lg.Err("getWF25E",is,ks); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                cShL = cRte.chgShT(i,null); /* get current local path-definition, */
                ((TSDynTrk)cUiD).chgShR(cShL); /* insert it as shape-reference */
                cShL.incCntW(1); /* and count usage */
                /* when 'Dynatrax' converts a dyntrack-object into a TrkObj, all tracksection-definitions
                 * are deleted. In order to check the original object, they must be restored from
                 * all available data. */
                if(cUiD.isOpt(8)) { /* DynTrack was converted to TrackObj -- insert tracksections */
                  is = ((TSDynTrk)cUiD).crSc(cRte); /* create section-definitions from path */
                  if(is!=null) { /* error found during creation) */
                    Lg.Err("getWF25F",ks,is); /* print errormessage */
                    ec += 1; /* count error */
                    break dtl; } /* terminate evaluation */
                } /* all tracksection-definitions were inserted */
              } /* type of current object is correct an complete */
              cUiD.setMsk(2); /* mark: definitionline is successfully processed */
            } else if(is.equals("elevation")) SD02:{ /* Sub-Definition: 'Elevation' */
              if(!TSOpts.chkMsk(2,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF261",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD02; } /* do not further process definitionline */
                Lg.Err("getWF262",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(3)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF263",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD02; } /* do not further process definitionline */
                Lg.Err("getWF264",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              f1 = cB.getFV(); /* get elevation-value of world-object */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getWF265",Typ,ks,""+cB.getStat(true),is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.chgElv(f1); /* insert currnt value for 'elevation' */
              cUiD.setMsk(3); /* mark: definitionline is successfully processed */
            } else if(is.equals("jnodeposn")) SD03:{ /* Sub-Definition: 'JNodePosn' */
              if(cUiD instanceof TSStatic) { /* static object really is a track-object */
                /* 'JNodePosn' is not used with static objects but with track-objects */
                cUiD = new TSTrkObj((TSStatic)cUiD); /* correct object-type of entry */
                reqMsk = cUiD.getCtl(0); /* new mask of 'requested keywords' ('reqMsk') */
                valMsk = cUiD.getCtl(1); /* new mask of 'valid keywords' ('valMsk') */
                Typ = "TrackObj"; /* set objekt-Type to be used for error-messages */
                cUiD.setOpt(9); /* mark object as a converted 'static track'-object */
                cUiD.setOpt(10); /* mark: create 'hidewire'-object when writing */
                valMsk |= cUiD.getCtl(9); /* set additional valid lines */
                if(EnaH) Lg.Log("getWF057","JNodePosn",ks,cB.getStat(true)); /* print warning */
              } /* static object is converted to a track-object */
              if(!TSOpts.chkMsk(3,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF271",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD03; } /* do not further process definitionline */
                Lg.Err("getWF272",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(4)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF273",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD03; } /* do not further process definitionline */
                Lg.Err("getWF274",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* load position-values (qx qz x y z) and check them */
              if((is=getPos(cB,true,true))!=null) { /* error within (JN-)position */
                Lg.Err("getWF275",Typ,ks,is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              aPos = (TSQPos)RetVal; /* get created JN-position */
              if((aPos=((TSTrkObj)cUiD).setNdeP(aPos))!=null) { /* position already set */
                Lg.Err("getWF276",Typ,ks,aPos.getPos(0)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setOpt(8); /* mark: JN-position has been defined */
              cUiD.setMsk(4); /* mark: definitionline is successfully processed */
            } else if(is.equals("treetexture")) SD04:{ /* Sub-Definition: 'TreeTexture' */
              if(cUiD instanceof TSStatic) { /* static object really is a track-object */
                /* 'TreeTexture' is used neighter with static objects nor track-objects.
                 * However 'Hidewire'-function uses 'TreeTexture' ONLY with track-objects.
                 */
                cUiD = new TSTrkObj((TSStatic)cUiD); /* correct object-type of entry */
                reqMsk = cUiD.getCtl(0); /* new mask of 'requested keywords' ('reqMsk') */
                valMsk = cUiD.getCtl(1); /* new mask of 'valid keywords' ('valMsk') */
                Typ = "TrackObj"; /* set objekt-Type to be used for error-messages */
                cUiD.setOpt(9); /* mark object as a converted 'static track'-object */
                cUiD.setOpt(10); /* mark: create 'hidewire'-object when writing */
                valMsk |= cUiD.getCtl(9); /* set additional valid lines */
                if(EnaH) Lg.Log("getWF057","TreeTexture",ks,cB.getStat(true)); /* print warning */
              } /* static object is converted to a track-object */
              if(!TSOpts.chkMsk(4,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF281",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD04; } /* do not further process definitionline */
                Lg.Err("getWF282",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              is = cB.getVal(1); /* get specified name of texture */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF285",Typ,ks); /* print errormessage */
                  cc = 113; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF286",Typ,ks,is); /* print errormessage */
                cc = 114; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(is.length()==0) { /* value is not present */
                Lg.Err("getWF287",Typ,ks); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(cUiD instanceof TSTrkObj) { /* current world-object is 'Trackobj' */
                if(cUiD.isOpt(12)) {  /* unmodified filename already specified ? */
                  if(KM) { /* correction-mode active -- do not terminate */
                    if(EnaW) Lg.Log("getWF283",Typ,ks,cB.getStat(true)); /* print warning-message */
                    break SD04; } /* do not further process definitionline */
                  Lg.Err("getWF284",Typ,ks,cB.getStat(true)); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if(cUiD.chkMsk(19)) { /* modified filename is NOT specified */
                  Lg.Err("getWF288",Typ,ks,cB.getStat(true)); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                /* Attention: 'unmodified filename' must not contain path */
                is = cUiD.chgNme(is); /* swap unmodified filename with modified one */
                ((TSTrkObj)cUiD).modNme(is); /* and store modified filename again */
              } else { /* current world-object is 'Forest' */
                if(!cUiD.chkMsk(1)) { /* definitionline was already present */
                  if(KM) { /* correction-mode active -- do not terminate */
                    if(EnaW) Lg.Log("getWF283",Typ,ks,cB.getStat(true)); /* print warning-message */
                    break SD04; } /* do not further process definitionline */
                  Lg.Err("getWF284",Typ,ks,cB.getStat(true)); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                cUiD.chgNme(is); /* insert name for treetexture into world-object */
                cUiD.setMsk(1); /* mark: definitionline is successfully processed */
              } /* all types of world-objects are processed now */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) /* error found within current input */
                if((is=cB.getErr())==null) is = TSLogg.getKey("getWF035"); /* EOF */
                else is = TSLogg.getMsg("getWF036",is); /* error within data */
              if(is.length()>1) { /* additional data found (" " returned in every case) */
                Lg.Err("getWF286",Typ,ks,is);  /* print errormessage */
                ec += 1; /* count error */
              } /* report additional error */
            } else if(is.equals("population")) SD05:{ /* Sub-Definition: 'Population' */
              if(!TSOpts.chkMsk(5,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF291",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD05; } /* do not further process definitionline */
                Lg.Err("getWF292",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF295",Typ,ks); /* print errormessage */
                  cc = 119; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF296",Typ,ks,is); /* print errormessage */
                cc = 120; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(cUiD instanceof TSForest) { /* current world-object is 'Forest' */
                if(!cUiD.chkMsk(4)) { /* definitionline was already present */
                  if(KM) { /* correction-mode active -- do not terminate */
                    if(EnaW) Lg.Log("getWF293",Typ,ks,cB.getStat(true)); /* print warning-message */
                    break SD05; } /* do not further process definitionline */
                  Lg.Err("getWF294",Typ,ks,cB.getStat(true)); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if((is=cUiD.chgDta(4,is))!=null) { /* value already set -- replaced */
                  if(is.charAt(0)!=' ') Lg.Err("getWF296",Typ,ks,is);
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                cUiD.setMsk(4); /* mark: definitionline is successfully processed */
              } else { /* current world-object is 'Telepole' */
                if(!cUiD.chkMsk(1)) { /* definitionline was already present */
                  if(KM) { /* correction-mode active -- do not terminate */
                    if(EnaW) Lg.Log("getWF293",Typ,ks,cB.getStat(true)); /* print warning-message */
                    break SD05; } /* do not further process definitionline */
                  Lg.Err("getWF294",Typ,ks,cB.getStat(true)); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if((is=cUiD.chgDta(0,is))!=null) { /* value already set -- replaced */
                  if(is.charAt(0)!=' ') Lg.Err("getWF296",Typ,ks,is);
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                cUiD.setMsk(1); /* mark: definitionline is successfully processed */
              } /* all types of world-objects are processed now */
            } else if(is.equals("config")) SD06:{ /* Sub-Definition: 'Config' */
              if(!TSOpts.chkMsk(6,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF301",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD06; } /* do not further process definitionline */
                Lg.Err("getWF302",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              i = (int)cB.getNV(); /* get number of config-definition */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getWF305",Typ,ks,""+cB.getStat(true),is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(i<0) { /* index is invalid in every case */
                Lg.Err("getWF306",Typ,ks,i); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(cUiD instanceof TSTelep) { /* current world-object is 'Telepol' */
                if(!cUiD.chkMsk(8)) { /* definitionline was already present */
                  if(KM) { /* correction-mode active -- do not terminate */
                    if(EnaW) Lg.Log("getWF303",Typ,ks,cB.getStat(true)); /* print warning-message */
                    break SD06; } /* do not further process definitionline */
                  Lg.Err("getWF304",Typ,ks,cB.getStat(true)); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if((i=cUiD.setInt(0,i))!=Integer.MIN_VALUE) { /* definition already stored? */
                  Lg.Err("getWF307",ks,i); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                cUiD.setMsk(8); /* mark: definitionline is successfully processed */
                break SD06; /* definitionline is processed completely and successful */
              }  /* current world-object was 'Telepol' */
              /* 'Config'-definitionline is additionally used in track-objects */
              if(!cUiD.chkMsk(5)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF303",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD06; } /* do not further process definitionline */
                Lg.Err("getWF304",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(2)) { /* 'SectionIDX-definition already processed? */
                if(EnaW) Lg.Log("getWF308",Typ,ks,cB.getStat(true)); /* print warning-message */
                break SD06; } /* do not further process definitionline */
              if((i=cUiD.setInt(0,i))!=Integer.MIN_VALUE) { /* definition already stored? */
                Lg.Err("getWF309",Typ,ks,i); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(5); /* mark: definitionline is successfully processed */
            /* 3. Part : Keywords, which are used only once with all world-objects, are handled here.
             *    To verify, that these keywords are valid with a world-object-type, class names of
             *    the appropriate world-object is used. Mask 'valMask' is no longer used for this
             *    purpose (inside this part).
             */
            } else if(is.equals("tracksections")) SD51:{ /* Sub-Definition: 'TrackSections' */
              if(!(cUiD instanceof TSDynTrk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF351",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD51; } /* do not further process definitionline */
                Lg.Err("getWF352",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(1)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF353",ks,cB.getStat(true)); /* print warning-message */
                  break SD51; } /* do not further process definitionline */
                Lg.Err("getWF354",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              for(i=0;i<5;i+=1) { /* definition contains exactly 5 entries */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getWF355",ks,i); /* print errormessage */
                    cc = 54; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getWF356",is,ks,i); /* print errormessage */
                  cc = 55; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                if(is.length()==0) { /* next keword not present */
                  Lg.Err("getWF357",ks,i); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if(!is.equals("tracksection")) { /* 'TrackSection' not found */
                  Lg.Err("getWF358",is,ks,i); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getWF359",ks,i); /* print errormessage */
                    cc = 56; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getWF356",is,ks,i); /* print errormessage */
                  cc = 57; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                if(is.length()==0) { /* next keword not present */
                  Lg.Err("getWF35A",ks,i); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if(!is.equals("sectioncurve")) { /* 'SectionCurve' not found */
                  Lg.Err("getWF35B",is,ks,i); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                j = (int)cB.getNV(); /* get argument of sectioncurve */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  Lg.Err("getWF35C",is,k,i,cB.getStat(true)); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if((i%2)!=j) { /* invalid type of SectionCurve */
                  Lg.Err("getWF35D",ks,i,j); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                  cc = 58; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                l = cB.getNV(); /* get number of connected section-definition */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  Lg.Err("getWF35E",is,k,i,cB.getStat(true)); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                if(l<NoVS) { /* ID references valid sectiondefinition (no dummy-value) */
                  j = (int)l; /* convert sectiondefinition for further processing */
                  f1 = cB.getFV(); /* get first section-value (length/angle) */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getWF35F",is,k,i,cB.getStat(true)); /* print errormessage */
                    ec += 1; /* count error */
                    break dtl; } /* terminate evaluation */
                  f2 = cB.getFV(); /* get second section-value ('0'/radius) */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getWF35G",is,k,i,cB.getStat(true)); /* print errormessage */
                    ec += 1; /* count error */
                    break dtl; } /* terminate evaluation */
                  if((cSc=cRte.chgScT(j,null))==null) { /* get local section -- error? */
                    is = cRte.chkScT(j,Double.NaN,0.0); /* get message due to error */
                    Lg.Err("getWF356",is,ks,i); /* print errormessage */
                    ec += 1; /* count error */
                    break dtl; } /* terminate evaluation */
                  if((is=cRte.chkScT(j,f1,f2))!=null) /* valid section-definition ? */
                    Lg.Err("getWF356",is,ks,i); /* print errormessage */
                  ((TSDynTrk)cUiD).chgScR(i,false,cSc); /* store it to world-object */
                  cSc.incCntW(1); /* and count usage */
                  if(f2>0.0) { /* section is a curve -- continue checking */
                    j += 1; /* switch to next section-index (left to right version) */
                    if((cSc=cRte.chgScT(j,null))==null) { /* get local section -- error? */
                      is = cRte.chkScT(j,Double.NaN,0.0); /* get message due to error */
                      Lg.Err("getWF356",is,ks,i); /* print errormessage */
                    } else { /* insert second section-definition to world-object */
                      if((is=cRte.chkScT(j,-f1,f2))!=null) /* valid section-definition ? */
                        Lg.Err("getWF356",is,ks,i); /* print errormessage */
                      ((TSDynTrk)cUiD).chgScR(i,true,cSc); /* store it to world-object */
                      cSc.incCntW(1); /* and count usage */
                    } /* second tracksection is handled */
                  } /* current section was a 'curve' */
                } /* no dummy-value found */
                if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                  cc = 61; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
              } /* process all 5 entries and check them */
              /* all 5 tracksection-definitons were checked -- definition is valid */
              cUiD.setMsk(1); /* mark: definitionline is successfully processed */
            } else if(is.equals("scalerange")) SD52:{ /* Sub-Definition: 'ScaleRange' */
              if(!(cUiD instanceof TSForest)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF361",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD52; } /* do not further process definitionline */
                Lg.Err("getWF362",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(2)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF363",ks,cB.getStat(true)); /* print warning-message */
                  break SD52; } /* do not further process definitionline */
                Lg.Err("getWF364",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF365",ks,cB.getStat(true)); /* print errormessage */
                  cc = 115; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF366",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 116; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(1,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF366",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(2); /* mark: definitionline is successfully processed */
            } else if(is.equals("area")) SD53:{ /* Sub-Definition: 'Area' */
              if(!(cUiD instanceof TSForest)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF371",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD53; } /* do not further process definitionline */
                Lg.Err("getWF372",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(3)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF373",ks,cB.getStat(true)); /* print warning-message */
                  break SD53; } /* do not further process definitionline */
                Lg.Err("getWF374",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF375",ks,cB.getStat(true)); /* print errormessage */
                  cc = 117; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF376",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 118; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(2,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF376",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(3); /* mark: definitionline is successfully processed */
            } else if(is.equals("treesize")) SD54:{ /* Sub-Definition: 'TreeSize' */
              if(!(cUiD instanceof TSForest)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF381",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD54; } /* do not further process definitionline */
                Lg.Err("getWF382",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(5)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF383",ks,cB.getStat(true)); /* print warning-message */
                  break SD54; } /* do not further process definitionline */
                Lg.Err("getWF384",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF385",ks,cB.getStat(true)); /* print errormessage */
                  cc = 121; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF386",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 122; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(5,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF386",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(5); /* mark: definitionline is successfully processed */
            } else if(is.equals("platformdata")) SD55:{ /* Sub-Definition: 'PlatformData' */
              if(!(cUiD instanceof TSPlatform)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF391",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD55; } /* do not further process definitionline */
                Lg.Err("getWF392",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(1)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF393",ks,cB.getStat(true)); /* print warning-message */
                  break SD55; } /* do not further process definitionline */
                Lg.Err("getWF394",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF395",ks,cB.getStat(true)); /* print errormessage */
                  cc = 133; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF396",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 134; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(0,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF396",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(1); /* mark: definitionline is successfully processed */
            } else if(is.equals("sidingdata")) SD56:{ /* Sub-Definition: 'SidingData' */
              if(!(cUiD instanceof TSSiding)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF401",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD56; } /* do not further process definitionline */
                Lg.Err("getWF402",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(1)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF403",ks,cB.getStat(true)); /* print warning-message */
                  break SD56; } /* do not further process definitionline */
                Lg.Err("getWF404",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF405",ks,cB.getStat(true)); /* print errormessage */
                  cc = 153; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF406",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 154; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(0,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF406",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(1); /* mark: definitionline is successfully processed */
            } else if(is.equals("speed_digit_tex")) SD57:{ /* Sub-Def: 'Speed_Digit_Tex' */
              if(!(cUiD instanceof TSSpeed)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF411",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD57; } /* do not further process definitionline */
                Lg.Err("getWF412",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(1)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF413",ks,cB.getStat(true)); /* print warning-message */
                  break SD57; } /* do not further process definitionline */
                Lg.Err("getWF414",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              is = cB.getVal(1); /* get specified name of texture */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF415",ks,cB.getStat(true)); /* print errormessage */
                  cc = 193; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF416",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 194; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(is.length()==0) { /* value is not present */
                Lg.Err("getWF417",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              ((TSSpeed)cUiD).chgTNme(is); /* insert name of digit-texture */
              cUiD.setMsk(1); /* mark: definitionline is successfully processed */
            } else if(is.equals("speed_sign_shape")) SD58:{ /* Sub-Def: 'Speed_Sign_Shape' */
              if(!(cUiD instanceof TSSpeed)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF421",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD58; } /* do not further process definitionline */
                Lg.Err("getWF422",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(2)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF423",ks,cB.getStat(true)); /* print warning-message */
                  break SD58; } /* do not further process definitionline */
                Lg.Err("getWF424",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF425",ks,cB.getStat(true)); /* print errormessage */
                  cc = 195; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF426",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 196; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(0,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF426",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(2); /* mark: definitionline is successfully processed */
            } else if(is.equals("speed_text_size")) SD59:{ /* Sub-Def: 'Speed_Text_Size' */
              if(!(cUiD instanceof TSSpeed)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF431",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD59; } /* do not further process definitionline */
                Lg.Err("getWF432",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(3)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF433",ks,cB.getStat(true)); /* print warning-message */
                  break SD59; } /* do not further process definitionline */
                Lg.Err("getWF434",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF435",ks,cB.getStat(true)); /* print errormessage */
                  cc = 195; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF436",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 196; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(1,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF436",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(3); /* mark: definitionline is successfully processed */
            } else if(is.equals("carfrequency")) SD60:{ /* Sub-Def: 'CarFrequency' */
              if(!(cUiD instanceof TSCarSp)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF441",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD60; } /* do not further process definitionline */
                Lg.Err("getWF442",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(1)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF443",ks,cB.getStat(true)); /* print warning-message */
                  break SD60; } /* do not further process definitionline */
                Lg.Err("getWF444",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF445",ks,cB.getStat(true)); /* print errormessage */
                  cc = 213; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF446",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 214; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(0,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF446",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(1); /* mark: definitionline is successfully processed */
            } else if(is.equals("caravspeed")) SD61:{ /* Sub-Definition: 'CarAvSpeed' */
              if(!(cUiD instanceof TSCarSp)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF451",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD61; } /* do not further process definitionline */
                Lg.Err("getWF452",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(2)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF453",ks,cB.getStat(true)); /* print warning-message */
                  break SD61; } /* do not further process definitionline */
                Lg.Err("getWF454",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF455",ks,cB.getStat(true)); /* print errormessage */
                  cc = 215; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF456",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 216; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(1,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF456",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(2); /* mark: definitionline is successfully processed */
            } else if(is.equals("levelcrparameters")) SD62:{ /* Sub-Def: 'LevelCrParameters' */
              if(!(cUiD instanceof TSLevelCr)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF461",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD62; } /* do not further process definitionline */
                Lg.Err("getWF462",Typ,k,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(1)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF463",Typ,k,cB.getStat(true)); /* print warning-message */
                  break SD62; } /* do not further process definitionline */
                Lg.Err("getWF464",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF465",ks,cB.getStat(true)); /* print errormessage */
                  cc = 233; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF466",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 234; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(0,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF466",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(1); /* mark: definitionline is successfully processed */
            } else if(is.equals("crashprobability")) SD63:{ /* Sub-Def: 'CrashProbability' */
              if(!(cUiD instanceof TSLevelCr)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF471",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD63; } /* do not further process definitionline */
                Lg.Err("getWF472",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(2)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF473",ks,cB.getStat(true)); /* print warning-message */
                  break SD63; } /* do not further process definitionline */
                Lg.Err("getWF474",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF475",ks,cB.getStat(true)); /* print errormessage */
                  cc = 235; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF476",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 236; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(1,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF476",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(2); /* mark: definitionline is successfully processed */
            } else if(is.equals("levelcrdata")) SD64:{ /* Sub-Def: 'LevelCrData' */
              if(!(cUiD instanceof TSLevelCr)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF481",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD64; } /* do not further process definitionline */
                Lg.Err("getWF482",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(3)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF483",ks,cB.getStat(true)); /* print warning-message */
                  break SD64; } /* do not further process definitionline */
                Lg.Err("getWF484",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              i = cB.getHV(8); /* convert options to number (8 Hex-chars) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getWF485",ks,is,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              ((TSLevelCr)cUiD).setDtaOpt(i); /* store options for 'LevelCrData' */
              i = (int)cB.getNV(); /* get number of TrItem-ID's */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getWF486",ks,is,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.chgItS(i); /* store expected number of TrItem-references (per DB) */
              cUiD.setMsk(3); /* mark: definitionline is successfully processed */
            } else if(is.equals("levelcrtiming")) SD65:{ /* Sub-Def: 'LevelCrTiming' */
              if(!(cUiD instanceof TSLevelCr)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF491",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD65; } /* do not further process definitionline */
                Lg.Err("getWF492",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(4)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF493",ks,cB.getStat(true)); /* print warning-message */
                  break SD65; } /* do not further process definitionline */
                Lg.Err("getWF494",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF495",ks,cB.getStat(true)); /* print errormessage */
                  cc = 237; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF496",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 238; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(2,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF496",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(4); /* mark: definitionline is successfully processed */
            } else if(is.equals("width")) SD66:{ /* Sub-Definition: 'Width' */
              if(!(cUiD instanceof TSTransf)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF501",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD66; } /* do not further process definitionline */
                Lg.Err("getWF502",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(1)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF503",ks,cB.getStat(true)); /* print warning-message */
                  break SD66; } /* do not further process definitionline */
                Lg.Err("getWF504",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF505",ks,cB.getStat(true)); /* print errormessage */
                  cc = 273; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF506",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 274; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(0,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF506",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(1); /* mark: definitionline is successfully processed */
            } else if(is.equals("height")) SD67:{ /* Sub-Definition: 'Height' */
              if(!(cUiD instanceof TSTransf)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF511",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD67; } /* do not further process definitionline */
                Lg.Err("getWF512",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(2)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF513",ks,cB.getStat(true)); /* print warning-message */
                  break SD67; } /* do not further process definitionline */
                Lg.Err("getWF514",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF515",ks,cB.getStat(true)); /* print errormessage */
                  cc = 275; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF516",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 276; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(1,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF516",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(2); /* mark: definitionline is successfully processed */
            } else if(is.equals("startposition")) SD68:{ /* Sub-Def: 'StartPosition' */
              if(!(cUiD instanceof TSTelep)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF521",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD68; } /* do not further process definitionline */
                Lg.Err("getWF522",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(2)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF523",ks,cB.getStat(true)); /* print warning-message */
                  break SD68; } /* do not further process definitionline */
                Lg.Err("getWF524",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF525",ks,cB.getStat(true)); /* print errormessage */
                  cc = 315; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF526",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 316; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(1,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF526",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(2); /* mark: definitionline is successfully processed */
            } else if(is.equals("endposition")) SD69:{ /* Sub-Def: 'EndPosition' */
              if(!(cUiD instanceof TSTelep)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF531",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD69; } /* do not further process definitionline */
                Lg.Err("getWF532",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(3)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF533",ks,cB.getStat(true)); /* print warning-message */
                  break SD69; } /* do not further process definitionline */
                Lg.Err("getWF534",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF535",ks,cB.getStat(true)); /* print errormessage */
                  cc = 317; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF536",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 318; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(2,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF536",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(3); /* mark: definitionline is successfully processed */
            } else if(is.equals("starttype")) SD70:{ /* Sub-Definition: 'StartType' */
              if(!(cUiD instanceof TSTelep)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF541",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD70; } /* do not further process definitionline */
                Lg.Err("getWF542",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(4)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF543",ks,cB.getStat(true)); /* print warning-message */
                  break SD70; } /* do not further process definitionline */
                Lg.Err("getWF544",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF545",ks,cB.getStat(true)); /* print errormessage */
                  cc = 319; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF546",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 320; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(5,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF546",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(4); /* mark: definitionline is successfully processed */
            } else if(is.equals("endtype")) SD71:{ /* Sub-Definition: 'EndType' */
              if(!(cUiD instanceof TSTelep)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF551",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD71; } /* do not further process definitionline */
                Lg.Err("getWF552",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(5)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF553",ks,cB.getStat(true)); /* print warning-message */
                  break SD71; } /* do not further process definitionline */
                Lg.Err("getWF554",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF555",ks,cB.getStat(true)); /* print errormessage */
                  cc = 321; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF556",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 322; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(6,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF556",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(5); /* mark: definitionline is successfully processed */
            } else if(is.equals("startdirection")) SD72:{ /* Sub-Def: 'StartDirection' */
              if(!(cUiD instanceof TSTelep)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF561",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD72; } /* do not further process definitionline */
                Lg.Err("getWF562",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(6)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF563",ks,cB.getStat(true)); /* print warning-message */
                  break SD72; } /* do not further process definitionline */
                Lg.Err("getWF564",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF565",ks,cB.getStat(true)); /* print errormessage */
                  cc = 323; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF566",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 324; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(7,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF566",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(6); /* mark: definitionline is successfully processed */
            } else if(is.equals("enddirection")) SD73:{ /* Sub-Def: 'EndDirection' */
              if(!(cUiD instanceof TSTelep)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF571",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD73; } /* do not further process definitionline */
                Lg.Err("getWF572",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(7)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF573",ks,cB.getStat(true)); /* print warning-message */
                  break SD73; } /* do not further process definitionline */
                Lg.Err("getWF574",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF575",ks,cB.getStat(true)); /* print errormessage */
                  cc = 325; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF576",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 326; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(8,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF576",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(7); /* mark: definitionline is successfully processed */
            } else if(is.equals("quality")) SD75:{ /* Sub-Definition: 'Quality' */
              if(!(cUiD instanceof TSTelep)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF591",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD75; } /* do not further process definitionline */
                Lg.Err("getWF592",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(9)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF593",ks,cB.getStat(true)); /* print warning-message */
                  break SD75; } /* do not further process definitionline */
                Lg.Err("getWF594",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF595",ks,cB.getStat(true)); /* print errormessage */
                  cc = 329; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF596",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 330; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(9,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF596",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(9); /* mark: definitionline is successfully processed */
            } else if(is.equals("direction")) SD76:{ /* Sub-Definition: 'Direction' */
              if(!(cUiD instanceof TSTelep)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF601",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD76; } /* do not further process definitionline */
                Lg.Err("getWF602",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(22)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF603",ks,cB.getStat(true)); /* print warning-message */
                  break SD76; } /* do not further process definitionline */
                Lg.Err("getWF604",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF605",ks,cB.getStat(true)); /* print errormessage */
                  cc = 331; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF606",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 332; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(10,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF606",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(22); /* mark: definitionline is successfully processed */
            } else if(is.equals("speedrange")) SD77:{ /* Sub-Def: 'SpeedRange' */
              if(!(cUiD instanceof TSPickup)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF611",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD77; } /* do not further process definitionline */
                Lg.Err("getWF612",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(1)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF613",ks,cB.getStat(true)); /* print warning-message */
                  break SD77; } /* do not further process definitionline */
                Lg.Err("getWF614",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF615",ks,cB.getStat(true)); /* print errormessage */
                  cc = 343; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF616",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 344; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(0,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF616",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(1); /* mark: definitionline is successfully processed */
            } else if(is.equals("pickuptype")) SD78:{ /* Sub-Definition: 'PickupType' */
              if(!(cUiD instanceof TSPickup)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF621",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD78; } /* do not further process definitionline */
                Lg.Err("getWF622",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(2)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF623",ks,cB.getStat(true)); /* print warning-message */
                  break SD78; } /* do not further process definitionline */
                Lg.Err("getWF624",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF625",ks,cB.getStat(true)); /* print errormessage */
                  cc = 345; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF626",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 346; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(2,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF626",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(2); /* mark: definitionline is successfully processed */
            } else if(is.equals("pickupanimdata")) SD79:{ /* Sub-Def: 'PickupAnimData' */
              if(!(cUiD instanceof TSPickup)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF631",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD79; } /* do not further process definitionline */
                Lg.Err("getWF632",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(3)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF633",ks,cB.getStat(true)); /* print warning-message */
                  break SD79; } /* do not further process definitionline */
                Lg.Err("getWF634",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF635",ks,cB.getStat(true)); /* print errormessage */
                  cc = 347; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF636",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 348; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(3,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF636",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(3); /* mark: definitionline is successfully processed */
            } else if(is.equals("pickupcapacity")) SD80:{ /* Sub-Def: 'PickupCapacity' */
              if(!(cUiD instanceof TSPickup)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF641",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD80; } /* do not further process definitionline */
                Lg.Err("getWF642",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cUiD.chkMsk(4)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getWF643",ks,cB.getStat(true)); /* print warning-message */
                  break SD80; } /* do not further process definitionline */
                Lg.Err("getWF644",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getWF645",ks,cB.getStat(true)); /* print errormessage */
                  cc = 349; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getWF646",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 350; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cUiD.chgDta(4,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getWF646",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cUiD.setMsk(4); /* mark: definitionline is successfully processed */
            } else { /* unknown keyword -- do not process */
              Lg.Err("getWF053",Typ,is,ks,""+cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl; } /* terminate evaluation */
            if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
              cc = 49; /* set current return-code to error */
              break bl; } /* terminate evaluation */
          } /* -while- process all sub-definitions (definitionlines) */
          if((j=cUiD.tstMsk(reqMsk))!=0) { /* check if definitionlines are missed
              * (check-mask is NOT changed) */
            is = ""; /* preset: no line is missed */
            l3 = -1; /* label not active -- used as intermediate value */
            for(i=0;i<32;i+=1) { /* check all possible definition-lines */
              if(TSOpts.chkMsk(i,reqMsk)) l3 += 1; /* forward to next index */
              if(!TSOpts.chkMsk(i,j)) continue; /* line not needed or present */
              is += "," + cUiD.getItem(l3); /* get/add description of missing line */
            } /* check all definition-lines */
            Lg.Err("getWF054",Typ,is.substring(1),ks,""+cB.getStat(true));
            ec += 1; /* count error */
            break dtl; } /* terminate evaluation */
          if(KM) { /* correction-mode active -- additional actions */
            if((j=cUiD.getCtl(2))!=0) /* add line ? ('getctl(2)' returns mask) */
             for(i=0;i<31;i+=1) { /* check all present definition-lines */
              if(!TSOpts.chkMsk(i,j)) continue; /* add is not needed/requested */
              if((is=cUiD.setDef(i,k))==null) { /* severe error while adding default-line */
                Lg.Err("getWF055",Typ,ks,i); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(EnaW) Lg.Log("getWF056",is); /* print: line has been created */
            } /* check all present definition-lines */
          }  /* correction-mode active */
          /* definition is now correct -- execute additional processing: */
          if(cUiD instanceof TSForest) /* process 'Forest'-definition */
            if(cUiD.chkMsk(1)) cUiD.setOpt(8); /* set marker for 'yard' */
              /* if 'TreeTexture' is missed a 'Forest'-definition defines a 'yard'-entry */
          cU.add(cUiD); /* add new entry to sorted list of world-objects */
          cUiD.chgQDf(cQDf); /* insert back-reference to quad-basis-definition */
        } /* 'dtl' - break-block for errors */
        /* If the processing of the world-object is aborted, the reamining definition-lines
         * must be skipped. The next 'skpFwd'-command advances the input-pointer after the
         * closing bracket of the current world-definition.
         */
        if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
          Lg.Err("getWF034",cB.getStat(true)); /* print errormessage */
          cc = 23; /* set current return-code to error */
          break bl; } /* terminate evaluation */
      } /* -for- process all world-definitions of the file */

      is = cB.skpVal(); /* get remaining value(s) within brackets */
      if(is==null) /* error found within current input */
        if((is=cB.getErr())==null) is = TSLogg.getKey("getWF035"); /* EOF */
        else is = TSLogg.getMsg("getWF036",is); /* error within data */
      if(is.length()>1) Lg.Err("getWF037",is); /* print error-message */
        /* additional data found (" " returned in every case) */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        cc = 17; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(cQDf.chgWTab(cU,u)!=null) Lg.Err("getWF039",u); /* print errormessage */
        /* insert chain of world-object-definitions to the quad-basis */

//      if() /* watermark-definition is still NOT stored */
//        if(EnaW) Lg.Log("getWF038",?); /* print warning about 'Watermark' */
    } /* -bl- break-block used in case of error */
    is = cF.close(); /* close inputfile again */
    if(is!=null) Lg.Err("getWF001",is); /* print errormessage */
    if(cc!=0) Lg.Log("getWF005",cc); /* print errormessage */
    else if(ec>0) Lg.Log("getWF006",ec); /* print number of errors */

    return cc; /* terminate method using return-code */
  }

 /**. <pre>
  *=====================================================================
  * Method "getVS"
  * Read complete viewSphere-definition(-chain) (recursive)
  * Method is used within: 'getWrld()'
  * Method returns address of the topmost element of the new (sub)chain
  *   of viewsheres.
  * Bracket-level (entry): next character inside vs-block
  *                        Pos = after keyword 'viewdbsphere('
  * Bracket-level (exit): next char AFTER closing bracket of vs-block
  * Global Counter:
  *   c4 - maximum allowed value for viewsphere-ID (x-1)
  *   c5 - current recursion-level within viewsphere-chain
  * ##getVS (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static TSView getVS( /* read viewSphere-definition */
   TSBuf  cB)  /* definiton of current input-buffer */
   {
   /*-----------------------------------------------------------------*/
    TSView cVS,nVS;  /* TSView-Definitions (current, new) */
    int    lv,ro;    /* current input-position, requested entries */
    int    i,id;     /* intermediate values */
    double fx,fy,fz; /* position-values of viewsphere */
    String is;       /* intermediate value */
   /*=================================================================*/
    lv  = cB.getBrL(); /* current bracket-level for terminate */
    ro  = 1;    /* no definitionlines found until now */
    cVS = null; /* ViewDBShere still NOT created */
    id  = -1;   /* viewsphere-ID is still not known */
    vl:while(true) { /* process all keywords of a viewsphere */
      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getVS01",c5); /* print errormessage */
          return null; } /* terminate evaluation */
        Lg.Err("getVS02",is,c5); /* print errormessage */
        return null; } /* terminate evaluation */
      if(is.length()==0) break; /* no more entries found */
      if(is.equals("vdbid")) { /* Definitionstype: 'VDbId' */
        /* Attention: This type of entry is the first definition of a new
         *            viewsphere. So, this line starts the
         *            definition of the curent viewsphere.
         */
        i = (int)cB.getNV(); /* get value of viewsphere-ID */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getVS11",is,cB.getStat(true)); /* print errormessage */
          break vl; } /* terminate evaluation */
        if(i<0 || i>=c4) { /* Id-Wert is not allowed */
          Lg.Err("getVS12",""+c5,i,c4); /* print errormessage */
          break vl; } /* terminate evaluation */
        if(cVS!=null) { /* ViewSphere is already created */
          Lg.Err("getVS13",null,id,i); /* print errormessage */
          break vl; } /* terminate evaluation */
        cVS = new TSView(i); /* create new TSView-Definition */
        id = i; /* and activate it as current viewsphere */
        ro *= 2; /* mark definitionline as 'present' */
      } else if(is.equals("viewdbsphere")) { /* Definitionstype: 'ViewDbSphere' */
        /* Attention: This type of entry starts the definition of a new
         *            viewsphere, which is located inside the current one.
         */
        if(cVS==null) { /* current viewSphere still NOT created */
          Lg.Err("getVS21",c5); /* print errormessage */
          break vl; } /* terminate evaluation */
        if(c5==TSUtil.mxLvl) /* Iteration error -- recursion to great */
          Lg.Err("getVS23",c5); /* print errormessage */
        c5 += 1; /* increment current recursion-level */
        nVS = getVS(cB); /* and process viewsphere-definition recursively */
          /* Attention: when returning the viewsphere is already closed */
        if(nVS==null) return null; /* pass-through error if present */
        c5 -= 1; /* viewsphere is processed -- decrement recursion-level again */
        if((is=nVS.chkPrnt())!=null) { /* parent already connected ? */
          Lg.Err("getVS22",is,cB.getStat(true)); /* print errormessage */
          break vl; } /* terminate evaluation */
        cVS.addVS(nVS); /* insert new child-connection  */
        continue; /* DO NOT skip terminating bracket (already done) */
      } else if(is.equals("position")) { /* Definitionstype: 'Position' */
        if(cVS==null) { /* ViewSphere still NOT created */
          Lg.Err("getVS31",c5); /* print errormessage */
          break vl; } /* terminate evaluation */
        if((ro%3)==0) { /* definitionline was already present */
          Lg.Err("getVS32",id); /* print errormessage */
          break vl; } /* terminate evaluation */
        fx = cB.getFV(); /* get first value of argument (number) */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getVS33",is,id,cB.getStat(true));
          break vl; } /* terminate evaluation */
        fy = cB.getFV(); /* get second value of argument (number) */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getVS34",is,id,cB.getStat(true));
          break vl; } /* terminate evaluation */
        fz = cB.getFV(); /* get third value of argument (number) */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getVS35",is,id,cB.getStat(true));
          break vl; } /* terminate evaluation */
        cVS.setPos(new TSPos(fx,fy,fz)); /* store new position-values */
        ro *= 3; /* mark definitionline as 'present' */
      } else if(is.equals("radius")) { /* Definitionstype: 'Radius' */
        if(cVS==null) { /* ViewSphere still NOT created */
          Lg.Err("getVS41",c5); /* print errormessage */
          break vl; } /* terminate evaluation */
        if((ro%5)==0) { /* definitionline was already present */
          Lg.Err("getVS42",id); /* print errormessage */
          break vl; } /* terminate evaluation */
        fx = cB.getFV(); /* get radius-value of viewsphere */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getVS43",is,id,cB.getStat(true));
          break vl; } /* terminate evaluation */
        cVS.setRad(fx); /* insert new value for 'Radius' */
        ro *= 5; /* mark definitionline as 'present' */
      } else { /* unknown definitionline found */
        Lg.Err("getVS03",is,c5,0); /* print errormessage */
        break vl; } /* terminate evaluation */
      if(cB.skpFwd()) return null; /* skip resuming data -- EOF/error found? */
    } /* -vl- process all keyword-definitions */
    if(cB.skpFwd(lv)) { /* skip resuming data to new entry -- EOF/error found? */
      Lg.Err("getVS04",""+c5,id,ro); /* print errormessage */
      return null; } /* terminate evaluation */
    if(ro!=30) { /* viewsphere is not complete (2,3,5) */
      Lg.Err("getVS05",""+c5,id,ro); /* print errormessage */
      return null; } /* terminate evaluation */
    return cVS; /* viewsphere was processed successfully */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkPos"
  * Check position-definition and create positionobject if successful.
  *   Format of position is: 'x y z'
  * Method can generate MORE than one error-message
  * Attention: 'RetVal' will obtain the result-object
  * Attention: Method shares message-IDs with 'getPos()'-method
  * Methode is referenced within:
  *  'getWrld()', 'getSnd()', getITF(), getItem()
  * ##chkPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String chkPos( /* check position-definition */
   TSBuf             cB, /* definiton of current input-buffer */
   TSSnd             cF, /* reference to sound-object or 'null' */
   ArrayList<String> EL) /* current list of warnings/errors */
   {
   /*-----------------------------------------------------------------*/
    double fx,fy,fz; /* intermediate results */
    String is;       /* current error-message */
   /*=================================================================*/
    fx = cB.getFV(); /* get value of argument (x-position) */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getPos3",is);
    if(fx< -1024.0) if(cF==null) return TSLogg.getMsg("getPos4",fx);
     else { cF.setOpt(8); /* mark error for checking */
      EL.add(TSLogg.getMsg("getPos4",fx)); /* store errormessage */
    } /* x-position was too small */
    if(fx>  1024.0) if(cF==null) return TSLogg.getMsg("getPos5",fx);
     else { cF.setOpt(9); /* mark error for checking */
      EL.add(TSLogg.getMsg("getPos5",fx)); /* store errormessage */
    } /* x-position was too great */
    fy = cB.getFV(); /* get value of argument (y-position) */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getPos6",is);
    fz = cB.getFV(); /* get value of argument (z-position) */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getPos7",is);
    if(fz< -1024.0) if(cF==null) return TSLogg.getMsg("getPos8",fz);
     else { cF.setOpt(10); /* mark error for checking */
      EL.add(TSLogg.getMsg("getPos8",fz)); /* store errormessage */
    } /* z-position was too small */
    if(fz>  1024.0) if(cF==null) return TSLogg.getMsg("getPos9",fz);
     else { cF.setOpt(11); /* mark error for checking */
      EL.add(TSLogg.getMsg("getPos9",fz)); /* store errormessage */
    } /* z-position was too great */

    RetVal = new TSPos(fx,fy,fz); /* create position */
    return null; /* return with 'no error' */
  }

 /**. <pre>
  *=====================================================================
  * Method "getQDir"
  * Load direction-values from Sub-Entry 'QDirection' and check them
  * Attention: 'RetVal' will obtain the result-object
  * Methode is referenced within:
  *  'getWrld()', 'getSnd()'
  * Background: 'Quaternions' uses
  *   Ax = X-Component of rotationvector (0..1)
  *   Ay = Y-Component of rotationvector (0..1)
  *   Az = Z-Component of rotationvector (0..1)
  *   w is rotation-angle of vector(0..2pi) relative to 'North'
  *   Relation1: Ax*Ax + Ay*Ay + Az*Az == 1
  *   Relation2: fa*fa + fb*fb + fc*fc + fd*fd == 1
  * ##getQDir (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getQDir( /* check direction-definition */
   TSBuf  cB)  /* definiton of current input-buffer */
   {
   /*-----------------------------------------------------------------*/
    double fa,fb,fc,fd,ft; /* intermediate values */
    String is;             /* current error-message */
   /*=================================================================*/
    /* fa = Ax * sin(w/2) */
    fa = cB.getFV(); /* get first value of direction */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getQDir1",is);
    ft = fa * fa; /* compute parity-check */
    /* fb = Ay * sin(w/2) */
    fb = cB.getFV(); /* get second value of direction */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getQDir2",is);
    ft += fb * fb; /* compute parity-check */
    /* fc = Az * sin(w/2) */
    fc = cB.getFV(); /* get third value of direction */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getQDir3",is);
    ft += fc * fc; /* compute parity-check */
    /* fd = cos(w/2) */
    fd = cB.getFV(); /* get fourth value of direction */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getQDir4",is);
    ft += fd * fd; /* compute parity-check */
    /* check parity, consider rounding */
    if(ft>1.001 || ft<0.999) return TSLogg.getMsg("getQDir5",ft);

    RetVal = new TSQDir(fa,fb,fc,fd); /* create Quaternion */
    return null; /* return with 'no error' */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkWrld"
  * gespeicherte World-Dateien bearbeiten und Fehler melden
  * Neuer Ausgabe-Modus einstellen, falls gefordert
  * ACHTUNG: Der Modus kann mit Optionen ueberlagert werden (+128,+64,..),
  *            die vor der Auswertung abgetrennt werden muessen
  * ##chkWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void chkWrld( /* alle 'World'-Dateien pruefen */
   TSRoute   cRte, /* aktuelle Routendefinition mit Basisverz. */
   TSNameSet Nme,  /* Liste fuer Shape-Namen (oder 'null') */
   int       mde)  /* Ausgabe-Modus und Optionen */
   {
   /*-----------------------------------------------------------------*/
    final String[]  prm = cRte.getParm(); /* arg-list for path-mod */
   /*-----------------------------------------------------------------*/
    TreeSet<TSQuad> QDf;  /* List of Quad-definitions */
    TSQuad          cQDf; /* current (active) Quad-definition */
    TSChain         cC;   /* current chain of (UiD-)objects */
    TSShape         cShG; /* global static Shape-reference */
    TSShL           cShL; /* dynamic Shape-reference */
    TSScL           cScL; /* dynamic Section-reference */
    TSUiD           cUiD; /* current UiD-entry */
    TSUiD           aUiD; /* alternate UiD-entry */
    TSTrkObj        cTrk; /* casted UiD-entry */
    TSSigSh         cSgS; /* current Signal-Shape-Definition */
    TSOpts          cM;   /* current selection-mask (object-type) */
    TSOpts          cMsk; /* current mask of recovery-types */
    int             i,j,u,v,w,n,cnt,c,ca;
    TSArrList       cL;   /* current data-queue */
    Object          o;    /* comparision-ctl: String/Pattern/null */
    Matcher         m;    /* used with regular expression */
    String          cFn1,cFn2,cP; /* Filenames, pathname */
    String          is;   /* Arbeitswert(e) */
    File            dat;  /* File-Objekt zum Testen */
    Iterator        cI;   /* common Iterator, used with 'TreeSet' */
    boolean         optZ; /* option '-z' is active (if 'true') */
    boolean         chg;  /* UiD-Aenderungen melden (UiD[1] wird immer gesetzt) */
    boolean         ren;  /* Neunummerierung durchfuehren wenn moeglich */
    boolean         mod;  /* Modify object-definitions if possible */
    boolean         cst;  /* Change 'StaticDetailLevel' if possible */
   /*=================================================================*/
    optZ = false; if(mde>=256) {optZ = true; mde -= 256;} /* Option! */
    chg  = false; if(mde>=128) {chg  = true; mde -= 128;} /* Option! */
    ren  = false; if(mde>=64) {ren = true; mde -= 64;} /* Option! */
    mod  = false; if(mde>=32) {mod = true; mde -= 32;} /* Option! */
    cst  = false; if(mde>=16) {cst = true; mde -= 16;} /* Option! */
    if((mde&4)!=0) mde = -1; /* set default IO-mode for world-files */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("chkW001",cRte.getInfo(1)); /* Aktionsmeldung */

    cnt = 0; /* World-Zahler initialisieren */
    ca  = 0; /* init counter of TrackObj (overall) */
    QDf = cRte.chgQDf(null); /* Alle Quadrat-Definitionen */
    if(QDf==null) throw new IllegalStateException( /* Sicherheitsabfrage */
      TSLogg.getMsg("Msg908","TreeSet<TSQuad>==null","TSUtil.chkWrld()",0));

    cMsk = Fo.getOpt(4,2); /* get current mask of recovery-types */
    cI = QDf.iterator(); /* Iterator fuer Quadrat-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cQDf = (TSQuad)cI.next(); /* naechste Quadrat-Definition */
      is = cQDf.getInf(2); /* Namen der World-Datei */
      if(is==null) continue; /* World-Datei fehlt -- nicht bearbeiten */
      cC = cQDf.chgWTab(null,0); /* Aktuelle Element-Kette (UiDs) */
      if(cC==null) continue; /* Leere World-Datei nicht bearbeiten */

      cnt += 1; /* Datei zaehlen */
      n = ren ? 0 : -1; /* neue UiD initialisieren (-1 : KEINE neue UiD) */
      Lg.Log("chkW002",is); /* Aktion melden */
      if(mde>=0) cQDf.chgMde(mde); /* establish NEW I/O-Mode of file */
        /* World-Dateien werden in DER Form wieder geschrieben,
         * in der sie gelesen wurden, falls nicht expliziert ein
         * neuer Modus gesetzt wird */

      c = 0; /* init counter of TrackObj */

      /* interne World-Daten bearbeiten und pruefen */
      for(cUiD=(TSUiD)cC.list(true);cUiD!=null;cUiD=(TSUiD)cC.list(false)) {
        /* nicht belegte UiD-Eintraege gibt es nicht (siehe 'getWF()') */
        if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
        if(cUiD.isCtl()) continue; /* kein aktiver UiD-Eintrag */
        u = cUiD.getUiD(0); /* aktuelle UiD holen */
        for(aUiD=(TSUiD)cC.next(true);aUiD!=cUiD;aUiD=(TSUiD)cC.next(false)) {
          if(aUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT vergleichen */
          if(aUiD.isCtl()) continue; /* kein aktiver UiD-Eintrag */
          if(aUiD.getUiD(1)==u) {  /* UiD ist mehrfach vergeben */
            is = ""; /* Vorbesetzen: keine Aenderung der UiD */
            if(!cUiD.isTrack()) { /* keine Track-Def. -- UiD aenderbar */
              j = cUiD.nxtUiD(cQDf); /* neue UiD eintragen (UiD[1],UiD[2]) */
              is = chg ? "chkW011" : "chkW012"; /* Kennung fuer Message */
              is = TSLogg.getMsg(is,cUiD.getName(true),j); /* Messageteil erstellen */
            } else if(!aUiD.isTrack()) { /* keine Track-Def. -- UiD aenderbar */
              j = aUiD.nxtUiD(cQDf); /* neue UiD eintragen (UiD[1],UiD[2]) */
              is = chg ? "chkW011" : "chkW012"; /* Kennung fuer Message */
              is = TSLogg.getMsg(is,aUiD.getName(true),j); /* Messageteil erstellen */
            } else if(cUiD.isRoad()) { /* Strassendefinition UND 2.Uid -- UiD aendern */
              j = cUiD.nxtUiD(cQDf); /* neue UiD eintragen (UiD[1],UiD[2]) */
              is = chg ? "chkW013" : "chkW014"; /* Kennung fuer Message */
              is = TSLogg.getMsg(is,cUiD.getName(true),j); /* Messageteil erstellen */
            } else if(aUiD.isRoad()) { /* Strassendefinition in erster UiD -- UiD aendern */
              j = aUiD.nxtUiD(cQDf); /* neue UiD eintragen (UiD[1],UiD[2]) */
              is = chg ? "chkW015" : "chkW016"; /* Kennung fuer Message */
              is = TSLogg.getMsg(is,aUiD.getName(true),j); /* Messageteil erstellen */
            } else if(cUiD instanceof TSTrkObj) { /* TrackObjekt UND 2.Uid -- UiD aendern */
              j = cUiD.nxtUiD(cQDf); /* neue UiD eintragen (UiD[1],UiD[2]) */
              is = chg ? "chkW017" : "chkW018"; /* Kennung fuer Message */
              is = TSLogg.getMsg(is,cUiD.getName(true),j); /* Messageteil erstellen */
            } else if(aUiD instanceof TSTrkObj) { /* TrackObjekt in erster UiD -- UiD aendern */
              j = aUiD.nxtUiD(cQDf); /* neue UiD eintragen (UiD[1],UiD[2]) */
              is = chg ? "chkW019" : "chkW020"; /* Kennung fuer Message */
              is = TSLogg.getMsg(is,aUiD.getName(true),j); /* Messageteil erstellen */
            } else { /* beide Uid's sind Schienen(TSDynTrk) -- 2. UiD aendern */
              j = cUiD.nxtUiD(cQDf); /* neue UiD eintragen (UiD[1],UiD[2]) */
              is = chg ? "chkW017" : "chkW018"; /* Kennung fuer Message */
              is = TSLogg.getMsg(is,cUiD.getName(true),j); /* Messageteil erstellen */
            } /* UiD -Typ-Pruefung abgeschlossen */
            Lg.Msg("chkW021",is,""+u,aUiD.getName(true),cUiD.getName(true));
            if(cUiD.chainUiD(aUiD)) Lg.Err("chkW022",u); /* Fehlermeldung ausgeben */
              /* Verkettungsfehler aufgetreten */
            break; /* Gleichheit -- nicht mehr weiter pruefen */
          } /* UiD doppelt vergeben */
        } /* alle vorangehenden UiD's */

        /* If an UId-entry is really valid, attributes 'Sh' and 'Sc' are valid, too.
         * However, if the SectionIdx-enty was not defined, a valid shape-definition is
         * not inserted into the object and 'Sh' contains 'null'. */
        if(cUiD instanceof TSTrkObj) {  /* continue check with next object-type ('TrackObj') */
          cL = Fo.getQue(4); /* prefetch affected Queue */
          cTrk = (TSTrkObj)cUiD; /* cast object to correct object-type */
          cFn1 = cTrk.modNme(null); /* get file/shape-Name(original) of object */
          if(Nme!=null) Nme.add(cFn1); /* register original Shape-Name */
          if(cUiD.isOpt(14)) ckw01R:{ /* Shape-Reference is unknown -- try to restore value */
            /* Object is of status 'to be restored'. It does not contain a valid
             * shape-definition. The filename should be modified and checked until
             * a valid shape-defintion is found.
             */
            /* 1) use filename without modification */
            if((i=insShE(cTrk,cFn1))>=0) { /* shape entry found and inserted */
              /* 'i' is the IDX-number of the inserted shape or '-1'. */
              if(EnaH) Lg.Log("chkW051",cFn1,u,i); /* print assignment-message */
              if((i=Fo.getInt(1))>0) { /* new 'StaticDetailLevel' requested */
                cUiD.setSL(i);   /* insert StaticDetailLevel (explicitely) into source-object */
                cC.reSort(cUiD); /* and adjust position of new element */
              } /* new StaticDetailLevel was requested -- changed */
              break ckw01R; /* match occurred -- do not continue search, no more checking */
            } /* shape-entry was found and inserted */

            /* 2) check all Path-Definitions and remove path if match found */
            cP = null; /* preset: path not found */
            is = cFn1; /* and remember unmodified filename */
            if((i=chkPath(Fo.getQue(2),cFn1,prm))>0) { /* alternate path was found */
              /* 'i' is the length of the path-prefix within the filename (or '0').
               * Now, use filename without path-prefix ('cFn1.substring(i)') */
              cFn1 = cFn1.substring(i); /* remove path from filename */
              cP = (String)TSUtil.RetVal; /* get appropriate path-value from sec. result */
            } /* alternate path found and activated */

            /* 3) use name after current path is removed */
            if((i=insShE(cTrk,cFn1))>=0) { /* shape entry found and inserted */
              /* 'i' is the IDX-number of the inserted shape or '-1'. */
              cFn1 = ShTab[i].chkNme(null); /* get correct name of shape-definition (case) */
              cUiD.chgNme(cFn1); /* set original filename/shapename of the object */
              cTrk.modNme(is);   /* and add the modified name (including path-prefix) */
              cUiD.setOpt(12);   /* mark: original name and current name do NOT match */
              if(EnaH) Lg.Log("chkW052",cFn1,u,1); /* print assignment-message */
              c += 1; /* count object as 'modified' */
              if((i=Fo.getInt(2))>0) { /* new 'StaticDetailLevel' requested */
                cUiD.setSL(i);   /* insert StaticDetailLevel (explicitely) into source-object */
                cC.reSort(cUiD); /* and adjust position of new element */
              } /* new StaticDetailLevel was requested -- changed */
              break ckw01R; /* match occurred -- do not continue search, no more checking */
            } /* shape-entry was found and inserted */

            /* 4) considder additional filename-modifications if available */
            if(optZ) { /* modifications should be considdered */
              w = cL.size(); /* get number of entries within control-queue (min=3) */
                /* Attention: some slots do not correspond to this entry-type */
              for(v=3;v<w;v+=3) { /* use all entries to check filename  (n groups a 3 entries) */
                if(!cMsk.chkMsk(v/3)) continue; /* entries do not apply -- skip them */
                o = cL.get(v+1); /* get selection-definition */
                is = cL.getDta(v+2); /* get replacement-string */
                if(o instanceof Pattern) { /* regular expression found */
                  m = ((Pattern)o).matcher(cFn1); /* compare names */
                  if(!m.lookingAt()) continue; /* 'match' is NOT successful */
                  cFn2 = m.replaceAll(is); /* create new filename */
                } else { /* text is compared to beginning of name */
                  cFn2 = (String)o; /* convert name to compare */
                  if(!cFn1.toLowerCase().startsWith(cFn2)) continue;
                    /* names do not match -- try next definition */
                  i = cFn2.length(); /* get length of prefix to be removed */
                  if(cFn1.length()>i) cFn2 = is + cFn1.substring(i);
                  else cFn2 = is; /* add replacementstring (may be of length 0) */
                } /* selection and process were successful */
                /* name (may) have been modified -- check if valid track */
                if((i=insShE(cTrk,cFn2))>=0) { /* shape entry found and inserted */
                  /* 'i' is the IDX-number of the inserted shape or '-1'. */
                  cFn2 = ShTab[i].chkNme(null); /* get correct name of shape-definition (case) */
                  if(cP!=null) cFn1 = cP + cFn1; /* add path to original filename again */
                  cUiD.chgNme(cFn2); /* set original filename/shapename of the object */
                  cTrk.modNme(cFn1); /* and add the modified name (including path-prefix) */
                  cUiD.setOpt(12); /* mark: original name and current name do NOT match */
                  c += 1; /* count object as 'modified' */
                  Lg.Log("chkW053",cFn1,cFn2,""+u,""+i,""+v); /* print modified object */
                  i = ((Integer)cL.get(v)).intValue(); /* get requested StaticDetailLevel */
                  if(i>0) { /* new 'StaticDetailLevel' requested */
                    cUiD.setSL(i);   /* insert StaticDetailLevel (explicitely) into source-object */
                    cC.reSort(cUiD); /* and adjust position of new element */
                  } /* new StaticDetailLevel was requested -- changed */
                  break ckw01R; /* match occurred -- do not continue search, no more checking */
                } /* shape-entry was found and inserted */
              } /* -for- try all modification-definitions */
            } /* -optZ- modifications should be considdered */
            Lg.Err("chkW054",cFn1,cP==null?"":cP,u); /* no match found -- print error-message */

          } else ckw01:{ /* -ckw01R- shape-reference was (successfully) restored  -- else check it */
            /* Definition contains a valid TrackObj. However, the filename may be modified and will
             * not match the selected shape-definition. This should be investigated and resolved.
             */
            cShG = cTrk.chgShR(null); /* get current shape-definition */
            if(cShG==null) throw new IllegalStateException( /* security-check */
              TSLogg.getMsg("Msg908","Shape<TSTrkObj>==null","TSUtil.chkWrld()",0));
              /* shape reference must be inserted  */

            /* 1) use filename without modification */
            if(cShG.chkNme(cFn1)==null) break ckw01; /* tsection-Definition matches filename */

            /* 2) check all Path-Definitions and remove path if match found */
            cP = null; /* preset: path not found */
            is = cFn1; /* and remember unmodified filename */
            if((i=chkPath(Fo.getQue(2),cFn1,prm))>0) { /* alternate path was found */
              /* 'i' is the length of the path-prefix within the filename (or '0').
               * Now, use filename without path-prefix ('cFn1.substring(i)') */
              cFn1 = cFn1.substring(i); /* remove path from filename */
              cP = (String)TSUtil.RetVal; /* get appropriate path-value from sec. result */
            } /* alternate path found and activated */

            /* 3) use name after current path is removed */
            if(cShG.chkNme(cFn1)==null) { /* tsection-Definition NOW matches filename */
              cFn1 = cShG.chkNme(null); /* get correct name of shape-definition (case) */
              cUiD.chgNme(cFn1); /* set original filename/shapename of the object */
              cTrk.modNme(is);   /* and add the modified name (including path-prefix) */
              cUiD.setOpt(12);   /* mark: original name and current name do NOT match */
              c += 1; /* count object as 'modified' */
              break ckw01; /* match occurred -- do not continue search, no more checking */
            } /* shape-entry was found and inserted */

            /* 4) considder additional filename-modifications if available */
            if(optZ) { /* modifications should be considdered */
              w = cL.size(); /* get number of entries within control-queue (min=3) */
                /* Attention: some slots do not correspond to this entry-type */
              for(v=3;v<w;v+=3) { /* use all entries to check filename  (n groups a 3 entries) */
                if(!cMsk.chkMsk(v/3)) continue; /* entries do not apply -- skip them */
                o = cL.get(v+1); /* get selection-definition */
                is = cL.getDta(v+2); /* get replacement-string */
                if(o instanceof Pattern) { /* regular expression found */
                  m = ((Pattern)o).matcher(cFn1); /* compare names */
                  if(!m.lookingAt()) continue; /* 'match' is NOT successful */
                  cFn2 = m.replaceAll(is); /* create new filename */
                } else { /* text is compared to beginning of name */
                  cFn2 = (String)o; /* convert name to compare */
                  if(!cFn1.toLowerCase().startsWith(cFn2)) continue;
                    /* names do not match -- try next definition */
                  i = cFn2.length(); /* get length of prefix to be removed */
                  if(cFn1.length()>i) cFn2 = is + cFn1.substring(i);
                  else cFn2 = is; /* add replacementstring (may be of length 0) */
                } /* selection and process were successful */
                /* name (may) have been modified -- check if valid track */
                if(cShG.chkNme(cFn2)==null) { /* tsection-Definition NOW matches filename */
                  cFn2 = cShG.chkNme(null); /* get correct name of shape-definition (case) */
                  if(cP!=null) cFn1 = cP + cFn1; /* add path to original filename again */
                  cUiD.chgNme(cFn2); /* set original filename/shapename of the object */
                  cTrk.modNme(cFn1); /* and add the modified name (including path-prefix) */
                  cUiD.setOpt(12); /* mark: original name and current name do NOT match */
                  Lg.Log("chkW053",cFn1,cFn2,""+u,""+cShG.getNr(true),""+v); /* print modified object */
                  c += 1; /* count object as 'modified' */
                  break ckw01; /* match occurred -- do not continue search, no more checking */
                } /* shape-entry was found and inserted */
              } /* -for- try all modification-definitions */
            } /* -optZ- modifications should be considdered */
            if(EnaW) Lg.Log("chkW055",cFn1,cShG.chkNme(null),u); /* Meldung ausgeben */
            cUiD.setOpt(16); /* mark it within definition */
          } /* -ckw01- check fully defined TrackObj-definition */
          is = cUiD.chgNme(null); /* get (finally) used Shape-/File-Name */
          if(Nme!=null) Nme.add(is); /* and register it, if necessary */
          if(cUiD.isOpt(8)) { /* zusaetzliche Quadrat-Definition ist vorhanden (JNodePosn) */
            if(cTrk.fndWrld(QDf)==null) Lg.Err("chkW056",is,u); /* print error-message */
             /* assignment of referenced quad was NOT possible -- quad not found */
          } else if(cUiD.isOpt(3)) if(EnaH) Lg.Log("chkW057",is,u); /* print warning-message */
            /* quad-assignment of 'JNodePosn' processed */

        } else if(cUiD instanceof TSDynTrk) {  /* continue check with next object-type ('Dyntrack') */
          if(cUiD.isOpt(14)) ckw02R:{ /* Pfad-Referenz war nicht nutzbar -- Wert suchen und einsetzen */
            /* alle Pfad-Definitionen durchsuchen */
            j = cRte.get$Sh(true); /* aktuelle 'alte' obere Grenze holen */
            if(j<=ShA) { /* eine lokale 'tsection.dat'-tabelle existiert nicht! */
              Lg.Err("chkW103",u); /* nicht gefunden -- Fehlermeldung ausgeben */
              break ckw02R; /* Bearbeitung der Track-Definition beendet, NICHT weiter pruefen */
            } /* Dyntrack-Definition OHNE lokale tsection.dat aufgetreten */
            ckw02L:for(i=ShA;i<j;i+=1) { /* alle Pfad-Definitionen ueberpruefen */
              cShL = cRte.chgShT(i,null); /* aktuellen Eintrag holen */
              if(cShL==null) continue; /* nicht benutzt -- weiter */
              if(cShL.incCntW(0)>0) continue; /* Pfad ist bereits zugeordnet */
              for(v=0,w=0;v<5;v+=1) { /* alle Tracksection-Definitionen vergleichen */
                cScL = ((TSDynTrk)cUiD).chgScR(v,false,null); /* gespeicherte Section-Kennung holen */
                if(cScL==null) continue; /* TrackSection nicht belegt */
                if(cShL.fndSc(cScL)!=w) continue ckw02L; /* Verkettete Section-Kennung passt nicht */
                w += 1; /* auf naechste Section */
              } /* alle 'TrackSections' vergleichen */
              if(w!=cShL.addScR(null)) continue; /* Section-Kennung passt nicht */
              /* passende Pfad-Definition gefunden -- registrieren */
              ((TSDynTrk)cUiD).chgShR(cShL); /* Lokale Shape-Referenz eintragen */
              cShL.incCntW(1); /* und vermerken (zaehlen) */
              if((v=Fo.getInt(1))>0) { /* neuer 'StaticDetailLevel' angegeben */
                cUiD.setSL(v);   /* insert StaticDetailLevel (explicitely) into source-object */
                cC.reSort(cUiD); /* Element neu einsortieren */
              } /* neuer (geforderter) StaticDetailLevel angegeben */
              if(EnaH) Lg.Log("chkW105",null,u,cShL.getNr(true)); /* Zuordnungs-Meldung ausgeben */
              break ckw02R; /* Bearbeitung der Track-Definition beendet, NICHT weiter pruefen */
            } /* -ckw02L- alle Pfad-Definitionen versuchen */
            /* KEINE gueltige Section-Zuordung fuer Pfad gefunden! */
            Lg.Err("chkW104",u); /* nicht gefunden -- Fehlermeldung ausgeben */
          } else { /* -chkw02R- Pfad-Referenz wurde restauriert -- sonst pruefen */
            cShL = ((TSDynTrk)cUiD).chgShR(null); /* gespeicherte Shape/Pfad-Referenz holen */
            for(v=0,w=0;v<5;v+=1) { /* alle Tracksection-Definitionen */
              cScL = ((TSDynTrk)cUiD).chgScR(v,false,null); /* gespeicherte Section-Kennung holen */
              if(cScL==null) continue; /* TrackSection nicht belegt */
              if(cShL.fndSc(cScL)!=w) /* Verkettete Section-Kennung passt nicht */
                Lg.Err("chkW101",""+w,u,v); /* Fehlermeldung ausgeben */
              w += 1; /* auf naechste Section */
            } /* alle 'TrackSections' */
            if(w!=cShL.addScR(null)) Lg.Err("chkW102",""+cShL.getNr(true),u,w); /* print errormessage */
          } /* Section-Pruefung war erforderlich */

          /* continue with range-check for both cases */
          for(v=0,w=0;v<5;v+=1) { /* check all connected section-definitions */
            cScL = ((TSDynTrk)cUiD).chgScR(v,false,null); /* get stored section-definition */
            if(cScL==null) continue; /* TrackSection is not used -- continue */
            if(w==0) w = v; /* FIRST valid section available -- definition-gap may now occur */
            if(v!=w) { /* definition-gap within section-definitions */
              Lg.Err("chkW107",null,u,v); /* gap within section-definitions -- print error */
              break; } /* no more checking needed */
            w += 1; /* valid definition -- count it */
            if(!cScL.isCurve()) continue; /* do not check 'straight' */
            if(cScL.getLR()<50.0) if(EnaW) Lg.Log("chkW106","50.0",u,cScL.getNr(false)); /* Radius is too small */
          } /* -for- check all 'TrackSection'-definitions */
          if(Nme!=null) Nme.add(cUiD.chgNme(null)); /* register file-name if available (Dynatrack-object) */

        } else if(cUiD instanceof TSSignal) { /* continue check with next object-type ('Signal') */
          is = cUiD.chgNme(null); /* Datei/Shape-Name des Signals holen */
          if(Nme!=null) Nme.add(is); /* genutzter Shape-Name registrieren */
          if(cRte.get$SgS(false)>0) { /* Signal-Shape-Definitionen verfuegbar */
            cSgS = cRte.fndSigS(is); /* Signal-Shape-Eintrag suchen */
            if(cSgS==null) /* Signal-Shape-Definition nicht gefunden */
              Lg.Err("chkW152",is,u,0); /* Fehlermeldung ausgeben */
            else { /* Signal-Shape-Referenz gefunden -- eintragen */
              ((TSSignal)cUiD).chgSigS(cSgS); /* Shape-Referenz eintragen */
              cSgS.incCnt(1); /* und benutzte Referenz zaehlen */
              /* weitere logische Pruefungen */
              i = ((TSSignal)cUiD).chgMsk(0); /* Maske der verwendeten Subobjekte holen */
              for(v=cSgS.get$SO();v<TSSignal.K_MaxIt;v+=1) /* Ungueltige Subobjekte ueberpruefen */
                if(TSOpts.chkMsk(v,i)) Lg.Err("chkW153",is,u,v); /* weitere Objekte definiert -- Fehler */
            } /* Signal-Shape-Referenz ist verfuegbar */
          } /* Signal-Shape-Definitionen verfuegbar */
          if((i=chkItm(cUiD,cRte,0,"'Signal("+u))!=0) /* TrItem-Definition pruefen und registrieren */
            Lg.Err("chkW151",null,u,i); /* Fehlermeldung ausgeben */

        } else if(cUiD instanceof TSStatic) { /* continue check with next object-type ('Static') */
          is = cUiD.chgNme(null); /* get file/shape-name of current object */
          dat = cRte.getFile(15); /* get reference to Shape-directory */
          dat = new File(dat,is); /* and expand it to file-definition */
          if(!dat.exists()) { /* requested file is NOT found within shape-directory */
            dat = cRte.getFile(-2); /* get reference to GLOBAL-Shape-directory */
            dat = new File(dat,is); /* and expand it to file-definition */
            if(dat.exists()) /* requested file is NOT found within GLOBAL shape-directory */
              if (EnaW) Lg.Log("chkW201",is,u); /* print message concerning type of entry */
          } /* requested file is NOT found within LOCAL shape-directory */
          if(Nme!=null) Nme.add(is); /* register shape-name */

          if((w=Fo.get$Obj(2))>10) { /* object may be converted into 'Gantry' -- check it */
            for(v=10;v<w;v+=1) { /* process all modification-requests */
              o = Fo.getObj(2,v); /* get selection-definition */
              if(o instanceof Pattern) { /* check of text uses 'regular expression' */
                if(!((Pattern)o).matcher(is).matches()) continue; /* 'match' is NOT successful */
              } else /* text is compared to beginning of name */
                if(!is.toLowerCase().startsWith(((String)o).toLowerCase())) continue;

              /* OK -- change object into 'Gantry'-definition */
              if((is=cC.remove(cUiD))!=null) { /* error when deleting old entry from UiD-chain */
                Lg.Err("chkW202",is,cUiD.getMsg(1),u); /* create nessage */
                break; /* do not remove entry -- ignore it */
              } /* current static entry could not be removed */
              cUiD = new TSGantry((TSStatic)cUiD); /* convert 'Static'-entry to 'Gantry'-entry */
              cC.add(cUiD); /* add converted entry to current object-chain */
              cUiD.chgQDf(cQDf); /* and insert backchain to quad-definition */
              if (EnaW) Lg.Log("chkW203",is,cUiD.getMsg(1),u); /* print message about conversion */
              break; /* no more checks needed -- object was converted */
            } /* -for- all modification-requests are processed */
          } /* convert object into 'Gantry' */

        } else if(cUiD instanceof TSForest) { /* continue check with next object-type ('Forest'/'yard') */
          if(cUiD.isOpt(8)) { /* Definition ist 'yard' */
            if (EnaH) Lg.Log("chkW251",u); /* Hinweis ueber Eintragstyp */
            is = cUiD.chgDta(5," 0 0 "); /* aktueller Wert fuer 'Treesize' ersetzen */
            if(!is.equals(" 0 0 ")) /* 'TreeSize' passt nicht -- melden Aenderung */
              if (EnaW) Lg.Log("chkW252",is,u); /* Hinweis ueber Eintragstyp */
          } /* 'yard'-Definition lag vor */
          if(Nme!=null) Nme.add(cUiD.chgNme(null)); /* register texturename */

        } else if(cUiD instanceof TSPlatform) { /* continue check with next object-type ('Platform') */
          i = cUiD.get$TrI(0); /* Anzahl der 'TrItem's */
          if(i!=2) /* Anzahl der geforderten Definitionen falsch */
            Lg.Err("chkW302",null,u,i); /* Fehlermeldung ausgeben */
          if((i=chkItm(cUiD,cRte,0,"'Platform("+u))!=0) /* TrItem-Definition pruefen und registrieren */
            Lg.Err("chkW301",null,u,i); /* Fehlermeldung ausgeben */
          if((is=chkSrt(cUiD,"'Platform("+u))!=null) /* check sequence of items and correct it */
            Lg.Err(is); /* error -- print message */

        } else if(cUiD instanceof TSSiding) { /* continue check with next object-type ('Siding') */
          i = cUiD.get$TrI(0); /* Anzahl der 'TrItem's */
          if(i!=2) /* Anzahl der geforderten Definitionen falsch */
            Lg.Err("chkW352",null,u,i); /* Fehlermeldung ausgeben */
          if((i=chkItm(cUiD,cRte,0,"'Siding("+u))!=0) /* TrItem-Definition pruefen und registrieren */
            Lg.Err("chkW351",null,u,i); /* Fehlermeldung ausgeben */
          if((is=chkSrt(cUiD,"'Siding("+u))!=null) /* check sequence of items and correct it */
            Lg.Err(is); /* error -- print message */

        } else if(cUiD instanceof TSSpeed) { /* continue check with next object-type ('Speedpost') */
          if((i=chkItm(cUiD,cRte,0,"'Speedpost("+u))!=0) /* TrItem-Definition pruefen und registrieren */
            Lg.Err("chkW451",null,u,i); /* Fehlermeldung ausgeben */
          if(Nme!=null) { Nme.add(cUiD.chgNme(null)); /* genutzter Shape-Name registrieren */
            Nme.add(((TSSpeed)cUiD).chgTNme(null)); } /* register texture */

        } else if(cUiD instanceof TSCarSp) { /* continue check with next object-type ('CarSpawner') */
          if((i=chkItm(cUiD,cRte,1,"'CarSpawner("+u))!=0) /* TrItem-Definition pruefen und registrieren */
            Lg.Err("chkW501",null,u,i); /* Fehlermeldung ausgeben */

        } else if(cUiD instanceof TSLevelCr) { /* continue check with next object-type ('LevelCr') */
          j = ((TSLevelCr)cUiD).chkItS(-1); /* Anzahl der TrItems (Soll) pro Datenbank */
          if((i=((TSLevelCr)cUiD).chkItS(0))>=0) /* Anzahl TrItem-Definition pruefen */
            Lg.Err("chkW552",""+i+"!="+j,u,0); /* Fehlermeldung ausgeben */
          if((i=((TSLevelCr)cUiD).chkItS(1))>=0) /* Anzahl TrItem-Definition pruefen */
            Lg.Err("chkW553",""+i+"!="+j,u,0); /* Fehlermeldung ausgeben */
          if((i=chkItm(cUiD,cRte,0,"'LevelCr("+u))!=0) /* TrItem-Definition pruefen und registrieren */
            Lg.Err("chkW551",null,u,i); /* Fehlermeldung ausgeben */
          if((i=chkItm(cUiD,cRte,1,"'LevelCr("+u))!=0) /* TrItem-Definition pruefen und registrieren */
            Lg.Err("chkW551",null,u,i); /* Fehlermeldung ausgeben */
          if(Nme!=null) Nme.add(cUiD.chgNme(null)); /* genutzter Shape-Name registrieren */

        } else if(cUiD instanceof TSHazard) { /* continue check with next object-type ('Hazard') */
          if((i=chkItm(cUiD,cRte,0,"'Hazard("+u))!=0) /* TrItem-Definition pruefen und registrieren */
            Lg.Err("chkW601",null,u,i); /* Fehlermeldung ausgeben */
          if(Nme!=null) Nme.add(cUiD.chgNme(null)); /* genutzter Shape-Name registrieren */

        } else if(cUiD instanceof TSPickup) { /* continue check with next object-type ('Pickup') */
          if((i=chkItm(cUiD,cRte,0,"'Pickup("+u))!=0) /* TrItem-Definition pruefen und registrieren */
            Lg.Err("chkW801",null,u,i); /* Fehlermeldung ausgeben */
          if(Nme!=null) Nme.add(cUiD.chgNme(null)); /* genutzter Shape-Name registrieren */

        } else if(Nme!=null) Nme.add(cUiD.chgNme(null)); /* register name if available */
          /* all other object-types: check if name available and register it */

        /* Modify object if requested */
        if(mod && !cUiD.chkMsk(20)) { /* modify object-definition as requested */
          /* modification is only possible if 'StaticFlags' are explicitely defined */
          cL = Fo.getQue(6); /* prefetch affected Queue */
          is = cUiD.chgNme(null); /* register file-name if available */
          if(cUiD instanceof TSTrkObj) is = ((TSTrkObj)cUiD).modNme(null); /* real name */
          if(is==null) is = ""; /* use 0-name if no name exists */
          for(i=10;i<cL.size();i+=4) { /* process all modification-requests */
            cM = cL.getOpt(i); /* get mask of supported object-types */
            if(!cM.chkMsk(24)) continue; /* NO modification-request -- next entry */
            if(!cUiD.chkType(cM)) continue; /* modification-request does not apply */
            o = cL.get(i+1); /* get selection-definition */
            if(o instanceof Pattern) { /* regular expression found */
              if(!((Pattern)o).matcher(is).matches()) continue; /* 'match' is NOT successful */
            } else /* text is compared to beginning of name */
              if(!is.toLowerCase().startsWith(((String)o).toLowerCase())) continue;
            v = cL.getInt(i+2); /* get OR-mask for new value */
            w = cL.getInt(i+3); /* get AND-mask for new value */
            cUiD.setStF((cUiD.setStF(0)|v)&w); /* compute new value for 'StaticFlags' */
          } /* -for- all modification-requests are processed */
        } /* object-definition was modified */
        if(cst) { /* change current 'StaticDetailLevel' of object as requested */
          cL = Fo.getQue(6); /* prefetch affected Queue */
          is = cUiD.chgNme(null); /* register file-name if available */
          if(cUiD instanceof TSTrkObj) is = ((TSTrkObj)cUiD).modNme(null); /* real name */
          if(is==null) is = ""; /* use 0-name if no name exists */
          for(i=10;i<cL.size();i+=4) { /* process all modification-requests */
            cM = cL.getOpt(i); /* get mask of supported object-types */
            if(!cM.chkMsk(25)) continue; /* NO change-request -- next entry */
            if(!cUiD.chkType(cM)) continue; /* change-request does not apply */
            if(!cUiD.chkSL(cL.getOpt(i+2))) continue; /* check StaticDetailLevel */
              /* skip if current StaticDetailLevel not involved */
            o = cL.get(i+1); /* get selection-definition */
            if(o instanceof Pattern) { /* regular expression found */
              if(!((Pattern)o).matcher(is).matches()) continue; /* 'match' is NOT successful */
            } else /* text is compared to beginning of name */
              if(!is.toLowerCase().startsWith(((String)o).toLowerCase())) continue;
            /* OK -- change StaticDetailLevel of object */
            cUiD.setSL(cL.getInt(i+3)); /* insert new StaticDetailLevel (explicitely) */
            cC.reSort(cUiD); /* and resort world-object */
          } /* -for- all change-requests were processed */
        } /* object-definition was modified */

        n = cUiD.renUiD(n); /* ggf. neue UiD vergeben */
      } /* alle Eintraege der 'World'-Datei bearbeiten */
      ca += c; /* increment 'overall'-counter */
      Lg.Log("chkW008",c); /* print result of the check-operation */
      Lg.Skip(false); /* print empty line */
    } /* process all 'World'-files */

    Lg.Log("chkW009",""+cnt,ca); /* print result of the check-operation */
    Lg.Skip(false); /* print empty line */
    return; /* OK -- leave method */
  }

 /**. <pre>
  *=====================================================================
  * Methode "insShE"
  * Search name of shape within table of shapes and insert appropriate
  *  element into TSTrkObj-object if found.
  * Function returns IDX-number of inserted shape or '-1'.
  * ##insShE (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int insShE( /* search and insert shape (element) */
   TSTrkObj cU,  /* current world-object to be processed */
   String   cFn) /* filename to be checked */
   {
   /*-----------------------------------------------------------------*/
    TSShape cSh;   /* static shape-entry */
    int     i,j,g; /* index-/temporary value(s) */
   /*=================================================================*/
    g = ShTab.length; /* compute upper bound of shape-array */
    for(i=0,j=1;i<g;i+=j,j=1) { /* check all shape-entries */
      if((cSh=ShTab[i])==null) continue; /* shape not defined -- skip it */
      j = cSh.$dIx(0); /* compute difference to next element */
      if(cSh.chkNme(cFn)==null) { /* tsection.dat-definition matches */
        if(cSh.chkMsk(2)) cU.setOpt(2); /* copy 'road'-option (if set) */
        if(cSh.chkMsk(16)) cU.setOpt(3); /* set 'junction'-option */
        cU.chgShR(cSh); /* insert new shape-reference */
        cSh.incCntW(1); /* and count it */
        return i; /* return number/index of shape */
      } /* shape was found */
    } /* check all shape-entries */
    return -1; /* no match found -- report it */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkItm"
  * IT-Referenz eines World-Eintrags pruefen und vervollstaendigen
  * Methode wird in 'chkWorld()' und 'chkSnd()' benutzt!
  * ##chkItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chkItm( /* TrItem-Referenz (World-Obj) pruefen */
   TSWrld  cObj, /* aktuelles Registrierungs-Element (World/Sound) */
   TSRoute cRte, /* Routendefinition mit Datenbanken */
   int     db,   /* Nummer der betroffenen Datenbank (0,1) */
   String  txt)  /* Bezeichnung des Items */
   {
   /*-----------------------------------------------------------------*/
    TSRefC  cRf; /* aktuelle TrItem-Referenz */
    TSTrItm cIt; /* aktuelles TrItem-Element */
    int     i,m; /* Arbeitswerte */
   /*=================================================================*/
    if((i=cRte.get$TrI(db))<0) return db*10-i; /* DB-Fehler */
    m = cObj.get$TrI(db); /* Anzahl der 'TrItem'-Definitionen */
    for(i=0;i<m;i+=1) { /* alle TrItem-Referenzen bearbeiten */
      cRf = cObj.chgTrI(db,i,null); /* Aktuelle TrItem-Referenz holen */
      if(cRf==null) return -1; /* Fehlerhafte TrItem-Struktur */
      cIt = cRte.fndTrI(db,cRf); /* TrItem suchen und einsetzen */
      if(cIt==null) { /* TrItem nicht in DB definiert */
        Lg.Err("chkTrI01",txt,cRf.chgNr(Integer.MIN_VALUE),0);
        continue; } /* Bearbeitung beenden */
      if(cObj.chkTrItmT(cIt.getTyp())) /* Typen passen nicht zusammen */
        Lg.Err("chkTrI02",txt,cIt.getName(),cRf.chgNr(Integer.MIN_VALUE));
      if(cIt.chkMsk(0)) /* TrItem wird nicht (mehr) genutzt */
        Lg.Err("chkTrI03",txt,cRf.chgNr(Integer.MIN_VALUE),0);
      cIt.incCnt(1); /* Nutzung in Referenz-Count zaehlen */
      if(cIt.chgRef(cObj)!=null) /* insert backward-reference to world-object */
        if(EnaW) Lg.Log("chkTrI04",txt,cRf.chgNr(Integer.MIN_VALUE));
    } /* process all 'TrItem'-definitions */
    return 0; /* Pruefung wurde durchgefuehrt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkPath"
  * Check filename if it contains a valid path-prefix due to list
  *  within pl.
  * Function returns length of path-prefix within the filename (or '0').
  * Attention: 'RetVal' will get the (whole)path-prefix used.
  * ##chkPath (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chkPath( /* find valid path within filename */
   TSArrList pl,  /* list of path-prefixes */
   String    cFn, /* filename to be checked */
   String[]  prm) /* arguments for modify of path */
   {
   /*-----------------------------------------------------------------*/
    String cP; /* current path to be used */
    int    i;  /* index-value */
   /*=================================================================*/
    cFn = cFn.toLowerCase(); /* modify filenamme for checking */
    /* Attention: original object is NOT changed (due to 'final') */
    for(i=0;i<pl.size();i+=1) { /* check all valid path-definitions */
      if((cP=(String)pl.get(i))==null) continue; /* not found */
        /* path is not defined -- continue */
      cP = TSLogg.getMsg(cP,prm); /* modify it if needed */
      if(cP.length()==0) continue; /* skip dummy-path */
      TSUtil.RetVal = cP; /* save current path as secondary result */
      if(cFn.startsWith(cP.toLowerCase())) return cP.length();
        /* current path is valid -- return it (no more checks) */
    } /* check all defined path-values */
    return 0; /* no valid path found -- report it */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkSrt"
  * Check sequence of TSTrItem-elements and correct it if neccessary
  * Attention: It is already verified that this entry contains
  *            exactly two valid TrItem-references(TrackDB)!
  * ##chkSrt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String chkSrt( /* check sort of TrItem-References */
   TSWrld  cObj, /* current object to be checked (World/Sound) */
   String  txt)  /* Description of Item */
   {
   /*-----------------------------------------------------------------*/
    TSRefC  cRf; /* current TrItem-Reference */
    TSTrItm cIt; /* current TrItem-Element */
   /*=================================================================*/
    cRf = cObj.chgTrI(0,0,null); /* get current TrItem-Reference */
    cIt = (TSTrItm)cRf.chgRef(null); /* get reference to current TrItem */
    if(cIt==null) /* refernce to TrItem is not valid -- no sort */
      return TSLogg.getMsg("chkSrt01",txt,cRf.chgNr(Integer.MIN_VALUE),0);
    if(cIt.chkRO(0)) { /* invalid element -- swap and check again */
      cObj.chgTrI(0,0,cObj.chgTrI(0,1,null)); /* copy TrItem */
      cObj.chgTrI(0,1,cRf); /* swap TrItem-definitions */
      cRf = cObj.chgTrI(0,0,null); /* current new TrItem-Reference */
      cIt = (TSTrItm)cRf.chgRef(null); /* get reference again */
      if(cIt==null) /* refernce to TrItem is not valid -- no sort */
        return TSLogg.getMsg("chkSrt01",txt,cRf.chgNr(Integer.MIN_VALUE),0);
      if(cIt.chkRO(0)) /* type of TrItemID still in error */
        return TSLogg.getMsg("chkSrt02",txt,cRf.chgNr(Integer.MIN_VALUE));
    } /* first reference was checked and corrected */
    cRf = cObj.chgTrI(0,1,null); /* get second TrItem-Reference */
    cIt = (TSTrItm)cRf.chgRef(null); /* get reference again */
    if(cIt==null) /* refernce to TrItem is not valid -- no sort */
      return TSLogg.getMsg("chkSrt01",txt,cRf.chgNr(Integer.MIN_VALUE),1);
    if(cIt.chkRO(-1)) /* error within second item */
      return TSLogg.getMsg("chkSrt03",txt,cRf.chgNr(Integer.MIN_VALUE));
    return null; /* check complete -- no error found */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTrk"
  * Schienendefinitionen ('TrkObj','Dyntrack') modifizieren
  *   Statische Schiene aktivieren/deaktivieren, falls gefordert
  * Methode wird von BEIDEN Versionen (h,f) genutzt.
  * ##chgTrk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chgTrk( /* Schienendefinitionen modifizieren */
   TSRoute  cRte, /* aktuelle Routendefinition mit Basisverzeichnis */
   TSData   cCtl, /* Datendefinition zur Steuerung */
   int      ofs)  /* Offset der Steuerbits in der Maske */
   {
   /*-----------------------------------------------------------------*/
    final String[]   prm = cRte.getParm(); /* path-arguments */
   /*-----------------------------------------------------------------*/
    TreeSet<TSQuad>  QDf;  /* Quadrat-Definitionen */
    TSQuad           cQDf; /* aktive Quadrat-Definition */
    TSUiD            cUiD; /* aktuelles UiD-Element */
    TSOpts           M1,M2; /* control-elements */
    int              cnt1,cnt2,cnt3,cnt4;
    int              i,j,k,nr;
    String           is,Typ,cP;
    Iterator<TSQuad> cI;  /* Iterator fuer 'TreeSet': 'TSQuad' */
    TSArrList        cL;  /* aktuelle Modifikationsliste */
    boolean          act; /* HW-Aktion wurde durchgefuehrt */
    boolean          clr; /* HW-Aktion: KEIN Hidewire-Objekt mehr */
    boolean          set; /* HW-Aktion: HW-Objekte erstellen */
    boolean          fnc; /* HW-Aktion: Dateinamen fuer HW-Objekt loeschen */
    boolean          fns; /* HW-Aktion: Dateinamen fuer HW-Objekt aendern */
   /*=================================================================*/
    Lg.Skip(true); /* Leerzeile loggen */
    cL = cCtl.getQue(3); /* establish access to relevant ArrayList */
    M1 = cL.getOpt(0); /* get control-mask of 'Hidewire-Objects' */
    M2 = cL.getOpt(1); /* get control-mask of file-modifications */
      /* Attention: mask(-references) are valid in every case */
    clr = cCtl.chkMsk(ofs++); /* Merken, ob Aktion gefordert */
    set = cCtl.chkMsk(ofs++); /* Merken, ob Aktion gefordert */
    fnc = cCtl.chkMsk(ofs++); /* Merken, ob Aktion gefordert */
    fns = cCtl.chkMsk(ofs); /* Merken, ob Aktion gefordert */
    if(!cRte.isElec()) { /* Strecke NICHT elektrifiziert */
      M2.orMsk(M1); /* include 'Hidewire' into 'modification' */
      clr = true; /* alle Hidewire-Aktionen zuruecknehmen */
      set = false; /* und Orginal-Aktion abschalten */
      if(M2.cntMsk(0)>0) fns = true; /* Aktion needed -- include it (switch on) */
      Lg.Msg("chgTrk01",cRte.getInfo(1)); /* Aktion melden */
    } /* Strecke ist NICHT elektrifiziert */
    cnt1 = cnt2 = cnt3 = cnt4 = 0; /* Objekt-Zaehler initialisieren */
    QDf = cRte.chgQDf(null); /* Alle Quadrat-Definitionen */
    if(QDf==null) throw new IllegalStateException( /* Sicherheitsabfrage */
      TSLogg.getMsg("Msg908","TreeSet<TSQuad>==null","TSUtil.chgTrk()",0));

    Lg.Msg("chgTrk02",cRte.getInfo(1)); /* Aktion melden */

    j = cL.size(); /* Anzahl der Steuereintraege */
    cI = QDf.iterator(); /* Iterator fuer Quadrat-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cQDf = cI.next(); /* naechste Quadrat-Definition */
      if(cQDf.getInf(2)==null) continue; /* World-Datei fehlt -- nicht bearbeiten */

      for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
        /* nicht belegte UiD-Eintraege gibt es nicht (siehe 'getWF()') */
        if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
        if(!cUiD.isTrack()) continue; /* Objekt trifft nicht zu */
          /* Auswertung NUR fuer 'TSTrkObj' und 'TSDynTrk' */
        k = cUiD.getSL(); /* aktuellen 'StaticDetailLevel' holen */
        Typ = cUiD.getName(true); /* Typ des Schieneneintrags holen */
        if(clr) Lclr:{ /* Statische Schiene (Hidewire) deaktivieren */
          if(!cUiD.chkSL(M1)) break Lclr; /* 'StaticDetailLevel' do NOT match */
          act = cUiD.clrOpt(10); /* Kennzeichen loeschen, voher gesetzt? (h) */
          act |= cUiD.clrOpt(15); /* Kennzeichen loeschen, voher gesetzt? (f) */
          if(!act) break Lclr; /* Kennzeichen war nicht gesetzt -- Ende */
          cnt1 += 1; /* Statische Schiene wurde deaktiviert -- zaehlen */
          if(EnaH) Lg.Log("chgTrk11",cQDf.getMsg(3,Typ,cUiD.getUiD(0),0),k);
        } /* -Lclr- erkannte Objekte NICHT MEHR zurueckkonvertieren */
        if(fnc) Lfnc:{ /* Modifikationen des Dateinamens loeschen */
          if(!cUiD.chkSL(M2)) break Lfnc; /* 'StaticDetailLevel' do NOT match */
          if(!cUiD.clrOpt(12)) break Lfnc; /* Filename ist NICHT modifiziert -- OK */
          cUiD.setName(null,0,null); /* Modifikation zuruecknehmen */
//          if(EnaH) Lg.Log("chgTrk12",,cQDf.getMsg(3,Typ,cUiD.getUiD(0),0),k);
        } /* -Lfnc- alle Modifikationen des Dateinamens loeschen */
        if(set) Lset:{ /* Statische Schiene aktivieren */
          if(!cUiD.chkSL(M1)) break Lset; /* 'StaticDetailLevel' do NOT match */
          i = k * 5 - 3; /* Indexnummer berechnen */
          nr = cL.getInt(i); /* Kennung fuer 'Hidewire'-Typ holen */
          if(nr>9) { /* SectionIDX-Version von Hidewire aktiv (f) (0..9 ist reserviert) */
            if(nr>=ShA) { /* SectionIDX-Kennung zu gross -- nicht aktivieren */
              Lg.Err("chgTrk21",cQDf.getMsg(3,Typ,cUiD.getUiD(0),0),nr,k);
              break Lset;} /* Fehler in Kennung -- Hidewire NICHT aktivieren */
            if(ShTab[nr]==null) { /* Shape-Definition nicht gefunden -- nicht aktivieren */
              Lg.Err("chgTrk22",cQDf.getMsg(3,Typ,cUiD.getUiD(0),0),nr,k);
              break Lset;} /* Fehler in Kennung -- Hidewire NICHT aktivieren */
            if(!ShTab[nr].chkMsk(2)) { /* Keine 'Road'-Definition -- nicht aktivieren */
              Lg.Err("chgTrk23",cQDf.getMsg(3,Typ,cUiD.getUiD(0),0),nr,k);
              break Lset;} /* Fehler in Kennung -- Hidewire NICHT aktivieren */
            cUiD.setOpt(15); /* Kennung fuer 'HW-Objekt' setzen */
            cUiD.setInt(0,nr); /* Kennung fuer SectionIDX speichern */
            nr = -1; /* allgemeine Pfad-Kennung trifft nicht zu */
          } else cUiD.setOpt(10); /* Kennung fuer 'HW-Objekt' setzen */
          cnt2 += 1; /* Statische Schiene wurde aktiviert -- zaehlen */
          if(EnaH) Lg.Log("chgTrk13",cQDf.getMsg(3,Typ,cUiD.getUiD(0),0),k);
          cP = null; /* vorbesetzen: Allgemeiner Pfad NICHT gesetzt */
          if(nr>=0) { /* Pfad-Definition vorhanden (nr= 0..9) */
            cP = cCtl.getDta(2,nr); /* Pfad-Definition holen und aufbereiten */
            if(cP!=null) cP = TSLogg.getMsg(cP,prm); /* and modify it */
          } /* (Allgemeine) Pfad-Definition war vorhanden */
          if(cUiD.setName(cL,i+1,cP,prm)) break Lset; /* Name ggf. modifizieren */
            /* Modifikation wurde NICHT durchgefuehrt -- Lset abbrechen */
          cnt4 += 1; /* Statische Schiene erhielt neuen Dateinamen -- zaehlen */
          if(EnaH) Lg.Log("chgTrk14",cQDf.getMsg(3,Typ,cUiD.getUiD(0),0));
        } /* -Lset- Definition pruefen und ggf. aktivieren */
        if(fns) Lfns:{ /* Modifikation des Dateinamens aktivieren */
          if(!cUiD.chkSL(M2)) break Lfns; /* 'StaticDetailLevel' do NOT match */
          for(i=17;i<j;i+=5) { /* Alle moeglichen Eintraege beachten */
            if(!cUiD.chkSL((TSOpts)cL.get(i))) continue; /* 'StaticDetailLevel' do NOT match */
            if(cUiD.setName(cL,i+1,null,prm)) continue; /* Name ggf. modifizieren */
              /* Modifikation wurde NICHT durchgefuehrt -- weiter */
            cnt3 += 1; /* Modifikation wurde durchgefuehrt -- zaehlen */
            if(EnaH) Lg.Log("chgTrk15",cQDf.getMsg(3,Typ,cUiD.getUiD(0),0),k);
            break Lfns; /* Eintrag erfolgreich bearbeitet -- Ende */
          } /* alle Eintraege pruefen */
          /* kein zutreffender Eintrag gefunden -- keine Aktion */
        } /* -Lfns- Definition pruefen und ggf. aktivieren */
      } /* alle Eintraege der 'World'-Datei bearbeiten */

    } /* alle 'World'-Dateien bearbeiten */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("chgTrk06",cnt1); /* Ergebnis ausgeben */
    Lg.Log("chgTrk07",cnt2); /* Ergebnis ausgeben */
    Lg.Log("chgTrk08",cnt4); /* Ergebnis ausgeben */
    Lg.Log("chgTrk09",cnt3); /* Ergebnis ausgeben */
    Lg.Skip(false); /* Leerzeile loggen */
    return cnt1+cnt2; /* Aktivierung/Deaktivierung wurde durchgefuehrt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "rcvWrld"
  * Hidewire-Objekte in World-Dateien restaurieren
  * Achtung: Alle definierten Pfad-Definitionen (global Option 'p')
  *          werden benutzt.
  * ##rcvWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int rcvWrld( /* TrkObj-Objekte restaurieren */
   TSRoute cRte, /* aktuelle Routendefinition mit Basisverzeichnis */
   TSData  ctl)  /* Steuerungsblock der Methode */
   {
   /*-----------------------------------------------------------------*/
    final String[]    prm = cRte.getParm(); /* arg-list for path-mod */
   /*-----------------------------------------------------------------*/
    TreeSet<TSQuad>   QDf;  /* Quadrat-Definitionen */
    TSQuad            cQDf; /* aktive Quadrat-Definition */
    TSUiD             cUiD; /* aktuelles UiD-Element */
    TSTrkObj          cTrk; /* neues UiD-Element */
    TSShape           cSh;  /* statisches Shape-Element */
    TSTrNde           cTrN; /* aktuelles TrackNode-DB-Element */
    TSVector          cNde; /* current vector-node */
    TSOpts            cMsk; /* current mask of recovery-types */
    TSArrList         cL;   /* current data-queue */
    int               i,j,u,v,w,n,ng,cnt;
    double            elv;  /* Berechnung 'Elevation' */
    String            is,cP; /* Arbeitswert(e) */
    String            cFn1,cFn2; /* File-Namen */
    Iterator<TSTrNde> aI;  /* Iterator fuer TrackNode-Tabelle */
    Iterator<TSQuad>  cI;  /* Iterator fuer Quadranden-Tabelle */
   /*=================================================================*/
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("rcvW001",cRte.getInfo(1)); /* Aktionsmeldung */

    cnt = 0; /* World-Zaehler initialisieren */
    ng  = 0; /* Zaehler der Umstellungen initialisieren */
    QDf = cRte.chgQDf(null); /* Alle Quadrat-Definitionen */
    if(QDf==null) throw new IllegalStateException( /* Sicherheitsabfrage */
      TSLogg.getMsg("Msg908","TreeSet<TSQuad>==null","TSUtil.rcvWrld()",0));
    cL = ctl.getQue(4); /* prefetch affected Queue */
    cMsk = cL.getOpt(2); /* get current mask of recovery-types */
    cI = QDf.iterator(); /* Iterator fuer Quadrat-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cQDf = cI.next(); /* naechste Quadrat-Definition */
      is = cQDf.getInf(2); /* Namen der World-Datei */
      if(is==null) continue; /* World-Datei fehlt -- nicht bearbeiten */

      cnt += 1; /* Datei zaehlen */
      Lg.Log("rcvW002",is); /* Aktion melden */

      /* interne World-Daten bearbeiten und pruefen */
      n = 0; /* Zaehler der Umstellungen initialisieren */
      for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
        /* nicht belegte UiD-Eintraege gibt es nicht (siehe 'getWF()') */
        if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
        if(cUiD.isCtl()) continue; /* kein aktiver UiD-Eintrag */
        if(!(cUiD instanceof TSStatic)) continue; /* NUR 'Static' pruefen */
        u = cUiD.getUiD(0); /* aktuelle UiD holen */
        cFn1 = cUiD.chgNme(null); /* Datei/Shape-Name des Objektes holen */
        /* alle Pfad-Definitionen ueberpruefen und Pfad ggf. entfernen */
        cP = null; /* preset: path not found */
        if((v=chkPath(ctl.getQue(2),cFn1,prm))>0) { /* alternate path was found */
          /* 'v' is the length of the path-prefix within the filename (or '0').
           * Now, use filename without path-prefix ('cFn1.substring(v)') */
          cFn1 = cFn1.substring(v); /* remove path from filename */
          cP = (String)TSUtil.RetVal; /* get appropriate path-value from sec. result */
        } /* alternate path found and activated */

        w = cL.size(); /* Anzahl der Korrektureintraege holen (min=3) */
          /* some slots do not correspond to this entry-type */
        for(v=3;v<w;v+=3) { /* alle Eintraege testen  (n Gruppen zu je 3 Eintraegen) */
          if(cMsk.chkMsk(v/3)) continue; /* entries do not apply -- skip them */
          cFn2 = cFn1; /* Annehmen: Original-Namen unveraendert uebernehmen */
          is = cL.getDta(v+1); /* Vergleichskette holen */
          if(is!=null) { /* NICHT leer -- Name zur Pruefung veraendern */
            if(!cFn1.toLowerCase().startsWith(is)) continue;
              /* Name passt nicht -- naechste Definition versuchen */
            i = is.length(); /* Laenge des Vorlaufs */
            if(cFn1.length()>i) cFn2 = cFn1.substring(i); else cFn2 = "";
            if((is=cL.getDta(v+2))!=null) cFn2 = is + cFn2;
              /* Ersetzungsstring hinzufuegen */
          } /* Aenderung des Namens erfolgreich */
          /* Modifizierung des Namens erfolgt -- gueltige Schiene? */
          sl1: { /* break-Block fuer Shape-Suche */
            for(i=0,j=1;i<ShTab.length;i+=j) { /* alle Shape-Eintraege testen */
              if((cSh=ShTab[i])==null) continue; /* Shape nicht definiert */
              j = cSh.$dIx(0); /* neuen Abstand merken */
              if(cSh.chkNme(cFn2)==null) break sl1; /* Name passt zu Shape-Definition */
            } /* alle Shape-Eintraege testen */
            continue; /* nicht gefunden -- naechster Vergleichseintrag nutzen */
          } /* -sl1- Shape-Definition gefunden */
          cFn2 = cSh.chkNme(null); /* korrekten File-Namen holen und setzen */
          i = 0; /* Datenbank-Kennung (default) */
          if(cSh.chkMsk(2)) i = 1; /* Road! -- Strassendatenbank benutzen */
          cNde = null; /* Vorbesetzen: KEINE Tracknodes definiert */
          aI = cRte.getIt(i); /* Iterator fuer TrackNode-Definitionen */
          sl2:while(aI.hasNext()) { /* Alle TrackNode-Definitionen bearbeiten */
            if((cTrN=aI.next())==null) continue; /* Fehl-Eintrag uebergehen */
            if(cTrN.getTyp()!=2) continue; /* NUR TrVectorNodes beachten */
            j = cTrN.get$Nde(); /* Anzahl der Sub-Eintraege holen */
              /* Anzahl stimmt AUCH bei 'TrEndNode' und 'TrJunctionNode' */
            for(i=0;i<j;i+=1) { /* alle Track-Sections bearbeiten */
              if(cTrN.chkMsk(22)) continue; /* Node fehlerhaft definiert -- uebergehen */
              cNde = cTrN.chgNde(i,null); /* aktuell verkettetes Element */
                /* 'cNde' kann nicht 'null' sein, da sonst Option 22 gesetzt ist. */
              if(!cNde.chkId(cQDf,u)) break sl2; /* Quadrant und UiD stimmt -- gefunden */
            } /* alle Sub-Eintraege bearbeiten */
            cNde = null; /* Kennzeichen: nicht gefunden */
          } /* -sl2- alle Track-Nodes pruefen */
          if(cNde==null) continue; /* keine gueltige Zuordnung -- naechster Versuch */

          /* Alle Vorraussetzungen sind OK -- Element nach TrkObj wandeln */
          cTrk = new TSTrkObj((TSStatic)cUiD); /* Objekt-Typ veraendern */
          i = ctl.getInt(4,v); /* get new StaticDetailLevel */
          j = cTrk.setSL(i); /* and insert StaticDetailLevel (explicitely) into object */
          if(EnaH) Lg.Log("rcvW004",cFn1,cTrk.getUiD(0),i); /* Umstellung melden */
          if(j!=0 && j!=i) if(EnaW) Lg.Log("rcvW013",null,i,j); /* Problem melden */
          cTrk.chgShR(cSh); /* aktuelle Shape-Referenz einsetzen (SectionIdx) */
          cTrk.setMsk(2);   /* und Existenz der Definition merken */
          if(cSh.chkMsk(2)) cTrk.setOpt(2); /* Option uebernehmen (Road) */
          cSh.incCntW(1); /* Referenz auf Shape-Definition vermerken */
          elv = cUiD.crQDir().getTerm(-1); /* Elev-Winkel aus Quaternion des Objektes extrahieren */
          elv = TSUtil.round(2.0*elv,8); /* Elevationwert berechnen */
          cTrk.chgElv(elv); /* neue Steigung einsetzen */
          cTrk.setMsk(3);   /* und Existenz der Definition merken */
          i = cTrk.setStF(0x00200180); /* neuen Wert fuer 'StaticFlags' eintragen */
          if(i!=0x00200180) { /* Flag-Definitionen wurden veraendert -- Suchsequenz korrigieren */
            if(cP!=null) cFn1 = cP + cFn1; /* Namen erneut erweitern */
            if(EnaW) Lg.Log("rcvW011",TSUtil.toHex(i,-8)); /* Problem melden */
          } /* Veraenderung der Flags bearbeitet */
          cTrk.chgNme(cFn2); /* originaler Datei/Shape-Name des Objektes setzen */
          cTrk.modNme(cFn1); /* und modifizierten Name hinzufuegen */
            /* bisheriger Name der Schiene wird 'modifizierter' Name */
          cTrk.setOpt(9); /* TrkObj ist 'Hidewire-Objekt' */
          cTrk.setOpt(10); /* Kennzeichnen: Hidewire-Objekt wieder erzeugen */
          /* ACHTUNG: 'CollideFlags' und 'JNodePosn' werden (vorlaeufig) NICHT gesetzt */
          n += 1; /* umgestelltes Objekt zaehlen */
          cTrk.chgQDf(cQDf); /* insert back-reference to quad-basis-definition */
          is = cQDf.chgWTab(null,0).replace(cUiD,cTrk); /* Element in Objektkette ersetzen */
          if(is==null) break; /* Element wurde erfolgreich bearbeitet */
          /* Fehler beim Aktivieren des neuen Objektes */
          Lg.Err("rcvW012",is); /* Fehlermeldung ausgeben */
          break; /* Element wurde bearbeitet */
        } /* -for- alle Korrektur-Eintraege testen */

      } /* -for- alle Eintraege der 'World'-Datei bearbeiten */
      Lg.Log("rcvW007",n); /* Anzahl der Umstellungen melden */
      ng += n; /* Alle umgestellten Objekte addieren */
    } /* -while- alle 'World'-Dateien bearbeiten */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("rcvW008",null,cnt,ng); /* Anzahl der Umstellungen melden */
    Lg.Skip(false); /* Leerzeile loggen */
    return 0; /* Return-code liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "modWrld"
  * Restore Filenames of Track-objects. Remove path if needed.
  * Attention: All specified path-definitions (global Option 'p')
  *          are used to identify path.
  * ##modWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int modWrld( /* restore TrkObj-Objects */
   TSRoute cRte, /* current route-definition */
   TSData  ctl,  /* control-block of this action */
   boolean optZ) /* option '-z' is active (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    final String[]    prm = cRte.getParm(); /* arg-list for path-mod */
   /*-----------------------------------------------------------------*/
    TreeSet<TSQuad>   QDf;  /* Quad-Definitions */
    TSQuad            cQDf; /* current Quad-Definition */
    TSUiD             cUiD; /* current UiD-entry */
    TSTrkObj          cTrk; /* casted UiD-entry */
    TSShape           cSh;  /* static Shape-Element */
    TSArrList         cL;   /* current data-queue */
    TSOpts            cMsk; /* current mask of recovery-types */
    Matcher           m;    /* used with regular expression */
    Object            o;    /* generic for 'Pattern' and 'String' */
    int               i,u,v,w,n,ng,cnt;
    String            is,cP; /* temporary values */
    String            cFn1,cFn2; /* Filenames */
    Iterator<TSQuad>  cI;   /* Quad-table-iterator */
   /*=================================================================*/
    Lg.Skip(true); /* print and log empty line */
    Lg.Msg("modW001",cRte.getInfo(1)); /* print message abount avtion */

    cnt = 0; /* init counter of world-files */
    ng  = 0; /* init overall counter for matches */
    QDf = cRte.chgQDf(null); /* All Quad-Definitions */
    if(QDf==null) throw new IllegalStateException( /* security-check */
      TSLogg.getMsg("Msg908","TreeSet<TSQuad>==null","TSUtil.modWrld()",0));
    cL = ctl.getQue(4); /* prefetch affected Queue */
    cMsk = cL.getOpt(2); /* get current mask of recovery-types */
    cI = QDf.iterator(); /* create current iterator for Quad-Definitions */
    while(cI.hasNext()) { /* all definitions processed ? */
      cQDf = cI.next(); /* get next quad-definition */
      is = cQDf.getInf(2); /* and extract name of the world-file */
      if(is==null) continue; /* name is missing -- do not process Quad */

      cnt += 1; /* count world-file */
      Lg.Log("modW002",is); /* and print message abount action */

      /* process all entries within world-file */
      n = 0; /* init counter for matches */
      for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
        /* there are no invalid UiD-entries (compare to 'getWF()') */
        if(cUiD.isOpt(0)) continue; /* do not process Dummy-entry */
        if(cUiD.isCtl()) continue; /* entry is not active -- skip it */
        if(!(cUiD instanceof TSTrkObj)) continue; /* only tracks are processed */
        cTrk = (TSTrkObj)cUiD; /* cast object to correct object-type */

        u = cUiD.getUiD(0); /* get current UiD (messages) */
        cFn1 = cTrk.modNme(null); /* get file/shape-Name(original) of object */
        if(cUiD.isOpt(14)) ckw1:{ /* Shape-Reference was unknown -- restore value */
          /* Object is of status 'to be restored'. It does not contain a valid
           * shape-definition. The filename should be modified and checked until
           * a valid shape-defintion is found.
           */

          /* 1) use filename without modification */
          if((i=insShE(cTrk,cFn1))>=0) { /* shape entry found and inserted */
            /* 'i' is the IDX-number of the inserted shape or '-1'. */
            if(EnaH) Lg.Log("modW011",cFn1,u,i); /* print assignment-message */
            if((i=ctl.getInt(1))>0) { /* new 'StaticDetailLevel' requested */
              cUiD.setSL(i); /* insert StaticDetailLevel (explicitely) into source-object */
              cQDf.reSortW(cUiD); /* and adjust position of new element */
            } /* new StaticDetailLevel was requested -- changed */
            break ckw1; /* match occurred -- do not continue search, no more checking */
          } /* shape-entry was found and inserted */

          /* 2) check all Path-Definitions and remove path if match found */
          cP = null; /* preset: path not found */
          is = cFn1; /* and remember unmodified filename */
          if((i=chkPath(ctl.getQue(2),cFn1,prm))>0) { /* alternate path was found */
            /* 'i' is the length of the path-prefix within the filename (or '0').
             * Now, use filename without path-prefix ('cFn1.substring(i)') */
            cFn1 = cFn1.substring(i); /* remove path from filename */
            cP = (String)TSUtil.RetVal; /* get appropriate path-value from sec. result */
          } /* alternate path found and activated */

          /* 3) use name after current path is removed */
          if((i=insShE(cTrk,cFn1))>=0) { /* shape entry found and inserted */
            /* 'i' is the IDX-number of the inserted shape or '-1'. */
            cUiD.chgNme(cFn1); /* set original filename/shapename of the object */
            cTrk.modNme(is);   /* and add the modified name (including path-prefix) */
            cUiD.setOpt(12);   /* mark: original name and current name do NOT match */
            n += 1; /* count object as 'modified' */
            if(EnaH) Lg.Log("modW012",cFn1,u); /* print assignment-message */
            if((i=ctl.getInt(2))>0) { /* new 'StaticDetailLevel' requested */
              cUiD.setSL(i); /* insert StaticDetailLevel (explicitely) into source-object */
              cQDf.reSortW(cUiD); /* and adjust position of new element */
            } /* new StaticDetailLevel was requested -- changed */
            break ckw1; /* match occurred -- do not continue search, no more checking */
          } /* shape-entry was found and inserted */

          /* 4) considder additional filename-modifications if available */
          if(optZ) { /* modifications should be considdered */
            w = cL.size(); /* get number of entries within control-queue (min=3) */
              /* Attention: some slots do not correspond to this entry-type */
            for(v=3;v<w;v+=3) { /* use all entries to check filename  (n groups a 3 entries) */
              if(!cMsk.chkMsk(v/3)) continue; /* entries do not apply -- skip them */
              o = cL.get(v+1); /* get selection-definition */
              is = (String)cL.get(v+2); /* get replacement-string */
              if(o instanceof Pattern) { /* regular expression found */
                m = ((Pattern)o).matcher(cFn1); /* compare names */
                if(!m.lookingAt()) continue; /* 'match' is NOT successful */
                cFn2 = m.replaceAll(is); /* create new filename */
              } else { /* text is compared to beginning of name */
                cFn2 = (String)o; /* convert name to compare */
                if(!cFn1.toLowerCase().startsWith(cFn2)) continue;
                  /* names do not match -- try next definition */
                i = cFn2.length(); /* get length of prefix to be removed */
                if(cFn1.length()>i) cFn2 = is + cFn1.substring(i);
                else cFn2 = is; /* add replacementstring (may be of length 0) */
              } /* selection and process were successful */
              /* name (may) have been modified -- check if valid track */
              if((i=insShE(cTrk,cFn2))>=0) { /* shape entry found and inserted */
                /* 'i' is the IDX-number of the inserted shape or '-1'. */
                if(cP!=null) cFn1 = cP + cFn1; /* add path to original filename again */
                cUiD.chgNme(cFn2); /* set original filename/shapename of the object */
                cTrk.modNme(cFn1); /* and add the modified name (including path-prefix) */
                cUiD.setOpt(12); /* mark: original name and current name do NOT match */
                n += 1; /* count object as 'modified' */
                Lg.Log("modW013",cFn1,cFn2,""+u,""+i); /* print modified object */
                i = ((Integer)cL.get(v)).intValue(); /* get requested StaticDetailLevel */
                if(i>0) { /* new 'StaticDetailLevel' requested */
                  cUiD.setSL(i);      /* insert StaticDetailLevel (explicitely) into source-object */
                  cQDf.reSortW(cUiD); /* and adjust position of new element */
                } /* new StaticDetailLevel was requested -- changed */
                break ckw1; /* match occurred -- do not continue search, no more checking */
              } /* shape-entry was found and inserted */
            } /* -for- try all modification-definitions */
          } /* -optZ- modifications should be considdered */
          Lg.Err("modW014",cFn1,u); /* no match found -- print error-message */
          cUiD.setOpt(16); /* and mark it within definition */
        } else ckw2:{ /* -ckw1- shape-reference was (successfully) restored  -- else check it */
          /* Definition contains a valid TrackObj. However, the filename may be modified and will
           * not match the selected shape-definition. This should be investigated and resolved.
           */
          cSh = cTrk.chgShR(null); /* get current shape-definition */
          if(cSh==null) throw new IllegalStateException( /* security-check */
            TSLogg.getMsg("Msg908","Shape<TSTrkObj>==null","TSUtil.modWrld()",0));
            /* shape reference must be inserted  */

          /* 1) use filename without modification */
          if(cSh.chkNme(cFn1)==null) break ckw2; /* tsection-Definition matches filename */

          /* 2) check all Path-Definitions and remove path if match found */
          cP = null; /* preset: path not found */
          is = cFn1; /* and remember unmodified filename */
          if((i=chkPath(ctl.getQue(2),cFn1,prm))>0) { /* alternate path was found */
            /* 'i' is the length of the path-prefix within the filename (or '0').
             * Now, use filename without path-prefix ('cFn1.substring(i)') */
            cFn1 = cFn1.substring(i); /* remove path from filename */
            cP = (String)TSUtil.RetVal; /* get appropriate path-value from sec. result */
          } /* alternate path found and activated */

          /* 3) use name after current path is removed */
          if(cSh.chkNme(cFn1)==null) { /* tsection-Definition NOW matches filename */
            cUiD.chgNme(cFn1); /* set original filename/shapename of the object */
            cTrk.modNme(is);   /* and add the modified name (including path-prefix) */
            cUiD.setOpt(12);   /* mark: original name and current name do NOT match */
            n += 1; /* count object as 'modified' */
            break ckw2; /* match occurred -- do not continue search, no more checking */
          } /* shape-entry was found and inserted */

          /* 4) considder additional filename-modifications if available */
          if(optZ) { /* modifications should be considdered */
            w = cL.size(); /* get number of entries within control-queue (min=3) */
              /* Attention: some slots do not correspond to this entry-type */
            for(v=3;v<w;v+=3) { /* use all entries to check filename  (n groups a 3 entries) */
              if(!cMsk.chkMsk(v/3)) continue; /* entries do not apply -- skip them */
              o = cL.get(v+1); /* get selection-definition */
              is = (String)cL.get(v+2); /* get replacement-string */
              if(o instanceof Pattern) { /* regular expression found */
                m = ((Pattern)o).matcher(cFn1); /* compare names */
                if(!m.lookingAt()) continue; /* 'match' is NOT successful */
                cFn2 = m.replaceAll(is); /* create new filename */
              } else { /* text is compared to beginning of name */
                cFn2 = (String)o; /* convert name to compare */
                if(!cFn1.toLowerCase().startsWith(cFn2)) continue;
                  /* names do not match -- try next definition */
                i = cFn2.length(); /* get length of prefix to be removed */
                if(cFn1.length()>i) cFn2 = is + cFn1.substring(i);
                else cFn2 = is; /* add replacementstring (may be of length 0) */
              } /* selection and process were successful */
              /* name (may) have been modified -- check if valid track */
              if(cSh.chkNme(cFn2)==null) { /* tsection-Definition NOW matches filename */
                if(cP!=null) cFn1 = cP + cFn1; /* add path to original filename again */
                cUiD.chgNme(cFn2); /* set original filename/shapename of the object */
                cTrk.modNme(cFn1); /* and add the modified name (including path-prefix) */
                cUiD.setOpt(12); /* mark: original name and current name do NOT match */
                n += 1; /* count object as 'modified' */
                break ckw2; /* match occurred -- do not continue search, no more checking */
              } /* shape-entry was found and inserted */
            } /* -for- try all modification-definitions */
          } /* -optZ- modifications should be considdered */

          /* Attention: Although NO match is finally found, this is NOT reported. The appropriate
           *            message will be printed within method 'chkWrld()'. However, it is
           *            marked within definition.
           */
          cUiD.setOpt(16); /* mark it within definition */
        } /* -ckw2- check fully defined TrackObj-definition */

      } /* -for- process all entries within world-file */
      Lg.Log("modW008",n); /* print numer of modified objects */
      ng += n; /* and add it to 'overall'-counter */
    } /* -while- process all world-files */

    Lg.Skip(false); /* print empty line */
    Lg.Log("modW009",null,cnt,ng); /* and print overall number of modifications */
    Lg.Skip(false); /* print empty line (again) */
    return 0; /* and terminate method without error */
  }

 /**. <pre>
  *=====================================================================
  * Method "putWF"
  * Write ALL world-files again
  * ##putWF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int putWF( /* write world-files again */
   TSRoute cRte, /* current route-definition */
   File    tdat, /* file-definition of temporary file (or 'null') */
   boolean chg,  /* replace current UiD (0) with 'new'(2) one ? */
   boolean clr)  /* clear references in case of error */
   {
   /*-----------------------------------------------------------------*/
    File   dats,datz; /* file-definitions for In- and Output */
    TSQuad cQDf;      /* current quad-definition of world-file */
    String is,js;     /* intermediate values */
    int    i,ce,cf;   /* intermediate value, counter */
    Iterator<TSQuad> cI; /* iterator of quad-structures */
   /*=================================================================*/
    if(cRte.chgQDf(null)==null) throw new IllegalStateException(
      TSLogg.getMsg("Msg908","TreeSet<TSQuad>==null","TSUtil.putWF()",0));

    Lg.Skip(true); /* print empty line to log-file and screen */
    /* verify if world-directory exits */
    if(tdat==null) /* temporary file is NOT used */
     if(cRte.getFile(40)==null) { /* get target-directory -- valid? */
      Lg.Skip(true); /* print empty line to log-file and screen */
      Lg.Msg("MsgC63",cRte.getInfo(40)); /* print message: 'terminating' */
      Lg.Msg("putWF01"); /* print error-message */
      Lg.Close(); /* close output to Log-file */
      return 25; } /* terminate function with errorcode */

    Lg.Msg("putWF02",cRte.getInfo(1)); /* print description of next action */

    ce = cf = 0; /* init counter (overall errors, world-files) */
    cI = cRte.getIt(12); /* get iterator of quad-definitions */
    while(cI.hasNext()) { /* more unprocessed quad-definitions ? */
      /* process all Quad-definitions */
      cQDf = cI.next(); /* get next quad-definition */
      is = cQDf.getInf(2); /* get source-name of world-file */
      if(is==null) continue; /* name missing -- do not process */
      js = cQDf.getInf(3); /* get target-name of world-file */
      cf += 1; /* count world-file */
      if(is.equals(js)) Lg.Log("MsgC32",is); /* print description */
      else Lg.Log("putWF03",is,js); /* of current action */

      dats = cRte.getFile(10,is); /* get full reference to source-file */
      if(tdat!=null) { /* overwrite is requested! */
        datz = tdat; /* preset: use temporary file */
        if(!is.equals(js)) { /* source and target are NOT indentical! */
          Lg.Err("putWF04",is); /* print error-message */
          continue; /* and continue with next quad-definition */
        } /* source- and target-name are NOT identical */
      } else datz = cRte.getFile(40,js); /* create target-definition */

      i = putWrld(datz,cQDf,chg,clr); /* write world-file */
      if(i<0) continue; /* open-error occurred -- use next file */
      ce += ((Integer)RetVal).intValue(); /* inc overall error-counter */

      /* copy back result to world-file(source) if overwrite requested */
      if(i>0) continue; /* error(s) found -- do NOT copy file */
      if(tdat!=null) { /* overwrite of original file requested */
        is = dats.getAbsolutePath(); /* source-file-name */
        js = "copy \""+tdat.getAbsolutePath()+"\" \""+is+"\" ";
          /* create 'copy'-command */
        if((i=exec(true,js,null,Lg))>0) /* error during 'execute' */
          Lg.Log("MsgC49",is,i); /* print error-message */
      } /* overwrite of original file requested */
    } /* -while- write ALL world-files */

    Lg.Skip(false); /* print empty line to log-file */
    Lg.Log("putWF09",cf); /* print result: file-counter */
    Lg.Skip(false); /* print empty line to log-file */
    return 0; /* return from method normally */
  }

 /**. <pre>
  *=====================================================================
  * Method "putWrld"
  * Write ONE world-file modified to output-file
  * Attention: 'RetVal' will additionally return the number of errors
  * ##putWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final int putWrld( /* write ONE world-file again */
   File    dat,  /* output-file (may be temporary) */
   TSQDef  cQDf, /* current world-definition to write */
   boolean chg,  /* replace current UiD (0) with 'new'(2) one */
   boolean clr)  /* clear references in case of error */
   {
   /*-----------------------------------------------------------------*/
    TSFileW  cF;        /* current world-file (output) */
    TSUiD    cUiD;      /* current world-element */
    TSView   cVS;       /* current ViewSphere-definition */
    int      i,j,cc,ec; /* intermediate values */
    String   is;        /* intermediate values */
//    Iterator<String>  LneI; /* Line-Iterator for output */
//    ArrayList<String> LneT; /* Line-Table for output */
   /*=================================================================*/
    /* open world-file for output */
    cF = new TSFileW(dat); /* create control of new world-file */
    i = cQDf.chgMde(-1); /* get current I/O-Mode of world-file */
    if(i<0) i = TSFile.OUT; /* use default-mode if mode not defined */
    is = cF.open(i); /* open world-file for output and set mode */
    if(is!=null) { /* open-error found -- write message */
      Lg.Err("putWF11",is); /* print errormessage */
      return -1; /* process next world-file */
    } /* error while opening world-file for output */

    ec = 0; /* init error-counter */
//    LneT = new ArrayList<String>(10); /* create table for output-line-blocks */
//      /* This list is normally empty. After it was filled with output-lines
//       * and all lines have been processed, it MUST be cleared again. */
    bl: { /* block for error-break */
      j = cQDf.chg$View(-1); /* get number of ViewSphere-Entries */
      cUiD = cQDf.getUid(true); /* get first world-entry and init */

      cc = 11; /* preset position in case of error */
      is = "Tr_Worldfile ("; /* create first line of world-file */
      if(j==0 && cUiD==null) { /* world-file is empty */
        is += " )"; /* add termination to line */
        if((is=cF.putData(is))!=null) break bl; /* write-error ? */
          /* method 'putData()' will return 'null' if no error */
        cc = 0; /* set condition to 'no error' */
        break bl; /* terminate output -- file is complete */
      } /* empty world-file successfully processed */
      if((is=cF.putData(is))!=null) break bl; /* write-error ? */

      if(j>0) { /* Viewsphere-Definitions are present */
        is = "\tVDbIdCount ( " + j + " )"; /* create line */
        cc = 12; /* preset position in case of error */
        if((is=cF.putData(is))!=null) break bl; /* write-error ? */
        cVS = cQDf.chgView(null); /* get first viewsphere-definition */
        is = putVS(cF,cVS,1); /* write ViewSphere-Definitions */
        cc = 13; /* preset position in case of error */
        if(is!=null) break bl; /* error occurred -- terminate */
      } /* output of viewsphere-definitions complete */

      /* process all UID-entries and write them to the world-file */
      for(;cUiD!=null;cUiD=cQDf.getUid(false)) { /* first entry already present */
        if(cUiD.isOpt(0)) continue; /* do not write 'Dummy-Entries' */
        if(cUiD.isCtl()) { /* current entry is 'control-entry' */
          for(i=0;i<100;i+=1) { /* write ALL lines (no more than 100) */
            is = cUiD.crDef(i,true); /* create definition-line for control-entry */
            if(is==null) break; /* no more lines to write */
            /* Attention: outputline must start with '\t' (otherwise 'error'-message) */
            if(is.charAt(0)!='\t') { /* message returned instead of line */
              Lg.Err("putWF12",is); /* print errormessage */
              ec += 1; /* and count error */
              is = cUiD.crDef(i,false); /* create definition-line again (no message) */
            } /* error-message was processed */
            cc = i * 100 + 21; /* preset position in case of error */
            if((is=cF.putData(is))!=null) break bl; /* write-error ? */
          } /* create all definition-lines of this entry */
          continue; /* control-entry fully processed -- continue with next entry */
        } /* current entry was a 'control-entry' */

        is = "\t" + cUiD.getName(false) + " ("; /* Type-Definition */
        cc = 22; /* preset position in case of error */
        if((is=cF.putData(is))!=null) break bl; /* write-error ? */
        is = "\t\tUiD ( " + cUiD.getUiD(chg ? 2 : 0) + " )"; /* UiD-Definition */
        cc = 23; /* preset position in case of error */
        if((is=cF.putData(is))!=null) break bl; /* write-error ? */

        for(j=1;j<31;j+=1) { /* write all attributes of the entry */
          if(cUiD.chkMsk(j)) continue; /* no output here */
          for(i=0;i<100;i+=1) { /* write all lines (max. 100) */
            is = cUiD.crDef(j,i,true,clr); /* create definitionline */
            if(is==null) break; /* no more lines -- continue with next object */
            /* Attention: outputline must start with '\t' (otherwise 'error'-message) */
            if(is.charAt(0)!='\t') { /* error-message instead of line */
              Lg.Err("putWF12",is); /* print errormessage */
              ec += 1; /* and count error */
              is = cUiD.crDef(j,i,false,clr); /* create def.-line again (no message) */
            } /* message processed */
            cc = i * 100 + j + 31; /* preset position in case of error */
            if((is=cF.putData(is))!=null) break bl; /* write-error ? */
          } /* -for- write all lines of a definition */
        } /* -for- write all attributes of the definition */
        cc = 24; /* preset position in case of error */
        if((is=cF.putData("\t)"))!=null) break bl; /* write-error ? */
      } /* -for- write all UID-definitions of the file */

      cc = 14; /* preset position in case of error */
      if((is=cF.putData(")"))!=null) break bl; /* write-error ? */
      cc = 19; /* preset position of error */
      is = TSLogg.getMsg("Msg100","World"); /* create TSUtil-ID-Line */
      if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
      cc = 0; /* no error found */
    } /* -bl- break-block used in case of error */
    if(is!=null) { /* error-message must be written */
      Lg.Err("putWF11",is); /* print errormessage */
      ec += 1; /* and count error */
    } /* output of error-message needed */
    is = cF.close(); /* close outputfile again */
    if(is!=null) Lg.Err("putWF11",is); /* print errormessage */
    if(cc!=0) Lg.Err("putWF15",cc); /* print reason of termination */
    else if(ec>0) Lg.Log("putWF16",ec); /* print number of errors */

    Lg.Log("putWF17",cF.getStat(true)); /* print result of counter */
    Lg.Log("putWF18",cF.getStat(false)); /* print result of counter */
    RetVal = new Integer(ec); /* return number of errors */
    return cc; /* return reason of termination */
  }

 /**. <pre>
  *=====================================================================
  * Method "putVS"
  * write ViewSphere-Entries (recursive)
  * Usage from: putWrld()
  * ##putVS (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String putVS( /* write ViewSphere-chain */
   TSFile cF,  /* Output-file */
   TSView cVS, /* current ViewSphere-Definition */
   int    lvl) /* current output-level (Start=1) */
   {
   /*-----------------------------------------------------------------*/
    String           is;  /* current output-data */
    String[]         Lne; /* current output-lines */
    Iterator<TSView> cI;  /* iterator for childs */
   /*=================================================================*/
    is = TSUtil.setPrfx(lvl) + "ViewDbSphere ("; /* begin of stmt */
    if((is=cF.putData(is))!=null) return is; /* write-error ? */
    lvl += 1; /* new viewsphere with new level -- increment it */
    Lne = cVS.crDef(TSUtil.setPrfx(lvl)); /* create new definition */
    if((is=cF.putData(Lne[0]))!=null) return is; /* write-error? */
    if((is=cF.putData(Lne[1]))!=null) return is; /* write-error? */
    if((is=cF.putData(Lne[2]))!=null) return is; /* write-error? */
    /* process all Child-definitions and write them too */
    cI = cVS.getIt(); /* get iterator of TSView-Childs */
    /* 'cVS' no longer needed -- used as temporary value */
    if(cI!=null) /* Child-Definitions exit -- process them */
     while(cI.hasNext()) { /* more definitions */
      cVS = cI.next(); /* get next TSView-Child */
      if((is=putVS(cF,cVS,lvl))!=null) return is; /* return if error */
    } /* process all child-definitions */
    lvl -= 1; /* decrement current level again (for last line) */
    is = TSUtil.setPrfx(lvl) + ")"; /* last line of ViewSphere */
    if((is=cF.putData(is))!=null) return is; /* write-error */
    return null; /* viewsphere-data successfully processed */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getSF"
  * Load ALL 'Sound'-files from world-directory and check syntax of
  *   entries.
  * ATTENTION: if an error is discovered (syntactical or content)
  *            the object is NOT inserted into the list of sound-objects.
  *            So, there is no index-gap within defined sound-objects.
  * ##getSF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getSF( /* load all sound-files and check them */
   TSRoute cRte, /* current route-definition */
   boolean KM)   /* use correction-mode if 'true' */
   {
   /*-----------------------------------------------------------------*/
    File             dat;  /* current inputfile */
    TSQuad           cQDf; /* current quad-definition */
    int              i,c;  /* intermediate value, counter */
    String           is;   /* file-name/path */
    Iterator<TSQuad> cI;   /* TSQuad-iterator */
   /*=================================================================*/
    if(cRte.chgQDf(null)==null) { /* quad-definitions missing */
      Lg.Skip(false); /* print empty line to LOG-file */
      Lg.Msg("getSF$01"); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 4; /* terminate function with errorcode */
    } /* error found -- function terminated */

    Lg.Skip(true); /* print empty line (screen and LOG-file) */
    Lg.Msg("getSF$02",cRte.getInfo(1)); /* print description of next action */

    c = 0; /* init file-counter */
    cI = cRte.getIt(12); /* get iterator for quad-definitons */
    while(cI.hasNext()) { /* all quad-definitions processed? */
      /* process all quad-definitions and load sound-filr */
      cQDf = cI.next(); /* get next quad-definition */
      is = cQDf.getInf(4); /* get name of sound-file (source) */
      if(is==null) continue; /* name missing -- skip quad-definition */
      c += 1; /* count sound-file(s) */
      dat = cRte.getFile(10,is); /* create complete reference to file */
      is = dat.getAbsolutePath(); /* and extract complete path-name */
      Lg.Log("MsgC54",is,DF4.format(c)); /* print next action */

      i = getSnd(dat,cQDf,cRte,KM); /* load sound-file and check objects */
//      if(i<0) continue; /* open-error -- process next file */
    } /* -while- read and load all sound-files */

    Lg.Skip(false); /* print empty line to LOG-file */
    Lg.Log("getSF$03",c); /* print number of loaded sound-files */
    Lg.Skip(false); /* print empty line to LOG-file */
    return 0; /* method complete -- return successfully */
  }

 /**. <pre>
  *=====================================================================
  * Method "getSnd"
  * Load ONE sound-file and check syntax of definition
  * ATTENTION: if an error is discovered (syntactical or content)
  *            the object is NOT inserted into the list of sound-objects.
  *            So, there is no index-gap within defined sound-objects.
  * ##getSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getSnd( /* load one sound-file */
   File    dat,  /* definition of sound-file to read */
   TSQDef  cQDf, /* current environment for sound-file */
   TSRoute cRte, /* current route-definition (basis-anchor) */
   boolean KM)   /* use correction-mode if 'true' */
   {
   /*-----------------------------------------------------------------*/
    TSFileX cF;    /* inputfile of world-definition */
    TSBuf   cB;    /* current input-buffer for 'read file' */
    TSSnd   cSnd;  /* current sound-entry */
    TSChain cC;    /* current list of sound-objects (chain) */
    TSView  cVS;   /* current ViewSphere-definition */
    TSPos   cPos;  /* current position-object */
    TSQDir  cDir;  /* current direction-object */
    long    l;     /* stores 'unsigned Integer' */
    int     cid,reqMsk,valMsk; /* requested lines, valid lines */
    int     i,j,k,u,w,l1,l2,ec,cc; /* intermediate values */
    String  is,ks; /* intermediate value / UID-Value */
    String  Typ;   /* current object-type for error-messages */
    ArrayList<String> ETab; /* temporary list of warnings/errors */
   /*=================================================================*/
    /* open sound-file for input */
    cF = new TSFileX(TSFileX.FT$ws,dat); /* create input-control of sound-file */
    is = cF.open(false); /* and open file for input */
    if(is!=null) { /* error occurred while opening file */
      Lg.Err("getSF001",is); /* print errormessage: terminating */
      return -1; /* terminate method -- use next world-file */
    } /* error while opening world-file */

    cB = new TSBuf(cF); /* create inputbuffer and init counter */
    /* check sound-file and gather data for the sound-objects */
    cc = 0; /* preset current Condition-Code */
    ec = 0; /* initialize error-counter (non-terminating) */
    bl: { /* block for error-break */
      is = cB.getKE(true); /* get first controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getSF011"); /* print errormessage */
          cc = 4; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getSF012",is); /* print errormessage */
        cc = 5; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getSF013"); /* print errormessage */
        cc = 6; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(!is.equals("tr_worldsoundfile")) { /* 'Tr_Worldsoundfile' not found */
        Lg.Err("getSF014",is); /* print errormessage */
        cc = 7; /* set current return-code to error */
        break bl; } /* terminate evaluation */

      l1 = cB.getBrL(); /* current bracket-level for terminate */
      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getSF015"); /* print errormessage */
          cc = 8; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getSF016",is); /* print errormessage */
        cc = 9; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        if(cB.charAt(false)==')') { /* sound-file is empty */
          cQDf.chgSTab(new TSChain(),0); /* insert dummy-values */
          Lg.Log("getSF018"); /* print result */
          break bl; /* file was processed successfully */
        } /* sound-file was empty */
        Lg.Err("getSF017"); /* print errormessage */
        cc = 10; /* set current return-code to error */
        break bl; } /* terminate evaluation */

      /* process ALL definitions of world-objects */
      u = 0; /* initialize value of 'maximum UID' */
      w = 0; /* initialize 'StaticDetailLevel' */
      cC = new TSChain(); /* creat new (sorted) chain for sound-objects */
      ETab = new ArrayList<String>(); /* initialize list of messages */
      for(;true;is=cB.getKE(true)) { /* process all definitions */
        /* skip 'getKE()' when entering; init endless loop */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getSF031"); /* print errormessage */
            cc = 21; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getSF032",is); /* print errormessage */
          cc = 22; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) break; /* no more entries found */
        l2 = cB.getBrL(); /* current bracket-level for terminate */
        k  = -1; /* preset UID-value (clear it) */
        ks = "?"; /* and mark UID as unknown (printing) */
        cSnd = null; /* Compiler needs it */
        dtl: { /* block for error-break -- do not store definition */
          /* if an error is discovered (syntactical or content)
           *   the object is NOT inserted into the list of sound-objects.
           *   So, there is no index-gap within defined sound-objects.
           */
          if(is.equals("soundregion")) { /* Definitiontype: 'Soundregion' */
            cSnd = new TSSRgn(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "Soundregion"; /* set objekt-type to be used for error-messages */
            cid = 17; /* set index of UID-statement */
          } else if(is.equals("soundsource")) { /* Definitiontype: 'Soundsource' */
            cSnd = new TSSSrc(cQDf.getOId(),w); /* create basisdefinition */
            Typ = "Soundsource"; /* set objekt-type to be used for error-messages */
            cid = 29; /* set index of UID-statement */
          } else { /* unknown keyword of sound-type -- do not process */
            Lg.Err("getSF033",is); /* print errormessage */
            ec += 1; /* count error */
            break dtl; } /* terminate evaluation */
          reqMsk = cSnd.getCtl(0); /* mask of 'requested keywords' ('reqMsk') */
          valMsk = cSnd.getCtl(1); /* mask of 'valid keywords' ('valMsk') */

          while(true) { /* process all sub-definitions (definitionlines) */
            /* All definition lines, which follow the type-definition of a sound-
             * object, are processed independant from the type of the entry. Then
             * they are assigned to the current valid object-type.
             * 1. part : commonly valid keywords (id = 16..31).
             */
            is = cB.getKE(true); /* get next controlword */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getSF051",Typ); /* print errormessage */
                cc = 31; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              Lg.Err("getSF052",Typ,is); /* print errormessage */
              cc = 32; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            if(is.length()==0) break; /* no more entries found */
            if(is.equals("tritemid")) SD16:{ /* Sub-Definition: 'TrItemId' */
              if(!TSOpts.chkMsk(16,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF071",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD16; } /* do not further process definitionline */
                Lg.Err("getSF072",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              i = (int)cB.getNV(); /* get number of database */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getSF073",Typ,ks,""+cB.getStat(true),is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(i<0 || i>1) { /* invalid range of database-number */
                Lg.Err("getSF074",Typ,k,i); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              j = (int)cB.getNV(); /* get 'TrItem'-number */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getSF075",Typ,ks,""+cB.getStat(true),is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if((j=cSnd.addTrI(i,j))!=0) { /* there are errors in this values */
                if(j<0) Lg.Err("getSF076",Typ,k,j,i); /* print errormessage */
                  /* database-referenece (number) is NOT valid */
                else Lg.Err("getSF077",Typ,ks,j); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cSnd.setMsk(16); /* mark: definitionline is successfully processed */
            } else if(is.equals("uid")) SD17:{ /* Sub-Definition: 'UiD' */
              /* Attention: indexnumber of UiD : Soundregion - 17
               *            (val='cid')          Soundsource - 29    */
              i = (int)cB.getNV(); /* get new value of 'UID' */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getSF061",Typ,is,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(i<0) { /* invalid range */
                Lg.Err("getSF062",Typ,i); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if((j=cSnd.setUiD(i,cid))>=0) { /* insert new 'UiD' into object -- already done? */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF063",Typ,j,cB.getStat(true)); /* print warning-message */
                  break SD17; } /* do not further process definitionline */
                Lg.Err("getSF064",Typ,j,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              k = i; /* activate new UID-value */
              u = Math.max(u,i); /* compute maximum of ALL UID-values */
              ks = "" + i; /* convert for printing */
            } else if(is.equals("filename")) SD19:{ /* Sub-Definition: 'FileName' */
              if(!TSOpts.chkMsk(19,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF101",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD19; } /* do not further process definitionline */
                Lg.Err("getSF102",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cSnd.chkMsk(19)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF103",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD19; } /* do not further process definitionline */
                Lg.Err("getSF104",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              is = cB.getVal(7); /* get current filename */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getSF105",Typ,ks); /* print errormessage */
                  cc = 39; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getSF106",Typ,is,ks); /* print errormessage */
                cc = 40; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(is.length()==0) { /* (length-)value is not present */
                Lg.Err("getSF107",Typ,ks); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              is = is.replace('\\','/'); /* replace backslash within filename (if available) */
                /* filenames should be written using a common form */
              cSnd.chgNme(is); /* insert new filename */
              cSnd.setMsk(19); /* mark: definitionline is successfully processed */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) /* error found within current input */
                if((is=cB.getErr())==null) is = TSLogg.getKey("getSF035"); /* EOF */
                else is = TSLogg.getMsg("getSF036",is); /* error within data */
              if(is.length()>1) { /* additional data found */
                Lg.Err("getSF106",Typ,is,ks);  /* print errormessage */
                ec += 1; /* count error */
              } /* report additional error */
            } else if(is.equals("staticflags")) SD20:{ /* Sub-Definition: 'StaticFlags' */
              if(!TSOpts.chkMsk(20,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF111",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD20; } /* do not further process definitionline */
                Lg.Err("getSF112",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cSnd.chkMsk(20)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF113",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD20; } /* do not further process definitionline */
                Lg.Err("getSF114",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              i = cB.getHV(8); /* get value of argument (Hex-number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getSF115",Typ,ks,""+cB.getStat(true),is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cSnd.setStF(i);  /* insert new value for 'StaticFlags' into current object */
              cSnd.setMsk(20); /* mark: definitionline is successfully processed */
            } else if(is.equals("position")) SD21:{ /* Sub-Definition: 'Position' */
              if(!TSOpts.chkMsk(21,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF121",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD21; } /* do not further process definitionline */
                Lg.Err("getSF122",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(cSnd instanceof TSSSrc) i = 15; /* current object is: 'Soundsource' */
              else i = 21;  /* current object is: 'Soundregion' */
              if(!cSnd.chkMsk(i)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF123",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD21; } /* do not further process definitionline */
                Lg.Err("getSF124",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if((is=chkPos(cB,i==15?cSnd:null,ETab))!=null) { /* read pos-values and check them */
                Lg.Err("getSF125",Typ,is,ks); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              while(!ETab.isEmpty()) { /* add. message-definitions are available -- print them */
                is = ETab.remove(0); /* remove first element from stack */
                Lg.Err("getSF125",Typ,is,ks); /* print errormessage */
                ec += 1; /* count error */
              } /* remove all message-definitions and print them */
              cPos = (TSPos)RetVal; /* get created position-object */
              if((cPos=cSnd.setPos(cPos))!=null) { /* definition was already set */
                Lg.Err("getSF126",Typ,cPos.getPos(true),ks); /* print warning-message */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cSnd.setMsk(i); /* mark: definitionline is successfully processed */
            } else if(is.equals("qdirection")) SD22:{ /* Sub-Definition: 'QDirection' */
              if(!TSOpts.chkMsk(22,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF131",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD22; } /* do not further process definitionline */
                Lg.Err("getSF132",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cSnd.chkMsk(22)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF133",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD22; } /* do not further process definitionline */
                Lg.Err("getSF134",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if((is=getQDir(cB))!=null) { /* read direction values and check them */
                Lg.Err("getSF135",Typ,is,ks); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cDir = (TSQDir)RetVal; /* get created quaternion */
              if((cDir=cSnd.setQDir(cDir))!=null) { /* Quaternion was already set */
                Lg.Err("getSF136",Typ,cDir.getDir(true),ks); /* print warning-message */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cSnd.setMsk(22); /* mark: definitionline is successfully processed */
            } else if(is.equals("vdbid")) SD25:{ /* Sub-Definition: 'VDbId' */
              if(!TSOpts.chkMsk(25,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF161",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD25; } /* do not further process definitionline */
                Lg.Err("getSF162",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cSnd.chkMsk(25)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF163",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD25; } /* do not further process definitionline */
                Lg.Err("getSF164",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              l = cB.getNV(); /* get specified viewsphere-ID */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getSF165",Typ,ks,""+cB.getStat(true),is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(l<NoVS) { /* ID references valid viewsphere (no dummy-version) */
                i = (int)l; /* convert viewsphere-ID for further processing */
                if((cVS=cQDf.fndView(i))==null) { /* NO viewsphere defined */
                  Lg.Err("getSF166",Typ,ks,i); /* print errormessage */
                  ec += 1; /* count error */
                  break dtl; } /* terminate evaluation */
                cVS.incCnt(1); /* count reference to viewsphere */
                cSnd.chgView(cVS); /* and insert viewSphere-reference */
              } else cSnd.clrView((int)(l-NoVS)); /* store special ID of viewsphere */
              cSnd.setMsk(25); /* mark: definitionline is successfully processed */
            } else if(is.equals("staticdetaillevel")) SD26:{ /* 'StaticDetailLevel' */
              if(!TSOpts.chkMsk(26,valMsk)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF171",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD26; } /* do not further process definitionline */
                Lg.Err("getSF172",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cSnd.chkMsk(26)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF173",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD26; } /* do not further process definitionline */
                Lg.Err("getSF174",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              i = (int)cB.getNV(); /* get new value for 'StaticDetailLevel' */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getSF175",Typ,ks,""+cB.getStat(true),is); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(i<w) Lg.Err("getSF176",Typ,k,i,w); /* Sort-error within levels */
              if(i>=0) { /* valid level register it with object */
                if(i!=w) cSnd.setSL(i); /* insert new level (explicitely) into object */
                w = i; /* new MINIMAL StaticDetailLevel is valid from now */
              } /* value was registered and set */
              cSnd.setMsk(26); /* mark: definitionline is successfully processed */
            /* 2. Part : Keywords, which are used more than once within an object-definition, are
             *   processed here. Additional keywords, which are used to represent 'Hidewire'-objects
             *   are also checked within this part.
             */
            /* 3. Part : Keywords, which are used only once with all world-objects, are handled here.
             *    To verify, that these keywords are valid with a world-object-type, class names of
             *    the appropriate world-object is used. Mask 'valMask' is no longer used for this
             *    purpose (inside this part).
             */
            } else if(is.equals("soundregionroty")) SD33:{ /* Sub-Definition: 'SoundregionRoty' */
              if(!(cSnd instanceof TSSRgn)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF351",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD33; } /* do not further process definitionline */
                Lg.Err("getSF352",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cSnd.chkMsk(1)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF353",ks,cB.getStat(true)); /* print warning-message */
                  break SD33; } /* do not further process definitionline */
                Lg.Err("getSF354",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              /* content of line is not evaluated but stored */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getSF355",ks,cB.getStat(true)); /* print errormessage */
                  cc = 33; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getSF356",ks,is,cB.getStat(true)); /* print errormessage */
                cc = 34; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cSnd.chgDta(0,is))!=null) { /* value already set -- replaced */
                if(is.charAt(0)!=' ') Lg.Err("getSF356",ks,is,cB.getStat(true));
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              cSnd.setMsk(1); /* mark: definitionline is successfully processed */
            } else if(is.equals("soundregiontracktype")) SD34:{ /* Sub-Def.: 'SoundregionTrackType' */
              if(!(cSnd instanceof TSSRgn)) { /* type of definitionline is not valid */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF361",Typ,ks,cB.getStat(true)); /* print warning-message */
                  break SD34; } /* do not further process definitionline */
                Lg.Err("getSF362",Typ,ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(!cSnd.chkMsk(2)) { /* definitionline was already present */
                if(KM) { /* correction-mode active -- do not terminate */
                  if(EnaW) Lg.Log("getSF363",ks,cB.getStat(true)); /* print warning-message */
                  break SD34; } /* do not further process definitionline */
                Lg.Err("getSF364",ks,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              i = (int)cB.getNV(); /* get new number of tracktype */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getSF365",is,k,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              if(i<0) { /* invalid range */
                Lg.Err("getSF356",ks,i,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation */
              ((TSSRgn)cSnd).chgType(i); /* insert reference-number into 'ttype.dat' */
              cSnd.setMsk(2); /* mark: definitionline is successfully processed */
            } else { /* unknown keyword -- do not process */
              Lg.Err("getSF053",Typ,is,ks,""+cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl; } /* terminate evaluation */
            if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
              cc = 49; /* set current return-code to error */
              break bl; } /* terminate evaluation */
          } /* -while- process all sub-definitions (definitionlines) */
          if((j=cSnd.tstMsk(reqMsk))!=0) { /* check if definitionlines are missed
              * (check-mask is NOT changed) */
            is = ""; /* preset: no line is missed */
            cid = -1; /* label not active -- used as intermediate value */
            for(i=0;i<32;i+=1) { /* check all possible definition-lines */
              if(TSOpts.chkMsk(i,reqMsk)) cid += 1; /* forward to next index */
              if(!TSOpts.chkMsk(i,j)) continue; /* line not needed or present */
              is += "," + cSnd.getItem(cid); /* get/add description of missing line */
            } /* check all definition-lines */
            Lg.Err("getSF054",Typ,is.substring(1),ks,""+cB.getStat(true));
            ec += 1; /* count error */
            break dtl; } /* terminate evaluation */
          cC.add(cSnd); /* add new entry to sorted list of world-objects */
        } /* 'dtl' - break-block for errors */
        /* If the processing of the sound-object is aborted, the reamining definition-lines
         * must be skipped. The next 'skpFwd'-command advances the input-pointer after the
         * closing bracket of the current sound-definition.
         */
        if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
          Lg.Err("getSF034"); /* print errormessage */
          cc = 23; /* set current return-code to error */
          break bl; } /* terminate evaluation */
      } /* -for- process all world-definitions of the file */

      is = cB.skpVal(); /* get remaining value(s) within brackets */
      if(is==null) /* error found within current input */
        if((is=cB.getErr())==null) is = TSLogg.getKey("getSF035"); /* EOF */
        else is = TSLogg.getMsg("getSF036",is); /* error within data */
      if(is.length()>1) Lg.Err("getSF037",is); /* print error-message */
        /* additional data found (" " returned in every case) */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        cc = 17; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(cQDf.chgSTab(cC,u)!=null) Lg.Err("getSF039",u); /* print errormessage */
        /* insert chain of sound-object-definitions to the quad-basis */
    } /* -bl- break-block used in case of error */
    is = cF.close(); /* close inputfile again */
    if(is!=null) Lg.Err("getSF001",is); /* print errormessage */
    if(cc!=0) Lg.Log("getSF005",cc); /* print errormessage */
    else if(ec>0) Lg.Log("getSF006",ec); /* print number of errors */

    return cc; /* terminate method using return-code */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkSnd"
  * gespeicherte Sound-Dateien bearbeiten und Fehler melden
  * ##chkSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chkSnd( /* Sound-Dateien in Tab pruefen */
   TSRoute   cRte, /* aktuelle Routendefinition mit Basisverzeichnis */
   TSNameSet Nme,  /* Liste fuer Shape-Namen (oder 'null') */
   int       mde)  /* Ausgabe-Modus und Optionen */
   {
   /*-----------------------------------------------------------------*/
    TreeSet<TSQuad> QDf;       /* Quadrat-Definitionen */
    TSQuad          cQDf,nQDf; /* aktive Quadrat-Definition */
    TSSnd           cSnd,aSnd; /* aktive Sound-Definition */
    TSChain         cC,nC;     /* Arbeitswert Objektkette */
    TStType         cTp;       /* aktuelle ttype-Referenz */
    TSPos           cPos;      /* aktuelle Positionsdefinition */
    TSView          cVS;       /* aktuelles ViewSphere-Element */
    int             i,j,u,cnt,n;
    double          d;   /* Pruefwert fuer Verschieben */
    String          is;
    Iterator        cI;  /* allgemeiner Iterator fuer 'TreeSet' */
    boolean         chg; /* UiD-Aenderungen melden (UiD[1] wird immer gesetzt) */
    boolean         ren; /* Neunummerierung durchfuehren wenn moeglich */
    boolean         clp; /* clip position-values if needed */
   /*=================================================================*/
    chg = false; if(mde>=128) {chg = true; mde -= 128;} /* Option! */
    ren = false; if(mde>=64) {ren = true; mde -= 64;} /* Option! */
    clp = false; if(mde>=32) {clp = true; mde -= 32;} /* Option! */
    if(mde>=4) mde = -1; /* Standard-Wert setzen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("chkS001",cRte.getInfo(1)); /* Aktionsmeldung */

    cnt = 0; /* Sound-Dateizahler initialisieren */
    QDf = cRte.chgQDf(null); /* Alle Quadrat-Definitionen */
    if(QDf==null) throw new IllegalStateException( /* Sicherheitsabfrage */
      TSLogg.getMsg("Msg908","TreeSet<TSQuad>==null","TSUtil.chkSnd()",0));
    cI = QDf.iterator(); /* Iterator fuer Quadrat-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cQDf = (TSQuad)cI.next(); /* naechste Quadrat-Definition */
      is = cQDf.getInf(4); /* Namen der Sound-Datei (Quelle) */
      if(is==null) continue; /* Sound-Datei fehlt -- nicht bearbeiten */
      cC = cQDf.chgSTab(null,0);  /* aktuelle Verkettung der Sound-Elemente holen */
      if(cC==null) throw new IllegalStateException( /* Sicherheitsabfrage */
        TSLogg.getMsg("Msg908","TSChain==null","TSUtil.chkSnd()",0));

      cnt += 1; /* Datei zaehlen */
      n = ren ? 100000 : -1; /* neue UiD initialisieren (-1 : KEINE neue UiD) */
      Lg.Log("chkS002",is); /* Fehlermeldung ausgeben */

      /* interne Sound-Daten bearbeiten und pruefen */
      for(cSnd=(TSSnd)cC.list(true);cSnd!=null;cSnd=(TSSnd)cC.list(false)) {
        /* nicht belegte Eintraege gibt es nicht */
        if(cSnd.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
        u = cSnd.getUiD(0); /* aktuelle UiD holen */
        for(aSnd=(TSSnd)cC.next(true);aSnd!=cSnd;aSnd=(TSSnd)cC.next(false)) {
          if(aSnd.isOpt(0)) continue; /* Dummy-Eintrag NICHT vergleichen */
          if(aSnd.getUiD(1)==u) { /* UiD ist mehrfach vergeben */
            is = ""; /* Vorbesetzen: keine Aenderung der UiD */
            if(!(cSnd instanceof TSSRgn)) { /* keine 'Soundregion' -- UiD aenderbar */
              j = cSnd.nxtUiD(cQDf); /* neue UiD eintragen (UiD[1],UiD[2]) */
              is = chg ? "chkS011" : "chkS012"; /* Kennung fuer Message */
              is = TSLogg.getMsg(is,cSnd.getName(true),j); /* Messageteil erstellen */
            } else if(!(aSnd instanceof TSSRgn)) { /* keine 'Soundregion' -- UiD aenderbar */
              j = aSnd.nxtUiD(cQDf); /* neue UiD eintragen (UiD[1],UiD[2]) */
              is = chg ? "chkS011" : "chkS012"; /* Kennung fuer Message */
              is = TSLogg.getMsg(is,aSnd.getName(true),j); /* Messageteil erstellen */
            } /* UiD -Typ-Pruefung abgeschlossen */
            Lg.Msg("chkS021",is,""+u,aSnd.getName(true),cSnd.getName(true));
            if(cSnd.chainUiD(aSnd)) Lg.Err("chkS022",u); /* Fehlermeldung ausgeben */
              /* Verkettungsfehler aufgetreten */
            break; /* Gleichheit -- nicht mehr weiter pruefen */
          } /* UiD doppelt vergeben */
        } /* alle vorangehenden UiD's */

        if(cSnd instanceof TSSRgn) {  /* weitere Pruefung ('Soundregion') */
          if((i=chkItm(cSnd,cRte,0,"'Soundregion("+u))!=0) /* TrItem-Definition bearbeiten */
            Lg.Err("chkS051",null,u,i); /* Fehlermeldung ausgeben */
          i = cRte.set$Type(0); /* 'ttype.dat' geladen ? */
          if(i>0) { /* Datei ist geladen -- pruefen und setzen */
            j = ((TSSRgn)cSnd).chgType(-1); /* aktuelle Referenz holen */
            if(j<0 || j>=i) { /* Referenzwert fuer Datei zu falsch */
              Lg.Err("chkS052",""+i,u,j); /* Fehlermeldung ausgeben */
            } else { /* Referenz ist OK -- zuweisen ? */
              cTp = cRte.chgType(j,null); /* aktuelle ttype-Referenz holen */
              ((TSSRgn)cSnd).chgTRef(cTp); /* und aktivieren */
              cTp.incCnt(1); /* Referenz zaehlen */
            } /* ttype-Referenz wurde gesetzt */
          } else if(EnaW) Lg.Log("chkS053",u); /* Hinweis: ttype.dat nicht verfuegbar */
          if(Nme!=null) Nme.add(cSnd.chgNme(null)); /* register file-name if available */
        } else if(cSnd instanceof TSSSrc) {  /* weitere Pruefung ('Soundsource') */
          if(cSnd.getOpt(3840)!=0) t2: { /* mind. ein Positionswert fehlerhaft (x0F00) */
            cPos = cSnd.crPos(); /* Kopie der Positionsdefinition holen */
            if(cPos==null) break t2; /* Positionsdefinition fehlt -- keine Bearbeitung */
            i = j = 0; /* Differenz vorbesetzen (falls Wert nicht betroffen) */
            if(cSnd.getOpt(768)!=0) i = cPos.addPosX(0.0); /* Quad-Nr (Diff) berechnen */
              /* X-Position betroffen (x0300)=(8,9) -- Quadrantenfehler errechnen */
 if(Fo.chkMsk(31)) Lg.Msg("Msg010","PosX: u="+u+", Quad=("+cQDf.getInf(0)+")--Ende (i="+
                          i+",Pos=("+cPos.getPos(0,15)+")");
            if(cSnd.getOpt(3072)!=0) j = cPos.addPosZ(0.0);/* Quad-Nr (Diff) berechnen */
              /* Z-Position betroffen (x0C00)=(10,11)-- Quadrantenfehler errechnen */
 if(Fo.chkMsk(31)) Lg.Msg("Msg010","PosZ: u="+u+", Quad=("+cQDf.getInf(0)+")--Ende (j="+
                          j+",Pos=("+cPos.getPos(0,6)+")");
 if(Fo.chkMsk(31)) Lg.Msg("Msg010","Values(Alt): u="+u+", Val: "+cSnd.toStr());

            nQDf = cQDf.fndQuad(cRte,i,j); /* passende Quadrantendefinition suchen */
            if(nQDf==null) { /* Quadrant nicht definiert -- Fehler/keine Aenderung */
              /* Achtung: Wenn ein Quadrant fuer eine SOUND-Datei fehlt, wird kein neuer
               * Quadrant erzeugt, sondern die Anpassung zurueckgewiesen.
               */
              if(clp) { /* Veraendern der Positionswerte innerhalb des Quadranten gefordert */
                cPos = cSnd.setPos(null); /* Referenz auf originale Positionsdefinition holen, */
                cPos.clipPos(); /* Positionswerte gueltig machen */
                cSnd.setPos(cPos); /* und Referenz wieder einsetzen */
                cSnd.resOpt(3840); /* Markierung ueber Fehlwerte loeschen */
                Lg.Log(chg?"chkS107":"chkS108",cPos.getPos(true),u,i,j); /* Meldung ausgeben */
              } else Lg.Err(chg?"chkS101":"chkS102",""+i,u,j); /* Fehlermeldung ausgeben */
              break t2; /* keine weitere Aktion */
            } /* Ziel-Quadranten nicht gefunden/definiert */
            /* Ziel-Quadrant ist definiert -- Sound-Objekt verschieben */
            if((is=cC.remove(cSnd))!=null) { /* Fehler beim Entfernen des Elementes */
              Lg.Err("chkS100",is,u,0); /* Fehlermeldung ausgeben */
              continue; /* naechstes Objekt bearbeiten */
            } /* Element konnte nicht korrekt entfernt werden */
            if((nC=nQDf.chgSTab(null,0))==null) { /* NOCH keine Sound-Datei vorhanden */
              if(nQDf.setNme(false)) Lg.Log(chg?"chkS103":"chkS104",nQDf.getInf(0),u,0);
              nC = new TSChain(); /* neue, leere Objekt-Kette erzeugen */
              nQDf.chgSTab(nC,0); /* und in Quadranten eintragen */
            } /* Objektkette fuer Sound-Objekte musste erzeugt werden */

            /* Sound-Objekt fuer neuen Quadranten bearbeiten */
            cSnd.$reNew(nQDf.getOId(),nQDf.getSId()); /* Eindeutige Daten neu setzen */
            cSnd.setPos(cPos); /* neuer Positionswert einsetzen (modifizierte Kopie) */
            cSnd.resOpt(3840); /* Markierung ueber Fehlwerte loeschen */
            cSnd.setOpt(24); /* Kennzeichnen setzen: UiD NICHT neu vergeben */
            if(!cSnd.chkMsk(25)) /* VDbId-Definition ist vorhanden */
             if((cVS=cSnd.chgView(null))!=null) { /* Explizite ViewSphere-Referenz -- bearbeiten */
              cVS.incCnt(-1); /* Zaehler anpassen */
              cSnd.clrView(cSnd.getVNrDef()); /* Viewsphere-Referenz loeschen und durch 'default' ers. */
            } /* Explizite Viewsphere-Referenz musste bearbeitet werden */
 if(Fo.chkMsk(31)) Lg.Msg("Msg010","Values(Neu): u="+cSnd.getUiD(0)+", Val: "+cSnd.toStr());
            /* Achtung: Kette der Sound-Objekte kann leer sein. */
            nC.add(cSnd); /* Sound-Eintrag sortiert hinzufuegen und speichern */
            Lg.Log(chg?"chkS105":"chkS106",nQDf.getInf(0),cPos.getPos(true),u); /* Hinweis ausgeben */
          } /* -t2- fehlerhafte Positionswerte */
        } else if(Nme!=null) Nme.add(cSnd.chgNme(null)); /* register name if available */
          /* all other object-types: check if name available and register it */

        n = cSnd.renUiD(n); /* ggf. neue UiD vergeben */
      } /* alle Eintraege der 'Sound'-Datei bearbeiten */
    } /* alle Sound-Dateien bearbeiten */
    return cnt; /* Anzahl der bearbeiteten Dateien liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "putSF"
  * Write ALL sound-files (world-version) again
  * ##putSF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int putSF( /* write sound-files again */
   TSRoute cRte, /* current route-definition */
   File    tdat, /* file-definition of temporary file (or 'null') */
   boolean chg)  /* replace current UiD (0) with 'new'(2) one ? */
   {
   /*-----------------------------------------------------------------*/
    File   dats,datz; /* file-definitions for In- and Output */
    TSQuad cQDf;      /* current quad-definition of sound-file */
    String is,js;     /* intermediate values */
    int    i,ce,cf,z; /* intermediate value, counter */
    Iterator<TSQuad> cI; /* iterator of quad-structures */
   /*=================================================================*/
    if(cRte.chgQDf(null)==null) throw new IllegalStateException(
      TSLogg.getMsg("Msg908","TreeSet<TSQuad>==null","TSUtil.putSF()",0));

    Lg.Skip(true); /* print empty line to log-file and screen */
    /* verify if sound-directory exits */
    if(tdat==null) /* temporary file is NOT used */
     if(cRte.getFile(40)==null) { /* get target-directory -- valid? */
      Lg.Skip(true); /* print empty line to log-file and screen */
      Lg.Msg("MsgC63",cRte.getInfo(40)); /* print message: 'terminating' */
      Lg.Msg("putSF01"); /* print error-message */
      Lg.Close(); /* close output to Log-file */
      return 25; } /* terminate function with errorcode */

    Lg.Msg("putSF02",cRte.getInfo(1)); /* print description of next action */

    z = chg ? 2 : 0; /* create number of UID-version */
    ce = cf = 0; /* init counter (overall errors, sound-files) */
    cI = cRte.getIt(12); /* get iterator of quad-definitions */
    while(cI.hasNext()) { /* more unprocessed quad-definitions ? */
      /* process all Quad-definitions */
      cQDf = cI.next(); /* get next quad-definition */
      is = cQDf.getInf(4); /* get source-name of sound-file */
      if(is==null) continue; /* name missing -- do not process */
      js = cQDf.getInf(5); /* get target-name of sound-file */
      cf += 1; /* count sound-file */
      if(is.equals(js)) Lg.Log("MsgC34",is); /* print description */
      else Lg.Log("putSF03",is,js); /* of current action */

      dats = cRte.getFile(10,is); /* get full reference to source-file */
      if(tdat!=null) { /* overwrite is requested! */
        datz = tdat; /* preset: use temporary file */
        if(!is.equals(js)) { /* source and target are NOT indentical! */
          Lg.Err("putSF04",is); /* print error-message */
          continue; /* and continue with next quad-definition */
        } /* source- and target-name are NOT identical */
      } else datz = cRte.getFile(40,js); /* create target-definition */

      i = putSnd(datz,cQDf,z); /* write sound-file */
      if(i<0) continue; /* open-error occurred -- use next file */
      ce += ((Integer)RetVal).intValue(); /* inc overall error-counter */

      /* copy back result to sound-file(source) if overwrite requested */
      if(i>0) continue; /* error(s) found -- do NOT copy file */
      if(tdat!=null) { /* overwrite of original file requested */
        is = dats.getAbsolutePath(); /* source-file-name */
        js = "copy \""+tdat.getAbsolutePath()+"\" \""+is+"\" ";
          /* create 'copy'-command */
        if((i=exec(true,js,null,Lg))>0) /* error during 'execute' */
          Lg.Log("MsgC49",is,i); /* print error-message */
      } /* overwrite of original file requested */
    } /* -while- write ALL sound-files */

    Lg.Skip(false); /* print empty line to log-file */
    Lg.Log("putSF09",cf); /* print result: file-counter */
    Lg.Skip(false); /* print empty line to log-file */
    return 0; /* return from method normally */
  }

 /**. <pre>
  *=====================================================================
  * Method "putSnd"
  * Write ONE sound-file (world-version) modified to output-file
  * Attention: 'RetVal' will additionally return the number of errors
  * ##putSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final int putSnd( /* write ONE sound-file again */
   File    dat,  /* output-file (may be temporary) */
   TSQDef  cQDf, /* current sound-definition to write */
   int     chg)  /* replace current UiD (0) with 'new'(2) one */
   {
   /*-----------------------------------------------------------------*/
    TSFileX  cF;        /* current sound-file (output) */
    TSSnd    cSnd;      /* current sound-element */
    int      i,j,cc,ec; /* intermediate values */
    String   is;        /* intermediate values */
//    Iterator<String>  LneI; /* Line-Iterator for output */
//    ArrayList<String> LneT; /* Line-Table for output */
   /*=================================================================*/
    /* open sound-file for output */
    cF = new TSFileX(TSFileX.FT$ws,dat); /* create control of new sound-file */
    is = cF.open(true); /* open sound-file for output */
    if(is!=null) { /* open-error found -- write message */
      Lg.Err("putSF11",is); /* print errormessage */
      return -1; /* process next world-file */
    } /* error while opening world-file for output */

    ec = 0; /* init error-counter */
//    LneT = new ArrayList<String>(10); /* create table for output-line-blocks */
//      /* This list is normally empty. After it was filled with output-lines
//       * and all lines have been processed, it MUST be cleared again. */
    bl: { /* block for error-break */
      cSnd = cQDf.getSnd(true); /* get first sound-entry and init */
      cc = 11; /* preset position in case of error */
      is = "Tr_Worldsoundfile ("; /* create first line of sound-file */
      if(cSnd==null) { /* sound-file is empty */
        is += " )"; /* add termination to line */
        if((is=cF.putData(is))!=null) break bl; /* write-error ? */
          /* method 'putData()' will return 'null' if no error */
        cc = 0; /* set condition to 'no error' */
        break bl; /* terminate output -- file is complete */
      } /* empty sound-file successfully processed */
      if((is=cF.putData(is))!=null) break bl; /* write-error ? */

      /* process all Sound-entries and write them to the sound-file */
      for(;cSnd!=null;cSnd=cQDf.getSnd(false)) { /* first entry already present */
        if(cSnd.isOpt(0)) continue; /* do not write 'Dummy-Entries' */

        is = "\t" + cSnd.getName(true) + " ("; /* Type-Definition */
        cc = 22; /* preset position in case of error */
        if((is=cF.putData(is))!=null) break bl; /* write-error ? */
        for(j=1;j<31;j+=1) { /* write all attributes of the entry */
          if(cSnd.chkMsk(j)) continue; /* no output here */
          for(i=0;i<100;i+=1) { /* write all lines (max. 100) */
            is = cSnd.crDef(j,i,true,chg); /* create definitionline */
            if(is==null) break; /* no more lines -- continue with next object */
            /* Attention: outputline must start with '\t' (otherwise 'error'-message) */
            if(is.charAt(0)!='\t') { /* error-message instead of line */
              Lg.Err("putSF12",is); /* print errormessage */
              ec += 1; /* and count error */
              is = cSnd.crDef(j,i,false,chg); /* create def.-line again (no message) */
            } /* message processed */
            cc = i * 100 + j + 31; /* preset position in case of error */
            if((is=cF.putData(is))!=null) break bl; /* write-error ? */
          } /* -for- write all lines of a definition */
        } /* -for- write all attributes of the definition */
        cc = 24; /* preset position in case of error */
        if((is=cF.putData("\t)"))!=null) break bl; /* write-error ? */
      } /* -for- write all Sound-definitions of the file */

      cc = 14; /* preset position in case of error */
      if((is=cF.putData(")"))!=null) break bl; /* write-error ? */
      cc = 19; /* preset position of error */
      is = TSLogg.getMsg("Msg100","Sound"); /* create TSUtil-ID-Line */
      if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
      cc = 0; /* no error found */
    } /* -bl- break-block used in case of error */
    if(is!=null) { /* error-message must be written */
      Lg.Err("putSF11",is); /* print errormessage */
      ec += 1; /* and count error */
    } /* output of error-message needed */
    is = cF.close(); /* close outputfile again */
    if(is!=null) Lg.Err("putSF11",is); /* print errormessage */
    if(cc!=0) Lg.Err("putSF15",cc); /* print reason of termination */
    else if(ec>0) Lg.Log("putSF16",ec); /* print number of errors */

    Lg.Log("putSF17",cF.getStat(true)); /* print result of counter */
    Lg.Log("putSF18",cF.getStat(false)); /* print result of counter */
    RetVal = new Integer(ec); /* return number of errors */
    return cc; /* return reason of termination */
  }

 /**. <pre>
  *=====================================================================
  * Method "getDBF"
  * Laden der Schienen- oder Strassendatenbank und Syntax pruefen
  * TDB/RDB Datenbank in Zwischenverzeichnis laden
  * Es wird fuer JEDEN Eintrag in der TrNode-DB ein Eintrag angelegt. Im
  *   Fehlerfall ist dies ein Fehler-(leerer) Eintrag. Damit entsteht
  *   eine 1:1-Zuordnung zwischen Eintraegen und Datei
  * Fehlende Eintraege in der TrNode-DB erzeugen KEINEN Dummy-Eintrag
  * Achtung: UNBEKANNTE Typen in der TrItem-Tabelle werden als
  *          'null'-Eintrag gespeichert. Wenn der Typ gueltig ist und
  *          der TrItemId-Wert nicht bekannt ist, wird der INDEX als
  *          ID benutzt.
  * ##getDBF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getDBF( /* load Track-/Road-database */
   TSRoute cRte, /* Current route-definition (Basis-object) */
   int     typ)  /* Database-type (0-TDB,1-RDB) */
   {
   /*-----------------------------------------------------------------*/
    File               dat;    /* definiton of input-file */
    TSFileX            cF;     /* current database-file-control */
    TSBuf              cB;     /* current input-buffer for 'read file' */
    ArrayList<TSTrNde> TrN;    /* table of TrackNode-definitions */
    TSTrNde            cTrN;   /* current TrackNode-element */
    TSVector           cNde;   /* current vector-node */
    ArrayList<TSTrItm> ItT;    /* table of TrItem-definitions */
    TSTrItm            cIt;    /* current TrItem-element */
    ArrayList<TSRefC>  ItRfT;  /* table of TrItem-references */
    TSRefC             cRef;   /* current TrItem-reference (control) */
    int                i,j,v,w,ix,l1,l2,l3,si,sc,cc,ec;
    String             is,txt; /* intermediate values */
   /*=================================================================*/
    if(typ<0 || typ>1) { /* unknown database-type */
      Lg.Err("getDB001",typ); /* print errormessage */
      return 4; } /* terminate function with errorcode */
    txt = TSLogg.getKey("getDB01"+typ); /* Beschreibung fuer Datenbank */
    dat = cRte.getFile(typ+6); /* Dateiname zum Laden holen */
    if(dat==null) throw new IllegalStateException( /* security-query */
      TSLogg.getMsg("Msg908","File==null","TSUtil.getDBF()",0));
    if(dat.isDirectory()) { /* input-file is 'directory' */
      Lg.Skip(true); /* print empty line to log-file and screen */
      Lg.Msg("getDB002",txt,dat.getPath()); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* severe error found */
    if(!dat.exists()) { /* database-file not found */
      Lg.Skip(true); /* print empty line to log-file and screen */
      if(typ==0) { /* track-database MUST exist */
        Lg.Msg("getDB003",dat.getPath()); /* print message: terminating */
        Lg.Close(); /* close output to Log-file */
        return 6; /* terminate function with errorcode */
      } /* database-file not found */
      /* road-database may be missing */
      Lg.Msg("getDB004",dat.getPath()); /* print message: terminating */
      return -1; /* terminate NORMAL, but return marker */
    } /* severe error found */
    Lg.Skip(true); /* print empty line to log-file and screen */
    Lg.Msg("getDB005",txt,dat.getAbsolutePath()); /* print action-message */

    /* open database-file for input */
    cF = new TSFileX(TSFileX.FT$xdb,dat); /* create access-control of database-file */
    is = cF.open(false); /* and open file for input */
    if(is!=null) { /* open-error occurred */
      Lg.Skip(false); /* print empty line to log-file */
      Lg.Msg("getDB006",txt,is); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 7; /* terminate function with errorcode */
    } /* error while opening of database-file */

    cB = new TSBuf(cF); /* create inputbuffer and init counter */
    cc = ec = 0; /* init error-counter and current condition-code */
    bl: { /* block for error-break */
      is = cB.getKE(true); /* get first controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getDB021"); /* print errormessage */
          cc = 11; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getDB022",is); /* print errormessage */
        cc = 12; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getDB023"); /* print errormessage */
        cc = 13; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(!is.equals("trackdb")) { /* 'TrackDB' not found */
        Lg.Err("getDB024",is); /* print errormessage */
        cc = 14; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      l1 = cB.getBrL(); /* current bracket-level for terminate */
      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getDB025"); /* print errormessage */
          cc = 15; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getDB022",is); /* print errormessage */
        cc = 16; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getDB026"); /* print errormessage */
        cc = 17; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(!is.equals("serial")) { /* 'Serial' not found */
        Lg.Err("getDB027",is); /* print errormessage */
        cc = 18; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      i = (int)cB.getNV(); /* get value of 'Serial-Number' */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        Lg.Err("getDB028",is,cB.getStat(true)); /* print errormessage */
        cc = 19; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      Lg.Log("getDB029",i); /* print Serial-Number */
      cRte.setInt(4+typ,i); /* and store it */
      if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
        cc = 20; /* set current return-code to error */
        break bl; } /* terminate evaluation */

      /* pointer points after closing bracket of serial-number */
      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getDB030"); /* print errormessage */
          cc = 21; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getDB022",is); /* print errormessage */
        cc = 22; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getDB031"); /* print errormessage */
        cc = 23; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(!is.equals("tracknodes")) { /* 'TrackNodes' not found */
        Lg.Err("getDB032",is); /* print errormessage */
        cc = 24; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      w = (int)cB.getNV(); /* get number of expected entries */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        Lg.Err("getDB033",is,cB.getStat(true)); /* print errormessage */
        cc = 25; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      /* 'w' contains number of 'TrackNode'-definitions (expected) */
      l2 = cB.getBrL(); /* current bracket-level for terminate */
      Lg.Log("getDB034",txt,w); /* print number of track-Nodes */
      TrN = cRte.getTrN(typ,Math.max(w,1)); /* create TrackNode-Table */
      cRte.setInt(typ,w); /* and store 'last used' TrackNode-number */

      /* read all TrackNode-definitions */
      for(v=1;true;v+=1) { /* process all Track-Nodes */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getDB041",v); /* print errormessage */
            cc = 31; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getDB042",is,v); /* print errormessage */
          cc = 32; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) break; /* no more entries found */
        l3 = cB.getBrL(); /* current bracket-level for terminate */
        if(!is.equals("tracknode")) { /* 'TrackNode' not found */
          Lg.Err("getDB043",is,v); /* print errormessage */
          cc = 33; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        ix = (int)cB.getNV(); /* get number of node (first arg) */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getDB044",is,v,cB.getStat(true)); /* print errormessage */
          cc = 34; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        cTrN = new TSTrNde(ix); /* create dummy-entry (preliminary) */
          /* This entry is stored only, if an error occurs, so that the real
           * entry could not be created. Error-marker 'setMsk(22)'/'setMsk(23)'
           * are already set within this error-definition.
           */
        lp1: { /* inner break-loop (first one) */
          is = cB.getKE(true); /* get next controlword */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getDB051",null,ix,v); /* print errormessage */
              cc = 35; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getDB052",is,ix,v); /* print errormessage */
            ec += 1; /* count error */
            break lp1; } /* and terminate processing of entry */
          if(is.length()==0) { /* next keword not present */
            Lg.Err("getDB053",null,ix,v); /* print errormessage */
            ec += 1; /* count error */
            break lp1; } /* and terminate processing of entry */
          if(is.equals("trjunctionnode")) { /* Entry: 'TrJunctionNode' */
            cTrN = new TSTrNde(3,ix,1); /* next preliminary entry */
            i = (int)cB.getNV(); /* get first argument within definition */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getDB061",is,ix,v); /* print errormessage */
              cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
              ec += 1; /* count error */
              break lp1; } /* and terminate processing of entry */
            if(i!=0) /* plausibility-check of value -- not allowed */
              if(EnaW) Lg.Log("getDB062",""+i,ix,v); /* print errormessage */
            i = (int)cB.getNV(); /* get second argument: shape-value */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getDB063",is,ix,v); /* print errormessage */
              cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
              ec += 1; /* count error */
              break lp1; } /* and terminate processing of entry */
            if(i<0) { /* invalid shape-number */
              Lg.Err("getDB067",""+i,ix,v); /* print errormessage */
              cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
              ec += 1; /* count error */
              break lp1; } /* and terminate processing of entry */
            cNde = new TSVector(i,-1); /* create Node-Def. using shape, no section */
            i = (int)cB.getNV(); /* get third argument: manual operation */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getDB064",is,ix,v); /* print errormessage */
              cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
              ec += 1; /* count error */
              break lp1; } /* and terminate processing of entry */
            if(i==1) cTrN.setMsk(16); /* set marker: manual operation of switch */
            else if(i!=0) /* plausibility-check of value -- not allowed */
              if(EnaW) Lg.Log("getDB065",""+i,ix,v); /* print errormessage */
            if((is=getDBUid(cB,cNde,true))!=null) { /* error within UiD-definitionline found */
              Lg.Err("getDB066",is,ix,v); /* print errormessage */
              cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
              ec += 1; /* count error */
              break lp1; } /* and terminate processing of entry */
            cTrN.chgNde(0,cNde); /* insert new Node-Reference */
            if((is=getDBPins(cB,cTrN))!=null) { /* error found -- report it and terminate */
              Lg.Err("getDB066",is,ix,v); /* print errormessage */
              cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
              ec += 1; /* count error */
              break lp1; } /* and terminate processing of entry */
          } else if(is.equals("trendnode")) { /* Entry: 'TrEndNode' */
            cTrN = new TSTrNde(1,ix,1); /* next preliminary entry */
            cNde = new TSVector(-1,-1); /* create Node-Def., no shape, no section */
            if((is=getDBUid(cB,cNde,true))!=null) { /* error within UiD-definitionline found */
              Lg.Err("getDB071",is,ix,v); /* print errormessage */
              cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
              ec += 1; /* count error */
              break lp1; } /* and terminate processing of entry */
            cTrN.chgNde(0,cNde); /* insert new Node-Reference */
            if((is=getDBPins(cB,cTrN))!=null) { /* error found -- report it and terminate */
              Lg.Err("getDB071",is,ix,v); /* print errormessage */
              cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
              ec += 1; /* count error */
              break lp1; } /* and terminate processing of entry */
          } else if(is.equals("trvectornode")) { /* Entry: 'TrVectorNode' */
            is = cB.getKE(true); /* get next controlword */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getDB081",null,ix,v); /* print errormessage */
                cc = 36; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              Lg.Err("getDB082",is,ix,v); /* print errormessage */
              ec += 1; /* count error */
              break lp1; } /* and terminate processing of entry */
            if(is.length()==0) { /* next keword not present */
              Lg.Err("getDB083",null,ix,v); /* print errormessage */
              ec += 1; /* count error */
              break lp1; } /* and terminate processing of entry */
            if(!is.equals("trvectorsections")) { /* 'TrVectorSections' not found */
              Lg.Err("getDB084",is,ix,v); /* print errormessage */
              ec += 1; /* count error */
              break lp1; } /* and terminate processing of entry */
            sc = (int)cB.getNV(); /* get number of subentry-definitions */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getDB085",is,ix,v); /* print errormessage */
              ec += 1; /* count error */
              break lp1; } /* and terminate processing of entry */
            if(sc<1) { /* plausibility-check of value -- not allowed */
              Lg.Err("getDB086",""+sc,ix,v); /* print errormessage */
              ec += 1; /* count error */
              break lp1; } /* and terminate processing of entry */
            cTrN = new TSTrNde(2,ix,sc); /* next preliminary entry */
            for(si=0;si<sc;si+=1) { /* process all subentries */
              j = (int)cB.getNV(); /* get first argument (section-number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getDB087",is,ix,si); /* print errormessage */
                cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
                ec += 1; /* count error */
                break lp1; } /* and terminate processing of entry */
              if(j<0) { /* invalid value for section-number */
                Lg.Err("getDB08A",""+j,ix,si); /* print errormessage */
                cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
                ec += 1; /* count error */
                break lp1; } /* and terminate processing of entry */
              i = (int)cB.getNV(); /* get second argument (shape-number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getDB088",is,ix,si); /* print errormessage */
                cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
                ec += 1; /* count error */
                break lp1; } /* and terminate processing of entry */
              if(i<0) { /* invalid value for shape-number */
                Lg.Err("getDB08B",""+i,ix,si); /* print errormessage */
                cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
                ec += 1; /* count error */
                break lp1; } /* and terminate processing of entry */
              cNde = new TSVector(i,j); /* create Node-Def. using shape and section */
              if((is=getDBUid(cB,cNde,false))!=null) { /* error within UiD-def. found */
                Lg.Err("getDB089",is,ix,si); /* print errormessage */
                cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
                ec += 1; /* count error */
                break lp1; } /* and terminate processing of entry */
              cTrN.chgNde(si,cNde); /* insert new Node-Reference */
            } /* -for- process all subentries (si,sc) */
            if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
              cc = 37; /* set current return-code to error */
              break bl; } /* terminate evaluation */

            /* process TrItem-references and store them */
            is = cB.getKE(true); /* get next controlword */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getDB090",null,ix,v); /* print errormessage */
                cc = 38; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              Lg.Err("getDB082",is,ix,v); /* print errormessage */
              ec += 1; /* count error */
              break lp1; } /* and terminate processing of entry */
            if(is.length()!=0) { /* additional keword IS present */
              if(!is.equals("tritemrefs")) { /* 'TrItemRefs' not found */
                Lg.Err("getDB091",is,ix,v); /* print errormessage */
                cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
                ec += 1; /* count error */
                break lp1; } /* and terminate processing of entry */
              sc = (int)cB.getNV(); /* get number of references */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getDB092",is,ix,v); /* print errormessage */
                ec += 1; /* count error */
                break lp1; } /* and terminate processing of entry */
              if(sc>0) { /* number of references is correct -- read them */
                ItRfT = cTrN.getItm(sc); /* initialize memory for TrItem-references */
                if(ItRfT==null) { /* storage could not be allocated */
                  Lg.Err("getDB093",""+sc,ix,v); /* print errormessage */
                  cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
                  ec += 1; /* count error */
                  break lp1; } /* and terminate processing of entry */
                for(si=0;si<sc;si+=1) { /* read all TrItem-references */
                  is = cB.getKE(true); /* get next controlword */
                  if(is==null) { /* error found within current input */
                    if((is=cB.getErr())==null) { /* EOF within data */
                      Lg.Err("getDB094",""+v,ix,si); /* print errormessage */
                      cc = 39; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    Lg.Err("getDB095",is,ix,si); /* print errormessage */
                    ec += 1; /* count error */
                    break lp1; } /* and terminate processing of entry */
                  if(is.length()==0) { /* next keword not present */
                    Lg.Err("getDB096",null,ix,v); /* print errormessage */
                    cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
                    ec += 1; /* count error */
                    break; } /* and terminate processing of entry */
                  if(!is.equals("tritemref")) { /* 'TrItemRef' not found */
                    Lg.Err("getDB097",is,ix,si); /* print errormessage */
                    cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
                    ec += 1; /* count error */
                    break lp1; } /* and terminate processing of entry */
                  i = (int)cB.getNV(); /* get reference-number (TrItem) */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getDB098",is,ix,si); /* print errormessage */
                    cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
                    ec += 1; /* count error */
                    break lp1; } /* and terminate processing of entry */
                  if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                    cc = 40; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  cRef = new TSRefC(i); /* create reference-element */
                  ItRfT.add(cRef); /* and add it to list of references */
                } /* -for- process all TrItem-references (si,sc) */
                if((i=ItRfT.size())!=sc) { /* check number of TrItem-references */
                  Lg.Err("getDB099",""+i,ix,sc); /* print errormessage */
                  cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
                  ec += 1; /* count error */
                } /* integrity error found -- report it */
              } else { /* invalid number of references -- print message and ignore */
                Lg.Err("getDB09A",""+sc,ix,v); /* print errormessage */
                ec += 1; /* count error */
              } /* ignore input -- continue with next entry */
              if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                cc = 41; /* set current return-code to error */
                break bl; } /* terminate evaluation */
            } /* 'TrItemRef'-entries were present */
            if((is=getDBPins(cB,cTrN))!=null) { /* error found -- report it and terminate */
              Lg.Err("getDB080",is,ix,v); /* print errormessage */
              cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
              ec += 1; /* count error */
              break lp1; } /* and terminate processing of entry */
          } else { /* Unknown TrNode-type */
            Lg.Err("getDB054",is,ix,v); /* print errormessage */
            ec += 1; /* count error */
            break; } /* and terminate processing of entry */
          is = cB.getKE(false); /* get next controlword */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getDB055",null,ix,v); /* print errormessage */
              cc = 49; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getDB052",is,ix,v); /* print errormessage */
            ec += 1; /* count error */
            break lp1; } /* and terminate processing of entry */
          if(is.length()!=0) { /* additional keword present */
            Lg.Err("getDB056",is,ix,v); /* print errormessage */
            cTrN.setMsk(22); /* (pre)set error-marker (getDBF()) */
            ec += 1; /* count error */
          } /* and terminate processing of entry */
        } /* -lp1- end of break-block */
        TrN.add(cTrN); /* insert node into TrNode-list (in any case) */
        if(cB.skpFwd(l3)) { /* skip resuming data to new entry -- EOF/error found? */
          cc = 51; /* set current return-code to error */
          break bl; } /* terminate evaluation */
      } /* -for- process all TrackNodes (v) */

      if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getDB045"); /* print errormessage */
        cc = 54; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      /* 'v' contain the number of REALLY WRITTEN TrNode-entries (+1) */
      if((i=cRte.setInt(12+typ,w))!=Integer.MIN_VALUE) /* value already set -- replaced */
        Lg.Err("getDB047",""+typ,w,i); /* print errormessage */
      /* Attention: The number of actually present entries is written to the route-
       *            definition (Slot I.12 and I.13). So, the number of entries is available
       *            to the check-method. However, this entry is marked as 'volatile',
       *            because it is overwritten, if THIS method is called again.
       */

      /* OLD: Attention: An additional, special entry is written to the end of the
       * track-node-table, which contains the number of actually present entries instead
       * of the track-node-ID. This item is removed again later during check of table.
       * So, the number of entries is available to the check-method.
       */
      cTrN = new TSTrNde(w); /* create special entry using dummy-ID */
      TrN.add(cTrN); /* and add entry to TrackNode-table */
        /* Attention: There must be two entries using the SAME ID (Nr) now */

      v -= 1; /* adjust number, value now equals 'number of Nodes' */
      if(v!=w) Lg.Err("getDB046",null,w,v); /* print errormessage */

      /* --------------------------------------------------------------------------------
       * 2. Part: process TrItem-Table */
      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getDB101"); /* print errormessage */
          cc = 61; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getDB102",is); /* print errormessage */
        cc = 62; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Log("getDB103"); /* Print: TrItem-part of database not used */
        if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
          cc = 63; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        cc = -2; /* set current return-code to 'warning' */
        break bl; /* terminate evaluation */
      } /* TrItem-table is NOT defined (used) */

      if(!is.equals("tritemtable")) { /* 'TrItemTable' not found */
        Lg.Err("getDB104",is); /* print errormessage */
        cc = 65; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      w = (int)cB.getNV(); /* get number of TrItem-entries */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        Lg.Err("getDB105",is,cB.getStat(true)); /* print errormessage */
        cc = 66; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(w<1) { /* plausibility-check of value -- not allowed */
        Lg.Err("getDB111",w); /* print errormessage */
        cc = 67; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      /* 'w' contains number of TrItem-definitions (expected)
       *  process all entries of TrItem-table */
      l2 = cB.getBrL(); /* current bracket-level for terminate */
      ItT = cRte.getTrI(typ,w); /* create new TrItem-Tabelle and register it */
      Lg.Log("getDB106",txt,w); /* print number of entries (if allowed) */

      /**** read all 'TrItemTable'-Definitionen einlesen */
      for(v=0;true;v+=1) { /* process all 'TrItemTable'-entries */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getDB115",v); /* print errormessage */
            cc = 67; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getDB116",is,v,cB.getStat(true)); /* print errormessage */
          cc = 68; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) break; /* no more entries found */
        l3 = cB.getBrL(); /* current bracket-level for terminate */
        lp2: { /* break-loop */
          ec += 1; /* preset: error found -- count it */
          if(is.equals("emptyitem")) { /* valid type of entry -- process it */
            cIt = new TSTrItm(0,v); /* create basis-entry using dummy-ID */
            cIt.setMsk(2); /* set marker: 'Index' is used instead of 'TrItemID' */
            if((i=getItNr(cB,"'TrItem("+v+")-EmptyItem"))<0) break lp2; /* error in 'TrItemId' */
            cIt.setID(i,false); /* correct basis-entry: insert TrItem-ID and reset marker */
            ec -= 1; /* no error found -- decrement counter again */
          } else if(is.equals("signalitem")) { /* valid type of entry -- process it */
            cIt = new TSTrItm01(v); /* create basis-entry using dummy-ID */
            cIt.setMsk(2); /* set marker: 'Index' is used instead of 'TrItemID' */
            is = "'TrItem("+v+")-SignalItem"; /* create message-prefix */
            if((i=getItNr(cB,is))<0) break lp2; /* error found within 'TrItemId'-line */
            cIt.setID(i,false); /* correct basis-entry: insert TrItem-ID and reset marker */
            if((i=getItem(cB,cIt,TrN,"SignalItem("+i))>0) break lp2; /* error found within arguments */
            ec -= 1; /* no error found -- decrement counter again */
            if(i<0) { /* EOF found while reading data */
              cIt.setMsk(1); /* set marker: Error found within TrItem-Definition */
              cc = 71; /* set current return-code to error */
              break bl; } /* terminate evaluation */
         } else if(is.equals("platformitem")) { /* valid type of entry -- process it */
            cIt = new TSTrItm02(v); /* create basis-entry using dummy-ID */
            cIt.setMsk(2); /* set marker: 'Index' is used instead of 'TrItemID' */
            is = "'TrItem("+v+")-PlatformItem"; /* create message-prefix */
            if((i=getItNr(cB,is))<0) break lp2; /* error found within 'TrItemId'-line */
            cIt.setID(i,false); /* correct basis-entry: insert TrItem-ID and reset marker */
            if((i=getItem(cB,cIt,TrN,"PlatformItem("+i))>0) break lp2; /* error found within arguments */
            ec -= 1; /* no error found -- decrement counter again */
            if(i<0) { /* EOF found while reading data */
              cIt.setMsk(1); /* set marker: Error found within TrItem-Definition */
              cc = 72; /* set current return-code to error */
              break bl; } /* terminate evaluation */
         } else if(is.equals("sidingitem")) { /* valid type of entry -- process it */
            cIt = new TSTrItm03(v); /* create basis-entry using dummy-ID */
            cIt.setMsk(2); /* set marker: 'Index' is used instead of 'TrItemID' */
            is = "'TrItem("+v+")-SidingItem"; /* create message-prefix */
            if((i=getItNr(cB,is))<0) break lp2; /* error found within 'TrItemId'-line */
            cIt.setID(i,false); /* correct basis-entry: insert TrItem-ID and reset marker */
            if((i=getItem(cB,cIt,TrN,"SidingItem("+i))>0) break lp2; /* error found within arguments */
            ec -= 1; /* no error found -- decrement counter again */
            if(i<0) { /* EOF found while reading data */
              cIt.setMsk(1); /* set marker: Error found within TrItem-Definition */
              cc = 73; /* set current return-code to error */
              break bl; } /* terminate evaluation */
         } else if(is.equals("speedpostitem")) { /* valid type of entry -- process it */
            cIt = new TSTrItm04(v); /* create basis-entry using dummy-ID */
            cIt.setMsk(2); /* set marker: 'Index' is used instead of 'TrItemID' */
            is = "'TrItem("+v+")-SpeedpostItem"; /* create message-prefix */
            if((i=getItNr(cB,is))<0) break lp2; /* error found within 'TrItemId'-line */
            cIt.setID(i,false); /* correct basis-entry: insert TrItem-ID and reset marker */
            if((i=getItem(cB,cIt,TrN,"SpeedpostItem("+i))>0) break lp2; /* error found within arguments */
            ec -= 1; /* no error found -- decrement counter again */
            if(i<0) { /* EOF found while reading data */
              cIt.setMsk(1); /* set marker: Error found within TrItem-Definition */
              cc = 74; /* set current return-code to error */
              break bl; } /* terminate evaluation */
         } else if(is.equals("carspawneritem")) { /* valid type of entry -- process it */
            cIt = new TSTrItm(5,v); /* create basis-entry using dummy-ID */
            cIt.setMsk(2); /* set marker: 'Index' is used instead of 'TrItemID' */
            is = "'TrItem("+v+")-CarSpawnerItem"; /* create message-prefix */
            if((i=getItNr(cB,is))<0) break lp2; /* error found within 'TrItemId'-line */
            cIt.setID(i,false); /* correct basis-entry: insert TrItem-ID and reset marker */
            if((i=getItem(cB,cIt,TrN,"CarSpawnerItem("+i))>0) break lp2; /* error found within arguments */
            ec -= 1; /* no error found -- decrement counter again */
            if(i<0) { /* EOF found while reading data */
              cIt.setMsk(1); /* set marker: Error found within TrItem-Definition */
              cc = 75; /* set current return-code to error */
              break bl; } /* terminate evaluation */
         } else if(is.equals("levelcritem")) { /* valid type of entry -- process it */
            cIt = new TSTrItm(6,v); /* create basis-entry using dummy-ID */
            cIt.setMsk(2); /* set marker: 'Index' is used instead of 'TrItemID' */
            is = "'TrItem("+v+")-LevelCrItem"; /* create message-prefix */
            if((i=getItNr(cB,is))<0) break lp2; /* error found within 'TrItemId'-line */
            cIt.setID(i,false); /* correct basis-entry: insert TrItem-ID and reset marker */
            if((i=getItem(cB,cIt,TrN,"LevelCrItem("+i))>0) break lp2; /* error found within arguments */
            ec -= 1; /* no error found -- decrement counter again */
            if(i<0) { /* EOF found while reading data */
              cIt.setMsk(1); /* set marker: Error found within TrItem-Definition */
              cc = 76; /* set current return-code to error */
              break bl; } /* terminate evaluation */
         } else if(is.equals("hazzarditem")) { /* valid type of entry -- process it */
            cIt = new TSTrItm(7,v); /* create basis-entry using dummy-ID */
            cIt.setMsk(2); /* set marker: 'Index' is used instead of 'TrItemID' */
            is = "'TrItem("+v+")-HazzardItem"; /* create message-prefix */
            if((i=getItNr(cB,is))<0) break lp2; /* error found within 'TrItemId'-line */
            cIt.setID(i,false); /* correct basis-entry: insert TrItem-ID and reset marker */
            if((i=getItem(cB,cIt,TrN,"HazzardItem("+i))>0) break lp2; /* error found within arguments */
            ec -= 1; /* no error found -- decrement counter again */
            if(i<0) { /* EOF found while reading data */
              cIt.setMsk(1); /* set marker: Error found within TrItem-Definition */
              cc = 77; /* set current return-code to error */
              break bl; } /* terminate evaluation */
         } else if(is.equals("pickupitem")) { /* valid type of entry -- process it */
            cIt = new TSTrItm08(v); /* create basis-entry using dummy-ID */
            cIt.setMsk(2); /* set marker: 'Index' is used instead of 'TrItemID' */
            is = "'TrItem("+v+")-PickupItem"; /* create message-prefix */
            if((i=getItNr(cB,is))<0) break lp2; /* error found within 'TrItemId'-line */
            cIt.setID(i,false); /* correct basis-entry: insert TrItem-ID and reset marker */
            if((i=getItem(cB,cIt,TrN,"PickupItem("+i))>0) break lp2; /* error found within arguments */
            ec -= 1; /* no error found -- decrement counter again */
            if(i<0) { /* EOF found while reading data */
              cIt.setMsk(1); /* set marker: Error found within TrItem-Definition */
              cc = 78; /* set current return-code to error */
              break bl; } /* terminate evaluation */
         } else if(is.equals("soundregionitem")) { /* valid type of entry -- process it */
            cIt = new TSTrItm09(v); /* create basis-entry using dummy-ID */
            cIt.setMsk(2); /* set marker: 'Index' is used instead of 'TrItemID' */
            is = "'TrItem("+v+")-SoundRegionItem"; /* create message-prefix */
            if((i=getItNr(cB,is))<0) break lp2; /* error found within 'TrItemId'-line */
            cIt.setID(i,false); /* correct basis-entry: insert TrItem-ID and reset marker */
            if((i=getItem(cB,cIt,TrN,"SoundRegionItem("+i))>0) break lp2; /* error found within arguments */
            ec -= 1; /* no error found -- decrement counter again */
            if(i<0) { /* EOF found while reading data */
              cIt.setMsk(1); /* set marker: Error found within TrItem-Definition */
              cc = 79; /* set current return-code to error */
              break bl; } /* terminate evaluation */
         } else if(is.equals("crossoveritem")) { /* valid type of entry -- process it */
            cIt = new TSTrItm10(v); /* create basis-entry using dummy-ID */
            cIt.setMsk(2); /* set marker: 'Index' is used instead of 'TrItemID' */
            is = "'TrItem("+v+")-CrossoverItem"; /* create message-prefix */
            if((i=getItNr(cB,is))<0) break lp2; /* error found within 'TrItemId'-line */
            cIt.setID(i,false); /* correct basis-entry: insert TrItem-ID and reset marker */
            if((i=getItem(cB,cIt,TrN,"CrossoverItem("+i))>0) break lp2; /* error found within arguments */
            ec -= 1; /* no error found -- decrement counter again */
            if(i<0) { /* EOF found while reading data */
              cIt.setMsk(1); /* set marker: Error found within TrItem-Definition */
              cc = 81; /* set current return-code to error */
              break bl; } /* terminate evaluation */
          } else { /* unknown TrItem-type process as error-type */
            /* A unknown TrItem is handled as if it is a 'EmptyItem' (preliminary) */
            cIt = new TSTrItm(0,v); /* create basis-entry using dummy-ID */
            cIt.setMsk(0); /* set marker: TrItem is NOT valid */
            cIt.setMsk(1); /* set marker: TrItem contains error(s) */
            cIt.setMsk(2); /* set marker: 'Index' is used instead of 'TrItemID' */
            Lg.Err("getDB117",is,v); /* print errormessage */
            /* error-counter is already correct */
          } /* unknown TrItem-type found */
        } /* -lp2- end of break-block */
        ItT.add(cIt); /* add new TrItem to table (in any case) */
        if(cB.skpFwd(l3)) { /* skip resuming data to new entry -- EOF/error found? */
          Lg.Err("getDB113",v); /* print errormessage */
          cc = 69; /* set current return-code to error */
          break bl; } /* terminate evaluation */
      } /* -for- process all TrItem-entries of the 'TrItemTable' */
      if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getDB107"); /* print errormessage */
        cc = 91; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      /* 'v' contain the number of REALLY WRITTEN TrItem-entries */
      if(v!=w) Lg.Err("getDB112",null,w,v); /* print errormessage */
      cIt = new TSTrItm(0,w); /* create special entry using dummy-ID */
      cIt.setMsk(0); /* set marker: TrItem is NOT valid */
      ItT.add(cIt); /* and add entry to TrItem-table */
//      ItT.trimToSize(); /* reorganize memory for TrItem-table */

      /* TrItemTable is fully peocessed now */
      is = cB.getKE(false); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getDB009",txt); /* print errormessage */
          cc = 92; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getDB006",txt,is); /* print errormessage */
        cc = 93; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()!=0) { /* additional keword present */
        Lg.Err("getDB201",txt,is); /* print errormessage */
        cc = 94; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getDB009",txt); /* print errormessage */
        cc = 95; /* set current return-code to error */
      } /* terminate evaluation */
    } /* -bl- break-block used in case of error */
    is = cF.close(); /* Eingabe-Datei schliessen */
    if(is!=null) Lg.Err("getDB006",txt,is); /* print errormessage */

    if(cc>0) { /* error occured while database is loaded */
      Lg.Skip(true); /* print empty line to LOG-file and screen */
      Lg.Msg("getDB008",txt,dat.getPath(),""+cc);
      Lg.Close(); /* close output to Log-file */
      return cc; /* terminate function with errorcode */
    } /* terminating error occurred */
    if(ec>0) Lg.Log("getDB007",txt,ec,0); /* print message */
    return cc; /* leave method and return recent error */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getITF"
  * Laden der Schienen- oder Strassendatenbank (IT) und Syntax pruefen
  * ##getITF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getITF( /* Schienen/Strassen-Datenbank laden */
   TSRoute cRte, /* Routendefinition mit Basisverzeichnis */
   int     typ)  /* Typ der Datenbank (0-TDB,1-RDB) */
   {
   /*-----------------------------------------------------------------*/
    File       dat;    /* Inputfile */
    TSFileX    cF;     /* current database-file (input) */
    TSBuf      cB;     /* current input-buffer for 'read file' */
    TSTrItm    cIt;    /* current TrItem-object */
    TSTrItm01T cTrItD; /* reference to TrackNode (TrSignalDir) */
    TSRefC     cRef;   /* reference-object to TrItem */
    TSQPos     cPos;   /* current position (extended) */
    int        i,j,v,w,ix,l2,l3,l4,si,sc,cc,ec;
    double     f,fx,fy,fz; /* intermediate values */
    String     is,txt; /* intermediate values */
    ArrayList<TSTrItm01T> TrItD; /* TrSignal(R)Dir-Table */
   /*=================================================================*/
    if(typ<0 || typ>1) { /* unknown type of database */
      Lg.Err("getDB001",typ); /* Fehlermeldung ausgeben */
      return 4; } /* Bearbeitung beenden */
    txt = TSLogg.getKey("getDB01"+typ); /* Beschreibung fuer Datenbank */
    dat = cRte.getFile(typ+8); /* Dateiname zum Laden holen */
    if(dat==null) throw new IllegalStateException( /* Sicherheitsabfrage */
      TSLogg.getMsg("Msg908","File==null","TSUtil.getITF()",0));
    if((i=cRte.get$TrI(typ))<0) { /* TrItembereich fehlt */
      Lg.Skip(true); /* Leerzeile loggen */
      /* Datenbank kann (eventuell) fehlen */
      Lg.Msg("getDB012",txt,dat.getPath()); /* Abbruch melden */
      return -1; /* System NORMAL, jedoch mit Kennzeichen beenden */
    } /* TrItem-Bereich existiert nicht */

    if(dat.isDirectory()) { /* es liegt keine Datei vor */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getDB002",txt,dat.getPath()); /* Meldung */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datei existiert nicht */
    if(!dat.exists()) { /* Datei existiert nicht */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getDB013",txt,dat.getPath()); /* Abbruch melden */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datei existiert nicht */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("getDB005",txt,dat.getAbsolutePath()); /* Meldung */

    /* Datenbank-Datei fuer Eingabe oeffnen */
    cF = new TSFileX(TSFileX.FT$xit,dat); /* Eingabe-Steuerung erstellen */
    is = cF.open(false); /* Datei fuer Eingabe oeffnen */
    if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("getDB006",txt,is); /* Meldung ueber Abbruch */
      Lg.Close(); /* close output to Log-file */
      return 7; /* terminate function with errorcode */
    } /* Fehler beim Oeffnen der Datenbank-Datei */

    cB = new TSBuf(cF); /* create inputbuffer and init counter */
    cc = ec = 0; /* init error-counter and current condition-code */
    bl: { /* block for error-break */
      is = cB.getKE(true); /* get first controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getDB101"); /* print errormessage */
          cc = 61; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getDB102",is); /* print errormessage */
        cc = 62; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getDB109"); /* print errormessage */
        cc = 63; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      /* process TrItem-table */
      if(!is.equals("tritemtable")) { /* 'TrItemTable' not found */
        Lg.Err("getDB104",is); /* print errormessage */
        cc = 65; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      w = (int)cB.getNV(); /* get number of TrItem-entries */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        Lg.Err("getDB105",is,cB.getStat(true)); /* print errormessage */
        cc = 66; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      l2 = cB.getBrL(); /* current bracket-level for terminate */
      /* process all 'TrItemTable'-definitions */
      for(v=0;true;v+=1) { /* get all TrItem-entries and process them */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getDB115",v); /* print errormessage */
            cc = 67; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getDB116",is,v,cB.getStat(true)); /* print errormessage */
          cc = 68; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) break; /* no more entries found */
        l3 = cB.getBrL(); /* current bracket-level for terminate */
        lp2: { /* break-loop */
          ec += 1; /* preset: error found -- count it */
          if(is.equals("signalitem")) { /* valid type of entry -- process it */
            is = "'TrItem("+v+")-SignalItem"; /* create message-prefix */
            if((ix=getItNr(cB,is))<0) break lp2; /* error found within 'TrItemId'-line */
            cRef = new TSRefC(ix); /* create reference-object for signalitem */
            cIt = cRte.fndTrI(typ,cRef); /* find requested item within TrItem-table */
            if(cIt==null) { /* entry was NOT found */
              Lg.Err("getDB211",txt,v,ix); /* print errormessage */
              break lp2; } /* and terminate processing of entry */
            if(!(cIt instanceof TSTrItm01)) { /* current type of item is NOT correct */
              Lg.Err("getDB212",txt,""+v,""+ix,cIt.getName()); /* print errormessage */
              break lp2; } /* and terminate processing of entry */
            lp21:while(true) { /* process all subtypes of the current entry */
              is = cB.getKE(true); /* get next controlword */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getDB213",null,v,ix); /* print errormessage */
                  cc = 101; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getDB214",is,v,ix); /* print errormessage */
                break lp2; } /* and terminate processing of entry */
              if(is.length()==0) break; /* no more entries found */
              l4 = cB.getBrL(); /* current bracket-level for terminate */
              if(is.equals("trsignaldirs")) { /* Type of line: 'TrSignalDirs' */
                sc = (int)cB.getNV(); /* get number of SignalDir-entries */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  Lg.Err("getDB215",is,v,ix,cB.getStat(true)); /* print errormessage */
                  break lp2; } /* and terminate processing of entry */
                TrItD = ((TSTrItm01)cIt).getSgD(0); /* get current Signal(R)Dir-Table */
                si = (TrItD==null) ? -1 : TrItD.size(); /* get current number of entries */
                if(si!=sc) { /* current number of references DO NOT match */
                  Lg.Err("getDB216",""+sc+","+si,v,ix); /* print errormessage */
                  break lp2; } /* and terminate processing of entry */
                for(si=0;si<sc;si+=1) { /* process all 'TrSignal(R)Dir'-entries */
                  is = cB.getKE(true); /* get first controlword */
                  if(is==null) { /* error found within current input */
                    if((is=cB.getErr())==null) { /* EOF within data */
                      Lg.Err("getDB217",""+si,v,ix); /* print errormessage */
                      cc = 102; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    Lg.Err("getDB218",is,v,ix,si); /* print errormessage */
                    break lp21; } /* and terminate processing of sub-entry */
                  if(is.length()==0) { /* next keword not present */
                    Lg.Err("getDB219",""+si,v,ix); /* print errormessage */
                    break lp21; } /* and terminate processing of sub-entry */
                  if(!is.equals("trsignalrdir")) { /* 'TrSignalRDir' not found */
                    Lg.Err("getDB220",is,v,ix,si); /* print errormessage */
                    break lp21; } /* and terminate processing of sub-entry */
                  if((cTrItD=TrItD.get(si))==null) { /* Reference to TrackNode missing */
                    Lg.Err("getDB221",""+si,v,ix); /* print errormessage */
                    break lp21; } /* and terminate processing of sub-entry */
                  /* load and check the next position-values (x,y,z) */
                  if((is=chkPos(cB,null,null))!=null) { /* error within position found */
                    Lg.Err("getDB222",is,v,ix,si); /* print errormessage */
                    break lp21; } /* and terminate processing of sub-entry */
                  i = (int)cB.getNV(); /* get value of QX-Coordinate */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getDB223",is,v,ix,si); /* print errormessage */
                    break lp21; } /* and terminate processing of sub-entry */
                  j = (int)cB.getNV(); /* get value of QZ-Coordinate */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getDB224",is,v,ix,si); /* print errormessage */
                    break lp21; } /* and terminate processing of sub-entry */
                  cPos = new TSQPos(i,j,(TSPos)RetVal); /* create position-object */
                  if((cPos=cTrItD.setPos(cPos))!=null) { /* save data, is it already set? */
                    Lg.Err("getDB225",""+si,v,ix); /* print errormessage */
                    break lp21; } /* and terminate processing of sub-entry */
                  f = cB.getFV(); /* get distance-value */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getDB226",is,v,ix,si); /* print errormessage */
                    break lp21; } /* and terminate processing of sub-entry */
                  if(!Double.isNaN(f=cTrItD.chgDir(f))) { /* save data, is it already set? */
                    Lg.Err("getDB227",""+f,v,ix,si); /* print errormessage */
                    break lp21; } /* and terminate processing of sub-entry */
                  if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                    Lg.Err("getDB228",""+si,v,ix); /* print errormessage */
                    cc = 103; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                } /* -for- process all 'TrSignal(R)Dir'-entries (only one) */
              } /* process 'TrSignalDirs'-entries ONLY */
              if(cB.skpFwd(l4)) { /* skip resuming data to new entry -- EOF/error found? */
                Lg.Err("getDB230",txt,v,ix); /* print errormessage */
                cc = 104; /* set current return-code to error */
                break bl; } /* terminate evaluation */
            } /* -lp21- process all subtypes of the current entry */
          } else { /* all other allowed types of TrItem-definitions */
            si = TSTrItm.setTyp(is); /* check if entry-type is allowed */
            if(si<0) { /* invalid type of TrItem-entry */
              Lg.Err("getDB117",is,v); /* invalid type -- print errormessage */
              break lp2; } /* and terminate processing of entry */
            is = TSTrItm.getName(si); /* get description of TrItem-type */
            if((ix=getItNr(cB,"'TrItem("+v+")-"+is))<0) break lp2; /* error found? */
            cRef = new TSRefC(ix); /* create reference-object for current item */
            cIt = cRte.fndTrI(typ,cRef); /* find requested item within TrItem-table */
            if(cIt==null) { /* entry was NOT found */
              Lg.Err("getDB240",txt,""+v,""+ix,is); /* print errormessage */
              break lp2; } /* and terminate processing of entry */
            if(cIt.getTyp()!=si) { /* requested type of TrItem do not match */
              Lg.Err("getDB241",txt,""+v,""+ix,is,cIt.getName()); /* print errormessage */
              break lp2; } /* and terminate processing of entry */
          } /* all types of TrItem-definitions processed */
          ec -= 1; /* no error found -- decrement counter again */
        } /* -lp2- end of break-block (used in case of error) */
        if(cB.skpFwd(l3)) { /* skip resuming data to new entry -- EOF/error found? */
          Lg.Err("getDB113",v); /* print errormessage */
          cc = 69; /* set current return-code to error */
          break bl; } /* terminate evaluation */
      } /* all TrItem-entries are successfully processed */
      if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getDB107"); /* print errormessage */
        cc = 91; /* set current return-code to error */
        break bl; } /* terminate evaluation */
    } /* -bl- break-block used in case of error */
    is = cF.close(); /* close input-file again */
    if(is!=null) Lg.Err("getDB006",txt,is); /* print errormessage */

    if(cc>0) { /* Fehler beim Laden der Datenbank */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getDB008",txt,dat.getPath(),""+cc);
      Lg.Close(); /* close output to Log-file */
      return cc; /* terminate function with errorcode */
    } /* Funktionsfehler */
    if(ec>0) Lg.Log("getDB007",txt,ec); /* print message */
    return 0; /* leave method and return recent error (none) */
  }

 /**. <pre>
  *=====================================================================
  * Method "getDBUid"
  * Reading of an UiD-Definition from Track-/Road-database
  * Method is called from within: 'getDBF()'
  * ##getDBUid (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getDBUid( /* get current UiD-Definition */
   TSBuf    cB,   /* definiton of current input-buffer */
   TSVector cNde, /* current vector-node */
   boolean  v)    /* marker: prefix and line-change requested */
   {
   /*-----------------------------------------------------------------*/
    TSQPos cPos;     /* current (extended) position */
    int    i,qx,qz;  /* intermediate value(s) */
    double fa,fb,fc; /* intermediate value(s) */
    String is;       /* intermediate value(s) */
   /*=================================================================*/
    if(v) { /* process first running as requested */
      if(cB.skpFwd()) return TSLogg.getKey("getDBU01"); /* error-return */
        /* skip resuming data to new entry -- EOF/error found? */
      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) return TSLogg.getKey("getDBU02");
          /* EOF within data -- return with error-marker */
        return TSLogg.getMsg("getDBU00",is); /* Keyword (UID) not found */
      } /* error found within current input */
      if(is.length()==0) return TSLogg.getKey("getDBU03"); /* no value */
      if(!is.equals("uid")) return TSLogg.getMsg("getDBU04",is);
        /* no 'UiD'-entry found -- report error */
    } /* first running fully processed */
    qx = (int)cB.getNV(); /* get first part of UID-definition */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getDBU05",is);
      /* error while evaluating: Qx(Uid) missing */
    qz = (int)cB.getNV(); /* get second part of UID-definition */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getDBU06",is);
      /* error while evaluating: Qz(Uid) missing */
    i = (int)cB.getNV(); /* get third part of UID-definition */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getDBU07",is);
      /* error while evaluating: 'Uid' missing */
    if(i<0) return TSLogg.getMsg("getDBU08",i); /* UiD is invalid */
    if((is=cNde.setID(qx,qz,i))!=null) return TSLogg.getMsg("getDBU09",is);
      /* insert UID into Node-definition, return if error occurrs */

    qx = (int)cB.getNV(); /* get connection-value 'Start/Single' */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getDBU10",is);
      /* error while evaluating: value missing */
    qz = i = -1; /* Default */
    if(!v) { /* more values are defined -- get them */
      qz = (int)cB.getNV(); /* get second value */
      if((is=cB.getErr())!=null) return TSLogg.getMsg("getDBU11",is);
        /* error while evaluating: value missing */
      i = cB.getHV(2); /* get hex-version of third connection-value */
      if((is=cB.getErr())!=null) return TSLogg.getMsg("getDBU12",is);
        /* error while evaluating: value missing */
    } /* all connection-values are processed -- store them */
    if((is=cNde.setConn(qx,qz,i))!=null) return TSLogg.getMsg("getDBU13",is);

    /* load position-values (qx qz x y z) and check them */
    if((is=getPos(cB,true,true))!=null) return TSLogg.getMsg("getDBU14",is);
    cPos = (TSQPos)RetVal; /* get created position-definition */
    if((cPos=cNde.setPos(cPos))!=null) /* insert new position-definition */
      return TSLogg.getMsg("getDBU15",cPos.getPos(0));

    /* load direction-values (NOT QDIRECTION) and store them */
    fa = cB.getFV(); /* get first direction-value */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getDBU16",is);
    fb = cB.getFV(); /* get second direction-value */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getDBU17",is);
    fc = cB.getFV(); /* get third direction-value */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getDBU18",is);
    if((is=cNde.setDir(fa,fb,fc))!=null) return TSLogg.getMsg("getDBU13",is);
    return null; /* OK -- return without error */
  }

 /**. <pre>
  *=====================================================================
  * Method "getDBPins"
  * Lesen von Node-Verkettungen aus der Schienen-/Strassen-Datenbank
  * Wird ausschliesslich in 'getDBF()' benutzt!
  * ##getDBPins (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getDBPins( /* extract Node-references */
   TSBuf   cB,   /* definiton of current input-buffer */
   TSTrNde cTrN) /* currente Node-definition */
   {
   /*-----------------------------------------------------------------*/
    TSRefC cRef;         /* intermediate value */
    int    i,j,ci,cc,l1; /* intermediate value */
    String is,msg;       /* intermediate value */
   /*=================================================================*/
    if(cB.skpFwd()) return TSLogg.getKey("getDBP01"); /* error-return */
      /* skip resuming data to new entry -- EOF/error found? */
    is = cB.getKE(true); /* get next controlword */
    if(is==null) { /* error found within current input */
      if((is=cB.getErr())==null) return TSLogg.getKey("getDBP02");
        /* EOF within data -- return with error-marker */
      return TSLogg.getMsg("getDBP03",is); /* Keyword not found */
    } /* error found within current input */
    if(is.length()==0) return TSLogg.getKey("getDBP04"); /* no value */
    if(!is.equals("trpins")) return TSLogg.getMsg("getDBP05",is);
      /* no 'TrPins'-entry found -- report error */
    i = (int)cB.getNV(); /* get number of predecessor nodes */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getDBP06",is);
      /* error while evaluating: value missing */
    cc = (int)cB.getNV(); /* get number of successor nodes */
    if((is=cB.getErr())!=null) return TSLogg.getMsg("getDBP07",is);
      /* error while evaluating: value missing */
    cc += i; /* compute complete number of referenced nodes */
    if((is=cTrN.setTyp(cc,i))!=null) return TSLogg.getMsg("getDBP08",is);
      /* number of references do not match type of node */
    l1 = cB.getBrL(); /* current bracket-level for terminate ('TrPins') */
    msg = null; /* preset: no '0-error' found */
    for(ci=0;ci<cc;ci+=1) { /* check all connection-references */
      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) return TSLogg.getMsg("getDBP09",ci);
          /* EOF within data -- return with error-marker */
        return TSLogg.getMsg("getDBP10",is,ci); /* Keyword not found */
      } /* error found within current input */
      if(is.length()==0) return TSLogg.getMsg("getDBP11",ci);
      if(!is.equals("trpin")) return TSLogg.getMsg("getDBP12",is,ci);
        /* no entry 'TrPin' -- keyword missing -- report error */
      i = (int)cB.getNV(); /* get number of referenced node */
      if((is=cB.getErr())!=null) return TSLogg.getMsg("getDBP13",is,ci);
        /* error while evaluating: reference-number missing */
      if(i<0) return TSLogg.getMsg("getDBP14",null,ci,i); /* invalid */
      j = (int)cB.getNV(); /* get reference-flag (0/1) (=position) */
        /* 1 = connection to START of node(-chain)
         * 0 = connection to END of node(-chain) */
      if((is=cB.getErr())!=null) return TSLogg.getMsg("getDBP15",is,ci);
        /* error while evaluating: reference-flag missing */
      if(j<0 || j>1) return TSLogg.getMsg("getDBP16",null,ci,j); /* no flag */
      cRef = new TSRefC(i); /* create TrNode-connection */
      cRef.chgIx(j); /* and insert reference-flag */
      if(i==0) { /* 0-Reference found (= no valid connection exists) -- process it */
        cTrN.setMsk(ci); /* insert marker for 0-Reference */
        if(cc<3) /* Invalid reference -- report it */
          msg = TSLogg.getMsg("getDBP25",null,ci,cc); /* set message */
            /* error only occurrs with TrEnd- and TrVector-Nodes */
      } /* 0-Reference found */
      if((cRef=cTrN.chgTrN(ci,cRef))!=null) /* insert reference, already set? */
        return TSLogg.getMsg("getDBP17",null,ci,cRef.chgNr(Integer.MIN_VALUE));
      if(cB.skpFwd()) return TSLogg.getMsg("getDBP18",ci); /* error-return */
        /* skip resuming data to new entry -- EOF/error found? */
    } /* process all TrPin-entries */
    is = cB.getKE(true); /* get next controlword */
    if(is==null) { /* error found within current input */
      if((is=cB.getErr())==null) return TSLogg.getKey("getDBP19");
        /* EOF within data -- return with error-marker */
      return TSLogg.getMsg("getDBP20",is); /* Keyword not possible */
    } /* error found within current input */
    if(is.length()!=0) return TSLogg.getMsg("getDBP21",is);
      /* additional keyword found although NOT expected -- invalid */
    if(cB.skpFwd(l1)) return TSLogg.getKey("getDBP22"); /* error-return */
      /* skip resuming data to new entry -- EOF/error found? */
    return msg; /* return with error-marker (if set) */
  }

 /**. <pre>
  *=====================================================================
  * Method "getItNr"
  * Check TrItemID of a TrItem-table-entry and return ID
  * Method returns a value <0 if an error is found
  * Method used within: 'getDBF()', 'getITF()'
  * ##getItNr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getItNr( /* check TrItemId */
   TSBuf  cB,  /* definiton of current input-buffer */
   String txt) /* description of requested node (message-id) */
   {
   /*-----------------------------------------------------------------*/
    int    i;  /* intermediate value */
    String is; /* intermediate value */
   /*=================================================================*/
    is = cB.getKE(true); /* get next controlword */
    if(is==null) { /* error found within current input */
      if((is=cB.getErr())==null) { /* EOF within data */
        Lg.Err("getItNr1",txt); /* print errormessage */
        return -6; } /* terminate evaluation */
      Lg.Err("getItNr2",txt,is); /* print errormessage */
      return -7; } /* terminate evaluation */
    if(is.length()==0) { /* next keword not present */
      Lg.Err("getItNr3",txt); /* print errormessage */
      return -8; } /* terminate evaluation */
    if(!is.equals("tritemid")) { /* 'TrItemId' not found */
      Lg.Err("getItNr4",txt,is); /* print errormessage */
      return -9; } /* terminate evaluation */
    i = (int)cB.getNV(); /* get value of TrItemID */
    if((is=cB.getErr())!=null) { /* error while evaluating */
      Lg.Err("getItNr5",txt,is); /* print errormessage */
      return i; } /* terminate evaluation */
    is = cB.getKE(false); /* try next controlword */
    if(is==null) { /* error found within current input */
      if((is=cB.getErr())==null) { /* EOF within data */
        Lg.Err("getItNr6",txt); /* print errormessage */
        return -10; } /* terminate evaluation */
      Lg.Err("getItNr7",txt,is); /* print errormessage */
      return -11; } /* terminate evaluation */
    if(is.length()!=0) { /* additional keword found */
      Lg.Err("getItNr8",txt,is); /* print errormessage */
      return -12; } /* terminate evaluation */
    if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
      Lg.Err("getItNr9",txt); /* print errormessage */
      return -13; } /* terminate evaluation */
    return i; /* no error found -- return 'TrItemID' */
  }

 /**. <pre>
  *=====================================================================
  * Method "getItem"
  * Check Arguments of a TrItem-Entry and fill TrItem-object
  * Result: <0 if EOF found, ==0 if OK, >0 else
  * Method is called from: 'getDBF()'
  * ##getItem (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getItem( /* check arguments of TrItem-entries */
   TSBuf              cB,  /* definiton of current input-buffer */
   TSTrItm            cIt, /* current TrItem-definition */
   ArrayList<TSTrNde> TrN, /* Reference-table of TrackNodes */
   String             txt) /* description of TrItem-Node (message-id) */
   {
   /*-----------------------------------------------------------------*/
    TSQPos            cPos;   /* current extended position */
    TSTrItm01T        cTrItD; /* TrackNode-reference (TrSignalDir) */
    TSTrNde           cTrN;   /* current Track-Node-Element (search) */
    int               i,j,k;  /* intermediate value */
    String            is;     /* intermediate value */
    double            fx,fz;  /* intermediate value */
    Iterator<TSTrNde> cI;     /* Track-Node - iterator */
    ArrayList<TSTrItm01T> TrItD; /* TrSignal(R)Dir-Tabelle */
   /*=================================================================*/
    loop:do { /* process all definitionlines of the TrItem-entry */
      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getItm01",txt); /* print errormessage */
          return -1; } /* terminate evaluation */
        Lg.Err("getItm02",txt,is); /* print errormessage */
        return -2; /* terminate evaluation */
      } /* error found within current input */
      if(is.length()==0) return 0; /* all lines successfully read */
      if(is.equals("tritemsdata")) { /* Type of line: 'S-Data' */
        fx = cB.getFV(); /* get value of offset */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItm11",txt,is); /* print errormessage */
          if(Double.isNaN(fx)) return -11; /* terminate function (EOL) */
          return 11; } /* terminate function and return with signal */
        if(fx<0.0) { /* invalid value for Offset */
          Lg.Err("getItm12",txt,fx); /* print errormessage */
          return 12; } /* terminate function and return with signal */
        i = cB.getHV(8); /* get optionmask from line */
        if((is=cB.getErr())!=null) { /* error while evaluating hex-number */
          Lg.Err("getItm13",txt,is); /* print errormessage */
          return 13; } /* terminate function and return with signal */
        if(cIt.setDta(fx,i)) /* save data, is it already set? */
          Lg.Err("getItm14",txt,""+fx,i); /* print errormessage */
        cIt.setMsk(17); /* mark: definitionline is successfully processed */
      } else if(is.equals("tritempdata")) { /* Type of line: 'P-Data' */
        fx = cB.getFV(); /* get value of X-coordinate */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItm21",txt,is); /* print errormessage */
          return 21; } /* terminate function and return with signal */
        if(fx< -1024.0 || fx>1024.0) { /* invalid coordinate */
          Lg.Err("getItm22",txt,fx); /* print errormessage */
          return 22; } /* terminate function and return with signal */
        fz = cB.getFV(); /* get value of Z-coordinate */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItm23",txt,is); /* print errormessage */
          return 23; } /* terminate function and return with signal */
        if(fz< -1024.0 || fz>1024.0) { /* invalid coordinate */
          Lg.Err("getItm24",txt,fz); /* print errormessage */
          return 24; } /* terminate function and return with signal */
        i = (int)cB.getNV(); /* get value of QX-Coordinate */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItm25",txt,is); /* print errormessage */
          return 26; } /* terminate function and return with signal */
        j = (int)cB.getNV(); /* get value of QZ-Coordinate */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItm26",txt,is); /* print errormessage */
          return 27; } /* terminate function and return with signal */
        cPos = new TSQPos(i,j,new TSPos(fx,0.0,fz)); /* create position-object */
        if((is=cIt.setPos(1,cPos))!=null) { /* save data, is it already set? */
          Lg.Err("getItm29",txt,is); /* print errormessage */
          return 28; } /* terminate function and return with signal */
        cIt.setMsk(18); /* mark: definitionline is successfully processed */
      } else if(is.equals("tritemrdata")) { /* Type of line: 'R-Data' */
        /* load and check the next position-values (x,y,z) */
        if((is=chkPos(cB,null,null))!=null) { /* error within position found */
          Lg.Err("getItm39",txt,is); /* print errormessage */
          return 31; } /* terminate function and return with signal */
        i = (int)cB.getNV(); /* get value of QX-Coordinate */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItm31",txt,is); /* print errormessage */
          return 32; } /* terminate function and return with signal */
        j = (int)cB.getNV(); /* get value of QZ-Coordinate */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItm32",txt,is); /* print errormessage */
          return 33; } /* terminate function and return with signal */
        cPos = new TSQPos(i,j,(TSPos)RetVal); /* create position-object */
        if((is=cIt.setPos(0,cPos))!=null) { /* save data, is it already set? */
          Lg.Err("getItm39",txt,is); /* print errormessage */
          return 34; } /* terminate function and return with signal */
        cIt.setMsk(19); /* mark: definitionline is successfully processed */
      } else if(is.equals("trsignaltype")) { /* Type of line: 'TrSignalType' */
        if(cIt.chkTyp(2)) break loop; /* Subtyp-entry is not allowed here */
          /* 2 = (1<<1) - 'SignalItem' */
        i = cB.getHV(8); /* get optionmask of 'SignalItems' from line */
        if((is=cB.getErr())!=null) { /* error while evaluating hex-number */
          Lg.Err("getItm41",txt,is); /* print errormessage */
          return 41; } /* terminate function and return with signal */
        j = (int)cB.getNV(); /* get next value */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItm42",txt,is); /* print errormessage */
          return 42; } /* terminate function and return with signal */
        fx = cB.getFV(); /* get next value from 'SignalItem' */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItm43",txt,is); /* print errormessage */
          return 43; } /* terminate function and return with signal */
        is = cB.getVal(1); /* get name of signal-script */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getItm44",txt); /* print errormessage */
            return 44; } /* terminate function and return with signal */
          Lg.Err("getItm49",txt,is); /* print errormessage */
          return 45; } /* terminate function and return with signal */
        if(is.length()==0) { /* Scriptname not found */
          Lg.Err("getItm45",txt); /* print errormessage */
          return 46; } /* terminate function and return with signal */
        if((is=((TSTrItm01)cIt).setSigT(i,j,fx,is))!=null) /* save data */
          Lg.Err("getItm49",txt,is); /* print errormessage if is it already set */
        cIt.setMsk(21); /* mark: definitionline is successfully processed */
      } else if(is.equals("trsignaldirs")) { /* Type of line: 'TrSignalDirs' */
        if(cIt.chkTyp(2)) break loop; /* Subtyp-entry is not allowed here */
          /* 2 = (1<<1) - 'SignalItem' */
        j = (int)cB.getNV(); /* get number of subentries */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItm51",txt,is); /* print errormessage */
          return 51; } /* terminate function and return with signal */
        if(j<1) { /* invalid value encountered */
          Lg.Err("getItm52",txt,j); /* print errormessage */
          return 52; } /* terminate function and return with signal */
        TrItD = ((TSTrItm01)cIt).getSgD(j); /* allocate memory */
        if(TrItD==null) { /* memory could not be allocated */
          Lg.Err("getItm50",txt,j); /* print errormessage */
          return 50; }  /* terminate function and return with signal */
        for(k=0;k<j;k+=1) { /* process all subentries */
          is = cB.getKE(true); /* get next controlword */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getItm53",txt,k); /* print errormessage */
              return -51; } /* terminate function and return with signal */
            Lg.Err("getItm5B",txt,is,k); /* print errormessage */
            return 53; } /* terminate function and return with signal */
          if(is.length()==0) { /* next keword not present */
            Lg.Err("getItm54",txt,k); /* print errormessage */
            return 54; } /* terminate function and return with signal */
          if(!is.equals("trsignaldir")) { /* 'TrSignalDir' not found */
            Lg.Err("getItm55",txt,is,k); /* print errormessage */
            return 55; } /* terminate function and return with signal */
          i = (int)cB.getNV(); /* get number of TrackNode */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getItm56",txt,is,k); /* print errormessage */
            return 56; } /* terminate function and return with signal */
          sl: { /* search for (address of) target-node */
            cI = TrN.iterator(); /* get iterator for track-nodes */
            while(cI.hasNext()) { /* search for target-Node */
              cTrN = cI.next(); /* receive current object for testing */
              if(cTrN.chkMsk(23)) continue; /* not a valid node -- do not check */
              if(cTrN.getNr(true)==i) break sl; /* target-node found */
            } /* check all defined nodes */
            Lg.Err("getItm57",txt,k,i); /* print errormessage */
            cTrN = null; /* set marker: taget-node NOT found */
          } /* -sl- end of search-block of target-node */
          /* Attention: the contends of 'i' and 'cTrN' are (still) valid */
          is = cB.skpVal(); /* get remaining value(s) within brackets */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getItm5A",txt,k); /* print errormessage */
              return -52; } /* terminate function and return with signal */
            Lg.Err("getItm5B",txt,is,k); /* print errormessage */
            return 58; } /* terminate function and return with signal */
          cTrItD = new TSTrItm01T(i,cTrN,is); /* init reference-entry */
          if(!TrItD.add(cTrItD)) /* and insert as new TrackNode-reference */
            Lg.Err("getItm58",txt,k,i); /* print errormessage if not inserted */
          if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
            Lg.Err("getItm59",txt,k); /* print errormessage */
            return -53; } /* terminate evaluation */
        } /* -for- process all TrSignalDir-entries */
        cIt.setMsk(22); /* mark: definitionline is successfully processed */
      } else if(is.equals("platformtritemdata")) { /* Type of line: 'PlatformTrItemData' */
        if(cIt.chkTyp(4)) break loop; /* Subtyp-entry is not allowed here */
          /* 4 = (1<<2) - 'PlatformItem' */
        i = cB.getHV(8); /* get optionmask of 'PlatformTrItemData' from line */
        if((is=cB.getErr())!=null) { /* error while evaluating hex-number */
          Lg.Err("getItm61",txt,is); /* print errormessage */
          return 61; } /* terminate function and return with signal */
        j = (int)cB.getNV(); /* get next value */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItm62",txt,is); /* print errormessage */
          return 62; } /* terminate function and return with signal */
        cIt.setIRef(j,i); /* create reference-connection and insert it */
        cIt.setMsk(21); /* mark: definitionline is successfully processed */
      } else if(is.equals("platformname")) { /* Type of line: 'PlatformName' */
        if(cIt.chkTyp(4)) break loop; /* Subtyp-entry is not allowed here */
          /* 4 = (1<<2) - 'PlatformItem' */
        is = cB.skpVal(); /* get remaining value(s) within brackets */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getItm77",txt); /* print errormessage */
            return -71; } /* terminate function and return with signal */
          Lg.Err("getItm78",txt,is); /* print errormessage */
          return 71; } /* terminate function and return with signal */
        if((is=cIt.chgLne(0,is))!=null) { /* save data, is it already set? */
          Lg.Err("getItm79",txt,is); /* print error: data already set */
          return 72; } /* terminate function and return with signal */
        cIt.setMsk(24); /* mark: definitionline is successfully processed */
      } else if(is.equals("station")) { /* Type of line: 'Station' */
        if(cIt.chkTyp(4)) break loop; /* Subtyp-entry is not allowed here */
          /* 4 = (1<<2) - 'PlatformItem' */
        is = cB.skpVal(); /* get remaining value(s) within brackets */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getItm87",txt); /* print errormessage */
            return -81; } /* terminate function and return with signal */
          Lg.Err("getItm88",txt,is); /* print errormessage */
          return 81; } /* terminate function and return with signal */
        if((is=cIt.chgLne(1,is))!=null) { /* save data, is it already set? */
          Lg.Err("getItm89",txt,is); /* print error: data already set */
          return 82; } /* terminate function and return with signal */
        cIt.setMsk(25); /* mark: definitionline is successfully processed */
      } else if(is.equals("platformminwaitingtime")) { /* 'PlatformMinWaitingTime' */
        if(cIt.chkTyp(4)) break loop; /* Subtyp-entry is not allowed here */
          /* 4 = (1<<2) - 'PlatformItem' */
        is = cB.skpVal(); /* get remaining value(s) within brackets */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getItm97",txt); /* print errormessage */
            return -91; } /* terminate function and return with signal */
          Lg.Err("getItm98",txt,is); /* print errormessage */
          return 91; } /* terminate function and return with signal */
        if((is=cIt.chgLne(2,is))!=null) { /* save data, is it already set? */
          Lg.Err("getItm99",txt,is); /* print error: data already set */
          return 92; } /* terminate function and return with signal */
        cIt.setMsk(26); /* mark: definitionline is successfully processed */
      } else if(is.equals("platformnumpassengerswaiting")) { /* 'PlatformNumPassengersWaiting' */
        if(cIt.chkTyp(4)) break loop; /* Subtyp-entry is not allowed here */
          /* 4 = (1<<2) - 'PlatformItem' */
        is = cB.skpVal(); /* get remaining value(s) within brackets */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getItmA7",txt); /* print errormessage */
            return -101; } /* terminate function and return with signal */
          Lg.Err("getItmA8",txt,is); /* print errormessage */
          return 101; } /* terminate function and return with signal */
        if((is=cIt.chgLne(3,is))!=null) { /* save data, is it already set? */
          Lg.Err("getItmA9",txt,is); /* print error: data already set */
          return 102; } /* terminate function and return with signal */
        cIt.setMsk(27); /* mark: definitionline is successfully processed */
      } else if(is.equals("sidingtritemdata")) { /* Type of line: 'SidingTrItemData' */
        if(cIt.chkTyp(8)) break loop; /* Subtyp-entry is not allowed here */
          /* 8 = (1<<3) - 'SidingItem' */
        i = cB.getHV(8); /* get optionmask of 'SidingTrItemData' from line */
        if((is=cB.getErr())!=null) { /* error while evaluating hex-number */
          Lg.Err("getItmB1",txt,is); /* print errormessage */
          return 111; } /* terminate function and return with signal */
        j = (int)cB.getNV(); /* get next value */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItmB2",txt,is); /* print errormessage */
          return 112; } /* terminate function and return with signal */
        cIt.setIRef(j,i); /* create reference-connection and insert it */
        cIt.setMsk(21); /* mark: definitionline is successfully processed */
      } else if(is.equals("sidingname")) { /* Type of line: 'SidingName' */
        if(cIt.chkTyp(8)) break loop; /* Subtyp-entry is not allowed here */
          /* 8 = (1<<3) - 'SidingItem' */
        is = cB.skpVal(); /* get remaining value(s) within brackets */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getItmC7",txt); /* print errormessage */
            return -121; } /* terminate function and return with signal */
          Lg.Err("getItmC8",txt,is); /* print errormessage */
          return 121; } /* terminate function and return with signal */
        if((is=cIt.chgLne(0,is))!=null) { /* save data, is it already set? */
          Lg.Err("getItmC9",txt,is); /* print error: data already set */
          return 122; } /* terminate function and return with signal */
        cIt.setMsk(24); /* mark: definitionline is successfully processed */
      } else if(is.equals("speedposttritemdata")) { /* Type of line: 'SpeedpostTrItemData' */
        if(cIt.chkTyp(16)) break loop; /* Subtyp-entry is not allowed here */
          /* 16 = (1<<4) - 'SpeedpostItem' */
        is = cB.skpVal(); /* get remaining value(s) within brackets */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getItmD7",txt); /* print errormessage */
            return -131; } /* terminate function and return with signal */
          Lg.Err("getItmD8",txt,is); /* print errormessage */
          return 131; } /* terminate function and return with signal */
        if((is=cIt.chgLne(0,is))!=null) { /* save data, is it already set? */
          Lg.Err("getItmD9",txt,is); /* print error: data already set */
          return 132; } /* terminate function and return with signal */
        cIt.setMsk(21); /* mark: definitionline is successfully processed */
      } else if(is.equals("pickuptritemdata")) { /* Type of line: 'PickupTrItemData' */
        if(cIt.chkTyp(256)) break loop; /* Subtyp-entry is not allowed here */
          /* 256 = (1<<8) - 'PickupItem' */
        i = (int)cB.getFV(); /* get next value (amount) */
        /* Attention: value may be expressed using exponent-form */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItmE1",txt,is); /* print errormessage */
          return 141; } /* terminate function and return with signal */
        j = cB.getHV(8); /* get optionmask of 'PickupTrItemData' from line */
        if((is=cB.getErr())!=null) { /* error while evaluating hex-number */
          Lg.Err("getItmE2",txt,is); /* print errormessage */
          return 142; } /* terminate function and return with signal */
        if(j==0) { /* invalid options found */
          is = TSLogg.getKey("getItmE4"); /* get default-value */
          if((j=is.indexOf(' '))>=0) is = is.substring(0,j); /* adjust value */
          try { j = Integer.parseInt(is,16); /* and convert options */
          } catch (NumberFormatException e) { /* error found while converting */
            Lg.Err("getItmE5",txt,e.toString()); /* print errormessage */
            return 143; } /* terminate function and return with signal */
          Lg.Err("getItmE3",txt,is); /* print errormessage */
        } /* invalid value replaced by default */
        if(((TSTrItm08)cIt).setItm(i,j)) /* save data, is it already set? */
          Lg.Err("getItmE6",txt,i,j); /* print errormessage */
        cIt.setMsk(21); /* mark: definitionline is successfully processed */
      } else if(is.equals("tritemsrdata")) { /* Type of line: 'TrItemSRData' */
        if(cIt.chkTyp(512)) break loop; /* Subtyp-entry is not allowed here */
          /* 512 = (1<<9) - 'SoundregionItem' */
        j = (int)cB.getNV(); /* get database-number */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItmF1",txt,is); /* print errormessage */
          return 151; } /* terminate function and return with signal */
        if(j!=0) { /* invalid database specified */
          Lg.Err("getItmF2",txt,j); /* print errormessage */
          return 152; } /* terminate function and return with signal */
        j = (int)cB.getNV(); /* get next value */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItmF3",txt,is); /* print errormessage */
          return 153; } /* terminate function and return with signal */
        if(j<0) { /* invalid value specified */
          Lg.Err("getItmF4",txt,j); /* print errormessage */
          return 154; } /* terminate function and return with signal */
        ((TSTrItm09)cIt).chgSR1Dta(j); /* insert value into sound-object */
        fx = cB.getFV(); /* get next value from 'TrItemSRData' */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItmF5",txt,is); /* print errormessage */
          return 155; } /* terminate function and return with signal */
        ((TSTrItm09)cIt).chgSR2Dta(fx); /* insert value into sound-object */
        cIt.setMsk(21); /* mark: definitionline is successfully processed */
      } else if(is.equals("crossovertritemdata")) { /* 'CrossoverTrItemData' */
        if(cIt.chkTyp(1024)) break loop; /* Subtyp-entry is not allowed here */
          /* 1024 = (1<<10) - 'CrossoverItem' */
        i = (int)cB.getNV(); /* get trackNode-reference-number */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItmG1",txt,is); /* print errormessage */
          return 161; } /* terminate function and return with signal */
        cIt.setIRef(i,0);/* create reference-connection and insert it */
        i = (int)cB.getNV(); /* get shape-reference (number) */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getItmG2",txt,is); /* print errormessage */
          return 162; } /* terminate function and return with signal */
        ((TSTrItm10)cIt).setShRef(i); /* create and insert shape-reference */
        cIt.setMsk(21); /* mark: definitionline is successfully processed */
      } else break loop; /* Subtyp-entry is not allowed here */
      if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getItm08",txt); /* print errormessage */
        return -3; } /* terminate evaluation */
    } while(true); /* -loop- process all subentries */
    Lg.Err("getItm09",txt,is,cIt.getName()); /* print errormessage */
    return 1; /* return error-code, error cannot occur */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkDBTab"
  * Tabelle der Schienen-/Strassendatenbank auf Integritaet pruefen
  *  Arbeitsmodus ungerade --> Strassendatenbank
  * Modus: 0,1 - alle Nodes/TrItems muessen vorhanden sein
  *        2,3 - Nodes zusammenschieben, alle TrItems muessen existieren
  *        4,5 - alle Luecken in Nodes/TrItems entfernen
  *        6,7 - alle Luecken in Nodes/TrItems entfernen,
  *              nicht referenzierte TrItems uebergehen/loeschen
  * Achtung: Fuer Typ=0,1 gelten auch fehlende Nodes/Items als benutzt!
  * Hinweis: Die Belegung der DB-Slots ist LUECKENLOS
  * ACHTUNG: Der Modus kann mit Optionen ueberlagert werden (+16,+32,..),
  *            die vor der Auswertung abgetrennt werden muessen
  * ##chkDBTab (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chkDBTab( /* Datenbank erweitert pruefen */
   TSRoute cRte, /* Routendefinition mit Basisverzeichnis */
   int     typ)  /* Arbeitsmodus der Routine (0,1,2,3,4,5) */
   {
   /*-----------------------------------------------------------------*/
    TreeSet<TSQuad>    QDf;    /* alle Quadrat-Definitionen */
    ArrayList<TSVector> NdeT;  /* table of vector-nodes of track-node */
    TSQuad             cQDf;   /* aktuelle Quadrat-Definition */
    ArrayList<TSTrNde> TrN;    /* aktuelle TrackNode-Tabelle */
    TSTrNde            cTrN,xTrN; /* aktuelle TrackNode-DB-Elemente */
    TSVector           cNde;   /* current vector-node */
    TSUiD              cUiD,xUiD; /* currnet/save UiD-Reference */
    TSSh               cSh;    /* Shape-Arbeitswert (lokal/global) */
    ArrayList<TSTrItm> ItT;    /* Speicher fuer TrItem-Elemente */
    TSTrItm            cIt,aIt; /* aktuelles Item-Element */
    ArrayList<TSRefC>  ItRfT;  /* Referenz-Tabelle TrItem-Referenzen */
    TSRefC             cRef;   /* aktuelle Referenz-Steuerung */
    ArrayList<TSTrItm01T> TrItD; /* TrSignalDir-Tabelle (SignalItem) */
    TSTrItm01T         cTrItD; /* aktuelle TrSignalDir-Referenz (SignalItem) */
    TSSigTyp           cSgT;   /* aktuelle Signal-Type-Definition */
    TStType            cTp;    /* aktuelle ttype-Referenz */
    int                db,i,j,ix,l,m,v,w,e; /* Arbeitswerte */
    String             dbN,is; /* Arbeitswert(e) */
    boolean            refC;   /* Referenz-Korrektur vornehmen */
    boolean            exist;  /* UiD-Definition existiert */
    Iterator<TSTrNde>  aI;     /* Tabellen-Iterator (Node) */
    Iterator<TSTrItm>  cI;     /* Tabellen-Iterator (Item) */
   /*=================================================================*/
    refC = false; if(typ>=128) {refC = true; typ -= 128;} /* Option! */
    db = typ % 2;    /* Kennung der Datenbank erstellen */
    QDf = cRte.chgQDf(null); /* Alle Quadrat-Definitionen */
    dbN = TSLogg.getKey("chkDB00"+db); /* Beschreibung fuer Datenbank */

    if(cRte.get$TrN(db)<0) return 0; /* Tabelle nicht vorhanden -- kein Fehler */

    NdeT = cRte.getNdeT(db); /* Tabelle fuer die Vektoren holen */
    if(NdeT.size()>0) NdeT.clear(); /* alle Eintraege entfernen falls notwendig */

    e = 0; /* Anzahl der Fehler */
    TrN = cRte.getTrN(db,0); /* aktuelle TrackNode-Tabelle holen */
    if(TrN==null) throw new  /* TrackNode-Tabelle darf jetzt nicht mehr fehlen */
      IllegalStateException(TSLogg.getMsg("Msg907","chkDBTab()","TrNdeTab==null"));
    if((w=cRte.getInt(12+db))==Integer.MIN_VALUE) throw new /* Number of entries missing */
      IllegalStateException(TSLogg.getMsg("Msg906","chkDBTab("+db+")"));
//
    w = TrN.size() - 1; /* Index-Nummer des letzten Elementes holen */
    w = TrN.remove(w).getNr(true); /* Anzahl der geforderten Elemente holen */
      /* Dummy-Element wird dabei entfernt */

    aI = (new ArrayList<TSTrNde>(TrN)).iterator(); /* Iterator auf TrackNode-Tabelle */
      /* Tabelle wird modifiziert -- (Shallow-)Kopie benutzen */
    ix = 0; /* Vergleichskennung initialisieren -- erste Erhoehung folgt sogleich */
      /* TrNode-Nummer 'ix' ist normalerweise immer 'eins' hoeher als der Tabellenindex */
    while(aI.hasNext()) { /* Weitere TrackNode-Definitionen vorhanden */
      cTrN = aI.next(); /* naechste TrackNode-Definition */
      if(cTrN==null) throw new  /* TrackNode-Eintrag KANN NOCH NICHT fehlen */
        IllegalStateException(TSLogg.getMsg("Msg906","chkDBTab()"));
      ix += 1; /* auf zugeordnete TrackNode-Nummer weiterschalten */
      v = cTrN.getNr(true); /* aktuelle TrackNode-Kennung holen */

      if(ix>v) { /* TrackNode-ID doppelt vergeben ? */
        if(!TrN.remove(cTrN)) throw new /* Original Track-Node aus Tabelle loeschen */
          IllegalStateException(TSLogg.getMsg("Msg906","ArrayList<TSTrNde>("+v+")"));
        if(cTrN.chkMsk(23)) { /* Node ist Dummy-Node -- entfernen */
          Lg.Err("chkDB011",dbN,v,ix); /* Fehlermeldung ausgeben */
          e += 1; /* Fehler zaehlen */
          continue; /* -while- naechste Track-Node bearbeiten */
        } /* Node war Dummy-Node */
        /* TrackNode-ID doppelt vergeben ? */
        i = v - 1; /* Index aus Nummer berechnen */
        xTrN = TrN.get(i); /* vorhandenes Element an Position 'v' holen */
          /* An Position 'v' kann durch einen Fehler (ix<v) ein Fehl-Element ('null')
           * hinzugefuegt worden sein. Dann kann dieses durch das aktuelle ersetzt werden.
           * Fuer Werte kleiner als die aktuelle Position (ix) gilt dass die TrackNodeID mit
           * der Position uebereinstimmt.
           */
        if(xTrN!=null) { /* An der Ziel-Position ist ein gueltiges Element vorhanden */
          if(!xTrN.chkMsk(22) || cTrN.chkMsk(22)) { /* Altes Element ist Fehlerfrei */
            Lg.Err("chkDB012",dbN,ix,v); /* melden: Neues Element wird verworfen */
            e += 1; /* Fehler zaehlen */
            continue; /* -while- naechste TrackNode bearbeiten */
          } /* Altes Element wurde beibehalten */
          /* Das neue Element enthaelt KEINE Fehler waehrend das alte Element mit
           * fehlerhaft gekennzeichnet ist. Deshalb ersetzt das NEUE Element das ALTE.
           */
          Lg.Err("chkDB013",dbN,ix,v); /* Fehlermeldung ausgeben */
        } else Lg.Err("chkDB014",dbN,ix,v); /* An der Ziel-Position ist ein Fehl-Element */
        e += 1; /* Fehler zaehlen */
        TrN.set(i,cTrN); /* vorhandenes Element an Position 'v' ersetzen */
        ix -= 1; /* Index nochmal benutzen (Addition ausgleichen) */
      } /* Track-Node-ID doppelt vergeben ? */
      while(ix<v) { /* fehlende Nodes bearbeiten */
        if(typ<2) { /* Node muss vorhanden sein */
          Lg.Err("chkDB015",dbN,ix,0); /* Fehlermeldung ausgeben */
          e += 1; /* Fehler zaehlen */
        } else Lg.Log("chkDB016",dbN,ix,0); /* Hinweis ausgeben */
        TrN.add(ix-1,null); /* Fehl-Element einfuegen */
        ix += 1; /* auf naechste Nummer weiterschalten */
      } /* Track-Node fehlt */

      v = cTrN.getTyp(); /* akteller Typ der Node */
      if(v==1) t1:{ /* Pruefung fuer TrEndNode */
        if(cTrN.chkMsk(22)) { /* Node fehlerhaft definiert */
          Lg.Err("chkDB111",ix); /* Fehlermeldung ausgeben */
          cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
          e += 1; /* Fehler zaehlen */
          break t1; /* naechste Node testen */
        } /* Node-Definition ist fehlerhaft */
        cNde = cTrN.chgNde(0,null); /* aktuell verkettetes Element */
          /* 'cNde' kann nicht 'null' sein, da sonst Option 22 gesetzt ist. */
        cUiD = null; /* Kennzeichen: UiD-Eintrag nicht gefunden/falsch */
        if(QDf!=null) { /* World-Definition geladen -- UiD pruefbar */
          /* Referenz wird automatisch registriert falls gefunden */
          cQDf = cNde.fndWrld(QDf,true); /* World-Referenz(Pos) suchen */
          if(cQDf==null) { /* World-Datei(3) nicht gefunden */
            Lg.Err("chkDB112",cNde.getMsg(3,null),ix); /* Fehlermeldung ausgeben */
            cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
            e += 1; /* Fehler zaehlen */
          } /* World-Datei nicht gefunden */
          cQDf = cNde.fndWrld(QDf,false); /* World-Referenz(Uid) suchen */
          if(cQDf==null) { /* World-Datei(0) nicht gefunden */
            Lg.Err("chkDB112",cNde.getMsg(2,null),ix); /* Fehlermeldung ausgeben */
            cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
            cTrN.setMsk(21); /* Fehler: World-Datei nicht gefunden */
            e += 1; /* Fehler zaehlen */
            break t1; /* naechste Node testen */
          } /* World-Datei nicht gefunden */
          i = cNde.getUid(); /* Nummer der gesuchten UiD holen */
          for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
            /* Modus 2: UiD muss NUR existieren */
            if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT bearbeiten */
            if(cUiD.isCtl()) continue; /* kein aktiver UiD-Eintrag */
            if((cUiD=cUiD.chkId(i,db,2))!=null) break; /* UiD wurde gefunden -- OK */
          } /* nach UiD suchen */
          if(cUiD==null) { /* Element wurde nicht gefunden */
            Lg.Err("chkDB112",cNde.getMsg(4,null),ix,0); /* Fehlermeldung ausgeben */
              /* Message 4: UiD nicht gefunden */
            cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
            cTrN.setMsk(21); /* Fehler: UiD-Definition nicht gefunden */
            e += 1; /* Fehler zaehlen */
            break t1; /* naechste Node testen */
          } /* UiD nicht gefunden */
          /* UiD gefunden  - Definiert UiD Track ? */
          is = cUiD.getName(true); /* UiD-Typ als Name holen (fuer Message) */
          cUiD = cUiD.chkId(i,db,1); /* UiD auf Track pruefen */
            /* Modus 1: UID muss auf Schiene/Strasse zeigen!
             * ACHTUNG: UiD-Definition kann wechseln (Verkettung) */
          if(cUiD==null) { /* UiD zeigt NICHT auf Schiene/Strasse */
            Lg.Err("chkDB112",cNde.getMsg(5,is),ix); /* Fehlermeldung ausgeben */
              /* Message 5: UiD zeigt nicht auf Schiene/Strasse */
            cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
            e += 1; /* Fehler zaehlen */
            break t1; /* naechste Node testen */
          } /* UiD nicht gefunden */
          /* UiD zeigt auf Track  - Definiert UiD richtigen Typ */
          is = cUiD.getName(true); /* UiD-Typ als Name holen (fuer Message) */
          cUiD = cUiD.chkId(i,db,0); /* UiD auf Schiene/Strasse pruefen */
            /* Modus 0: UID muss auf geforderten Track-Typ verweisen!
             * ACHTUNG: UiD-Definition kann wechseln (Verkettung) */
          if(cUiD==null) { /* UiD zeigt NICHT auf richtigen Typ */
            Lg.Err("chkDB112",cNde.getMsg(db,is),ix); /* Fehlermeldung ausgeben */
              /* Message 0/1: UiD zeigt nicht auf geforderten Track-Typ(0/1) */
            cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
            e += 1; /* Fehler zaehlen */
            break t1; /* naechste Node testen */
          } /* UiD zeigte NICHT auf richtigen Typ */
          /* UID zeigt auf jeden Fall auf Schiene/Strasse */
          xUiD = cNde.chgUid(cUiD); /* insert UID-Reference to Tracknode */
          cUiD.incCntC(1); /* and count it */
          if(xUiD==null) break t1; /* UiD successfully inserted */
          /* An UiD-Reference was already inserted -- process it */
          Lg.Err("chkDB112",cNde.getMsg(6,null),ix); /* Fehlermeldung ausgeben */
          xUiD.incCntC(-1); /* decrement counter of previous UiD again */
        } /* UiD kennung war pruefbar (World-Definition) */
        /* -t1- Ende */
      } else if(v==2) { /* Pruefung fuer TrVectorNode */
        exist = true; /* annehmen: World-Dateien fehlen / KEINE UiD existiert */
        m = cTrN.get$Nde(); /* Anzahl der Sub-Eintraege holen */
        for(l=0;l<m;l+=1) { /* alle Track-Sections bearbeiten */
          if(cTrN.chkMsk(22)) { /* Node fehlerhaft definiert (gemaess getDBF()) */
            Lg.Err("chkDB121",null,ix,l); /* Fehlermeldung ausgeben */
            cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
            e += 1; /* Fehler zaehlen */
            continue; /* naechste Node testen */
          } /* Node-Definition ist fehlerhaft */
          cNde = cTrN.chgNde(l,null); /* aktuelles Vector-Node-Element */
            /* 'cNde' kann nicht 'null' sein, da sonst Option '22' gesetzt ist. */
          cUiD = null; /* Kennzeichen: UiD-Eintrag nicht gefunden/falsch */
          cQDf = null; /* Kennzeichen: World-Eintrag nicht gefunden */
          if(QDf!=null) t2a:{ /* World-Definitionen geladen -- UiD pruefbar */
            /* Referenz wird automatisch registriert falls gefunden */
            cQDf = cNde.fndWrld(QDf,true); /* World-Referenz(Pos) suchen */
            if(cQDf==null) { /* World-Datei(3) nicht gefunden */
              Lg.Err("chkDB122",cNde.getMsg(3,null),ix,l); /* Fehlermeldung ausgeben */
              cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
              e += 1; /* Fehler zaehlen */
            } /* World-Datei nicht gefunden */
            cQDf = cNde.fndWrld(QDf,false); /* World-Referenz(Uid) suchen */
            if(cQDf==null) { /* World-Datei(0) nicht gefunden */
              Lg.Err("chkDB122",cNde.getMsg(2,null),ix,l); /* Fehlermeldung ausgeben */
              cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
              e += 1; /* Fehler zaehlen */
              break t2a; /* naechsten Teil des Nodes testen */
            } /* World-Datei nicht gefunden */
            i = cNde.getUid(); /* Nummer der gesuchten UiD holen */
            for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
              /* Modus 2: UiD muss NUR existieren */
              if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT beachten */
              if(cUiD.isCtl()) continue; /* kein aktiver UiD-Eintrag */
              if((cUiD=cUiD.chkId(i,db,2))!=null) break; /* UiD wurde gefunden -- OK */
            } /* nach UiD suchen */
            if(cUiD==null) { /* Element wurde nicht gefunden */
              Lg.Err("chkDB122",cNde.getMsg(4,null),ix,l); /* Fehlermeldung ausgeben */
                /* Message 4: UiD nicht gefunden */
              cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
              e += 1; /* Fehler zaehlen */
              break t2a; /* naechsten Teil des Nodes testen */
            } /* UiD nicht gefunden */
            /* UiD gefunden  - Definiert UiD Track ? */
            exist = false; /* UiD existiert DOCH */
            is = cUiD.getName(true); /* UiD-Typ als Name holen (fuer Message) */
            cUiD = cUiD.chkId(i,db,1); /* UiD auf Track pruefen */
              /* Modus 1: UID muss auf Schiene/Strasse zeigen!
               * ACHTUNG: UiD-Definition kann wechseln (Verkettung) */
            if(cUiD==null) { /* UiD zeigt NICHT auf Schiene/Strasse */
              Lg.Err("chkDB122",cNde.getMsg(5,is),ix,l); /* Fehlermeldung ausgeben */
                /* Message 5: UiD zeigt nicht auf Schiene/Strasse */
              cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
              e += 1; /* Fehler zaehlen */
              break t2a; /* naechsten Teil des Nodes testen */
            } /* UiD nicht gefunden */
            /* UiD zeigt auf Track  - Definiert UiD richtigen Typ */
            is = cUiD.getName(true); /* UiD-Typ als Name holen (fuer Message) */
            cUiD = cUiD.chkId(i,db,0); /* UiD auf Schiene/Strasse pruefen */
              /* Modus 0: UID muss auf geforderten Track-Typ verweisen!
               * ACHTUNG: UiD-Definition kann wechseln (Verkettung) */
            if(cUiD==null) { /* UiD zeigt NICHT auf Schiene/Strasse */
              Lg.Err("chkDB122",cNde.getMsg(db,is),ix,l); /* Fehlermeldung ausgeben */
                /* Message 0/1: UiD zeigt nicht auf geforderten Track-Typ(0/1) */
              cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
              e += 1; /* Fehler zaehlen */
              break t2a; /* naechsten Teil des Nodes testen */
            } /* UiD zeigte NICHT auf richtigen Typ */
            /* UID zeigt auf jeden Fall auf Schiene/Strasse */
            xUiD = cNde.chgUid(cUiD); /* insert UID-Reference to Tracknode */
            cUiD.incCntC(1); /* and count it */
            cUiD.incCntS(1); /* count section-reference */
            if(xUiD==null) break t2a; /* UiD successfully inserted */
            /* An UiD-Reference was already inserted -- process it */
            Lg.Err("chkDB122",cNde.getMsg(6,null),ix,l); /* Fehlermeldung ausgeben */
            xUiD.incCntC(-1); /* decrement counter of previous UiD again */
            xUiD.incCntS(-1); /* decrement section-reference of previous UiD again */
          } /* -t2a- UiD kennung war pruefbar (World-Definition) */
          if(cUiD==null) { /* UiD-Kennung nicht gesetzt -- Shape-NUMMER pruefen */
            if((is=cNde.chkSh(ShTab,cRte))!=null) { /* Shape/Pfad nicht definiert */
              Lg.Err("chkDB122",is,ix,l); /* Fehlermeldung ausgeben */
              cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
              e += 1; /* Fehler zaehlen */
              continue; /* naechste Node testen */
            } /* Shape-Id passt nicht */
            if(EnaW) Lg.Log("chkDB123",null,ix,l); /* Hinweis ausgeben (Verbindung) */
            cSh = cRte.chgShT(cNde.getSh(true),null); /* zugeordneten Pfad holen wenn definiert */
          } else { /* UiD-Kennung bekannt, passt Shape-Nummer ? */
            cSh = cUiD.chgShR(null); /* zugeordnete Shape-Referenz holen */
              /* Wert kann 'null' sein, wenn KEINE gueltige Shape-Zuordnung fuer einen
               * SectionIDX-Wert gefunden wurde.
               * Es liegt auf jeden Fall ein 'Schienenobjekt' vor. */
            if(cSh==null) { /* no valid shape/path-reference -- try to get it fron node */
              i = cNde.getSh(true); /* get number of requested shape (SectionIDX) */
              cSh = cRte.chgShT(i,null); /* and translate it to connected path (if defined) */
              /* If a valid path could be located (due to SectionIDX-value), 'cSh' contains the reference. */
              if(cSh==null) { /* no path found -- try static shape */
                if(i<ShA) cSh = ShTab[i]; /* try to locate a static shape-definition */
              } else if(cUiD instanceof TSTrkObj) ASh: { /* Dynatrax-object is NOT converted -- do it */
               /* A valid path-definition could be located but the current world-object DO NOT describes
                * a 'DynTrack'-object. So, a valid 'TrackObject' means, that this world-object may be
                * a 'not converted Trackobj'.
                */
                if(cUiD.isOpt(8)) throw new /* 'JNodePosn' already defined -- terminate */
                  IllegalStateException(TSLogg.getMsg("Msg906","TrkObj-JNodePosn (Cnv.)"));
                  /* 'JNodePosn' cannot be defined with converted objects. */
                xUiD = new TSDynTrk((TSTrkObj)cUiD); /* correct object-type of entry */
                xUiD.setOpt(8); /* mark object as a converted from 'TSTrkObj' */
                  /* Attention: opt(8) differs between 'TrkObj' and 'DynTrk' */
                xUiD.chgShR(cSh); /* preset shape-reference because 'crSc' needs it */
                is = ((TSDynTrk)xUiD).crSc(cRte); /* create section-definitions from path */
                if(is!=null) { /* error found during creation of section-definitions */
                  Lg.Err("chkDB124",is,ix,l); /* print error-message */
                  cSh = null; /* invalidate current shape-definition */
                  break ASh; /* and terminate shape-assignment */
                } /* error found during creation of section-definitions */
                xUiD.chgQDf(cQDf); /* insert back-reference to quad-basis-definition */
                is = cQDf.chgWTab(null,0).replace(cUiD,xUiD); /* replace object within chain */
                if(is!=null) { /* target-object could not be replaced */
                  Lg.Err("chkDB125",is,ix,l); /* print error-message */
                  cSh = null; /* invalidate current shape-definition */
                  break ASh; /* and terminate shape-assignment */
                } /* target-object could not be replaced */
                cNde.chgUid(xUiD); /* replace UID-Reference to Tracknode */
                  /* Attention: counters are already copied -- do NOT modify */
                cUiD.setOpt(0); /* invalidate old object (security) */
                cUiD = xUiD; /* use new object for further actions */
                if(EnaH) Lg.Log("chkDB126",cUiD.chgNme(null),ix,l); /* print warning */
              } /* -ASh- 'Dynatrax'-object needed to be converted */

              if(cSh!=null) { /* A shape-/path-definition has been successfully located */
                cUiD.chgShR(cSh); /* insert Shape-Reference into world-object */
                cSh.incCntW(1); /* Shape/Pfad was inserted to world-object */
                cSh.incCntS(1); /* Shape/Pfad-reference was used from node */
                is = cUiD.getName(true) + "(" + cUiD.getUiD(0) + ") (" + cQDf.getInf(0) + ")";
//                is = cQDf.getInf(0) + " " + cUiD.getUiD(0); /* Objektbeschreibung erstellen */
                  /* Wenn die 'UID' gueltig ist hat auch die Quad-Definition einen
                   * gueltigen Wert. */
                if(EnaH) Lg.Log("chkDB127",is,ix,l,i); /* print warning-message */
              } /* neue Shape-Referenz gefunden */
            } else { /* Shape-Nummer/Referenz aus UID ist gueltig -- kann geprueft werden */
              i = cSh.getNr(true); /* und Nummer extrahieren */
              if((is=cNde.chkSh(i))!=null) { /* Shape/Pfad stimmt nicht! */
                Lg.Err("chkDB122",is,ix,l); /* Fehlermeldung ausgeben */
                cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
                e += 1; /* Fehler zaehlen */
                continue; /* naechste Node testen */
              } /* Shape-Id passt nicht */
              cSh.incCntS(1); /* Referenz registrieren (Shape/Pfad) */
              /* Section-Definition pruefen.
               * Die in 'TSDynTrk' definierten Sections brauchen nicht beachtet zu werden,
               * da der entsprechende Shape/Pfad-Eintrag die gleichen Referenzen enthaelt.
               * Dies ist bereits geprueft!
               */
            } /* Shape-Referenz ist gueltig */
          } /* Shape-Nummer/Referenz geprueft */

          if((is=cNde.chkSc(ScTab,cRte))!=null) { /* Section nicht definiert */
            Lg.Err("chkDB122",is,ix,l); /* Fehlermeldung ausgeben */
            cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
            e += 1; /* Fehler zaehlen */
            continue; /* naechste Node testen */
          } /* Section-Id passt nicht */
          if(cSh!=null) /* check if section-definition is a part of current shape */
           if((is=cNde.chkScR(cSh))!=null) { /* section and shape do NOT match */
            Lg.Err("chkDB122",is,ix,l); /* print error-message */
            e += 1; /* count error */
          } /* Section-Id do not match shape */
        } /* alle Track-Sections bearbeiten */
        if(exist) cTrN.setMsk(21); /* Fehler: World-Datei/UiD nicht gefunden */
      } else if(v>2 && v<TrN_T) t3:{ /* Pruefung fuer TrJunctionNode-Typen */
        if(cTrN.chkMsk(22)) { /* Node fehlerhaft definiert */
          Lg.Err("chkDB131",ix); /* Fehlermeldung ausgeben */
          cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
          e += 1; /* Fehler zaehlen */
          break t3; /* naechste Node testen */
        } /* Node-Definition ist fehlerhaft */
        cNde = cTrN.chgNde(0,null); /* aktuell verkettetes Element (TSVector) */
          /* 'cNde' kann nicht 'null' sein, da sonst Option 29 gesetzt ist. */
        NdeT.add(cNde); /* Node der Nodevektor-Tabelle hinzufuegen */
        cUiD = null; /* Kennzeichen: UiD-Eintrag nicht gefunden/falsch */
        cQDf = null; /* Kennzeichen: World-Eintrag nicht gefunden */
        if(QDf!=null) t3a:{ /* World-Definition geladen -- UiD pruefbar */
          /* Referenz wird automatisch registriert falls gefunden */
          cQDf = cNde.fndWrld(QDf,true); /* World-Referenz(Pos) suchen */
          if(cQDf==null) { /* World-Datei(3) nicht gefunden */
            Lg.Err("chkDB132",cNde.getMsg(3,null),ix,0); /* Fehlermeldung ausgeben */
            cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
            e += 1; /* Fehler zaehlen */
          } /* World-Datei nicht gefunden */
          cQDf = cNde.fndWrld(QDf,false); /* World-Referenz(Uid) suchen */
          if(cQDf==null) { /* World-Datei(0) nicht gefunden */
            Lg.Err("chkDB132",cNde.getMsg(2,null),ix,0); /* Fehlermeldung ausgeben */
            cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
            cTrN.setMsk(21); /* Fehler: World-Datei nicht gefunden */
            e += 1; /* Fehler zaehlen */
            break t3a; /* naechste Node testen */
          } /* World-Datei nicht gefunden */
          i = cNde.getUid(); /* Nummer der gesuchten UiD holen */
          for(cUiD=cQDf.getUid(true);cUiD!=null;cUiD=cQDf.getUid(false)) {
            /* Modus 2: UiD muss NUR existieren */
            if(cUiD.isOpt(0)) continue; /* Dummy-Eintrag NICHT beachten */
            if(cUiD.isCtl()) continue; /* kein aktiver UiD-Eintrag */
            if((cUiD=cUiD.chkId(i,db,2))!=null) break; /* UiD wurde gefunden -- OK */
          } /* nach UiD suchen */
          if(cUiD==null) { /* Element wurde nicht gefunden */
            Lg.Err("chkDB132",cNde.getMsg(4,null),ix); /* Fehlermeldung ausgeben */
              /* Message 4: UiD nicht gefunden */
            cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
            cTrN.setMsk(21); /* Fehler: UiD-Definition nicht gefunden */
            e += 1; /* Fehler zaehlen */
            break t3a; /* naechste Node testen */
          } /* UiD nicht gefunden */
          /* UiD gefunden  - Definiert UiD Track ? */
          is = cUiD.getName(true); /* UiD-Typ als Name holen (fuer Message) */
          cUiD = cUiD.chkId(i,db,1); /* UiD auf Track pruefen */
            /* Modus 1: UID muss auf Schiene/Strasse zeigen!
             * ACHTUNG: UiD-Definition kann wechseln (Verkettung) */
          if(cUiD==null) { /* UiD zeigt NICHT auf Schiene/Strasse */
            Lg.Err("chkDB132",cNde.getMsg(5,is),ix); /* Fehlermeldung ausgeben */
              /* Message 5: UiD zeigt nicht auf Schiene/Strasse */
            cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
            e += 1; /* Fehler zaehlen */
            break t3a; /* naechste Node testen */
          } /* UiD nicht gefunden */
          /* UiD zeigt auf Track  - Definiert UiD richtigen Typ */
          is = cUiD.getName(true); /* UiD-Typ als Name holen (fuer Message) */
          cUiD = cUiD.chkId(i,db,0); /* UiD auf Schiene/Strasse pruefen */
            /* Modus 0: UID muss auf geforderten Track-Typ verweisen!
             * ACHTUNG: UiD-Definition kann wechseln (Verkettung) */
          if(cUiD==null) { /* UiD zeigt NICHT auf Schiene/Strasse */
            Lg.Err("chkDB132",cNde.getMsg(db,is),ix); /* Fehlermeldung ausgeben */
              /* Message 0/1: UiD zeigt nicht auf geforderten Track-Typ(0/1) */
            cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
            e += 1; /* Fehler zaehlen */
            break t3a; /* naechste Node testen */
          } /* UiD zeigte NICHT auf richtigen Typ */
          /* UID zeigt auf jeden Fall auf Schiene/Strasse */
          xUiD = cNde.chgUid(cUiD); /* insert UID-Reference to Tracknode */
          cUiD.incCntC(1); /* and count it */
          if(xUiD==null) break t3a; /* UiD successfully inserted */
          /* An UiD-Reference was already inserted -- process it */
          Lg.Err("chkDB132",cNde.getMsg(6,null),ix); /* Fehlermeldung ausgeben */
          xUiD.incCntC(-1); /* decrement counter of previous UiD again */
        } /* -t3a- UiD kennung war pruefbar (World-Definition) */
        if(cUiD==null) { /* UiD-Kennung nicht gesetzt -- Shape-NUMMER pruefen */
          if((is=cNde.chkSh(ShTab,cRte))!=null) { /* Shape/Pfad nicht definiert */
            Lg.Err("chkDB132",is,ix,0); /* Fehlermeldung ausgeben */
            cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
            e += 1; /* Fehler zaehlen */
            break t3; /* naechste Node testen */
          } /* Shape-Id passt nicht */
          if(EnaW) Lg.Log("chkDB133",ix); /* Hinweis ausgeben (Verbindung) */
        } else { /* UiD-Kennung bekannt, passt Shape-Nummer ? */
          cSh = cUiD.chgShR(null); /* get connected Shape-Reference */
            /* Reference may be 'null', if no valid Shape was found due to a given
             * SectionIDX-Value.
             * Type of object is 'trackobject' (static/dynamic) in every case. */
          if(cSh==null) { /* no valid connection -- get requested value from node */
            i = cNde.getSh(true); /* get number of requested shape */
            if(i<ShA) cSh = ShTab[i]; /* get static shape if available */
            if(cSh!=null) { /* connected shape-definition could be located */
              cUiD.chgShR(cSh); /* insert new shape-reference */
              cSh.incCntS(1); /* and register it (shape/path) */
              is = cUiD.getName(true) + "(" + cUiD.getUiD(0) + ") (" + cQDf.getInf(0) + ")";
//              is = cQDf.getInf(0) + " " + cUiD.getUiD(0); /* create description of object */
                /* If a valid 'UID' exists, the appropriate Quad-Definition also contains
                 * a valid value. */
                if(EnaH) Lg.Log("chkDB134",is,ix,i); /* print message */
            } /* new shape-reference could be located */
          } else { /* Shape-Number/Reference from UID is valid -- check it */
            i = cSh.getNr(true); /* get number of requested shape */
            if((is=cNde.chkSh(i))!=null) { /* Shape/Path is not valid! */
              Lg.Err("chkDB132",is,ix); /* print errormessage */
              cTrN.setMsk(20); /* register error (type 20) */
              e += 1; /* and count it */
              break t3; /* continue with next node */
            } /* Shape-Id does not match */
            cSh.incCntS(1); /* gegister reference (Shape/Path) */
          } /* Shape-Reference was valid */
        } /* Shape-Number/shape-reference was (successfully) checked */
        /* -t3- Ende */
      } else { /* Unbekannter Node-Typ gespeichert */
        Lg.Err("chkDB002",ix); /* Fehlermeldung ausgeben */
        cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
        e += 1; /* Fehler zaehlen */
      } /* weitere Typen: nichts pruefen (tritt nicht auf) */

      rl:for(j=0;j<v;j+=1) { /* alle Node-Verkettungen pruefen (Typ (v) bestimmt Anzahl) */
        cRef = cTrN.chgTrN(j,null); /* aktueller Verkettungswert holen */
        if(cRef==null) { /* Verkettung fehlt */
          Lg.Err("chkDB004",null,ix,j); /* Fehlermeldung ausgeben */
          e += 1; /* Fehler zaehlen */
          continue rl; } /* naechste Verkettung pruefen */
        if(!cTrN.chkMsk(j)) { /* keine 0-Ref. -- verkettete Node-Def. muss gesucht werden */
          i = cRef.chgNr(Integer.MIN_VALUE); /* Nummer der verketteten Node holen */
          for(l=0;l<TrN.size();l+=1) { /* Verkettete TrackNode suchen -- alle Nodes pruefen */
            if((xTrN=TrN.get(l))==null) continue; /* Fehlende TrackNode nicht beachten */
            if(xTrN.chkMsk(23)) continue; /* Dummy-Node trifft nicht zu */
            if(xTrN.getNr(true)==i) { /* Verbindungs-Node gefunden */
              if(cRef.chgRef(xTrN)!=null) Lg.Err("chkDB005",null,ix,j); /* Fehlermeldung */
              continue rl; /* naechste Verkettung pruefen */
            } /* Node gefunden */
          } /* alle definierten Nodes testen */
          Lg.Err("chkDB006",""+i,ix,j); /* Fehlermeldung ausgeben */
          e += 1; /* Fehler zaehlen */
        } else if(EnaW) Lg.Log("chkDB007",null,ix,j); /* report '0-reference' */
      } /* -rl- alle Verkettungen pruefen */

      ItRfT = cTrN.getItm(0); /* TrItem-Referenzen (Chain-Objekte) definiert? */
      if(ItRfT!=null) { /* TrItem-Referenzen sind vorhanden */
        if((i=cRte.get$TrI(db))<0) { /* keine TrItem-Tabelle fuer Itemreferenz */
          Lg.Err("chkDB021",ix); /* Fehlermeldung ausgeben */
          cTrN.setMsk(20); /* Registrieren, dass Fehler aufgetreten */
          e += 1; /* Fehler zaehlen */
        } else { /* TrItemTable available -- check reference */
//          f1 = 0.0; /* initialize vector-distance */
          for(j=0;j<ItRfT.size();j+=1) { /* check all references of the 'Chain-Objects'  */
            cRef = ItRfT.get(j); /* get reference (Chain-Object) */
            if((cIt=cRte.fndTrI(db,cRef))==null) { /* requested TrItem not found */
              Lg.Err("chkDB023",""+cRef.chgNr(Integer.MIN_VALUE),ix,j);
              cTrN.setMsk(20); /* register error within object */
              e += 1; /* and count it */
              continue; /* continue with next reference-object */
            } /* TrItem was not found */
            /* establish connection to TrItem-object */
            cIt.incCnt(1);      /* count usage within TrItem */
            if(cIt.setTrNde(cTrN)!=null) cIt.setMsk(3); /* and insert backward-reference */
              /* mark error if connection was already established */
            /* check if distance to vectorstart increases (TrItemSData) */
            if(cIt.getTyp()==0) continue; /* 'EmptyItem' contains no data */
              /* invalid reference to 'EmptyItem' is checked later */

          } /* check all refernces of the Node-object */
        } /* TrItemTable is available */
      } /* TrItem-Referenzen sind vorhanden */

    } /* -aI- alle Track-Nodes bearbeiten */

    /* Nachbehandlung fuer Nodekennungen mit groesseren Nummern */
    while(ix<w) { /* fehlende Nodes bearbeiten */
      if(typ<2) { /* Node muss vorhanden sein */
        Lg.Err("chkDB015",dbN,ix,0); /* Fehlermeldung ausgeben */
        e += 1; /* Fehler zaehlen */
      } else Lg.Log("chkDB016",dbN,ix,0); /* Hinweis ausgeben */
      TrN.add(ix-1,null); /* Fehl-Element einfuegen */
      ix += 1; /* auf naechste Nummer weiterschalten */
    } /* Track-Node fehlt */
    /* 'w' ist JETZT durch 'TrN.size()' (+1) darstellbar */

    /* Wenn Typ<2 wird die interne Nummer NICHT veraendert (Wert NICHT neu gesetzt) */
    if(typ>=2) { /* Interne Nummerierung kann/soll veraendert werden */
      i = 0; /* Index initialisieren */
      aI = TrN.iterator(); /* neuer Iterator auf TrackNode-Tabelle */
      while(aI.hasNext()) { /* Weitere TrackNode-Definitionen vorhanden */
        cTrN = aI.next(); /* naechste TrackNode-Definition */
        if(cTrN==null) aI.remove(); /* Fehl-Eintrag -- loeschen */
        else if(cTrN.chkMsk(23)) aI.remove(); /* Eintrag nicht genutzt -- loeschen */
        else cTrN.chgIx(++i); /* sonst: Index neu setzen */
      } /* alle TrackNode-Eintraege testen */
    } /* Nummerierung musste veraendert werden */
    else i = w; /* Wert ist immer fest */
    cRte.setInt(db,i); /* letzten genutzten Index der Track-Nodes speichern */
//    NdeT.trimToSize(); /* Speicher der TrJunctionNode-Tabelle optimieren */

    /* ***** TrItem-Tabelle ******* */
    /* weitere Pruefungen mit der TrItem-Tabelle (falls vorhanden) */
    ItT = cRte.getTrI(db,0); /* aktuelle TrItem-Tabelle holen */
    if(ItT==null) return e; /* TrItemTable nicht definiert oder vorhanden -- Ende */
    w = ItT.size() - 1; /* Index-Nummer des letzten Elementes holen */
    w = ItT.remove(w).getNr(true); /* Anzahl der geforderten Elemente holen */
      /* Dummy-Element wird dabei entfernt */
    Lg.Log("chkDB201"); /* Hinweis ausgeben -- Fortsetzung bei Items */

    cI = (new ArrayList<TSTrItm>(ItT)).iterator(); /* Iterator auf TrItem-Tabelle */
      /* Tabelle wird modifiziert -- (Shallow-)Kopie benutzen */
    ix = 0; /* Vergleichskennung initialisieren */
    while(cI.hasNext()) { /* Weitere TrItem-Definitionen vorhanden */
      cIt = cI.next(); /* naechste TrItem-Definition */
      if(cIt==null) throw new  /* TrItem-Eintrag KANN NOCH NICHT fehlen */
        IllegalStateException(TSLogg.getMsg("Msg906","chkDBTab(I)"));
      v = cIt.getNr(true); /* aktuelle TrItem-Kennung holen */
      if(ix>v) { /* TrItemID doppelt vergeben ? */
        if(cIt.chkMsk(2)) { /* ID ist dynamisch -- anpassen */
          if(cIt.chkMsk(0)) { /* ungueltiger Eintrag entfernen */
            Lg.Err("chkDB202",dbN,v,ix); /* Fehlermeldung ausgeben */
            e += 1; /* Fehler zaehlen */
            if(!ItT.remove(cIt)) throw new /* TrItem aus Tabelle loeschen */
              IllegalStateException(TSLogg.getMsg("Msg906","ArrayList<TSTrItm>("+v+")"));
            continue; /* naechstes TrItem bearbeiten */
          } /* ungueltiger Eintrag entfernen */
          v = ix; /* neuen Index als ID vergeben */
          cIt.setID(v,true); /* ID/Index neu setzen (Kennung bleiben unveraendert) */
        } else { /* ID ist NICHT dynamisch -- TrItemID doppelt vergeben ? */
          if(!ItT.remove(cIt)) throw new /* (Original-)TrItem aus Tabelle loeschen */
            IllegalStateException(TSLogg.getMsg("Msg906","ArrayList<TSTrItm>("+v+")"));
          aIt = ItT.get(v); /* vorhandenes Element an Position 'v' holen */
            /* An Position 'v' kann durch einen Fehler (ix<v) ein Fehl-Element ('null')
             * hinzugefuegt worden sein. Dann kann dieses durch das aktuelle ersetzt werden.
             */
          if(aIt!=null) { /* An der Ziel-Position ist ein gueltiges Element vorhanden */
            Lg.Err("chkDB203",dbN,ix,v); /* Fehlermeldung ausgeben */
            e += 1; /* Fehler zaehlen */
            continue; /* naechstes TrItem bearbeiten */
          } /* doppelter Eintrag entfernen */
          /* An der Ziel-Position ist ein Fehl-Element vorhanden */
          Lg.Err("chkDB204",dbN,ix,v); /* Fehlermeldung ausgeben */
          e += 1; /* Fehler zaehlen */
          ItT.set(v,cIt); /* vorhandenes Element an Position 'v' ersetzen */
          ix -= 1; /* Index nochmal benutzen (Addition ausgleichen) */
        } /* TrItemID doppelt vergeben ? */
      } /* ID wurde angepasst */
      while(ix<v) { /* fehlende TrItems bearbeiten */
        if(typ<4) { /* TrItem muessen definiert sein */
          Lg.Err("chkDB205",dbN,ix,v); /* Fehlermeldung ausgeben */
          e += 1; /* Fehler zaehlen */
        } else Lg.Log("chkDB206",dbN,ix,v); /* Hinweis ausgeben (Nutzung) */
        ItT.add(ix,null); /* Fehl-Element einfuegen */
        ix += 1; /* auf naechste Nummer weiterschalten */
      } /* TrItem fehlt */
      /* Hier: 'ix' entspricht der TrItem-ID (cIt.getNr(true)) und dem Tabellenindex
       * Ausgenommen dass ein Item verschoben wurde!
       * TrItem-Kennung ist in 'v' gespeichert (Meldungen)
       */

      /* allgemeine, Typ-unabhaengige Pruefungen und Zuweisungen */
      if(cIt.chkMsk(2)) { /* ID ist dynamisch -- KEINE gueltigen Daten */
        if(typ>3) cIt.setMsk(0); /* TrItem wird nicht mehr geschrieben werden */
        cIt.setMsk(1); /* Fehler kennzeichnen */
      } /* Fehlerkennzeichnung fuer dynamische TrItems */

      if(cIt.chkMsk(0) && (l=cIt.incCnt(0))>0) { /* Ungueltiges Item wird referenziert */
        Lg.Err("chkDB221",dbN,v,l); /* Fehlermeldung ausgeben */
        e += 1; /* Fehler zaehlen */
        cIt.setMsk(1); /* Fehler kennzeichnen */
      } /* Ungueltiges Item wird referenziert */

      if(cIt.chkMsk(18)) { /* 'TrItemPData' vorhanden */
        if(QDf!=null) { /* World-Definition geladen -- Quadranten pruefbar */
          cQDf = cIt.fndWrld(QDf,1); /* World-Referenz(P) suchen */
          if(cQDf==null) { /* World-Datei nicht gefunden */
            Lg.Err("chkDB301",cIt.getMsg(1),v); /* Fehlermeldung ausgeben */
            cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
            e += 1; /* Fehler zaehlen */
          } /* World-Datei nicht gefunden */
        } else if(EnaW) Lg.Log("chkDB302",cIt.getMsg(3),v); /* Hinweis ausgeben */
      }  /* 'TrItemPData' is available */
      if(cIt.chkMsk(19)) { /* 'TrItemRData' vorhanden */
        if(QDf!=null) { /* World-Definition geladen -- Quadranten pruefbar */
          cQDf = cIt.fndWrld(QDf,0); /* World-Referenz(R) suchen */
          if(cQDf==null) { /* World-Datei nicht gefunden */
            Lg.Err("chkDB311",cIt.getMsg(0),v); /* Fehlermeldung ausgeben */
            cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
            e += 1; /* Fehler zaehlen */
          } /* World-Datei nicht gefunden */
        } else if(EnaW) Lg.Log("chkDB312",cIt.getMsg(2),v); /* Hinweis ausgeben */
      } /* 'TrItemRData' is available */

      l = cIt.getTyp(); /* preload current type of Item */
      if(l==0) { /* Pruefung fuer 'EmptyItem' */
        if((i=cIt.incCnt(0))>0) { /* Empty-Item wird referenziert! -- nicht erlaubt */
          Lg.Err("chkDB320",cIt.getName(),v,i); /* Fehler ausgeben (Referenz) */
          e += 1; } /* Fehler zaehlen */
      } else if(l==1) { /* Pruefung fuer 'SignalItem' */
        if(cRte.get$SgT(false)>0) { /* Signal-Type-Definitionen verfuegbar (geladen) */
          is = ((TSTrItm01)cIt).setSigT(0,0,0.0,null); /* Signal-Type-Name holen */
          if(is==null) { /* Signal-Type/Script-Referenz nicht vorhanden */
            if(EnaW) Lg.Log("chkDB323",v); /* Fehler ausgeben */
          } else if((cSgT=cRte.fndSigT(is))==null) { /* Eintrag existiert nicht */
            Lg.Err("chkDB324",is,v); /* Fehler ausgeben */
            e += 1; /* Fehler zaehlen */
          } else { /* SignalType-Definition ist vorhanden */
            ((TSTrItm01)cIt).chgSigT(cSgT); /* Type-Referenz eintragen */
            if(!cSgT.chkMsk(16)) /* Script nicht vorhanden */
              if(EnaW) Lg.Log("chkDB325",is,v); /* Fehler ausgeben */
            if((is=cSgT.chkName(is))!=null) if(EnaW) Lg.Log("chkDB327",is,v);
          } /* Fehler im Signalitem */
        } /* Signal-Type-Definitionen verfuegbar */
        if(cIt.chkMsk(22)) { /* 'TrSignalDir'-Daten wurden erkannt */
          TrItD = ((TSTrItm01)cIt).getSgD(0); /* Referenztabelle holen */
          for(i=0,j=TrItD.size();i<j;i+=1) { /* alle Signal-Units bearb. */
            cTrItD = TrItD.get(i); /* aktuellen 'TrSignalDir'-Eintrag holen */
            if(cTrItD==null) { /* Referenz wurde nicht gefunden */
              Lg.Err("chkDB321",null,v,i); /* Fehlermeldung ausgeben */
              cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
              e += 1; /* Fehler zaehlen */
            } else { /* TrSignal(R)Dir-Referenz bearbeiten */
              if((is=cTrItD.chkTrN(null))!=null) { /* Referenz NICHT vollstaendig definiert */
                Lg.Err("chkDB322",is,v,i); /* Fehlermeldung ausgeben */
                cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
                e += 1; /* Fehler zaehlen */
                TrItD.set(i,(TSTrItm01T)null); /* 'TrSignalDir'-Eintrag ersetzen */
              } /* Signal-Item-Referenz nicht zugeordnet */
              if(cTrItD.fndWrld(QDf)==null) { /* World-Referenz(RDir) suchen */
                Lg.Err("chkDB326",null,v,i); /* Fehlermeldung ausgeben */
                cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
                e += 1; /* Fehler zaehlen */
              } /* Signal-Item-Referenz nicht zugeordnet */
            } /* TrSignal(R)Dir-Referenz bearbeiten */
          } /* ALLE TrSignalDir-Referenzen pruefen */
        } /* Daten sind vorhanden */
      } else if(l==2) { /* Pruefung fuer 'PlatformItem' */
        cRef = cIt.setIRef(-1,0); /* Referenz ist Verkettung der beiden Items */
        if(cRef==null) { /* Verkettung nicht vorhanden */
          Lg.Err("chkDB331",v); /* Fehlermeldung ausgeben */
          cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
          e += 1; /* Fehler zaehlen */
        } else { /* verkettete Node muss gesucht werden */
          if((aIt=cRte.fndTrI(db,cRef))==null) { /* TrItem wurde nicht gefunden */
            Lg.Err("chkDB332",null,v,cRef.chgNr(Integer.MIN_VALUE)); /* Fehlermeldung */
            cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
            e += 1; /* Fehler zaehlen */
          } else { /* TrItem gefunden und zugewiesen -- weiter bearbeiten */
            if((j=aIt.getTyp())!=2) { /* ReferenzItem hat falschen Typ */
              Lg.Err("chkDB333",TSTrItm.getName(j),v,cRef.chgNr(Integer.MIN_VALUE));
              cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
            } /* Fehler aufgetreten */
            if((is=cIt.chkRef(aIt,true))!=null) { /* Itemreferences point to different nodes */
              Lg.Err("chkDB334",is,v,cRef.chgNr(Integer.MIN_VALUE));
              e += 1; /* count error */
            } /* Destination of Item-Reference is invalid */
          } /* TrItem wurde gefunden */
        } /* TrItem musste gesucht werden */
      } else if(l==3) { /* Pruefung fuer 'SidingItem' */
        cRef = cIt.setIRef(-1,0); /* Referenz ist Verkettung der beiden Items */
        if(cRef==null) { /* Verkettung nicht vorhanden */
          Lg.Err("chkDB341",v); /* Fehlermeldung ausgeben */
          cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
          e += 1; /* Fehler zaehlen */
        } else { /* verkettete Node muss gesucht werden */
          if((aIt=cRte.fndTrI(db,cRef))==null) { /* TrItem wurde nicht gefunden */
            Lg.Err("chkDB342",null,v,cRef.chgNr(Integer.MIN_VALUE)); /* Fehlermeldung */
            cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
            e += 1; /* Fehler zaehlen */
          } else { /* TrItem gefunden und zugewiesen -- weiter bearbeiten */
            if((j=aIt.getTyp())!=3) { /* ReferenzItem hat falschen Typ */
              Lg.Err("chkDB343",TSTrItm.getName(j),v,cRef.chgNr(Integer.MIN_VALUE));
              cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
            } /* Fehler aufgetreten */
            if((is=cIt.chkRef(aIt,true))!=null) { /* Itemreferences point to different nodes */
              Lg.Err("chkDB344",is,v,cRef.chgNr(Integer.MIN_VALUE));
              e += 1; /* count error */
            } /* Destination of Item-Reference is invalid */
          } /* TrItem wurde gefunden */
        } /* TrItem musste gesucht werden */
      } else if(l==9) { /* Pruefung fuer 'SoundRegionItem' */
        i = cRte.set$Type(0); /* 'ttype.dat' geladen ? */
        if(i>0) { /* Datei ist geladen -- pruefen und setzen */
          j = ((TSTrItm09)cIt).chgSR1Dta(-1); /* aktuelle Referenz holen */
          if(j>=i) { /* Referenzwert fuer Datei zu gross */
            Lg.Err("chkDB381",""+i,v,j); /* Fehlermeldung ausgeben */
            cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
            e += 1; /* Fehler zaehlen */
          } else { /* Referenz ist OK -- zuweisen ? */
            cTp = cRte.chgType(j,null); /* aktuelle ttype-Referenz holen */
            ((TSTrItm09)cIt).chgTRef(cTp); /* und aktivieren */
            cTp.incCnt(1); /* Referenz zaehlen */
          } /* ttype-Referenz wurde gesetzt */
        } else if(EnaW) Lg.Log("chkDB382",v); /* Hinweis: ttype.dat nicht verfuegbar */
      } else if(l==10) { /* Pruefung fuer 'CrossoverItem' */
        cRef = cIt.setIRef(-1,0); /* Referenz ist Verkettung der beiden Items */
        if(cRef==null) { /* Verkettung nicht vorhanden */
          Lg.Err("chkDB391",v); /* Fehlermeldung ausgeben */
          cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
          e += 1; /* Fehler zaehlen */
        } else { /* verkettete Node muss gesucht werden */
          if((aIt=cRte.fndTrI(db,cRef))==null) { /* TrItem wurde nicht gefunden */
            Lg.Err("chkDB392",null,v,cRef.chgNr(Integer.MIN_VALUE)); /* Fehlermeldung */
            cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
            e += 1; /* Fehler zaehlen */
          } else { /* TrItem gefunden und zugewiesen -- weiter bearbeiten */
            if((j=aIt.getTyp())!=10) { /* ReferenzItem hat falschen Typ */
              Lg.Err("chkDB393",TSTrItm.getName(j),v,cRef.chgNr(Integer.MIN_VALUE));
              cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
              e += 1; /* Fehler zaehlen */
            } /* Fehler aufgetreten */
            if((is=cIt.chkRef(aIt,false))!=null) { /* Itemreferences point to same node */
              Lg.Err("chkDB394",is,v,cRef.chgNr(Integer.MIN_VALUE));
              e += 1; /* count error */
            } /* Destination of Item-Reference is invalid */
          } /* TrItem wurde gefunden */
        } /* TrItem musste gesucht werden */
        cRef = ((TSTrItm10)cIt).setShRef(-1); /* Referenz fuer Verkettung Shape-Wert */
        i = cRef.chgNr(Integer.MIN_VALUE); /* Nummer des Shapes extrahieren */
        if(ShTab==null) { /* Systemfehler: 'tsection.dat' nicht geladen */
          Lg.Err("chkDB395",v); /* Fehlermeldung ausgeben */
          cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
          e += 1; /* Fehler zaehlen */
        } else if(i<0 || i>ShTab.length) { /* Index in Tabelle passt nicht */
          Lg.Err("chkDB396",">="+ShTab.length,v,i); /* Fehlermeldung ausgeben */
          cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
          e += 1; /* Fehler zaehlen */
        } else if(ShTab[i]==null) { /* Eintrag existiert nicht */
          Lg.Err("chkDB397",null,v,i); /* Fehlermeldung ausgeben */
          cIt.setMsk(1); /* Registrieren, dass Fehler aufgetreten */
          e += 1; /* Fehler zaehlen */
        } else cRef.chgRef(ShTab[i]); /* Shape-Referenz eintragen */
        if((i=cIt.incCnt(0))>1) { /* TrItem wird falsch referenziert! -- nicht erlaubt */
          Lg.Err("chkDB398",cIt.getPos(0,0),v,i); /* Fehler ausgeben (Ref.) */
          e += 1; } /* Fehler zaehlen */
      } /* weitere Typen: nichts pruefen */

      i = cIt.incCnt(0); /* Anzahl der TrItem-Ref. holen (Normal=2, (World,Node)) */
      if(l>0) { /* Pruefung fuer alle Items ausser EmptyItem */
        if(i==0 && EnaH) /* TrItem wird nicht referenziert -- Meldung */
          Lg.Log("chkDB207",TSTrItm.getName(l),v,0); /* Hinweis ausgeben (Referenz) */
        if(l!=10) { /* restliche Pruefung trifft (fuer Crossoveritem) nicht zu */
          if(i==1) { /* TrItem wird falsch referenziert. Normal ist '2' (World,Node) */
            Lg.Err("chkDB208",TSTrItm.getName(l)+" {"+cIt.getPos(0,0)+"}",v,i);
            e += 1; /* Fehler zaehlen */
            if(refC) rC: { /* fehlende Referenz korrigieren */
              cTrN = cIt.setTrNde(null); /* Verkettete Node holen und loeschen */
              if(cTrN==null) break rC; /* keine Rueck-Referenz -- keine Aenderung */
              ItRfT = cTrN.getItm(0); /* TrItem-Referenzen definiert? */
              if(ItRfT==null) break rC; /* Keine TrItem-Referenzen -- Rueck-Referenz loeschen */
              cRef = null; /* fuer Compiler */
              for(j=0;j<ItRfT.size();j+=1) { /* Verkettungsindex suchen */
                cRef = ItRfT.get(j); /* Steuerung der Zuordnung holen */
                if((TSTrItm)(cRef.chgRef(null))==cIt) break; /* Zuordnung gefunden */
              } /* nach Index suchen */
              if(j>=ItRfT.size()) { /* Zuordnung NICHT gefunden */
                Lg.Err("chkDB211",TSTrItm.getName(l)+" {"+cIt.getPos(0,0)+"}",v);
                e += 1; /* Fehler zaehlen */
                cIt.setTrNde(cTrN); /* Verkettete Node wieder einsetzen */
                break rC; /* Aktion abbrechen */
              } /* Zuordnung NICHT gefunden -- Abbruch */
              if((m=cRef.chgNr(Integer.MIN_VALUE))!=cIt.getNr(true)) { /* Referenz stimmt nicht */
                Lg.Err("chkDB210",TSTrItm.getName(l)+" {"+cIt.getPos(0,0)+"}",v,m);
                e += 1; /* Fehler zaehlen */
                cIt.setTrNde(cTrN); /* Verkettete Node wieder einsetzen */
                break rC; /* Aktion abbrechen */
              } /* Referenz stimmt nicht -- Abbruch */
              /* Alle Pruefungen OK -- Eintrag loeschen */
              ItRfT.remove(j); /* TrItem-Referenzeintrag loeschen */
              cIt.incCnt(Integer.MIN_VALUE); /* Referenzzaehler zuruecksetzen */
              i = 0; /* und im gespeicherten Wert anpassen */
              if(EnaH) Lg.Log("chkDB213",TSTrItm.getName(l),v,cTrN.getNr(true)); /* Meldung */
            } /* -rC- TrItem wird jetzt NICHT mehr referenziert! */
          } /* TrItem wird nur einmal referenziert! */
          if(i>2) { /* TrItem wird mehrfach referenziert. Normal ist '2' (World,Node) */
            Lg.Err("chkDB209",TSTrItm.getName(l)+" {"+cIt.getPos(0,0)+"}",v,i);
            e += 1; } /* Fehler zaehlen */
          if(cIt.chkMsk(3)) { /* TrItem is referenced from Node more than once */
            Lg.Err("chkDB214",TSTrItm.getName(l)+" {"+cIt.getPos(0,0)+"}",v,i);
            e += 1; } /* Fehler zaehlen */
      } } /* restliche Item-Typen */
      if(i==0) { /* element is NOT referenced -- suppress output ? */
        if(typ>=6) cIt.setMsk(0); /* Mode is OK -- Output can be suppressed */
      } else { /* element is referenced -- position-definitions available ? */
        if(TSOpts.chkMsk(l,0x03D0) && !cIt.chkMsk(18)) Lg.Err("chkDB303",v); /* 'TrItemPData' missing */
        if(TSOpts.chkMsk(l,0x07FE) && !cIt.chkMsk(19)) Lg.Err("chkDB313",v); /* 'TrItemRData' missing */
      } /* availability of positions is checked */

      ix += 1; /* TrItem erfolgreich bearbeitet -- registrieren */
    } /* alle TrItem-Eintraege testen */

    /* Nachbehandlung fuer TrItemkennungen mit groesseren Nummern */
    while(ix<w) { /* fehlende Items bearbeiten */
      if(typ<4) { /* TrItem muessen definiert sein */
        Lg.Err("chkDB212",dbN,ix,0); /* Fehlermeldung ausgeben */
        e += 1; /* Fehler zaehlen */
      } else Lg.Log("chkDB206",dbN,ix,0); /* Hinweis ausgeben (Nutzung) */
      ItT.add(ix,null); /* Fehl-Element einfuegen */
      ix += 1; /* auf naechste Nummer weiterschalten */
    } /* TrItem fehlt */
    /* 'w' ist JETZT durch 'ItT.size()' darstellbar */

    /* Wenn Typ<4 wird die interne Nummer NICHT veraendert (Wert NICHT neu gesetzt) */
    if(typ>=4) { /* Interne Nummerierung kann/soll veraendert werden */
      i = 0; /* Index initialisieren */
      cI = ItT.iterator(); /* Iterator auf TrItem-Tabelle */
      while(cI.hasNext()) { /* Weitere TrItem-Definitionen vorhanden */
        cIt = cI.next(); /* naechste TrItem-Definition */
        if(cIt==null) cI.remove(); /* Fehl-Eintrag -- loeschen */
        else if(cIt.chkMsk(0)) cI.remove(); /* Eintrag nicht genutzt -- loeschen */
        else cIt.setNr(i++); /* sonst: Index neu setzen */
      } /* alle TrItem-Eintraege testen */
    } /* Nummerierung musste veraendert werden */

    return e; /* Anzahl der Fehler melden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "putDBF"
  * Schienen-/Strassendatenbank neu und modifiziert ausgeben
  * ROAD-database is marked with a odd type-value (t)
  * 'Overwrite' is signalled with 'datz!=null'. Then the original
  *   file is overwritten. In the other case a copy is created within
  *   destination-path.
  * ATTENTION: Type-value (t) may be overlayed with options (+16,+32,..),
  *            which must be separated first.
  * ##putDBF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int putDBF( /* Schienen-Datenbank neu schreiben */
   TSRoute cRte, /* Routendefinition mit Basisverzeichnis */
   File    datz, /* Dateidefinition Zwischendatei oder 'null' */
   int     t)    /* Typ und Optionen der Datenbank (0,1) */
   {
   /*-----------------------------------------------------------------*/
    int                mxRL = 768; /* Grenzwert fuer Satzlaenge */
    File               dats;  /* Dateidefinition fuer I/O */
    TSFileX            cF;    /* aktuelle Datenbank-Datei (Ausgabe) */
    TSTrNde            cTrN;  /* aktuelles TrackNode-DB-Element */
    TSTrNde            rTrN;  /* Referenz-Element fuer TrackNode */
    TSTrItm            cIt;   /* aktuelles TrItem-Element */
    ArrayList<TSRefC>  ItRfT; /* Referenz-Tabelle TrItem-Referenzen */
    TSRefC             cRef;  /* aktuelle Referenz-Steuerung */
    TSVector           cNde;  /* current vector-node */
    TSUiD              cUiD;  /* UiD-Arbeitswert */
    TSSh               cSh;   /* Shape/Pfad-Arbeitswert */
    int                i,j,k,ix,si,sc,cc; /* Arbeitswerte */
    String             txt,nn,rn,is,js,ks;
    boolean            nOV;   /* Schreiben erfolgreich/Ueberschreiben */
    boolean            chg;   /* Korrigierte UiD benutzen (Ix==2) */
    boolean            clr;   /* Referenz im Fehlerfall loeschen */
    boolean            fmt;   /* Ausgabe der TrvectorSections formatieren */
    Iterator<TSTrNde>  aI;    /* Tabellen-Iterator (Node) */
    Iterator<TSTrItm>  cI;    /* Tabellen-Iterator (Item) */
   /*=================================================================*/
    fmt = false; if(t>=64) {fmt = true; t -= 64;} /* Option! */
    clr = false; if(t>=32) {clr = true; t -= 32;} /* Option! */
    chg = false; if(t>=16) {chg = true; t -= 16;} /* Option! */
    nOV = false; /* preset: overwrite original file */
    t %= 2;   /* Typ der Datenbank berechnen */
    txt = TSLogg.getKey("putDB0"+t); /* Beschreibung fuer Datenbank */
    dats = cRte.getFile(t+6); /* Basisdatei holen */
    nn = dats.getAbsolutePath(); /* Name der nominalen Ausgabedatei */
    if(datz==null) { /* keine Zwischendatei -- Namen setzen */
      nOV = true; /* switch off overwrite of original file */
      datz = cRte.getFile(t+36); /* Ausgabedatei holen */
      nn = datz.getAbsolutePath(); /* neue nominal-Name setzen */
    } /* keine Zwischendatei definiert */
    rn = datz.getAbsolutePath(); /* Name der realen Ausgabedatei */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("putDB04",txt,nn); /* Aktionsmeldung */

    /* Datenbank-Datei fuer Ausgabe oeffnen */
    cF = new TSFileX(TSFileX.FT$xdb,datz); /* Ausgabe-Steuerung erstellen */
    is = cF.open(true); /* Datei fuer Ausgabe oeffnen */
    if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("putDB05",txt,is); /* Fehlermeldung */
      Lg.Close(); /* close output to Log-file */
      return 7; /* terminate function with errorcode */
    } /* Fehler beim Oeffnen der Datenbank-Datei */

    ix = 0; /* fuer Compiler */
    FL:{ /* Break-Loop fuer Fehler */
      is = "TrackDB ("; /* Basiszeile hinzufuegen */
      cc = 13; /* Kennzeichne Fehlerposition (praeventiv) */
      if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */
      is = "\tSerial ( " + cRte.getInt(4+t) + " )"; /* Ser.-Nummer */
      cc = 14; /* Kennzeichne Fehlerposition (praeventiv) */
      if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */

      is = "\tTrackNodes ( " + cRte.get$TrN(t); /* naechste Zeile erstellen */
      cc = 15; /* Kennzeichne Fehlerposition (praeventiv) */
      if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */

      aI = cRte.getIt(t); /* Iterator auf TrackNode-Tabelle */
      ix = 0; /* Vergleichskennung initialisieren, erste Erhoehung folgt */
      while(aI.hasNext()) { /* Weitere TrackNode-Definitionen vorhanden */
        cTrN = aI.next(); /* naechste TrackNode-Definition holen */
        ix += 1; /* und auf geforderte ID weiterschalten */
        if(cTrN==null) continue; /* TrackNode-Definition NICHT vorhanden */
        if(cTrN.chkMsk(23)) continue; /* Dummy-Node NICHT ausgeben */
        i = cTrN.getNr(false); /* NEUE TrackNode-Nummer aus Eintrag */
//        j = cTrN.getNr(true); /* alte TrackNode-Nummer aus Eintrag */
//        if(i!=j) Lg.Log("putDB51",""+j,i,cF.getStat(true)); /* Meldung ausgeben */
          /* Hinweis: Node-Nummer hat sich geaendert */
        if(i<ix) throw new IndexOutOfBoundsException( /* Nummer der Node falsch */
          TSLogg.getMsg("Msg909","TrackNode","putDBF()-1",""+ix,""+i));
        if(i>ix) { /* Systemfehler -- Sequenz nicht eingehalten */
          Lg.Err("putDB52",""+i,ix,cF.getStat(true)); /* Fehlermeldung ausgeben */
          cc = 16; /* Kennzeichne Fehlerposition (praeventiv) */
          is = null; /* es steht keine Meldung aus */
          ix = i; /* mit Maximum fortfahren */
        } /* Node-Index justiert */
        is = "\t\tTrackNode ( " + ix; /* naechste Zeile erstellen */
        cc = 17; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */
        if(cTrN.chkMsk(20)) Lg.Log("putDB53",""+cTrN.getNr(true),ix,cF.getStat(true));
          /* Fehler ist in Eintrag vermerkt -- melden */
        i = cTrN.getTyp(); /* aktuell gespeicherter Node-Typ */
        if(i<1 || i>=TrN_T) { /* Pruefen Node-Typ in der Speicherung */
          Lg.Err("putDB54",""+i,ix,cF.getStat(true)); /* Fehlermeldung ausgeben */
          cc = 18; /* Kennzeichne Fehlerposition (praeventiv) */
          is = null; /* es steht keine Meldung aus */
          break FL; } /* Datei kann nicht weiter erstellt werden */
        cNde = cTrN.chgNde(0,null); /* zugeordneten Node-Eintrag holen (Ix==0 -> immer vorh.) */
        cUiD = cNde.chgUid(null); /* UID-Verkettung paeventiv holen (1/3) */

        if(i==1) { /* Eintrag ist 'TrEndNode' */
          is = "\t\t\tTrEndNode ( 0 )"; /* naechste Zeile erstellen */
          cc = 21; /* Kennzeichne Fehlerposition (praeventiv) */
          if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */
          if(cUiD==null) { /* UiD-Objekt nicht eingetragen -- Original/0 nutzen */
            if(clr) { /* Referenzwert auf '?' setzen */
              if(EnaW) Lg.Log("putDB11",null,ix,cF.getStat(true)); /* Hinweis: Ref. auf '?' gesetzt */
              js = "? ? ?"; /* UiD-Wert loeschen und damit ungueltig machen */
            } else { /* Originalwerte muessen uebernommen werden */
              js = cNde.getId(true); /* Aufloesbarkeit der World-Datei testen */
              if(js!=null) Lg.Err("putDB12",js,ix,cF.getStat(true)); /* Fehlermeldung ausgeben */
              js = cNde.getId(false); /* Original-Werte der Node-ID holen */
              if(EnaH) Lg.Log("putDB13",null,ix,cF.getStat(true)); /* Hinweis: Originaluebername */
            } /* Originalwerte wurden uebernommen */
          } else js = cUiD.getMsg(chg?5:4); /* aktuelle UID-Definition + Quadranten holen */
          is = cNde.crDef(js,false); /* Datenzeile vervollstaendigen */
        } else if(i==2) { /* Eintrag ist 'TrVectorNode' */
          is = "\t\t\tTrVectorNode ("; /* naechste Zeile erstellen */
          cc = 31; /* Kennzeichne Fehlerposition (praeventiv) */
          if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */
          sc = cTrN.get$Nde(); /* Anzahl der Subeintraege holen */
          is = "\t\t\t\tTrVectorSections ( " + sc + " "; /* Beginn der naechsten Zeile */

          for(si=0;si<sc;si+=1) { /* alle Sections bearbeiten */
            if(is.length()>mxRL || (fmt && si>0)) { /* Zeile wird zu gross -- schreiben */
              cc = 32; /* Kennzeichne Fehlerposition (praeventiv) */
              if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */
              is = "\t\t\t\t\t"; /* Zeile neu initialisieren */
            } /* Zeilenumbruch erforderlich */
            cNde = cTrN.chgNde(si,null); /* zugeordneten Node-Eintrag holen (immer vorhanden) */
            cUiD = cNde.chgUid(null); /* UID-Verkettung holen (immer vorhanden) */
            i = cNde.getSc(true); /* original Sectionnummer holen  (immer gueltig) */
              /* ggf. wird die beim Load vorhandene ORIGINAL-Nummer geliefert */
            j = cNde.getSc(false); /* neue Sectionnummer holen */
            if(j<0) { /* Sectionnummer wurde nicht gefunden -- Original nutzen */
              if(EnaH) Lg.Log("putDB21",""+ix+"-"+si,i,cF.getStat(true)); /* Hinweis: Originaluebername */
            } else i = j; /* neue Section-Kennung benutzen */
            is += "" + i; /* aktuelle Sectionnummer umwandeln und anhaengen */
            i = cNde.getSh(true); /* original Shapenummer holen  (immer gueltig) */
            if(cUiD==null) { /* UiD-Objekt nicht eingetragen -- Original nutzen */
              if(EnaH) Lg.Log("putDB22",""+ix+"-"+si,i,cF.getStat(true)); /* Hinweis: Originaluebername */
            } else { /* neue Shape/Pfad-Kennung benutzen */
              j = (cSh=cUiD.chgShR(null)).getNr(true); /* Original-Nummer holen */
              if(j!=i) { /* Shape-Nummer gemaess UiD passt nicht zur Nummer im Satz */
                if(EnaH) Lg.Log("putDB23",""+ix+"-"+si,i,cF.getStat(true)); /* Hinweis: Originaluebername */
              } else i = cSh.getNr(false); /* neue Shape/Pfad-Kennung holen */
            } /* neue Shape/Pfad-Kennung vorhanden */
            is += " " + i;  /* und anhaengen */
            if(cUiD==null) { /* UiD-Objekt nicht eingetragen -- Original/0 nutzen */
              if(clr) { /* Referenzwert auf '?' setzen */
                if(EnaW) Lg.Log("putDB24","-"+si,ix,cF.getStat(true)); /* Hinweis: Ref.-Werte auf '?' */
                js = "? ? ?"; /* UiD-Wert loeschen und damit ungueltig machen */
              } else { /* Originalwerte muessen uebernommen werden */
                js = cNde.getId(true); /* Aufloesbarkeit der World-Datei testen */
                if(js!=null) Lg.Err("putDB25",""+ix+"-"+si,js,cF.getStat(true)); /* Fehlermeldung ausgeben */
                js = cNde.getId(false); /* Original-Werte der Node-ID holen */
                if(EnaH) Lg.Log("putDB26","-"+si,ix,cF.getStat(true)); /* Hinweis: Originaluebername */
              } /* Originalwerte wurden uebernommen */
            } else js = cUiD.getMsg(chg?5:4); /* aktuelle UID-Definition + Quadranten holen */
            is += cNde.crDef(js,true); /* Datenzeile vervollstaendigen */
          } /* alle Sections bearbeiten (si,sc) */
          is += ")"; /* Abschluss hinzufuegen und schreiben */
          cc = 33; /* Kennzeichne Fehlerposition (praeventiv) */
          if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */

          ItRfT = cTrN.getItm(0); /* TrItem-Referenzen definiert? */
          if(ItRfT!=null) wIt:{ /* TrItem-Referenzen sind vorhanden */
            i = ItRfT.size(); /* Anzahl der gueltigen Elemente holen */
            if(i==0) break wIt; /* alle Referenzen geloescht -- Schreiben abbrechen */
            is = "\t\t\t\tTrItemRefs ( " + i; /* Start-Zeile setzen und schreiben */
            cc = 34; /* Kennzeichne Fehlerposition (praeventiv) */
            if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */
            for(i=0;i<ItRfT.size();i+=1) { /* alle TrItems bearbeiten */
              cRef = ItRfT.get(i); /* naechste TrItem-Referenz */
              cIt = (TSTrItm)cRef.chgRef(null); /* Zugeordnetes TrItem holen */
              if(cIt==null) { /* Zuordnungs-Original-TrItem fehlt */
                j = cRef.chgNr(Integer.MIN_VALUE); /* Originalwert holen */
                if(clr) { /* Referenzwert auf '0' setzen */
                  if(EnaW) Lg.Log("putDB28",""+j,ix,cF.getStat(true),i); /* Meldung ausgeben */
                  j = 0; /* Referenzwert loeschen und damit ungueltig machen */
                } else if(EnaH) Lg.Log("putDB29",""+j,ix,cF.getStat(true),i); /* Meldung ausgeben */
              } else j = cIt.getNr(false); /* neue Kennung holen */
              is = "\t\t\t\t\tTrItemRef ( " + j + " )"; /* neue/alte Kennung einsetzen */
              cc = 35; /* Kennzeichne Fehlerposition (praeventiv) */
              if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */
            } /* -while- alle TrItem-Referenzen bearbeiten */
            cc = 36; /* Kennzeichne Fehlerposition (praeventiv) */
            if((is=cF.putData("\t\t\t\t)"))!=null) break FL; /* Schreib-Fehler */
          } /* Item-Referenzen wurden ausgegeben */
          is = "\t\t\t)"; /* letzte Zeile der Node aufbereiten ('TrVectorNode') */
        } else { /* Eintrag ist 'TrJunctionNode' */
          i = cNde.getSh(true); /* original Shapenummer holen  (immer gueltig) */
          if(cUiD==null) { /* UiD-Objekt nicht eingetragen -- Original nutzen */
            if(EnaH) Lg.Log("putDB35",""+i,ix,cF.getStat(true)); /* Hinweis: Originaluebername */
          } else { /* neue Shape/Pfad-Kennung benutzen */
            j = (cSh=cUiD.chgShR(null)).getNr(true); /* Original-Nummer holen */
            if(j!=i) /* Shape-Nummer gemaess UiD passt nicht zur Nummer im Satz */
              if(EnaW) Lg.Log("putDB31",""+i,ix,cF.getStat(true)); /* Hinweis: Korrektur gemaess UiD */
            i = cSh.getNr(false); /* neue Shape/Pfad-Kennung holen */
          } /* neue Shape/Pfad-Kennung vorhanden */
          is = "\t\t\tTrJunctionNode ( 0 " + i + (cTrN.chkMsk(16)?" 1 )":" 0 )");
          cc = 41; /* Kennzeichne Fehlerposition (praeventiv) */
          if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */
          if(cUiD==null) { /* UiD-Objekt nicht eingetragen -- Original/0 nutzen */
            if(clr) { /* Referenzwert auf '?' setzen */
              if(EnaW) Lg.Log("putDB32",null,ix,cF.getStat(true)); /* Hinweis: Ref. auf '?' gesetzt */
              js = "? ? ?"; /* UiD-Wert loeschen und damit ungueltig machen */
            } else { /* Originalwerte muessen uebernommen werden */
              js = cNde.getId(true); /* Aufloesbarkeit der World-Datei testen */
              if(js!=null) Lg.Err("putDB33",js,ix,cF.getStat(true)); /* Fehlermeldung ausgeben */
              js = cNde.getId(false); /* Original-Werte der Node-ID holen */
              if(EnaH) Lg.Log("putDB34",null,ix,cF.getStat(true)); /* Hinweis: Originaluebername */
            } /* Originalwerte wurden uebernommen */
          } else js = cUiD.getMsg(chg?5:4); /* aktuelle UID-Definition + Quadranten holen */
          is = cNde.crDef(js,false); /* Datenzeile vervollstaendigen */
        } /* Node-Typen abgearbeitet */
        /* ACHTUNG: Letzte Zeile des Node-Typs wurde noch nicht geschrieben */
        cc = 51; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */

        /* 'TrPins' ausgeben */
        sc = cTrN.getTyp(); /* Anzahl der Referenzen holen */
        is = cTrN.getPin(); /* erste Definitionszeile bilden */
        cc = 52; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */
        for(si=0;si<sc;si+=1) { /* alle Referenzen bearbeiten */
          cRef = cTrN.chgTrN(si,null); /* aktueller Verkettungswert holen */
          if(cRef==null) { /* keine Verkettung definiert -- Default setzen */
            if(EnaW) Lg.Log("putDB41",""+si,ix,cF.getStat(true)); /* Meldung ausgeben */
            if(clr) { /* Referenzwert auf '?' setzen */
              if(EnaW) Lg.Log("putDB?42",null,ix,cF.getStat(true)); /* Hinweis: Ref. auf '?' gesetzt */
              is = "\t\t\t\tTrPin ( ? ? )"; /* Dummy-Wert erstellen */
            } else is = "\t\t\t\tTrPin ( 0 0 )"; /* Dummy-Wert erstellen */
          } else { /* Verkettungsreferenz definiert -- weiter bearbeiten */
            is = "\t\t\t\tTrPin ( "; /* Anfang der Zeile setzen */
            if(cTrN.chkMsk(si)) is += "0"; /* Kennung der 0-Verkettung setzen */
            else { /* KEINE 0-Referenz gesetzt -- bearbeiten */
              rTrN = (TSTrNde)cRef.chgRef(null); /* Adresse der Zuordnungsnode holen */
              if(rTrN==null) { /* Gueltige Zuordnung zu Node fehlt */
                i = cRef.chgNr(Integer.MIN_VALUE); /* Originalwert der Verkettung */
                Lg.Log("putDB43",""+si,ix,cF.getStat(true),i); /* Meldung ausgeben */
                is += (clr ? "?" : i); /* Original-Verkettung setzen */
              } else is += rTrN.getNr(false); /* neue Kennung holen und setzen */
            } /* gueltige Verkettung bearbeitet */
            is += " " + cRef.chgIx(Integer.MIN_VALUE) + " )"; /* Ende der Zeile hinzuf. */
          } /* Verkettungsreferenz war definiert */
          cc = 53; /* Kennzeichne Fehlerposition (praeventiv) */
          if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */
        } /* alle Referenzen bearbeiten (si,sc) */
        cc = 54; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData("\t\t\t)"))!=null) break FL; /* Schreib-Fehler */
        cc = 55; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData("\t\t)"))!=null) break FL; /* Schreib-Fehler */
      } /* -aI- alle TrackNodes bearbeiten (v) */
      cc = 56; /* Kennzeichne Fehlerposition (praeventiv) */
      if((is=cF.putData("\t)"))!=null) break FL; /* Schreib-Fehler */

      /***** TrItem-Definitionen ausgeben */
      cI = cRte.getIt(2+t); /* Iterator auf TrItem-Tabelle holen */
      if(cI!=null) { /* TrItems sind vorhanden */
        /* Jedes Element dieser Tabelle ist gueltig und enthaelt aufsteigende Nummern
         * im Feld: 'NrN'. (Dies muss durch vorangehende Methoden sichergestellt sein.)
         * Wenn ein Element nicht geschrieben wird ('null' oder 'chkMsk(0)') dann ist
         * dieses fehlerhaft und es wird eine Luecke in der Nummerierung generiert.
         */
        is = "\tTrItemTable ( " + cRte.get$TrI(t); /* naechste Zeile erstellen */
        cc = 61; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */
        ix = 0; /* Vergleichsindex initialisieren */
        while(cI.hasNext()) { /* Weitere TrItem-Definitionen vorhanden */
          cIt = cI.next(); /* naechste TrItem-Definition */
          if(cIt==null) continue; /* keine Ausgabe moeglich */
          if(cIt.chkMsk(0)) continue; /* keine Ausgabe gefordert */
          if(cIt.chkMsk(1)) /* Fehler in Eintrag vermerkt */
            Lg.Log("putDB61",""+cIt.getNr(true),ix,cF.getStat(true)); /* Hinweis: Fehler erkannt */
          i = cIt.getNr(false); /* neue Item-Nummer holen */
          if(i!=ix) { /* Systemfehler -- Sequenz nicht eingehalten */
            Lg.Err("putDB62",""+ix,i,cF.getStat(true)); /* Fehlermeldung ausgeben */
            if(i<ix) break FL; /* kann nicht weiter gemacht werden */
            ix = i; /* mit Maximum fortfahren */
          } /* Node-Index justiert */
          is = "\t\t" + cIt.getName() + " ("; /* Typzeile aus Definition erstellen */
          cc = 71; /* Kennzeichne Fehlerposition (praeventiv) */
          if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */
          for(j=16;j<31;j+=1) { /* alle Definitionen ausgeben */
            if(!cIt.chkMsk(j)) continue; /* keine Ausgabe gefordert */
            for(i=0;i<100;i+=1) { /* alle Zeilen abfragen (100 ist Sicherung) */
              is = cIt.crDef(j,i,true,0); /* Definitionszeile erzeugen */
              if(is==null) break; /* keine weitere Zeile */
              /* Achtung: Ausgabe-zeile muss mindestens ein '\t' enthalten */
              if(is.charAt(0)!='\t') { /* Meldung statt Zeile erhalten */
                Lg.Err(is,null,cF.getStat(true),ix); /* Meldung ausgeben */
                is = cIt.crDef(j,i,false,0); /* Definitionszeile erzeugen */
              } /* Meldung bearbeitet */
              cc = i * 100 + j + 56; /* Kennzeichne Fehlerposition (praeventiv) */
                /* cc = 72,..73,173,..74,174,... 86,186 */
              if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */
            } /* alle Zeilen abfragen und ausgeben */
          } /* alle Definitionszeilen ausgeben */
          cc = 88; /* Kennzeichne Fehlerposition (praeventiv) */
          if((is=cF.putData("\t\t)"))!=null) break FL; /* Schreib-Fehler */
          ix += 1; /* TrItem wurde erstellt -- Sequenz zaehlen */
        } /* alle TrItem's bearbeiten (cI) */
        cc = 62; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData("\t)"))!=null) break FL; /* Schreib-Fehler */
      } /* TrItem-Definitionen ausgeben (cI!=null) */

      cc = 63; /* Kennzeichne Fehlerposition (praeventiv) */
      if((is=cF.putData(")"))!=null) break FL; /* Schreib-Fehler */
      cc = 69; /* preset position of error */
      is = TSLogg.getMsg("Msg100","Database"); /* create TSUtil-ID-Line */
      if((is=cF.putData(is))!=null) break FL; /* write-error --terminate */
      cc = 0; /* Datei erfolgreich erstellt */
    } /* -FL- Abbruch im Fehlerfall */
    if(is!=null) /* Fehlermeldung steht noch aus */
      Lg.Err("putDB06",txt,is,cF.getStat(true)); /* Fehlermeldung ausgeben */

    is = cF.close(); /* Ausgabe-Datei schliessen */
    if(is!=null) Lg.Err("putDB06",txt,is,cF.getStat(true)); /* Fehlermeldung ausgeben */

    if(cc>0) { /* Fehler beim Schreiben der Datenbank */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("putDB07",txt,dats.getPath(),""+cc);
      Lg.Close(); /* close output to Log-file */
      return 9; /* terminate function with errorcode */
    } /* Funktionsfehler */

    Lg.Log("putDB08",txt,cF.getStat(true)); /* print number of records */
    Lg.Log("putDB09",txt,cF.getStat(false)); /* print recordlength */
    Lg.Skip(false); /* Leerzeile loggen */

    if(nOV) return 0; /* Datenbank ohne Fehler geschrieben */

    /* ueberschreiben der Originaldatei muss noch erfolgen */
    is = "copy \"" + rn  +"\" \"" + nn + "\" "; /* copy - Befehl erstellen */
    if((t=exec(true,is,null,Lg))>0) /* Fehler bei Ausfuehrung */
      Lg.Err("MsgC49",nn,t); /* Fehlermeldung ausgeben */
    Lg.Skip(false); /* Leerzeile loggen */

    return -t; /* Datenbank geschrieben */
  }

 /**. <pre>
  *=====================================================================
  * Methode "putITF"
  * Schienen-/Strassendatenbank (.?it) neu und modifiziert ausgeben
  * ROAD-database is marked with a odd type-value (t)
  * 'Overwrite' is signalled with 'datz!=null'. Then the original
  *   file is overwritten. In the other case a copy is created within
  *   destination-path.
  * ATTENTION: Type-value (t) may be overlayed with options (+16,+32,..),
  *            which must be separated first.
  * ##putITF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int putITF( /* Schienen-Datenbank neu schreiben */
   TSRoute cRte, /* Routendefinition mit Basisverzeichnis */
   File    datz, /* Dateidefinition Zwischendatei oder 'null' */
   int     t,    /* Typ und Optionen der Datenbank (0,1) */
   boolean clr)  /* Referenz im Fehlerfall loeschen */
   {
   /*-----------------------------------------------------------------*/
    File              dats; /* Dateidefinition fuer I/O */
    TSFileX           cF;   /* aktuelle Datenbank-Datei (Ausgabe) */
    TSTrItm           cIt;  /* aktuelles TrItem-Element */
    int               i,j,k,ix,cc;  /* Arbeitswerte */
    String            txt,nn,rn,is; /* Arbeitswerte */
    boolean           nOV;  /* Schreiben erfolgreich/Ueberschreiben */
    Iterator<TSTrItm> cI;   /* allgemeiner Tabellen-Iterator */
   /*=================================================================*/
    t %= 2;   /* Typ der Datenbank berechnen */
    txt = TSLogg.getKey("putDB0"+t); /* Beschreibung fuer Datenbank */
    dats = cRte.getFile(t+8); /* Basisdatei holen */
    cI = cRte.getIt(t+2); /* Iterator auf TrItem-Tabelle holen */
    if(cI==null) { /* TrItembereich fehlt -- normal beenden */
      if(datz!=null) dats.delete(); /* remove original file if overwrite */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("putDB03",txt,dats.getPath()); /* Abbruchmeldung */
      return -1; /* System NORMAL, jedoch mit Kennzeichen beenden */
    } /* TrItem-Bereich existiert nicht */
    nn = dats.getAbsolutePath(); /* Name der nominalen Ausgabedatei */
    nOV = false; /* preset: overwrite original file */
    if(datz==null) { /* keine Zwischendatei -- Namen setzen */
      nOV = true; /* switch off overwrite of original file */
      datz = cRte.getFile(t+38); /* Ausgabedatei holen */
      nn = datz.getAbsolutePath(); /* neue nominal-Name setzen */
    } /* keine Zwischendatei definiert */
    rn = datz.getAbsolutePath(); /* Name der realen Ausgabedatei */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("putDB04",txt,nn); /* Aktionsmeldung */

    /* Datenbank-Datei fuer Ausgabe oeffnen */
    cF = new TSFileX(TSFileX.FT$xit,datz); /* Ausgabe-Steuerung erstellen */
    is = cF.open(true); /* Datei fuer Ausgabe oeffnen */
    if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("putDB05",txt,is); /* Fehlermeldung */
      Lg.Close(); /* close output to Log-file */
      return 7; /* terminate function with errorcode */
    } /* Fehler beim Oeffnen der Datenbank-Datei */

    ix = 0; /* Vergleichsindex initialisieren (fuer Compiler) */
    FL:{ /* Break-Loop fuer Fehler  ('cI' ist schon gesetzt) */
      is = "TrItemTable ( " + cRte.get$TrI(t); /* naechste Zeile erstellen */
      cc = 61; /* Kennzeichne Fehlerposition (praeventiv) */
      if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */
      while(cI.hasNext()) { /* Weitere TrItem-Definitionen vorhanden */
        cIt = cI.next(); /* naechste TrItem-Definition lesen */
        if(cIt==null) continue; /* keine Ausgabe moeglich */
        if(cIt.chkMsk(0)) continue; /* keine Ausgabe gefordert */
        if(cIt.chkMsk(1)) /* Fehler in Eintrag vermerkt */
          Lg.Log("putDB61",""+cIt.getNr(true),ix,cF.getStat(true)); /* Hinweis: Fehler erkannt */
        i = cIt.getNr(false); /* neue Item-Nummer holen */
        if(i!=ix) { /* Systemfehler -- Sequenz nicht eingehalten */
          Lg.Err("putDB62",""+ix,i,cF.getStat(true)); /* Fehlermeldung ausgeben */
          if(i<ix) break FL; /* kann nicht weiter gemacht werden */
          ix = i; /* mit Maximum fortfahren */
        } /* Node-Index justiert */
        is = "\t" + cIt.getName() + " ( "; /* Typzeile aus Definition erstellen */
        cc = 71; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */
        /* Optionen erstellen und Daten ausgeben */
        k = 2; /* Default-Option fuer ITF-Modul */
        if(clr) k *= 3; /* clr-Option einsetzen */
        if(EnaW) k *= 5; /* 'EnaW' ist gesetzt */
        if(EnaH) k *= 7; /* 'EnaH' ist gesetzt */
        for(j=16;j<31;j+=1) { /* alle Definitionen ausgeben */
          if(!cIt.chkMsk(j)) continue; /* keine Ausgabe notwendig */
          for(i=0;i<100;i+=1) { /* alle Zeilen abfragen (100 ist Sicherung) */
            is = cIt.crDef(j,i,true,k); /* Definitionszeile erzeugen */
            if(is==null) break; /* keine weitere Zeile */
            /* Achtung: Ausgabe-zeile muss mindestens ein '\t' enthalten */
            if(is.charAt(0)!='\t') { /* Meldung statt Zeile erhalten */
              if(is.charAt(0)==' ') Lg.Log(is,null,cF.getStat(true),ix); /* Warnung/Hinweis */
              else Lg.Err(is,null,cF.getStat(true),ix); /* Meldung (Fehler) ausgeben */
              is = cIt.crDef(j,i,false,k); /* Definitionszeile erzeugen */
            } /* Meldung bearbeitet */
            cc = i * 100 + j + 56; /* Kennzeichne Fehlerposition (praeventiv) */
              /* cc = 72,..73,173,..74,174,... 86,186 */
            if((is=cF.putData(is))!=null) break FL; /* Schreib-Fehler */
          } /* alle Zeilen abfragen und ausgeben */
        } /* alle Definitionszeilen ausgeben */
        cc = 88; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData("\t)"))!=null) break FL; /* Schreib-Fehler */
        ix += 1; /* TrItem wird erstellt -- Sequenz zaehlen */
      } /* alle TrItem's bearbeiten (cI) */
      cc = 62; /* Kennzeichne Fehlerposition (praeventiv) */
      if((is=cF.putData(")"))!=null) break FL; /* Schreib-Fehler */
      cc = 69; /* preset position of error */
      is = TSLogg.getMsg("Msg100","Database(I)"); /* create TSUtil-ID-Line */
      if((is=cF.putData(is))!=null) break FL; /* write-error --terminate */
      cc = 0; /* Datei erfolgreich erstellt */
    } /* -FL- Abbruch im Fehlerfall */
    if(is!=null) /* Fehlermeldung steht noch aus */
      Lg.Err("putDB06",txt,is,cF.getStat(true)); /* Fehlermeldung ausgeben */

    is = cF.close(); /* Ausgabe-Datei schliessen */
    if(is!=null) Lg.Err("putDB06",txt,is,cF.getStat(true)); /* Fehlermeldung ausgeben */

    if(cc>0) { /* Fehler beim Schreiben der Datenbank */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("putDB07",txt,dats.getPath(),""+cc);
      Lg.Close(); /* close output to Log-file */
      return 9; /* terminate function with errorcode */
    } /* Funktionsfehler */

    Lg.Log("putDB08",txt,cF.getStat(true)); /* print number of records */
    Lg.Log("putDB09",txt,cF.getStat(false)); /* print recordlength */
    Lg.Skip(false); /* Leerzeile loggen */

    if(nOV) return 0; /* Datenbank ohne Fehler geschrieben */

    /* ueberschreiben der Originaldatei muss noch erfolgen */
    is = "copy \"" + rn  +"\" \"" + nn + "\" "; /* copy - Befehl erstellen */
    if((t=exec(true,is,null,Lg))>0) /* Fehler bei Ausfuehrung */
      Lg.Err("MsgC49",nn,t); /* Fehlermeldung ausgeben */
    Lg.Skip(false); /* Leerzeile loggen */

    return -t; /* Datenbank geschrieben */
  }

 /**. <pre>
  *=====================================================================
  * Methode "creTDCtl"
  * TD-Steuerungsdatei erstellen (falls nicht vorhanden)
  * ##creTDCtl (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int creTDCtl( /* TD-Definitionen erstellen */
   TSRoute cRte, /* Routendefinition mit Basisverzeichnis */
   boolean lo)   /* Basis der Quadrat-Auswertung(lo/hi) */
   {
   /*-----------------------------------------------------------------*/
    TSFileX   cF;      /* aktuelle Ausgabe-Datei */
    TSFleMask cM;      /* aktuelle Dateimaske */
    int       x,z,cc;  /* Arbeitswert(e) */
    File      dir,dat; /* Terrain-Datei, idx/idxl-Datei */
    String    is;
    String[]  fl;      /* Dateiliste */
   /*=================================================================*/
    dat = cRte.getFile(lo?5:4); /* Ausgabedatei holen (ggf. anlegen) */
    if(dat==null) { /* Systemfehler beim Vorbereiten Zugriff */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("creTD08",cRte.getInfo(lo?5:4)); /* Abbruchmeldung ausgeben */
      return 5; /* System beenden */
    } /* Fehler beim Oeffnen der Datei */
    dir = dat.getParentFile(); /* Verzeichnis fuer Dateien */
    is = dat.getAbsolutePath(); /* Name der Ausgabedatei */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("creTD01",is); /* Aktionsmeldung ausgeben */

    cM = new TSFleMask(false,lo?".*\\.tdl":".*\\.td"); /* Dateiendung */
    if((is=cM.getErr())!=null) { /* Fehler aufgetreten */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("creTD02",is); /* Abbruchmeldung ausgeben */
      return 5; /* System beenden */
    } /* Fehler beim Oeffnen der Datei */

    fl = dir.list((FilenameFilter)cM); /* relevante Dateien auflisten */
      /* Es werden KEINE Directories geliefert! */
    if(fl==null) { /* Source-ist kein Verzeichnis */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("creTD03",dir.getPath()); /* Fehlermeldung ausgeben */
      return 6; /* System beenden */
    } /* Dateiliste konnte nicht erstellt werden */
    if(fl.length==0) { /* Keine relevanten Dateien gefunden */
      if(lo) { /* Lo-Tiles koennen fehlen */
        Lg.Msg("creTD04"); /* Fehlermeldung ausgeben */
        return -1; /* mit Kennung zurueck */
      } /* Steuerdatei kann fehlen wenn keine LO-Tiles */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("creTD05"); /* Fehlermeldung ausgeben */
      return 7; /* System beenden */
    } /* Keine Dateiliste gefunden */

    /* Ausgabe-Datei oeffnen */
    cF = new TSFileX(TSFileX.FT$idx,dat); /* Ausgabe-Steuerung erstellen */
    is = cF.open(true); /* Datei fuer Ausgabe oeffnen */
    if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("creTD02",is); /* Abbruchmeldung ausgeben */
      return 8; /* System beenden */
    } /* Fehler beim Oeffnen der Datei */

    sl: { /* Schreib-Loop (Break-Block) */
      is = "Terrain_Desc ("; /* Zeile erzeugen */
      cc = 12; /* Fehlerkennung vorsorglich setzen */
      if((is=cF.putData(is))!=null) break sl; /* Schreib-Fehler */
      is = TSLogg.getKey("creTD20"); /* fester Text holen */
      cc = 13; /* Fehlerkennung vorsorglich setzen */
      if((is=cF.putData(is))!=null) break sl; /* Schreib-Fehler */
      is = TSLogg.getKey("creTD22"); /* fester Text holen */
      cc = 14; /* Fehlerkennung vorsorglich setzen */
      if((is=cF.putData(is))!=null) break sl; /* Schreib-Fehler */
      is = "\tTerrain_Desc_Tiles ( ";
      cc = 15; /* Fehlerkennung vorsorglich setzen */
      if((is=cF.putData(is))!=null) break sl; /* Schreib-Fehler */

      cc = 16; /* Fehlerkennung vorsorglich setzen */
      for(String cs:fl) { /* process all file-definitions */
        ol$: { /* break-Block fuer Namensfehler */
          if((x=chkNum(cs,0,6))==Integer.MIN_VALUE) break ol$;
          if((z=chkNum(cs,6,12))==Integer.MIN_VALUE) break ol$;
          is = "\t\tTdFile ( "+x+" "+z+" )"; /* Steuereintrag */
          if((is=cF.putData(is))!=null) break sl; /* Schreib-Fehler */
          continue; /* Satz erfolgreich aufbereitet und geschrieben */
        } /* -ol$- Fehler im Dateiformat */
        Lg.Err("creTD11",is); /* Fehler im Namensformat der Datei */
      } /* process all files */

      cc = 17; /* Fehlerkennung vorsorglich setzen */
      if((is=cF.putData("\t)"))!=null) break sl; /* Schreib-Fehler */
      cc = 18; /* Fehlerkennung vorsorglich setzen */
      if((is=cF.putData(")"))!=null) break sl; /* Schreib-Fehler */
      cc = 0; /* kein Fehler aufgetreten */
    } /* -sl- Break-Block fuer das Schreiben */
    if(is!=null) { /* Meldung steht noch aus */
      cc = 19; /* Kennzeichne Fehlerposition */
      Lg.Err("creTD02",is); /* Meldung ausgeben */
    } /* Meldung musste noch ausgegeben werden */
    is = cF.close(); /* Ausgabe-Datei schliessen */
    if(is!=null) Lg.Err("creTD02",is); /* Meldung ausgeben */

    if(cc>0) { /* Fehler beim Schreiben der Datenbank */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("creTD06",dat.getPath(),cc,0); /* Abbruchmeldung ausgeben */
      return 15; /* System beenden */
    } /* Funktionsfehler */

    Lg.Log("creTD07",cF.getStat(true)); /* print number of records */
    Lg.Skip(false); /* Leerzeile loggen */

    return 0; /* Programm erfolgreich beendet */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTDF"
  * Read TD-Definitons
  * Method uses global class 'TSTemp' (stored in 'gT') to transfer
  *  variables/values from 'getTDF()' to 'getTD()'
  * ##getTDF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getTDF( /* TD-Definitionen einlesen */
   TSRoute cRte, /* aktuelle Routendefinition */
   int     t)    /* Basis der Quadrat-Auswertung(lo/hi) und Optionen */
   {
   /*-----------------------------------------------------------------*/
    File       dat,tdat,dir; /* Terrain-file(s) */
    TSFileX    cF; /* current input-file (control) */
    TSFile$td  cT; /* current input of '*.td'/'*.tdl'-file */
    TSBuf      cB; /* current input-buffer for 'read file' */
    int        l1,l2,i,x,z,cc; /* temporary value(s) */
    String     is;
   /*=================================================================*/
    t = t%2; /* ggf. Optionen entfernen, (t==0)->Hi, (t==1)->Lo */
    dat = cRte.getFile(t+4); /* File-Objekt der idx/idxl - Datei */
    if(dat==null) { /* Systemfehler im Verzeichnispfad erhalten */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getTDF05",cRte.getInfo(t+4)); /* Abbruchmeldung ausgeben */
      return 5; /* System beenden */
    } /* Datei ist ein Verzeichnis */
    if(dat.isDirectory()) { /* es liegt keine Datei vor */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getTDF01",dat.getPath()); /* Abbruchmeldung ausgeben */
      return 5; /* System beenden */
    } /* Datei ist ein Verzeichnis */
    if(!dat.exists()) { /* Datei existiert nicht und kann fehlen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getTDF02",dat.getPath()); /* Aktionsmeldung */
      return -1; /* System NORMAL, jedoch mit Kennzeichen beenden */
    } /* Datei existiert nicht */
    /* check if data-directory is present */
    dir = cRte.getFile(t+18); /* get reference to tile-directory */
    if(dir==null) { /* error -- tile-directory is missing */
      dir = (File)TSUtil.RetVal; /* get original file-definition */
      Lg.Skip(true); /* skip line */
      Lg.Msg("getTDF07",dir.getPath()); /* print error-message */
      return 6; /* terminate reading of tiles */
    } /* dirctory missing */
    dir = dat.getParentFile(); /* directory of '.td'/'.tdl' - files */
    if(dir==null) throw new IllegalStateException( /* integrity OK? */
      TSLogg.getMsg("Msg908","getParentFile()==null","getTDF()",0));
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("getTDF03",dat.getAbsolutePath()); /* Aktionsmeldung */

    /* create and open input-file for control of tiles */
    cF = new TSFileX(TSFileX.FT$idx,dat); /* create input-control of file */
    is = cF.open(TSFile.IN); /* open file and check file-ID */
    if(is!=null) { /* error occured during 'open' */
      Lg.Skip(false); /* log empty line */
      Lg.Msg("getTDF04",is); /* print error-message */
      return 7; /* terminate function */
    } /* error occured during 'open' */
    cB = new TSBuf(cF); /* create inputbuffer and init counter */

    cRte.getTle(t,true); /* init sorted Tile-Definitions (create table) */
    if(t==0) cRte.getQDf(true); /* init sorted Structure-Quad's */

    cc = 0; /* preset condition-code */
    bl: { /* Break-Block (used with errors) */
      is = cB.getKE(true); /* get first controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getTDF11"); /* print errormessage */
          cc = 14; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getTDF10",is); /* print errormessage */
        cc = 11; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getTDF12"); /* print errormessage */
        cc = 15; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(!is.equals("terrain_desc")) {  /* 'terrain_desc' not found */
        Lg.Err("getTDF13",is); /* print errormessage */
        cc = 16; /* set current return-code to error */
        break bl; } /* terminate evaluation */

      /* process all following definitions */
      l1 = cB.getBrL(); /* current bracket-level for terminate */
      while(true) { /* process all definitions */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getTDF14"); /* print errormessage */
            cc = 12; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getTDF10",is); /* print errormessage */
          cc = 17; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) break; /* no more kewords present */
        l2 = cB.getBrL(); /* current bracket-level for terminate */
        if(is.equals("terrain_desc_size")) { /* Definition-type: 'terrain_desc_size' */
          i = (int)cB.getNV(); /* get value of argument */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getTDF21",is,cB.getStat(true)); /* print errormessage */
            cc = 18; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          if(i!=67108864) Lg.Err("getTDF22",i); /* requested value not found */
          cRte.setInt(t+8,i); /* save current value */
        } else if(is.equals("depth")) { /* Definition-type: 'Depth' */
          i = (int)cB.getNV(); /* get value of argument */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getTDF31",is,cB.getStat(true)); /* print errormessage */
            cc = 19; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          if(i!=6) Lg.Err("getTDF32",i); /* requested value not found */
          cRte.setInt(t+10,i); /* save current value */
        } else if(is.equals("terrain_desc_tiles")) { /* Def.-type: 'terrain_desc_tiles' */
          while(true) { /* process all Tile-Definitions */
            is = cB.getKE(true); /* get next controlword */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getTDF14"); /* print errormessage */
                cc = 20; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              Lg.Err("getTDF10",is); /* print errormessage */
              cc = 13; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            if(is.length()==0) break; /* no more kewords present */
            if(!is.equals("tdfile")) {  /* token 'TdFile' not found */
              Lg.Err("getTDF41",is); /* print errormessage */
              cc = 21; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            x = (int)cB.getNV(); /* get value of argument */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTDF42",is,cB.getStat(true)); /* print errormessage */
              cc = 22; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            z = (int)cB.getNV(); /* get value of argument */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTDF43",is,cB.getStat(true)); /* print errormessage */
              cc = 23; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
              cc = 24; /* set current return-code to error */
              break bl; } /* terminate evaluation */

            /* Syntax geprueft und OK -- Datei lesen und pruefen */
            is = prFN(x,z,5) + TleS[t]; /* Dateiname erstellen */
            tdat = new File(dir,is); /* Dateireferenz der Strukturdatei erstellen */
            if(tdat==null) throw new IllegalStateException( /* integrity OK? */
              TSLogg.getMsg("Msg908","Datei(*.td?)==null","getTDF()",t));
            if(tdat.isDirectory()) { /* es liegt keine Datei vor */
              Lg.Err("getTDF51",tdat.getPath()); /* Fehlermeldung ausgeben */
              cc = 25; /* neuer Condition-Code setzen */
              break bl; } /* terminate evaluation */
            if(!tdat.exists()) { /* Datei existiert nicht */
              Lg.Err("getTDF52",tdat.getPath()); /* Fehlermeldung ausgeben */
              cc = 26; /* neuer Condition-Code setzen */
              break bl; } /* terminate evaluation */
            Lg.Msg("getTDF53",tdat.getAbsolutePath()); /* Aktionsmeldung */
            x *= 512; /* Basiskoordinate (X) berechnen */
            z *= 512; /* Basiskoordinate (Z) berechnen */
 if(PrMsk.chkMsk(31)) Lg.Log("Msg010","Qx-Basis = "+x+", Qz-Basis = "+z); // ##!D

            gB = new TSByteArrIO(); /* create Buffercontrol for input */
            cT = new TSFile$td(tdat); /* create file-definition for tile-control */
            if((is=cT.load(gB))!=null) { /* read complete file into buffer -- error? */
              Lg.Err("getTDF54",is); /* print terminating errormessage */
              cc = 27; /* and set new Condition-Code */
              break bl; } /* terminate evaluation */
            /* Attention: 'cT' is already closed again and a prefix of 18 bytes is skipped */
 if(PrMsk.chkMsk(31)) Lg.Log("Msg010","File='"+gB.toString()+"'"); // ##!D
            gT = new TSTemp(cRte,t,(int)gB.getInt(4)); /* create temporary object */
              /* read length of file and store it into counter 1 */
            cc = getTD(x,z,512); /* start recursion and read all tile-definitions */
 if(PrMsk.chkMsk(31)) Lg.Log("Msg010","RC:'"+cc+"', Count = "+cB.getStat(true)+",Rest = "+gT.incCnt1(0)); // ##!D
            if(cc>0) break bl; /* terminate evaluation */
            if((i=gT.incCnt1(0))>0) { /* nicht ALLE Eingabedaten gelesen */
              Lg.Err("getTDF56",i); /* Fehlermeldung ausgeben */
              continue; } /* terminate load */
            Lg.Log("getTDF57",null,gT.incCnt5(0),gT.incCnt2(0)); /* Ergebnisse ausgeben */
            Lg.Log("getTDF58",TleP[t],gT.incCnt3(0)); /* Ergebnisse ausgeben */
            if(t==0) Lg.Log("getTDF59",gT.incCnt4(0)); /* genaue Aufloesung ist aktiv */
            Lg.Skip(false); /* Leerzeile loggen */
          } /* -while- process all Tile-Definitions */
        } else Lg.Err("getTDF49",is); /* invalid keyword -- do not process */
        if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
          cc = 30; /* set current return-code to error */
          break bl; } /* terminate evaluation */
      } /* -while- process all definitions */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        cc = 31; /* set current return-code to error */
        break bl; } /* terminate evaluation */
    } /* -bl- break-block used in case of error */
    is = cF.close(); /* close ipnut-fiel (control) again */
    if(is!=null) Lg.Err("getTDF04",is); /* error -- print message */

    if(cc>0) { /* Fehler beim Laden der Datei */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getTDF09",dat.getPath(),cc,0); /* Abschlussmeldung ausgeben */
      return 9; /* System beenden */
    } /* Funktionsfehler */

    Lg.Log("getTDF06",cF.getStat(true));  /* print counter */
    Lg.Skip(false); /* Leerzeile loggen */

    return 0; /* Modul beenden -- Ergebnis zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTD"
  * Read TD-Quad's (tile-definitions) and process them
  * Method is used recursively and is ONLY called from within 'getTDF()'!
  * ##getTD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getTD( /* process TD-Quads */
   int    Qx, /* X-Coordinate of container-quad */
   int    Qz, /* Z-Coordinate of container-quad */
   int    Ql) /* quad-length of container-quad */
   {
   /*-----------------------------------------------------------------*/
    File    dat; /* temporary file-definition */
    TSRoute cR;  /* current route-reference */
    TSQuad  QDf; /* connected Quad-definitions */
    TSTile  cT;  /* intermediate value */
    int     i,j,t,x,z,ix,iz,qx,qz; /* intermediate values */
    String  is,js; /* file-names */
    TreeSet<TSQuad> cQ; /* current container of Quad-definitions */
   /*=================================================================*/
    Ql /= 2; /* compute quad-length of the new (partitioned) sub-quad */
 if(PrMsk.chkMsk(31)) Lg.Log("Msg010","Qx-Data = "+Qx+", Qz-Data = "+Qz+", Length = "+Ql); // ##!D
    if(Ql<1) return 4; /* return using error-marker (quad-length) */
    cR = gT.chgRte(null); /* extract route-reference */
    t = gT.chgNr(Integer.MIN_VALUE); /* get type of node (lo==1/hi==0) */

    if(gB.available()<1) { /* EOF reached -- handle it */
      Lg.Err("getTDF80",gT.incCnt1(0)); /* print errormessage */
      return 5; /* return using errorcode (common error-marker) */
    } /* EOF reached */
    i = (int)gB.getInt(1); /* get control-byte from buffer, increment pointer */
    gT.incCnt1(-1); /* decrement avaliable byte within file */
    /* The control-byte may contain partition-marker (first four bit) as well
     * as tile-marker (second four bit). Both alternatives must be processed.
     * However only 4 bits can be concurrently set.
     * Processing-order is from left to right, because data within the file is
     * ordered in this way.
     */
 if(PrMsk.chkMsk(31)) Lg.Log("Msg010","\t\t\t\t\t\tContrl="+TSUtil.toHex(i,-3)); // ##!D

    for(j=3;j>=0;j-=1) { /* process all bit within control-byte */
      ix = 0; /* preset: Tile is not partitioned */
      if((i&(16<<j))!=0) ul:{ /* partitioning has priority over tile-marker */
        ix = 1; /* change marker: Tile is partitioned */
        if(t>0 && Ql<16) break ul; /* partitioning of tiles is no longer allowed */
        iz = Qz; if(j>1) iz += Ql; /* compute Z-number of Quad-position */
                  /* X-number of Quad-position is computed by table-lookup */
        iz = getTD(Qx+TDdx[j]*Ql,iz,Ql); /* process quad recursively */
        if(iz>0) return iz; /* Fehler zurueckgeben */
      } /* -ul- partitioning is processed */
       else gT.incCnt5(1); /* Quad is not partitioned and therefore 'valid' */
      if((i&(1<<j))!=0) ml:{ /* Quad-definition contains tile-marker -- analyse it */
        x = Qx + TDdx[j]*Ql; /* compute Qx-Coordinate (quad is left) */
        z = Qz + (j>1?Ql:0); /* Qz-Koordinate berechnen (quad is down-left) */
        if(ix>0) { /* Tile is partitioned AND marked */
          if(EnaW) Lg.Log("getTDF89",""+Ql,x,z); /* print error-message */
          break ml; /* no further processing of marked tile */
        } /* Tile is ALSO partitioned */
        gT.incCnt2(1); /* count marked tile */
        QDf = null; /* preset: no structure-definition available (LO-Tiles) */
        if(t==0) { /* inner check is NOT available for LO-Tile-definitions */
          cQ = cR.getQDf(false); /* get current Quad-container */
          for(ix=0;ix<Ql;ix+=1) /* check all quads (X-direction) */
           for(iz=0;iz<Ql;iz+=1) { /* check all quads (Z-direction) */
            qx = x + ix; qz = z + iz; /* compute current coordinate-values */
            js = "w" + prFN(qx,qz,6); /* common part of filename */
            is = js + ".w"; /* create filename of the corresponding world-file */
            dat = cR.getFile(10,is); /* get file-object of this world-definition */
            if(dat==null) throw new IllegalStateException( /* check integrity */
              TSLogg.getMsg("Msg908","World-Datei==null","getTD()",0));
            if(dat.isDirectory()) { /* filename refers to directory -- error */
              Lg.Err("getTDF81",dat.getPath()); /* print error-message */
              is = null; /* and invalidate current file-definition */
            } else if(!dat.exists()) { /* world-file does not exist */
              Lg.Err("getTDF82",dat.getPath(),TSTile.getTNme(qx,qz,1),Ql);
              gT.incCnt4(1); /* count missing file */
              is = null; /* and invalidate current file-definition */
            } /* world-file is NOT valid */
            js += ".ws"; /* create filename of the corresponding sound-file */
            dat = cR.getFile(10,js); /* get file-object of this sound-definition */
            if(dat==null) throw new IllegalStateException( /* integrity OK? */
              TSLogg.getMsg("Msg908","Sound-Datei==null","getTD()",0));
            if(dat.isDirectory()) { /* filename refers to directory -- error */
              Lg.Err("getTDF83",dat.getPath()); /* print error-message */
              js = null; /* and invalidate current file-definition */
            } else if(!dat.exists()) { /* sound-file does not exist */
              if(EnaH) Lg.Log("getTDF84",dat.getPath()); /* print warning */
              js = null; /* and invalidate current file-definition */
            } /* sound-file is NOT valid */
            if(is==null && js==null) continue; /* neither definition -- no quad available */
            QDf = new TSQuad(qx,qz,is,js,QDf); /* create and store new structure-definition */
            if(!cQ.add(QDf)) { /* insert new quad into global chain, too. -- already present? */
              Lg.Err("getTDF91",""+Ql,qx,qz); /* print error-message */
            } /* current quad was ALREADY defined */
          } /* process all quads (ix,iz) within container */
        } /* LO-Tile was NOT active */
        is = TSTile.getTNme(x,z,Ql); /* compute Tile-Address of quad */
          /* ALL x/z-numbered sub-quads contain the SAME Tile-Address! */
        ix = t + 18; /* create temporary access-ID for retrieve of names */
        dat = cR.getFile(ix,is+"_y.raw"); /* create file-name for tile-data */
        if(dat==null) throw new IllegalStateException( /* check integrity */
          TSLogg.getMsg("Msg908","Tile-Datei(y)==null","getTD()",t));
        if(dat.isDirectory()) Lg.Err("getTDF85",dat.getPath(),x,z); /* directory */
        else if(!dat.exists()) Lg.Err("getTDF86",dat.getPath(),x,z); /* missing file */
        dat = cR.getFile(ix,is+".t"); /* create file-name for tile-definition */
        if(dat==null) throw new IllegalStateException( /* check integrity */
          TSLogg.getMsg("Msg908","Tile-Datei(t)==null","getTD()",t));
        if(dat.isDirectory()) {  /* filename refers to directory -- error */
          Lg.Err("getTDF87",dat.getPath(),x,z); /* print error-message */
          is = null; /* and invalidate current file-definition */
        } else if(!dat.exists()) { /* tile-definition does not exist */
          Lg.Err("getTDF88",dat.getPath(),x,z); /* print error-message */
          gT.incCnt3(1); /* count missing file */
          is = null; /* and invalidate current file-definition */
        } /* tile-definition is NOT valid */
        cT = new TSTile(x,z,Ql,t>0,is,QDf); /* create Tile-definition-object */
        if(!cR.getTle(t,false).add(cT)) { /* and store to global chain -- error? */
          Lg.Err("getTDF92",TleP[t],x,z); /* print error-message */
        } /* current tile-definition was ALREADY defined */
        while(QDf!=null) { /* post-processing of all newly defined structure-quads */
          QDf.chgTle(cT); /* insert tile-reference */
          QDf = QDf.chgQDf(null); /* skip to next element within tile-chain */
        } /* process back-chaining of structure-quads */
      } /* -ml- Quad was marked/populated */
    } /* -for- process all partinion-definitions / marker */
    return 0; /* Definition was successfully processed */
  }

 /**. <pre>
  *=====================================================================
  * Method "putTDF"
  * Write TD-Definitonen again
  * Method uses global variables 'vn2', 'gB', 'gC', 'gD' and 'gF' to
  *  transfer variables/values from 'putTDF()' to 'putTD()'
  * Attention: Global array 'gP' must contain file-prefix of controlfile.
  * ##putTDF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int putTDF( /* TD-Definitionen neu schreiben */
   TSRoute cRte, /* Routendefinition mit Basisverzeichnis */
   File    dat,  /* Def. der Zieldatei Steuerung (idx/idxl-Datei) */
   int     t)    /* Basis der Quadrat-Auswertung(lo/hi) und Optionen */
   {
   /*-----------------------------------------------------------------*/
    TSTileC[] TCTab; /* Speicherung der Baumstruktur */
    TSTileC   aTleC,bTleC,cTleC;
    TSTile    cTle; /* aktueller Tile */
    int       i,j,w,r,x,z,cc; /* Arbeitswert(e) */
    String    is;
    Iterator  cI;  /* allgemeiner Iterator fuer 'TreeSet' */
   /*=================================================================*/
    t = t%2; /* ggf. Optionen entfernen, (t==0)->Hi, (t==1)->Lo */
    if(dat==null) dat = cRte.getFile(t+34); /* Ausgabedatei holen */
      /* falls nicht angegeben, wird die Default-Datei verwendet. */
    if(dat==null) { /* Systemfehler beim 'Vorbereiten Zugriff' */
      Lg.Skip(true); /* Leerzeile Loggen */
      Lg.Msg("putTDF03",cRte.getInfo(t+34)); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 6; /* terminate function with errorcode */
    } /* Systemfehler beim Vorbereiten Zugriff */
    if(cRte.get$Tle(t)<1) { /* no more tile-definitions available */
      Lg.Skip(true); /* skip line */
      Lg.Msg("putTDF08",dat.getPath()); /* print message */
      return -1; /* terminate NORMAL and return marker */
    } /* no output needed */
    gD = dat.getParentFile(); /* Verzeichnis fuer Dateien */
    if(gD==null) throw new IllegalStateException( /* integrity OK? */
      TSLogg.getMsg("Msg908","getParentFile()==null","putTDF()",t));
    vn2 = TleS[t]; /* Dateiendung festlegen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("putTDF01",dat.getAbsolutePath()); /* write action-message */

    /* create output-file and open it for UT */
    gC = new TSFileX(TSFileX.FT$idx,dat); /* create output-control */
    is = gC.open(TSFile.OUT); /* open file for output and write file-ID */
    if(is!=null) { /* error occured during 'open' */
      Lg.Skip(false); /* log empty line */
      Lg.Msg("putTDF02",is); /* print error-message */
      Lg.Close(); /* close output to Log-file */
      return 7; /* terminate function */
    } /* error occured during 'open' */

    TCTab = null; /* init fuer Fehler */
    sl: { /* Schreib-Loop (Break-Block) */
      is = "Terrain_Desc ("; /* Zeile erzeugen */
      cc = 12; /* Fehlerkennung vorsorglich setzen */
      if((is=gC.putData(is))!=null) break sl; /* Schreib-Fehler */
      is = "\tTerrain_Desc_Size ( " + cRte.getInt(t+8) + " )";
      cc = 13; /* Fehlerkennung vorsorglich setzen */
      if((is=gC.putData(is))!=null) break sl; /* Schreib-Fehler */
      is = "\tDepth ( " + cRte.getInt(t+10) + " )";
      cc = 14; /* Fehlerkennung vorsorglich setzen */
      if((is=gC.putData(is))!=null) break sl; /* Schreib-Fehler */
      is = "\tTerrain_Desc_Tiles ( ";
      cc = 15; /* Fehlerkennung vorsorglich setzen */
      if((is=gC.putData(is))!=null) break sl; /* Schreib-Fehler */

      /* Quadrat-Steuerungsdateien neu erzeugen und ausgeben */
      TCTab = new TSTileC[14]; /* Zwischentabelle erzeugen (waagerecht) */
        /* Verkettung von Quadranten mit GLEICHER Kantenlaenge
         * TCTab[0] = Kette der (Verbindungs-)Qudanten mit KL == 16384
         * TCTab[1] = Kette der (Verbindungs-)Qudanten mit KL == 8192
         * .......
         * TCTab[12] = Kette der (Verbindungs-)Qudanten mit KL == 4
         * TCTab[13] = Kette der (Verbindungs-)Qudanten mit KL == 2
         */
      Arrays.fill(TCTab,null); /* Tabelle initialisieren */
      cI = cRte.getIt(t+10); /* Iterator fuer Tile-Definitionen */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        cTle = (TSTile)cI.next(); /* naechste Tile-Definition */
        cTleC = cTle.crTleC(); /* primaeres Tile-Verbindungsobjekt erstellen */
        x = cTle.getK(true); /* X-Koordinate holen */
        z = cTle.getK(false); /* Z-Koordinate holen */
        /* Fuer jedes primaere Tile-Verbindungsobjekt (cTleC) wird nun eine
         * (sekrechte) Kette von (sekundaeren) Verbindungsobjekten mit STEIGENDER
         * Kantenlaenge erstellt und jeweils das Objekt mit geringerer Kantenlaenge
         * als Child angehaengt. Alle Verbindungsobjekte mit gleicher
         * Kantenlaenge werden dabei in die waagrechte Kette aufgenommen.
         * ACHTUNG: Das primaere Tile-Verbindungsobjekt wird
         * NICHT in die waagerechte Kette mit aufgenommen. Es ist ein
         * Leaf-Objekt und besitzt KEINE abhaengigen Childs. Es kommt
         * damit NICHT als Parent-objekt in Frage.
         * Das erste aufgenommene Objekt ist das naechst hoehere Verbindungs-
         * objekt, das dann das primaere Objekt als Child erhaelt.
         * Bemerkung: Da Verbindungsobjekte mit Kantenlaenge '1' IMMER
         *            Leaf-Objekte sind, gibt es deshalb auch keine waagrechte
         *            Kette mit dieser Kantenlaenge
         */
        for(i=0,w=2;i<14;i+=1,w*=2) { /* alle Kantenlaengen (KL) */
          /* Maske w: w = 2**(i+1) (2..16384) */
          r = w / 2; /* Maske des aktuellen Quadranten (Kantenlaenge) */
          x &= -r; /* X-Koordinate verifizieren/modifizieren */
          z &= -r; /* Z-Koordinate verifizieren/modifizieren */
          if(cTleC.chkQl(r)) continue; /* -for- KL des Tiles ist noch groesser */
            /* Im Fall 'LO-Tile' trifft dies mindestens 3 mal zu (KL>=8) */
          r = x; /* Orginalwert merken */
          x = x & -w; /* Koordinate des Ueberquadrats maskieren */
          r = (r - x) >> i; /* X-Differenz dx = {0,1} zum Ueberquadrat berechnen */
          j = z; /* Orginalwert merken */
          z = z & -w; /* Koordinate des Ueberquadrats maskieren */
          r = r * 2 + ((j - z) >> i); /* Z-Differenz dz = {0,1} */
            /* r = dx*2 + dz ==> r = 0..3 */
          r = TDr[r]; /* Index fuer Child-Eintrag erstellen */
          /* x und z wurden auf die Werte des naechst HOEHEREN Quadranten
           * modifiziert (maskiert). Dieser wird nun in der Kette gesucht, damit
           * er (an Position 'r') den aktuellen Quadranten als Child aufnehmen kann.
           */
          j = 13 - i; /* TCTab-Index berechnen (gemaess akt. Kantenlaenge) */
          /* Hier: (x,z) = Koordinaten des Ueberquadranten */
          ol: { /* break-Block fuer: Adr. Ueberquadrant gefunden
            * Verbindungsstruktur in zutreffende waagrechte Kette einhaengen */
            aTleC = TCTab[j]; /* Anfang der Kette */
            bTleC = null; /* Kennzeichen fuer Anfang */
            while(aTleC!=null) { /* gleiches Quadrat suchen */
              bTleC = aTleC; /* Vorgaenger merken */
              if(aTleC.isTile(x,z)) break ol; /* Objekt schon definiert
                 * d.h.: Teilkette bis zum Basisquadranten ist schon vorhanden.
                 * Wenn die Schleife mindestens EINMAL betreten wird ist
                 * 'bTleC' auf jeden Fall '!=null' ---> Min. EINE Eintrags-
                 * definition auf dieser Ebene existiert bereits.
                 * 'bTleC' wird damit als Schalter benutzt. */
              aTleC = aTleC.chgNxt(null); /* weiterschalten */
            } /* Kette waagerecht durchsuchen */
            /* KEIN passendes Verbindungsobjekt in der Kette vorhanden */
            aTleC = new TSTileC(x,z,w); /* SteuerObjekt erstellen
              * Verbindungsobjekt fuer die Aufnahme in die waagrechte Kette
              * erstellen. Dies ist kein primaeres Objekt und hat KEINE Referenz
              * zu einem existierenden Tile-Eintrag. */
            if(bTleC==null) TCTab[j] = aTleC; /* Beginn der Kette erstellen */
            else bTleC.chgNxt(aTleC); /* Nachfolger eintragen */
            bTleC = null; /* Kennzeichen: Qbjekt wurde erstellt */
          } /* -ol- 'aTleC' enthaelt jetzt passendes uebergeordnetes Objekt */
          aTleC.chgChld(r,cTleC); /* Child einhaengen */
          if(bTleC!=null) break; /* Objekt NICHT erstellt -- Restkette schon da */
          cTleC = aTleC; /* fuer naechsten Quadranten  (hoehere Ebene) */
        } /* -for- alle Strukturgroessen bearbeiten */
      } /* -while- alle Tiles bearbeitet */

      /* Steuerdaten aufbereiten */
      gB = new TSByteArrIO(); /* create output-definition of files */
      gF = null; /* no structure-file ('.td'/'.tdl') is open */
      putTD(TCTab[0]); /* process and write all Tiles */
       /* TCTab[0] contains EXACTLY one TSTileC-structure (with QL=16384) */
      if(gF!=null) { /* control-file already/still active -- complete it */
        if((is=gF.close())!=null) /* write complete buffer to targetfile */
          Lg.Err("putTDF12",gF.getPath(),is); /* print error-message */
      } /* controlfile was successfully created */

      /* temporaere Daten zusaetzlich ausgeben */
      if(Fo.chkMsk(16)) { /* Zusaetzliche Definitionen ausgeben */
        for(i=0;i<14;i+=1) { /* alle Sub-Baeume ausgeben */
          cTleC = TCTab[i]; /* Beginn der Kette */
          while(cTleC!=null) { /* gleiches Quadrat suchen */
            Lg.Log("putTDF11",cTleC.toStr(),i); /* Datenausgabe */
            cTleC = cTleC.chgNxt(null); /* weiterschalten */
          } /* Kette durchsuchen */
        } /* alle SubBaeume */
      } /* zusaetzliche Daten ausgeben */

      cc = 17; /* Fehlerkennung vorsorglich setzen */
      if((is=gC.putData("\t)"))!=null) break sl; /* Schreib-Fehler */
      cc = 18; /* Fehlerkennung vorsorglich setzen */
      if((is=gC.putData(")"))!=null) break sl; /* Schreib-Fehler */
      cc = 19; /* preset position of error */
      is = TSLogg.getMsg("Msg100","Terrain"); /* create TSUtil-ID-Line */
      if((is=gC.putData(is))!=null) break sl; /* write-error --terminate */
      cc = 0; /* kein Fehler aufgetreten */
    } /* -sl- Break-Block fuer das Schreiben */
    if(is!=null) { /* Meldung steht noch aus */
      cc = 19; /* Kennzeichne Fehlerposition */
      Lg.Err("putTDF02",is); /* Meldung ausgeben */
    } /* Meldung musste noch ausgegeben werden */
    is = gC.close(); /* Ausgabe-Datei schliessen */
    if(is!=null) Lg.Err("putTDF02",is); /* Meldung ausgeben */

    /* alle Referenzen loeschen um 'gc' zu entlasten */
    if(TCTab!=null) /* Tabelle wurde gefuellt */
     for(i=0;i<14;i+=1) { /* alle SubBaeume bearbeiten */
      cTleC = TCTab[i]; /* Beginn der Kette */
      TCTab[i] = null; /* Adresse entwerten */
      while(cTleC!=null) { /* alle gleichen Quadrate bearbeiten */
        cTleC = cTleC.clear(); /* Referenzen loeschen und weiterschalten */
      } /* Kette bearbeiten */
    } /* alle SubBaeume  bearbeiten */

    if(cc>0) { /* Fehler beim Schreiben der Datenbank */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("putTDF05",dat.getPath(),cc,0); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 15; /* terminate function with errorcode */
    } /* Funktionsfehler */

    Lg.Log("putTDF06",gC.getStat(true));  /* print counter */
    Lg.Log("putTDF07",gC.getStat(false)); /* print length */
    Lg.Skip(false); /* Leerzeile loggen */

    return 0; /* Programm erfolgreich beendet */
  }

 /**. <pre>
  *=====================================================================
  * Methode "putTD"
  * rekursive Aufbereitung der Tile-Definitionen aus Baumstruktur
  * Methode wird ausschliesslich in 'putTDF()' benutzt!
  * ##putTD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static boolean putTD( /* Strukturquadranten aufbereiten */
   TSTileC cTle) /* aktuell zu bearbeitendes Steuerobjekt */
   {
   /*-----------------------------------------------------------------*/
    TSTileC chld;
    int     i,j,p; /* intermediate value(s) */
    String  is;    /* errormessage if applicable */
   /*=================================================================*/
    if(cTle.isLeaf()) return true; /* Ende des Baumes erreicht */
      /* mit Kennzeichen (besiedeltes Quadrat) zurueck */

    p = gB.size(); /* get current position for new controlbyte */
    if(!cTle.chkQl(512)) /* Ql<=512 -- reserve controlbyte */
      gB.write(-1); /* write dummy-controlbyte to buffer */

    j = 0; /* initialize control-byte */
    for(i=0;i<4;i+=1) { /* check all connected child-Quads */
      if((chld=cTle.chgChld(i,null))!=null) {/* child-Quad is defined */
        if(!chld.chkQl(512)) { /* Ql<=512 */
          if(chld.chkQl(256)) {  /* Ql>256  ==> QL==512 */
            /* The current child-tile, which is connected to 'cTle', has QL==512
             * ==> [QL of 'cTle']==1024
             * ==> ALL connected child-Quads must get their own controlfile (.td/.tdl)
             * Rem.: The current controlbyte is NOT used. So, 'p' is available.
             */
            if(gF!=null) { /* control-file already/still active -- complete it */
              if((is=gF.close())!=null) /* write complete buffer to targetfile */
                Lg.Err("putTDF12",gF.getPath(),is); /* print error-message */
            } /* controlfile was successfully created */
            gC.putData(chld.getId(-2)); /* write name of controlfile */
            is = chld.getId(0) + vn2; /* create filename */
              /* 'vn2' contains suffix of the file: '.td' or '.tdl' */
            gF = new TSFile$td(new File(gD,is)); /* create new output-file */
            if((is=((TSFile$td)gF).open(gB))!=null) { /* open it for output
              * and clear and init buffer */
              Lg.Err("putTDF12",gF.getPath(),is); /* print error-message */
              gF = null; /* and suppress write of data */
            } /* controlfile was successfully created */
          } /* QuadLength(QL) equals 512 */
        } /* QuadLength(QL) <= 512 */
        /* enter recursion for lower tiles */
        if(putTD(chld)) j |= 8 >> i; /* insert use-marker for child-Quad */
        else j |= 128 >> i; /* insert 'subtree-marker' for child-Quad */
      } /* current tile contains 1..4 child(s) */
    } /* -for- all connected child-Quads */
    if(cTle.chkQl(512)) return false; /* QL>512 -- do not store controlbyte */
      /* Steuerbytes fuer Quadranten mit QL>512 sind in der Datei NICHT vorhanden
       * und werden deshalb NICHT gesetzt. */
    gB.putByte(j,p); /* (over)write controlbyte to file/buffer */
    return false; /* return and signal 'valid subtree' */
  }

 /**. <pre>
  *=====================================================================
  * Method "mveTile"
  * Copy tile-definiton and connected data-files from source- to
  *   target-directory. Modify tile (names) due to tile-definition and
  *   requested actions.
  * Copy buffer-files if requested.
  * Method returns number of modified lines within*.t-file or
  *   '-1' if an error occurred.
  * Method uses (preinitialized) counter 'c4' which is incremented by
  *   the number of files, which are copied.
  * ##mveTile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int mveTile( /* copy Tile-definitions */
   TSTile    cTle, /* current Tile-Definition */
   File      sDir, /* Source-directory of files */
   File      zDir, /* Target-directory of files */
   double    dy,   /* Height-modification-value or 'NaN' */
   TSNameSet Lst, /* List of filenames ('terrain_texslot') or 'null' */
   boolean   red,  /* output data in reduced format (else: Type unchanged) */
   boolean   cpy)  /* copy buffer-files, too */
   {
   /*-----------------------------------------------------------------*/
    TSFileT cR,cW; /* Reader and Writer for tile-file */
    File    dat,datz; /* file-definitions (source/target) */
    TSBuf   cB;    /* current input-buffer for 'read/write file' */
    String  is,js,sn,zn; /* intermediate values */
    int     i,j,c; /* intermediate values/counter */
    double  y;     /* current height-value (y-value) */
    boolean err;   /* error occurred if 'true' */
   /*=================================================================*/
    is = cTle.getNme(2); /* Name der Tile-Datei (Quelle) */
    if(is==null) return -1; /* Datei existiert nicht -- Fehler */
    dat = new File(sDir,is); /* Dateibeschreibung erstellen */
    is = cTle.getNme(3); /* Name der Tile-Datei (Ziel) */
    datz = new File(zDir,is); /* Dateibeschreibung erstellen */
    js = dat.getPath(); /* Dateiname (gesamt) erstellen fuer Meldung */
    if(dat.isDirectory()) { /* es liegt keine Datei vor */
      Lg.Err("mveTle01",js); /* print termination-message */
      return -1; /* System beenden */
    } /* Datei existiert nicht */
    Lg.Msg("MsgC45",dat.getName(),is); /* print message of next actions */
    if((i=js.indexOf("Routes"))>=0) js = js.substring(i+7); /* Name kuerzen */

    cR = new TSFileT(dat); /* create input-handle of file */
    is = cR.open(TSFile.IN); /* open file for reading (copying) */
    if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
      Lg.Err("mveTle02",is); /* print termination-message */
      return -1; /* System beenden */
    } /* Fehler beim Oeffnen der Datei */
    i = cR.getMode(TSFile.OUT); /* get/mod current input-mode (file-format) */
    if(red) i = TSFile.OUB; /* change to UB-Format if requested */
    cW = new TSFileT(datz); /* create output-handle of file */
    is = cW.open(i); /* open file for output using requested format */
    if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
      cR.close(); /* Eingabe-Datei wieder schliessen */
      Lg.Err("mveTle02",is); /* print termination-message */
      return -1; /* System beenden */
    } /* Fehler beim Oeffnen der Datei */
 if(PrMsk.chkMsk(28)) /* print Filenames with IO-Modes */ // ##!D
    Lg.Log("mveTle19",cR.getPath(),cR.prtMode(),cW.getPath(),cW.prtMode());

    c = 0; /* initialize counter (number of changes) */
    err = true; /* preset: error occurred */
    cB = new TSBuf(cR,cW); /* create buffer-control (input/output) */
      /* line -mode is used so that data may be modified */
    cl: { /* read/write-loop (Break-Block/copy-loop) */
      while(!cB.getNext(false)) { /* copy all records (read/write) */
        is = cB.getKE(true); /* get keyword-expression of line */
        if(is==null) { /* no data available */
          is = cB.getErr(); /* get current errormessage */
          if(is!=null) continue; /* no keyword found -- copy normal line */
          Lg.Err("mveTle04",js,cR.getStat(true)); /* EOF reached */
          break cl; /* terminate copy of file */
        } /* data was not available */
        if(is.equals("terrain_sample_ybuffer")) { /* valid keyword -- process line */
          cB.mark(false); /* mark current position for replace */
          sn = cB.getVal(1); /* get original file-name */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("mveTle11",js,"terrain_sample_ybuffer",is); /* print error */
            break cl; } /* terminate copy of file */
          if(sn.length()==0) { /* file-name not specified */
            Lg.Err("mveTle12",js,"terrain_sample_ybuffer",cR.getStat(true)); /* print error */
            break cl; } /* terminate copy of file */
          zn = cTle.getNme(4); /* get filename of Tile-datafile (y-Source) */
          if(!sn.equalsIgnoreCase(zn)) /* original filename has been modified */
            Lg.Log("mveTle13",js,"terrain_sample_ybuffer",zn,sn); /* report change */
          zn = cTle.getNme(5); /* get filename of Tile-datafile (y-Target) */
          if(cB.modData(" "+zn)) { /* error during replacement */
            Lg.Err("mveTle14",js,"terrain_sample_ybuffer",cR.getStat(true)); /* errormessage */
            break cl; } /* terminate copy of file */
          c += 1; /* count modification */
          dat = new File(sDir,sn); /* create file-reference of source-file */
          if(dat.exists()) { /* file exists -- copy it */
            sn = dat.getAbsolutePath(); /* get full name of Source-file */
            dat = new File(zDir,zn); /* create file-reference of target-file */
            zn = dat.getAbsolutePath(); /* and get full name of Target-file */
            /* copy file (*_y.raw) using new file-name as the target */
            sn = "copy \""+sn+"\" \""+zn+"\" "; /* create copy-command */
            if((i=exec(true,sn,null,null))>0) /* error while executing */
              Lg.Log("MsgC50",zn,i); /* print error-message */
            else c4 += 1; /* count copied file */
          } else Lg.Err("mveTle15",js,"terrain_sample_ybuffer",sn,""+cR.getStat(true));
            /* file not found -- skip copy and report it */
        } else if(is.equals("terrain_sample_fbuffer")) { /* valid keyword -- process line */
          cB.mark(false); /* mark current position for replace */
          sn = cB.getVal(1); /* get original file-name */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("mveTle11",js,"terrain_sample_fbuffer",is); /* print error */
            break cl; } /* terminate copy of file */
          if(sn.length()==0) { /* file-name not specified */
            Lg.Err("mveTle12",js,"terrain_sample_fbuffer",cR.getStat(true)); /* print error */
            break cl; } /* terminate copy of file */
          zn = cTle.getNme(6); /* get filename of Tile-datafile (f-Source) */
          if(!sn.equalsIgnoreCase(zn)) /* original filename has been modified */
            Lg.Log("mveTle13",js,"terrain_sample_fbuffer",zn,sn); /* report change */
          zn = cTle.getNme(7); /* get filename of Tile-datafile (f-Target) */
          if(cB.modData(" "+zn)) { /* error during replacement */
            Lg.Err("mveTle14",js,"terrain_sample_fbuffer",cR.getStat(true)); /* errormessage */
            break cl; } /* terminate copy of file */
          c += 1; /* count modification */
          dat = new File(sDir,sn); /* create file-reference of source-file */
          if(dat.exists()) { /* file exists -- copy it */
            sn = dat.getAbsolutePath(); /* get full name of Source-file */
            dat = new File(zDir,zn); /* create file-reference of target-file */
            zn = dat.getAbsolutePath(); /* and get full name of Target-file */
            /* copy file (*_f.raw) using new file-name as the target */
            sn = "copy \""+sn+"\" \""+zn+"\" "; /* create copy-command */
            if((i=exec(true,sn,null,null))>0) /* error while executing */
              Lg.Log("MsgC50",zn,i); /* print error-message */
            else c4 += 1; /* count copied file */
          } else Lg.Err("mveTle15",js,"terrain_sample_fbuffer",sn,""+cR.getStat(true));
            /* file not found -- skip copy and report it */
        } else if(is.equals("terrain_sample_ebuffer")) le:{ /* valid keyword -- process line */
          cB.mark(false); /* mark current position for replace */
          sn = cB.getVal(1); /* get original file-name */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("mveTle11",js,"terrain_sample_ebuffer",is); /* print error */
            break cl; } /* terminate copy of file */
          if(sn.length()==0) { /* file-name not specified */
            Lg.Err("mveTle12",js,"terrain_sample_ebuffer",cR.getStat(true)); /* print error */
            break cl; } /* terminate copy of file */
          zn = cTle.getNme(8); /* get filename of Tile-datafile (e-Source) */
          if(!sn.equalsIgnoreCase(zn)) /* original filename has been modified */
            Lg.Log("mveTle13",js,"terrain_sample_ebuffer",zn,sn); /* report change */
          zn = cTle.getNme(9); /* get filename of Tile-datafile (e-Target) */
          if(cB.modData(" "+zn)) { /* error during replacement */
            Lg.Err("mveTle14",js,"terrain_sample_ebuffer",cR.getStat(true)); /* errormessage */
            break cl; } /* terminate copy of file */
          c += 1; /* count modification */
          if(!cpy) break le; /* filename changed -- do not copy buffer */
          dat = new File(sDir,sn); /* create file-reference of source-file */
          if(dat.exists()) { /* file exists -- copy it */
            sn = dat.getAbsolutePath(); /* get full name of Source-file */
            dat = new File(zDir,zn); /* create file-reference of target-file */
            zn = dat.getAbsolutePath(); /* and get full name of Target-file */
            /* copy file (*_e.raw) using new file-name as the target */
            sn = "copy \""+sn+"\" \""+zn+"\" "; /* create copy-command */
            if((i=exec(true,sn,null,null))>0) /* error while executing */
              Lg.Log("MsgC50",zn,i); /* print error-message */
            else c4 += 1; /* count copied file */
          } else Lg.Err("mveTle15",js,"terrain_sample_ebuffer",sn,""+cR.getStat(true));
            /* file not found -- skip copy and report it */
        } else if(is.equals("terrain_sample_nbuffer")) ln:{ /* valid keyword -- process line */
          cB.mark(false); /* mark current position for replace */
          sn = cB.getVal(1); /* get original file-name */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("mveTle11",js,"terrain_sample_nbuffer",is); /* print error */
            break cl; } /* terminate copy of file */
          if(sn.length()==0) { /* file-name not specified */
            Lg.Err("mveTle12",js,"terrain_sample_nbuffer",cR.getStat(true)); /* print error */
            break cl; } /* terminate copy of file */
          zn = cTle.getNme(10); /* get filename of Tile-datafile (n-Source) */
          if(!sn.equalsIgnoreCase(zn)) /* original filename has been modified */
            Lg.Log("mveTle13",js,"terrain_sample_nbuffer",zn,sn); /* report change */
          zn = cTle.getNme(11); /* get filename of Tile-datafile (n-Target) */
          if(cB.modData(" "+zn)) { /* error during replacement */
            Lg.Err("mveTle14",js,"terrain_sample_nbuffer",cR.getStat(true)); /* errormessage */
            break cl; } /* terminate copy of file */
          c += 1; /* count modification */
          if(!cpy) break ln; /* filename changed -- do not copy buffer */
          dat = new File(sDir,sn); /* create file-reference of source-file */
          if(dat.exists()) { /* file exists -- copy it */
            sn = dat.getAbsolutePath(); /* get full name of Source-file */
            dat = new File(zDir,zn); /* create file-reference of target-file */
            zn = dat.getAbsolutePath(); /* and get full name of Target-file */
            /* copy file (*_n.raw) using new file-name as the target */
            sn = "copy \""+sn+"\" \""+zn+"\" "; /* create copy-command */
            if((i=exec(true,sn,null,null))>0) /* error while executing */
              Lg.Log("MsgC50",zn,i); /* print error-message */
            else c4 += 1; /* count copied file */
          } else Lg.Err("mveTle15",js,"terrain_sample_nbuffer",sn,""+cR.getStat(true));
            /* file not found -- skip copy and report it */
        } else if(is.equals("terrain_sample_cbuffer")) { /* valid keyword -- process line */
          cB.mark(false); /* mark current position for replace */
          sn = cB.getVal(1); /* get original file-name */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("mveTle11",js,"terrain_sample_cbuffer",is); /* print error */
            break cl; } /* terminate copy of file */
          if(sn.length()==0) { /* file-name not specified */
            Lg.Err("mveTle12",js,"terrain_sample_cbuffer",cR.getStat(true)); /* print error */
            break cl; } /* terminate copy of file */
          zn = cTle.getNme(12); /* get filename of Tile-datafile (c-Source) */
          if(!sn.equalsIgnoreCase(zn)) /* original filename has been modified */
            Lg.Log("mveTle13",js,"terrain_sample_cbuffer",zn,sn); /* report change */
          zn = cTle.getNme(13); /* get filename of Tile-datafile (c-Target) */
          if(cB.modData(" "+zn)) { /* error during replacement */
            Lg.Err("mveTle14",js,"terrain_sample_cbuffer",cR.getStat(true)); /* errormessage */
            break cl; } /* terminate copy of file */
          c += 1; /* count modification */
          dat = new File(sDir,sn); /* create file-reference of source-file */
          if(dat.exists()) { /* file exists -- copy it */
            sn = dat.getAbsolutePath(); /* get full name of Source-file */
            dat = new File(zDir,zn); /* create file-reference of target-file */
            zn = dat.getAbsolutePath(); /* and get full name of Target-file */
            /* copy file (*_c.raw) using new file-name as the target */
            sn = "copy \""+sn+"\" \""+zn+"\" "; /* create copy-command */
            if((i=exec(true,sn,null,null))>0) /* error while executing */
              Lg.Log("MsgC50",zn,i); /* print error-message */
            else c4 += 1; /* count copied file */
          } else Lg.Err("mveTle15",js,"terrain_sample_cbuffer",sn,""+cR.getStat(true));
            /* file not found -- skip copy and report it */
        } else if(is.equals("terrain_sample_dbuffer")) { /* valid keyword -- process line */
          cB.mark(false); /* mark current position for replace */
          sn = cB.getVal(1); /* get original file-name */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("mveTle11",js,"terrain_sample_dbuffer",is); /* print error */
            break cl; } /* terminate copy of file */
          if(sn.length()==0) { /* file-name not specified */
            Lg.Err("mveTle12",js,"terrain_sample_dbuffer",cR.getStat(true)); /* print error */
            break cl; } /* terminate copy of file */
          zn = cTle.getNme(14); /* get filename of Tile-datafile (d-Source) */
          if(!sn.equalsIgnoreCase(zn)) /* original filename has been modified */
            Lg.Log("mveTle13",js,"terrain_sample_dbuffer",zn,sn); /* report change */
          zn = cTle.getNme(15); /* get filename of Tile-datafile (d-Target) */
          if(cB.modData(" "+zn)) { /* error during replacement */
            Lg.Err("mveTle14",js,"terrain_sample_dbuffer",cR.getStat(true)); /* errormessage */
            break cl; } /* terminate copy of file */
          c += 1; /* count modification */
          dat = new File(sDir,sn); /* create file-reference of source-file */
          if(dat.exists()) { /* file exists -- copy it */
            sn = dat.getAbsolutePath(); /* get full name of Source-file */
            dat = new File(zDir,zn); /* create file-reference of target-file */
            zn = dat.getAbsolutePath(); /* and get full name of Target-file */
            /* copy file (*_d.raw) using new file-name as the target */
            sn = "copy \""+sn+"\" \""+zn+"\" "; /* create copy-command */
            if((i=exec(true,sn,null,null))>0) /* error while executing */
              Lg.Log("MsgC50",zn,i); /* print error-message */
            else c4 += 1; /* count copied file */
          } else Lg.Err("mveTle15",js,"terrain_sample_dbuffer",sn,""+cR.getStat(true));
            /* file not found -- skip copy and report it */
        } else if(is.equals("terrain_sample_floor")) lsf:{ /* valid keyword -- process line */
          if(Double.isNaN(dy)) break lsf; /* Height-modification is NOT requested */
          cB.mark(false); /* mark current position for replace */
          y = cB.getFV(); /* get current height-value */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("mveTle21",js,is,cR.getStat(true)); /* print errormessage */
            break cl; } /* terminate copy of file */
          if(cB.modData(putFV(y+dy,0))) { /* error during replacement */
            Lg.Err("mveTle22",js,cR.getStat(true)); /* print errormessage */
            break cl; } /* terminate copy of file */
          c += 1; /* count modification */
        } else if(is.equals("terrain_water_height_offset")) lwh:{ /* valid keyword -- process line */
          if(Double.isNaN(dy)) break lwh; /* Height-modification is NOT requested */
          cB.mark(false); /* mark current position for replace */
          y = cB.getFV(); /* get current height-value */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("mveTle31",js,is,cR.getStat(true)); /* print errormessage */
            break cl; } /* terminate copy of file */
          if(cB.modData(putFV(y+dy,0))) { /* error during replacement */
            Lg.Err("mveTle32",js,cR.getStat(true)); /* print errormessage */
            break cl; } /* terminate copy of file */
          cB.mark(false); /* mark current position for next replace */
          y = cB.getFV(); /* get next height-value */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            if(y!=2e99) { /* 'value not found' is allowed in this case */
              Lg.Err("mveTle33",js,is,cR.getStat(true)); /* print errormessage */
              break cl; } /* terminate copy of file */
          } else { /* additional valid height-specifications found */
            if(cB.modData(putFV(y+dy,0))) { /* error during replacement */
              Lg.Err("mveTle32",js,cR.getStat(true)); /* print errormessage */
              break cl; } /* terminate copy of file */
            cB.mark(false); /* mark next position for replace */
            y = cB.getFV(); /* get next height-value */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("mveTle34",js,is,cR.getStat(true)); /* print errormessage */
              break cl; } /* terminate copy of file */
            if(cB.modData(putFV(y+dy,0))) { /* error during replacement */
              Lg.Err("mveTle32",js,cR.getStat(true)); /* print errormessage */
              break cl; } /* terminate copy of file */
            cB.mark(false); /* mark next position for replace */
            y = cB.getFV(); /* get next height-value */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("mveTle35",js,is,cR.getStat(true)); /* print errormessage */
              break cl; } /* terminate copy of file */
            if(cB.modData(putFV(y+dy,0))) { /* error during replacement */
              Lg.Err("mveTle32",js,cR.getStat(true)); /* print errormessage */
              break cl; } /* terminate copy of file */
          } /* additional height-values are processed */
          c += 1; /* count modification */
        } else if(is.equals("terrain_patchset_patch")) lpp:{ /* valid keyword -- process line */
          if(Double.isNaN(dy)) break lpp; /* Height-modification is NOT requested */
          cB.getHV(8); /* skip flags (Hex-number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("mveTle41",js,is,cR.getStat(true)); /* print errormessage */
            break cl; } /* terminate copy of file */
          cB.getFV(); /* get next value and check it */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("mveTle42",js,is,cR.getStat(true)); /* print errormessage */
            break cl; } /* terminate copy of file */
          cB.mark(false); /* mark current position for replace */
          y = cB.getFV(); /* get next height-value and check it */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("mveTle42",js,is,cR.getStat(true)); /* print errormessage */
            break cl; } /* terminate copy of file */
          if(cB.modData(putFV(y+dy,0))) { /* error during replacement */
            Lg.Err("mveTle43",js,cR.getStat(true)); /* print errormessage */
            break cl; } /* terminate copy of file */
          c += 1; /* count modification */
        } else if(is.equals("terrain_texslot")) ltt:{ /* valid keyword -- process line */
          if(Lst==null) break ltt; /* Action is NOT requested */
          sn = cB.getVal(1); /* get original file-name */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("mveTle51",js,is,cR.getStat(true)); /* print errormessage */
            break cl; } /* terminate copy of file */
          if(sn.length()==0) { /* file-name not specified */
            Lg.Err("mveTle52",js,cR.getStat(true)); /* print errormessage */
            break cl; } /* terminate copy of file */
          Lst.add(sn); /* insert filename of terrain into 'List' (only) */
        } /* no keyword to process -- just copy line */
      } /* -while- copy all lines and process them */
      if((is=cB.getErr())!=null) /* error while reading/writing */
        Lg.Err("mveTle03",is,cR.getStat(true)); /* print errormessage */
      else err = false; /* OK -- no error occurred */
    } /* -cl- Break-Block used for terminating read/write */
    is = cW.close(); /* close output-file again */
    if(is!=null) Lg.Err("mveTle02",is); /* print errormessage */
    is = cR.close(); /* close input-file again */
    if(is!=null) Lg.Err("mveTle02",is); /* print errormessage */

    if(err) c = -1; /* set marker, if error was found */
    return c; /* method (successfully) completed */
  }

 /**. <pre>
  *=====================================================================
  * Method "cpyTile"
  * Copy ALL valid Tile-definitions from source-directory to
  *   target-directory. Include buffer-files if requested.
  * ACHTUNG: - 'mveTile' nutzt den Zaehler 'c4'.
  *    'c4' wird um Anzahl der bearbeiteten Tile-Dateien erhoeht!
  * Attention: If a tile is flagged, it is NOT copied.
  * ##cpyTile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String cpyTile( /* copy Tile-definitions */
   TSRoute cRte, /* current Route-definition */
   boolean TleT, /* Type of Tile-definitions (LO-Tile='true') */
   boolean cpyB) /* request copy of buffer-files if 'true' */
   {
   /*-----------------------------------------------------------------*/
    File             sdir,zdir; /* File-definitions (source,target) */
    TSTile           cTle; /* current Tile-definition */
    Iterator<TSTile> cI;   /* Iterator for tiles */
   /*=================================================================*/
    zdir = cRte.getFile(TleT?49:48); /* Target-path of tile-files */
    if(zdir==null) /* Folder cannot be created -- return with error */
      return TSLogg.getMsg("MsgC63",cRte.getInfo(TleT?49:48));
    sdir = cRte.getFile(TleT?19:18); /* Source-path of tile-def. */
    /* copy  ALL requested Tile-definitions */
    cI = cRte.getIt(TleT?11:10); /* get Iterator of Tile-definitions */
    while(cI.hasNext()) { /* More definitions available ? */
      cTle = cI.next(); /* get next Tile-definition */
      if(cTle.chgFlag(0)) continue; /* do not copy marked tiles */
      mveTile(cTle,sdir,zdir,Double.NaN,null,false,cpyB);
        /* Copy Tile-file including raw data-file. DO NOT change
         * fileformat of files. Copy buffer-files if requested.
         */
    } /* copy ALL Tile-definitions */
    return null; /* ALL Tile-files were successfully copied */
  }

 /**. <pre>
  *=====================================================================
  * Method "getActF"
  * Load ALL Activity-Definitions of a route into memory
  * ##getActF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getActF( /* Activity-Definitionen laden */
   TSRoute cRte, /* Routendefinition mit Basisverzeichnis */
   boolean nocr) /* do not create directory if not available */
   {
   /*-----------------------------------------------------------------*/
    File                    dir,dat; /* file-definitons */
    TSFileX                 cF;     /* current input-file-handle */
    TSFleMask               cM;     /* current file-mask */
    TSBuf                   cB;     /* current input-buffer for 'read file' */
    String[]                fl;     /* List of input-files */
    TreeMap<String,TSAct>   Act;    /* Instance of Activity-Definitions */
    TSAct                   cAct;   /* current Activity-Definition */
    ArrayList<TSXtSrv>      TrfT;   /* Traffic-Service-Definition */
    TSXtSrv                 cSrv;   /* curr. (extended) Service-Definition (Player) */
    TreeSet<TSActEv>        EvT;    /* List of 'Event'-References */
    ArrayList<TSActAO>      AObjT;  /* List of AO-References */
    TSActAO                 cAO;    /* current reference-element */
    ArrayList<TSActSZ>      RSZT;   /* List of (RSZne-)References */
    TSActSZ                 cRSZ;   /* current reference-element */
    ArrayList<TSRefC>       RefT;   /* Table of (TrItem-)References */
    TSRefC                  cRef;   /* current reference-element */
    TreeMap<String,TSTrain> Trn;    /* current table of train-references */
    TSTrain                 cTrn;   /* current reference to train */
    TSQPos                  cPos;   /* current definiton of a 'position' */
    String[]                cL;     /* temporary String-Array (list) */
    String                  is;     /* intermediate values */
    String                  Typ,Typ1; /* name of keywords (for messages) */
    int                     i,j,n,l1,l2,l3,l4,l5,l6;
    int                     ec,cc,cf,ce,tn; /* intermediate values */
   /*=================================================================*/
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("getAct01",cRte.getInfo(1)); /* Aktionsmeldung ausgeben */

    dir = cRte.getFile(11); /* File-Referenz fuer Verzeichnis */
    if(dir==null) { /* Keine Verzeichnis-Definition erstellbar */
      Lg.Msg("getAct02"); /* Fehler melden --  Bearbeitung abbrechen */
      Lg.Close(); /* close output to Log-file */
      return 11; /* terminate function with errorcode */
    } /* Datei existiert nicht */
    if(!dir.exists()) { /* Verzeichnis nicht gefunden */
      Lg.Msg("getAct03",dir.getPath()); /* Fehler melden */
      if(nocr) return -1; /* terminate function with marker */
      if(!dir.mkdirs()) Lg.Msg("getAct11"); /* print message */
        /* try to create folder and print error if unsuccessful-- error? */
      return -2; /* terminate function with marker */
    } /* Datei existiert nicht */
    cM = new TSFleMask(false,".*\\.act"); /* select activity-files */
    if((is=cM.getErr())!=null) { /* error within file-mask */
      Lg.Skip(false); /* print empty line to LOG-file */
      Lg.Msg("getAct05",is); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* error found -- function terminated */
    fl = dir.list((FilenameFilter)cM); /* create list of ALL files */
      /* result contains NO directories! */
    if(fl==null) { /* Source-is not a directory */
      Lg.Msg("getAct04",dir.getPath()); /* print terminating-message */
      Lg.Close(); /* close output to Log-file */
      return 11; /* terminate function with errorcode */
    } /* source-directory missing */

    cf = ce = 0; /* init file-counter, overall errors */
    Act = cRte.getAct(); /* get/create storage for activity-services and init */
    Trn = cRte.getTrain(); /* get/create storage for train-definitions and init */
    for(String fn:fl) { /* process all selected file-definitions */
      dat = new File(dir,fn); /* create file-reference (source) */
      cf += 1; /* and count valid file */
      Lg.Log("MsgC54",dat.getAbsolutePath(),DF3.format(cf));

      /* open Input-file (TSFileX) */
      cF = new TSFileX(TSFileX.FT$act,dat); /* create input-control-handle */
      is = cF.open(false); /* and open file using input-mode */
      if(is!=null) { /* error during open of file */
        Lg.Err("getAct05",is); /* print terminating message */
        continue; /* process next file */
      } /* error during open of file */
      cB = new TSBuf(cF); /* create inputline (file-mode) and init counter */

      cAct = new TSAct(fn,dat); /* create activity-entry (Basis) */

      cc = 0; /* Compiler needs it */
      ec = 0; /* preset: no error found */
      tn = 0; /* preset current number of static train */
      bl: { /* Break-Block (used with errors) */
        is = cB.getKE(true); /* get first controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getAct15"); /* print errormessage */
            cc = 5; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getAct16",is); /* print errormessage */
          cc = 6; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) { /* next keword not present */
          Lg.Err("getAct17"); /* print errormessage */
          cc = 7; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(!is.equals("tr_activity")) { /* 'Tr_Activity' not found */
          Lg.Err("getAct18",is); /* print errormessage */
          cc = 8; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        l1 = cB.getBrL(); /* current bracket-level for terminate */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getAct21"); /* print errormessage */
            cc = 11; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getAct22",is); /* print errormessage */
          cc = 12; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) { /* next keword not present */
          Lg.Err("getAct23"); /* print errormessage */
          cc = 13; /* set current return-code to error */
          break bl; } /* terminate evaluation */

        if(is.equals("serial")) { /* Entry 'Serial' found (optional) */
          i = (int)cB.getNV(); /* get Serial-Nummer */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getAct24",is,cB.getStat(true)); /* print errormessage */
            cc = 15; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          if(i<1) { /* invalid value for 'Serial' */
            Lg.Err("getAct25",null,i,cB.getStat(true)); /* print errormessage */
            i = 1; /* use default-value (Nummer aktivieren) */
          } /* invalid value for 'Serial' */
          cAct.setInt(0,i); /* insert Serial-Nummer (TSData) */
          cAct.setMsk(0); /* mark entry as 'found' */
          /* entry 'serial' processed -- skip to next keyword and extract it */
          if(cB.skpFwd()) { /* skip resuming data -- EOF/error found? */
            cc = 16; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          is = cB.getKE(true); /* get next controlword */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getAct21"); /* print errormessage */
              cc = 17; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getAct22",is); /* print errormessage */
            cc = 18; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          if(is.length()==0) { /* next keword not present */
            Lg.Err("getAct23"); /* print errormessage */
            cc = 19; /* set current return-code to error */
            break bl; } /* terminate evaluation */
        } /* 'Serial' found and processed */

        if(!is.equals("tr_activity_header")) { /* 'Tr_Activity_Header' NOT found */
          Lg.Err("getAct26",is,"Tr_Activity_Header",cB.getStat(true));
          cc = 21; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        l2 = cB.getBrL(); /* current bracket-level for terminate */
        while(true) { /* process all lines within 'Header' */
          is = cB.getKE(true); /* get next controlword */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getAct31",cB.getStat(true)); /* print errormessage */
              cc = 22; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getAct32",is); /* print errormessage */
            cc = 23; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          if(is.length()==0) break; /* all entries processed */
          dhl:{ /* break-Block, used if error found */
            if(is.equals("routeid")) { /* Definition-type: 'RouteID' */
              Typ = "RouteID"; /* set 'name' of keyword */
              is = cB.getVal(1); /* get value of argument */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getAct41",Typ,0,cB.getStat(true)); /* print errormessage */
                  cc = 31; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getAct42",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 32; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(is.length()==0) { /* next keword not present */
                Lg.Err("getAct43",Typ,0,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              if((is=cAct.setDta(0,is))!=null) /* Route-ID already set */
                Lg.Err("getAct44",Typ,is,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(1); /* mark entry as 'found' */
            } else if(is.equals("name")) { /* Definition-type: 'Name' */
              Typ = "Name"; /* set 'name' of keyword */
              is = cB.getVal(1); /* get value of argument */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getAct41",Typ,0,cB.getStat(true)); /* print errormessage */
                  cc = 33; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getAct42",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 34; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(is.length()==0) { /* next keword not present */
                Lg.Err("getAct43",Typ,0,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              if((is=cAct.chgNme(is))!=null) /* insert 'name' into storage */
                Lg.Err("getAct44",Typ,is,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(2); /* mark entry as 'found' */
            } else if(is.equals("description")) { /* Definition-type: 'Description' */
              Typ = "Description"; /* set 'name' of keyword */
              /* Attention: message may contain MORE than one line */
              cL = cB.getArr(); /* get value of argument  (message-array) */
              if(cL==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getAct41",Typ,0,cB.getStat(true)); /* print errormessage */
                  cc = 35; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getAct42",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 36; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((cL=cAct.setDesc(cL))!=null) /* insert description into storage */
                Lg.Err("getAct47",Typ,null,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(3); /* mark entry as 'found' */
            } else if(is.equals("briefing")) { /* Definition-type: 'Briefing' */
              Typ = "Briefing"; /* set 'name' of keyword */
              /* Attention: message may contain MORE than one line */
              cL = cB.getArr(); /* get value of argument  (message-array) */
              if(cL==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getAct41",Typ,0,cB.getStat(true)); /* print errormessage */
                  cc = 37; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getAct42",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 38; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((cL=cAct.setBrief(cL))!=null) /* insert briefing into storage */
                Lg.Err("getAct47",Typ,null,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(4); /* mark entry as 'found' */
            } else if(is.equals("completeactivity")) { /* Definition-type: 'CompleteActivity' */
              Typ = "CompleteActivity"; /* set 'name' of keyword */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 39; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>1) { /* invalid value for 'CompleteActivity' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","1");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              if((i=cAct.setInt(2,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
                Lg.Err("getAct44",Typ,i,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(5); /* mark entry as 'found' */
            } else if(is.equals("type")) { /* Definition-type: 'Type' */
              Typ = "Type"; /* set 'name' of keyword */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 40; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>2) { /* invalid value for 'Type' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","2");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              if((i=cAct.setInt(3,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
                Lg.Err("getAct44",Typ,i,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(6); /* mark entry as 'found' */
            } else if(is.equals("mode")) { /* Definition-type: 'Mode' */
              Typ = "Mode"; /* set 'name' of keyword */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 41; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>2) { /* invalid value for 'Mode' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","2");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              if((i=cAct.setInt(4,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
                Lg.Err("getAct44",Typ,i,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(7); /* mark entry as 'found' */
            } else if(is.equals("starttime")) { /* Definition-type: 'StartTime' */
              Typ = "StartTime"; /* set 'name' of keyword */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 42; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>23) { /* invalid value for 'StartTime' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","23");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              j = i * 60; /* convert hours to minutes */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 43; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>59) { /* invalid value for 'StartTime' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","59");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              j += i; /* add minutes and */
              j *= 60; /* convert into seconds */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 44; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>59) { /* invalid value for 'StartTime' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","59");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              j += i; /* add seconds */
              if((i=cAct.setInt(5,j))!=Integer.MIN_VALUE) /* value already set -- replaced */
                Lg.Err("getAct44",Typ,i,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(8); /* mark entry as 'found' */
            } else if(is.equals("season")) { /* Definition-type: 'Season' */
              Typ = "Season"; /* set 'name' of keyword */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 45; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>3) { /* invalid value for 'Season' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","3");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              if((i=cAct.setInt(6,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
                Lg.Err("getAct44",Typ,i,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(9); /* mark entry as 'found' */
            } else if(is.equals("weather")) { /* Definition-type: 'Weather' */
              Typ = "Weather"; /* set 'name' of keyword */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 46; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>2) { /* invalid value for 'Weather' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","2");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              if((i=cAct.setInt(7,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
                Lg.Err("getAct44",Typ,i,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(10); /* mark entry as 'found' */
            } else if(is.equals("pathid")) { /* Definition-type: 'PathID' */
              Typ = "PathID"; /* set 'name' of keyword */
              if(cAct.chkMsk(11)) { /* definition was already present */
                Lg.Err("getAct4A",Typ,0,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              is = cB.getVal(1); /* get value of argument */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getAct41",Typ,0,cB.getStat(true)); /* print errormessage */
                  cc = 47; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getAct42",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 48; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(is.length()==0) { /* next keword not present */
                Lg.Err("getAct43",Typ,0,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              if((is=cAct.chgPNme(is))!=null) /* insert 'name' into storage */
                Lg.Err("getAct44",Typ,is,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(11); /* mark entry as 'found' */
            } else if(is.equals("startingspeed")) { /* Definition-type: 'StartingSpeed' */
              Typ = "StartingSpeed"; /* set 'name' of keyword */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 49; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i!=0) { /* invalid value for 'StartingSpeed' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","0");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              cAct.setMsk(12); /* mark entry as 'found' */
            } else if(is.equals("duration")) { /* Definition-type: 'Duration' */
              Typ = "Duration"; /* set 'name' of keyword */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 50; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>23) { /* invalid value for 'Duration' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","23");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              l4 = i * 60; /* convert hours to minutes */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 51; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>59) { /* invalid value for 'Duration' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","59");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              l4 += i; /* add minutes */
              if((i=cAct.setInt(8,l4))!=Integer.MIN_VALUE) /* value already set -- replaced */
                Lg.Err("getAct44",Typ,i,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(13); /* mark entry as 'found' */
            } else if(is.equals("difficulty")) { /* Definition-type: 'Difficulty' */
              Typ = "Difficulty"; /* set 'name' of keyword */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 52; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>2) { /* invalid value for 'Difficulty' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","2");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              if((i=cAct.setInt(9,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
                Lg.Err("getAct44",Typ,i,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(14); /* mark entry as 'found' */
            } else if(is.equals("animals")) { /* Definition-type: 'Animals' */
              Typ = "Animals"; /* set 'name' of keyword */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 53; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>100) { /* invalid value for 'Animals' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","100");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              if((i=cAct.setInt(10,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
                Lg.Err("getAct44",Typ,i,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(15); /* mark entry as 'found' */
            } else if(is.equals("workers")) { /* Definition-type: 'Workers' */
              Typ = "Workers"; /* set 'name' of keyword */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 54; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>100) { /* invalid value for 'Workers' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","100");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              if((i=cAct.setInt(11,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
                Lg.Err("getAct44",Typ,i,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(16); /* mark entry as 'found' */
            } else if(is.equals("fuelwater")) { /* Definition-type: 'FuelWater' */
              Typ = "FuelWater"; /* set 'name' of keyword */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 55; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>100) { /* invalid value for 'FuelWater' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","100");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              if((i=cAct.setInt(12,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
                Lg.Err("getAct44",Typ,i,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(17); /* mark entry as 'found' */
            } else if(is.equals("fuelcoal")) { /* Definition-type: 'FuelCoal' */
              Typ = "FuelCoal"; /* set 'name' of keyword */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 56; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>100) { /* invalid value for 'FuelCoal' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","100");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              if((i=cAct.setInt(13,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
                Lg.Err("getAct44",Typ,i,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(18); /* mark entry as 'found' */
            } else if(is.equals("fueldiesel")) { /* Definition-type: 'FuelDiesel' */
              Typ = "FuelDiesel"; /* set 'name' of keyword */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct48",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 57; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>100) { /* invalid value for 'FuelDiesel' */
                Lg.Err("getAct49",Typ,""+i,""+cB.getStat(true),"0","100");
                ec += 1; /* count error */
                break dhl; } /* terminate evaluation of entry */
              if((i=cAct.setInt(14,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
                Lg.Err("getAct44",Typ,i,cB.getStat(true)); /* print errormessage */
              cAct.setMsk(19); /* mark entry as 'found' */
            } else { /* unknown keyword -- do not process */
              Lg.Err("getAct33",is,0,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
            } /* unknown keyword found ('break dhl' is not needed) */
          } /* 'dhl' - break-block for errors */
          if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
            Lg.Err("getAct34",cB.getStat(true)); /* print errormessage */
            cc = 24; /* set current return-code to error */
            break bl; } /* terminate evaluation */
        } /* -while- process all 'Header'-Definitions */
        if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
          Lg.Err("getAct27",cB.getStat(true)); /* print errormessage */
          cc = 25; /* set current return-code to error */
          break bl; } /* terminate evaluation */

        /* header processed -- next part: 'Tr_Activity_File'-section */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getAct21"); /* print errormessage */
            cc = 61; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getAct22",is); /* print errormessage */
          cc = 62; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) { /* next keword not present */
          Lg.Err("getAct23"); /* print errormessage */
          cc = 63; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(!is.equals("tr_activity_file")) { /* 'Tr_Activity_File' NOT found */
          Lg.Err("getAct26",is,"Tr_Activity_File",cB.getStat(true));
          cc = 64; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        l2 = cB.getBrL(); /* current bracket-level for terminate */
        while(true) { /* process all lines within 'File' */
          is = cB.getKE(true); /* get next controlword */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getAct35",cB.getStat(true)); /* print errormessage */
              cc = 65; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getAct36",is); /* print errormessage */
            cc = 66; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          if(is.length()==0) break; /* all entries processed */
          l3 = cB.getBrL(); /* current bracket-level for terminate/break */
          dfl:{ /* break-Block, used if error found */
            if(is.equals("player_service_definition")) { /* Def-type: 'Player_Service_Definition' */
              Typ = "Player_Service_Definition"; /* set 'name' of keyword */
              is = cB.getVal(1); /* get value of argument (name of 'Player-service') */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getAct51",Typ,cB.getStat(true)); /* print errormessage */
                  cc = 71; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getAct52",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 72; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(is.length()==0) { /* next keword not present */
                Lg.Err("getAct53",Typ,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dfl; } /* terminate evaluation of entry */
              cSrv = new TSXtSrv(is); /* create Service-Definition 'Player' */
              /* get all service-definitons (incl. traffic-part) and match them */
              i = getActDef(cB,cSrv,ec,Typ,"P_S_D("); /* get service-definitions */
              if(i>0) { /* error within procedure */
                cc = 72 + i; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              ec = ((Integer)RetVal).intValue(); /* set new current value */
              if((cSrv=cAct.chgSrv(cSrv))!=null) /* service-definition already set */
                Lg.Err("getAct57",Typ,0,cB.getStat(true)); /* print errormessage */
              /* closing bracket is skipped with next 'cB.skpFwd(l3)'-command */
            } else if(is.equals("nextserviceuid")) { /* Definition-type: 'NextServiceUID' */
              Typ = "NextServiceUID"; /* set 'name' of keyword */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct58",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 91; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0) { /* invalid value for 'NextServiceUID' */
                Lg.Err("getAct56",Typ,i,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dfl; } /* terminate evaluation of entry */
              if((i=cAct.setInt(15,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
                Lg.Err("getAct54",Typ,i,cB.getStat(true)); /* print errormessage */
            } else if(is.equals("nextactivityobjectuid")) { /* Def.-type: 'NextActivityObjectUID' */
              Typ = "NextActivityObjectUID"; /* set 'name' of keyword */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getAct58",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 92; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0) { /* invalid value for 'NextActivityObjectUID' */
                Lg.Err("getAct56",Typ,i,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dfl; } /* terminate evaluation of entry */
              if((i=cAct.setInt(16,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
                Lg.Err("getAct54",Typ,i,cB.getStat(true)); /* print errormessage */
            } else if(is.equals("traffic_definition")) tdl:{ /* Definition-type: 'Traffic_Definition' */
              Typ = "Traffic_Definition"; /* set 'name' of keyword */
              is = cB.getVal(1); /* get value of argument (name of 'Traffic_Definition') */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getAct51",Typ,cB.getStat(true)); /* print errormessage */
                  cc = 93; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getAct52",Typ,is,cB.getStat(true)); /* print errormessage */
                cc = 94; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(is.length()==0) { /* next keword not present */
                Lg.Err("getAct53",Typ,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break tdl; } /* terminate evaluation of entry */
              if((is=cAct.chgTNme(is))!=null) { /* traffic-name already set */
                Lg.Err("getAct54",Typ,is,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
              } /* traffic-name already set -- replaced */
              TrfT = cAct.getTrfT(0); /* get table for 'Traffic-Service'-definitions */
              if(TrfT!=null) { /* table already allocated  - sequence error */
                Lg.Err("getAct5G",Typ,TrfT.size(),cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
              } else TrfT = cAct.getTrfT(10); /* create table for 'Traffic-Service'-definitions */
              n = 0; /* init relative number of definition-line */
              while(true) { /* read all definition-lines within 'Traffic_Definition' */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getAct61",Typ,n,cB.getStat(true)); /* print errormessage */
                    cc = 95; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getAct62",Typ,""+n,""+cB.getStat(true),is); /* print errormessage */
                  cc = 96; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                if(is.length()==0) break; /* all entries processed */
                l4 = cB.getBrL(); /* current bracket-level for terminate/break */
                tdsl:{ /* break-Block, used if error found */
                  if(!is.equals("service_definition")) {
                    /* Definition-type: 'Service_Definition' missing */
                    Lg.Err("getAct6B",Typ,""+n,""+cB.getStat(true),is); /* print errormessage */
                    ec += 1; /* count error */
                    break tdsl; } /* terminate evaluation of entry */
                  Typ1 = "T_D-Service_Definition"; /* set 'name' of keyword */
                  is = cB.getVal(1); /* get value of argument (name of 'Service_Definition') */
                  if(is==null) { /* error found within current input */
                    if((is=cB.getErr())==null) { /* EOF within data */
                      Lg.Err("getAct61",Typ1,n,cB.getStat(true)); /* print errormessage */
                      cc = 97; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    Lg.Err("getAct62",Typ1,""+n,""+cB.getStat(true),is); /* print errormessage */
                    cc = 98; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  if(is.length()==0) { /* next keword not present */
                    Lg.Err("getAct63",Typ1,n,cB.getStat(true)); /* print errormessage */
                    ec += 1; /* count error */
                    break tdsl; } /* terminate evaluation of entry */
                  cSrv = new TSXtSrv(is); /* create Service-Definition 'Traffic' */
                  i = (int)cB.getNV(); /* get value of argument (number) */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getAct68",Typ1,""+n,""+cB.getStat(true),is); /* print errormessage */
                    cc = 99; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  if(i<0 || i>=86400) { /* time-value is invalid (60*60*24=86400) */
                    Lg.Err("getAct69",Typ1,""+n,""+cB.getStat(true),""+i,"0","86400");
                    ec += 1; /* count error */
                    break tdsl; } /* terminate evaluation of entry */
                  cSrv.setTime(i); /* insert 'Start-Time' into service */
                    /* Service has just been created. No replacement possible */
                  /* get all traffic-service-definitons (Traffic-Mode) */
                  i = getActDef(cB,cSrv,ec,Typ1,"#S_D("); /* get service-definitions */
                  if(i>0) { /* error within procedure */
                    cc = 99 + i; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  ec = ((Integer)RetVal).intValue(); /* set new current value */
                  TrfT.add(cSrv); /* add entry to proper list */
                  n = TrfT.size(); /* set new definition-number for errors */
                } /* 'tdsl' - break-block for errors */
                if(cB.skpFwd(l4)) { /* skip resuming data to new entry -- EOF/error found? */
                  Lg.Err("getAct66",Typ,""+n,""+cB.getStat(true),cB.getErr()); /* errormessage */
                  cc = 118; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
              } /* -while- read all definition-lines 'Traffic_Definition' */
              /* closing bracket is skipped with next 'cB.skpFwd(l3)'-command */
              cAct.setMsk(20); /* mark entry as 'found' */
            } else if(is.equals("events")) { /* Definition-type: 'Events' */
              Typ = "Events"; /* set 'name' of keyword */
              EvT = cAct.getEvT(false); /* get table for 'Event'-definitions */
              if(EvT!=null) { /* table already allocated  - sequence error */
                Lg.Err("getAct5G",Typ,EvT.size(),cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
              } else EvT = cAct.getEvT(true); /* create table for 'Event'-definitions */
              n = 0; /* init relative number of definition-line */
              while(true) { /* read all definition-lines within 'Events' */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getAct61",Typ,n,cB.getStat(true)); /* print errormessage */
                    cc = 119; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getAct62",Typ,""+n,""+cB.getStat(true),is); /* print errormessage */
                  cc = 120; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                if(is.length()==0) break; /* all entries processed */
                l4 = cB.getBrL(); /* current bracket-level for terminate/break */
                evl:{ /* break-Block, used if error found */
                  if(is.equals("eventcategoryaction")) { /* Definition-type: 'EventCategoryAction' */
                    Typ1 = "Ev(" + n + ")-EventCatAction"; /* set 'name' of keyword */
                    i = getActEv(cB,EvT,TSActEv.AMsk,ec,Typ1,"EvA("+n); /* read event-definition */
                    if(i!=0) { /* error discovered within method */
                      if(i<0) break evl; /* error is not severe */
                      cc = 121; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    ec = ((Integer)RetVal).intValue(); /* set new current value */
                  } else if(is.equals("eventcategorytime")) { /* Definition-type: 'EventCategoryTime' */
                    Typ1 = "Ev(" + n + ")-EventCatTime"; /* set 'name' of keyword */
                    i = getActEv(cB,EvT,TSActEv.TMsk,ec,Typ1,"EvT("+n); /* read event-definition */
                    if(i!=0) { /* error discovered within method */
                      if(i<0) break evl; /* error is not severe */
                      cc = 122; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    ec = ((Integer)RetVal).intValue(); /* set new current value */
                  } else if(is.equals("eventcategorylocation")) { /* Def.-type: 'EventCategoryLocation' */
                    Typ1 = "Ev(" + n + ")-EventCatLocation"; /* set 'name' of keyword */
                    i = getActEv(cB,EvT,TSActEv.LMsk,ec,Typ1,"EvL("+n); /* read event-definition */
                    if(i!=0) { /* error discovered within method */
                      if(i<0) break evl; /* error is not severe */
                      cc = 123; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    ec = ((Integer)RetVal).intValue(); /* set new current value */
                  } else { /* unknown keyword -- do not process */
                    Lg.Err("getAct6B",Typ,""+n,""+cB.getStat(true),is); /* errormessage */
                    ec += 1; /* count error */
                  } /* unknown keyword found ('break evl' is not needed) */
                } /* 'evl' - break-block for errors */
                if(cB.skpFwd(l4)) { /* skip resuming data to new entry -- EOF/error found? */
                  Lg.Err("getAct66",Typ,""+n,""+cB.getStat(true),cB.getErr()); /* errormessage */
                  cc = 124; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                n += 1; /* count valid event-definition */
              } /* -while- read all definition-lines 'Events' */
              /* closing bracket is skipped with next 'cB.skpFwd(l3)'-command */
              cAct.setMsk(21); /* mark entry as 'found' */
            } else if(is.equals("activityobjects")) { /* Definition-type: 'ActivityObjects' */
              Typ = "ActivityObjects"; /* set 'name' of keyword */
              AObjT = cAct.getAObj(0); /* get table for 'ActivityObject'-definitions */
              if(AObjT!=null) { /* table already allocated  - sequence error */
                Lg.Err("getAct5G",Typ,AObjT.size(),cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
              } else AObjT = cAct.getAObj(5); /* create table for 'ActivityObject'-definitions */
              n = 0; /* init relative number of definition-line */
              while(true) { /* read all definition-lines 'ActivityObjects' */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getAct61",Typ,n,cB.getStat(true)); /* print errormessage */
                    cc = 125; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getAct62",Typ,""+n,""+cB.getStat(true),is); /* print errormessage */
                  cc = 126; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                if(is.length()==0) break; /* all entries processed */
                l4 = cB.getBrL(); /* current bracket-level for terminate/break */
                aol:{ /* break-Block, used if error found */
                  if(!is.equals("activityobject")) { /* Definition-type: 'ActivityObject' missing */
                    Lg.Err("getAct6B",Typ,""+n,""+cB.getStat(true),is); /* print errormessage */
                    ec += 1; /* count error */
                    break aol; } /* terminate evaluation of entry */
                  cAO = new TSActAO(); /* create 'ActivityObject'-definition */
                  while(true) { /* read all definition-lines within 'ActivityObject' */
                    is = cB.getKE(true); /* get next controlword */
                    if(is==null) { /* error found within current input */
                      if((is=cB.getErr())==null) { /* EOF within data */
                        Lg.Err("getAct61",Typ,n,cB.getStat(true)); /* print errormessage */
                        cc = 127; /* set current return-code to error */
                        break bl; } /* terminate evaluation */
                      Lg.Err("getAct62",Typ,""+n,""+cB.getStat(true),is); /* print errormessage */
                      cc = 128; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    if(is.length()==0) break; /* all entries processed */
                    l5 = cB.getBrL(); /* current bracket-level for terminate/break */
                    aol1:{ /* break-Block, used if error found */
                      if(is.equals("objecttype")) { /* Definition-type: 'ObjectType' */
                        Typ1 = "AO(" + n + ")-ObjectType"; /* set 'name' of keyword */
                        is = cB.getVal(2); /* get value of argument  */
                        if(is==null) { /* error found within current input */
                          if((is=cB.getErr())==null) { /* EOF within data */
                            Lg.Err("getAct51",Typ,cB.getStat(true)); /* print errormessage */
                            cc = 129; /* set current return-code to error */
                            break bl; } /* terminate evaluation */
                          Lg.Err("getAct52",Typ,is,cB.getStat(true)); /* print errormessage */
                          cc = 130; /* set current return-code to error */
                          break bl; } /* terminate evaluation */
                        if(is.length()==0) { /* next keword not present */
                          Lg.Err("getAct53",Typ1,cB.getStat(true)); /* print errormessage */
                          ec += 1; /* count error */
                          break aol1; } /* terminate evaluation of entry */
                        if(!is.equals("wagonslist")) { /* Definition-type: 'WagonsList' missing */
                          Lg.Err("getAct56",Typ1,is,cB.getStat(true)); /* print errormessage */
                          ec += 1; /* count error */
                          break aol1; } /* terminate evaluation of entry */
                        cAO.setMsk(0); /* mark 'WagonsList' as present */
                      } else if(is.equals("train_config")) { /* Definition-type: 'Train_Config' */
                        Typ1 = "AO(" + n + ")-Train_Config"; /* set 'name' of keyword */
                        is = cB.getKE(true); /* get next controlword */
                        if(is==null) { /* error found within current input */
                          if((is=cB.getErr())==null) { /* EOF within data */
                            Lg.Err("getAct51",Typ1,cB.getStat(true)); /* print errormessage */
                            cc = 131; /* set current return-code to error */
                            break bl; } /* terminate evaluation */
                          Lg.Err("getAct52",Typ1,is,cB.getStat(true)); /* print errormessage */
                          cc = 132; /* set current return-code to error */
                          break bl; } /* terminate evaluation */
                        if(!is.equals("traincfg")) { /* Definition-type: 'TrainCfg' missing */
                          Lg.Err("getAct5D",Typ1,is,cB.getStat(true)); /* print errormessage */
                          ec += 1; /* count error */
                          break aol1; } /* terminate evaluation of entry */
                        i = cB.getStat(true); /* save current line-number for check */
                        is = cB.getVal(1); /* get value of argument (filename) */
                        if(is==null) { /* error found within current input */
                          if((is=cB.getErr())==null) { /* EOF within data */
                            Lg.Err("getAct51",Typ1,i); /* print errormessage */
                            cc = 133; /* set current return-code to error */
                            break bl; } /* terminate evaluation */
                          Lg.Err("getAct52",Typ1,is,i); /* print errormessage */
                          cc = 134; /* set current return-code to error */
                          break bl; } /* terminate evaluation */
                        /* Attention: length() may be 0 (if used within Act-definition)
                         *            line-number MUST NOT change or name is missing */
                        if(i!=cB.getStat(true)) { /* line-number has changed -- name missing */
                          Lg.Err("getAct5N",Typ1,is,i); /* print errormessage */
                          cc = 135; /* set current return-code to error */
                          break bl; } /* terminate evaluation */
                        is = cAct.chgNme(null) + "-" + DF4.format(tn); /* create synthetic key */
                        tn += 1; /* number is exclusive */
                        cTrn = new TSTrain(is); /* create activity-definition for new Train */
                        cTrn.setMsk(0); /* and mark type of entry as 'static train' */
 
                        i = getTrain(cB,cTrn,ec,TSLogg.getMsg("getAct5Q",Typ1),
                                                TSLogg.getMsg("getAct5R",n)); /* read train-definition */
                        if(i>0) { /* error discovered within method */
                          Lg.Err("getAct5K",Typ1,i,cB.getStat(true)); /* print errormessage */
                          cc = 136; /* set current return-code to error */
                          break bl; } /* terminate evaluation */
                        ec = ((Integer)RetVal).intValue(); /* set new current value */
                        is = cTrn.getName(false); /* get filename as key */
                        if(Trn.put(is,cTrn)!=null) /* store current train-definition */
                          Lg.Err("getAct5P",is); /* print errormessage */
                        if(cAO.chgTrn(cTrn)!=null) { /* value was already set */
                          Lg.Err("getAct57",Typ1,cTrn.chgNme(null),cB.getStat(true)); /* errormessage */
                          ec += 1; /* count error */
                          break aol1; } /* terminate evaluation of entry */
                        /* closing brackets are skipped with next 'cB.skpFwd(l5)'-command */
                        cAO.setMsk(15); /* mark 'Train_Config' as present */
                      } else if(is.equals("direction")) { /* Definition-type: 'Direction' */
                        Typ1 = "AO(" + n + ")-Direction"; /* set 'name' of keyword */
                        i = (int)cB.getNV(); /* get value of argument (number) */
                        if((is=cB.getErr())!=null) { /* error while evaluating */
                          Lg.Err("getAct58",Typ1,is,cB.getStat(true)); /* print errormessage */
                          cc = 137; /* set current return-code to error */
                          break bl; } /* terminate evaluation */
                        if(i<0 || i>359) { /* 'heading' value is not valid */
                          Lg.Err("getAct59",Typ1,""+i,""+cB.getStat(true),"0","359");
                          ec += 1; /* count error */
                          break aol1; } /* terminate evaluation of entry */
                        if((i=cAO.chgDir(i))!=Integer.MIN_VALUE) /* value already set -- replaced */
                          Lg.Err("getAct54",Typ1,""+i,""+cB.getStat(true)); /* print errormessage */
                        cAO.setMsk(16); /* mark 'Direction' as present */
                      } else if(is.equals("id")) { /* Definition-type: 'ID' */
                        Typ1 = "AO(" + n + ")-ID"; /* set 'name' of keyword */
                        i = (int)cB.getNV(); /* get value of argument (number) */
                        if((is=cB.getErr())!=null) { /* error while evaluating */
                          Lg.Err("getAct58",Typ1,is,cB.getStat(true)); /* print errormessage */
                          cc = 138; /* set current return-code to error */
                          break bl; } /* terminate evaluation */
                        if(i<0) { /* value is not valid */
                          Lg.Err("getAct56",Typ1,""+i,""+cB.getStat(true)); /* print errormessage */
                          ec += 1; /* count error */
                          break aol1; } /* terminate evaluation of entry */
                        if((i=cAO.setID(i))!=Integer.MIN_VALUE) /* value already set -- replaced */
                          Lg.Err("getAct54",Typ1,""+i,""+cB.getStat(true)); /* print errormessage */
                        cAO.setMsk(17); /* mark 'ID' as present */
                      } else if(is.equals("tile")) { /* Definition-type: 'Tile' */
                        Typ1 = "AO(" + n + ")-Tile"; /* set 'name' of keyword */
                        /* load position-values (qx qz x z) and check them */
                        if((is=getPos(cB,false,true))!=null) { /* error within position */
                          Lg.Err("getAct52",Typ1,is,cB.getStat(true)); /* print errormessage */
                          ec += 1; /* count error */
                          break aol1; } /* terminate evaluation of entry */
                        cPos = (TSQPos)RetVal; /* get valid position-definition */
                        if((cPos=cAO.setPos(cPos))!=null) { /* value was already set */
                          Lg.Err("getAct57",Typ1,cPos.getPos(4),cB.getStat(true)); /* print error-msg */
                          ec += 1; /* count error */
                          break aol1; } /* terminate evaluation of entry */
                        cAO.setMsk(18); /* mark 'Tile' as present */
                      } else { /* unknown keyword -- do not process */
                        Lg.Err("getAct6B",Typ,""+n,""+cB.getStat(true),is); /* errormessage */
                        ec += 1; /* count error */
                      } /* unknown keyword found ('break aol1' is not needed) */
                    } /* 'aol1' - break-block for errors */
                    /* closing bracket is skipped with next 'cB.skpFwd(l5)'-command */
                    if(cB.skpFwd(l5)) { /* skip resuming data to new entry -- EOF/error found? */
                      Lg.Err("getAct66",Typ,""+n,""+cB.getStat(true),cB.getErr()); /* errormessage */
                      cc = 139; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                  } /* -while- read all definition-lines within 'ActivityObject' */
                  AObjT.add(cAO); /* add entry to proper list */
                  n = AObjT.size(); /* set new definition-number for errors */
                } /* 'aol' - break-block for errors */
                /* closing bracket is skipped with next 'cB.skpFwd(l4)'-command */
                if(cB.skpFwd(l4)) { /* skip resuming data to new entry -- EOF/error found? */
                  Lg.Err("getAct66",Typ,""+n,""+cB.getStat(true),cB.getErr()); /* errormessage */
                  cc = 140; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
              } /* -while- read all definition-lines 'ActivityObjects' */
              /* closing bracket is skipped with next 'cB.skpFwd(l3)'-command */
              cAct.setMsk(22); /* mark entry as 'found' */
            } else if(is.equals("activityrestrictedspeedzones")) {
              /* Definition-type: 'ActivityRestrictedSpeedZones' */
              Typ = "ActivityRestrictedSpeedZones"; /* set 'name' of keyword */
              RSZT = cAct.getRSZne(0); /* get table for 'RestrictedSpeedZone'-definitions */
              if(RSZT!=null) { /* table already allocated  - sequence error */
                Lg.Err("getAct5G",Typ,RSZT.size(),cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
              } else RSZT = cAct.getRSZne(5); /* create table for 'RestrictedSpeedZone'-definitions */
              n = 0; /* init relative number of definition-line */
              while(true) { /* read all definition-lines 'RestrictedSpeedZones' */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getAct61",Typ,n,cB.getStat(true)); /* print errormessage */
                    cc = 141; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getAct62",Typ,""+n,""+cB.getStat(true),is); /* print errormessage */
                  cc = 142; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                if(is.length()==0) break; /* all entries processed */
                l4 = cB.getBrL(); /* current bracket-level for terminate/break */
                rszl:{ /* break-Block, used if error found */
                  if(!is.equals("activityrestrictedspeedzone")) {
                    /* Definition-type: 'ActivityRestrictedSpeedZone' missing */
                    Lg.Err("getAct6B",Typ,""+n,""+cB.getStat(true),is); /* print errormessage */
                    ec += 1; /* count error */
                    break rszl; } /* terminate evaluation of entry */
                  cRSZ = new TSActSZ(); /* create reference to 'RestrictedSpeedZone' */
                  while(true) { /* read all definition-lines within 'RestrictedSpeedZone' */
                    is = cB.getKE(true); /* get next controlword */
                    if(is==null) { /* error found within current input */
                      if((is=cB.getErr())==null) { /* EOF within data */
                        Lg.Err("getAct61","SpeedZone",n,cB.getStat(true)); /* print errormessage */
                        cc = 143; /* set current return-code to error */
                        break bl; } /* terminate evaluation */
                      Lg.Err("getAct62","SpeedZone",""+n,""+cB.getStat(true),is); /* print errormessage */
                      cc = 144; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    if(is.length()==0) break; /* all entries processed */
                    szl:{ /* break-Block, used if error found */
                      if(is.equals("startposition")) { /* Definition-type: 'StartPosition' */
                        Typ1 = "SpeedZone(" + n + ")-StartPosition"; /* error-description */
                        /* load position-values (qx qz x z) and check them */
                        if((is=getPos(cB,false,true))!=null) { /* error within position */
                          Lg.Err("getAct52",Typ1,is,cB.getStat(true)); /* print errormessage */
                          ec += 1; /* count error */
                          break szl; } /* terminate evaluation of entry */
                        cPos = (TSQPos)RetVal; /* get valid position-definition */
                        if((is=cRSZ.setPos(0,cPos))!=null) { /* value could not be stored */
                          Lg.Err("getAct52",Typ1,is,cB.getStat(true)); /* print errormessage */
                          ec += 1; /* count error */
                          break szl; } /* terminate evaluation of entry */
                      } else if(is.equals("endposition")) { /* Definition-type: 'EndPosition' */
                        Typ1 = "SpeedZone(" + n + ")-EndPosition"; /* error-description */
                        /* load position-values (qx qz x z) and check them */
                        if((is=getPos(cB,false,true))!=null) { /* error within position */
                          Lg.Err("getAct52",Typ1,is,cB.getStat(true)); /* print errormessage */
                          ec += 1; /* count error */
                          break szl; } /* terminate evaluation of entry */
                        cPos = (TSQPos)RetVal; /* get valid position-definition */
                        if((is=cRSZ.setPos(1,cPos))!=null) { /* value could not be stored */
                          Lg.Err("getAct52",Typ1,is,cB.getStat(true)); /* print errormessage */
                          ec += 1; /* count error */
                          break szl; } /* terminate evaluation of entry */
                      } else { /* unknown keyword -- do not process */
                        Lg.Err("getAct6B","SpeedZone",""+n,""+cB.getStat(true),is); /* errormessage */
                        ec += 1; /* count error */
                      } /* unknown keyword found ('break szl' is not needed) */
                    } /* 'szl' - break-block for errors */
                    if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                      Lg.Err("getAct66","SpeedZone",""+n,""+cB.getStat(true),cB.getErr());
                      cc = 145; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                  } /* -while- read all definition-lines within 'RestrictedSpeedZone' */
                  RSZT.add(cRSZ); /* add entry to proper list */
                  n = RSZT.size(); /* set new definition-number for errors */
                } /* 'rszl' - break-block for errors */
                if(cB.skpFwd(l4)) { /* skip resuming data to new entry -- EOF/error found? */
                  Lg.Err("getAct66",Typ,""+n,""+cB.getStat(true),cB.getErr()); /* errormessage */
                  cc = 146; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
              } /* -while- read all definition-lines 'RestrictedSpeedZones' */
              /* closing bracket is skipped with next 'cB.skpFwd(l3)'-command */
              cAct.setMsk(23); /* mark entry as 'found' */
            } else if(is.equals("activityfailedsignals")) { /* Def-typ: 'ActivityFailedSignals' */
              Typ = "ActivityFailedSignals"; /* set 'name' of keyword */
              n = 0; /* init relative number of definition-line */
              RefT = cAct.getSigR(0); /* get table for 'ActivityFailedSignals'-definitions */
              if(RefT!=null) { /* table already allocated  - sequence error */
                Lg.Err("getAct5G",Typ,RefT.size(),cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
              } else RefT = cAct.getSigR(5); /* create table for 'ActivityFailedSignals'-definitions */
              while(true) { /* read all definition-lines 'ActivityFailedSignals' */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getAct61",Typ,n,cB.getStat(true)); /* print errormessage */
                    cc = 147; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getAct62",Typ,""+n,""+cB.getStat(true),is); /* print errormessage */
                  cc = 148; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                if(is.length()==0) break; /* all entries processed */
                Typ1 = "ActivityFailedSignal"; /* set 'name' of keyword */
                fsl:{ /* break-Block, used if error found */
                  if(!is.equals("activityfailedsignal")) { /* Def-typ: 'ActivityFailedSignal' missing */
                    Lg.Err("getAct6B",Typ,""+n,""+cB.getStat(true),is); /* print errormessage */
                    ec += 1; /* count error */
                    break fsl; } /* terminate evaluation of entry */
                  i = (int)cB.getNV(); /* get value of argument (number) (item-ID) */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getAct68",Typ1,""+n,""+cB.getStat(true),is); /* print errormessage */
                    cc = 149; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  if(i<0) { /* invalid value for ID */
                    Lg.Err("getAct65",Typ1,n,cB.getStat(true),i);
                    ec += 1; /* count error */
                    break fsl; } /* terminate evaluation of entry */
                  cRef = new TSRefC(i); /* create reference to 'signalitem' */
                  RefT.add(cRef); /* and add entry to proper list */
                  n = RefT.size(); /* set new definition-number for errors */
                } /* 'fsl' - break-block for errors */
                if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                  Lg.Err("getAct66",Typ1,""+n,""+cB.getStat(true),cB.getErr()); /* errormessage */
                  cc = 150; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
              } /* -while- read all definition-lines 'ActivityFailedSignals' */
              /* closing bracket is skipped with next 'cB.skpFwd(l3)'-command */
              cAct.setMsk(24); /* mark entry as 'found' */
            } else if(is.equals("platformnumpassengerswaiting")) {
              /* Definition-type: 'PlatformNumPassengersWaiting' */
              Typ = "PlatformNumPassengersWaiting"; /* set 'name' of keyword */
              n = 0; /* init relative number of definition-line */
              RefT = cAct.getPNPWt(0); /* get table for 'PNPW'-definitions */
              if(RefT!=null) { /* table already allocated  - sequence error */
                Lg.Err("getAct5G",Typ,RefT.size(),cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
              } else RefT = cAct.getPNPWt(5); /* create table for 'PNPW'-definitions */
              while(true) { /* read all definition-lines 'PlatformNumPassengersWaiting' */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getAct61",Typ,n,cB.getStat(true)); /* print errormessage */
                    cc = 151; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getAct62",Typ,""+n,""+cB.getStat(true),is); /* print errormessage */
                  cc = 152; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                if(is.length()==0) break; /* all entries processed */
                Typ1 = "PlatformData"; /* set 'name' of keyword */
                pnll:{ /* break-Block, used if error found */
                  if(!is.equals("platformdata")) { /* Def-typ: 'PlatformData' missing */
                    Lg.Err("getAct6B",Typ,""+n,""+cB.getStat(true),is); /* print errormessage */
                    ec += 1; /* count error */
                    break pnll; } /* terminate evaluation of entry */
                  i = (int)cB.getNV(); /* get value of argument (number) (platform-ID) */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getAct68",Typ1,""+n,""+cB.getStat(true),is); /* print errormessage */
                    cc = 153; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  if(i<0) { /* invalid value for ID */
                    Lg.Err("getAct65",Typ1,n,cB.getStat(true),i);
                    ec += 1; /* count error */
                    break pnll; } /* terminate evaluation of entry */
                  j = (int)cB.getNV(); /* get value of argument (number of passengers) */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getAct68",Typ1,""+n,""+cB.getStat(true),is); /* print errormessage */
                    cc = 154; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  if(j<0) { /* invalid value for ID */
                    Lg.Err("getAct65",Typ1,n,cB.getStat(true),j);
                    ec += 1; /* count error */
                    break pnll; } /* terminate evaluation of entry */
                  cRef = new TSRefC(i); /* create reference to 'platform' */
                  cRef.chgIx(j); /* insert 'number of passengers' as 'additional information' */
                  RefT.add(cRef); /* add entry to proper list */
                  n = RefT.size(); /* set new definition-number for errors */
                } /* 'pnll' - break-block for errors */
                if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                  Lg.Err("getAct66",Typ1,""+n,""+cB.getStat(true),cB.getErr()); /* errormessage */
                  cc = 155; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
              } /* -while- read all definition-lines 'PlatformNumPassengersWaiting' */
              /* closing bracket is skipped with next 'cB.skpFwd(l3)'-command */
              cAct.setMsk(25); /* mark entry as 'found' */
            } else if(is.equals("pickuptritemdata")) { /* Definition-type: 'PickupTrItemData' */
              Typ = "PickupTrItemData"; /* set 'name' of keyword */
              n = 0; /* init relative number of definition-line */
              RefT = cAct.getTrI08(0); /* get table for 'PickupTrItemData'-definitions */
              if(RefT!=null) { /* table already allocated  - sequence error */
               Lg.Err("getAct5G",Typ,RefT.size(),cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
              } else RefT = cAct.getTrI08(5); /* create table for 'PickupTrItemData'-definitions */
              while(true) { /* read all definition-lines 'PickupTrItemData' */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getAct61",Typ,n,cB.getStat(true)); /* print errormessage */
                    cc = 156; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getAct62",Typ,""+n,""+cB.getStat(true),is); /* print errormessage */
                  cc = 157; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                if(is.length()==0) break; /* all entries processed */
                Typ1 = "PickupItem"; /* set 'name' of keyword */
                pkll:{ /* break-Block, used if error found */
                  if(!is.equals("pickupitem")) { /* Def-typ: 'PickupItem' missing */
                    Lg.Err("getAct6B",Typ,""+n,""+cB.getStat(true),is); /* print errormessage */
                    ec += 1; /* count error */
                    break pkll; } /* terminate evaluation of entry */
                  i = (int)cB.getNV(); /* get value of argument (number) (item-ID) */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getAct68",Typ1,""+n,""+cB.getStat(true),is); /* print errormessage */
                    cc = 158; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  if(i<0) { /* invalid value for ID */
                    Lg.Err("getAct65",Typ1,n,cB.getStat(true),i);
                    ec += 1; /* count error */
                    break pkll; } /* terminate evaluation of entry */
                  j = (int)cB.getNV(); /* get value of argument (number) */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getAct68",Typ1,""+n,""+cB.getStat(true),is); /* print errormessage */
                    cc = 159; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  if(j<0) { /* invalid value for ID */
                    Lg.Err("getAct65",Typ1,n,cB.getStat(true),j);
                    ec += 1; /* count error */
                    break pkll; } /* terminate evaluation of entry */
                  cRef = new TSRefC(i); /* create reference to 'PickupItem' */
                  cRef.chgIx(j); /* insert pickup-value as 'additional information' */
                  RefT.add(cRef); /* add entry to proper list */
                  n = RefT.size(); /* set new definition-number for errors */
                } /* 'pkll' - break-block for errors */
                if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                  Lg.Err("getAct66",Typ1,""+n,""+cB.getStat(true),cB.getErr()); /* errormessage */
                  cc = 160; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
              } /* -while- read all definition-lines 'PickupTrItemData' */
              /* closing bracket is skipped with next 'cB.skpFwd(l3)'-command */
              cAct.setMsk(26); /* mark entry as 'found' */
            } else { /* unknown keyword -- do not process */
              Lg.Err("getAct37",is,0,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
            } /* unknown keyword found ('break dfl' is not needed) */
          } /* 'dfl' - break-block for errors */
          if(cB.skpFwd(l3)) { /* skip resuming data to new entry -- EOF/error found? */
            Lg.Err("getAct38",cB.getStat(true)); /* print errormessage */
            cc = 161; /* set current return-code to error */
            break bl; } /* terminate evaluation */
        } /* -while- process all lines within 'File'-range */
        if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
          Lg.Err("getAct27",cB.getStat(true)); /* print errormessage */
          cc = 162; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        is = cB.getKE(false); /* get next controlword if present */
        if(is==null) { /* error found within current input */
          cc = 10; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()>0) Lg.Err("getAct19",is,0,cB.getStat(true));
          /* additional data found although NOT expected */
        if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
          Lg.Err("getAct1A",cB.getStat(true)); /* print errormessage */
          cc = 9; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        cc = 0; /* mark: return WITHOUT error */
      } /* -bl- break-block used in case of error */

      is = cF.close(); /* Eingabe-Datei schliessen */
      if(is!=null) Lg.Err("getAct05",is); /* Meldung ausgeben */
      if(cc!=0) Lg.Log("getAct12",cc); /* Aktionsmeldung */
      else { /* kein Abbruch -- Activity-Definition setzen */
        if(ec>0) Lg.Log("getAct13",ec); /* Aktionsmeldung */
        is = cAct.getName(false); /* get current filename as key */
        if(Act.put(is,cAct)!=null) /* store current path-definition */
          Lg.Err("getAct06",fn,is,cB.getStat(true)); /* print errormessage */
        ce += ec; /* add number of errors to 'overall errors' */
      } /* Activity-Definition gueltig */
      Lg.Log("getAct14",cB.getStat(true)); /* Ergebniss der Pruefung ausgeben */
    } /* -ol- alle Datei-Saetze lesen */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("getAct08",cf); /* Ergebniss der Pruefung ausgeben */
    Lg.Log("getAct09",ce); /* Ergebniss der Pruefung ausgeben */
    Lg.Skip(false); /* Leerzeile loggen */

    return 0; /* Programm (erfolgreich) beendet */
  }

 /**. <pre>
  *=====================================================================
  * Method "getActDef"
  * Load Service-Definition (Activity)  and store into class
  * Method is referenced from 'getAct()'!
  * Method uses 2 modes (player/traffic). If argument 'prK' contains a
  *   '#' as first charcter traffic-mode is used. (else 'Player')
  * Both modes read the A-version of a service. All stops within this
  *  service are read and stored into the service. If 'Player'-mode is
  *  used a T-version of the service is also read and all stops of
  *  the A-version are correlated to the T-version. Then all additional
  *  data from the T-version are moved to the A-version and the
  *  T-version is deleted again.
  * Attention: Length of String 'prK' must be '>0'
  * Attention: Method stores current/updated error-counter to 'RetVal'.
  * Return-CC used are: 0 and 1..18
  * ##getActDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getActDef( /* get Service-Definition (Act) */
   TSBuf   cB,   /* current input-buffer */
   TSXtSrv cSrv, /* current (ext.) Service-Definition */
   int     ec,   /* current error-couter (will be returned) */
   String  prL,  /* message-prefix (long form) */
   String  prK)  /* message-prefix incl. '(' (short form) */
   {
   /*-----------------------------------------------------------------*/
    ArrayList<TSStStp> HltT;  /* List of 'StationStop's (A) */
    ArrayList<TSStStp> StpT;  /* List of 'StationStop's (T) */
    TSStStp            cStp;  /* current definition of 'StationStop' */
    String             prfx,SNme; /* message-prefix (full) */
    String             is;    /* intermediate value */
    int                i,j,n,sc,id,l1;
    double             f1,f2; /* intermediate value */
    boolean            mde; /* traffic-mode if 'true' */
   /*=================================================================*/
    HltT = cSrv.getStp(10); /* create table for 'StationStop'-definitions
      * (whole table describes ONE (extended) Service) */
    StpT = null; /* mark: table not available */
    mde = false; /* set 'Player'-mode as default */
    if(prK.charAt(0)=='#') { prK = prK.substring(1); mde = true; }
    j = 1; /* used to control definitions of 'StationStop' type 'A' */
    n = 0; /* init number of 'StationStop'-definition */
    f1 = f2 = Double.NaN; /* init for compiler */
    id = sc = Integer.MIN_VALUE; /* init for compiler */
    SNme = cSrv.getName(); /* get name of Service for errors */
    prK += SNme; /* create part of message-identifier */

    while(true) { /* process all lines of 'Player_Service_Definition'/'Traffic_Definition' */
      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getAct61",prL,SNme,cB.getStat(true)); /* errormessage */
          return 1; } /* set current return-code and terminate evaluation */
        Lg.Err("getAct62",prL,SNme,""+cB.getStat(true),is); /* errormessage */
        return 2; } /* set current return-code and terminate evaluation */
      if(is.length()==0) break; /* all entries processed */
      l1 = cB.getBrL(); /* current bracket-level for terminate/break */
      psl:{ /* break-Block, used if error found */
        if(is.equals("player_traffic_definition")) { /* 'Player_Traffic_Definition' */
          if(mde) { /* keyword not allowed (traffic-mode) -- handle as 'unknown' */
            Lg.Err("getAct6B",prL,SNme,""+cB.getStat(true),is); /* errormessage */
            ec += 1; /* count error */
            break psl; } /* terminate evaluation of entry */
          prfx = prK + ")-Player_Traffic_Definition";
          if(j!=1) { /* 'StationStop'-definition was already present */
            Lg.Err("getAct5B",prfx,j,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
            break psl; } /* terminate evaluation of entry */
          /* first value: Time of start */
          i = (int)cB.getNV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getAct58",prfx,is,cB.getStat(true)); /* print errormessage */
            return 3; } /* set current return-code and terminate evaluation */
          if(i<0 || i>=86400) { /* time-value is invalid (60*60*24=86400) */
            Lg.Err("getAct59",prfx,""+i,""+cB.getStat(true),"0","86400");
            ec += 1; /* count error */
            break psl; } /* terminate evaluation of entry */
          if(cSrv.setTime(i)) /* value already set -- replaced */
            Lg.Err("getAct54",prfx,cSrv.chkTime(0),cB.getStat(true)); /* print errormessage */
          /* get all definitons from traffic-part which are repeated here */
          StpT = new ArrayList<TSStStp>(); /* create table for 'StationStop'-def's (T)
            * Attention: table is NOT part of the service-definition and not stored there.
            */
          i = getTrfDef(cB,StpT,ec,"File-"+prfx); /* get Traffic-Definitions
            *  (T-version of StationStop-object (TSStStp)) */
          if(i>0) return 3+i; /* set current return-code and terminate evaluation */
          ec = ((Integer)RetVal).intValue(); /* set new current value */
        } else if(is.equals("uid")) { /* Definition-type: 'UiD' */
          prfx = prK + ")-UiD"; /* set 'name' of keyword */
          if(j!=1) { /* 'StationStop'-definition was already present */
            Lg.Err("getAct5B",prfx,j,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
            break psl; } /* terminate evaluation of entry */
          i = (int)cB.getNV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getAct58",prfx,is,cB.getStat(true)); /* print errormessage */
            return 13; } /* set current return-code and terminate evaluation */
          if(i<0) { /* invalid value for ID */
            Lg.Err("getAct56",prfx,i,cB.getStat(true));
            ec += 1; /* count error */
            break psl; } /* terminate evaluation of entry */
          if(cSrv.setID(i)) /* value already set -- replaced */
            Lg.Err("getAct54",prfx,cSrv.chkID(Integer.MIN_VALUE),cB.getStat(true));
        } else if(is.equals("efficiency")) { /* Definition-type: 'Efficiency' */
          prfx = prK + ")-Efficiency"; /* set 'name' of keyword */
          if((j%2)==0) { /* line is already processed */
            Lg.Err("getAct6A",prfx,n,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
            break psl; } /* terminate evaluation of entry */
          f1 = cB.getFV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getAct68",prfx,""+n,""+cB.getStat(true),is); /* print errormessage */
            return 14; } /* set current return-code and terminate evaluation */
          if(f1<0.0 || f1>2.0) { /* 'Efficiency'-value is invalid */
            Lg.Err("getAct69",prfx,""+n,""+cB.getStat(true),""+f1,"0.0","2.0");
            ec += 1; /* count error */
            if(f1<0.0) f1 = 0.0; /* set minimum value */
            if(f1>2.0) f1 = 2.0; /* set maximum value */
          } /* Sub-Entry is valid but contains error */
          j *= 2; /* line was successfully processed -- register definition */
        } else if(is.equals("skipcount")) { /* Definition-type: 'SkipCount' */
          prfx = prK + ")-SkipCount"; /* set 'name' of keyword */
          if((j%3)==0) { /* line is already processed */
            Lg.Err("getAct6A",prfx,n,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
            break psl; } /* terminate evaluation of entry */
          sc = (int)cB.getNV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getAct68",prfx,""+n,""+cB.getStat(true),is); /* print errormessage */
            return 15; } /* set current return-code and terminate evaluation */
          if(sc<0) { /* 'SkipCount'-value is invalid */
            Lg.Err("getAct65",prfx,""+n,""+cB.getStat(true),""+sc); /* print errormessage */
            ec += 1; /* count error */
            sc = Integer.MIN_VALUE; /* signal: invalid value */
          } /* Sub-Entry is valid but contains error */
          j *= 3; /* line was successfully processed -- register definition */
        } else if(is.equals("distancedownpath")) { /* Definition-type: 'DistanceDownPath' */
          prfx = prK + ")-DistanceDownPath"; /* set 'name' of keyword */
          if((j%5)==0) { /* line is already processed */
            Lg.Err("getAct6A",prfx,n,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
            break psl; } /* terminate evaluation of entry */
          f2 = cB.getFV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getAct68",prfx,""+n,""+cB.getStat(true),is); /* print errormessage */
            return 16; } /* set current return-code and terminate evaluation */
          if(f2<0.0) { /* 'DistanceDownPath'-value is invalid */
            Lg.Err("getAct65",prfx,""+n,""+cB.getStat(true),""+f2); /* print errormessage */
            ec += 1; /* count error */
            f2 = Double.NaN; /* signal: invalid value */
          } /* Sub-Entry is valid but contains error */
          j *= 5; /* line was successfully processed -- register definition */
        } else if(is.equals("platformstartid")) { /* Definition-type: 'PlatformStartID' */
          prfx = prK + ")-PlatformStartID"; /* set 'name' of keyword */
          if((j%7)==0) { /* line is already processed */
            Lg.Err("getAct6A",prfx,n,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
            break psl; } /* terminate evaluation of entry */
          id = (int)cB.getNV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getAct68",prfx,""+n,""+cB.getStat(true),is); /* print errormessage */
            return 17; } /* set current return-code and terminate evaluation */
          if(id<0) { /* 'PlatformStartID'-value is invalid */
            Lg.Err("getAct65",prfx,""+n,""+cB.getStat(true),""+id); /* print errormessage */
            ec += 1; /* count error */
            id = Integer.MIN_VALUE; /* signal: invalid value */
          } /* Sub-Entry is valid but contains error */
          j *= 7; /* line was successfully processed -- register definition */
        } else { /* unknown keyword -- do not process */
          Lg.Err("getAct6B",prL,SNme,""+cB.getStat(true),is); /* print errormessage */
          ec += 1; /* count error */
        } /* unknown keyword found ('break psl' is not needed) */
      } /* 'psl' - break-block for errors */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getAct5C",prL,SNme,cB.getStat(true)); /* print errormessage */
        return 18; } /* set current return-code and terminate evaluation */
      if(j==210) { /* 'StationStop'-definition is complete -- store it (2*3*5*7=210) */
        cStp = new TSStStp(f1,id,sc,f2); /* create 'StationStop'-definition (A) */
        HltT.add(cStp); /* and add to proper list */
        n = HltT.size(); /* set new definition-number for errors */
        j = 1; /* next definition will follow */
      } /* 'StationStop'-definition created */
    } /* -while- process all lines of 'Player_Service_Definition'/'Traffic_Definition' */
    if(j!=1) { /* UNCOMPLETE 'StationStop'-definition found */
      Lg.Err("getAct5L",prL,j,cB.getStat(true)); /* print errormessage */
      ec += 1; /* count error */
    } /* terminate evaluation of entry */
    RetVal = new Integer(ec); /* return new number of errors */
    if(mde) return 0; /* return from function ('Traffic'-mode) and signal 'no error' */

    /* correlate 'StationStop'-table (A) with (T) ('Player'-mode)
     * HltT - Table of A-versions, StpT - Table of T-versions */
    if(StpT==null) { /* error -- traffic-table not available */
      Lg.Err("getAct6C",prL,SNme); /* print errormessage */
      return 19; /* set current return-code and terminate evaluation */
    } /* traffic-table is not available -- action terminated */
    if(StpT.size()==0) { /* no Traffic-entries allowed -- delete them */
      for(id=0,j=HltT.size();id<j;id+=1) { /* report all 'StationStop's */
//        cStp = HltT.get(id); /* get 'StationStop'-entry (T) */
        Lg.Err("getAct6D",prL,SNme,id); /* print errormessage */
        ec += 1; /* and count error */
      } /* -for- report all 'StationStop's for delete */
      HltT.clear(); /* delete ALL entries */
    } else { /* process all 'StationStop's -definitions and correlate */
      for(id=0,j=StpT.size();id<j;id+=1) { /* process all entries (T) */
        cStp = StpT.get(id); /* get requested entry (T-version) */
        do { /* find this StationStop'-entry(T) within activity-service */
          if(id>=HltT.size()) { /* entry missing in Activity-table -- create it */
            HltT.add(new TSStStp(cStp)); /* add new entry to activity-table */
              /* create required 'StationStop'-entry (A)
               * Attention: template entry (T) contains NO connection to entry type (S) */
            Lg.Err("getAct6E",prL,SNme,id); /* print errormessage */
            ec += 1; /* and count error */
          } /* requested entry added to activity-table */
          if((i=HltT.get(id).corrT(cStp))<=0) break; /* try to correlate entries */
          /* additional entry found -- process(delete) it */
          Lg.Err("getAct6D",prL,SNme,id); /* print errormessage */
          ec += 1; /* and count error */
          HltT.remove(id); /* delete additional entry */
        } while(true); /* loop until correct correlation is found */
        if(i<0) { /* no matching activity-entry found (entry missing) */
          Lg.Err("getAct6E",prL,SNme,id); /* print errormessage */
          ec += 1; /* and count error */
          HltT.add(new TSStStp(cStp)); /* add new entry to activity-table */
            /* create required 'StationStop'-entry (A) */
        } /* no matching activity-entry found  -- created */
        if(RetVal!=null) Lg.Err("getAct6F",prL,SNme,""+id,(String)RetVal);
          /* error only can be active if a valid correlation is found */
      } /* -for- process all 'StationStop'-Entries */
      for(id=StpT.size(),j=HltT.size();id<j;id+=1) { /* delete remaining 'StationStop's */
//        cStp = HltT.get(id); /* get 'StationStop'-entry (T) */
        Lg.Err("getAct6D",prL,SNme,id); /* print errormessage */
        ec += 1; /* and count error */
        HltT.remove(id); /* delete additional entry */
      } /* -for- delete remaining 'StationStop's for delete */
    } /* process all 'StationStop's -definitions and correlate */
    RetVal = new Integer(ec); /* return new number of errors */
    return 0; /* return from function and signal 'no error' */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getActEv"
  * Read Event-definition within Activity
  * Method is used within: 'getAct()'
  * Return-CC used are: 0 and 1..37
  * Within 'validation-mask' the following keyword-mapping is used:
  *   0 'EventTypeTime'
  *   1 'EventTypeLocation'
  *   2 'EventTypeAllStops'
  *   3 'EventTypePickUpPassengers'
  *   4 Aufnahme machen
  *   5 'EventTypeReachSpeed'
  *   6 'EventTypePickUpWagons'
  *   7 'EventTypeDropOffWagonsAtLocation'
  *   8 'EventTypeAssembleTrain'
  *   9 'EventTypeAssembleTrainAtLocation'
  *  10 'ID'
  *  11 'Activation_Level'
  *  12 'Outcomes'
  *  13 'TextToDisplayOnCompletionIfTriggered'
  *  14 'TextToDisplayOnCompletionIfNotTriggered'
  *  15 'TextToDisplayDescriptionOfTask'
  *  16 'Reversable_Event'
  *  17 'Name'
  *  18 'Time'
  *  19 'Location'
  *  20 'TriggerOnStop'
  *  21 'StationStop'
  *  22 'Speed'
  *  23 'Wagon_List'
  *  24 'SidingItem'
  * Within 'Outcomes' the following 'Action-ID' is used:
  *   0 'IncActLevel' (<nr>)
  *   1 'DecActLevel' (<nr>)
  *   2 'ActivateEvent' (<nr>)
  *   3 'RestoreActLevel' (<nr>)
  *   4 'DisplayMessage' (<msg+>)
  *   5 'ActivitySuccess'
  *   6 'ActivityFail' (<msg>)
  *   7 'StartIgnoringSpeedLimits'
  *   8 'StopIgnoringSpeedLimits'
  * ##getActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getActEv( /* read Activity-Event-definition */
   TSBuf            cB,  /* definiton of current input-buffer */
   TreeSet<TSActEv> EvT, /* List of 'Event'-References */
   int              msk, /* validation-mask for event-type */
   int              ec,  /* current error-couter (will be returned) */
   String           prL, /* message-prefix (long form) */
   String           prK) /* message-prefix incl. '(' (short form) */
   {
   /*-----------------------------------------------------------------*/
    TSActEv           cEv;  /* control of current event-definition */
    TSQPos            cPos; /* temporary 'Location' */
    ArrayList<TSRefC> WgnT; /* current list of Wagons */
    TSRefC            cRef; /* temporary 'SidingItem' */
    String[]          cL;   /* message-array */
    String            prfx,pref,EvNme; /* message-prefix (full) */
    String            is;   /* intermediate value */
    int               i,j,l1,l2;
    double            d;    /* intermediate value */
   /*=================================================================*/
    cEv = null; /* event-definition is not created until now */
    EvNme = ""; /* Name of Event is not known */
    while(true) { /* read all definition-lines within 'EventCategory' */
      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getAct51",prL,cB.getStat(true)); /* print errormessage */
          return 1; } /* set current return-code and terminate evaluation */
        Lg.Err("getAct52",prL,is,cB.getStat(true)); /* print errormessage */
        return 2; } /* set current return-code and terminate evaluation */
      if(is.length()==0) break; /* all entries processed */
      l1 = cB.getBrL(); /* current bracket-level for terminate/break */
      eval:{ /* break-Block, used if error found */
        for(j=0;j<10;j+=1) /* check all event-types (definition-part) */
          if(is.equals(TSActEv.typNme[j].toLowerCase())) break; /* type found */
        if(j<10) { /* Eventype found within table */
          is = TSActEv.typNme[j]; /* get current 'name' of keyword */
          prfx = prK + ")-" + is; /* set 'name' of keyword */
          prL += "(" + is + ")"; /* and add it to long form */
          if(!TSOpts.chkMsk(j,msk)) { /* keyword is NOT valid for current event */
            Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv!=null) { /* Event was already created -- keyword no longer valid */
            Lg.Err("getAct5A",prfx,0,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          /* Attention: type-definitions DO NOT contain arguments */
          cEv = new TSActEv(j); /* create Event-definition of appropriate type */
          msk &= TSActEv.modMsk[j]; /* some keywords are no longer valid */
        } else if(is.equals("id")) { /* Definition-type: 'ID' */
          prfx = prK + ")-ID"; /* set 'name' of keyword */
          if(!TSOpts.chkMsk(10,msk)) { /* keyword is NOT valid for current event */
            Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv==null) { /* Creation of event is missing -- keyword not just jet valid */
            Lg.Err("getAct5F",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv.chkMsk(10)) { /* Keword was already processed -- no longer valid */
            Lg.Err("getAct5A",prfx,0,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          i = (int)cB.getNV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getAct58",prfx,is,cB.getStat(true)); /* print errormessage */
            return 3; } /* set current return-code and terminate evaluation */
          if(i<0) { /* invalid value for ID */
            Lg.Err("getAct56",prfx,i,cB.getStat(true));
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if((i=cEv.chgID(i))!=Integer.MIN_VALUE) { /* value already set -- replaced */
            Lg.Err("getAct54",prfx,i,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
          } /* error occurred while value was stored */
          cEv.setMsk(10); /* register: valid keyword was processed */
        } else if(is.equals("activation_level")) { /* Definition-type: 'Activation_Level' */
          prfx = prK + ")-Activation_Level"; /* set 'name' of keyword */
          if(!TSOpts.chkMsk(11,msk)) { /* keyword is NOT valid for current event */
            Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv==null) { /* Creation of event is missing -- keyword not just jet valid */
            Lg.Err("getAct5F",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv.chkMsk(11)) { /* Keword was already processed -- no longer valid */
            Lg.Err("getAct5A",prfx,0,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          i = (int)cB.getNV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getAct58",prfx,is,cB.getStat(true)); /* print errormessage */
            return 4; } /* set current return-code and terminate evaluation */
          if(Math.abs(i)>9) Lg.Log("getAct71",prfx,i,cB.getStat(true)); /* value seems to be NOT OK */
          if((i=cEv.chgLvl(i))!=Integer.MIN_VALUE) { /* value already set -- replaced */
            Lg.Err("getAct54",prfx,i,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
          } /* error occurred while value was stored */
          cEv.setMsk(11); /* register: valid keyword was processed */
        } else if(is.equals("outcomes")) { /* Definition-type: 'Outcomes' */
          prfx = prK + ")-Outcomes"; /* set 'name' of keyword */
          if(!TSOpts.chkMsk(12,msk)) { /* keyword is NOT valid for current event */
            Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv==null) { /* Creation of event is missing -- keyword not just jet valid */
            Lg.Err("getAct5F",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv.chkMsk(12)) { /* Keword was already processed -- no longer valid */
            Lg.Err("getAct5A",prfx,0,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          while(true) { /* read all definition-lines within 'Outcomes' */
            is = cB.getKE(true); /* get next controlword */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getAct51",prfx,cB.getStat(true)); /* print errormessage */
                return 5; } /* set current return-code and terminate evaluation */
              Lg.Err("getAct52",prfx,is,cB.getStat(true)); /* print errormessage */
              return 6; } /* set current return-code and terminate evaluation */
            if(is.length()==0) break; /* all entries processed */
            l2 = cB.getBrL(); /* current bracket-level for terminate/break */
            cRef = null; /* initialize: no entry created */
            outl:{ /* break-Block, used if error found */
              if(is.equals("incactlevel")) { /* Definition-type: 'IncActLevel' */
                pref = prK + ")-Out-IncActLevel"; /* set 'name' of keyword */
                i = (int)cB.getNV(); /* get value of argument (number) */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  Lg.Err("getAct58",pref,is,cB.getStat(true)); /* print errormessage */
                  return 7; } /* set current return-code and terminate evaluation */
                cRef = new TSRefC(i); /* create Reference-Definiton to Event-entry */
                cRef.chgIx(0); /* and insert 'Action-ID' into record */
              } else if(is.equals("decactlevel")) { /* Definition-type: 'DecActLevel' */
                pref = prK + ")-Out-DecActLevel"; /* set 'name' of keyword */
                i = (int)cB.getNV(); /* get value of argument (number) */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  Lg.Err("getAct58",pref,is,cB.getStat(true)); /* print errormessage */
                  return 8; } /* set current return-code and terminate evaluation */
                cRef = new TSRefC(i); /* create Reference-Definiton to Event-entry */
                cRef.chgIx(1); /* and insert 'Action-ID' into record */
              } else if(is.equals("activateevent")) { /* Definition-type: 'ActivateEvent' */
                pref = prK + ")-Out-ActivateEvent"; /* set 'name' of keyword */
                i = (int)cB.getNV(); /* get value of argument (number) */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  Lg.Err("getAct58",pref,is,cB.getStat(true)); /* print errormessage */
                  return 9; } /* set current return-code and terminate evaluation */
                cRef = new TSRefC(i); /* create Reference-Definiton to Event-entry */
                cRef.chgIx(2); /* and insert 'Action-ID' into record */
              } else if(is.equals("restoreactlevel")) { /* Definition-type: 'RestoreActLevel' */
                pref = prK + ")-Out-RestoreActLevel"; /* set 'name' of keyword */
                i = (int)cB.getNV(); /* get value of argument (number) */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  Lg.Err("getAct58",pref,is,cB.getStat(true)); /* print errormessage */
                  return 10; } /* set current return-code and terminate evaluation */
                cRef = new TSRefC(i); /* create Reference-Definiton to Event-entry */
                cRef.chgIx(3); /* and insert 'Action-ID' into record */
              } else if(is.equals("displaymessage")) { /* Definition-type: 'DisplayMessage' */
                pref = prK + ")-Out-DisplayMessage"; /* set 'name' of keyword */
                /* Attention: message may contain MORE than one line */
                cL = cB.getArr(); /* get value of argument  (message-array) */
                if(cL==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getAct51",pref,cB.getStat(true)); /* print errormessage */
                    return 11; } /* set current return-code and terminate evaluation */
                  Lg.Err("getAct52",pref,is,cB.getStat(true)); /* print errormessage */
                  return 12; } /* set current return-code and terminate evaluation */
                cRef = new TSRefC(); /* create Reference-Definiton without reference */
                cRef.chgIx(4);   /* insert 'Action-ID' into record */
                cRef.chgRef(cL); /* and add message-reference(s) to action-item */
              } else if(is.equals("activitysuccess")) { /* Definition-type: 'ActivitySuccess' */
                /* definition contains NO argument */
                cRef = new TSRefC(); /* create Reference-Definiton without reference */
                cRef.chgIx(5); /* and insert 'Action-ID' into record */
              } else if(is.equals("activityfail")) { /* Definition-type: 'ActivityFail' */
                pref = prK + ")-Out-ActivityFail"; /* set 'name' of keyword */
                is = cB.getVal(1); /* get value of argument  (current message) */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getAct51",pref,cB.getStat(true)); /* print errormessage */
                    return 13; } /* set current return-code and terminate evaluation */
                  Lg.Err("getAct52",pref,is,cB.getStat(true)); /* print errormessage */
                  return 14; } /* set current return-code and terminate evaluation */
                cRef = new TSRefC(); /* create Reference-Definiton without reference */
                cRef.chgIx(6);   /* insert 'Action-ID' into record */
                cRef.chgRef(is); /* and add message-reference to action-item */
              } else if(is.equals("startignoringspeedlimits")) {
                  /* Definition-type: 'StartIgnoringSpeedLimits' */
                pref = prK + ")-Out-StartIgnoringSpeedLimits"; /* set 'name' of keyword */
                /* definition contains NO argument */
                cRef = new TSRefC(); /* create Reference-Definiton without reference */
                cRef.chgIx(7); /* and insert 'Action-ID' into record */
              } else if(is.equals("stopignoringspeedlimits")) {
                  /* Definition-type: 'StopIgnoringSpeedLimits' */
                /* definition contains NO argument */
                cRef = new TSRefC(); /* create Reference-Definiton without reference */
                cRef.chgIx(8); /* and insert 'Action-ID' into record */
              } else { /* unknown keyword -- do not process */
                Lg.Err("getAct5D",prfx,is,cB.getStat(true)); /* errormessage */
                ec += 1; /* count error */
              } /* unknown keyword found ('break outl' is not needed) */
            } /* 'outl' - break-block for errors */
            if(cRef!=null) cEv.addRslt(cRef); /* store record into array */
              /* new entry created -- insert it into 'Rslt'-table */
            if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
              Lg.Err("getAct5C",prfx,cB.getErr(),cB.getStat(true)); /* errormessage */
              return 15; } /* set current return-code and terminate evaluation */
          } /* -while- read all definition-lines 'Outcomes' */
          cEv.setMsk(12); /* register: valid keyword was processed */
        } else if(is.equals("texttodisplayoncompletioniftriggered")) {
            /* Definition-type: 'TextToDisplayOnCompletionIfTriggered' */
          prfx = prK + ")-TextToDisplayOnCompletionIfTriggered"; /* set 'name' of keyword */
          if(!TSOpts.chkMsk(13,msk)) { /* keyword is NOT valid for current event */
            Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv==null) { /* Creation of event is missing -- keyword not just jet valid */
            Lg.Err("getAct5F",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv.chkMsk(13)) { /* Keword was already processed -- no longer valid */
            Lg.Err("getAct5A",prfx,0,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          is = cB.getVal(1); /* get value of argument  */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getAct51",prL,cB.getStat(true)); /* print errormessage */
              return 16; } /* set current return-code and terminate evaluation */
            Lg.Err("getAct52",prL,is,cB.getStat(true)); /* print errormessage */
            return 17; } /* set current return-code and terminate evaluation */
          if(is.length()==0) { /* argument not present -- clear storage */
            if(EnaW) Lg.Log("getAct72",prfx,"",cB.getStat(true));
            break eval; } /* terminate evaluation of entry */
          if((is=cEv.chgTxt(0,is))!=null) { /* value already set -- replaced */
            Lg.Err("getAct54",prfx,is,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
          } /* error occurred while value was stored */
          cEv.setMsk(13); /* register: valid keyword was processed */
        } else if(is.equals("texttodisplayoncompletionifnottriggered")) {
            /* Definition-type: 'TextToDisplayOnCompletionIfNotTriggered' */
          prfx = prK + ")-TextToDisplayOnCompletionIfNotTriggered"; /* set 'name' of keyword */
          if(!TSOpts.chkMsk(14,msk)) { /* keyword is NOT valid for current event */
            Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv==null) { /* Creation of event is missing -- keyword not just jet valid */
            Lg.Err("getAct5F",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv.chkMsk(14)) { /* Keword was already processed -- no longer valid */
            Lg.Err("getAct5A",prfx,0,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          is = cB.getVal(1); /* get value of argument  */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getAct51",prL,cB.getStat(true)); /* print errormessage */
              return 18; } /* set current return-code and terminate evaluation */
            Lg.Err("getAct52",prL,is,cB.getStat(true)); /* print errormessage */
            return 19; } /* set current return-code and terminate evaluation */
          if(is.length()==0) { /* argument not present -- clear storage */
            if(EnaW) Lg.Log("getAct72",prfx,"",cB.getStat(true));
            break eval; } /* terminate evaluation of entry */
          if((is=cEv.chgTxt(1,is))!=null) { /* value already set -- replaced */
            Lg.Err("getAct54",prfx,is,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
          } /* error occurred while value was stored */
          cEv.setMsk(14); /* register: valid keyword was processed */
        } else if(is.equals("texttodisplaydescriptionoftask")) {
            /* Definition-type: 'TextToDisplayDescriptionOfTask' */
          prfx = prK + ")-TextToDisplayDescriptionOfTask"; /* set 'name' of keyword */
          if(!TSOpts.chkMsk(15,msk)) { /* keyword is NOT valid for current event */
            Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv==null) { /* Creation of event is missing -- keyword not just jet valid */
            Lg.Err("getAct5F",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv.chkMsk(15)) { /* Keword was already processed -- no longer valid */
            Lg.Err("getAct5A",prfx,0,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          is = cB.getVal(1); /* get value of argument  */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getAct51",prL,cB.getStat(true)); /* print errormessage */
              return 20; } /* set current return-code and terminate evaluation */
            Lg.Err("getAct52",prL,is,cB.getStat(true)); /* print errormessage */
            return 21; } /* set current return-code and terminate evaluation */
          if(is.length()==0) { /* argument not present -- clear storage */
            if(EnaW) Lg.Log("getAct72",prfx,"",cB.getStat(true));
            break eval; } /* terminate evaluation of entry */
          if((is=cEv.chgTxt(2,is))!=null) { /* value already set -- replaced */
            Lg.Err("getAct54",prfx,is,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
          } /* error occurred while value was stored */
          cEv.setMsk(15); /* register: valid keyword was processed */
        } else if(is.equals("reversable_event")) { /* Definition-type: 'Reversable_Event' */
          prfx = prK + ")-Reversable_Event"; /* set 'name' of keyword */
          if(!TSOpts.chkMsk(16,msk)) { /* keyword is NOT valid for current event */
            Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv==null) { /* Creation of event is missing -- keyword not just jet valid */
            Lg.Err("getAct5F",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv.chkMsk(16)) { /* Keword was already processed -- no longer valid */
            Lg.Err("getAct5A",prfx,0,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          /* value is NOT explicitly stored. Existence of keyword marks it */
          cEv.setMsk(16); /* register: valid keyword was processed */
        } else if(is.equals("name")) { /* Definition-type: 'Name' */
          prfx = prK + ")-Name"; /* set 'name' of keyword */
          if(!TSOpts.chkMsk(17,msk)) { /* keyword is NOT valid for current event */
            Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv==null) { /* Creation of event is missing -- keyword not just jet valid */
            Lg.Err("getAct5F",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv.chkMsk(17)) { /* Keword was already processed -- no longer valid */
            Lg.Err("getAct5A",prfx,0,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          is = cB.getVal(1); /* get value of argument  */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getAct51",prL,cB.getStat(true)); /* print errormessage */
              return 22; } /* set current return-code and terminate evaluation */
            Lg.Err("getAct52",prL,is,cB.getStat(true)); /* print errormessage */
            return 23; } /* set current return-code and terminate evaluation */
          if(is.length()==0) { /* next keword not present */
            Lg.Err("getAct53",prfx,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if((is=cEv.chgNme(is))!=null) { /* value already set -- replaced */
            Lg.Err("getAct54",prfx,is,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
          } /* error occurred while value was stored */
          cEv.setMsk(17); /* register: valid keyword was processed */
        } else if(is.equals("time")) { /* Definition-type: 'Time' */
          prfx = prK + ")-Time"; /* set 'name' of keyword */
          if(!TSOpts.chkMsk(18,msk)) { /* keyword is NOT valid for current event */
            Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv==null) { /* Creation of event is missing -- keyword not just jet valid */
            Lg.Err("getAct5F",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv.chkMsk(18)) { /* Keword was already processed -- no longer valid */
            Lg.Err("getAct5A",prfx,0,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          i = (int)cB.getNV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getAct58",prfx,is,cB.getStat(true)); /* print errormessage */
            return 24; } /* set current return-code and terminate evaluation */
          if(i<0 || i>=86400) { /* invalid value for 'Time' */
            Lg.Err("getAct59",prfx,""+i,""+cB.getStat(true),"0","86400");
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if((i=cEv.chgTme(i))!=Integer.MIN_VALUE) { /* value already set -- replaced */
            Lg.Err("getAct54",prfx,i,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
          } /* error occurred while value was stored */
          cEv.setMsk(18); /* register: valid keyword was processed */
        } else if(is.equals("location")) { /* Definition-type: 'Location' */
          prfx = prK + ")-Location"; /* set 'name' of keyword */
          if(!TSOpts.chkMsk(19,msk)) { /* keyword is NOT valid for current event */
            Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv==null) { /* Creation of event is missing -- keyword not just jet valid */
            Lg.Err("getAct5F",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv.chkMsk(19)) { /* Keword was already processed -- no longer valid */
            Lg.Err("getAct5A",prfx,0,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          /* load position-values (qx qz x z) and check them */
          if((is=getPos(cB,false,true))!=null) { /* error within position */
            Lg.Err("getAct52",prfx,is,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          cPos = (TSQPos)RetVal; /* get valid position-definition */
          i = (int)cB.getNV(); /* get NEXT value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getAct58",prfx,is,cB.getStat(true)); /* print errormessage */
            return 25; } /* set current return-code and terminate evaluation */
          if(i<0 || i>100) { /* invalid value for Radius */
            Lg.Err("getAct59",prfx,""+i,""+cB.getStat(true),"0","100");
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          cPos.addPosY((double)i); /* insert value (add it to 0.0) */
          if(cEv.setPos(cPos)!=null) { /* value could not be stored */
            Lg.Err("getAct57",prfx,0,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
          } /* error occurred while value was stored */
          cEv.setMsk(19); /* register: valid keyword was processed */
        } else if(is.equals("triggeronstop")) { /* Definition-type: 'TriggerOnStop' */
          prfx = prK + ")-TriggerOnStop"; /* set 'name' of keyword */
          if(!TSOpts.chkMsk(20,msk)) { /* keyword is NOT valid for current event */
            Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv==null) { /* Creation of event is missing -- keyword not just jet valid */
            Lg.Err("getAct5F",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv.chkMsk(20)) { /* Keword was already processed -- no longer valid */
            Lg.Err("getAct5A",prfx,0,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          i = (int)cB.getNV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getAct58",prfx,is,cB.getStat(true)); /* print errormessage */
            return 26; } /* set current return-code and terminate evaluation */
          if(i!=0) { /* 'TriggerOnStop' is NOT 'false'(0) */
            if(i==1) cEv.setToS(); /* 'TriggerOnStop' is correctly set -- register it */
            else { /* invalid value (true/false) */
              Lg.Err("getAct56",prfx,i,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break eval; } /* terminate evaluation of entry */
          } /* value was NOT set */
          cEv.setMsk(20); /* register: valid keyword was processed */
        } else if(is.equals("stationstop")) { /* Definition-type: 'StationStop' */
          prfx = prK + ")-StationStop"; /* set 'name' of keyword */
          if(!TSOpts.chkMsk(21,msk)) { /* keyword is NOT valid for current event */
            Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv==null) { /* Creation of event is missing -- keyword not just jet valid */
            Lg.Err("getAct5F",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv.chkMsk(21)) { /* Keword was already processed -- no longer valid */
            Lg.Err("getAct5A",prfx,0,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          i = (int)cB.getNV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getAct58",prfx,is,cB.getStat(true)); /* print errormessage */
            return 27; } /* set current return-code and terminate evaluation */
          if(i<0) { /* invalid value */
            Lg.Err("getAct56",prfx,i,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          cRef = new TSRefC(i); /* create Reference for 'StationStop' */
          if((cRef=cEv.chgStStp(cRef))!=null) { /* value already set -- replaced */
            Lg.Err("getAct54",prfx,cRef.chgNr(Integer.MIN_VALUE),cB.getStat(true));
            ec += 1; /* count error */
          } /* error occurred while value was stored */
          cEv.setMsk(21); /* register: valid keyword was processed */
        } else if(is.equals("speed")) { /* Definition-type: 'Speed' */
          prfx = prK + ")-Speed"; /* set 'name' of keyword */
          if(!TSOpts.chkMsk(22,msk)) { /* keyword is NOT valid for current event */
            Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv==null) { /* Creation of event is missing -- keyword not just jet valid */
            Lg.Err("getAct5F",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv.chkMsk(22)) { /* Keword was already processed -- no longer valid */
            Lg.Err("getAct5A",prfx,0,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          d = cB.getFV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getAct58",prfx,is,cB.getStat(true)); /* print errormessage */
            return 28; } /* set current return-code and terminate evaluation */
          if(d<0.0) { /* 'Speed'-value is invalid */
            Lg.Err("getAct56",prfx,""+d,cB.getStat(true));
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(!Double.isNaN(d=cEv.chgSpd(d))) { /* value already set -- replaced */
            Lg.Err("getAct54",prfx,""+d,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
          } /* error occurred while value was stored */
          cEv.setMsk(22); /* register: valid keyword was processed */
        } else if(is.equals("wagon_list")) { /* Definition-type: 'Wagon_List' */
          prfx = prK + ")-Wagon_List"; /* set 'name' of keyword */
          if(!TSOpts.chkMsk(23,msk)) { /* keyword is NOT valid for current event */
            Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv==null) { /* Creation of event is missing -- keyword not just jet valid */
            Lg.Err("getAct5F",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv.chkMsk(23)) { /* Keword was already processed -- no longer valid */
            Lg.Err("getAct5A",prfx,0,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          WgnT = cEv.getWgn(5); /* create List of Wagon-definitions */
          j = 6; /* 'UID'(=2) and 'Sidingitem'(=3) allowed */
          cRef = new TSRefC(); /* create empty definition */
          while(true) { /* read all definition-lines within 'Wagon_List' */
            is = cB.getKE(true); /* get next controlword */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getAct51",prfx,cB.getStat(true)); /* print errormessage */
                return 29; } /* set current return-code and terminate evaluation */
              Lg.Err("getAct52",prfx,is,cB.getStat(true)); /* print errormessage */
              return 30; } /* set current return-code and terminate evaluation */
            if(is.length()==0) break; /* all entries processed */
            l2 = cB.getBrL(); /* current bracket-level for terminate/break */
            wgnl:{ /* break-Block, used if error found */
              if(is.equals("uid")) { /* Definition-type: 'UiD' */
                pref = prK + ")-WgnL-UiD"; /* set 'name' of keyword */
                if((j%2)!=0) { /* keyword not allowed at the moment */
                  Lg.Err("getAct5M",prfx,is,cB.getStat(true)); /* errormessage */
                  ec += 1; /* count error */
                  break wgnl; } /* terminate evaluation of entry */
                /* Due to the fact that UiD-numbers may be greater than a valid integer,
                 * the resulting 'stored number' may be negative.
                 * However, it MUST not be '2147483648'L (==Integer.MIN_VALUE) */
                i = (int)cB.getNV(); /* get value of argument (number) */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  Lg.Err("getAct58",pref,is,cB.getStat(true)); /* print errormessage */
                  return 31; } /* set current return-code and terminate evaluation */
                cRef.chgIx(i); /* insert 'UID' into Wagon-entry */
                j /= 2; /* switch off keyword (no longer allowed) */
              } else if(is.equals("sidingitem")) { /* Definition-type: 'SidingItem' */
                pref = prK + ")-WgnL-SidingItem"; /* set 'name' of keyword */
                if((j%3)!=0) { /* keyword not allowed at the moment */
                  Lg.Err("getAct5M",prfx,is,cB.getStat(true)); /* errormessage */
                  ec += 1; /* count error */
                  break wgnl; } /* terminate evaluation of entry */
                i = (int)cB.getNV(); /* get value of argument (number) */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  Lg.Err("getAct58",pref,is,cB.getStat(true)); /* print errormessage */
                  return 32; } /* set current return-code and terminate evaluation */
                if(i==-1) j *= 5; /* 'Description is now allowed */
                  /* 'SidingItem' is not specified */
                cRef.chgNr(i); /* insert 'SidingItem' / Marker into definition-record */
                j /= 3; /* switch off keyword (no longer allowed) */
              } else if(is.equals("description")) { /* Definition-type: 'Description' */
                pref = prK + ")-WgnL-Description"; /* set 'name' of keyword */
                if((j%5)!=0) { /* keyword not allowed at the moment */
                  Lg.Err("getAct5M",prfx,is,cB.getStat(true)); /* errormessage */
                  ec += 1; /* count error */
                  break wgnl; } /* terminate evaluation of entry */
                is = cB.getVal(1); /* get value of argument  (current message) */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getAct51",pref,cB.getStat(true)); /* print errormessage */
                    return 33; } /* set current return-code and terminate evaluation */
                  Lg.Err("getAct52",pref,is,cB.getStat(true)); /* print errormessage */
                  return 34; } /* set current return-code and terminate evaluation */
                if(is.length()==0) { /* next keword not present */
                  Lg.Err("getAct53",pref,cB.getStat(true)); /* print errormessage */
                  ec += 1; /* count error */
                  break wgnl; } /* terminate evaluation of entry */
                cRef.chgRef(is); /* insert message into definition-record */
                j /= 5; /* switch off keyword (no longer allowed) */
              } else { /* unknown keyword -- do not process */
                Lg.Err("getAct5D",prfx,is,cB.getStat(true)); /* errormessage */
                ec += 1; /* count error */
              } /* unknown keyword found ('break wgnl' is not needed) */
            } /* 'wgnl' - break-block for errors */
            if(j==1) { /* definition fully processed */
              WgnT.add(cRef); /* add complete element to table */
              cRef = new TSRefC(); /* create new empty definition */
              j = 6; /* 'UID'(=2) and 'Sidingitem'(=3) again allowed */
            } /* definition was fully processed */
            if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
              Lg.Err("getAct5C",prfx,cB.getErr(),cB.getStat(true)); /* errormessage */
              return 35; } /* set current return-code and terminate evaluation */
          } /* -while- read all definition-lines 'Wagon_List' */
          if(j!=6) Lg.Err("getAct5H",prfx,j,cB.getStat(true)); /* errormessage */
          cEv.setMsk(23); /* register: valid keyword was processed */
        } else if(is.equals("sidingitem")) { /* Definition-type: 'SidingItem' */
          prfx = prK + ")-SidingItem"; /* set 'name' of keyword */
          if(!TSOpts.chkMsk(24,msk)) { /* keyword is NOT valid for current event */
            Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv==null) { /* Creation of event is missing -- keyword not just jet valid */
            Lg.Err("getAct5F",prL,is,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          if(cEv.chkMsk(24)) { /* Keword was already processed -- no longer valid */
            Lg.Err("getAct5A",prfx,0,cB.getStat(true)); /* errormessage */
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          i = (int)cB.getNV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getAct58",prfx,is,cB.getStat(true)); /* print errormessage */
            return 36; } /* set current return-code and terminate evaluation */
          if(i<0) { /* invalid value for 'SidingItem' */
            Lg.Err("getAct56",prfx,i,cB.getStat(true));
            ec += 1; /* count error */
            break eval; } /* terminate evaluation of entry */
          cRef = new TSRefC(i); /* create Reference for 'SidingItem' */
          if((i=cEv.setItm(cRef))!=Integer.MIN_VALUE) { /* value already set -- replaced */
            Lg.Err("getAct54",prfx,i,cB.getStat(true));
            ec += 1; /* count error */
          } /* error occurred while value was stored */
          cEv.setMsk(24); /* register: valid keyword was processed */
        } else { /* unknown keyword -- do not process */
          Lg.Err("getAct5D",prL,is,cB.getStat(true)); /* errormessage */
          ec += 1; /* count error */
        } /* unknown keyword found ('break eval' is not needed) */
      } /* 'eval' - break-block for errors */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getAct5C",prL,cB.getErr(),cB.getStat(true)); /* errormessage */
        return 37; } /* set current return-code and terminate evaluation */
    } /* -while- read all definition-lines within 'EventCategory' */
    if(cEv!=null) { /* Event was created -- check it and add item to 'Event'-table */
      i = -EvT.size(); /* get dummy-ID in case of error */
      if(!cEv.chkMsk(10)) { /* ID is not available -- sort must fail */
        Lg.Err("getAct5I",prL,i,cB.getStat(true)); /* errormessage */
        cEv.chgID(i); /* Insert unique dummy-ID  */
        ec += 1; /* and count error */
      } /* error occurred while value was stored */
      if(!EvT.add(cEv)) { /* add (modified) item to 'Event'-table -- already present ? */
        Lg.Err("getAct5J",prL,cEv.chgID(i),i,cB.getStat(true)); /* errormessage */
          /* print errormessage and change ID to unique dummy-ID  */
        ec += 1; /* and count error */
        EvT.add(cEv); /* try it again and insert element (now successful) */
      } /* error occurred while value was stored */
    } /* (now) valid Event is added to 'Event'-table */

    RetVal = new Integer(ec); /* return new number of errors */
    return 0; /* return from function and signal 'no error' */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTrfDef"
  * Load Traffic-Definition and store into 'StationStop'-list
  * Method is referenced from 'getActDef()' and 'getTrfF()'!
  * Attention: Method stores current/updated error-counter to 'RetVal'.
  * Return-CC used are: 0 and 1..9
  * Prime-number-ID of (accepted) keywords are:
  *    2 - ArrivalTime
  *    3 - DepartTime
  *    5 - SkipCount
  *    7 - DistanceDownPath
  *   11 - PlatformStartID
  * ##getTrFDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getTrfDef( /* Traffic-Definition laden */
   TSBuf              cB,   /* current input-buffer */
   ArrayList<TSStStp> StpT, /* List of 'StationStop's */
   int                ec,   /* current error-couter (will be returned) */
   String             pref) /* message-prefix */
   {
   /*-----------------------------------------------------------------*/
    TSStStp cSt; /* current definition of 'StationStop' */
    String  is;  /* intermediate value */
    int     i,h,at,dt,sc,id,l1;
    double  d;   /* intermediate value */
   /*=================================================================*/
    d  = Double.NaN; /* initialize target-values */
    at = dt = sc = id = Integer.MIN_VALUE;
    h  = StpT.size(); /* initialize number of train-stop */
    l1 = cB.getBrL(); /* current bracket-level for terminate/break */
    ml:while(true) { /* process all lines of train-stops */
      i = 1; /* Initialize control of groups */
      while(i!=2310) { /* read until group of definitions is complete */
                       /* 2 * 3 * 5 * 7 * 11 = 2310 */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getTDef1",pref,h,cB.getStat(true)); /* print errormessage */
            return 1; } /* terminate function and return with signal */
          Lg.Err("getTDef2",pref,""+h,""+cB.getStat(true),is);
          return 2; } /* terminate function and return with signal */
        if(is.length()==0) break ml; /* all entries processed */
        gl:{ /* break-Block, used if error found */
          if(is.equals("arrivaltime")) { /* Definition-type: 'ArrivalTime' */
            if((i%2)==0) { /* line is already processed */
              Lg.Err("getTDef3",pref,"ArrivalTime",""+cB.getStat(true),""+h);
              ec += 1; /* count error */
              break gl; } /* terminate evaluation of sub-entry */
            at = (int)cB.getNV(); /* get value of argument (number) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTDef4",pref,"ArrivalTime",""+cB.getStat(true),""+h,is);
              return 3; } /* terminate function and return with signal */
            if(at<0 || at>=86400) { /* time-value is invalid (60*60*24=86400) */
              Lg.Err("getTDef5",pref,"ArrivalTime",""+cB.getStat(true),""+h,""+at);
              ec += 1; /* count error */
              at = Integer.MIN_VALUE; /* signal: invalid value */
            } /* Sub-Entry is valid but contains error */
            i *= 2; /* line was successfully processed -- register definition */
          } else if(is.equals("departtime")) { /* Definition-type: 'DepartTime' */
            if((i%3)==0) { /* line is already processed */
              Lg.Err("getTDef3",pref,"DepartTime",""+cB.getStat(true),""+h);
              ec += 1; /* count error */
              break gl; } /* terminate evaluation of sub-entry */
            dt = (int)cB.getNV(); /* get value of argument (number) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTDef4",pref,"DepartTime",""+cB.getStat(true),""+h,is);
              return 4; } /* terminate function and return with signal */
            if(dt<0 || dt>=86400) { /* time-value is invalid (60*60*24=86400) */
              Lg.Err("getTDef5",pref,"DepartTime",""+cB.getStat(true),""+h,""+dt);
              ec += 1; /* count error */
              dt = Integer.MIN_VALUE; /* signal: invalid value */
            } /* Sub-Entry is valid but contains error */
            i *= 3; /* line was successfully processed -- register definition */
          } else if(is.equals("skipcount")) { /* Definition-type: 'SkipCount' */
            if((i%5)==0) { /* line is already processed */
              Lg.Err("getTDef3",pref,"SkipCount",""+cB.getStat(true),""+h);
              ec += 1; /* count error */
              break gl; } /* terminate evaluation of sub-entry */
            sc = (int)cB.getNV(); /* get value of argument (number) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTDef4",pref,"SkipCount",""+cB.getStat(true),""+h,is);
              return 5; } /* terminate function and return with signal */
            if(sc<0) { /* 'SkipCount'-value is invalid */
              Lg.Err("getTDef5",pref,"SkipCount",""+cB.getStat(true),""+h,""+sc);
              ec += 1; /* count error */
              sc = Integer.MIN_VALUE; /* signal: invalid value */
            } /* Sub-Entry is valid but contains error */
            i *= 5; /* line was successfully processed -- register definition */
          } else if(is.equals("distancedownpath")) { /* Def.-type: 'DistanceDownPath' */
            if((i%7)==0) { /* line is already processed */
              Lg.Err("getTDef3",pref,"DistanceDownPath",""+cB.getStat(true),""+h);
              ec += 1; /* count error */
              break gl; } /* terminate evaluation of sub-entry */
            d = cB.getFV(); /* get value of argument (number) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTDef4",pref,"DistanceDownPath",""+cB.getStat(true),""+h,is);
              return 6; } /* terminate function and return with signal */
            if(d<0.0) { /* 'DistanceDownPath'-value is invalid */
              Lg.Err("getTDef5",pref,"DistanceDownPath",""+cB.getStat(true),""+h,""+d);
              ec += 1; /* count error */
              d = Double.NaN; /* signal: invalid value */
            } /* Sub-Entry is valid but contains error */
            i *= 7; /* line was successfully processed -- register definition */
          } else if(is.equals("platformstartid")) { /* Definition-type: 'PlatformStartID' */
            if((i%11)==0) { /* line is already processed */
              Lg.Err("getTDef3",pref,"PlatformStartID",""+cB.getStat(true),""+h);
              ec += 1; /* count error */
              break gl; } /* terminate evaluation of sub-entry */
            id = (int)cB.getNV(); /* get value of argument (number) */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getTDef4",pref,"PlatformStartID",""+cB.getStat(true),""+h,is);
              return 7; } /* terminate function and return with signal */
            if(id<0) { /* 'PlatformStartID'-value is invalid */
              Lg.Err("getTDef5",pref,"PlatformStartID",""+cB.getStat(true),""+h,""+id);
              ec += 1; /* count error */
              id = Integer.MIN_VALUE; /* signal: invalid value */
            } /* Sub-Entry is valid but contains error */
            i *= 11; /* line was successfully processed -- register definition */
          } else { /* unknown keyword -- do not process */
            Lg.Err("getTDef6",pref,is,""+cB.getStat(true),""+h); /* print errormessage */
            ec += 1; /* count error */
          } /* unknown keyword found ('break gl' is not needed) */
        } /* 'gl' - break-block for errors */
        if(cB.skpFwd()) { /* skip remaining data to new entry -- EOF/error found? */
          Lg.Err("getTDef7",pref,h,cB.getStat(true)); /* errormessage */
          return 8; } /* terminate function and return with signal */
      } /* -while- process goup completely */
      cSt = new TSStStp(at,dt,id,sc,d); /* create 'StationStop'-definition (T) */
      StpT.add(cSt); /* and add to proper list */
      h = StpT.size(); /* set new definition-number for errors */
    } /* -while- process all 'TrainStop'-Definitions */
    /* end of service-data reached -- check for uncomplete groups */
    if((i%2)==0) { /* line is defined additionally and is not part of any group */
      Lg.Err("getTDef8",pref,"ArrivalTime",""+cB.getStat(true),""+h); /* print errormessage */
      ec += 1; } /* count error */
    if((i%3)==0) { /* line is defined additionally and is not part of any group */
      Lg.Err("getTDef8",pref,"DepartTime",""+cB.getStat(true),""+h); /* print errormessage */
      ec += 1; } /* count error */
    if((i%5)==0) { /* line is defined additionally and is not part of any group */
      Lg.Err("getTDef8",pref,"SkipCount",""+cB.getStat(true),""+h); /* print errormessage */
      ec += 1; } /* count error */
    if((i%7)==0) { /* line is defined additionally and is not part of any group */
      Lg.Err("getTDef8",pref,"DistanceDownPath",""+cB.getStat(true),""+h); /* print errormessage */
      ec += 1; } /* count error */
    if((i%11)==0) { /* line is defined additionally and is not part of any group */
      Lg.Err("getTDef8",pref,"PlatformStartID",""+cB.getStat(true),""+h); /* print errormessage */
      ec += 1; } /* count error */
    if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
      Lg.Err("getTDef9",pref,cB.getStat(true)); /* print errormessage */
      return 9; } /* terminate function and return with signal */
    RetVal = new Integer(ec); /* return new number of errors */
    return 0; /* return from function -- no error */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTrain"
  * Read Train-definiton (Act/Consist) into memory, starting within
  *  'TrainCfg'-definition after name has been read.
  * Method is used within: 'getAct()', 'getSrv()'
  * Return-CC used are: 0 and 1..37
  * ##getTrain (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getTrain( /* read Train-definition */
   TSBuf   cB,   /* current input-buffer */
   TSTrain cTrn, /* current Train-definition */
   int     ec,   /* current error-couter (will be returned) */
   String  prL,  /* message-prefix (long form) */
   String  prK)  /* message-prefix incl. '(' (short form) */
   {
   /*-----------------------------------------------------------------*/
    ArrayList<TSRefC> TOT;  /* train-object-table */
    String            prfx; /* message-prefix (full) */
    String            is;   /* intermediate value */
    int               i,j,l1;
   /*=================================================================*/
    TOT = null; /* no table of train-objects available until now */
    while(true) { /* read all definition-lines within 'TrainCfg' */
      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getTrn01",prL,cB.getStat(true)); /* print errormessage */
          return 1; } /* terminate function and return with signal */
        Lg.Err("getTrn02",prL,is,cB.getStat(true)); /* errormessage */
        return 2; } /* terminate function and return with signal */
      if(is.length()==0) break; /* all entries processed */
      l1 = cB.getBrL(); /* current bracket-level for terminate/break */
      tcfl:{ /* break-Block, used if error found */
        if(is.equals("name")) { /* Definition-type: 'Name' */
          prfx = TSLogg.getMsg(prK,"Name"); /* set 'name' of keyword */
          is = cB.getVal(1); /* get value of argument */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getTrn01",prfx,cB.getStat(true)); /* print errormessage */
              return 3; } /* terminate function and return with signal */
            Lg.Err("getTrn02",prfx,is,cB.getStat(true)); /* print errormessage */
            return 4; } /* terminate function and return with signal */
          if(is.length()==0) { /* next keword not present */
            Lg.Err("getTrn03",prfx,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
            break tcfl; } /* terminate evaluation of entry */
          if((is=cTrn.chgNme(is))!=null) /* value already set -- replaced */
            Lg.Err("getTrn04",prfx,is,cB.getStat(true)); /* print errormessage */
          cTrn.setMsk(20); /* mark entry as 'found' */
        } else if(is.equals("serial")) { /* Definition-type: 'Serial' */
          prfx = TSLogg.getMsg(prK,"Serial"); /* set 'name' of keyword */
          i = (int)cB.getNV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getTrn05",prfx,is,cB.getStat(true)); /* print errormessage */
            return 5; } /* terminate function and return with signal */
          if(i<0) { /* invalid value for 'Serial' */
            Lg.Err("getTrn06",prfx,""+i,""+cB.getStat(true),"0","...");
            ec += 1; /* count error */
            break tcfl; } /* terminate evaluation of entry */
          if((i=cTrn.setInt(0,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
            Lg.Err("getTrn04",prfx,i,cB.getStat(true)); /* print errormessage */
          cTrn.setMsk(21); /* mark entry as 'found' */
        } else if(is.equals("maxvelocity")) { /* Definition-type: 'MaxVelocity' */
          prfx = TSLogg.getMsg(prK,"MaxVelocity"); /* set 'name' of keyword */
          is = cB.skpVal(); /* get remaining value(s) within brackets */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getTrn01",prfx,cB.getStat(true)); /* print errormessage */
              return 6; } /* terminate function and return with signal */
            Lg.Err("getTrn02",prfx,is,cB.getStat(true)); /* print errormessage */
            return 7; } /* terminate function and return with signal */
          if((is=cTrn.setDta(0,is))!=null) /* value already set -- replaced */
            Lg.Err("getTrn04",prfx,is,cB.getStat(true)); /* print errormessage */
          cTrn.setMsk(22); /* mark entry as 'found' */
        } else if(is.equals("nextwagonuid")) { /* Definition-type: 'NextWagonUID' */
          prfx = TSLogg.getMsg(prK,"NextWagonUID"); /* set 'name' of keyword */
          i = (int)cB.getNV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getTrn05",prfx,is,cB.getStat(true)); /* print errormessage */
            return 8; } /* terminate function and return with signal */
          if(i<0) { /* invalid value for 'NextWagonUID' */
            Lg.Err("getTrn06",prfx,""+i,""+cB.getStat(true),"0","...");
            ec += 1; /* count error */
            break tcfl; } /* terminate evaluation of entry */
          if(TOT==null) TOT = cTrn.getTObjT(i); /* get new table of train-objects */
          if((i=cTrn.setInt(1,i))!=Integer.MIN_VALUE) /* value already set -- replaced */
            Lg.Err("getTrn04",prfx,i,cB.getStat(true)); /* print errormessage */
          cTrn.setMsk(23); /* mark entry as 'found' */
        } else if(is.equals("durability")) { /* Definition-type: 'Durability */
          prfx = TSLogg.getMsg(prK,"Durability"); /* set 'name' of keyword */
          is = cB.skpVal(); /* get remaining value(s) within brackets */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getTrn01",prfx,cB.getStat(true)); /* print errormessage */
              return 9; } /* terminate function and return with signal */
            Lg.Err("getTrn02",prfx,is,cB.getStat(true)); /* print errormessage */
            return 10; } /* terminate function and return with signal */
          if((is=cTrn.setDta(1,is))!=null) /* value already set -- replaced */
            Lg.Err("getTrn05",prfx,is,cB.getStat(true)); /* print errormessage */
          cTrn.setMsk(24); /* mark entry as 'found' */
        } else if(is.equals("engine")) { /* Definition-type: 'Engine' */
          if(TOT==null) TOT = cTrn.getTObjT(10); /* get new table of train-objects */
          is = "Engine(" + TOT.size(); /* create extension for printing */
          i = getTrWgn(cB,TOT,ec,prK,is); /* read 'Engine/Wagon'-definition */
          if(i>0) return 10+i; /* set current return-code and terminate evaluation */
          ec = ((Integer)RetVal).intValue(); /* set new current value */
        } else if(is.equals("wagon")) { /* Definition-type: 'Wagon' */
          if(TOT==null) TOT = cTrn.getTObjT(10); /* get new table of train-objects */
          is = "Wagon(" + TOT.size(); /* create extension for printing */
          i = getTrWgn(cB,TOT,ec,prK,is); /* read 'Engine/Wagon'-definition */
          if(i>0) return 23+i; /* set current return-code and terminate evaluation */
          ec = ((Integer)RetVal).intValue(); /* set new current value */
        } else { /* unknown keyword -- do not process */
          Lg.Err("getTrn07",prL,is,cB.getStat(true)); /* errormessage */
          ec += 1; /* count error */
        } /* unknown keyword found ('break tcfl' is not needed) */
      } /* 'tcfl' - break-block for errors */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getTrn08",prL,cB.getErr(),cB.getStat(true)); /* errormessage */
        return 37; } /* terminate function and return with signal */
    } /* -while- read all definition-lines within 'TrainCfg' */
    /* more closing brackets are skipped with next 'cB.skpFwd()'-command */
    if(TOT!=null) TOT.trimToSize(); /* reorganize table of train-objects */
    RetVal = new Integer(ec); /* return new number of errors */
    return 0; /* return from function -- no error */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTrWgn"
  * Read Train-definiton (Act/Consist) into memory
  * Method is used within: 'getTrain()'
  * Return-CC used are: 0 and 1..13
  * ##getTrWgn (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getTrWgn( /* read Engine/Wagon-definition */
   TSBuf             cB,  /* current input-buffer */
   ArrayList<TSRefC> TOT, /* train-object-table */
   int               ec,  /* current error-counter (will be returned) */
   String            pr,  /* message-prefix */
   String            prE) /* message-prefix extension (first part) */
   {
   /*-----------------------------------------------------------------*/
    TSRefC   cRef;  /* collection of all parts of a train */
    String   prfx;  /* message-prefix (full) */
    String   is,js; /* intermediate value */
    String[] dta;   /* storage of train-data */
    int      i,o;   /* intermediate value */
   /*=================================================================*/
    o = 1; /* preset options */
    dta  = null; /* preset: no data available */
    cRef = null; /* preset: no Object (UID) available */
    while(true) { /* read all definition-lines within 'Engine'/'Wagon' */
      prfx = TSLogg.getMsg(pr,prE+")"); /* set 'name' of keyword */
      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getTrn01",prfx,cB.getStat(true)); /* print errormessage */
          return 1; } /* terminate function and return with signal */
        Lg.Err("getTrn02",prfx,is,cB.getStat(true)); /* print errormessage */
        return 2; } /* terminate function and return with signal */
      if(is.length()==0) break; /* all entries processed */
      kwl:{ /* break-Block, used if error found */
        if(is.equals("uid")) { /* Definition-type: 'UiD' */
          prfx = TSLogg.getMsg(pr,prE+")-UiD"); /* set 'name' of keyword */
          if(cRef!=null) { /* definition was already processed */
            Lg.Err("getTrn11",prfx,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
            break kwl; } /* terminate evaluation of entry */
          i = (int)cB.getNV(); /* get value of argument (number) */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getTrn05",prfx,is,cB.getStat(true)); /* print errormessage */
            return 3; } /* terminate function and return with signal */
          if(i!=TOT.size()) { /* incorrect value for 'UiD' */
            if(EnaW) Lg.Log("getTrn12",prfx,""+i,""+cB.getStat(true),""+TOT.size());
            ec += 1; /* count error */
          }  /* invalid value for 'UiD' */
          cRef = new TSRefC(i); /* create object with new ID */
        } else if(is.equals("flip")) { /* Definition-type: 'flip' */
          prfx = TSLogg.getMsg(pr,prE+")-Flip"); /* set 'name' of keyword */
          if((o%5)==0) { /* definition was already processed */
            Lg.Err("getTrn11",prfx,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
            break kwl; } /* terminate evaluation of entry */
          o *= 5; /* register 'flip' within options */
        } else if(is.equals("enginedata")) { /* Definition-type: 'EngineData' */
          prfx = TSLogg.getMsg(pr,prE+")-EngineData"); /* set 'name' of keyword */
          if(dta!=null) { /* definition was already processed */
            Lg.Err("getTrn11",prfx,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
            break kwl; } /* terminate evaluation of entry */
          is = cB.getVal(1); /* get value of argument */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getTrn01",prfx,cB.getStat(true)); /* print errormessage */
              return 4; } /* terminate function and return with signal */
            Lg.Err("getTrn02",prfx,is,cB.getStat(true)); /* print errormessage */
            return 5; } /* terminate function and return with signal */
          if(is.length()==0) { /* next keword not present */
            Lg.Err("getTrn03",prfx,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
            break kwl; } /* terminate evaluation of entry */
          js = cB.getVal(1); /* get value of argument */
          if(js==null) { /* error found within current input */
            if((js=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getTrn01",prfx,cB.getStat(true)); /* print errormessage */
              return 6; } /* terminate function and return with signal */
            Lg.Err("getTrn02",prfx,js,cB.getStat(true)); /* print errormessage */
            return 7; } /* terminate function and return with signal */
          if(js.length()==0) { /* next keword not present */
            Lg.Err("getTrn03",prfx,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
          } /* invalid path-definition found -- still use it */
          dta = new String[2]; /* create collector */
          dta[0] = is; /* insert (file-)name of train-object */
          dta[1] = js; /* insert (directory-)name of train-object */
          o *= 3; /* register 'EngineData' within options */
        } else if(is.equals("wagondata")) { /* Definition-type: 'WagonData' */
          prfx = TSLogg.getMsg(pr,prE+")-WagonData"); /* set 'name' of keyword */
          if(dta!=null) { /* definition was already processed */
            Lg.Err("getTrn11",prfx,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
            break kwl; } /* terminate evaluation of entry */
          is = cB.getVal(1); /* get value of argument */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getTrn01",prfx,cB.getStat(true)); /* print errormessage */
              return 8; } /* terminate function and return with signal */
            Lg.Err("getTrn02",prfx,is,cB.getStat(true)); /* print errormessage */
            return 9; } /* terminate function and return with signal */
          if(is.length()==0) { /* next keword not present */
            Lg.Err("getTrn03",prfx,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
            break kwl; } /* terminate evaluation of entry */
          is = is.replace('\\','/'); /* replace backslash within filename (if available) */
            /* filenames should be written using a common form */
          js = cB.getVal(1); /* get value of argument */
          if(js==null) { /* error found within current input */
            if((js=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getTrn01",prfx,cB.getStat(true)); /* print errormessage */
              return 10; } /* terminate function and return with signal */
            Lg.Err("getTrn02",prfx,js,cB.getStat(true)); /* print errormessage */
            return 11; } /* terminate function and return with signal */
          if(js.length()==0) { /* next keword not present */
            Lg.Err("getTrn03",prfx,cB.getStat(true)); /* print errormessage */
            ec += 1; /* count error */
          } /* invalid path-definition found -- still use it */
          is = is.replace('\\','/'); /* replace backslash within filename (if available) */
            /* directorynames should be written using a common form */
          dta = new String[2]; /* create collector */
          dta[0] = is; /* insert (file-)name of train-object */
          dta[1] = js; /* insert (directory-)name of train-object */
        } else { /* unknown keyword -- do not process */
          prfx = TSLogg.getMsg(pr,prE+")"); /* set 'name' of keyword */
          Lg.Err("getTrn07",prfx,is,cB.getStat(true)); /* errormessage */
          ec += 1; /* count error */
        } /* unknown keyword found ('break kwl' is not needed) */
      } /* 'kwl' - break-block for errors */
      if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
        prfx = TSLogg.getMsg(pr,prE+")"); /* set 'name' of keyword */
        Lg.Err("getTrn08",prfx,cB.getErr(),cB.getStat(true)); /* errormessage */
        return 12; } /* terminate function and return with signal */
    } /* -while- read all definition-lines within 'Engine'/'Wagon' */
    /* ALL definition-lines are read -- create train-object */
    prfx = TSLogg.getMsg(pr,prE+")"); /* set 'name' of keyword */
    if(cRef==null) { /* UID-definition was not present */
      Lg.Err("getTrn13",prfx,cB.getStat(true)); /* errormessage */
      return 13; /* terminate function and return with signal */
    } /* data-definition was not correct */
    if(dta==null) { /* data-definition was not correct */
      Lg.Err("getTrn14",prfx,o,cB.getStat(true)); /* errormessage */
      ec += 1; /* count error */
      o *= 2; /* insert error into options */
    } /* data-definition was not correct */
    cRef.chgIx(o); /* insert options */
    cRef.chgRef(dta); /* and data-definitions */
    if(!TOT.add(cRef)) { /* 'addition' of new entry was NOT successfull */
      Lg.Err("getTrn15",prfx,TOT.size(),cB.getStat(true)); /* errormessage */
      return 14; /* terminate function and return with signal */
    } /* object created and saved */

    RetVal = new Integer(ec); /* return new number of errors */
    return 0; /* return from function -- no error */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkAct"
  * Check and complete all activity-definitions of the route.
  * Attention: Traffic-definitions must be checked first
  * ##chkAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chkAct( /* check integrity of all activities */
   TSRoute cRte, /* current route-definition */
   boolean chg)  /* correct/remove invalid definition */
   {
   /*-----------------------------------------------------------------*/
    Iterator<TSAct>    cI;    /* iterator for all activity-definitions' */
    TSAct              cAct;  /* current Activity-Definition */
    TreeSet<TSQuad>    QDf;   /* Quad-definitions */
    TreeMap<String,TSTrf> Trf; /* List of all Traffic-Definitions */
    TSTrf              cTrf;  /* current Traffic-Definition */
    TreeMap<String,TSSrv> SvT; /* List of all Service-Definitions */
    TSSrv              cSv;   /* current Service-Definition */
    ArrayList<TSXtSrv> SrvT;  /* List of (ext.) Service-Definitions */
    Iterator<TSXtSrv>  SrvI;  /* Iterator for ext. Service-Definitions */
    TSXtSrv            cSrv; /* current (ext.) Service-Definition */
    ArrayList<TSStStp> StT;   /* List of 'StationStop'-Definitions(A) */
    ArrayList<TSStStp> StpT;  /* List of 'StationStop'-Definitions(T) */
    TSStStp            cStp;  /* current 'StationStop'-Definition */
    ArrayList<TSStop>  HltT;  /* List of 'StationStop'-Definitions (S) */
    TSStop             cHlt;  /* current 'StationStop'-definition (S) */
    TreeSet<TSActEv>   EvT;   /* List of all 'Event'-References */
    Iterator<TSActEv>  cEvI;  /* iterator for all 'Event'-References */
    TSActEv            cEv;   /* current Event-reference-element */
    ArrayList<TSActAO> AObjT; /* List of all AO-References */
    Iterator<TSActAO>  cAOI;  /* iterator for all AO-References */
    TSActAO            cAO;   /* current AO-reference-element */
    TSTrain            cTrn;  /* current reference to train */
    File               dir,dat; /* temporary files */
    ArrayList<TSActSZ> RSZT;  /* List of all RSZne-References */
    Iterator<TSActSZ>  cZneI; /* iterator for all RSZne-References */
    TSActSZ            cZne;  /* current reference-element (RSZ) */
    ArrayList<TSRefC>  RefT;  /* current 'RefC'-object-table */
    Iterator<TSRefC>   cRfI;  /* iterator for 'RefC'-objects */
    TSRefC             cRef;  /* current reference-element */
    TSTrItm            cIt;   /* currrent TrItem-Element */
    TSQPos             cPos;  /* current definiton of 'position' */
    int                rqU;   /* requested UID of object */
    int                c,ec;  /* counter */
    int                i,j,k,v,n; /* intermediate values */
    String             is;    /* intermediate string */
    String[]           cL;    /* intermediate string-Array */
    TSStStp[]          corrT; /* intermediate 'StationStop'-table */
    boolean            srt;   /* resort 'StationStop'-entries */
   /*=================================================================*/
    cI = cRte.getIt(16); /* get list of activity-definitions */
    if(cI==null) return -1; /* Activities are NOT loaded -- return */

    Lg.Skip(true); /* print empty line to Log-file and screen */
    Lg.Msg("chkAct01",cRte.getInfo(1)); /* print action-message */

    QDf = cRte.chgQDf(null); /* get list of valid quad-definitions */
    if(QDf==null) throw new IllegalStateException( /* integrity-check */
      TSLogg.getMsg("Msg908","TreeSet<TSQuad>==null","TSUtil.chkAct()",0));

    ec = 0; /* initialize: number of errors */
    c  = 0; /* initialize counter */
    SvT = cRte.getServ(); /* get table of ALL Service-Definitions */
    Trf = cRte.getTrf(); /* get table of ALL Traffic-Definitions */
    while(cI.hasNext()) { /* other activity-definitions available ? */
      cAct = cI.next(); /* get next Activity-entry */
      if(cAct==null) throw new IllegalStateException(
        TSLogg.getMsg("Msg908","TSAct==null","TSUtil.chkAct()",0));
      is = cAct.getName(true); /* get filename of activity */
      c += 1; /* count activity-definition */
      Lg.Log("chkAct02",is,c); /* report next action */

      /* process 'Player_Service_Definition' */
      cSrv = cAct.chgSrv(null); /* get current 'Player'-Service */
      if(cSrv==null) throw new IllegalStateException( /* integrity-error */
        TSLogg.getMsg("Msg908","Serv==null","TSUtil.chkAct()",0));
      is = cSrv.getName(); /* get name of current service (message,...) */
      /* search for Service-Definition with same name */
      cSv = SvT.get(is.toLowerCase()); /* get Service */
      if(cSv==null) { /* referenced service is not known */
        Lg.Err(chg?"chkAct11":"chkAct1A",is); /* print error-message */
        ec += 1; /* and count error */
        if(chg) { /* modify/correct/delete activity-definition */
          cI.remove(); /* activity contains severe error -- delete it */
          continue; /* no more checking neccessary */
        } /* error within Player_Service_Definition */
        cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
        HltT = new ArrayList<TSStop>(); /* Dummy-list for missing 'Service' */
      } else { /* Service was found -- connect it */
        cSrv.chgSrv(cSv); /* insert service-reference */
        cSv.incCnt(1);     /* and count connection */
        if(cSv.chkMsk(16)) cAct.setMsk(28); /* transfer error-marker from service */
        HltT = cSv.getStp(0); /* get StationStop-table of connected Service-definition */
      } /* connected service-definiton is checked */
      i = cSrv.chkID(0); /* check current UID-value */
      if(i>=0) { /* Player-service must use UID-value '0' */
        Lg.Err("chkAct12",is,i); /* print error-message */
        ec += 1; /* and count error */
        cSrv.setID(0); /* set current UID to valid value */
      } /* error within Player_Service_Definition */

      /* process internals of the player-service */
      StpT = cSrv.getStp(0); /* get table of Player-'StationStop'-entries (A/T) */
      n = 0;       /* initialize Skip-Count; value starts with '0' */
      srt = false; /* preset: no sort-error -- do NOT sort */
      j = StpT.size(); /* get number of entries for above table */
      corrT = new TSStStp[j]; /* create intermediate table for Event-correlation */
      for(i=0;i<j;i+=1) { /* process all 'StationStop'-entries (A/T) */
        cStp = StpT.get(i); /* get next 'StationStop'-entry (A/T) */
        if(cStp==null) throw new IllegalStateException( /* integrity-check */
          TSLogg.getMsg("Msg908","TSStStp==null","TSUtil.chkAct()",0));
        corrT[i] = cStp; /* save current element for Event-checking */
        n = cStp.chkSkip(n); /* check Skip-Count (greater?) */
        if(n<0) { /* error within sequence of skipcount-values */
          n = -n; /* clear error-marker */
          Lg.Err("chkAct13",is,i,n); /* print error-message */
          ec += 1; /* and count error */
          srt = true; /* initate 'sort' of entries */
        }  /* error within sequence of skipcount-values */
      } /* -while- process all 'StationStop'-definitions */
      if(srt) { /* error in order found -- sort entries */
        Collections.sort(StpT); /* sort all definitions */
        Lg.Err("chkAct14",is); /* print error-message */
      } /* sorting-error is corrected */

      /* process all 'StationStop'-definitions of the player-service */
//      if(cSv==null) HltT = new ArrayList<TSStop>(); /* Dummy-list for missing 'Service' */
//      else HltT = cSv.getStp(0); /* get StationStop-table of connected Service-definition */

      /* correlate 'StationStop'-entries (A/T) due to 'StationStop'-entries (S) */
      cl:for(i=j=0;i<HltT.size();i+=1,j+=1) { /* process all 'StationStop's (S) */
        cHlt = HltT.get(i); /* get required 'StationStop'-entry (S) */
        do { /* find this StationStop'-entry(S) within activity/traffic-service */
          if(j>=StpT.size()) { /* entry missing in player-service-table -- create it */
            Lg.Err(chg?"chkAct15":"chkAct16",is,j); /* print error-message */
            ec += 1; /* and count error */
            if(!chg) continue cl; /* do not create missing entry */
            cStp = new TSStStp(new TSStStp(cHlt)); /* create 'StationStop'-entry (A/T) */
            StpT.add(cStp); /* and add it to traffic-table */
          } else cStp = StpT.get(j); /* get required 'StationStop'-entry (A/T) */

          /* both entries are available (maybe new one) -- correlate them */
          if((n=cStp.corrS(cHlt))<=0) break; /* try to correlate entries */
          /* additional entry found -- process(delete) it */
          Lg.Err(chg?"chkAct17":"chkAct18",is,j); /* print error-message */
          ec += 1; /* and count error */
          cAct.setMsk(30); /* set error-marker: 'StationStop' for Player-service */
          if(chg) { /* invalidate and delete additional entry */
            cStp.mark(false); /* mark StationStop-Entry as 'invalid' (event-table) */
            StpT.remove(j); /* and delete additional entry (main-table) */
          } else j += 1; /* do not delete entry -- just skip it */
        } while(true); /* loop until correct correlation is found */
        if(n<0) { /* no matching activity/traffic-entry found  (entry missing) */
          Lg.Err(chg?"chkAct15":"chkAct16",is,j); /* print error-message */
          ec += 1; /* and count error */
          if(chg) { /* add missing entry and shift following entries */
            cStp = new TSStStp(new TSStStp(cHlt)); /* create 'StationStop'-entry (A/T) */
            StpT.add(j,cStp); /* and add it to activity-table */
            cAct.setMsk(30); /* set error-marker: 'StationStop' for Player-service */
          } else j -= 1; /* use current (target-)entry again -> adjust index */
        } /* no matching player-service-entry found  -- created */
        if(RetVal!=null) Lg.Err("chkAct19",is,(String)RetVal,j);
          /* error only can be active if a valid correlation is found */
      } /* -cl- process all 'StationStop's */
      /* report and delete additional 'StationStop'-entries (A/T) */
      for(n=j;j<StpT.size();n+=1) { /* report remaining 'StationStop's and delete */
        cStp = StpT.get(j); /* get 'StationStop'-entry (A/T) of player-service */
        Lg.Err(chg?"chkAct17":"chkAct18",is,n); /* print error-message */
        ec += 1; /* and count error */
        if(chg) { /* modification is requested -- delete additional entry */
          cStp.mark(false); /* mark StationStop-Entry as 'invalid' (event-table) */
          StpT.remove(j); /* delete current entry (main-table) */
        } else j += 1; /* or switch to next entry */
      } /* -for- report remaining 'StationStop's and delete */
      StpT.trimToSize(); /* reorganize memory for entries of table */

      rqU = 0; /* preset minimum service-ID */
      if(cAct.chkMsk(20)) L20:{ /* 'Traffic_Definition' present */
        is = cAct.chgTNme(null); /* get name of current traffic-definition */
        cTrf = Trf.get(is.toLowerCase()); /* get Traffic from traffic-list */
        if(cTrf==null) { /* referenced traffic is not known */
          Lg.Err(chg?"chkAct21":"chkAct22",is); /* print error-message */
          ec += 1; /* and count error */
//          cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
          if(chg) cAct.clrMsk(20); /* remove invalid Traffic-definition */
          break L20; /* no more checking neccessary */
        } /* error within Traffic-Definition */
        if(cTrf.chkMsk(16)) cAct.setMsk(28); /* transfer error-marker from traffic */
        cAct.chgTrf(cTrf); /* insert traffic-reference */
        cTrf.incCnt(1);    /* and count connection */

        SrvT = cAct.getTrfT(0); /* get current table of 'Traffic-Service'-definitions */
        if(SrvT==null) throw new IllegalStateException( /* integrity-error */
          TSLogg.getMsg("Msg908","TrfT==null","TSUtil.chkAct()",0));
        SrvI = SrvT.iterator(); /* get iterator to table of Traffic-services (A) */
        j = Integer.MIN_VALUE; /* preset 'Time'-value for check */
        i = -1; /* initialize number of entry (first valid index = 0) */
        while(SrvI.hasNext()) { /* more traffic-service-definitions available ? */
          cSrv = SrvI.next(); /* get next traffic-service-entry */
          i += 1; /* compute next index of entry */
          is = cSrv.getName(); /* get name of current traffic-service (message,...) */

          /* Correlate 'A<->T'-Service. If match is found all data is tranfered to A-service
           * Find current traffic-service in the list of all services of the selected
           * traffic-definition. Copy all fix values to the current service, if a valid
           * correlation could be found. */
          if((StpT=cSrv.fndTrf(cTrf))==null) { /* connection cannot be established */
            Lg.Err("chkAct23",is,i); /* print error-message */
            ec += 1; /* and count error */
            if(chg) { /* remove entry and continue testing */
              Lg.Err("chkAct24",is,i); /* print error-message */
              SrvI.remove(); /* remove invalid Traffic-Service-definition from Activity */
              continue; /* no more checking neccessary */
            } /* invalid entry was removed */
            /* continue testing although NO 'A<->T'-connection exits */
            StpT = new ArrayList<TSStStp>(); /* create Dummy-table */
            cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
          } /* no traffic-version of current service-definition */
          /* 'StpT' contains 'StationStop'-definitions (version T) of connected traffic
           * 'StpT' contains a dummy-table if no 'connected traffic' could be found */

          k = cSrv.chkID(++rqU); /* check current ID */
          if(k>=0) { /* error: ID is NOT correct */
            if(k>rqU) { /* ID's missing but valid situation */
              if(EnaH) Lg.Log("chkAct25",is,i,k,rqU); /* print message */
              rqU = k; /* set new ID for continuation */
            } else { /* Warning: ID is NOT correct */
              if (EnaW) Lg.Log("chkAct26",is,i,k,rqU); /* print message */
            } /* service-ID was not correct -- renumber it */
            cAct.setMsk(29); /* mark operation within activity-definition */
          } /* service-ID was not correct -- renumber it */

          j = cSrv.chkTime(j); /* check 'Start-Time' if ascending */
          if(j<0) { /* error: time is NOT ascending */
            j = -j; /* clear error-marker */
//            if(EnaH) Lg.Log("chkAct27",is,i); /* print message */
            cAct.setMsk(29); /* mark operation within activity-definition */
          } /* warning: 'Start-Time' was not ascending */

          /* process all 'StationStop'-definitions of the service */
          StT = cSrv.getStp(0); /* get StationStop-table (A) of connected Service-definition */
          /* correlate 'StationStop'-entries (A) due to 'StationStop'-entries (T/S) */
          xl:for(k=v=0;k<StpT.size();k+=1,v+=1) { /* process all 'StationStop's (T) */
            cStp = StpT.get(k); /* get required 'StationStop'-entry (T) */
            do { /* find this StationStop'-entry(T) within activity-service */
              if(v>=StT.size()) { /* entry missing in activity-table -- create it */
                Lg.Err(chg?"chkAct28":"chkAct29",is,i,v); /* print error-message */
                ec += 1; /* and count error */
                if(!chg) continue xl; /* do not create entry -- process next one */
                StT.add(new TSStStp(cStp)); /* create 'StationStop'-entry (A/T) */
                  /* using template and add it to traffic-table
                   * Attention: template entry (T) already has a connection to entry type (S) */
              } /* requested entry added to traffic-table */

              if((n=StT.get(v).corrT(cStp))<=0) break; /* try to correlate entries */
                /* get required 'StationStop'-entry (A) and try to correlate.

              /* additional entry(A) found -- process(delete) it */
              Lg.Err(chg?"chkAct2A":"chkAct2B",is,i,v); /* print error-message */
              ec += 1; /* and count error */
              if(chg) StT.remove(v); /* delete additional entry (A) */
              else v += 1; /* do not delete entry -- just skip it */
            } while(true); /* loop until correct correlation is found */
            if(n<0) { /* matching activity-entry missing */
              Lg.Err(chg?"chkAct28":"chkAct29",is,i,v); /* print error-message */
              ec += 1; /* and count error */
              if(chg) StT.add(v,new TSStStp(cStp)); /* create 'StationStop'-entry (A/T) */
                /* using template and add it to traffic-table (A) */
              else v -= 1;  /* use current (target-)entry again -> adjust index */
            } /* no matching activity-entry found  -- created */
            if(RetVal!=null) Lg.Err("chkAct2C",is,""+i,""+v,(String)RetVal);
              /* error only can be active if a valid correlation is found */
          } /* -xl- process all 'StationStop's */
          /* report and delete additional 'StationStop'-entries (A) */
          for(n=v;v<StT.size();n+=1) { /* report remaining 'StationStop's and delete */
            Lg.Err(chg?"chkAct2A":"chkAct2B",is,i,n); /* print error-message */
            ec += 1; /* and count error */
            if(chg) StT.remove(v); /* delete current (additional) entry */
            else v += 1; /* or switch to next entry */
          } /* -for- report remaining 'StationStop's and delete */
          StT.trimToSize(); /* reorganize memory for entries of table */
        } /* -while- process all traffic-definitions */

        if(cAct.chkMsk(29)) { /* error in sort-order found -- sort entries */
          if(EnaH) Lg.Log("chkAct2D",cAct.chgTNme(null)); /* print message */
          Collections.sort(SrvT); /* sort all definitions */
          SrvI = SrvT.iterator(); /* get iterator to table */
          rqU = 0; /* preset new 'UiD'-value */
          while(SrvI.hasNext()) { /* more definitions available ? */
            cSrv = SrvI.next(); /* get next traffic-entry */
            cSrv.setID(++rqU); /* insert new UID-value for traffic-definition */
          } /* -while- process all traffic-definitions */
        } /* sorting-error is corrected */
      } /* 'Traffic_Definition' was present */

      /* process entry: 'NextServiceUID' */
      rqU += 1; /* increment to 'NextServiceUID' */
      if((i=cAct.setInt(15,rqU))!=rqU) /* requested value replaced -- check it */
        if(EnaW) Lg.Log("chkAct31",null,i,rqU); /* print error-message */
      /* 'NextServiceUID' was corrected or adjusted */

      if(cAct.chkMsk(21)) { /* 'Events' available */
        EvT = cAct.getEvT(false); /* get current table of definitions */
        if(EvT==null) throw new IllegalStateException( /* integrity-error */
          TSLogg.getMsg("Msg908","EvntT==null","TSUtil.chkAct()",0));
        cEvI = EvT.iterator(); /* get iterator to table */
        j = -1; /* preset number of event-id */
        while(cEvI.hasNext()) { /* more definitions available ? */
          cEv = cEvI.next(); /* get next 'Evnt'-entry */
          j += 1; /* forward to next serial-number */
          /* check all sub-definitions of the event-object */
          if((i=cEv.chgID(Integer.MIN_VALUE))<0) { /* Dummy-'ID'-definition used */
            Lg.Err("chkAct41",null,j,i); /* print errormessage */
            ec += 1; /* count error */
            cEvI.remove(); /* delete definition in any case */
            continue; /* and continue with next definition */
          } /* 'ID'-definition uses dummy-ID */
          if(!cEv.setMsk(11)) { /* 'Activation_Level'-definition WAS NOT present */
            Lg.Err("chkAct42",j); /* print errormessage */
            ec += 1; /* count error */
            cEv.chgLvl(1); /* insert new default-level */
          } /* definition WAS NOT present */
          if(!cEv.setMsk(12)) { /* 'Outcomes'-definition WAS NOT present */
            Lg.Err("chkAct43",j); /* print errormessage */
            ec += 1; /* count error */
            /* create dummy-result and add it to 'Outcomes'-table */
            cRef = new TSRefC(); /* create empty result-definition */
            cRef.chgIx(6); /* insert result-type 'ActivityFail' */
            cRef.chgRef(TSLogg.getKey("TSActEC8")); /* and error-message */
              /* Attention: Message is also used within 'TSActEv.crDef()' */
            i = cEv.addRslt(cRef); /* store record into array */
            if(i!=1) throw new IllegalStateException( /* integrity-error */
              TSLogg.getMsg("Msg908","Outcomes-Problem","TSUtil.chkAct()",i));
            if(!chg) cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
              /* modifications not requested: mark correction as an error */
          } /* definition WAS NOT present */
          cRfI = cEv.getRslt(); /* get iterator over all 'Outcomes'-entries */
          while(cRfI.hasNext()) { /* check all 'Outcomes'-definitions */
            cRef = cRfI.next(); /* get next entry from table */
            switch(i=cRef.chgIx(Integer.MIN_VALUE)) { /* check due to 'Action-ID' */
              case(0): /* process action: 'IncActLevel' */
              case(1): /* process action: 'DecActLevel' */
              case(2): /* process action: 'ActivateEvent' */
              case(3): /* process action: 'RestoreActLevel' */
                if(cAct.fndEvnt(cRef)!=null) break; /* connection found -- OK */
                Lg.Err("chkAct54",TSActEv.getAct(i),j,cRef.chgNr(Integer.MIN_VALUE));
                ec += 1; /* count error */
                break; /* action was completely processed */
              case(4): /* process action: 'DisplayMessage' */
                cL = (String[])cRef.chgRef(null); /* get message-definition of action */
                if(cL.length<2 && cL[0].length()==0)  /* empty message specified */
                  if(EnaH) Lg.Log("chkAct55",TSActEv.getAct(i),j); /* print message */
                break; /* action was completely processed */
              case(6): /* process action: 'ActivityFail' */
                is = (String)cRef.chgRef(null); /* get message-definition of action */
                if(is.length()==0) /* no (valid) message specified */
                  if(EnaH) Lg.Log("chkAct56",TSActEv.getAct(i),j); /* print message */
                break; /* action was completely processed */
              case(5): /* process action: 'ActivitySuccess' */
              case(7): /* process action: 'StartIgnoringSpeedLimits' */
              case(8): /* process action: 'StopIgnoringSpeedLimits' */
                break; /* action was completely processed */
              default: /* invalid 'Action-ID' found */
                Lg.Err("chkAct51",null,j,i); /* print errormessage */
                ec += 1; /* count error */
                cRfI.remove(); /* delete definition */
                if(!chg) cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
                  /* modifications not requested: mark correction as an error */
            } /* -switch- entry was checked due to 'Action-id' */
          } /* -while- all 'Outcomes'-definitions were checked */
          if((i=cEv.addRslt(null))>4) { /* too many 'Outcomes'-entries defined */
            Lg.Err("chkAct59",null,j,i); /* print errormessage */
            ec += 1; /* count error */
          } /* too many definition present */
          /* Definition 'TextToDisplayOnCompletionIfTriggered' (13) needs not to be checked */
          /* Definition 'TextToDisplayOnCompletionIfNotTriggered' (14) needs not to be checked */
          /* Definition 'TextToDisplayDescriptionOfTask' (15) needs not to be checked */
          /* Definition 'Reversable_Event' (16) needs not to be checked */
          if(!cEv.setMsk(17)) { /* 'Name'-definition WAS NOT present */
            is = "Event-" + j; /* create dummy-name of event */
            Lg.Err("chkAct45",is,j); /* print errormessage */
            ec += 1; /* count error */
            cEv.chgNme(is); /* insert new event-name */
          } /* definition WAS NOT present */
          if(!cEv.chkMsk(18) && cEv.chkMsk(0)) { /* 'Time'-definition WAS NOT present */
            /* If type is (0)'EventTypeTime', current definition is needed. */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkAct46",j); /* print errormessage */
              cEvI.remove(); /* delete definition */
              continue; /* and continue with next definition */
            } /* incorrect definition should be removed/corrected */
            Lg.Err("chkAct47",j); /* print errormessage */
            cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
          } /* definition WAS NOT present */
          if(cEv.chkMsk(19)) { /* 'Location'-definition is present */
            if((is=cEv.fndWrld(QDf))!=null) { /* position contains no valid world-ref. */
              ec += 1; /* count error */
              if(chg) { /* incorrect definition should be removed/corrected */
                Lg.Err("chkAct61",is,j); /* print errormessage */
                cEvI.remove(); /* delete definition */
              } else { /* modifications not requested: mark correction as an error */
                Lg.Err("chkAct62",is,j); /* print errormessage */
                cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
              } /* modifications not requested: mark correction as an error */
              continue; /* and continue with next definition */
            } /* world-reference within position NOT valid */
          } else if(cEv.chkMsk(1)) { /* 'Location'-definition IS required
             * If type is (1)'EventTypeLocation', current definition is needed.
             */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkAct63",j); /* print errormessage */
              cEvI.remove(); /* delete definition */
              continue; /* and continue with next definition */
            } /* incorrect definition should be removed/corrected */
            Lg.Err("chkAct64",j); /* print errormessage */
            cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
          } /* 'Location'-definition NOT present */
          /* Definition 'TriggerOnStop' (20) needs not to be checked */
          if(cEv.chkMsk(21)) L21:{ /* 'StationStop'-definition is present */
            cRef = cEv.chgStStp(null); /* get connected 'StationStop'-reference */
            if(cRef==null) throw new IllegalStateException( /* integrity-error */
              TSLogg.getMsg("Msg908","StStp==null","TSUtil.chkAct()",0));
            i = cRef.chgNr(Integer.MIN_VALUE); /* get number of relative 'StationStop' */
            if(i<0 || i>=corrT.length) { /* invalid reference to 'StationStop' */
              ec += 1; /* count error */
              if(chg) { /* incorrect definition should be removed/corrected */
                Lg.Err("chkAct71",""+(corrT.length-1),j,i); /* print errormessage */
                cEvI.remove(); /* delete definition */
                continue; /* and continue with next definition */
              } /* incorrect definition should be removed/corrected */
              Lg.Err("chkAct72",""+(corrT.length-1),j,i); /* print errormessage */
              cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
              break L21; /* definition processed with error */
            } /* index to StationStop'-entry was NOT valid */
            if(corrT[i].mark(true)) { /* 'StationStop'-entry is invalid due to error */
              ec += 1; /* count error */
              if(chg) { /* incorrect definition should be removed/corrected */
                Lg.Err("chkAct73",null,j,i); /* print errormessage */
                cEvI.remove(); /* delete definition */
                continue; /* and continue with next definition */
              } /* incorrect definition should be removed/corrected */
              Lg.Err("chkAct74",null,j,i); /* print errormessage */
              cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
              break L21; /* definition processed with error */
            } /* 'StationStop'-entry was deleted due to error */
            cRef.chgRef(corrT[i]); /* insert reference to 'StationStop'-entry */
          } else if(cEv.chkMsk(3)) { /* 'StationStop'-definition IS required */
            /* If type is (3)'EventTypePickUpPassengers', current definition is needed. */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkAct75",j); /* print errormessage */
              cEvI.remove(); /* delete definition */
              continue; /* and continue with next definition */
            } else Lg.Err("chkAct76",j); /* print errormessage */
          } /* 'StationStop'-definition NOT present */
          if(!cEv.chkMsk(22) && cEv.chkMsk(5)) { /* 'Speed'-definition WAS NOT present */
            /* If type is (5)'EventTypeReachSpeed', current definition is needed. */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkAct48",j); /* print errormessage */
              cEvI.remove(); /* delete definition */
              continue; /* and continue with next definition */
            } /* incorrect definition should be removed/corrected */
            Lg.Err("chkAct49",j); /* print errormessage */
            cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
          } /* definition WAS NOT present */
          if(cEv.chkMsk(23)) { /* 'Wagon_List'-definition is present */
            RefT = cEv.getWgn(0); /* get current table of wagons */
            if(RefT==null) throw new IllegalStateException( /* integrity-error */
              TSLogg.getMsg("Msg908","Evnt.WgnT==null","TSUtil.chkAct()",0));
            cRfI = RefT.iterator(); /* get iterator to table */
            k = -1; /* initialize numer of entry (first valid number will be 0) */
            while(cRfI.hasNext()) { /* more definitions available ? */
              cRef = cRfI.next(); /* get next 'RefC'-entry */
              k += 1; /* advance number of entry */
              if((i=cRef.chgNr(Integer.MIN_VALUE))<0) continue; /* NO reference to 'SidingItem' */
              if((cIt=cRte.fndTrI(0,cRef))==null) { /* connection NOT found */
                ec += 1; /* count error */
                if(chg) { /* incorrect definition should be removed/corrected */
                  Lg.Err("chkAct81",""+i,j,k); /* print errormessage */
                  cRfI.remove(); /* delete definition */
                } else { /* modifications not requested: mark correction as an error */
                  Lg.Err("chkAct82",""+i,j,k); /* print errormessage */
                  cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
                } /* mark correction as an error */
                continue; /* and continue with next definition */
              } /* referenced TrItem not found */
              /* 'TrItem'-connection found -- check it */
              i = cIt.getNr(true); /* get number of TrItem-definition */
              if(cIt.getTyp()!=3) { /* no 'SidingItem' connected */
                ec += 1; /* count error */
                if(chg) { /* incorrect definition should be removed/corrected */
                  Lg.Err("chkAct83",""+i,j,k); /* print errormessage */
                  cRfI.remove(); /* delete definition */
                } else { /* modifications not requested: mark correction as an error */
                  Lg.Err("chkAct84",""+i,j,k); /* print errormessage */
                  cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
                } /* mark correction as an error */
              } /* referenced TrItem fully processed */
              if(cIt.chkMsk(0)) { /* 'SidingItem' no longer valid */
                ec += 1; /* count error */
                if(chg) { /* incorrect definition should be removed/corrected */
                  Lg.Err("chkAct8A",""+i,j,k); /* print errormessage */
                  cRfI.remove(); /* delete definition */
                } else { /* modifications not requested: mark correction as an error */
                  Lg.Err("chkAct8B",""+i,j,k); /* print errormessage */
                  cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
                } /* mark correction as an error */
              } /* referenced TrItem fully processed */
              if(cIt.chkMsk(1) || cIt.incCnt(0)==0) { /* Item contains error */
                Lg.Err("chkAct85",""+i,j,k); /* print errormessage */
                ec += 1; /* count error */
              } /* error within TrItem-definition -- report it */
            } /* -while- process all 'RefC'-definitions */
            if(RefT.isEmpty()) { /* empty table -- deactivate it */
              ec += 1; /* count error */
              if(chg) { /* incorrect definition should be removed/corrected */
                Lg.Err("chkAct86",j); /* print errormessage */
                cEvI.remove(); /* delete definition */
                continue; /* and continue with next definition */
              } /* incorrect definition should be removed/corrected */
              Lg.Err("chkAct87",j); /* print errormessage */
              cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
            } /* table is now empty -- delete event */
          } else if(cEv.getMsk(0x3C0)!=0) { /* 'Wagon_List'-definition IS required
             * If type is (6)'EventTypePickUpWagons', current definition is needed.
             * If type is (7)'EventTypeDropOffWagonsAtLocation', current definition is needed.
             * If type is (8)'EventTypeAssembleTrain', current definition is needed.
             * If type is (9)'EventTypeAssembleTrainAtLocation', current definition is needed.
             */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkAct88",j); /* print errormessage */
              cEvI.remove(); /* delete definition */
              continue; /* and continue with next definition */
            } /* incorrect definition should be removed/corrected */
            Lg.Err("chkAct89",j); /* print errormessage */
            cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
          } /* 'Wagon_List'-definition NOT present */
          if(cEv.chkMsk(24)) { /* 'SidingItem'-definition is present */
            cIt = cEv.fndTrI(cRte); /* find connection for 'SidingItem' */
            if(cIt==null) { /* requested connection NOT found */
              i = ((Integer)RetVal).intValue(); /* get number of TrItem-object */
              ec += 1; /* count error */
              if(chg) { /* incorrect definition should be removed/corrected */
                Lg.Err("chkAct91",null,j,i); /* print errormessage */
                cEvI.remove(); /* delete definition */
              } else { /* modifications not requested: mark correction as an error */
                Lg.Err("chkAct92",null,j,i); /* print errormessage */
                cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
              } /* mark correction as an error */
              continue; /* and continue with next definition */
            } /* referenced TrItem not found */
            /* 'TrItem'-connection found -- check it */
            i = cIt.getNr(true); /* get number of TrItem-definition */
            if(cIt.getTyp()!=3) { /* no 'SidingItem' connected */
              ec += 1; /* count error */
              if(chg) { /* incorrect definition should be removed/corrected */
                Lg.Err("chkAct93",null,j,i); /* print errormessage */
                cEvI.remove(); /* delete definition */
              } else { /* modifications not requested: mark correction as an error */
                Lg.Err("chkAct94",null,j,i); /* print errormessage */
                cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
              } /* mark correction as an error */
            } /* referenced TrItem fully processed */
            if(cIt.chkMsk(0)) { /* 'SidingItem' no longer valid */
              ec += 1; /* count error */
              if(chg) { /* incorrect definition should be removed/corrected */
                Lg.Err("chkAct98",null,j,i); /* print errormessage */
                cRfI.remove(); /* delete definition */
              } else { /* modifications not requested: mark correction as an error */
                Lg.Err("chkAct99",null,j,i); /* print errormessage */
                cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
              } /* mark correction as an error */
            } /* referenced TrItem fully processed */
            if(cIt.chkMsk(1) || cIt.incCnt(0)==0) { /* Item contains error */
              Lg.Err("chkAct95",null,j,i); /* print errormessage */
              ec += 1; /* count error */
            } /* error within TrItem-definition -- report it */
          } else if(cEv.getMsk(0x280)!=0) { /* 'SidingItem'-definition IS required
             * If type is (7)'EventTypeDropOffWagonsAtLocation', current definition is needed.
             * If type is (9)'EventTypeAssembleTrainAtLocation', current definition is needed.
             */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkAct96",j); /* print errormessage */
              cEvI.remove(); /* delete definition */
              continue; /* and continue with next definition */
            } /* incorrect definition should be removed/corrected */
            Lg.Err("chkAct97",j); /* print errormessage */
            cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
          } /* 'SidingItem'-definition NOT present */
        } /* -while- process all 'Evnt'-definitions */

        /* process table again and renumber 'Event'-IDs */
        cEvI = EvT.iterator(); /* get iterator to table again */
        j = 0; /* preset number of event-id */
        while(cEvI.hasNext()) { /* more definitions available ? */
          cEv = cEvI.next(); /* get next 'Evnt'-entry */
          cEv.chgID(j++); /* replace new event-ids and renumber them  */
        } /* -while- process all 'Evnt'-definitions */
        if(EvT.isEmpty()) cAct.clrMsk(21); /* empty table -- deactivate it */
      } /* 'Events'-entries were available */

      rqU = 32767; /* preset minimum object-ID */
      if(cAct.chkMsk(22)) { /* 'ActivityObjects' available */
        AObjT = cAct.getAObj(0); /* get current table of definitions */
        if(AObjT==null) throw new IllegalStateException( /* integrity-error */
          TSLogg.getMsg("Msg908","ActObj==null","TSUtil.chkAct()",0));
        cAOI = AObjT.iterator(); /* get iterator to table */
        dir = cRte.getFile(-8); /* directory of train-objects */
        if(dir==null) Lg.Err("chkActA0"); /* print errormessage */
        k = -1; /* initialize numer of entry (first valid number will be 0) */
        while(cAOI.hasNext()) { /* more definitions available ? */
          cAO = cAOI.next(); /* get next 'AObj'-entry */
          k += 1; /* advance number of entry */
          rqU = cAO.maxID(rqU); /* get current maximum of IDs */
          /* establish reference within position to world-definition */
          if((is=cAO.fndWrld(QDf))!=null) { /* position contains no valid world-reference */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkActA1",is,k); /* print errormessage */
              cAOI.remove(); /* delete definition */
              continue; /* and continue with next definition */
            } /* incorrect definition should be removed/corrected */
            Lg.Err("chkActA2",is,k); /* print errormessage */
          } /* world-reference within position NOT valid */
          cTrn = cAO.chgTrn(null); /* get connected Train-definition */
          if(cTrn==null) { /* no valid Train-Reference available */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkActA3",k); /* print errormessage */
              cAOI.remove(); /* delete definition */
            } else { /* modifications not requested: mark correction as an error */
              Lg.Err("chkActA4",k); /* print errormessage */
              cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
            } /* mark correction as an error */
            continue; /* and continue with next definition */
          } /* no valid train-reference available */
 if(PrMsk.chkMsk(31)) Lg.Msg("Msg010","Train="+cTrn.toStr()); // ##!D
          RefT = cTrn.getTObjT(0); /* get list of engines/waggons */
          if(RefT==null) throw new IllegalStateException( /* integrity-error */
            TSLogg.getMsg("Msg908","Train.TOT==null","TSUtil.chkAct()",k));
          j = RefT.size(); /* get number of Train-objects */
          for(i=0;i<j;i+=1) { /* more definitions available ? */
            cRef = RefT.get(i); /* get next 'RefC'-entry */
            if(i!=cRef.chgNr(Integer.MIN_VALUE)) { /* UID must be changed */
              ec += 1; /* count error */
              Lg.Err("chkActA5",null,k,i); /* print errormessage */
              cRef.chgNr(i); /* insert new UID-value */
            } /* UID processed and possibly changed */
            dat = TSTrain.getPath(cRef,dir); /* get reference to train-object */
            if(dat==null) { /* reference to train-object not found */
              ec += 1; /* count error */
              Lg.Err("chkActA6",null,k,i); /* print errormessage */
            } else if(!dat.exists()) { /* train-object NOT available */
              ec += 1; /* count error */
              Lg.Err("chkActA7",dat.getAbsolutePath(),k,i); /* print errormessage */
            } /* UID processed and possibly changed */
          } /* -for- process all 'RefC'-definitions */
          i = cTrn.getInt(1); /* get current value for 'NextWagonUID' */
          if(i!=RefT.size()) { /* value is NOT correct -- replace it */
            ec += 1; /* count error */
            Lg.Err("chkActA8",""+RefT.size(),k,i); /* print errormessage */
            cTrn.setInt(1,RefT.size()); /* insert new , correct value */
          } /* value for 'NextWagonUID' processed */
        } /* -while- process all 'AObj'-definitions */
        if(AObjT.isEmpty()) cAct.clrMsk(22); /* empty table -- deactivate it */
      } /* 'ActivityObjects'-entries were available */

      /* process entry: 'NextActivityObjectUID' */
      rqU += 1; /* increment to 'NextActivityObjectUID' */
      if((i=cAct.setInt(16,rqU))!=rqU) /* requested value replaced -- check it */
        if(EnaW) Lg.Log("chkAct32",null,i,rqU); /* print error-message */

      if(cAct.chkMsk(23)) { /* 'ActivityRestrictedSpeedZones' available */
        RSZT = cAct.getRSZne(0); /* get current table of definitions */
        if(RSZT==null) throw new IllegalStateException( /* integrity-error */
          TSLogg.getMsg("Msg908","RSZne==null","TSUtil.chkAct()",0));
        cZneI = RSZT.iterator(); /* get iterator to table */
        k = -1; /* initialize numer of entry (first valid number will be 0) */
        while(cZneI.hasNext()) { /* more definitions available ? */
          cZne = cZneI.next(); /* get next 'RSZne'-entry */
          k += 1; /* advance number of entry */
          if(cZne.isComplete()) { /* Speedzone is NOT completely defined */
            ec += 1; /* count error */
            Lg.Err("chkActB1",k); /* print errormessage */
            cZneI.remove(); /* delete definition */
            continue; /* and continue with next definition */
          } /* referenced speedzone is not fully defined */
          cPos = cZne.getPos(0); /* get first position-definition (start) */
          if(cPos.fndWrld(QDf)==null) { /* position contains no valid world-reference */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkActB2",cPos.getPos(0),k); /* print errormessage */
              cZneI.remove(); /* delete definition */
            } else { /* modifications not requested: mark correction as an error */
              Lg.Err("chkActB3",cPos.getPos(0),k); /* print errormessage */
              cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
            } /* mark correction as an error */
            continue; /* and continue with next definition */
          } /* world-reference within position NOT valid */
          cPos = cZne.getPos(1); /* get second position-definition (end) */
          if(cPos.fndWrld(QDf)==null) { /* position contains no valid world-reference */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkActB4",cPos.getPos(0),k); /* print errormessage */
              cZneI.remove(); /* delete definition */
            } else { /* modifications not requested: mark correction as an error */
              Lg.Err("chkActB5",cPos.getPos(0),k); /* print errormessage */
              cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
            } /* mark correction as an error */
            continue; /* and continue with next definition */
          } /* world-reference within position NOT valid */
        } /* -while- process all 'RSZne'-definitions */
        if(RSZT.isEmpty()) cAct.clrMsk(23); /* empty table -- deactivate it */
      } /* 'ActivityRestrictedSpeedZones'-entries were available */

      if(cAct.chkMsk(24)) { /* 'ActivityFailedSignals' available */
        RefT = cAct.getSigR(0); /* get current table of definitions */
        if(RefT==null) throw new IllegalStateException( /* integrity-error */
          TSLogg.getMsg("Msg908","SgRef==null","TSUtil.chkAct()",0));
        cRfI = RefT.iterator(); /* get iterator to table */
        k = -1; /* initialize numer of entry (first valid number will be 0) */
        while(cRfI.hasNext()) { /* more definitions available ? */
          cRef = cRfI.next(); /* get next 'RefC'-entry */
          k += 1; /* advance number of entry */
          if((cIt=cRte.fndTrI(0,cRef))==null) { /* connection NOT found */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkActC1",null,k,cRef.chgNr(Integer.MIN_VALUE));
              cRfI.remove(); /* delete definition */
            } else { /* modifications not requested: mark correction as an error */
              Lg.Err("chkActC2",null,k,cRef.chgNr(Integer.MIN_VALUE));
              cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
            } /* mark correction as an error */
            continue; /* and continue with next definition */
          } /* referenced TrItem not found */
          /* 'TrItem'-connection found -- check it */
          i = cIt.getNr(true); /* get number of TrItem-definition */
          if(cIt.getTyp()!=1) { /* no 'SignalItem' connected */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkActC3",null,k,i); /* print errormessage */
              cRfI.remove(); /* delete definition */
            } else { /* modifications not requested: mark correction as an error */
              Lg.Err("chkActC4",null,k,i); /* print errormessage */
              cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
            } /* mark correction as an error */
          } /* referenced TrItem fully processed */
          if(cIt.chkMsk(0)) { /* 'SignalItem' no longer valid */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkActC6",null,k,i); /* print errormessage */
              cRfI.remove(); /* delete definition */
            } else { /* modifications not requested: mark correction as an error */
              Lg.Err("chkActC7",null,k,i); /* print errormessage */
              cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
            } /* mark correction as an error */
          } /* referenced TrItem fully processed */
          if(cIt.chkMsk(1) || cIt.incCnt(0)==0) { /* Item contains error */
            Lg.Err("chkActC5",null,k,i); /* print errormessage */
            ec += 1; /* count error */
          } /* error within TrItem-definition -- report it */
        } /* -while- process all 'RefC'-definitions */
        if(RefT.isEmpty()) cAct.clrMsk(24); /* empty table -- deactivate it */
      } /* 'ActivityFailedSignals'-entries were available */

      if(cAct.chkMsk(25)) { /* 'PlatformNumPassengersWaiting' available */
        RefT = cAct.getPNPWt(0); /* get current table of definitions */
        if(RefT==null) throw new IllegalStateException( /* integrity-error */
          TSLogg.getMsg("Msg908","PNPWt==null","TSUtil.chkAct()",0));
        cRfI = RefT.iterator(); /* get iterator to table */
        k = -1; /* initialize numer of entry (first valid number will be 0) */
        while(cRfI.hasNext()) { /* more definitions available ? */
          cRef = cRfI.next(); /* get next 'RefC'-entry */
          k += 1; /* advance number of entry */
          if((cIt=cRte.fndTrI(0,cRef))==null) { /* connection NOT found */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkActD1",null,k,cRef.chgNr(Integer.MIN_VALUE));
              cRfI.remove(); /* delete definition */
            } else { /* modifications not requested: mark correction as an error */
              Lg.Err("chkActD2",null,k,cRef.chgNr(Integer.MIN_VALUE));
              cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
            } /* mark correction as an error */
            continue; /* and continue with next definition */
          } /* referenced TrItem not found */
          /* 'TrItem'-connection found -- check it */
          i = cIt.getNr(true); /* get number of TrItem-definition */
          if(cIt.getTyp()!=2) { /* no 'PlatformItem' connected */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkActD3",null,k,i); /* print errormessage */
              cRfI.remove(); /* delete definition */
            } else { /* modifications not requested: mark correction as an error */
              Lg.Err("chkActD4",null,k,i); /* print errormessage */
              cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
            } /* mark correction as an error */
          } /* referenced TrItem fully processed */
          if(cIt.chkMsk(0)) { /* 'PlatformItem' no longer valid */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkActD6",null,k,i); /* print errormessage */
              cRfI.remove(); /* delete definition */
            } else { /* modifications not requested: mark correction as an error */
              Lg.Err("chkActD7",null,k,i); /* print errormessage */
              cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
            } /* mark correction as an error */
          } /* referenced TrItem fully processed */
          if(cIt.chkMsk(1) || cIt.incCnt(0)==0) { /* Item contains error */
            Lg.Err("chkActD5",null,k,i); /* print errormessage */
            ec += 1; /* count error */
          } /* error within TrItem-definition -- report it */
        } /* -while- process all 'RefC'-definitions */
        if(RefT.isEmpty()) cAct.clrMsk(25); /* empty table -- deactivate it */
      } /* 'PlatformNumPassengersWaiting'-entries were available */

      if(cAct.chkMsk(26)) { /* 'PickupTrItemData' available */
        RefT = cAct.getTrI08(0); /* get current table of definitions */
        if(RefT==null) throw new IllegalStateException( /* integrity-error */
          TSLogg.getMsg("Msg908","TrI08==null","TSUtil.chkAct()",0));
        cRfI = RefT.iterator(); /* get iterator to table */
        k = -1; /* initialize numer of entry (first valid number will be 0) */
        while(cRfI.hasNext()) { /* more definitions available ? */
          cRef = cRfI.next(); /* get next 'RefC'-entry */
          k += 1; /* advance number of entry */
          if((cIt=cRte.fndTrI(0,cRef))==null) { /* connection NOT found */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkActE1",null,k,cRef.chgNr(Integer.MIN_VALUE));
              cRfI.remove(); /* delete definition */
            } else { /* modifications not requested: mark correction as an error */
              Lg.Err("chkActE2",null,k,cRef.chgNr(Integer.MIN_VALUE));
              cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
            } /* mark correction as an error */
            continue; /* and continue with next definition */
          } /* referenced TrItem not found */
          /* 'TrItem'-connection found -- check it */
          i = cIt.getNr(true); /* get number of TrItem-definition */
          if(cIt.getTyp()!=8) { /* no 'PickupTrItem' connected */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkActE3",null,k,i); /* print errormessage */
              cRfI.remove(); /* delete definition */
            } else { /* modifications not requested: mark correction as an error */
              Lg.Err("chkActE4",null,k,i); /* print errormessage */
              cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
            } /* mark correction as an error */
          } /* referenced TrItem fully processed */
          if(cIt.chkMsk(0)) { /* 'PickupTrItem' no longer valid */
            ec += 1; /* count error */
            if(chg) { /* incorrect definition should be removed/corrected */
              Lg.Err("chkActE6",null,k,i); /* print errormessage */
              cRfI.remove(); /* delete definition */
            } else { /* modifications not requested: mark correction as an error */
              Lg.Err("chkActE7",null,k,i); /* print errormessage */
              cAct.setMsk(28); /* set marker: activity contain(s) error(s) */
            } /* mark correction as an error */
          } /* referenced TrItem fully processed */
          if(cIt.chkMsk(1) || cIt.incCnt(0)==0) { /* Item contains error */
            Lg.Err("chkActE5",null,k,i); /* print errormessage */
            ec += 1; /* count error */
          } /* error within TrItem-definition -- report it */
        } /* -while- process all 'RefC'-definitions */
        if(RefT.isEmpty()) cAct.clrMsk(26); /* empty table -- deactivate it */
      } /* PickupTrItem'-entries were available */

    } /* process all activity-definitions */

    Lg.Skip(false); /* print empty line to Log-file */
    Lg.Log("chkAct08",c); /* print result */
    Lg.Log("chkAct09",ec); /* print result (number of errors) */
    Lg.Skip(false); /* print empty line to Log-file */

    return 0; /* return with 'no error' */
  }

 /**. <pre>
  *=====================================================================
  * Method "putActF"
  * Write all activity-definitions (modified) of a route
  * Prime-number-options used with 'opt':
  *       2 - create files without errors ONLY
  *       3 - 'noreplace' - Service must not already exist
  * ##putActF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int putActF( /* write service-definitions */
   TSRoute cRte, /* current route-definition */
   File    tdat, /* definition of the temporary file (overwrite) */
   int     opt)  /* options (coded using prime-numbers) */
   {
   /*-----------------------------------------------------------------*/
    File               dats,datz,dir1,dir2; /* temporary files */
    TSFileX            cF;    /* current output-file (control) */
    Iterator<TSAct>    cI;    /* current Iterator for Activities */
    TSAct              cAct;  /* current activity-definition */
//    TSTrf              cTrf;  /* current Traffic-Definition */
    Iterator<TSXtSrv>  SrvI;  /* Iterator for service-definitions */
    TSXtSrv            cSrv;  /* current (ext.) Service-Definition */
    ArrayList<TSStStp> StpT;  /* List of 'StationStop'-Definitions */
    TSStStp            cStp;  /* current 'StationStop'-Definition (T) */
    Iterator<TSActEv>  cEvI;  /* iterator for all 'Event'-References */
    TSActEv            cEv;   /* current Event-reference-element */
    Iterator<TSActAO>  cAOI;  /* iterator for all AO-References */
    TSActAO            cAO;   /* current AO-reference-element */
    Iterator<TSActSZ>  cZneI; /* iterator for all RSZne-References */
    TSActSZ            cZne;  /* current reference-element (RSZ) */
    Iterator<TSRefC>   cRfI;  /* iterator for all 'RefC'-objects */
    TSRefC             cRef;  /* current reference-element */
    TSTrain            cTrn;  /* current reference to train */
    TSTrItm            cIt;   /* currrent TrItem-Element */
    TSQPos             cPos;  /* current definiton of 'position' */
    Iterator<String>   LneI;  /* Line-Iterator for output */
    ArrayList<String>  LneT;  /* Line-Table for output */
    String             is,js; /* intermediate values */
    int                i,j,ec,cc; /* intermediate values */
    int                ce,cf; /* intermediate values */
   /*=================================================================*/
    cI = cRte.getIt(16); /* get list of activity-definitions */
    if(cI==null) return -1; /* Activity-definitons are NOT available */

    Lg.Skip(true); /* print empty line to LOG-file and screen */
    /* check if target-directory of activity-definitions exist */
    dir2 = null; /* compiler needs it */
    if(tdat==null) { /* temporary file is NOT used */
      dir2 = cRte.getFile(41); /* get target-directory */
      if(dir2==null) { /* folder NOT available -- terminate */
        Lg.Skip(true); /* print empty line to LOG-file and screen */
        Lg.Msg("MsgC63",cRte.getInfo(41)); /* print message: terminating */
        Lg.Msg("putAct01"); /* print errormessage */
        Lg.Close(); /* close output to Log-file */
        return 25; } /* terminate function with errorcode */
    } /* target-directory used for output */
    dir1 = cRte.getFile(11); /* get file-reference of source-directory */

    Lg.Msg("putAct02",cRte.getInfo(1)); /* print description of next action */

    ce = 0; /* init error-counter */
    cf = 0; /* init number of definition-files */
    LneT = new ArrayList<String>(10); /* create table for output-line-blocks */
      /* This list is normally empty. After it was filled with output-lines
       * and all lines have been processed, it MUST be cleared again. */
    while(cI.hasNext()) { /* more activity-definitions to process */
      cAct = cI.next(); /* get next activity-entry */
      if(cAct==null) throw new IllegalStateException( /* security-query */
        TSLogg.getMsg("Msg908","TSAct==null","TSUtil.putActF()",0));
      is = cAct.getName(true); /* get unmodified name of activity-file */
      if(is==null) continue;  /* file is missing -- do not process */

      dats = new File(dir1,is); /* create Source-Reference (for copy/delete) */
      if(cAct.chkMsk(28) && (opt%2)==0) { /* activity-def. has error(s) -- do not write */
        Lg.Err("putAct04",is); /* print message: terminating */
        if(tdat==null) continue; /* do not write activity-definition */
        dats.delete(); /* overwrite-mode: delete faulty file (inplace) */
        Lg.Log("putAct21",dats.getAbsolutePath()); /* print message */
        continue; /* activity-definition was deleted */
      } /* activity-definition contained error(s) */
      Lg.Log("putAct03",is); /* print description of action */

      if(tdat!=null) datz = tdat; /* preset: use temporary file */
      else { /* full target-reference is needed otherwise */
        datz = new File(dir2,is); /* create full target-reference */
        if((opt%3)==0 && datz.exists()) { /* service-file already exist? */
          Lg.Err("putAct05",is); /* print message: terminating */
          continue; /* do not write service-definition */
        } /* service-definition already exist */
      }  /* full target-reference is needed */

      /* open activity-file for output */
      cF = new TSFileX(TSFileX.FT$act,datz); /* create output-control */
      is = cF.open(true); /* set sub-id and open file */
      if(is!=null) { /* error occurred while opening */
        Lg.Err("putAct11",is); /* print message: terminating */
        continue; /* process next service-file */
      } /* error occurred while opening */
      cf += 1; /* count valid activity-definition */

      ec = 0; /* init error-counter (per file) */
      bl: { /* block for error-break */
        cc = 10; /* preset position of error */
        is = "Tr_Activity ("; /* set first line */
        if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
        if(cAct.chkMsk(0)) { /* Serial-Number is defined */
          is = "\tSerial ( " + cAct.getInt(0) + " )"; /* Serial-Number */
          cc = 11; /* preset position of error */
          if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
        } /* Serial-Number was defined */

        cc = 12; /* preset position of error */
        is = "\tTr_Activity_Header ("; /* set first line of paragraph */
        if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
        for(j=1;j<20;j+=1) { /* write first part of definitions */
          if(!cAct.chkMsk(j)) continue; /* no output required -- skip it */
          LneI = cAct.crDef(j,LneT); /* create definitionline(s) */
          if(LneI==null) continue; /* no valid output-lines -- do not write */
          while(LneI.hasNext()) { /* more output-lines available ? */
            is = LneI.next(); /* get next output-line */
            if(is==null) continue; /* dummy line -- do not write */
            /* Attention: A output-line must start with '\t' or it is
             * considered as an error-message */
            if(is.charAt(0)!='\t') { /* got error-message instead of output-line */
              Lg.Err("putAct12",is,j); /* print error-message */
              ec += 1; /* and count error */
            } else { /* NO error-message --write it */
              cc = j + 60; /* preset position of error */
              if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
            } /* output-line processed */
          } /* -while- process all output-lines */
          LneT.clear(); /* all lines written -- delete them */
        } /* -for- process all definitions */
        cc = 13; /* preset position of error */
        if((is=cF.putData("\t)"))!=null) break bl; /* write-error --terminate */

        cc = 14; /* preset position of error */
        is = "\tTr_Activity_File ("; /* set first line of next paragraph */
        if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */

        /* create and write 'Player_Service_Definition' */
        cSrv = cAct.chgSrv(null); /* get current 'Player'-Service */
        is = cSrv.getName(); /* get name of current service (message,...) */
        is = "\t\tPlayer_Service_Definition ( " + modStr(is); /* next output-line */
        cc = 15; /* preset position of error */
        if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
        i = cSrv.chkTime(0); /* get current 'Start-Time' of service */
        is = "\t\t\tPlayer_Traffic_Definition ( " + i; /* next output-line */
        StpT = cSrv.getStp(0); /* get table of 'StationStop'-entries (A/T) */
        if((j=StpT.size())==0) is += " )"; /* terminate stmt if no entries */
          /* also: get number of current 'StationStop'-entries */
        cc = 16; /* preset position of error */
        if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
        if(j>0) { /* Outputblock 'StationStop' is requested (Player) */
          is = "\t\t\t\t"; /* set prefix of next lines */
          for(i=0;i<j;i+=1) /* process all StationStop, add lines */
            StpT.get(i).crDef(LneT,true,i,is); /* add 'StationStop'-def. */
          LneT.add("\t\t\t)"); /* set separator-line of output-block */
        } /* do not write 'StationStop'-entries */
        LneT.add("\t\t\tUiD ( 0 )"); /* set UiD-definition of player-service */
        is = "\t\t\t"; /* set prefix of next lines */
        for(i=0;i<j;i+=1) /* process all StationStop, add lines */
          StpT.get(i).crDef(LneT,false,i,is); /* add 'StationStop'-def. */
        j = LneT.size(); /* get number of current output-lines */
        for(i=0;i<j;i+=1) { /* process all Output-lines */
          is = LneT.get(i); /* get next output-line */
          if(is==null) continue; /* dummy line -- do not write */
          /* Attention: A output-line must start with '\t' or it is
           * considered as an error-message */
          if(is.charAt(0)!='\t') { /* got error-message instead of output-line */
            Lg.Err("putAct13",is,i); /* print error-message */
            ec += 1; /* and count error */
          } else { /* NO error-message --write it */
            cc = i + 100; /* preset position of error */
            if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
          } /* output-line processed */
        } /* -while- process all output-lines */
        LneT.clear(); /* all lines written -- delete them */
        cc = 17; /* preset position of error */
        if((is=cF.putData("\t\t)"))!=null) break bl; /* write-error --terminate */

        is = "\t\tNextServiceUID ( " + cAct.getInt(15) + " )"; /* next output-line */
        cc = 18; /* preset position of error */
        if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
        is = "\t\tNextActivityObjectUID ( " + cAct.getInt(16) + " )";
        cc = 19; /* preset position of error */
        if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */

        if(cAct.chkMsk(20)) { /* 'Traffic-Definition's available */
//          cTrf = cAct.chgTrf(null); /* get current 'Traffic'-Service */
          is = cAct.chgTNme(null); /* get name of current traffic-definition */
          if(cAct.chkMsk(28)) Lg.Log("putAct14",is); /* print error-message */
          is = "\t\tTraffic_Definition ( " + modStr(is); /* create next output-line */
          cc = 20; /* preset position of error */
          if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
          SrvI = cAct.getTrfT(0).iterator(); /* get list of all (ext.) Service-Def's */
          while(SrvI.hasNext()) { /* more definitions available ? */
            cSrv = SrvI.next(); /* get next service-entry */
            j = 0; /* preset number of output-line */
            js = cSrv.getName(); /* get current service-description */
            LneI = cSrv.crDef(LneT,false,"\t\t\t"); /* create definitionline(s) */
            if(LneI!=null) /* output-lines are valid -- write them */
             while(LneI.hasNext()) { /* more output-lines available ? */
              is = LneI.next(); /* get next output-line */
              if(is==null) continue; /* dummy line -- do not write */
              j += 1; /* increment current number of line */
              /* Attention: A output-line must start with '\t' or it is
               * considered as an error-message */
              if(is.charAt(0)!='\t') { /* got error-message instead of output-line */
                Lg.Err("putAct15",is,js,j); /* print error-message */
                ec += 1; /* and count error */
              } else { /* NO error-message --write it */
                cc = j + 150; /* preset position of error */
                if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
              } /* output-line processed */
            } /* -while- process all output-lines */
            LneT.clear(); /* all lines written -- delete them */
          } /* -while- process all service-definitions */
          cc = 21; /* preset position of error */
          if((is=cF.putData("\t\t)"))!=null) break bl; /* write-error --terminate */
        } /* 'Traffic-Definition'-entries were available */

        if(cAct.chkMsk(21)) { /* 'Events' available */
          RetVal = cAct.chgSrv(null).getStp(0); /* get table of 'StationStop'-entries (A/T)
            * of 'Player-Service' and set it as additional argument to 'TSActEv.crDef()' */
          cEvI = cAct.getEvT(false).iterator(); /* get iterator to table */
          cc = 22; /* preset position of error */
          is = "\t\tEvents ("; /* set first line of next paragraph */
          if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
          i = -1; /* preset number of entry (first number is '0') */
          while(cEvI.hasNext()) { /* more definitions available ? */
            cEv = cEvI.next(); /* get next 'Evnt'-entry */
            i += 1; /* advance number to next entry */
            if(cEv.chkMsk(0)) is = "\t\t\tEventCategoryTime (";
            else if(cEv.chkMsk(1)) is = "\t\t\tEventCategoryLocation (";
            else is = "\t\t\tEventCategoryAction ("; /* create next output-line */
            cc = 23; /* preset position of error */
            if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
            is = cEv.getTyp("\t\t\t\t"); /* create next output-line (type of event) */
            cc = 24; /* preset position of error */
            if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
            for(j=10;j<25;j+=1) { /* process all output-line-blocks */
              if(!cEv.chkMsk(j)) continue; /* no output required -- skip it */
              LneI = cEv.crDef(j,LneT,"\t\t\t\t"); /* create output-lines */
              if(LneI==null) continue; /* no valid output-lines -- do not write */
              while(LneI.hasNext()) { /* more output-lines available ? */
                is = LneI.next(); /* get next output-line */
                if(is==null) continue; /* dummy line -- do not write */
                /* Attention: A output-line must start with '\t' or it is
                 * considered as an error-message */
                if(is.charAt(0)!='\t') { /* got error-message instead of output-line */
                  Lg.Err("putAct16",is,i,j); /* print error-message */
                  ec += 1; /* and count error */
                } else { /* NO error-message --write it */
                  cc = 200 + j; /* preset position of error */
                  if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
                } /* output-line processed */
              } /* -while- process all output-lines */
              LneT.clear(); /* all lines written -- delete them */
            } /* -for- all output-line-blocks are processed */
            cc = 25; /* preset position of error */
            if((is=cF.putData("\t\t\t)"))!=null) break bl; /* write-error --terminate */
          } /* -while- process all 'Evnt'-definitions */
          cc = 26; /* preset position of error */
          if((is=cF.putData("\t\t)"))!=null) break bl; /* write-error --terminate */
        } /* 'Events'-entries were available */
        if(cAct.chkMsk(22)) { /* 'ActivityObjects' available */
          cAOI = cAct.getAObj(0).iterator(); /* get iterator to table */
          cc = 27; /* preset position of error */
          is = "\t\tActivityObjects ("; /* set first line of next paragraph */
          if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
          while(cAOI.hasNext()) { /* more definitions available ? */
            cAO = cAOI.next(); /* get next 'AObj'-entry */
            is = "\t\t\tActivityObject ("; /* create next output-line */
            cc = 28; /* preset position of error */
            if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
            if(cAO.chkMsk(0)) { /* ObjectType is 'WagonsList' */
              cc = 29; /* preset position of error */
              if((is=cF.putData(cAO.crDef(0)))!=null) break bl; /* write-error --terminate */
            } /* Subobject is defined, available and now written */
            if(cAO.chkMsk(15)) { /* 'Train_Config'-definition available */
              cTrn = cAO.chgTrn(null); /* get connected Train-definition */
              is = "\t\t\t\tTrain_Config ("; /* create next output-line */
              cc = 30; /* preset position of error */
              if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
              LneI = cTrn.crTrn(LneT,"\t\t\t\t\t"); /* create Train-definition */
              if(LneI!=null) /* valid output-lines -- write them */
               while(LneI.hasNext()) { /* more output-lines available ? */
                is = LneI.next(); /* get next output-line (definition-line) */
                if(is==null) continue; /* dummy line -- do not write */
                /* Attention: No error-messages are provided -- no need to check */
                cc = 31; /* preset position of error */
                if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
              } /* -while- process all output-lines */
              LneT.clear(); /* all lines written -- delete them */
              cc = 32; /* preset position of error */
              if((is=cF.putData("\t\t\t\t)"))!=null) break bl; /* write-error --terminate */
            } /* Subobject is defined, available and now written */
            if(cAO.chkMsk(16)) { /* 'Direction'-definition available */
              cc = 33; /* preset position of error */
              if((is=cF.putData(cAO.crDef(16)))!=null) break bl; /* write-error --terminate */
            } /* Subobject is defined, available and now written */
            if(cAO.chkMsk(17)) { /* 'ID'-definition available */
              cc = 34; /* preset position of error */
              if((is=cF.putData(cAO.crDef(17)))!=null) break bl; /* write-error --terminate */
            } /* Subobject is defined, available and now written */
            if(cAO.chkMsk(18)) { /* 'Tile'-definition available */
              cc = 35; /* preset position of error */
              if((is=cF.putData(cAO.crDef(18)))!=null) break bl; /* write-error --terminate */
            } /* Subobject is defined, available and now written */
            cc = 36; /* preset position of error */
            if((is=cF.putData("\t\t\t)"))!=null) break bl; /* write-error --terminate */
          } /* -while- process all 'AObj'-definitions */
          cc = 37; /* preset position of error */
          if((is=cF.putData("\t\t)"))!=null) break bl; /* write-error --terminate */
        } /* 'ActivityObjects'-entries were available */
        if(cAct.chkMsk(23)) { /* 'ActivityRestrictedSpeedZones' available */
          cZneI = cAct.getRSZne(0).iterator(); /* get iterator to table */
          cc = 38; /* preset position of error */
          is = "\t\tActivityRestrictedSpeedZones ("; /* set first line of next paragraph */
          if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
          j = -1; /* preset number of entry (first number is '0') */
          while(cZneI.hasNext()) { /* more definitions available ? */
            cZne = cZneI.next(); /* get next 'RSZne'-entry */
            j += 1; /* advance number to next entry */
            is = "\t\t\tActivityRestrictedSpeedZone ("; /* create next output-line */
            cc = 39; /* preset position of error */
            if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
            cPos = cZne.getPos(0); /* get first position-definition (start) */
            is = "\t\t\t\tStartPosition ( " + cPos.getPos(4) + " )"; /* create output-line */
            cc = 40; /* preset position of error */
            if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
            cPos = cZne.getPos(1); /* get second position-definition (end) */
            is = "\t\t\t\tEndPosition ( " + cPos.getPos(4) + " )"; /* create output-line */
            cc = 41; /* preset position of error */
            if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
            cc = 42; /* preset position of error */
            if((is=cF.putData("\t\t\t)"))!=null) break bl; /* write-error --terminate */
          } /* -while- process all 'RSZne'-definitions */
          cc = 43; /* preset position of error */
          if((is=cF.putData("\t\t)"))!=null) break bl; /* write-error --terminate */
        } /* 'ActivityRestrictedSpeedZones'-entries were available */
        if(cAct.chkMsk(24)) { /* 'ActivityFailedSignals' available */
          cRfI = cAct.getSigR(0).iterator(); /* get iterator to table */
          cc = 44; /* preset position of error */
          is = "\t\tActivityFailedSignals ("; /* set first line of next paragraph */
          if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
          j = -1; /* preset number of entry (first number is '0') */
          while(cRfI.hasNext()) { /* more definitions available ? */
            cRef = cRfI.next(); /* get next 'RefC'-entry */
            j += 1; /* advance number to next entry */
            is = "\t\t\tActivityFailedSignal ( "; /* create basis of output-line */
            if((cIt=(TSTrItm)cRef.chgRef(null))==null) { /* no reference inserted */
              i = cRef.chgNr(Integer.MIN_VALUE); /* get original number of TrItem */
              Lg.Err("putAct17",""+j,i); /* print errormessage */
              is += i + " )"; /* and insert it into line */
            } else is += cIt.getNr(false) + " )"; /* get correct value from TrItem-definition */
            cc = 45; /* preset position of error */
            if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
          } /* -while- process all 'RefC'-definitions */
          cc = 46; /* preset position of error */
          if((is=cF.putData("\t\t)"))!=null) break bl; /* write-error --terminate */
        } /* 'ActivityFailedSignals'-entries were available */
        if(cAct.chkMsk(25)) { /* 'PlatformNumPassengersWaiting' available */
          cRfI = cAct.getPNPWt(0).iterator(); /* get iterator to table */
          cc = 47; /* preset position of error */
          is = "\t\tPlatformNumPassengersWaiting ("; /* set first line of next paragraph */
          if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
          j = -1; /* preset number of entry (first number is '0') */
          while(cRfI.hasNext()) { /* more definitions available ? */
            cRef = cRfI.next(); /* get next 'RefC'-entry */
            j += 1; /* advance number to next entry */
            is = "\t\t\tPlatformData ( "; /* create basis of output-line */
            if((cIt=(TSTrItm)cRef.chgRef(null))==null) { /* no reference inserted */
              i = cRef.chgNr(Integer.MIN_VALUE); /* get original number of TrItem */
              Lg.Err("putAct18",""+j,i); /* print errormessage */
              is += i; /* and insert it into line */
            } else is += cIt.getNr(false); /* get correct value from TrItem-definition */
            is += " " + cRef.chgIx(Integer.MIN_VALUE) + " )"; /* add additional value */
            cc = 48; /* preset position of error */
            if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
          } /* -while- process all 'RefC'-definitions */
          cc = 49; /* preset position of error */
          if((is=cF.putData("\t\t)"))!=null) break bl; /* write-error --terminate */
        } /* 'PlatformNumPassengersWaiting'-entries were available */
        if(cAct.chkMsk(26)) { /* 'PickupTrItemData' available */
          cRfI = cAct.getTrI08(0).iterator(); /* get iterator to table */
          cc = 50; /* preset position of error */
          is = "\t\tPickupTrItemData ("; /* set first line of next paragraph */
          if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
          j = -1; /* preset number of entry (first number is '0') */
          while(cRfI.hasNext()) { /* more definitions available ? */
            cRef = cRfI.next(); /* get next 'RefC'-entry */
            j += 1; /* advance number to next entry */
            is = "\t\t\tPickupItem ( "; /* create basis of output-line */
            if((cIt=(TSTrItm)cRef.chgRef(null))==null) { /* no reference inserted */
              i = cRef.chgNr(Integer.MIN_VALUE); /* get original number of TrItem */
              Lg.Err("putAct19",""+j,i); /* print errormessage */
              is += i; /* and insert it into line */
            } else is += cIt.getNr(false); /* get correct value from TrItem-definition */
            is += " " + cRef.chgIx(Integer.MIN_VALUE) + " )"; /* add additional value */
            cc = 51; /* preset position of error */
            if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
          } /* -while- process all 'RefC'-definitions */
          cc = 52; /* preset position of error */
          if((is=cF.putData("\t\t)"))!=null) break bl; /* write-error --terminate */
        } /* PickupTrItem'-entries were available */

        cc = 15; /* preset position of error */
        if((is=cF.putData("\t)"))!=null) break bl; /* write-error --terminate */
        cc = 18; /* preset position of error */
        if((is=cF.putData(")"))!=null) break bl; /* write-error --terminate */
        cc = 19; /* preset position of error */
        is = TSLogg.getMsg("Msg100","Activity"); /* create TSUtil-ID-Line */
        if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
        cc = 0; /* no error occurred -- mark it */
      } /* -bl- break-block used in case of error */
      if(is!=null) { /* pending message has to be writtens */
        Lg.Err("putAct11",is); /* print error-message */
        ec += 1; /* count error */
      } /* pending message was found */
      is = cF.close(); /* close output-file again */
      if(is!=null) Lg.Err("putAct06",is); /* print errormessage */
      if(cc!=0) Lg.Err("putAct22",cc); /* print errormessage */
      else if(ec>0) Lg.Log("putAct23",ec); /* print description of next action */
      LneT.clear(); /* delete output-line-block in case an error occurred */

      Lg.Log("putAct24",cF.getStat(true)); /* print number of entries */
//      Lg.Log("putAct25",cF.getStat(false)); /* print file-length */
      ce += ec; /* count overall number of errors */

      /* copy back result to activity-file(source) if overwrite requested */
      cc += ec; /* compute error-threshold */
      if(tdat!=null) { /* overwrite of original file is requested */
        if(cc>0) cf -= 1; /* error --do not copy file */
          /* if an error occured the original file is NOT changed */
        else { /* copy target-file and overwrite original file */
          is = dats.getAbsolutePath(); /* name of source-file */
          js = "copy \""+tdat.getAbsolutePath()+"\" \""+is+"\" ";
            /* create copy-command */
          if((i=exec(true,js,null,Lg))>0) /* error during execute */
            Lg.Log("MsgC49",is,i); /* print errormessage */
        } /* original file (source) was overwritten */
      } else if(cc>0 && (opt%2)==0) { /* error -- delete file again */
        datz.delete(); /* delete created file due to error(s) */
        is = datz.getAbsolutePath(); /* name of target-file */
        Lg.Msg("putAct07",is); /* print errormessage */
        cf -= 1; /* activity-file is NOT created */
      } /* new target-file has been deleted again */
    } /* -while- write ALL service-definitions */

    Lg.Skip(false); /* print empty line to LOG-file */
    Lg.Log("putAct08",cf); /* print number of activity-files */
    Lg.Log("putAct09",ce); /* print number of overall errors */
    Lg.Skip(false); /* print empty line to LOG-file */

    return 0; /* terminate program (successfully) */
  }

 /**. <pre>
  *=====================================================================
  * Method "getPatF"
  * load ALL path-definions of all activities
  * ##getPatF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getPatF( /* load all path-definitions */
   TSRoute cRte, /* current route-definition */
   boolean nocr) /* do not create directory if not available */
   {
   /*-----------------------------------------------------------------*/
    File                   dir,dat;  /* temporary file-definitions */
    TSFileX                cF;    /* current input-file (control) */
    TSFleMask              cM;    /* current file-mask */
    TSBuf                  cB;    /* current input-buffer 'read file' */
    TreeMap<String,TSPath> Pth;   /* table of path-definitions */
    ArrayList<TSPatPDP>    PDP;   /* table of PDP-definitions */
    ArrayList<TSPatNde>    PNde;  /* table of PathNode-definitions */
    TSPath                 cPth;  /* current path-definition */
    TSPatPDP               cPDP;  /* current PDP-definition */
    TSPatNde               cPNde; /* current PathNode-definition */
    TSRefC                 cRef;  /* current PathNode-reference */
    String                 is;    /* intermediate values */
    String[]               fl;    /* list of path-files */
    int                    i,j,c,l1,l2; /* intermediate v. */
    int                    ec,cc,cf,ce; /* intermediate values */
   /*=================================================================*/
    Lg.Skip(true); /* print empty line (screen and LOG-file) */
    Lg.Msg("getPat01",cRte.getInfo(1)); /* print description of next action */

    dir = cRte.getFile(12); /* get file-reference to path-directory */
    if(dir==null) { /* file-reference could not be created */
      Lg.Msg("getPat03"); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 11; /* terminate function with errorcode */
    } /* Datei existiert nicht */
    if(!dir.exists()) { /* path-directory does not exist -- terminate */
      Lg.Msg("getPat04",dir.getPath()); /* print errormessage */
      if(nocr) return -1; /* terminate function with marker */
      if(!dir.mkdirs()) Lg.Msg("getPat08"); /* print message */
        /* try to create folder and print error if unsuccessful-- error? */
      return -2; /* terminate function with marker */
    } /* world-directory does not exist */
    cM = new TSFleMask(false,".*\\.pat"); /* select path-files */
    if((is=cM.getErr())!=null) { /* error within file-mask */
      Lg.Skip(false); /* print empty line to LOG-file */
      Lg.Msg("getPat02",is); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 11; /* terminate function with errorcode */
    } /* error found -- function terminated */
    fl = dir.list((FilenameFilter)cM); /* create list of ALL path-files */
      /* result contains NO directories! */
    if(fl==null) { /* error found: source is no directory */
      Lg.Msg("getPat05",dir.getPath()); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 11; /* terminate function with errorcode */
    } /* file-list could not be created */

    cf = ce = 0; /* init file-counter, overall errors */
    Pth = cRte.getPath(); /* create and initialize path-table */
    for(String fn:fl) { /* process all selected file-definitions */
      dat = new File(dir,fn); /* create file-reference (source) */
      cf += 1; /* and count path-file */
      Lg.Log("MsgC54",dat.getAbsolutePath(),DF3.format(cf));

      /* open path-file for input */
      cF = new TSFileX(TSFileX.FT$pat,dat); /* create file-control of path-file */
      is = cF.open(false); /* and open it for input */
      if(is!=null) { /* error occurred while open-action */
        Lg.Err("getPat11",is); /* print message: terminating */
        continue; /* continue and process next path-file */
      } /* error occurred while open of path-file */
      cPth = new TSPath(fn); /* create path-object (basis) */

      cB = new TSBuf(cF); /* create inputbuffer and init counter */
      cc = 0; /* Compiler needs it */
      ec = 0; /* init: no error registered */
      bl: { /* block for error-break */
        is = cB.getKE(true); /* get first controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getPat21"); /* print errormessage */
            cc = 5; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getPat22",is); /* print errormessage */
          cc = 6; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) { /* next keword not present */
          Lg.Err("getPat23"); /* print errormessage */
          cc = 7; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(!is.equals("serial")) { /* 'Serial' not found */
          Lg.Err("getPat24",is,cB.getStat(true)); /* print errormessage */
          cc = 8; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        i = (int)cB.getNV(); /* get value of 'Serial-Number' */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getPat25",is,cB.getStat(true)); /* print errormessage */
          cc = 9; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(i<1) { /* invalid range for 'Serial-Number' */
          Lg.Err("getPat26",null,i,cB.getStat(true)); /* print errormessage */
          cc = 10; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        cPth.setInt(0,i); /* store 'Serial-Number' to path-object (TSData) */
        cPth.setMsk(0); /* mark: definitionline is successfully processed */
        if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
          cc = 11; /* set current return-code to error */
          break bl; } /* terminate evaluation */

        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getPat31"); /* print errormessage */
            cc = 21; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getPat32",is); /* print errormessage */
          cc = 22; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) { /* next keword not present */
          Lg.Err("getPat33"); /* print errormessage */
          cc = 23; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(!is.equals("trackpdps")) { /* 'TrackPDPs' not found */
          Lg.Err("getPat34",is); /* print errormessage */
          cc = 24; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        l1 = cB.getBrL(); /* current bracket-level for terminate */
        PDP = cPth.getPDP(10); /* create and initialize PDP-table */
        if(PDP==null) { /* table was NOT correctly initialized */
          Lg.Err("getPat35",cB.getStat(true)); /* print errormessage */
          cc = 25; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        for(c=0;c<10000;c+=1) { /* read and process ALL PDP-records (max. 10000) */
          is = cB.getKE(true); /* get next controlword */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getPat41",null,c,cB.getStat(true)); /* print errormessage */
              cc = 31; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getPat42",is,c,cB.getStat(true)); /* print errormessage */
            cc = 22; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          if(is.length()==0) break; /* no more entries found */
          dtl1: { /* block for error-break */
            cPDP = null; /* set 'Default' in case of error */
            if(!is.equals("trackpdp")) { /* 'TrackPDP' not found */
              Lg.Err("getPat43",is,c,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl1; } /* terminate evaluation */
            /* load position-values (qx qz x y z) and check them */
            if((is=getPos(cB,true,true))!=null) { /* error within position */
              Lg.Err("getPat42",is,c,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl1; } /* terminate evaluation */
            i = (int)cB.getNV(); /* get value of type-id '1' */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getPat51",is,c,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl1; } /* terminate evaluation */
            j = (int)cB.getNV(); /* get value of type-id '2' */
            if((is=cB.getErr())!=null) { /* error while evaluating */
              Lg.Err("getPat52",is,c,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl1; } /* terminate evaluation */
            cPDP = new TSPatPDP(c,(TSQPos)RetVal,i,j); /* create PDP-entry */
          } /* -dtl1- break-block used in case of error */
          PDP.add(cPDP); /* store valid PDP-entry or 'null' as error-marker */
          if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
            Lg.Err("getPat44",c); /* print errormessage */
            cc = 33; /* set current return-code to error */
            break bl; } /* terminate evaluation */
        } /* -for- process all PDP-definitionlines */
        if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
          cc = 25; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        cPth.setMsk(1); /* mark: PDP-table is successfully processed */
          /* Attention: PDP-table is still valid. */
        if(PDP.contains(null)) cPth.setMsk(18); /* mark: PDP-table contains error(s) */

        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getPat61"); /* print errormessage */
            cc = 41; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getPat62",is,cB.getStat(true)); /* print errormessage */
          cc = 42; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) { /* next keword not present */
          Lg.Err("getPat63"); /* print errormessage */
          cc = 43; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(!is.equals("trackpath")) { /* 'TrackPath' not found */
          Lg.Err("getPat64",is,cB.getStat(true)); /* print errormessage */
          cc = 44; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        l1 = cB.getBrL(); /* current bracket-level for terminate */
        while(true) { /* read and process ALL TrackPath-records */
          is = cB.getKE(true); /* get next controlword */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getPat71"); /* print errormessage */
              cc = 51; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getPat72",is,cB.getStat(true)); /* print errormessage */
            cc = 52; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          if(is.length()==0) break; /* no more entries found */
          l2 = cB.getBrL(); /* current bracket-level for terminate */
          dtl2: { /* block for error-break */
            if(is.equals("trpathname")) { /* Definition-type: 'TrPathName' */
              is = cB.getVal(1); /* get current pathname */
                /* Attention: if filename contains ')' or '('
                 *            it must be surrounded by quotes */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getPat81","TrPathName"); /* print errormessage */
                  cc = 55; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getPat82","TrPathName",is,cB.getStat(true)); /* print errormessage */
                cc = 56; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(is.length()==0) { /* (length-)value is not present */
                Lg.Err("getPat83","TrPathName",cB.getStat(true)); /* print errormessage */
                cc = 57; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cPth.setDta(0,is))!=null) { /* insert name into path (Slot 0). error? */
                Lg.Err("getPat82","TrPathName",is,cB.getStat(true)); /* print errormessage */
                cc = 58; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              cPth.setMsk(4); /* mark: definitionline is successfully processed */
            } else if(is.equals("trpathflags")) { /* Definition-type: 'TrPathFlags' */
              i = cB.getHV(8); /* get flags (Hex-number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getPat84","TrPathFlags",is,cB.getStat(true)); /* print errormessage */
                cc = 61; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              cPth.setFlag(i); /* insert new flag-value into path-object (overwrite) */
              cPth.setMsk(5); /* mark: definitionline is successfully processed */
            } else if(is.equals("name")) { /* Definition-type: 'Name' */
              is = cB.getVal(1); /* get current (TS-)name of path */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getPat81","Name"); /* print errormessage */
                  cc = 65; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getPat82","Name",is,cB.getStat(true)); /* print errormessage */
                cc = 66; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(is.length()==0) { /* (length-)value is not present */
                Lg.Err("getPat83","Name",cB.getStat(true)); /* print errormessage */
                cc = 67; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cPth.setDta(1,is))!=null) { /* insert name into path (Slot 1). error? */
                Lg.Err("getPat82","Name",is,cB.getStat(true)); /* print errormessage */
                cc = 68; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              cPth.setMsk(6); /* mark: definitionline is successfully processed */
            } else if(is.equals("trpathstart")) { /* Definition-type: 'TrPathStart' */
              is = cB.getVal(1); /* get current name of pathstart */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getPat81","TrPathStart"); /* print errormessage */
                  cc = 71; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getPat82","TrPathStart",is,cB.getStat(true)); /* print errormessage */
                cc = 72; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(is.length()==0) { /* (length-)value is not present */
                Lg.Err("getPat83","TrPathStart",cB.getStat(true)); /* print errormessage */
                cc = 73; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cPth.setDta(2,is))!=null) { /* insert name into path (Slot 2). error? */
                Lg.Err("getPat82","TrPathStart",is,cB.getStat(true)); /* print errormessage */
                cc = 74; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              cPth.setMsk(7); /* mark: definitionline is successfully processed */
            } else if(is.equals("trpathend")) { /* Definition-type: 'TrPathEnd' */
              is = cB.getVal(1); /* get current name of pathend */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getPat81","TrPathEnd"); /* print errormessage */
                  cc = 75; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getPat82","TrPathEnd",is,cB.getStat(true)); /* print errormessage */
                cc = 76; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(is.length()==0) Lg.Err("getPat83","TrPathEnd",cB.getStat(true)); /* name not found */
              if((is=cPth.setDta(3,is))!=null) { /* insert name into path (Slot 3). error? */
                Lg.Err("getPat82","TrPathEnd",is,cB.getStat(true)); /* print errormessage */
                cc = 78; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              cPth.setMsk(8); /* mark: definitionline is successfully processed */
            } else if(is.equals("trpathnodes")) { /* Definition-type: 'TrPathNodes' */
              cc = (int)cB.getNV(); /* get number of folowing entries */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getPat84","TrPathNodes",is,cB.getStat(true)); /* print errormessage */
                cc = 81; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(cc<1) { /* range of number is invalid (too small) */
                Lg.Err("getPat85","TrPathNodes",cc,cB.getStat(true)); /* print errormessage */
                cc = 82; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              PNde = cPth.getPNde(cc); /* create and init PathNode-table */
              if(PNde==null) { /* table was NOT correctly initialized */
                Lg.Err("getPat86","TrPathNodes",cc,cB.getStat(true)); /* print errormessage */
                cc = 83; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              for(c=0;c<cc;c+=1) { /* read and process ALL PathNode-definitions */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getPat91",null,c,cB.getStat(true)); /* print errormessage */
                    cc = 91; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getPat92",is,c,cB.getStat(true)); /* print errormessage */
                  cc = 92; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                dtl3: { /* block for error-break */
                  if(!is.equals("trpathnode")) { /* 'TrPathNode' not found */
                    Lg.Err("getPat93",is,c,cB.getStat(true)); /* print errormessage */
                    ec += 1; /* count error */
                    break dtl3; } /* terminate evaluation */
                  i = cB.getHV(8); /* get flags (Hex-number) */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getPat94",is,c,cB.getStat(true)); /* print errormessage */
                    ec += 1; /* count error */
                    break dtl3; } /* terminate evaluation */
                  j = (int)cB.getNV(); /* get index-number of following entry */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getPat95",is,c,cB.getStat(true)); /* print errormessage */
                    ec += 1; /* count error */
                    break dtl3; } /* terminate evaluation */
                  if(j<-1 || j>=cc) { /* range-error within index */
                    Lg.Err("getPat96",""+j,c,cB.getStat(true)); /* print errormessage */
                    ec += 1; /* count error */
                    break dtl3; } /* terminate evaluation */
                  cRef = (j<0) ? null : new TSRefC(j); /* create first reference-definition */
                  j = (int)cB.getNV(); /* get alternate index-number of following entry */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getPat95",is,c,cB.getStat(true)); /* print errormessage */
                    ec += 1; /* count error */
                    break dtl3; } /* terminate evaluation */
                  if(j<-1 || j>=cc) { /* range-error within index */
                    Lg.Err("getPat96",""+j,c,cB.getStat(true)); /* print errormessage */
                    ec += 1; /* count error */
                    break dtl3; } /* terminate evaluation */
                  cPNde = new TSPatNde(c,i,cRef,(j<0) ? null : new TSRefC(j)); /* PNode-entry */
                  i = (int)cB.getNV(); /* get index-number of PDP-entry */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getPat97",is,c,cB.getStat(true)); /* print errormessage */
                    ec += 1; /* count error */
                    break dtl3; } /* terminate evaluation */
                  if(i<0 || i>=PDP.size()) { /* range-error within index */
                    Lg.Err("getPat98",""+i,c,cB.getStat(true)); /* print errormessage */
                    ec += 1; /* count error */
                    break dtl3; } /* terminate evaluation */
                  cPDP = PDP.get(i); /* resolve PDP-reference of index (or 'null') */
                  cPNde.chgPDP(cPDP); /* and insert it into PathNode */
                  PNde.add(cPNde); /* register PathNode within PathNode-table */
                  if(cPDP==null) { /* PDP-reference is NOT valid (due to error) */
                    Lg.Err("getPat99",""+i,c,cB.getStat(true)); /* print errormessage */
                    ec += 1; /* count error */
                    break dtl3; } /* terminate evaluation */
                  cPDP.incCnt(1); /* increment usage-count of PDP-reference */
                } /* -dtl3- break-block used in case of error */
                if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                  cc = 99; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
              } /* -for- process ALL PathNode-definitions */
              if(PNde.size()>0) cPth.setMsk(9); /* mark: definitionline is successfully processed */
              else Lg.Err("getPat9A",cB.getStat(true)); /* print errormessage */
                /* EMPTY PathNode-table (no valid entry) means: terminate */
            } else { /* unknown keyword -- do not process */
              Lg.Err("getPat73",is,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
            } /* terminate evaluation ('break dtl2' is not needed here) */
          } /* -dtl2- break-block used in case of error */
          if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
            Lg.Err("getPat74",cB.getStat(true)); /* print errormessage */
            cc = 53; /* set current return-code to error */
            break bl; } /* terminate evaluation */
        } /* -while- process all definitions */
        if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
          cc = 45; /* set current return-code to error */
          break bl; } /* terminate evaluation */

        if((j=cPth.tstMsk(TSPath.reqMsk))!=0) { /* definitions are missing -- which one?
            * (mask within path-object is NOT changed) */
          is = ""; /* preset: no missing item */
          cc = -1; /* not used -- cc is item-counter */
          for(i=0;i<32;i+=1) { /* check all definitions if present */
            if(TSOpts.chkMsk(i,TSPath.reqMsk)) cc += 1; /* skip to next index */
            if(!TSOpts.chkMsk(i,j)) continue; /* item NOT requested / available */
            is += "," + TSPath.reqNme[cc]; /* insert name of missing item */
          } /* check all definitionlines */
          Lg.Err("getPat12",is.substring(1),j); /* print errormessage */
          cc = 101;  /* set current return-code to error */
          break bl; } /* terminate evaluation */
        cc = 0; /* set condition-code to 'no error' */
      } /* -bl- break-block used in case of error */

      is = cF.close(); /* close input-file again -- error? */
      if(is!=null) Lg.Err("getPat11",is); /* print errormessage */
      if(cc!=0) Lg.Log("getPat13",cc); /* severe error -- print errormessage */
      else { /* path-definition is valid -- store it */
        if(ec>0) Lg.Log("getPat14",ec); /* print number of errors */
        is = fn.toLowerCase(); /* convert filename for key */
        is = is.substring(0,is.indexOf(".pat")); /* and remove suffix */
        if(Pth.put(is,cPth)!=null) /* store current path-definition */
          Lg.Err("getPat16",is); /* print errormessage */
        ce += ec; /* add number of errors to 'overall errors' */
      } /* path-definition is valid */
      Lg.Log("getPat15",cB.getStat(true)); /* print result of file-check */
    } /* -for- process all file-definitions */

    Lg.Skip(false); /* print empty line to LOG-file */
    Lg.Log("getPat06",cf); /* print number of files processed */
    Lg.Log("getPat07",ce); /* print number of errors (overall) */
    Lg.Skip(false); /* print empty line to LOG-file */

    return 0; /* return -- program (successfully) ended */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkPat"
  * Path-Definitionen einer Route pruefen und Referenzen erzeugen
  * ##chkPat (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chkPat( /* Path-Definitionen bearbeiten */
   TSRoute cRte) /* Routendefinition mit Basisverzeichnis */
   {
   /*-----------------------------------------------------------------*/
    TSPath              cPth;  /* current Path-definition */
    TSPatPDP            cPDP;  /* current Pathpoint-definition */
    TSPatNde            cPNde; /* current PathNode-definition */
    ArrayList<TSPatNde> PNde;  /* table of PathNode-definitions */
    TSPatNde            rPNde; /* referenced PathNode-definition */
    String              is;    /* intermediate value */
    int                 nr,c,ix,ec; /* intermediate values */
    Iterator<TSPath>    cI;    /* Iterator of Path-definitions */
    Iterator            pI;    /* Iterator of PathNode-/Pathpoint-Def. */
    boolean             rep;   /* repeat deletion-loop */
   /*=================================================================*/
    cI = cRte.getIt(17); /* get list of path-definitions */
    if(cI==null) return -1; /* definitions are NOT loaded -- cancel */

    Lg.Skip(true); /* insert empty line to log and screen */
    Lg.Msg("chkPat01",cRte.getInfo(1)); /* print description of next action */
    if(EnaH) Lg.Log("chkPat02",""+TSPatPDP.chkTol); /* print hint */

    ec = 0; /* preset: no error found */
    c  = 0; /* init counter of path-definitions */
    while(cI.hasNext()) { /* more path-definitions available? */
      cPth = cI.next(); /* get next path-entry */
      if(cPth==null) throw new IllegalStateException(
        TSLogg.getMsg("Msg908","TSPath==null","TSUtil.chkPat()",0));
      c += 1; /* count valid path-definition */
      Lg.Log("chkPat05",cPth.getName(true),c); /* print description of next action */

      if(cPth.chkMsk(9)) { /* valid PathNode-Table available -- check it */
        PNde = cPth.getPNde(0); /* get list of PathNode-Definitions */
        cPNde = PNde.get(0); /* get FIRST PathNode-entry */
        cPNde.incCnt(1); /* and increment usage-count */

        /* create reference-connections between PathNodes */
        pI = PNde.iterator(); /* process all PathNode-definitions */
        ix = -1; /* initialize counter of valid PathNodes */
        while(pI.hasNext()) { /* more PathNode-definitions available */
          cPNde = (TSPatNde)pI.next(); /* get next PathNode-entry */
          if(cPNde==null) throw new IllegalStateException( /* only once */
            TSLogg.getMsg("Msg908","TSPatNde==null","TSUtil.chkPat()",0));
          ix += 1; /* count valid entry */
          is = cPNde.fndNxt(true,PNde); /* resolve NEXT PathNode-Reference */
            /* if the target of the reference is found, it is inserted into
             *  the addressfield of the reference-definition */
          if(is!=null) { /* Reference NOT resolved -- report error */
            Lg.Err("chkPat11",is,ix); /* print error-message */
            ec += 1; /* and count it */
          } /* PathNode-Reference NOT resolved */
          is = cPNde.fndNxt(false,PNde); /* resolve ALTERNATE PathNode-Reference */
          if(is!=null) { /* Reference NOT resolved -- report error */
            Lg.Err("chkPat11",is,ix); /* print error-message */
            ec += 1; /* and count it */
          } /* PathNode-Reference NOT resolved */
        } /* process all PathNode-definitions */

        /* Delete PathNode-definitions which are NOT referenced (iterative) */
        do { /* repeat until no more definitions are deleted */
          rep = false; /* preset: loop is done */
          pI = PNde.iterator(); /* process all PathNode-definitions */
          while(pI.hasNext()) { /* more PathNode-definitions available */
            cPNde = (TSPatNde)pI.next(); /* get next PathNode-entry */
            if(cPNde.incCnt(0)>0) continue; /* entry is still used -- OK */
            /* current entry is (no longer) used / referenced */
            /* check NEXT reference */
            if((rPNde=cPNde.chkNxt(true))!=null) { /* valid reference may exist */
              rPNde.incCnt(-1); /* PathNode is no longer referenced */
              rep = true; /* enter loop again to process this PathNode */
            } /* valid reference exists -- successfully processed */
            /* check ALTERNATE reference */
            if((rPNde=cPNde.chkNxt(false))!=null) { /* valid reference may exist */
              rPNde.incCnt(-1); /* PathNode is no longer referenced */
              rep = true; /* enter loop again to process this PathNode */
            } /* valid reference exists -- successfully processed */
            if((cPDP=cPNde.chgPDP(null))!=null) cPDP.incCnt(-1);
              /* if PathNode contains a valid reference to a Pathpoint- entry
               * the reference-count of this entry must be decremented, too */
            Lg.Err("chkPat12",cPNde.chgNr(-1)); /* print error-message */
            ec += 1; /* and count it */
            pI.remove(); /* delete the no longer used PathNode-definition */
          } /* process all PathNode-definitions */
        } while(rep); /* repeat loop if another entry was deleted */

        /* Renumber PathNode-Definitions (ALL PathNodes are VALID) */
        pI = PNde.iterator(); /* process all PathNode-definitions */
        ix = 0; /* initialize new ID-number of entry */
        while(pI.hasNext()) { /* more PathNode-definitions available */
          cPNde = (TSPatNde)pI.next(); /* get next PathNode-entry */
          cPNde.chgNr(ix++); /* renumber entry */
        } /* process all PathNode-definitions */
      } /* PathNode-Table is available and valid */

      if(cPth.chkMsk(1)) { /* valid Pathpoint-table (PDP) available -- check it */
        pI = cPth.getPDP(0).iterator(); /* process ALL PDP-Definitions */
        ix = -1; /* initialize counter of valid Pathpoints */
        nr = 0; /* initialize new ID-number of entry */
        while(pI.hasNext()) { /* more PDP-Definitions available */
          cPDP = (TSPatPDP)pI.next(); /* get next PDP-entry */
          ix += 1; /* compute number of entry */
          if(cPDP==null) continue; /* entry missing due to error(s) */
          if(cPDP.incCnt(0)==0) { /* entry is NOT referenced from any PathNode-entry */
            Lg.Err("chkPat21",ix); /* print error-message */
            ec += 1; /* and count it */
            continue; } /* entry is fully processed -- next one */
          cPDP.chgNr(nr++); /* entry is referenced -- (re)number it */

          is = cPDP.fndNde(cRte); /* search for connected TrNode-Reference
            * If the height-value of the Pathpoint-entry differs 'too much' from the
            * height-value of the TrackNode, this value is inserted into the Pathpoint.*/
          if(is!=null) { /* reference not found -- path is broken! */
            Lg.Err("chkPat22",is,ix); /* print error-message */
            ec += 1; /* and count it */
            cPth.setMsk(16); /* mark: path-definition contains a broken path */
            continue; } /* entry is fully processed -- next one */
          if(cPDP.isCorr()) cPth.setMsk(17); /* height modified -- mark it */
        } /* process ALL PDP-Definitions */
      } else Lg.Err("chkPat31");/* print error-message */

    } /* process ALL Pfad-Definitions */

    Lg.Skip(false); /* insert empty line to screen */
    Lg.Log("chkPat06",c); /* print result of the checking */
    Lg.Log("chkPat07",ec); /* print result of the checking */
    Lg.Skip(false); /* insert empty line to screen */

    return 0; /* Program ended (sucessfully) */
  }

 /**. <pre>
  *=====================================================================
  * Method "putPatF"
  * Write (modified) ALL path-definitions of a route
  * ATTENTION: If modifications are included in the target-files,
  *          the files cannot be used as pathdefinitions any longer.
  * Prime-number-options used with 'opt':
  *       2 - create files without errors ONLY
  *       3 - 'noreplace' - Path must not exist
  *       5 - include extensions (modifications)?
  *       7 - ONLY write files which height-values have been corrected
  * ##putPatF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int putPatF( /* write path-definitions */
   TSRoute cRte, /* current route-definition */
   File    tdat, /* definition of the temporary file (overwrite) */
   int     opt)  /* options (coded using prime-numbers) */
   {
   /*-----------------------------------------------------------------*/
    File                dats,datz,dir1,dir2; /* temporary files */
    TSFileX             cF;    /* current output-file (control) */
    ArrayList<TSPatNde> PNde;  /* table of PathNode-definitions */
    TSPath              cPth;  /* current path-definition */
    TSPatPDP            cPDP;  /* current PDP-definition */
    TSPatNde            cPNde; /* current PathNode-definition */
    String              is,js; /* intermediate values */
    int                 i,ec,cc,ix; /* intermediate values */
    int                 ce,cf; /* intermediate values */
    boolean             ext;   /* inclue modifications (extensions) */
    Iterator<TSPath>    cI;    /* Iterator for Path-definitions */
    Iterator            pI;    /* Iterator for PDP-definitions */
    Iterator<String>    LneI;  /* Line-Iterator for output */
    ArrayList<String>   LneT;  /* Line-Table for output */
   /*=================================================================*/
    cI = cRte.getIt(17); /* get list of path-definitions */
    if(cI==null) return -1; /* Path-definitons are NOT available */

    Lg.Skip(true); /* print empty line to LOG-file and screen */
    /* check if target-directory of path-definitions exist */
    dir2 = null; /* compiler needs it */
    ext = (opt%5)==0; /* extract special option from option-value */
    if(ext && tdat!=null) { /* no extended output if overwrite active */
      Lg.Msg("putPat11"); /* print errormessage */
      ext = false; /* switch off extended output */
    } /* no extended output if overwrite active */
    if(tdat==null) { /* temporary file is NOT used */
      dir2 = cRte.getFile(42); /* get target-directory */
      if(dir2==null) { /* folder NOT available -- terminate */
        Lg.Skip(true); /* print empty line to LOG-file and screen */
        Lg.Msg("MsgC63",cRte.getInfo(42)); /* print message: terminating */
        Lg.Msg("putPat01"); /* print errormessage */
        Lg.Close(); /* close output to Log-file */
        return 25; } /* terminate function with errorcode */
    } /* target-directory used for output */
    dir1 = cRte.getFile(12); /* get file-reference of source-directory */

    Lg.Msg("putPat02",cRte.getInfo(1)); /* print description of next action */

    ce = 0; /* init error-counter */
    cf = 0; /* init number of definition-files */
    LneT = new ArrayList<String>(10); /* create table for output-line-blocks */
      /* This list is normally empty. After it was filled with output-lines
       * and all lines have been processed, it MUST be cleared again. */
    while(cI.hasNext()) { /* more path-definitions to process */
      cPth = cI.next(); /* get next path-entry */
      if(cPth==null) throw new IllegalStateException( /* security-query */
        TSLogg.getMsg("Msg908","TSPath==null","TSUtil.putPatF()",0));
      is = cPth.getName(true); /* get unmodified name of path-file */
      if(is==null) continue;  /* file is missing -- do not process */

      dats = new File(dir1,is); /* create Source-Reference (for copy/delete) */
      if(cPth.chkMsk(16) && (opt%2)==0) { /* path-def. has error(s) -- do not write */
        Lg.Err("putPat13",is); /* print message: terminating */
        if(tdat==null) continue; /* do not write path-definition */
        dats.delete(); /* overwrite-mode: delete faulty file (inplace) */
        Lg.Log("putPat15",dats.getAbsolutePath()); /* print message */
        continue; /* path-definition was deleted */
      } /* path-definition contained error(s) */
      if((opt%7)==0 && !cPth.chkMsk(17)) continue; /* do not write path-def. */
        /* height-values do not have been modified --> do not write */
      if(ext) is += ".txt"; /* extension requested -- change suffix of file */
      Lg.Log("putPat03",is); /* print description of action */

      if(tdat!=null) datz = tdat; /* preset: use temporary file */
      else { /* full target-reference is needed otherwise */
        datz = new File(dir2,is); /* create full target-reference */
        if((opt%3)==0 && datz.exists()) { /* path-file already exist? */
          Lg.Err("putPat12",is); /* print message: terminating */
          continue; /* do not write path-definition */
        } /* path-definition already exist */
      }  /* full target-reference is needed */

      /* open path-file for output */
      cF = new TSFileX(TSFileX.FT$pat,datz); /* create output-control */
      is = cF.open(true); /* set sub-id and open file */
      if(is!=null) { /* error occurred while opening */
        Lg.Err("putPat06",is); /* print message: terminating */
        continue; /* process next path-file */
      } /* error occurred while opening */
      cf += 1; /* count valid path-definition */

      ec = 0; /* init: no error registered (per file) */
      cc = 10; /* preset overall error-position */
      bl: { /* block for error-break */
        if(cPth.chkMsk(0)) { /* Serial-Number is defined */
          is = "Serial ( " + cPth.getInt(0) + " )"; /* create stmt */
          cc = 11; /* preset error-position */
          if((is=cF.putData(is))!=null) break bl; /* write-error */
        } /* Serial-Number was defined */

        if(cPth.chkMsk(1)) { /* PDP-Definitions are available */
          is = "TrackPDPs ( "; /* set prefix of PDP-definitions */
          cc = 12; /* preset error-position */
          if((is=cF.putData(is))!=null) break bl; /* write-error */
          pI = cPth.getPDP(0).iterator(); /* process all PDP-entries */
            /* table is available in any case (chkMsk) */
          ix = -1; /* init line-number of PDP-entries */
          while(pI.hasNext()) { /* more PDP-definitions available? */
            cPDP = (TSPatPDP)pI.next(); /* get next PDP-entry */
            if(cPDP==null) continue; /* entry is NOT used (due to error) */
            if(cPDP.incCnt(0)==0) continue; /* entry is NOT referenced */
            ix += 1; /* correct/compute number of entry */
            LneI = cPDP.crDef(LneT); /* create output-lines */
            if(LneI==null) { cc = 0; break bl;} /* no valid output-lines -- do not write */
            i = 0; /* initialize line-counter */
            while(LneI.hasNext()) { /* more output-lines available ? */
              is = LneI.next(); /* get next output-line */
              if(is==null) continue; /* dummy line -- do not write */
              i += 1; /* increment counter to next line */
              /* Attention: A output-line must start with '\t' or it is
               * considered as an error-message */
              if(is.charAt(0)!='\t') { /* got error-message instead of output-line */
                Lg.Err("putPat05",is,cF.getStat(true)); /* print error-message */
                ec += 1; /* and count error */
              } else { /* NO error-message --write it */
                if(ext) is = DF4.format(ix) + is; /* add extension if requested */
                cc = i + 13; /* preset error-position */
                if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
              } /* output-line processed */
            } /* -while- process all output-lines */
            LneT.clear(); /* all lines written -- delete them */
          } /* -while- write all PDP-definitions */
          cc = 19; /* preset error-position */
          if((is=cF.putData(")"))!=null) break bl; /* write-error */
        } /* PDP-Definitions were processed */

        is = "TrackPath ( "; /* prefix of next part */
        cc = 21; /* preset error-position */
        if((is=cF.putData(is))!=null) break bl; /* write-error */
        if(cPth.chkMsk(4)) { /* defintionline is available -- write it */
          is = modStr(cPth.getDta(0)); /* get name-value (modified) */
          is = "\tTrPathName ( " + is + " )"; /* create current definitionline */
          cc = 22; /* preset error-position */
          if((is=cF.putData(is))!=null) break bl; /* write-error */
        } /* definition has been written */
        if(cPth.chkMsk(5)) { /* defintionline is available -- write it */
          cPth.setFlag(i=cPth.setFlag(0)); /* get Flag-definitions */
          is = "\tTrPathFlags ( " + TSUtil.toHex(i,8) + " )"; /* and build line */
          cc = 23; /* preset error-position */
          if((is=cF.putData(is))!=null) break bl; /* write-error */
        } /* definition has been written */
        if(cPth.chkMsk(6)) { /* defintionline is available -- write it */
          is = modStr(cPth.getDta(1)); /* get name-value (modified?) */
          is = "\tName ( " + is + " )"; /* create current definitionline */
          cc = 24; /* preset error-position */
          if((is=cF.putData(is))!=null) break bl; /* write-error */
        } /* definition has been written */
        if(cPth.chkMsk(7)) { /* defintionline is available -- write it */
          is = modStr(cPth.getDta(2)); /* get name-value (modified?) */
          is = "\tTrPathStart ( " + is + " )"; /* create current definitionline */
          cc = 25; /* preset error-position */
          if((is=cF.putData(is))!=null) break bl; /* write-error */
        } /* definition has been written */
        if(cPth.chkMsk(8)) { /* defintionline is available -- write it */
          is = modStr(cPth.getDta(3)); /* get name-value (modified?) */
          is = "\tTrPathEnd ( " + is + " )"; /* create current definitionline */
          cc = 26; /* preset error-position */
          if((is=cF.putData(is))!=null) break bl; /* write-error */
        } /* definition has been written */
        if(cPth.chkMsk(9)) { /* PathNode-definitions are available -- write them */
          PNde = cPth.getPNde(0); /* get PathNode-table */
            /* table is available in any case (chkMsk) */
          is = "\tTrPathNodes ( " + PNde.size(); /* prefix of PathNode-definitions */
          cc = 31; /* preset error-position */
          if((is=cF.putData(is))!=null) break bl; /* write-error */
          pI = PNde.iterator(); /* process all entries of PathNode-table */
          ix = -1; /* init line-number */
          while(pI.hasNext()) { /* More PathNode-definitions available */
            cPNde = (TSPatNde)pI.next(); /* get next PathNode-entry */
            if(cPNde==null) throw new IllegalStateException( /* security-query */
              TSLogg.getMsg("Msg908","TSPatNde==null","TSUtil.putPatF()",0));
            ix += 1; /* correct/create current entry-number */
            LneI = cPNde.crDef(LneT); /* create output-lines */
            if(LneI==null) { cc = 0; break bl;} /* no valid output-lines -- do not write */
            i = 0; /* initialize line-counter */
            while(LneI.hasNext()) { /* more output-lines available ? */
              is = LneI.next(); /* get next output-line */
              if(is==null) continue; /* dummy line -- do not write */
              i += 1; /* increment counter to next line */
              /* Attention: A output-line must start with '\t' or it is
               * considered as an error-message */
              if(is.charAt(0)!='\t') { /* got error-message instead of output-line */
                Lg.Err("putPat05",is,cF.getStat(true)); /* print error-message */
                ec += 1; /* and count error */
              } else { /* NO error-message --write it */
                if(ext) is = DF4.format(ix) + is; /* add extension if requested */
                cc = i + 13; /* preset error-position */
                if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
              } /* output-line processed */
            } /* -while- process all output-lines */
            LneT.clear(); /* all lines written -- delete them */
          } /* -while- write ALL PathNode-Definitions */
          cc = 39; /* preset error-position */
          if((is=cF.putData("\t)"))!=null) break bl; /* write-error */
        } /* PathNode-definitions were available */
        cc = 28; /* preset error-position */
        if((is=cF.putData(")"))!=null) break bl; /* write-error */
        cc = 29; /* preset position of error */
        is = TSLogg.getMsg("Msg100","Path"); /* create TSUtil-ID-Line */
        if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
        cc = 0; /* NO error occurred */
      } /* -bl- break-block used in case of error */
      if(is!=null) { /* output of message still needed */
        Lg.Err("putPat05",is,cF.getStat(true)); /* print errormessage */
        ec += 1; /* and count error */
      } /* message has to be written */
      is = cF.close(); /* clos output-file again */
      if(is!=null) Lg.Err("putPat05",is,cF.getStat(true)); /* print errormessage */
      if(cc!=0) Lg.Err("putPat16",cc); /* print severe error */
      else if(ec>0) Lg.Log("putPat17",ec); /* print number of errors */

      Lg.Log("putPat18",cF.getStat(true)); /* print number of entries */
//      Lg.Log("putPat19",cF.getStat(false)); /* print file-length */
      ce += ec; /* count overall number of errors */

      /* copy back result to path-file(source) if overwrite requested */
      cc += ec; /* compute error-threshold */
      if(tdat!=null) { /* overwrite of original file is requested */
        if(cc>0) cf -= 1; /* error --do not copy file */
          /* if an error occured the original file is NOT changed */
        else { /* copy target-file and overwrite original file */
          is = dats.getAbsolutePath(); /* name of source-file */
          js = "copy \""+tdat.getAbsolutePath()+"\" \""+is+"\" ";
            /* create copy-command */
          if((i=exec(true,js,null,Lg))>0) /* error during execute */
            Lg.Log("MsgC49",is,i); /* print errormessage */
        } /* original file (source) was overwritten */
      } else if(cc>0 && (opt%2)==0) { /* error -- delete file */
        datz.delete(); /* delete created file due to error(s) */
        is = datz.getAbsolutePath(); /* name of target-file */
        Lg.Msg("putPat07",is); /* print errormessage */
        cf -= 1; /* path-file is NOT created */
      } /* new target-file has been deleted again */
    } /* -while- write ALL path-definitions */

    Lg.Skip(false); /* print empty line to LOG-file */
    Lg.Log("putPat08",cf); /* print number of path-files */
    Lg.Log("putPat09",ce); /* print number of overall errors */
    Lg.Skip(false); /* print empty line to LOG-file */

    return 0; /* terminate program (successfully) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getSrvF"
  * alle Service-Definitionen einer Route laden
  * ##getSrvF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getSrvF( /* Service-Definitionen laden */
   TSRoute cRte, /* Routendefinition mit Basisverzeichnis */
   boolean nocr) /* do not create directory if not available */
   {
   /*-----------------------------------------------------------------*/
    File                    dir,dat; /* temporary files/folder */
    TSFileX                 cF;    /* current input-file (service,train) */
    TSFleMask               cM;    /* current file-mask */
    TSBuf                   cB;    /* current input-buffer 'read file' */
    TreeMap<String,TSSrv>   Srv;   /* Table of service-definitions */
    Iterator<TSSrv>         SrvI;  /* Iterator for service-definitions */
    TSSrv                   cSrv;  /* current service-definition */
    TreeMap<String,TSTrain> Trn;   /* current table of train-references */
    TSTrain                 cTrn;  /* current reference to train */
    ArrayList<TSStop>       StpT;  /* List of 'StationStop's */
    TSStop                  cStp;  /* current 'StationStop'-definition */
    String                  is;    /* intermediate values */
    String[]                fl;    /* filelist of service-files */
    int                     i,j,c,l1,l2,l3;
    int                     ec,cc,cf,ce; /* intermediate values */
    double                  d;     /* intermediate value */
   /*=================================================================*/
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("getSrv01",cRte.getInfo(1)); /* Aktionsmeldung ausgeben */

    dir = cRte.getFile(13); /* File-Referenz fuer Verzeichnis */
    if(dir==null) { /* Keine Verzeichnis-Definition erstellbar */
      Lg.Msg("getSrv02"); /* Fehler melden --  Bearbeitung abbrechen */
      Lg.Close(); /* close output to Log-file */
      return 11; /* terminate function with errorcode */
    } /* Datei existiert nicht */
    if(!dir.exists()) { /* Verzeichnis nicht gefunden */
      Lg.Msg("getSrv03",dir.getPath()); /* Fehler melden */
      if(nocr) return -1; /* terminate function with marker */
      if(!dir.mkdirs()) Lg.Msg("getSrv04"); /* print message */
        /* try to create folder and print error if unsuccessful-- error? */
      return -2; /* terminate function with marker */
    } /* Datei existiert nicht */

    cM = new TSFleMask(false,".*\\.srv"); /* select service-files */
    if((is=cM.getErr())!=null) { /* error within file-mask */
      Lg.Skip(false); /* print empty line to LOG-file */
      Lg.Msg("getSrv11",is); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* error found -- function terminated */
    fl = dir.list((FilenameFilter)cM); /* create list of ALL files */
      /* result contains NO directories! */
    if(fl==null) { /* Source-ist kein Verzeichnis */
      Lg.Msg("getSrv05",dir.getPath()); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 11; /* terminate function with errorcode */
    } /* Datei existiert nicht */

    cf = ce = 0; /* init file-counter, overall errors */
    Srv = cRte.getServ(); /* Service-Speicher erstellen und init */
    for(String fn:fl) { /* process all selected file-definitions */
      dat = new File(dir,fn); /* create file-reference (source) */
      cf += 1; /* and count path-file */
      Lg.Log("MsgC54",dat.getAbsolutePath(),DF3.format(cf));

      /* Eingabe-Datei oeffnen */
      cF = new TSFileX(TSFileX.FT$srv,dat); /* Eingabe-Steuerung erstellen */
      is = cF.open(false); /* Datei fuer Eingabe oeffnen */
      if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
        Lg.Err("getSrv11",is); /* Abbruchmeldung ausgeben */
        continue; /* naechste Datei bearbeiten */
      } /* Fehler beim Oeffnen der Datei */
      cB = new TSBuf(cF); /* create inputline and init counter */

      cSrv = new TSSrv(fn,dat); /* create service-entry (Basis) */

      cc = 0; /* fuer Compiler */
      ec = 0; /* noch kein Fehler erkannt */
      c  = 0; /* preset currend number of 'StationStop'-entry */
      bl: { /* block for error-break */
        is = cB.getKE(true); /* get first controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getSrv21"); /* print errormessage */
            cc = 5; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getSrv22",is); /* print errormessage */
          cc = 6; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) { /* next keword not present */
          Lg.Err("getSrv23"); /* print errormessage */
          cc = 7; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(!is.equals("service_definition")) { /* 'Service_Definition' fehlt */
          Lg.Err("getSrv24",is); /* Fehlermeldung ausgeben */
          cc = 8; /* aktuellen Condition-Code setzen */
          break bl; } /* Bearbeitung beenden */
        l1 = cB.getBrL(); /* current bracket-level for terminate */

        while(true) { /* alle weiteren Definitions-Saetze lesen */
          is = cB.getKE(true); /* get next controlword */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getSrv41"); /* print errormessage */
              cc = 21; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getSrv42",is); /* print errormessage */
            cc = 22; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          if(is.length()==0) break; /* kein weiterer Eintrag mehr */
          l2 = cB.getBrL(); /* current bracket-level for terminate */
          dtl:{ /* break-Block fuer Fehler */
            if(is.equals("serial")) { /* Definitionstyp: 'Serial' */
              if(cSrv.chkMsk(0)) { /* Eintrag bereits definiert */
                Lg.Err("getSrv51","Serial",0,c0); /* Fehlermeldung ausgeben */
                ec += 1; /* Fehler zaehlen */
                break dtl; } /* Bearbeitung des Eintrags beenden */
              i = (int)cB.getNV(); /* get Serial-Nummer */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getSrv31",is,cB.getStat(true)); /* print errormessage */
                cc = 15; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<1) { /* invalid value for 'Serial' */
                Lg.Err("getSrv32",null,i,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; /* terminate evaluation of entry */
              } /* invalid value for 'Serial' */
              cSrv.setInt(0,i); /* Serial-Nummer einsetzen (TSData) */
              cSrv.setMsk(0); /* kennzeichnen, dass Eintrag gefunden wurde */
            } else if(is.equals("name")) { /* Definitionstyp: 'Name' */
              is = cB.getVal(1); /* get value of argument */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getSrv52","Name",0,cB.getStat(true)); /* print errormessage */
                  cc = 31; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getSrv53","Name",is,cB.getStat(true)); /* print errormessage */
                cc = 32; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(is.length()==0) { /* next keword not present */
                Lg.Err("getSrv54","Name",cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation of entry */
              if((is=cSrv.chgNme(is))!=null) /* Name in Objekt eintragen */
                Lg.Err("getSrv55","Name",is,cB.getStat(true)); /* Fehler melden */
              cSrv.setMsk(1); /* kennzeichnen, dass Eintrag gefunden wurde */
            } else if(is.equals("train_config")) { /* Definitionstyp: 'Train_Config' */
              is = cB.getVal(1); /* get value of argument */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getSrv52","Train_Config",0,cB.getStat(true)); /* print errormessage */
                  cc = 33; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getSrv53","Train_Config",is,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation of entry */
              if(is.length()==0) { /* next keword not present */
                Lg.Err("getSrv54","Train_Config",cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation of entry */
              cTrn = new TSTrain(is); /* create default-definition for new Train */
              cTrn.setMsk(1); /* preset: 'consist' could not be found */
              if((cTrn=cSrv.chgTrn(cTrn))!=null) /* insert train-reference */
                Lg.Err("getSrv55","Train_Config",cTrn.getName(true),cB.getStat(true));
              cSrv.setMsk(2); /* kennzeichnen, dass Eintrag gefunden wurde */
            } else if(is.equals("pathid")) { /* Definitionstyp: 'PathID' */
              if(cSrv.chkMsk(3)) { /* Definitionszeile schon vorhanden */
                Lg.Err("getSrv51","PathID",0,cB.getStat(true)); /* Fehler melden */
                ec += 1; /* Fehler zaehlen */
                break dtl; } /* Bearbeitung beenden */
              is = cB.getVal(1); /* get value of argument */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getSrv52","PathID",0,cB.getStat(true)); /* print errormessage */
                  cc = 34; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getSrv53","PathID",is,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation of entry */
              if(is.length()==0) { /* next keword not present */
                Lg.Err("getSrv54","PathID",cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation of entry */
              if((is=cSrv.chgPNme(is))!=null) /* Name in Objekt eintragen */
                Lg.Err("getSrv55","PathID",is,cB.getStat(true)); /* Fehler melden */
              cSrv.setMsk(3); /* kennzeichnen, dass Eintrag gefunden wurde */
            } else if(is.equals("maxwheelacceleration")) { /* Def-typ: 'MaxWheelAcceleration' */
              d = cB.getFV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getSrv56","MaxWheelAcceleration",is,cB.getStat(true));
                cc = 35; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(!Double.isNaN(d=cSrv.setFlt(2,0,d))) /* value already defined */
                Lg.Err("getSrv55","MaxWheelAcceleration",""+d,cB.getStat(true));
              cSrv.setMsk(4); /* kennzeichnen, dass Eintrag gefunden wurde */
            } else if(is.equals("efficiency")) { /* Definitionstyp: 'Efficiency' */
              d = cB.getFV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getSrv56","Efficiency",is,cB.getStat(true));
                cc = 36; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(!Double.isNaN(d=cSrv.setFlt(2,1,d))) /* value already defined */
                Lg.Err("getSrv55","Efficiency",""+d,cB.getStat(true)); /* Fehler melden */
              cSrv.setMsk(5); /* kennzeichnen, dass Eintrag gefunden wurde */
            } else if(is.equals("timetable")) { /* Definitionstyp: 'TimeTable' */
              if(cSrv.chkMsk(6)) { /* Definitionszeile schon vorhanden */
                Lg.Err("getSrv51","TimeTable",0,cB.getStat(true)); /* Fehler melden */
                ec += 1; /* Fehler zaehlen */
                break dtl; } /* Bearbeitung beenden */
              StpT = cSrv.getStp(20); /* create table for 'StationStop'-definitions */
              while(true) { /* alle weiteren Definitions-Saetze lesen */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getSrv61"); /* print errormessage */
                    cc = 41; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getSrv62",is); /* print errormessage */
                  cc = 42; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                if(is.length()==0) break; /* kein weiterer Eintrag mehr */
                l3 = cB.getBrL(); /* current bracket-level for terminate */
                tt:{ /* break-Block fuer Fehler */
                  if(is.equals("startingspeed")) { /* Definitionstyp: 'StartingSpeed' */
                    d = cB.getFV(); /* get value of argument (number) */
                    if((is=cB.getErr())!=null) { /* error while evaluating */
                      Lg.Err("getSrv71","StartingSpeed",is,cB.getStat(true));
                      cc = 43; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    if(!Double.isNaN(d=cSrv.setFlt(2,2,d))) /* value already defined */
                      Lg.Err("getSrv72","StartingSpeed",""+d,cB.getStat(true)); /* Fehler melden */
                    cSrv.setMsk(7); /* kennzeichnen, dass Eintrag gefunden wurde */
                  } else if(is.equals("endingspeed")) { /* Definitionstyp: 'EndingSpeed' */
                    d = cB.getFV(); /* get value of argument (number) */
                    if((is=cB.getErr())!=null) { /* error while evaluating */
                      Lg.Err("getSrv71","EndingSpeed",is,cB.getStat(true));
                      cc = 44; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    if(!Double.isNaN(d=cSrv.setFlt(2,3,d))) /* value already defined */
                      Lg.Err("getSrv72","EndingSpeed",""+d,cB.getStat(true)); /* Fehler melden */
                    cSrv.setMsk(8); /* kennzeichnen, dass Eintrag gefunden wurde */
                  } else if(is.equals("startinworld")) { /* Definitionstyp: 'StartInWorld' */
                    i = (int)cB.getNV(); /* get value of argument (number) */
                    if((is=cB.getErr())!=null) { /* error while evaluating */
                      Lg.Err("getSrv71","StartInWorld",is,cB.getStat(true)); /* print errormessage */
                      cc = 45; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    cSrv.setInt(2,i); /* World-Nummer einsetzen (TSData) */
                    cSrv.setMsk(9); /* kennzeichnen, dass Eintrag gefunden wurde */
                  } else if(is.equals("endinworld")) { /* Definitionstyp: 'EndInWorld' */
                    i = (int)cB.getNV(); /* get value of argument (number) */
                    if((is=cB.getErr())!=null) { /* error while evaluating */
                      Lg.Err("getSrv71","EndInWorld",is,cB.getStat(true)); /* print errormessage */
                      cc = 46; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    cSrv.setInt(3,i); /* World-Nummer einsetzen (TSData) */
                    cSrv.setMsk(10); /* kennzeichnen, dass Eintrag gefunden wurde */
                  } else if(is.equals("stationstop")) { /* Definitionstyp: 'StationStop' */
                    i = Integer.MIN_VALUE; /* Kennzeichen: Wert noch nicht gefunden */
                    d = Double.NaN;        /* Kennzeichen: Wert noch nicht gefunden */
                    j = Integer.MIN_VALUE; /* Kennzeichen: Wert noch nicht gefunden */
                    while(true) { /* alle weiteren Definitions-Saetze lesen */
                      is = cB.getKE(true); /* get next controlword */
                      if(is==null) { /* error found within current input */
                        if((is=cB.getErr())==null) { /* EOF within data */
                          Lg.Err("getSrv81",c); /* print errormessage */
                          cc = 51; /* set current return-code to error */
                          break bl; } /* terminate evaluation */
                        Lg.Err("getSrv82",is,c,cB.getStat(true)); /* print errormessage */
                        cc = 52; /* set current return-code to error */
                        break bl; } /* terminate evaluation */
                      if(is.length()==0) break; /* kein weiterer Eintrag mehr */
                      sst:{ /* break-Block fuer Fehler */
                        if(is.equals("platformstartid")) { /* Definitionstyp: 'PlatformStartID' */
                          if(i!=Integer.MIN_VALUE) { /* Definitionszeile schon vorhanden */
                            Lg.Err("getSrv85","PlatformStartID",c,cB.getStat(true)); /* Fehler melden */
                            ec += 1; /* count error */
                            break sst; } /* terminate evaluation of entry */
                          i = (int)cB.getNV(); /* get value of argument (number) */
                          if((is=cB.getErr())!=null) { /* error while evaluating */
                            Lg.Err("getSrv86","PlatformStartID",i,cB.getStat(true)); /* print errormessage */
                            cc = 53; /* set current return-code to error */
                            break bl; } /* terminate evaluation */
                        } else if(is.equals("distancedownpath")) {
                          /* Definitionstyp: 'DistanceDownPath' */
                          if(!Double.isNaN(d)) { /* Definitionszeile schon vorhanden */
                            Lg.Err("getSrv85","DistanceDownPath",c,cB.getStat(true)); /* Fehler melden */
                            ec += 1; /* Fehler zaehlen */
                            break sst; } /* Bearbeitung des Sub-Eintrags beenden */
                          d = cB.getFV(); /* get value of argument (number) */
                          if((is=cB.getErr())!=null) { /* error while evaluating */
                            Lg.Err("getSrv86","DistanceDownPath",""+d,cB.getStat(true));
                            cc = 54; /* set current return-code to error */
                            break bl; } /* terminate evaluation */
                        } else if(is.equals("skipcount")) { /* Definitionstyp: 'SkipCount' */
                          if(j!=Integer.MIN_VALUE) { /* Definitionszeile schon vorhanden */
                            Lg.Err("getSrv85","SkipCount",c,cB.getStat(true)); /* Fehler melden */
                            ec += 1; /* Fehler zaehlen */
                            break sst; } /* Bearbeitung des Sub-Eintrags beenden */
                          j = (int)cB.getNV(); /* get value of argument (number) */
                          if((is=cB.getErr())!=null) { /* error while evaluating */
                            Lg.Err("getSrv86","SkipCount",j,cB.getStat(true)); /* print errormessage */
                            cc = 55; /* set current return-code to error */
                            break bl; } /* terminate evaluation */
                        } else { /* unknown keyword -- do not process */
                          Lg.Err("getSrv83",is,c,cB.getStat(true)); /* print errormessage */
                          ec += 1; /* count error */
                        } /* unknown keyword found ('break sst' is not needed) */
                      } /* 'sst' - break-block for errors */
                      if(cB.skpFwd()) { /* skip remaining data to new entry -- EOF/error found? */
                        Lg.Err("getSrv84",null,c,cB.getStat(true)); /* errormessage */
                        cc = 23; /* set current return-code to error */
                        break bl; } /* terminate evaluation */
                    } /* -while- alle 'StationStop'-Definitionen bearbeiten */
                    if(i==Integer.MIN_VALUE) { /* Definitionszeile nicht definiert */
                      Lg.Err("getSrv87","PlatformStartID",c,cB.getStat(true)); /* Fehler melden */
                      ec += 1; /* Fehler zaehlen */
                      break tt; } /* Bearbeitung des Sub-Eintrags beenden */
                    if(Double.isNaN(d)) { /* Definitionszeile nicht definiert */
                      Lg.Err("getSrv87","DistanceDownPath",c,cB.getStat(true)); /* Fehler melden */
                      ec += 1; /* Fehler zaehlen */
                      break tt; } /* Bearbeitung des Sub-Eintrags beenden */
                    if(j==Integer.MIN_VALUE) { /* Definitionszeile nicht definiert */
                      Lg.Err("getSrv87","SkipCount",c,cB.getStat(true)); /* Fehler melden */
                      ec += 1; /* Fehler zaehlen */
                      break tt; } /* Bearbeitung des Sub-Eintrags beenden */
                    cStp = new TSStop(i,j,d); /* create 'StationStop'-definition (S) */
                    StpT.add(cStp); /* and add to proper list */
                    c = StpT.size(); /* set new definition-number for errors */
                    cSrv.setMsk(11); /* kennzeichnen, dass min. ein Eintrag gefunden wurde */
                  } else { /* unknown keyword -- do not process */
                    Lg.Err("getSrv63",is,c,cB.getStat(true)); /* print errormessage */
                    ec += 1; /* count error */
                  } /* unknown keyword found ('break tt' is not needed) */
                } /* 'tt' - break-block for errors */
                if(cB.skpFwd(l3)) { /* skip resuming data to new entry -- EOF/error found? */
                  Lg.Err("getSrv64",cB.getStat(true)); /* print errormessage */
                  cc = 23; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
              } /* -while- process all 'TimeTable'-Definitions */
              StpT.trimToSize(); /* reorganize (now filled) table */
              cSrv.setMsk(6); /* kennzeichnen, dass Eintrag korrekt bearbeitet wurde */
            } else { /* unknown keyword -- do not process */
              Lg.Err("getSrv43",is,c,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
            } /* unknown keyword found ('break dtl' is not needed) */
          } /* 'dtl' - break-block for errors */
          /* Wenn die Bearbeitung der Sub-Eintraege durch einen Abbruch beendet wird,
           * liegen bis zu einem neuen Eintrag noch Restzeilen vor, die uebergangen werden
           * muessen. Der naechste Befehl uebergeht alles incl. der schliessenden Klammer
           * des aktuellen Eintrags. */
          if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
            Lg.Err("getSrv44",cB.getStat(true)); /* print errormessage */
            cc = 23; /* set current return-code to error */
            break bl; } /* terminate evaluation */
        } /* -while- alle Definitionen bearbeiten */
        is = cB.getKE(false); /* get next controlword if present */
        if(is==null) { /* error found within current input */
          cc = 10; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()>0) Lg.Err("getSrv25",is,0,cB.getStat(true)); /* print errormsg */
          /* additional data found although NOT expected */
        if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
          cc = 9; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if((j=cSrv.tstMsk(TSSrv.reqMsk))!=0) {
          /* Definitionen fehlen (Speichermaske wird nicht veraendert) */
          is = ""; /* noch kein fehlendes Item */
          cc = -1; /* nicht benutzt -- hier Hilfsvariable */
          for(i=0;i<32;i+=1) { /* alle Definitionen pruefen */
            if(TSOpts.chkMsk(i,TSSrv.reqMsk)) cc += 1; /* naechster Index */
            if(!TSOpts.chkMsk(i,j)) continue; /* nicht gefordert/vorhanden */
            is += "," + TSSrv.reqNme[cc]; /* fehlendes Item */
          } /* alle Definitionszeilen ausgeben */
          Lg.Err("getSrv12",is.substring(1),j,0); /* print errormessage */
          cc = 101; /* aktuellen Condition-Code setzen */
          break bl; } /* Bearbeitung beenden */
        cc = 0; /* keine aktuellen CC */
      } /* -bl- break-block used in case of error */

      is = cF.close(); /* Eingabe-Datei schliessen */
      if(is!=null) Lg.Err("getSrv11",is); /* print errormessage */
      if(cc!=0) Lg.Log("getSrv13",cc); /* Aktionsmeldung */
      else { /* kein Abbruch -- Service-Definition setzen */
        if(ec>0) Lg.Log("getSrv14",ec); /* Aktionsmeldung */
        is = cSrv.getName(false); /* get filename as key */
        if(Srv.put(is,cSrv)!=null) /* store current path-definition */
          Lg.Err("getSrv19",is); /* print errormessage */
        ce += ec; /* add number of errors to 'overall errors' */
      } /* Service-Definition gueltig */
      Lg.Log("getSrv15",cB.getStat(true)); /* Ergebniss der Pruefung ausgeben */
      Lg.Log("getSrv16",c); /* Ergebniss der Pruefung ausgeben */
    } /* -for- read all file-definitions */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("getSrv08",cf); /* Ergebniss der Pruefung ausgeben */
    Lg.Log("getSrv09",ce); /* Ergebniss der Pruefung ausgeben */
    Lg.Skip(false); /* Leerzeile loggen */

    /* --------------------------------------------------- */
    /* load all referenced train-definitions (if possible) */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("getSrvA1",cRte.getInfo(1)); /* print action */

    dir = cRte.getFile(-9); /* reference to train-directory */
    if(dir==null) Lg.Err("getSrvA2"); /* no valid reference found */
    else if(!dir.exists()) { /* train-directory does NOT exist / not found */
      Lg.Err("getSrvA3",dir.getPath()); /* print error */
      dir = null; /* set marker for invalid reference */
    } /* error within train-directory */
    if(dir==null) return -3; /* no load possible -- terminate with marker */

    ec = 0; /* preset: no error(s) found */
    c  = 0; /* preset current number of consist-files */
    SrvI = Srv.values().iterator(); /* create iterator to service-definitions */
    Trn = cRte.getTrain(); /* get/create storage for train-definitions and init */
    while(SrvI.hasNext()) { /* recall ALL service-definitions again */
      cSrv = SrvI.next(); /* get current service-entry */
      if(cSrv==null) throw new IllegalStateException( /* Sicherheitsabfrage */
        TSLogg.getMsg("Msg908","TSSrv==null","TSUtil.getSrv()",0));
      cTrn = cSrv.chgTrn(null); /* get connected train-reference */

      if(Trn.containsKey(is=cTrn.getName(false))) { /* consist is already defined */
        cTrn = Trn.get(is); /* resolve already defined train-definition */
        cTrn.incCnt(1); /* count reference to consist */
        cSrv.chgTrn(cTrn); /* and insert it into current service-definition */
        continue; /* processing complete -- check next entry */
      } /* referenced consist is already defined */
      dat = cTrn.getFile(dir); /* create file-reference to consist */
      if(!dat.exists()) { /* Consist-definition was NOT found */
        Lg.Err("getSrvB1",dat.getName()); /* print error */
        ec += 1; /* and count it */
        /* Attention: Missing train is not a severe error */
        continue; /* processing terminated -- check next entry */
      } /* referenced consist is not found */

      /* referenced consist is available -- load it */
      c += 1; /* count new consist-definition */
      cF = new TSFileX(TSFileX.FT$con,dat); /* create input-control for file */
      is = cF.open(false); /* and open it for input */
      if(is!=null) { /* error occurred while opening file */
        Lg.Err("getSrvB2",is); /* print-termination-message */
        cTrn.setMsk(2); /* mark: train-definition contains error */
        continue; /* processing terminated -- check next entry */
      } /* consist could not be opened for input */
      cB = new TSBuf(cF); /* create inputline and init counter */
      Lg.Log("getSrvB3",dat.getName()); /* print current action */

      l1 = cB.getBrL(); /* current bracket-level for terminate */
      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getSrvB4",cB.getStat(true)); /* print errormessage */
          cTrn.setMsk(2); /* mark: train-definition contains error */
          cF.close(); /* close consist-file again because of error */
          continue; } /* processing terminated -- check next entry */
        Lg.Err("getSrvB5",is,cB.getStat(true)); /* print errormessage */
        cTrn.setMsk(2); /* mark: train-definition contains error */
        cF.close(); /* close consist-file again because of error */
        continue; } /* processing terminated -- check next entry */
      if(!is.equals("train")) { /* master-definition: 'Train' missing */
        Lg.Err("getSrvB6",is,cB.getStat(true)); /* print errormessage */
        ec += 1; /* and count error */
        cTrn.setMsk(2); /* mark: train-definition contains error */
        cF.close(); /* close consist-file again because of error */
        continue; } /* processing terminated -- check next entry */

      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getSrvB7",cB.getStat(true)); /* print errormessage */
          cTrn.setMsk(2); /* mark: train-definition contains error */
          cF.close(); /* close consist-file again because of error */
          continue; } /* processing terminated -- check next entry */
        Lg.Err("getSrvB8",is,cB.getStat(true)); /* print errormessage */
        cTrn.setMsk(2); /* mark: train-definition contains error */
        cF.close(); /* close consist-file again because of error */
        continue; } /* processing terminated -- check next entry */
      if(!is.equals("traincfg")) { /* Definition-type: 'TrainCfg' missing */
        Lg.Err("getSrvB9",is,cB.getStat(true)); /* print errormessage */
        ec += 1; /* and count error */
        cTrn.setMsk(2); /* mark: train-definition contains error */
        cF.close(); /* close consist-file again because of error */
        continue; } /* processing terminated -- check next entry */
      is = cB.getVal(1); /* get value of argument (filename) */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getSrvB7",cB.getStat(true)); /* print errormessage */
          cTrn.setMsk(2); /* mark: train-definition contains error */
          cF.close(); /* close consist-file again because of error */
          continue; } /* processing terminated -- check next entry */
        Lg.Err("getSrvB8",is,cB.getStat(true)); /* print errormessage */
        cTrn.setMsk(2); /* mark: train-definition contains error */
        cF.close(); /* close consist-file again because of error */
        continue; } /* processing terminated -- check next entry */
      if(!is.equalsIgnoreCase(cTrn.getName(true))) { /* filename NOT specified */
        Lg.Err("getSrvBA",is,cTrn.getName(true),cB.getStat(true));
        cTrn.setMsk(2); /* mark: train-definition contains error */
        cF.close(); /* close consist-file again because of error */
        continue; } /* processing terminated -- check next entry */

      i = getTrain(cB,cTrn,ec,TSLogg.getKey("getSrvBB"),
                              TSLogg.getMsg("getSrvBC")); /* read train-definition */
      if(i>0) { /* error discovered within method */
        Lg.Err("getSrvBD",null,i,cB.getStat(true)); /* print errormessage */
        cTrn.setMsk(2); /* mark: train-definition contains error */
        cF.close(); /* close consist-file again because of error */
        continue; } /* processing terminated -- check next entry */
      ec = ((Integer)RetVal).intValue(); /* set new current value */
      /* closing brackets are skipped with next 'cB.skpFwd(lx)'-command */

      /* file is read completely */
      is = cF.close(); /* close input-file for read of consist again */
      if(is!=null) Lg.Err("getSrvB2",is); /* print errormessage */

      cTrn.clrMsk(1); /* reset marker: train-definition is now complete */
      is = cTrn.getName(false); /* get filename as key */
      if(Trn.put(is,cTrn)!=null) /* store current train-definition */
        Lg.Err("getSrvBE",is); /* print errormessage */

    } /* -while- process all Service-Definitions */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("getSrvA8",c); /* print count of consists */
    Lg.Log("getSrvA9",ec); /* print count of errors (all consists) */
    Lg.Skip(false); /* Leerzeile loggen */

    return 0; /* program ended (successfully) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkSrv"
  * Service-Definitionen einer Route pruefen und Referenzen erzeugen
  * ##chkSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chkSrv( /* Service-Definitionen bearbeiten */
   TSRoute cRte, /* Routendefinition mit Basisverzeichnis */
   boolean chg)  /* correct/remove invalid definition */
   {
   /*-----------------------------------------------------------------*/
    Iterator<TSSrv>        SrvI;  /* Iterator for Service-Definitions */
    TSSrv                  cSrv;  /* aktuelle Service-Definition */
    TSPath                 cPth;  /* aktuelle Pfad-Definition */
    TSTrItm                cIt;   /* aktuelles TrItem-Element */
    TreeMap<String,TSPath> Pth;   /* Liste der Pfad-Definitionen */
    String                 is,js;
    long                   cDate,vDate; /* current Date (state) of service */
    int                    ix,c,ec,sk,r; /* intermediate values */
    double                 d;     /* Distance-check */
    Iterator<TSStop>       StpI;  /* Iterator for 'StationStop'-entries */
    ArrayList<TSStop>      StpT;  /* List of 'StationStop'-Definitions */
    TSStop                 cStp;  /* current 'StationStop' */
    Iterator<TSAct>        ActI;  /* iterator for all activity-definitions' */
    TSAct                  cAct;  /* current Activity-Definition */
    Iterator<TSTrf>        TrfI;  /* Iterator for Traffic-Definitions */
    TSTrf                  cTrf;  /* aktuelle Traffic-Definition */
    TSTrain                cTrn;  /* current reference to train */
    ArrayList<TSStStp>     HltT,HltT1;  /* extended 'StationStop'-entries */
    TSStStp                cHlt;  /* current extended 'StationStop'-entry */
    TSWrld                 cUid;  /* current world-object (TSPlatform) */
   /*=================================================================*/
    SrvI = cRte.getIt(18); /* Liste der Service-Definitionen holen */
    if(SrvI==null) return -1; /* Service-Definitionen sind nicht geladen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("chkSrv01",cRte.getInfo(1)); /* Aktionsmeldung ausgeben */

    ec = 0; /* noch kein Fehler erkannt */
    c  = 0; /* initialize definition-counter */
    r  = 0; /* initialize replacement-counter */
    Pth = cRte.getPath(); /* Liste der Pfad-Definitionen vorab holen */
    while(SrvI.hasNext()) { /* Weitere Service-Definition vorhanden */
      cSrv = SrvI.next(); /* Service-Eintrag holen */
      if(cSrv==null) throw new IllegalStateException( /* Sicherheitsabfrage */
        TSLogg.getMsg("Msg908","TSSrv==null","TSUtil.chkSrv()",0));
      js = cSrv.getName(true); /* Namen der Service-Datei holen */
      c += 1; /* Service-Definition zaehlen */
      Lg.Log("chkSrv05",js,c); /* Aktion melden */

      if(!cSrv.chkMsk(0)) { /* Serial-Nummer nicht spezifiziert */
        if(EnaW) Lg.Log("chkSrv14"); /* Aktion melden */
        cSrv.setInt(0,0); /* Serial-Nummer '0' einsetzen (TSData) */
        cSrv.setMsk(0); /* kennzeichnen, dass Eintrag nun gueltig ist */
      } /* Serial-Nummer nicht angegeben */

      cTrn = cSrv.chgTrn(null); /* get connected consist-definition */
      if(cTrn.chkMsk(1)) { /* consist-definition does not exist */
        Lg.Err("chkSrv11",cTrn.getName(true)); /* print error */
        ec += 1; /* count error */
      } /* Consist-definition is not available */

      is = cSrv.chgPNme(null); /* zugeordnete Pfad-Definition holen */
      if(is==null) { /* Pfad-Definition ist nicht vorhanden */
        Lg.Err("chkSrv12"); /* Fehler melden */
        ec += 1; /* Fehler zaehlen */
        cSrv.setMsk(16); /* Fehlerkennzeichen fuer diesen Service setzen */
      } else { /* Nach Referenz fuer Definition suchen */
        cPth = Pth.get(is.toLowerCase()); /* Pfad-Definition aus Liste holen */
        if(cPth==null) { /* Pfad-Definition wurde NICHT gefunden */
          Lg.Err("chkSrv13",is); /* Fehler melden */
          ec += 1; /* Fehler zaehlen */
          cSrv.orMsk(0x70000); /* Kennzeichen: Service (16) und Pfad (17) setzen */
            /* additional: Path not found (18) is set too. */
        } else { /* gefunden -- Eintrag registrieren */
          cSrv.chgPat(cPth); /* Pfad-Referenz eintragen */
          cPth.incCnt(1); /* Referenz zaehlen */
          if(cPth.chkMsk(16)) cSrv.orMsk(0x30000); /* Fehlerkennzeichen setzen */
            /* Kennzeichen: Service (16) und Pfad fehlerhaft (17) setzen */
//          cPth.setFlag(ix=cPth.setFlag(0)); /* Flag-Definition des Pfades holen */
//          if(TSOpts.chkMsk(5,ix)) cSrv.setMsk(24); /* Flag-Definition pruefen */
          if(cPth.chkMsk(5)) cSrv.setMsk(24); /* Flag-Definition des Pfades pruefen */
            /* (beliebige) Flags vorhanden -- Pfad vom Spieler nicht befahrbar */
        } /* Pfad-Definition bearbeitet */
      } /* Pfad-Definition war im Service eingetragen */

      /* compare file-dates to see if NEWER service-versions exist.
       *   try with 'traffic' first!
       */
      vDate = cSrv.chkDate(Long.MIN_VALUE); /* get current Date for compare */
      HltT = null; /* set marker: no valid newer definition found */
      is = cSrv.getName(false); /* get file-name of the service-file (key-version) */
      sk = 0; /* set source-marker to 'Traffic' */
      TrfI = cRte.getIt(19); /* get list of all traffic-definitions */
      if(TrfI!=null) { /* traffic-definitions are available -- check them */
        while(TrfI.hasNext()) { /* Weitere 'Traffic'-Definition vorhanden */
          cTrf = TrfI.next(); /* Traffic-Eintrag holen */
          if(cTrf==null) continue; /* not found -- do not check */
          if((cDate=cTrf.chkDate(vDate))<=0) continue; /* traffic-definition is older */
          if((HltT1=cTrf.fndSrv(is))==null) continue; /* service NOT included */
          HltT = HltT1; /* valid list found, save it */
          vDate = cDate; /* update file-date, too */
        } /* -while- all Traffic-definitions were checked */
      } /* Traffic-Definitions were available */
      /* second: try using services within activity-definitions */
      ActI = cRte.getIt(16); /* get list of activity-definitions */
      if(ActI!=null) { /* activity-definitions are available -- check them */
        while(ActI.hasNext()) { /* other activity-definitions available ? */
          cAct = ActI.next(); /* get next Activity-entry */
          if(cAct==null) continue; /* not found -- do not check */
          if((cDate=cAct.chkDate(vDate))<=0) continue; /* activity-definition is older */
          if((HltT1=cAct.fndSrv(is))==null) continue; /* service NOT included */
          HltT = HltT1; /* valid list found, save it */
          vDate = cDate; /* update file-date, too */
          sk = 1; /* set source-marker to 'Activity' */
        } /* -while- process all activity-definitions */
      } /* activity-definitions are available */
      StpT = cSrv.getStp(0); /* get current List of Stationstops (preset) */
      if(HltT!=null) ck:{ /* newer service-definition found -- replace it? */
        /* definiton must only be replaced if it differs from original definition */
        if(HltT.size()==StpT.size()) ckok:{ /* if not equal -- definitons differ in every case */
          for(ix=0;ix<HltT.size();ix+=1) { /* process all StationStop's of new service */
//            cHlt = HltT.get(ix); /* get next entry */
//            cStp = StpT.get(ix); /* get next 'StationStop'-entry */
//            if(cHlt.chkSkip(0)!=cStp.chkSkip(0)) break ckok; /* different -- stop compare */
            if(HltT.get(ix).chkSkip(0)!=StpT.get(ix).chkSkip(0)) break ckok; /* different -- stop compare */
          } /* for- process all StationStops */
          break ck; /* both definitions do NOT differ -- do not replace */
        } /* -ckok- definitions differ (in every case) */

        cDate = cSrv.chkDate(Long.MIN_VALUE); /* get original Date for message */
        Lg.Log("chkSrv20",sk==0?"Traffic":"Activity",getDate(cDate,false),getDate(vDate,false));
        StpT = cSrv.getStp(HltT.size()); /* create new List of Stationstops */
        /* Attention: If new list contains NO ENTRIES (size()==0) nothing is changed and
         * the old list of StationStop's remain intact. */
        for(ix=0;ix<HltT.size();ix+=1) { /* process all StationStop's of new service */
          cHlt = HltT.get(ix); /* get next entry */
          if(cHlt==null) continue; /* entry not available -- skip it */
          cStp = cHlt.crSrv(); /* create service-version of 'StationStop'-entry */
          StpT.add(cStp); /* and add it to list of Stops */
        } /* for- process all StationStops */
        r += 1; /* count replacement of StationStop-definitions */
      } /* -ck- newer service-definition found -- replace it if different */

      /* 'StpT' contains current/new list of Stationstops */
      sk = 0; /* initialize Skip-Count; value starts with '0' */
        /* FIRST 'Skipcount(0)' is accepted! (-0 is not negative) */
      for(ix=0;ix<StpT.size();ix+=1) { /* process all 'StationStop'-entries */
        cStp = StpT.get(ix); /* get next 'StationStop'-entry */
        if(cStp==null) throw new IllegalStateException(
          TSLogg.getMsg("Msg908","TSStStp==null","TSUtil.chkSrv()",0));
        sk = cStp.chkSkip(sk); /* check Skip-Count (greater?) */
        if(sk<0) { /* error within sequence of skipcount-values */
          sk = -sk; /* clear error-marker */
          Lg.Err("chkSrv21",null,sk,ix); /* print error-message */
          ec += 1; /* and count error */
          cSrv.setMsk(19); /* mark error and initate 'sort' of entries */
        }  /* error within sequence of skipcount-values */
      } /* -for- process all 'StationStop'-definitions */
      if(cSrv.chkMsk(19)) { /* error in order found -- sort entries */
        Collections.sort(StpT); /* sort all definitions */
        Lg.Err("chkSrv22"); /* print error-message */
      } /* sorting-error is corrected */

      ix = -1; /* initialize Index-Number (FIRST VALID index becomes 0) (again) */
      d = 0.0; /* path starts with pathlength '0' */
      StpI = StpT.iterator(); /* again create iterator for all entries */
      while(StpI.hasNext()) { /* more 'StationStop'-entries available? */
        cStp = StpI.next(); /* get next 'StationStop'-entry */
        ix += 1; /* compute correct index-number */
        d = cStp.chkDist(d); /* check path-distance */
        if(d<0.0) { /* error within distance-value */
          d = -d; /* clear error-marker */
          Lg.Err("chkSrv23",""+d,ix); /* print error-message */
          ec += 1; /* and count error */
          cSrv.setMsk(20); /* set marker: 'StationStop'definition contains error */
        }  /* error within distance-value for 'StationStop' */
        cIt = cStp.fndTrI(cRte); /* search for platform and connect it */
        sk = ((Integer)RetVal).intValue(); /* get current platform-number */
        if(cIt==null) { /* no platform-connection found */
          Lg.Err("chkSrv24",null,sk,ix); /* print error-message */
          ec += 1; /* and count error */
          cSrv.setMsk(20); /* set marker: 'StationStop'definition contains error */
          if(chg) { /* modify/correct/delete service-definition */
            StpI.remove(); /* service-def. contains severe error -- delete it */
            continue; /* no more checking neccessary */
          } /* error within Service-definition */
          cSrv.setMsk(16); /* set marker: service contain(s) error(s) */
          continue; /* remaining checks DO NOT apply */
        } /* error within platform-definition of 'StationStop' */
        if(cIt.getTyp()!=2) { /* Item ist NOT a platform-definition */
          Lg.Err("chkSrv25",cIt.getName(),sk,ix); /* print error-message */
          ec += 1; /* and count error */
          cSrv.setMsk(20); /* set marker: 'StationStop'definition contains error */
          if(chg) { /* modify/correct/delete service-definition */
            StpI.remove(); /* service-def. contains severe error -- delete it */
            continue; /* no more checking neccessary */
          } /* error within Service-definition */
          cSrv.setMsk(16); /* set marker: service contain(s) error(s) */
        }  /* error: Item ist NOT a platform-definition */
        if(cIt.chkMsk(0)) { /* Item is no longer valid */
          Lg.Err("chkSrv27",cIt.getName(),sk,ix); /* print error-message */
          ec += 1; /* and count error */
          cSrv.setMsk(20); /* set marker: 'StationStop'definition contains error */
          if(chg) { /* modify/correct/delete service-definition */
            StpI.remove(); /* service-def. contains severe error -- delete it */
            continue; /* no more checking neccessary */
          } /* error within Service-definition */
          cSrv.setMsk(16); /* set marker: service contain(s) error(s) */
        } /* error within platformItem-definition of 'StationStop' */
        if(cIt.chkMsk(1) || cIt.incCnt(0)==0) { /* Item contains error */
          Lg.Err("chkSrv26",cIt.getName(),sk,ix); /* print error-message */
          ec += 1; /* and count error */
          cSrv.setMsk(20); /* set marker: 'StationStop'definition contains error */
        } /* error within platformItem-definition of 'StationStop' */
      } /* -while- process all 'StationStop'-definitions */
    } /* process all Service-Definitions */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("chkSrv06",c); /* print result of the examination */
    Lg.Log("chkSrv07",r); /* print result of the examination */
    Lg.Log("chkSrv08",ec); /* print result of the examination */
    Lg.Skip(false); /* Leerzeile loggen */

    return 0; /* Programm (erfolgreich) beendet */
  }

 /**. <pre>
  *=====================================================================
  * Method "putSrvF"
  * Write all service-definitions of a route
  * Prime-number-options used with 'opt':
  *       2 - create files without errors ONLY
  *       3 - 'noreplace' - Service must not already exist
  * ##putSrvF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int putSrvF( /* write service-definitions */
   TSRoute cRte, /* current route-definition */
   File    tdat, /* definition of the temporary file (overwrite) */
   int     opt)  /* options (coded using prime-numbers) */
   {
   /*-----------------------------------------------------------------*/
    File              dats,datz,dirS,dirT; /* temporary files */
    TSFileX           cF;    /* current output-file (control) */
    TSSrv             cSrv;  /* current service-definition */
    String            is,js; /* intermediate values */
    int               i,ec,cc; /* intermediate values */
    int               ce,cf; /* intermediate values */
    Iterator<TSSrv>   cI;    /* Iterator for Service-definitions */
    Iterator<String>  LneI;  /* Line-Iterator for output */
    ArrayList<String> LneT;  /* Line-Table for output */
   /*=================================================================*/
    cI = cRte.getIt(18); /* get list of service-definitions */
    if(cI==null) return -1; /* Service-definitons are NOT available */

    Lg.Skip(true); /* print empty line to LOG-file and screen */
    /* check if target-directory of service-definitions exist */
    dirT = null; /* compiler needs it */
    if(tdat==null) { /* temporary file is NOT used */
      dirT = cRte.getFile(43); /* get target-directory */
      if(dirT==null) { /* folder NOT available -- terminate */
        Lg.Skip(true); /* print empty line to LOG-file and screen */
        Lg.Msg("MsgC63",cRte.getInfo(43)); /* print message: terminating */
        Lg.Msg("putSrv01"); /* print errormessage */
        Lg.Close(); /* close output to Log-file */
        return 25; } /* terminate function with errorcode */
    } /* target-directory used for output */
    dirS = cRte.getFile(13); /* get file-reference of source-directory */

    Lg.Msg("putSrv02",cRte.getInfo(1)); /* print description of next action */

    ce = 0; /* init error-counter */
    cf = 0; /* init number of definition-files */
    LneT = new ArrayList<String>(25); /* create table for output-line-blocks */
      /* This list is normally empty. After it was filled with output-lines
       * and all lines have been processed, it MUST be cleared again. */
    while(cI.hasNext()) { /* more service-definitions to process */
      cSrv = cI.next(); /* get next service-entry */
      if(cSrv==null) throw new IllegalStateException( /* security-query */
        TSLogg.getMsg("Msg908","TSSrv==null","TSUtil.putSrvF()",0));
      is = cSrv.getName(true); /* get unmodified name of service-file */
      if(is==null) continue;  /* file is missing -- do not process */

      dats = new File(dirS,is); /* create Source-Reference (for copy/delete) */
      if(cSrv.chkMsk(16) && (opt%2)==0) { /* service-def. has error(s) -- do not write */
        Lg.Err("putSrv04",is); /* print message: terminating */
        if(tdat==null) continue; /* do not write service-definition */
        dats.delete(); /* overwrite-mode: delete faulty file (inplace) */
        Lg.Log("putSrv15",dats.getAbsolutePath()); /* print message */
        continue; /* service-definition was deleted */
      } /* service-definition contained error(s) */
      Lg.Log("putSrv03",is); /* print description of action */

      if(tdat!=null) datz = tdat; /* preset: use temporary file */
      else { /* full target-reference is needed otherwise */
        datz = new File(dirT,is); /* create full target-reference */
        if((opt%3)==0 && datz.exists()) { /* service-file already exist? */
          Lg.Err("putSrv05",is); /* print message: terminating */
          continue; /* do not write service-definition */
        } /* service-definition already exist */
      }  /* full target-reference is needed */

      /* open service-file for output */
      cF = new TSFileX(TSFileX.FT$srv,datz); /* create output-control */
      is = cF.open(true); /* set sub-id and open file */
      if(is!=null) { /* error occurred while opening */
        Lg.Err("putSrv11",is); /* print message: terminating */
        continue; /* process next service-file */
      } /* error occurred while opening */
      cf += 1; /* count valid service-definition */

      ec = 0; /* Zaehler fuer Fehler initialisieren */
      bl: { /* block for error-break */
        cc = 10; /* preset position of error */
        is = "Service_Definition ("; /* set first line of file */
        if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
        LneI = cSrv.crDef(LneT,"\t"); /* create output-lines */
        if(LneI==null) { cc = 0; break bl;} /* no valid output-lines -- do not write */
        i = 0; /* initialize line-counter */
        while(LneI.hasNext()) { /* more output-lines available ? */
          is = LneI.next(); /* get next output-line */
          if(is==null) continue; /* dummy line -- do not write */
          i += 1; /* increment counter to next line */
          /* Attention: A output-line must start with '\t' or it is
           * considered as an error-message */
          if(is.charAt(0)!='\t') { /* got error-message instead of output-line */
            Lg.Err("putSrv12",is,i); /* print error-message */
            ec += 1; /* and count error */
          } else { /* NO error-message --write it */
            cc += 1; /* advance to next error-position */
            if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
          } /* output-line processed */
        } /* -while- process all output-lines */
        LneT.clear(); /* all lines written -- delete them */
        cc = 38; /* preset position of error */
        if((is=cF.putData(")"))!=null) break bl; /* Schreib-Fehler */
        cc = 39; /* preset position of error */
        is = TSLogg.getMsg("Msg100","Service"); /* create TSUtil-ID-Line */
        if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
        cc = 0; /* kein Fehler aufgetreten */
      } /* -bl- break-block used in case of error */
      if(is!=null) { /* Meldung steht noch aus */
        Lg.Err("putSrv11",is); /* Meldung ausgeben */
        ec += 1; /* Fehler zaehlen */
      } /* Meldung musste noch ausgegeben werden */
      is = cF.close(); /* Ausgabe-Datei schliessen */
      if(is!=null) Lg.Err("putSrv06",is); /* Meldung ausgeben */
      if(cc!=0) Lg.Err("putSrv16",cc); /* Aktionsmeldung */
      else if(ec>0) Lg.Log("putSrv17",ec); /* Aktionsmeldung */

      Lg.Log("putSrv18",cF.getStat(true)); /* print number of entries */
//      Lg.Log("putSrv19",cF.getStat(false)); /* print file-length */
      ce += ec; /* count overall number of errors */

      /* copy back result to path-file(source) if overwrite requested */
      cc += ec; /* compute error-threshold */
      if(tdat!=null) { /* overwrite of original file is requested */
        if(cc>0) cf -= 1; /* error --do not copy file */
          /* if an error occured the original file is NOT changed */
        else { /* copy target-file and overwrite original file */
          is = dats.getAbsolutePath(); /* name of source-file */
          js = "copy \""+tdat.getAbsolutePath()+"\" \""+is+"\" ";
            /* create copy-command */
          if((i=exec(true,js,null,Lg))>0) /* error during execute */
            Lg.Log("MsgC49",is,i); /* print errormessage */
        } /* original file (source) was overwritten */
      } else if(cc>0 && (opt%2)==0) { /* error -- delete file again */
        datz.delete(); /* delete created file due to error(s) */
        is = datz.getAbsolutePath(); /* name of target-file */
        Lg.Msg("putSrv07",is); /* print errormessage */
        cf -= 1; /* path-file is NOT created */
      } /* new target-file has been deleted again */
    } /* -while- write ALL service-definitions */

    Lg.Skip(false); /* print empty line to LOG-file */
    Lg.Log("putSrv08",cf); /* print number of service-files */
    Lg.Log("putSrv09",ce); /* print number of overall errors */
    Lg.Skip(false); /* print empty line to LOG-file */

    return 0; /* terminate program (successfully) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkCon"
  * Check consist-definitions
  * ##chkCon (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chkCon( /* process consist-definitions */
   TSRoute cRte) /* reference to route-definition */
   {
   /*-----------------------------------------------------------------*/
    File              dirT,dat; /* file-references */
    Iterator<TSTrain> TrnI;  /* Iterator for train-definitions */
    TSTrain           cTrn;  /* current reference to train */
    ArrayList<TSRefC> RefT;  /* current 'RefC'-object-table */
    TSRefC            cRef;  /* current reference-element */
    String            is;    /* intermediate values */
    int               c,ec,r,i,j,k; /* intermediate values */
   /*=================================================================*/
    TrnI = cRte.getIt(26); /* get list of consist-definitions */
    if(TrnI==null) return -1; /* error: consist-definitions not avail */

    Lg.Skip(true); /* skip one line and log it */
    Lg.Msg("chkCon01",cRte.getInfo(1)); /* print next action */

    dirT = cRte.getFile(-8); /* get reference to train-directory */
    if(dirT==null) { /* no directory acessible */
      Lg.Msg("chkCon02"); /* print error and terminate */
      return -1; /* return with error-marker */
    } /* no train-folder found */
    if(!dirT.exists()) { /* train-folder not available */
      Lg.Msg("chkCon03",dirT.getPath()); /* print error and terminate */
      return -2; /* return with error-marker */
    } /* requested train-folder not found */

    ec = 0; /* no error registered */
    c  = 0; /* initialize definition-counter */
    r  = 0; /* initialize replacement-counter */
    while(TrnI.hasNext()) { /* more consist-definitions available ? */
      cTrn = TrnI.next(); /* get next consist-definition */
      if(cTrn==null) throw new IllegalStateException( /* security-check */
        TSLogg.getMsg("Msg908","TSTrn==null","TSUtil.chkCon()",0));
      if(cTrn.chkMsk(0)) continue; /* static one is already checked */

      is = cTrn.getName(true); /* resolve name of the consist-file */
      c += 1; /* count number of (different) consist-definitions */
      Lg.Log("chkCon05",is,c); /* print current action */

      Lg.Log("chkCon06",cTrn.incCnt(0)); /* print information */

      if(cTrn.chkMsk(2)) Lg.Err("chkCon10"); /* print errormessage */

      if(!cTrn.chkMsk(21)) Lg.Err("chkCon11"); /* print errormessage */
      if(!cTrn.chkMsk(22)) Lg.Err("chkCon12"); /* print errormessage */
      if(!cTrn.chkMsk(23)) Lg.Err("chkCon13"); /* print errormessage */
      if(!cTrn.chkMsk(24)) Lg.Err("chkCon14"); /* print errormessage */

      RefT = cTrn.getTObjT(0); /* get list of engines/waggons */
      if(RefT==null) throw new IllegalStateException( /* integrity-error */
        TSLogg.getMsg("Msg908","Train.TOT==null","TSUtil.chkCon()",0));
      j = RefT.size(); /* get number of Train-objects */
      for(i=0;i<j;i+=1) { /* more definitions available ? */
        cRef = RefT.get(i); /* get next 'RefC'-entry */
        if((k=cRef.chgNr(Integer.MIN_VALUE))!=i) { /* UID must be changed */
          ec += 1; /* count error */
          if(EnaH) Lg.Log("chkCon21",""+i,k); /* print errormessage */
          cRef.chgNr(i); /* insert new UID-value */
          r += 1; /* entry was changed */
        } /* UID processed and possibly changed */
        dat = TSTrain.getPath(cRef,dirT); /* get reference to train-object */
        if(dat==null) { /* reference to train-object not found */
          ec += 1; /* count error */
          Lg.Err("chkCon22",i); /* print errormessage */
        } else if(!dat.exists()) { /* train-object NOT available */
          ec += 1; /* count error */
          Lg.Err("chkCon23",dat.getAbsolutePath(),i); /* print errormessage */
        } /* UID processed and possibly changed */
      } /* -for- process all 'RefC'-definitions */
      i = cTrn.getInt(1); /* get current value for 'NextWagonUID' */
      if(i!=j) { /* value is NOT correct -- replace it */
        ec += 1; /* count error */
        if(EnaH) Lg.Log("chkCon24",""+i,j); /* print errormessage */
        cTrn.setInt(1,j); /* insert new, correct value */
        r += 1; /* entry was changed */
      } /* value for 'NextWagonUID' processed */
    } /* process all consist-Definitions */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("chkCon07",c); /* print result of the examination */
    Lg.Log("chkCon08",r); /* print result of the examination */
    Lg.Log("chkCon09",ec); /* print result of the examination */
    Lg.Skip(false); /* Leerzeile loggen */

    return 0; /* terminate program sucessfully */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTrfF"
  * alle Traffic-Definitionen einer Route laden
  * ##getTrfF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getTrfF( /* Traffic-Definitionen laden */
   TSRoute cRte, /* Routendefinition mit Basisverzeichnis */
   boolean nocr) /* do not create directory if not available */
   {
   /*-----------------------------------------------------------------*/
    File                  dir,dat;  /* temporaere Dateiliste */
    TSFileX               cF;    /* aktuelle Eingabe-Datei */
    TSFleMask             cM;    /* current file-mask */
    TSBuf                 cB;    /* current input-buffer 'read file' */
    TreeMap<String,TSTrf> Trf;   /* Instanz fuer Traffic-Definitionen */
    TSTrf                 cTrf;  /* aktuelle Traffic-Definition */
    ArrayList<TSXtSrv>    SrvT;  /* Table of (ext.) service-definitions */
    TSXtSrv               cSrv;  /* current extended service */
    ArrayList<TSStStp>    StpT;  /* Traffic-'StationStop'-Tab (Typ T) */
    TSStStp               cStp;  /* current 'StationStop'-definition */
    String                is;    /* intermediate values */
    String[]              fl;    /* Dateiliste */
    int                   i,c,l1,l2; /* intermediate values */
    int                   ec,cc,cf,ce; /* intermediate values */
   /*=================================================================*/
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("getTrf01",cRte.getInfo(1)); /* Aktionsmeldung ausgeben */

    dir = cRte.getFile(14); /* File-Referenz fuer Verzeichnis */
    if(dir==null) { /* Keine Verzeichnis-Definition erstellbar */
      Lg.Msg("getTrf03"); /* Fehler melden --  Bearbeitung abbrechen */
      Lg.Close(); /* close output to Log-file */
      return 11; /* terminate function with errorcode */
    } /* Datei existiert nicht */
    if(!dir.exists()) { /* Verzeichnis nicht gefunden */
      Lg.Msg("getTrf04",dir.getPath()); /* Fehler melden */
      if(nocr) return -1; /* terminate function with marker */
      if(!dir.mkdirs()) Lg.Msg("getTrf08"); /* print message */
        /* try to create folder and print error if unsuccessful-- error? */
      return -2; /* terminate function with marker */
    } /* Datei existiert nicht */
    cM = new TSFleMask(false,".*\\.trf"); /* select traffic-files */
    if((is=cM.getErr())!=null) { /* error within file-mask */
      Lg.Skip(false); /* print empty line to LOG-file */
      Lg.Msg("getTrf11",is); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* error found -- function terminated */
    fl = dir.list((FilenameFilter)cM); /* create list of ALL files */
      /* result contains NO directories! */
    if(fl==null) { /* Source-ist kein Verzeichnis */
      Lg.Msg("getTrf05",dir.getPath()); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 11; /* terminate function with errorcode */
    } /* Datei existiert nicht */

    cf = ce = 0; /* init file-counter, overall errors */
    Trf = cRte.getTrf(); /* Service-Speicher erstellen und init */
    for(String fn:fl) { /* process all selected file-definitions */
      dat = new File(dir,fn); /* create file-reference (source) */
      cf += 1; /* and count path-file */
      Lg.Log("MsgC54",dat.getAbsolutePath(),DF3.format(cf));

      /* Eingabe-Datei oeffnen */
      cF = new TSFileX(TSFileX.FT$trf,dat); /* Eingabe-Steuerung erstellen */
      is = cF.open(false); /* Datei fuer Eingabe oeffnen */
      if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
        Lg.Err("getTrf11",is); /* Abbruchmeldung ausgeben */
        continue; /* naechste Datei bearbeiten */
      } /* Fehler beim Oeffnen der Datei */
      cB = new TSBuf(cF); /* create inputline and init counter */

      cTrf = new TSTrf(fn,dat); /* create traffic-entry (Basis) */

      /* Initialisierungen auf Grund von Compiler-Warnings */
      cc = 0;
      ec = 0; /* noch kein Fehler erkannt */
      bl: { /* block for error-break */
        is = cB.getKE(true); /* get first controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getTrf21"); /* print errormessage */
            cc = 5; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getTrf22",is); /* print errormessage */
          cc = 6; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) { /* next keword not present */
          Lg.Err("getTrf23"); /* print errormessage */
          cc = 7; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(!is.equals("traffic_definition")) { /* kein Eintrag 'Traffic_Definition' */
          Lg.Err("getTrf24",is); /* Fehlermeldung ausgeben */
          cc = 8; /* aktuellen Condition-Code setzen */
          break bl; } /* Bearbeitung beenden */
        l1 = cB.getBrL(); /* current bracket-level for terminate */

        is = cB.getVal(1); /* get value of argument */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getTrf25",cB.getStat(true)); /* print errormessage */
            cc = 9; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getTrf26",is,0,cB.getStat(true)); /* print errormessage */
          cc = 10; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) { /* next keword not present */
          Lg.Err("getTrf27",cB.getStat(true)); /* print errormessage */
          cc = 11; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        cTrf.chgNme(is); /* Name in Objekt eintragen */

        c  = 0; /* laufende Nummer fuer Traffic-Service-Eintrag (0..) */
        SrvT = cTrf.getSrv(25); /* create and get new service-table */
        while(true) { /* alle weiteren Definitions-Saetze lesen */
          is = cB.getKE(true); /* get next controlword */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getTrf31"); /* print errormessage */
              cc = 31; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getTrf32",is); /* print errormessage */
            cc = 32; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          if(is.length()==0) break; /* kein weiterer Eintrag mehr */
          l2 = cB.getBrL(); /* current bracket-level for terminate */
          dtl:{ /* break-Block fuer Fehler */
            if(is.equals("serial")) { /* Entry 'Serial' found */
              if((i=cTrf.getInt(0))!=Integer.MIN_VALUE) { /* Wert ist schon gesetzt */
                Lg.Err("getTrf41",null,i,c0); /* Fehlermeldung ausgeben */
                ec += 1; /* Fehler zaehlen */
                break dtl; } /* Bearbeitung des Eintrags beenden */
              i = (int)cB.getNV(); /* get Serial-Nummer */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getTrf42",is,cB.getStat(true)); /* print errormessage */
                cc = 25; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<1) { /* invalid value for 'Serial' */
                Lg.Err("getTrf43",null,i,cB.getStat(true)); /* print errormessage */
                cc = 26; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              cTrf.setInt(0,i); /* Serial-Nummer einsetzen (TSData) */
            } else if(is.equals("service_definition")) { /* Def-typ: 'Service_Definition' */
              is = cB.getVal(1); /* get value of argument */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getTrf44",null,c,cB.getStat(true)); /* print errormessage */
                  cc = 33; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getTrf45",is,c,cB.getStat(true)); /* print errormessage */
                cc = 34; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(is.length()==0) { /* next keword not present */
                Lg.Err("getTrf46",null,c,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                break dtl; } /* terminate evaluation of entry */
              cSrv = new TSXtSrv(is); /* Service-Definition fuer Traffic erstellen */
              i = (int)cB.getNV(); /* get value of argument (number) */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getTrf47",""+i,c,cB.getStat(true)); /* print errormessage */
                cc = 35; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0 || i>=86400) { /* time-value invalid (60*60*24=86400) */
                Lg.Err("getTrf48",""+i,c,cB.getStat(true)); /* print errormessage */
                ec += 1; /* count error */
                i = Integer.MIN_VALUE; /* Kennzeichen: Wert ungueltig */
                break dtl; } /* terminate evaluation of entry */
              if(cSrv.setTime(i)) throw new /* Abbruch mit Systemfehler */
                IllegalStateException(TSLogg.getMsg("Msg904","TSXtSrv.setTime()"));

              /* Service-Definition erstellt -- Haltepunkte einlesen */
              StpT = cSrv.getStp(20); /* Haltepunkt-Tabelle anlegen und liefern */
              i = getTrfDef(cB,StpT,ec,TSLogg.getMsg("getTrf50",c)); /* get Traffic-Definitions */
              if(i>0) { /* error within procedure */
                cc = 40 + i; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              ec = ((Integer)RetVal).intValue(); /* set new current value */
              StpT.trimToSize(); /* all entries inserted -- reorganize table */

              /* Traffic-Service was created correctly -- register it */
              SrvT.add(cSrv); /* add valid service-definition to table */
              c = SrvT.size(); /* and set new index from 'number of entries' */
            } else { /* unknown keyword -- do not process */
              Lg.Err("getTrf33",is,c,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
            } /* unknown keyword found ('break dtl' is not needed) */
          } /* 'dtl' - break-block for errors */
          /* Wenn die Bearbeitung der Sub-Eintraege durch einen Abbruch beendet wird,
           * liegen bis zu einem neuen Eintrag noch Restzeilen vor, die uebergangen werden
           * muessen. Der naechste Befehl uebergeht alles incl. der schliessenden Klammer
           * des aktuellen Eintrags. */
          if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
            Lg.Err("getTrf49",null,c,cB.getStat(true)); /* print errormessage */
            cc = 28; /* set current return-code to error */
            break bl; } /* terminate evaluation */
        } /* -while- process all Definitions */
        SrvT.trimToSize(); /* all entries inserted -- reorganize table */
        is = cB.getKE(false); /* get next controlword if present */
        if(is==null) { /* error found within current input */
          cc = 13; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()>0) Lg.Err("getTrf28",is,0,cB.getStat(true));
          /* additional data found although NOT expected */
        if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
          cc = 12; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(cTrf.getInt(0)==Integer.MIN_VALUE) { /* Wert ist NICHT gesetzt */
          if(EnaW) Lg.Log("getTrf34",cB.getStat(true)); /* (Fehler)-Meldung ausgeben */
          cTrf.setInt(0,0); /* Serial-Nummer (Default) einsetzen (TSData) */
        } /* Bearbeitung des Eintrags beenden */
        cc = 0; /* keine aktuellen CC */
      } /* -bl- break-block used in case of error */

      is = cF.close(); /* Eingabe-Datei schliessen */
      if(is!=null) Lg.Err("getTrf11",is); /* Meldung ausgeben */
      if(cc!=0) Lg.Log("getTrf13",cc); /* Aktionsmeldung */
      else { /* kein Abbruch -- Traffic-Definition setzen */
        if(ec>0) Lg.Log("getTrf14",ec); /* Aktionsmeldung */
        is = cTrf.getName(false); /* get filename as key */
        if(Trf.put(is,cTrf)!=null) /* store current traffic-definition */
          Lg.Err("getTrf19",is); /* print errormessage */
        ce += ec; /* add number of errors to 'overall errors' */
      } /* Service-Definition gueltig */
      Lg.Log("getTrf15",cB.getStat(true)); /* Ergebniss der Pruefung ausgeben */
    } /* -while- process all trafficfile-definitions */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("getTrf06",cf); /* Ergebniss der Pruefung ausgeben */
    Lg.Log("getTrf07",ce); /* Ergebniss der Pruefung ausgeben */
    Lg.Skip(false); /* Leerzeile loggen */

    return 0; /* Programm (erfolgreich) beendet */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkTrf"
  * Traffic-Definitionen einer Route pruefen und Referenzen erzeugen
  * ##chkTrf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chkTrf( /* check all traffic-definitions */
   TSRoute cRte, /* current route-definition (Basis) */
   boolean chg,  /* correct/remove invalid definition */
   boolean hMsg) /* extended output of messages */
   {
   /*-----------------------------------------------------------------*/
    Iterator<TSTrf>       TrfI; /* Iterator for Traffic-Definitions */
    TSTrf                 cTrf; /* current Traffic-Definition */
    ArrayList<TSXtSrv>    SrvT; /* Service-table of (ext.) services */
    Iterator<TSXtSrv>     SrvI; /* Iterator of Traffic-Service-Def's */
    TSXtSrv               cSrv; /* akt. Service-Definition (ext. fuer Traffic) */
    TreeMap<String,TSSrv> SvT;  /* Table of Service-Definitions */
    TSSrv                 cSv;  /* current Service-Definition */
    ArrayList<TSStop>     HltT; /* StationStop-table of current service */
    TSStop                cHlt; /* current 'StationStop'-definition (S) */
    ArrayList<TSStStp>    StpT; /* StationStop-table of current traffic-service */
    Iterator<TSStStp>     StpI; /* Iterator for 'StationStop'-entries */
    TSStStp               cStp; /* current 'StationStop'-definition (T) */
    String                is,js;
    int                   ix,jx,kx,c,ec,t,sk; /* intermediate values */
    boolean               srt;  /* resort 'StationStop'-entries */
   /*=================================================================*/
    hMsg &= EnaH; /* output only if informations are enabled */
    TrfI = cRte.getIt(19); /* Liste der Traffic-Definitionen holen */
    if(TrfI==null) return -1; /* Traffic-Definitionen sind nicht geladen */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("chkTrf01",cRte.getInfo(1)); /* Aktionsmeldung ausgeben */

    ec = 0; /* noch kein Fehler erkannt */
    c  = 0; /* Zaehler initialisieren */
    SvT = cRte.getServ(); /* get table of ALL 'Service'-Definitions */
    while(TrfI.hasNext()) { /* Weitere 'Traffic'-Definition vorhanden */
      cTrf = TrfI.next(); /* Traffic-Eintrag holen */
      if(cTrf==null) throw new IllegalStateException( /* Sicherheitsabfrage */
        TSLogg.getMsg("Msg908","TSTrf==null","TSUtil.chkTrf()",0));
      js = cTrf.getName(true); /* Namen der Traffic-Datei holen */
      c += 1; /* Traffic-Definition zaehlen */
      Lg.Log("chkTrf05",js,c); /* Aktion melden */

      SrvT = cTrf.getSrv(0); /* get table of all 'Traffic-Service's */
      SrvI = SrvT.iterator(); /* get iterator for all services */
      ix = -1; /* initialize Index-Number (FIRST VALID index becomes 0) */
      t = 0; /* set Start-value for 'Start-Time'-check */
      while(SrvI.hasNext()) { /* more Traffic-Service-Definitions available? */
        cSrv = SrvI.next(); /* erweiterte Service-Definition holen */
        if(cSrv==null) throw new IllegalStateException( /* Sicherheitsabfrage */
          TSLogg.getMsg("Msg908","TSXtSrv==null","TSUtil.chkTrf()",0));
        ix += 1; /* Index-Nummer fortschreiben */

        is = cSrv.getName(); /* get name of current service (message,...) */
        t = cSrv.chkTime(t); /* check value of 'Start-Time' (ascending) */
        if(t<0) { /* error found within 'Start-Time'-sequence */
          t = -t; /* clear error-marker */
          if(hMsg) Lg.Log("chkTrf11",is,ix); /* report sequence-error */
          cTrf.setMsk(19); /* mark operation within traffic-definition */
        } /* error within 'Start-Time'-sequence */

        /* search for Service-Definition with same name */
        cSv = SvT.get(is.toLowerCase()); /* get 'Service' with same name */
        if(cSv==null) { /* Service wurde NICHT gefunden */
          Lg.Err("chkTrf12",is,ix); /* print errormessage */
          ec += 1; /* and count error */
          cTrf.setMsk(17); /* set marker: service contains errors */
          if(chg) { /* modify/correct/delete traffic-definition */
            SrvI.remove(); /* traffic-def. contains severe error -- delete it */
            continue; /* no more checking neccessary */
          } /* error within Traffic-Service-definition */
          cTrf.setMsk(16); /* set marker: traffic contain(s) error(s) */
          HltT = new ArrayList<TSStop>(); /* create dummy-'StationStop'-table */
        } else { /* Service was found -- connect it */
          cSrv.chgSrv(cSv); /* Service-Referenz eintragen */
          cSv.incCnt(1);     /* und Referenz zaehlen */
          if(cSv.chkMsk(16)) cTrf.orMsk(0x030000); /* transfer error-marker from service
            * set marker 16: 'error within traffic' and 17: 'service contains errors' */
          HltT = cSv.getStp(0); /* get StationStop-table of connected Service-definition */
        } /* connected service-definiton is checked */
        StpT = cSrv.getStp(0); /* get table of 'StationStop'-entries (T) */

        jx = -1; /* initialize Index-Number (FIRST VALID index becomes 0) */
        sk = 0; /* initialize Skip-Count; value starts with '0' */
        srt = false; /* preset: no sort-error -- do NOT sort */
        StpI = StpT.iterator(); /* get iterator for 'StationStop'-entries (T) */
        while(StpI.hasNext()) { /* more 'StationStop'-entries available? */
          cStp = StpI.next(); /* get next 'StationStop'-entry */
          if(cStp==null) throw new IllegalStateException(
            TSLogg.getMsg("Msg908","TSStStp==null","TSUtil.chkTrf()",0));
          jx += 1; /* compute correct index-number */
          sk = cStp.chkSkip(sk); /* check Skip-Count (greater?) */
          if(sk<0) { /* error within sequence of skipcount-values */
            sk = -sk; /* clear error-marker */
            Lg.Err("chkTrf21",is,ix,jx,sk); /* print error-message */
            ec += 1; /* and count error */
            srt = true; /* initate 'sort' of entries */
          }  /* error within sequence of skipcount-values */
        } /* -while- process all 'StationStop'-definitions */
        if(srt) { /* error in order found -- sort entries */
          Collections.sort(StpT); /* sort all definitions */
          Lg.Err("chkTrf22",is,ix); /* print error-message */
        } /* sorting-error is corrected */

        /* correlate 'StationStop'-entries (T) due to 'StationStop'-entries (S) */
        cl:for(jx=kx=0;jx<HltT.size();jx+=1,kx+=1) { /* process all 'StationStop's (S) */
          cHlt = HltT.get(jx); /* get required 'StationStop'-entry (S) */
          do { /* find this StationStop'-entry(S) within traffic-service */
            if(kx>=StpT.size()) { /* entry missing in traffic-table -- create it */
              Lg.Err(chg?"chkTrf23":"chkTrf24",is,ix,kx); /* print error-message */
              ec += 1; /* and count error */
              cTrf.setMsk(18); /* set error-marker: 'StationStop' for this Traffic */
              if(!chg) continue cl; /* do not add new entry */
              cStp = new TSStStp(cHlt); /* create required 'StationStop'-entry (T) */
              StpT.add(cStp); /* and add it to traffic-table */
            } else cStp = StpT.get(kx); /* get required 'StationStop'-entry (T) */

            /* both entries are available (maybe new one) -- correlate them */
            if((sk=cStp.corrS(cHlt))<=0) break; /* try to correlate entries */
            /* additional entry within traffic(cStp) found -- process(delete) it */
            Lg.Err(chg?"chkTrf25":"chkTrf26",is,ix,kx); /* print error-message */
            ec += 1; /* and count error */
            cTrf.setMsk(18); /* set error-marker: 'StationStop' for this Traffic */
            if(chg) StpT.remove(kx); /* delete additional entry */
            else kx += 1; /* or switch to next entry (just skip it) */
          } while(true); /* loop until correct correlation is found */
          if(sk<0) { /* no matching traffic-entry found (entry missing) */
            Lg.Err(chg?"chkTrf23":"chkTrf24",is,ix,kx); /* print error-message */
            ec += 1; /* and count error */
            cTrf.setMsk(18); /* set error-marker: 'StationStop' for this Traffic */
            if(chg) { /* add new entry and shift all following entries */
              cStp = new TSStStp(cHlt); /* create required 'StationStop'-entry (T) */
              StpT.add(kx,cStp); /* and add it to traffic-table */
            } else kx -= 1; /* use current (target-)entry again -> adjust index */
          } /* no matching traffic-entry found  -- created */
          if(RetVal!=null) Lg.Err("chkTrf27",is,""+ix,""+kx,(String)RetVal);
            /* error only can be active if a valid correlation is found */
        } /* -cl- process all 'StationStop's (S) */
        /* report and delete additional 'StationStop'-entries (T) */
        for(jx=kx;kx<StpT.size();jx+=1) { /* report all 'StationStop's */
          Lg.Err(chg?"chkTrf25":"chkTrf26",is,ix,jx); /* print error-message */
          ec += 1; /* and count error */
          cTrf.setMsk(18); /* set error-marker: 'StationStop' for this Traffic */
          if(chg) StpT.remove(kx); /* delete current entry */
          else kx += 1; /* or switch to next entry */
        } /* -for- report remaining 'StationStop's (T) and delete */
        StpT.trimToSize(); /* reorganize memory for entries of table */

      } /* -while- check ALL Traffic-Service-Definitions */

      if(cTrf.chkMsk(19)) { /* error in service-order found -- sort entries */
        Collections.sort(SrvT); /* sort all definitions */
        if(EnaH) Lg.Log("chkTrf02"); /* print message */
      } /* sorting-error is corrected */
    } /* alle Traffic-Definitionen bearbeiten */

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("chkTrf06",c); /* Ergebniss der Pruefung ausgeben */
    Lg.Log("chkTrf07",ec); /* Ergebniss der Pruefung ausgeben */
    Lg.Skip(false); /* Leerzeile loggen */

    return 0; /* Programm (erfolgreich) beendet */
  }

 /**. <pre>
  *=====================================================================
  * Method "putTrfF"
  * Write all traffic-definitions of a route
  * Prime-number-options used with 'opt':
  *       2 - create files without errors ONLY
  *       3 - 'noreplace' - Service must not already exist
  * ##putTrfF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int putTrfF( /* write traffic-definitions */
   TSRoute cRte, /* current route-definition */
   File    tdat, /* definition of the temporary file (overwrite) */
   int     opt)  /* options (coded using prime-numbers) */
   {
   /*-----------------------------------------------------------------*/
    File              dats,datz,dir1,dir2; /* temporary files */
    TSFileX           cF;    /* current output-file (control) */
    Iterator<TSTrf>   TrfI;  /* Iterator for traffic-definitions */
    TSTrf             cTrf;  /* current traffic-definition */
    Iterator<TSXtSrv> SrvI;  /* Iterator for service-definitions */
    TSXtSrv           cSrv;  /* current extended service-definition */
    String            is,js; /* intermediate values */
    int               i,ec,cc; /* intermediate values */
    int               ce,cf; /* intermediate values */
    Iterator<String>  LneI;  /* Line-Iterator for output */
    ArrayList<String> LneT;  /* Line-Table for output */
   /*=================================================================*/
    TrfI = cRte.getIt(19); /* get list of traffic-definitions */
    if(TrfI==null) return -1; /* traffic-definitons are NOT available */

    Lg.Skip(true); /* print empty line to LOG-file and screen */
    /* check if target-directory of service-definitions exist */
    dir2 = null; /* compiler needs it */
    if(tdat==null) { /* temporary file is NOT used */
      dir2 = cRte.getFile(44); /* get target-directory */
      if(dir2==null) { /* folder NOT available -- terminate */
        Lg.Skip(true); /* print empty line to LOG-file and screen */
        Lg.Msg("MsgC63",cRte.getInfo(44)); /* print message: terminating */
        Lg.Msg("putTrf01"); /* print errormessage */
        Lg.Close(); /* close output to Log-file */
        return 25; } /* terminate function with errorcode */
    } /* target-directory used for output */
    dir1 = cRte.getFile(14); /* get file-reference of source-directory */

    Lg.Msg("putTrf02",cRte.getInfo(1)); /* print description of next action */

    ce = 0; /* init error-counter */
    cf = 0; /* init number of definition-files */
    LneT = new ArrayList<String>(10); /* create table for output-line-blocks */
      /* This list is normally empty. After it was filled with output-lines
       * and all lines have been processed, it MUST be cleared again. */
    while(TrfI.hasNext()) { /* more traffic-definitions to process */
      cTrf = TrfI.next(); /* get next traffic-entry */
      if(cTrf==null) throw new IllegalStateException( /* security-query */
        TSLogg.getMsg("Msg908","TSTrf==null","TSUtil.putTrfF()",0));
      is = cTrf.getName(true); /* get unmodified name of traffic-file */
      if(is==null) continue;  /* file is missing -- do not process */

      dats = new File(dir1,is); /* create Source-Reference (for copy/delete) */
      if(cTrf.chkMsk(16) && (opt%2)==0) { /* traffic-def. has error(s) -- do not write */
        Lg.Err("putTrf04",is); /* print message: terminating */
        if(tdat==null) continue; /* do not write traffic-definition */
        dats.delete(); /* overwrite-mode: delete faulty file (inplace) */
        Lg.Log("putTrf15",dats.getAbsolutePath()); /* print message */
        continue; /* traffic-definition was deleted */
      } /* traffic-definition contained error(s) */
      Lg.Log("putTrf03",is); /* print description of action */

      if(tdat!=null) datz = tdat; /* preset: use temporary file */
      else { /* full target-reference is needed otherwise */
        datz = new File(dir2,is); /* create full target-reference */
        if((opt%3)==0 && datz.exists()) { /* traffic-file already exist? */
          Lg.Err("putTrf05",is); /* print message: terminating */
          continue; /* do not write traffic-definition */
        } /* traffic-definition already exist */
      }  /* full target-reference is needed */

      /* open service-file for output */
      cF = new TSFileX(TSFileX.FT$trf,datz); /* create output-control */
      is = cF.open(true); /* set sub-id and open file */
      if(is!=null) { /* error occurred while opening */
        Lg.Err("putTrf11",is); /* print message: terminating */
        continue; /* process next traffic-file */
      } /* error occurred while opening */
      cf += 1; /* count valid traffic-definition */

      ec = 0; /* Zaehler fuer Fehler initialisieren */
      bl: { /* block for error-break */
        is = cTrf.chgNme(null); /* Namen der Traffic-Definition */
        is = "Traffic_Definition ( " + modStr(is); /* erstes Statement erzeugen */
        cc = 10; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */

        i = cTrf.getInt(0); /* Serial-Nummer holen */
        if(i>=0) { /* Serial-Nummer definiert */
          is = "\tSerial ( " + i + " )"; /* Stmt Serial-Nummer erstellen */
          cc = 11; /* Kennzeichne Fehlerposition (praeventiv) */
          if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
        } /* Serial-Nummer war definiert */
        SrvI = cTrf.getSrv(0).iterator(); /* Liste der Service-Definitionen holen */
        while(SrvI.hasNext()) { /* Weitere Service-Definition vorhanden */
          cSrv = SrvI.next(); /* erweiterten Service-Eintrag holen */
          if(cSrv==null) throw new IllegalStateException( /* Sicherheitsabfrage */
            TSLogg.getMsg("Msg908","TSXtSrv==null","TSUtil.putTrfF()",0));
          js = cSrv.getName(); /* Name der Traffic-Service-Definition holen */
          LneI = cSrv.crDef(LneT,true,"\t"); /* create output-lines */
          if(LneI==null) { cc = 0; break bl;} /* no valid output-lines -- do not write */
          i = 0; /* initialize line-counter */
          cc = 20; /* preset number of error-position */
          while(LneI.hasNext()) { /* more output-lines available ? */
            is = LneI.next(); /* get next output-line */
            if(is==null) continue; /* dummy line -- do not write */
            i += 1; /* increment counter to next line */
            /* Attention: A output-line must start with '\t' or it is
             * considered as an error-message */
            if(is.charAt(0)!='\t') { /* got error-message instead of output-line */
              Lg.Err("putTrf12",is,js,i); /* print error-message */
              ec += 1; /* and count error */
            } else { /* NO error-message --write it */
              cc += 1; /* advance to next error-position */
              if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
            } /* output-line processed */
          } /* -while- process all output-lines */
          LneT.clear(); /* all lines written -- delete them */
        } /* alle Service-Definitionen wurden bearbeitet */
        cc = 12; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(")"))!=null) break bl; /* Schreib-Fehler */
        cc = 19; /* preset position of error */
        is = TSLogg.getMsg("Msg100","Traffic"); /* create TSUtil-ID-Line */
        if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
        cc = 0; /* kein Fehler aufgetreten */
      } /* -bl- break-block used in case of error */
      if(is!=null) { /* Meldung steht noch aus */
        Lg.Err("putTrf11",is); /* Meldung ausgeben */
        ec += 1; /* Fehler zaehlen */
      } /* Meldung musste noch ausgegeben werden */
      is = cF.close(); /* Ausgabe-Datei schliessen */
      if(is!=null) Lg.Err("putTrf06",is); /* Meldung ausgeben */
      if(cc!=0) Lg.Err("putTrf16",cc); /* Aktionsmeldung */
      else if(ec>0) Lg.Log("putTrf17",ec); /* Aktionsmeldung */

      Lg.Log("putTrf18",cF.getStat(true)); /* print number of entries */
//      Lg.Log("putTrf19",cF.getStat(false)); /* print file-length */
      ce += ec; /* count overall number of errors */

      /* copy back result to path-file(source) if overwrite requested */
      cc += ec; /* compute error-threshold */
      if(tdat!=null) { /* overwrite of original file is requested */
        if(cc>0) cf -= 1; /* error --do not copy file */
          /* if an error occured the original file is NOT changed */
        else { /* copy target-file and overwrite original file */
          is = dats.getAbsolutePath(); /* name of source-file */
          js = "copy \""+tdat.getAbsolutePath()+"\" \""+is+"\" ";
            /* create copy-command */
          if((i=exec(true,js,null,Lg))>0) /* error during execute */
            Lg.Log("MsgC49",is,i); /* print errormessage */
        } /* original file (source) was overwritten */
      } else if(cc>0 && (opt%2)==0) { /* error -- delete file again */
        datz.delete(); /* delete created file due to error(s) */
        is = datz.getAbsolutePath(); /* name of target-file */
        Lg.Msg("putTrf07",is); /* print errormessage */
        cf -= 1; /* traffic-file is NOT created */
      } /* new target-file has been deleted again */
    } /* -while- write ALL traffic-definitions */

    Lg.Skip(false); /* print empty line to LOG-file */
    Lg.Log("putTrf08",cf); /* print number of traffic-files */
    Lg.Log("putTrf09",ce); /* print number of overall errors */
    Lg.Skip(false); /* print empty line to LOG-file */

    return 0; /* terminate program (successfully) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getSCfg"
  * Read complete Signal-Configuration-File and store it.
  * ##getSCfg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getSCfg( /* Read Signal-Configuration */
   TSRoute   cRte, /* current route-definition */
   File      dat,  /* File-Definition of configuration (input-file) */
   TSNameSet Nme,  /* List of used Shape-Names (oder 'null') */
   boolean   wMsg) /* extended usage of messages */
   {
   /*-----------------------------------------------------------------*/
    TSFileX              cF;     /* current signal-file (input) */
    TSBuf                cB;     /* current input-buffer 'read file' */
    ArrayList<TSSigSh>   SgShT;  /* current SignalShape-table */
    ArrayList<TSSigSObj> SgSOT;  /* current SignalSubObject-table */
    ArrayList<TSSigTyp>  SgTT;   /* current SignalType-table */
    ArrayList<TSSigLTx>  SgX;    /* current LightTexture-table */
    ArrayList<TSSigLgt>  SgL;    /* current Lights-table */
    TSSigSh              cSgS;   /* current SignalShape */
    TSSigSObj            cSgO;   /* current SignalSubobjekt of shape */
    TSSigTyp             cSgT;   /* current SignalType-entry */
    TSSigSgL             cSgSgL; /* current SignalLight-entry */
    TSSigDrSt            cSgDrS; /* current SignalDrawState-entry */
    TSSigAsp             cSgA;   /* current SignalAspect-entry */
    TSSigLTx             cSgX;   /* current LightTexture (LightTex) */
    TSSigLgt             cSgL;   /* current LightTab-entry */
    TSSigFle             cSgF;   /* current Script-File-Definition */
    ArrayList<TSRefC>    SgJN;   /* table of JNLink-references */
    TSRefC               cRef;   /* current reference-control */
    int                  l1,l2,l3,l4,i,ci,cc,kc,sc,si,oc,oi,xc,xi;
    int                  GrpCnt; /* zusaetzliche Meldung bei Fehler */
    double               fx,fy,fz,fr;
    String               is,js,ks;
    boolean              hMsg;   /* print extended informations ? */
    LinkedHashMap<String,TSSigFle> SgF; /* aktuelle Script-File-Tabelle */
    Iterator             cI;     /* Tabelleniterator of SgShT,SgTT,... */
   /*=================================================================*/
    hMsg = wMsg & EnaH; /* Ausgabe NUR wenn auch Hinweise aktiv */
    wMsg &= EnaW; /* Ausgabe NUR wenn auch Warungen aktiv */
    if(dat.isDirectory()) { /* es liegt keine Datei vor */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getSg001",dat.getPath()); /* Abbruchmeldung ausgeben */
      return 5; /* System beenden */
    } /* Datei ist ein Verzeichnis */
    if(!dat.exists()) { /* Datei existiert nicht und kann fehlen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getSg002",dat.getPath()); /* Aktionsmeldung */
      return -1; /* System NORMAL, jedoch mit Kennzeichen beenden */
    } /* Datei existiert nicht */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("getSg003",dat.getAbsolutePath()); /* Aktionsmeldung */

    /* Datenbank-Datei fuer Eingabe oeffnen */
    cF = new TSFileX(TSFileX.FT$sig,dat); /* Eingabe-Steuerung erstellen */
    is = cF.open(false); /* Datei fuer Eingabe oeffnen */
    if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("getSg004",is); /* Abbruchmeldung ausgeben */
      return 6; /* System beenden */
    } /* Fehler beim Oeffnen der Datenbank-Datei */
    cB = new TSBuf(cF); /* create inputbuffer and init counter */

    cc = 0; /* current condition-code */
    bl:{ /* break-block (used with errors) */
      is = cB.getKE(true); /* get first controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getSg011"); /* print errormessage */
          cc = 21; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getSg012",is,cB.getStat(true)); /* print errormessage */
        cc = 22; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getSg013"); /* print errormessage */
        cc = 23; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(!is.equals("lighttextures")) { /* entry 'LightTextures' missing */
        Lg.Err("getSg014",is); /* print errormessage */
        cc = 24; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      l1 = cB.getBrL(); /* current bracket-level for terminate */
      sc = (int)cB.getNV(); /* get number of entries */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        Lg.Err("getSg015",is,cB.getStat(true)); /* print errormessage */
        cc = 25; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      Lg.Msg("getSg008",sc); /* print message about next action */
      SgX = cRte.getSigLTx(sc); /* allocate Signal-LTexture-Table */
      if(SgX==null) { /* LTexture-Table could not be created */
        Lg.Err("getSg016",sc); /* print errormessage */
        cc = 26; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      for(si=0;si<100;si+=1) { /* process all 'LightTex'-entries */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getSg017",si); /* print errormessage */
            cc = 27; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getSg018",is,si,cB.getStat(true)); /* print errormessage */
          cc = 28; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) { /* next keword not present */
          if(si>=sc) break; /* all definitions processed */
          Lg.Err("getSg019",si); /* print errormessage */
          break; } /* terminate processing of entries */
        if(!is.equals("lighttex")) { /* no entry 'LightTex' */
          Lg.Err("getSg020",is,si,sc); /* print errormessage */
          break; } /* terminate processing of entries */
        l2 = cB.getBrL(); /* current bracket-level for terminate */
        if(si<sc) ltl1:{ /* fully process 'LightTex'-entry */
          js = cB.getVal(1); /* get name as next argument */
          if(js==null) { /* error found within current input */
            if((js=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getSg021",si); /* print errormessage */
              cc = 31; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getSg022",js,si,cB.getStat(true)); /* print errormessage */
            break; } /* terminate processing of entries */
          if(js.length()==0) { /* name not found */
            Lg.Err("getSg023",si); /* print errormessage */
            break ltl1; } /* terminate processing of entry */
          ks = cB.getVal(1); /* get texture-name as next argument */
          if(ks==null) { /* error found within current input */
            if((ks=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getSg024",si); /* print errormessage */
              cc = 34; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getSg022",ks,si,cB.getStat(true)); /* print errormessage */
            break; } /* terminate processing of entries */
          if(ks.length()==0) { /* name not found */
            Lg.Err("getSg025",si); /* print errormessage */
            break ltl1; } /* terminate processing of entry */
          cSgX = new TSSigLTx(si,js,ks); /* create Light-Texture-Definition */
          if(Nme!=null) Nme.add(ks); /* register texture-name for checking */
          fx = cB.getFV(); /* get value of 'top'-position */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getSg026",is,"top",""+si,""+cB.getStat(true));
            if(!Double.isNaN(fx)) break ltl1; /* EOF NOT found -- next entry */
            cc = 35; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          fy = cB.getFV(); /* get value of 'left'-position */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getSg026",is,"left",""+si,""+cB.getStat(true));
            if(!Double.isNaN(fy)) break ltl1; /* EOF NOT found -- next entry */
            cc = 36; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          fz = cB.getFV(); /* get value of 'top'-position */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getSg026",is,"bottom",""+si,""+cB.getStat(true));
            if(!Double.isNaN(fz)) break ltl1; /* EOF NOT found -- next entry */
            cc = 37; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          fr = cB.getFV(); /* get value of 'right'-position */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getSg026",is,"right",""+si,""+cB.getStat(true));
            if(!Double.isNaN(fr)) break ltl1; /* EOF NOT found -- next entry */
            cc = 38; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          cSgX.setPos(fx,fy,fz,fr); /* insert coordinate-values */
          SgX.add(cSgX); /* and activate Light-Texture-definition */
        } else /* -ltl1- all 'LightTex'-entries were already processed */
          Lg.Err("getSg029",si); /* additional 'LightTex'-definition found */
        if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
          Lg.Err("getSg006","LightTex"); /* print errormessage */
          cc = 48; /* set current return-code to error */
          break bl; } /* terminate evaluation */
      } /* -for- process all 'LightTex'-entries */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getSg006","LightTextures"); /* print errormessage */
        cc = 49; /* set current return-code to error */
        break bl; } /* terminate evaluation */

      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getSg031"); /* print errormessage */
          cc = 51; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getSg032",is,cB.getStat(true)); /* print errormessage */
        cc = 52; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getSg033"); /* print errormessage */
        cc = 53; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(!is.equals("lightstab")) { /* entry 'LightsTab' missing */
        Lg.Err("getSg034",is); /* print errormessage */
        cc = 54; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      l1 = cB.getBrL(); /* current bracket-level for terminate */
      sc = (int)cB.getNV(); /* get number of entries */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        Lg.Err("getSg035",is,cB.getStat(true)); /* print errormessage */
        cc = 55; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      Lg.Msg("getSg009",sc); /* print message about next action */
      SgL = cRte.getSigL(sc); /* allocate Signal-Light-Table */
      if(SgL==null) { /* Light-Table could not be created */
        Lg.Err("getSg036",sc); /* print errormessage */
        cc = 56; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      for(si=0;si<1000;si+=1) { /* process all 'LightsTab'-entries */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getSg037",si); /* print errormessage */
            cc = 57; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getSg038",is,si,cB.getStat(true)); /* print errormessage */
          cc = 58; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) { /* next keword not present */
          if(si>=sc) break; /* all definitions processed */
          Lg.Err("getSg039",si); /* print errormessage */
          break; } /* terminate processing of entries */
        if(!is.equals("lightstabentry")) { /* no entry 'LightsTab' */
          Lg.Err("getSg040",is,si,sc); /* print errormessage */
          break; } /* terminate processing of entries */
        l2 = cB.getBrL(); /* current bracket-level for terminate */
        if(si<sc) ltl2:{ /* fully process 'LightsTab'-entry */
          is = cB.getVal(1); /* get name as next argument */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getSg041",si); /* print errormessage */
              cc = 61; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getSg042",is,si,cB.getStat(true)); /* print errormessage */
            break; } /* terminate processing of entries */
          if(is.length()==0) { /* name not found */
            Lg.Err("getSg043",si); /* print errormessage */
            break ltl2; } /* terminate processing of entry */
          cSgL = new TSSigLgt(si,is); /* create Light-definition */
          is = cB.getKE(true); /* get next controlword */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getSg044",si); /* print errormessage */
              cc = 62; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getSg042",is,si,sc); /* print errormessage */
            break; } /* terminate processing of entries */
          if(is.length()==0) { /* next keword not present */
            Lg.Err("getSg045",si); /* print errormessage */
            break ltl2; } /* terminate processing of entry */
          if(!is.equals("colour")) { /* no entry 'Colour' */
            Lg.Err("getSg046",is,si,sc); /* print errormessage */
            break ltl2; } /* terminate processing of entry */
          oc = (int)cB.getNV(); /* get 'Alpha'-value */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getSg047",is,"Alpha",""+si,""+cB.getStat(true));
            cc = 63; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          oi = (int)cB.getNV(); /* get 'Red'-value */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getSg047",is,"R",""+si,""+cB.getStat(true));
            cc = 64; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          xc = (int)cB.getNV(); /* get 'Green'-value */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getSg047",is,"G",""+si,""+cB.getStat(true));
            cc = 65; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          xi = (int)cB.getNV(); /* get 'Blue'-value */
          if((is=cB.getErr())!=null) { /* error while evaluating */
            Lg.Err("getSg047",is,"B",""+si,""+cB.getStat(true));
            cc = 66; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          cSgL.setCol(oc,oi,xc,xi); /* insert color-values into current definition */
          if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
            Lg.Err("getSg006","LightsTabEntry-colour"); /* print errormessage */
            cc = 67; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          SgL.add(cSgL); /* activate LightTab-definition */
        } else /* -ltl2- all 'LightsTab'-entries were already processed */
          Lg.Err("getSg049",si); /* additional 'LightTab'-definition found */
        if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
          Lg.Err("getSg006","LightsTabEntry"); /* print errormessage */
          cc = 68; /* set current return-code to error */
          break bl; } /* terminate evaluation */
      } /* -for- process all 'LightTex'-entries */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getSg006","LightsTab"); /* print errormessage */
        cc = 69; /* set current return-code to error */
        break bl; } /* terminate evaluation */

      /* ---------- SignalType ---------- */
      Lg.Skip(false); /* insert empty line into LOG */
      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getSg051"); /* print errormessage */
          cc = 71; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getSg052",is,cB.getStat(true)); /* print errormessage */
        cc = 72; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getSg053"); /* print errormessage */
        cc = 73; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(!is.equals("signaltypes")) { /* entry 'SignalTypes' missing */
        Lg.Err("getSg054",is); /* print errormessage */
        cc = 74; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      l1 = cB.getBrL(); /* current bracket-level for terminate */
      sc = (int)cB.getNV(); /* get number of entries */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        Lg.Err("getSg055",is,cB.getStat(true)); /* print errormessage */
        cc = 75; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      SgTT = cRte.getSigT(sc); /* allocate SignalType-Table */
      if(SgTT==null) { /* Table could not be created */
        Lg.Err("getSg056",sc); /* print errormessage */
        cc = 76; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      for(si=0;si<1000;si+=1) { /* process all 'SignalType'-entries */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getSg057",si); /* print errormessage */
            cc = 77; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getSg058",is,si,cB.getStat(true)); /* print errormessage */
          cc = 78; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) { /* next keword not present */
          if(si>=sc) break; /* all definitions processed */
          Lg.Err("getSg059",si); /* print errormessage */
          break; } /* terminate processing of entries */
        if(!is.equals("signaltype")) { /* no entry 'SignalType' */
          Lg.Err("getSg060",is,si,cB.getStat(true)); /* print errormessage */
          break; } /* terminate processing of entries */
        l2 = cB.getBrL(); /* current bracket-level for terminate */
        if(si<sc) stl:{ /* fully process 'SignalType'-entry */
          is = cB.getVal(1); /* get 'SignalType'-name as next argument */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getSg061",si); /* print errormessage */
              cc = 81; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getSg062",is,si,cB.getStat(true)); /* print errormessage */
            cc = 82; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          if(is.length()==0) { /* name not found */
            Lg.Err("getSg063",si); /* print errormessage */
            break stl; } /* terminate processing of entries */
          if((cSgT=cRte.fndSigT(is))!=null) { /* 'SignalType'-name is already defined */
            oi = SgTT.indexOf(cSgT); /* get already used index */
            Lg.Err("getSg499",is,si,oi); /* print errormessage */
            break stl; } /* terminate processing of entries */
          cSgT = new TSSigTyp(is); /* create 'SignalType'-definition */
          kc = 1; /* preset keyword-control: no keywords processed */
          GrpCnt = 9; /* preset: there is an error within all sub-definitions */
          while(true) { /* read and process all following sub-definitions */
            is = cB.getKE(true); /* get next keyword */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getSg064",cSgT.getNme(),si); /* print errormessage */
                cc = 84; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              Lg.Err("getSg062",is,si,cB.getStat(true)); /* print errormessage */
              Lg.Err("getSg498",cSgT.getNme(),si); /* print extension */
              cc = 85; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            if(is.length()==0) break; /* no more definitions */
            l3 = cB.getBrL(); /* current bracket-level for terminate */
            if(is.equals("signalfntype")) lt1:{ /* definition: 'SignalFnType' */
              if((kc%2)==0) { /* keyword was already present */
                Lg.Err("getSg065","SignalFnType",si,cB.getStat(true)); /* print errormessage */
                GrpCnt += 1; /* mark: additional description neccessary */
                break lt1; } /* terminate processing of entry */
              kc *= 2; /* mark that an (erroneous) entry of this type was processed */
              js = cB.getVal(2); /* get type of 'SignalType' */
              if(js==null) { /* error found within current input */
                if((js=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getSg071",cSgT.getNme(),si,cB.getStat(true)); /* print errormessage */
                  cc = 91; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getSg072",js,si,cB.getStat(true)); /* print errormessage */
                break lt1; } /* terminate processing of entry */
              if(js.length()==0) { /* name not found */
                Lg.Err("getSg073",si); /* print errormessage */
                break lt1; } /* terminate processing of entry */
              if((i=TSSigTyp.chkTyp(js))<0) { /* unknown type of 'SignalType' */
                Lg.Err("getSg074",js,si,i);  /* print errormessage */
                break lt1; } /* terminate processing of entry */
              cSgT.chgTyp(i); /* insert type of 'SignalType'-entry */
              cSgT.setMsk(1); /* mark that this entry was processed (successfully) */
              GrpCnt -= 1; /* one (more) definitiongroup handled successfully */
              js = cB.skpVal(); /* get remaining value(s) within brackets */
              if(js==null) { /* error found within current input */
                if((js=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getSg071",cSgT.getNme(),si,cB.getStat(true)); /* print errormessage */
                  cc = 92; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getSg072",js,si,cB.getStat(true)); /* print errormessage */
                break lt1; } /* terminate processing of entry */
              if(js.length()>1) if(wMsg) Lg.Log("getSg075",js,si); /* additional data found */
            } else if(is.equals("signalflags")) lt2:{ /* definition: 'SignalFlags' */
              if((kc%3)==0) { /* keyword was already present */
                Lg.Err("getSg065","SignalFlags",si,cB.getStat(true)); /* print errormessage */
                GrpCnt += 1; /* mark: additional description neccessary */
                break lt2; } /* terminate processing of entry */
              kc *= 3; /* mark that an (erroneous) entry of this type was processed */
              while(true) { /* process all keywords of 'SignalFlags' */
                js = cB.getVal(2); /* get keyword for 'SignalFlag' */
                if(js==null) { /* error found within current input */
                  if((js=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getSg081",cSgT.getNme(),si,cB.getStat(true)); /* print errormessage */
                    cc = 101; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getSg082",js,si,cB.getStat(true)); /* print errormessage */
                  break lt2; } /* terminate processing of entry */
                if(js.length()==0) break; /* all SignalFlag-definitions are processed */
                if(js.equals("semaphore")) i = 18; /* valid keyword -- process it */
                else if(js.equals("no_gantry")) i = 19; /* valid keyword -- process it */
                else if(js.equals("abs")) i = 20; /* valid keyword -- process it */
                else if(js.equals("dir_display")) i = 21; /* valid keyword -- process it */
                else { /* name of 'SignalFlag' is not known -- print message */
                  Lg.Err("getSg083",js,si,cB.getStat(true)); /* print errormessage */
                  break lt2; } /* terminate processing of entry */
                cSgT.setMsk(i); /* insert option into 'SignalType'-definition */
              } /* keyword was investigated */
              cSgT.setMsk(4); /* mark that this entry was processed (successfully) */
              GrpCnt -= 1; /* one (more) definitiongroup handled successfully */
            } else if(is.equals("sigflashduration")) lt3:{ /* definition: 'SigFlashDuration' */
              if((kc%5)==0) { /* keyword was already present */
                Lg.Err("getSg065","SigFlashDuration",si,cB.getStat(true)); /* print errormessage */
                GrpCnt += 1; /* mark: additional description neccessary */
                break lt3; } /* terminate processing of entry */
              kc *= 5; /* mark that an (erroneous) entry of this type was processed */
              /* entry is not further checked -- data is stored only */
              is = cB.skpVal(); /* get remaining value(s) within brackets */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getSg091",cSgT.getNme(),si,cB.getStat(true)); /* print errormessage */
                  cc = 111; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getSg092",is,si,cB.getStat(true)); /* print errormessage */
                Lg.Err("getSg498",cSgT.getNme(),si); /* print extension */
                cc = 112; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if((is=cSgT.chgLne(is))!=null) { /* save data -- values already stored? */
                Lg.Err("getSg093",is,si,sc); /* data was already present */
                cc = 113; /* set current return-code to error */
                break lt3; } /* terminate processing of entry */
              cSgT.setMsk(5); /* mark that this entry was processed (successfully) */
              GrpCnt -= 1; /* one (more) definitiongroup handled successfully */
            } else if(is.equals("signallighttex")) lt4:{ /* definition: 'SignalLightTex' */
              if((kc%7)==0) { /* keyword was already present */
                Lg.Err("getSg065","SignalLightTex",si,cB.getStat(true)); /* print errormessage */
                GrpCnt += 1; /* mark: additional description neccessary */
                break lt4; } /* terminate processing of entry */
              kc *= 7; /* mark that an (erroneous) entry of this type was processed */
              js = cB.getVal(1); /* get name of light-texture */
              if(js==null) { /* error found within current input */
                if((js=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getSg101",cSgT.getNme(),si,cB.getStat(true)); /* print errormessage */
                  cc = 121; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getSg102",js,si,cB.getStat(true)); /* print errormessage */
                break lt4; } /* terminate processing of entry */
              if(js.length()==0) { /* name not found */
               Lg.Err("getSg103",si); /* print errormessage */
                break lt4; } /* terminate processing of entry */
              lt4x:{ /* break-block: search for texture */
                cI = cRte.getIt(24); /* Iterator within SignalLTexture-definitions */
                if(cI!=null) while(cI.hasNext()) { /* more SignalLTexture-Definitions? */
                  cSgX = (TSSigLTx)cI.next(); /* get next LTexture-Definition */
                  if(cSgX.chkNme(js)) break lt4x; /* Name found -- continue without error */
                } /* compare to all defined textures */
                Lg.Err("getSg104",js,si,sc); /* print errormessage */
                break lt4; /* terminate processing of entry */
              } /* -lt4x- break here if match received */
              cSgT.chgLTx(cSgX); /* insert reference to 'SignalLight-Texture' */
              cSgX.incCnt(1); /* and count reference */
              cSgT.setMsk(2); /* mark that this entry was processed (successfully) */
              GrpCnt -= 1; /* one (more) definitiongroup handled successfully */
            } else if(is.equals("signallights")) lt5:{ /* definition: 'SignalLights' */
              if((kc%11)==0) { /* keyword was already present */
                Lg.Err("getSg065","SignalLights",si,cB.getStat(true)); /* print errormessage */
                GrpCnt += 1; /* mark: additional description neccessary */
                break lt5; } /* terminate processing of entry */
              kc *= 11; /* mark that an (erroneous) entry of this type was processed */
              oc = (int)cB.getNV(); /* get number of 'SignalLight'-definitions */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getSg111",is,cSgT.getNme(),""+si,""+cB.getStat(true)); /* print errormessage */
                cc = 131; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(oc<0) { /* invalid value for number of 'SignalLights' */
                Lg.Err("getSg112",null,si,oc); /* print errormessage */
                break lt5; } /* terminate processing of entry */
              if(oc==0) { /* no definition follows -- ignore entry */
                if(wMsg) Lg.Log("getSg114",cSgT.getNme(),si); /* print errormessage */
                GrpCnt -= 1; /* one (more) definitiongroup handled successfully */
                break lt5; } /* terminate processing of entry */
              if((i=cSgT.get$SgL(oc))<0) { /* allocate storage for 'SignalLights' */
                Lg.Err("getSg113",""+i,si,oc); /* print errormessage */
                Lg.Err("getSg498",cSgT.getNme(),si); /* print extension */
                cc = 132; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              GrpCnt += oc; /* more new definitiongroups must be handled */
              lt5$1:for(oi=0;oi<1000;oi+=1) { /* process all 'SignalLight'-definitions */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                     Lg.Err("getSg115",cSgT.getNme(),si,oi); /* print errormessage */
                    cc = 133; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getSg116",is,si,oi); /* print errormessage */
                  break lt5; } /* terminate processing of entry */
                if(is.length()==0) { /* next keword not present */
                  if(oi==oc) break lt5$1; /* all definitions processed */
                  if(oi>oc) { /* additional definitions found (too many)  */
                    Lg.Err("getSg119",""+oc,si,oi); /* print errormessage */
                    GrpCnt -= oi - oc; /* more definitiongroups handled */
                  } else Lg.Err("getSg117",""+oc,si,oi); /* print errormessage */
                  break lt5; } /* terminate processing of entry */
                l4 = cB.getBrL(); /* current bracket-level for terminate */
                lt5$2: { /* break-block (used for 'SignalLight'-investigation) */
                  if(!is.equals("signallight")) { /* no entry 'SignalLight' */
                    Lg.Err("getSg118",is,si,oi); /* print errormessage */
                    break lt5$2; } /* terminate processing of entry */
                  ci = (int)cB.getNV(); /* get number of current 'SignalLight' */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getSg121",is,si,oi,cB.getStat(true)); /* print errormessage */
                    Lg.Err("getSg498",cSgT.getNme(),si); /* print extension */
                    cc = 134; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  if(ci<0 || ci>=oc) { /* invalid number of 'SignalLight' (index) */
                    Lg.Err("getSg122",""+ci,si,oi); /* print errormessage */
                    break lt5$2; } /* terminate processing of entry */
                  if(cSgT.chgSgL(ci,null)!=null) { /* 'SignalLight'-entry is already defined */
                    Lg.Err("getSg141",""+ci,si,oi); /* print errormessage */
                    break lt5$2; } /* terminate processing of entry */
                  js = cB.getVal(1); /* get name of 'SignalLight'-definition */
                  if(js==null) { /* error found within current input */
                    if((js=cB.getErr())==null) { /* EOF within data */
                      Lg.Err("getSg123",cSgT.getNme(),si,oi,ci); /* print errormessage */
                      cc = 135; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    Lg.Err("getSg124",js,si,oi,ci); /* print errormessage */
                    break lt5$2; } /* terminate processing of entry */
                  if(js.length()==0) { /* name not found */
                    Lg.Err("getSg125",""+ci,si,oi); /* print errormessage */
                    break lt5$2; } /* terminate processing of entry */
                  lt5$3:{ /* break-block (search for global Light-definition) */
                    cI = cRte.getIt(23); /* Iterator within gobal 'Lights'-Definitions */
                    if(cI!=null) while(cI.hasNext()) { /* more 'SignalLight'-Def's exist */
                      cSgL = (TSSigLgt)cI.next(); /* get next Light-Definition */
                      if(cSgL.chkNme(js)) break lt5$3; /* name found -- continue without error */
                    } /* compare with all possible definitions */
                    Lg.Err("getSg126",js,si,oi,ci); /* print errormessage */
                    break lt5$2; /* terminate processing of entry */
                  } /* -lt5$3- if match found, processing continues here */
                  cSgSgL = new TSSigSgL(ci,cSgL); /* create SignalLight-Definition */
                  cSgL.incCnt(1); /* and count usage of global Lights-reference */
                  i = 1; /* preset: no keywords processed */
                  while(true) { /* check all following keywords for attributes */
                    is = cB.getKE(true); /* get next controlword */
                    if(is==null) { /* error found within current input */
                      if((is=cB.getErr())==null) { /* EOF within data */
                        Lg.Err("getSg127",cSgT.getNme(),si,oi,ci); /* print errormessage */
                        cc = 136; /* set current return-code to error */
                        break bl; } /* terminate evaluation */
                      Lg.Err("getSg124",is,si,oi,ci); /* print errormessage */
                      break lt5$2; } /* terminate processing of entry */
                    if(is.length()==0) break; /* no more keywords found */
                    if(is.equals("position")) { /* Definition-type: 'Position' */
                      fx = cB.getFV(); /* get first value of position */
                      if((is=cB.getErr())!=null) { /* error while evaluating */
                        Lg.Err("getSg131",is,si,oi,ci); /* print errormessage */
                        break lt5$2; } /* terminate processing of entry */
                      fy = cB.getFV(); /* get second value of position */
                      if((is=cB.getErr())!=null) { /* error while evaluating */
                        Lg.Err("getSg132",is,si,oi,ci); /* print errormessage */
                        break lt5$2; } /* terminate processing of entry */
                      fz = cB.getFV(); /* get third value of position */
                      if((is=cB.getErr())!=null) { /* error while evaluating */
                        Lg.Err("getSg133",is,si,oi,ci); /* print errormessage */
                        break lt5$2; } /* terminate processing of entry */
                      cSgSgL.setLPos(new TSPos(fx,fy,fz)); /* insert position */
                      i *= 2; /* mark: keyword successfully processed */
                    } else if(is.equals("radius")) { /* Definition-type: 'Radius' */
                      fx = cB.getFV(); /* get requested value of radius */
                      if((is=cB.getErr())!=null) { /* error while evaluating */
                        Lg.Err("getSg135",is,si,oi,ci); /* print errormessage */
                        break lt5$2; } /* terminate processing of entry */
                      cSgSgL.setLRad(fx); /* insert radius of light */
                      i *= 3; /* mark: keyword successfully processed */
                    } else if(is.equals("signalflags")) { /* Definition-type: 'SignalFlags' */
                      js = cB.getVal(2); /* get name of option */
                      if(js==null) { /* error found within current input */
                        if((js=cB.getErr())==null) { /* EOF within data */
                          Lg.Err("getSg137",cSgT.getNme(),si,oi,ci); /* print errormessage */
                          cc = 137; /* set current return-code to error */
                          break bl; } /* terminate evaluation */
                        Lg.Err("getSg138",js,si,oi,ci); /* print errormessage */
                        break lt5$2; } /* terminate processing of entry */
                      if(!js.equals("semaphore_change")) { /* value NOT valid */
                        Lg.Err("getSg139",js,si,oi,ci); /* print errormessage */
                        break lt5$2; } /* terminate processing of entry */
                      cSgSgL.setMsk(16); /* store option */
                    } else Lg.Err("getSg148",is,si,oi,ci); /* print errormessage */
                      /* unknown keyword -- print and ignore it */
                    if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                      Lg.Err("getSg149",cSgT.getNme(),si,oi,ci); /* print errormessage */
                      cc = 139; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                  } /* -while(true)- check and process all following keywords */
                  if(i!=6) { /* not all requested keywords are present */
                    Lg.Err("getSg128",""+i,si,oi,ci); /* print errormessage */
                    break lt5$2; } /* terminate processing of entry */
                  cSgT.chgSgL(ci,cSgSgL); /* insert 'SignalLight'-reference into 'SignalType'-definition */
                  GrpCnt -= 1; /* one (more) definitiongroup handled successfully */
                } /* -lt5$2- SignalLight-entry was (fully?) processed */
                if(cB.skpFwd(l4)) { /* skip resuming data to new entry -- EOF/error found? */
                  Lg.Err("getSg129",cSgT.getNme(),si,oi); /* print errormessage */
                  cc = 140; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
              } /* -lt5$1- whole 'SignalLight'-group is processed */
              cSgT.setMsk(6); /* mark that this entry was processed (successfully) */
              GrpCnt -= 1; /* one (more) definitiongroup handled successfully */
            } else if(is.equals("signaldrawstates")) lt6:{ /* definition: 'SignalDrawStates' */
              if((kc%13)==0) { /* keyword was already present */
                Lg.Err("getSg065","SignalDrawStates",si,cB.getStat(true)); /* print errormessage */
                GrpCnt += 1; /* mark: additional description neccessary */
                break lt6; } /* terminate processing of entry */
              kc *= 13; /* mark that an (erroneous) entry of this type was processed */
              if((kc%11)!=0) if(wMsg) Lg.Log("getSg150",si); /* print warning */
              oc = (int)cB.getNV(); /* get number of 'SignalDrawState'-definitions */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getSg151",is,cSgT.getNme(),""+si,""+cB.getStat(true)); /* print errormessage */
                cc = 151; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(oc<0) { /* invalid value for number of 'SignalDrawStates' */
                Lg.Err("getSg152",null,si,oc); /* print errormessage */
                break lt6; } /* terminate processing of entry */
              if((i=cSgT.get$SgD(oc))<0) { /* allocate storage for 'SignalDrawStates' */
                Lg.Err("getSg153",""+i,si,oc); /* print errormessage */
                Lg.Err("getSg498",cSgT.getNme(),si); /* print extension */
                cc = 152; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              GrpCnt += oc; /* more new definitiongroups must be handled */
              lt6$1:for(oi=0;oi<1000;oi+=1) { /* process all 'SignalDrawState'-definitions */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getSg155",cSgT.getNme(),si,oi); /* print errormessage */
                    cc = 153; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getSg156",is,si,oi); /* print errormessage */
                  break lt6; } /* terminate processing of entry */
                if(is.length()==0) { /* next keword not present */
                  if(oi==oc) break lt6$1; /* all definitions processed */
                  if(oi>oc) { /* additional definitions found (too many)  */
                    Lg.Err("getSg159",""+oc,si,oi); /* print errormessage */
                    GrpCnt -= oi - oc; /* more definitiongroups handled */
                  } else Lg.Err("getSg157",""+oc,si,oi); /* print errormessage */
                  break lt6; } /* terminate processing of entry */
                l4 = cB.getBrL(); /* current bracket-level for terminate */
                lt6$2: { /* break-block (used for 'SignalDrawState'-investigation) */
                  if(!is.equals("signaldrawstate")) { /* no entry 'SignalDrawState' */
                    Lg.Err("getSg158",is,si,oi); /* print errormessage */
                    break lt6$2; } /* terminate processing of entry */
                  ci = (int)cB.getNV(); /* get number of current 'SignalDrawState' */
                  if((is=cB.getErr())!=null) { /* error while evaluating */
                    Lg.Err("getSg161",is,si,oi); /* print errormessage */
                    Lg.Err("getSg498",cSgT.getNme(),si); /* print extension */
                    cc = 154; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  if(ci<0 || ci>=oc) { /* invalid number of 'SignalDrawState' (index) */
                    Lg.Err("getSg162",""+ci,si,oi); /* print errormessage */
                    break lt6$2; } /* terminate processing of entry */
                  if(cSgT.chgDrSt(ci,null)!=null) { /* 'SignalDrawState'-entry is already defined */
                    Lg.Err("getSg166",""+ci,si,oi); /* print errormessage */
                    break lt6$2; } /* terminate processing of entry */
                  js = cB.getVal(1); /* get name of 'SignalDrawState'-definition */
                  if(js==null) { /* error found within current input */
                    if((js=cB.getErr())==null) { /* EOF within data */
                      Lg.Err("getSg163",cSgT.getNme(),si,oi,ci); /* print errormessage */
                      cc = 155; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    Lg.Err("getSg164",js,si,oi,ci); /* print errormessage */
                    break lt6$2; } /* terminate processing of entry */
                  if(js.length()==0) { /* name not found */
                    Lg.Err("getSg165",""+ci,si,oi); /* print errormessage */
                    break lt6$2; } /* terminate processing of entry */
                  cSgDrS = new TSSigDrSt(ci,js); /* create current 'SignalDrawState'-Definition */
                  while(true) { /* check all following keywords for attributes */
                    is = cB.getKE(true); /* get next controlword */
                    if(is==null) { /* error found within current input */
                      if((is=cB.getErr())==null) { /* EOF within data */
                        Lg.Err("getSg171",cSgT.getNme(),si,oi,ci); /* print errormessage */
                        cc = 156; /* set current return-code to error */
                        break bl; } /* terminate evaluation */
                      Lg.Err("getSg164",is,si,oi,ci); /* print errormessage */
                      break lt6$2; } /* terminate processing of entry */
                    if(is.length()==0) break; /* no more keywords found */
                    if(is.equals("drawlights")) { /* Definition-type: 'DrawLights' */
                      if((kc%11)!=0) { /* referred 'SignalLight'-definition was still not found */
                        Lg.Err("getSg190",""+ci,si,oi); /* print errormessage */
                        break lt6$2; } /* terminate processing of entry */
                      xc = (int)cB.getNV(); /* get number of 'DrawLight'-definitions */
                      if((is=cB.getErr())!=null) { /* error while evaluating */
                        Lg.Err("getSg181",is,si,oi,ci,cB.getStat(true)); /* print errormessage */
                        Lg.Err("getSg498",cSgT.getNme(),si); /* print extension */
                        cc = 157; /* set current return-code to error */
                        break bl; } /* terminate evaluation */
                      if(xc<1) { /* invalid value for number of 'DrawLights' */
                        Lg.Err("getSg182",""+xc,si,oi,ci); /* print errormessage */
                        break lt6$2; } /* terminate processing of entry */
                      if((i=cSgDrS.set$SgLi(xc))<0) { /* allocate storage for 'DrawLights' */
                        Lg.Err("getSg183",cSgT.getNme(),si,oi,xc,i); /* print errormessage */
                        cc = 158; /* set current return-code to error */
                        break bl; } /* terminate evaluation */
                      lt6$3:for(xi=0;xi<1000;xi+=1) { /* process all 'DrawLight'-definitions */
                        is = cB.getKE(true); /* get next keyword */
                        if(is==null) { /* error found within current input */
                          if((is=cB.getErr())==null) { /* EOF within data */
                            Lg.Err("getSg185",""+xi,si,oi,ci); /* print errormessage */
                            Lg.Err("getSg498",cSgT.getNme(),si); /* print extension */
                            cc = 159; /* set current return-code to error */
                            break bl; } /* terminate evaluation */
                          Lg.Err("getSg186",is,si,oi,xi,ci); /* print errormessage */
                          break lt6$2; } /* terminate processing of entry */
                        if(is.length()==0) { /* next keword not present */
                          if(xi>=xc) break lt6$3; /* all definitions processed */
                          Lg.Err("getSg187",""+xi,si,oi,ci); /* print errormessage */
                          break lt6$2; } /* terminate processing of entry */
                        if(!is.equals("drawlight")) { /* no entry 'DrawLight' */
                          Lg.Err("getSg188",is,si,oi,xi,ci); /* print errormessage */
                          break lt6$2; } /* terminate processing of entry */
                        if(xi>=xc) { /* too many entries defined for 'DrawLight' */
                          Lg.Err("getSg189",""+xc,si,oi,xi,ci); /* print errormessage */
                          break lt6$2; } /* terminate processing of entry */
                        i = (int)cB.getNV(); /* get id of 'SignalLight'-reference */
                        if((is=cB.getErr())!=null) { /* error while evaluating */
                          Lg.Err("getSg191",is,si,oi,xi,ci); /* print errormessage */
                          break lt6$2; } /* terminate processing of entry */
                        if(i<0 || i>=cSgT.get$SgL(0)) { /* invalid id of 'SignalLight' */
                          Lg.Err("getSg192",""+i,si,oi,xi,ci); /* print errormessage */
                          break lt6$2; } /* terminate processing of entry */
                        if((cSgSgL=cSgT.chgSgL(i,null))==null) { /* ger reference from Type-Def. */
                          Lg.Err("getSg193",""+i,si,oi,xi,ci); /* print errormessage */
                          break lt6$2; } /* terminate processing of entry */
                        cSgDrS.chgLight(xi,cSgSgL); /* insert 'SignalLight'-Reference */
                        cSgSgL.incCnt(1); /*  into Drawstate and count it */
                        is = cB.getKE(true); /* try to get next keyword */
                        if(is==null) { /* error found within current input */
                          if((is=cB.getErr())==null) { /* EOF within data */
                            Lg.Err("getSg201",cSgT.getNme(),si,oi,xi,ci); /* print errormessage */
                            cc = 160; /* set current return-code to error */
                            break bl; } /* terminate evaluation */
                          Lg.Err("getSg202",is,si,oi,xi,ci); /* print errormessage */
                          break lt6$2; } /* terminate processing of entry */
                        if(is.length()>0) { /* keword was found -- process it */
                          if(!is.equals("signalflags")) { /* no entry 'SignalFlags' */
                            Lg.Err("getSg203",is,si,oi,xi,ci); /* print errormessage */
                            break lt6$2; } /* terminate processing of entry */
                          is = cB.getVal(2); /* get name of option */
                          if(is==null) { /* error found within current input */
                            if((is=cB.getErr())==null) { /* EOF within data */
                              Lg.Err("getSg204",cSgT.getNme(),si,oi,xi,ci); /* print errormessage */
                              cc = 161; /* set current return-code to error */
                              break bl; } /* terminate evaluation */
                            Lg.Err("getSg205",is,si,oi,xi,ci); /* print errormessage */
                            break lt6$2; } /* terminate processing of entry */
                          if(!is.equals("flashing")) { /* value NOT valid */
                            Lg.Err("getSg206",is,si,oi,xi,ci); /* print errormessage */
                            break lt6$2; } /* terminate processing of entry */
                          cSgDrS.setLOpt(xi); /* insert option into 'SignalDrawstate' */
                          if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                            Lg.Err("getSg209",cSgT.getNme(),si,oi,xi,ci); /* print errormessage */
                            cc = 162; /* set current return-code to error */
                            break bl; } /* terminate evaluation */
                        } /* check and process the following keyword */
                        if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                          Lg.Err("getSg199",cSgT.getNme(),si,oi,xi,ci); /* print errormessage */
                          cc = 163; /* set current return-code to error */
                          break bl; } /* terminate evaluation */
                      } /* -lt6$3- 'DrawLight'-entry was (fully?) processed */
                    } else if(is.equals("semaphorepos")) { /* Definition-type: 'SemaphorePos' */
                      fx = cB.getFV(); /* get value of 'SemaphorePos' */
                      if((is=cB.getErr())!=null) { /* error while evaluating */
                        Lg.Err("getSg211",is,si,oi,ci,cB.getStat(true)); /* print errormessage */
                        break lt6$2; } /* terminate processing of entry */
                      cSgDrS.chgSPos(fx); /* insert value into 'SignalDrawstate' */
                    } else Lg.Err("getSg218",is,si,oi,ci); /* print errormessage */
                      /* unknown keyword -- print and ignore it */
                    if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                      Lg.Err("getSg219",cSgT.getNme(),si,oi,ci); /* print errormessage */
                      cc = 168; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                  } /* -while(true)- check and process all following keywords */
                  cSgT.chgDrSt(ci,cSgDrS); /* insert 'SignalDrawState'-reference into 'SignalType' */
                  GrpCnt -= 1; /* one (more) definitiongroup handled successfully */
                } /* -lt6$2- SignalDrawState-entry was (fully?) processed */
                if(cB.skpFwd(l4)) { /* skip resuming data to new entry -- EOF/error found? */
                  Lg.Err("getSg169",cSgT.getNme(),si,oi); /* print errormessage */
                  cc = 169; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
              } /* -lt6$1- whole 'SignalDrawState'-group is processed */
              cSgT.setMsk(7); /* mark that this entry was processed (successfully) */
              GrpCnt -= 1; /* one (more) definitiongroup handled successfully */
            } else if(is.equals("signalaspects")) lt7:{ /* definition: 'SignalAspects' */
              if((kc%17)==0) { /* keyword was already present */
                Lg.Err("getSg065","SignalAspects",si,cB.getStat(true)); /* print errormessage */
                GrpCnt += 1; /* mark: additional description neccessary */
                break lt7; } /* terminate processing of entry */
              kc *= 17; /* mark that an (erroneous) entry of this type was processed */
              if((kc%13)!=0) Lg.Err("getSg230",si); /* print errormessage */
              oc = (int)cB.getNV(); /* get number of 'SignalAspect'-definitions */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getSg231",is,cSgT.getNme(),""+si,""+cB.getStat(true)); /* print errormessage */
                cc = 171; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(oc<0 || oc>8) { /* invalid value for number of 'SignalAspects' */
                Lg.Err("getSg232",null,si,oc); /* print errormessage */
                break lt7; } /* terminate processing of entry */
              if((i=cSgT.get$SgA(oc))<0) { /* allocate storage for 'SignalAspects' */
                Lg.Err("getSg233",""+i,si,oc); /* print errormessage */
                Lg.Err("getSg498",cSgT.getNme(),si); /* print extension */
                cc = 172; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              GrpCnt += oc; /* more new definitiongroups must be handled */
              lt7$1:for(oi=0;oi<15;oi+=1) { /* process all 'SignalAspect'-definitions */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getSg235",cSgT.getNme(),si,oi); /* print errormessage */
                    cc = 173; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getSg236",is,si,oi); /* print errormessage */
                  break lt7; } /* terminate processing of entry */
                if(is.length()==0) { /* next keword not present */
                  if(oi==oc) break lt7$1; /* all definitions processed */
                  if(oi>oc) { /* additional definitions found (too many)  */
                    Lg.Err("getSg239",""+oc,si,oi); /* print errormessage */
                    GrpCnt -= oi - oc; /* more definitiongroups handled */
                  } else Lg.Err("getSg237",""+oc,si,oi); /* print errormessage */
                  break lt7; } /* terminate processing of entry */
                l4 = cB.getBrL(); /* current bracket-level for terminate */
                lt7$2: { /* break-block (used for 'SignalAspect'-investigation) */
                  if(!is.equals("signalaspect")) { /* no entry 'SignalAspect' */
                    Lg.Err("getSg238",is,si,oi); /* print errormessage */
                    break lt7$2; } /* terminate processing of entry */
                  js = cB.getVal(2); /* get id of 'SignalAspect'-definition */
                  if(js==null) { /* error found within current input */
                    if((js=cB.getErr())==null) { /* EOF within data */
                      Lg.Err("getSg241",cSgT.getNme(),si,oi); /* print errormessage */
                      cc = 174; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    Lg.Err("getSg242",js,si,oi); /* print errormessage */
                    break lt7$2; } /* terminate processing of entry */
                  if(js.length()==0) { /* id not found */
                    Lg.Err("getSg243",null,si,oi); /* print errormessage */
                    break lt7$2; } /* terminate processing of entry */
                  if(oi>=oc) break lt7$2; /* no further processing of additional def's */
                  if((i=TSSigAsp.chkTyp(js))<0) { /* 'SignalAspect'-id not known -- check number */
                    try {i = Integer.parseInt(js); /* try to convert id (name) into a number */
                    } catch (NumberFormatException e) { /* error found while converting */
                      Lg.Err("getSg244",js,si,oi); /* print errormessage */
                      break lt7$2; } /* terminate processing of entry */
                    if(i<0 || i>7) { /* range of converted id is invalid */
                      Lg.Err("getSg244",""+i,si,oi); /* print errormessage */
                      break lt7$2; } /* terminate processing of entry */
                  } /* 'SignalAspect'-id was not known */
                  js = cB.getVal(1); /* get 'SignalAspect'-name ('SignalDrawState'-reference) */
                  if(js==null) { /* error found within current input */
                    if((js=cB.getErr())==null) { /* EOF within data */
                      Lg.Err("getSg245",cSgT.getNme(),si,oi); /* print errormessage */
                      cc = 175; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    Lg.Err("getSg242",js,si,oi); /* print errormessage */
                    break lt7$2; } /* terminate processing of entry */
                  if(js.length()==0) { /* id not found */
                    Lg.Err("getSg246",null,si,oi); /* print errormessage */
                    break lt7$2; } /* terminate processing of entry */
                  xc = cSgT.get$SgD(-1); /* get number of 'SignalDrawState'-definitions */
                  lt7$3:{ /* break-block (search for 'SignalDrawState'-definition) */
                    for(xi=0;xi<xc;xi+=1) { /* compare all 'SignalDrawState'-definitions */
                      cSgDrS = cSgT.chgDrSt(xi,null); /* get 'SignalDrawState'-definition */
                      if(cSgDrS==null) continue; /* entry not used -- do not compare */
                      if(cSgDrS.chkNme(js)) break lt7$3; /* match found -- continue without error */
                    } /* compare to all possible definitions */
                    Lg.Err("getSg247",js,si,oi); /* print errormessage */
                    break lt7$2; /* terminate processing of entry */
                  } /* -lt7$3- if match found, processing continues here */
                  cSgA = new TSSigAsp(oi,i,cSgDrS); /* create 'SignalAspect'-Definition */
                  cSgDrS.incCnt(1); /* and count reference */
                  while(true) { /* check all following keywords for attributes */
                    is = cB.getKE(true); /* get next controlword */
                    if(is==null) { /* error found within current input */
                      if((is=cB.getErr())==null) { /* EOF within data */
                        Lg.Err("getSg251",cSgT.getNme(),si,oi); /* print errormessage */
                        cc = 176; /* set current return-code to error */
                        break bl; } /* terminate evaluation */
                      Lg.Err("getSg252",is,si,oi); /* print errormessage */
                      break lt7$2; } /* terminate processing of entry */
                    if(is.length()==0) break; /* no more keywords found */
                    if(is.equals("speedkph")) { /* Definition-type: 'SpeedKPH' */
                      i = (int)cB.getNV(); /* get speed-value */
                      if((is=cB.getErr())!=null) { /* error while evaluating */
                        Lg.Err("getSg261",is,si,oi,cB.getStat(true)); /* print errormessage */
                        break lt7$2; } /* terminate processing of entry */
                      if(cSgA.chkMsk(17)) { /* option already set to 'mile' */
                        Lg.Err("getSg262",""+i,si,oi);  /* print errormessage */
                        break lt7$2; } /* terminate processing of entry */
                      cSgA.setMsk(16); /* signal: speed is 'kilometer' */
                      cSgA.chgSpd(i); /* insert speed-value to 'SignalAspect'-definition */
                    } else if(is.equals("speedmph")) { /* Definition-type: 'SpeedMPH' */
                      i = (int)cB.getNV(); /* get speed-value */
                      if((is=cB.getErr())!=null) { /* error while evaluating */
                        Lg.Err("getSg265",is,si,oi,cB.getStat(true)); /* print errormessage */
                        break lt7$2; } /* terminate processing of entry */
                      if(cSgA.chkMsk(16)) { /* option already set to 'kilometer' */
                        Lg.Err("getSg266",""+i,si,oi);  /* print errormessage */
                        break lt7$2; } /* terminate processing of entry */
                      cSgA.setMsk(17); /* signal: speed is 'mile' */
                      cSgA.chgSpd(i); /* insert speed-value to 'SignalAspect'-definition */
                    } else if(is.equals("signalflags")) { /* Definition-type: 'SignalFlags' */
                      js = cB.getVal(2); /* get optionname */
                      if(js==null) { /* error found within current input */
                        if((js=cB.getErr())==null) { /* EOF within data */
                          Lg.Err("getSg271",cSgT.getNme(),si,oi); /* print errormessage */
                          cc = 177; /* set current return-code to error */
                          break bl; } /* terminate evaluation */
                        Lg.Err("getSg272",js,si,oi); /* print errormessage */
                        break lt7$2; } /* terminate processing of entry */
                      if(!js.equals("asap")) { /* invalid option - print and ignore */
                        Lg.Err("getSg273",js,si,oi); /* print errormessage */
                        break lt7$2; } /* terminate processing of entry */
                      cSgA.setMsk(18); /* insert option into 'SignalAspect'-definition */
                    } else Lg.Err("getSg257",is,si,oi); /* print errormessage */
                      /* unknown keyword -- print and ignore it */
                    if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                      Lg.Err("getSg258",cSgT.getNme(),si,oi); /* print errormessage */
                      cc = 188; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                  } /* -while(true)- check and process all following keywords */
                  cSgT.chgAsp(oi,cSgA); /* insert 'SignalAspect'-reference into 'SignalType' */
                  GrpCnt -= 1; /* one (more) definitiongroup handled successfully */
                } /* -lt7$2- 'SignalAspect'-entry was (fully?) processed */
                if(cB.skpFwd(l4)) { /* skip resuming data to new entry -- EOF/error found? */
                  Lg.Err("getSg259",cSgT.getNme(),si,oi); /* print errormessage */
                  cc = 189; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
              } /* -lt7$1- whole 'SignalAspect'-group is processed */
              cSgT.setMsk(8); /* mark that this entry was processed (successfully) */
              GrpCnt -= 1; /* one (more) definitiongroup handled successfully */
            } else if(is.equals("signalnumclearahead")) lt8:{ /* 'SignalNumClearAhead' */
              if((kc%19)==0) { /* keyword was already present */
                Lg.Err("getSg065","SignalNumClearAhead",si,cB.getStat(true)); /* print errormessage */
                GrpCnt += 1; /* mark: additional description neccessary */
                break lt8; } /* terminate processing of entry */
              kc *= 19; /* mark that an (erroneous) entry of this type was processed */
              i = (int)cB.getNV(); /* get 'SignalNumClearAhead'-number */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getSg281",is,cSgT.getNme(),""+si,""+cB.getStat(true)); /* print errormessage */
                cc = 191; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(i<0) { /* invalid value for 'SignalNumClearAhead'-number */
                Lg.Err("getSg282",null,si,i); /* print errormessage */
                break lt8; } /* terminate processing of entry */
              cSgT.chgNCA(i); /* insert new ClearAhead-value */
              cSgT.setMsk(9); /* mark that this entry was processed (successfully) */
              GrpCnt -= 1; /* one (more) definitiongroup handled successfully */
            } else if(is.equals("semaphoreinfo")) lt9:{ /* definition: 'SemaphoreInfo' */
              if((kc%23)==0) { /* keyword was already present */
                Lg.Err("getSg065","SemaphoreInfo",si,cB.getStat(true)); /* print errormessage */
                GrpCnt += 1; /* mark: additional description neccessary */
                break lt9; } /* terminate processing of entry */
              kc *= 23; /* mark that an (erroneous) entry of this type was processed */
              fx = cB.getFV(); /* get value of 'SemaphoreInfo' */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getSg285",is,si,cB.getStat(true)); /* print errormessage */
                Lg.Err("getSg498",cSgT.getNme(),si); /* print extension */
                cc = 201; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              if(fx<0.0) { /* invalid value for 'SemaphoreInfo' */
                Lg.Err("getSg286",""+si,fx); /* print errormessage */
                Lg.Err("getSg498",cSgT.getNme(),si); /* print extension */
                cc = 202; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              cSgT.chgSInf(fx); /* insert 'SemaphoreInfo' into 'SignalType' */
              cSgT.setMsk(3); /* mark that this entry was processed (successfully) */
              GrpCnt -= 1; /* one (more) definitiongroup handled successfully */
            } else Lg.Err("getSg066",is,si); /* print errormessage */
              /* unknown keyword -- print and ignore it */
            if(cB.skpFwd(l3)) { /* skip resuming data to new entry -- EOF/error found? */
              Lg.Err("getSg067",cSgT.getNme(),si,sc); /* print errormessage */
              cc = 107; /* set current return-code to error */
              break bl; } /* terminate evaluation */
          } /* -while(true)- check and process all following sub-definitions */
          if((kc%3)!=0) GrpCnt -= 1; /* This definitiongroup cannot create an error */
          if((kc%5)!=0) GrpCnt -= 1; /* This definitiongroup cannot create an error */
          if((kc%7)!=0) GrpCnt -= 1; /* This definitiongroup cannot create an error */
          if((kc%11)!=0) GrpCnt -= 1; /* This definitiongroup cannot create an error */
          if((kc%19)!=0) GrpCnt -= 1; /* This definitiongroup cannot create an error */
          if((kc%23)!=0) GrpCnt -= 1; /* This definitiongroup cannot create an error */
          if(GrpCnt!=0) Lg.Err("getSg497",cSgT.getNme(),si,GrpCnt); /* group-error */
          if((kc%442)!=0) { /* requested definitions (2,13,17) are NOT complete */
              Lg.Err("getSg068",null,si,kc); /* print errormessage */
              break stl; } /* do not store entry */
          SgTT.add(cSgT); /* activate new SignalType-definition (add to type-table) */
          /* check internal connections and print errors */
          if(hMsg) { /* do not print if not output requested */
            is = cSgT.getNme(); /* get name of record (used for error-messages) */
            oc = cSgT.get$SgL(0); /* get number of 'SignalLight'-definitions */
            for(oi=0;oi<oc;oi+=1) { /* check all definitions */
              cSgSgL = cSgT.chgSgL(oi,null); /* get current entry */
              if(cSgSgL==null) continue; /* definition is not valid due to error */
              if(cSgSgL.incCnt(0)==0) Lg.Log("getSg491",is,si,oi);
            } /* check all definitions */
            oc = cSgT.get$SgD(-1); /* get number of 'SignalDrawState'-definitions */
            for(oi=0;oi<oc;oi+=1) { /* check all definitions */
              cSgDrS = cSgT.chgDrSt(oi,null); /* get current entry */
              if(cSgDrS==null) continue; /* definition is not valid due to error */
              if(cSgDrS.incCnt(0)==0) Lg.Log("getSg492",is,si,oi);
            } /* check all definitions */
          } /* only if messageoutput requested */
        } else /* -stl- 'SignalType' is completely processed */
          Lg.Err("getSg069",si); /* additional 'SignalType'-definition found */
        if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
          Lg.Err("getSg006","SignalType"); /* print errormessage */
          cc = 248; /* set current return-code to error */
          break bl; } /* terminate evaluation */
      } /* -for- process all 'SignalType'-entries */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getSg006","SignalTypes"); /* print errormessage */
        cc = 249; /* set current return-code to error */
        break bl; } /* terminate evaluation */

      /* ---------- SignalShape ---------- */
      Lg.Skip(false); /* print empty line to LOG-file */
      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getSg501"); /* print errormessage */
          cc = 251; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getSg502",is); /* print errormessage */
        cc = 252; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getSg503"); /* print errormessage */
        cc = 253; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(!is.equals("signalshapes")) { /* entry 'SignalShapes' missing */
        Lg.Err("getSg504",is); /* print errormessage */
        cc = 254; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      l1 = cB.getBrL(); /* current bracket-level for terminate */
      sc = (int)cB.getNV(); /* get number of entries */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        Lg.Err("getSg505",is,cB.getStat(true)); /* print errormessage */
        cc = 255; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      SgShT = cRte.getSigS(sc); /* allocate SignalShape-Table */
      if(SgShT==null) { /* Table could not be created */
        Lg.Err("getSg506",sc); /* print errormessage */
        cc = 256; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      for(si=0;si<1000;si+=1) { /* process all 'SignalShape'-entries */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getSg511",si); /* print errormessage */
            cc = 261; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getSg512",is,si,cB.getStat(true)); /* print errormessage */
          cc = 262; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) { /* next keword not present */
          if(si>=sc) break; /* all definitions processed */
          Lg.Err("getSg513",si); /* print errormessage */
//          cc = 263; /* set current return-code to error */
          break; } /* terminate processing of entries */
        if(!is.equals("signalshape")) { /* no entry 'SignalShape' */
          Lg.Err("getSg514",is,si); /* print errormessage */
//          cc = 264; /* set current return-code to error */
          break; } /* terminate processing of entries */
        SgSOT = null; /* Compiler needs it */
        l2 = cB.getBrL(); /* current bracket-level for terminate */
        if(si<sc) shl:{ /* fully process 'SignalShape'-entry */
          js = cB.getVal(1); /* get filename of 'SignalShape' */
          if(js==null) { /* error found within current input */
            if((js=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getSg521",si); /* print errormessage */
              cc = 265; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getSg522",js,si,cB.getStat(true)); /* print errormessage */
            break shl; } /* terminate processing of entries */
          if(js.length()==0) { /* name not found */
            Lg.Err("getSg523",si); /* print errormessage */
            break shl; } /* terminate processing of entries */
          ks = cB.getVal(1); /* get description of 'SignalShape' */
          if(ks==null) { /* error found within current input */
            if((ks=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getSg521",si); /* print errormessage */
              cc = 266; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getSg522",ks,si,cB.getStat(true)); /* print errormessage */
            break shl; } /* terminate processing of entries */
          if(ks.length()==0) { /* name not found */
            Lg.Err("getSg525",si); /* print errormessage */
            break shl; } /* terminate processing of entries */
          if((cSgS=cRte.fndSigS(js))!=null) { /* 'SignalShape'-name is already defined */
            oi = SgShT.indexOf(cSgS); /* get already used index */
            Lg.Err("getSg526",js,si,oi); /* print errormessage */
            break shl; } /* terminate processing of entries */
          cSgS = new TSSigSh(js,ks); /* create 'SignalShape'-definition */
          if(Nme!=null) Nme.add(js); /* register file-name (shape) for checking */

          while(true) { /* read and process all following sub-definitions */
            is = cB.getKE(true); /* get next keyword */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getSg527",si); /* print errormessage */
                cc = 267; /* set current return-code to error */
                break bl; } /* terminate evaluation */
              Lg.Err("getSg522",is,si,sc); /* print errormessage */
              break shl; } /* terminate processing of entries */
            if(is.length()==0) break; /* no more definitions */
            l3 = cB.getBrL(); /* current bracket-level for terminate */
            if(is.equals("signalflags")) shl$1:{ /* entry: 'SignalFlags' */
              while(true) { /* process all keywords of 'SignalFlags' */
                is = cB.getVal(2); /* get keyword for 'SignalFlag' */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getSg531",si); /* print errormessage */
                    cc = 271; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getSg532",is,si,cB.getStat(true)); /* print errormessage */
                  break shl$1; } /* terminate processing of entry */
                if(is.length()==0) break; /* all SignalFlag-definitions are processed */
//                else { /* name of 'SignalFlag' is not known -- print message */
                Lg.Err("getSg533",is,si,cB.getStat(true)); /* print errormessage */
//                  break shl$1; } /* terminate processing of entry */
              } /* keyword was investigated */
              is = "SignalFlags"; /* preset keywordname for next errormessage */
            } else if(is.equals("signalsubobjs")) shl$2:{ /* entry: 'SignalSubObjs' */
              oc = (int)cB.getNV(); /* get number of 'SignalSubObj'-definitions */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err("getSg551",is,si,cB.getStat(true)); /* print errormessage */
                break shl$2; } /* terminate processing of entry */
              if(oc<1 || oc>TSSignal.K_MaxIt) { /* invalid value for number of 'SignalSubObjs' */
                Lg.Err("getSg552",""+cB.getStat(true),si,oc); /* print errormessage */
                break shl$2; } /* terminate processing of entry */
              SgSOT = cSgS.getSOT(oc); /* allocate storage for 'SignalSubObjs' */
              if(SgSOT==null) { /* error while allocating */
                Lg.Err("getSg554",null,si,oc); /* print errormessage */
                break shl; } /* terminate processing of entries */
              for(oi=0;oi<TSSignal.K_MaxIt;oi+=1) { /* process all 'SignalSubObj'-definitions */
//                cSgO = null; /* preset 'SignalSubObj'-definition (dummy) */
                is = cB.getKE(true); /* get next controlword */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getSg555",""+cB.getStat(true),si,oi); /* print errormessage */
                    cc = 281; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getSg556",is,si,oi); /* print errormessage */
                  break shl$2; } /* terminate processing of entry */
                if(is.length()==0) break; /* next keword not present -- end of definitions */
                if(!is.equals("signalsubobj")) { /* entry 'SignalSubObj' missing */
                  Lg.Err("getSg558",is,si,oi); /* print errormessage */
                  break shl$2; } /* terminate processing of entry */
                i = (int)cB.getNV(); /* get number of current 'SignalSubObj' */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  Lg.Err("getSg561",is,si,oi,cB.getStat(true)); /* print errormessage */
                  break shl$2; } /* terminate processing of entry */
                if(i!=oi) { /* invalid number of 'SignalSubObj' (index) */
                  Lg.Err("getSg562",""+i,si,oi); /* print errormessage */
                  break shl$2; } /* terminate processing of entry */
                is = cB.getVal(1); /* get objectname of 'SignalSubObj' */
                if(is==null) { /* error found within current input */
                  if((is=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getSg563",""+cB.getStat(true),si,oi); /* print errormessage */
                    cc = 282; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getSg564",is,si,oi,cB.getStat(true)); /* print errormessage */
                  break shl$2; } /* terminate processing of entry */
                /* Attention: String of length 0 is allowed! */
                js = cB.getVal(1); /* get description of 'SignalSubObj' */
                if(js==null) { /* error found within current input */
                  if((js=cB.getErr())==null) { /* EOF within data */
                    Lg.Err("getSg565",""+cB.getStat(true),si,oi); /* print errormessage */
                    cc = 283; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                  Lg.Err("getSg564",js,si,oi,cB.getStat(true)); /* print errormessage */
                  break shl$2; } /* terminate processing of entry */
                if(js.length()==0) Lg.Err("getSg566",null,si,oi);
                  /* description not found or empty */
                if(js.trim().length()==0) { /* description only contains blanks */
                  if(hMsg) Lg.Log("getSg567",js,si,oi); /* print warning */
                  js = " "; /* set new desription, probably shortened */
                } /* description only contains blanks */
                cSgO = new TSSigSObj(oi,is,js); /* create 'SignalSubObj'-definition */
                while(true) { /* check all following keywords for attributes */
                  is = cB.getKE(true); /* get next controlword */
                  if(is==null) { /* error found within current input */
                    if((is=cB.getErr())==null) { /* EOF within data */
                      Lg.Err("getSg571",null,si,oi); /* print errormessage */
                      cc = 284; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    Lg.Err("getSg572",is,si,oi); /* print errormessage */
                    break shl$2; } /* terminate processing of entry */
                  if(is.length()==0) break; /* no more keywords found */
                  if(is.equals("sigsubtype")) ls1:{ /* sub-entry: 'SigSubType' */
                    is = cB.getVal(2); /* get type of 'SignalSubObj' */
                    if(is==null) { /* error found within current input */
                      if((is=cB.getErr())==null) { /* EOF within data */
                        Lg.Err("getSg581",null,si,oi); /* print errormessage */
                        cc = 285; /* set current return-code to error */
                        break bl; } /* terminate evaluation */
                      Lg.Err("getSg582",is,si,oi); /* print errormessage */
                      break ls1; } /* terminate processing of entry */
                    if(is.length()==0) { /* name not found */
                      Lg.Err("getSg583",null,si,oi); /* print errormessage */
                      break ls1; } /* terminate processing of entry */
                    if((i=TSSigSObj.chkTyp(is))<0) { /* unknown type of 'SignalSubObj' */
                      Lg.Err("getSg584",is,si,oi);  /* print errormessage */
                      break ls1; } /* terminate processing of entry */
                    cSgO.chgTyp(i); /* insert type of 'SignalSubObj'-entry */
                  } else if(is.equals("sigsubstype")) ls2:{ /* sub-entry: 'SigSubSType' */
                    is = cB.getVal(1); /* get name of connected 'SignalType' */
                    if(is==null) { /* error found within current input */
                      if((is=cB.getErr())==null) { /* EOF within data */
                        Lg.Err("getSg591",null,si,oi); /* print errormessage */
                        cc = 286; /* set current return-code to error */
                        break bl; } /* terminate evaluation */
                      Lg.Err("getSg592",is,si,oi); /* print errormessage */
                      break ls2; } /* terminate processing of entry */
                    if(is.length()==0) { /* name not found */
                      Lg.Err("getSg593",null,si,oi); /* print errormessage */
                      break ls2; } /* terminate processing of entry */
                    cSgT = cRte.fndSigT(is); /* search for connected 'SignalType'-entry */
                    if(cSgT==null) { /* connected definition not found */
                      Lg.Err("getSg594",is,si,oi); /* print errormessage */
                      break ls2; } /* terminate processing of entry */
                    cSgO.chgSigT(cSgT); /* insert 'SignalType'-name */
                    cSgT.incCnt(1);     /* and count reference */
                    if(cSgO.chgTyp(-1)!=TSSigSObj.Tp_SHead) Lg.Err("getSg595",is,si,oi);
                      /* SignalType do NOT fit to 'SigSubSType' -- print error */
                    if((is=cSgT.chkName(is))!=null) if(hMsg) Lg.Log("getSg596",is,si,oi);
                  } else if(is.equals("signalflags")) ls3:{ /* sub-entry: 'SignalFlags' */
                    while(true) { /* process all keywords of 'SignalFlags' */
                      is = cB.getVal(2); /* get keyword for 'SignalFlag' */
                      if(is==null) { /* error found within current input */
                        if((is=cB.getErr())==null) { /* EOF within data */
                          Lg.Err("getSg601",null,si,oi); /* print errormessage */
                          cc = 287; /* set current return-code to error */
                          break bl; } /* terminate evaluation */
                        Lg.Err("getSg602",is,si,oi); /* print errormessage */
                        break ls3; } /* terminate processing of entry */
                      if(is.length()==0) break; /* all options are processed */
                      if(is.equals("optional")) { /* option is valid -- check it */
                        if(cSgO.isOpt(2)) Lg.Err("getSg603","Optional",si,oi);
                        cSgO.setOpt(2); /* mark: option was specified */
                      } else if(is.equals("default")) { /* option is valid -- check it */
                        if(cSgO.isOpt(3)) Lg.Err("getSg603","Default",si,oi);
                        cSgO.setOpt(3); /* mark: option was specified */
                      } else if(is.equals("back_facing")) { /* option is valid -- check it */
                        if(cSgO.isOpt(5)) Lg.Err("getSg603","Back_Facing",si,oi);
                        cSgO.setOpt(5); /* mark: option was specified */
                      } else if(is.equals("jn_link")) { /* option is valid -- check it */
                        if(cSgO.isOpt(7)) Lg.Err("getSg603","JN_Link",si,oi);
                        cSgO.setOpt(7); /* mark: option was specified */
                      } else Lg.Err("getSg604",is,si,oi); /* not known -- print errormessage */
                    } /* keyword was investigated */
                  } else if(is.equals("sigsubjnlinkif")) ls4:{ /* sub-entry: 'SigSubJnLinkIf' */
                    xc = (int)cB.getNV(); /* get number of link-references */
                    if((is=cB.getErr())!=null) { /* error while evaluating */
                      Lg.Err("getSg611",is,si,oi); /* print errormessage */
                      cc = 288; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    if(xc<1 || xc>31) { /* there must be min. one reference */
                      Lg.Err("getSg612",""+xc,si,oi); /* print errormessage */
                      break ls4; } /* terminate processing of entry */
                    if((SgJN=cSgO.getJNRef(xc))==null) { /* allocate storage for link-ref's */
                      Lg.Err("getSg613",null,si,oi); /* print errormessage */
                      cc = 289; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    for(xi=0;xi<TSSignal.K_MaxIt;xi+=1) { /* load all JN-references */
                      i = (int)cB.getNV(); /* get number of link-references */
                      if((is=cB.getErr())!=null) { /* error while evaluating */
                        if(i==-1) break; /* all JN-references loaded */
                        Lg.Err("getSg614",is,si,oi,xi,cB.getStat(true)); /* print errormessage */
                        cc = 290; /* set current return-code to error */
                        break bl; } /* terminate evaluation */
                      if(i<0 || i>=oc) { /* reference-value valid? */
                        Lg.Err("getSg615",""+i,si,oi,xi); /* print errormessage */
                        break ls4; } /* terminate processing of entry */
                      if(i==oi) { /* no back-reference allowed */
                        Lg.Err("getSg616",""+xi,si,oi); /* print errormessage */
                        break ls4; } /* terminate processing of entry */
                      cRef = new TSRefC(i); /* create reference-control */
                      SgJN.add(cRef); /* and insert(add) new JN-reference */
                    } /* -for- process all JN-references */
                    if((i=SgJN.size())!=xc) /* number of entries (expected--found) do not match */
                      Lg.Err("getSg617",""+i,si,oi,xc); /* print errormessage */
                  } else if(is.equals("sigsubrequires")) ls5:{ /* 'SigSubRequires' */
                    i = (int)cB.getNV(); /* get number of required reference */
                    if((is=cB.getErr())!=null) { /* error while evaluating */
                      Lg.Err("getSg621",is,si,oi); /* print errormessage */
                      cc = 291; /* set current return-code to error */
                      break bl; } /* terminate evaluation */
                    if(i<0 || i>=oc) { /* reference-value valid? */
                      Lg.Err("getSg622",""+i,si,oi); /* print errormessage */
                      break ls5; } /* terminate processing of entry */
                    if(i==oi) { /* no back-reference allowed */
                      Lg.Err("getSg623",""+i,si,oi); /* print errormessage */
                      break ls5; } /* terminate processing of entry */
                    cRef = new TSRefC(i); /* create reference-control */
                    if((cRef=cSgO.chgReq(cRef))!=null) /* required reference was already set */
                      Lg.Err("getSg624",""+cRef.chgNr(Integer.MIN_VALUE),si,oi,i);
                  } else { /* unknown keyword -- print error and terminate */
                    Lg.Err("getSg573",is,si,oi); /* print errormessage */
                    break shl$2; } /* terminate processing of entry */
                  if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                    Lg.Err("getSg579",is,si,oi); /* print errormessage */
                    cc = 298; /* set current return-code to error */
                    break bl; } /* terminate evaluation */
                } /* -while(true)- check and process all following keywords */
                if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
                  Lg.Err("getSg569",null,si,oi); /* print errormessage */
                  cc = 299; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                SgSOT.add(cSgO); /* insert new Signal-Subobjekt into object-table */
              } /* -for- process all 'SignalSubObj'-definitions */
              is = cB.getVal(1); /* additional data found ? */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err("getSg559",si); /* print errormessage */
                  cc = 297; /* set current return-code to error */
                  break bl; } /* terminate evaluation */
                Lg.Err("getSg553",is,si,cB.getStat(true)); /* print errormessage */
              } else if(is.length()!=0) Lg.Err("getSg560",is,si); /* data found -- print it */
              if((i=SgSOT.size())!=oc) /* number of entries (expected--found) do not match */
                Lg.Err("getSg557",""+i,si,oc); /* print errormessage */
              is = "SignalSubObjs"; /* preset keywordname for next errormessage */
            } else Lg.Err("getSg528",is,si); /* print errormessage */
              /* unknown keyword -- print and ignore it */
            if(cB.skpFwd(l3)) { /* skip resuming data to new entry -- EOF/error found? */
              Lg.Err("getSg006",is); /* print errormessage */
              cc = 269; /* set current return-code to error */
              break bl; } /* terminate evaluation */
          } /* -while(true)- check and process all following sub-definitions */
          /* resolve internal references (JN) (number to address) */
          oc = SgSOT.size(); /* get number of subobject-definitions */
          for(oi=0;oi<oc;oi+=1) { /* process all reference-entries */
            cSgO = SgSOT.get(oi); /* get current subobject */
            if(cSgO==null) continue; /* subobject is not available due to error */
            SgJN = cSgO.getJNRef(0); /* get current list of JN-References */
            if(SgJN!=null && (xc=SgJN.size())>0) { /* subobject contains JN-references */
              for(xi=0;xi<xc;xi+=1) { /* process all JN-references of subdefinition */
                cRef = SgJN.get(xi); /* get current JN-Reference-definition */
                i = cRef.chgNr(Integer.MIN_VALUE); /* get number of requested reference */
                if(i>=SgSOT.size()) continue; /* requested reference not found -- skip */
                cRef.chgRef(SgSOT.get(i)); /* insert JN-Reference-address */

//                if(cRef.chgRef(null)==null) continue; /* NO VALID address inserted */
//                if(!((TSSigSObj)cRef.chgRef(null)).isOpt(2)) { /* only if ref. is NOT OPTIONAL */
//                  if(!cSgO.isOpt(7)) { /* JN-Link-reference is not set */
//                    if(wMsg) Lg.Log("getSg699",""+xi,si,oi); /* print action */
//                    cSgO.setOpt(7); /* set option */
//                  } /* JN-link-reference WAS not set */
//                } /* Reference is NOT optional */
// Attention:     Signalsubsystem loops endless if 'SignalFlags ( JN_LINK )' is active with
//                  valid SIGNAL_HEAD and 'SigSubJnLinkIf ( )'

              } /* process all existing JN-references */
            } /* min one JN-reference exists */
            if((cRef=cSgO.chgReq(null))!=null) rqr:{ /* required reference-address available */
              i = cRef.chgNr(Integer.MIN_VALUE); /* get number of requested reference */
              if(i>=SgSOT.size()) break rqr; /* requested reference not found */
              cRef.chgRef(SgSOT.get(i)); /* insert address-value */
            } /* -rqr- address-reference now inserted */
          } /* process all subobject-definitions */
          SgShT.add(cSgS); /* activate SignalShape-Definition (insert into table) */
        } else /* -shl- 'SignalShape' is completely processed */
          Lg.Err("getSg515",si); /* additional 'SignalShape'-definition found */
        if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
          Lg.Err("getSg006","SignalShape"); /* print errormessage */
          cc = 258; /* set current return-code to error */
          break bl; } /* terminate evaluation */
      } /* -for- process all 'SignalShape'-entries */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getSg006","SignalShapes"); /* print errormessage */
        cc = 259; /* set current return-code to error */
        break bl; } /* terminate evaluation */

      /* check internal connections and print existing errors */
      Lg.Skip(false); /* print empty line to LOG-file */
      cI = SgTT.iterator(); /* get iterator of 'SignalType'-definitions */
      si = 0; /* initialize number of 'Signaltype'-entry */
      while(cI.hasNext()) { /* process all 'SignalType'-definitions */
        cSgT = (TSSigTyp)cI.next(); /* get next 'SignalType'-definition */
        si += 1; /* and count it */
        if(cSgT==null) continue; /* definiton not present due to error */
        if(cSgT.incCnt(0)==0) Lg.Log("getSg791",cSgT.getNme(),si);
          /* print errormessage if definition is still not referenced */
      } /* check all definitions */
      cI = SgX.iterator(); /* get iterator of 'LightTexture'-definitions */
      si = 0; /* initialize number of 'LightTexture'-entry */
      while(cI.hasNext()) { /* process all 'LightTexture'-definitions */
        cSgX = (TSSigLTx)cI.next(); /* get next 'LightTexture'-definition */
        si += 1; /* and count it */
        if(cSgX==null) continue; /* definiton not present due to error */
        if(cSgX.incCnt(0)==0) Lg.Log("getSg792",cSgX.chgNme(null),si);
          /* print errormessage if definition is still not referenced */
      } /* check all definitions */
      cI = SgL.iterator(); /* get iterator of 'LightTab'-definitions */
      si = 0; /* initialize number of 'LightTab'-entry */
      while(cI.hasNext()) { /* process all 'LightTab'-definitions */
        cSgL = (TSSigLgt)cI.next(); /* get next 'LightTab'-definition */
        si += 1; /* and count it */
        if(cSgL==null) continue; /* definiton not present due to error */
        if(cSgL.incCnt(0)==0) Lg.Log("getSg793",cSgL.chgNme(null),si);
          /* print errormessage if definition is still not referenced */
      } /* check all definitions */

      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) { /* EOF within data */
          Lg.Err("getSg901"); /* print errormessage */
          cc = 801; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        Lg.Err("getSg902",is); /* print errormessage */
        cc = 802; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getSg903"); /* print errormessage */
        cc = 803; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(!is.equals("scriptfiles")) { /* entry 'ScriptFiles' missing */
        Lg.Err("getSg904",is); /* print errormessage */
        cc = 804; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      l1 = cB.getBrL(); /* current bracket-level for terminate */
      SgF = cRte.getSigF(5); /* allocate storage for 'ScriptFiles' */
      for(si=0;si<1000;si+=1) { /* process all 'ScriptFile'-entries */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getSg905",si); /* print errormessage */
            cc = 805; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getSg902",is,si); /* print errormessage */
          cc = 806; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) break; /* no more definitions */
        if(!is.equals("scriptfile")) { /* no entry 'ScriptFile' */
          Lg.Err("getSg906",is,si); /* print errormessage */
          break; } /* terminate processing of entries */
        js = cB.getVal(1); /* get filename of scriptfile */
          /* Attention: if filename contains ')' or '('
           *            it must be surrounded by quotes */
        if(js==null) { /* error found within current input */
          if((js=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getSg907",si); /* print errormessage */
            cc = 807; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getSg908",js,si); /* print errormessage */
          break; } /* terminate processing of entry */
        if(js.length()==0) { /* filename is empty or 'not found' */
          Lg.Err("getSg909",si); /* print errormessage */
          break; } /* terminate processing of entry */
        if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
          Lg.Err("getSg006","ScriptFile"); /* print errormessage */
          cc = 808; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        cSgF = new TSSigFle(js); /* create new Signal-Script-Definition */
        is = js.toLowerCase(); /* convert for key-creation */
        if(is.endsWith(".dat")) is = is.substring(0,is.length()-4); /* file without suffix */
         else if(is.endsWith(".")) is = is.substring(0,is.length()-1);
         else if((i=is.lastIndexOf("."))>0) /* get position of last separator */
          is = is.substring(i+1).toUpperCase() + "$" + is.substring(0,i);
            /* create key: suffix(UC) + '$' + file without suffix */
        /* '.dat' is removed and if not found, a special key is created */
        if(SgF.containsKey(is)) Lg.Err("getSg910",js,is,si);
          /* current script-definition already present -- print error */
        else SgF.put(is,cSgF); /* activate current definition (store it) */
      } /* -for- process all 'ScriptFile'-entries */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getSg006","ScriptFiles"); /* print errormessage */
        cc = 811; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(SgF.isEmpty()) Lg.Err("getSg911"); /* no scriptfile-definition found */
    } /* -bl- break-block used in case of error */
    is = cF.close(); /* close input-file */
    if(is!=null) Lg.Err("getSg004",is); /* print errormessage */

    if(cc>0) { /* error occurred while loading of signal-file */
      Lg.Skip(true); /* print empty line (screen and LOG-file) */
      Lg.Msg("getSg007",dat.getPath(),cc,0); /* print term-message */
      return 9; /* terminate program */
    } /* severe error was found */

    return 0; /* method successfully ended */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getSScr"
  * Signalscript-Definitionen einlesen, Existenz markieren
  * ##getSScr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getSScr( /* read Signal-Scripts */
   TSRoute cRte, /* current route-definition */
   TSRoute sRte) /* reoute-definition used for (file-)input */
   {
   /*-----------------------------------------------------------------*/
    File                dat;   /* current script-file */
    TSFile              cF;    /* current buffered inputfile */
    TSBuf               cB;    /* current input-buffer */
    ArrayList<TSSigTyp> SgT;   /* current SignalType-Table */
    TSSigFle            cSgF;  /* aktuelle Script-File-Definition */
    TSSigTyp            cSgT;  /* aktuelle Typ-Definition */
    int                 ec,z1,z2,z3,z4; /* (error-) counter */
    String              is,js; /* Arbeitswert */
    Iterator<TSSigFle>  cI;    /* Iterator for all script-files */
   /*=================================================================*/
    cI = cRte.getIt(20); /* alle Script-Definitionen bearbeiten */
    if(cI==null) { /* keine Script-Dateien registriert */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("getSgS01"); /* Fehlermeldung ausgeben */
      return 5; /* System beenden */
    } /* logischer Fehler */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("getSgS02",cRte.getInfo(1)); /* Aktion melden */

    ec = 0; /* no errors found */
    z1 = z2 = z3 = 0; /* initialize counters */
    while(cI.hasNext()) { /* Weitere Signalscript-Definitionen vorhanden */
      cSgF = cI.next(); /* naechste Signalscript-Definition */
      if(cSgF==null) throw new IllegalStateException( /* Sicherheitsabfrage */
        TSLogg.getMsg("Msg908","TSSigFle==null","TSUtil.getSScr()",0));
      z1 += 1; /* count overall number of files */
      dat = cSgF.getFile(sRte,1); /* vollstaendige Referenz holen */
      if(dat==null) throw new IllegalStateException( /* Sicherheitsabfrage */
        TSLogg.getMsg("Msg908","File==null","TSUtil.getSScr()",0));
      js = dat.getAbsolutePath(); /* vollstaendiger Name */
      if(dat.isDirectory()) { /* es liegt keine Datei vor */
        Lg.Msg("getSgS03",js,DF2.format(z1)); /* Meldung */
        continue; /* naechste Datei nutzen */
      } /* Datei ist ein Verzeichnis */
      if(!dat.exists()) { /* Datei existiert nicht */
        Lg.Msg("getSgS04",js,DF2.format(z1)); /* Meldung */
        continue; /* naechste Datei nutzen */
      } /* Datei nicht vorhanden */
      z3 += 1; /* (gueltige) Script-Datei zaehlen */
      Lg.Log("getSgS05",js,DF2.format(z1)); /* Aktionsmeldung ausgeben */

      z4 = 0; /* init number of script-definitions within file */
      cF = new TSFile(dat); /* create reader (buffered) and init counter */
      if((is=cF.open(TSFile.IA))!=null) { /* open file (input,ASCII) -- error? */
        Lg.Err("getSgS06",is,js); /* print errormessage */
        return 6; /* and terminate function with errorcode */
      } /* file-open-error */
      cB = new TSBuf(cF,null); /* initialize inputbuffer (mode='line') */
      while(!cB.getNext(false)) { /* read all lines until EOF */
        is = cB.getVal(2); /* get first word within line */
        if(is==null) continue; /* skip empty line */
        if(!is.equals("script")) continue; /* NO Script-Statement found */
        is = cB.getVal(1); /* get next word within line (name of script) */
        if(is==null) { /* EOL found: script-name missing */
          Lg.Err("getSgS07",cB.getStat(true)); /* print errormessage */
          ec += 1; /* count error */
          continue; } /* continue with next line */
        if(is.length()==0) { /* name of script is invalid */
          Lg.Err("getSgS08",cB.getStat(true)); /* print errormessage */
          ec += 1; /* count error */
          continue; } /* continue with next line */
        z4 += 1; /* count valid Signalscripts */
        if(cRte.get$SgT(false)>0) { /* type-definitions loaded -- continue */
          cSgT = cRte.fndSigT(is); /* search type-definition with same name */
          if(cSgT==null) { /* appropriate type-definition NOT found */
            if(EnaW) Lg.Log("getSgS09",is); /* print errormessage */
            ec += 1; /* count error */
          } else { /* type-definition found -- already used? */
            if(cSgT.chkMsk(16)) Lg.Err("getSgS10",is); /* print errormessage */
              /* script of this type-definition already found and assigned */
            cSgT.setMsk(16); /* set marker: script of type-def. was found */
          } /* type-definition found */
        } else if(EnaW) Lg.Msg("getSgS11",is); /* print errormessage */
      } /* -while- read all script-lines  */
      if((is=cB.getErr())!=null) Lg.Err("getSgS06",is,js); /* print error */
      cF.close(); /* close script-file again */

      z2 += z4; /* compute overall number of scripts */
      Lg.Log("getSgS12",z4); /* Aktionsmeldung ausgeben */
    } /* -while- process all requested script-files */

    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("getSgS13",null,z2,z3); /* Aktionsmeldung ausgeben */
    Lg.Skip(false); /* Leerzeile loggen */

    SgT = cRte.getSigT(0); /* get table of Signal-Type-Definitions */
    z2 = 0; /* preset number of errors */
    for(z1=0;z1<SgT.size();z1+=1) { /* check all type-entries */
      cSgT = SgT.get(z1); /* get current Signaltype-Entry */
      if(cSgT==null) continue; /* invalid entry -- skip it */
      if(cSgT.chkMsk(16)) continue; /* Scriptfile assigned -- OK */
      Lg.Err("getSgS21",cSgT.getNme(),z1); /* print errormessage */
      z2 += 1; /* count error */
    } /* all Signal-Type-Entries were checked */
    if(z2>0) { /* errors found -- print summary */
      Lg.Skip(true); /* add empty output-line */
      Lg.Msg("getSgS22",z2); /* print errormessage */
      Lg.Skip(false); /* add empty output-line */
    } /* summary was printed */
    return ec; /* Modul beenden -- Ergebnis zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "putSCfg"
  * Signal-Konfigurationsdatei modifiziert neu erstellen
  * ##putSCfg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int putSCfg( /* Signal-Konfiguration neu schreiben */
   TSRoute cRte, /* Routendefinition mit Basisverzeichnis */
   File    datz) /* Dateidefinition Zwischendatei oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    File      dats;   /* Dateidefinition fuer I/O */
    TSFileX   cF;     /* aktuelle Signal-Datei (Ausgabe) */
    TSSigSh   cSgS;   /* aktueller SignalShape */
    TSSigSObj cSgO;   /* aktuelles SignalSubobjekt (Shape) */
    TSSigTyp  cSgT;   /* aktueller SignalTyp */
    TSSigSgL  cSgSgL; /* aktueller SignalLight-Eintrag */
    TSSigDrSt cSgDrS; /* aktueller SignalDrawState-Eintrag */
    TSSigAsp  cSgA;   /* aktuelle SignalAspect-Definition */
    TSSigLTx  cSgX;   /* aktuelle LightTexture (LightTex) */
    TSSigLgt  cSgL;   /* aktueller LightTab-Eintrag */
    TSSigFle  cSgF;   /* aktuelle Script-Datei-Definition */
    double    f;      /* Arbeitswert fuer Ausgabe */
    int       i,j,v,w,si,sc,ec,cc; /* Arbeitswerte */
    String    nn,rn,is;
    boolean   nOV;    /* Schreiben erfolgreich/Ueberschreiben */
    Iterator  cI;     /* allgemeiner Tabellen-Iterator */
    ArrayList<TSSigSObj> SgSOT; /* current SignalSubObject-Table */
    Iterator<String>     LneI;  /* Line-Iterator for output */
    ArrayList<String>    LneT;  /* Line-Table for output */
   /*=================================================================*/
    dats = cRte.getFile(21); /* Basisdatei holen */
    nn = dats.getAbsolutePath(); /* Name der nominalen Ausgabedatei */
    nOV = false; /* annehmen: Datei ueberschreiben */
    if(datz==null) { /* keine Zwischendatei -- Namen setzen */
      datz = cRte.getFile(51); /* Ausgabedatei holen */
      nn = datz.getAbsolutePath(); /* neue nominal-Name setzen */
      nOV = true; /* Originaldatei nicht ueberschreibbar */
    } /* keine Zwischendatei definiert */
    rn = datz.getAbsolutePath(); /* Name der realen Ausgabedatei */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("putSg001",nn); /* Aktionsmeldung */

    /* Signal-Datei fuer Ausgabe oeffnen */
    cF = new TSFileX(TSFileX.FT$sig,datz); /* Ausgabe-Steuerung erstellen */
    is = cF.open(true); /* Datei fuer Ausgabe oeffnen */
    if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("putSg002",is); /* Fehleraktion ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 7; /* terminate function with errorcode */
    } /* Fehler beim Oeffnen der Signal-Datei */

    ec = 0; /* Zaehler fuer Fehler initialisieren */
    LneT = new ArrayList<String>(10); /* create table for output-line-blocks */
      /* This list is normally empty. After it was filled with output-lines
       * and all lines have been processed, it MUST be cleared again. */
    bl: { /* block for error-break */
      w = cRte.get$SgLTx(false); /* Anzahl der 'LightTexture'-Definitionen */
      if(w>0) { /* Definitionen sind vorhanden */
        cc = 11; /* Kennzeichne Fehlerposition (praeventiv) */
        is = "LightTextures ( " + w; /* Basiszeile erstellen */
        if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
        cI = cRte.getIt(24); /* Iterator fuer Signal-LTexture-Tabelle holen */
        v = -1; /* laufende Nummer initialisieren */
        while(cI.hasNext()) { /* Weitere Signal-LTexture-Definitionen vorhanden */
          cSgX = (TSSigLTx)cI.next(); /* Light-Texture-Definition holen */
          v += 1; /* Eintrag zaehlen */
          if(cSgX==null) { /* Fehler -- Eintrag nicht definiert */
            Lg.Err("putSg011",v); /* Meldung ausgeben */
            ec += 1; /* Fehler zaehlen */
            continue; } /* mit naechstem Eintrag fortfahren */
          is = cSgX.crDef(true); /* Definitionszeile erzeugen */
          if(is==null) continue; /* tritt nicht auf (Sicherung) */
          /* Achtung: Ausgabe-zeile muss mindestens ein '\t' enthalten */
          if(is.charAt(0)!='\t') { /* Meldung statt Zeile erhalten */
            Lg.Err("putSg012",is,v,0); /* Meldung ausgeben */
            ec += 1; /* Fehler zaehlen */
            is = cSgX.crDef(false); /* Definitionszeile erzeugen */
          } /* Meldung bearbeitet */
          cc = 12; /* Kennzeichne Fehlerposition (praeventiv) */
          if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
        } /* alle Eintragselemente ausgeben */
        cc = 13; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(")"))!=null) break bl; /* Schreib-Fehler */
        cc = 14; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(null))!=null) break bl; /* Schreib-Fehler */
      } /* alle LightTexture-Definitionen wurden erstellt */

      w = cRte.get$SgLT(false); /* Anzahl der 'LightTab'-Definitionen */
      if(w>0) { /* Definitionen sind vorhanden */
        cc = 21; /* Kennzeichne Fehlerposition (praeventiv) */
        is = "LightsTab ( " + w; /* Basiszeile erstellen */
        if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
        cI = cRte.getIt(23); /* Iterator fuer Signal-Light-Tabelle holen */
        v = -1; /* laufende Nummer initialisieren */
        while(cI.hasNext()) { /* Weitere Signal-Light-Definitionen vorhanden */
          cSgL = (TSSigLgt)cI.next(); /* naechste Signal-Light-Definition */
          v += 1; /* Eintrag zaehlen */
          if(cSgL==null) { /* Fehler -- Eintrag nicht definiert */
            Lg.Err("putSg021",v); /* Meldung ausgeben */
            ec += 1; /* Fehler zaehlen */
            continue; } /* mit naechstem Eintrag fortfahren */
          is = cSgL.crDef(true); /* Definitionszeile erzeugen */
          if(is==null) continue; /* tritt nicht auf (Sicherung) */
          /* Achtung: Ausgabe-zeile muss mindestens ein '\t' enthalten */
          if(is.charAt(0)!='\t') { /* Meldung statt Zeile erhalten */
            Lg.Err("putSg022",is,v,0); /* Meldung ausgeben */
            ec += 1; /* Fehler zaehlen */
            is = cSgL.crDef(false); /* Definitionszeile erzeugen */
          } /* Meldung bearbeitet */
          cc = 22; /* Kennzeichne Fehlerposition (praeventiv) */
          if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
        } /* alle Eintragselemente ausgeben */
        cc = 23; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(")"))!=null) break bl; /* Schreib-Fehler */
        cc = 24; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(null))!=null) break bl; /* Schreib-Fehler */
      } /* alle LightsTab-Definitionen wurden erstellt */

      w = cRte.get$SgT(false); /* Anzahl der 'SignalType'-Definitionen */
      if(w>0) { /* Definitionen sind vorhanden */
        cc = 31; /* Kennzeichne Fehlerposition (praeventiv) */
        is = "SignalTypes ( " + w; /* Basiszeile erstellen */
        if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
        cI = cRte.getIt(22); /* Iterator fuer Signal-Type-Tabelle holen */
        v = -1; /* laufende Nummer initialisieren */
        while(cI.hasNext()) { /* Weitere Signal-Type-Definitionen vorhanden */
          cSgT = (TSSigTyp)cI.next(); /* naechste Signal-Type-Definition */
          v += 1; /* Eintrag zaehlen */
          if(cSgT==null) { /* Fehler -- Eintrag nicht definiert */
            Lg.Err("putSg031",v); /* Meldung ausgeben */
            ec += 1; /* Fehler zaehlen */
            continue; } /* mit naechstem Eintrag fortfahren */
          cc = 32; /* Kennzeichne Fehlerposition (praeventiv) */
          is = "\t_skip ( " + v +" ) "; /* Nummer des Signaltype voran */
          if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
          cc = 33; /* Kennzeichne Fehlerposition (praeventiv) */
          is = "\tSignalType ( " + TSUtil.addStr(cSgT.getNme());
          if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
          for(i=0;i<9;i+=1) { /* Alle Basiszeilen erzeugen */
            is = cSgT.crDef(i,true); /* Definitionszeile erzeugen */
            if(is==null) continue; /* Zeile nicht gueltig oder Fehler */
            /* Achtung: Ausgabe-zeile muss mindestens ein '\t' enthalten */
            if(is.charAt(0)!='\t') { /* Meldung statt Zeile erhalten */
              Lg.Err("putSg032",is,v,i); /* Meldung ausgeben */
              ec += 1; /* Fehler zaehlen */
              is = cSgT.crDef(i,false); /* Definitionszeile erzeugen */
            } /* Meldung bearbeitet */
            cc = 34 + i; /* Kennzeichne Fehlerposition (praeventiv) */
            if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
          } /* Vorlaufzeilen erzeugen */

          /* Signal-Light-Werte ausgeben */
          sc = cSgT.get$SgL(0); /* Anzahl der Light-Definitionen holen */
          if(sc>0) { /* Definitionen sind vorhanden */
            cc = 41; /* Kennzeichne Fehlerposition (praeventiv) */
            is = "\t\tSignalLights ( " + sc; /* Startzeile der Definitionen */
            if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
            for(si=0;si<sc;si+=1) { /* process all SignalLight-Definitions */
              cSgSgL = cSgT.chgSgL(si,null); /* aktuelles Unterelement holen */
              if(cSgSgL==null) { /* Fehler -- Eintrag nicht definiert */
                Lg.Err("putSg033",null,v,si); /* Meldung ausgeben */
                ec += 1; /* Fehler zaehlen */
                continue; } /* mit naechstem Eintrag fortfahren */
              LneI = cSgSgL.crDef(LneT); /* get signallight-definition */
              if(LneI==null) continue; /* no valid messages -- next entry */
              cc = 42; /* preset position of error */
              while(LneI.hasNext()) { /* more message-lines available ? */
                is = LneI.next(); /* get next message-line */
                if(is==null) continue; /* dummy line -- do not write */
                /* Attention: A output-line must start with '\t' or it is
                 * considered as an error-message */
                if(is.charAt(0)!='\t') { /* got error-message instead of output-line */
                  Lg.Err("putSg034",is,v,si); /* print error-message */
                  ec += 1; /* and count error */
                } else if((is=cF.putData(is))!=null) break bl; /* write-error */
              } /* -while- process all output-lines */
              LneT.clear(); /* all lines written -- delete them */
            } /* -for- process all signallight-entries */
            cc = 43; /* Kennzeichne Fehlerposition (praeventiv) */
            if((is=cF.putData("\t\t)"))!=null) break bl; /* Schreib-Fehler */
          } /* Light-Definitionen ausgeben */

          /* Signal-DrawState-Werte ausgeben */
          sc = cSgT.get$SgD(-1); /* Anzahl der DrawState-Definitionen holen */
          if(sc>0) { /* Definitionen sind vorhanden */
            cc = 51; /* Kennzeichne Fehlerposition (praeventiv) */
            is = "\t\tSignalDrawStates ( " + sc; /* Startzeile der Definitionen */
            if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
            for(si=0;si<sc;si+=1) { /* Subobjekte (DrawState) bearbeiten */
              cSgDrS = cSgT.chgDrSt(si,null); /* aktuelles Unterelement holen */
              if(cSgDrS==null) { /* Fehler -- Eintrag nicht definiert */
                Lg.Err("putSg035",null,v,si); /* Meldung ausgeben */
                ec += 1; /* Fehler zaehlen */
                continue; } /* mit naechstem Eintrag fortfahren */
              cc = 52; /* Kennzeichne Fehlerposition (praeventiv) */
              is = "\t\t\tSignalDrawState ( "+si+" "+TSUtil.addStr(cSgDrS.chgNme(null));
              if(cSgDrS.isSDef()) { /* Statement kann vollstaendig erstellt werden */
                is += ") "; /* Abschluss direkt hinzufuegen */
                if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
                continue; } /* Statement bereits fertig bearbeitet -- naechstes */
              if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
              j = cSgDrS.set$SgLi(0); /* Anzahl der DrawLight-Definitionen holen */
              if(j>0) { /* DrawLight-Definitionen sind vorhanden */
                cc = 53; /* Kennzeichne Fehlerposition (praeventiv) */
                is = "\t\t\t\tDrawLights ( " + j; /* Begin der DrawLight-Stmt's */
                if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
                for(i=0;i<j;i+=1) { /* alle DrawLight-Definitionen */
                  cSgSgL = cSgDrS.chgLight(i,null); /* aktuelles Unterelement holen */
                  if(cSgSgL==null) { /* Fehler -- SignalLight-Eintrag nicht definiert */
                    Lg.Err("putSg036",""+i,v,si); /* Meldung ausgeben */
                    ec += 1; /* Fehler zaehlen */
                    continue; } /* mit naechstem Eintrag fortfahren */
                  is = "\t\t\t\t\tDrawLight ( " + cSgSgL.getNr(); /* Stmt (Anfang) */
                  if(cSgDrS.isLOpt(i)) is += " SignalFlags ( FLASHING )"; /* Option hinzu */
                  is += " ) "; /* DrawLight-Definition erstellen (Abschluss) */
                  cc = 54; /* Kennzeichne Fehlerposition (praeventiv) */
                  if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
                } /* alle DrawLight-Definitionen bearbeiten */
                cc = 55; /* Kennzeichne Fehlerposition (praeventiv) */
                is = "\t\t\t\t) "; /* Abschluss des Eintrags erstellen */
                if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
              } /* DrawLight-Definitionen waren vorhanden */
              f = cSgDrS.chgSPos(Double.NaN); /* Wert fuer SemaphorePosition holen */
              if(!Double.isNaN(f)) { /* Wert ist gueltig -- ausgeben */
                cc = 56; /* Kennzeichne Fehlerposition (praeventiv) */
                is = "\t\t\t\tSemaphorePos (" + putFV(f,1) + " ) "; /* Stmt erstellen */
                if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
              } /* SemaphorePosition war gueltig */
              cc = 57; /* Kennzeichne Fehlerposition (praeventiv) */
              is = "\t\t\t) "; /* Abschluss des Eintrags erstellen */
              if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
            } /* alle Unterelemente (DrawState) abarbeiten */
            cc = 58; /* Kennzeichne Fehlerposition (praeventiv) */
            if((is=cF.putData("\t\t)"))!=null) break bl; /* Schreib-Fehler */
          } /* DrawState-Definitionen ausgeben */

          /* Signal-Aspekt-Werte ausgeben */
          sc = cSgT.get$SgA(-1); /* Anzahl der Aspekt-Definitionen holen */
          if(sc>0) { /* Definitionen sind vorhanden */
            cc = 61; /* Kennzeichne Fehlerposition (praeventiv) */
            is = "\t\tSignalAspects ( " + sc; /* Startzeile der Definitionen */
            if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
            for(si=0;si<sc;si+=1) { /* Subobjekte bearbeiten */
              cSgA = cSgT.chgAsp(si,null); /* aktuelles Unterelement holen */
              if(cSgA==null) { /* Fehler -- Eintrag nicht definiert */
                Lg.Err("putSg037",null,v,si); /* Meldung ausgeben */
                ec += 1; /* Fehler zaehlen */
                continue; } /* mit naechstem Eintrag fortfahren */
              LneI = cSgA.crDef(LneT); /* get signalaspect-definition */
              if(LneI==null) continue; /* no valid messages -- next entry */
              cc = 62; /* preset position of error */
              while(LneI.hasNext()) { /* more message-lines available ? */
                is = LneI.next(); /* get next message-line */
                if(is==null) continue; /* dummy line -- do not write */
                /* Attention: A output-line must start with '\t' or it is
                 * considered as an error-message */
                if(is.charAt(0)!='\t') { /* got error-message instead of output-line */
                  Lg.Err("putSg038",is,v,si); /* print error-message */
                  ec += 1; /* and count error */
                } else if((is=cF.putData(is))!=null) break bl; /* write-error */
              } /* -while- process all output-lines */
              LneT.clear(); /* all lines written -- delete them */
            } /* -for- process all signalaspect-entries */
            cc = 63; /* Kennzeichne Fehlerposition (praeventiv) */
            if((is=cF.putData("\t\t)"))!=null) break bl; /* Schreib-Fehler */
          } /* Aspekt-Definitionen ausgeben */

          is = cSgT.crDef(9,true); /* Definitionszeile erzeugen */
          if(is!=null) tp:{ /* Zeile ist gueltig */
            /* Achtung: Ausgabe-zeile muss mindestens ein '\t' enthalten */
            if(is.charAt(0)!='\t') { /* Meldung statt Zeile erhalten */
              Lg.Err("putSg032",is,v,9); /* Meldung ausgeben */
              ec += 1; /* Fehler zaehlen */
              is = cSgT.crDef(9,false); /* Definitionszeile erzeugen */
              if(is==null) break tp; /* jetzt Fehler -- Abbruch */
            } /* Meldung bearbeitet */
            cc = 34; /* Kennzeichne Fehlerposition (praeventiv) */
            if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
          } /* Zeile war gueltig */
          cc = 35; /* Kennzeichne Fehlerposition (praeventiv) */
          if((is=cF.putData("\t)"))!=null) break bl; /* Schreib-Fehler */
        } /* alle Eintragselemente ausgeben */
        cc = 36; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(")"))!=null) break bl; /* Schreib-Fehler */
      } /* alle SignalType-Definitionen wurden erstellt */

      w = cRte.get$SgS(false); /* Anzahl der 'SignalShape'-Definitionen */
      if(w>0) { /* Definitionen sind vorhanden */
        cc = 71; /* Kennzeichne Fehlerposition (praeventiv) */
        is = "SignalShapes ( " + w; /* Basiszeile erstellen */
        if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
        cI = cRte.getIt(21); /* Iterator fuer Signal-Shape-Tabelle holen */
        v = -1; /* laufende Nummer initialisieren */
        while(cI.hasNext()) { /* Weitere Signal-Shape-Definitionen vorhanden */
          cSgS = (TSSigSh)cI.next(); /* naechste Signal-Shape-Definition */
          v += 1; /* Eintrag zaehlen */
          if(cSgS==null) { /* Fehler -- Eintrag nicht definiert */
            Lg.Err("putSg051",v); /* Meldung ausgeben */
            ec += 1; /* Fehler zaehlen */
            continue; } /* mit naechstem Eintrag fortfahren */
          cc = 72; /* Kennzeichne Fehlerposition (praeventiv) */
          is = "\t_skip ( " + v +" ) "; /* Vorlauf fuer erste Zeile */
          if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
          cc = 73; /* Kennzeichne Fehlerposition (praeventiv) */
          is = "\tSignalShape ( "; /* erste Zeile */
          if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
          for(i=0;i<2;i+=1) { /* beide Vorlaufzeilen erzeugen */
            is = cSgS.crDef(i,true); /* Definitionszeile erzeugen */
            if(is==null) continue; /* Fehler -- keine weitere Zeile */
            /* Achtung: Ausgabe-zeile muss mindestens ein '\t' enthalten */
            if(is.charAt(0)!='\t') { /* Meldung statt Zeile erhalten */
              Lg.Err("putSg052",is,v,i); /* Meldung ausgeben */
              ec += 1; /* Fehler zaehlen */
              is = cSgS.crDef(i,false); /* Definitionszeile erzeugen */
            } /* Meldung bearbeitet */
            cc = 74 + i; /* Kennzeichne Fehlerposition (praeventiv) */
            if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
          } /* Vorlaufzeilemn erzeugen */
          SgSOT = cSgS.getSOT(0); /* get table of SignalSubObject-def's */
          sc = SgSOT.size(); /* Anzahl der SubObj-Definitionen holen */
          cc = 76; /* Kennzeichne Fehlerposition (praeventiv) */
          is = "\t\tSignalSubObjs ( " + sc; /* Startzeile der Subobjekte */
          if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
          for(si=0;si<sc;si+=1) { /* Subobjekte bearbeiten */
            cSgO = SgSOT.get(si); /* get signalsubobject-definition */
            if(cSgO==null) { /* Fehler -- Eintrag nicht definiert */
              Lg.Err("putSg053",null,v,si); /* Meldung ausgeben */
              ec += 1; /* Fehler zaehlen */
              continue; } /* mit naechstem Eintrag fortfahren */
            for(i=0;i<10;i+=1) { /* max. 10 Zeilen abfragen */
              is = cSgO.crDef(i,true); /* Definitionszeile erzeugen */
              if(is==null) continue; /* keine Daten geliefert */
              /* Achtung: Ausgabe-zeile muss mindestens ein '\t' enthalten */
              if(is.charAt(0)!='\t') { /* Meldung statt Zeile erhalten */
                Lg.Err("putSg054",is,v,si); /* Meldung ausgeben */
                ec += 1; /* Fehler zaehlen */
                is = cSgO.crDef(i,false); /* Definitionszeile erzeugen */
                if(is==null) continue; /*  immer noch keine Daten geliefert */
              } /* Meldung bearbeitet */
              cc = i * 100 + 77; /* Kennzeichne Fehlerposition (praeventiv) */
              if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
            } /* alle Definitionszeilen ausgeben */
          } /* alle Subobjekte abarbeiten */
          cc = 78; /* Kennzeichne Fehlerposition (praeventiv) */
          if((is=cF.putData("\t\t)"))!=null) break bl; /* Schreib-Fehler */
          cc = 79; /* Kennzeichne Fehlerposition (praeventiv) */
          if((is=cF.putData("\t)"))!=null) break bl; /* Schreib-Fehler */
        } /* alle Eintragselemente ausgeben */
        cc = 80; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(")"))!=null) break bl; /* Schreib-Fehler */
        cc = 81; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(null))!=null) break bl; /* Schreib-Fehler */
      } /* alle Signal-Shape-Definitionen wurden erstellt */

      cI = cRte.getIt(20); /* Iterator fuer Script-Datei-Tabelle holen */
        /* Achtung: 'cI' ist NUR !=null, wenn Elemente vorhanden sind */
      if(cI!=null) { /* Tabelle ist vorhanden und gueltig */
        cc = 91; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData("ScriptFiles ( "))!=null) break bl;
        v = 0; /* laufende Nummer initialisieren */
        while(cI.hasNext()) { /* Weitere Script-Definitionen vorhanden */
          cSgF = (TSSigFle)cI.next(); /* naechste Signalscript-Definition */
          if(cSgF==null) throw new IllegalStateException( /* Sicherheitsabfrage */
            TSLogg.getMsg("Msg908","TSSigFle==null","TSUtil.putSCfg()",0));
          v += 1; /* Script-Eintrag zaehlen */
          is = cSgF.crDef(true); /* Definition oder Fehlermeldung erzeugen */
          /* Achtung: Ausgabe-zeile muss mindestens ein '\t' enthalten */
          if(is.charAt(0)!='\t') { /* Meldung statt Zeile erhalten */
            Lg.Err("putSgS01",is,v,0); /* Meldung ausgeben */
            ec += 1; /* Fehler zaehlen */
            is = cSgF.crDef(false); /* Definitionszeile erzeugen */
          } /* Meldung bearbeitet */
          cc = 92; /* Kennzeichne Fehlerposition (praeventiv) */
          if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
        } /* alle Eintragselemente hinzufuegen */
        cc = 93; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(")"))!=null) break bl; /* Schreib-Fehler */
      } /* Script-Datei-Tabelle wurde geschrieben */
      cc = 99; /* preset position of error */
      is = TSLogg.getMsg("Msg100","Signal-Config"); /* create TSUtil-ID-Line */
      if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
      cc = 0; /* Datei erfolgreich erstellt */
    } /* -bl- break-block used in case of error */
    if(is!=null) Lg.Err("putSg003",is,cF.getStat(true),0); /* F-meldung steht noch aus */

    is = cF.close(); /* Ausgabe-Datei schliessen */
    if(is!=null) Lg.Err("putSg003",is,cF.getStat(true),0);

    if(cc>0) { /* Fehler beim Schreiben der Datenbank */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("putSg004",dats.getPath(),cc,0);
      Lg.Close(); /* close output to Log-file */
      return 9; /* terminate function with errorcode */
    } /* Funktionsfehler */
    if(ec>0) Lg.Log("putSg005",ec); /* Aktionsmeldung */


    Lg.Log("putSg006",cF.getStat(true)); /* print number of records */
    Lg.Log("putSg007",cF.getStat(false)); /* print recordlength */
    Lg.Skip(false); /* Leerzeile loggen */

    if(nOV) return 0; /* Datenbank ohne Fehler geschrieben */

    /* ueberschreiben der Originaldatei muss noch erfolgen */
    is = "copy \"" + rn  +"\" \"" + nn + "\" "; /* copy - Befehl erstellen */
    if((i=exec(true,is,null,Lg))>0) /* Fehler bei Ausfuehrung */
      Lg.Err("MsgC49",nn,i); /* Fehlermeldung ausgeben */
    Lg.Skip(false); /* Leerzeile loggen */

    return -i; /* Datenbank geschrieben */
  }

 /**. <pre>
  *=====================================================================
  * Method "getType"
  * Read Sound-file 'ttype.dat' and check syntax
  * ##getType (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getType( /* read 'ttype.dat' */
   TSRoute cRte) /* current route-definition */
   {
   /*-----------------------------------------------------------------*/
    File     dat; /* refrence to inputfile */
    TSFileX  cF;  /* current inputfile */
    TSBuf    cB;  /* current input-buffer for 'read file' */
    int      l1,sc,si,cc; /* intermediate values */
    String   is,js,ks;
   /*=================================================================*/
    dat = cRte.getFile(22); /* File-Objekt der 'ttype'-Datei */
    if(dat.isDirectory()) { /* es liegt keine Datei vor */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getCF101",dat.getAbsolutePath()); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datei ist ein Verzeichnis */
    if(!dat.exists()) { /* Datei existiert nicht und kann fehlen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getCF102",dat.getAbsolutePath()); /* Aktionsmeldung */
      return -1; /* System NORMAL, jedoch mit Kennzeichen beenden */
    } /* Datei existiert nicht */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("getCF103",cRte.getInfo(1)); /* Aktionsmeldung */

    /* Datenbank-Datei fuer Eingabe oeffnen */
    cF = new TSFileX(TSFileX.FT$ttp,dat); /* Eingabe-Steuerung erstellen */
    is = cF.open(false); /* Datei fuer Eingabe oeffnen */
    if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("getCF104",is); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 6; /* terminate function with errorcode */
    } /* Fehler beim Oeffnen der Datenbank-Datei */
    cB = new TSBuf(cF); /* create inputbuffer and init counter */

    cc = 0; /* preset condition-code */
    bl:{ /* Break-Block (used with errors) */
      sc = (int)cB.getNV(); /* get number of definitions */
      if((is=cB.getErr())!=null) { /* error while evaluating */
        Lg.Err("getCF105",is,cB.getStat(true)); /* print errormessage */
        cc = 5; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(sc<1) { /* number of definitions not allowed */
        Lg.Err("getCF106",null,sc,cB.getStat(true)); /* print errormessage */
        cc = 6; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      cRte.set$Type(sc); /* allocate storage for 'sc' entries */

      for(si=0;si<sc;si+=1) { /* read all ttype-definitions */
        is = cB.getKE(true); /* get next controlword */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getCF111",si); /* print errormessage */
            cc = 11; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getCF112",is,si,cB.getStat(true)); /* print errormessage */
          cc = 12; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(is.length()==0) { /* next keword not present */
          Lg.Err("getCF113",si); /* print errormessage */
          cc = 13; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(!is.equals("tracktype")) {  /* 'TrackType' not found */
          Lg.Err("getCF114",is,si); /* print errormessage */
          cc = 14; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        l1 = cB.getBrL(); /* current bracket-level for terminate */
        ttl:{ /* second Break-Block (used with errors) */
          is = cB.getVal(1); /* get description-text */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getCF121",si); /* print errormessage */
              cc = 21; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getCF122",is,si,cB.getStat(true)); /* print errormessage */
            break ttl; } /* terminate evaluation */
          if(is.length()==0) { /* value is not present */
            Lg.Err("getCF123",si); /* print errormessage */
            break ttl; } /* terminate evaluation */
          js = cB.getVal(1); /* get first filename */
          if(js==null) { /* error found within current input */
            if((js=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getCF124",si); /* print errormessage */
              cc = 22; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getCF122",js,si,cB.getStat(true)); /* print errormessage */
            break ttl; } /* terminate evaluation */
          if(js.length()==0) { /* value is not present */
            Lg.Err("getCF125",si); /* print errormessage */
            break ttl; } /* terminate evaluation */
          ks = cB.getVal(1); /* get second filename */
          if(ks==null) { /* error found within current input */
            if((ks=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getCF126",si); /* print errormessage */
              cc = 23; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getCF122",ks,si,cB.getStat(true)); /* print errormessage */
            break ttl; } /* terminate evaluation */
          if(ks.length()==0) { /* value is not present */
            Lg.Err("getCF127",si); /* print errormessage */
            break ttl; } /* terminate evaluation */
          cRte.chgType(si,new TStType(si,is,js,ks)); /* set new 'ttype'-Object */
        } /* -ttl- break-block used in case of errors */
        if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
          Lg.Err("getCF115",cB.getStat(true)); /* print errormessage */
          cc = 15; /* set current return-code to error */
          break bl; } /* terminate evaluation */
      } /* -for- process all ttype-definions */
    } /* -bl- break-block used in case of error */
    is = cF.close(); /* Ausgabe-Datei schliessen */
    if(is!=null) Lg.Err("getCF104",is); /* Meldung ausgeben */

    if(cc>0) { /* Fehler beim Laden der Datei */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getCF107",cc); /* Abschlussmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 9; /* terminate function with errorcode */
    } /* Funktionsfehler */

    return 0; /* Programm (erfolgreich) beendet */
  }

 /**. <pre>
  *=====================================================================
  * Methode "putType"
  * Sound-Datei 'ttype.dat' schreiben
  * ##putType (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int putType( /* 'ttype.dat' neu schreiben */
   TSRoute cRte) /* aktuelle Routendefinition */
   {
   /*-----------------------------------------------------------------*/
    File     dat; /* Konfigurationsdatei */
    TSFileX  cF;   /* aktuelle Ausgabe-Datei */
    TStType  cTyp; /* aktueller Eintrag */
    int      el,sc,si,cc; /* Arbeitswert(e) */
    String   is;
   /*=================================================================*/
    sc = cRte.set$Type(0); /* Anzahl der ttype-Eintraege */
    if(sc<=0) return -1; /* keine Definition vorhanden */
    /* Laenge des laengsten Namen berechnen */
    for(el=0,si=0;si<sc; si+=1) { /* alle Eintraege bearbeiten */
      cTyp = cRte.chgType(si,null); /* aktuellen Eintrag */
      el = Math.max(el,cTyp.getNme(0).length()); /* Laenge setzen */
    } /* alle Eintraege beachten */
    el += 15; /* Vorlauf beachten */

    dat = cRte.getFile(52); /* File-Objekt der 'ttype'-Datei */
    if(dat.isDirectory()) { /* es liegt keine Datei vor */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("putCF101",dat.getAbsolutePath()); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datei ist ein Verzeichnis */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("putCF103",cRte.getInfo(1)); /* Aktionsmeldung */

    /* Datenbank-Datei fuer Ausgabe oeffnen */
    cF = new TSFileX(TSFileX.FT$ttp,dat); /* Ausgabe-Steuerung erstellen */
    is = cF.open(true); /* Datei fuer Ausgabe oeffnen */
    if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("putCF104",is); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 6; /* terminate function with errorcode */
    } /* Fehler beim Oeffnen der Datenbank-Datei */

    bl:{ /* Break-Loop fuer Fehler */
      is = "" + sc; /* Basiszeile hinzufuegen */
      cc = 13; /* Kennzeichne Fehlerposition (praeventiv) */
      if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
      for(si=0;si<sc; si+=1) { /* alle Eintraege bearbeiten */
        cTyp = cRte.chgType(si,null); /* aktuellen Eintrag */
        is = cTyp.crLine(el); /* Ausgabezeile erstellen */
        cc = 14; /* Kennzeichne Fehlerposition (praeventiv) */
        if((is=cF.putData(is))!=null) break bl; /* Schreib-Fehler */
      } /* alle Eintraege beachten */
      cc = 15; /* Kennzeichne Fehlerposition (praeventiv) */
      if((is=cF.putData(null))!=null) break bl; /* Schreib-Fehler */
      cc = 19; /* preset position of error */
      is = TSLogg.getMsg("Msg100","ttype"); /* create TSUtil-ID-Line */
      if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
      cc = 0; /* Datei erfolgreich erstellt */
    } /* -bl- Abbruch im Fehlerfall */
    if(is!=null) /* Fehlermeldung steht noch aus (cc ist gesetzt) */
      Lg.Err("putCF104",is); /* Fehlermeldung ausgeben */

    if((is=cF.close())!=null) { /* Ausgabe-Datei schliessen */
      Lg.Err("putCF104",is); /* Meldung ausgeben */
      cc = 7; /* Fehlerposition kennzeichnen */
    } /* Fehler bei 'close' Ausgabedatei */

    if(cc>0) { /* Fehler beim Schreiben der Datei */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("putCF109",cc); /* Ergebnis ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 9; /* terminate function with errorcode */
    } /* Funktionsfehler */

    return 0; /* Programm (erfolgreich) beendet */
  }

 /**. <pre>
  *=====================================================================
  * Method "getSpp"
  * Read file 'Speedpost.dat', check Syntax
  * If namelist is NOT specified, no registration of mentioned shape-
  *    names takes place.
  * ##getSpp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getSpp( /* read 'Speedpost.dat' */
   TSRoute   cRte, /* current route-definition */
   TSNameSet Lst)  /* Namelist of used Shape-definitions */
   {
   /*-----------------------------------------------------------------*/
    File     dat; /* reference to inputfile */
    TSFileX  cF;  /* current inputfile */
    TSBuf    cB;  /* current input-buffer for 'read file' */
    int      l1,l2,ic,ii,cc,ec,m,mc; /* intermediate values */
    double   d;   /* intermediate value */
    String   is,mid,nme;
   /*=================================================================*/
    dat = cRte.getFile(27); /* File-Object of 'Speedpost.dat'-file */
    if(dat.isDirectory()) { /* file counld not be found */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getCF201",dat.getAbsolutePath()); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datei ist ein Verzeichnis */
    if(!dat.exists()) { /* Datei existiert nicht und kann fehlen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getCF202",dat.getAbsolutePath()); /* Aktionsmeldung */
      return -1; /* System NORMAL, jedoch mit Kennzeichen beenden */
    } /* Datei existiert nicht */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("getCF203",cRte.getInfo(1)); /* Aktionsmeldung */

    /* Open database for input (read dat-file) */
    cF = new TSFileX(TSFileX.FT$spp,dat); /* create input-control */
    is = cF.open(false); /* open file for input */
    if(is!=null) { /* error found while opening */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("getCF204",is); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 6; /* terminate function with errorcode */
    } /* error during open of database-file */
    cB = new TSBuf(cF); /* create inputbuffer and init counter */

    cc = 0; /* preset condition-code */
    ec = 0; /* preset: no errors found */
    m  = 0; /* preset marker: no definitions found */
    ic = 0; /* compiler needs it */
    mid = nme = null; /* compiler needs it */
    bl:while(true) { /* read all definitions (also used with errors) */
      is = cB.getKE(true); /* get next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) break; /* all definitions processed (?) */
        Lg.Err("getCF212",is,cB.getStat(true)); /* print errormessage */
        cc = 12; /* set current return-code to error */
        break; } /* terminate evaluation */
      l1 = cB.getBrL(); /* current bracket-level for terminate */
      if(is.equals("speed_warning_sign_shape")) s1:{ /* FIRST definition found */
        if((m&1)!=0) { /* definition already specified */
          Lg.Err("getCF221",cB.getStat(true)); /* print errormessage */
          ec += 1; /* and count error */
          break s1; } /* terminate evaluation */
        is = cB.getVal(1); /* get name of shape */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getCF222",cB.getStat(true)); /* print errormessage */
            cc = 21; /* set current return-code to error */
            break; } /* terminate evaluation */
          Lg.Err("getCF223",is,cB.getStat(true)); /* print errormessage */
          ec += 1; /* and count error */
          break s1; } /* terminate evaluation */
        if(is.length()==0) { /* value is not present */
          Lg.Err("getCF224",cB.getStat(true)); /* print errormessage */
          ec += 1; /* and count error */
          break s1; } /* terminate evaluation */
        /* valid Sign-shape specified -- handle it */
        if(Lst!=null) Lst.add(is); /* add shape to list if requested */
        m |= 1; /* set marker: definiton successfully processed */
        if((m&0x0FE)==0) break s1; /* position of definition OK -- end check */
        Lg.Err("getCF225",toHex(m,2),cB.getStat(true)); /* print errormessage */
        ec += 1; /* and count error */
      } else if(is.equals("restricted_shape")) s2:{ /* SECOND definition found */
        if((m&2)!=0) { /* definition already specified */
          Lg.Err("getCF231",cB.getStat(true)); /* print errormessage */
          ec += 1; /* and count error */
          break s2; } /* terminate evaluation */
        is = cB.getVal(1); /* get name of shape */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getCF232",cB.getStat(true)); /* print errormessage */
            cc = 31; /* set current return-code to error */
            break; } /* terminate evaluation */
          Lg.Err("getCF233",is,cB.getStat(true)); /* print errormessage */
          ec += 1; /* and count error */
          break s2; } /* terminate evaluation */
        if(is.length()==0) { /* value is not present */
          Lg.Err("getCF234",cB.getStat(true)); /* print errormessage */
          ec += 1; /* and count error */
          break s2; } /* terminate evaluation */
        /* valid Sign-shape specified -- handle it */
        if(Lst!=null) Lst.add(is); /* add shape to list if requested */
        m |= 2; /* set marker: definiton successfully processed */
        if((m&0x0FC)==0) break s2; /* position of definition OK -- end check */
        Lg.Err("getCF235",toHex(m,2),cB.getStat(true)); /* print errormessage */
        ec += 1; /* and count error */
      } else if(is.equals("end_restricted_shape")) s3:{ /* THIRD definition found */
        if((m&4)!=0) { /* definition already specified */
          Lg.Err("getCF241",cB.getStat(true)); /* print errormessage */
          ec += 1; /* and count error */
          break s3; } /* terminate evaluation */
        is = cB.getVal(1); /* get name of shape */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getCF242",cB.getStat(true)); /* print errormessage */
            cc = 41; /* set current return-code to error */
            break; } /* terminate evaluation */
          Lg.Err("getCF243",is,cB.getStat(true)); /* print errormessage */
          ec += 1; /* and count error */
          break s3; } /* terminate evaluation */
        if(is.length()==0) { /* value is not present */
          Lg.Err("getCF244",cB.getStat(true)); /* print errormessage */
          ec += 1; /* and count error */
          break s3; } /* terminate evaluation */
        /* valid Sign-shape specified -- handle it */
        if(Lst!=null) Lst.add(is); /* add shape to list if requested */
        m |= 4; /* set marker: definiton successfully processed */
        if((m&0x0F8)==0) break s3; /* position of definition OK -- end check */
        Lg.Err("getCF245",toHex(m,2),cB.getStat(true)); /* print errormessage */
        ec += 1; /* and count error */
      } else if(is.equals("speedpost_set")) { /* other definition found */
        m |= 16; /* set marker: definiton was specified */
        while(true) { /* read all 'set'-definitions */
          is = cB.getKE(true); /* get next controlword */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getCF251",cB.getStat(true)); /* print errormessage */
              cc = 51; /* set current return-code to error */
              break bl; } /* terminate evaluation */
            Lg.Err("getCF252",is,cB.getStat(true)); /* print errormessage */
            cc = 52; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          if(is.length()==0) break; /* all definitions processed (?) */
          l2 = cB.getBrL(); /* current bracket-level for terminate */
          if(is.equals("name")) { /* name of set specified */
            mc = 0x0100; /* set control-value for definition-mask */
            mid = "getCF26"; /* set start of message-iD */
            ic = -1; /* set marker: read shape/texture, do NOT read coordinates */
            cc = 61; /* preset current return-code in case of error */
          } else if(is.equals("speed_warning_sign_shape")) { /* other definition found */
            mc = 0x0200; /* set control-value for definition-mask */
            mid = "getCF27"; /* set start of message-iD */
            ic = 0; /* set marker: read shape/texture, ask for number of coordinates */
            cc = 71; /* preset current return-code in case of error */
          } else if(is.equals("speed_sign_shape")) { /* other definition found */
            mc = 0x80000400; /* set control-value for definition-mask */
            mid = "getCF28"; /* set start of message-iD */
            ic = 0; /* set marker: read shape/texture, ask for number of coordinates */
            cc = 81; /* preset current return-code in case of error */
          } else if(is.equals("speed_resume_sign_shape")) { /* other definition found */
            mc = 0x0800; /* set control-value for definition-mask */
            mid = "getCF29"; /* set start of message-iD */
            ic = 0; /* set marker: read shape/texture, ask for number of coordinates */
            cc = 91; /* preset current return-code in case of error */
          } else if(is.equals("speed_digit_tex")) { /* other definition found */
            mc = 0x01000; /* set control-value for definition-mask */
            mid = "getCF2A"; /* set start of message-iD */
            ic = -1; /* set marker: read shape/texture, do NOT read coordinates */
            cc = 101; /* preset current return-code in case of error */
          } else if(is.equals("speed_text_size")) { /* other definition found */
            mc = 0x02000; /* set control-value for definition-mask */
            mid = "getCF2B"; /* set start of message-iD */
            ic = 3; /* set marker: do not read shape/texture, read coordinates */
            cc = 111; /* preset current return-code in case of error */
          } else if(is.equals("milepost_shape")) { /* other definition found */
            mc = 0x010000; /* set control-value for definition-mask */
            mid = "getCF2C"; /* set start of message-iD */
            ic = 0; /* set marker: read shape/texture, ask for number of coordinates */
            cc = 121; /* preset current return-code in case of error */
          } else if(is.equals("milepost_digit_tex")) { /* other definition found */
            mc = 0x020000; /* set control-value for definition-mask */
            mid = "getCF2D"; /* set start of message-iD */
            ic = -1; /* set marker: read shape/texture, do NOT read coordinates */
            cc = 131; /* preset current return-code in case of error */
          } else if(is.equals("milepost_text_size")) { /* other definition found */
            mc = 0x040000; /* set control-value for definition-mask */
            mid = "getCF2E"; /* set start of message-iD */
            ic = 3; /* set marker: do not read shape/texture, read coordinates */
            cc = 141; /* preset current return-code in case of error */
          } else { /* unknown keyword encountered */
            mc = 0; /* do NOT read any values */
            Lg.Err("getCF253",is,cB.getStat(true)); /* print errormessage */
            ec += 1; /* and count error */
          } /* invalid keyword processed */
          if(mc!=0) lp:{ /* read values from 'Speedpost.dat'-line */
            if(mc>0 && (m&mc)!=0) { /* definition already specified */
              Lg.Err(mid+"1",cB.getStat(true)); /* print errormessage */
              ec += 1; /* and count error */
              break lp; } /* terminate evaluation */
            if(ic<=0) { /* marker: read shape/texture */
              is = cB.getVal(1); /* get name of set */
              if(is==null) { /* error found within current input */
                if((is=cB.getErr())==null) { /* EOF within data */
                  Lg.Err(mid+"2",cB.getStat(true)); /* print errormessage */
                  /* current return-code is already set */
                  break bl; } /* terminate evaluation */
                Lg.Err(mid+"3",is,cB.getStat(true)); /* print errormessage */
                ec += 1; /* and count error */
                break lp; } /* terminate evaluation */
              if(is.length()==0) { /* value is not present */
                Lg.Err(mid+"4",cB.getStat(true)); /* print errormessage */
                ec += 1; /* and count error */
                break lp; } /* terminate evaluation */
              if(Lst!=null) Lst.add(is); /* add shape to list if requested */
              if(mc==0x0100) nme = is; /* set name of current Speedpost-Set */
            } /* marker: read shape/texture */
            if(ic==0) { /* marker: ask for number of coordinates */
              ic = (int)cB.getNV(); /* get number of following definitions */
              if((is=cB.getErr())!=null) { /* error while evaluating */
                Lg.Err(mid+"5",is,cB.getStat(true)); /* print errormessage */
//                cc += 1; /* modify current return-code due to error */
//                break bl; } /* terminate evaluation */
                ec += 1; /* and count error */
                break lp; } /* terminate evaluation */
              if(ic<0 || ic>4) { /* number of definitions not allowed */
                Lg.Err(mid+"6",toHex(m,6),ic,cB.getStat(true)); /* print errormessage */
                ec += 1; /* and count error */
                break lp; } /* terminate evaluation */
              ic *= 4; /* compute correct number of coordinates */
            } /* marker: ask for number of coordinates */
            if(ic>0) { /* marker: read 'ic' coordinates */
              for(ii=0;ii<ic;ii+=1) { /* read all coordinate-definitions */
                d = cB.getFV(); /* get value of argument (number) */
                if((is=cB.getErr())!=null) { /* error while evaluating */
                  Lg.Err(mid+"7",is,ii,cB.getStat(true)); /* print errormessage */
                  cc += 2; /* modify current return-code due to error */
                  break bl; } /* terminate evaluation */
              } /* -for- read all coordinates */
            } /* marker: read 'ic' coordinates */
            m |= mc; /* set marker: definiton successfully processed */
          } /* -lp- data has been read from 'Speedpost.dat'-line */
          cc = 0; /* no termination-error -- reset condition-code again */
          if(cB.skpFwd(l2)) { /* skip resuming data to new entry -- EOF/error found? */
            Lg.Err("getCF254",cB.getStat(true)); /* print errormessage */
            cc = 53; /* set current return-code to error */
            break bl; } /* terminate evaluation */
        } /* -while- process all speedpost-set-defintions */
        if((m&0x0100)==0) { /* 'Name'-definition missing */
          Lg.Err("getCF2Z1",cB.getStat(true)); /* print errormessage */
          ec += 1; /* and count error */
        } /* definition-line missing */
        if((m&0x0400)!=0) /* 'Speed_Sign_Shape'-definition available */
         if((m&0x01000)==0) { /* 'Speed_Digit_Tex'-definition missing */
          Lg.Err("getCF2Z2",nme,cB.getStat(true)); /* print errormessage */
          ec += 1; /* and count error */
        } /* definition-line missing */
        if((m&0x010000)!=0) /* 'Milepost_Shape'-definition available */
         if((m&0x020000)==0) { /* 'Milepost_Digit_Tex'-definition missing */
          Lg.Err("getCF2Z3",nme,cB.getStat(true)); /* print errormessage */
          ec += 1; /* and count error */
        } /* definition-line missing */
        m &= 0x0FF; /* 'speedpost_set' processed successfully -- clear marker */
      } else { /* unknown keyword encountered */
        Lg.Err("getCF213",is,cB.getStat(true)); /* print errormessage */
        ec += 1; /* and count error */
      } /* invalid keyword processed */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getCF214",cB.getStat(true)); /* print errormessage */
        cc = 15; /* set current return-code to error */
        break; } /* terminate evaluation */
    } /* -bl- process all speedpost-defintions (break-block used in case of error) */
    is = cF.close(); /* close input-file again */
    if(is!=null) { /* error found -- handle it */
      Lg.Err("getCF204",is); /* print error-message */
      ec += 1; /* and count error */
    } /* error found -- handle it */

    /* check if all required definitions were present */
    if((m&1)==0) Lg.Log("getCF229"); /* print message */
    if((m&2)==0) Lg.Log("getCF239"); /* print message */
    if((m&4)==0) Lg.Log("getCF249"); /* print message */

    if(cc>0) { /* error found while loading file */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getCF205",cc); /* print last message */
      Lg.Close(); /* close output to Log-file */
      return 9; /* terminate function with errorcode */
    } /* error found */
    if(ec==0) return 0; /* no error found -- return */
//    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("getCF206",ec); /* print last message */
    return 0; /* programm ended successfully */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getMF"
  * Marker-Datei der Strecke einlesen und pruefen
  * ##getMF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getMF( /* Marker-Datei der Strecke einlesen */
   TSRoute cRte) /* aktuelle Routendefinition */
   {
   /*-----------------------------------------------------------------*/
    File     dat; /* Konfigurationsdatei */
    TSFileX  cF;  /* aktuelle Eingabe-Datei */
    TSBuf    cB;  /* current input-buffer for 'read file' */
    int      i,l1,nr,cc,ec; /* Arbeitswert(e) */
    double   k; /* aktuelle Koordinatendefinition */
    String   is;
   /*=================================================================*/
    dat = cRte.getFile(29); /* File-Objekt der Marker-Datei */
    is = dat.getAbsolutePath(); /* Dateiname extrahieren */
    if(dat.isDirectory()) { /* es liegt keine Datei vor */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getMF001",is); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5;  /* terminate function with errorcode */
    } /* Datei ist ein Verzeichnis */
    if(!dat.exists()) { /* Datei existiert nicht und kann fehlen */
      Lg.Skip(true); /* Leerzeile loggen */
      is = cRte.getInfo(2); /* Name der Route holen */
      dat = cRte.getFile(1,is+".mkr"); /* alternativer Marker-Name erstellen */
      if(dat!=null && dat.exists()) { /* falscher Name fuer Markerdatei */
        is = dat.getAbsolutePath(); /* Dateiname extrahieren */
        Lg.Msg("getMF006",is); /* Aktionsmeldung */
      } else Lg.Msg("getMF002",cRte.getFile(29).getAbsolutePath()); /* Aktionsmeldung */
      return -1; /* System NORMAL, jedoch mit Kennzeichen beenden */
    } /* Datei existiert nicht */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("getMF003",is); /* Aktionsmeldung */

    /* Datenbank-Datei fuer Eingabe oeffnen */
    cF = new TSFileX(TSFileX.FT$mkr,dat); /* Eingabe-Steuerung erstellen */
    is = cF.open(false); /* Datei fuer Eingabe oeffnen */
    if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("getMF004",is); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 6; /* terminate function with errorcode */
    } /* Fehler beim Oeffnen der Datenbank-Datei */
    cB = new TSBuf(cF); /* create inputbuffer and init counter */

    nr = 0; /* current number of entry */
    cc = 0; /* condition-code */
    ec = 0; /* current error-counter */
    bl: while(true) { /* process all definition-lines */
      is = cB.getKE(true); /* get first/next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) break; /* EOF is valid here */
        Lg.Err("getMF011",is,nr,cB.getStat(true)); /* print errormessage */
        cc = 11; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getMF012",null,nr,cB.getStat(true)); /* print errormessage */
        cc = 12; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      if(!is.equals("marker")) {  /* 'Marker' not found */
        Lg.Err("getMF013",is,nr,cB.getStat(true)); /* print errormessage */
        cc = 13; /* set current return-code to error */
        break bl; } /* terminate evaluation */
      l1 = cB.getBrL(); /* current bracket-level for terminate */
      nr += 1; /* adjust number of the entry */
      elp:{ /* break-block (used with errors) */
        k = cB.getFV(); /* get first coordinate (longitude) */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getMF021",is,nr,cB.getStat(true)); /* print errormessage */
          ec += 1; /* count error */
          if(!Double.isNaN(k)) break elp; /* EOF NOT found -- next entry */
          cc = 21; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(k<-180.0 || k>180.0) { /* value is not a valid coordinate */
          Lg.Err("getMF022",""+k,nr,cB.getStat(true)); /* print errormessage */
          ec += 1;/* count error */
          break elp; } /* terminate processing of entry */
        k = cB.getFV(); /* get second coordinate (lattitude) */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getMF023",is,nr,cB.getStat(true)); /* print errormessage */
          ec += 1; /* count error */
          if(!Double.isNaN(k)) break elp; /* EOF NOT found -- next entry */
          cc = 22; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(k<-90.0 || k>90.0) { /* value is not a valid coordinate */
          Lg.Err("getMF024",""+k,nr,cB.getStat(true)); /* print errormessage */
          ec += 1;/* count error */
          break elp; } /* terminate processing of entry */
        is = cB.getVal(1); /* get description as next argument */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getMF025",null,nr,cB.getStat(true)); /* print errormessage */
            cc = 23; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getMF026",is,nr,cB.getStat(true)); /* print errormessage */
          ec += 1; /* count error */
          break elp; } /* terminate processing of entry */
        if(is.length()==0) Lg.Log("getMF027",null,nr,cB.getStat(true));
          /* description is empty -- print warning */
        i = (int)cB.getNV(); /* get type of marker */
        if((is=cB.getErr())!=null) { /* error while evaluating */
          Lg.Err("getMF028",""+i,nr,cB.getStat(true)); /* print errormessage */
          ec += 1; /* count error */
          if(i!=0) break elp; /* EOF NOT found -- next entry */
          cc = 24; /* set current return-code to error */
          break bl; } /* terminate evaluation */
        if(i<0 || i>2) { /* invalid markertype */
          Lg.Err("getMF029",""+i,nr,cB.getStat(true)); /* print errormessage */
          ec += 1; /* count error */
          break elp; } /* terminate processing of entry */
        is = cB.getVal(1); /* check if more values present */
        if(is==null) { /* error found within current input */
          if((is=cB.getErr())==null) { /* EOF within data */
            Lg.Err("getMF025",null,nr,cB.getStat(true)); /* print errormessage */
            cc = 25; /* set current return-code to error */
            break bl; } /* terminate evaluation */
          Lg.Err("getMF030",is,nr,cB.getStat(true)); /* print errormessage */
          ec += 1; /* count error */
          break elp; } /* terminate processing of entry */
        if(is.length()>0) { /* more data fpund within line */
          Lg.Err("getMF031",is,nr,cB.getStat(true)); /* print errormessage */
          ec += 1; /* count error */
        } /* terminate processing of entry */
      } /* -elp- break-block used in case of errors */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getMF019",null,nr,cB.getStat(true)); /* print errormessage */
        cc = 15; /* set current return-code to error */
      } /* terminate evaluation */
    } /* -bl- break-block used in case of error */
    is = cF.close(); /* Ausgabe-Datei schliessen */
    if(is!=null) Lg.Err("getMF004",is); /* Meldung ausgeben */

    if(cc>0) { /* Fehler beim Laden der Datei */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getMF005",cc); /* Abschlussmeldung ausgeben */
      return -2; /* System beenden */
    } /* Funktionsfehler */
    if(ec>0) Lg.Log("getMF009",ec); /* Aktionsmeldung */

    return 0; /* Programm (erfolgreich) beendet */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getRF"
  * Read Ref-File of route and check it
  * Keywords are using the following ID-numbers:
  *  0 : Class
  *  1 : Description
  *  2 : FileName
  *  3 : Shadow
  *  4 : Align
  *  5 :
  *  6 :
  *  7 : PickupType
  *  8 : StoreMatrix
  *  9 : NoDirLight
  * 10 : TunnelEntrance
  * 11 : AnimShape
  * 12 :
  * ##getRF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int getRF( /* Read Ref-File of route */
   TSRoute   cRte, /* current route-definition */
   TSNameSet Nme)  /* List for shape-names (or 'null') */
   {
   /*-----------------------------------------------------------------*/
    File     dat;  /* Konfigurationsdatei */
    TSFileX  cF;   /* aktuelle Eingabe-Datei */
    TSBuf    cB;   /* current input-buffer for 'read file' */
    TSObjLst cLst; /* current list of route-reference-objects */
    TSObjDef cObj; /* current route-reference-object */
    TSOpts   keyMsk,cMsk; /* validation-mask, existence-mask */
    int      l1,nr,cc,ec; /* Arbeitswert(e) */
    int      i,OT; /* temporary value, current Object-Type */
    String   Typ;  /* Typ des aktuellen Eintrags */
    String   is,js,fn;
   /*=================================================================*/
    dat = cRte.getFile(30); /* File-Objekt der Ref-Datei */
    is = dat.getAbsolutePath(); /* Dateiname extrahieren */
    if(dat.isDirectory()) { /* es liegt keine Datei vor */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getRF001",is); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 5; /* terminate function with errorcode */
    } /* Datei ist ein Verzeichnis */
    if(!dat.exists()) { /* Datei existiert nicht und kann fehlen */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getRF002",is); /* Aktionsmeldung */
      return -1; /* System NORMAL, jedoch mit Kennzeichen beenden */
    } /* Datei existiert nicht */
    Lg.Skip(true); /* Leerzeile loggen */
    Lg.Msg("getRF003",is); /* Aktionsmeldung */

    /* Datenbank-Datei fuer Eingabe oeffnen */
    cF = new TSFileX(TSFileX.FT$ref,dat); /* Eingabe-Steuerung erstellen */
    is = cF.open(false); /* Datei fuer Eingabe oeffnen */
    if(is!=null) { /* Fehler beim Oeffnen aufgetreten */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("getRF004",is); /* Abbruchmeldung ausgeben */
      Lg.Close(); /* close output to Log-file */
      return 6; /* terminate function with errorcode */
    } /* Fehler beim Oeffnen der Datenbank-Datei */
    cB = new TSBuf(cF); /* create inputbuffer and init counter */

    nr = 0; /* current number of entry */
    cc = 0; /* condition-code */
    ec = 0; /* current error-counter */
    bl: while(true) { /* process all definition-lines */
      is = cB.getKE(true); /* get first/next controlword */
      if(is==null) { /* error found within current input */
        if((is=cB.getErr())==null) break; /* EOF is valid here */
        Lg.Err("getRF011",is,nr,cB.getStat(true)); /* print errormessage */
        cc = 21; /* set current return-code to error */
        break bl; /* terminate evaluation */
      } /* terminate evaluation */
      if(is.length()==0) { /* next keword not present */
        Lg.Err("getRF010",null,nr,cB.getStat(true)); /* print errormessage */
        cc = 22; /* set current return-code to error */
        break bl; /* terminate evaluation */
      } /* next keword not present -- terminate evaluation */
      l1 = cB.getBrL(); /* current bracket-level for terminate */
      nr += 1; /* adjust number of the entry */

      cMsk = new TSOpts(); /* currently no options are used */
      fn   = null; /* no filename available */
      dtl:{ /* break-block (used with errors) */
        if(is.equals("dyntrack")) { /* Entrytype: 'Dyntrack' */
          js = "TSUidX1Z"; /* get key of validation-mask due to type */
          OT = 1; /* and set object-type */
//        } else if(is.equals("signal")) { /* Entrytype: 'Signal' */
//          js = "TSUidX2Z"; /* get key of validation-mask due to type */
//          OT = 2; /* and set object-type */
        } else if(is.equals("static")) { /* Entrytype: 'Static' */
          js = "TSUidX3Z"; /* get key of validation-mask due to type */
          OT = 3; /* and set object-type */
//        } else if(is.equals("forest")) { /* Entrytype: 'Forest' */
//          js = "TSUidX4Z"; /* get key of validation-mask due to type */
//          OT = 4; /* and set object-type */
        } else if(is.equals("platform")) { /* Entrytype: 'Platform' */
          js = "TSUidX5Z"; /* get key of validation-mask due to type */
          OT = 5; /* and set object-type */
          cMsk.$init(0x80000004); /* simulate: filename successfully processed */
          fn = "<Platform>"; /* set sythetical filename */
        } else if(is.equals("siding")) { /* Entrytype: 'Siding' */
          js = "TSUidX6Z"; /* get key of validation-mask due to type */
          OT = 6; /* and set object-type */
          cMsk.$init(0x80000004); /* simulate: filename successfully processed */
          fn = "<Siding>"; /* set sythetical filename */
        } else if(is.equals("gantry")) { /* Entrytype: 'Gantry' */
          js = "TSUidX7Z"; /* get key of validation-mask due to type */
          OT = 7;  /* and set object-type */
//        } else if(is.equals("speedpost")) { /* Entrytype: 'Speedpost' */
//          js = "TSUidX8Z"; /* get key of validation-mask due to type */
//          OT = 8; /* and set object-type */
        } else if(is.equals("carspawner")) { /* Entrytype: 'CarSpawner' */
          js = "TSUidX9Z"; /* get key of validation-mask due to type */
          OT = 9; /* and set object-type */
          cMsk.$init(0x80000004); /* simulate: filename successfully processed */
          fn = "<CarSpawner>"; /* set sythetical filename */
        } else if(is.equals("levelcr")) { /* Entrytype: 'LevelCr' */
          js = "TSUidXAZ"; /* get key of validation-mask due to type */
          OT = 10; /* and set object-type */
        } else if(is.equals("hazard")) {  /* Entrytype: 'Hazard' */
          js = "TSUidXBZ"; /* get key of validation-mask due to type */
          OT = 11; /* and set object-type */
        } else if(is.equals("transfer")) { /* Entrytype: 'Transfer' */
          js = "TSUidXCZ"; /* get key of validation-mask due to type */
          OT = 12; /* and set object-type */
        } else if(is.equals("collideobject")) { /* Entrytype: 'CollideObject' */
          js = "TSUidXDZ"; /* get key of validation-mask due to type */
          OT = 13; /* and set object-type */
//        } else if(is.equals("telepole")) { /* Entrytype: 'Telepole' */
//          js = "TSUidXEZ"; /* get key of validation-mask due to type */
//          OT = 14; /* and set object-type */
        } else if(is.equals("pickup")) { /* Entrytype: 'Pickup' */
          js = "TSUidXFZ"; /* get key of validation-mask due to type */
          OT = 15; /* and set object-type */
        } else { /* unknown keyword found -- do not process it */
          Lg.Err("getRF012",is,nr,cB.getStat(true)); /* print errormessage */
          ec += 1; /* count error */
          break dtl; /* terminate processing of entry */
        } /* unknown keyword -- terminate processing of entry */

        Typ = TSUiD.getName(OT); /* set object-type used within errormessages */
        js = TSLogg.getKey(js); /* get validation-mask due to type */
        if((i=js.indexOf('#'))>=0) js = js.substring(0,i); /* remove comment */
        js = js.trim(); /* and additional 'whitechar's */
        try { i = (int)Long.parseLong(js,16); /* convert number */
        } catch (NumberFormatException e) { /* not only digits found */
          Lg.Err("getRF093",Typ,""+nr,""+cB.getStat(true),js);  /* print errormessage */
          i = 0; /* use default-value if error within number */
        } /* use default-value if error within number */
        keyMsk = new TSOpts(i); /* create validation-object */

        cLst = null; /* preset: no current list available */
        js   = null; /* no description available */
        while(true) { /* process all sub-definitions */
          /* all definition-lines are processed independant from the current entry-type */
          is = cB.getKE(true); /* get first controlword */
          if(is==null) { /* error found within current input */
            if((is=cB.getErr())==null) { /* EOF within data */
              Lg.Err("getRF021",Typ,nr,cB.getStat(true)); /* print errormessage */
              cc = 31; /* set current return-code to error */
              break bl; /* EOF within data -- terminate evaluation */
            } /* terminate evaluation */
            Lg.Err("getRF022",Typ,is,cB.getStat(true)); /* print errormessage */
            cc = 32; /* set current return-code to error */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
          if(is.length()==0) break; /* no more keywords present */
          if(is.equals("class")) SD00:{ /* Sub-Definition: 'Class' */
            if(!keyMsk.chkMsk(0)) { /* Sub-Definition is not valid */
              Lg.Err("getRF101",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break SD00; /* terminate processing of entry */
            } /* terminate processing of entry */
            if(cLst!=null) { /* definition was already present */
              Lg.Err("getRF102",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl; /* terminate processing of entry */
            } /* definition already present -- terminate processing of entry */
            is = cB.getVal(1); /* get current class-name */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getRF103",Typ,nr,cB.getStat(true)); /* print errormessage */
                cc = 39; /* set current return-code to error */
                break bl; /* terminate evaluation */
              } /* EOF within data -- terminate evaluation */
              Lg.Err("getRF104",Typ,is,cB.getStat(true)); /* print errormessage */
              cc = 40; /* set current return-code to error */
              break bl; /* terminate evaluation */
            } /* terminate evaluation */
            if(is.length()==0) { /* next keword not present */
              Lg.Err("getRF105",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break SD00; /* terminate processing of entry */
            } /* next keword not present -- terminate processing of entry */
            cLst = cRte.addList(is); /* create list of reference-objects for new class.
              * If class is already present, the current class is returned. */
            cMsk.setMsk(0); /* mark current entrytype as 'found' and 'processed' */
            if(true) break SD00;
            is = cB.skpVal(); /* get remaining value(s) within brackets */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) is = TSLogg.getKey("getRF091"); /* EOF within data */
              else is = TSLogg.getMsg("getRF092",is); /* create errormessage */
            } /* error found -- create message */
            if(is.length()>1) { /* additional data or errormessage found */
              Lg.Err("getRF104",Typ,is,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
            } /* additional error found */
          } else if(is.equals("description")) SD01:{ /* Sub-Definition: 'Description' */
            if(!keyMsk.chkMsk(1)) { /* Sub-Definition is not valid */
              Lg.Err("getRF111",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break SD01; /* terminate processing of entry */
            } /* terminate processing of entry */
            if(js!=null) { /* definition was already present */
              Lg.Err("getRF112",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl; /* terminate processing of entry */
            } /* definition already present -- terminate processing of entry */
            is = cB.getVal(1); /* get current description */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getRF113",Typ,nr,cB.getStat(true)); /* print errormessage */
                cc = 39; /* set current return-code to error */
                break bl; /* EOF within data -- terminate evaluation */
              } /* terminate evaluation */
              Lg.Err("getRF114",Typ,is,cB.getStat(true)); /* print errormessage */
              cc = 40; /* set current return-code to error */
              break bl; /* terminate evaluation */
            } /* terminate evaluation */
            if(is.length()==0) { /* next keword not present */
              Lg.Err("getRF115",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break SD01; /* terminate processing of entry */
            } /* next keword not present -- terminate processing of entry */
            js = is; /* store current description */
            cMsk.setMsk(1); /* mark current entrytype as 'found' and 'processed' */
            is = cB.skpVal(); /* get remaining value(s) within brackets */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) is = TSLogg.getKey("getRF091"); /* EOF within data */
              else is = TSLogg.getMsg("getRF092",is); /* create errormessage */
            } /* error found -- create message */
            if(is.length()>1) { /* additional data or errormessage found */
              Lg.Err("getRF114",Typ,is,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
            } /* additional error found */
          } else if(is.equals("filename")) SD02:{ /* Sub-Definition: 'Filename' */
            if(!keyMsk.chkMsk(2)) { /* Sub-Definition is not valid */
              Lg.Err("getRF121",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break SD02; /* terminate processing of entry */
            } /* terminate processing of entry */
            if(fn!=null) { /* definition was already present */
              Lg.Err("getRF122",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl; /* terminate processing of entry */
            } /* definition already present -- terminate processing of entry */
            is = cB.getVal(1); /* get current file-name */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getRF123",Typ,nr,cB.getStat(true)); /* print errormessage */
                cc = 39; /* set current return-code to error */
                break bl; /* terminate evaluation */
              } /* EOF within data -- terminate evaluation */
              Lg.Err("getRF124",Typ,is,cB.getStat(true)); /* print errormessage */
              cc = 40; /* set current return-code to error */
              break bl; /* terminate evaluation */
            } /* terminate evaluation */
            if(is.length()==0) { /* next keword not present */
              Lg.Err("getRF125",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break SD02; /* terminate processing of entry */
            } /* next keword not present -- terminate processing of entry */
            fn = is; /* store current filename (shape) */
            cMsk.setMsk(2); /* mark current entrytype as 'found' and 'processed' */
            if(Nme!=null) Nme.add(is); /* register file-name (shape) for checking */
            is = cB.skpVal(); /* get remaining value(s) within brackets */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) is = TSLogg.getKey("getRF091"); /* EOF within data */
              else is = TSLogg.getMsg("getRF092",is); /* create errormessage */
            } /* error found -- create message */
            if(is.length()>1) { /* additional data or errormessage found */
              Lg.Err("getRF124",Typ,is,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
            } /* additional error found */
          } else if(is.equals("shadow")) SD03:{ /* Sub-Definition: 'Shadow' */
            if(!keyMsk.chkMsk(3)) { /* Sub-Definition is not valid */
              Lg.Err("getRF131",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break SD03; /* terminate processing of entry */
            } /* terminate processing of entry */
            if(cMsk.chkMsk(3)) { /* definition was already present */
              Lg.Err("getRF132",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl; /* terminate processing of entry */
            } /* definition already present -- terminate processing of entry */
            is = cB.getVal(2); /* get current shadow-type (lower case) */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getRF133",Typ,nr,cB.getStat(true)); /* print errormessage */
                cc = 39; /* set current return-code to error */
                break bl; /* terminate evaluation */
              } /* EOF within data -- terminate evaluation */
              Lg.Err("getRF134",Typ,is,cB.getStat(true)); /* print errormessage */
              cc = 40; /* set current return-code to error */
              break bl; /* terminate evaluation */
            } /* terminate evaluation */
            if(is.length()==0) { /* next keword not present */
              Lg.Err("getRF135",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break SD03; /* terminate processing of entry */
            } /* next keword not present -- terminate processing of entry */
            if(is.equals("none")) cMsk.setMsk(16); /* set shadow-marker */
            else if(is.equals("round")) cMsk.setMsk(17); /* set shadow-marker */
            else if(is.equals("rect")) cMsk.setMsk(18); /* set shadow-marker */
//            else if(is.equals("")) cMsk.setMsk(19); /* set shadow-marker */
            else if(is.equals("dynamic")) cMsk.setMsk(20); /* set shadow-marker */
            else { /* invalid shadow-marker found */
              Lg.Err("getRF136",Typ,is,cB.getStat(true),nr); /* print errormessage */
              ec += 1; /* count error */
              cMsk.setMsk(16); /* set DEFAULT shadow-marker */
            } /* invalid shadow-marker found -- 'None' assumed */
            cMsk.setMsk(3); /* mark current entrytype as 'found' and 'processed' */
            is = cB.skpVal(); /* get remaining value(s) within brackets */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) is = TSLogg.getKey("getRF091"); /* EOF within data */
              else is = TSLogg.getMsg("getRF092",is); /* create errormessage */
            } /* error found -- create message */
            if(is.length()>1) { /* additional data or errormessage found */
              Lg.Err("getRF134",Typ,is,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
            } /* additional error found */
          } else if(is.equals("align")) SD04:{ /* Sub-Definition: 'Align' */
            if(!keyMsk.chkMsk(4)) { /* Sub-Definition is not valid */
              Lg.Err("getRF141",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break SD04; /* terminate processing of entry */
            } /* terminate processing of entry */
            if(cMsk.chkMsk(4)) { /* definition was already present */
              Lg.Err("getRF142",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl; /* terminate processing of entry */
            } /* definition already present -- terminate processing of entry */
            is = cB.getVal(2); /* get current align-type (lower case) */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getRF143",Typ,nr,cB.getStat(true)); /* print errormessage */
                cc = 39; /* set current return-code to error */
                break bl; /* terminate evaluation */
              } /* EOF within data -- terminate evaluation */
              Lg.Err("getRF144",Typ,is,cB.getStat(true)); /* print errormessage */
              cc = 40; /* set current return-code to error */
              break bl; /* terminate evaluation */
            } /* terminate evaluation */
            if(is.length()==0) { /* next keword not present */
              Lg.Err("getRF145",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break SD04; /* terminate processing of entry */
            } /* next keword not present -- terminate processing of entry */
            if(is.equals("none")) cMsk.setMsk(24); /* set align-marker */
//            else if(is.equals("")) cMsk.setMsk(25); /* set align-marker */
            else { /* invalid align-marker found */
              Lg.Err("getRF146",Typ,is,cB.getStat(true),nr); /* print errormessage */
              ec += 1; /* count error */
              cMsk.setMsk(20); /* set DEFAULT align-marker */
            } /* invalid align-marker found -- 'None' assumed */
            cMsk.setMsk(4); /* mark current entrytype as 'found' and 'processed' */
            is = cB.skpVal(); /* get remaining value(s) within brackets */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) is = TSLogg.getKey("getRF091"); /* EOF within data */
              else is = TSLogg.getMsg("getRF092",is); /* create errormessage */
            } /* error found -- create message */
            if(is.length()>1) { /* additional data or errormessage found */
              Lg.Err("getRF144",Typ,is,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
            } /* additional error found */
          } else if(is.equals("pickuptype")) SD07:{ /* Sub-Definition: 'PickupType' */
            if(!keyMsk.chkMsk(7)) { /* Sub-Definition is not valid */
              Lg.Err("getRF171",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break SD07; /* terminate processing of entry */
            } /* terminate processing of entry */
            if(cMsk.chkMsk(7)) { /* definition was already present */
              Lg.Err("getRF172",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl; /* terminate processing of entry */
            } /* definition already present -- terminate processing of entry */
            is = cB.getVal(2); /* get current pickuptype (lower case) */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) { /* EOF within data */
                Lg.Err("getRF173",Typ,nr,cB.getStat(true)); /* print errormessage */
                cc = 39; /* set current return-code to error */
                break bl; /* terminate evaluation */
              } /* EOF within data -- terminate evaluation */
              Lg.Err("getRF174",Typ,is,cB.getStat(true)); /* print errormessage */
              cc = 40; /* set current return-code to error */
              break bl; /* terminate evaluation */
            } /* terminate evaluation */
            if(is.length()==0) { /* next keword not present */
              Lg.Err("getRF175",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break SD07; /* terminate processing of entry */
            } /* next keword not present -- terminate processing of entry */
            if(is.equals("_fuel_diesel_")) cMsk.setMsk(28); /* set pickuptype */
            else if(is.equals("_fuel_water_")) cMsk.setMsk(29); /* set pickuptype */
            else if(is.equals("_fuel_coal_")) cMsk.setMsk(30); /* set pickuptype */
            else { /* invalid pickuptype found */
              Lg.Err("getRF176",Typ,is,cB.getStat(true),nr); /* print errormessage */
              ec += 1; /* count error */
              cMsk.setMsk(28); /* set DEFAULT PickupType */
            } /* invalid align-marker found -- 'None' assumed */
            cMsk.setMsk(7); /* mark current entrytype as 'found' and 'processed' */
            is = cB.skpVal(); /* get remaining value(s) within brackets */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) is = TSLogg.getKey("getRF091"); /* EOF within data */
              else is = TSLogg.getMsg("getRF092",is); /* create errormessage */
            } /* error found -- create message */
            if(is.length()>1) { /* additional data or errormessage found */
              Lg.Err("getRF174",Typ,is,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
            } /* additional error found */
          } else if(is.equals("storematrix")) SD08:{ /* Sub-Definition: 'StoreMatrix' */
            if(!keyMsk.chkMsk(8)) { /* Sub-Definition is not valid */
              Lg.Err("getRF181",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break SD08; /* terminate processing of entry */
            } /* terminate processing of entry */
            if(cMsk.chkMsk(8)) { /* definition was already present */
              Lg.Err("getRF182",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl; /* terminate processing of entry */
            } /* definition already present -- terminate processing of entry */
            cMsk.setMsk(8); /* mark current entrytype as 'found' and 'processed' */
            is = cB.skpVal(); /* get remaining value(s) within brackets */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) is = TSLogg.getKey("getRF091"); /* EOF within data */
              else is = TSLogg.getMsg("getRF092",is); /* create errormessage */
            } /* error found -- create message */
            if(is.length()>1) { /* additional data or errormessage found */
              Lg.Err("getRF184",Typ,is,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
            } /* additional error found */
          } else if(is.equals("nodirlight")) SD09:{ /* Sub-Definition: 'NoDirLight' */
            if(!keyMsk.chkMsk(9)) { /* Sub-Definition is not valid */
              Lg.Err("getRF191",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break SD09; /* terminate processing of entry */
            } /* terminate processing of entry */
            if(cMsk.chkMsk(9)) { /* definition was already present */
              Lg.Err("getRF192",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl; /* terminate processing of entry */
            } /* definition already present -- terminate processing of entry */
            cMsk.setMsk(9); /* mark current entrytype as 'found' and 'processed' */
            is = cB.skpVal(); /* get remaining value(s) within brackets */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) is = TSLogg.getKey("getRF091"); /* EOF within data */
              else is = TSLogg.getMsg("getRF092",is); /* create errormessage */
            } /* error found -- create message */
            if(is.length()>1) { /* additional data or errormessage found */
              Lg.Err("getRF194",Typ,is,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
            } /* additional error found */
          } else if(is.equals("tunnelentrance")) SD10:{ /* Sub-Definition: 'Tunnelentrance' */
            if(!keyMsk.chkMsk(10)) { /* Sub-Definition is not valid */
              Lg.Err("getRF201",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break SD10; /* terminate processing of entry */
            } /* terminate processing of entry */
            if(cMsk.chkMsk(10)) { /* definition was already present */
              Lg.Err("getRF202",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl; /* terminate processing of entry */
            } /* definition already present -- terminate processing of entry */
            cMsk.setMsk(10); /* mark current entrytype as 'found' and 'processed' */
            is = cB.skpVal(); /* get remaining value(s) within brackets */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) is = TSLogg.getKey("getRF091"); /* EOF within data */
              else is = TSLogg.getMsg("getRF092",is); /* create errormessage */
            } /* error found -- create message */
            if(is.length()>1) { /* additional data or errormessage found */
              Lg.Err("getRF204",Typ,is,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
            } /* additional error found */
          } else if(is.equals("animshape")) SD11:{ /* Sub-Definition: 'AnimShape' */
            if(!keyMsk.chkMsk(11)) { /* Sub-Definition is not valid */
              Lg.Err("getRF211",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break SD11; /* terminate processing of entry */
            } /* terminate processing of entry */
            if(cMsk.chkMsk(11)) { /* definition was already present */
              Lg.Err("getRF212",Typ,nr,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
              break dtl; /* terminate processing of entry */
            } /* definition already present -- terminate processing of entry */
            cMsk.setMsk(11); /* mark current entrytype as 'found' and 'processed' */
            is = cB.skpVal(); /* get remaining value(s) within brackets */
            if(is==null) { /* error found within current input */
              if((is=cB.getErr())==null) is = TSLogg.getKey("getRF091"); /* EOF within data */
              else is = TSLogg.getMsg("getRF092",is); /* create errormessage */
            } /* error found -- create message */
            if(is.length()>1) { /* additional data or errormessage found */
              Lg.Err("getRF214",Typ,is,cB.getStat(true)); /* print errormessage */
              ec += 1; /* count error */
            } /* additional error found */
          } else { /* invalid keyword -- do not process */
            Lg.Err("getRF023",Typ,is,cB.getStat(true),nr); /* print errormessage */
            ec += 1; /* count error */
            break dtl; /* terminate processing of entry */
          } /* terminate processing of entry */
          if(cB.skpFwd()) { /* skip resuming data to new entry -- EOF/error found? */
            cc = 49; /* set current return-code to error */
            break bl; /* terminate evaluation */
          } /* terminate evaluation */
        } /* -while- process all sub-sections */
        if(cMsk.cntMsk(7)!=3) { /* definition is NOT complete -- skip it
         * all three control-bits (class,desc,file) must be set
         */
          Lg.Err("getRF031",Typ,nr,cB.getStat(true),cMsk.getMsk(7)); /* print errormessage */
          ec += 1; /* count error */
          break dtl; /* terminate processing of entry */
        } /* terminate processing of entry */
        i = cMsk.getMsk(-1); /* get all options from control-object */
        cObj = new TSObjDef(i,OT,fn,js); /* create new object-reference-definition */
        if(!cLst.add(cObj)) { /* insert object-reference-definition to classlist */
          /* object-reference-definition already present */
          Lg.Err("getRF032",Typ,fn,cB.getStat(true),nr); /* print errormessage */
          ec += 1; /* count error */
          break dtl; /* terminate processing of entry */
        } /* terminate processing of entry */
      } /* -dtl- break-block in case of error */
      if(cB.skpFwd(l1)) { /* skip resuming data to new entry -- EOF/error found? */
        Lg.Err("getRF019",cB.getStat(true)); /* print errormessage */
        cc = 15; /* set current return-code to error */
      } /* set current return-code to error */
    } /* -bl:while-  break-block in case of error */
    is = cF.close(); /* Ausgabe-Datei schliessen */
    if(is!=null) Lg.Err("getRF004",is); /* Meldung ausgeben */

    if(cc>0) { /* Fehler beim Laden der Datei */
      Lg.Skip(true); /* Leerzeile loggen */
      Lg.Msg("getRF005",cc); /* Abschlussmeldung ausgeben */
      return -2; /* System beenden */
    } /* Funktionsfehler */
    if(ec>0) Lg.Log("getRF006",ec); /* Aktionsmeldung */
    Lg.Log("getRF009",nr); /* report number of loaded entries */

    return 0; /* Programm (erfolgreich) beendet */
  }

 /**. <pre>
  *=====================================================================
  * Methode "putRF"
  * Write Ref-File of route again
  * ##putRF (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int putRF( /* write Ref-File of route */
   TSRoute cRte, /* current route-definition */
   File    datz) /* file-definition of temporary file (or 'null') */
   {
   /*-----------------------------------------------------------------*/
    File     dats; /* source-file-definition of ref-file */
    TSFileX  cF;   /* current route-reference-file (output) */
//    TSObjLst cLst; /* current list of route-reference-objects */
    TSObjDef cObj; /* current route-reference-object */
    int      i,cc,ec,c; /* intermediate value(s) */
    String   nn,rn,is;
    boolean  nOV;  /* overwrite? */
    Iterator<TSObjLst> cI;   /* current iterator to 'ObjLst-table' */
    Iterator<TSObjDef> oI;   /* current iterator to 'ObjDef-table' */
    Iterator<String>   LneI; /* Line-Iterator for output */
    ArrayList<String>  LneT; /* Line-Table for output */
   /*=================================================================*/
    cI = cRte.getIt(25); /* get reference to stored definitions */
    if(cI==null) { /* Route-Objectreferences are NOT available */
      Lg.Msg("putRF000"); /* print errormessage */
      return -1; /* terminate output and return with marker */
    } /* data is not available -- skip output of file */

    dats = cRte.getFile(30); /* get reference to original file */
    nn = dats.getAbsolutePath(); /* Name of nominal outputfile */
    nOV = false; /* preset: overwrite original filen */
    if(datz==null) { /* no intermediate file -- set new names */
      datz = cRte.getFile(60); /* get new outputfile */
      nn = datz.getAbsolutePath(); /* and set new nominal name */
      nOV = true; /* set: do NOT overwrite original file */
    } /* no intermediate file specified */
    rn = datz.getAbsolutePath(); /* get name of real outputfile */
    Lg.Skip(true); /* skip printline */
    Lg.Msg("putRF001",nn); /* Aktionsmeldung */

    /* Open file for output */
    cF = new TSFileX(TSFileX.FT$ref,datz); /* Create output-control */
    is = cF.open(true); /* and open file for output */
    if(is!=null) { /* Error while opening new reference-file */
      Lg.Skip(false); /* skip printline */
      Lg.Msg("putRF002",is); /* print errormessage */
      Lg.Close(); /* close output to Log-file */
      return 7; /* terminate function with errorcode */
    } /* Error while opening new reference-file */

    ec = 0; /* initialize error-counter */
    c  = 0; /* initialize object-counter */
    LneT = new ArrayList<String>(10); /* create table for output-line-blocks */
      /* This list is normally empty. After it was filled with output-lines
       * and all lines have been processed, it MUST be cleared again. */
    bl: { /* block for error-break */
      cc = 11; /* Mark Errorposition (if needed) */
      while(cI.hasNext()) { /* handle all class-definitions */
        oI = cI.next().getIt(); /* process next class-definition and
          * get Iterator to current 'Objectreferences' */
        if(oI==null) continue; /* no valid objects -- skip 'class' */
        cc += 1; /* Modify Errorposition */
        while(oI.hasNext()) { /* handle all object-definitions */
          cObj = oI.next(); /* get next Objectreference-definition */
          if(cObj==null) continue; /* no valid object -- do not write */
          LneI = cObj.crDef(LneT); /* create definitionline(s) */
          if(LneI==null) continue; /* no valid output-lines -- do not write */
          while(LneI.hasNext()) { /* more output-lines available ? */
            is = LneI.next(); /* get next output-line */
            if(is==null) continue; /* dummy line -- do not write */
            if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
          } /* -while- process all output-lines */
          LneT.clear(); /* all lines written -- delete them */
          c += 1; /* another valid definition processed */
        } /* process ALL Object-reference-definitions */
      } /* process ALL classes */
      cc = 99; /* preset position of error */
      if((is=cF.putData(null))!=null) break bl; /* write-error */
      is = TSLogg.getMsg("Msg100","Route-Reference"); /* create TSUtil-ID-Line */
      if((is=cF.putData(is))!=null) break bl; /* write-error --terminate */
      cc = 0; /* file has been created successfully */
    } /* -bl- break-block used in case of error */
    if(is!=null) Lg.Err("putRF003",is,cF.getStat(true));
      /* there is a pending errormessage to be printed */

    is = cF.close(); /* close outputfile again */
    if(is!=null) Lg.Err("putRF003",is,cF.getStat(true));

    if(cc>0) { /* severe error found writing of database */
      Lg.Skip(true); /* skip printline */
      Lg.Msg("putRF004",dats.getPath(),cc,0);
      Lg.Close(); /* close output to Log-file */
      return 9; /* terminate function with errorcode */
    } /* terminal error found -- terminate function */
    if(ec>0) Lg.Log("putRF005",ec); /* print result of action */

    Lg.Log("putRF008",c); /* print number of definitions */
    Lg.Log("putRF006",cF.getStat(true)); /* print number of records */
    Lg.Log("putRF007",cF.getStat(false)); /* print recordlength */
    Lg.Skip(false); /* skip printline */

    if(nOV) return 0; /* no error occurred while writing, no overwrite */

    /* overwrite of original file must still be done */
    is = "copy \"" + rn  +"\" \"" + nn + "\" "; /* create copy - command */
    if((i=exec(true,is,null,Lg))>0) /* error with execute */
      Lg.Err("MsgC49",nn,i); /* print errormessage */
    Lg.Skip(false); /* skip printline */
    return 0; /* program ended (successfully) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "putObj"
  * Objektdefinitionen fuer weitere, spaetere Bearbeitung speichern
  * Routine schreibt Objekte:
  *   Version, ScTab, ShTab, P.Route
  * ##putObj (Eyecatcher)
  * ===> ACHTUNG: Diese Methode befindet sich noch in Entwicklung <===
  *=====================================================================
  </pre>*/
  protected static int putObj( /* Objekt-Definitionen speichern */
   TSRoute cRte) /* Routendefinition mit Basisverzeichnis */
   {
   /*-----------------------------------------------------------------*/
    File               dat; /* Ausgabedatei */
    ObjectOutputStream pO;  /* Objekt-Ausgabe */
    String             is;
    int                i; /* Arbeitswerte */
   /*=================================================================*/
    Lg.Skip(true); /* Leerzeile loggen */
    dat = cRte.getFile(99); /* File-Referenz fuer Verzeichnis */
    if(dat==null) { /* Verzeichnis nicht zugreifbar */
      Lg.Msg("MsgC63",cRte.getInfo(99)); /* Abbruchmeldung ausgeben */
      return 12; /* System beenden */
    } /* Datei kann nicht angelegt werden */
    is = dat.getAbsolutePath(); /* Dateiname setzen */
    Lg.Msg("putObj1",is); /* Aktionsmeldung ausgeben */

    try { pO = new ObjectOutputStream(new BufferedOutputStream(
               new FileOutputStream(dat))); /* Ausgabe */
    } catch (IOException e) {
      System.err.println(e.toString());
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("putOb2",is); /* Abbruchmeldung ausgeben */
      return 7; /* System beenden */
    } /* Dateifehler */

    i = 0; /* Return-code initialisieren */
System.out.println("putObj: Start");
    bl: { /* block for error-break */
System.out.println("putObj: Write 'Version'");
      try { pO.writeObject(Version); /* Versionskennung schreiben */
      } catch (IOException e) {
        System.err.println(e.toString());
        i = 21; /* neuen Return-Code setzen */
        break bl; /* Schreiben beenden */
      } /* Dateifehler */
//System.out.println("putObj: Write 'ScTab'");
//      try { pO.writeObject(ScTab); /* Section-Tabelle schreiben */
//      } catch (IOException e) {
//        System.err.println(e.toString());
//        i = 22; /* neuen Return-Code setzen */
//        break bl; /* Schreiben beenden */
//      } /* Dateifehler */
//System.out.println("putObj: Write 'ShTab'");
//      try { pO.writeObject(ShTab); /* Shape-Tabelle schreiben */
//      } catch (IOException e) {
//        System.err.println(e.toString());
//        i = 23; /* neuen Return-Code setzen */
//        break bl; /* Schreiben beenden */
//      } /* Dateifehler */
System.out.println("putObj: Write 'Route'");
      try { pO.writeObject(cRte); /* Routendefinition schreiben */
      } catch (IOException e) {
        System.err.println(e.toString()+",RC=24");
        i = 24; /* neuen Return-Code setzen */
        break bl; /* Schreiben beenden */
      } catch (Exception e) {
        System.err.println(e.toString()+",RC=25");
        e.printStackTrace();
        i = 25; /* neuen Return-Code setzen */
        break bl; /* Schreiben beenden */
      } /* Dateifehler */
System.out.println("putObj: Ende");
    } /* -bl- break-block used in case of error */
    try { pO.close();
    } catch (IOException e) { System.err.println(e.toString()); }
    if(i>0) { /* Fehler aufgetreten -- ausgeben */
      Lg.Skip(false); /* Leerzeile Loggen */
      Lg.Msg("putObj3",is,i,0); /* Abbruchmeldung ausgeben */
    } /* Fehlerkennung ausgeben */
    return i; /* Methode beenden -- Ergebnis zurueck */
  }

 /* ##+ (Eyecatcher)
  * AlLgemeine Utility-Methoden und Methoden von allgemeiner Bedeutung */

 /**. <pre>
  *=====================================================================
  * Methode "actOFle"
  * Activate read-mode to use an optionfile for option-input.
  * Attention: method uses and modifies global values: gF
  * Method returns 'true' if an error occurs.
  * ##actOFle (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final boolean actOFle( /* activate optionfile */
   TSBuf   cB,  /* current inputbuffer contains command-definition */
   String  msg, /* start of Message-ID */
   boolean mde) /* current type of file-access (global(=true)/local) */
   {
   /*-----------------------------------------------------------------*/
    File    dat; /* definition of optionfile */
    String  cC;  /* current command */
   /*=================================================================*/
    if(gF!=null) { /* optionfile cannot be used recursively */
      TSLogg.prtMsg(msg+"1",""+gF.getStat(true)); /* print error-msg */
      return true; /* terminate function */
    } /* call was recursive */
    cC = cB.getTail(true); /* extract filename from command */
    if(cC.length()==0) { /* file-name missing */
      TSLogg.prtMsg(msg+"2",cC); /* print error-msg */
      return true; /* terminate function */
    } /* file-name missing */
    if(cC.length()<9) cC = "%%%%%%%%" + cC; /* do not use value as key */
    cC = TSLogg.getMsg(cC,"/Routes/"); /* resolve registry-references */
    dat = new File(cC); /* check filename of optionfile */
    if(!dat.exists()) { /* file is not found */
      TSLogg.prtMsg(msg+"3",dat.getAbsolutePath());
      return true; /* terminate function */
    } /* optionfile does not exist */
    if(dat.isDirectory()) { /* input-source is a directory */
      TSLogg.prtMsg(msg+"4",dat.getAbsolutePath());
      return true; /* terminate function */
    } /* inputfile references a directory */
    gF = new TSFile(dat); /* locate and create file */
    if(gF.open(TSFile.IA)!=null) { /* open file (input,ASCII) -- error ? */
      TSLogg.prtMsg(msg+"5",gF.getErr(),dat.getAbsolutePath());
      gF = null; /* do not use file */
      return true; /* terminate function */
    } /* Error found while 'open' */
    /* Attention 'cB' can be / is reused now */
    cB = new TSBuf(gF,null); /* initialize inputbuffer (mode='line') */
    cB.setUsr(mde);          /* transfer current type of access */
    gF.chgBuf(cB);           /* and store as user-extention to file */
    return false; /* command successfully processed */
//    gF.chgBuf(new TSBuf(gF,null)); /* initialize inputbuffer (mode='line') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addStr"
  * Creates a valid 'String' from argument
  *  This function surrounds the result with '"' in any case
  *  (also compare to 'modStr()' which uses this method to modify
  *     the string)
  * ##addStr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final String addStr( /* modify String in any case */
   String src)  /* source of result to be converted */
   {
   /*-----------------------------------------------------------------*/
    StringBuilder s; /* temporary string */
    int           i; /* intermediate index-value */
   /*=================================================================*/
    s = new StringBuilder(src); /* convert it */
    for(i=0;i<s.length();i+=1) /* process all characters */
      switch(s.charAt(i)) { /* check if action needed */
        case('\\'): s.insert(i++,'\\'); /* insert escape-character */
          break; /* character is processed */
        case('"'): s.insert(i++,'\\'); /* insert escape-character */
          break; /* character is processed */
        case('\r'): s.replace(i,i+1,"\\r"); /* change sequence */
          /* Attention: replaced char 'r' is checked again */
          break; /* character is processed */
        case('\n'): s.replace(i,i+1,"\\n"); /* change sequence */
          /* Attention: replaced char 'n' is checked again */
          break; /* character is processed */
        case('\t'): s.replace(i,i+1,"\\t"); /* change sequence */
          /* Attention: replaced char 't' is checked again */
          break; /* character is processed */
        default: /* do nothing */
      } /* -switch- process all characters */
    s.insert(0,'"'); /* prefix result with quote */
    s.append('"'); /* suffix result with quote */
    return s.toString(); /* return result as a string */
  }

 /**. <pre>
  *=====================================================================
  * Methode "askTerm"
  * Aufforderung ausgeben, das Programm abzubrechen falls ein
  *  Ueberschreiben der Daten nicht gewollt.
  * ##askTerm (Eyecatcher)
  *=====================================================================
  </pre>*/
  private static final void askTerm() /* Terminierung erfragen */
   {
   /*-----------------------------------------------------------------*/
    String msg; /* buffer */
    int    i;   /* counter */
   /*=================================================================*/
    msg = TSLogg.getKey("Msg201"); /* get first outputline */
    System.out.println(msg); /* and write it to DOS-console */
    msg = TSLogg.getKey("Msg202"); /* get second outputline */
    System.out.println(msg); /* and write it to DOS-console, too */
    System.out.println(); /* skip one line within DOS-console */
    i = 11; /* initialize Countdown-value */
    while(--i>0) { /* execute countdown */
      System.out.print("\r   "+i+"  "); /* print current number */
      try {Thread.sleep(2000); /* and wait 2 seconds */
      } catch(InterruptedException e) { /* wait was cancelled */
        System.err.println(); /* skip another line  */
      } /* wait was cancelled */
    } /* execute countdown */
    System.out.println("\r          "); /* clear last line again */
    return; /* OK -- continue program */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkLog"
  * Ueberpruefen, ob Dateiname zum Log benutzt werden kann und
  * erzeugen Logging-Objekt falls erfolgreich
  * Methode liefert 'null' wenn Dateiname fehlerhaft!
  * ##chkLog (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final TSLogg chkLog( /* Dateiname pruefen */
   String dn) /* Dateiname fuer Logging */
   {
   /*-----------------------------------------------------------------*/
    File dat; /* File-Objekt zum Pruefen */
   /*=================================================================*/
    if(dn==null) return null; /* error within argument -- no check */
    dat = (new File(dn)).getAbsoluteFile(); /* Pruefungsobjekt erst, */
    if(dat.exists()) { /* Datei/Verzeichnis existiert bereits */
      if(dat.isFile()) return new TSLogg(dn); /* OK - Objekt liefern */
      TSLogg.prtMsg("Msg013",dn,dat.getAbsolutePath()); /* print message */
      return null; /* Ende -- Fehler aufgetreten */
    } /* Datei/Verzeichnis existiert bereits */
    dat = dat.getParentFile(); /* Verzeichnis fuer Log-Datei */
    if(dat.exists()) return new TSLogg(dn); /* OK -- Obj. zurueck */
    TSLogg.prtMsg("Msg014",dn); /* Meldung erstellen */
    return null; /* Ende -- Fehler aufgetreten */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkNum"
  * Prueft das Vorhandensein einer (Integer-) Nummer und konvertiert
  *  diese. Die Nummer MUSS mit Vorzeichen versehen sein und eine
  *  genau festgelegte Position und Laenge haben.
  *  Falls ein Fehler auftritt wird 'MIN_VALUE' geliefert.
  * ##chkNum (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final int chkNum( /* pruefe und konvertiere Nummer */
   String s, /* current string-buffer */
   int    b, /* Beginn der Nummer (erstes Zeichen) */
   int    e) /* Ende der Nummer (naechstes Z. nach Nummer) */
   {
   /*-----------------------------------------------------------------*/
    int  i;  /* intermediate value */
    char vz; /* Vorzeichen */
   /*=================================================================*/
    if(e<0 || b<0) return Integer.MIN_VALUE; /* falsche Werte */
    if(e>=s.length()) return Integer.MIN_VALUE; /* Zahl passt nicht */
    if(b>=e) return Integer.MIN_VALUE; /* Zahl passt nicht */

    vz = s.charAt(b++); /* Vorzeichen holen und uebergehen */
    try {i = Integer.parseInt(s.substring(b,e)); /* wandeln */
    } catch (NumberFormatException E) { /* Fehler in der Zahl */
      return Integer.MIN_VALUE; /* nicht nur Ziffern in der Zahl */
    } /* Fehler in der Zahl gefunden */
    if(vz=='-') i = -i; /* Vorzeichen beachten */
    else if(vz!='+') return Integer.MIN_VALUE; /* Vorzeichen falsch */
    return i; /* Umgewandelte Zahl liefern */
  }


 /**. <pre>
  *=====================================================================
  * Methode "chkOFle"
  * check optionfile and disable if EOF, return next option-command
  * Attention: method uses and modifies global values: gF
  * ##chkOFle (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final String chkOFle( /* check optionfile */
   String cC,  /* current command */
   String msg) /* Message-ID */
   {
   /*-----------------------------------------------------------------*/
    TSBuf   cB;   /* current input-buffer for 'read file' */
    String  is;   /* current part of option-command */
    boolean skip; /* skip lines because of wrong mode */
   /*=================================================================*/
    if(gF==null) return cC; /* optionfile NOT active -- use cC */
    cB = gF.chgBuf(null); /* get current buffer-control */
    skip = false; /* do not skip any line */
    do { /* until command is valid */
      is = cB.getVal(7); /* copy next field to 'is' */
      while(is==null) { /* end of line reached -- read new line */
        if(cB.getNext(false)) { /* read new line into buffer -- EOF? */
          if((is=cB.getErr())!=null) /* read-error found */
            TSLogg.prtMsg(msg+"Y",is,""+gF.getStat(true));
          gF.close(); /* close input-file */
          gF = null; /* and stop usage of it */
          return cC; /* Optionfile fully processed */
        } /* EOF found */
        is = cB.getVal(7); /* get next field from the beginning */
      } /* repeat until valid input-field is available or EOF */
      if(is.startsWith("[")) mc:{ /* mode-change requested -- check it */
        if(is.equalsIgnoreCase("[global]")) skip = !cB.getUsr();
          /* activate global-mode -- transfer mode id to readmode */
         else if(is.equalsIgnoreCase("[local]")) skip = cB.getUsr();
          /* activate local-mode -- transfer mode id to readmode */
         else break mc; /* invald command -- handle as valid line */
        is = "# "; /* flush buffer and initiate new command */
      } /* -mc- ignore change-request */
      if(skip || is.startsWith("#")) { /* comment -- ignore rest of buffer */
        cB.getNext(true);  /* flush buffer */
        is = ""; /* initiate new command */
      } /* ignore comment */
    } while(is.length()==0); /* Do not use empty commands */
    if(is.charAt(0)!='-') { /* ONLY option-definitions allowed! */
      TSLogg.prtMsg(msg+"Z",is,""+gF.getStat(true)); /* print error-msg */
      System.exit(15); /* terminate function */
//      gF.close(); /* close input-file */
//      gF = null; /* and stop usage of it */
//      is = cC; /* processing terminated -- use next command */
    } /* no option-definition */
    return is; /* and activate new option-command */
  }

 /**. <pre>
  *=====================================================================
  * Method "cnvInt"
  * Converts an array of integer-values into an array of Strings.
  * Method returns a Stringarray of equal size.
  * ##cnvInt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final String[] cnvInt( /* convert integers */
   int... v) /* enumeration/array of integers */
   {
   /*-----------------------------------------------------------------*/
    String[]  rs;           /* result-array */
    int       i;            /* loop-control */
    final int j = v.length; /* create intermediate value */
   /*=================================================================*/
    rs = new String[j]; /* create result-array as requested */
    for(i=0;i<j;i+=1) rs[i] = "" + v[i]; /* convert it */
    return rs; /* return result */
  }

 /**. <pre>
  *=====================================================================
  * Method "cpyDat"
  * Copy files recursively (whole tree)
  * Method returns number of already copied files.
  * Method is called from : 'dcopy()'
  * ##cpyDat (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int cpyDat( /* copy whole tree of file(s) */
   File dir1, /* Source-directory */
   File dir2, /* Compare-directory */
   File dir3, /* Target-directory */
   int  c)    /* current number of copied files */
   {
   /*-----------------------------------------------------------------*/
    File     bdat,vdat,zdat; /* file-definitions */
    long     b,v; /* creation-dates */
    int      i;   /* temporaries */
    String[] fa;  /* file-list */
    String   is;  /* current copy-command */
   /*=================================================================*/
    fa = dir1.list(); /* get list of all files within current directory */
    for(String fn:fa) { /* process all files/folders within this directory */
      bdat = new File(dir1,fn); /* create reference to source-file/directory */
      if(bdat.isDirectory()) { /* source defines directory -- handle it */
        vdat = new File(dir2,fn); /* create reference to new directory */
        zdat = new File(dir3,fn); /* create reference to new directory */
        c = cpyDat(bdat,vdat,zdat,c); /* and process it recursively */
      } else { /* file is referenced from 'bdat' */
        if(!Fo.chkMsk(1) && fn.toLowerCase().endsWith(".bk")) continue;
          /* do NOT copy special files */
        vdat = new File(dir2,fn); /* create reference to compare-file */
        if(vdat.exists()) { /* file existes -- compare it with source */
          if(!vdat.isDirectory()) { /* reference refers to file -- compare date */
            /* Resolution : 60 seconds (computed from 'Milliseconds') */
            b = bdat.lastModified() / 60000; /* get file-date (source) */
            v = vdat.lastModified() / 60000; /* get file-date (compare) */
            if(Fo.chkMsk(3)) b += Fo.getInt(0); /* add time-displacement if needed */
 if(PrMsk.chkMsk(31)) Lg.Log("Msg004","'"+bdat.getAbsolutePath()+"',"+b+","+v); // ##!D
            if(b<=v) continue; /* source-file is older or equal -- do not copy */
          } /* entry referes to file */
        } else if(Fo.chkMsk(2)) continue; /* do not process missing compare-files */
        if(!dir3.exists()) dir3.mkdirs(); /* create new target-directory */
        zdat = new File(dir3,fn); /* and reference to target-file */
        is = "copy \""+bdat.getAbsolutePath()+"\" \""+
          zdat.getAbsolutePath()+"\" "; /* create copy - command */
        if((i=exec(true,is,null,null))>0) { /* execute it -- error? */
          Lg.Log("cpyDat1",i); /* print errormessage */
          continue; /* and continue with next source-file */
        } /* copy failed */
        c += 1; /* count copied file */
        Lg.Log("cpyDat2",bdat.getAbsolutePath(),c); /* print message */
      } /* source-reference is file */
    } /* -for- process all list-entries */
    return c; /* OK -- terminate function -- return number of copied files */
  }

 /**. <pre>
  *=====================================================================
  * Methode "exec"
  * ##exec (Eyecatcher)
  *=====================================================================
  </pre>*/
  private static final int exec( /* execute Dos-command */
   boolean sh,  /* Shell-Environment  requested */
   String  cmd, /* current command */
   File    vz,  /* working-directory */
   TSLogg  Lg)  /* Log-Object */
   {
   /*-----------------------------------------------------------------*/
    Process        aPr;   /* process of execution */
    BufferedReader PrOut; /* Message-Reader (responses) */
    String         data;  /* buffer */
    int            i;     /* return-code */
   /*=================================================================*/
    if(sh) { /* add Shell-Environment */
      if(OSName.indexOf("98")>=0) cmd = "command.com /c " + cmd;
      else if(OSName.equalsIgnoreCase("windows me")) /* Win-ME! */
        cmd = "command.com /c " + cmd;
      else cmd = "cmd /c " + cmd; /* all other Windows-OS */
    } /* Shell-Environment was requested */
    try { /* try to execute external command */
      aPr = gRE.exec(cmd,null,vz); /* do it */
      PrOut = new BufferedReader( /* get reader for responses */
        new InputStreamReader(aPr.getInputStream()));
      while((data=PrOut.readLine())!=null) { /* lines present? */
        if(Lg!=null) Lg.Log("execCmd1",data); /* yes -- log them */
      } /* response-lines present */
      i = aPr.waitFor(); /* wait until command finished and get return-code */
    } catch (Exception e) { /* error found while command-exec */
      System.err.println(TSLogg.getMsg("execCmd2",e.toString()));
      i = 20; /* set special return-code */
    } /* error occurred */
    return i; /* send result */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getDate"
  * Get and format a date-value to a string (German version).
  *  This may be the current date.
  * ##getDate (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getDate( /* get date/time and format */
   long    ct,  /* current time/date or '<=0' for 'current time */
   boolean ext) /* format milliseconds, too (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    Calendar cD; /* date/time-value */
    String   s;  /* temporary result */
   /*=================================================================*/
    cD = Calendar.getInstance(cLoc); /* get current date/time-def. */
    if(ct>0) cD.setTimeInMillis(ct); /* change to requested time */
    s = DF2.format(cD.get(Calendar.DATE)) + "." + /* format it */
      DF2.format(cD.get(Calendar.MONTH)+1) + "." +
      cD.get(Calendar.YEAR) + " " +
      DF2.format(cD.get(Calendar.HOUR_OF_DAY)) + ":" +
      DF2.format(cD.get(Calendar.MINUTE)) + ":" +
      DF2.format(cD.get(Calendar.SECOND));
    if(ext) s += "." + DF3.format(cD.get(Calendar.MILLISECOND));
    return s; /* return requested result */
  }

 /**. <pre>
  *=====================================================================
  * Method "getEnv"
  * This methods requests the registry an resolves an environment-
  *  variable.
  * If 'mde==true' a value of 'null' is returned in case of error.
  * If 'mde==false' and an error occurs, an appropriate error-message
  *  is returned.
  *  Attention: If the requested variable is NOT found 'null' is
  *             returned in both cases.
  * Call:
  *  result = getEnv(name,true); get requested result
  *  if(result==null) {  error-marker was returned
  *    result = getEnv(name,false); get appropriate message
  *    if(result==null) ... variable was not found
  *    else print error-message from 'result'
  *  } error occurred
  * ##getEnv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final String getEnv( /* get value from environment */
   String  key, /* name of environment-variable */
   boolean mde) /* mode of request : false - return message */ 
   {
   /*-----------------------------------------------------------------*/
    Process        aPr;   /* process of execution */
    BufferedReader PrOut; /* Message-Reader (responses) */
    String         data;  /* input-buffer */
    String         txt;   /* command / result */
    int            i;     /* return-code */
   /*=================================================================*/
    txt = TSLogg.getKey("Msg301"); /* get registry-directory */
    txt = TSLogg.getMsg("Msg302",txt,key); /* create command for request */

    key = key.toUpperCase(); /* change name for index-command */
// System.out.println("Cmd:'"+txt+"'");
    try { /* try to execute command */
      aPr = gRE.exec(txt); /* do it */
      PrOut = new BufferedReader( /* get reader for responses */
        new InputStreamReader(aPr.getInputStream()));
      txt = null; /* preset result */
      while((data=PrOut.readLine())!=null) { /* lines present? */
// System.out.println("Line:'"+data+"'");
        if((i=data.toUpperCase().indexOf(key))<0) continue;
          /* real result-line must contain the variable-name  */
        i += key.length(); /* compute start of valid data */
        data = data.substring(i).trim(); /* delete leading blanks */
// System.out.println("Line(t):'"+data+"'");
        /* search end of valid data */
        for(i=0;i<data.length();i+=1) if(Character.isWhitespace(data.charAt(i))) break;
        if(i>=data.length()) /* error should not occur -- terminate */
          if(mde) return null; /* return and signal error */
          else return TSLogg.getMsg("Msg311",data,i); /* return error-message */
        if(!(txt=data.substring(0,i)).equals("REG_SZ")) /* check type of registry-entry */
          if(mde) return null; /* return and signal error */
          else return TSLogg.getMsg("Msg312",txt); /* return error-message */
        txt = data.substring(i).trim(); /* extract value, delete leading blanks */
// System.out.println("Line(x): Val = '"+txt+"'");
      } /* response-lines present */
      i = aPr.waitFor(); /* wait until command finished and get return-code */
      if(i>0) if(mde) return null; /* return and signal error */
              else return TSLogg.getMsg("Msg313",i); /* return error-message */
    } catch (Exception e) { /* error found while command-exec */
      if(mde) return null; /* return and signal error */
      return TSLogg.getMsg("Msg314",e.toString()); /* return error-message */
    } /* error occurred */
    return txt; /* send result or error-marker */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getLvlMsk"
  * Convert a StaticDetailLevel-expression into a mask.
  * supports ranges (e.g. 0-3) and listings (e.g. 0,1,2) or both
  * ##getLvlMsk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static TSOpts getLvlMsk( /* convert StDL-expression */
   String s) /* expression to convert */
   {
   /*-----------------------------------------------------------------*/
    TSOpts cM;    /* current Level-Mask */
    int    i,j,k; /* intermediate value */
   /*=================================================================*/
    if(s.equals("*")) return new TSOpts(0x07FF); /* return all levels */
    cM = new TSOpts(); /* no 'StaticDetailLevel' specified until now */
    k = 0; /* reset marker for range/listing */
      /* init; k=0; number found: k= number(1..11);
       * number followed by '-' found: k= -number
       */
    for(i=0;i<s.length();i+=1) { /* process all specified characters */
      j = "0123456789+-,".indexOf(s.charAt(i)); /* number of next char */
      if(j<0) return new TSOpts(0x80010000); /* invalid char -- report it */
      if(k==0) { /* no number found until now */
        if(j>10) return new TSOpts(0x80010000); /* invalid char -- report it */
        k = j + 1; /* set marker for number */
        continue; /* value is processed */
      } /* number found while not active */
      /* charcter is following a number, k<>0 */
      if(j==11) { /* range-indicator found */
        if(k<0) return new TSOpts(0x80020000); /* invalid char (second indicator) -- report it */
        k = -k; /* mark range-indicator present */
        continue; /* value is processed */
      } /* range-indicator found */
      if(j==12) { /* listings-indicator found */
        if(k<0) return new TSOpts(0x80020000); /* invalid char -- report it */
        cM.setMsk(k-1); /* change mask due to number */
        k = 0; /* mark 'state = init' */
        continue; /* value is processed */
      } /* range-indicator found */
      if(k>0) return new TSOpts(0x80040000); /* invalid char -- report it */
      /* resolve range, last number is again marked so that a following ',' or
       * 'end of string' is valid */
      k = -k - 1; /* restore original number */
      if(k>j) return new TSOpts(0x80080000); /* invalid range -- report it */
      for(;k<=j;k+=1) cM.setMsk(k); /* change mask due to number */
      k = j + 1; /* set marker for number (mark it again) */
    } /* process all specified character(s) */
    if(k<=0) return new TSOpts(0x80100000); /* invalid state -- report it */
    cM.setMsk(k-1); /* change mask due to number */
    return cM; /* return requested result */
  }

 /**. <pre>
  *=====================================================================
  * Method "getPrnt"
  * Return a modified string used for printing the basic command.
  * ##getPrnt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final String getPrnt( /* return command-string */
   String src, /* basic string to be extended */
   String ext) /* string for extension */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    return src + " '" + ext + "'"; /* build and return result */
  }

 /**. <pre>
  *=====================================================================
  * Methode "modStr"
  * Creates a valid 'String' from argument if it contains characters,
  *  which requires surrounding quotes
  * ##modStr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final String modStr( /* check String and modify it */
   String src)  /* source of result to be checked */
   {
   /*-----------------------------------------------------------------*/
    char[] z = {')','(','\r','\n','\t','\\','"',' '};
      /* invalid chars (fix) -- qoutes needed */
    int    i; /* intermediate value */
   /*=================================================================*/
    if(src.length()==0) return "\"\""; /* empty string -- return it */
      /* 'empty string' needs quotes in any case or it is not recognized
       * as a string */
    i = z.length; /* number of characters to be checked */
    while(i>0) { /* check all possible (invalid) chars */
      if(src.indexOf(z[--i])>=0) return addStr(src); /* quotes needed */
    } /* check all character */
    return src; /* no surrounding quotes required */
  }

 /**. <pre>
  *=====================================================================
  * Methode "prExtD"
  * erweiterte Druckausgaben erstellen
  * ##prExtD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static boolean prExtD( /* erweiterte Daten drucken */
   TSRoute cRte) /* Routendefinition wenn aktiv */
   {
   /*-----------------------------------------------------------------*/
    int      i,og; /* Arbeitswert(e) */
    TSScL    cSc;
    TSShL    cSh;
    TSTile   ct;
    TSQuad   cq;
    TSTrNde  cTrN;
    TSTrItm  cIt;
    TSView   cVS;
    TSSigSh  cSgS;
    TSSigTyp cSgT;
    TSSigLgt cSgL;
    TSSigLTx cSgX;
    TSSigFle cSgF;
    TSAct    cAct;
    TSPath   cPth;
    TSSrv    cSrv;
    TSTrf    cTrf;
    TSTrain  cTrn;
    TStType  cTp;
    TSObjLst cObjT;
    Iterator cI;  /* allgemeiner Iterator fuer 'TreeSet'/'HashMap' */
   /** Options of 'PrMsk' are allocated to:
    *   0 - TSTile (High)
    *   1 - TSTile (Low)
    *   2 - TSQuad
    *   3 - TSTrNde (Track)
    *   4 - TSTrItm (Track)
    *   5 - TSTrNde (Road)
    *   6 - TSTrItm (Road)
    *   7 - TSSigSh
    *   8 - TSSigTyp
    *   9 - TSSigLTx
    *  10 - TSSigLgt
    *  11 - TSSigFle
    *  12 - TSShape
    *  13 - TSSect
    *  14 - TSShape(L)
    *  15 - TSSect(L)
    *  16 - TSAct
    *  17 - TSPath
    *  18 - TSSrv
    *  19 - TSTrf
    *  20 - TStType
    *  21 - TSObjLst & TSObjDef
    *  22 - TSTrain (Consist)
    *  23 - still not used
    *  24 - still not used
    *  25 - still not used
    *  26 - still not used
    *  27 - still not used
    *  28 - reserved for '-$X'-group
    *  29 - reserved for '-$X'-group
    *  30 - reserved for '-$X'-group
    *  31 - reserved for '-$X'-group
    *=================================================================*/
    /* Definitionen ausgeben */
    if(Lg.Skip(true)) return true; /* skip line -- logging active? */
    Lg.Msg("prExtD01",PrMsk.prtMsk(0x0FFFFFFF));

    Lg.Skip(false); /* Leerzeile loggen */
    Lg.Log("prExtD02",Fo.toStr()); /* Datenfeld ausgeben */

    if(PrMsk.chkMsk(12) && ShTab!=null) { /* Datentabelle ist gefuellt */
      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Log("prExtD11",ShTab.length); /* Datenfeld ausgeben */
      for(i=0;i<ShTab.length;i+=1) { /* alle Eintraege */
        if(ShTab[i]==null) continue; /* nicht ausgeben */
        Lg.Log("prExtD09",ShTab[i].toStr(),i); /* Datenfeld ausgeben */
      } /* alle Eintraege */
    } /* Datentabelle ausgeben */
    if(PrMsk.chkMsk(13) && ScTab!=null) { /* Datentabelle ist gefuellt */
      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Log("prExtD12",ScTab.length); /* Datenfeld ausgeben */
      for(i=0;i<ScTab.length;i+=1) { /* alle Eintraege */
        if(ScTab[i]==null) continue; /* nicht ausgeben */
        Lg.Log("prExtD09",ScTab[i].toStr(),i); /* Datenfeld ausgeben */
      } /* alle Eintraege */
    } /* Datentabelle ausgeben */

    if(cRte!=null) { /* Routendefinitionen ausgeben */
      Lg.Skip(false); /* Leerzeile loggen */
      Lg.Log("prExtD13",cRte.toStr()); /* Daten ausgeben */

      if(PrMsk.chkMsk(14) && (og=cRte.get$Sh(true))>ShA) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD15",og - ShA); /* Datenfeld ausgeben */
        for(i=ShA;i<og;i+=1) { /* alle Eintraege */
          if((cSh=cRte.chgShT(i,null))==null) continue;
          Lg.Log("prExtD09",cSh.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Eintraege bearbeiten und ausgeben */
      } /* Datentabelle ausgeben */
      cSc = null; /* fuer Compiler */
      if(PrMsk.chkMsk(15) && (og=cRte.get$Sc(true))>ScA) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD14",og - ScA); /* Datenfeld ausgeben */
        for(i=ScA;i<og;i+=1) { /* alle Eintraege */
          if((cSc=cRte.chgScT(i,null))==null) continue;
          Lg.Log("prExtD09",cSc.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Eintraege bearbeiten und ausgeben */
      } /* Datentabelle ausgeben */
      cSh = null; /* fuer Compiler */
      if(PrMsk.chkMsk(0) && (cI=cRte.getIt(10))!=null) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD16",cRte.getTle(0,false).size()); /* Feld ausgeben */
        i = 0; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          ct = (TSTile)cI.next(); /* naechste Tile-Definition */
          i += 1; /* weiterer Satz vorhanden */
          Lg.Log("prExtD09",ct.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Datensaetze ausgeben */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(1) && (cI=cRte.getIt(11))!=null) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD17",cRte.getTle(1,false).size()); /* Feld ausgeben */
        i = 0; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          ct = (TSTile)cI.next(); /* naechste Tile-Definition */
          i += 1; /* weiterer Satz vorhanden */
          Lg.Log("prExtD09",ct.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Datensaetze ausgeben */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(2) && (cI=cRte.getIt(12))!=null) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD18",cRte.chgQDf(null).size()); /* Datenfeld ausgeben */
        i = 0; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cq = (TSQuad)cI.next(); /* naechste Tile-Definition */
          i += 1; /* weiterer Satz vorhanden */
          Lg.Log("prExtD09",cq.toStr(),i); /* Datenfeld ausgeben */
          if(cq.chg$View(-1)<1) continue; /* keine Viewsphere-Elemente */
          cVS = cq.chgView(null); /* akt. Viewsphere-Elementkette */
          if(cVS!=null) Lg.Log("prExtD09",cVS.toStr(),i);
        } /* alle Eintraege */
      } /* Datentabelle ausgeben */

      if(PrMsk.chkMsk(3) && (cI=cRte.getIt(0))!=null) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD19",cRte.get$TrN(0)); /* Datenfeld ausgeben */
        i = -1; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cTrN = (TSTrNde)cI.next(); /* naechste TrackNode-Definition */
          i += 1; /* weiterer Satz vorhanden */
          if(cTrN==null) throw new IllegalStateException( /* Sicherheitsabfrage */
            TSLogg.getMsg("Msg908","TSTrNde==null","prExtD()",0));
          Lg.Log("prExtD09",cTrN.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Datensaetze ausgeben */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(4) && (cI=cRte.getIt(2))!=null) { /* Tabelle ist gefuellt */
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD20",cRte.get$TrI(0)); /* Datenfeld ausgeben */
        i = -1; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cIt = (TSTrItm)cI.next(); /* naechste TrItem-Definition */
          i += 1; /* weiterer Satz vorhanden */
          if(cIt==null) throw new IllegalStateException( /* Sicherheitsabfrage */
            TSLogg.getMsg("Msg908","TSTrItem==null","prExtD()",0));
          Lg.Log("prExtD09",cIt.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Datensaetze ausgeben */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(5) && (cI=cRte.getIt(1))!=null) { /* Tabelle ist gefuellt */
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD21",cRte.get$TrN(1)); /* Datenfeld ausgeben */
        i = -1; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cTrN = (TSTrNde)cI.next(); /* naechste TrackNode-Definition */
          i += 1; /* weiterer Satz vorhanden */
          if(cTrN==null) throw new IllegalStateException( /* Sicherheitsabfrage */
            TSLogg.getMsg("Msg908","TSTrNde==null","prExtD()",1));
          Lg.Log("prExtD09",cTrN.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Datensaetze ausgeben */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(6) && (cI=cRte.getIt(3))!=null) { /* Tabelle ist gefuellt */
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD22",cRte.get$TrI(1)); /* Datenfeld ausgeben */
        i = -1; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cIt = (TSTrItm)cI.next(); /* naechste TrItem-Definition */
          i += 1; /* weiterer Satz vorhanden */
          if(cIt==null) throw new IllegalStateException( /* Sicherheitsabfrage */
            TSLogg.getMsg("Msg908","TSTrItem==null","prExtD()",1));
          Lg.Log("prExtD09",cIt.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Datensaetze ausgeben */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(7) && (og=cRte.get$SgS(false))>0) { /* Tabelle ist gefuellt */
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD23",og); /* Datenfeld ausgeben */
        cI = cRte.getIt(21); /* Iterator ueber Signal-Shape-Tabelle */
        i = -1; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cSgS = (TSSigSh)cI.next(); /* naechste Signal-Shape-Definition */
          i += 1; /* weiterer Satz vorhanden */
          if(cSgS==null) continue; /* ungueltiger Satz -- nicht ausgeben */
          Lg.Log("prExtD09",cSgS.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Eintraege */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(8) && (og=cRte.get$SgT(false))>0) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD24",og); /* Datenfeld ausgeben */
        cI = cRte.getIt(22); /* Iterator ueber Signal-Type-Tabelle */
        i = -1; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cSgT = (TSSigTyp)cI.next(); /* naechste Signal-Type-Definition */
          i += 1; /* weiterer Satz vorhanden */
          if(cSgT==null) continue; /* ungueltiger Satz -- nicht ausgeben */
          Lg.Log("prExtD09",cSgT.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Eintraege */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(9) && (og=cRte.get$SgLTx(false))>0) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD25",og); /* Datenfeld ausgeben */
        cI = cRte.getIt(24); /* Iterator ueber Signal-LTexture-Tabelle */
        i = -1; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cSgX = (TSSigLTx)cI.next(); /* naechste Signal-Type-Definition */
          i += 1; /* weiterer Satz vorhanden */
          if(cSgX==null) continue; /* ungueltiger Satz -- nicht ausgeben */
          Lg.Log("prExtD09",cSgX.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Eintraege */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(10) && (og=cRte.get$SgLT(false))>0) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD26",og); /* Datenfeld ausgeben */
        cI = cRte.getIt(23); /* Iterator ueber Signal-Light-Tabelle */
        i = -1; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cSgL = (TSSigLgt)cI.next(); /* naechste Signal-Type-Definition */
          i += 1; /* weiterer Satz vorhanden */
          if(cSgL==null) continue; /* ungueltiger Satz -- nicht ausgeben */
          Lg.Log("prExtD09",cSgL.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Eintraege */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(11) && (cI=cRte.getIt(20))!=null) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD32",cRte.getSigF(0).size()); /* Datenfeld ausgeben */
        i = 0; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cSgF = (TSSigFle)cI.next(); /* Signalscript-Eintrag-Eintrag holen */
          if(cSgF==null) continue; /* Datensatz nicht gefuellt */
          i += 1; /* weiterer Satz vorhanden */
          Lg.Log("prExtD09",cSgF.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Eintraege */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(16) && (cI=cRte.getIt(16))!=null) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD27",cRte.getAct().size()); /* Datenfeld ausgeben */
        i = 0; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cAct = (TSAct)cI.next(); /* Pfad-Eintrag holen */
          if(cAct==null) continue; /* Datensatz nicht gefuellt */
          i += 1; /* weiterer Satz vorhanden */
          Lg.Log("prExtD09",cAct.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Eintraege */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(17) && (cI=cRte.getIt(17))!=null) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD28",cRte.getPath().size()); /* Datenfeld ausgeben */
        i = 0; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cPth = (TSPath)cI.next(); /* Pfad-Eintrag holen */
          if(cPth==null) continue; /* Datensatz nicht gefuellt */
          i += 1; /* weiterer Satz vorhanden */
          Lg.Log("prExtD09",cPth.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Eintraege */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(18) && (cI=cRte.getIt(18))!=null) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD29",cRte.getServ().size()); /* Datenfeld ausgeben */
        i = 0; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cSrv = (TSSrv)cI.next(); /* Service-Eintrag holen */
          if(cSrv==null) continue; /* Datensatz nicht gefuellt */
          i += 1; /* weiterer Satz vorhanden */
          Lg.Log("prExtD09",cSrv.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Eintraege */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(19) && (cI=cRte.getIt(19))!=null) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD30",cRte.getTrf().size()); /* Datenfeld ausgeben */
        i = 0; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cTrf = (TSTrf)cI.next(); /* Traffic-Eintrag holen */
          if(cTrf==null) continue; /* Datensatz nicht gefuellt */
          i += 1; /* weiterer Satz vorhanden */
          Lg.Log("prExtD09",cTrf.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Eintraege */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(20) && (og=cRte.set$Type(0))>0) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD31",og); /* Datenfeld ausgeben */
        for(i=0;i<og;i+=1) { /* alle Eintraege */
          if((cTp=cRte.chgType(i,null))==null) continue;
          Lg.Log("prExtD09",cTp.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Eintraege */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(21) && (cI=cRte.getIt(25))!=null) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD33",cRte.get$ObjL()); /* print prefix */
        i = 0; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cObjT = (TSObjLst)cI.next(); /* get next List-entry for route-objects */
          if(cObjT==null) continue; /* no data available */
          i += 1; /* weiterer Satz vorhanden */
          Lg.Log("prExtD09",cObjT.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Eintraege */
      } /* Datentabelle ausgeben */
      if(PrMsk.chkMsk(22) && (cI=cRte.getIt(26))!=null) {
        Lg.Skip(false); /* Leerzeile loggen */
        Lg.Log("prExtD34",cRte.getTrain().size()); /* print prefix */
        i = 0; /* Satznummer initialisieren */
        while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
          cTrn = (TSTrain)cI.next(); /* get next List-entry for route-objects */
          if(cTrn==null) continue; /* no data available */
          i += 1; /* weiterer Satz vorhanden */
          Lg.Log("prExtD09",cTrn.toStr(),i); /* Datenfeld ausgeben */
        } /* alle Eintraege */
      } /* Datentabelle ausgeben */

    } /* Routendefinition vorhanden */

    Lg.Skip(false); /* Leerzeile loggen */
    return false; /* Programm ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "prStart"
  * Aufbereiten Vorlauf und Ausgeben
  * Methode nutzt globale Variablen 'Lg','Kdo','SpVers' und 'Fo'
  * ##prStart (Eyecatcher)
  *=====================================================================
  </pre>*/
  private static final void prStart( /* Meldung ausgeben */
   String    key, /* Nummer der Meldung */
   String... prm) /* aktuelle Ersetzungswerte */
   {
   /*-----------------------------------------------------------------*/
    String            txt; /* Datenpuffer */
    String[]          a = {"","",Version}; /* Ausgabe-Werte Vorlauf */
    String[]          p = {OSName,OSVer,JVName,JVer};
    Iterator<String>  cI;  /* Iterator fuer Fehlermeldungen */
    ArrayList<String> EL;  /* Fehler-Speicher */
   /*=================================================================*/
    EL = Fo.getQue(0); /* Liste der Fehler extrahieren */
    if(!Lg.Log("Msg101",a)) { /* print 1. leaderline -- successfull */
      Lg.Log("Msg102",a); /* 2. Vorlaufsatz ausgeben */
      Lg.Log("Msg103",a); /* 3. Vorlaufsatz ausgeben */
      Lg.Log("Msg104",a); /* 4. Vorlaufsatz ausgeben */
      if(SpVers.length()>0) Lg.Log("Msg001",SpVers); /* Sonderfall ? */
      Lg.Log("Msg003",p); /* BS-/Java-Version ausgeben */
      if(Kdo!=null) Lg.Log("Msg004",Kdo); /* akt. Kommando ausgeben */
    } /* Logging aktiv -- Vorlauf ausgeben */

   if(EL.size()>0) { /* gespeicherte Meldungen ausgeben */
      Lg.Skip(false); /* Leerzeile ausgeben */
      cI = EL.iterator(); /* alle Meldungen durchgehen */
      while(cI.hasNext()) { /* Weitere Meldungen vorhanden ? */
        txt = cI.next(); /* naechste Meldung holen */
        if(txt.startsWith("####")) { /* Programmabbruch gefordert */
          Lg.Close(); /* close output to Log-file */
          System.exit(Integer.parseInt(txt.substring(4)));
        } /* Programmabbruch gefordert */
        Lg.Log("Msg010",txt); /* Meldung ausgeben (falls Log aktiv) */
      } /* alle gespeicherte Meldungen bearbeiten */
      EL.clear(); /* alle gespeicherte Meldungen loeschen */
    } /* gespeicherte Fehlermeldungen ausgegeben */

    if(Lg.Skip(false)) return; /* terminate if logging not active */
    Lg.Log(key,prm); /* Letzte, gelieferte Meldung ausgeben */
    if(Fo.chkMsk(30)) Lg.Log("Msg010","   ( "+getDate(0,true)+" )");
    else Lg.Log("Msg010","   ( "+getDate(0,false)+" )"); /* Timestamp */
    Lg.Skip(false); /* Leerzeile ausgeben */
    return; /* Programm ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "putFV" (Version mit Runden)
  * Double-Zahl aufbereiten fuer Ausgabe
  * Wenn c>0 ist wird der Wert vor dem Aufbereiten auf
  *   c Nachkommastellen gerundet
  * ACHTUNG: Es wird immer ein fuehrendes Blank geliefert
  * ##putFV (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String putFV( /* Aufbereiten einer Zahl */
   double v, /* Wert (value) zum Aufbereiten */
   int    c) /* Anzahl der gueltigen Nachkomma-Stellen */
   {
   /*-----------------------------------------------------------------*/
    String rs;  /* result-string */
    double f;   /* Arbeitswert */
    int    i,p; /* Arbeitswert */
   /*=================================================================*/
    f = Math.abs(v); /* Positiver Wert fuer Exponent-Suche */
    if(f==0.0) return " 0"; /* einfache Aufbereitung */
    if(c>0) { /* Runden vor dem Aufbereiten gefordert */
      while(f<0.10) { c += 1; f *= 10.0; } /* Wert anpassen */
      f = Math.pow(10.0,c); /* Filterwert berechnen */
      v = Math.rint(v * f); /* erster Teil berechnen */
      v /= f; /* gerundeten Wert setzen */
    } /* Runden wurde durchgefuehrt */
    rs = " " + v; /* Ausgabe-String erstellen */
    p = rs.indexOf('.'); /* Position des Dezimalpunktes */
    if(rs.endsWith(".0")) return rs.substring(0,p); /* fertig */
    if(p<0) return rs; /* kein Dezimalpunkt erstellt -- fertig */
    if(rs.indexOf('e')>p) return rs; /* Exponent-Format -- Ende */
    if(rs.indexOf('E')>p) return rs; /* Exponent-Format -- Ende */
    if((i=rs.indexOf("00000",p+2))>p) return rs.substring(0,i);
    if((i=rs.indexOf("999999",p))>p) return rs.substring(0,i+5);
    return rs; /* leave method */
  }

 /**. <pre>
  *=====================================================================
  * Methode "prFN"
  * Zahlenaufbereitung fuer Dateinamen (World, Sound,... )
  * ##prFN (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String prFN( /* Aufbereiten fuer Dateiname */
   int w1, /* ganzahliger Wert zum Aufbereiten */
   int w2, /* ganzahliger Wert zum Aufbereiten */
   int fl) /* Feldlaenge eines Wertes */
   {
   /*-----------------------------------------------------------------*/
    String        rs; /* result-string */
    DecimalFormat DF; /* Formatierungsobjekt */
   /*=================================================================*/
    if(fl<3 || fl>10) return null; /* Fehler beim Aufbereiten */
    DF  = new DecimalFormat("0000000000".substring(0,fl));
    if(w1<0) rs = "-" + DF.format(-w1); /* negativer Wert erstellen */
    else rs = "+" + DF.format(w1); /* positiver Wert erstellen */
    if(w2<0) rs += "-" + DF.format(-w2); /* negativer Wert erstellen */
    else rs += "+" + DF.format(w2); /* positiver Wert erstellen */
    return rs; /* leave method */
  }

 /**. <pre>
  *=====================================================================
  * Methode "round"
  * 'double-Wert' auf n-Nachkomma-Stellen runden
  * ##round (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static double round( /* Wert runden */
   double w, /* Wert der gerundet werden soll */
   int    c) /* Anzahl der gueltigen Nachkomma-Stellen */
   {
   /*-----------------------------------------------------------------*/
    double f; /* Arbeitswerte */
   /*=================================================================*/
    f = Math.abs(w); /* Positiver Wert fuer Exponent-Suche */
    if(f==0.0) return w; /* Wert kann nicht gerundet werden */
    c = Math.abs(c); /* negativer Wert NICHT gueltig */
    while(f<0.10) { c += 1; f *= 10.0; } /* Wert anpassen */
    f = Math.pow(10.0,c); /* Filterwert berechnen */
    w = Math.rint(w * f); /* erster Teil berechnen */
    return w / f; /* gerundeten Wert zurueckliefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setPrfx"
  * Create a prefix-definition of an output-line
  *   and return it as String
  * ##setPrfx (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final String setPrfx( /* create line-prefix */
   int l) /* length of prefix-string */
   {
   /*-----------------------------------------------------------------*/
    char[] t; /* temporary array */
   /*=================================================================*/
    if(l<1) return ""; /* error -- return default */
    t = new char[l]; /* create array of requested length */
    Arrays.fill(t,'\t'); /* fill it with requested character */
    return new String(t); /* convert to String and return */
  }

 /**. <pre>
  *=====================================================================
  * Methode "toHex"
  * Long/Integer-Zahl hexadezimal aufbereiten
  * Die Ziel-Laenge ist angebbar und kann zwischen 1 und 16 liegen
  * Wenn Laenge<0 werden grosse Buchstaben benutzt
  * ##toHex (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String toHex( /* hexadezimal Aufbereiten */
   long w, /* ganzahliger Wert zum Aufbereiten */
   int  l) /* Laenge des Ziel-Wertes */
   {
   /*-----------------------------------------------------------------*/
    String  rs; /* result-string */
    boolean up; /* uppercase-Character */
   /*=================================================================*/
    up = false; /* Default: kleine Buchstaben verwenden */
    if(l<0) { up = true; l = -l; } /* Modus umschalten */
    if(l<1) return ""; /* ungueltiger Wert */
    rs = "000000000000000" + Long.toHexString(w); /* hexadezimal */
    l = rs.length() - Math.min(l,16); /* Start-Position berechnen */
    if(up) rs = rs.toUpperCase(); /* Ergebnis umwandeln */
    return rs.substring(l); /* Wert liefern */
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSLogg -- Definition fuer Log-Ausgabe
 * Achtung: Meldungskennungen duerfen NICHT laenger als 8 Zeichen sein
 * ##TSLogg (Eyecatcher)
 *======================================================================
 </pre>*/
class TSLogg implements Serializable { /* Definitionen fuer Logging */
 /*-------------------------------------------------------------------*/
  protected static String        IdStr = " 3.4.00 11.11.2008";
  private static ResourceBundle  Msgs = null; /* Messages */
  private static HashSet<String> MsgL = null; /* negativ-Liste */
  private static String          pref = " ---> ";
  private static String          sep = /* separator for output-files */
    "============================================================" +
    "============================================================";
 /*-------------------------------------------------------------------*/
  private static StringBuilder   CRLF;   /* Line-separator */
 /*-------------------------------------------------------------------*/
  private boolean                nol;    /* Logging nicht aktiv */
  private String                 fn;     /* Log-Dateiname */
//  private TSFile                 LgF;    /* buff. output (Log-file) */
  private BufferedWriter         LgF;    /* Log-File */
  private boolean                msgK;   /* Meldungskennung anfuegen */
 /**. <pre>
  *=====================================================================
  * Constructor: (0) Create static definitions
  *=====================================================================
  </pre>*/
  static { /* Perform static initialisations */
   /*-----------------------------------------------------------------*/
    Properties sysprop; /* System Properties */
    Locale     cL;      /* current used language */
    String     is;      /* temporary only */
   /*=================================================================*/
    cL = Locale.getDefault(); /* get default-language (unmodified) */
    Locale.setDefault(Locale.ENGLISH); /* set new default-language */
    sysprop = System.getProperties(); /* get pointer to properties */
    is = sysprop.getProperty("Lang"); /* special language requested? */
    if(is!=null) if(is.length()==2) /* language specified -- use it */
      cL = new Locale(is.toLowerCase()); /* requested language */
    /* establish language-dependent files */
    try { Msgs = ResourceBundle.getBundle("TSErrMsg",cL); /* Messages */
    } catch (MissingResourceException e) { Msgs = null; }
    if(Msgs==null) { /* error -- language-file(s) is/are missed */
      System.err.println();  /* print empty line */
      System.err.println("ERROR: Language-Definition not correct!");
      System.err.println("       Please check file 'TSErrMsg.properties'!");
      System.err.println("       'TSUtil' cannot continue! (RC=99)");
      System.err.println();   /* print empty line */
      System.exit(99); /* abort program */
    } /* Language-files are missed */
    CRLF = new StringBuilder(sysprop.getProperty("line.separator"));
    MsgL = new HashSet<String>(); /* initialize blacklist of messages */
  } /* end of 'static' initialisations */

 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSLogg() /* Logging-Definition erstellen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    nol  = true;  /* Logging is NOT active */
//    fn   = null;  /* kein Dateiname bekannt */
//    LgF  = null;  /* Ausgabe noch nicht aktiv */
//    msgK = false; /* Meldungskennung wird nicht vorangestellt */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Logging Eintrag fuer aktives Logging erstellen
  *=====================================================================
  </pre>*/
  protected TSLogg( /* Logging-Definition erstellen */
   String dname) /* Dateiname fuer Logging */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    nol  = true;  /* Logging noch nicht aktiviert */
    fn   = dname; /* aktuellen Dateiname merken */
    LgF  = null;  /* Ausgabe noch nicht aktiv */
    msgK = false; /* Meldungskennung wird nicht vorangestellt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Close"
  * Schliessen der Log-Datei falls offen
  * ##Close.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Close() /* Log-Datei schliessen falls offen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    nol = true; /* Logging nicht mehr aktiviert */
    if(LgF==null) return true; /* nicht offen - keine Funktion */
    try {LgF.close(); /* Datei-Handle schliessen */
    } catch (IOException e) { /* Fehler beim Schliessen */
      System.err.println(); /* Leerzeile zur Abtrennung */
      System.err.println(e.toString()); /* Fehler melden */
      System.err.println(); /* Leerzeile zur Abtrennung */
    } /* schliessen der Datei */
    LgF = null; /* Logging nicht mehr moeglich */
    return false; /* Programm beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Err" (Version <...>)
  * Aufbereiten und Ausgeben einer Meldung MIT Fehlerkennzeichen
  * Achtung: Routine liefert IMMER Fehlerkennzeichen ('true')
  * ##Err.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Err( /* Aufbereiten einer Meldung */
   String    key, /* Schluessel/Text der Meldung */
   String... prm) /* aktuelle Ersetzungswerte */
   {
   /*-----------------------------------------------------------------*/
    String msg; /* Arbeitskette */
   /*=================================================================*/
    if(MsgL.contains(key)) return true; /* Meldung nicht ausgeben */
    msg = pref + getMsg(key,prm) + CRLF; /* Msg erstellen */
    System.out.print(msg); /* Meldung auf Console ausgeben */
    if(nol) return true; /* Logging nicht aktiv -- Ende */
    if(msgK) msg = fmtKey(key,msg); /* Meldungskennung voranstellen */
    try {LgF.write(msg); /* Datensatz schreiben */
    } catch (IOException e) { /* IO-Fehler aufgetreten */
      System.err.println(); /* Leerzeile zur Abtrennung */
      System.err.println(e.toString()); /* Fehler melden */
      System.err.println(); /* Leerzeile zur Abtrennung */
      nol = true; /* Fehler -- Logging abschalten */
    } /* Logging aktiviert */
    return true; /* Programm beenden -- Fehlerkennung liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Err" (Version <I>)
  * Aufbereiten und Ausgeben einer Meldung MIT Fehlerkennzeichen
  * Achtung: Routine liefert IMMER Fehlerkennzeichen ('true')
  * ##Err.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Err( /* Aufbereiten einer Meldung */
   String key, /* Schluessel/Text der Meldung */
   int    p0)  /* 1. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Err(key,""+p0); /* Version '...' benutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Err" (Version <SI>)
  * Aufbereiten und Ausgeben einer Meldung MIT Fehlerkennzeichen
  * Achtung: Routine liefert IMMER Fehlerkennzeichen ('true')
  * ##Err.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Err( /* Aufbereiten einer Meldung */
   String key, /* Schluessel/Text der Meldung */
   String p0,  /* 1. Ersetzungswert */
   int    p1)  /* 2. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Err(key,p0,""+p1); /* Version '...' benutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Err" (Version <SF>)
  * Aufbereiten und Ausgeben einer Meldung MIT Fehlerkennzeichen
  * Achtung: Routine liefert IMMER Fehlerkennzeichen ('true')
  * ##Err.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Err( /* Aufbereiten einer Meldung */
   String key, /* Schluessel/Text der Meldung */
   String p0,  /* 1. Ersetzungswert */
   double p1)  /* 2. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
    String msg; /* Arbeitskette */
   /*=================================================================*/
    if(MsgL.contains(key)) return true; /* Meldung nicht ausgeben */
    msg = pref + getMsg(key,p0,p1) + CRLF; /* erstellen */
    System.out.print(msg); /* Meldung auf Console ausgeben */
    if(nol) return true; /* Logging nicht aktiv -- Ende */
    if(msgK) msg = fmtKey(key,msg); /* Meldungskennung voranstellen */
    try {LgF.write(msg); /* Datensatz schreiben */
    } catch (IOException e) { /* IO-Fehler aufgetreten */
      System.err.println(); /* Leerzeile zur Abtrennung */
      System.err.println(e.toString()); /* Fehler melden */
      System.err.println(); /* Leerzeile zur Abtrennung */
      nol = true; /* Fehler -- Logging abschalten */
    } /* Logging aktiviert */
    return true; /* Programm beenden -- Fehlerkennung liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Err" (Version <SSI>)
  * Aufbereiten und Ausgeben einer Meldung MIT Fehlerkennzeichen
  * Achtung: Routine liefert IMMER Fehlerkennzeichen ('true')
  * ##Err.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Err( /* Aufbereiten einer Meldung */
   String key, /* Schluessel/Text der Meldung */
   String p0,  /* 1. Ersetzungswert */
   String p1,  /* 2. Ersetzungswert */
   int    p2)  /* 3. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Err(key,p0,p1,""+p2); /* Version '...' benutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Err" (Version <SII>)
  * Aufbereiten und Ausgeben einer Meldung MIT Fehlerkennzeichen
  * Achtung: Routine liefert IMMER Fehlerkennzeichen ('true')
  * ##Err.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Err( /* Aufbereiten einer Meldung */
   String key, /* Schluessel/Text der Meldung */
   String p0,  /* 1. Ersetzungswert */
   int    p1,  /* 2. Ersetzungswert */
   int    p2)  /* 3. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Err(key,p0,""+p1,""+p2); /* Version '...' benutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Err" (Version <SSII>)
  * Aufbereiten und Ausgeben einer Meldung MIT Fehlerkennzeichen
  * Achtung: Routine liefert IMMER Fehlerkennzeichen ('true')
  * ##Err.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Err( /* Aufbereiten einer Meldung */
   String key, /* Schluessel/Text der Meldung */
   String p0,  /* 1. Ersetzungswert */
   String p1,  /* 2. Ersetzungswert */
   int    p2,  /* 3. Ersetzungswert */
   int    p3)  /* 4. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Err(key,p0,p1,""+p2,""+p3); /* Version '...' benutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Err" (Version <SIII>)
  * Aufbereiten und Ausgeben einer Meldung MIT Fehlerkennzeichen
  * Achtung: Routine liefert IMMER Fehlerkennzeichen ('true')
  * ##Err.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Err( /* Aufbereiten einer Meldung */
   String key, /* Schluessel/Text der Meldung */
   String p0,  /* 1. Ersetzungswert */
   int    p1,  /* 2. Ersetzungswert */
   int    p2,  /* 3. Ersetzungswert */
   int    p3)  /* 4. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Err(key,p0,""+p1,""+p2,""+p3); /* Version '...' benutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Err" (Version <SIIII>)
  * Aufbereiten und Ausgeben einer Meldung MIT Fehlerkennzeichen
  * Achtung: Routine liefert IMMER Fehlerkennzeichen ('true')
  * ##Err.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Err( /* Aufbereiten einer Meldung */
   String key, /* Schluessel/Text der Meldung */
   String p0,  /* 1. Ersetzungswert */
   int    p1,  /* 2. Ersetzungswert */
   int    p2,  /* 3. Ersetzungswert */
   int    p3,  /* 4. Ersetzungswert */
   int    p4)  /* 5. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Err(key,p0,""+p1,""+p2,""+p3,""+p4); /* Version '...' */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fmtKey"
  * Schluesselkennung formatieren und Meldung voranstellen
  * ##fmtKey.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  private static String fmtKey( /* Schluesseldefinition formatieren */
   String key, /* Kennung der Meldung */
   String msg) /* Meldungsrumpf */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(key.length()>8) return "{********}" + msg; /* direkter Text */
    return "{" + (key+"        ").substring(0,8) + "}" + msg;
     /* Programm beenden -- neue Meldung zurueckgeben */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getKey"
  * Meldung gemaess Schluessel aus Sprachdefinition holen
  *  Es findet KEINE Parameter-Ersetzung (ausser Sonderfall) statt!!
  * Achtung: 'Msgs' ist auf jeden Fall gueltig. da sonst Programm
  *   sofort beendet wird. 'Msgs' wird deshalb nicht mehr geprueft.
  * ##getKey.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getKey( /* get message-definition */
   String key) /* key of the message */
   {
   /*-----------------------------------------------------------------*/
    String msg,txt;
    int    i,j;
   /*=================================================================*/
    try { msg = Msgs.getString(key); /* Text holen */
    } catch (MissingResourceException e) { msg = null; } /* Dummy */
    if(key.indexOf('*')>=0) return msg; /* auf jeden Fall liefern */
    if(msg!=null) return msg; /* gefunden -- OK */
    txt = "'"+key+"','"+Msgs.getLocale()+"'"; /* create signature */
    try { msg = Msgs.getString("Default"); /* get default-message */
    } catch (MissingResourceException e) { msg = null; } /* Dummy */
    if(msg==null) return "ERROR: ****** "+txt+" ******";
      /* Meldung (akt. & 'Default') fehlt -- Dummy-Wert liefern */
    i = msg.indexOf("%"); /* Ersetzungszeichen ? */
    if(i<0) return msg; /* not found -- do not replace */
    if((j=i+2)<msg.length()) txt += msg.substring(j);
    return msg.substring(0,i) + txt; /* terminate method */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getMsg" (Version <...>)
  * Aufbereiten einer Meldung -- Ersetzen von Parametern
  * Wenn die Schluessellaenge >8 Zeichen ist, wird angenommen,
  *  dass es sich NICHT um einen Schluessel sondern um die
  *  Rohmeldung(='Meldung mit Platzhalter') selbst handelt!
  * ACHTUNG: Sprachdefinition wird beachtet!!!
  * Achtung: 'Msgs' ist auf jeden Fall gueltig. da sonst Programm
  *   sofort beendet wird. 'Msgs' wird deshalb nicht mehr geprueft.
  * Achtung: Es erfolgt (prinzipiell) kein 'reScan'. Wenn ein Argument
  *   Platzhalter enthaelt, werden diese NICHT aufgeloest.
  * ##getMsg.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getMsg( /* Aufbereiten Meldung */
   String    key, /* Schluessel/Text der Meldung */
   String... prm) /* aktuelle Ersetzungswerte (array/sequence) */
   {
   /*-----------------------------------------------------------------*/
    String  msg,txt; /* Arbeitstexte */
    int     i,j,k,z; /* Arbeitswerte */
    char    c;       /* Steuerzeichen */
   /*=================================================================*/
    msg = key; /* Annehmen: Rohmeldung */
    if(key.length()<9) msg = getKey(key); /* Meldung gem. Sprache holen */
    if(msg==null) return ""; /* Sonderfall: NICHTS liefern */
    if(msg.startsWith("%%%%%%%%")) msg = msg.substring(8); /* verkuerzen */
    z = 0; /* relative Zeilenlaenge setzen */
    i = msg.indexOf('%'); /* Ersetzungszeichen ? */
    while(i>=0) { /* process all replacements */
      k = i + 2; /* weiterer Arbeitswert */
      if(msg.length()<k) break; /* Ersetzung nicht moeglich */
      txt = "";  /* kein gueltiger Ersetzungswert -- Default/Dummy */
      switch(c=msg.charAt(i+1)) { /* gemaess Steuerung bearbeiten */
        case('%'): txt = CRLF.toString(); /* Sonderwert eintragen */
          z = i + 1; /* Relative Zeile beginnt hier neu */
          break; /* replacement-string was successfully provided */
        case('?'): if(key.length()<9) txt = key; /* Sonderwert */ break;
        case('&'): /* Positionswert angegeben */
        case('+'): /* Laengenwert angegeben */
          for(j=k;j<msg.length();j+=1) /* Laenge der Ziffernreihe */
            if(!Character.isDigit(msg.charAt(j))) break;
          if(j==k) break; /* keine Nummer ist definiert */
          k = j; /* Fortsetzung der Message */
          j = Integer.parseInt(msg.substring(i+2,j)); /* Zahl holen */
          if(c=='&') j -= i - z; /* Anzahl Fuellzeichen berechnen */
          j = Math.max(0,j); /* Wert muss positiv sein */
          while(j-->0) txt += " "; /* Fuellstring erstellen */
          break; /* replacement-string was successfully provided */
        case('\''): /* Referenzwert angegeben */
          j = msg.indexOf('\'',k); /* Ende der Namensdefinition suchen */
          if(j<=k) break; /* KEINE Referenz gefunden */
          if((j-k)<=8) { /* gueltige Referenz gefunden */
            txt = msg.substring(k,j); /* Schluessel holen */
            txt = getMsg(txt,prm); /* Referenz rekursiv aufloesen */
          } /* gueltige Referenz vorhanden und bearbeitet */
          k = j + 1; /* Fortsetzung nach (ungueltiger) Referenz */
          c = ' '; /* 'reScan' des Ersetzungswertes einschalten */
          break; /* replacement-string was successfully provided */
        case('['): /* reference to registy-entry provided */
          j = msg.indexOf(']',k); /* search for end of variable-name */
          if(j<=k) break; /* NO reference provided */
          /* Attention: length of registry-variable may be longer than 8 characters */
          txt = msg.substring(k,j); /* resolve variable-name of key */
          txt = TSUtil.getEnv(txt,true); /* get result from registry */
          if(txt==null) { /* error occurred -- repeat it and get message */
            txt = msg.substring(k,j); /* resolve variable-name of key again */
            txt = TSUtil.getEnv(txt,false); /* get message from registry */
            if(txt==null) txt = "?("+msg.substring(k,j)+")"; /* variable not found -- insert marker */
            else txt = " ---" + txt + "--- "; /* mark error-message within message */
          } else c = ' '; /* apply 'reScan' of replacement if no error was found */
          k = j + 1; /* compute new position for next replacement */
          break; /* replacement-string was successfully provided */
        case('{'): /* Fix-Text angegeben */
          /* Achtung: KEINE REKURSIVE Klammerung moeglich */
          j = msg.indexOf('}',k); /* Ende der Namensdefinition suchen */
          if(j<k) break; /* KEINE Referenz gefunden */
          txt = msg.substring(k,j); /* Fix-Text holen */
          k = j + 1; /* Fortsetzung nach festem Text */
          break; /* replacement-string was successfully provided */
        default: /* Parameter-Nummer bearbeiten */
          if((j="0123456789".indexOf(c))<0) break; /* Ungueltiger Wert */
          if(prm!=null && prm.length>j) txt = prm[j]; /* Element */
          if(txt==null) txt = ""; /* Null-Argument ersetzen */
      } /* replacement-id was (successfully) processed */
      if(msg.length()==k) msg = msg.substring(0,i) + txt;
      else msg = msg.substring(0,i) + txt + msg.substring(k);
      if(c!=' ') i += txt.length(); /* Fortsetzungstelle berechnen */
        /* ' ' ist Kennzeichen fuer EINMALIGEN 'reScan' des Arguments */
      i = msg.indexOf('%',i); /* weitere Ersetzungszeichen ? */
    } /* all placeholder have been replaced */
    return msg; /* OK -- return modified message */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getMsg" (Version <S>)
  * Aufbereiten einer Meldung -- Ersetzen von Parametern
  * ACHTUNG: Beschreibung siehe allgemeine Version
  * ##getMsg.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getMsg( /* Aufbereiten Meldung */
   String key, /* Schluessel/Text der Meldung */
   String p0)  /* 1. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
    String  msg,txt; /* Arbeitstexte */
    int     i,j,k,z; /* Arbeitswerte */
    char    c;       /* Steuerzeichen */
   /*=================================================================*/
    msg = key; /* Annehmen: Rohmeldung */
    if(key.length()<9) msg = getKey(key); /* Meldung gem. Sprache holen */
    if(msg==null) return ""; /* Sonderfall: NICHTS liefern */
    if(msg.startsWith("%%%%%%%%")) msg = msg.substring(8); /* verkuerzen */
    z = 0; /* relative Zeilenlaenge setzen */
    i = msg.indexOf('%'); /* Ersetzungszeichen ? */
    while(i>=0) { /* alle Ersetzungen durchfuehren */
      k = i + 2; /* weiterer Arbeitswert */
      if(msg.length()<k) break; /* Ersetzung nicht moeglich */
      txt = "";  /* kein gueltiger Ersetzungswert -- Default/Dummy */
      switch(c=msg.charAt(i+1)) { /* gemaess Steuerung bearbeiten */
        case('0'): if(p0!=null) txt = p0; /* Wert ersetzen */ break;
        case('%'): txt = CRLF.toString(); /* Sonderwert eintragen */
          z = i + 1; /* Relative Zeile beginnt hier neu */
          break; /* Ersetzungswert wurde bearbeitet */
        case('?'): if(key.length()<9) txt = key; /* Sonderwert */ break;
        case('&'): /* Positionswert angegeben */
        case('+'): /* Laengenwert angegeben */
          for(j=k;j<msg.length();j+=1) /* Laenge der Ziffernreihe */
            if(!Character.isDigit(msg.charAt(j))) break;
          if(j==k) break; /* keine Nummer ist definiert */
          k = j; /* Fortsetzung der Message */
          j = Integer.parseInt(msg.substring(i+2,j)); /* Zahl holen */
          if(c=='&') j -= i - z; /* Anzahl Fuellzeichen berechnen */
          j = Math.max(0,j); /* Wert muss positiv sein */
          while(j-->0) txt += " "; /* Fuellstring erstellen */
          break; /* Ersetzungswert wurde bearbeitet */
        case('\''): /* Referenzwert angegeben */
          j = msg.indexOf('\'',k); /* Ende der Namensdefinition suchen */
          if(j<=k) break; /* KEINE Referenz gefunden */
          if((j-k)<=8) { /* gueltige Referenz gefunden */
            txt = msg.substring(k,j); /* Schluessel holen */
            txt = getMsg(txt,p0); /* Referenz rekursiv aufloesen */
          } /* gueltige Referenz vorhanden und bearbeitet */
          k = j + 1; /* Fortsetzung nach (ungueltiger) Referenz */
          c = ' '; /* 'reScan' des Ersetzungswertes einschalten */
          break; /* Ersetzungswert wurde bearbeitet */
        case('['): /* reference to registy-entry provided */
          j = msg.indexOf(']',k); /* search for end of variable-name */
          if(j<=k) break; /* NO reference provided */
          /* Attention: length of registry-variable may be longer than 8 characters */
          txt = msg.substring(k,j); /* resolve variable-name of key */
          txt = TSUtil.getEnv(txt,true); /* get result from registry */
          if(txt==null) { /* error occurred -- repeat it and get message */
            txt = msg.substring(k,j); /* resolve variable-name of key again */
            txt = TSUtil.getEnv(txt,false); /* get message from registry */
            if(txt==null) txt = "?("+msg.substring(k,j)+")"; /* variable not found -- insert marker */
            else txt = " ---" + txt + "--- "; /* mark error-message within message */
          } else c = ' '; /* apply 'reScan' of replacement if no error was found */
          k = j + 1; /* compute new position for next replacement */
          break; /* replacement-string was successfully provided */
        case('{'): /* Fix-Text angegeben */
          /* Achtung: KEINE REKURSIVE Klammerung moeglich */
          j = msg.indexOf('}',k); /* Ende der Namensdefinition suchen */
          if(j<k) break; /* KEINE Referenz gefunden */
          txt = msg.substring(k,j); /* Fix-Text holen */
          k = j + 1; /* Fortsetzung nach festem Text */
          break; /* Ersetzungswert wurde bearbeitet */
        default:; /* keine Aktion -- 'txt' ist bereits gesetzt */
      } /* Ersetzungskennung wurde (erfolgreich) bearbeitet */
      if(msg.length()==k) msg = msg.substring(0,i) + txt;
      else msg = msg.substring(0,i) + txt + msg.substring(k);
      if(c!=' ') i += txt.length(); /* Fortsetzungstelle berechnen */
        /* ' ' ist Kennzeichen fuer EINMALIGEN 'reScan' des Arguments */
      i = msg.indexOf('%',i); /* weitere Ersetzungszeichen ? */
    } /* alle Platzhalter wurden ersetzt */
    return msg; /* Programm beenden -- neuen String liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getMsg" (Version <I>)
  * Aufbereiten einer Meldung -- Ersetzen von Parametern
  * ACHTUNG: Beschreibung siehe allgemeine Version
  * ##getMsg.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getMsg( /* Aufbereiten Meldung */
   String key, /* Schluessel/Text der Meldung */
   int    p0)  /* 1. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return getMsg(key,""+p0); /* Version 'S' nutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getMsg" (Version <F>)
  * Aufbereiten einer Meldung -- Ersetzen von Parametern
  * ACHTUNG: Beschreibung siehe allgemeine Version
  * ##getMsg.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getMsg( /* Aufbereiten Meldung */
   String key, /* Schluessel/Text der Meldung */
   double p0)  /* 1. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return getMsg(key,""+p0); /* Version 'S' nutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getMsg" (Version <SS>)
  * Aufbereiten einer Meldung -- Ersetzen von Parametern
  * ACHTUNG: Beschreibung siehe allgemeine Version
  * ##getMsg.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getMsg( /* Aufbereiten Meldung */
   String key, /* Schluessel/Text der Meldung */
   String p0,  /* 1. Ersetzungswert */
   String p1)  /* 2. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
    String  msg,txt; /* Arbeitstexte */
    int     i,j,k,z; /* Arbeitswerte */
    char    c;       /* Steuerzeichen */
   /*=================================================================*/
    msg = key; /* Annehmen: Rohmeldung */
    if(key.length()<9) msg = getKey(key); /* Meldung gem. Sprache holen */
    if(msg==null) return ""; /* Sonderfall: NICHTS liefern */
    if(msg.startsWith("%%%%%%%%")) msg = msg.substring(8); /* verkuerzen */
    z = 0; /* relative Zeilenlaenge setzen */
    i = msg.indexOf('%'); /* Ersetzungszeichen ? */
    while(i>=0) { /* alle Ersetzungen durchfuehren */
      k = i + 2; /* weiterer Arbeitswert */
      if(msg.length()<k) break; /* Ersetzung nicht moeglich */
      txt = "";  /* kein gueltiger Ersetzungswert -- Default/Dummy */
      switch(c=msg.charAt(i+1)) { /* gemaess Steuerung bearbeiten */
        case('0'): if(p0!=null) txt = p0; /* Wert ersetzen */ break;
        case('1'): if(p1!=null) txt = p1; /* Wert ersetzen */ break;
        case('%'): txt = CRLF.toString(); /* Sonderwert eintragen */
          z = i + 1; /* Relative Zeile beginnt hier neu */
          break; /* Ersetzungswert wurde bearbeitet */
        case('?'): if(key.length()<9) txt = key; /* Sonderwert */ break;
        case('&'): /* Positionswert angegeben */
        case('+'): /* Laengenwert angegeben */
          for(j=k;j<msg.length();j+=1) /* Laenge der Ziffernreihe */
            if(!Character.isDigit(msg.charAt(j))) break;
          if(j==k) break; /* keine Nummer ist definiert */
          k = j; /* Fortsetzung der Message */
          j = Integer.parseInt(msg.substring(i+2,j)); /* Zahl holen */
          if(c=='&') j -= i - z; /* Anzahl Fuellzeichen berechnen */
          j = Math.max(0,j); /* Wert muss positiv sein */
          while(j-->0) txt += " "; /* Fuellstring erstellen */
          break; /* Ersetzungswert wurde bearbeitet */
        case('\''): /* Referenzwert angegeben */
          j = msg.indexOf('\'',k); /* Ende der Namensdefinition suchen */
          if(j<=k) break; /* KEINE Referenz gefunden */
          if((j-k)<=8) { /* gueltige Referenz gefunden */
            txt = msg.substring(k,j); /* Schluessel holen */
            txt = getMsg(txt,p0,p1); /* Referenz rekursiv aufloesen */
          } /* gueltige Referenz vorhanden und bearbeitet */
          k = j + 1; /* Fortsetzung nach (ungueltiger) Referenz */
          c = ' '; /* 'reScan' des Ersetzungswertes einschalten */
          break; /* Ersetzungswert wurde bearbeitet */
        case('['): /* reference to registy-entry provided */
          j = msg.indexOf(']',k); /* search for end of variable-name */
          if(j<=k) break; /* NO reference provided */
          /* Attention: length of registry-variable may be longer than 8 characters */
          txt = msg.substring(k,j); /* resolve variable-name of key */
          txt = TSUtil.getEnv(txt,true); /* get result from registry */
          if(txt==null) { /* error occurred -- repeat it and get message */
            txt = msg.substring(k,j); /* resolve variable-name of key again */
            txt = TSUtil.getEnv(txt,false); /* get message from registry */
            if(txt==null) txt = "?("+msg.substring(k,j)+")"; /* variable not found -- insert marker */
            else txt = " ---" + txt + "--- "; /* mark error-message within message */
          } else c = ' '; /* apply 'reScan' of replacement if no error was found */
          k = j + 1; /* compute new position for next replacement */
          break; /* replacement-string was successfully provided */
        case('{'): /* Fix-Text angegeben */
          /* Achtung: KEINE REKURSIVE Klammerung moeglich */
          j = msg.indexOf('}',k); /* Ende der Namensdefinition suchen */
          if(j<k) break; /* KEINE Referenz gefunden */
          txt = msg.substring(k,j); /* Fix-Text holen */
          k = j + 1; /* Fortsetzung nach festem Text */
          break; /* Ersetzungswert wurde bearbeitet */
        default:; /* keine Aktion -- 'txt' ist bereits gesetzt */
      } /* Ersetzungskennung wurde (erfolgreich) bearbeitet */
      if(msg.length()==k) msg = msg.substring(0,i) + txt;
      else msg = msg.substring(0,i) + txt + msg.substring(k);
      if(c!=' ') i += txt.length(); /* Fortsetzungstelle berechnen */
        /* ' ' ist Kennzeichen fuer EINMALIGEN 'reScan' des Arguments */
      i = msg.indexOf('%',i); /* weitere Ersetzungszeichen ? */
    } /* alle Platzhalter wurden ersetzt */
    return msg; /* Programm beenden -- neuen String liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getMsg" (Version <SI>)
  * Aufbereiten einer Meldung -- Ersetzen von Parametern
  * ACHTUNG: Beschreibung siehe allgemeine Version
  * ##getMsg.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getMsg( /* Aufbereiten Meldung */
   String key, /* Schluessel/Text der Meldung */
   String p0,  /* 1. Ersetzungswert */
   int    p1)  /* 2. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return getMsg(key,p0,""+p1); /* Version 'SS' nutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getMsg" (Version <SF>)
  * Aufbereiten einer Meldung -- Ersetzen von Parametern
  * ACHTUNG: Beschreibung siehe allgemeine Version
  * ##getMsg.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getMsg( /* Aufbereiten Meldung */
   String key, /* Schluessel/Text der Meldung */
   String p0,  /* 1. Ersetzungswert */
   double p1)  /* 2. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return getMsg(key,p0,""+p1); /* Version 'SS' nutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getMsg" (Version <II>)
  * Aufbereiten einer Meldung -- Ersetzen von Parametern
  * ACHTUNG: Beschreibung siehe allgemeine Version
  * ##getMsg.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getMsg( /* Aufbereiten Meldung */
   String key, /* Schluessel/Text der Meldung */
   int    p0,  /* 1. Ersetzungswert */
   int    p1)  /* 2. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return getMsg(key,""+p0,""+p1); /* Version 'SS' nutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getMsg" (Version <FF>)
  * Aufbereiten einer Meldung -- Ersetzen von Parametern
  * ACHTUNG: Beschreibung siehe allgemeine Version
  * ##getMsg.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getMsg( /* Aufbereiten Meldung */
   String key, /* Schluessel/Text der Meldung */
   double p0,  /* 1. Ersetzungswert */
   double p1)  /* 2. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return getMsg(key,""+p0,""+p1); /* Version 'SS' nutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getMsg" (Version <SSI>)
  * Aufbereiten einer Meldung -- Ersetzen von Parametern
  * ACHTUNG: Beschreibung siehe allgemeine Version
  * ##getMsg.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getMsg( /* Aufbereiten Meldung */
   String key, /* Schluessel/Text der Meldung */
   String p0,  /* 1. Ersetzungswert */
   String p1,  /* 2. Ersetzungswert */
   int    p2)  /* 3. Ersetzungswert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return getMsg(key,p0,p1,""+p2); /* Version '...' nutzen */
  }

 /**. <pre>
  *=====================================================================
  * Method "getMsg" (Version <SII>)
  * Process message -- replace formal parameter if applicable
  *   Description: see 'common version'
  * ##getMsg.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getMsg( /* process message */
   String key, /* 'key' or 'raw text' of the message */
   String p0,  /* 1. replacement-value */
   int    p1,  /* 2. replacement-value */
   int    p2)  /* 3. replacement-value */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return getMsg(key,p0,""+p1,""+p2); /* use '...'-version */
  }

 /**. <pre>
  *=====================================================================
  * Method "Log" (Version <...>)
  * Process message and write it to Log-file.
  *   DO NOT add an error-marker.
  * Method returns state of logging.
  * ##Log.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Log( /* process message and write it */
   String    key, /* 'key' or 'raw text' of the message */
   String... prm) /* current replacement-values */
   {
   /*-----------------------------------------------------------------*/
    String msg; /* intermediate string */
   /*=================================================================*/
    if(nol) return true; /* logging is NOT active -- terminate */
    if(MsgL.contains(key)) return false; /* do not write message */
    msg = getMsg(key,prm) + CRLF; /* get message and replace parms */
    if(msgK) msg = fmtKey(key,msg); /* add key if requested */
    try {LgF.write(msg); /* write new message to file */
    } catch (IOException e) { /* IO-error occurred -- switch off */
      System.err.println(); /* skip line for readability */
      System.err.println(e.toString()); /* print error */
      System.err.println(); /* skip line again */
      nol = true; /* error occurred -- switch off logging */
    } /* error-handling complete */
    return nol; /* return state of logging */
  }

 /**. <pre>
  *=====================================================================
  * Method "Log" (Version <I>)
  * Process message and write it to Log-file.
  * ##Log.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Log( /* process message and write it */
   String key, /* 'key' or 'raw text' of the message */
   int    p0)  /* 1. replacement-value */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Log(key,""+p0); /* use/delegate to '...'-version */
  }

 /**. <pre>
  *=====================================================================
  * Method "Log" (Version <SI>)
  * Process message and write it to Log-file.
  * ##Log.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Log( /* process message and write it */
   String key, /* 'key' or 'raw text' of the message */
   String p0,  /* 1. replacement-value */
   int    p1)  /* 2. replacement-value */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Log(key,p0,""+p1); /* use/delegate to '...'-version */
  }

 /**. <pre>
  *=====================================================================
  * Method "Log" (Version <SSI>)
  * Process message and write it to Log-file.
  * ##Log.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Log( /* process message and write it */
   String key, /* 'key' or 'raw text' of the message */
   String p0,  /* 1. replacement-value */
   String p1,  /* 2. replacement-value */
   int    p2)  /* 3. replacement-value */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Log(key,p0,p1,""+p2); /* use/delegate to '...'-version */
  }

 /**. <pre>
  *=====================================================================
  * Method "Log" (Version <SII>)
  * Process message and write it to Log-file.
  * ##Log.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Log( /* process message and write it */
   String key, /* 'key' or 'raw text' of the message */
   String p0,  /* 1. replacement-value */
   int    p1,  /* 2. replacement-value */
   int    p2)  /* 3. replacement-value */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Log(key,p0,""+p1,""+p2); /* use/delegate to '...'-version */
  }

 /**. <pre>
  *=====================================================================
  * Method "Log" (Version <SIII>)
  * Process message and write it to Log-file.
  * ##Log.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Log( /* process message and write it */
   String key, /* 'key' or 'raw text' of the message */
   String p0,  /* 1. replacement-value */
   int    p1,  /* 2. replacement-value */
   int    p2,  /* 3. replacement-value */
   int    p3)  /* 4. replacement-value */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Log(key,p0,""+p1,""+p2,""+p3); /* use '...'-version */
  }

 /**. <pre>
  *=====================================================================
  * Method "Msg" (Version <...>)
  * Process message and write it to Log-file and window.
  *   DO NOT add an error-marker.
  * Method returns state of logging.
  * ##Msg.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Msg( /* process message and write it */
   String    key, /* 'key' or 'raw text' of the message */
   String... prm) /* current replacement-values */
   {
   /*-----------------------------------------------------------------*/
    String msg; /* intermediate string */
   /*=================================================================*/
    if(MsgL.contains(key)) return nol; /* do not write message */
    msg = getMsg(key,prm) + CRLF; /* get message and replace parms */
    System.out.print(msg); /* print message to (console-)window */
    if(nol) return true; /* logging is NOT active -- terminate */
    if(msgK) msg = fmtKey(key,msg); /* add key if requested */
    try {LgF.write(msg); /* write new message to file */
    } catch (IOException e) { /* IO-error occurred -- switch off */
      System.err.println(); /* skip line for readability */
      System.err.println(e.toString()); /* print error */
      System.err.println(); /* skip line again */
      nol = true; /* error occurred -- switch off logging */
    } /* error-handling complete */
    return nol; /* return state of logging */
  }

 /**. <pre>
  *=====================================================================
  * Method "Msg" (Version <I>)
  * Process message and write it to Log-file and window.
  * ##Msg.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Msg( /* process message and write it */
   String key, /* 'key' or 'raw text' of the message */
   int    p0)  /* 1. replacement-value */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Msg(key,""+p0); /* use/delegate to '...'-version */
  }

 /**. <pre>
  *=====================================================================
  * Method "Msg" (Version <SSI>)
  * Process message and write it to Log-file and window.
  * ##Msg.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Msg( /* process message and write it */
   String  key, /* 'key' or 'raw text' of the message */
   String  p0,  /* 1. replacement-value */
   String  p1,  /* 2. replacement-value */
   int     p2)  /* 3. replacement-value */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Msg(key,p0,p1,""+p2); /* use/delegate to '...'-version */
  }

 /**. <pre>
  *=====================================================================
  * Method "Msg" (Version <SII>)
  * Process message and write it to Log-file and window.
  * ##Msg.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Msg( /* process message and write it */
   String  key, /* 'key' or 'raw text' of the message */
   String  p0,  /* 1. replacement-value */
   int     p1,  /* 2. replacement-value */
   int     p2)  /* 3. replacement-value */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Msg(key,p0,""+p1,""+p2); /* use/delegate to '...'-version */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Open"
  * Oeffnen der Log-Datei falls Dateiname verfuegbar
  * ##Open.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Open( /* Log-Datei oeffnen falls moeglich */
   boolean app) /* Append-Mode nutzen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(fn==null) return true; /* kein Dateiname -- kein Log moeglich */
    if(LgF!=null) return true; /* Ausgabe bereits geoeffnet */
    try {LgF = new BufferedWriter(new FileWriter(fn,app)); /* oeffnen */
    } catch (IOException e) { /* IO-Fehler erhalten */
      System.err.println(); /* Leerzeile zur Abtrennung */
      System.err.println(e.toString()); /* Fehler melden */
      System.err.println(); /* Leerzeile zur Abtrennung */
      LgF = null; /* Logging nicht mehr moeglich */
      return true; /* logging ist nicht moeglich */
    } /* ignore open -- do not log */
    nol = false; /* activate logging-capability */
    if(!app) return false; /* ok - terminate */
    try { /* separate new output from previous one */
      LgF.newLine();  /* skip one line */
      LgF.newLine();  /* skip one line */
      LgF.write(sep); /* write separator-line (120 chars) */
      LgF.newLine();  /* skip one line */
      LgF.newLine();  /* skip one line */
    } catch (IOException e) { /* check if IO-error occurrs */
      System.err.println(); /* skip one line for separation */
      System.err.println(e.toString()); /* report error */
      System.err.println(); /* skip another line */
      nol = true; /* error -- switch off logging */
      LgF = null; /* switch off logging to file */
    } /* error found -- ignore output */
    return nol; /* terminate program */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Print" (Version <...>)
  * Aufbereiten und Ausgeben einer Meldung auf Console
  * ACHTUNG: Sprachdefinition wird beachtet!!!
  * Achtung: Routine liefert IMMER Fehlerkennzeichen ('true')
  * ##Print.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static boolean Print( /* process msg. for console-output */
   String    key, /* key or message to be printed */
   String... prm) /* current replacement-values */
   {
   /*-----------------------------------------------------------------*/
    String msg; /* temporary */
   /*=================================================================*/
    if(MsgL.contains(key)) return true; /* do not print message */
    msg = getMsg(key,prm); /* get message and process it (placeholders) */
    System.out.print(msg); /* print processed message */
    return true; /* terminate program and return error-marker */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Print" (Version <I>)
  * Aufbereiten und Ausgeben einer Meldung auf Console
  * ACHTUNG: Sprachdefinition wird beachtet!!!
  * Achtung: Routine liefert IMMER Fehlerkennzeichen ('true')
  *=====================================================================
  </pre>*/
  protected static boolean Print( /* process msg. for console-output */
   String key, /* key or message to be printed */
   int    p0)  /* 1. replacement-value */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Print(key,""+p0); /* use version '...' */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Print" (Version <F>)
  * Aufbereiten und Ausgeben einer Meldung auf Console
  * ACHTUNG: Sprachdefinition wird beachtet!!!
  * Achtung: Routine liefert IMMER Fehlerkennzeichen ('true')
  *=====================================================================
  </pre>*/
  protected static boolean Print( /* process msg. for console-output */
   String key, /* key or message to be printed */
   double p0)  /* 1. replacement-value */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Print(key,""+p0); /* use version '...' */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Print" (Version <SI>)
  * Aufbereiten und Ausgeben einer Meldung auf Console
  * ACHTUNG: Sprachdefinition wird beachtet!!!
  * Achtung: Routine liefert IMMER Fehlerkennzeichen ('true')
  *=====================================================================
  </pre>*/
  protected static boolean Print( /* process msg. for console-output */
   String key, /* key or message to be printed */
   String p0,  /* 1. replacement-value */
   int    p1)  /* 2. replacement-value */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Print(key,p0,""+p1); /* use version '...' */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Print" (Version <SII>)
  * Aufbereiten und Ausgeben einer Meldung auf Console
  * ACHTUNG: Sprachdefinition wird beachtet!!!
  * Achtung: Routine liefert IMMER Fehlerkennzeichen ('true')
  *=====================================================================
  </pre>*/
  protected static boolean Print( /* process msg. for console-output */
   String key, /* key or message to be printed */
   String p0,  /* 1. replacement-value */
   int    p1,  /* 2. replacement-value */
   int    p2)  /* 3. replacement-value */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Print(key,p0,""+p1,""+p2); /* use version '...' */
  }

 /**. <pre>
  *=====================================================================
  * Method "prtMsg"
  * Create message, store it for LOG-output and print it to screen.
  * Method uses global variables/classes: 'Fo'.
  * Method returns 'true' if the message was suppressed.
  * ##prtMsg.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static boolean prtMsg( /* print Message to Screen */
   String    key, /* Message-key */
   String... arg) /* Argument(s) of message */
   {
   /*-----------------------------------------------------------------*/
    String msg; /* intermediate value -- message-buffer */
   /*=================================================================*/
    if(MsgL.contains(key)) return true; /* suppress message */
    msg = TSLogg.getMsg(key,arg); /* create message */
    TSUtil.Fo.addDta(msg); /* Save message for output to log-file */
    System.out.println(msg); /* print message to screen */
    return false; /* end of function -- Message was NOT suppressed */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setKey"
  * Schluesselkennung fuer Meldungsunterdrueckung setzen
  * Methode liefert 'true' wenn Kennung NICHT gespeichert wurde
  * ##setKey.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static boolean setKey( /* Schluesselkennung setzen */
   String key) /* Kennung des Schluessels */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(MsgL==null) return true; /* Liste nicht verfuegbar */
    return !MsgL.add(key); /* Einsetzen -- Status zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setOpt"
  * Optionen fuer die Meldungsaugabe eintragen
  * ##setOpt.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final void setOpt( /* Optionen eintragen/setzen */
   boolean key) /* Schluesselkennung voranstellen (wenn 'true') */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    msgK = key; /* aktuelle Option eintragen und merken */
    return; /* keine Rueckgabe moeglich */
  }

 /**. <pre>
  *=====================================================================
  * Methode "Skip"
  * Aufbereiten und Ausgeben einer Leerzeile
  * ##Skip.TSLogg (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Skip( /* Aufbereiten einer Leerzeile */
   boolean win) /* Leerzeile auch in Fenster schreiben */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(win) System.out.println(); /* skip line on Console */
    if(nol) return true; /* Logging nicht aktiv -- Ende */
    try {LgF.newLine();  /* skip one line */
    } catch (IOException e) { /* IO-Fehler aufgetreten */
      System.err.println(); /* Leerzeile zur Abtrennung */
      System.err.println(e.toString()); /* Fehler melden */
      System.err.println(); /* Leerzeile zur Abtrennung */
      nol = true; /* Fehler -- Logging abschalten */
    } /* Logging aktiviert */
    return false; /* Programm ohne Fehlerkennung beenden */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSPos -- Definition eines Positionsvektors
 * Die Klasse beschreibt einen Positionsvector relativ zu (0,0,0)
 * ##TSPos (Eyecatcher)
 *======================================================================
 </pre>*/
class TSPos implements Serializable { /* Positions-Vektor */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.6.03 30.09.2011";
 /*-------------------------------------------------------------------*/
  private double                Px;     /* X-Position im Quadranten */
  private double                Py;     /* Y-Position im Quadranten */
  private double                Pz;     /* Z-Position im Quadranten */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSPos() /* Positionsvektor initialisieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSPos( /* aktuellen Positionsvektor erstellen */
   double px, /* Positionswert X */
   double py, /* Positionswert Y */
   double pz) /* Positionswert Z */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Px = px; /* X-Position uebertragen */
    Py = py; /* Y-Position uebertragen */
    Pz = pz; /* Z-Position uebertragen */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create copy-entry from template
  *=====================================================================
  </pre>*/
  protected TSPos( /* aktuellen Positionsvektor erstellen */
   TSPos cP) /* Positionsdefinition als Vorlage */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Px = cP.Px; /* X-Position aus Vorlage uebertragen */
    Py = cP.Py; /* Y-Position aus Vorlage uebertragen */
    Pz = cP.Pz; /* Z-Position aus Vorlage uebertragen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addPosX"
  * Positionswert X korrigieren und Quadrantenfehler ermitteln
  *   (Objekt verschieben)
  * ##addPosX.TSPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int addPosX( /* Positionswerte veraendern */
   double d) /* Veraenderungswert der X-Position (+/-) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    d = (Px += d); /* neuen Positionswert berechnen und merken */
    /* Pruefung auf GROESSER als erlaubt */
    while(Px>1024.0) Px -= 2048.0; /* Wert anpassen */
    /* Pruefung auf KLEINER als erlaubt */
    while(Px<-1024.0) Px += 2048.0; /* Wert anpassen */
    /* BEIDE Faelle GLEICHZEITIG koennen NICHT vorliegen */
    d -= Px; /* neuen Differenzwert berechnen */
    return (int)(d/2048.0); /* Ende -- Korrekturwert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addPosY"
  * Positionswert Y (Hoehe) korrigieren (Objekt verschieben)
  * ##addPosY.TSPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int addPosY( /* Positionswerte veraendern */
   double d) /* Veraenderungswert der Hoehe (+/-) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Py += d; /* neuen Positionswert berechnen */
    return 0; /* Ende -- fester Korrekturwert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addPosZ"
  * Positionswert Z korrigieren und Quadrantenfehler ermitteln
  *   (Objekt verschieben)
  * ##addPosZ.TSPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int addPosZ( /* Positionswerte veraendern */
   double d) /* Veraenderungswert der Z-Position (+/-) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    d = (Pz += d); /* neuen Positionswert berechnen und merken */
    /* Pruefung auf GROESSER als erlaubt */
    while(Pz>1024.0) Pz -= 2048.0; /* Wert anpassen */
    /* Pruefung auf KLEINER als erlaubt */
    while(Pz<-1024.0) Pz += 2048.0; /* Wert anpassen */
    /* BEIDE Faelle GLEICHZEITIG koennen NICHT vorliegen */
    d -= Pz; /* neuen Differenzwert berechnen */
    return (int)(d/2048.0); /* Ende -- Korrekturwert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "clipPos"
  * Positionswerte auf gueltige Werte (-1024..+1024) aendern
  * Y-Komponete (Hoehe) wird nicht veraendert
  * ##clipPos.TSPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int clipPos() /* Positionswerte anpassen */
   {
   /*-----------------------------------------------------------------*/
    int m; /* Ergebniskennung (Maskenbits 0,1,2,3,8,9,16) */
   /*=================================================================*/
    m = 0; /* Vorbesetzen: Kein Wert wurde veraendert */
    if(Px< -1024.0) { /* X-Komponente zu klein */
      m |= 0x010101; /* Kennung einsetzen (0,8,16) */
      Px = -1024.0; /* Komponente auf gueltigen Wert setzen */
    } /* Komponete enthielt Fehler */
    if(Px>  1024.0) { /* X-Komponente zu gross */
      m |= 0x010102; /* Kennung einsetzen (1,8,16) */
      Px =  1024.0; /* Komponente auf gueltigen Wert setzen */
    } /* Komponete enthielt Fehler */
    if(Pz< -1024.0) { /* Z-Komponente zu klein */
      m |= 0x010204; /* Kennung einsetzen (2,9,16) */
      Pz = -1024.0; /* Komponente auf gueltigen Wert setzen */
    } /* Komponete enthielt Fehler */
    if(Pz>  1024.0) { /* Z-Komponente zu gross */
      m |= 0x010208; /* Kennung einsetzen (3,9,16) */
      Pz =  1024.0; /* Komponente auf gueltigen Wert setzen */
    } /* Komponete enthielt Fehler */
    return m; /* Kennung fuer Aenderungen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "cmpAbs"
  * Compute distance between two position-values.
  * This method returns the distance of two koordinates, which is
  *   computed due to Pythargoras.
  * ##cmpAbs.TSPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double cmpAbs( /* compute distance between positions */
   TSPos cP, /* Definition of target-node */
   int   dx, /* basic X-distance between Quad's */
   int   dz) /* basic Z-distance between Quad's */
   {
   /*-----------------------------------------------------------------*/
    double da,db; /* intermediate values */
   /*=================================================================*/
    da = Px - cP.Px + dx; /* compute X-distance of positions */
    da *= da;             /* and square it */
    db = Py - cP.Py;      /* compute Y-distance of positions */
    da += db * db;        /* square it and add it */
    db = Pz - cP.Pz + dz; /* compute Z-distance of positions */
    da += db * db;        /* square it and build sum of all values */
    return Math.sqrt(da); /* return distance of koordinates */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getPos"
  * Information-Hiding: Positionswerte in Zeichenkettenform liefern
  * Aufbereitungsoptionen nach dem Primzahlverfahren:
  *  2 - Px-Wert NICHT beruecksichtigen
  *  3 - Py-Wert NICHT beruecksichtigen (Hoehenwert)
  *  5 - Pz-Wert NICHT beruecksichtigen
  * Achtung: Ergebnis enthaelt ein fuehrendes Leerzeichen
  * ##getPos.TSPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getPos( /* Positionswerte liefern */
   int prec, /* Genauigkeit des Wertes */
   int opt)  /* Aufbereitungsoptionen (Primzahlverfahren) */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    if(prec<0 || prec>8) prec = 6; /* Standardwert benutzen */
    rs = ""; /* Defaultwert initialisieren */
    if((opt%2)!=0) rs += TSUtil.putFV(Px,prec); /* Px-Wert gefordert */
      /* Px-Wert (ggf. gerundet) aufbereiten */
    if((opt%3)!=0) rs += TSUtil.putFV(Py,prec); /* Py-Wert gefordert */
      /* Hoehen-Wert (ggf. gerundet) aufbereiten */
    if((opt%5)==0) return rs; /* aubereitete Positionswerte liefern */
    rs += TSUtil.putFV(Pz,prec); /* Pz-Wert gefordert */
      /* Pz-Wert (ggf. gerundet) aufbereiten */
    return rs; /* aubereitete Positionswerte liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getPos" (2.Version)
  * Information-Hiding: Positionswerte in Zeichenkettenform liefern
  * Aufbereitung erfolgt ohne Rundungsmoeglichkeit
  * ##getPos.TSPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getPos( /* Positionswerte liefern */
   boolean comma) /* Datenmodus mit Komma gefordert (true) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(comma) return Px + "," + Py + "," + Pz; /* mit Komma liefern */
    return Px + " " + Py + " " + Pz;/* Positionswerte liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getPosX"
  * Get X-value of a position-definition (information-Hiding)
  *  This method is used to successfully create a 'TSCoo'-object
  * ##getPosX.TSPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double getPosX() /* get X-value of a position */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    return Px; /* return the rquested value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getPosY"
  * Information-Hiding: Positionswert Y (Hoehe) liefern
  * ##getPosY.TSPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double getPosY() /* Positionswert Y liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Py; /* Positionswert Y liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getPosZ"
  * Get Z-value of a position-definition (information-Hiding)
  *  This method is used to successfully create a 'TSCoo'-object
  * ##getPosZ.TSPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double getPosZ() /* get Z-value of a position */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    return Pz; /* return the rquested value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "modPos"
  * 'add' or 'sub' difference-vector to/from current position
  * This realizes a 'shift-operation'
  * ##modPos.TSPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected void modPos( /* modify current position */
   boolean m,  /* mode of operation: 'true'->'add', 'false'->'sub' */
   TSPos   cP) /* difference-vector */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(m) { /* addition requested */
      Px += cP.Px; /* compute new X-position */
      Py += cP.Py; /* compute new X-position */
      Pz += cP.Pz; /* compute new X-position */
      return; /* operation completed */
    } /* addition was requested */
    Px -= cP.Px; /* compute new X-position */
    Py -= cP.Py; /* compute new X-position */
    Pz -= cP.Pz; /* compute new X-position */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mul"
  * Positionswerte mit Quaterion multiplizieren und ggf. Fehler melden
  * --> Vector (=aktuelles Positionsobjekt) gemaess Quaterion rotieren
  * Also compare to 'Object-Rotator'-manual (Rotating a 3D-vector)
  * Px' = (Qx*Qx - Qy*Qy - Qz*Qz + Qw*Qw)*Px +
  *       2*(Qx*Qy + Qz*Qw)*Py + 2*(Qx*Qz - Qy*Qw)*Pz
  * Py' = 2*(Qx*Qy - Qz*Qw)*Px + (Qy*Qy - Qx*Qx - Qz*Qz + Qw*Qw)*Py +
  *       2*(Qx*Qw - Qy*Qz)*Pz
  * Pz' = 2*(Qx*Qz + Qy*Qw)*Px + 2*(Qy*Qz - Qx*Qw)*Py +
  *         (Qz*Qz - Qx*Qx - Qy*Qy + Qw*Qw)*Pz
  * ##mul.TSPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String mul( /* rotate positionvalues */
   TSQDir q) /* Quaterion zum multiplizieren/rotieren */
   {
   /*-----------------------------------------------------------------*/
    double px,py; /* intermediate values */
    double t1,t2,t3,t4; /* intermediate values */
   /*=================================================================*/
    t1 = q.getTerm(1); /* Zwischenwert holen */
    t2 = q.getTerm(2); /* Zwischenwert holen */
    t3 = q.getTerm(3); /* Zwischenwert holen */
    t4 = q.getTerm(4); /* Zwischenwert holen */
    px  = Px * (t1 + t4 - t2 - t3);
    py  = Py * (t2 + t4 - t1 - t3);
    if(Pz!=0.0) { /* weiter Pz-Terme */
      px += Pz * (q.getTerm(13) - q.getTerm(24));
      py += Pz * (q.getTerm(14) + q.getTerm(23));
      Pz  = Pz * (t3 + t4 - t1 - t2);
    } /* weitere Terme berechnet */
    if(Px!=0.0) { /* weiter Px-Terme */
      py += Px * (q.getTerm(12) - q.getTerm(34));
      Pz += Px * (q.getTerm(13) + q.getTerm(24));
    } /* weitere Terme berechnet */
    if(Py!=0.0) { /* weiter Py-Terme */
      px += Py * (q.getTerm(12) + q.getTerm(34));
      Pz += Py * (q.getTerm(23) - q.getTerm(14));
    } /* weitere Terme berechnet */
    Px = px; /* finally: set value */
    Py = py; /* finally: set value */
    return null; /* Operation fully executed */
  }

 /**. <pre>
  *=====================================================================
  * Methode "shftPos"
  * Shift Position of object 'half way' in direction of second object
  * ##shftPos.TSPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String shftPos( /* shift position */
   TSPos cP) /* definition of second position (direction) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Px = (Px + cP.Px) / 2; /* compute new X-position */
    Py = (Py + cP.Py) / 2; /* compute new Y-position */
    Pz = (Pz + cP.Pz) / 2; /* compute new Z-position */
    return null; /* return without errormarker */
  }

 /**. <pre>
  *=====================================================================
  * Method "toEnd"
  * Current vector points to beginning of section -- compute End-Position
  * 'rl' may be negative if position has to be subtracted (left curve)
  * Also compare to 'Object-Rotator'-manual (Rotating a 3D-vector)
  * specially: rotating vector (0,0,1) -> (x3,y3,z3)
  * w==0.0 (rl is 'length'):
  *    Px = Px + rl * 2*(Qx*Qz - Qy*Qw)
  *    Py = Py + rl * 2*(Qx*Qw + Qy*Qz)
  *    Pz = Pz + rl * (Qz*Qz + Qw*Qw - Qx*Qx - Qy*Qy)
  * w!=0.0 (rl is 'radius'):
  *    Px = Px + rl*sin(w) * 2*(Qx*Qz - Qy*Qw)
  *         - rl*(1-cos(w)) * (Qx*Qx - Qy*Qy - Qz*Qz + Qw*Qw)
  *    Py = Py + rl*sin(w) * 2*(Qx*Qw + Qy*Qz)
  *         - rl*(1-cos(w)) * 2*(Qx*Qy - Qz*Qw)
  *    Pz = Pz + rl*sin(w) * (Qz*Qz + Qw*Qw - Qx*Qx - Qy*Qy)
  *         - rl*(1-cos(w)) * 2*(Qx*Qz + Qy*Qw)
  * ##toEnd.TSPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toEnd( /* compute 'End'-position */
   TSQDir q,  /* Quaterion specifies direction of basisvector */
   double rl, /* Radius/Length of section */
   double w)  /* Angle of section (Radians), '0' if straight present */
   {
   /*-----------------------------------------------------------------*/
    double t1,t2,t3,t4,wc; /* interim values */
   /*=================================================================*/
    t1 = q.getTerm(1); /* get value from quaternion */
    t2 = q.getTerm(2); /* get value from quaternion */
    t3 = q.getTerm(3); /* get value from quaternion */
    t4 = q.getTerm(4); /* get value from quaternion */
    if(w!=0.0) { /* NO 'Straight' found */
      /* Angle may be negative, because Cosinus is symmetric */
      wc = rl * (1.0 - Math.cos(w)); /* compute Cosinus-interim-value */
      Px -= wc * (t1 + t4 - t2 - t3);
      Py -= wc * (q.getTerm(12) - q.getTerm(34));
      Pz -= wc * (q.getTerm(13) + q.getTerm(24));
      if(w<0.0) w += Math.PI; /* Sinus must be positive */
      rl *= Math.sin(w); /* compute Sinus-interim-value */
    } /* Straight was NOT found  -- 'rl' anjusted */
    /* common computation for both cases (straight/curve) */
    Px += rl * (q.getTerm(13) - q.getTerm(24));
    Py += rl * (q.getTerm(14) + q.getTerm(23));
    Pz += rl * (t3 + t4 - t1 - t2);
    return null; /* Operation is OK */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSPos{" + Px + "," + Py + "," + Pz + "}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSQPos -- Definition eines Positionsvektors im Quadranten
 * Die Klasse beschreibt einen Positionsvector relativ zu (0,0,0)
 *  inklusiv der Verkettung innerhalb des Quadranten
 * Achtung: Wenn der Quadrant veraendert wird (move), muss eine Quad-
 *	Referenz vorhanden sein, die diese Aenderung reflektiert, da die
 *	Originalwerte NICHT veraendert werden koennen.
 * Achtung: Ein Quadrantenwechsel der Position wird durch die Kennung
 *	'0' in den Quadrantennummern gekennzeichnet.
 * ##TSQPos (Eyecatcher)
 *======================================================================
 </pre>*/
class TSQPos extends TSPos { /* erweiterter Positions-Vektor */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.6.03 30.09.2011";
 /*-------------------------------------------------------------------*/
  private int                   Qx;     /* X-Kennung des Quadranten */
  private int                   Qz;     /* Z-Kennung des Quadranten */
  private TSQuad                QDf;    /* Reference to Quad-Def. */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSQPos() /* Positionsvektor initialisieren */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Qx = Qz = Integer.MIN_VALUE; /* mark quad's as invalid */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSQPos( /* aktuellen Positionsvektor erstellen */
   int   qx, /* Nummer des X-Quanranten */
   int   qz, /* Nummer des Z-Quadranten */
   TSPos cP) /* Positionsdefinition als Vorlage */
   {
    super(cP);  /* initialize vector (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Qx  = qx; /* Qx-Nummer eintragen */
    Qz  = qz; /* Qz-Nummer eintragen */
    /* all other variables are initialized by default ('0' / 'null') */
    QDf = null; /* Quadranten-Referenz (noch) nicht gesetzt */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create copy-entry from template
  *=====================================================================
  </pre>*/
  protected TSQPos( /* aktuellen Positionsvektor erstellen */
   TSQPos cP) /* Positionsdefinition als Vorlage */
   {
    super(cP);  /* initialize vector (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Qx  = cP.Qx;  /* Qx-Nummer uebernehmen */
    Qz  = cP.Qz;  /* Qz-Nummer uebernehmen */
    QDf = cP.QDf; /* Quadranten-Referenz aus Vorlage uebernehmen */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (4) Create verified entry from components
  *=====================================================================
  </pre>*/
  protected TSQPos( /* create current positionvector */
   TSQuad cQ, /* use specified Quad-reference */
   TSPos  cP) /* and add position from template */
   {
    super(cP);  /* initialize vector (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Qx  = 0;  /* mark Qx-number as 'modified' */
    Qz  = 0;  /* mark Qz-number as 'modified' */
    QDf = cQ; /* and insert valid Quad-reference */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addPos"
  * Positionswerte anpassen und Quadrantendefinition justieren
  * ##addPos.TSQPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String addPos( /* Positionswerte veraendern */
   TSRoute cR, /* Referenz zur aktuellen Route  (Suchen) */
   double  dx, /* Korrekturwert der X-Komponente */
   double  dy, /* Korrekturwert der Y-Komponente */
   double  dz) /* Korrekturwert der Z-Komponente */
   {
   /*-----------------------------------------------------------------*/
    int    qx,qz; /* Korrekturwerte des Quadranten */
    TSQuad nQDf;  /* Adresse neuer, korrigierter Quadrant */
   /*=================================================================*/
    qx = addPosX(dx); /* X-Position anpassen */
    addPosY(dy); /* Hoehe anpassen -- Kein Korrekturwert */
    qz = addPosZ(dz); /* Z-Position anpassen */
    if(qx==0 && qz==0) return null; /* alter Quadrant -- ohne Fehler */
    if(QDf==null) { /* Quadrantenreferenz noch nicht zugewiesen */
      Qx += qx; /* neue Quadrantenreferenz berechnen */
      Qz += qz; /* neue Quadrantenreferenz berechnen */
      return TSLogg.getMsg("TSQPosA1",Qx,Qz); /* Meldung liefern */
    } /* Quadrantenreferenz noch nicht gesetzt */
    nQDf = QDf.fndQuad(cR,qx,qz); /* passenden Quadranten suchen */
    if(nQDf==null) /* Meldung liefern -- neuer Quadrant nicht gefunden */
      return TSLogg.getMsg("TSQPosA2",QDf.getMsg(1,null,qx,qz));
    QDf = nQDf; /* neuen Quadranten aktivieren */
    Qx = Qz = 0; /* Kennzeichen setzen -- Referenz ist exclusiv */
    return null; /* kein Fehler zurueck -- Aktion erfolgreich */
  }

 /**. <pre>
  *=====================================================================
  * Methode "cmpAbs"
  * Abstand der Positionswerte berechnen (fuer Vergleich)
  * Methode liefert den Abstand der beiden Koordinaten (nach Pythargoras)
  * Achtung: Wenn eine Quadrantenreferenz gesetzt ist, haben die Werte
  *          Qx und Qz keine Gueltigkeit mehr, da der Quadrant veraendert
  *          sein kann.
  * ##cmpAbs.TSQPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double cmpAbs( /* Abstand Positionswerte berechnen */
   TSQPos cP) /* Definition des Vergleichsknotens */
   {
   /*-----------------------------------------------------------------*/
    int x,z; /* valid number of target-quad / distance between quad's */
   /*=================================================================*/
    /* compute all 4 different cases */
    x = (cP.QDf==null) ? cP.Qx : cP.QDf.dX(0); /* get target-quad-nbr (X) */
    z = (cP.QDf==null) ? cP.Qz : cP.QDf.dZ(0); /* get target-quad-nbr (Z) */
    if(QDf==null) { /* reference to basic-QUD missing */
      x = (Qx - x) * 2048; /* compute basic distance X */
      z = (Qz - z) * 2048; /* compute basic distance Z */
    } else { /* basic QUAD-definition is valid -- use it */
      x = QDf.dX(x) * 2048; /* get basic distance from primary QUAD */
      z = QDf.dZ(z) * 2048; /* get basic distance from primary QUAD */
    } /* quad-distance has been computed */
    return super.cmpAbs(cP,x,z); /* delegate final calculation */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crCoo"
  * Positions-Definition als Koordinaten-Objekt liefern
  * ##crCoo.TSQPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSCoo crCoo() /* Koordinatenobjekt liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(QDf!=null) return QDf.crCoo((TSPos)this); /* delegate it */
    return new TSCoo(Qx,Qz,getPosX(),getPosY(),getPosZ());
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndWrld"
  * suchen und liefern der World-Definition gemaess 'Qx' und 'Qz'
  * ACHTUNG: Im Erfolgsfall wird die Quadrat-Referenz eingetragen!!
  * ##fndWrld.TSQPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSQuad fndWrld( /* Quad-Definition (Adresse) liefern */
   TreeSet<TSQuad> qdf) /* Alle Quadrat-Definitionen der World-Dateien */
   {
   /*-----------------------------------------------------------------*/
    TSQuad           cQDf; /* current quad-reference */
    Iterator<TSQuad> cI;   /* Iterator of 'TreeSet' */
   /*=================================================================*/
    if(Qx==0 && Qz==0) return null; /* valid quad-reference is locked */
    QDf = null; /* clear reference in case it contains invalid value */
    if(Qx==Integer.MIN_VALUE) return null; /* value is not set */
    if(Qz==Integer.MIN_VALUE) return null; /* value is not set */
    cI = qdf.iterator(); /* Iterator of Quad-definitions */
    while(cI.hasNext()) { /* more definitions available ? */
      cQDf = cI.next(); /* yes -- get next one */
      if(cQDf.isWrld(Qx,Qz)) { /* Welt gefunden */
        QDf = cQDf; /* register quad-reference */
        return cQDf; /* and return appropriate world */
      } /* correct world-reference(quad) found */
    } /* -while- check all defeinitions */
    return null; /* no relevant entry found -- return with marker */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getPos"
  * Information-Hiding: erweiterte Position lesbar liefern
  * Achtung: Ergebnis enthaelt ggf. ein fuehrendes Leerzeichen!
  * ##getPos.TSQPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getPos( /* erweiterte Positionswerte liefern */
   int m)  /* Aufbereitungsmodus */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-String */
   /*=================================================================*/
    if(QDf!=null) rs = QDf.getInf(1); /* Quadranten (neu) holen */
    else rs = "" + Qx + " " + Qz; /* Orginalwerte nutzen */
    switch(m) { /* Ergebnis gemaess Modus aufbereiten */
      case(0): return rs + super.getPos(0,1); /* Standard-Aufbereitung */
      case(1): /* Aufbereitung wie in 'TrItemRData' */
       return super.getPos(0,1) + " " + rs; /* Ergebnis liefern */
      case(2): /* Aufbereitung wie in 'TrItemPData' */
        return super.getPos(0,3) + " " + rs; /* Ergebnis liefern */
      case(3): return rs; /* Nur Quadranden liefern */
      case(4): return rs + super.getPos(0,3); /* Route-Form */
      case(5): return rs + super.getPos(0,3) + super.getPos(1,10);
        /* special form used by activity ('Location') */
      default: return "? ? ? ? ?"; /* Fehler-Kennung */
    } /* Modus beachten und Aufbereitung durchfuehren */
  }

 /**. <pre>
  *=====================================================================
  * Methode "noRef"
  * Pruefen ob Quadrantenreferenz verfuegbar
  * Wenn eine Referenz verfuegbar ist, werden die Originalwerte Qx und
  *    Qz NICHT mehr benoetigt.
  * Methode liefert 'true' wenn die Referenz NICHT verfuegbar ist.
  * ##noRef.TSQPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean noRef() /* Quadranten-Referenz ueberpruefen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return QDf==null; /* melden ob gueltige Referenz vorhanden */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSQPos (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-String */
   /*=================================================================*/
    rs = "TSQPos{(" + Qx + "," + Qz; /* create prefix of result */
    if(QDf==null) rs += "),<null>,"; /* invalid value */
    else rs += "),("+QDf.getInf(0)+"),"; /* valid reference exist */
    rs += super.toStr() + "}"; /* add common suffix */
    return rs; /* and return result */
  }
 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSQDir -- Definition eines 'Quaternion'
 * Quaterions werden benutzt um eine Richtung zu spezifizieren, die
 *   mit Hilfe einer Rotation aus einer Basisrichtung (=Nord) entsteht.
 *   Diese Rotation wird durch das Quaternion beschrieben.
 * ##TSQDir (Eyecatcher)
 *======================================================================
 </pre>*/
class TSQDir implements Serializable { /* Positions-Vektor */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 03.08.2008";
 /*-------------------------------------------------------------------*/
  private double                Vx;     /* X-Wert fuer Rotation */
  private double                Vy;     /* Y-Wert fuer Rotation */
  private double                Vz;     /* Z-Wert fuer Rotation */
  private double                W;      /* Winkel fuer Rotation */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSQDir() /* 'Quaternion' initialisieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* Quaternion wird auf 'Nord' vorbesetzt */
//    Vx = Vy = Vz = 0.0; /* Position vorbesetzen */
    W = 1.0; /* gueltiger Winkel vorbesetzen */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSQDir( /* aktuelles 'Quaternion' erstellen */
   double vx, /* Vektorwert X */
   double vy, /* Vektorwert Y */
   double vz, /* Vektorwert Z */
   double w)  /* Winkelwert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Vx = vx; /* X-Wert uebertragen */
    Vy = vy; /* Y-Wert uebertragen */
    Vz = vz; /* Z-Wert uebertragen */
    W  = w;  /* Winkel uebertragen */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Crerate copy-entry from template
  *=====================================================================
  </pre>*/
  protected TSQDir( /* aktuelles 'Quaternion' erstellen */
   TSQDir cD) /* Richtungsdefinition als Vorlage */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Vx = cD.Vx; /* X-Wert aus Vorlage uebertragen */
    Vy = cD.Vy; /* Y-Wert aus Vorlage uebertragen */
    Vz = cD.Vz; /* Z-Wert aus Vorlage uebertragen */
    W  = cD.W;  /* Winkel aus Vorlage uebertragen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkVals"
  * Integritaet der gespeicherten Werte testen
  * Soll: x*x + y*y + z*z + w*w = 1 (Normalform)
  * ##chkVals.TSQDir (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double chkVals() /* gespeicherte Werte pruefen */
   {
   /*-----------------------------------------------------------------*/
    double f; /* Zwischenwert */
   /*=================================================================*/
    f = Vx * Vx; /* Zwischenwert berechnen */
    f += Vy * Vy; /* Zwischenwert berechnen */
    f += Vz * Vz; /* Zwischenwert berechnen */
    f += W * W; /* Zwischenwert berechnen */
    f = Math.sqrt(f); /* Ergebniswert als Pruefwert erstellen */
    return f-1.0; /* und als Abweichung liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getDir"
  * Information-Hiding: Richtungswerte in Zeichenkettenform liefern
  * Achtung: Es gibt keine Aufbereitungsoptionen, da Richtungswerte
  *          IMMER VOLLSTAENDIG aufbereitet werden muessen (Quaternion)
  * Achtung: Ergebnis enthaelt ein fuehrendes Leerzeichen
  * ##getDir.TSQDir (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getDir( /* Positionswerte liefern */
   int prec) /* Genauigkeit des Wertes */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    if(prec<0 || prec>12) prec = 8; /* Standardwert benutzen */
    rs = TSUtil.putFV(Vx,prec);  /* Vx-Wert (ggf. gerundet) setzen */
    rs += TSUtil.putFV(Vy,prec); /* Vy-Wert (ggf. gerundet) setzen */
    rs += TSUtil.putFV(Vz,prec); /* Vz-Wert (ggf. gerundet) setzen */
    rs += TSUtil.putFV(W,prec);  /* W-Wert (ggf. gerundet) setzen */
    return rs; /* aubereitete Positionswerte liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getDir" (2.Version)
  * Information-Hiding: Richtungswerte in Zeichenkettenform liefern
  * Aufbereitung erfolgt ohne Rundungsmoeglichkeit
  * ##getDir.TSQDir (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getDir( /* Richtungswerte liefern */
   boolean comma) /* Datenmodus mit Komma gefordert (true) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(comma) return Vx+","+Vy+","+Vz+","+W; /* mit Komma liefern */
    return Vx+" "+Vy+" "+Vz+" "+W;/* Richtungswerte liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTerm"
  * Returns a Term which is computed from 'QDirection'-values
  * QDirection = (Vx Vy Vz W)
  * ##getTerm.TSQDir (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double getTerm( /* return term from qdirection */
   int t) /* ID of requested term (type) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* return requested term due to id */
      case(1): return Vx * Vx; /* return computed value */
      case(2): return Vy * Vy; /* return computed value */
      case(3): return Vz * Vz; /* return computed value */
      case(4): return W * W;   /* return computed value */
      case(12): return 2.0 * Vx * Vy; /* return computed value */
      case(13): return 2.0 * Vx * Vz; /* return computed value */
      case(14): return 2.0 * Vx * W;  /* return computed value */
      case(23): return 2.0 * Vy * Vz; /* return computed value */
      case(24): return 2.0 * Vy * W;  /* return computed value */
      case(34): return 2.0 * Vz * W;  /* return computed value */
      case(-1): /* Special case: compute 'Elevation' (U/2) */
        /* Attention: Result is only correct if 'bank' == 0.0 */
        if(W==0.0) /* No division possible -- use fix value */
          if(Vx<0.0) return -TSCoo.HPI; /* return 1/2 PI */
          else return TSCoo.HPI; /* return 1/2 PI */
        return Math.atan(Vx/W); /* compute Term and return it */
    } /* due to id of requested term */
    return Double.NaN; /* return marker: unknown value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "inv"
  * 'Quaterion'-Werte invertieren fuer 'inverse Rotation'
  * Wert beschreibt nun 'antiparallele' Richtung
  * Methode liefert Fehlermeldung oder 'null'
  * Achtung: Werte werden auf positiv justiert falls moeglich
  * ##inv.TSQDir (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String inv() /* 'Quaterion'-Werte invertieren */
   {
   /*-----------------------------------------------------------------*/
    double z; /* Arbeitswerte */
   /*=================================================================*/
    z  = Vx;  /* Wert zwischenspeichern */
    Vx = -Vz; /* neue Komponente invertiert setzen */
    Vz = z;   /* neue Komponente setzen */
    z  = Vy;  /* Wert zwischenspeichern */
    Vy = -W;  /* neue Komponente invertiert setzen */
    W  = z;   /* neue Komponente setzen */
    /* wenn ALLE Werte negativ -- positiv machen */
    if(Vx>0.0) return null; /* trifft schon nicht zu */
    if(Vy>0.0) return null; /* trifft schon nicht zu */
    if(Vz>0.0) return null; /* trifft schon nicht zu */
    if(W>0.0)  return null; /* trifft schon nicht zu */
    Vx = Math.abs(Vx); /* positiven Wert einsetzen */
    Vy = Math.abs(Vy); /* positiven Wert einsetzen */
    Vz = Math.abs(Vz); /* positiven Wert einsetzen */
    W  = Math.abs(W);  /* positiven Wert einsetzen */
    return null; /* ohne Fehlermeldung zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mul"
  * Positionswerte mit Quaterion multiplizieren und ggf. Fehler melden
  * Matrixmultiplikation: q1' = q1.q2 ist q1' = q1.mul(q2)
  * Objekt q2 (x2 y2 z2 w2) wird als Argument beim Aufruf mitgegeben
  * x' = x1*w2 + z1*y2 + w1*x2 - y1*z2
  * y' = x1*z2 + y1*w2 + w1*y2 - z1*x2
  * z' = y1*x2 + z1*w2 + w1*z2 - x1*y2
  * w' = w1*w2 - x1*x2 - y1*y2 - z1*z2
  * Methode kombiniert damit zwei aufeinanderfolgende Rotationen zu
  *   einer einzigen.
  * ##mul.TSQDir (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String mul( /* neue Richtungswerte berechnen */
   TSQDir q) /* Quaterion zum multiplizieren */
   {
   /*-----------------------------------------------------------------*/
    double a,b,c; /* Zwischenwerte */
   /*=================================================================*/
    a = Vx*q.W + Vz*q.Vy + W*q.Vx - Vy*q.Vz; /* Zwischenwert ber. */
    b = Vx*q.Vz + Vy*q.W + W*q.Vy - Vz*q.Vx; /* Zwischenwert ber. */
    c = Vy*q.Vx + Vz*q.W + W*q.Vz - Vx*q.Vy; /* Zwischenwert ber. */
    W = W*q.W - Vx*q.Vx - Vy*q.Vy - Vz*q.Vz; /* neuen Wert berechnen */
    Vx = a; /* neuen Wert aus Zwischenwert setzen */
    Vy = b; /* neuen Wert aus Zwischenwert setzen */
    Vz = c; /* neuen Wert aus Zwischenwert setzen */
    return null; /* ohne Fehlermeldung zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "raise"
  * 'Quaterion'-Werte senkrecht (zu aktuellem Objekt) rotieren
  * Realisierung durch Multiplikation mit Quaternion 'senkrecht'
  *   q=New-Quaterion(Vector (1,0,0),Winkel w) = (sin(w/2) 0 0 cos(w/2))
  * Methode liefert Fehlermeldung oder 'null'
  * ##raise.TSQDir (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String raise( /* 'Quaterion's senkrecht rotieren */
   double w) /* Winkel fuer Rotation im Radiantenmass */
   {
   /*-----------------------------------------------------------------*/
    double a; /* Arbeitswerte */
   /*=================================================================*/
    if(w==0.0) return null; /* keine Veraenderung -- keine Aktion */
    w /= -2.0; /* erster Berechnungsschritt (normaler Winkel positiv) */
    a = Math.sin(w); /* QDir-X berechnen */
    w = Math.cos(w); /* QDir-W berechnen */
    return mul(new TSQDir(a,0.0,0.0,w)); /* Ergebnis erstellen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "turn"
  * 'Quaterion'-Werte waagerecht (zu aktuellem Objekt) rotieren
  * Realisierung durch Multiplikation mit Quaternion 'waagrecht'
  *   q=New-Quaterion(Vector (0,1,0),Winkel w) = (0 sin(w/2) 0 cos(w/2))
  * Methode liefert Fehlermeldung oder 'null'
  * ##turn.TSQDir (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String turn( /* 'Quaterion's waagerecht rotieren */
   double w) /* Winkel fuer Rotation im Radiantenmass */
   {
   /*-----------------------------------------------------------------*/
    double b; /* Arbeitswerte */
   /*=================================================================*/
    if(w==0.0) return null; /* keine Veraenderung -- keine Aktion */
    w /= -2.0; /* ester Berechnungsschritt (normaler Winkel positiv) */
    b = Math.sin(w); /* QDir-Y berechnen */
    w = Math.cos(w); /* QDir-W berechnen */
    return mul(new TSQDir(0.0,b,0.0,w)); /* Ergebnis erstellen */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSQDir (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSQDir{("+Vx+","+Vy+","+Vz+","+W+")"+chkVals()+"}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSCoo -- Coordinate for different geographical Systems
 * Attention: Usage of region-numbers is different to common
 *            documentation of this theme
 * ##TSCoo (Eyecatcher)
 *======================================================================
 </pre>*/
class TSCoo implements Serializable { /* Definition of Coordinate */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 06.06.2008";
  protected static double       PI2 = Math.PI * 2.0;
  protected static double       HPI = Math.PI * 0.5;
  private static double         eps = 1.0e-10;
  private static double         R   = 6370997.0; /* Radius of earth */
  private static double         Z1 = R *  0.710987989993; /* 40.?? */
  private static double         Z2 = R * -0.710987989993; /* -40.?? */
  private static double         X1 = R * -0.698131700798; /* -40 */
  private static double         X2 = R * -1.74532925199; /* -100 */
  private static double         X3 = R * -0.349065850399; /* -20 */
  private static double         X4 = R *  1.3962634016; /* +80 */
  private static double         LC[] = {-1.74532925199, /* -100.0 (1) */
                                         0.523598775598, /* 30.0 (3) */
                                        -2.79252680319, /* -160.0 (4) */
                                        -1.0471975512, /* -60.0 (5) */
                                         0.349065850399, /* 20.0 (8) */
                                         2.44346095279, /* 140.0 (9) */
                                        -2.79252680319, /* -160.0 (6) */
                                        -1.0471975512, /* -60.0 (7) */
                                        -1.74532925199, /* -100.0 (0) */
                                         0.523598775598, /* 30.0 (2) */
                                         0.349065850399, /* 20.0 (10) */
    /* 140.0 */                          2.44346095279 }; /* (11) */
 /*-------------------------------------------------------------------*/
  private int                   Qx;     /* east-west-quad (gov) */
  private int                   Qz;     /* south-north-quad (gov) */
  private double                Px;     /* east-west-value (gov) */
  private double                Pz;     /* south-north-value (gov) */
  private double                Lat;    /* latitude (Wgs84-Radians) */
  private double                Lon;    /* longitude (Wgs84-Radians) */
  private double                Hgt;    /* height-value */
  private String                EMsg;   /* Errormessage or 'null' */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSCoo() /* create dummy-definition of Coordinate */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Hgt  = Double.NaN; /* set invalid value (Not-a-Number) */
    Qx   = Integer.MIN_VALUE; /* set invalid value */
    Qz   = Integer.MIN_VALUE; /* set invalid value */
    Px   = Double.NaN; /* set invalid value (Not-a-Number) */
    Pz   = Double.NaN; /* set invalid value (Not-a-Number) */
    Lat  = Double.NaN; /* set invalid value (Not-a-Number) */
    Lon  = Double.NaN; /* set invalid value (Not-a-Number) */
//    EMsg = null;       /* no current error-message */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSCoo( /* create standard coordinate */
   int    qx, /* current Quad-value (gov) */
   int    qz, /* current Quad-value (gov) */
   double x,  /* current position (ew-gov) */
   double y,  /* current position (height) */
   double z)  /* current position (sn-gov) */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Qx  = qx; /* store Quad-number */
    Qz  = qz; /* store Quad-number */
    Px  = x;  /* store position-value */
    Hgt = y;  /* store position-value */
    Pz  = z;  /* store position-value */
  }

 /**. <pre>
  *=====================================================================
  * Method "getErr"
  * Get active error-message (or 'null' if none)
  * ##getErr.TSCoo (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getErr() /* get current error-message */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return EMsg; /* provide error-message or 'null' */
  }

 /**. <pre>
  *=====================================================================
  * Method "getHgt"
  * Get current value for Height
  * ##getHgt.TSCoo (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double getHgt() /* get current value for Height */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Hgt; /* provide value in every case */
  }

 /**. <pre>
  *=====================================================================
  * Method "getLat"
  * Get current value for Latitude
  * Value will be computed if not available
  * ##getLat.TSCoo (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double getLat() /* get current value for Latitude */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Double.isNaN(Lat)) { /* value not available */
      EMsg = toLatLon(); /* compute new values */
      if(EMsg!=null) return Double.NaN; /* error -- value not created */
    } /* value was succesfully created */
    return Lat; /* provide value */
  }

 /**. <pre>
  *=====================================================================
  * Method "getLon"
  * Get current value for Longitude
  * Value will be computed if not available
  * ##getLon.TSCoo (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double getLon() /* get current value for Longitude */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Double.isNaN(Lon)) { /* value not available */
      EMsg = toLatLon(); /* compute new values */
      if(EMsg!=null) return Double.NaN; /* error -- value not created */
    } /* value was succesfully created */
    return Lon; /* provide value */
  }

 /**. <pre>
  *=====================================================================
  * Method "R2D" (static)
  * Transform radiant-value to degrees (-PI..+PI)->(-180..+180)
  * ##R2D.TSCoo (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static double R2D( /* convert radiant to degreee */
   double r)  /* value messured in radians */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Double.isNaN(r)) return Double.NaN; /* Error -- return it */
    if(r<-Math.PI) return Double.NaN; /* return if argument-error */
    if(r>Math.PI) return Double.NaN; /* return if argument-error */
    r *= 180.0;
    r /= Math.PI; /* compute result */
    return r; /* provide value in degree */
  }

 /**. <pre>
  *=====================================================================
  * Method "toLatLon"
  * Convert Coordinate to Lat/Lon-Format
  * Method returns error-message or null if no error
  * Longitude: -180..180 (-PI..PI), Latitude: -90..90 (-PI/2..PI/2)
  * Region-numbers used(documentation->program):
  *   0->8, 1->0, 2->9, 3->1, 4->2, 5->3, 6->6, 7->7, 8->4, 9->5,
  *         10->10, 11->11
  * ##toLatLon.TSCoo (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toLatLon() /* Convert Coordinate to Lat/Lon */
   {
   /*-----------------------------------------------------------------*/
    double x,z;
    double theta,lat,lon;
    int    rgn; /* Number of region (Attention: modified use) */
   /*=================================================================*/
    if(Qx==Integer.MIN_VALUE) /* basis-coordinate is not valid */
      return TSLogg.getKey("TSCoo01"); /* return message */
    x = (Qx + 6610) * 2048.0 + Px; /* compute real value */
    z = (Qz - 12149) * 2048.0 + Pz; /* compute real value */

    if(z>=Z1) /* on or above 40 44' 11.8" */
      if(x<=X1) rgn = 8; /* left to -40 */ else rgn = 9;
    else if(z>=0.0) /* between 0 and 40 44' 11.8" */
      if(x<=X1) rgn = 0; /* left to -40 */ else rgn = 1;
    else if(z>Z2) /* between -40 44' 11.8" and 0 */
      if(x<=X2) rgn = 2; /* between -180 and -100 */
      else if(x<=X3) rgn = 3; /* between -100 and -20 */
      else if(x<=X4) rgn = 4; /* between -20 and 80 */
      else rgn = 5; /* between 80 and 180 */
    else /* below -40 44' 11.8" */
      if(x<=X2) rgn = 6; /* between -180 and -100 */
      else if(x<=X3) rgn = 7; /* between -100 and -20 */
      else if(x<=X4) rgn = 10; /* between -20 and 80 */
      else rgn = 11; /* between 80 and 180 */

    x -= R *  LC[rgn]; /* adjust easting */

    if(rgn<6) {
      lat = z / R; /* set value to relative */
      if(Math.abs(lat)>HPI) return TSLogg.getMsg("TSCoo02",lat); /* Input-Data-Error */
      theta = HPI - Math.abs(lat); /* theta>0 ! */
      lon = LC[rgn]; /* use center (default) */
      if(theta>eps) {
        lon += x / (R * Math.cos(lat));
        while(Math.abs(lon)>Math.PI) { /* adjust longitude to -180..+180 */
          lon -= lon<0.0 ? -PI2 : PI2;
        } /* adjust longitude */
      } /* Longitude was calcutated */
    } else { /* all other regions */
      theta = (z + 0.0528035274542 * R * (z<0 ? -1.0 : 1.0)) /  (1.4142135623731 * R);
      if (Math.abs(theta)>1.0) return TSLogg.getMsg("TSCoo03",""+rgn,theta);
      theta = Math.asin(theta); /* result: -HPI .. +HPI */
      lon = LC[rgn] + (x / (0.900316316158 * R * Math.cos(theta)));
      if(lon<-Math.PI) return TSLogg.getMsg("TSCoo04",lon);
      theta = (2.0 * theta + Math.sin(2.0 * theta)) / Math.PI;
      if (Math.abs(theta)>1.0) return TSLogg.getMsg("TSCoo05",theta); /* in 'Break' */
      lat = Math.asin(theta);
    }

    switch(rgn) { /* test all 'breaks' */
      case( 8): if(lon>=-Math.PI && lon<=-0.698131700798) break;
        return TSLogg.getMsg("TSCoo06","8/0",lon); /* -180..-40 */
      case( 0): if(lon>=-Math.PI && lon<=-0.698131700798) break;
        return TSLogg.getMsg("TSCoo06","0/1",lon); /* -180..-40 */
      case( 9): if(lon>=-0.698131700798 && lon<=Math.PI) break;
        return TSLogg.getMsg("TSCoo06","9/2",lon); /* -40..+180 */
      case( 1): if(lon>=-0.698131700798 && lon<=Math.PI) break;
        return TSLogg.getMsg("TSCoo06","1/3",lon); /* -40..+180 */
      case( 2): if(lon>=-Math.PI && lon<=-1.74532925199) break;
        return TSLogg.getMsg("TSCoo06","2/4",lon); /* -180..-100) */
      case( 3): if(lon>=-1.74532925199 && lon<=-0.349065850399) break;
        return TSLogg.getMsg("TSCoo06","3/5",lon); /* -100..-20 */
      case( 6): if(lon>=-Math.PI && lon<=-1.74532925199) break;
        return TSLogg.getMsg("TSCoo06","6/6",lon); /* -180..-100 */
      case( 7): if(lon>=-1.74532925199 && lon<=-0.349065850399) break;
        return TSLogg.getMsg("TSCoo06","7/7",lon); /* -100..-20 */
      case( 4): if(lon>=-0.349065850399 && lon<=1.3962634016) break;
        return TSLogg.getMsg("TSCoo06","4/8",lon); /* -20..+80 */
      case( 5): if(lon>=1.3962634016 && lon<=Math.PI) break;
        return TSLogg.getMsg("TSCoo06","5/9",lon); /* +80..+180 */
      case(10): if(lon>=-0.349065850399 && lon<=1.3962634016) break;
        return TSLogg.getMsg("TSCoo06","10/10",lon); /* -20..+80 */
      case(11): if(lon>=1.3962634016 && lon<=Math.PI) break;
        return TSLogg.getMsg("TSCoo06","11/11",lon); /* +80..+180 */
      default: return TSLogg.getMsg("TSCoo09",rgn); /* normally not used! */
    } /* test all break-regions */

    Lat = lat; /* activate Value */
    Lon = lon; /* activate Value */
    return null; /* return marker for valid result */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSCoo (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* String for result */
   /*=================================================================*/
    rs = "TSCoo{["+Qx+","+Qz+",("+Px+","+Hgt+","+Pz+")],[";
    rs += Lat+","+Lon+","+Hgt+"]}";
    return rs; /* return result */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * ##+ (Eyecatcher)
 *    OBJEKT-Definitionen fuer TS-Objekte (Daten-Klassen)
 *======================================================================
 </pre>*/

/**. <pre>
 *======================================================================
 * Class TSOpts -- Definition and control of an option-memory
 * Diese Klasse stellt AUCH Statische Methoden der gleichen Funktionen
 *  mit gleichem Namen bereit, bei denen der Maskenwert angegeben
 *  werden muss und die den NEUEN Maskenwert liefern.
 * ##TSOpts (Eyecatcher)
 *======================================================================
 </pre>*/
class TSOpts implements Serializable { /* control of options */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.09 18.11.2010";
 /*-------------------------------------------------------------------*/
  private int                   Msk;    /* Value contains 32 options */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSOpts() /* Basis-Definition erstellen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    Msk = 0; /* Init: keine Option/Maskenbit aktiv */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSOpts( /* create basic definition */
   int w) /* initial value of the optionmask */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Msk = w; /* set initial value */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create entry using template
  *=====================================================================
  </pre>*/
  protected TSOpts( /* create basic definition */
   TSOpts cO) /* option-definition used as template */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Msk = cO.Msk; /* copy value from template */
  }

 /**. <pre>
  *=====================================================================
  * Methode "$init"
  * Reinitialize Option-Mask (mask is reusable)
  *  Use argument 'w' as initial value.
  * ##$init.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int $init( /* Definitionsmaske neu initialisieren */
   int w) /* new initial option-value */
   {
   /*-----------------------------------------------------------------*/
    int i; /* Arbeitswerte */
   /*=================================================================*/
    i = Msk; /* alter Wert merken */
    Msk = w; /* Initialisierungswert neu vorbesetzen */
    return i; /* alten Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "andMsk"
  * Optionen-Maske maskieren
  * Methode liefert Maske der NICHT MEHR gesetzten Werte
  * ##andMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
//  protected final int andMsk( /* Definitionsmaske maskieren */
//   int m) /* Maske zum Maskieren */
//   {
   /*-----------------------------------------------------------------*/
//    int i; /* Arbeitswerte */
   /*=================================================================*/
//    i = Msk & (~m); /* Maske der veraenderten Optionen erstellen */
//    Msk &= m; /* neue aktuelle Maske erstellen */
//    return i; /* Maske zurueckliefern */
//  }

 /**. <pre>
  *=====================================================================
  * Method "chkMsk"
  * Check optionsmask according to bitnumber specified as 'nr' (0..31).
  * Method returns 'true' if the Definition/Option is set!
  * If invalid bitnumber is specified, 'IllegalArgumentException' is
  *   thrown.
  * ##chkMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkMsk( /* Definitionsnummer pruefen */
   int nr) /* number of optionbit */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>31) throw new /* Abbruch Programm mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","chkMsk",nr,1));
    nr = 1 << nr; /* Test-Maske fuer Kennungsbit erstellen */
    return (Msk&nr)!=0; /* liefern aktuelles Optionen-Bit */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkMsk" (static version (32))
  * Check provided optionsmask according to bitnumber specified as
  *   'nr' (0..31).
  * Method returns 'true' if the Definition/Option is set!
  * If invalid bitnumber is specified, 'IllegalArgumentException' is
  *   thrown.
  * ##chkMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static boolean chkMsk( /* Definitionsnummer pruefen */
   int nr,  /* number of optionbit */
   int msk) /* Optionenmaske wird spezifiziert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>31) throw new /* Abbruch Programm mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","chkMsk",nr,1));
    nr = 1 << nr; /* Test-Maske fuer Kennungsbit erstellen */
    return (msk&nr)!=0; /* liefern aktuelles Optionen-Bit */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkMsk" (static Version (64))
  * Check provided optionsmask according to bitnumber specified as
  *   'nr' (0..63).
  * Method returns 'true' if the Definition/Option is set!
  * If invalid bitnumber is specified, 'IllegalArgumentException' is
  *   thrown.
  * ##chkMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
//  protected static boolean chkMsk( /* Definitionsnummer pruefen */
//   int  nr,  /* number of optionbit */
//   long msk) /* Optionenmaske wird spezifiziert */
//   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    if(nr<0 || nr>63) throw new /* Abbruch Programm mit Systemfehler */
//      IllegalArgumentException(TSLogg.getMsg("Msg901","chkMsk",nr,1));
//    return (msk&(1L<<nr))!=0; /* liefern aktuelles Optionen-Bit */
//  }

 /**. <pre>
  *=====================================================================
  * Method "clrMsk"
  * Clear optionbit according to bitnumber specified as 'nr' (0..31).
  * Method returns state of selected optionbit BEFORE is was cleared.
  * If invalid bitnumber is specified, 'IllegalArgumentException' is
  *   thrown.
  * ##clrMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean clrMsk( /* clear selected optionbit */
   int nr) /* number of optionbit */
   {
   /*-----------------------------------------------------------------*/
    boolean s; /* intermediate value */
   /*=================================================================*/
    if(nr<0 || nr>31) throw new /* Abbruch Programm mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","clrMsk",nr,1));
    nr = 1 << nr; /* Test-Maske fuer Kennungsbit erstellen */
    s = (Msk & nr)!=0; /* Status des Maskenbits festhalten */
    Msk &= ~nr; /* neues Maskenbit herausloeschen */
    return s; /* Ende -- alter Status liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "clrMsk" (static Version (32))
  * Optionen-Maske gemaess Definitionsnummer loeschen
  * Achtung: Methode liefert die neue Optionenmaske
  * ##clrMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int clrMsk( /* Definitionsnummer loeschen */
   int nr,  /* Nummer der Option */
   int msk) /* Optionenmaske wird spezifiziert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>31) throw new /* Abbruch Programm mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","clrMsk",nr,1));
    nr = 1 << nr; /* Test-Maske fuer Kennungsbit erstellen */
    msk &= ~nr; /* neues Maskenbit herausloeschen */
    return msk; /* Ende -- neuer Status liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "cntMsk"
  * Anzahl der relevanten Optionen zaehlen, die aktiv sind
  * Bei Maske '-1' (=0xFFFFFFFF) sind ALLE Optionen relevant
  * Methode liefert die Anzahl gesetzter Optionen
  * Die gespeicherte Maske wird NICHT veraendert
  * ##cntMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int cntMsk( /* gesetzte Optionenbits zaehlen */
   int m) /* Optionenmaske zur Auswahl relevanter Optionen */
   {
   /*-----------------------------------------------------------------*/
    int i; /* Arbeitswerte */
   /*=================================================================*/
    if(m==0) m = -1; /* adjust alternate value of mask */
    m &= Msk; /* zu pruefende Maske erstellen */
    for(i=0;m!=0;m>>>=1) /* alle gesetzen Optionen pruefen */
      if((m&1)!=0) i += 1; /* Option gesetzt -- zaehlen */
    return i; /* Ende -- geforderte Anzahl liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "cntMsk" (statische Version (32))
  * Anzahl der relevanten Optionen zaehlen, die aktiv sind
  * Bei Maske '-1' (=0xFFFFFFFF) (oder '0') sind ALLE Optionen relevant
  * Methode liefert die Anzahl gesetzter Optionen
  * ##cntMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int cntMsk( /* gesetzte Optionenbits zaehlen */
   int m,   /* Optionenmaske zur Auswahl relevanter Optionen */
   int msk) /* Optionenmaske wird spezifiziert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(m==0) m = -1; /* adjust alternate value of mask */
    m &= msk; /* zu pruefende Maske erstellen */
    for(msk=0;m!=0;m>>>=1) /* alle gesetzen Optionen pruefen */
      if((m&1)!=0) msk += 1; /* Option gesetzt -- zaehlen */
    return msk; /* Ende -- geforderte Anzahl liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndMsk"
  * Search optionmask for first bit which is 'set' or 'not set'.
  * Method returns lowest number of Bit due to requested condition.
  * If NO bit of the condition can be found, 'Integer.MIN_VALUE' is
  *   returned.
  * ##fndMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int fndMsk( /* search for first bit due to cond. */
   boolean cnd) /* requested condition ('true' = 'set') */
   {
   /*-----------------------------------------------------------------*/
    int m,c; /* mask and counter */
   /*=================================================================*/
    m = cnd ? Msk : (Msk ^ -1); /* create Mask due to condition */
    for(c=0;m!=0;m>>>=1,c+=1) /* check options due to condition */
      if((m&1)!=0) return c; /* condition found -- return */
    return Integer.MIN_VALUE; /* no requested bit found */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getMsk"
  * Optionen-Maske maskiert liefern
  * Maske '-1' (=0xFFFFFFFF) (or '0') liefert ALLE Optionen
  * Die gespeicherte Maske wird NICHT veraendert
  * ##getMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getMsk( /* Definitionsmaske maskieren */
   int m) /* Maske der geforderten Optionen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(m==0) m = -1; /* adjust alternate value of mask */
    return Msk&m; /* geforderte Maske zurueckliefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "orMsk"
  * Extend optionmask.
  * Method returns mask of newly set bits.
  * ##orMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int orMsk( /* extend optionmask */
   int m) /* mask to be merged */
   {
   /*-----------------------------------------------------------------*/
    int i; /* storage for result */
   /*=================================================================*/
    i = (~Msk) & m; /* compte mask of extensions */
    Msk |= m; /* compute new optionmask */
    return i; /* return mask of extensions */
  }

 /**. <pre>
  *=====================================================================
  * Method "orMsk" (object-version)
  * Extend optionmask using another TSOpts-object.
  * Method returns mask of newly set bits.
  * ##orMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int orMsk( /* extend optionmask */
   TSOpts m) /* object contains mask to be merged */
   {
   /*-----------------------------------------------------------------*/
    int i; /* storage for result */
   /*=================================================================*/
    i = (~Msk) & m.Msk; /* compte mask of extensions */
    Msk |= m.Msk; /* compute new optionmask */
    return i; /* return mask of extensions */
  }

 /**. <pre>
  *=====================================================================
  * Method "prtMsk"
  * Build a hexadecimal string-representation of the current Mask.
  * Mask '-1' (=0xFFFFFFFF) (or '0') return ALL options as valid.
  * ##prtMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String prtMsk( /* return hexadecimal optionmask */
   int m) /* primary masking value (do not return some options) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(m==0) m = -1; /* adjust alternate value of mask */
    return TSUtil.toHex(Msk&m,-8); /* return printable mask */
  }

 /**. <pre>
  *=====================================================================
  * Methode "resMsk"
  * Selektierte Definitionen der Optionen-Maske zuruecksetzen
  * Methode liefert Maske der Werte, die geloescht wurden
  * Maske '-1' (=0xFFFFFFFF) loescht ALLE Optionen
  * ##resMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int resMsk( /* Definitionsmaske zuruecksetzen */
   int m) /* Maske zum Zuruecksetzen */
   {
   /*-----------------------------------------------------------------*/
    int i; /* Arbeitswerte */
   /*=================================================================*/
    i = Msk & m; /* Maske der veraenderten Optionen erstellen */
    Msk &= (~m); /* neue aktuelle Maske erstellen */
    return i; /* Maske zurueckliefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setMsk"
  * Optionen-Maske gemaess Definitionsnummer setzen
  * Methode liefert den Status des Maskenbits VOR dem Setzen
  * ##setMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean setMsk( /* Definitionsnummer setzen */
   int nr) /* Nummer der Option */
   {
   /*-----------------------------------------------------------------*/
    boolean s; /* Arbeitswerte */
   /*=================================================================*/
    if(nr<0 || nr>31) throw new /* Abbruch Programm mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","setMsk",nr,1));
    nr = 1 << nr; /* Test-Maske fuer Kennungsbit erstellen */
    s = (Msk & nr)!=0; /* Status des Maskenbits festhalten */
    Msk |= nr; /* neues Maskenbit einsetzen */
    return s; /* Ende -- alter Status liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setMsk" (statische Version (32))
  * Optionen-Maske gemaess Definitionsnummer setzen
  * Achtung: Methode liefert die neue Optionenmaske
  * ##setMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int setMsk( /* Definitionsnummer setzen */
   int nr,  /* Nummer der Option */
   int msk) /* Optionenmaske wird spezifiziert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>31) throw new /* Abbruch Programm mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","setMsk",nr,1));
    nr = 1 << nr; /* Test-Maske fuer Kennungsbit erstellen */
    msk |= nr; /* neues Maskenbit einsetzen */
    return msk; /* Ende -- neuer Status liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "tstMsk"
  * Pruefen der relevanten Optionen ob diese aktiv sind
  * Bei Maske '-1' (=0xFFFFFFFF) (or '0') sind ALLE Optionen relevant
  * Methode liefert die Maske der NOCH NICHT gesetzen relevanten Optionen
  * Die gespeicherte Maske wird NICHT veraendert
  * ##tstMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int tstMsk( /* relante Optionen pruefen */
   int m) /* Optionenmaske zur Auswahl relevanter Optionen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(m==0) m = -1; /* adjust alternate value of mask */
    return (~Msk) & m; /* relevante Optionen auswaehlen und testen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "xorMsk"
  * Optionen-Maske mit 'exclusive or' veraendern
  * Methode liefert Zustands-Maske der veraenderten Werte
  * ##xorMsk.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
//  protected final int xorMsk( /* Definitionsmaske veraendern */
//   int m) /* Maske der Veraenderungen */
//   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    Msk ^= m; /* neue aktuelle Maske erstellen */
//    return Msk&m; /* geforderte Zustandsmaske zurueckliefern */
//  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSOpts (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    return "TSOpts{" + TSUtil.toHex(Msk,-8) + "}";
   }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSArrList -- Extension of the java 'ArrayList'-definition
 * This class provides additional methods to the arraylist-definition,
 *   which are used if, the list contains entries of MIXED types.
 * ##TSArrList (Eyecatcher)
 *======================================================================
 </pre>*/
class TSArrList<E> extends ArrayList<E> { /* common data-definitions */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.6.04 04.11.2011";
 /*-------------------------------------------------------------------*/
                            /* no definitions of instance-variables */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSArrList() /* create basic definition */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Method "addObj"
  * Add new object to current list. Return length of queue.
  * ##addObj.TSArrList (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int addObj( /* add new object and return length */
   E cO) /* new object to be added */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(this.add(cO)) return this.size(); /* successfully added */
    return Integer.MIN_VALUE; /* action NOT successful (n.v.) */
  }

 /**. <pre>
  *=====================================================================
  * Method "getDta"
  * Return selected object from table. Check type of object.
  * Resolved entry must be of type 'String' or an error is raised.
  * ##getDta.TSArrList (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getDta( /* return String-object from array */
   int ix) /* number/index of object within table */
   {
   /*-----------------------------------------------------------------*/
    Object cO; /* current object */
   /*=================================================================*/
    if(ix<0) throw new IllegalArgumentException( /* systemerror */
      TSLogg.getMsg("Msg901","TSArrList.getDta()",ix,1));
    if(ix>=this.size()) return null; /* invalid index */
    cO = this.get(ix); /* get requested object */
    if(cO==null) return null; /* no valid object -- signal it */
    if(!(cO instanceof String)) throw new /* invalid type */
      IllegalStateException(TSLogg.getMsg("Msg906","TSArrList.getDta()"));
    return (String)cO; /* return valid object from list */
  }

 /**. <pre>
  *=====================================================================
  * Method "getInt"
  * Return selected object from table. Check type of object.
  * Resolved entry must be of type 'Integer' or an error is raised.
  * ##getInt.TSArrList (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getInt( /* return integer-value from array */
   int ix) /* number/index of object within table */
   {
   /*-----------------------------------------------------------------*/
    Object cO; /* current object */
   /*=================================================================*/
    if(ix<0) throw new IllegalArgumentException( /* systemerror */
      TSLogg.getMsg("Msg901","TSArrList.getInt()",ix,1));
    if(ix>=this.size()) return Integer.MIN_VALUE; /* invalid index */
    cO = this.get(ix); /* get requested object */
    if(cO==null) return Integer.MIN_VALUE; /* no entries exist */
    if(!(cO instanceof Integer)) throw new /* invalid type */
      IllegalStateException(TSLogg.getMsg("Msg906","TSArrList.getInt()"));
    return ((Integer)cO).intValue(); /* return valid object from list */
  }
 /**. <pre>
  *=====================================================================
  * Method "getObj"
  * Return selected object from table. Check type of object.
  * Resolved entry can be of any type. However, the index is
  *   additionally checked.
  * ##getDta.TSArrList (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final E getObj( /* return object from array */
   int ix) /* number/index of object within table */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(ix<0) throw new IllegalArgumentException( /* systemerror */
      TSLogg.getMsg("Msg901","TSArrList.getObj()",ix,1));
    if(ix>=this.size()) return null; /* invalid index */
    return this.get(ix); /* get requested object */
  }

 /**. <pre>
  *=====================================================================
  * Method "getOpt"
  * Return selected object from table. Check type of object.
  * Resolved entry must be of type 'TSOpts' or an error is raised.
  * ##getOpt.TSArrList (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSOpts getOpt( /* return 'TSOpts'-object from array */
   int ix) /* number/index of object within table */
   {
   /*-----------------------------------------------------------------*/
    Object cO; /* current object */
   /*=================================================================*/
    if(ix<0) throw new IllegalArgumentException( /* systemerror */
      TSLogg.getMsg("Msg901","TSArrList.getDta()",ix,1));
    if(ix>=this.size()) return null; /* invalid index */
    cO = this.get(ix); /* get requested object */
    if(cO==null) return null; /* no valid object -- signal it */
    if(!(cO instanceof TSOpts)) throw new /* invalid type */
      IllegalStateException(TSLogg.getMsg("Msg906","TSArrList.getOpt()"));
    return (TSOpts)cO; /* return valid object from list */
  }

 /**. <pre>
  *=====================================================================
  * Method "setDta"
  * Replace selected object within table. Check type of object and
  *   return original one.
  * If the table is TOO small, it is filled with dummy-objects (null).
  * Resolved entry must be of type 'String' or an error is raised.
  * ##setDta.TSArrList (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String setDta( /* replace/add String within array */
   int    ix,  /* number/index of object within table */
   String dta) /* new entry for replace */
   {
   /*-----------------------------------------------------------------*/
    Object cO; /* current object */
   /*=================================================================*/
    if(ix<0) throw new IllegalArgumentException( /* systemerror */
      TSLogg.getMsg("Msg901","TSArrList.setDta()",ix,1));
    while(ix>=this.size()) this.add(null); /* insert dummy-entries */
    cO = this.set(ix,(E)dta); /* replace selected entry */
    if(cO==null) return null; /* no valid object -- signal it */
    if(!(cO instanceof String)) throw new /* invalid type */
      IllegalStateException(TSLogg.getMsg("Msg906","TSArrList.setDta()"));
    return (String)cO; /* return valid object from list */
  }

 /**. <pre>
  *=====================================================================
  * Method "setInt"
  * Replace selected object within table. Check type of object and
  *   return original one.
  * If the table is TOO small, it is filled with dummy-objects (null).
  * Resolved entry must be of type 'Integer' or an error is raised.
  * ##setInt.TSArrList (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int setInt( /* replace/add Integer within array */
   int ix,  /* number/index of object within table */
   int dta) /* new entry for replace */
   {
   /*-----------------------------------------------------------------*/
    Object cO; /* current object */
   /*=================================================================*/
    if(ix<0) throw new IllegalArgumentException( /* systemerror */
      TSLogg.getMsg("Msg901","TSArrList.setInt()",ix,1));
    while(ix>=this.size()) this.add(null); /* insert dummy-entries */
    cO = this.set(ix,(E)(new Integer(dta))); /* replace selected entry */
    if(cO==null) return Integer.MIN_VALUE; /* no valid entry exists */
    if(!(cO instanceof Integer)) throw new /* invalid type */
      IllegalStateException(TSLogg.getMsg("Msg906","TSArrList.setInt()"));
    return ((Integer)cO).intValue(); /* return valid object from list */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSArrList (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String   rs; /* result-String */
    boolean  t;  /* separator needed */
    Iterator cI; /* common Iterator of list-entries */
    Object   cO; /* common object-reference */
   /*=================================================================*/
    rs = "TSArrList{" + this.size() + "("; /* init prefix */
    t = false; /* do not insert separator */
    cI = this.iterator(); /* get iterator for all entries */
    while(cI.hasNext()) { /* more entries available */
      cO = cI.next(); /* get next object */
      if(t) rs += ","; /* insert separator if needed */
      if(cO==null) rs += "<null>"; /* entry missing */
      else /* convert current entry */
        if(cO instanceof Integer)
          rs += "Int(" + ((Integer)cO).intValue() + ")";
        else if(cO instanceof String)
          rs += "Str('" + (String)cO + "')";
        else if(cO instanceof TSOpts)
          rs += ((TSOpts)cO).toStr();
        else rs += cO.getClass().getName() + "()";
      t = true; /* separator needed from now on */
    } /* process all entries within list */
    if(rs.length()>0) rs = rs.substring(1); /* delete first separator */
    return rs + ")}"; /* provide result-string */
   }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSData -- common unspecified data-storage
 * Diese Klasse erweitert die Klasse 'TSOpts' um die Moeglichkeiten
 * zur Speicherung von Objekt-Daten.
 * Sie nutzt die Definitionen der Klasse 'TSOpts' zur Implementierung
 * einer Optionenmaske. Deshalb wird diese Klasse von TSOpts
 * abgeleitet. Von dieser Klasse wird auch das Interface 'Serializable'
 * uebernommen.
 * Achtung! Zwei Default-Queues werden (immer) installiert:
 *  0 - String-Speicher
 *  1 - Integer-Speicher
 *  Diese beiden Queues koennen mit speziellen Methoden DIREKT
 *  angesprochen werden.
 * Weiterhin gibt es Methoden um Objekte vom Typ 'String' oder
 *  'Integer' in den/allen Queues anzusprechen. Wenn eine solche
 *  Methode benutzt wird, MUSS das erwartete/spezifizierte Element
 *  auch diesen speziellen Typ besitzen.
 * ##TSData (Eyecatcher)
 *======================================================================
 </pre>*/
class TSData extends TSOpts { /* common data-definitions */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.3.03 28.12.2006";
 /*-------------------------------------------------------------------*/
  private TSArrList[]           Dta;    /* common Vector of Data */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSData() /* create basic definition */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Dta = new TSArrList[2]; /* create list of vectors (Minimal) */
    Dta[0] = Dta[1] = null; /* datavectors are NOT allocated */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSData( /* create standard definition */
   int c) /* Number of datavectors */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c<2) c = 3; /* requested value too small -- use default */
    Dta = new TSArrList[c]; /* create list of data-vectors (fix number) */
    Arrays.fill(Dta,null); /* datavectors are NOT allocated */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create entry using parent-entry
  *=====================================================================
  </pre>*/
  protected TSData( /* create definition using parent */
   TSOpts cO, /* Parent-Definition (TSOpts) */
   int    c)  /* Number of datavectors */
   {
    super(cO); /* copy 'TSOpts' (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c<2) c = 3; /* requested value too small -- use default */
    Dta = new TSArrList[c]; /* create list of data-vectors (fix number) */
    Arrays.fill(Dta,null); /* datavectors are NOT allocated */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (4) Create copy-entry from template
  * ACHTUNG: Es wird KEINE Kopie der Objekte erstellt, die in den
  *          in den einzelnen Datenarrays gespeichert sind!
  *=====================================================================
  </pre>*/
  protected TSData( /* create Basic-Definition using template */
   TSData cDta) /* template */
   {
    super(cDta); /* copy 'TSOpts' (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
    int i,j; /* intermediate value */
   /*=================================================================*/
    j = cDta.Dta.length; /* Number of datavectors */
    Dta = new TSArrList[j]; /* create list of data-vectors (fix number) */
    Arrays.fill(Dta,null); /* datavectors are NOT allocated */
    for(i=0;i<Dta.length;i+=1) /* copy all arrays */
      for(j=0;j<cDta.get$Obj(i);j+=1) /* and all entries */
        setObj(i,j,cDta.getObj(i,j)); /* copy the entry */
  }

 /**. <pre>
  *=====================================================================
  * Method "addDta" (String-Version->QueueNr=0)
  * Datenzeile aus ungeprueften Werten speichern/hinzufuegen
  * ##addDta.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int addDta( /* add new string-object to queue 0 */
   String dta) /* new string to be added */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return addObj(0,dta); /* delegate to universal-version */
  }

 /**. <pre>
  *=====================================================================
  * Method "addObj"
  * Add/Store new object to queue
  * ##addObj.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int addObj( /* store (new) object to queue */
   int    iv, /* Number of datavector (0..?) as per documentation */
   Object cO) /* new object to be added/replaced */
   {
   /*-----------------------------------------------------------------*/
    TSArrList cL; /* current used List */
   /*=================================================================*/
    if(Dta==null) throw new /* Abbruch Programm mit Systemfehler */
      IllegalStateException(TSLogg.getMsg("Msg904","TSData.addObj()"));
    if(iv<0 || iv>=Dta.length) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","addObj",iv,1));
    cL = Dta[iv]; /* aktuellen Datenspeicher auswaehlen */
    if(cL==null) Dta[iv] = cL = new TSArrList(); /* create list */
    if(cL.add(cO)) return cL.size(); /* successfully added */
    return Integer.MIN_VALUE; /* action NOT successful (n.v.) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "cr$Obj"
  * Sicherstellen, dass Datenspeichers existiert/gueltig ist.
  * Anzzahl der Elemente pruefen und ggf. erweitern.
  * ##cr$Obj.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean cr$Obj( /* Datenspeicher anlegen */
   int iv,  /* Number of datavector (0..?) as per documentation */
   int nr)  /* notwendige Anzahl der Dateneintraege */
   {
   /*-----------------------------------------------------------------*/
    TSArrList cL; /* current used List */
   /*=================================================================*/
    if(Dta==null) return true; /* Kennung/Groesse liefern */
    if(iv<0 || iv>=Dta.length) return true; /* Argumentenfehler */
    cL = Dta[iv]; /* aktuellen Datenspeicher auswaehlen */
    if(cL==null) Dta[iv] = cL = new TSArrList(); /* create list */
    while(nr>cL.size()) cL.add(null); /* Zwischenwert(e) einfuegen */
    return false; /* Kein Fehler -- Liste ggf. erstellt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$Obj"
  * Array-Groesse des Datenspeichers liefern
  * ##get$Obj.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$Obj( /* Groesse Datenspeicher liefern */
   int iv)  /* Number of datavector (0..?) as per documentation */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Dta==null) return 0; /* Groesse liefern */
    if(iv<0) return Dta.length; /* Anzahl der Datenvektoren liefern */
    if(iv>=Dta.length) return Integer.MIN_VALUE; /* Index zu gross! */
    if(Dta[iv]==null) return 0; /* kein Element definiert */
    return Dta[iv].size(); /* aktuelle Array-Groesse liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getDta"
  * Datenzeile aus ungeprueften Werten liefern
  * ##getDta.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getDta( /* String-Datenzeile lesen */
   int iv, /* Number of datavector (0..?) as per documentation */
   int ix) /* Index der Datenzeile gemaess Dokumentation */
   {
   /*-----------------------------------------------------------------*/
    TSArrList cL; /* current used List */
    Object    cO; /* aktuelles Datenelement */
   /*=================================================================*/
    if(Dta==null) throw new /* Abbruch Programm mit Systemfehler */
      IllegalStateException(TSLogg.getMsg("Msg904","TSData.getDta()"));
    if(iv<0 || iv>=Dta.length) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","getDta",iv,1));
    if(ix<0) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","getDta",ix,2));
    cL = Dta[iv]; /* aktuellen Datenspeicher auswaehlen */
    if(cL==null) return null; /* Keine Element gespeichert */
    if(ix>=cL.size()) return null; /* Index ungueltig */
    cO = cL.get(ix); /* Objekt holen */
    if(cO==null) return null; /* Kein Element gespeichert */
    if(!(cO instanceof String)) throw new /* Abbruch mit Sys-Fehler */
      IllegalStateException(TSLogg.getMsg("Msg906","TSData.getDta()"));
    return (String)cO; /* Tabelleneintrag liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getDta" (String-Version->QueueNr=0)
  * Datenzeile aus ungeprueften Werten liefern
  * ##getDta.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getDta( /* String-Datenzeile lesen */
   int ix) /* Index der Datenzeile gemaess Dokumentation */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return getDta(0,ix); /* Basisversion benutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getFlt"
  * Datenzeile aus ungeprueften Werten liefern
  * ##getFlt.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double getFlt( /* Float-Datenzeile lesen (double) */
   int iv, /* Number of datavector (0..?) as per documentation */
   int ix) /* Index der Datenzeile gemaess Dokumentation */
   {
   /*-----------------------------------------------------------------*/
    TSArrList cL; /* current used List */
    Object    cO; /* aktuelles Datenelement */
   /*=================================================================*/
    if(Dta==null) throw new /* Abbruch Programm mit Systemfehler */
      IllegalStateException(TSLogg.getMsg("Msg904","TSData.getFlt()"));
    if(iv<0 || iv>=Dta.length) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","getFlt",iv,1));
    if(ix<0) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","getFlt",ix,2));
    cL = Dta[iv]; /* aktuellen Datenspeicher auswaehlen */
    if(cL==null) return Double.NaN; /* Keine Element gespeichert */
    if(ix>=cL.size()) return Double.NaN; /* Index ungueltig */
    cO = cL.get(ix); /* Objekt holen */
    if(cO==null) return Double.NaN; /* Kein Element gespeichert */
    if(!(cO instanceof Double)) throw new /* Abbruch mit Sys-Fehler */
      IllegalStateException(TSLogg.getMsg("Msg906","TSData.getFlt()"));
    return ((Double)cO).doubleValue(); /* Tabelleneintrag liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getInt"
  * AlLgemeiner Nummernspeicher lesen
  * Bei einem Argument <0 wird die aktuelle Array-Groesse geliefert
  * ##getInt.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getInt( /* Nummern-Tabelle lesen */
   int iv, /* Number of datavector (0..?) as per documentation */
   int ix) /* Index des Wertes gemaess Dokumentation */
   {
   /*-----------------------------------------------------------------*/
    TSArrList cL; /* current used List */
    Object    cO; /* aktuelles Datenelement */
   /*=================================================================*/
    if(Dta==null) throw new /* Abbruch Programm mit Systemfehler */
      IllegalStateException(TSLogg.getMsg("Msg904","TSData.getInt()"));
    if(iv<0 || iv>=Dta.length) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","getInt",iv,1));
    cL = Dta[iv]; /* aktuellen Datenspeicher auswaehlen */
    if(cL==null) return Integer.MIN_VALUE; /* Keine Elemente */
    if(ix<0) return cL.size(); /* Aktuelle Laenge des Arrays */
    if(ix>=cL.size()) return Integer.MIN_VALUE; /* Index zu gross! */
    cO = cL.get(ix); /* Objekt holen */
    if(cO==null) return Integer.MIN_VALUE; /* Keine Element gesp. */
    if(!(cO instanceof Integer)) throw new /* Abbruch mit Sys-fehler */
      IllegalStateException(TSLogg.getMsg("Msg906","TSData.getInt()"));
    return ((Integer)cO).intValue(); /* Tabelleneintrag liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getInt" (Int-Version->QueueNr=1)
  * AlLgemeiner Nummernspeicher lesen
  * Bei einem Argument <0 wird die aktuelle Array-Groesse geliefert
  * ##getInt.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getInt( /* Nummern-Tabelle lesen */
   int ix) /* Index des Wertes gemaess Dokumentation */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return getInt(1,ix); /* Basisversion benutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getObj"
  * Datenzeile aus ungeprueften Werten liefern
  * ##getObj.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Object getObj( /* Datenobjekt aus Queue lesen */
   int iv, /* Number of datavector (0..?) as per documentation */
   int ix) /* Index des Objektes gemaess Dokumentation */
   {
   /*-----------------------------------------------------------------*/
    TSArrList cL; /* current used List */
   /*=================================================================*/
    if(Dta==null) throw new /* Abbruch Programm mit Systemfehler */
      IllegalStateException(TSLogg.getMsg("Msg904","TSData.getObj()"));
    if(iv<0 || iv>=Dta.length) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","getObj",iv,1));
    if(ix<0) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","getObj",ix,2));
//    return Dta[iv].getObj(ix); /* return requested entry */
    cL = Dta[iv]; /* select current used List */
    if(cL==null) return null; /* Keine Element gespeichert */
    if(ix>=cL.size()) return null; /* requested index is invalid */
    return cL.get(ix); /* Objekt holen und liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getOpt"
  * Get object of type 'TSOpts' from selectable datavector.
  * Attention: selected datavector MUST be defined
  * ##getOpt.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSOpts getOpt( /* read 'TSOpts'-value from list */
   int iv, /* Number of datavector (0..?) as per documentation */
   int ix) /* Index of object within list due to documentation */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Dta==null) throw new /* terminate program with systemerror */
      IllegalStateException(TSLogg.getMsg("Msg904","TSData.getOpt()"));
    if(iv<0 || iv>=Dta.length) throw new /* terminate due to error */
      IllegalArgumentException(TSLogg.getMsg("Msg901","getOpt",iv,1));
    if(ix<0) throw new /* terminate program with systemerror */
      IllegalArgumentException(TSLogg.getMsg("Msg901","getOpt",ix,2));
    return Dta[iv].getOpt(ix); /* return requested entry */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getQue"
  * Datenarray fuer Management-Zwecke liefern
  * ##getQue.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSArrList getQue( /* return current Datavectorlist */
   int iv) /* Number of datavector (0..?) as per documentation */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Dta==null) throw new /* Abbruch Programm mit Systemfehler */
      IllegalStateException(TSLogg.getMsg("Msg904","TSData.getQue()"));
    if(iv<0 || iv>=Dta.length) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","getQue",iv,1));
    return Dta[iv]; /* return requested list */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDta"
  * Datenzeile aus ungeprueften Werten setzen
  * Daten werden AUF JEDEN FALL geschrieben (Loeschen moeglich)
  * ##setDta.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String setDta( /* String-Datenzeile setzen und lesen */
   int    iv,  /* Number of datavector (0..?) as per documentation */
   int    ix,  /* Index der Datenzeile gemaess Dokumentation */
   String dta) /* new entry for replace */
   {
   /*-----------------------------------------------------------------*/
    TSArrList cL; /* current used List */
    Object    cO; /* aktuelles Datenelement */
   /*=================================================================*/
    if(Dta==null) throw new /* Abbruch Programm mit Systemfehler */
      IllegalStateException(TSLogg.getMsg("Msg904","TSData.setDta()"));
    if(iv<0 || iv>=Dta.length) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","setDta",iv,1));
    if(ix<0) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","setDta",ix,2));
    cL = Dta[iv]; /* aktuellen Datenspeicher auswaehlen */
    if(cL==null) Dta[iv] = cL = new TSArrList(); /* Liste generieren */
//    return cL.setDta(ix,dta); /* replace/add requested entry */
    while(ix>=cL.size()) cL.add(null); /* insert dummy-entries */
//    try { return (String)cL.set(ix,dta); /* exchange and return */
//    } catch (ClassCastException e) { throw new IllegalStateException(
//      TSLogg.getMsg("Msg916","TSData.setDta()",e.toString()));
//      /* terminate program with systemerror due to illegal object */
//    } /* illegal type of object found */
    cO = cL.set(ix,dta); /* replace selected entry */
    if(cO==null) return null; /* Keine Element gespeichert */
    if(!(cO instanceof String)) throw new /* Abbruch mit Sys-fehler */
      IllegalStateException(TSLogg.getMsg("Msg906","TSData.setDta()"));
    return (String)cO; /* Tabelleneintrag liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDta" (String-Version->QueueNr=0)
  * Datenzeile aus ungeprueften Werten setzen
  * Daten werden AUF JEDEN FALL geschrieben (Loeschen moeglich)
  * ##setDta.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String setDta( /* String-Datenzeile setzen und lesen */
   int    ix,  /* Index der Datenzeile gemaess Dokumentation */
   String dta) /* neue Datenzeile */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return setDta(0,ix,dta); /* Basisversion benutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setFlt"
  * AlLgemeiner Nummernspeicher setzen
  * ##setFlt.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double setFlt( /* Float-Tabelle modif. (double) */
   int    iv, /* Number of datavector (0..?) as per documentation */
   int    ix, /* Index des Wertes gemaess Dokumentation */
   double w)  /* neuer Wert */
   {
   /*-----------------------------------------------------------------*/
    TSArrList cL; /* current used List */
    Object    cO; /* aktuelles Datenelement */
   /*=================================================================*/
    if(Dta==null) throw new /* Abbruch Programm mit Systemfehler */
      IllegalStateException(TSLogg.getMsg("Msg904","TSData.setFlt()"));
    if(iv<0 || iv>=Dta.length) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","setFlt",iv,1));
    if(ix<0) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","setFlt",ix,2));
    cL = Dta[iv]; /* aktuellen Datenspeicher auswaehlen */
    if(cL==null) Dta[iv] = cL = new TSArrList(); /* create list */
    while(ix>=cL.size()) cL.add(null); /* Zwischenwerte einfuegen */
    cO = cL.set(ix,new Double(w)); /* replace selected entry */
    if(cO==null) return Double.NaN; /* Keine Elemente gespeichert */
    if(!(cO instanceof Double)) throw new /* Abbruch mit Sys-fehler */
      IllegalStateException(TSLogg.getMsg("Msg906","TSData.setFlt()"));
    return ((Double)cO).doubleValue(); /* Tabelleneintrag liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setInt"
  * AlLgemeiner Nummernspeicher setzen
  * ##setInt.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int setInt( /* Nummern-Tabelle modifizieren */
   int iv, /* Number of datavector (0..?) as per documentation */
   int ix, /* Index des Wertes gemaess Dokumentation */
   int nr) /* neuer Wert */
   {
   /*-----------------------------------------------------------------*/
    TSArrList cL; /* current used List */
    Object    cO; /* aktuelles Datenelement */
   /*=================================================================*/
    if(Dta==null) throw new /* Abbruch Programm mit Systemfehler */
      IllegalStateException(TSLogg.getMsg("Msg904","TSData.setInt()"));
    if(iv<0 || iv>=Dta.length) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","setInt",iv,1));
    if(ix<0) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","setInt",ix,2));
    cL = Dta[iv]; /* aktuellen Datenspeicher auswaehlen */
    if(cL==null) Dta[iv] = cL = new TSArrList(); /* Liste generieren */
//    return cL.setInt(ix,nr); /* replace/add requested entry */
    while(ix>=cL.size()) cL.add(null); /* Zwischenwerte einfuegen */
    cO = cL.set(ix,new Integer(nr)); /* replace selected entry */
    if(cO==null) return Integer.MIN_VALUE; /* Keine Element gesp. */
    if(!(cO instanceof Integer)) throw new /* Abbruch mit Sys-fehler */
      IllegalStateException(TSLogg.getMsg("Msg906","TSData.setInt()"));
    return ((Integer)cO).intValue(); /* Tabelleneintrag liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setInt" (Int-Version->QueueNr=1)
  * AlLgemeiner Nummernspeicher setzen
  * ##setInt.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int setInt( /* Nummern-Tabelle modifizieren */
   int ix, /* Index des Wertes gemaess Dokumentation */
   int nr) /* neuer Wert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return setInt(1,ix,nr); /* Basisversion benutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setObj"
  * Datenzeile aus ungeprueften Werten setzen
  * Daten werden AUF JEDEN FALL geschrieben (Loeschen moeglich)
  * ##setObj.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Object setObj( /* Objekt-Definition setzen und lesen */
   int    iv, /* Number of datavector (0..?) as per documentation */
   int    ix, /* Index des Objektes gemaess Dokumentation */
   Object nO) /* neues Datenobjekt */
   {
   /*-----------------------------------------------------------------*/
    TSArrList cL; /* current used List */
   /*=================================================================*/
    if(Dta==null) throw new /* Abbruch Programm mit Systemfehler */
      IllegalStateException(TSLogg.getMsg("Msg904","TSData.setObj()"));
    if(iv<0 || iv>=Dta.length) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","setObj",iv,1));
    if(ix<0) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","setObj",ix,2));
    cL = Dta[iv]; /* aktuellen Datenspeicher auswaehlen */
    if(cL==null) Dta[iv] = cL = new TSArrList(); /* create list */
    while(ix>=cL.size()) cL.add(null); /* insert dummy-entries */
    return cL.set(ix,nO); /* replace object and return old entry */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSData (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String   rs;    /* result-String */
    int      i;     /* selects number of datavector */
    boolean  t1,t2; /* separator needed */
    Iterator cI;    /* iterator to datavector */
    Object   cO;    /* common object-reference */
   /*=================================================================*/
    if(Dta==null) rs = "TSData{0("; /* initialize result */
    else { /* valid datavector available -- process it */
      rs = "TSData{"+Dta.length+"("; /* initialize result */
      for(t1=false,i=0;i<Dta.length;i+=1) /* add data-lines */
        if(Dta[i]!=null) { /* valid datavector found -- add it */
          if(t1) rs += ","; /* insert separator if needed */
          rs += "" + i + "-" + Dta[i].size() + "(";
          cI = Dta[i].iterator(); /* retrieve all elements sequentially */
          t2 = false; /* preset: separator is not needed */
          while(cI.hasNext()) { /* check if more entries available */
            cO = cI.next(); /* get next object from datavector */
            if(t2) rs += ","; /* insert separator if needed */
            if(cO==null) rs += "<null>"; /* entry missing -- insert 'null' */
            else /* format entry and add it to result */
              if(cO instanceof Integer)
                rs += "Int(" + ((Integer)cO).intValue() + ")";
              else if(cO instanceof String)
                rs += "Str('" + (String)cO + "')";
              else if(cO instanceof TSOpts)
                rs += ((TSOpts)cO).toStr();
              else rs += cO.getClass().getName() + "()";
            t2 = true; /* separator is needed as from now */
          } /* process all entries of datavector */
          rs += ")"; /* terminate definition of entry */
          t1 = true; /* separator is needed as from now */
        } /* valid entry was formatted */
    } /* valid datavector was available */
    rs += ")-" + super.toStr() + "}";
    return rs; /* provide result-string */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSRefC -- Definition of a 'Reference-Control'-class
 *   This class controls references, which uses either numbers or
 *   addresses or both to connect class-entries together.
 *   It also contains a (second) independant ID-Number, so that these
 *   entries may be sorted.
 *   This number may also be used as an 'aditional information'.
 *
 *  Attention: This class may also be used for other reasons and
 *             therefore may not reference a single object. However,
 *             this is stated in the super-class if appropriate.
 * ##TSRefC (Eyecatcher)
 *======================================================================
 </pre>*/
class TSRefC implements Serializable,Comparable<TSRefC> { /* ref-ctl */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 31.07.2008";
 /*-------------------------------------------------------------------*/
  private int                   Ix;     /* Index of entry */
  private int                   Nr;     /* Number of reference-object */
  private Object                Adr;    /* Address-reference */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) create default-entry
  *=====================================================================
  </pre>*/
  protected TSRefC() /* define Connection-control-entry */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Ix  = Integer.MIN_VALUE; /* no number specified */
    Nr  = Integer.MIN_VALUE; /* no reference defined */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) create standard-entry
  *=====================================================================
  </pre>*/
  protected TSRefC( /* define Connection-control-entry */
   int c) /* Number(ID) of reference-object */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Ix  = Integer.MIN_VALUE; /* no number specified */
    Nr  = c;    /* insert number of reference-object */
    Adr = null; /* no Address-reference still exists */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create complete entry
  *=====================================================================
  </pre>*/
  protected TSRefC( /* define Connection-control-entry */
   int    c, /* Number(ID) of reference-object */
   Object o) /* Reference (adr) of object */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Ix  = Integer.MIN_VALUE; /* no number specified */
    Nr  = c; /* insert number of reference-object */
    Adr = o; /* insert address of reference-object */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (4) Create copy-entry from template.
  * Attention: The referenced object is NOT copied. ONLY the reference
  *          is transfered to the new TSRefC-object.
  *=====================================================================
  </pre>*/
  protected TSRefC( /* create Connection-control-entry from template */
   TSRefC cRef) /* template-definition */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Ix  = Integer.MIN_VALUE; /* value NOT copied */
    Nr  = cRef.Nr;  /* copy reference-NUMBER of object */
    Adr = cRef.Adr; /* copy reference-ADDRESS of object */
  }

 /**. <pre>
  *=====================================================================
  * Method "addNr"
  * Increment or Decrement reference-value (number).
  * Attention: if this method is used, ONLY positive numbers are
  *            supported, range is also checked.
  * This method return the result of the operation.
  * ##addNr.TSRefC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int addNr( /* modify number-reference */
   int inc) /* modification-value (+/-) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(inc<0) inc = Math.max(inc,-Nr); /* Summ cannot become negative */
    Nr += inc; /* compute new value */
    return Nr; /* return new value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgIx"
  * Get/update index of entry (aditional information).
  * Attention: positive AND negative numbers are supported.
  * ##chgIx.TSRefC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int chgIx( /* get/update index-value of entry */
   int ix) /* new value or 'Integer.MIN_VALUE' if no change */
   {
   /*-----------------------------------------------------------------*/
    int cIx; /* old value */
   /*=================================================================*/
    cIx = Ix;  /* save original value */
    if(ix!=Integer.MIN_VALUE) Ix = ix; /* set new value if requested */
    return cIx; /* return original value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgNr"
  * Modify or return reference-value (number).
  * Attention: positive AND negative numbers are supported.
  * ##chgNr.TSRefC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int chgNr( /* modify number-reference */
   int nr) /* new value or 'Integer.MIN_VALUE' if no change */
   {
   /*-----------------------------------------------------------------*/
    int cNr; /* old value */
   /*=================================================================*/
    cNr = Nr; /* store original value */
    if(nr!=Integer.MIN_VALUE) Nr = nr; /* insert new value if valid */
    return cNr; /* return original value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgRef"
  * Modify or return address-reference-value.
  * ##chgRef.TSRefC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Object chgRef( /* modify address-reference */
   Object o) /* new address of object */
   {
   /*-----------------------------------------------------------------*/
    Object cO; /* old value */
   /*=================================================================*/
    cO  = Adr; /* store original value */
    if(o!=null) Adr = o; /* insert new address if valid */
    return cO; /* return original value */
  }

 /**. <pre>
  *=====================================================================
  * Method "compareTo"
  * Method is used to sort Elements.
  * Attention: Name of this Methode is requested by Interface
  *           'Comparable'. Results need NOT be 0,1,-1 .
  * Note: This class has a natural ordering that is
  *       inconsistent with equals.
  * ##compareTo.TSRefC (Eyecatcher)
  *=====================================================================
  </pre>*/
  public final int compareTo( /* compare Definitions for sorting */
   TSRefC vR) /* compare-object */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Ix-vR.Ix; /* compare and return result */
  }

 /**. <pre>
  *=====================================================================
  * Method "cmpNr"
  * Compare reference-entries using 'NR'-definition.
  * ##cmpNr.TSRefC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int cmpNr( /* compare objects due to 'Nr' */
   TSRefC vR) /* compare-object */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Nr==Integer.MIN_VALUE) return Nr; /* return special */
    return Nr-vR.Nr; /* compare and return result */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class.
  * ##toStr.TSRefC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    if(Ix==Integer.MIN_VALUE) rs = "TSRefC{<NoV>";
    else rs = "TSRefC{" + Ix; /* create first part */
    if(Nr==Integer.MIN_VALUE) rs += ":(<NoV>";
    else rs += ":(" + Nr; /* create second part */
    if(Adr==null) rs += ",<null>)}"; /* invalid value */
    else rs += ",<set>)}"; /* valid reference exist */
    return rs; /* return all values of the object */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSSc -- Basisklasse fuer globale und lokale Sections
 * ##TSSc (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSc implements Serializable { /* Basis of Section-Definitions */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.04 14.09.2009";
 /*-------------------------------------------------------------------*/
  private int                   CntS;   /* Nutzung aus Datenbank */
  private int                   CntW;   /* Nutzung aus World-Datei */
 /** Used options (stored within mask of 'TSOpt'):
  *  12 -
  ======================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSc() /* allgemeine Section-Definition erstellen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    CntS = CntW = 0;   /* Section ist noch NICHT referenziert */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Method "getAng" (This dummy-method is normally overlayed)
  * Methode liefert immer 'NaN' wenn sie benutzt wird
  * ##getAng.TSSc (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected double getAng() { return Double.NaN; }

 /**. <pre>
  *=====================================================================
  * Method "getLR" (This dummy-method is normally overlayed)
  * ##getLR.TSSc (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected double getLR() { return Double.NaN; }

 /**. <pre>
  *=====================================================================
  * Method "getNr" (This dummy-method is normally overlayed)
  * ##getNr.TSSc (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getNr(boolean b) { return -9; }

 /**. <pre>
  *=====================================================================
  * Method "incCntS"
  * Increment reference-count of track-database for section-definitions
  * (using argument'0', reference-counter may be returned only)
  * ##incCntS.TSSc (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCntS( /* change reference-counter (Track) */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = CntS; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-CntS); /* must not become negative */
    CntS += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCntW"
  * Increment reference-count of world-files for section-definitions
  * (using argument'0', reference-counter may be returned only)
  * ##incCntW.TSSc (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCntW( /* change reference-counter (World) */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = CntW; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-CntW); /* must not become negative */
    CntW += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSc (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSSc{" + CntS + "-" + CntW + "}"; /* return class-values */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSSh -- Basisklasse fuer globale und lokale Shapes
 * ACHTUNG: Diese Klasse nutzt die Definitionen der Klasse 'TSOpts' zur
 *          Implementierung einer Optionenmaske. Deshalb wird diese
 *          Klasse von TSOpts abgeleitet. Von dieser Klasse wird auch
 *          das Interface 'Serializable' uebernommen.
 * ##TSSh (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSh extends TSOpts { /* Basisklasse fuer Shape-Definitionen */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.6.03 04.07.2011";
 /*-------------------------------------------------------------------*/
  private int                   CntS;   /* references from database */
  private int                   CntW;   /* references from worldfile */
  private int                   CntR;   /* overall reference-counter
    * number of sections connected to this shape via SectionIDX */
  private HashSet<TSSc>         ScL;    /* list of connected sections
    * Attention: Although a section may be used more than once within
    *            a shape/path-definition it is only inserted once.
    *            So, this list only contains types of sections, which
    *            are used within this shape. */
/**. <pre>
  * Used options (stored within mask of 'TSOpt'):
  *  12 -
  ======================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSh() /* create common Shape/Path-Definition */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    ScL  = new HashSet<TSSc>(); /* init List of sections */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Method "addSc"
  * Add section-reference (global/local) to section-list.
  * Method returns 'true' if the section is already in the list
  * ##addSc.TSSh (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean addSc( /* add section to section-list */
   TSSc cSc) /* current section-definition */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return !ScL.add(cSc); /* add it and return result */
  }

 /**. <pre>
  *=====================================================================
  * Method "getNr" (This dummy-method is normally overlayed)
  * ##getNr.TSSh (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getNr(boolean b) { return -9; }

 /**. <pre>
  *=====================================================================
  * Methode "getSc"
  * Get access to section-array using iterator
  * ##getSc.TSSh (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected Iterator getSc() /* get access to sections */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(ScL==null) return null; /* array is NOT available */
    return ScL.iterator(); /* return Iterator for sections */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCntR"
  * Increment overall-counter of section-references.
  * (using argument'0', reference-counter may be returned only)
  * ##incCntR.TSSh (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCntR( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = CntR; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-CntR); /* must not become negative */
    CntR += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCntS"
  * Increment reference-counter of track-database for shape-definitions
  * (using argument'0', reference-counter may be returned only)
  * ##incCntS.TSSh (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCntS( /* change reference-counter (Track) */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = CntS; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-CntS); /* must not become negative */
    CntS += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCntW"
  * Increment reference-counter of world-files for shape-definitions
  * (using argument'0', reference-counter may be returned only)
  * ##incCntW.TSSh (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCntW( /* change reference-counter (World) */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = CntW; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-CntW); /* must not become negative */
    CntW += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSh (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String         rs; /* result-string */
    Iterator<TSSc> ScI;
   /*=================================================================*/
    if(ScL==null) rs = "-(<null>)-";
    else if(ScL.size()==0) rs = "-(<none>)-";
    else { /* sectionlist available */
      rs = ""; /* initialize result (second part) */
      ScI = ScL.iterator(); /* get all elements */
      while(ScI.hasNext()) /* get all elements */
        rs += "," + ScI.next().getNr(true);
      rs = "-(" + rs.substring(1) + ")-"; /* set prefix */
    } /* sectionlist was available */
    rs = "TSSh{" + CntS + "-" + CntW + "-" + CntR +
          rs + super.toStr() + "}";
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSSect -- Definition eines Section-Eintrags
 * ##TSSect (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSect extends TSSc { /* Section-Definition */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.04 14.09.2009";
 /*-------------------------------------------------------------------*/
  private int                   Nr;     /* Number of section (index) */
  private int                   Nxt;    /* Distance to next entry */
  private double                ScW0;   /* Section-Value: Gauge(>0)
     * Gauge is changed to negative if 'waterscoop' is found! */
  private double                ScW1;   /* Section-Value:
     * Straight: Length of straight (>0)
     * Curve   : Radius of curve (>0)
     */
  private double                ScW2;   /* Section-Value:
     * Straight: 'Double.NaN' (used as marker)
     * Curve   : Angle of curve (+/-) (degree)
     */
  private double                ScW3;   /* Section-Value:
     * Skew-value if specified; else 'Double.NaN'
     */
  private TSSect                ScR;    /* connect section (target) */
/**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSect() /* Section-Definition erstellen */
   {
    super(); /* init parent class(es) (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr   = Integer.MIN_VALUE; /* Mark entry as 'invalid' */
    Nxt  = 1;          /* set distance to 'normal' */
    ScW0 = Double.NaN; /* mark value as 'not valid' */
    ScW1 = Double.NaN; /* mark value as 'not valid' */
    ScW2 = Double.NaN; /* mark value as 'not valid' */
    ScW3 = Double.NaN; /* mark value as 'not valid' */
    ScR  = this;       /* set default-connection (self-connect) */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSect( /* create 'straight'-version of new section */
   int    nr,  /* Number of section */
   double sw0, /* Gauge-value */
   double sw1) /* Length-value of 'straight' */
   {
    super(); /* init parent class(es) (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr   = nr; /* set section-index of new section-definition */
    Nxt  = 1;  /* set distance to 'normal' */
    ScW0 = sw0;        /* transfer gauge-value (must be positive) */
    ScW1 = sw1;        /* transfer length of section ('straight') */
    ScW2 = Double.NaN; /* mark section as 'straight' */
    ScW3 = Double.NaN; /* set 'no skew specified' */
    ScR  = this;       /* set default-connection (self-connect) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "$dIx"
  * Differerenz-Eintrag setzen/abfragen
  * ##$dIx.TSSect (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int $dIx( /* Differenz-Eintrag bearbeiten */
   int nIx) /* neuer Eintrag (falls gewuenscht) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nIx!=0) Nxt = nIx;   /* neuen Eintrag setzen */
    return Nxt; /* Wert liefern (Abfragen/erneut) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "$reNew"
  * neuen Section-Eintrag erstellen (Kopie) ohne Adress-Aenderung
  * ##$reNew.TSSect (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final void $reNew( /* neuen Section-Eintrag erstellen */
   int nr) /* neue Nummer des Eintrags */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr  = nr;   /* Section-Index eintragen */
    Nxt = 1;    /* naechster Eintrag ist normal entfernt */
    ScR = this; /* Default-Verkettung auf sich selbst */
    return;     /* alle anderen Werte werden NICHT veraendert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgWS"
  * Change current marker of 'waterscoop'-attribute
  * ##chgWS.TSSect (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean chgWS( /* change 'waterscoop'-marker */
   boolean set) /* set marker if 'true' (else 'reset') */
   {
   /*-----------------------------------------------------------------*/
    boolean m; /* previous marker */
   /*=================================================================*/
    if(Nr<0) return false; /* section not valid -- return default */
    m = (ScW0 < 0); /* get current marker and save it */
    ScW0 = Math.abs(ScW0); /* reset marker unconditionally */
    if(set) ScW0 = -ScW0; /* set marker if requested */
    return m; /* return prevoius 'waterscoop'-marker */
  }

 /**. <pre>
  *=====================================================================
  * Method "cmpDef"
  * Compare section-definitions.
  * Method returns 'true' if a match is NOT found (identical/similiar).
  * ##cmpDef.TSSect (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean cmpDef( /* compare section-Definitions */
   TSSect  cs, /* zu vergleichende Definition */
   boolean ex) /* Eintraege muessen EXAKT sein (nicht nur AEHNLICH) */
   {
   /*-----------------------------------------------------------------*/
    boolean st; /* current secion describes 'straight' */
   /*=================================================================*/
    if(Nr<0) return true; /* section is NOT valid -- no match */
    if(cs.Nr<0) return true; /* section is NOT valid -- no match */
    if(Math.abs(ScW0)!=Math.abs(cs.ScW0)) return true; /* no match */
    if(ScW1!=cs.ScW1) return true; /* length/radius do not match */
    if((st=Double.isNaN(ScW2))!=Double.isNaN(cs.ScW2)) return true;
      /* type of section (straight/curve) do NOT match */
    if(Double.isNaN(ScW3)!=Double.isNaN(cs.ScW3)) return true;
    if(st) return false; /* straight -- no further check (OK) */
    /* current section is a curve -- continue */
    if(ScW2==cs.ScW2) return false; /* angle OK -- section matches */
    /* no match -- similarity allowed? */
    if(ex) return true; /* similarity is NOT alloed -- do not check */
    if(ScW2!=(-cs.ScW2)) return true; /* no match */
    return false; /* Section-Definition is similiar */
  }

 /**. <pre>
  *=====================================================================
  * Method "getAng"
  * Method returns current angle of the section-definition.
  * Angle is converted into 'radian'
  * Method returns '0' if it is a 'straight-section'
  * Method returns 'NaN' if an error is found
  * ##getAng.TSSect (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double getAng() /* get angle of current section */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Nr<0) return Double.NaN; /* invalid section -- return marker */
    if(Double.isNaN(ScW2)) return 0.0; /* straight found */
    return Math.toRadians(ScW2); /* return converted angle-value */
  }

 /**. <pre>
  *=====================================================================
  * Method "getLR"
  * Method returns current Length/Radius of the section-definition
  * Method returns 'NaN' if an error is found
  * ##getLR.TSSect (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double getLR() /* get section-Definition */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Nr<0) return Double.NaN; /* invalid section -- return marker */
    return ScW1; /* return requested value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getNr"
  * neue/aktuelle Nummer der Section-Definition holen
  * ##getNr.TSSect (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getNr( /* aktuelle Section-Nummer holen */
   boolean orig) /* 'true' - originale Nr, 'false' - neue Nummer */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(orig) return Nr; /* original Section-Nummer liefern */
    if(ScR==null) return -4; /* Fehlerkennung: keine Zielnummer */
    return ScR.getNr(true);  /* neue Section-Nummer liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setCrv"
  * Change current section to 'curve'-section
  * ##setCrv.TSSect (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String setCrv( /* change section to curve */
   double sw0, /* Radius-value */
   double sw1) /* Angle used with new curve */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(!Double.isNaN(ScW3)) return "***setCrv";
    ScW1 = sw0;   /* transfer radius-value */
    ScW2 = sw1;   /* transfer angle and reset marker */
    return null; /* return without error-marker */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setScR"
  * Referenz zu zugeordnetem TSSect-Eintrag setzen
  * Achtung: Methode kann Zielreferenz loeschen (sc=='null')
  * ##setScR.TSSect (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSSect setScR( /* Referenz setzen und alte liefern */
   TSSect sc) /* neue TSSect-Definition */
   {
   /*-----------------------------------------------------------------*/
    TSSect cSc; /* aktueller Wert */
   /*=================================================================*/
    cSc = ScR; /* letzten Wert merken */
    ScR = sc;  /* neue Referenz (immer) setzen */
    return cSc; /* alte Referenz liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setSkew"
  * Add 'Skew'-value to current section
  * ##setSkew.TSSect (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String setSkew( /* add 'Skew'-value to section */
   double sv) /* 'Skew'-value to be set or 'Double.NaN' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Nr<0) return "***setSkew";
    ScW3 = sv; /* transfer skew-value */
    return null; /* and return without error-marker */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSect (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result of class-definition */
   /*=================================================================*/
    rs = "TSSect{" + Nr + "-" + Nxt; /* first part of class */
    if(Double.isNaN(ScW2)) rs += "-S(" + Math.abs(ScW0) + "," + ScW1;
    else rs += "-C(" + Math.abs(ScW0) + "," + ScW1 + "," + ScW2;
    if(Double.isNaN(ScW3)) rs += ")-(NaN"; /* no skew-value */
    else rs += ")-(" + ScW3; /* add current skew-value */
    rs += ")-'" + (ScW0<0); /* add waterscoop-marker */
    rs += "'-" + super.toStr() + "}--->";
    if(ScR==this) rs += "'this'"; /* Kennzeichen setzen */
    else if(ScR==null) rs += "'null'"; /* Kennzeichen setzen */
    else rs += ScR.toStr(); /* verkettete Definition anhaengen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSScC -- Definition eines Section-Verbindungs-Eintrags
 * Dieser Eintrag wird zur Herstellung der Zuordnung von
 *  Section-Definitionen (alt) zu Section-Definitionen (neu) benutzt.
 * Achtung: Maximal 16 IDENTISCHE Section-Definitionen sind moeglich.
 * ##TSScC (Eyecatcher)
 *======================================================================
 </pre>*/
class TSScC { /* Section-Verbindungs-Definition */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.3.01 03.11.2006";
  private static final int      mL = 16; /* max. Anz. d. Zuordnungen */
 /*-------------------------------------------------------------------*/
  private TSSect                Sc;     /* Section zum Anbinden */
  private int                   zIx;    /* aktuelle Zuordnung
    * Index auf Zuordnungsreferenzen (ScR)
    * erst relative, spaeter absolute Zuordnug der Section */
  private int                   cc;     /* Anzahl der Zuordnungen
    * Anzahl der Sections mit gleichen Definitionswerten (alt<->neu) */
  private TSSect[]              ScR;    /* Zuordungs-Referenzen */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSScC() /* Section-Verbindungs-Definition erstellen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    Sc  = null; /* keine Section-Referenz vorhanden */
    zIx = -1;   /* keine aktuelle Zuordung definiert (Kennung!) */
//    cc  = 0;    /* noch keine Zuordnungen vorhanden */
//    ScR = null; /* Zuordnungen werden nicht erfolgen */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSScC( /* Section-Verbindungs-Definition erstellen */
   TSSect sc) /* Section-Definition zum Anbinden */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Sc  = sc; /* Section-Referenz merken */
    zIx = -1; /* keine aktuelle Zuordung definiert (Kennung!) */
    cc  = 0;  /* noch keine Zuordnungen vorhanden */
    ScR = new TSSect[mL]; /* max. Anz. identische Referenzen moeglich */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "$dIx"
  * Differerenz-Eintrag der TSSect-Definition abfragen
  * ##$dIx.TSScC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int $dIx() /* Differenz-Eintrag abfragen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Sc==null) return 99999999; /* grosser Fehlerwert liefern */
    return Sc.$dIx(0); /* Wert abfragen und liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "check"
  * Korrelation eines Section-Eintrags pruefen
  * Falls section-Definitionen identisch sind, wird eine Zuordnung
  *   (eine von mehreren) eingetragen
  * ##check.TSScC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean check( /* Korrelation pruefen */
   TSSect cs) /* Sectiondefinition zum Vergleich */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Sc==null) return false; /* keine verkettete Definition */
      /* Verbindungseintrag enthaelt KEINE gueltige Referenz auf eine
       * Section-Definition (Systemfehler) */
    if(Sc.cmpDef(cs,true)) return false; /* nicht identisch -- Ende */
      /* Achtung: Eintraege muessen EXAKT uebereinstimmen */
    /* Eintragskombination gueltig -- registrieren */
    if(cc>=ScR.length) return false; /* max. Anz. Zuordnungen erreicht */
    ScR[cc] = cs; /* Referenz eintragen */
    cc += 1;      /* Zuordnung registrieren */
    return true; /* Ergebnis zurueckgeben */
  }

 /**. <pre>
  *=====================================================================
  * Methode "cmpNr"
  * Pruefen ob Eintrag einer gegebenen Section auch zugeordnet ist
  *   ja : relativer Zuordungsindex anpassen
  * Achtung: Antwort 'true' wenn NICHT zugeordnet
  * ##cmpNr.TSScC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean cmpNr( /* Zuordnung pruefen */
   int sc) /* Sectionnummer als Ziel */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    for(i=0;i<cc;i+=1) /* alle Eintraege pruefen */
      if(ScR[i].getNr(true)==sc) { /* Zuordnung ist vorhanden und
                                    * wurde jetzt auch referenziert */
        if(zIx<0) zIx = i; /* Index der ersten Zuordnung merken */
          /* Eine von mehereren moeglichen Zuordnungen wurde benutzt! */
        return false; /* Zuordnung passt -- Ende */
      } /* Zuordnung angesprochen */
    return true; /* keine passende Zuordnung gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "doConn"
  * Zuordnungs-Index (Connection) bearbeiten (relativer Index)
  * Zusatz: Abfrage 'isConn' ist integriert (cs==null)
  * ##doConn.TSScC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean doConn( /* Zuordnung bearbeiten */
   TSScC cs) /* Vorlage fuer Pruefung und Zuordnung / 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSSect cSc; /* referenzierte Section-Definition (TSSect) */
    int    d;   /* Differenzwert der Sectionnummern */
   /*=================================================================*/
    if(cs==null) { /* Kennung: Test gefordert */
      if(cc==0) return false; /* keine Zuordnung moeglich */
      if(zIx>=0) return false; /* Zuordnung bereits erfolgt */
      return true; /* Zuordnung muss noch erfolgen */
    } /* Zuordnungstest gefordert */
    /* Pruefen ob Eintrage zumindest aehnlich sind */
    if(Sc==null) return false; /* Fehler -- default melden */
      /* Verbindungseintrag enthaelt KEINE gueltige Referenz auf eine
       * Section-Definition (Systemfehler) */
    if(cs.cc==0) return false; /* keine Zuordnung moeglich */
    if(cs.zIx<0) return false; /* keine eindeutige Zuordnung vorhanden */
    if(cs.zIx>=cc) return false; /* Index kann nicht gesetzt werden */
    cSc = cs.ScR[cs.zIx]; /* zugeordneter Sectioneintrag */
    if(Sc.cmpDef(cSc,false)) return false;
      /* pruefen ob eigener Eintrag mit der anderen Verbindung aehnlich
       * ist. Wenn Ergebnis=='false' sind die Eintraege aehnlich.
       */
    d = cSc.getNr(true) - cs.Sc.getNr(true);
      /* Nummerndifferenz zwischen original und zugeordneter Section
       * im Vergleichseintrag berechnen */
    d += Sc.getNr(true); /* auf eigene Nummer anwenden */
    if(cmpNr(d)) return false; /* Nummer nicht in Liste -- Fehler */
    return true; /* Kennung 'OK' liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "doRef"
  * immer:Zuordnungs-Index gemaess eindeutiger Zuordnung korrigieren
  * true :Zuordnung zu neuem Eintrag durchfuehren. Verbundne Section-
  *        Definition wird neu gesetzt.
  * Achtung: Routine liefert Differenzeintrag
  * ##doRef.TSScC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int doRef( /* eindeutige Zuordnung registrieren */
   boolean set) /* Setzen der Verkettung gefordert ? */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(cc==1) zIx = 0; /* eindeutige Zuordnung in erstem Eintrag */
    if(set) /* Verkettung der Eintraege durchfuehren */
      if(zIx>=0) Sc.setScR(ScR[zIx]); /* Zuordnung permanent machen */
    return Sc.$dIx(0); /* Differenzeintrag liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getScR"
  * aktueller Section-Eintrag liefern
  * Methode wird zum 'Information-Hiding' benoetigt.
  * ##getScR.TSScC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSSect getScR() /* Section-Eintrag liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Sc; /* Section-Eintrag liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSScC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* Ergebnis-String */
    int    i;   /* intermediate value */
   /*=================================================================*/
    if(Sc==null) rs = "'null'"; /* Wert nicht gueltig */
    else rs = "" + Sc.getNr(true); /* Nummer (orig) der Section */
    rs += "-'" +zIx + "'-" + cc + "("; /* Vorlauf */
    for(i=0;i<cc;i+=1) { /* alle Referenzen */
      if(i>0) rs += ","; /* Trennzeichen anhaengen */
      if(ScR[i]==null) rs += "'null'"; /* Wert nicht gueltig */
      else rs += ScR[i].getNr(true); /* Nummer (orig) der Section */
    } /* alle Referenzen */
    rs += ")";
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSScIdx -- Definition eines Shape-Verbindungs-Eintrags
 *   Diese Klasse beschreibt einen SectionIdx-Eintrag, wie er in
 *   einer Shape-Definition (tsection.dat) verwendet wird.
 * ##TSScIdx (Eyecatcher)
 *======================================================================
 </pre>*/
class TSScIdx implements Serializable { /* Shape-Verbindungs-Def. */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.02 09.03.2009";
 /*-------------------------------------------------------------------*/
  private double                wy;     /* Winkel-Offset (ueber y) */
  private TSPos                 dP;     /* Offsets der Position */
  private TSSect[]              Sc;     /* Zuordungs-Referenzen */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSScIdx() /* Shape-Verbindungs-Definition erstellen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    wy = 0.0;  /* kein Winkel-Offset definiert */
//    dP = null; /* no offset-definition available */
    Sc = null; /* Zuordnungen werden nicht erfolgen */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) create standard-entry(global)
  *=====================================================================
  </pre>*/
  protected TSScIdx( /* create shape-'SectionIdx'-definition */
   int    c, /* number of section-references */
   double w, /* angle-offset (y) to the section-definitions */
   TSPos  p) /* offset-values (x,y,z) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    wy = w;             /* copy angle-offset */
    dP = p;             /* copy offset-definition */
    Sc = new TSSect[c]; /* create reference-storage */
    Arrays.fill(Sc,null); /* and invalidate all values */
  }

 /**. <pre>
  *=====================================================================
  * Method "adj"
  * Compute direction of offset-vector and add/sub it to/from
  *  current position
  * ##adj.TSScIdx (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean adj( /* adjust position */
   boolean m,  /* mode: true - 'add', false - 'sub' */
   TSQDir  cD, /* current direction of object */
   TSPos   cP) /* position will be modified due to current offset */
   {
   /*-----------------------------------------------------------------*/
    TSPos cPos; /* temporary Position */
   /*=================================================================*/
    if(wy!=0.0) return true; /* function NOT applicable */
    cPos = new TSPos(dP); /* create copy of offset-vector */
      /* DO NOT change value of 'dP' */
    cPos.mul(cD); /* create diff-vector */
    cP.modPos(m,cPos); /* add/sub difference to/from position */
    return false; /* no error found -- return successfull */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgScR"
  * liefern/modifizieren der verbundenen Section-Definition
  * ##chgScR.TSScIdx (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSSect chgScR( /* Section-Definition liefern */
   int    ix, /* Index der Definition */
   TSSect sc) /* Wert zum Eintragen oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSSect cSc; /* intermediate value */
   /*=================================================================*/
    if(Sc==null) return null; /* Daten nicht gefuellt */
    if(ix<0 || ix>=Sc.length) return null; /* Fehler kein Element */
    cSc = Sc[ix]; /* alten Wert merken */
    if(sc!=null) Sc[ix] = sc; /* neuen Wert eintragen falls gefordert */
    return cSc; /* alte/aktuelle Section-Definition liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Definitionszeile fuer 'tsection.dat' (global/lokal) erstellen
  * ##crDef.TSScIdx (Eyecatcher)
  *=====================================================================
  </pre>*/
//  protected final String crDef( /* Erzeugen Definition */
//   int nr) /* Pfad-Nummer fuer lokale 'tsection.dat' */
//   {
//   /*-----------------------------------------------------------------*/
//    String rs; /* Ergebnis-String */
//    int    i;  /* intermediate value */
//   /*=================================================================*/
//    if(Sc==null) return null; /* Erstellen nicht moeglich */
//    if(nr<0) rs = "    SectionIdx ( " + Sc.length + TSUtil.putFV(dx,0) +
//               TSUtil.putFV(dy,0) + TSUtil.putFV(dz,0) + TSUtil.putFV(wy,0);
//    else rs = "\tTrackPath ( " + nr + " " + Sc.length;
//      /* Definition fuer lokale Version erstellen */
//    for(i=0;i<Sc.length;i+=1) rs += " " + Sc[i].getNr(false);
//      /* alle Section-Nummern anhaengen */
//    rs += " )"; /* Abschluss hinzufuegen */
//    return rs; /* Ergebnis zurueckgeben */
//  }

 /**. <pre>
  *=====================================================================
  * Methode "get$Sc"
  * Anzahl der Elemente des Feldes 'Sc' liefern
  * ##get$Sc.TSScIdx (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$Sc() /* Laenge des Arrays liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Sc==null) return 0; /* Speicher nicht vorhanden */
    return Sc.length; /* Laenge des Section-Feldes */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSScIdx (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* Ergebnis-String */
    int    i;  /* intermediate value */
   /*=================================================================*/
    rs = "TSScIdx{" + dP.toStr() + "," + wy + ",";
    if(Sc==null) rs += "0('null'"; /* Wert nicht gueltig */
    else { /* Definitionen vorhanden */
      rs += Sc.length + "("; /* Beginn der Liste */
      for(i=0;i<Sc.length;i+=1) { /* alle Referenzen */
        if(i>0) rs += ","; /* Trennezichen einfuegen */
        rs += Sc[i].getNr(true); /* Nummer (orig) der Section */
      } /* alle section-Referenzen */
    } /* Section-Definition vorhanden */
    rs += ")}"; /* Abschluss hinzufuegen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSShape -- Definition eines Shape-Eintrags
 *   Diese Klasse beschreibt eine Shape-Definition, wie sie in
 *   der globalen 'tsection.dat' vorkommt.
 * ##TSShape (Eyecatcher)
 *======================================================================
 </pre>*/
class TSShape extends TSSh { /* Shape-Definition */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.04 04.09.2009";
 /*-------------------------------------------------------------------*/
  private int                   Nr;     /* number of shape (Index)
    * Normally, the number of shape equals the index of the shape
    * within table 'ShTab'. */
  private int                   Nxt;    /* distance to next entry */
  private int                   MRt;    /* number of main-route */
  private double                Clr;    /* clearance-distance */
  private TSPos[]               XPos;   /* crossover-point-definition */
  private TSScIdx[]             Sc;     /* sectionIdx-references
    * Ein Shape hat mehrere 'SectionIdx'-Definitionen, die durch das
    * Objekt 'TSScIdx' abgebildet werden. Dieses Objekt referenziert
    * dann mehrere Section-Definitionen. */
  private TSShape               Sh;     /* connected shape-definition */
  private String                Nme;    /* name of .s-File */
/**. <pre>
  * Shape-Options (stored in TSShape.TSSh.TSOpts ):
  *    0 - Error-marker (if entry is not created correctly)
  *    2 - RoadShape()
  *    3 - TunnelShape()
  *    5 - ManualJunctionShape()
  *    7 - CrossoverShape()
  *   16 - 'MainRoute' specified
  *   17 - 'Clearance' available
  *=====================================================================
  * Constructor: (1) create default-entry
  *=====================================================================
  </pre>*/
  protected TSShape() /* create default version of shape-entry */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr   = -1;   /* mark entry as 'invalid' */
    Nxt  = 1;    /* initialize distance to next entry with 'normal' */
//    MRt  = 0;    /* number of MainRoute is not set */
//    Clr  = 0.0;  /* Clearance is still not specified */
    Sc   = null; /* no SectionIDX-definitions connected */
    Sh   = this; /* connect target-shape (recursive) */
    XPos = null; /* no crossover-definitions available */
//    Nme  = null; /* filename of shape is not set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSShape( /* create standard shape-definition */
   int    nr,  /* number of shape */
   String nme) /* File-Name of Shape */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr  = nr;   /* insert Shape-Number */
    Nme = nme;  /* transfer Name of Shape */
  }

 /**. <pre>
  *=====================================================================
  * Methode "$dIx"
  * Differerenz-Eintrag setzen/abfragen
  * ##$dIx.TSShape (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int $dIx( /* Differenz-Eintrag bearbeiten */
   int nIx) /* neuer Eintrag (falls gewuenscht) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nIx!=0) Nxt = nIx; /* neuen Eintrag setzen */
    return Nxt; /* Wert liefern (Abfragen/erneut) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "$reNew"
  * neuen Shape-Eintrag erstellen (Kopie) ohne Adress-Aenderung
  * ##$reNew.TSShape (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final void $reNew( /* neuen Shape-Eintrag erstellen */
   int nr) /* neue Nummer des Eintrags */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr  = nr;   /* Shape-Nummer eintragen */
    Nxt = 1;    /* naechster Eintrag ist normal entfernt */
    Sh  = this; /* Default-Verkettung auf sich selbst */
    return;      /* alle anderen Werte werden NICHT veraendert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "check"
  * Korrelation eines Eintrags pruefen und ggf. durchfuehren
  * ##check.TSShape (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean check( /* Korrelation pruefen */
   TSShape cs, /* Shapedefinition zum Vergleich */
   TSScC[] st) /* Section-Tabelle fuer Pruefung */
   {
   /*-----------------------------------------------------------------*/
    TSScIdx si1,si2; /* SectionIdx-Definitionen */
    TSSect  csc;     /* Arbeitswert */
    int     i,j,t;   /* intermediate value */
   /*=================================================================*/
    Sh = null; /* keine Eigenverkettung mehr */
    if(cs==null) return false; /* kein Vergleichswert!!! */
    if(st==null) return false; /* kein Sectionvergleich */
    if(cs.Nme==null) return false; /* nicht identisch - Ende */
    if(!Nme.equalsIgnoreCase(cs.Nme.toLowerCase())) return false;
    if(Sc.length!=cs.Sc.length) return false; /* nicht id. - Ende */
    if(getMsk(65535)!=cs.getMsk(65535)) return false;
      /* nicht identisch (Maske = 0x0000FFFF) - Ende */

    for(i=0;i<Sc.length;i+=1) { /* alle SectionIdx-Def. pruefen */
      si1 = Sc[i]; si2 = cs.Sc[i]; /* aktuelle Referenzelemente */
      if(si1.get$Sc()!=si2.get$Sc()) return false; /* nicht identisch */
      for(j=0;j<si1.get$Sc();j+=1) { /* alle Sectionreferenzen pruefen */
        csc = si1.chgScR(j,null); /* Adresse der Section extrahieren */
        t = csc.getNr(true); /* Nummer der Section extrahieren */
        if(t>=st.length) return false; /* Fehler kann nicht auftreten */
        if(st[t]==null) return false; /* Fehler kann nicht auftreten */
        if(st[t].getScR()!=csc) return false; /* Systemfehler */
        if(st[t].cmpNr(si2.chgScR(j,null).getNr(true))) return false;
      } /* Alle Eintraege geprueft */
    } /* Alle Eintraege geprueft */
    /* korrekte Zuordnung gefunden */
    Sh = cs; /* Referenz eintragen und kennzeichnen */
    return true; /* Ergebnis zurueckgeben */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgScI"
  * liefern/modifizieren der verbundenen SectionIdx-Definitionen
  * ##chgScI.TSShape (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSScIdx chgScI( /* SectionIdx-Definition liefern */
   int     ix, /* Index der Definition */
   TSScIdx sc) /* Wert zum Eintragen oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSScIdx cSc; /* intermediate value */
   /*=================================================================*/
    if(Sc==null) return null; /* Daten nicht gefuellt */
    if(ix<0 || ix>=Sc.length) return null; /* Fehler kein Element */
    cSc = Sc[ix]; /* alten Wert merken */
    if(sc!=null) Sc[ix] = sc; /* neuen Wert eintragen falls gefordert */
    return cSc; /* alte/aktuelle SectionIdx-Definition liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkNme"
  * Name der Shape-Definition vergleichen (z.B mit W-Eintrag)
  * Methode liefert den Shape-Namen wenn die Namen NICHT gleich sind.
  * Wenn KEIN Shape-Name definiert ist, wird Fehlerkennung "" geliefert
  * ##chkNme.TSShape (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String chkNme( /* Shape-Namen vergleichen */
   String nme) /* Vergleichsnamen der Shape-Definition */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Nme==null) return ""; /* kein Vergleichswert!!! */
    if(nme==null) return Nme; /* kein Vergleich moeglich */
    if(Nme.equalsIgnoreCase(nme)) return null; /* OK */
    return Nme; /* Namen stimmen nicht -- gef. Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$ScI"
  * Anzahl der Elemente des Feldes 'Sc' liefern
  * --- Method is NOT referenced until now. (marked by 'XXX...') ---
  * ##get$ScI.TSShape (Eyecatcher)
  *=====================================================================
  </pre>*/
//  protected final int XXXget$ScI() /* Laenge des Arrays liefern */
//   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    if(Sc==null) return 0; /* Speicher nicht vorhanden */
//    return Sc.length; /* Laenge des Section-Feldes */
//  }

 /**. <pre>
  *=====================================================================
  * Methode "getNr"
  * neue/aktuelle Nummer der Shape-Definition holen
  * ##getNr.TSShape (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getNr( /* aktuelle Shape-Nummer holen */
   boolean orig) /* 'true' - originale Nr, 'false' - neue Nummer */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(orig) return Nr; /* original Shape-Nummer liefern */
    if(Sh==null) return -4; /* Fehlerkennung: keine Zielnummer */
    return Sh.getNr(true); /* neue Shape-Nummer liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setShR"
  * Referenz zu zugeordnetem TSShape-Eintrag setzen
  * Achtung: Methode kann Zielreferenz loeschen (sh=='null')
  * Liefern ohne Veraenderung: 'setShR(x=setShR(null));'
  * ##setShR.TSShape (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSShape setShR( /* Referenz setzen und alte liefern */
   TSShape sh) /* neue TSShape-Definition */
   {
   /*-----------------------------------------------------------------*/
    TSShape cSh; /* aktueller Wert */
   /*=================================================================*/
    cSh = Sh; /* letzten Wert merken */
    Sh  = sh;  /* neue Referenz (immer) setzen */
    return cSh; /* alte Referenz liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "setVal"
  * Set remaining definitions of the shape
  * ##setVal.TSShape (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final void setVal( /* set remaining definitions */
   int       mrt, /* number of Main-Route */
   double    clr, /* Clearance-Value */
   TSScIdx[] sd,  /* SectionIDX-Definitions */
   TSPos[]   xp)  /* Crossover-Points (if defined) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    MRt  = mrt; /* copy number of main-Route */
    Clr  = clr; /* set Clearance-value */
    Sc   = sd;  /* insert SectionIdx-entries */
    XPos = xp;  /* copy definition of crossover-points */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSShape (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-String */
    int    i;  /* intermediate value */
   /*=================================================================*/
    rs = "TSShape{" + Nr+"-"+Nxt+"-'"+((Nme==null)?"<Pfad>":Nme)+
          "'-("+MRt+","+Clr+")-";
    if(XPos==null) rs += "0[()"; /* keine Punkte */
    else { /* Crossover-Punkte definiert */
      rs += XPos.length + "["; /* Beginn der Ausgabe */
      for(i=0;i<XPos.length;i+=1) { /* alle Punkte */
        if(i>0) rs += ","; /* Trennzeichen einsetzen */
        if(XPos[i]==null) rs += "( 0.0,0.0,0.0 )";
        else rs += "( " + XPos[i].getPos(true) + " )";
      } /* alle Punkte aufbereiten */
    } /* Crossover-Punkte vorhanden */
    rs += "]-" + Sc.length + "(";
    for(i=0;i<Sc.length;i+=1) { /* alle Idx-Eintraege */
      if(i>0) rs += ","; /* Trennzeichen anhaengen */
      if(Sc[i]==null) rs +="'null'"; /* Dummy-Wert einsetzen */
      else rs+=Sc[i].toStr(); /* Definition anhaengen */
    } /* alle Idx-Eintraege */
    rs += ")-" + super.toStr() + "}--->";
    if(Sh==this) rs += "'this'"; /* Kennzeichen setzen */
    else if(Sh==null) rs += "'null'"; /* Kennzeichen setzen */
    else rs += Sh.toStr(); /* verkettete Definition anhaengen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSChain -- Definition einer einfachen sortierten Collection
 *  Die Methoden dieser Klasse gehen davon aus dass NICHT versucht
 *    wird, doppelte Eintraege (gemaess Sortierung) hinzuzufuegen.
 *  ACHTUNG: Diese Version ist auf TSWrld-Eintraege und deren
 *          Ableitungen fixiert
 *  Die verwalteten Klassen muessen folgende Methoden implementieren:
 *    boolean isEqual(TSWrld)   - Objekt schon eingestzt
 *    boolean isBefore(TSWrld)  - Objekt davor einzusetzen
 *    TSWrld chgChn(TSWrld)     - Weiterschalten naechstes Element
 *  Diese Klasse stellt EINEN Iteratoren zur Verfuegung, der die Elemente
 *    der Collection durchlaeuft. Dieser Iterator ist NICHT gegen
 *    Veraenderungen der zu Grunde liegenden Collection gesichert.
 *    Eventuelle Veraenderungen werden ohne Warnung durch den Iterator
 *    reflektiert.
 *  Es wird weiterhin EIN Iterator bereitgestellt, der die Elemente der
 *    Collection durchlaeuft, wie sie zum Zeitpunkt der Initialisierung
 *    vorlagen. Alle Aenderungen nach diesem Zeitpunkt sind in der
 *    Reihenfolge der Elemente nicht erkennbar.
 *    Achtung: Auch geloeschte Elemente werden ggf. geliefert.
 *
 * Achtung Implementierungstrick:
 *  Da eine Verkettung auf 'null' benoetigt wird und anderseits eine
 *    Verkettung auf sich selbst ungueltig ist, wird als Schalter fuer
 *    die Abfrage in der Methode 'chgChn()' die EIGENREFERENZ benutzt:
 *    'xxx.chgChn(...)' LIEFERT IMMER den aktuellen Verkettungswert
 *    'xxx.chgChn(xxx)' setzt KEINEN neuen Verkettungswert
 *    'xxx.chgChn(yyy)' setzt 'yyy' als neuen Verkettungswert
 * ##TSChain (Eyecatcher)
 *======================================================================
 </pre>*/
class TSChain implements Serializable { /* sortierte Collection */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 25.11.2008";
 /*-------------------------------------------------------------------*/
  private int                   Cnt;    /* Anzahl der Elemente */
  private TSWrld                Head;   /* Anfang der Kette */
  private TSWrld                Next;   /* Naechstes El. (Iterator) */
  private TSWrld[]              ItArr;  /* Array fuer Iterator */
  private int                   ItIx;   /* Index fuer Iterator */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSChain() /* sortierte Collection initialisieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    Cnt  = 0;     /* noch KEIN Element in der Kette */
//    Head = null;  /* noch kein Element vorhanden */
//    Next = null;  /* Iterator geloescht */
    ItArr = null; /* Iterator-Array ist noch nicht genutzt */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "add"
  * Neues Element SORTIERT in die Kette einsetzen
  * Methode liefert ggf. Fehlermeldung oder 'null'
  * Achtung: 'null'-Objekte werden NICHT unterstuetzt (Systemfehler)
  * ##add.TSChain (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String add( /* neues Element sortiert einsetzen */
   TSWrld cObj) /* vorgegebener neuer Eintrag */
   {
   /*-----------------------------------------------------------------*/
    TSWrld aObj,pObj; /* Arbeitswerte */
   /*=================================================================*/
    if(Cnt<0) throw new /* Objekt-Anzahl ist fehlerhaft */
      IllegalStateException(TSLogg.getMsg("Msg907","TSChain.add()",
        "Count="+Cnt)); /* Abbruch Programm mit Systemfehler */
    if(cObj==null) throw new /* Ungueltiges Element angegeben */
      IllegalArgumentException(TSLogg.getMsg("Msg901","TSChain.add()",
        "<null>",1)); /* Abbruch Programm mit Systemfehler */

    Cnt += 1; /* neues Element zaehlen */
    if(Cnt==1) { /* Kette war noch leer -- an erster Stelle einsetzen */
      Head = cObj; /* erstes Element in Kette eintragen */
      cObj.chgChn(null); /* Nachfolge-Element (Ende) einsetzen */
      return null; /* Element wurde erfolgreich eingefuegt */
    } /* Kette war noch leer */

    pObj = null; /* kein vorangehendes Element */
    aObj = Head; /* Anfang der kette sichern (Head!=null) */
    while(aObj.isBefore(cObj)) { /* neues Element liegt noch dahinter */
      pObj = aObj; /* Vorgaenger merken */
      aObj = aObj.chgChn(aObj); /* verkettetes Element holen */
      if(aObj==null) break; /* Ende der Kette erreicht */
    } /* Element-Position suchen */
    if(pObj==null) Head = cObj; /* neuer Kettenanfang */
      /* neues Element an erster Stelle ( Es gilt: aObj==Head) */
    else pObj.chgChn(cObj); /* Vorgaenger-Element korrekt verketten */
    cObj.chgChn(aObj); /* Nachfolge-Element einsetzen */
    return null; /* Element erfolgreich eingefuegt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isEqual"
  * pruefen ob ein gegebenes Element schon in der Liste vorhanden ist
  * Methode liefert 'true' falls schon in der Liste
  * ##isEqual.TSChain (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean isEqual( /* neues Element schon vorhanden? */
   TSWrld vObj) /* vorgegebener Vergleichs-Eintrag */
   {
   /*-----------------------------------------------------------------*/
    TSWrld aObj; /* Arbeitswerte */
   /*=================================================================*/
    if(Cnt==0) return false; /* Kette ist noch leer -- eindeutig */
    aObj = Head; /* Anfang der Kette sichern */
    do { /* alle Ketteneintraege pruefen */
      if(aObj.isEqual(vObj)) return true; /* Element schon vorhanden */
      aObj = aObj.chgChn(aObj); /* verkettetes Element abfragen */
    } while(aObj!=null); /* alle Verketteten Elemente pruefen */
    return false; /* Element ist noch NICHT eingefuegt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "next"
  * Iterator initialisieren/fortschreiben
  * Methode liefert 'null' falls 'kein weiteres Element' zutrifft.
  * Achtung: 'Next' zeigt immer auf 'null' oder
  *   'naechstes zu lieferndes Element'. Dadurch kann das
  *   'letzte gelieferte Element' umgehaengt werden, ohne ein Element
  *   NICHT zu liefern.
  * ACHTUNG: Aenderungen in der zu Grunde liegenden Reihenfolge der
  *          Elemente werden durch die Iteratoren BEACHTET. d.h. Es ist
  *          moeglich, dass ein Element MEHRMALS geliefert wird, wenn
  *          waehrend eines aktiven Iterators dieses Element nach hinten
  *          verschoben wird.
  * ##next.TSChain (Eyecatcher)
 *=====================================================================
 </pre>*/
  protected final TSWrld next( /* erstes/naechstes Element liefern */
   boolean mode) /* Kennung des Modus */
   {
   /*-----------------------------------------------------------------*/
    TSWrld cObj; /* Arbeitswert */
   /*=================================================================*/
    if(mode) { /* Iterator neu initialisieren */
      Next = Head; /* Ausgabe von vorne starten */
      if(Head!=null) Next = Head.chgChn(Head); /* naechstes */
      return Head; /* und aktuellen Zeiger liefern */
    } /* Init ist jetzt erfolgt */
    cObj = Next; /* naechstes Element zum liefern */
    if(cObj!=null) Next = cObj.chgChn(cObj);
      /* zeiger auf naechstes Element fortschreiben */
    return cObj; /* und aktuelles Element liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "list"
  * UNVERAENDERBARER Iterator initialisieren/fortschreiben
  * Argument: 'true'  - Iterator initialisieren und erstes Element liefern
  *           'false' - naechstes Element liefern
  * Methode liefert 'null' falls 'kein weiteres Element' vorhanden ist.
  * Falls der Iterator NICHT initialisiert ist wird mit Argument 'false'
  *   'null' geliefert.
  * Achtung: Beim Initialisieren des Iterators wird eine Kopie der
  *          Liste erzeugt und diese fuer weitere Elementlieferungen
  *          genutzt. Die Reihenfolge der Elemente kann deshalb
  *          veraendert werden, ohne dass dies in diesem Iterator
  *          erkannt wird.
  * ##list.TSChain (Eyecatcher)
 *=====================================================================
 </pre>*/
  protected final TSWrld list( /* erstes/naechstes Element liefern */
   boolean mode) /* Kennung des Modus */
   {
   /*-----------------------------------------------------------------*/
    int    i;    /* intermediate value */
    TSWrld cObj; /* Arbeitswerte */
   /*=================================================================*/
    if(mode) { /* Iterator initialisieren */
      ItArr = null; /* (altes) Iterator-Array deaktivieren */
      if(Cnt==0) return null; /* Liste leer -- kein weiteres Element */
      ItArr = new TSWrld[Cnt]; /* Neuen Zwischenspeicher erstellen */
      cObj = Head; /* Erstes Listenelement holen */
      for(i=0;i<Cnt;i+=1) { /* Zwischenliste fuellen */
        ItArr[i] = cObj; /* aktuelles Listenelement entragen */
        cObj = cObj.chgChn(cObj); /* naechstes Eelment holen */
      } /* Zwischenliste fuellen */
      ItIx = 0; /* Index des LETZTEN gelieferten Elementes */
      return Head; /* Erstes Element liefern */
    } /* Iterator wurde initialisiert */
    /* Modus = 'false' -- naechstes Element liefern */
    if(ItArr==null) return null; /* Iterator nicht initialisiert */
    ItIx += 1; /* auf naechstes, zu lieferndes Element weiterschalten */
    if(ItIx<ItArr.length) return ItArr[ItIx]; /* naechstes Element */
    /* Ende der Tabelle wurde erreicht */
    ItArr = null; /* Iterator-Array deaktivieren */
    return null; /* Kennzeichnen 'Ende der Iteration' */
  }

 /**. <pre>
  *=====================================================================
  * Methode "remove"
  * Ein Element gezielt aus der Kette entfernen
  * Methode liefert ggf. Fehlermeldung oder 'null'
  * Achtung: Eine Iteration wird NUR dann deaktiviert, wenn das
  *   'naechste zu liefernde' Element entfernt wird.
  * Achtung: 'null'-Objekte werden NICHT unterstuetzt (Systemfehler)
  * ##remove.TSChain (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String remove( /* Element aus der Kette entfernen */
   TSWrld cObj) /* Eintrag, der entfernt werden soll */
   {
   /*-----------------------------------------------------------------*/
    TSWrld aObj,pObj; /* Arbeitswerte */
   /*=================================================================*/
    if(cObj==null) throw new /* Ungueltiges Element angegeben */
      IllegalArgumentException(TSLogg.getMsg("Msg901","TSChain.remove()",
        "<null>",1)); /* Abbruch Programm mit Systemfehler */
    if(Cnt==0) return TSLogg.getKey("TSChnR01");
      /* Kein Element vorhanden -- Aktion nicht moeglich */
    if(Next==cObj) Next = null; /* Treffer -- Iterator abschalten */

    /* 'altes' Element suchen und aus Kette entfernen */
    pObj = null; /* kein vorangehendes Element */
    aObj = Head; /* Anfang der Kette sichern */
    do { /* alle Ketteneintraege pruefen */
      if(aObj==cObj) break; /* Element gefunden */
      pObj = aObj; /* Vorgaenger merken */
      aObj = aObj.chgChn(aObj); /* verkettetes Element abfragen */
    } while(aObj!=null); /* alle Verketteten Elemente pruefen */
    if(aObj==null) return TSLogg.getKey("TSChnR02"); /* nicht gefunden */
    /* gefundenes Element aus der Kette entfernen */
    aObj = cObj.chgChn(cObj); /* Nachfolge-Objekt holen */
    if(pObj==null) Head = aObj; /* neuer Kettenanfang */
      /* naechstes Element an erste Stelle setzen */
    else pObj.chgChn(aObj); /* neue Nachfolge setzen --Element ausketten */
    Cnt -= 1; /* entferntes Element registrieren */
    return null; /* Element erfolgreich entfernt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "replace"
  * ein Element aus der Kette entfernen und ein neues SORTIERT in die
  * Kette einsetzen
  * Methode liefert ggf. Fehlermeldung oder 'null'
  * Achtung: Eine Iteration wird NUR dann deaktiviert, wenn das
  *   'naechste zu liefernde' Element entfernt wird.
  * Achtung: 'null'-Objekte werden NICHT unterstuetzt (Systemfehler)
  * ##replace.TSChain (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String replace( /* Element in der Kette austauschen */
   TSWrld cObj, /* Eintrag, der entfernt werden soll */
   TSWrld nObj) /* Eintrag, der neu einsortiert werden muss */
   {
   /*-----------------------------------------------------------------*/
    String is; /* Arbeitswert */
   /*=================================================================*/
    if(cObj==null) throw new /* Ungueltiges Element angegeben */
      IllegalArgumentException(TSLogg.getMsg("Msg901","TSChain.replace()",
        "<null>",1)); /* Abbruch Programm mit Systemfehler */
    if(nObj==null) throw new /* Ungueltiges Element angegeben */
      IllegalArgumentException(TSLogg.getMsg("Msg901","TSChain.replace()",
        "<null>",2)); /* Abbruch Programm mit Systemfehler */

    if((is=remove(cObj))!=null) return is; /* Fehler beim Entfernen */
    return add(nObj); /* Element einfuegen und Ergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "reSort"
  * Element aus der Kette entfernen und SORTIERT neu in die Kette
  *   einsetzen
  * Methode liefert ggf. Fehlermeldung oder 'null'
  * Achtung: Eine Iteration wird NUR dann deaktiviert, wenn das
  *   'naechste zu liefernde' Element das spezifizierte (cObj) ist.
  * Achtung: 'null'-Objekte werden NICHT unterstuetzt (Systemfehler)
  * ##reSort.TSChain (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String reSort( /* Element in der Kette umhaengen */
   TSWrld cObj) /* Eintrag, der neu einsortiert werden muss */
   {
   /*-----------------------------------------------------------------*/
    String is; /* Arbeitswert */
   /*=================================================================*/
    if(cObj==null) throw new /* Ungueltiges Element angegeben */
      IllegalArgumentException(TSLogg.getMsg("Msg901","TSChain.reSort()",
        "<null>",1)); /* Abbruch Programm mit Systemfehler */

    if((is=remove(cObj))!=null) return is; /* Fehler beim Entfernen */
    return add(cObj); /* Element neu einfuegen und Ergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "size"
  * aktuelle Anzahl der Eintraege liefern
  * ##size.TSChain (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int size() /* Anzahl der Elemente liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Cnt; /* Anzahl zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSWrld -- common definition/methods for world-objects
 * Diese Klasse stellt gemeinsame Methoden zur Verfuegung, die fuer
 *  die Bearbeitung von World-Objekten notwendig sind. Ausserdem
 *  implementiert sie fuer 'NICHT gemeinsame Methoden' eine
 *  Dummy-Version, die einen Fehler erzeugt.
 * ACHTUNG: Diese Klasse nutzt die Definitionen der Klasse 'TSData' um
 *          einen allgemeinen Datenspeicher (String und Integer) sowie
 *          eine Optionenmaske zu implementieren. Deshalb wird diese
 *          Klasse von TSData abgeleitet. Von dieser Klasse wird auch
 *          das Interface 'Serializable' uebernommen, das diese von der
 *          Klasse 'TSOpts' geerbt hat.
 * ##TSWrld (Eyecatcher)
 *======================================================================
 </pre>*/
class TSWrld extends TSData { /* common methods of world-objects */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 22.07.2008";
 /*-------------------------------------------------------------------*/
                            /* no definitions of instance-variables */
/**. <pre>
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.xx(S) - (Queue) not used
  *   1.xx(I) - (Queue) not used
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSWrld() /* Basis-Definition erstellen */
   {
    super();  /* 'TSData' setzen (2 Arrays) (--- Restriktion ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Kopie-Eintrag erstellen (shallow-copy)
  * ACHTUNG: Es wird KEINE Kopie der Objekte erstellt, die in den
  *          in den einzelnen Datenarrays gespeichert sind!
  *=====================================================================
  </pre>*/
  protected TSWrld( /* Basis-Definition aus Vorlage erstellen */
   TSWrld cWrld) /* Datenvorlage */
   {
    super(cWrld); /* set TSOpts and copy all Queue-objects */
      /* init and copy 'TSData'-Definition (--- Restriktion ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Method "addTrI" (This dummy-method is normally overlayed)
  * ##addTrI.TSWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int addTrI(int i,int j) { return -9; }

 /**. <pre>
  *=====================================================================
  * Methode "chgChn" (Dummy (TSChain) fuer abgeleitete Klassen)
  * ##chgChn.TSWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSWrld chgChn(TSWrld o) { return null; }

 /**. <pre>
  *=====================================================================
  * Methode "chgDta"
  * Datenzeile aus ungeprueften Werten setzen/liefern
  * Daten NUR setzen wenn angegeben (Loeschen NICHT moeglich)
  * ##chgDta.TSWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgDta( /* Datenzeile (ungeprueft) setzen/lesen */
   int    ix,  /* Index der Datenzeile (= Typ des Eintrags) */
   String dta) /* neue Datenzeile */
   {
   /*-----------------------------------------------------------------*/
    String cDta; /* intermediate value */
   /*=================================================================*/
    if(ix<0) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","chgDta",ix,1));
    cDta = getDta(ix); /* alten Wert merken (ggf. 'null') */
    if(dta!=null) setDta(ix,dta); /* Wert vorhanden -- eintragen */
    return cDta; /* alten Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgTrI" (This dummy-method is normally overlayed)
  * ##chgTrI.TSWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC chgTrI(int i, int j, TSRefC r) { return null; }

 /**. <pre>
  *=====================================================================
  * Methode "chkMsk"
  * Definitions-/Optionen-Maske gemaess Definitionsnummer testen
  * Methode liefert 'true' wenn Definition/Option NICHT gesetzt ist!
  * ##chkMsk.TSWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkMsk( /* Definitionsnummer pruefen */
   int nr) /* Nummer des Definitions-Typs */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return !super.chkMsk(nr); /* liefern INVERTIERTEN Status */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkTrItmT" (This dummy-method is normally overlayed)
  * ##chkTrItmT.TSWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkTrItmT(int t) { return true; }

 /**. <pre>
  *=====================================================================
  * Method "crPos" (This dummy-method is normally overlayed)
  * ##crPos.TSWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSPos crPos() { return null; }

 /**. <pre>
  *=====================================================================
  * Method "crQDir" (This dummy-method is normally overlayed)
  * ##crQDir.TSWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQDir crQDir() { return null; }

 /**. <pre>
  *=====================================================================
  * Method "get$TrI" (This dummy-method is normally overlayed)
  * ##get$TrI.TSWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int get$TrI(int i) { return -9; }

 /**. <pre>
  *=====================================================================
  * Method "getVNrDef" (This dummy-method is normally overlayed)
  * Achtung: Im Gegensatz zu 'anderen' Dummy-Methoden liefert diese
  *          Methode den Defaultwert und kein Fehlerkennzeichen.
  * ##getVNrDef.TSWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getVNrDef() { return 15; } /* allgemeiner Default! */

 /**. <pre>
  *=====================================================================
  * Methode "isBefore" (Dummy (TSChain) fuer abgeleitete Klassen)
  * Attention: This method MUST BE overlayed to function correctly.
  * ##isBefore.TSWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isBefore(TSWrld o) { throw new /* Systemfehler */
    IllegalArgumentException(TSLogg.getMsg("Msg903","isBefore",0)); }

 /**. <pre>
  *=====================================================================
  * Methode "isEqual" (Dummy (TSChain) fuer abgeleitete Klassen)
  * Attention: This method MUST BE overlayed to function correctly.
  * ##isEqual.TSWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isEqual(TSWrld o) { throw new /* Systemfehler */
    IllegalArgumentException(TSLogg.getMsg("Msg903","isEqual",0)); }

 /**. <pre>
  *=====================================================================
  * Method "setDef" (This dummy-method is normally overlayed)
  * ##setDef.TSWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef(int i, int j)
   { return "*** Error: setDef("+i+","+j+") ***"; }

 /**. <pre>
  *=====================================================================
  * Method "setQDir" (This dummy-method is normally overlayed)
  * ##setQDir.TSWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQDir setQDir(TSQDir q)  { return null; }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSWrld (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSWrld{" + super.toStr() + "}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSRoute -- Route-definition (basis of all route-objects)
 * ##TSRoute (Eyecatcher)
 *======================================================================
 </pre>*/
class TSRoute extends TSData { /* Definition of Route-basis */
 /*-------------------------------------------------------------------*/
  protected static String        IdStr = " 3.6.05 02.12.2011";
  protected static final String[] envNme = { /* Environment-def's */
    "SpringClear","SpringRain","SpringSnow","SummerClear",
    "SummerRain","SummerSnow","AutumnClear","AutumnRain",
    "AutumnSnow","WinterClear","WinterRain","WinterSnow"};
 /*-------------------------------------------------------------------*/
  private String                 Nme;    /* (Verz.-)Name der Strecke */
  private String                 FNme;   /* Basis fuer Dateinamen */
  private String                 RteID;  /* Kennung der Strecke */
  private File                   Sys;    /* Systemdirectory */
  private File                   Rte;    /* Routedirectory */
  private File                   Dst;    /* Targetdirectory of route */
  private File                   gTSct;  /* reference to 'global tsection.dat' */
  private int                    ScN,ScU,ScO; /* Start Section-Indices */
  private int                    ShN,ShU,ShO; /* Start Path-Indices */
  private File                   Src;    /* Filename of '*.trk'-File */
  private String[]               Desc;   /* Route-'Description'-memory */
  private TSQPos                 Pos;    /* Position of 'RouteStart' */
  private TreeSet<TSTile>[]      TleT;   /* Tile-Definitions (hi/lo) */
  private TreeSet<TSQuad>        QDef;   /* sorted Structurequads */
  private TSScL[]                ScT;    /* Section-Tables (local) */
  private TSScL                  Sc;     /* Section-Chain (local) */
  private TSShL[]                ShT;    /* Shape-Tables (local) */
  private TSShL                  Sh;     /* Shape-Chain (local) */
  private ArrayList<TSTrNde>[]   TrNdeT; /* TrackNode-DB-Tables */
  private ArrayList<TSTrItm>[]   TrItmT; /* TrItem-Tables */
  private ArrayList<TSVector>[]  NdeT;   /* vector-node-tables of TrJunctions */
  private ArrayList<TSSigSh>     SigShT; /* SignalShape-List */
  private ArrayList<TSSigTyp>    SigTT;  /* SignalType-List */
  private ArrayList<TSSigLTx>    SigLTx; /* Signal-Light-Texture-Array */
  private ArrayList<TSSigLgt>    SigLT;  /* Signal-Light-Array */
  private LinkedHashMap<String,TSSigFle> SigFle; /* Filenames of Signal-Scripts */
  private TStType[]              tType;  /* Definition: 'ttype.dat' */
  private TreeMap<String,TSAct>  Act;    /* Activity-Definitions */
  private TreeMap<String,TSPath> Pat;    /* Path-Definitions */
  private TreeMap<String,TSSrv>  Srv;    /* Service-Definitions */
  private TreeMap<String,TSTrf>  Trf;    /* Traffic-Definitions */
  private TreeMap<String,TSTrain> Trn;   /* Train-Definitions (*.con,...) */
  private LinkedHashMap<String,TSObjLst> RefT; /* Route-reference-list */
/**. <pre>
  * Used options (stored within mask of 'TSOpt'):
  *   16 - 'Kilometer' is used
  *   17 - 'Miles' is used
  *   18 -
  *   31 - Reserved for temporary usage
  * Index-Definitionen aus 'TSData' (<queue>.<element>):
  *   0.00(S) - Name of route-definition (Name)
  *   0.01(S) - Schematische Routendarstellung (Graphic)
  *   0.02(S) - Ladebild der Route (LoadingScreen)
  *   0.03(S) - Value of 'DefaultSignalSMS'
  *   0.04(S) - Value of 'DefaultCrossingSMS'
  *   0.05(S) - Value of 'DefaultWaterTowerSMS'
  *   0.06(S) - Value of 'DefaultCoalTowerSMS'
  *   0.07(S) - Value of 'DefaultDieselTowerSMS'
  *   0.08(S) - -reserved-
  *   0.09(S) - -reserved-
  *   0.10(S) - ? (PassengerRuleSet)
  *   0.11(S) - ? (FreightRuleSet)
  *   0.12(S) - ? (SignalSet)
  *   0.13(S) - ? (GantrySet)
  *   0.14(S) - ? (TrackGauge)
  *   0.15(S) - ? (Era)
  *   0.16(S) - ? (DerailScale)
  *   0.17(S) - ? (TimetableTollerance)
  *   0.18(S) - ? (GravityScale)
  *   0.19(S) - -reserved-
  *   0.20(S) - Wetherdefinition of ? (Environment-?)
  *   0.21(S) - Wetherdefinition of ? (Environment-?)
  *   0.22(S) - Wetherdefinition of ? (Environment-?)
  *   0.23(S) - Wetherdefinition of ? (Environment-?)
  *   0.24(S) - Wetherdefinition of ? (Environment-?)
  *   0.25(S) - Wetherdefinition of ? (Environment-?)
  *   0.26(S) - Wetherdefinition of ? (Environment-?)
  *   0.27(S) - Wetherdefinition of ? (Environment-?)
  *   0.28(S) - Wetherdefinition of ? (Environment-?)
  *   0.29(S) - Wetherdefinition of ? (Environment-?)
  *   0.30(S) - Wetherdefinition of ? (Environment-?)
  *   0.31(S) - Wetherdefinition of ? (Environment-?)
  *   1.00(I) - expected number of Track-entries (*.tdb)
  *   1.01(I) - expected number of Road-entries (*.rdb)
  *   1.02(I) - Value of 'Electrified'
  *   1.03(I) - Value of 'Mountains'
  *   1.04(I) - Serial-Nummer *.tdb
  *   1.05(I) - Serial-Nummer *.rdb
  *   1.06(I) - File-ID-Versionnumber of *.trk-file
  *   1.07(I) - File-ID-Versionnumber of *.???-file
  *   1.08(I) - Terrain_Desc_Size (High)
  *   1.09(I) - Terrain_Desc_Size (Low)
  *   1.10(I) - Terrain-Depth (High)
  *   1.11(I) - Terrain-Depth (Low)
  *   1.12(I) - current (actual) number of Track-entries (*.tdb, volatile)
  *   1.13(I) - current (actual) number of Road-entries (*.rdb, volatile)
  *   2.00( ) - -reserved-
  *   2.01( ) - -reserved-
  *   2.02(F) - Wert fuer 'OverheadWireHeight'
  *   2.03(F) - Wert fuer 'SpeedLimit'
  *   2.04(F) - Wert fuer 'TerrainErrorScale'
  *   2.05(F) - Wert fuer 'MaxLineVoltage'
  *   2.06(F) - Wert fuer 'TempRestrictedSpeed'
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSRoute() /* create basics for route-definition */
   {
    super(3);  /* 'TSData' setzen (3 Arrays) (--- Restriktion ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    Desc   = null; /* no Route-description available */
    TleT   = null; /* no Tile-Definition available */
    ScT    = null; /* Section-Table (local) is not defined */
    ShT    = null; /* Shape-Table (local) is not defined */
    TrNdeT = null; /* TrackNode-DB-Tables are still not created */
    TrItmT = null; /* TrItem-Tabeles are still not available */
    NdeT   = null; /* TrJunctionNode-Tabeles (TSVector) are not defined */
    tType  = null; /* 'ttype.dat' is still not loaded */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSRoute( /* create basics for route-definition */
   String dn,  /* current name of route-definition */
   File   sys, /* System-directory */
   File   rte, /* Route-directory */
   File   dst, /* Route-target-directory */
   File   src) /* Reference to basic-definition ('*.trk'-file) */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    Nme   = FNme = new String(dn); /* transfer (copy of) name of route */
    RteID = "?"; /* current 'Route-ID' is still not known */
    Sys   = sys; /* transfer directory-definition (or 'null') */
    Rte   = rte; /* transfer directory-definition (or 'null') */
    Dst   = dst; /* transfer directory-definition (or 'null') */
    Src   = src; /* transfer file-reference to '*.trk'-file */
    gTSct = $bFle(Sys,"global/tsection.dat",3); /* create reference */
  }

 /**. <pre>
  *=====================================================================
  * Methode "$bFle"
  * - ONLY for internal use -
  * Dateireferenz zusammensetzen (buildFile)
  * Pruefoptionen: 2 - 'Verzeichnis' liegt vor (sonst 'Datei')
  *                3 - Datei/Verzeichnis muss existieren (sonst Fehler)
  *                5 - Verzeichnis NICHT erstellen wenn es fehlt
  * Methode wird in 'getfile(int)' genutzt
  * Achtung: Methode schreibt Vater-Verzeichnis nach 'RetVal'
  * ##$bFle.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  private static final File $bFle( /* Dateireferenz verbinden und liefern */
   File   dat,  /* Referenz auf die geforderten Basis-Definition */
   String cont, /* Fortsetzung der Beschreibung/des Namens */
   int    opt)  /* Pruefungsoptionen nach dem Primzahlverfahren */
   {
   /*-----------------------------------------------------------------*/
    File p; /* zu testendes Directory */
   /*=================================================================*/
    if(dat==null) return null; /* Basisdefinition nicht verfuegbar */
    dat = new File(dat,cont); /* neue File-Definition liefern */
    p = ((opt%2)==0) ? dat : dat.getParentFile(); /* Ueber-Verzeichnis holen */
    TSUtil.RetVal = p; /* Verzeichnisbeschreibung fuer Fehlerfall sichern */
    if(p.exists()) return dat;  /* Verzeichnis existiert -- OK */
    if((opt%3)==0) return null; /* Verzeichnis/Datei MUSS existieren */
    if((opt%5)==0) return dat;  /* Verzeichnis nicht erstellen */
    if(p.mkdirs()) return dat;  /* Verzeichnis erstellt */
    return null; /* Fehlerkennzeichen liefen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "$bFn"
  * - ONLY for internal use -
  * Dateinamen zusammensetzen (buildFileName)
  * Methode wird in 'getInfo(int)' genutzt
  * ##$bFn.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final String $bFn( /* Dateinamen verbinden und liefern */
   int    bd,   /* Nummer der geforderten Basis-Definition */
   String cont) /* Fortsetzung der Beschreibung/des Namens */
   {
   /*-----------------------------------------------------------------*/
    String[] DN = {"<sys>/","<rte>/","<dst>/"};
    File[]   Vz = {Sys,Rte,Dst};
   /*=================================================================*/
    if(bd<0 || bd>=Vz.length) throw new /* error within reference */
      IllegalArgumentException(TSLogg.getMsg("Msg901","TSRoute.$bFn()",bd,1));
    if(Vz[bd]==null) return DN[bd]+cont; /* Ergebnis wenn Basispfad fehlt */
    return (new File(Vz[bd],cont)).getAbsolutePath(); /* Dateipfad */
  }

 /**. <pre>
  *=====================================================================
  * Method "addList"
  * Add an Entry to the list of route-reference-object-classes
  * ##addList.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSObjLst addList( /* add a class-entry */
   String nS) /* new name of route-object-class */
   {
   /*-----------------------------------------------------------------*/
    String   cS; /* intermediate value */
    TSObjLst cL; /* current object-definition-class-List */
   /*=================================================================*/
    if(RefT==null) throw new /* systemerror -- terminate */
      IllegalStateException(TSLogg.getMsg("Msg904","TSRoute.addList()"));
    if(nS==null) return null; /* name not available -- do not use */
    cS = nS.toLowerCase(); /* create key-value */
    if(RefT.containsKey(cS)) return RefT.get(cS); /* already present */
    cL = new TSObjLst(nS); /* create new object-class-definition */
    RefT.put(cS,cL); /* and insert it to List */
    return cL; /* return new entry as success-signal */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addType"
  * ttype-Eintrag hinzufuegen, falls noch nicht vorhanden
  * Methode liefert Index falls schon vorhanden
  * Um die Indices konsistent zu halten MUSS der neue Eintrag hinten
  *  angehaengt werden
  * Wenn der Eintrag hinzugefuegt wurde, wird der NEGATIVE Index
  *  (modifiziert um '-1'(wegen 0)) geliefert
  * ##addType.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int addType( /* ttype-Eintrag pflegen */
   TStType cTp) /* hinzuzufuegender Eintrag */
   {
   /*-----------------------------------------------------------------*/
    TStType[] tTT; /* intermediate value */
    int       i,j; /* Arbeitsvariable(n) */
   /*=================================================================*/
    if(tType!=null) { /* Tabelle ist vorhanden -- vergleichen */
      j = tType.length; /* aktuelle Anzahl der Elemente */
      for(i=0;i<j;i+=1) /* alle Eintraege vergleichen */
        if(tType[i].equals(cTp)) return i; /* Treffer gefunden */
    } else j = 0; /* Eintraege wurden verglichen */
    tTT = new TStType[j+1]; /* neue Tabelle erstellen */
    for(i=0;i<j;i+=1) tTT[i] = tType[i]; /* Elemente kopieren */
    tTT[j] = cTp; /* neues Element hinzufuegen */
    tType = tTT; /* neue Tabelle aktivieren */
    cTp.chgNr(j); /* neue ID eintragen */
    return -j-1; /* Eintrag wurde hinten angefuegt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgQDf"
  * Globale Quadrantendefinitionen setzen oder veraendern
  * ##chgQDf.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TreeSet<TSQuad> chgQDf( /* Quadrandendefinition veraendern */
   TreeSet<TSQuad> ts) /* Quadrantendef's im 'TreeSet' oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TreeSet<TSQuad> cT; /* aktuelle Speicherstruktur */
   /*=================================================================*/
    cT = QDef; /* aktuelle Definitionen speichern */
    if(ts!=null) QDef = ts; /* neue Quadrantendefinitionen speichern */
    return cT; /* OK -- mit altem Wert zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgRte"
  * aktuelle 'Route-ID' veraendern oder liefern
  * ##chgRte.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgRte( /* aktuelle 'Route-ID' bearbeiten */
   String cid) /* neue 'Route-ID' oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    String cID; /* intermediate value */
   /*=================================================================*/
    cID = RteID; /* alten Wert sichern */
    if(cid!=null) RteID = cid; /* neuen Wert setzen */
    return cID; /* alte/aktuelle 'Route-ID' liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgScR"
  * lokale Section-Kette bearbeiten (eintragen/lesen)
  * ##chgScR.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSScL chgScR( /* Section-Kette modifizieren */
   TSScL sc) /* Definition lokale Sectionkette oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSScL cSc; /* intermediate value */
   /*=================================================================*/
    cSc = Sc; /* alten Wert sichern */
    if(sc!=null) Sc = sc; /* neue Verkettung eintragen */
    return cSc; /* alten/aktuellen Verkettungswert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgScT"
  * Eintrag in lokaler Section-Tabelle lesen / modifizieren
  * Index 'ix' ist absolut d.h.: ScU<=ix<ScO
  * ##chgScT.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSScL chgScT( /* Section-Tabelle modifizieren */
   int   ix, /* Index des Section-Eintrags (absolut) */
   TSScL sc) /* Definition Section-Eintrag (lokal) oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSScL cSc; /* intermediate value */
   /*=================================================================*/
    if(ScT==null) return null; /* Speicher existiert (noch) nicht */
    ix -= ScU; /* lokalen Index berechnen */
    if(ix<0 || ix>=ScT.length) return null; /* Indexfehler */
    cSc = ScT[ix]; /* alten Wert sichern */
    if(sc!=null) ScT[ix] = sc; /* neue Tabelleneintrag einsetzen */
    return cSc; /* alten/aktuellen Tabelleneintrag liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgShR"
  * lokale Pfad-Kette bearbeiten (eintragen/lesen)
  * ##chgShR.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSShL chgShR( /* Pfad-Kette modifizieren */
   TSShL sh) /* Pfad-Definition oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSShL cSh; /* intermediate value */
   /*=================================================================*/
    cSh = Sh; /* alten Wert sichern */
    if(sh!=null) Sh = sh; /* neue Verkettung eintragen */
    return cSh; /* alten/aktuellen Verkettungswert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgShT"
  * Eintrag in lokaler Shape-Tabelle lesen / modifizieren
  * Index 'ix' ist absolut d.h. ShU<=ix<ShO
  * ##chgShT.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSShL chgShT( /* Shape-Tabelle modifizieren */
   int   ix, /* Index des Shape-Eintrags (absolut) */
   TSShL sh) /* Definition Shape-Eintrag oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSShL cSh; /* intermediate value */
   /*=================================================================*/
    if(ShT==null) return null; /* Speicher existiert (noch) nicht */
    ix -= ShU; /* lokalen Index berechnen */
    if(ix<0 || ix>=ShT.length) return null; /* Indexfehler */
    cSh = ShT[ix]; /* alten Wert sichern */
    if(sh!=null) ShT[ix] = sh; /* neue Tabelleneintrag einsetzen */
    return cSh; /* alten/aktuellen Tabelleneintrag liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgType"
  * Tabelle der 'ttype'-Eintraege  lesen oder modifizieren
  * ##chgType.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TStType chgType( /* 'ttype'-Eintraege modifizieren */
   int     ix, /* Index des 'ttype'-Eintrags */
   TStType tt) /* Definition 'ttype'-Eintrags oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TStType cTp; /* intermediate value */
   /*=================================================================*/
    if(tType==null) return null; /* Speicher existiert noch nicht */
    if(ix<0 || ix>=tType.length) return null; /* Indexfehler */
    cTp = tType[ix]; /* alten Wert sichern */
    if(tt!=null) tType[ix] = tt; /* neue Tabelleneintrag einsetzen */
    return cTp; /* alten/aktuellen Tabelleneintrag liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkRte"
  * Check basic-definitions of route as specified within .trk-file
  * ##chkRte.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chkRte( /* check definitions of route-basics */
   TSData  ctl, /* controlblock of route */
   boolean chg) /* enable 'change value if illegal' if NOT set */
   {
   /*-----------------------------------------------------------------*/
     TSQuad cQ;    /* valid Quad for routestart-replacement */
     double d1,d2; /* overheadwire */
   /*=================================================================*/
    if(!Double.isNaN(d2=ctl.getFlt(4,0))) { /* new value available */
      if(Double.isNaN(d1=getFlt(2,0))) /* basis not specified */
        d1 = 0.0; /* set dummy-value for height */
      /* value of overheadwire must be modified */
      if(ctl.chkMsk(22)) d1 += d2; else d1 = d2; /* modify it */
        /* change value due to requested mode (add / set) */
      setFlt(2,0,d1); /* set new value again */
    } /* value of overheadwire has been modified */

    /* last check: 'RouteStart'-Definition */
    if(Pos==null) return TSLogg.getKey("chkRte01");
      /* 'RouteStart' not available  -- return message */
    if(Pos.fndWrld(QDef)!=null) return null; /* Quad-reference found */
    /* Quad-reference NOT found -- modify numbers ? */
    if(chg) return TSLogg.getMsg("chkRte02",Pos.getPos(3));
      /* do not modify -- return warning */
    cQ = QDef.first(); /* use first valid Quad-definition */
    Pos = new TSQPos(cQ,Pos); /* and create new reference */
    return null; /* no error found -- return successful */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkScT"
  * Index eines lokalen Section-Eintrags pruefen und Fehler melden
  * ##chkScT.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chkScT( /* Section-Eintrags-Index (lokal) pruefen */
   int    ix, /* Index des Section-Eintrags */
   double w1, /* Vergleichswert */
   double w2) /* Vergleichswert */
   {
   /*-----------------------------------------------------------------*/
    int i; /* Arbeitsvariable(n) */
   /*=================================================================*/
    if(ScT==null) return TSLogg.getKey("TSRteC01"); /* Tabelle fehlt */
    if(ix<ScU) return TSLogg.getMsg("TSRteC02",null,ix,ScU); /* Fehler */
    if(ix>=ScO) return TSLogg.getMsg("TSRteC03",null,ix,ScO);
    i = ix - ScU; /* lokalen Index berechnen */
    if(ScT[i]==null) return TSLogg.getMsg("TSRteC04",ix);
      /* referenzierte Section (fuer Pfad) nicht definiert */
    if(Double.isNaN(w1)) return null; /* no more checking */
    return ScT[i].chkDef(ix,w1,w2); /* Ergebnis der Pruefung melden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkShT"
  * Index eines lokalen Shape(Pfad)-Eintrags pruefen und Fehler melden
  * ##chkShT.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chkShT( /* Shape-Eintrags-Index (lokal) pruefen */
   int     ix, /* Index des Shape(Pfad)-Eintrags */
   boolean p)  /* nur einfache Prufung */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(ShT==null) return TSLogg.getKey("TSRteH01"); /* Tabelle fehlt */
    if(ix<ShU) return TSLogg.getMsg("TSRteH02",null,ix,ShU); /* Fehler */
    if(ix>=ShO) return TSLogg.getMsg("TSRteH03",null,ix,ShO);
    if(p) return null; /* Methode ohne Fehler beenden */
    if(ShT[ix-ShU]==null) return TSLogg.getMsg("TSRteH04",ix);
      /* referenzierter Pfad ist nicht definiert */
    return null; /* Methode ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinitionen des verschiedenen Typs fuer die Ausgabe erzeugen
  * ##crDef.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* create definition-line */
   int t) /* ID of output-line */
   {
   /*-----------------------------------------------------------------*/
    String is; /* result-string */
   /*=================================================================*/
    switch(t) { /* create outputline due to type */
      case(-2): /* return definition-line for 'RouteStart' */
        if(Pos==null) return null; /* 'RouteStart' not defined */
        is = Pos.getPos(4); /* get line from TSQPos-class */
        return "\tRouteStart ( " + is + " )"; /* return final line */
      case(-1): /* return definition-line for 'Filename' */
        is = FNme; /* get current 'Filename' */
        return "\tFileName ( " + TSUtil.modStr(is) + " )"; /* return final line */
      default: return null; /* return invalid line */
    } /* processing done */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDesc"
  * Create linedefinition 'Description' for output
  * ##crDesc.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDesc( /* create 'Description'-line */
   int n) /* current number of output-line */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    if(Desc==null) return null; /* no description available */
    if(n>=Desc.length) return null; /* no more lines available */
    if(n==0) rs = "\tDescription ( "; /* set first line */
    else rs = "\t\t"; /* set prefix for next line(s) */
    rs += TSUtil.addStr(Desc[n]); /* create valid string and add it */
    if((n+1)==Desc.length) rs += " )"; else rs += "+";
    return rs; /* return next description-line */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndSigL"
  * Signal-Light-Tabelle nach Eintrag durchsuchen
  * ##fndSigL.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSSigLgt fndSigL( /* Signal-Light-Eintrag suchen */
   String nme) /* Name des Light-Eintrags */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(SigLT==null) return null; /* Light-Tabelle nicht vorhanden */
    for(TSSigLgt cSgL : SigLT) { /* Weitere Definitionen vorhanden */
      if(cSgL==null) continue; /* E. nicht belegt (tritt nicht auf) */
      if(cSgL.chkNme(nme)) return cSgL; /* gefunden! */
    } /* alle definierten Eintraege testen */
    return null; /* Element nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndSigS"
  * SignalShape-Tabelle nach Eintrag gemaess Namen durchsuchen
  * ##fndSigS.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSSigSh fndSigS( /* Signal-Shape-Eintrag suchen */
   String nme) /* Name des Shape-Eintrags */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(SigShT==null) return null; /* SignalShape-Tab. nicht vorhanden */
    for(TSSigSh cSgS : SigShT) { /* Weitere Definitionen vorhanden */
      if(cSgS==null) continue; /* E. nicht belegt (tritt nicht auf) */
      if(cSgS.chkFNme(nme)) return cSgS; /* gefunden! */
    } /* alle definierten Eintraege testen */
    return null; /* Element nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndSigT"
  * SignalType-Tabelle nach Eintrag gemaess Namen durchsuchen
  * ##fndSigT.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSSigTyp fndSigT( /* Signal-Type-Eintrag suchen */
   String nme) /* Name des Typ-Eintrags */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(SigTT==null) return null; /* SignalType-Tab. nicht vorhanden */
    for(TSSigTyp cSgT : SigTT) { /* Weitere Definitionen vorhanden */
      if(cSgT==null) continue; /* E. nicht belegt (tritt nicht auf) */
      if(cSgT.chkNme(nme)) return cSgT; /* gefunden! */
    } /* alle definierten Eintraege testen */
    return null; /* Element nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndSigX"
  * Signal-LightTexture-Tabelle nach Eintrag durchsuchen
  * ##fndSigX.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSSigLTx fndSigX( /* Signal-LightTexture-Eintrag suchen */
   String nme) /* Name des LightTexture-Eintrags */
   {
   /*-----------------------------------------------------------------*/
    int      i,j;  /* Loop-Steuerung */
    TSSigLTx cSgX; /* aktuelles Tabellenelement */
   /*=================================================================*/
    if(SigLTx==null) return null; /* LightTexture-Tabelle fehlt */
    for(i=0,j=SigLTx.size();i<j;i+=1) { /* Alle Definitionen pruefen */
      cSgX = SigLTx.get(i); /* naechste SignalLightTexture-Definition */
      if(cSgX==null) continue; /* Eintrag nicht belegt */
      if(cSgX.chkNme(nme)) return cSgX; /* gefunden! */
    } /* alle definierten Eintraege testen */
    return null; /* Element nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndTrI"
  * TrItem-Datenbank nach einem bestimmten Element durchsuchen und
  *  Referenz registrieren falls gefunden
  * Methode liefert zusaetzlich das gefundene TrItem-Element um eine
  *   weitere Pruefung zu ermoeglichen
  * ##fndTrI.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSTrItm fndTrI( /* TrItem-Definition suchen */
   int    db, /* Nummer der Datenbank */
   TSRefC rf) /* Referenz zu TrItem-Access-Control */
   {
   /*-----------------------------------------------------------------*/
    TSTrItm           cIt; /* aktuelles Tabellenelement */
    Iterator<TSTrItm> cI;  /* Tabellen-Iterator fuer Items */
   /*=================================================================*/
    if(TrItmT==null) return null; /* TrItem-Tabelle nicht vorhanden */
    if(db<0 || db>1) return null; /* Tabellenindex falsch */
    if(TrItmT[db]==null) return null; /* Teiltabelle nicht gesetzt */
    if(rf==null) return null; /* Zugriffsteuerung nicht angegeben */
    cI = TrItmT[db].iterator(); /* Iterator fuer TrItem-Definitionen */
    db = rf.chgNr(Integer.MIN_VALUE); /* Nummer des gesuchten TrItems */
      /* Variable 'db' wird hier missbraucht, da nicht mehr benoetigt */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cIt = cI.next(); /* naechste TrItem-Definition */
      if(cIt==null) continue; /* TrItem-Definition fehlt */
      if(cIt.chkMsk(0)) continue; /* TrItem nicht gueltig */
      if(cIt.getNr(true)!=db) continue; /* noch nicht gefunden */
      /* zugeordnetes TrItem-Objekt wurde gefunden */
      rf.chgRef(cIt); /* Adresse des TrItems einsetzen */
      return cIt; /* gefundenes TrItem-Element liefern */
    } /* alle definierten Items durchsuchen */
    return null; /* Element nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndTrI" (2.Version)
  * in TrItem-Datenbank nach einem bestimmten Element suchen
  * Achtung: Methode ist auf die Schienendatenbank(0) beschraenkt!
  * ##fndTrI.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSTrItm fndTrI( /* TrItem-Definition suchen */
   int nr) /* Nummer(ID) des gesuchten TrItems */
   {
   /*-----------------------------------------------------------------*/
    TSTrItm           cIt; /* aktuelles Tabellenelement */
    Iterator<TSTrItm> cI;  /* Tabellen-Iterator fuer Items */
   /*=================================================================*/
    if(TrItmT==null) return null; /* TrItem-Tabelle nicht vorhanden */
    if(TrItmT[0]==null) return null; /* Teiltabelle nicht gesetzt */
    cI = TrItmT[0].iterator(); /* Iterator fuer TrItem-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cIt = cI.next(); /* naechste TrItem-Definition */
      if(cIt==null) continue; /* TrItem-Definition fehlt */
      if(cIt.chkMsk(0)) continue; /* TrItem nicht gueltig */
      if(cIt.getNr(true)==nr) return cIt; /* gefunden! */
    } /* alle definierten Items durchsuchen */
    return null; /* Element nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndWrld"
  * suchen und liefern der World-Definition (Quadrat-Definition)
  * wird fuer Activities und unbekannte UID's benutzt!
  * ##fndWrld.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQuad fndWrld( /* World-Definition liefern */
   int qx, /* zu testende X-Koordinate */
   int qz) /* zu testende Z-Koordinate */
   {
   /*-----------------------------------------------------------------*/
    TSQuad           cQDf; /* Arbeitswerte */
    Iterator<TSQuad> cI;   /* Iterator fuer 'TreeSet' */
   /*=================================================================*/
    if(qx==Integer.MIN_VALUE) return null; /* Wert ist nicht gueltig */
    if(qz==Integer.MIN_VALUE) return null; /* Wert ist nicht gueltig */
    cI = QDef.iterator(); /* Iterator fuer Quadrat-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cQDf = cI.next(); /* naechste Quadrat-Definition */
      if(cQDf.isWrld(qx,qz)) return cQDf; /* Welt gefunden */
    } /* alle Eintraege testen */
    return null; /* Fehlerkennung zurueckgeben */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$ObjL"
  * Get number of Entries within route-reference-object-list
  * ##get$ObjL.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$ObjL() /* get number of object-lists */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(RefT==null) return -4; /* Table is not defined */
    return RefT.size(); /* return number of entries */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$Sc"
  * Obere Grenze (alt/neu) der lokalen Sections holen
  * ##get$Sc.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int get$Sc( /* Obere Grenze der lokalen Sections liefern */
   boolean orig) /* 'true' - originale, 'false' - neue Grenze */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(ScT==null) return -4; /* Speicher nicht vorhanden */
    if(orig) return ScO; /* Grenze des Section-Feldes (original,alt) */
    return ScN; /* Grenze des Section-Feldes (neu) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$Sh"
  * Obere Grenze (alt/neu) der lokalen Shapes(Pfade) holen
  * ##get$Sh.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int get$Sh( /* Obere Grenze der lokalen Pfade liefern */
   boolean orig) /* 'true' - originale, 'false' - neue Grenze */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(ShT==null) return -4; /* Speicher nicht vorhanden */
    if(orig) return ShO; /* Grenze des Pfad-Feldes (original,alt) */
    return ShN; /* Grenze des Pfad-Feldes (neu) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$SgLT"
  * Groesse der Signal-Light-Tabelle liefern
  * ##get$SgLT.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int get$SgLT( /* Groesse der Signal-Light-Tabelle liefern */
   boolean err) /* 'true' ==> Fehlercode falls nicht existiert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(SigLT==null) return err?-3:0; /* Tab. noch nicht vorhanden */
    return SigLT.size(); /* Laenge der aktuellen Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$SgLTx"
  * Groesse der Signal-LightTexture-Tabelle liefern
  * ##get$SgLTx.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int get$SgLTx( /* Groesse der Signal-LTx-Tabelle liefern */
   boolean err) /* 'true' ==> Fehlercode falls nicht existiert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(SigLTx==null) return err?-3:0; /* Tab. noch nicht vorhanden */
    return SigLTx.size(); /* Laenge der aktuellen Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$SgS"
  * Groesse der Signal-Shape-Tabelle liefern
  * ##get$SgS.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int get$SgS( /* Groesse der Signal-Shape-Tabelle liefern */
   boolean err) /* 'true' ==> Fehlercode falls nicht existiert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(SigShT==null) return err?-3:0; /* Tab. noch nicht vorhanden */
    return SigShT.size(); /* Laenge der aktuellen Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$SgT"
  * Groesse der Signal-Typ-Tabelle liefern
  * ##get$SgT.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int get$SgT( /* Groesse der Signal-Typ-Tabelle liefern */
   boolean err) /* 'true' ==> Fehlercode falls nicht existiert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(SigTT==null) return err?-3:0; /* Tab. noch nicht vorhanden */
    return SigTT.size(); /* Laenge der aktuellen Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$Tle"
  * Get current number of tile-definitions with the table
  * ##get$Tle.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$Tle( /* get number of tile-definitions */
   int t) /* type of tile: 0 - Tiles, 1 - LO-Tiles */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(TleT==null) return -3; /* no tiles defined (error) */
    if(t<0 || t>1) return -2; /* type of tile is invalid */
    if(TleT[t]==null) return -1; /* table of tiles is not available */
    return TleT[t].size(); /* return number of tiles */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$TrI"
  * Anzahl der physischen Elemente in der aktuellen TrItem-Tabelle
  *  liefern.
  * Venn die Tabelle nicht vorhanden/definiert ist, wird ein Fehlercode
  * geliefert
  * ##get$TrI.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$TrI( /* TrItem-Tabelle abfragen/ersetzen */
   int db) /* Nummer der Datenbank (0,1) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(TrItmT==null) return -3; /* Speicher existiert noch nicht */
    if(db<0 || db>1) return -2; /* Indexfehler -- Ende */
    if(TrItmT[db]==null) return -1; /* Tabelle nicht gesetzt */
    return TrItmT[db].size(); /* Laenge der akt. Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$TrN"
  * Anzahl der physischen Elemente in der aktuellen TrackNode-Tabelle
  *  liefern.
  * Venn die Tabelle nicht vorhanden/definiert ist, wird ein Fehlercode
  * geliefert
  * ##get$TrN.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$TrN( /* TrackNode-Tabelle abfragen */
   int db) /* Nummer der Datenbank (0,1) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(TrNdeT==null) return -3; /* Speicher existiert noch nicht */
    if(db<0 || db>1) return -2; /* Indexfehler -- Ende */
    if(TrNdeT[db]==null) return -1; /* Tabelle nicht gesetzt */
    return TrNdeT[db].size(); /* Elementanzahl der Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getAct"
  * Activity-Tabelle liefern und ggf. erstellen
  * ##getAct.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TreeMap<String,TSAct> getAct() /* Activity-Tabelle liefern */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(Act==null) Act = new TreeMap<String,TSAct>(); /* erstellen */
    return Act; /* selektierte Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getFile"
  * Datei-/Verzeichnisreferenz gemaess Typ erstellen
  * Kennungbereiche:
  *      <0 : Systempfad-Referenzen
  *    0..2 : Sonderfall Basisreferenzen
  *   3..30 : Referenzen auf Basis Streckendefinition (Quelle)
  *  31..32 : Sonderfall
  *  33..60 : Referenzen auf Basis Streckendefinition (Ziel)
  *      99 : Sicherungsdatei in der Streckendefinition (Quelle)
  *  Streckenreferenzen: Ziel = Quelle + 30
  * ##getFile.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected File getFile( /* Dateireferenz erstellen und liefern */
   int t) /* Typ der geforderten File-Definition */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    switch(t) { /* Name gemaess Typ erstellen */
      case(-9): return TSRoute.$bFle(Sys,"Trains/Consists",6);
      case(-8): return TSRoute.$bFle(Sys,"Trains/TrainSet",6);
      case(-7): return TSRoute.$bFle(Sys,"utils/ffedit",6);
      case(-5): return TSRoute.$bFle(Sys,"Sound",6);
      case(-3): return TSRoute.$bFle(Sys,"global/Textures",6);
      case(-2): return TSRoute.$bFle(Sys,"global/Shapes",6);
//      case(-1): return TSRoute.$bFle(Sys,"global/tsection.dat",3);
      case(-1): return gTSct; /* predefined global 'tsection.dat' */
      case( 0): return Sys; /* Verzeichnis schon definiert */
      case( 1): return Rte; /* Streckenpfad (Quelle) */
      case( 2): return Dst; /* Streckenpfad (Ziel) 'newRoute' */
      case( 3): return TSRoute.$bFle(Rte,"tsection.dat",3);
      case( 4): return TSRoute.$bFle(Rte,"TD/td_idx.dat",1);
      case( 5): return TSRoute.$bFle(Rte,"TD/lo_td_idx.dat",1);
        /* Achtung: TD-Verzeichnis muss ggf. angelegt werden koennen */
      case( 6): return TSRoute.$bFle(Rte,FNme+".tdb",3);
      case( 7): return TSRoute.$bFle(Rte,FNme+".rdb",3);
      case( 8): return TSRoute.$bFle(Rte,FNme+".tit",3);
      case( 9): return TSRoute.$bFle(Rte,FNme+".rit",3);
      case(10): return TSRoute.$bFle(Rte,"World",6);
      case(11): return TSRoute.$bFle(Rte,"Activities",10);
      case(12): return TSRoute.$bFle(Rte,"Paths",10);
      case(13): return TSRoute.$bFle(Rte,"Services",10);
      case(14): return TSRoute.$bFle(Rte,"Traffic",10);
      case(15): return TSRoute.$bFle(Rte,"Shapes",6);
      case(16): return TSRoute.$bFle(Rte,"Sound",6);
      case(17): return TSRoute.$bFle(Rte,"Textures",6);
      case(18): return TSRoute.$bFle(Rte,"Tiles",6);
      case(19): return TSRoute.$bFle(Rte,"Lo_Tiles",6);
      case(20): return TSRoute.$bFle(Rte,"Terrtex",6);
      case(21): return TSRoute.$bFle(Rte,"SigCfg.dat",3);
      case(22): return TSRoute.$bFle(Rte,"ttype.dat",3);
      case(23): return TSRoute.$bFle(Rte,"SSource.dat",3);
      case(24): return TSRoute.$bFle(Rte,"CarSpawn.dat",3);
      case(25): return TSRoute.$bFle(Rte,"Forests.dat",3);
      case(26): return TSRoute.$bFle(Rte,"Gantry.dat",3);
      case(27): return TSRoute.$bFle(Rte,"Speedpost.dat",3);
      case(28): return TSRoute.$bFle(Rte,"Telepole.dat",3);
      case(29): return TSRoute.$bFle(Rte,FNme+".mkr",3);
      case(30): return TSRoute.$bFle(Rte,FNme+".ref",3);
      case(31): return Src; /* Dateidefinition schon definiert */
      case(32): return TSRoute.$bFle(Dst,Nme+".trk",1);
      case(33): return TSRoute.$bFle(Dst,"tsection.dat",1);
      case(34): return TSRoute.$bFle(Dst,"TD/td_idx.dat",1);
      case(35): return TSRoute.$bFle(Dst,"TD/lo_td_idx.dat",1);
      case(36): return TSRoute.$bFle(Dst,FNme+".tdb",1);
      case(37): return TSRoute.$bFle(Dst,FNme+".rdb",1);
      case(38): return TSRoute.$bFle(Dst,FNme+".tit",1);
      case(39): return TSRoute.$bFle(Dst,FNme+".rit",1);
      case(40): return TSRoute.$bFle(Dst,"World",2);
      case(41): return TSRoute.$bFle(Dst,"Activities",2);
      case(42): return TSRoute.$bFle(Dst,"Paths",2);
      case(43): return TSRoute.$bFle(Dst,"Services",2);
      case(44): return TSRoute.$bFle(Dst,"Traffic",2);
      case(45): return TSRoute.$bFle(Dst,"Shapes",2);
      case(46): return TSRoute.$bFle(Dst,"Sound",2);
      case(47): return TSRoute.$bFle(Dst,"Textures",2);
      case(48): return TSRoute.$bFle(Dst,"Tiles",2);
      case(49): return TSRoute.$bFle(Dst,"Lo_Tiles",2);
      case(50): return TSRoute.$bFle(Dst,"Terrtex",2);
      case(51): return TSRoute.$bFle(Dst,"SigCfg.dat",1);
      case(52): return TSRoute.$bFle(Dst,"TType.dat",1);
      case(53): return TSRoute.$bFle(Dst,"SSource.dat",1);
      case(54): return TSRoute.$bFle(Dst,"CarSpawn.dat",1);
      case(55): return TSRoute.$bFle(Dst,"Forests.dat",1);
      case(56): return TSRoute.$bFle(Dst,"Gantry.dat",1);
      case(57): return TSRoute.$bFle(Dst,"Speedpost.dat",1);
      case(58): return TSRoute.$bFle(Dst,"Telepole.dat",1);
      case(59): return TSRoute.$bFle(Dst,FNme+".mkr",1);
      case(60): return TSRoute.$bFle(Dst,FNme+".ref",1);
      case(99): return TSRoute.$bFle(Rte,"NewRoute/TSObjL.dat",1);
      default: return null; /* Referenz kann nicht erstellt werden */
    } /* gemaess Typkennung Dateireferenz erzeugen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getFile"
  * * verschiedene Dateireferenzen gemaess Typ zusammensetzen
  * ##getFile.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected File getFile( /* Namen erstellen und liefern */
   int    t,    /* Typ der geforderten Basis-Definition */
   String cont) /* Fortsetzung der Beschreibung/des Namens */
   {
   /*-----------------------------------------------------------------*/
    File dat; /* Dateireferenz (Basis) */
   /*=================================================================*/
    dat = getFile(t); /* Verzeichnisdefinition gemaess Typ erstellen */
    if(dat==null) return null; /* Basisdefinition nicht verfuegbar */
    dat = new File(dat,cont); /* neue File-Definition erstellen */
    return dat; /* geforderte File-Beschreibung liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getInfo"
  * verschiedene Namensdefinitionen gemaess Typ erstellen
  * Die Nummer des Typs ist exakt der Dateinummer aus 'getFile(<nr>)'
  *   zugeordnet.
  * Achtung: Es sind NUR die benoetigten Auswahlen realisiert!
  * Zuordnung der Indizes '$bFn()': 0 - Sys, 1 - Rte, 2 - Dst
  * ##getInfo.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getInfo( /* Namen erstellen und liefern */
   int t) /* Typ des geforderten Namen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* Name gemaess Typ erstellen */
      case( 0): if(Sys==null) return "<sys>"; /* Dummy */
        return Sys.getAbsolutePath();  /* Pfadname (gesamt) liefern */
      case( 1): if(Rte==null) return "<rte>"; /* Dummy */
        return Rte.getAbsolutePath(); /* Pfadname (gesamt) liefern */
      case( 2): return Nme; /* Routennamen liefern (Sonderfall) */
      case( 4): return $bFn(1,"TD/td_idx.dat");
      case( 5): return $bFn(1,"TD/lo_td_idx.dat");
      case(31): if(Src==null) return "<src>"; /* Dummy */
        return Src.getAbsolutePath(); /* Pfadname (gesamt) liefern */
      case(32): return $bFn(2,Nme+".trk");
      case(34): return $bFn(2,"TD/td_idx.dat");
      case(35): return $bFn(2,"TD/lo_td_idx.dat");
      case(40): return $bFn(2,"World");
      case(41): return $bFn(2,"Activities");
      case(42): return $bFn(2,"Paths");
      case(43): return $bFn(2,"Services");
      case(44): return $bFn(2,"Traffic");
      case(45): return $bFn(2,"Shapes");
      case(46): return $bFn(2,"Sound");
      case(47): return $bFn(2,"Textures");
      case(48): return $bFn(2,"Tiles");
      case(49): return $bFn(2,"Lo_Tiles");
      case(50): return $bFn(2,"Terrtex");
      case(99): return $bFn(2,"NewRoute/TSObjL.dat");
      default: throw new /* Name kann nicht erstellt werden */
        IllegalArgumentException(TSLogg.getMsg("Msg901","getInfo()",t,1));
    } /* gemaess Typkennung Name erzeugen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getIt"
  * 'Iterator' fuer Route-Tabellen erzeugen und liefern
  * ACHTUNG: Mit (*) gekennzeichnete Iteratoren werden NUR geliefert,
  *          wenn die Tabelle auch Elemente enthaelt. (size()>0)
  * Nummer der Kennung:
  *     0/1: TrackNode-Tabelle (Track/Road)
  *     2/3: TrItem-Tabelle (Track/Road)
  *     4/5: TrJunctionNode-Tabelle (Track/Road)
  *      10: Tile-Definitionen (hi)
  *      11: Tile-Definitionen (lo)
  *      12: Sortierte Strukturquadrate
  *      16: Activity-Definitionen
  *      17: Pfad-Definitionen
  *      18: Service-Definitionen
  *      19: Traffic-Definitionen
  *      20: Signalscript-Definitionen (*)
  *      21: Signalshape-Definitionen
  *      22: Signaltype-Definitionen
  *      23: SignalLight-Definitionen
  *      24: SignalLTexture-Definitionen
  *      25: Route-reference-object-Definitions
  *      26: Consist-Definitions
  * ##getIt.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected Iterator getIt( /* Iterator fuer Route-Tabellen liefern */
   int nr) /* Kennung der Tabelle */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* Tabelle gemaess Nummer auswaehlen */
      case(0): /* TrackNode-Tabelle [0] (TSTrNde) */
      case(1): /* TrackNode-Tabelle [1] (TSTrNde) */
        if(TrNdeT==null) return null; /* Tabelle nicht vorhanden */
        if(TrNdeT[nr]==null) return null; /* Tabelle nicht vorhanden */
        return TrNdeT[nr].iterator(); /* Iterator auf Daten liefern */
      case(2): /* TrItem-Tabelle [0] (TSTrItm) */
      case(3): /* TrItem-Tabelle [1] (TSTrItm) */
        if(TrItmT==null) return null; /* Tabelle nicht vorhanden */
        nr -= 2; /* Nummer anpassen */
        if(TrItmT[nr]==null) return null; /* Tabelle nicht vorhanden */
        if(TrItmT[nr].size()<=0) return null; /* Tabelle ist leer */
        return TrItmT[nr].iterator(); /* Iterator auf Daten liefern */
      case(4): /* TrJunctionNode-Tabelle [0] (TSVector) */
      case(5): /* TrJunctionNode-Tabelle [1] (TSVector) */
        if(NdeT==null) return null; /* Tabelle nicht vorhanden */
        nr -= 4; /* Nummer anpassen */
        if(NdeT[nr]==null) return null; /* Tabelle nicht vorhanden */
        return NdeT[nr].iterator(); /* Iterator auf Daten liefern */
      case(10): /* Tile-Definitionen (hi) [0] */
      case(11): /* Tile-Definitionen (lo) [1] */
        if(TleT==null) return null; /* Tabelle nicht vorhanden */
        nr -= 10; /* Nummer anpassen */
        if(TleT[nr]==null) return null; /* Tabelle nicht vorhanden */
        return TleT[nr].iterator(); /* Iterator auf Daten liefern */
      case(12): /* Tabelle der sortierten Strukturquadrate */
        if(QDef==null) return null; /* Tabelle nicht vorhanden */
        return QDef.iterator(); /* Iterator auf Daten liefern */
      case(16): /* Tabelle der Activity-Definitionen */
        if(Act==null) return null; /* Tabelle nicht vorhanden */
        return Act.values().iterator(); /* Iterator auf Daten liefern */
      case(17): /* Tabelle der Pfad-Definitionen */
        if(Pat==null) return null; /* Tabelle nicht vorhanden */
        return Pat.values().iterator(); /* Iterator auf Daten liefern */
      case(18): /* Tabelle der Service-Definitionen */
        if(Srv==null) return null; /* Tabelle nicht vorhanden */
        return Srv.values().iterator(); /* Iterator auf Daten liefern */
      case(19): /* Tabelle der Traffic-Definitionen */
        if(Trf==null) return null; /* Tabelle nicht vorhanden */
        return Trf.values().iterator(); /* Iterator auf Daten liefern */
      case(20): /* Tabelle der Signalscript-Definitionen */
        if(SigFle==null) return null; /* Tabelle nicht vorhanden */
        if(SigFle.size()<=0) return null; /* Tabelle ist leer -- Fehler */
        return SigFle.values().iterator(); /* Iterator auf Daten liefern */
      case(21): /* Tabelle der SignalShape-Definitionen */
        if(SigShT==null) return null; /* Tabelle nicht vorhanden */
        return SigShT.iterator(); /* Iterator auf Daten liefern */
      case(22): /* Tabelle der SignalType-Definitionen */
        if(SigTT==null) return null; /* Tabelle nicht vorhanden */
        return SigTT.iterator(); /* Iterator auf Daten liefern */
      case(23): /* Tabelle der SignalLight-Definitionen */
        if(SigLT==null) return null; /* Tabelle nicht vorhanden */
        return SigLT.iterator(); /* Iterator auf Daten liefern */
      case(24): /* Tabelle der SignalLTexture-Definitionen */
        if(SigLTx==null) return null; /* Tabelle nicht vorhanden */
        return SigLTx.iterator(); /* Iterator auf Daten liefern */
      case(25): /* List of route-reference-object-definitions */
        if(RefT==null) return null; /* Table is NOT available */
        return RefT.values().iterator(); /* return Iterator to data */
      case(26): /* get iterator to table of consist-definitions */
        if(Trn==null) return null; /* table is NOT available */
        return Trn.values().iterator(); /* return iterator to data-list */
    } /* alle gueltigen Tabellen bearbeiten */
    throw new IllegalArgumentException /* Abbruch mit Systemfehler */
      (TSLogg.getMsg("Msg902","TSRoute.getIt()",1,nr));
  }

 /**. <pre>
  *=====================================================================
  * Methode "getNdeT"
  * TrJunctionNode-Tabelle (TSVector) liefern und ggf. erstellen
  * Methode wird benutzt um Pfad-Definitionen zu korrelieren
  * ##getNdeT.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSVector> getNdeT( /* vector-nodes of TrJunctions */
   int db) /* Nummer der Datenbank (0,1) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(NdeT==null) return null; /* Node-Tabelle nicht vorhanden */
    if(db<0 || db>1) return null; /* Tabellenindex falsch */
    if(NdeT[db]==null) NdeT[db] = new ArrayList<TSVector>(100); /* erst. */
    return NdeT[db]; /* selektierte Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "getParm"
  * Returns parameter-list for modifying a Path-definition
  * ##getParm.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String[] getParm() /* get parameter-list */
   {
   /*-----------------------------------------------------------------*/
    String[] sL; /* String-list for result */
   /*=================================================================*/
    sL = new String[3]; /* create list */
    sL[0] = getInfo(2); /* insert parm #0: 'route-Name' */
    sL[1] = "../../Routes/"; /* insert parm #1: <fix value> */
    sL[2] = "../../Routes/"+sL[0]+"/"; /* insert parm #2 */
    return sL; /* return requested list of parameter */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getPath"
  * Path-Tabelle liefern und ggf. erstellen
  * ##getPath.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TreeMap<String,TSPath> getPath() /* Path-Tabelle liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pat==null) Pat = new TreeMap<String,TSPath>(); /* erstellen */
    return Pat; /* selektierte Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getQDf"
  * Aktuelle Tabelle fuer Quadranten liefern und ggf. (neu) erstellen
  * Wenn fuer 'cr' der Wert 'true' angegeben wird, wird die
  *   Tabelle neu angelegt. Dies erfolgt AUCH, wenn die Tabelle
  *   bereits existiert!
  * ##getQDf.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TreeSet<TSQuad> getQDf( /* Quadranten-Tabelle liefern */
   boolean cr) /* Tabelle (neu) anlegen wenn 'true' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(cr) QDef = new TreeSet<TSQuad>(); /* neu anlegen */
    return QDef; /* (neue) Quadranten-Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getServ"
  * Service-Tabelle liefern und ggf. erstellen
  * ##getServ.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TreeMap<String,TSSrv> getServ() /* Service-Tabelle liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Srv==null) Srv = new TreeMap<String,TSSrv>(); /* erstellen */
    return Srv; /* selektierte Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getSigF"
  * Aktuelles Array fuer Signalscrip-Files setzen oder liefern
  * Wenn der Speicher noch nicht angelegt ist, wird er ggf.ohne
  *   aktuelle Elemente generiert (falls gefordert)
  * ##getSigF.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected LinkedHashMap<String,TSSigFle> getSigF( /* Script-File-Tab */
   int c) /* Anzahl der Datei-Definitionen (init) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(SigFle==null && c>0) SigFle = new LinkedHashMap<String,TSSigFle>(c);
    return SigFle; /* (neue) Elemente-Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getSigL"
  * Aktuelles Array fuer SignalLights liefern und ggf. (neu) erstellen
  * Wenn fuer 'c' ein Wert 'groesser 0' angegeben wird, wird die
  *   Tabelle neu angelegt. Dies erfolgt AUCH, wenn die Tabelle
  *   bereits existiert!
  * ##getSigL.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSSigLgt> getSigL( /* SignalLight-Tabelle liefern */
   int c) /* erwartete Anzahl der Definitionen (init) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c>0) SigLT = new ArrayList<TSSigLgt>(c); /* neu anlegen */
    return SigLT; /* (neue) SignalLight-Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getSigLTx"
  * Aktuelles Array fuer SignalLTextures liefern und ggf. (neu) erstellen
  * Wenn fuer 'c' ein Wert 'groesser 0' angegeben wird, wird die
  *   Tabelle neu angelegt. Dies erfolgt AUCH, wenn die Tabelle
  *   bereits existiert!
  * ##getSigLTx.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSSigLTx> getSigLTx( /* SignalLTextures-Tabelle */
   int c) /* erwartete Anzahl der Definitionen (init) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c>0) SigLTx = new ArrayList<TSSigLTx>(c); /* neu anlegen */
    return SigLTx; /* (neue) SignalLTextures-Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getSigS"
  * Aktuelles Array fuer Signalshapes liefern und ggf. (neu) erstellen
  * Wenn fuer 'c' ein Wert 'groesser 0' angegeben wird, wird die
  *   Tabelle neu angelegt. Dies erfolgt AUCH, wenn die Tabelle
  *   bereits existiert!
  * ##getSigS.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSSigSh> getSigS( /* SignalShape-Tabelle liefern */
   int c) /* erwartete Anzahl der Definitionen (init) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c>0) SigShT = new ArrayList<TSSigSh>(c); /* neu anlegen */
    return SigShT; /* (neue) SignalShape-Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getSigT"
  * Aktuelles Array fuer Signaltypes liefern und ggf. (neu) erstellen
  * Wenn fuer 'c' ein Wert 'groesser 0' angegeben wird, wird die
  *   Tabelle neu angelegt. Dies erfolgt AUCH, wenn die Tabelle
  *   bereits existiert!
  * ##getSigT.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSSigTyp> getSigT( /* SignalType-Tabelle liefern */
   int c) /* erwartete Anzahl der Definitionen (init) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c>0) SigTT = new ArrayList<TSSigTyp>(c); /* neu anlegen */
    return SigTT; /* (neue) SignalType-Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTle"
  * Aktuelle Tabelle fuer Tile-Def's liefern und ggf. (neu) erstellen
  * Wenn fuer 'cr' der Wert 'true' angegeben wird, wird die
  *   Tabelle neu angelegt. Dies erfolgt AUCH, wenn die Tabelle
  *   bereits existiert!
  * ##getTle.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TreeSet<TSTile> getTle( /* Tile-Tabelle (Hi/Lo) liefern */
   int     t,  /* 0 - Tiles, 1 - LO-Tiles */
   boolean cr) /* Tabelle (neu) anlegen wenn 'true' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(TleT==null) return null; /* Systemfehler -- Tabellen fehlen */
    if(t<0 || t>1) return null; /* Fehlerkennung liefern */
    if(cr) TleT[t] = new TreeSet<TSTile>(); /* neu anlegen */
    return TleT[t]; /* (neue) Tile-Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTrf"
  * Traffic-Tabelle liefern und ggf. erstellen
  * ##getTrf.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TreeMap<String,TSTrf> getTrf() /* Traffic-Tabelle liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Trf==null) Trf = new TreeMap<String,TSTrf>(); /* erstellen */
    return Trf; /* selektierte Tabelle liefern */
  }
 /**. <pre>
  *=====================================================================
  * Methode "getTrain"
  * Return current table of train-definitions.
  * Create table if it is not already present.
  * ##getTrain.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TreeMap<String,TSTrain> getTrain() /* get Train-Table */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Trn==null) Trn = new TreeMap<String,TSTrain>(); /* create it */
    return Trn; /* return selected table */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTrI"
  * aktuelle (gesamte) TrItem-Tabelle liefern und ggf. anlegen
  * Methode wird benutzt um Reihenfolge der TrItems in der Tabelle
  *  pruefen oder globale Modifikationen vornehmen zu koennen
  * Im Fehlerfall wird 'null' geliefert
  * ##getTrI.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSTrItm> getTrI( /* TrItem-Tabelle liefern */
   int db, /* Nummer der Datenbank (0,1) */
   int c)  /* Geplante Anzahl der Datenbankelemente */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(TrItmT==null) return null; /* TrItem-Tabelle nicht vorhanden */
    if(db<0 || db>1) return null; /* Tabellenindex falsch */
    if(c>0) TrItmT[db] = new ArrayList<TSTrItm>(c); /* Anlegen gefordert */
    return TrItmT[db]; /* selektierte Tabelle liefern (ggf. 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTrN"
  * aktuelle (gesamte) TrackNode-Tabelle liefern und ggf. anlegen
  * Methode wird benutzt um Reihenfolge der Eintraege in der Tabelle
  *  pruefen oder globale Modifikationen vornehmen zu koennen
  * Im Fehlerfall wird 'null' geliefert
  * ##getTrN.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSTrNde> getTrN( /* TrackNode-Tabelle liefern */
   int db, /* Nummer der Datenbank (0,1) */
   int c)  /* Geplante Anzahl der Datenbankelemente */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(TrNdeT==null) return null; /* TrItem-Tabelle nicht vorhanden */
    if(db<0 || db>1) return null; /* Tabellenindex falsch */
    if(c>0) TrNdeT[db] = new ArrayList<TSTrNde>(c); /* Anlegen gefordert */
    return TrNdeT[db]; /* selektierte Tabelle liefern (ggf. 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isElec"
  * Information liefern, ob Strecke elektrifiziert ist
  * ##isElec.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isElec() /* Elektrifizierungsinformation */
   {
   /*-----------------------------------------------------------------*/
    int i; /* Arbeitswert(e) */
   /*=================================================================*/
    i = getInt(2); /* Speicher fuer Elektrifizierungsstatus holen */
    if(i==Integer.MIN_VALUE) return false; /* NICHT gesetzt */
    return i!=0; /* Elektrifizierungsstatus liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isScL"
  * Check index-range of a local section-entry.
  * Method returns 'true' if a local section-definition is referenced
  * ##isScL.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isScL( /* check index-range of local section */
   int ix) /* Index of local section-entry */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(ScT==null) return false; /* index cannot be 'local' */
    if(ix<ScU) return false; /* index is not a local section-index */
    if(ix>=ScO) return false; /* index is not a local section-index */
    return true; /* index refers to local section-entry */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isSigL"
  * Signal-Light-Definition aus der Tabelle heraussuchen
  * ##isSigL.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSSigLgt isSigL( /* Signal-Light-Eintrag heraussuchen */
   TSSigLgt vSgL) /* Name des Signal-Light-Eintrags (Vergleich) */
   {
   /*-----------------------------------------------------------------*/
    TSSigLgt           cSgL; /* aktuelles Tabellenelement */
    Iterator<TSSigLgt> cI;   /* Tabellen-Iterator fuer SignalLights */
   /*=================================================================*/
    if(SigLT==null) return null; /* Light-Tabelle nicht vorhanden */
    cI = SigLT.iterator(); /* Iterator fuer SignalLight-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cSgL = cI.next(); /* naechste SignalLight-Definition */
      if(cSgL==null) continue; /* E. nicht belegt (tritt nicht auf) */
      if(cSgL.equals(vSgL)) return cSgL; /* gefunden! */
    } /* alle definierten Eintraege testen */
    return null; /* Element nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isSigTx"
  * Signal-LightTexture-Definition aus der Tabelle heraussuchen
  * ##isSigTx.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSSigLTx isSigTx( /* LightTexture-Eintrag heraussuchen */
   TSSigLTx cSgTx) /* Name des Signal-LightTexture-Eintrags */
   {
   /*-----------------------------------------------------------------*/
    TSSigLTx           cSgX; /* aktuelles Tabellenelement */
    Iterator<TSSigLTx> cI;   /* Tabellen-Iterator fuer SignalLTextures */
   /*=================================================================*/
    if(SigLTx==null) return null; /* LightTexture-Tabelle fehlt */
    cI = SigLTx.iterator(); /* Iterator fuer SignalLightTextures */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cSgX = cI.next(); /* naechste SignalLTexture-Definition */
      if(cSgX==null) continue; /* Eintrag nicht belegt */
      if(cSgX.equals(cSgTx)) return cSgX; /* gefunden! */
    } /* alle definierten Eintraege testen */
    return null; /* Element nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "set$TSL"
  * obere Grenzen (neu) der lokalen 'tsection.dat' setzen
  * ##set$TSL.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean set$TSL( /* obere Grenzen von 'tsection.dat' */
   int sc, /* naechster Index des Section-Eintraege */
   int sh) /* naechster Index des Pfad-Eintraege */
   {
   /*-----------------------------------------------------------------*/
    boolean set; /* Werte schon gesetzt ? */
   /*=================================================================*/
    set = false; /* Annnehmen: Werte noch nicht gesetzt */
    if(ScN!=0) set = true; /* Wert WAR schon gesetzt */
    if(ShN!=0) set = true; /* Wert WAR schon gesetzt */
    ScN = sc; /* Obere Grenze der Eintraege merken */
    ShN = sh; /* Obere Grenze der Eintraege merken */
    return set; /* Methode mit return-code beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "set$Type"
  * Groesse der 'ttype.dat'-Tabelle setzen oder liefern
  * Tabelle wird NUR angelegt wenn c>0
  * ##set$Type.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int set$Type( /* 'ttype.dat'-Tabelle erstellen */
   int c) /* Anzahl der Elemente */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c>0) { /* Erstellen der Tabelle gefordert */
      tType = new TStType[c]; /* Speicher erstellen */
      Arrays.fill(tType,null); /* Tabelle initialisieren */
    } /* Sonderfall -- Tabelle erstellen */
    if(tType==null) return -3; /* Tabelle noch nicht vorhanden */
    return tType.length; /* Laenge der aktuellen Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setScT"
  * lokale Section-Tabelle erstellen
  * Achtung: Auch Tabelle der Laenge '0' ist moeglich fuer den Fall,
  *          dess die lokale 'tsection.dat' NICHT existiert
  * ##setScT.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setScT( /* Section-Tabelle (lokal) erstellen */
   int c, /* Anzahl der Eintraege */
   int b) /* Basis der Indices */
   {
   /*-----------------------------------------------------------------*/
    String w; /* Warnung */
   /*=================================================================*/
    if(c<0) return TSLogg.getMsg("TSRteC11",c); /* Tabellengroesse? */
    w = null; /* vorbesetzen: keine Warnung */
    if(ScT!=null) w = TSLogg.getKey("TSRteC12"); /* Alte Tab. ersetzt */
    if(b<1) w = TSLogg.getMsg("TSRteC13",b); /* Warnung setzen */
      /* Warnung: Groesse der globalen Tabelle falsch */
    ScU = b; /* Untere Grenze (Basis) der Tabelle merken */
    ScN = ScO = b + c; /* Obere Grenze der Tabelle merken */
    ScT = new TSScL[c]; /* neuen Section-Speicher (lokal) erstellen */
    Arrays.fill(ScT,null); /* Tabelle initialisieren */
    return w; /* Methode ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setShT"
  * lokale Shape(Pfad)-Tabelle erstellen
  * Achtung: Auch Tabelle der Laenge '0' ist moeglich fuer den Fall,
  *          dess die lokale 'tsection.dat' NICHT existiert
  * ##setShT.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setShT( /* Shape(Pfad)-Tabelle (lokal) erstellen */
   int c, /* Anzahl der Eintraege */
   int b) /* Basis der Indices */
   {
   /*-----------------------------------------------------------------*/
    String w; /* Warnung */
   /*=================================================================*/
    if(c<0) return TSLogg.getMsg("TSRteH11",c); /* Tabellengroesse? */
    w = null; /* vorbesetzen: keine Warnung */
    if(ShT!=null) w = TSLogg.getKey("TSRteH12"); /* Alte Tab. ersetzt */
    if(b<1) w = TSLogg.getMsg("TSRteH13",b); /* Warnung setzen */
      /* Warnung: Groesse der globalen Tabelle falsch */
    ShU = b; /* Untere Grenze (Basis) der Tabelle merken */
    ShN = ShO = b + c; /* Obere Grenze der Tabelle merken */
    ShT = new TSShL[c]; /* neuen Shape-Speicher (lokal) erstellen */
    Arrays.fill(ShT,null); /* Tabelle initialisieren */
    return w; /* Methode ohne Fehler beenden */
  }

 /**. <pre>
  *=====================================================================
  * Method "setTS"
  * Establish path to alternate 'tsection.dat'-file.
  * ##setTS.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected File setTS( /* set path to alternate 'tsection.dat' */
   String fn) /* relative path to target */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    gTSct = $bFle(Sys,fn,3); /* create new reference */
    if(gTSct==null) gTSct = $bFle(Sys,"global/tsection.dat",3);
      /* invalid reference -- establish default-value again */
    return gTSct; /* return absolute path to target */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setVal"
  * restliche Werte einsetzen und Definition aktivieren
  * !! Beachte auch Kommentare in der Wertzuweisung
  * ##setVal.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean setVal( /* insert new definitions */
   String   fn, /* Filename used for databases */
   String   ri, /* current Route-ID */
   String[] cD, /* current description of route */
   TSQPos   cP, /* position of 'RouteStart' or 'null' */
   boolean  km) /* 'metric system'? */
   {
   /*-----------------------------------------------------------------*/
                                              /* no local definitions */
   /*=================================================================*/
    FNme = new String(fn); /* set new filename (use copy) */
    RteID  = ri;           /* current 'Route-ID' */
    Desc   = cD;           /* transfer route-description */
    Pos    = cP;           /* set 'RouteStart'-position */

    if(km) this.setMsk(16); /* set measure to 'metric system' */
    else this.setMsk(17); /* set measure to 'miles used' */

    TleT    = new TreeSet[2]; /* Speicher fuer Tiles erstellen */
    TleT[0] = TleT[1] = null; /* Tile-Tabellen fehlen noch */
    TrNdeT  = new ArrayList[2]; /* Speicher fuer TrackNode-DB erst. */
    TrNdeT[0] = TrNdeT[1] = null; /* TrackNode-Tabellen fehlen noch */
    TrItmT  = new ArrayList[2]; /* Speicher fuer TrItem-Tabellen */
    TrItmT[0] = TrItmT[1] = null; /* Tabellen gibt es noch nicht */
    /* 'NdeT' enthaelt eine Liste der verketteten TSVectors aller aktiven
     * TrJunction-Nodes, da diese von anderen Elementen referenzert
     * werden (z.B. Pfaden)
     * Attention: ONLY (type>=3)-Nodes are included */
    NdeT = new ArrayList[2]; /* Liste fuer 'TrJunctionNode's erst. */
    NdeT[0] = NdeT[1] = null; /* Tabellen sind noch nicht erstellt */
      /* ACHTUNG: NdeT[1] enthaelt NIE Elemente (TSVector) , da Strassen
       * keine TrJunction-Nodes kennen */
    RefT = new LinkedHashMap<String,TSObjLst>(); /* create class-list for
             * route-reference-objects (Table '*.ref') */
    return false; /* Definition erfolgreich aktiviert */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String skip = TSUtil.CRLF + "                "; /* next line */
   /*-----------------------------------------------------------------*/
    String rs,is; /* result-string */
    int    i;     /* intermediate value */
   /*=================================================================*/
    rs = "Route{('"+ Nme + "','" + RteID + "','" + FNme;
    if(Desc==null) rs += "'),0(),("; /* keine Beschreibung */
    else { /* Beschreibungswerte definiert */
      rs += "'," + Desc.length + "("; /* Vorlauf setzen */
      for(i=0;i<Desc.length;i+=1) { /* alle Eintraege hinzufuegen */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        rs += TSUtil.CRLF + "                " + TSUtil.addStr(Desc[i]);
      } /* alle Definitionen hinzufuegen */
      rs += ")," + skip + "("; /* add separator */
    } /* Definitionen waren vorhanden */
    if(Pos==null) rs += "<null>"; else rs += Pos.toStr();
    rs += ")," + (chkMsk(16) ? "KM" : "MH");
    rs += "," + getInt(2) + "," + getInt(3) + "," + getFlt(2,2);
    rs += "," + getFlt(2,3) + "," + getFlt(2,4) + "," + getFlt(2,5);
    rs += "," + getFlt(2,6) + ",'" + getDta(5) + "','" + getDta(6);
    rs += "','" + getDta(7) + "','" + getDta(8) + "','" + getDta(9);
    rs += "'-" + super.toStr() + "}"; /* Abschluss hinzufuegen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSScL -- Definition eines LOKALEN Section-Eintrags
 * Diese Klasse dient zur Definition eines lokalen Section-Eintrags
 *  wie er in der LOKALEN 'tsection.dat' einer Route auftritt.
 * ##TSScL (Eyecatcher)
 *======================================================================
 </pre>*/
class TSScL extends TSSc { /* lokale Section-Definition */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.3.06 12.07.2007";
 /*-------------------------------------------------------------------*/
  private int                   Nr;     /* Nummer der Section (Index) */
  private int                   NrA;    /* Nummer der Section (alt) */
  private double                ScW0;   /* Section-Wert:
    * Gerade: Laenge der Geraden
    * Kurve : Winkel der Kurve (+/-) (Radiant)
    */
  private double                ScW1;   /* Section-Wert:
    * Gerade: '0' / Flag (<0)
    * Kurve : Radius der Kurve (>0)
    */
  private TSShL                 ShR;    /* Pfad referenziert Eintrag */
  private TSScL                 ScR;    /* naechster Eintrag in Kette */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSScL() /* lokale Section-Definition erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr   = NrA = -4;   /* Eintrag als ungueltig kennzeichnen */
//    ShR  = null;       /* Pfad-Eintrag referenziert (noch) nicht */
//    ScW0 = ScW1 = 0.0; /* Wert noch nicht belegt */
//    ScR  = null;       /* Noch keine Kette gebildet */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSScL( /* lokale Section-Definition erstellen */
   int    nr,  /* Nummer der Section */
   double sw0, /* Section-Wert */
   double sw1) /* Section-Wert */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr = NrA = nr;  /* Section-Index eintragen
      * Es werden BEIDE Nummern initialisiert, so dass Objekte, die
      * dieses Element referenzieren, auch beim SCHREIBEN einen
      * korrekten Wert erhalten 'getNr(false)'
      */
    ScW0 = sw0; /* Wert uebernehmen */
    ScW1 = sw1; /* Wert uebernehmen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgScR"
  * Referenzverkettung und Nummer der Sections berabeiten
  * ##chgScR.TSScL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSScL chgScR( /* Section-Verkettung modifizieren */
   TSScL sc) /* Definition neuer Section-Eintrag oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSScL cSc; /* intermediate value */
   /*=================================================================*/
    cSc = ScR; /* alten Wert sichern */
    if(sc!=null) ScR = sc; /* neue Verkettung einsetzen */
    return cSc; /* alten/aktuellen Verkettungswert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgShR"
  * Rueck-Verkettung zu uebergeordnetem Pfad bearbeiten
  * ##chgShR.TSScL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSShL chgShR( /* Pfad-Verkettung modifizieren */
   TSShL sh) /* Definition des zugeordneten Pfad-Eintrags oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSShL cSh; /* intermediate value */
   /*=================================================================*/
    cSh = ShR; /* alten Wert sichern */
    if(sh!=null) ShR = sh; /* neue Rueck-Verkettung einsetzen */
    return cSh; /* alten/aktuellen Verkettungswert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkDef"
  * Pruefen ob zwei LOKALE Definitionen identisch sind
  * Im Fehlerfall wird Fehlermeldung geliefert
  * ACHTUNG: Es wird ein Toleranzwert von '0.005' akzeptiert
  * ##chkDef.TSScL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chkDef( /* Definition ueberpruefen */
   int    nr, /* Nummer der Definition */
   double w0, /* erster Vergleichswert (Laenge/Winkel) */
   double w1) /* zweiter Vergleichswert (Kennung/Radius) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr!=NrA) return TSLogg.getMsg("TSScL101",null,nr,NrA);
    /* Flag/Radius zuerst pruefen, da dort Modus kodiert ist */
    if(w1!=0.0 && ScW1==0.0) return TSLogg.getMsg("TSScL102","Str",nr,NrA);
       /* Akt. Section ist 'Gerade' -- gelieferte Kurve passt nicht. */
    if(w1==0.0 && ScW1!=0.0) return TSLogg.getMsg("TSScL102","Crv",nr,NrA);
       /* Akt. Section ist 'Kurve' -- gelieferte Gerade passt nicht. */
    if(Math.abs(ScW1-w1)>0.005) /* Radius: Wert weicht zu weit ab. */
      return TSLogg.getMsg("TSScL103",""+ScW1,""+w1,NrA);
    if(Math.abs(ScW0-w0)>0.005) /* Laenge oder Winkel weicht ab. */
      return TSLogg.getMsg("TSScL104",""+ScW0,""+w0,NrA);
    return null; /* Ergebnis OK -- kein Fehler melden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Definitionszeile 'Section' fuer 'tsection.dat' erstellen
  * ##crDef.TSScL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Erzeugen Definition */
   int vl) /* Anzahl der Vorlauf-Zeichen */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    if(vl<0 || vl>TSUtil.mxLvl) vl = 2; /* Defaultwert setzen */
    rs = TSUtil.setPrfx(vl); /* Einschub setzen */
    rs += "SectionCurve ( " + (ScW1>0.0?"1":"0") +" ) " +
           Nr + TSUtil.putFV(ScW0,0) + TSUtil.putFV(ScW1,0);
    return rs; /* Ergebnis zurueckgeben */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getAng"
  * Aktuellen Winkelwert und Kennung der Section-Definition liefern
  * Winkel wird im Radiantenmass geliefert! (rad)
  * Methode liefert 'NaN' wenn ein Fehler vorliegt
  * Methode liefert '0' wenn Gerade vorliegt
  * ##getAng.TSScL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected double getAng() /* Section-Definition holen */
   {
   /*-----------------------------------------------------------------*/
    double v; /* intermediate value */
   /*=================================================================*/
    v = ScW1; /* Kennung uebertragen */
    if(v<0.0) return Double.NaN; /* Flag gesetzt -- Fehler */
    if(v>0.0) v = ScW0; /* Kurve liegt vor -- Winkel setzen */
    return v; /* aktuellen Winkel liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getLR"
  * Aktuelle Laenge/Radius der Section-Definition liefern
  * Methode liefert 'NaN' wenn ein Fehler vorliegt
  * ##getLR.TSScL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected double getLR() /* Section-Definition holen */
   {
   /*-----------------------------------------------------------------*/
    double v; /* intermediate value */
   /*=================================================================*/
    v = ScW1; /* Kennung uebertragen */
    if(v<0.0) return Double.NaN; /* Flag gesetzt -- Fehler */
    if(v==0.0) v = ScW0; /* Gerade liegt vor -- Laenge setzen */
    return v; /* aktuell geforderten Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getNr"
  * neue/aktuelle Nummer der Section-Definition (lokal) holen
  * ##getNr.TSScL (Eyecatcher)
  *=====================================================================
  </pre>*/
 protected int getNr( /* aktuelle Section-Nummer holen */
  boolean orig) /* 'true' - originale Nr, 'false' - neue Nummer */
  {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
   if(orig) return NrA; /* original Section-Nummer liefern */
   return Nr;  /* neue Section-Nummer liefern */
 }

 /**. <pre>
  *=====================================================================
  * Methode "isCurve"
  * Beschreibt Eintrag eine Kurve ?
  * ##isCurve.TSScL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isCurve() /* liegt Kurve vor ? */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return ScW1>0.0; /* 'true' wenn Kurve */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setNr"
  * neue Nummer der Section-Definition (lokal) setzen
  * Ein negativer Wert 'entwertet' die Index-Nummer
  * ##setNr.TSScL (Eyecatcher)
  *=====================================================================
  </pre>*/
 protected int setNr( /* neue Nummer setzen */
   int nr) /* neue Index-Nummer oder Kennzeichen */
  {
   /*-----------------------------------------------------------------*/
    int aNr; /* intermediate value */
   /*=================================================================*/
   if(nr<1) nr = -4; /* Kennzeichen erstellen, falls notwendig */
   aNr = Nr; /* aktuelle Nummer merken */
   Nr = nr; /* neue Indexnummer setzen, ggf. Kennzeichen */
   return aNr;  /* alte Section-Nummer liefern */
 }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSScL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs,is; /* result-string */
   /*=================================================================*/
    rs = "TSScL{" + NrA + "-"; /* set first part of line */
    rs += (ShR==null) ? "<null>" : (""+ShR.getNr(true));
    if(ScW1>0.0) is = "C("; /* add marker for 'curve' */
    else if(ScW1==0.0) is = "S("; /* add marker for 'straight' */
    else is = "?("; /* add marker for 'unknown' */
    rs += "-" + is + ScW0 + "," + ScW1 + "),"+ super.toStr() + "----";
      /* Werte hinzufuegen, vorlaeufiger Abschluss */
    if(Nr<0) rs += "'null'"; /* add marker: 'no connection' */
    else if(Nr==NrA) rs += "'this'"; /* add marker: 'self-connected' */
    else rs += "(" + Nr + ")"; /* add marker: 'connected to ... ' */
    rs += "}"; /* add termination of outputline */
    return rs; /* and return result */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSShL -- Definition eines lokalen Shape-Eintrags
 *   Diese Klasse beschreibt eine Shape-Definition, wie sie in
 *   der LOKALEN 'tsection.dat' vorkommt. Dies wird im weiteren
 *   'Pfad-Definition genannt.
 * ##TSShL (Eyecatcher)
 *======================================================================
 </pre>*/
class TSShL extends TSSh { /* local Shape-Definition (Path) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.04 13.09.2009";
 /*-------------------------------------------------------------------*/
  private int                   Nr;     /* Number of path (Index) */
  private int                   NrA;    /* Number of path (old) */
  private TSShL                 ShR;    /* next entry within chain */
  private ArrayList<TSScL>      ScR;    /* list of Section-references */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSShL() /* lokale Shape-Definition erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr   = NrA = -4; /* mark entry as 'invalid' */
//    ShR  = null; /* object is not member of chain */
//    ScR  = null; /* no list of section-definitions available */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSShL( /* create local shape-definition (path) */
   int nr) /* new ID-number of local shape (path) */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr = NrA = nr; /* insert path-number (shape)
      * Both number are initialized so that objects, which may
      * reference this entry, will get a valid path-number. This is
      * especially needed for writing. 'getNr(false)'
      */
    ScR = new ArrayList<TSScL>(); /* create list for sections */
  }

 /**. <pre>
  *=====================================================================
  * Method "addScR"
  * Add a new section to the list of section-references
  * Method returns new number of references within the section-list
  * If Argument equals 'null' nothing is added but return-value matches.
  * Attention: Method is 'missused' to return current number of
  *            sectionlist-entries. Normally method 'get$Sc()' is used
  *            for this.
  * ##addSc.TSShL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int addScR( /* add another Section-Definition */
   TSScL cSc) /* Reference to section-definition or 'null' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(ScR==null) return 0; /* list is not available */
    if(cSc!=null) ScR.add(cSc); /* add section if available */
    return ScR.size(); /* return number of sections in the list */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgShR"
  * Referenzverkettung der Pfade berabeiten
  * ##chgShR.TSShL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSShL chgShR( /* Pfad-Verkettung modifizieren */
   TSShL sh) /* Definition neuer Pfad-Eintrag oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSShL cSh; /* intermediate value */
   /*=================================================================*/
    cSh = ShR; /* alten Wert sichern */
    if(sh!=null) ShR = sh; /* neue Verkettung einsetzen */
    return cSh; /* alten/aktuellen Verkettungswert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Definitionszeile 'Pfad' fuer 'tsection.dat' erstellen
  * ##crDef.TSShL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* create definition-line for path */
   int vl) /* length of line-prefix */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result of method */
    int    i;  /* intermediate value */
   /*=================================================================*/
    if(ScR==null) return null; /* line cannot be created */
    if(vl<0 || vl>9) vl = 1; /* check length and correct it */
    rs = TSUtil.setPrfx(vl); /* creat prefix of outputline */
    vl = (ScR==null) ? 0 : ScR.size(); /* get number of sections */
    rs += "TrackPath ( " + Nr + " " + vl; /* creat first part */
    for(i=0;i<vl;i+=1) rs += " " + ScR.get(i).getNr(false);
      /* add all defined section-numbers */
    rs += " )"; /* Abschluss hinzufuegen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndSc"
  * Find section-definition within list and return position
  * Methos returns 'MIN_VALUE' if section was not found
  * ##fndSc.TSShL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int fndSc( /* return position of section within list */
   TSScL cSc) /* Reference to section-definition */
   {
   /*-----------------------------------------------------------------*/
    int i,j; /* intermediate value */
   /*=================================================================*/
    if(ScR==null) return Integer.MIN_VALUE; /* List not available */
    for(i=0,j=ScR.size();i<j;i+=1) /* check all sections */
      if(ScR.get(i)==cSc) return i; /* found -- return position */
    return Integer.MIN_VALUE; /* section was NOT found */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getNr"
  * neue/aktuelle Nummer der Shape-Definition holen
  * ##getNr.TSShL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getNr( /* aktuelle Shape-Nummer holen */
   boolean orig) /* 'true' - originale Nr, 'false' - neue Nummer */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(orig) return NrA; /* original Shape-Nummer liefern */
    return Nr;           /* neue Shape-Nummer liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getScR"
  * Get access to section-array using iterator
  * ##getScR.TSShL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected Iterator getScR() /* get access to sections */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(ScR==null) return null; /* array is NOT available */
    return ScR.iterator(); /* return Iterator for sections */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setNr"
  * neue Nummer der Pfad-Definition (lokal) setzen
  * Ein negativer Wert 'entwertet' den Index-Eintrag
  * ##setNr.TSShL (Eyecatcher)
  *=====================================================================
  </pre>*/
 protected int setNr( /* neue Nummer setzen */
   int nr) /* neue Index-Nummer oder Kennzeichen */
  {
   /*-----------------------------------------------------------------*/
    int aNr; /* intermediate value */
   /*=================================================================*/
   if(nr<1) nr = -4; /* Kennzeichen erstellen, falls notwendig */
   aNr = Nr; /* aktuelle Nummer merken */
   Nr = nr; /* neue Indexnummer setzen, ggf. Kennzeichen */
   return aNr;  /* alte Pfad-Nummer liefern */
 }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSShL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
    int    i;  /* intermediate value */
   /*=================================================================*/
    rs = "TSShL{" + NrA + "-"; /* first part */
    if(ScR==null) rs += "0("; /* no section-list available */
    else { /* section-list available -- add it to line */
      rs += ScR.size() + "("; /* add prefix of list */
      for(i=0;i<ScR.size();i+=1) { /* add all sections */
        if(i>0) rs += ","; /* insert separator */
        rs += ScR.get(i).getNr(true); /* add definition */
      } /* all section-definitions */
    } /* section-list was available */
    rs += ")," + super.toStr() + "----";
    if(Nr<0) rs += "'null'"; /* Kennzeichen setzen */
    else if(NrA==Nr) rs += "'this'"; /* Kennzeichen setzen */
    else rs += "(" + Nr + ")"; /* neue Nummer anhaengen */
    rs += "}"; /* terminate outputline */
    return rs; /* and return result */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSTrNde -- Definition of a 'Track/Road-DB'-entry
 * ##TSTrNde (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTrNde extends TSOpts { /* 'Track/Road-DB'-Definition */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 31.07.2008";
 /*-------------------------------------------------------------------*/
  private int                   Typ;    /* type-Number (1,2,3,...) */
  private int                   Nr;     /* current index-no. (old) */
  private int                   NrN;    /* Index-number (new) */
  private int                   Pin;    /* first value of PIN */
  private int                   Cnt;    /* Reference-Count */
  private ArrayList<TSRefC>     ItRef;  /* TrItem-References */
  private TSVector[]            IdRef;  /* node-vectors (UiD-Ref.) */
  private TSRefC[]              TrNde;  /* List of TrNde-References
   * number of references matches type ('Typ') of node */
/**. <pre>
  * Used options (stored within mask of 'TSOpts'):
  *  0..03 - 0-Reference (TrPin) found in reference-slot x
  *  4..15 - not used until now
  *     16 - Flag 'manual switch' active
  *     17 - Node-type has changed
  *     18 -
  *     19 -
  *     20 - Error within node-definition (common)
  *     21 - Error within node-definition: world-file/UiD not found
  *     22 - Error within node-definition (getDBF())
  *     23 - Node ist Dummy-Node (normally: only LAST Node)
  * 24..29 - not used until now
  *     30 - temporary used (cleardb)
  *     31 - temporary used (cleardb)
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSTrNde() /* 'Track/Road-DB'-Definition erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Pin   = 1;    /* Defaultwert fuer Pin */
    IdRef = null; /* noch keine UiD-Eintraege referenziert */
    TrNde = null; /* no entries within TrNode-references */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  * ACHTUNG: Wert von 'c' muss '>0' sein
  *=====================================================================
  </pre>*/
  protected TSTrNde( /* 'Track/Road-DB'-Definition erstellen */
   int typ,  /* Typ der Node */
   int node, /* Nummer der Node */
   int c)    /* Groesse des Node-Arrays */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Typ   = typ;        /* Node-Typ setzen */
    Nr    = NrN = node; /* aktuelle Nummer uebertragen */
    IdRef = new TSVector[c]; /* Array fuer UiD-Definitionen setzen */
    Arrays.fill(IdRef,null); /* and invalidate entries */
    TrNde = new TSRefC[typ]; /* create array for TrNode-references */
    Arrays.fill(TrNde,null); /* and invalidate entries */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create Dummy-/Error-entry
  *=====================================================================
  </pre>*/
  protected TSTrNde( /* create dummy-node-entry */
   int node) /* Number of the Node */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr = NrN = node; /* transfer current number of node */
    setMsk(22);      /* mark error(s) within node-options */
    setMsk(23);      /* mark entry as 'Dummy' */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgIx"
  * neuen aktuellen Index der Track-Node setzen
  * wenn ix==0: liefern aktueller Node-Index (information-Hiding)
  * ##chgIx.TSTrNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int chgIx( /* Eintragsreferenz neu setzen */
   int nr) /* neue Referenz */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = NrN; /* alten Index merken */
    if(nr>0) NrN = nr; /* neue Referenz setzen */
    return i; /* alten Index liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNde"
  * Verkettung der Sub-Node (UiD) lesen / neu setzen
  * id==null -> Wert NICHT neu setzen
  * ##chgNde.TSTrNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSVector chgNde( /* UiD-Verkettung modifizieren */
   int      ix, /* Index der UiD-Verkettung */
   TSVector id) /* reference to new vector-node (contains UiD) */
   {
   /*-----------------------------------------------------------------*/
    TSVector cNde; /* intermediate value */
   /*=================================================================*/
    if(IdRef==null) return null; /* Array nicht erstellt */
    if(ix<0 || ix>=IdRef.length) return null; /* Plausi-Fehler Index */
    cNde = IdRef[ix]; /* alte UiD-Verkettung lesen */
    if(id!=null) IdRef[ix] = id; /* neue UiD-Verkettung setzen */
    return cNde; /* alte/aktuelle UiD-Verkettung liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTrN"
  * TrackNode-Referenz lesen / neu setzen
  * ##chgTrN.TSTrNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC chgTrN( /* Node-Referenz zu Sub-Node modifizieren */
   int    ix, /* Index des Referenz-Feldes */
   TSRefC rf) /* Node-Referenz (Control-Objekt) */
   {
   /*-----------------------------------------------------------------*/
    TSRefC cRef; /* intermediate value */
   /*=================================================================*/
    if(TrNde==null) return null; /* Array nicht erstellt */
    if(ix<0 || ix>=Typ) return null; /* Plausi-Fehler Index */
    cRef = TrNde[ix]; /* alte Referenz lesen */
    if(rf!=null) TrNde[ix] = rf; /* neue Referenz eintragen */
    return cRef; /* alte/aktuelle Node-Referenz liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkItm"
  * TrItem-Referenzen pruefen und ggf. loeschen
  *    Ueberprueft die Tabelle nachdem ein Eintrag entfernt wurde.
  * Ergebnis:
  *    'true'  - Tabelle ist (jetzt) nicht mehr vorhanden
  *    'false' - Tabelle enthaelt noch gueltige Eintraege
  * ##chkItm.TSTrNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkItm( /* TrItem-Referenzen ueberpruefen */
   boolean clr) /* Alle Eintraege loeschen falls 'true' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(ItRef==null) return true; /* Referenzliste nicht aktiv */
    if(clr) ItRef.clear(); /* loeschen aller Elemente gefordert */
    if(ItRef.size()>0) return false; /* weitere Elemente definiert */
    ItRef = null; /* Referenz-Liste entfernen */
    return true; /* Referenz-Liste nicht mehr vorhanden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$Nde"
  * Information-Hiding: Laenge des UiD-Speicherbereichs liefern
  * ##get$Nde.TSTrNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$Nde() /* Laenge Node-Bereichs (UiD) liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return IdRef.length; /* aktuellen Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItm"
  * Aktuelles Array der TrItem-Referenzen liefern
  * Wenn der Speicher noch nicht angelegt ist, wird er ggf.mit
  *   0 Elementen generiert (falls gefordert)
  * ##getItm.TSTrNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSRefC> getItm( /* Array der TrItem-Ref's liefern */
   int c) /* Anzahl der TrItem-Definitionen (init) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(ItRef==null && c>0) ItRef = new ArrayList<TSRefC>(c);
      /* Liste war noch nicht vorhanden und musste erstellt werden */
    return ItRef; /* Elemente-Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getNr"
  * neue/aktuelle Node-Identifikation liefern
  * ##getNr.TSTrNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getNr( /* Node-Identifier liefern */
   boolean orig) /* 'true' - originale Nr, 'false' - neue Nummer */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(orig) return Nr; /* originale Node-Identifikation liefern */
    return NrN; /* neuen Node-Identifikation liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getPin"
  * Verkettungsbasis in String-Form liefern
  * ##getPin.TSTrNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getPin() /* Verkettungsbasis liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "\t\t\tTrPins ( " + Pin + " " + (Typ - Pin);
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTrN"
  * TrackNode-Referenz (Adr) lesen
  * ##getTrN.TSTrNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSTrNde getTrN( /* Node-Referenz fuer Sub-Node holen */
   int ix) /* Index des Referenz-Feldes */
   {
   /*-----------------------------------------------------------------*/
    TSRefC cRef; /* intermediate value */
   /*=================================================================*/
    if(TrNde==null) return null; /* Array nicht erstellt */
    if(ix<0 || ix>=Typ) return null; /* Plausi-Fehler Index */
    cRef = TrNde[ix]; /* Verbindungsreferenz lesen */
    if(cRef==null) return null; /* Referenz nicht definiert */
    return (TSTrNde)cRef.chgRef(null); /* aktuelle Node-Ref. liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTyp"
  * Information-Hiding: Track-Node-Typ liefern
  * ##getTyp.TSTrNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getTyp() /* Track-Node-Typ liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Typ; /* aktuelles Ergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt"
  * Increment reference-counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt.TSTrNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = Cnt; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-Cnt); /* must not become negative */
    Cnt += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setTyp"
  * Node-Typ veraendern gemaess neuen Verkettungen
  * liefert Fehlermeldung, falls Aenderung nicht moeglich
  * ##setTyp.TSTrNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setTyp( /* Node-Typ veraendern */
   int typ, /* neuer Node-Typ */
   int pin) /* neuer/alter erster Pin-Wert */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    if(typ==Typ) { /* Typ soll beibehalten werden */
      Pin = pin; /* erster Pin-Wert aendern wenn KEIN Fehler */
      return null; /* korrekter Typ -- kein Fehler */
    } else if(Typ<3) return TSLogg.getMsg("TSTrNdT1",Typ);
    if(typ<4 || typ>=TSUtil.TrN_T) return TSLogg.getMsg("TSTrNdT2",typ);
    if(typ<Typ) return TSLogg.getMsg("TSTrNdT3",null,Typ,typ);
    for(i=0;i<Typ;i+=1) /* references already set ? */
      if(TrNde[i]!=null) return TSLogg.getMsg("TSTrNdT4",i);

    Typ = typ; /* neuen Typ eintragen */
    Pin = pin; /* erster Pin-Wert aendern wenn KEIN Fehler */
    TrNde = new TSRefC[typ]; /* create new array for TrNode-references */
    Arrays.fill(TrNde,null); /* and invalidate entries */
    setMsk(17); /* Kennzeichen setzen: Nodetyp veraendert */
    return null; /* ohne Fehler zurueck -- Aenderung erstellt */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTrNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs;   /* result-String */
    TSRefC cRef; /* Referenz-Definition */
    int    i,j;  /* intermediate value */
   /*=================================================================*/
    j = 0; /* fuer Umbruch */
    rs = "TSTrNde{" + Typ + "," + NrN + "(";
    for(i=0;i<Typ;i+=1) { /* alle Referenzen */
      if(i>0) rs += ","; /* Trennzeichen hinzufuegen */
      if((cRef=TrNde[i])==null) rs += "<>"; /* keine Verkettung */
      else rs += "" + cRef.chgNr(Integer.MIN_VALUE);
    } /* alle Referenzen */
    rs += ")-";

    if(ItRef!=null) { /* TrItem-Ref. sind definiert */
      rs += "" + ItRef.size() + "[";
      for(i=0;i<ItRef.size();i+=1) { /* alle Referenzen */
        if(i>0) rs += ","; /* Trennzeichen hinzufuegen */
        cRef = (TSRefC)ItRef.get(i); /* Referenz-Objekt holen */
        if(cRef.chgRef(null)!=null) /* Referenz vorhanden */
          rs += "" + ((TSTrItm)cRef.chgRef(null)).getNr(false);
         else rs += "" + cRef.chgNr(Integer.MIN_VALUE);
      } /* alle Werte */
      rs += "]-"; /* Abschluss setzen */
    } else rs += "?[]-"; /* Dummy-Kennung */

    if(IdRef!=null) { /* Nodes sind definiert */
      rs += IdRef.length+"[";
      for(i=0;i<IdRef.length;i+=1) { /* alle Referenzen */
        if(i>0) rs += ","; /* Trennzeichen hinzufuegen */
        if((rs.length()/TSUtil.ZL)>j) { /* Zeilenumbruch einfuegen */
          j += 1; /* naechster Umbruch vorsehen */
          rs += TSUtil.CRLF + "                ";
        } /* Umbruch-Steuerung erfolgt */
        rs += IdRef[i].toStr();
      } /* alle Werte */
      rs += "]"; /* Abschluss setzen */
    } else rs += "0[]"; /* Dummy-Kennung */
    rs += "-" + super.toStr() + "}"; /* Abschluss setzen */
    return rs; /* provide result-string */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSVector -- Definition of 'vector-section' from Track/Road-DB
 *  This class is also used to store data of an UID-Definition from
 *  TrEnd-/TrJunction-Node
 * ##TSVector (Eyecatcher)
 *======================================================================
 </pre>*/
class TSVector extends TSOpts { /* 'vector-section' from Track/Road-DB */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.10 04.03.2011";
 /*-------------------------------------------------------------------*/
  private int                   Id;     /* current UiD-number */
  private TSUiD                 Uid;    /* Reference to UID-definition */
  private int                   Qx;     /* Number of X-Quad */
  private int                   Qz;     /* Number of Z-Quad */
  private TSQuad                QDf;    /* Reference to world-quad */
  private TSQPos                Pos;    /* Position of Object (+Ref) */
  private double                R1;     /* Direction: Elevation */
  private double                R2;     /* Direction: Heading */
  private double                R3;     /* Direction: ? */
  private int                   CoS;    /* Number of Connection 'Start' */
  private int                   CoE;    /* Number of Connection 'End' */
  private int                   CoO;    /* Options for Connections */
  private int                   Sh;     /* Number of current Shape */
  private int                   Sc;     /* Number of current Section */
  private TSSc                  ScR;    /* Reference to current Section */
/**. <pre>
  * Used options (stored within mask of 'TSOpts'):  (refer to 'TSTrNde')
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSVector() /* create vector-node-definition */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Id  = -1;        /* ungueltige UiD ( = nicht gesetzt) */
    Qx  = Qz = Integer.MIN_VALUE; /* keine Nummer gesetzt */
//    R1 = R2 = R3 = 0.0;  /* Richtung vorbesetzen */
//    CoS = CoE = CoO = 0; /* Defaultwert fuer Connectionwerte */
    Sh  = Sc = -1;   /* keine Werte eingetragen */
//    Pos = null;      /* no Position-values available */
//    QDf = null;      /* keine Quadranden-Referenzen fuer ID */
//    Uid = null;      /* keine Verkettung zu UiD-Definition */
//    ScR = null;      /* keine Verkettung zu lokaler Section */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSVector( /* create vector-node-definition */
   int sh, /* new shape-number */
   int sc) /* new section-number */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Sh = sh; /* insert provided shape-number (-1 if not available) */
    Sc = sc; /* insert provided section-number */
  }

 /**. <pre>
  *=====================================================================
  * Methode "adjHgt"
  * Hoehenwert eines Knotens anpassen
  *   Ergebniswert muss nicht geprueft werden
  * ##adjHgt.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String adjHgt( /* Hoehenwert veraendern */
   double d) /* Korrekturwert der Hoehe */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return TSLogg.getKey("TSNdeA01");
    Pos.addPosY(d); /* Hoehenwert korrigieren */
//    if((i=Pos.addPosY(d))!=0) return TSLogg.getMsg("TSNdeA02",i);
    return null; /* Methode beenden -- kein Fehler */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgUid"
  * UiD-Referenz (Adr) lesen / neu setzen
  * ##chgUid.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSUiD chgUid( /* UiD-Referenz modifizieren */
   TSUiD id) /* UiD-Definition (Adresse) */
   {
   /*-----------------------------------------------------------------*/
    TSUiD cUiD; /* intermediate value */
   /*=================================================================*/
    cUiD = Uid; /* alte Definition merken */
    if(id!=null) Uid = id; /* neue Definition setzen */
    return cUiD; /* alte/aktuelle Definition liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkId"
  * Werte der UiD-Definition ueberpruefen
  * Methode liefert 'false' wenn die Referenz identisch ist.
  * Reihenfolge der Prufungen:
  *    (Wenn ein Wert nicht vorhanden ist (null) wird die naechste
  *     Pruefungsart verwendet)
  *   a) - Uid-Definition (incl. Rueckverkettung zum Quad)
  *   b) - Quad-Referenz + Uid-Definition(NUR ID)
  *   c) - Quad-Nummern + Uid-Definition(NUR ID)
  *   d) - Quad-Referenz + ID
  *   e) - Quad-Nummern + ID
  * ##chkId.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkId( /* Kennungen ueberpruefen */
   TSQuad cQdf, /* Quadranten-Referenz der zu prufenden Def. */
   int    id)   /* UiD-Kennung der zu prufenden Definition */
   {
   /*-----------------------------------------------------------------*/
    TSQDef cQ; /* intermediate value */
   /*=================================================================*/
    if(id<0) return true; /* NUR fuer Ueberpruefungen der UiD */
    if(Uid!=null) { /* UiD-Referenz verfuegbar -- nutzen */
      if(Uid.getUiD(0)!=id) return true; /* ID-stimmt nicht */
      cQ = Uid.chgQDf(null); /* aktuelle Rueckverkettung zu Quad */
      if(cQ!=null && cQ instanceof TSQuad) /* valid Quad-reference */
        if(cQ==cQdf) return false; /* Quadrantenreferenz stimmt */
        else return true; /* Quadranten stimmen NICHT ueberein */
    } else if(Id!=id) return true; /* UiD stimmt nicht */
    /* Hier: UiD==null oder Rueckreferenz der Uid ist 'null' */
    if(QDf!=null) /* Quadranten-Referenz vorhanden -- nutzen */
      if(QDf==cQdf) return false; /* Quadrantenreferenz stimmt */
      else return true; /* Quadranten stimmen NICHT ueberein */
    if(cQdf.isWrld(Qx,Qz)) return false; /* Referenz stimmt */
    return true; /* Referenz stimmt nicht ueberein */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkSc"
  * Section-Kennung (global/lokal) pruefen und ggf. Fehlermeldung liefern
  * Wenn Pruefung erfolgreich wird die Section registriert.
  * ACHTUNG: Erweiterte Version fuer ueberlappende Tabellen
  *    Dennoch MUSS gelten UG(local) <= OG(global)
  * ##chkSc.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chkSc( /* check ID of section-entry */
   TSSect[] ScT,  /* table of global sections */
   TSRoute  cRte) /* table of local sections defined within route */
   {
   /*-----------------------------------------------------------------*/
    int m; /* Maximalwert */
   /*=================================================================*/
    if(ScT==null) return TSLogg.getKey("TSNdeC01"); /* error */
    if(cRte.isScL(Sc)) { /* local section is referenced */
      if((ScR=cRte.chgScT(Sc,null))==null) /* Section not defined */
        return TSLogg.getMsg("TSNdeC02",Sc);
      ScR.incCntS(1); /* count reference within section */
      return null; /* Section-Id is valid and registered */
    } /* Reference to 'lokcal tsection.dat' found */
    if(Sc<ScT.length) { /* check global section-ID */
      if((ScR=ScT[Sc])==null) return TSLogg.getMsg("TSNdeC03",Sc);
      /* 'ScR.getNr(true) == Sc' gilt IMMER fuer Sections */
      ScR.incCntS(1); /* count reference within section */
      return null; /* Section-Id is defined with global table */
    } /* Reference to 'global tsection.dat' found */

    if((m=cRte.get$Sc(true))>=ScT.length) /* Index groesser */
      return TSLogg.getMsg("TSNdeC04",null,Sc,m);
    return TSLogg.getMsg("TSNdeC05",null,Sc,ScT.length);
  }

 /**. <pre>
  *=====================================================================
  * Method "chkScR"
  * Check section-id if it is part of current shape
  * Return error-message if it is not
  * ##chkScR.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chkScR( /* check connection section - shape */
   TSSh cSh) /* Address of current shape/path */
   {
   /*-----------------------------------------------------------------*/
    Iterator ScI; /* iterator for all connectes sections */
   /*=================================================================*/
    ScI = cSh.getSc(); /* get iterator from shape/path-definition */
    if(ScI==null) return TSLogg.getMsg("TSNdeC11",cSh.getNr(true));
    while(ScI.hasNext()) /* compare to all section-definitions */
      if(ScI.next()==ScR) return null; /* found --return marker */
    return TSLogg.getMsg("TSNdeC12",null,ScR.getNr(true),cSh.getNr(true));
      /* error -- return message: connection not found */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkSh"
  * Shape-Kennung mit gespeichertem Wert vergleichen
  *   und ggf. Fehlermeldung liefern
  * ##chkSh.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chkSh( /* Shape-Nummer pruefen */
   int sh) /* Nummer des geforderten Shapes */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(sh==Sh) return null; /* Nummer stimmt -- OK melden */
    return TSLogg.getMsg("TSNdeH11",""+Qx+","+Qz+","+Id,Sh,sh);
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkSh" (2. Version)
  * Shape-Kennung (global/lokal) pruefen und ggf. Fehlermeldung liefern
  * Wenn Pruefung erfolgreich wird der Shape registriert.
  * ACHTUNG: Erweiterte Version fuer ueberlappende Tabellen
  *    Dennoch MUSS gelten UG(loc) <= OG(glob)
  * ##chkSh.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chkSh( /* Shape-Nummer pruefen */
   TSShape[] ShT,  /* Shape-Tabelle (global) */
   TSRoute   cRte) /* Pfad-Tabelle in Route */
   {
   /*-----------------------------------------------------------------*/
    TSShL cSh; /* lokalen Pfad */
    int   m;   /* Maximalwert */
   /*=================================================================*/
    if(ShT==null) return TSLogg.getKey("TSNdeH01"); /* Fehler-Msg */
    if(cRte.chkShT(Sh,true)==null) { /* Index OK -- lokaler pfad */
      /* wenn keine Fehlermeldung gelieft wird ist der Index OK */
      if((cSh=cRte.chgShT(Sh,null))==null) /* Pfad ist nicht definiert */
        return TSLogg.getMsg("TSNdeH02",Sh);
      cSh.incCntS(1); /* Referenz registrieren */
      return null; /* Pfad-Id korrekt definiert */
    } /* Referenz auf 'lokale tsection.dat' lag vor */
    if(Sh<ShT.length) { /* globale Shape-Kennung */
      if(ShT[Sh]==null) return TSLogg.getMsg("TSNdeH03",Sh);
      return null; /* Shape-Id korrekt definiert */
    } /* gueltige globale Referenz lag vor */

    if((m=cRte.get$Sh(true))>=ShT.length) /* Index groeeser als glob. */
      return TSLogg.getMsg("TSNdeH04",null,Sh,m);
    return TSLogg.getMsg("TSNdeH05",null,Sh,ShT.length);
  }

 /**. <pre>
  *=====================================================================
  * Methode "clrS"
  * Shape- und Section-Referenzen loeschen
  * Methode meldet 'true' wenn Aktion NICHT erfolgreich
  * ACHTUNG: Restriktive Version (UG(loc) == OG(glob) gefordert)
  * ##clrS.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean clrS( /* Shape- / Section-Nummer loeschen */
   int      lShT, /* Groesse der statischen Shape-Tabelle */
   TSRoute  cRte) /* Pfad-Tabelle in Route */
   {
   /*-----------------------------------------------------------------*/
    TSShL cSh; /* lokalen Pfad */
   /*=================================================================*/
    if(ScR!=null) /* Section-Referenz ist vorhanden */
      if(ScR instanceof TSScL) ((TSScL)ScR).incCntS(-1);
        /* Section-Registrierung loeschen */
    if(Sh<0) return true; /* nicht loeschbar */
    if(Sh<lShT) return false; /* OK -- globale Shape-Kennung */
    if(cRte.get$Sh(true)<=Sh) return true;
    if((cSh=cRte.chgShT(Sh,null))==null) return true;
    cSh.incCntS(-1); /* Shape-Registrierung loeschen */
    return false; /* Aktion erfolgreich */
  }

 /**. <pre>
  *=====================================================================
  * Methode "cmpAbs"
  * Abstand der Positionswerte berechnen (fuer Vergleich)
  * Methode liefert den Abstand der beiden Koordinaten (nach Pythargoras)
  * Achtung: Aufgabe wird zum TSQPos-Objekt delegiert!
  *   Wenn BEIDE Koordinaten nicht im gleichen Quadranten liegen,
  *     wird der maximale Wert 'Double.MAX_VALUE' geliefert
  * Sonderfall wenn 'cP==null': Hoehenwert liefern
  * ##cmpAbs.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected double cmpAbs( /* Abstand Positionswerte berechnen */
   TSQPos cP) /* Definition des Vergleich-Knotens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return Double.NaN; /* Fehlerkennung liefern */
    if(cP==null) return Pos.getPosY(); /* Hoehenwert liefern */
    return Pos.cmpAbs(cP); /* Abstand der Koordinaten liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crCoo"
  * Positions-Definition als Koordinaten-Objekt liefern
  * Funktion wird an die Positionsdefinition delegiert!
  * ##crCoo.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSCoo crCoo() /* Positions-Definition liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return null; /* keine gueltige Position verfuegbar */
    return Pos.crCoo(); /* liefern Koordinate */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   String  id,  /* schon aufbereiteter ID-Teil der Zeile */
   boolean sec) /* erweiterte Ausgabedaten falls 'true' (section) */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = sec ? " " : "\t\t\tUiD ( "; /* erster Teil der Zeile */
    rs += id + " " + CoS; /* erster Teil der Werte erstellen */
    if(sec) rs += " " + CoE + " " + TSUtil.toHex(CoO,2); /* weiter */
    if(Pos==null) rs += " 0 0 0 0 0"; /* Dummy-Wert verwenden */
    else rs += " " + Pos.getPos(0); /* Werte (TSQPos) aufbereiten */
    rs += TSUtil.putFV(R1,0) + TSUtil.putFV(R2,0) + TSUtil.putFV(R3,0);
      /* Richtungswerte erstellen und hinzufuegen */
    rs += sec ? " " : " )"; /* Abschluss hinzufuegen */
    return rs; /* Zeilendefinition liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crPos"
  * Information-Hiding: Positionswerte als TSQPos-Objekt liefern
  * Achtung: Es wird eine (shallow-)Kopie geliefert, sodass die Attribute
  *          dieses Objektes (testweise) modifiziert werden koennen,
  *          ohne das Basisobjekt zu beeinflussen
  * ##crPos.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQPos crPos() /* Positionswerte als Vector liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return null; /* Positionswerte NICHT verfuegbar */
    return new TSQPos(Pos); /* Objekt-Kopie liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndWrld"
  * suchen und liefern der World-Definitionen aus 'Qx'/'Qz' und Pos
  * ACHTUNG: Im Erfolgsfall wird die Quadrat-Referenz eingetragen!!
  * ##fndWrld.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQuad fndWrld( /* World-Definition liefern */
   TreeSet<TSQuad> qdf, /* Alle Quadrat-Definitionen der World-Dateien */
   boolean         t)   /* 'Position' betroffen wenn 'true' */
   {
   /*-----------------------------------------------------------------*/
    TSQuad           cQDf;  /* Arbeitswerte */
    Iterator<TSQuad> cI;    /* Iterator fuer 'TreeSet' */
   /*=================================================================*/
    if(Pos==null) return null; /* Fehler: keine Positionsdef. vorhanden */
    if(t) return Pos.fndWrld(qdf); /* Referenz fuer Position suchen */

    if(Qx==Integer.MIN_VALUE) return null; /* Wert ungueltig */
    if(Qz==Integer.MIN_VALUE) return null; /* Wert ungueltig */
    cI = qdf.iterator(); /* Iterator fuer Quadrat-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cQDf = cI.next(); /* naechste Quadrat-Definition */
      if(cQDf.isWrld(Qx,Qz)) { /* Welt gefunden -- registrieren */
        QDf = cQDf; /* Referenz merken */
        return cQDf; /* gefundene Welt melden */
      } /* Welt-Definition gefunden */
    } /* alle Eintraege testen */
    return null; /* Fehlerkennung zurueckgeben */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getDir"
  * Information-Hiding: geforderter Richtungswert holen
  * ##getDir.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected double getDir( /* Richtungswert holen */
   int nr) /* Nummer des Wertes (0,1,2) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr==0) return R1; /* geforderter Wert liefern */
    if(nr==1) return R2; /* geforderter Wert liefern */
    if(nr==2) return R3; /* geforderter Wert liefern */
    return Double.NaN; /* Fehler kennzeichnen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getId"
  * Information-Hiding: UiD-Identifikation + Quadranden prufen und
  *  ggf. liefern
  * Achtung: Wenn diese Methode genutzt wird ist die UiD-Verkettung
  *          NICHT gueltig! Sonst koennen die korrekten Werte aus der
  *          UiD-Definition extrahiert werden.
  * ##getId.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getId( /* UiD-Identifikation liefern */
   boolean m) /* Testen Quadranden (true) / liefern Original-ID */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    if(QDf!=null) { /* Quadranten sind aufloesbar -- nutzen */
      if(m) return null; /* zurueck mit Kennzeichen */
      rs = QDf.getInf(1); /* Quadranten holen */
    } else rs = "" + Qx + " " + Qz; /* Orginalwerte nutzen */
    if(m) return rs; /* testen: NUR Original-Quadranten liefern */
    return rs + " " + Id; /* aktuelles Ergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getMsg"
  * Message gemaess Fehlerkennung erstellen
  * ACHTUNG: 'private'-Werte werden in die Meldung eingebaut
  * ##getMsg.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getMsg( /* (Fehler-)Meldung erstellen */
   int    nr, /* Nummer der Meldung */
   String s)  /* optionaler Zusatzwert */
   {
   /*-----------------------------------------------------------------*/
    String id = ""+Qx+","+Qz+","+Id; /* Zwischenwert */
   /*=================================================================*/
    switch(nr) { /* gemaess Kennung erstellen */
      case(0): return TSLogg.getMsg("TSNdeM01",id,s);
      case(1): return TSLogg.getMsg("TSNdeM02",id,s);
      case(2): return TSLogg.getMsg("TSNdeM03",null,Qx,Qz);
      case(3): return TSLogg.getMsg("TSNdeM07",Pos.getPos(3));
      case(4): return TSLogg.getMsg("TSNdeM04",id);
      case(5): return TSLogg.getMsg("TSNdeM05",id,s);
      case(6): return TSLogg.getKey("TSNdeM06"); /* Meldung zurueck */
    } /* gemaess Kennung beendet */
    return TSLogg.getMsg("TSNdeM09",nr); /* Nr. falsch */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getPos"
  * Information-Hiding: Positionswerte in Zeichenkettenform liefern
  * Achtung: Vollstaendiger Positionswert (incl. Quadrant)
  * ##getPos.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getPos() /* Positionswerte liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return "0 0 0 0 0"; /* Dummy-Wert liefern */
    return Pos.getPos(0); /* Werte (TSQPos) aufbereiten und liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getSc"
  * aktuell gueltige Section-Kennung holen (alt,neu)
  * Argument: 'true' -> 'alt', 'false' -> 'neu'
  * ##getSc.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getSc( /* Section-Nummer holen oder Fehlercode */
   boolean t) /* geforderte Originalnummer */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(ScR==null) return t ? Sc : -3; /* nicht zugewiesen */
    return ScR.getNr(t); /* Section-Nummer (neu/alt) liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getScV"
  * aktuell gueltige Section-Werte holen
  * Argument: 'true' -> 'Radius/Laenge', 'false' -> 'Winkel'
  * ##getScV.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected double getScV( /* Section-Werte holen oder Fehlercode */
   boolean t) /* Radius/Laenge gefordert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(ScR==null) return Double.NaN; /* nicht zugewiesen */
    if(t) return ScR.getLR(); /* Radius/Laenge der Section liefern */
    return ScR.getAng(); /* Winkel/Kennzeichen der Section liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getSh"
  * aktuell gueltiga Shape-Kennung holen
  * Argument: 'true' -> 'alt', 'false' -> 'neu'
  * ##getSh.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getSh( /* Shape-Nummer holen */
   boolean t) /* geforderte Originalnummer */
   {
   /*-----------------------------------------------------------------*/
    TSSh cSh; /* lokalen Pfad / oder Shape */
   /*=================================================================*/
    if(t) return Sh; /* immer original gelieferte Nummer */
    if(Uid==null) return -3; /* ID nicht vorhanden -- Fehler */
    cSh = Uid.chgShR(null); /* eingetragener Shape/Pfad holen */
    if(cSh==null) return -4; /* kein Shape -- Fehler */
    return cSh.getNr(false); /* Shape-Nummer (neu) liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getUid"
  * Wert der UiD-kennung liefern
  * ##getUid.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getUid() /* UiD-Kennung lieferen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Id; /* UiD-Nummer liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isT"
  * liefern Kennung ob Schiene 'gedreht' (twisted) ist
  * ##isT.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isT() /* Kennung 'twisted' liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return CoE<CoS; /* Kennung liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setConn"
  * Connectionwerte in Node-Definition uebernehmen
  * Nummer der Verbindungspunkte der SectionIdx-Definitionen setzen
  * ##setConn.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setConn( /* Zusatzwerte speichern */
   int a, /* Connectionwert Anfang */
   int e, /* Connectionwert Ende */
   int o) /* Optionen der Connection */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    CoS = a; /* neuen Wert uebertragen und speichern */
    CoE = e; /* neuen Wert uebertragen und speichern */
    CoO = o; /* neuen Wert uebertragen und speichern */
    return null; /* Methode beenden (Methode OK -- kein Fehler) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDir"
  * Richtungswerte eines Objektes speichern
  * ACHTUNG: neue Richtungswerte muessen geprueft und gueltig sein!
  * ##setDir.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDir( /* Richtungswerte speichern */
   double r1, /* Richtungswert 1 */
   double r2, /* Richtungswert 2 */
   double r3) /* Richtungswert 3 */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    R1 = r1; /* neue Richtung uebertragen */
    R2 = r2; /* neue Richtung uebertragen */
    R3 = r3; /* neue Richtung uebertragen */
    return null; /* Methode beenden (Methode OK -- kein Fehler) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setID"
  * Werte der UiD-Definition eintragen
  * ##setID.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setID( /* Kennungen eintragen */
   int qx, /* Qx-Koordinate */
   int qz, /* Qz-Koordinate */
   int id) /* UiD-Kennung */
   {
   /*-----------------------------------------------------------------*/
    String is; /* Fehlerkennung */
   /*=================================================================*/
    if(id<0) return TSLogg.getMsg("TSNdeI01",id); /* Fehler */
    is = null; /* Kennzeichen: noch kein Wert war gesetzt */
    if(Id>=0) is = TSLogg.getMsg("TSNdeI02",Id); /* Message setzen */
    if(Qx!=Integer.MIN_VALUE) is = TSLogg.getMsg("TSNdeI03",Qx);
    if(Qz!=Integer.MIN_VALUE) is = TSLogg.getMsg("TSNdeI04",Qz);
    Qx = qx; /* Qx-Nummer eintragen */
    Qz = qz; /* Qz-Nummer eintragen */
    Id = id; /* UiD-Kennung eintragen */
    return is; /* Funktion erfolgreich beendet ? */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setPos"
  * neues Positionsobjektes speichern/ersetzen (unbedingt)
  * ##setPos.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQPos setPos( /* Positionsobjekt speichern */
   TSQPos cP) /* neues Positionsobjekt */
   {
   /*-----------------------------------------------------------------*/
    TSQPos cPos; /* Original-Wert */
   /*=================================================================*/
    cPos = Pos; /* Originalwert sichern falls vorhanden */
    Pos = cP; /* neue Position uebertragen */
    return cPos; /* Methode beenden (Originalwert liefern) */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSVector (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-String */
   /*=================================================================*/
    rs = "TSVector{(("+Qx+","+Qz+","+Id+")/("+Sh +","+Sc+")-";
    if(Pos==null) rs += "<null>" + ")-";
    else rs += Pos.toStr() + ")-";
    if(Uid==null) rs += "<NoUiD>-"; /* keine Verkettung */
    else rs += Uid.toStr() + "-"; /* Definition anhaengen */
    if(ScR==null) rs += "<NoSect>"; /* keine Verkettung */
    else rs += ScR.getNr(true); /* Definition anhaengen */
    rs += "-" + super.toStr() + "}"; /* Abschluss setzen */
    return rs; /* provide result-string */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSTrItm -- Definition of a TrItem-Entry from Track/Road-DB
 * ##TSTrItm (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTrItm extends TSOpts { /* TrItem-Definition of Track/Road-DB */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.09 02.08.2010";
 /*-------------------------------------------------------------------*/
  private int                   Typ;    /* Type of Item */
  private int                   Nr;     /* current index-number (old) */
  private int                   NrN;    /* Index-Number (new) */
  private int                   Cnt;    /* Reference-Count */
//  private ArrayList<TSTrNde>    Nde;    /* Back-ref(s) to 'TRNode' */
  private TSTrNde               Nde;    /* Back-reference to 'TRNode' */
  private TSWrld                Uid;    /* Back-reference to World */
  private TSQPos[]              Pos;    /* Position-references */
  private int                   Opt;    /* Options within 'TrItemSData' */
  private double                Offs;   /* Offset within 'TrItemSData' */
/**. <pre>
  * Type-Numbers:  0 - EmptyItem
  *                1 - SignalItem
  *                2 - PlatformItem
  *                3 - SidingItem
  *                4 - SpeedpostItem
  *                5 - CarSpawnerItem
  *                6 - LevelCrItem
  *                7 - HazzardItem
  *                8 - PickupItem
  *                9 - SoundRegionItem
  *               10 - CrossoverItem
  * Options stored in Mask-Value of 'TSOpts':
  *        0 : DO NOT write TrItem-definiton
  *        1 : Error within TrItem-definition found
  *        2 : Index is used as 'TrItemId'
  *        3 : 'TrItem' is connected to database more than once
  *  3 to 15 : not used
  *       16 : 'TrItemId'
  *       17 : 'TrItemSData'
  *       18 : 'TrItemPData' (stored in Pos[1]))
  *       19 : 'TrItemRData' (stored in Pos[0]))
  *       20 : not used
  *       21 : '...TritemData' / 'TrSignalType' / 'TritemSRData'
  *       22 : 'TrSignal(R)Dir'
  *       23 : not used
  * 24 to 27 : additional Items (individual)
  * 28 to 31 : not used
  * Index-number of Position: 0 - 'TrItemRData'
  *                           1 - 'TrItemPData' (no valid Height!)
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm() /* create TrItem-Definition of Track/Road-DB */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Typ  = -1;   /* ungueltiger Item-Typ ( = nicht gesetzt) */
//    Nr   = 0;    /* keine Nummer gesetzt */
//    NrN  = 0;    /* keine Nummer gesetzt */
//    Cnt  = 0;    /* noch keine Referenz auf diesen Eintrag */
//    Nde  = null; /* TrItem is not referenced from TR-Node (Back-Ptr) */
//    Uid  = null; /* TrItem is not referenced from world (Back-Ptr) */
    Pos  = null; /* kein Speicher fuer Positions-Referenzen */
//    Opt  = 0;    /* options of 'TrItemSData'-value are NOT set */
    Offs = Double.NaN; /* offset of 'TrItemSData'-value is NOT set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm( /* create TrItem-Definition of Track/Road-DB */
   int typ,  /* current type of item */
   int ItNr) /* index of item */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Typ  = typ;  /* set type of item */
    Nr   = NrN = ItNr; /* insert index of item */
    Cnt  = 0;    /* noch keine Referenz auf diesen Eintrag */
    Nde  = null; /* TrItem is not referenced from TRNode (Back-Ptr) */
    Uid  = null; /* TrItem is not referenced from world (Back-Ptr) */
    Opt  = 0;    /* options of 'TrItemSData'-value are NOT set */
    Offs = Double.NaN; /* offset of 'TrItemSData'-value is NOT set */
    Pos  = new TSQPos[2];  /* Speicher fuer Positions-Referenzen */
    Pos[0] = Pos[1] = null; /* noch keine Positions-Referenz */
    setMsk(2); /* set marker: 'Index' is used instead of 'TrItemID' */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create copy-entry from template
  *=====================================================================
  </pre>*/
  protected TSTrItm( /* create TrItem-Definition of Track/Road-DB */
   TSTrItm cIt,  /* TrItem-definition used as template */
   int     typ,  /* new type of item */
   int     ItNr) /* new TrItemID of item */
   {
    super(cIt); /* copy values from parent (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Typ  = typ;  /* set type of item */
    Nr   = NrN = ItNr; /* insert 'TrItemID' to new element */
    Cnt  = 0;    /* this TrItem is still not referenced */
    Nde  = null; /* TrItem is not referenced from TR-Node (Back-Ptr) */
    Uid  = null; /* TrItem is not referenced from world (Back-Ptr) */
    Opt  = cIt.Opt;  /* copy options of 'TrItemSData'-value */
    Offs = cIt.Offs; /* copy offset of 'TrItemSData'-value */
    Pos  = new TSQPos[2];  /* create memory of position-references */
    Pos[0] = cIt.Pos[0]; Pos[1] = cIt.Pos[1]; /* and copy them */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "adjHgt"
  * Hoehenwert des Positionswertes [0] anpassen
  *   Ergebniswert muss nicht geprueft werden
  * (Positionswert [1] besitzt KEINE Hoehe)
  * ##adjHgt.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String adjHgt( /* Hoehenwert veraendern */
   double d) /* Korrekturwert der Hoehe */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return TSLogg.getKey("TSTrItA1");
    if(Typ==0) return null; /* 'EmptyItem' kann keine Position haben */
    if(Pos[0]==null) return TSLogg.getMsg("TSTrItA2",0);
    Pos[0].addPosY(d); /* Hoehenwert korrigieren */
//    if((i=Pos[0].addPosY(d))!=0) return TSLogg.getMsg("TSTrItA3",i);
    return null; /* Methode beenden -- kein Fehler */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgLne" (This dummy-method must be overlayed)
  * ##chgLne.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgLne(int i, String s) { throw new /* system-error */
    IllegalStateException(TSLogg.getMsg("Msg906","TSTrItm.chgLne()")); }

 /**. <pre>
  *=====================================================================
  * Methode "chgRef"
  * Get/Change current reference to world-entry
  * ##chgRef.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSWrld chgRef( /* get/change world-reference (back) */
   TSWrld nW) /* reference to new world-entry or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSWrld cW; /* current world-entry */
   /*=================================================================*/
    cW = Uid; /* save current reference to world-element */
    if(nW!=null)  Uid = nW; /* update world-reference if requested */
    return cW; /* return current/old world-reference */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkRef"
  * Check back-references to TrNodes. Return error-message if equal.
  * ##chkRef.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chkRef( /* check back-references of TrItem */
   TSTrItm cIt, /* second TrItem-Definition */
   boolean eq)  /* mode of comparison (equal='true'/notequal) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Nde==null || cIt.Nde==null) return null; /* still not assigned */
     /* do not check if Node is not valid referenced. Field may still
      * not be processed or item is not referenced */
    if((cIt.Nde==Nde)==eq) return null; /* references are OK */
    return TSLogg.getKey(eq?"TSTrItR2":"TSTrItR1"); /* mark error */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkRO" (This dummy-method is normally overlayed)
  * ##chkRO.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkRO(int i) { return true; }

 /**. <pre>
  *=====================================================================
  * Methode "chkTyp"
  * pruefen ob Objekt das angegebene Schluesselwort unterstuetzt
  * Routine liefert 'true', wenn es NICHT unterstuetzt wird
  * ##chkTyp.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkTyp( /* Schluesselwort pruefen */
   int msk) /* Maske der erlaubten Sub-Typen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return !TSOpts.chkMsk(Typ,msk); /* Antwort zurueckgeben */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * Version fuer ALLE GEMEINSAMEN Definitionen
  * Attention: Local version is handled FIRST!
  * Lokale Optionen im Argument 'tp' (Primzahlverfahren):
  *   2 - ITF-Datei soll erzeugt werden
  *   3 - clr-Option gesetzt
  *   5 - 'EnaW' ist aktiv
  *   7 - 'EnaH' ist aktiv
  * Achtung Sonderfall: tp==0 wenn xdb-Datei erzeugt werden soll
  * ##crDef.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   int     tp) /* Typ des Zeilenvorlaufs (prefix) und Optionen */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    if(n>0) return null; /* return and signal: no more lines */
    rs = (tp==0) ? "\t\t\t" : "\t\t"; /* Zeilenvorlauf setzen */
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(16): /* 'TrItemId' liefern */
        return rs + "TrItemId ( " + NrN + " )"; /* Stmt erzeugen */
      case(17): /* 'TrItemSData' requested */
        return(rs + "TrItemSData (" + TSUtil.putFV(Offs,0) + " " +
              TSUtil.toHex(Opt,8) + " )"); /* create line */
      case(18): /* 'TrItemPData' ist definiert */
        return rs + "TrItemPData (" + Pos[1].getPos(2) + " )";
      case(19): /* 'TrItemRData' ist definiert */
        return rs + "TrItemRData (" + Pos[0].getPos(1) + " )";
          /* Stmt erzeugen und liefern */
      case(21): /* '...TritemData' ist definiert */
        /* Systemfehler: ungueltige Kennung benutzt */
        if(me) return TSLogg.getMsg("TSTrItC1",getName(Typ),Nr,t);
        return rs + "??? ( ??? )"; /* Dummy liefern */
      default: /* Fehlerhafte Definition kennzeichnen */
        if(me) return TSLogg.getMsg("TSTrItC2",getName(Typ),Nr,t);
        return rs+"TSTrItC$-Error("+t+"{"+Nr+"})";  /* Stmt erzeugen */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crPos"
  * Information-Hiding: Positionswerte als TSQPos-Objekt liefern
  * Achtung: Es wird eine (shallow-)Kopie geliefert, sodass die Attribute
  *          dieses Objektes (testweise) modifiziert werden koennen,
  *          ohne das Basisobjekt zu beeinflussen
  * ##crPos.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQPos crPos( /* Positionswerte als Vector liefern */
   int pt) /* Kennung des Positionstyps */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(pt<0 || pt>1) throw new /* Abbruch Programm mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","crPos",pt,1));
    if(Pos==null) return null; /* Positionswerte NICHT verfuegbar */
    if(Pos[pt]==null) return null; /* Positionswerte NICHT verfuegbar */
    return new TSQPos(Pos[pt]); /* Objekt-Kopie liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndWrld"
  * suchen und liefern der World-Definition gemaess 'Qx' und 'Qz'
  *    (Funktion wird in das Positionsobjekt delegiert)
  * ACHTUNG: Im Erfolgsfall wird die Quadrat-Referenz eingetragen!!
  * ##fndWrld.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQuad fndWrld( /* World-Definition liefern */
   TreeSet<TSQuad> qdf, /* Alle Quadrat-Definitionen der World-Dateien */
   int             t)   /* Nummer der World-Referenz */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(t<0 || t>1) return null; /* Parameter fehlerhaft */
    if(Pos==null) return null; /* Fehler: kein Speicher erstellt */
    if(Pos[t]==null) return null; /* Fehler: kein Objekt vorhanden */
    return Pos[t].fndWrld(qdf); /* Aktion delegieren */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getMsg"
  * Message gemaess Fehlerkennung erstellen
  * ##getMsg.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getMsg( /* (Fehler-)Meldung erstellen */
   int nr) /* Nummer der Meldung */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* Ergebnis-String */
   /*=================================================================*/
    if(Pos==null) return TSLogg.getMsg("TSTrItM0",nr);
    switch(nr) { /* gemaess Kennung erstellen */
      case(0): return TSLogg.getMsg("TSTrItM1",Pos[0].getPos(3));
      case(1): return TSLogg.getMsg("TSTrItM1",Pos[1].getPos(3));
      case(2): return TSLogg.getMsg("TSTrItM2",Pos[0].getPos(3));
      case(3): return TSLogg.getMsg("TSTrItM2",Pos[1].getPos(3));
    } /* gemaess Kennung beendet */
    return TSLogg.getMsg("TSTrItM9",nr); /* Dummy-Fehler */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * Diese Methode wird benutzt wenn in der abgeleiteten Klasse
  *  keine Methode 'getName()' definiert ist. Da dies (normalerweise)
  *  nicht der Fall ist, wird diese Methode nur fuer Objekte der
  *  Basisklasse verwendet. Diese haben keinen Namen.
  * ##getName.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName() /* Name des Objekt-Typs liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return getName(Typ); /* Item-Typ gemaess gespeicherter Nummer */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName" (statisch)
  * liefern der Bezeichnung eines TrItem-Typs
  * ##getName.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getName( /* Name eines TrItem-Typs liefern */
   int t) /* geforderten TrItem-Typ */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* gemaess Item-Typ verzweigen */
      case( 0): return "EmptyItem"; /* Bezeichnung liefern */
      case( 1): return "SignalItem"; /* Bezeichnung liefern */
      case( 2): return "PlatformItem"; /* Bezeichnung liefern */
      case( 3): return "SidingItem"; /* Bezeichnung liefern */
      case( 4): return "SpeedPostItem"; /* Bezeichnung liefern */
      case( 5): return "CarSpawnerItem"; /* Bezeichnung liefern */
      case( 6): return "LevelCrItem"; /* Bezeichnung liefern */
      case( 7): return "HazzardItem"; /* Bezeichnung liefern */
      case( 8): return "PickupItem"; /* Bezeichnung liefern */
      case( 9): return "SoundRegionItem"; /* Bezeichnung liefern */
      case(10): return "CrossoverItem"; /* Bezeichnung liefern */
      default: return "<unknown>"; /* Objekt-Typ nicht bekannt */
    } /* Ende switch-Statement */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getNr"
  * Information-Hiding: Item-Identifikation liefern
  * ##getNr.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getNr( /* Item-Identifikation liefern */
   boolean orig) /* 'true' - originale Nr, 'false' - neue Nummer */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(orig) return Nr; /* originale Identifikation liefern */
    return NrN; /* neue Item-Identifikation liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getPos"
  * Positionsdefinition in mehreren Formen aufbereiten und liefern
  *   (Aktion wird an das Positionsobjekt delegiert)
  * ##getPos.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getPos( /* Position lesbar erstellen */
   int p, /* Nummer der Position (P-Data/R-Data) */
   int t) /* Typ der Aufbereitung */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return TSLogg.getMsg("TSTrItP1",p);
    if(p<0 || p>=Pos.length) /* Selektionswert ungueltig */
      return TSLogg.getMsg("TSTrItP2",p,Pos.length-1);
    if(Pos[p]==null) return "? ? ? ? ?"; /* return errorposition */
    return Pos[p].getPos(t); /* Position aufbereiten und liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTyp"
  * Information-Hiding: Track-Node-Typ liefern
  * ##getTyp.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getTyp() /* Track-Node-Typ liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Typ; /* aktuelles Ergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt"
  * Increment reference-counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = Cnt; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-Cnt); /* must not become negative */
    Cnt += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "setDta"
  * Store values of line 'TrItemSData'
  * Method returns 'true' if the values have been already set.
  * New values are stored in any case.
  * ##setDta.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean setDta( /* store 'TrItemSData'-line */
   double offs, /* new offset-value */
   int    opt)  /* new options */
   {
   /*-----------------------------------------------------------------*/
    boolean rslt; /* result: values replaced */
   /*=================================================================*/
    rslt = !Double.isNaN(Offs); /* value already set? */
    Offs = offs; /* store new 'Offset'-value */
    Opt  = opt;  /* store new options */
    return rslt; /* return flag */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setID"
  * ID-Wert korrigieren (ID-Wert von 'Index' nach 'TrItemID')
  * Methode liefert ALTEN ID-Wert
  * Wenn die ID-Werte neu/alt schon unterschiedlich sind (Fehler), wird
  *  MIN_VALUE geliefert
  * ##setID.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int setID( /* ID-Wert korrigieren */
   int     id,  /* neuer ID-Wert */
   boolean flg) /* Flagwerte anpassen wenn 'false' */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    if(Nr!=NrN) return Integer.MIN_VALUE; /* Fehler: veraenderter Wert */
    i = Nr; /* aktueller Wert merken */
    Nr = NrN = id; /* neue aktuelle Nummer uebertragen */
    if(flg) return i; /* Ende -- ID-Wert vor Aktion liefern */
    clrMsk(2);  /* Kennzeichen 'index' entfernen (falls gesetzt) */
    setMsk(16); /* und neues Kennzeichen ('TrItemID') hinzufuegen */
    return i; /* ID-Wert vor Aktion liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "setIRef" (This dummy-method is normally overlayed)
  * ##setIRef.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC setIRef(int i, int j) { return null; }

 /**. <pre>
  *=====================================================================
  * Methode "setNr"
  * neue Kennung der TrItem-Definition setzen
  * Methode liefert den Originalwert
  * ##setNr.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int setNr( /* Nummer des TrItem-Eintrags neu setzen */
   int ix) /* neue TrItemID (neu) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    if(ix<0) throw new IllegalArgumentException
      (TSLogg.getMsg("Msg901","TSTrItem.setNr()",ix,1));
      /* Systemerror - terminate */
    i  = NrN; /* alten Index merken */
    NrN = ix; /* neue TrItem-Nummer setzen */
    return i; /* Original-Nummer liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setPos"
  * Positionsobjektes speichern
  * Achtung: 'RetVal' wird benutzt!
  * ##setPos.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setPos( /* Positionswerte speichern */
   int    pt, /* Kennung des Positionstyps */
   TSQPos cP) /* neues Positionsobjekt */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(pt<0 || pt>1) return TSLogg.getMsg("TSTrItP0",pt);
    if(Pos==null) return TSLogg.getMsg("TSTrItP1",pt);
    TSUtil.RetVal = Pos[pt]; /* Originalwert sichern falls vorhanden */
    Pos[pt] = cP; /* neue Position uebertragen */
    return null; /* Methode beenden (Methode OK -- kein Fehler) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setTrNde"
  * Rueck-Referenz auf referenzierende Track-Node (TrItemRef) setzen
  * Methode liefert den alten Wert VOR der Aenderung
  * ACHTUNG: 'Wert nur lesen' erfolgt mit ZWEIMALIGEM Aufruf
  * ##setTrNde.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSTrNde setTrNde( /* Rueck-Referenz zu Track-Node setzen */
   TSTrNde r)  /* neue Referenz */
   {
   /*-----------------------------------------------------------------*/
    TSTrNde v; /* intermediate value */
   /*=================================================================*/
    v = Nde; /* alte Referenz merken */
    Nde = r; /* neue Referenz setzen */
    return v; /* alte Referenz liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setTyp" (statisch)
  * Item-Typ pruefen und liefern
  * ##setTyp.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int setTyp( /* TrItem-Typkennung pruefen */
   String kw) /* Name des Objekt-Typs (lowercase) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(kw==null) return -2; /* ungueltige Typ-Kennung */
    if(kw.equals("emptyitem")) return 0; /* Typ-Kennung liefern */
    if(kw.equals("signalitem")) return 1; /* Typ-Kennung liefern */
    if(kw.equals("platformitem")) return 2; /* Typ-Kennung liefern */
    if(kw.equals("sidingitem")) return 3; /* Typ-Kennung liefern */
    if(kw.equals("speedpostitem")) return 4; /* Typ-Kennung liefern */
    if(kw.equals("carspawneritem")) return 5; /* Typ-Kennung liefern */
    if(kw.equals("levelcritem")) return 6; /* Typ-Kennung liefern */
    if(kw.equals("hazzarditem")) return 7; /* Typ-Kennung liefern */
    if(kw.equals("pickupitem")) return 8; /* Typ-Kennung liefern */
    if(kw.equals("soundregionitem")) return 9; /* Typ-Kennung liefern */
    if(kw.equals("crossoveritem")) return 10; /* Typ-Kennung liefern */
    return -1; /* Kennung fuer unbekannten Item-Typ */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return toStr(true); /* use alternate method */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTrItm (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr( /* Create String-version of values */
   boolean term) /* add termination ? */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = "TSTrItm{" + Nr + "(" + NrN + ")-R(";
    if(Pos==null) rs += "<null>)-P(<null>";
    else { /* Positionsdefinitionen sind moeglich */
      if(Pos[0]!=null) rs += Pos[0].toStr() + ")-P(";
      else rs += "<null>)-P(";
      if(Pos[1]!=null) rs += Pos[1].toStr();
      else rs += "<null>";
    } /* Positionsdefinitionen */
    rs += ")-"+Cnt+"-";
    rs += super.toStr(); /* add basic values */
    rs += "-" + Typ + ":";
    if(term) rs += "[]}"; /* set termination */
    return rs; /* provide result-string */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSTrItm01 -- Definition eines TrItem-Sub-Eintrags
 * ##TSTrItm01 (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTrItm01 extends TSTrItm { /* TrItem-Typ: 'SignalItem' */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.6.04 05.10.2011";
 /*-------------------------------------------------------------------*/
  private ArrayList<TSTrItm01T> SgDir;  /* Signal(R)Dir-References */
  private int                   Opt;    /* 'TrSignalType'-Options */
  private int                   Pos;    /* Referenzposition (0,1) */
  private double                Abst;   /* distance to node */
  private TSSigTyp              SgR;    /* SignalType-Reference */
  private String                Name;   /* Signalscript-Name */
/**. <pre>
  * Additional/used options stored in Mask-Value of 'TSOpts':
  *     16 : 'TrItemId'
  *     17 : 'TrItemSData'
  *     19 : 'TrItemRData'
  *     21 : 'TrSignalType'
  *     22 : 'TrSignal(R)Dir'
  * Flag-Bits used within Option-value ('Opt'='TrSignalType()'):
  *      0 : 'JN_LINK' is active
  *      1 : 'DECOR' (not signaled)
  *      2 : 'SIGNAL_HEAD' (not signaled)
  *      3 : 'ANUM_DISPLAY' (not signaled)
  *      4 : 'NUMBER_PLATE' is active
  *      5 : 'GRADIENT_PLATE' is active
  *      6 : 'USER1' is active
  *      7 : 'USER2' is active
  *      8 : 'USER3' is active
  *      9 : 'USER4' is active
  *  10-30 : (not used)
  *     31 : Option value is NOT valid (not set until now)
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm01() /* TrItem-SubTyp-Definition erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Opt   = Integer.MIN_VALUE; /* TrSignaltype-Options are not valid */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm01( /* TrItem-SubTyp-Definition erstellen */
   int ItNr) /* index of item */
   {
    super(1,ItNr); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    SgDir = null; /* keine Signal(R)Dir-Tabelle eingestellt */
    Opt   = Integer.MIN_VALUE; /* TrSignaltype-Options are not valid */
    Pos   = 0;    /* Referenzposition noch nicht gesetzt */
    Abst  = 0.0;  /* Defaultwert fuer Abstand */
    SgR   = null; /* keine Signal-Type-Referenz vorhanden */
    Name  = null; /* kein Signalscript eingetragen */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create copy-entry from template
  * Attention: Copy is NOT complete. Some values are not copied from
  *            template. (compare to super-class, too)
  *=====================================================================
  </pre>*/
  protected TSTrItm01( /* TrItem-SubTyp-Definition erstellen */
   TSTrItm01 cIt,  /* TrItem-definition used as template */
   int       ItNr, /* new TrItemID of item */
   boolean   ext)  /* copy extension too? */
   {
    super(cIt,1,ItNr); /* copy values from parent (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(ext) SgDir = cIt.SgDir; /* copy reference to Signal(R)Dir-table */
    else clrMsk(22); /* delete definitions if already present */
    Opt   = Integer.MIN_VALUE; /* TrSignaltype-Options are not valid */
    Pos   = cIt.Pos;  /* Referenzposition kopieren */
    Abst  = cIt.Abst; /* Abstandswert kopieren */
    SgR   = cIt.SgR;  /* Signal-Type-Referenz uebertragen */
    Name  = cIt.Name; /* Name des Signalscripts setzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgSigT"
  * neue aktuelle Signal-Type-Referenz liefern oder aendern
  * wenn sh==null: liefern aktuellen Wert (information-Hiding)
  * ##chgSigT.TSTrItm01 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSSigTyp chgSigT( /* Signal-Type-Referenz neu setzen */
   TSSigTyp st) /* Signal-Type-Referenz oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSSigTyp cst; /* intermediate value */
   /*=================================================================*/
    cst = SgR; /* alte Signal-Type-Referenz merken */
    if(st!=null) { /* neue Signal-Type-Referenz setzen */
      SgR = st; /* neue Signal-Type-Referenz setzen */
      if(SgR.chkMsk(16)) Name = SgR.getNme(); /* neuen Namen setzen */
    } /* neue Signal-Type-Referenz wurde eingetragen */
    return cst; /* alte Signal-Type-Referenz liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkSgD"
  * Aktuelles Array der definierten Signal(R)Dir-Referenzen ueberpruefen
  *   und ggf. loeschen. Kennung zuruecksetzen falls notwendig.
  * Methode meldet ob Kennung zurueckgesetzt wurde (Antwort='true')
  * ##chkSgD.TSTrItm01 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkSgD() /* TrSignalDir-Tabelle pruefen */
   {
   /*-----------------------------------------------------------------*/
    boolean cM; /* current marker */
   /*=================================================================*/
    cM = clrMsk(22); /* Praeventiv Kennung loeschen */
    if(SgDir==null) return cM; /* Keine Tabelle vorhanden */
    if(SgDir.size()<=0) { /* Tabelle vorhanden aber leer -- loeschen */
      SgDir = null; /* Tabelle entfernen */
      return cM;   /* und Veraenderung im Status melden */
    } /* Tabelle war vorhanden aber leer */
    if(cM) setMsk(22); /* Kennung war gesetzt -- wieder setzen */
    return false; /* Kennung wurde NICHT veraendert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * Optionen ('tp'): Vergleiche 'gemeinsame Version'
  * ##crDef.TSTrItm01 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   int     tp) /* Typ des Zeilenvorlaufs (prefix) und Optionen */
   {
   /*-----------------------------------------------------------------*/
    TSTrItm01T cSg;  /* current TrackNode-Reference */
    TSVector   cNde; /* current vector-node */
    String     rs;   /* result-string */
    String     is;   /* Zwischenwert */
    int        c;    /* Anzahl der Tabellenelemente */
   /*=================================================================*/
    rs = (tp==0) ? "\t\t\t" : "\t\t"; /* Zeilenvorlauf setzen */
    if(t==21) { /* 'TrSignalType' liefern */
      if(n>0) return null; /* keine weitere Zeile mehr */
      rs += "TrSignalType ( " + TSUtil.toHex(Opt,8) + " " +
             Pos + TSUtil.putFV(Abst,0) + " ";
      if(SgR==null) is = Name; /* keine Referenz -- Original verwenden */
      else is = SgR.getNme(); /* aktuellen Namen des SignalType's */
      if(is==null) is = "?"; /* Dummy-Kennung, falls Name fehlt */
      rs += TSUtil.modStr(is) + " )";
      return rs; /* Methode beenden -- Itemzeile liefern */
    } /* 'TrSignalType'-Stmt erzeugen  und liefern */
    if(t==22) { /* 'TrSignal(R)Dir' liefern */
      if(SgDir==null) { /* Fehler -- kein Speicher erstellt */
        if(!me) return null; /* Abbrechen -- keine weitere Zeile mehr */
        return TSLogg.getKey("TSIt01C1"); /* Meldung liefern */
      } /* Fehler bearbeiten */
      if((c=SgDir.size())==0) return null; /* KEINE Zeilen erstellen */
      if(n==0) /* Basiszeile soll erstellt werden */
        return rs + "TrSignalDirs ( " + c; /* Basiszeile liefern */
      n -= 1; /* Index berechnen (aus laufender Nummer) */
      if(n==c) return rs+")"; /* Abschlusszeile liefern */
      if(n>c) return null; /* Ende -- keine weitere Zeile mehr */
      cSg = SgDir.get(n); /* aktuelles Element holen */
      if(tp==0) { /* 'xdb'-Datei('.tdb','.rdb') wird erzeugt */
        if(cSg==null) { /* Referenz nicht gesetzt */
          if(me) return TSLogg.getMsg("TSIt01C2",n); /* Fehler -- Node fehlt */
          return "\t\t\t\tTrSignalDir ( 0 0 0 0 )"; /* Dummy-Stmt liefern */
        } /* Referenz nicht definiert */
        return cSg.crDef(0,me,n); /* 'TrSignalDir'-Stmt erzeugen  und liefern */
      } /* 'xdb'-Datei wurde erzeugt */
      /* jetzt sollen die Werte fuer die 'xit'-Datei('.tit','.rit') erstellt werden */
      if(cSg==null) { /* Referenz nicht gesetzt */
        if(me) return TSLogg.getMsg("TSIt01C3",n); /* Fehler -- Node fehlt */
        return "\t\t\tTrSignalRDir ( 0 0 0 0 0 3.1415 )"; /* Dummy-'TrSignalRDir'-Stmt */
      } /* TrSignalDir-Definition NICHT verfuegbar */
      return cSg.crDef(tp,me,n); /* 'TrSignalDir'-Stmt erzeugen und liefern */
    } /* 'TrSignal(R)Dir'-Stmt erzeugen  und liefern */
    return super.crDef(t,n,me,tp); /* gemeinsame Definition nutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getSgD"
  * Aktuelles Array der definierten Signal(R)Dir-Referenzen liefern
  *   und ggf. (neu) erstellen
  * Wenn fuer 'c' ein Wert 'groesser 0' angegeben wird, wird die
  *   Tabelle neu angelegt. Dies erfolgt AUCH, wenn die Tabelle
  *   bereits existiert!
  * ##getSgD.TSTrItm01 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSTrItm01T> getSgD( /* TrSignalDir-Tabelle erst. */
   int c) /* erwartete Anzahl der Definitionen (init) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c>0) SgDir = new ArrayList<TSTrItm01T>(c); /* neu anlegen */
    return SgDir; /* (neue) TrSignalDir-Tabelle/'null' liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setSigO"
  * 'TrSignatItem'-Optionen setzen
  * Achtung: Methode ueberschreibt ALLE Maskenbits mit neuem Wert
  * Lesen der Optionen mit zweimaligem Aufruf der Methode moeglich:
  *     'setSigO(i=setSigO(0))' liefert Wert nach i
  * ##setSigO.TSTrItm01 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int setSigO( /* TrSignalItem-Optionen setzen */
   int opt) /* Maske der NEUEN Optionen */
   {
   /*-----------------------------------------------------------------*/
    int i; /* Arbeitswert */
   /*=================================================================*/
    i = Opt; /* ALTE Optionenmaske merken */
    Opt = opt; /* NEUE Optionenmaske ohne Nachfrage ueberschreiben */
    return i; /* ALTE Optionenmaske liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setSigT"
  * Werte aus 'TrSignalType'-Eintrag setzen
  * Sonderfall: Name des Signal-Scripts/Signal-Types liefern.
  * ##setSigT.TSTrItm01 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setSigT( /* TrSignalType-Werte setzen */
   int    opt,  /* Signal-Optionen des Items */
   int    pos,  /* Positionsschalter (0/1) */
   double abst, /* Abstandswert */
   String s)    /* SignalType-Name / Signalscript */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(s==null) return Name; /* Sonderfall beachten */

    Opt  = opt;  /* Signal-Subtyp-Optionen uebertragen */
    Pos  = pos;  /* Positionsreferenz uebertragen */
    Abst = abst; /* Abstandswert setzen */
    Name = s;    /* Name des Signalscripts setzen */
    return null; /* Methode beenden (Methode OK -- kein Fehler) */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTrItm01 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    TSTrItm01T cSg; /* current TrackNode-Reference */
    String     rs;  /* result-String */
    int        i;   /* temporary value(s) */
   /*=================================================================*/
    rs = toStr(false); /* Basisdefinition erstellen */
    if(SgDir==null) rs += "[0("; /* keine Referenz vorhanden */
    else { /* Node-Referenzen aufbereiten */
      rs += "[" + SgDir.size() + "(";
      for(i=0;i<SgDir.size();i+=1) { /* einzelne Referenzen aufb. */
        if(i>0) rs += ","; /* Trennzeichen einfuegen */
        if((cSg=SgDir.get(i))==null) rs += "<null>"; /* Dummy-Wert */
         else rs += cSg.toStr(); /* Eintrag aufbereiten */
      } /* alle Referenzen aufbereiten */
    } /* Referenzen sind vorhanden */
    rs += ")("+TSUtil.toHex(Opt,-8)+","+Pos+","+Abst+",'"; /* first part */
    if(SgR==null) rs += Name + "')]}"; /* Abschluss 2. Teil */
    else rs += SgR.getNme() + "')]}"; /* Abschluss 2. Teil */
    return rs; /* provide result-string */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSTrItm01T -- Definition eines Referenz-Eintrags eines
 *                      SignalItems (Tabellenelement zu TrackNode)
 * Klasse wird zur TrackNode-Referenz bei 'Signal(R)Dir' benutzt.
 * ##TSTrItm01T (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTrItm01T implements Serializable { /* 'SignalItem'-Ref-Entry */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 10.08.2008";
 /*-------------------------------------------------------------------*/
  private int                   TrNdeNr; /* TrackNode-Nr (Original) */
  private TSTrNde               TrNde;  /* TrackNode-Referenz */
  private TSQPos                Pos;    /* Positionsdefiniton (vollst.) */
  private double                R;      /* relative Richtung (PI=Nord) */
  private String                Stmt;   /* Rest der Definition (*.tdb) */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm01T() /* Referenz-Eintrag fuer SignalItem erst. */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    TrNdeNr = -1;         /* keine TrackNode-Nummer bekannt */
//    TrNde   = null;       /* keine TrackNode-Referenz eingestellt */
//    Pos     = null;       /* Positionsdefinition noch nicht gesetzt */
    R       = Double.NaN; /* kein gueltiger Wert eingetragen */
//    Stmt    = null;       /* noch keine Daten vorhanden */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm01T( /* Referenz-Eintrag fuer SignalItem erst. */
   int     nr, /* TrackNode-Nummer des TrSignalDir-Stmts */
   TSTrNde rf, /* TrackNode-Referenz des TrSignalDir-Stmts */
   String  df) /* Rest der TrSignalDir-Definition */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    TrNdeNr = nr; /* TrackNode-Nummer uebertragen */
    TrNde   = rf; /* TrackNode-Referenz uebertragen */
    Stmt    = df; /* Werte der restlichen Definition eintragen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "adjHgt"
  * Hoehenwert fuer Signalreferenz korrigieren
  *   Ergebniswert muss nicht geprueft werden
  * ##adjHgt.TSTrItm01T (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String adjHgt( /* Hoehenwert veraendern */
   double d) /* Korrekturwert der Hoehe */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return TSLogg.getKey("TSIt01A1");
    Pos.addPosY(d); /* Hoehenwert korrigieren */
//    if((i=Pos.addPosY(d))!=0) return TSLogg.getMsg("TSIt01A2",i);
    return null; /* Methode beenden -- kein Fehler */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgDir"
  * relativer Richtungswert speichern /liefern
  * ##chgDir.TSTrItm01T (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected double chgDir( /* Richtung speichern/liefern */
   double r) /* Korrekturwert */
   {
   /*-----------------------------------------------------------------*/
    double cR; /* Zwischenwert */
   /*=================================================================*/
    cR = R; /* aktuellen Wert speichern */
    if(!Double.isNaN(r)) R = r; /* neuen Wert speichern */
    return cR; /* OK - alten Wert zurueckgeben */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkTrN"
  * TSTrNode-Definition ueberpruefen ob gesetzt
  * Achtung: Methode liefert Fehlermeldung wenn die Referenz NICHT
  *          vorhanden oder ungueltig ist
  * ##chkTrN.TSTrItm01T (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chkTrN( /* TSTrNode-Definition pruefen */
    ArrayList<TSTrNde> TrN) /* TrackNode-DB-Tabelle zum pruefen */
   {
   /*-----------------------------------------------------------------*/
    int i,j; /* Zwischenwert */
   /*=================================================================*/
    if(TrNde==null) return TSLogg.getKey("TSIt01T1");
      /* pruefen ob Referenz definiert -- nein -> Meldung */
    i = TrNde.getNr(true); /* Nummer der Referenz (Original) holen */
    if((j=TrNde.getTyp())<3) return TSLogg.getMsg("TSIt01T2",i,j);
      /* Typ der TrackNode falsch -- melden */
    if(TrN==null) return null; /* keine weitere Pruefung */
    if(TrN.contains(TrNde)) return null; /* Referenz definiert -- OK */
    return TSLogg.getMsg("TSIt01T3",i); /* Ref. nicht in Tabelle */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition fuer die Ausgabe erzeugen
  * 'TrSignalDir'-Ausgabe erzeugen wenn Argument tp==0
  *   sonst 'TrSignalRDir'
  * ##crDef.TSTrItm01T (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendef. fuer 'TrSignal(R)Dir' erzeugen */
   int     tp, /* Kennung der geforderten Ausgabe (und Optionen) */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   int     n)  /* Nummer des 'TrSignal(R)Dir'-Stmt fuer Meldung */
   {
   /*-----------------------------------------------------------------*/
    int    i;  /* Arbeitswert */
    String is; /* Zwischenwert */
   /*=================================================================*/
    if(tp==0) { /* 'xdb'-Datei('.tdb','.rdb') wird erzeugt */
      if(TrNde==null) { /* TrackNode-Referenz nicht gueltig *
        if(me) return TSLogg.getMsg("TSIt01CA",n); /* Nodenummer fehlt */
        i = TrNdeNr; /* Node-Nummer durch Original ersetzen */
      } else i = TrNde.getNr(false); /* Nummer der Referenz liefern */
      return "\t\t\t\tTrSignalDir ( " + i + Stmt + ")";
        /* 'TrSignalDir'-Stmt erzeugen  und liefern */
    } /* 'xdb'-Datei wurde exzeugt */
    /* jetzt sollen die Werte fuer die 'xit'-Datei('.tit','.rit')
     * erstellt werden */
    if((i=getNdeTyp())<3) { /* keine JunctionNode verkettet -- Fehler */
      if(!me) return null; /* Abbrechen -- keine weitere Zeile mehr liefern */
      return TSLogg.getMsg("TSIt01CB",null,n,i); /* Fehlermeldung liefern */
    } /* Systemfehler in Node-Verkettungen gefunden */
    if(Pos==null) {  /* Position nicht definiert */
      if((tp%3)==0) { /* Referenzwert auf '?' setzen (clr-Option gesetzt) */
        if(me) /* Fehlermeldung gefordert, falls aktiviert */
         if((tp%5)==0) return TSLogg.getMsg("TSIt01CC",n); /* EnaW aktiv */
           /* Warnung liefern: Referenz auf '?' gesetzt */
        is = " 0 0 0 ? ?"; /* Quadranten-Wert loeschen, damit ungueltig machen */
      } else { /* Originalwerte muessen uebernommen werden */
        if(me) /* Fehlermeldung gefordert, falls aktiviert */
         if((tp%7)==0) return TSLogg.getMsg("TSIt01CD",n); /* EnaH aktiv */
           /* Hinweis liefern: 0-Referenz eingesetzt */
        is = " 0 0 0 0 0"; /* syntaktisch richtige, ungueltige Werte ben. */
      } /* Originalwerte wurden uebernommen */
    } else { /* Positionsdefinition vorhanden -- weiter pruefen */
      if(Pos.noRef()) /* nur Originalwerte verfuegbar */
       if(me) /* Fehlermeldung gefordert, falls aktiviert */
        if((tp%5)==0) return TSLogg.getMsg("TSIt01CE",n); /* EnaW aktiv */
      is = Pos.getPos(1); /* neue korrekte Werte erstellen */
    } /* Positionsdefinition war vorhanden */
    return "\t\t\tTrSignalRDir (" + is + TSUtil.putFV(R,0) + " )";
          /* 'TrSignalRDir'-Stmt erzeugen  und liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crPos"
  * Information-Hiding: Positionswerte als TSQPos-Objekt liefern
  * Achtung: Es wird eine (shallow-)Kopie geliefert, sodass die Attribute
  *          dieses Objektes (testweise) modifiziert werden koennen,
  *          ohne das Basisobjekt zu beeinflussen
  * ##crPos.TSTrItm01T (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQPos crPos() /* Positionswerte als Vector liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return null; /* Positionswerte NICHT verfuegbar */
    return new TSQPos(Pos); /* return (shallow-) copy of object */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndWrld"
  * suchen und liefern der World-Definition gemaess 'Qx' und 'Qz'
  *    (Funktion wird in das Positionsobjekt delegiert)
  * ACHTUNG: Im Erfolgsfall wird die Quadrat-Referenz eingetragen!!
  * ##fndWrld.TSTrItm01T (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQuad fndWrld( /* World-Definition liefern */
   TreeSet<TSQuad> qdf) /* Alle Quadrat-Definitionen der World-Dateien */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return null; /* Fehler: kein Speicher erstellt */
    return Pos.fndWrld(qdf); /* 'Pos'-object searches for reference */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getNdeTyp"
  * NodeTyp der verketteten TrackNode liefern
  * ##getNdeTyp.TSTrItm01T (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getNdeTyp() /* NodeTyp der verk. TrackNode liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(TrNde==null) return 0; /* Typ nicht bekannt */
    return TrNde.getTyp(); /* get current node-type and return it */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setPos"
  * neues Positionsobjektes speichern/ersetzen (unbedingt)
  * ##setPos.TSTrItm01T (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQPos setPos( /* Positionsobjekt speichern */
   TSQPos cP) /* neues Positionsobjekt */
   {
   /*-----------------------------------------------------------------*/
    TSQPos cPos; /* Original-Wert */
   /*=================================================================*/
    cPos = Pos; /* Originalwert sichern falls vorhanden */
    Pos = cP; /* neue Position uebertragen */
    return cPos; /* Methode beenden (Originalwert liefern) */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTrItm01T (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-String */
   /*=================================================================*/
    if(TrNde==null) return "TrItm01T{<null>}"; /* Dummy-value */
    rs = "TrItm01T{" + TrNde.getNr(true) + "(" +
          TrNde.getNr(false) + ")-(";
    if(Pos!=null) rs += Pos.toStr();
    else rs += "<null>"; /* Positionsdefinition aufbereiten */
    rs += ")-" + R + "-'" + Stmt + "'}";
    return rs; /* provide result-string */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSTrItm02 -- Definition eines TrItem-Sub-Eintrags
 * ##TSTrItm02 (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTrItm02 extends TSTrItm { /* TrItem-Typ: 'PlatformItem' */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 14.07.2008";
 /*-------------------------------------------------------------------*/
  private int                   IOt;    /* Interconnection-Optionen */
  private TSRefC                IRef;   /* Interconnection-Referenz */
  private String[]              Lne;    /* additional lines */
/**. <pre>
  * Additional/used options stored in Mask-Value of 'TSOpts':
  *     16 : 'TrItemId'
  *     17 : 'TrItemSData'
  *     19 : 'TrItemRData'
  *     21 : 'PlatformTrItemData'
  *     24 : 'PlatformName' (individual) (stored in Lne[0])
  *     25 : 'Station' (individual) (stored in Lne[1])
  *     26 : 'PlatformMinWaitingTime' (individual) (stored in Lne[2])
  *     27 : 'PlatformNumPassengersWaiting' (individual) (Lne[3])
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm02() /* TrItem-SubTyp-Definition erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    IOt  = 0;    /* keine Referenz-Optionen eingetragen */
//    IRef = null; /* keine TrItem-Referenz eingetragen */
    Lne  = null; /* no space for additional lines allocated */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm02( /* TrItem-SubTyp-Definition erstellen */
   int ItNr) /* index of item */
   {
    super(2,ItNr); /* Basiswerte setzen ---RESTRICTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    IOt = 0;    /* keine Referenz-Optionen eingetragen */
    IRef = null; /* keine TrItem-Referenz eingetragen */
    Lne = new String[4]; /* space for additional definition-lines */
    Arrays.fill(Lne,null); /* no data stored */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgLne"
  * Set or Change addiltional line-definitions
  * ##chgLne.TSTrItm02 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String chgLne( /* modify additional line-definitions */
   int    ix,  /* relative index of line-definition */
   String lne) /* new value of line */
   {
   /*-----------------------------------------------------------------*/
    String cL; /* old/current line-value */
   /*=================================================================*/
    if(ix<0 || ix>3) throw new IllegalArgumentException( /* system-err */
      TSLogg.getMsg("Msg901","TSTrItm02.chgLne()",ix,1));
    cL = Lne[ix]; /* save/get current value of line */
    if(lne!=null) Lne[ix] = lne; /* transfer value if requested */
    return cL; /* OK - return old/current value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkRO"
  * Check value of reference options
  * ##chkC.TSTrItm02 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean chkRO( /* check reference options */
   int v) /* required value of part of options */
   {
   /*-----------------------------------------------------------------*/
    int i; /* modified options */
   /*=================================================================*/
    i = IOt >> 16; /* correct value -- delete part of the options */
    if(v==i) return false; /* valid value found */
    return true; /* return marker for 'invalid' */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * Optionen ('tp'): Vergleiche 'gemeinsame Version'
  * ##crDef.TSTrItm02 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   int     tp) /* Typ des Zeilenvorlaufs (prefix) und Optionen */
   {
   /*-----------------------------------------------------------------*/
    String  rs;  /* result-string */
    String  is;  /* Zwischenwert */
    TSTrItm cIt; /* verbundener TrItem-Eintrag */
   /*=================================================================*/
    rs = (tp==0) ? "\t\t\t" : "\t\t"; /* Zeilenvorlauf setzen */
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(21): /* 'PlatformTrItemData' liefern */
        if(n>0) return null; /* keine weitere Zeile mehr */
        rs += "PlatformTrItemData ( " + TSUtil.toHex(IOt,8) + " ";
        if(IRef==null) { /* Keine Zuordnung vorhanden -- melden */
          if(me) return TSLogg.getKey("TSIt02C1"); /* Fehlermeldung */
          rs += "0 )"; /* Dummy-Wert verwenden */
        } else if((cIt=(TSTrItm)IRef.chgRef(null))==null) { /* Original */
          n = IRef.chgNr(Integer.MIN_VALUE); /* Originalwert holen */
          if(me) return TSLogg.getMsg("TSIt02C2",n); /* Fehlermeldung */
          rs += n + " )"; /* Originalwert verwenden */
        } else rs += cIt.getNr(false) + " )";
        return rs; /* Methode beenden -- Itemzeile liefern */
      case(24): /* 'PlatformName' liefern */
        if(n>0) return null; /* keine weitere Zeile mehr */
        if((is=Lne[0])==null) { /* Datenwert nicht vorhanden */
          if(me) return TSLogg.getKey("TSIt02C3"); /* Fehlermeldung */
          is = ""; /* Dummy-wert verwenden */
        } /* Fehler aufgetreten */
        return rs + "PlatformName (" + is + ")"; /* Stmt erzeugen */
      case(25): /* 'Station' liefern */
        if(n>0) return null; /* keine weitere Zeile mehr */
        if((is=Lne[1])==null) { /* Datenwert nicht vorhanden */
          if(me) return TSLogg.getKey("TSIt02C4"); /* Fehlermeldung */
          is = ""; /* Dummy-wert verwenden */
        } /* Fehler aufgetreten */
        return rs + "Station (" + is + ")"; /* Stmt erzeugen */
      case(26): /* 'PlatformMinWaitingTime' liefern */
        if(n>0) return null; /* keine weitere Zeile mehr */
        if((is=Lne[2])==null) { /* Datenwert nicht vorhanden */
          if(me) return TSLogg.getKey("TSIt02C5"); /* Fehlermeldung */
          is = ""; /* Dummy-wert verwenden */
        } /* Fehler aufgetreten */
        return rs + "PlatformMinWaitingTime (" + is + ")";
         /* Statement erzeugen und liefern */
      case(27): /* 'PlatformNumPassengersWaiting' liefern */
        if(n>0) return null; /* keine weitere Zeile mehr */
        if((is=Lne[3])==null) { /* Datenwert nicht vorhanden */
          if(me) return TSLogg.getKey("TSIt02C6"); /* Fehlermeldung */
          is = ""; /* Dummy-wert verwenden */
        } /* Fehler aufgetreten */
        return rs + "PlatformNumPassengersWaiting (" + is + ")";
         /* Statement erzeugen und liefern */
    } /* Bearbeitung gemaess Typ-Kennung */
    return super.crDef(t,n,me,tp); /* gemeinsame Definition nutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setIRef"
  * neue Interconnection-Referenz-erstellen, speichern und liefern
  * Sonderfall id<0: NUR liefern aktuelle Referenz (information-Hiding)
  * ##setIRef.TSTrItm02 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC setIRef( /* Interconnection-Referenz bearbeiten */
   int id, /* neue Referenz */
   int z)  /* Zusatzwert fuer Speicherung */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(id<0) return IRef; /* Sonderfall: NUR Referenz liefern */
    IRef = new TSRefC(id); /* Referenz-Eintrag erstellen und setzen */
    IOt = z;  /* neuen Zusatzwert festhalten */
    return IRef; /* Referenzeintrag (zusaetzlich) liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTrItm02 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String  rs;  /* result-String */
    TSTrItm cIt; /* verbundener TrItem-Eintrag */
   /*=================================================================*/
    rs = toStr(false) + "["; /* Basisdefinition erstellen */
    if(IRef==null) rs += "?/<null>(<null>)"; /* Wert fehlt */
    else { /* Referenzeintrage existiert -- eintragen */
      rs += IRef.chgNr(Integer.MIN_VALUE) + "/";
      if((cIt=(TSTrItm)IRef.chgRef(null))!=null) /* Referenz OK */
        rs += cIt.getNr(true) + "(" + cIt.getNr(false) + ")";
      else rs += "<null>(<null>)"; /* Dummy-Werte anfuegen */
    } /* Referenzeintag wurde bearbeitet */
    rs += "]}"; /* Abschluss (gesamt) setzen */
    return rs; /* provide result-string */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSTrItm03 -- Definition eines TrItem-Sub-Eintrags
 * ##TSTrItm03 (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTrItm03 extends TSTrItm { /* TrItem-Typ: 'SidingItem' */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 14.07.2008";
 /*-------------------------------------------------------------------*/
  private int                   IOt;    /* Interconnection-Optionen */
  private TSRefC                IRef;   /* Interconnection-Referenz */
  private String                Lne;    /* additional line */
/**. <pre>
  * Additional/used options stored in Mask-Value of 'TSOpts':
  *     16 : 'TrItemId'
  *     17 : 'TrItemSData'
  *     19 : 'TrItemRData'
  *     21 : 'SidingTrItemData'
  *     24 : 'SidingName' (individual) (stored in 'Lne')
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm03() /* TrItem-SubTyp-Definition erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    IOt  = 0;    /* keine Referenz-Optionen eingetragen */
//    IRef = null; /* keine TrItem-Referenz eingetragen */
//    Lne  = null; /* no additional line set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm03( /* TrItem-SubTyp-Definition erstellen */
   int ItNr) /* index of item */
   {
    super(3,ItNr); /* Basiswerte setzen ---RESTRICTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    IOt  = 0;    /* keine Referenz-Optionen eingetragen */
    IRef = null; /* keine TrItem-Referenz eingetragen */
    Lne  = null; /* no additional line set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgLne"
  * Set or Change addiltional line-definitions
  * ##chgLne.TSTrItm03 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String chgLne( /* modify additional line-definitions */
   int    ix,  /* relative index of line-definition */
   String lne) /* new value of line */
   {
   /*-----------------------------------------------------------------*/
    String cL; /* old/current line-value */
   /*=================================================================*/
    if(ix!=0) throw new IllegalArgumentException( /* system-error */
      TSLogg.getMsg("Msg901","TSTrItm03.chgLne()",ix,1));
    cL = Lne; /* save/get current value of line */
    if(lne!=null) Lne = lne; /* transfer value if requested */
    return cL; /* OK - return old/current value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkRO"
  * Check value of reference options
  * ##chkC.TSTrItm03 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean chkRO( /* check reference options */
   int v) /* required value of part of options */
   {
   /*-----------------------------------------------------------------*/
    int i; /* modified options */
   /*=================================================================*/
    i = IOt >> 16; /* correct value -- delete part of the options */
    if(v==i) return false; /* valid value found */
    return true; /* return marker for 'invalid' */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * Optionen ('tp'): Vergleiche 'gemeinsame Version'
  * ##crDef.TSTrItm03 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   int     tp) /* Typ des Zeilenvorlaufs (prefix) und Optionen */
   {
   /*-----------------------------------------------------------------*/
    String  rs;  /* result-string */
    String  is;  /* Zwischenwert */
    TSTrItm cIt; /* verbundener TrItem-Eintrag */
   /*=================================================================*/
    rs = (tp==0) ? "\t\t\t" : "\t\t"; /* Zeilenvorlauf setzen */
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(21): /* 'SidingTrItemData' liefern */
        if(n>0) return null; /* keine weitere Zeile mehr */
        rs += "SidingTrItemData ( " + TSUtil.toHex(IOt,8) + " ";
        if(IRef==null) { /* Keine Zuordnung vorhanden -- melden */
          if(me) return TSLogg.getKey("TSIt03C1"); /* Fehlermeldung */
          rs += "0 )"; /* Dummy-Wert verwenden */
        } else if((cIt=(TSTrItm)IRef.chgRef(null))==null) { /* Original */
          n = IRef.chgNr(Integer.MIN_VALUE); /* Originalwert holen */
          if(me) return TSLogg.getMsg("TSIt03C2",n); /* Fehlermeldung */
          rs += n + " )"; /* Originalwert verwenden */
        } else rs += cIt.getNr(false) + " )";
        return rs; /* Methode beenden -- Itemzeile liefern */
      case(24): /* 'SidingName' liefern */
        if(n>0) return null; /* keine weitere Zeile mehr */
        if((is=Lne)==null) { /* Datenwert nicht vorhanden */
          if(me) return TSLogg.getKey("TSIt03C3"); /* Fehlermeldung */
          is = ""; /* Dummy-wert verwenden */
        } /* Fehler aufgetreten */
        return rs + "SidingName (" + is + ")"; /* Stmt erzeugen */
    } /* Bearbeitung gemaess Typ-Kennung */
    return super.crDef(t,n,me,tp); /* gemeinsame Definition nutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setIRef"
  * neue Interconnection-Referenz-erstellen, speichern und liefern
  * Sonderfall id<0: NUR liefern aktuelle Referenz (information-Hiding)
  * ##setIRef.TSTrItm03 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC setIRef( /* Interconnection-Referenz bearbeiten */
   int id, /* neue Referenz */
   int z)  /* Zusatzwert fuer Speicherung */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(id<0) return IRef; /* Sonderfall: NUR Referenz liefern */
    IRef = new TSRefC(id); /* Referenz-Eintrag erstellen und setzen */
    IOt = z;  /* neuen Zusatzwert festhalten */
    return IRef; /* Referenzeintrag (zusaetzlich) liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTrItm03 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String  rs;  /* result-String */
    TSTrItm cIt; /* verbundener TrItem-Eintrag */
   /*=================================================================*/
    rs = toStr(false) + "["; /* Basisdefinition erstellen */
    if(IRef==null) rs += "?/<null>(<null>)"; /* Wert fehlt */
    else { /* Referenzeintrage existiert -- eintragen */
      rs += IRef.chgNr(Integer.MIN_VALUE) + "/";
      if((cIt=(TSTrItm)IRef.chgRef(null))!=null) /* Referenz OK */
        rs += cIt.getNr(true) + "(" + cIt.getNr(false) + ")";
      else rs += "<null>(<null>)"; /* Dummy-Werte anfuegen */
    } /* Referenzeintag wurde bearbeitet */
    rs += "]}"; /* Abschluss (gesamt) setzen */
    return rs; /* provide result-string */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSTrItm04 -- Definition of a TrItem-subentry
 * ##TSTrItm04 (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTrItm04 extends TSTrItm { /* TrItem-type: 'SpeedpostTrItem' */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.06 17.02.2010";
 /*-------------------------------------------------------------------*/
  private String                Lne;    /* additional line */
/**. <pre>
  * Additional/used options stored in Mask-Value of 'TSOpts':
  *     16 : 'TrItemId'
  *     17 : 'TrItemSData'
  *     18 : 'TrItemPData'
  *     19 : 'TrItemRData'
  *     21 : 'SpeedpostTrItemData'
  *=====================================================================
  * Constructor: (1) create default-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm04() /* create default version of TrItem-subentry */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    Lne  = null; /* no additional line set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm04( /* create basic version of TrItem-subentry */
   int ItNr) /* index of item */
   {
    super(4,ItNr); /* set basic values ---RESTRICTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Lne  = null; /* no additional line set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgLne"
  * Set or Change addiltional line-definitions
  * ##chgLne.TSTrItm04 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String chgLne( /* modify additional line-definitions */
   int    ix,  /* relative index of line-definition */
   String lne) /* new value of line */
   {
   /*-----------------------------------------------------------------*/
    String cL; /* old/current line-value */
   /*=================================================================*/
    if(ix!=0) throw new IllegalArgumentException( /* system-error */
      TSLogg.getMsg("Msg901","TSTrItm04.chgLne()",ix,1));
    cL = Lne; /* save/get current value of line */
    if(lne!=null) Lne = lne; /* transfer value if requested */
    return cL; /* OK - return old/current value */
  }

 /**. <pre>
  *=====================================================================
  * Method "crDef"
  * Create output-line(s) for writing TrItem-definition
  * Options ('tp'): Compare to 'common version'
  * ##crDef.TSTrItm04 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String crDef( /* creat line-definiton */
   int     t,  /* Number of output-type (due to 'setMsk') */
   int     n,  /* serial number of output-line */
   boolean me, /* return message if applicable (only if 'true') */
   int     tp) /* type of line-prefix and options */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = (tp==0) ? "\t\t\t" : "\t\t"; /* set appropriate line-prefix */
    switch(t) { /* process due to output-type */
      case(21): /* 'SpeedpostTrItemData' requested */
        if(n>0) return null; /* return and signal: no more lines */
        rs += "SpeedpostTrItemData (" + Lne + ")"; /* create line */
        return rs; /* leave method -- return created line */
    } /* process line due to output-type */
    return super.crDef(t,n,me,tp); /* use common definition */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTrItm04 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-String */
   /*=================================================================*/
    rs = toStr(false); /* create basics */
    rs  += "('" + Lne + "')}";
    return rs; /* provide result-string */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSTrItm08 -- Definition of a TrItem-subentry
 * ##TSTrItm08 (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTrItm08 extends TSTrItm { /* TrItem-type: 'PickupItem' */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.03 22.06.2009";
 /*-------------------------------------------------------------------*/
  private int                   Mass;   /* Pickup-amount */
  private int                   Opt;    /* Pickup-options */
/**. <pre>
  * Additional/used options stored in Mask-Value of 'TSOpts':
  *     16 : 'TrItemId'
  *     17 : 'TrItemSData'
  *     18 : 'TrItemPData'
  *     19 : 'TrItemRData'
  *     21 : 'PickupTrItemData'
  *=====================================================================
  * Constructor: (1) create default-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm08() /* create default version of TrItem-subentry */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    Mass = 0;                 /* loading amount not set until now */
    Opt  = Integer.MIN_VALUE; /* no options inserted */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm08( /* create basic version of TrItem-subentry */
   int ItNr) /* index of item */
   {
    super(8,ItNr); /* set basic values ---RESTRICTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Mass = 0;                 /* loading amount not set until now */
    Opt  = Integer.MIN_VALUE; /* no options inserted */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Method "crDef"
  * Create output-line(s) for writing TrItem-definition
  * Options ('tp'): Compare to 'common version'
  * ##crDef.TSTrItm08 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String crDef( /* creat line-definiton */
   int     t,  /* Number of output-type (due to 'setMsk') */
   int     n,  /* serial number of output-line */
   boolean me, /* return message if applicable (only if 'true') */
   int     tp) /* type of line-prefix and options */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = (tp==0) ? "\t\t\t" : "\t\t"; /* set appropriate line-prefix */
    switch(t) { /* process due to output-type */
      case(21): /* 'PickupTrItemData' requested */
        if(n>0) return null; /* return and signal: no more lines */
        rs += "PickupTrItemData ( " + Mass + " " +
                TSUtil.toHex(Opt,8) + " )"; /* create line */
        return rs; /* leave method -- return created line */
    } /* process line due to output-type */
    return super.crDef(t,n,me,tp); /* use common definition */
  }

 /**. <pre>
  *=====================================================================
  * Method "setItm"
  * insert TrItemData-values
  * ##setItm.TSTrItm08 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean setItm( /* insert values of 'TrItemData' */
   int mass, /* new 'mass'-value */
   int opt)  /* new options */
   {
   /*-----------------------------------------------------------------*/
    boolean rslt; /* result: values replaced */
   /*=================================================================*/
    rslt = (Opt!=Integer.MIN_VALUE); /* value already set? */
    Mass = mass; /* insert new value for 'amount of pickup' */
    Opt  = opt;  /* store new options */
    return rslt; /* return flag */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTrItm08 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-String */
   /*=================================================================*/
    rs = toStr(false); /* create basics */
    rs  += "(" + Mass + "," + TSUtil.toHex(Opt,8) + ")}";
    return rs; /* provide result-string */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSTrItm09 -- Definition eines TrItem-Sub-Eintrags
 * ##TSTrItm09 (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTrItm09 extends TSTrItm { /* TrItem-Typ: 'SoundRegionItem' */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.3.03 12.01.2007";
 /*-------------------------------------------------------------------*/
  private int                   Type;   /* Typ-Nummer Soundregion */
  private double                SR2;    /* Abstandswert */
  private TStType               TRef;   /* Referenz zu Typ-Eintrag */
/**. <pre>
  * Additional/used options stored in Mask-Value of 'TSOpts':
  *     16 : 'TrItemId'
  *     17 : 'TrItemSData'
  *     18 : 'TrItemPData'
  *     19 : 'TrItemRData'
  *     21 : 'TritemSRData'
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm09() /* TrItem-SubTyp-Definition erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Type = -1;   /* noch kein Soundregionstyp zugeordnet */
    SR2  = -1;   /* kein Wert gespeichert */
//    TRef = null; /* keine Referenz zu ttype-Eintrag erstellt */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm09( /* TrItem-SubTyp-Definition erstellen */
   int ItNr) /* index of item */
   {
    super(9,ItNr); /* Basiswerte setzen ---RESTRICTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Type = -1;   /* noch kein Soundregionstyp zugeordnet */
    SR2  = -1;   /* kein Wert gespeichert */
    TRef = null; /* keine Referenz zu ttype-Eintrag erstellt */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgSR1Dta"
  * Datenwert 1 aus 'TrItemSRData' veraendern oder abfragen
  * ACHTUNG: Wert nicht setzen wenn 'r<0'
  * ##chgSR1Dta.TSTrItm09 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int chgSR1Dta( /* Datenwert 1 aus 'TrItemSRData' */
   int r) /* neue Referenz zu ttype-Eintrag */
   {
   /*-----------------------------------------------------------------*/
    int v; /* intermediate value */
   /*=================================================================*/
    v  = Type; /* alte Referenz merken */
    if(r>=0) Type = r; /* neue Referenz setzen */
    return v; /* alte Referenz liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgSR2Dta"
  * Datenwert 2 aus 'TrItemSRData' veraendern oder abfragen
  * ACHTUNG: Wert nicht setzen wenn 'w==NaN'
  * ##chgSR2Dta.TSTrItm09 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected double chgSR2Dta( /* Datenwert 2 aus 'TrItemSRData' */
   double w) /* neuen Wert */
   {
   /*-----------------------------------------------------------------*/
    double v; /* intermediate value */
   /*=================================================================*/
    v  = SR2; /* alten Wert merken */
    if(!Double.isNaN(w)) SR2 = w; /* neuen Wert setzen */
    return v; /* alten Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTRef"
  * Referenz auf ttype-Element (TStType) veraendern oder abfragen
  * ACHTUNG: Wert nicht setzen wenn 'r==null'
  * ##chgTRef.TSTrItm09 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TStType chgTRef( /* ttype-Referenz pflegen */
   TStType r) /* neue Referenz zu ttype-Eintrag */
   {
   /*-----------------------------------------------------------------*/
    TStType v; /* intermediate value */
   /*=================================================================*/
    v  = TRef; /* alte Referenz merken */
    if(r!=null) TRef = r; /* neue Referenz setzen */
    return v; /* alte Referenz liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * Optionen ('tp'): Vergleiche 'gemeinsame Version'
  * ##crDef.TSTrItm09 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   int     tp) /* Typ des Zeilenvorlaufs (prefix) und Optionen */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = (tp==0) ? "\t\t\t" : "\t\t"; /* Zeilenvorlauf setzen */
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(21): /* 'TrItemSRData' liefern */
        if(n>0) return null; /* keine weitere Zeile mehr */
        rs += "TrItemSRData ( 0 "; /* Basiswerte hinzufuegen */
        if(TRef==null) { /* Keine Zuordnung vorhanden -- melden */
          if(me) return TSLogg.getMsg("TSIt09C1",Type); /* F.-meldung */
          rs += "" + Type; /* Originalwert verwenden */
        } else rs += TRef.chgNr(-1);
        rs += TSUtil.putFV(SR2,0) + " )"; /* Abschluss der Zeile */
        return rs; /* Methode beenden -- Itemzeile liefern */
    } /* Bearbeitung gemaess Typ-Kennung */
    return super.crDef(t,n,me,tp); /* gemeinsame Definition nutzen */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTrItm09 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-String */
   /*=================================================================*/
    rs = toStr(false); /* Basisdefinition erstellen */
    rs += "[" + Type + "," + SR2 + ",(";
    if(TRef==null) rs += "<null>)]}"; /* Wert fehlt */
    else rs += TRef.chgNr(-1) + ")]}";
    return rs; /* provide result-string */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSTrItm10 -- Definition eines TrItem-Sub-Eintrags
 * ##TSTrItm10 (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTrItm10 extends TSTrItm { /* TrItem-Typ: 'CrossoverItem' */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 01.08.2008";
 /*-------------------------------------------------------------------*/
  private TSRefC                IRef;   /* Interconnection-Referenz */
  private TSRefC                SRef;   /* Shape-Referenz (Nr/Adr) */
/**. <pre>
  * Additional/used options stored in Mask-Value of 'TSOpts':
  *     16 : 'TrItemId'
  *     17 : 'TrItemSData'
  *     19 : 'TrItemRData'
  *     21 : 'CrossoverTrItemData'
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm10() /* TrItem-SubTyp-Definition erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    IRef = null; /* keine TrItem-Referenz eingetragen */
//    SRef = null; /* keine Shape-Referenz eingetragen */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSTrItm10( /* TrItem-SubTyp-Definition erstellen */
   int ItNr) /* index of item */
   {
    super(10,ItNr); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    IRef = null; /* keine TrItem-Referenz eingetragen */
    SRef = null; /* keine Shape-Referenz eingetragen */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * Optionen ('tp'): Vergleiche 'gemeinsame Version'
  * ##crDef.TSTrItm10 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   int     tp) /* Typ des Zeilenvorlaufs (prefix) und Optionen */
   {
   /*-----------------------------------------------------------------*/
    String  rs;  /* result-string */
    TSTrItm cIt; /* verbundener TrItem-Eintrag */
    TSShape cSh; /* Shape-Referenz */
   /*=================================================================*/
    rs = (tp==0) ? "\t\t\t" : "\t\t"; /* Zeilenvorlauf setzen */
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(21): /* 'CrossoverTrItemData' liefern */
        if(n>0) return null; /* keine weitere Zeile mehr */
        rs += "CrossoverTrItemData ( "; /* Basisteil setzen */
        if(IRef==null) { /* Keine Zuordnung vorhanden -- melden */
          if(me) return TSLogg.getKey("TSIt10C1"); /* Fehlermeldung */
          rs += "0 "; /* Dummy-Wert verwenden */
        } else if((cIt=(TSTrItm)IRef.chgRef(null))==null) { /* Original */
          n = IRef.chgNr(Integer.MIN_VALUE); /* Originalwert holen */
          if(me) return TSLogg.getMsg("TSIt10C2",n); /* Fehlermeldung */
          rs += n + " "; /* Originalwert verwenden */
        } else rs += cIt.getNr(false) + " ";
        if(SRef==null) { /* Keine Zuordnung vorhanden -- melden */
          if(me) return TSLogg.getKey("TSIt10C3"); /* Fehlermeldung */
          rs += "0 )"; /* Dummy-Wert verwenden */
        } else if((cSh=(TSShape)SRef.chgRef(null))==null) { /* Original */
          n = SRef.chgNr(Integer.MIN_VALUE); /* Originalwert holen */
          if(me) return TSLogg.getMsg("TSIt10C4",n); /* Fehlermeldung */
          rs += n + " )"; /* Originalwert verwenden */
        } else rs += cSh.getNr(false) + " )";
        return rs; /* Methode beenden -- Itemzeile liefern */
    } /* Bearbeitung gemaess Typ-Kennung */
    return super.crDef(t,n,me,tp); /* gemeinsame Definition nutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setIRef"
  * neue Interconnection-Referenz-erstellen, speichern und liefern
  * Sonderfall id<0: NUR liefern aktuelle Referenz (information-Hiding)
  * ##setIRef.TSTrItm10 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC setIRef( /* Interconnection-Referenz bearbeiten */
   int id, /* neue Referenz */
   int z)  /* Zusatzwert fuer Speicherung (hier nicht genutzt) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(id<0) return IRef; /* Sonderfall: NUR Referenz liefern */
    IRef = new TSRefC(id); /* Referenz-Eintrag erstellen und setzen */
    return IRef; /* Referenzeintrag (zusaetzlich) liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setShRef"
  * neue Shape-Referenz-erstellen, speichern und liefern
  * Sonderfall id<0: NUR liefern aktuelle Referenz (information-Hiding)
  * ##setShRef.TSTrItm10 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC setShRef( /* Shape-Referenz bearbeiten */
   int id) /* neue Shape-Referenz (Nr) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(id<0) return SRef; /* Sonderfall: NUR Referenz liefern */
    SRef = new TSRefC(id); /* Referenz-Eintrag erstellen und setzen */
    return SRef; /* Referenzeintrag (zusaetzlich) liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTrItm10 (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs;   /* result-String */
    TSTrItm cIt; /* connected TrItem-entry */
    TSShape cSh; /* Shape-Referenz */
   /*=================================================================*/
    rs = toStr(false) + "["; /* set basic data */
    if(IRef==null) rs += "?/<null>(<null>),"; /* value missing */
    else { /* reference defined  -- use it */
      rs += IRef.chgNr(Integer.MIN_VALUE) + "/"; /* add original nbr */
      if((cIt=(TSTrItm)IRef.chgRef(null))!=null) /* reference is OK */
        rs += cIt.getNr(true) + "(" + cIt.getNr(false) + "),";
      else rs += "<null>(<null>),"; /* use dummy-value */
    } /* reference-entry was defined */
    if(SRef==null) rs += "?/<null>(<null>)]}"; /* value missing */
    else { /* reference defined  -- use it */
      rs += SRef.chgNr(Integer.MIN_VALUE) + "/"; /* add original nbr */
      if((cSh=(TSShape)SRef.chgRef(null))!=null) /* reference is OK */
        rs += cSh.getNr(true) + "(" + cSh.getNr(false) + ")]}";
      else rs += "<null>(<null>)]}"; /* use dummy-value */
    } /* reference-entry was defined */
    return rs; /* provide result-string */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSTile -- Definition eines Tile-Elementes
 * Ein Tile ist ein Strukturquadrat hherer Ordnung (Kantenlaenge>1)
 *   oder ein einfaches Strukturquadrat (Kantenlaenge=1)
 * ##TSTile (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTile implements Serializable,Comparable<TSTile> { /* Tile-Def. */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.3.06 28.11.2007";
  private static final int[]    K_xZf = {15,14,11,10};
  private static final int[]    K_zZf = {0,3,12,15};
  private static final int[][]  K_lZf = {{12,0},{8,4}};
 /*-------------------------------------------------------------------*/
  private int                   Qx;     /* Quadrat-Nummer X */
  private int                   Qz;     /* Quadrat-Nummer Z */
  private int                   nQx;    /* Quadrat-Nummer X (neu) */
  private int                   nQz;    /* Quadrat-Nummer Z (neu) */
  private int                   Ql;     /* Kantenlaenge des Quadrates */
  private String                NmeA;   /* Tile-Name (alt) */
  private String                NmeN;   /* Tile-Name (neu) */
  private TSQuad                QDef;   /* Kette abhaengige Quad-Def's */
  private boolean               loT;    /* LO-Tile-Definition */
  private int                   Cnt;    /* Nutzungssteuerung */
  private boolean               Flg;    /* temporary flag */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSTile() /* Tile-Element-Definition erstellen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    Qx = Qz = nQx = nQz = 0; /* Quadratnummern noch nicht gesetzt */
//    Ql = 0; /* keine Laenge -- Wert ungueltig */
//    NmeA = null;  /* Tile-Name (alt) noch nicht verfuegbar */
//    NmeN = null;  /* Tile-Name (neu) noch nicht verfuegbar */
//    QDef = null;  /* keine abhaengigen Strukturquadrate definiert */
//    loT  = false; /* Eintrag gehoert NICHT zu LO-Tiles */
//    Cnt  = 0;     /* Eintrag noch nicht benutzt/referenziert */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSTile( /* Tile-Definition erstellen */
   int     qx, /* X-Kennung des Strukturquadrates */
   int     qz, /* Z-Kennung des Strukturquadrates */
   int     ql, /* Kantenlaenge des Strukturquadrates */
   boolean lo, /* Tile-Definition ist LO-Tile */
   String  tn, /* Tile-Name (original) oder 'null' */
   TSQuad  qa) /* Kette abhaengiger Struktur-definitionen */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Qx   = nQx = qx; /* Quadratnummer X uebertragen */
    Qz   = nQz = qz; /* Quadratnummer Z uebertragen */
    Ql   = ql; /* aktuelle Kantenlaenge setzen */
    NmeA = tn; /* Tile-Name (alt) setzen (Schalter!) */
    NmeN = tn; /* Tile-Name (neu) setzen (noch identisch) */
      /* Achtung: Die Tile-Namen beinhalten lediglich den Dateinamen
       * ohne Pfad und Suffix. */
    QDef = qa; /* abhaengige Strukturquadranten anbinden */
    loT  = lo; /* Typ der Tile-Definition setzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgFlag"
  * Set new value for 'temporary flag'.
  * Method returns previous value of flag.
  * Three states are expressed by an integer-value:
  *   0 - do not change flag
  *  <0 - set flag to 'false' (e.g. -1)
  *  >0 - set flag to 'true' (e.g. 1)
  * ##chgFlag.TSTile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean chgFlag( /* change temporary flag */
   int nF) /* new value for flag (0 = no change, -1 = false, 1 = true */
   {
   /*-----------------------------------------------------------------*/
    boolean oF; /* old flag-value */
   /*=================================================================*/
    oF  = Flg; /* save return/old value */
    if(nF!=0) Flg = (nF>0); /* and insert new one */
    return oF; /* return old value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgQDf"
  * Quadratstruktur-Verkettung liefern oder veraendern
  * ACHTUNG: Wert nicht veraendern wenn 'cq==null'
  * ##chgQDf.TSTile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQuad chgQDf( /* Quadratstruktur-Verkettung bearbeiten */
   TSQuad cq) /* neue Verkettung oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSQuad cQ; /* aktueller Verkettungswert */
   /*=================================================================*/
    cQ = QDef; /* aktuellen Verkettungswert merken */
    if(cq!=null) QDef = cq; /* neue Verkettung erstellen */
    return cQ; /* Ergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "compareTo"
  * Methode zum sortieren der Elemente
  * ACHTUNG: Elemente sind gleich auch wenn die Vorzeichen
  *            NICHT uebereinstimmen  (Sortierfolge)
  * Attention: Name of this Methode is requested by Interface
  *           'Comparable'. Results need not be 0,1,-1
  * Note: This class has a natural ordering that is
  *       inconsistent with 'equals'.
  * ##compareTo.TSTile (Eyecatcher)
  *=====================================================================
  </pre>*/
  public int compareTo( /* Tile-Definitionen vergleichen fuer Sort */
   TSTile vT) /* compare-object */
   {
   /*-----------------------------------------------------------------*/
    int i;  /* Zwischenwert */
   /*=================================================================*/
    i = Math.abs(Qx) - Math.abs(vT.Qx); /* Differenz fuer Pruefung */
    if(i!=0) return i; /* kleiner/groesser - signalisieren */
    /* Qx-Definitionen sind gleich! */
    i = Math.abs(Qz) - Math.abs(vT.Qz); /* Differenz fuer Pruefung */
    if(i!=0) return i; /* kleiner/groesser - signalisieren */
    /* Bevor die Definitionen identisch sind mussen sie zusaetzlich
     * KORREKT verglichen werden. */
    i = Qx - vT.Qx; /* Differenz fuer Pruefung */
    if(i!=0) return i; /* kleiner/groesser - signalisieren */
    return Qz - vT.Qz; /* Letzen Vergleichswert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crQuad"
  * (eine) fehlende Quad-Definition erstellen
  * Wenn KEINE Quad-Definition mehr fehlt wird 'null' geliefert
  * ##crQuad.TSTile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQuad crQuad() /* fehlende Quad-Definition erstellen */
   {
   /*-----------------------------------------------------------------*/
    TSQuad cQ; /* aktuelle Quad-Definition */
    String is; /* Arbeitswert */
    int    ix,iz,x,z; /* Arbeitswerte */
   /*=================================================================*/
    if(loT) return null; /* keine Quad-Definitionen vorhanden */
    for(ix=0;ix<Ql;ix+=1) /* alle Quadranten der X-Richtung */
      zl:for(iz=0;iz<Ql;iz+=1) { /* alle Quadranten der Z-Richtung */
        x = Qx + ix; /* Nummer des Quadranten berechnen (X-Komponente) */
        z = Qz + iz; /* Nummer des Quadranten berechnen (Z-Komponente) */
        for(cQ=QDef;cQ!=null;cQ=cQ.chgQDf(null)) /* check all Quad's */
          if(cQ.isWrld(x,z)) continue zl; /* Eintrag schon vorhanden */
        /* Quad-entry missing -- create it */
        is = "w" + TSUtil.prFN(x,z,6) + ".w"; /* Dateiname erstellen */
        cQ = new TSQuad(x,z,is,null,QDef); /* Struktur-Definition erst. */
        QDef = cQ; /* lokale Kette neu bilden */
        return cQ; /* erzeugte Quad-Definition liefern */
    } /* -for,for- alle Sub-Quadrate (ix,iz) bearbeiten */
    return null; /* alle Quad-Definitionen vorhanden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crTle"
  * Tile-Definition erstellen und in Tile-Verzeichnis schreiben
  * ##crTle.TSTile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crTle( /* Tile-Definition erstellen */
   File   dir,  /* Verzeichnisname fuer Ziel */
   double flr)  /* Basis-Hoehenwert des Tiles (Floor) */
   {
   /*-----------------------------------------------------------------*/
    BufferedOutputStream bS;    /* Schreiben der Hoehendaten */
    TSFileT              cF;    /* aktuelle Ausgabe-Datei */
    File                 dat;   /* Dateidefinitionen */
    String               Err;   /* Dateifehler aufgetreten */
    String               is,js; /* Arbeitswerte */
    int                  i,c;   /* Arbeitswerte */
    String[]             arg = {null,null,null,null,null};
    DecimalFormat        DF = new DecimalFormat("000");
   /*=================================================================*/
    is = getNme(2); /* Name der Tile-Datei holen */
    dat = new File(dir,is); /* vollstaendige Ziel-Referenz erst. */
    js = dat.getAbsolutePath(); /* Gesamtname (doku) erstellen */
    cF = new TSFileT(dat); /* create output-handle of tile-file */
    is = cF.open(TSFile.OUB); /* open file for output using UB-format, init file */
    if(is!=null) return TSLogg.getMsg("TSTleC01",is,js); /* Open-Fehler */
      /* Fehler beim oeffnen aufgetreten -- Meldung liefern */
    /* Aufbereiten der Ersetzungsparameter: */
    arg[0] = TSUtil.putFV(flr-3.0,0); /* establish Floor-value within file */
    arg[1] = TSUtil.putFV(flr,0); /* Hoehenwert 'PatchSet' setzen */
    arg[2] = getNme(4);  /* Name der Hoehen-Datei(y) holen */
    arg[3] = getNme(8);  /* Name der Puffer-Datei(e) holen */
    arg[4] = getNme(10); /* Name der Puffer-Datei(n) holen */

    Err = null; /* keine Fehlerabbruch aufgetreten */
    for(c=0;c<1000;c+=1) { /* alle Datensaetze schreiben */
      /* 1000 Saetze maximal ist Sicherung */
      is = "TSTF*" + DF.format(c); /* Datensatzschluessel erstellen */
      is = TSLogg.getMsg(is,arg); /* naechsten Datensatz lesen */
      if(is.length()==0) break; /* alle Saetze geschrieben */
      is = cF.putData(is); /* Datensatz in ensprechender Form ausgeben */
      if(is!=null) { /* Fehler beim Schreiben aufgetreten */
        Err = TSLogg.getMsg("TSTleC02",is,js); /* Fehlermeldung generieren */
        break; /* Kopieren der Daten abbrechen */
      } /* Fehler beim Schreiben */
    } /* alle Datensaetze schreiben */
    is = cF.close(); /* Ausgabe-Datei wieder schliessen */
    if(is!=null) Err = TSLogg.getMsg("TSTleC03",is,js);
      /* Fehler beim Schliessen aufgetreten -- Kennzeichen setzen */

    if(Err!=null) { /* Fehler aufgetreten -- Fehlerabbruch */
      dat.delete(); /* Datei wieder loeschen */
      return Err; /* mit Fehlermeldung beenden */
    } /* Fehlerabbruch */

    dat = new File(dir,arg[2]); /* vollstaendige Ziel-Referenz erst. */
      /* Achtung: Argument-Nummer beachten (ist 'getNme(4)' ) */
    js = dat.getAbsolutePath(); /* Gesamtname (doku) erstellen */
    i = 128; /* Hoehenwert initialisieren */
    try {bS = new BufferedOutputStream(new FileOutputStream(dat)); /* oeffnen */
    } catch (IOException e) { /* IO-Fehler erhalten */
      System.err.println(e.toString());
      bS = null; /* Kennzeichen: Datei nicht genutzt */
      Err = TSLogg.getMsg("TSTleC04",js); /* Fehlermeldung generieren */
    } /* Dateifehler */
    /* 65536 mal x'0080' in Hoehendatei schreiben */
    if(Err==null) for(c=0;c<65536;c+=1) { /* alle Daten schreiben */
      try {bS.write(0); /* Datenwert schreiben */
      } catch (IOException e) { /* Schreib-Fehler erhalten */
        System.err.println(e.toString());
        Err = TSLogg.getMsg("TSTleC04",js,c); /* Fehlermeldung generieren */
        break; /* Erstellen der Daten abbrechen */
      } /* Fehler beim Schreiben */
      try {bS.write(128); /* Datenwert schreiben */
      } catch (IOException e) { /* Schreib-Fehler erhalten */
        System.err.println(e.toString());
        Err = TSLogg.getMsg("TSTleC04",js,c); /* Fehlermeldung generieren */
        break; /* Erstellen der Daten abbrechen */
      } /* Fehler beim Schreiben */
    } /* Datendatei schreiben */
    if(bS!=null) /* Ausgabe-Datei offen -- schliessen */
      try { bS.close(); /* Ausgabe-Datei wieder schliessen */
      } catch (IOException e) { System.err.println(e.toString()); }

    if(Err==null) return null; /* Tile ohne Fehler erstellt */
    dat.delete(); /* Hoehen-Datei wieder loeschen */
    return Err; /* mit Fehlermeldung beenden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crTleC"
  * primaeres Tile-Verbindungsobjekt generieren und liefern
  * ##crTleC.TSTile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSTileC crTleC() /* Tile-Verbindungseintrag erstellen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return new TSTileC(nQx,nQz,Ql,this); /* Objekt liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "equals"
  * pruefen ob Tile-Definition identisch (Typ, Position und Groesse)
  * Attention: This function is also needed, so that method 'contains()'
  *            functions correctly. So, the name of this method is
  *            fixed.
  * ##equals.TSTile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean equals( /* Tile-Definition pruefen */
   TSTile vT) /* zu vergleichende Tile-Definition */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Qx!=vT.Qx) return false; /* Kennung trifft nicht zu */
    if(Qz!=vT.Qz) return false; /* Kennung trifft nicht zu */
    if(Ql!=vT.Ql) return false; /* Kantenlaenge trifft nicht zu */
    if(loT!=vT.loT) return false; /* Typ ist unterschiedlich */
    return true; /* Quad-Definitions are matching */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getId"
  * Information-Hiding: Quadrantenkennung in String-Form liefern
  * ##getId.TSTile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getId( /* Quadranten-Kennung liefern */
   boolean orig) /* 'true' - originale Kng, 'false' - neue Kennung */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(orig) return ""+Qx+" "+Qz; /* originale Kennung liefern */
    return ""+nQx+" "+nQz; /* neue Quadrantenkennung liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getK"
  * aktuelle gespeicherte Koordinate liefern (modifizierte Version)
  * ##getK.TSTile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getK( /* Koordinate liefern */
   boolean typ) /* 'true' - X-Koordinate, 'false' - Z-Koordinate */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(typ) return nQx; /* X-Kennung (aktuell) liefern */
    return nQz; /* Z-Kennung des Quadranten (aktuelle) liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getLen"
  * Kantenlaenge des Tiles vergleichen und liefern
  * ##getLen.TSTile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getLen( /* Kantenlaenge des Tiles liefern */
   int kl) /* minimal vorgegebene Kantenlaenge */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Math.max(kl,Ql); /* geforderten Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getNme"
  * verschiedene Namen (Tile-Adresse) gemaess Typ erstellen
  * Achtung: Name enthaelt KEINEN Pfadanteil
  * ##getNme.TSTile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getNme(/* Namen erstellen und liefern */
   int t) /* requested form of name */
   {
   /*-----------------------------------------------------------------*/
    String sfx[] = {"",".t","_y.raw","_f.raw",
                    "_e.raw","_n.raw","_c.raw","_d.raw"};
    String is;     /* current basis of name */
   /*=================================================================*/
    if(t<0) { is = getTNme(Qx,Qz,Ql); t = -t; } /* name may be undef. */
    else is = (t%2==0) ? NmeA : NmeN; /* create requested name of tile */
    if(is==null) return null; /* Tile-Definition is invalid */
    t /= 2; /* compute number of suffix */
    if(t>7) return null; /* number of selection is invalid */
    return is + sfx[t]; /* and return correct name */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTNme" (Statische Version)
  * Tile-Adresse aus Koordinaten berechnen
  * ##getTNme.TSTile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final String getTNme( /* Tile-Adresse berechnen */
   int     qx, /* X-Koordinate des Quadrats */
   int     qz, /* Z-Koordinate des Quadrats */
   int     ql) /* Kantenlaenge des Quadrats (1,2,4,8,16,32,...,256 */
   {
   /*-----------------------------------------------------------------*/
    int i,j,c,e,g; /* intermediate value */
   /*=================================================================*/
    if(qx<-16384) return "-99999991"; /* Fehlerkennung */
    if(qx>16383) return "-99999993"; /* Fehlerkennung */
    if(qz<0) return "-99999995"; /* Fehlerkennung */
      /* Tile-Adr. '8xxxxxxx' bis 'Fxxxxxxx' nicht moeglich */
    if(qz>16383) return "-99999997"; /* Fehlerkennung */
//    if(TSOpts.cntMsk(-1,ql)!=1) return "-99999999"; /* Fehlerkennung */
    if(ql<1) return "-99999999"; /* Fehlerkennung */
    /* neuer Wertebereich: 0..32367 */
    qx += 16384; /* Nullpunkt verschieben fuer Berechnung */
    qz += 16384; /* Nullpunkt verschieben fuer Berechnung */
    g = ql / 2; /* Ende-Kriterium (Grenze) berechnen */
    e = c = 0; /* Ergebnis in Integerform vorbesetzen */
    for(i=8192;i>g;i/=4) { /* alle Ziffern der Tile-Adresse berechnen */
      e *= 16; /* neuen Platz fuer naechste Ziffer erstellen (<<4) */
      j = qx / i; /* Kachelkng. gemaess X-Koordinate (jx = 0,1,2,3) */
      qx %= i;    /* und Koordinate justieren */
      e += K_xZf[j]; /* Kennung der Kachel setzen (0->F,1->E,2->B,3->A) */
      j = qz / i; /* Kachelkng. gemaess Z-Koordinate (jz = 0,1,2,3) */
      qz %= i;    /* und Koordinate justieren */
      e ^= K_zZf[j]; /* Kachelkennung anpassen */
        /* Belegung fuer (jx,jz)-> ? (Angabe wie in der Welt)
         * (0,3) -> 0, (1,3) -> 1, (2,3) -> 4, (3,3) -> 5,
         * (0,2) -> 3, (1,2) -> 2, (2,2) -> 7, (3,2) -> 6,
         * (0,1) -> C, (1,1) -> D, (2,1) -> 8, (3,1) -> 9,
         * (0,0) -> F, (1,0) -> E, (2,0) -> B, (3,0) -> A */
      c += 1; /* Anzahl der belegten Bytes zaehlen */
    } /* alle Ziffern bearbeiten */
    if(i<g) return "_" + TSUtil.toHex(e,c); /* Dateinamen liefern */
    /* Adresse ist noch nicht vollstaendig (i==g) */
    e *= 16; /* neuen Platz fuer naechste Ziffer erstellen (<<4) */
    qx /= ql; /* ersten Teil des Index berechnen */
    qz /= ql; /* zweiten Teil des Index berechnen */
    e += K_lZf[qx][qz]; /* letzte Ziffer per Zuordnungstabelle */
    c += 1; /* zusaetzliches belegtes Byte zaehlen */
    return "-" + TSUtil.toHex(e,c); /* Dateinamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "shft"
  * aktuelle gespeicherte Koordinaten veraendern
  * Methode liefert Fehlermeldung falls Fehler auftritt
  * ##shft.TSTile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String shft( /* Tile-Definition veraendern/verschieben */
   int dx, /* Additionswert fuer die X-Koordinate */
   int dz) /* Additionswert fuer die Z-Koordinate */
   {
   /*-----------------------------------------------------------------*/
    int i; /* Arbeitswert */
   /*=================================================================*/
    i = nQx + dx; /* Wert zum Testen */
    if(i<-16384) return TSLogg.getMsg("TSTleS01",i); /* Wert! */
    if(i>16383) return TSLogg.getMsg("TSTleS02",i); /* Wert! */
    i = nQz + dz; /* Wert zum Testen */
    if(i<0) return TSLogg.getMsg("TSTleS03",i); /* Wert! */
    if(i>16383) return TSLogg.getMsg("TSTleS04",i); /* Wert! */
    nQx += dx; /* Wert anpassen */
    nQz = i; /* Wert anpassen */
    if(NmeA==null) return null; /* Tile nicht vorhanden -- OK */
    NmeN = getTNme(nQx,nQz,Ql); /* neuer Tile-Name setzen */
    if(NmeN.startsWith("-999999")) /* Fehler Tile-Berechnung (Gap?) */
      return TSLogg.getMsg("TSTleS05",NmeN,nQx,nQz); /* Meldung liefern */
    return null; /* Aktion ohne Fehler erfolgt */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = "Tile{["+Qx+","+Qz+"],"+Ql+",["+nQx+","+nQz+"]-";
    if(QDef==null) rs += "<N>"; else rs += "<Y>";
    rs += "-" + loT + "-" + Cnt + "}";
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSTileC -- Controldefinition of Quad-structure.
 * This class is only used when tile-definitions are written to
 *  file.
 * ##TSTileC (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTileC { /* Strukturquadrat-Steuerung */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.6.03 05.07.2011";
 /*-------------------------------------------------------------------*/
  private int                   Qx;     /* Quadrat-Nummer X */
  private int                   Qz;     /* Quadrat-Nummer Z */
  private int                   Ql;     /* Kantenlaenge */
  private TSTileC               Nxt;    /* Nachfolger in Kette */
  private TSTileC[]             Chld;   /* Abhaengige Quadranten */
  private TSTile                Tle;    /* Verkettung zu Tile */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSTileC() /* Strukturquadrat-Steuerung erstellen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Ql   = 1;    /* Kantenlaenge initialisieren */
    Chld = null; /* keine Verkettung vorhanden */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSTileC( /* Strukturquadrat-Steuerung erstellen */
   int qx, /* X-Kennung des Strukturquadrates */
   int qz, /* Z-Kennung des Strukturquadrates */
   int ql) /* Kantenlaenge des Strukturquadrates */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Qx   = qx; /* Quadratnummer X uebertragen */
    Qz   = qz; /* Quadratnummer Z uebertragen */
    Ql   = ql; /* Kantenlaenge initialisieren */
    Nxt  = null; /* keine Verkettung vorhanden */
    Tle  = null; /* kein Tile verbunden */
    Chld = new TSTileC[4]; /* Verkettungsspeicher setzen */
    Arrays.fill(Chld,null); /* Tabelle initialisieren */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create connection-entry
  *=====================================================================
  </pre>*/
  protected TSTileC( /* Strukturquadrat-Steuerung erstellen */
   int    qx,  /* X-Kennung des Strukturquadrates */
   int    qz,  /* Z-Kennung des Strukturquadrates */
   int    ql,  /* Kantenlaenge des Strukturquadrates */
   TSTile tle) /* Referenz zur Tile-Definition */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    this(qx,qz,ql); /* create standard entry */
    Tle = tle; /* Referenz zum Tile eintragen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgChld"
  * Tile-Verkettung anpassen (holen/setzen)
  * ##chgChld.TSTileC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSTileC chgChld( /* naechstes Tile-Quadrat bearbeiten */
   int     ix, /* Index der Verkettung */
   TSTileC cq) /* naechste Tile-Definition oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSTileC cQ; /* aktueller Wert */
   /*=================================================================*/
    if(Chld==null) return null; /* keine Verkettung moeglich */
    if(ix<0 || ix>=Chld.length) return null; /* Indexwert falsch */
    cQ = Chld[ix]; /* aktueller Wert sichern */
    if(cq!=null) Chld[ix] = cq; /* Wert eintragen wenn gefordert */
    return cQ; /* aktuellen/letzen Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNxt"
  * Naechstes Element in TileC-Verkettung holen/setzen
  * ##chgNxt.TSTileC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSTileC chgNxt( /* naechstes Tile-Quadrat bearbeiten */
   TSTileC cq) /* naechstes Quadrat oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSTileC cQ; /* aktueller Wert */
   /*=================================================================*/
    cQ = Nxt; /* aktueller Wert sichern */
    if(cq!=null) Nxt = cq; /* Wert eintragen wenn gefordert */
    return cQ; /* aktuellen/letzen Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkQl"
  * vergleichen und Pruefen Kantenlaenge eines Quadrates
  * Methode liefert 'true' wenn die Kantenlaenge des Tiles GROESSER
  *   als der angegebene Vergleichswert (ql = 2**n) ist.
  * ##chkQl.TSTileC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkQl( /* Kantenlaenge vergleichen */
   int ql) /* zu pruefende Kantenlaenge */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Ql>ql) return true; /* Kantenlaenge ist ausserhalb */
    return false; /* Kantenlaenge im erlaubten Bereich */
  }

 /**. <pre>
  *=====================================================================
  * Methode "clear"
  * ALLE Referenzen loeschen und
  *  naechstes Element in TileC-Verkettung liefern
  * ##clear.TSTileC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSTileC clear() /* naechstes Tile-Quadrat liefern */
   {
   /*-----------------------------------------------------------------*/
    TSTileC cQ; /* aktueller Wert */
   /*=================================================================*/
    cQ   = Nxt; /* aktueller Wert sichern */
    Nxt  = null; /* Verkettung loeschen */
    Tle  = null; /* Tile-Referenz loeschen */
    Arrays.fill(Chld,null); /* Tabelleneintraege loeschen */
    Chld = null; /* Verkettungsspeicher loeschen */
    return cQ; /* aktuellen/letzen Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getId"
  * (modifizierte) Id des Quadranten in Stringform liefern
  * ##getId.TSTileC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getId( /* Erzeugen ID-String */
   int t) /* Typ der Id */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* Id gemaess Anforderung erzeugen */
      case(-2): return "\t\tTdFile  ("+Qx/512+" "+Qz/512+" )";
      case(-1): return "["+Qx+","+Qz+"]"; /* fuer 'toStr()' */
      case( 0): return TSUtil.prFN(Qx/512,Qz/512,5);
      default: /* nicht erlaubte Angabe .. Default */
        if(t<1) t = 1; /* Wert ggf. anpassen */
    } /* gemaess Anforderung erstellen */
    return "( "+Qx/t+" "+Qz/t+" )"; /* ID liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isLeaf"
  * Pruefen ob, letztes (Blatt-) Element der Kette vorliegt
  * ##isLeaf.TSTileC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isLeaf() /* letztes Element? */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Tle!=null; /* Ergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isTile"
  * pruefen ob geforderte 'Tile'-Definition vorliegt
  * ##isTile.TSTileC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isTile( /* 'Tile'-Definition pruefen */
   int qx, /* Kennung des Quadranten (X) */
   int qz) /* Kennung des Quadranten (Z) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Qx!=qx) return false; /* Kennung trifft nicht zu */
    if(Qz!=qz) return false; /* Kennung trifft nicht zu */
    return true; /* 'Tile'-Definition gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTileC (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
    int    i;  /* intermediate value */
   /*=================================================================*/
    rs = "TileC{["+Qx+","+Qz+"]"+Ql+"-";
    if(Nxt==null) rs += "<null>"; else rs += Nxt.getId(-1);
    rs += "-("; /* Trennzeichen einsetzen */
    for(i=0;i<4;i+=1) { /* alle Verkettungen */
      if(i>0) rs += ","; /* Trennzeichen einfuegen */
      if(Chld[i]==null) rs += "<null>"; /* Kennung aufbereiten */
      else rs += Chld[i].getId(-1);
    } /* alle Abhaengigkeiten */
    rs += ")-"; /* Trennung setzen */
    if(Tle==null) rs += "null"; else rs += Tle.toStr();
    rs += "}"; /* Abschluss setzen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSQDef -- Position-independent part of a Quad-structure
 * This part of a Quad-structure is used to store the contends of
 *    a world-file in a position-independand form.
 * ##TSQDef (Eyecatcher)
 *======================================================================
 </pre>*/
class TSQDef implements Serializable { /* basis of a structure-quad */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.03 20.03.2009";
 /*-------------------------------------------------------------------*/
  private TSChain               Uid;    /* Set of 'UiD-Elements' */
  private TSChain               Snd;    /* Set of 'Sound-Elements' */
  private TSView                VId;    /* ViewSphere-Element (Basis) */
  private int                   mIdW;   /* maximum used UiD (Wrld) */
  private int                   mIdS;   /* maximum used UiD (Snd) */
  private int                   mVId;   /* next free View-Id
    * If this value is greater '0' a viewsphere-definition is present
    * and 'VId' referes to this viewsphere-chain. Otherwise NO
    * viewsphere is defined, regardless if 'VId' is used. */
  private int                   mOID;   /* maximum used Object-ID */
  private int                   Mde;    /* File-accessmode (WFile) */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSQDef() /* create definition of structure-Quad */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
//    Uid  = null; /* no chain of world-entries present */
//    Snd  = null; /* no chain of sound-entries present */
//    VId  = null; /* no 'ViewSphere'-chain available */
//    mIdW = 0;    /* maximum used UID of world-obj's is 0 */
    mIdS = 100000; /* maximum used UID of sound-obj's */
//    mVId = 0;    /* no ViewSphere-Id used until now */
//    mOID = 0;    /* no 'Object-ID' used ('0' is not used) */
    Mde  = -9;   /* accessmode (comp. to 'chgMde()') is not specified */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Method "chg$View"
  * 'modify' or 'get' current 'maximum viewsphere-ID'
  * ATTENTION: Do not modify value if argument is negative. However,
  *          the value may be cleared by setting it to '0'
  * ##chg$View.TSQDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int chg$View( /* red/set ViewSphere-Maximum */
   int v)  /* new value if NOT less than 0 */
   {
   /*-----------------------------------------------------------------*/
    int vs; /* intermediate value */
   /*=================================================================*/
    vs = mVId; /* save old value */
    if(v>=0) mVId = v; /* and change it if requested */
    return vs; /* return 'old'/current value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgMde"
  * Modify current accessmode of world-file (or return it only).
  * ATTENTION: - Do not modify value if argument is negative.
  *            - The mode-definiton (must) already contains the
  *                'write-flag', so that can directly be used to
  *                rewrite the file. 
  * ##chgMde.TSQDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int chgMde( /* read/modify accessmode of world-file */
   int v) /* new accessmode or marker (if value is negative) */
   {
   /*-----------------------------------------------------------------*/
    int m; /* intermediate value */
   /*=================================================================*/
    m = Mde; /* save old value */
    if(v>=0) Mde = v; /* and change it if requested */
    return m; /* return 'old'/current value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgSTab"
  * Insert/Return chain of sound-objects
  * Modify 'maximum used UID' if requested
  * ##chgSTab.TSQDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSChain chgSTab( /* manage sound-object-chain */
   TSChain cS, /* chain of sound-objects or 'null' */
   int     id) /* new maxim used object-ID (UID) if '>0' */
   {
   /*-----------------------------------------------------------------*/
    TSChain cC; /* intermediate value */
   /*=================================================================*/
    cC = Snd; /* save old value */
    if(cS!=null) Snd = cS; /* and change it if requested */
    if(id>0) mIdS = id; /* insert new 'maximum used' value if UID */
    return cC; /* all processed -- return 'old'/current value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgView"
  * Modify/Return current viewsphere-definition
  * ATTENTION: Do not modify value if argument is 'null'.
  *            Therefore the viwsphere-reference cannot be cleared and
  *            'mVId' is used as a flag, if a valid viewsphere-chain
  *            exists.
  * ##chgView.TSQDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSView chgView( /* Modify/Return current vs-entry */
   TSView nVS)  /* new viewsphere-entry or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSView cVS; /* intermediate value */
   /*=================================================================*/
    cVS = VId; /* save old value */
    if(nVS!=null) VId = nVS; /* and change it if requested */
    return cVS; /* return 'old'/current value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgWTab"
  * Insert/Return chain of world-objects
  * Modify 'maximum used UID' if requested
  * ##chgWTab.TSQDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSChain chgWTab( /* manage world-object-chain */
   TSChain cW, /* chain of world-objects or 'null' */
   int     id) /* new maxim used object-ID (UID) if '>0' */
   {
   /*-----------------------------------------------------------------*/
    TSChain cC; /* intermediate value */
   /*=================================================================*/
    cC = Uid; /* save old value */
    if(cW!=null) Uid = cW; /* and change it if requested */
    if(id>0) mIdW = id; /* insert new 'maximum used' value if UID */
    return cC; /* all processed -- return 'old'/current value */
  }

 /**. <pre>
  *=====================================================================
  * Method "fndView"
  * Search viewsphere- chain if an entry with specified id exists.
  *  If it is NOT found or if an error occurred, 'null' is returned.
  * ##fndView.TSQDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSView fndView( /* seach viewSphere-chain */
   int id)  /* ID of the requested viewsphere */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(id<0) return null; /* specified ID is not valid */
    if(mVId<=id) return null; /* ID is NOT within chain */
    if(VId==null) return null; /* no viewsphere-chain available */
    return VId.fndView(id); /* search; return address of viewSphere */
  }

 /**. <pre>
  *=====================================================================
  * Method "getOId"
  * get next unique object-ID
  * ##getOId.TSQDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getOId() /* return unique object-ID */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    mOID += 1; /* compute next unique object-ID */
    return mOID; /* return new ID */
  }

 /**. <pre>
  *=====================================================================
  * Method "getSId"
  * get next unique ID of a sound-object
  * ##getSId.TSQDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getSId() /* return unique sound-ID */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    mIdS += 1; /* compute next unique sound-ID */
    return mIdS; /* return new ID */
  }

 /**. <pre>
  *=====================================================================
  * Method "getWId"
  * get next unique ID of a world-object
  * ##getWId.TSQDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getWId() /* return unique world-ID */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    mIdW += 1; /* compute next unique world-ID */
    return mIdW; /* return new ID */
  }

 /**. <pre>
  *=====================================================================
  * Method "getSnd"
  * Iterator-Access to elements of the sound-chain
  * ATTENTION: This is a Delegation/Wrapper-Method for 'TSChain.next()'
  * ##getSnd.TSQDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSSnd getSnd( /* get next element within sound-chain */
   boolean mde) /* initialize chain if 'true' (returns FIRST element) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(Snd==null) return null; /* chain not available -- no more e. */
    return (TSSnd)Snd.next(mde); /* delegate function */
  }

 /**. <pre>
  *=====================================================================
  * Method "getUid"
  * Iterator-Access to elements of the world-chain
  * ATTENTION: This is a Delegation/Wrapper-Method for 'TSChain.next()'
  * ##getUid.TSQDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSUiD getUid( /* get next element within world-chain */
   boolean mde) /* initialize chain if 'true' (returns FIRST element) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(Uid==null) return null; /* chain not available -- no more e. */
    return (TSUiD)Uid.next(mde); /* delegate function */
  }

 /**. <pre>
  *=====================================================================
  * Method "reSortW"
  * Call 'reSort'-method of current TSChain-Object (Uid)
  * ##reSortW.TSQDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String reSortW( /* reSort current world-Objects */
   TSWrld cObj) /* entry, which should be adjusted within chain */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Uid==null) return TSLogg.getKey("TSQDfW00"); /* chain missing */
    return Uid.reSort(cObj); /* delegate function and return */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSQDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    TSWrld cC;  /* current UiD-/Snd-Reference */
    String rs;  /* result-String */
    int    i,j; /* intermediate values */
   /*=================================================================*/
    rs = "TSQDef{";
    if(Uid!=null) { /* world-entries present ? */
      rs += Uid.size() + "("+ TSUtil.CRLF + "\t"; /* count */
      for(i=0,cC=Uid.next(true);cC!=null;i+=1,cC=Uid.next(false)) {
        if(i>0) rs += TSUtil.CRLF + "\t"; /* insert separator */
        rs += cC.toStr(); /* format class of world-object */
      } /* process all entries */
      rs += TSUtil.CRLF + "\t"; /* insert separator */
    } else rs += "0("; /* NO world-entries present */
    if(Snd!=null) { /* sound-entries present ? */
      rs += ")," + Snd.size() + "("; /* insert separator */
      for(i=0,cC=Snd.next(true);cC!=null;i+=1,cC=Snd.next(false)) {
        if(i>0) rs += TSUtil.CRLF + "\t"; /* insert separator */
        rs += cC.toStr(); /* format class of sound-object */
      } /* process all entries */
      rs += TSUtil.CRLF + "\t"; /* insert separator */
    } else rs += "),0("; /* NO sound-entries present */
    rs += ")," + mIdW + "," + mIdS + "}";
    return rs; /* return result preparation */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSQuad -- Definition eines Strukturquadrates
 * Edge-length of a structe-quad equals 1 in every case.
 * This part extends the independand part of a Quad-structure with the
 * psition-dependand part (like quad-number X and Z) of a
 * structure-definition.
 * ##TSQuad (Eyecatcher)
 *======================================================================
 </pre>*/
class TSQuad extends TSQDef implements Comparable<TSQuad> { /* Quads */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.6.03 30.09.2011";
 /*-------------------------------------------------------------------*/
  private int                   Qx;     /* Quadrat-Nummer X */
  private int                   Qz;     /* Quadrat-Nummer Z */
  private int                   nQx;    /* Quadrat-Nummer X (neu) */
  private int                   nQz;    /* Quadrat-Nummer Z (neu) */
  private String                wNme;   /* World-Datei-Name */
  private String                sNme;   /* Sound-Datei-Name */
  private TSQuad                QDef;   /* Quad-Kette pro Tile (next) */
  private TSTile                Tle;    /* Rueckverkettung zu Tile */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSQuad() /* Strukturquadrat-Definition erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSQuad( /* Strukturquadrat-Definition erstellen */
   int    qx, /* X-Kennung des Strukturquadrates */
   int    qz, /* Z-Kennung des Strukturquadrates */
   String wn, /* World-Datei-Name (original)oder 'null' */
   String sn, /* Sound-Datei-Name (original)oder 'null' */
   TSQuad ch) /* Verkettung der Eintraege (pro Tile) */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Qx   = nQx = qx; /* Quadratnummer X uebertragen */
    Qz   = nQz = qz; /* Quadratnummer Z uebertragen */
    wNme = wn; /* World-Name setzen "w+??????+??????.w" */
    sNme = sn; /* Sound-Name setzen "w+??????+??????.ws" */
      /* Achtung: Dateinamen sind NICHT vollstaendig qualifiziert! */
    QDef = ch; /* Lokale Kette bilden, Vorgaenger eintragen */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create extension-entry
  *=====================================================================
  </pre>*/
  protected TSQuad( /* Strukturquadrat-Definition erstellen */
   TSQuad cQ, /* Vorlage fuer neuen Quadranten */
   int    qx, /* X-Differenz des Strukturquadrates */
   int    qz) /* Z-Differenz des Strukturquadrates */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Qx = nQx = cQ.Qx + qx; /* Quadratnummer X erstellen */
    Qz = nQz = cQ.Qz + qz; /* Quadratnummer Z erstellen */
    Tle = new TSTile(Qx,Qz,1,false,TSTile.getTNme(Qx,Qz,1),this);
      /* Tile-Definition erstellen und in Rueckverkettung speichern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgQDf"
  * Quadratstruktur-Verkettung innerhalb Tiles liefern oder veraendern
  * ACHTUNG: Wert nicht veraendern wenn 'cq==null'
  * ##chgQDf.TSQuad (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQuad chgQDf( /* Quadratstruktur-Verkettung bearbeiten */
   TSQuad cq) /* neue Verkettung oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSQuad cQ; /* aktueller Verkettungswert */
   /*=================================================================*/
    cQ = QDef; /* aktuellen Verkettungswert merken */
    if(cq!=null) QDef = cq; /* neue Verkettung erstellen */
    return cQ; /* Ergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTle"
  * Rueckverkettung zu Tile bearbeiten
  * ACHTUNG: Wert nicht veraendern wenn 'ct==null'
  * ##chgTle.TSQuad (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSTile chgTle( /* Tile-Rueckverkettung bearbeiten */
   TSTile ct) /* neue Verkettung oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSTile cT; /* aktueller Verkettungswert */
   /*=================================================================*/
    cT = Tle; /* aktuellen Verkettungswert merken */
    if(ct!=null) Tle = ct; /* neue Verkettung erstellen */
    return cT; /* Ergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "compareTo"
  * Methode zum sortieren der Elemente
  * ACHTUNG: Elemente sind gleich auch wenn die Vorzeichen
  *            NICHT uebereinstimmen (Sortierfolge)
  * Attention: Name of this Method is requested by Interface
  *           'Comparable'. Results need not be 0,1,-1
  * Note: This class has a natural ordering that is
  *       inconsistent with equals.
  * ##compareTo.TSQuad (Eyecatcher)
  *=====================================================================
  </pre>*/
  public int compareTo( /* Tile-Definitionen vergleichen fuer Sort */
   TSQuad vQ) /* compare-object */
   {
   /*-----------------------------------------------------------------*/
    int i;  /* Zwischenwert */
   /*=================================================================*/
    i = Math.abs(Qx) - Math.abs(vQ.Qx); /* Differenz fuer Pruefung */
    if(i!=0) return i; /* kleiner/groesser - signalisieren */
    /* Qx-Definitionen sind gleich! */
    i = Math.abs(Qz) - Math.abs(vQ.Qz); /* Differenz fuer Pruefung */
    if(i!=0) return i; /* kleiner/groesser - signalisieren */
    /* Bevor die Definitionen identisch sind mussen sie zusaetzlich
     * KORREKT verglichen werden. */
    i = Qx - vQ.Qx; /* Differenz fuer Pruefung */
    if(i!=0) return i; /* kleiner/groesser - signalisieren */
    return Qz - vQ.Qz; /* Letzen Vergleichswert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crCoo"
  * Positions-Definition als Koordinaten-Objekt liefern
  * ##crCoo.TSQuad (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSCoo crCoo( /* Koordinatenobjekt liefern */
   TSPos cP) /* aktuelles Positionsobjekt zur Nutzung */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(cP==null) return null; /* Argument fehlt */
    return new TSCoo(Qx,Qz,cP.getPosX(),cP.getPosY(),cP.getPosZ());
  }

 /**. <pre>
  *=====================================================================
  * Methode "dX"
  * Returns number of Quads to target using X-direction
  * ##dX.TSQuad (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int dX( /* returns distance to target */
   int cX) /* X-Koordinate of target */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Qx==0) return 0; /* Value is NOT valid -- signal it */
    return Qx - cX; /* return distance */
  }

 /**. <pre>
  *=====================================================================
  * Methode "dZ"
  * Returns number of Quads to target using Z-direction
  * ##dZ.TSQuad (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int dZ( /* returns distance to target */
   int cZ) /* Z-Koordinate of target */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Qz==0) return 0; /* Value is NOT valid -- signal it */
    return Qz - cZ; /* return distance */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndQuad"
  * benachbarte Quad-Definition gemaess Differenzwerten suchen
  * wenn nicht gefunden (oder Fehler) wird 'null' geliefert
  * ##fndQuad.TSQuad (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQuad fndQuad( /* benachbarte Quad-Def. suchen */
   TSRoute cR,  /* Referenz auf Route fuer 'Suchen' */
   int     dx,  /* Abstand X-Koordinate */
   int     dz)  /* Abstand Z-Koordinate */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(cR==null) return null; /* keine Suche moeglich */
    dx += Qx; /* X-Komponente des neuen Quadranten berechnen */
    dz += Qz; /* Z-Komponente des neuen Quadranten berechnen */
    return cR.fndWrld(dx,dz); /* Adresse der Quad-Definition liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getInf"
  * Diese Methode liefert aufbereitete Basisinformationen
  * ##getInf.TSQuad (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getInf( /* Informationen formattieren */
   int nr) /* Kennung der geforderten Information */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kennung erstellen */
      case(0): return ""+Qx+" "+Qz; /* originale W-Kennung liefern */
      case(1): return ""+nQx+" "+nQz; /* NEUE Quad-Kennung liefern */
      case(2): return wNme; /* World-Dateiname (Quelle) liefern */
      case(3): if(wNme==null) return null; /* Datei nicht vorhanden */
        return "w"+TSUtil.prFN(nQx,nQz,6)+".w";
      case(4): return sNme; /* Sound-Dateiname (Quelle) liefern */
      case(5): if(sNme==null) return null; /* Datei nicht vorhanden */
        return "w"+TSUtil.prFN(nQx,nQz,6)+".ws";
      case(6): return TSTile.getTNme(Qx,Qz,1); /* Tile-Name */
    } /* gemaess Kennung beendet */
    return null; /* Fehler-Kennung fuer Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getMsg"
  * Diese Methode liefert aufbereitete Informationen/Message/Datenwert
  *   Je nach Kennung koennen auch 'private'-Werte in den
  *     Rueckgabe-String eingebaut werden
  * ##getMsg.TSQuad (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getMsg( /* Meldungen aufbereiten */
   int    nr, /* Kennung der Meldung/Information */
   String s,  /* Zusatzwert 1 (optional benutzt) */
   int    x,  /* Zusatzwert 2 (optional benutzt) */
   int    z)  /* Zusatzwert 3 (optional benutzt) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kennung erstellen */
      case(0): /* Tile und Quadranten liefern (original) */
        return TSLogg.getMsg(s,TSTile.getTNme(Qx,Qz,1),Qx,Qz);
      case(1): /* Differenz-Quadranten liefern */
        x += Qx; z += Qz; /* Quadranten (X,Z) berechnen */
        return ""+x+","+z; /* berechnete Quadrantennummer liefern */
      case(3): /* vollstaendige UID-Definition liefern (original) */
        return s+"("+Qx+" "+Qz+" "+x+")"; /* UiD liefern */
//      case(?): return TSLogg.getMsg("TSQDfM03",s,Qx,Qz); /* Message */
    } /* gemaess Kennung beendet */
    return TSLogg.getMsg("TSQDfM00",nr); /* Nr. falsch */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isWrld"
  * pruefen ob geforderte Quadrat-Definition vorliegt
  * ##isWrld.TSQuad (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isWrld( /* Quadrat-Definition pruefen */
   int qx, /* Kennung des Quadranten (X) */
   int qz) /* Kennung des Quadranten (Z) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Qx!=qx) return false; /* Kennung trifft nicht zu */
    if(Qz!=qz) return false; /* Kennung trifft nicht zu */
    return true; /* Quadrat-Definition gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setNme"
  * Namensdefinition (world/sound) setzen (aktivieren) falls noch nicht
  *   vorhanden
  * Methode liefert 'true', wenn der Name neu erstellt wurde
  * ##setNme.TSQuad (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean setNme( /* Namensdefinition erzeugen/setzen */
   boolean wrld) /* true: Name fuer 'World-Datei' erzeugen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(wrld) { /* Name fuer World-Datei verifizieren */
      if(wNme!=null) return false; /* Name bereits gueltig */
      wNme = "w"+TSUtil.prFN(Qx,Qz,6)+".w"; /* Name eintragen */
      return true; /* Name wurde generiert */
    } /* World-Datei gefordert */
    /* Name fuer 'Sound-Datei' erzeugen/verifizieren */
    if(sNme!=null) return false; /* Name bereits gueltig */
    sNme = "w"+TSUtil.prFN(Qx,Qz,6)+".ws"; /* Name eintragen */
    return true; /* Name wurde generiert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "shft"
  * aktuelle gespeicherte 'NEUE' Koordinaten veraendern
  * Methode liefert Fehlermeldung falls Fehler auftritt
  * ##shft.TSQuad (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String shft( /* Quadratdef's veraendern/verschieben */
   int dx, /* Additionswert fuer die X-Koordinate */
   int dz) /* Additionswert fuer die Z-Koordinate */
   {
   /*-----------------------------------------------------------------*/
    int i; /* Arbeitswert */
   /*=================================================================*/
    i = nQx + dx; /* Wert zum Testen */
    if(i<-16384) return TSLogg.getMsg("TSQDfS01",i); /* Wert! */
    if(i>16383) return TSLogg.getMsg("TSQDfS02",i); /* Wert! */
    i = nQz + dz; /* Wert zum Testen */
    if(i<0) return TSLogg.getMsg("TSQDfS03",i); /* Wert! */
    if(i>16383) return TSLogg.getMsg("TSQDfS04",i); /* Wert! */
    nQx += dx; /* Wert anpassen */
    nQz = i; /* Wert anpassen */
    return null; /* Aktion ohne Fehler erfolgt */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSQuad (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = "TSQuad{["+Qx+","+Qz+"],1,["+nQx+","+nQz+"]-";
    rs += super.toStr() + "}";
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSUiD -- Basic-Definition of a world-entry (common to all types)
 * Attention: One object ONLY can be a member of ONE 'TSChain'-chain
 * ##TSUiD (Eyecatcher)
 *======================================================================
 </pre>*/
class TSUiD extends TSWrld { /* 'World'-Entry (common) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.6.03 05.07.2011";
  private static String[]       K_Dta = {"Direction","CollideFlags",
    "CollideFunction","Matrix3x3","MaxVisDistance","NoDirLight"};
 /*-------------------------------------------------------------------*/
  private int                   OID;    /* unambigous Object-ID */
  private int[]                 Uid;    /* some UiD-Versions
    * Versions of UID's: 0 - original, 1 - corrected, 2 - new */
  private int                   OT;     /* Object-Type of Entry */
  private int                   SL;     /* StaticDetailLevel */
  private int                   StF;    /* StaticFlags */
  private int                   CoF;    /* CollideFlags */
  private int                   Opt;    /* Options (see below) */
  private int                   CntC;   /* overall Count of Node-ref's */
  private int                   CntS;   /* section Count of Node-ref's */
  private TSPos                 Pos;    /* Position within Quad (Ref) */
  private TSQDir                Dir;    /* QDirection (Quaternion) */
  private TSView                VId;    /* ViewSphere-Reference */
  private int                   VNr;    /* ViewSphere-Number (Flag)
    * 'VNr' is only valid and used if 'VId' is NOT set ('VId==null') */
  private TSUiD                 nxt;    /* next entry with same UiD-value.
    * This chain is required to find the proper UID-entry when searching
    * for an UID-entry which connects to a track/road-database-entry.
    * The uid-number in such an entry may be ambigous. When the
    * world-entry is eventually connected to the track/road-db-entry
    * this chain is no longer needed and may be corrupted. */
  private TSWrld                Chn;    /* Conection to 'TSChain'-chain */
  private TSQDef                QRef;   /* Backward-Reference */

/**. <pre>
  * Object-Type-definition (OT) of entry (also refer to 'getName()'):
  *   0 - TrackObj
  *   1 - Dyntrack
  *   2 - Signal
  *   3 - Static
  *   4 - Forest
  *   5 - Platform
  *   6 - Siding
  *   7 - Gantry
  *   8 - Speedpost
  *   9 - CarSpawner
  *  10 - LevelCr
  *  11 - Hazard
  *  12 - Transfer
  *  13 - CollideObject
  *  14 - Telepole
  *  15 - Pickup
  *  32 - Tr_Watermark
  *
  * Used options (stored within field 'Opt'):
  *        0 - Entry is invalid ('Dummy-Entry') Do not handle nor write
  *        1 - UiD-Entry refers to Track-/Road-object
  *        2 - UiD-Entry describes road (copied from Shape)
  *        3 - UiD-Entry refers to Junction (evaluated from Shape)
  *        4 -
  *        7 - Entry is member of 'MveObj'-set
  *  8 to 23 - Options depend from extended type-definition
  * 24 to 31 - temporary used options
  *       24 - moved to other quad -- do NOT renumber
  *       31 - Entry is already processed
  *
  * Definition of 'Entry found' (common definition stored in TSOpt):
  *        0 : UiD
  *  1 to 15 : depends on object-class
  *       16 : TrItemId
  *       17 : CollideFlag
  *       18 : CollideFunction
  *       19 : FileName
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  *       23 : Matrix3x3
  *       24 : MaxVisDistance
  *       25 : VDbId
  *       26 : StaticDetailLevel
  *       27 : SignalSubObj
  *       28 : SignalUnits
  *       29 : NoDirLight
  *       30 : not used
  *       31 : QDirection/Matrix3x3
  * (Compare to sub-objects(object-class) for exact definition)
  *
  * This Bitarray uses the above definition, because it
  * reflects the sequence of 'line creation' while writeing.
  * Definition of mask 'valMsk' (common, extended objects):
  *        0 : UiD
  *        1 : SectionIdx
  *        2 : Elevation
  *        3 : JNodePosn
  *        4 : TreeTexture         (+Hidewire)
  *        5 : Population
  *        6 : Config              (+Hidewire)
  *  7 to 15 : not used
  *       16 : TrItemId
  *       17 : CollideFlag
  *       18 : CollideFunction
  *       19 : FileName
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  *       23 : Matrix3x3
  *       24 : MaxVisDistance
  *       25 : VDbId
  *       26 : StaticDetailLevel
  *       27 : SignalSubObj
  *       28 : SignalUnits
  *       29 : NoDirLight
  * 30 to 31 : not used
  * 'valMsk' ONLY reflect items, which are used in more than one
  * sub-object.
  * The bit-definitions of masks 'reqMsk' and 'addMsk' use the same
  * assignment as 'Lines found', because they are compared to this
  * array in order to check
  *  - if all requested lines were present
  *  - which item should be added to the set of definition-lines.
  *
  * Bit-usage of 'StaticFlags':
  *   0 to 5 : <not known>
  *        6 : Tunnelentrance
  *        7 : No_Visual_Obstruction
  *        8 : StoreMatrix
  *  9 to 12 : <not known>
  *       13 : round shadow
  *       14 : square shadow
  *       15 : treeline shadow
  *       16 : dynamic shadow
  *       17 : <not known>
  *       18 : terrain-object
  *       19 : animate object
  *       20 : dynamic track/road-object
  *       21 : static track/road-object
  * 22 to 31 : <not known / not used>
  *
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.xx(S) - (Queue) not used
  *   1.xx(I) - (Queue) not used
  * (Compare to sub-objects(object-class) for additional definitions)
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSUiD() /* 'World'-Definition (Basis) erstellen */
   {
    super();  /* init 'TSWrld' (2 TSData-Arrays)(--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    OID  = -1;   /* Object-ID ist noch nicht gueltig */
    Uid  = null; /* Speicher fuer UId's nicht belegt */
    OT   = -1;   /* Objekt-Typ ist nicht vergeben */
    SL   = -1;   /* Ungueltiger Defaultwert fuer 'StaticDetailLevel' */
    VNr  = -1;   /* Init: VS-Kennung nicht gesetzt */
//    Pos  = null; /* no Position-values available */
//    Dir  = null; /* no QDirection-values available */
//    VId  = null; /* keine ViewSphere-Referenz */
//    nxt  = null; /* keine weitere UiD mit gleichem Wert */
//    Chn  = null; /* Initialisierung der TSChain-Kette */
//    QRef = null; /* no current backward-reference to quad-basis */
    /* all other variables are initialized by default ('0' / 'null') */
  }
 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSUiD( /* 'World'-Definition (Basis) erstellen */
   int oid, /* aktuelle Object-ID */
   int ot,  /* Objekt-Typ-Kennung */
   int sl)  /* StaticDetailLevel */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    OID = oid; /* Objekt-ID eintragen */
    OT  = ot;  /* Objekt-Typ speichern */
    SL  = sl;  /* aktueller DetailLevel uebertragen */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create special entry for 'control-objects'
  *=====================================================================
  </pre>*/
  protected TSUiD( /* 'World'-Definition (Basis) erstellen */
   int ot,  /* Objekt-Typ-Kennung (Wert>31) */
   int sl)  /* StaticDetailLevel */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    OID = 0;  /* (alle) Sondereintraege haben eindeutige Object-ID */
    OT  = ot; /* Objekt-Typ speichern */
    SL  = sl; /* aktueller DetailLevel uebertragen */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (4) Create conversion-entry
  * Method is used to change object-types from
  *    - Static to TrkObj
  *    - TrkObj to DynTrack
  *    - Signal to Static
  *    - Static to Gantry
  *=====================================================================
  </pre>*/
  protected TSUiD( /* 'World'-Definition (Basis) erstellen */
   TSUiD cO, /* Objekt zum konvertieren/kopieren */
   int   ot) /* neue Objekt-Typ-Kennung */
   {
    super(cO);  /* copy values from parent (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    OID  = cO.OID; /* copy current object-ID */
    Uid  = new int[3]; /* Speicher fuer UiD's holen */
    Uid[0] = Uid[1] = Uid[2] = cO.Uid[0]; /* insert UiD-values */
    OT   = ot;     /* insert NEW object-Type of entry */
    SL   = cO.SL;  /* aktueller DetailLevel uebertragen */
    StF  = cO.StF; /* 'StaticFlags' uebertragen */
    CoF  = cO.CoF; /* copy 'CollideFlags' */
    Opt  = cO.getOpt(255); /* transfer options 0..7 */
    CntC = cO.CntC; /* copy overall reference-couter */
    CntS = cO.CntS; /* copy reference-couter of sections */
    VNr  = cO.VNr; /* Init: VS-Kennung kopieren (falls gesetzt) */
    VId  = cO.VId; /* ViewSphere-Referenz kopieren (falls gesetzt) */
    nxt  = null;   /* keine weitere UiD mit gleichem Wert */
    Chn  = null;   /* Initialize TSChain-value, no member of chain */
    QRef = null;   /* no current backward-reference to quad */
    Pos  = cO.Pos; /* copy current position from model */
    Dir  = cO.Dir; /* copy current Q-Direction from model */
  }

 /**. <pre>
  *=====================================================================
  * Methode "$reNew"
  * Objekt fuer den Wechsel des zugeordneten Quadranten vorbereiten
  *   Alle als 'eindeutig' geforderten Werte korrigieren
  * ##$reNew.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean $reNew( /* Basis der Objekt-Definition korrigieren */
   int oid, /* neue eindeutige Object-ID */
   int uid) /* neue Nutzerkennung */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Uid==null) return true; /* mit Fehler zurueck */
    OID = oid; /* neue Objekt-ID eintragen */
    Uid[0] = Uid[1] = Uid[2] = uid; /* neue UiD-Kennung eintragen */
    nxt = null; /* keine weitere UiD mit gleichem Wert */
    return false; /* Aktion erfolgreich */
  }

 /**. <pre>
  *=====================================================================
  * Method "addTrI" (This dummy-method is normally overlayed)
  * ##addTrI.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int addTrI(int i, int j) { return -9; }

 /**. <pre>
  *=====================================================================
  * Methode "adjHgt"
  * Hoehenwert eines Knotens anpassen
  *   Ergebniswert muss nicht geprueft werden
  * ##adjHgt.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String adjHgt( /* Hoehenwert veraendern */
   double d) /* Korrekturwert der Hoehe */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return TSLogg.getKey("TSUidA01");
    Pos.addPosY(d); /* Hoehenwert korrigieren */
//    if((i=Pos.addPosY(d))!=0) return TSLogg.getMsg("TSUidA02",i);
    return null; /* Methode beenden -- kein Fehler */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chainUiD"
  * doppelte UID-Werte (gemaess Uid[0]) miteinander verketten
  * Die hier definierte UiD wird an des Ende der bei 'cUiD'
  *   begonnenen Kette angehaengt. 'cUiD' liegt in der Objekt-Reihenfolge
  *   der World-Datei immer VOR dem aktuellen UID-Eintrag (this).
  * ##chainUiD.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chainUiD( /* UiD-Kennungen verketten */
   TSUiD cUiD) /* Index der Ende-UiD */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(cUiD==null) return true; /* Fehler -- Kette fehlt */
    if(nxt!=null) return true; /* Fehler -- Kette (akt. UiD) schon da */
      /* zwei Ketten koennen nicht miteinander verbunden werden */
    while(cUiD.nxt!=null) cUiD = cUiD.nxt; /* Verkettung verfolgen */
    cUiD.nxt = this; /* Neuen Eintrag anketten */
    return false; /* Daten erfolgreich gesetzt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgChn"
  * Verkettungswert 'Chn' pflegen (eintragen/aendern oder liefern)
  * Methode wird zur Verwaltung einer 'TSChain'-Kette benutzt
  * ACHTUNG: Obwohl in Wirklichkeit mit UiD-Objekten gearbeitet wird,
  *          werden diese ueber die Superklasse 'TSWrld' adressiert.
  * ##chgChn.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSWrld chgChn( /* sortierte UiD-Kette pflegen */
   TSWrld cU) /* neue UiD-Referenz oder 'this' */
   {
   /*-----------------------------------------------------------------*/
    TSWrld cUid; /* aktuelle UiD-Referenz */
   /*=================================================================*/
    cUid = Chn; /* aktuellen Wert sichern */
    if(cU!=this) Chn = cU; /* neue UiD-Nachfolger-Referenz eintragen */
    return cUid; /* alten/aktuellen Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgElv" (This dummy-method is normally overlayed)
  * ##chgElv.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected double chgElv(double f) { return Double.NaN; }

 /**. <pre>
  *=====================================================================
  * Methode "chgCoF"
  * aktuellen Wert fuer 'CollideFlags' liefern oder aendern
  * ##chgCoF.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int chgCoF( /* modify/read value of 'CollideFlags' */
   int w) /* new value of 'CollideFlag' or 'MIN_VALUE' */
   {
   /*-----------------------------------------------------------------*/
    int i;   /* intermediate value */
   /*=================================================================*/
    i  = CoF; /* save current value for return */
    if(w!=Integer.MIN_VALUE) CoF = w; /* update current value */
    return i; /* return original value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgItS" (This dummy-method is normally overlayed)
  * ##chgItS.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int chgItS(int i) { return -9; }

 /**. <pre>
  *=====================================================================
  * Method "chgNme" (This dummy-method is normally overlayed)
  * However it is used to signal, that a name does not exist.
  * ##chgNme.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme(String s) { return null; }

 /**. <pre>
  *=====================================================================
  * Methode "chgQDf"
  * Rueckverkettung Quadratstruktur liefern oder veraendern
  * ACHTUNG: Wert nicht veraendern wenn 'nQ==null'
  * Attention: backward-referennce may point to basis-part of structure
  * ##chgQDf.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQDef chgQDf( /* Rueckverkettung Quadranden bearbeiten */
   TSQDef nQ) /* neue Verkettung oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSQDef cQ; /* aktueller Verkettungswert */
   /*=================================================================*/
    cQ = QRef; /* aktuellen Verkettungswert merken */
    if(nQ!=null) QRef = nQ; /* neue Verkettung erstellen */
    return cQ; /* Ergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgShR" (This dummy-method is normally overlayed)
  * ACHTUNG: Da das Argument 'null' nicht dem richtigen Typ zugeordnet
  *   werden kann, ist eine explizite Aufrufsteuerung notwendig!
  * ##chgShR.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSSh chgShR( /* Shape-Definition bearbeiten */
   TSSh s) /* aktuellen Shape/Pfad-Wert */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(this instanceof TSTrkObj) /* Shape-Wert (global) gefordert */
      return ((TSTrkObj)this).chgShR((TSShape)s);
    if(this instanceof TSDynTrk) /* Pfad-Wert (lokal) gefordert */
      return ((TSDynTrk)this).chgShR((TSShL)s);
    return null; /* Default-Dummywert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgView"
  * Aktuelle ViewSphere Referenz eintragen/aendern oder liefern
  * ##chgView.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSView chgView( /* ViewSphere-Referenz bearbeiten */
   TSView nVS) /* neue ViewSphere-Referenz */
   {
   /*-----------------------------------------------------------------*/
    TSView cVS; /* aktuelle ViewShere-referenz */
   /*=================================================================*/
    cVS = VId; /* aktuelle ViewShere sichern */
    if(nVS!=null) VId = nVS; /* neue ViewSphere-Referenz eintragen */
    return cVS; /* alten/aktuellen Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkAnim"
  * Check 'Animation'-Status within 'StaticFlags' and report status
  *   Reset status if requested.
  * ##chkAnim.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkAnim( /* check Animation-status */
   boolean clr) /* clear status is 'true' */
   {
   /*-----------------------------------------------------------------*/
    boolean s; /* intermediate value */
   /*=================================================================*/
    s = TSOpts.chkMsk(19,StF); /* check animation-switch */
    if(clr) StF = TSOpts.clrMsk(19,StF); /* clear animation-status */
    return s; /* return previous status of animation-switch */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkColl"
  * Check 'Collition'-Status within 'CollideFlags' and report status
  *   Reset status if requested.
  * Attn: Status is 'reset' if bit is 'set'
  * ##chkColl.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkColl( /* check Collition-status */
   boolean clr) /* clear status is 'true' */
   {
   /*-----------------------------------------------------------------*/
    boolean s; /* intermediate value */
   /*=================================================================*/
    s = !TSOpts.chkMsk(1,CoF); /* check collition-switch */
    if(clr) CoF = TSOpts.setMsk(1,CoF); /* clear collition-status */
    return s; /* return previous status of animation-switch */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkId"
  * UiD-Definition vergleichen (Verkettung beachten)
  * Achtung: World-Definition(Qx,Qz) wird NICHT beachtet
  *          Es werden NUR UiD's fuer Schiene/Strasse akzeptiert
  * Kennung: 0 - geforderter Typ (Schiene/Strasse) muss stimmen
  *          1 - Schienen/Strassen-Objekt muss vorliegen
  *          2 - UiD muss existieren
  * ##chkId.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSUiD chkId( /* UiD-Kennung vergleichen */
   int id, /* gesuchte UiD-Kennung */
   int db, /* Nummer der Datenbank (0,1) */
   int t)  /* Haerte der Kriterien zum Suchen (0,1,2) */
   {
   /*-----------------------------------------------------------------*/
    TSUiD cUiD; /* intermediate value */
   /*=================================================================*/
    if(Uid[0]!=id) return null; /* UiD-Wert stimmt nicht */
    if(t>1) return this; /* Id stimmt -- zurueckgeben */
    for(cUiD=this;cUiD!=null;cUiD=cUiD.nxt) { /* alle Verketteten */
      if(!cUiD.isTrack()) continue; /* keine Schiene -- weiter */
      if(t>0) return cUiD; /* Id und Typ stimmt -- zurueckgeben */
      if((cUiD.Opt&4)==0) { /* Schiene liegt vor '!isOpt(2)' */
        if(db==0) return cUiD; /* Schiene ist gefordert -- OK */
      } else if(db==1) return cUiD; /* Strasse ist OK */
    } /* alle Verkettungen pruefen */
    return null; /* keine zutreffende UiD gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkRCnt"
  * Method checks if number of references from track-database to
  *   world-object matches the number of defined sections within the
  *   shape-definitions. If it does not match, a error-message is
  *   created, else 'null' is returned.
  * ##chkRCnt.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chkRCnt( /* check reference-counters */
   TSSh cSh) /* reference to current shape- / path - entry */
   {
   /*-----------------------------------------------------------------*/
    int c; /* intermediate counter-value */
   /*=================================================================*/
    if(CntS<=0) return null; /* not referenced -- skip message */
    if(cSh==null) return null; /* no valid connection -- skip Msg */
    c = cSh.incCntR(0); /* get number of section-references to entry */
    if(c==CntS) return null; /* number matches -- no error found */
    return TSLogg.getMsg("TSUidC01",""+c,CntS); /* return error */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkSL"
  * Check mask using current 'StaticDetailLevel'.
  * ##chkSL.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkSL( /* check value with 'StaticDetailLevel' */
   TSOpts cM) /* Mask to be checked */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return cM.chkMsk(SL); /* test mask and return */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkType"
  * Check mask-object if it selects current objecttype.
  * ##chkType.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkType( /* check type of object */
   TSOpts cM) /* Mask-object of supported object-types */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return cM.chkMsk(OT); /* is it a supported type? */
  }

 /**. <pre>
  *=====================================================================
  * Methode "clrOpt"
  * Option aus den Gesamt-Optionen herausloeschen
  * liefert den Status der Option VOR dem Loeschen
  * ##clrOpt.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean clrOpt( /* Optionenwert anpassen */
   int nr) /* Nummer der Option */
   {
   /*-----------------------------------------------------------------*/
    boolean s; /* Arbeitswerte */
   /*=================================================================*/
    if(nr<0 || nr>31) throw new /* Abbruch Programm mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","clrOpt",nr,1));
    nr = 1 << nr; /* Test-Maske fuer Kennungsbit erstellen */
    s = (Opt & nr)!=0; /* Status des Maskenbits festhalten */
    Opt &= ~nr; /* gefordertes Maskenbit herausloeschen */
    return s; /* Ende -- alter Status liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "clrView"
  * Aktuelle ViewSphere Referenz loeschen und durch Viewsphere-Kennung
  *   ersetzen. Alte Viewsphere Referenz liefern
  * ##clrView.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSView clrView( /* ViewSphere-Referenz deaktivieren */
   int w) /* Kennung der Viewsphere (0..15) */
   {
   /*-----------------------------------------------------------------*/
    TSView cVS; /* aktuelle ViewShere-referenz */
   /*=================================================================*/
    if(w<0 || w>15) w = 15; /* Default fuer ungueltigen Wert */
    cVS = VId;  /* aktuelle ViewShere sichern */
    VId = null; /* aktuelle ViewSphere-Referenz loeschen */
    VNr = w;    /* Viewsphere-Kennung setzen */
    return cVS; /* alten/aktuellen Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * Version fuer ALLE GEMEINSAMEN Definitionen
  * ##crDef.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   boolean c)  /* Kennzeichen setzen wenn Fehler und 'true' */
   {
   /*-----------------------------------------------------------------*/
    String   is;  /* Zwischenwert */
    long     l;
    double   A,R;
   /*=================================================================*/
    if(n>0) return null; /* keine weitere Zeile mehr */
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(17): /* 'CollideFlags */
        return "\t\tCollideFlags ( " + CoF + " )"; /* return Stmt */
      case(19): /* 'FileName' */
        is = chgNme(null); /* Dateiname holen */
        if(is==null) { /* Fehler: Dateiname nicht vorhanden */
          if(me) return TSLogg.getMsg("TSUidD01",getUiD(0));
          is = " "; /* Dummy-Wert benutzen */
        } /* File-Name ist OK */
        return "\t\tFileName ( " + TSUtil.modStr(is) + " )";
      case(20): /* 'StaticFlags' */
        return "\t\tStaticFlags ( " + TSUtil.toHex(StF,8) + " )";
         /* Statement erzeugen , Wert Hexadezimal ausgeben */
      case(21): /* 'Position' */
        if(Pos!=null)  /* Positionsreferenz vorhanden  -- nutzen */
          return "\t\tPosition (" + Pos.getPos(6,1) + " )"; /* Stmt erzeugen */
        if(me) return TSLogg.getMsg("TSUidD02",getUiD(0));
        return "\t\tPosition ( 0.0 0.0 0.0 )"; /* Stmt erzeugen */
      case(22): /* 'QDirection' */
        if(Dir!=null)  /* Directionreferenz vorhanden  -- nutzen */
          return "\t\tQDirection (" + Dir.getDir(9) + " )"; /* Stmt erzeugen */
        if(me) return TSLogg.getMsg("TSUidD03",getUiD(0));
        return "\t\tQDirection ( 0 0 0 1 )"; /* Stmt erzeugen */
      case(25): /* 'VDbId' */
        if(VId!=null) l = VId.getId(); /* aktuelle ID holen */
        else if(VNr>=0) l = TSUtil.NoVS + VNr; /* ID-Kennung */
        else { /* ID ist nicht bekannt */
          if(me) return TSLogg.getKey("TSUidD04");
          l = 4294967295L; /* Dummy-Wert benutzen */
        } /* VDbId ist OK */
        return "\t\tVDbId ( " + l + " )";  /* Stmt erzeugen */
      case(26): /* 'StaticDetailLevel' */
        return "\t\tStaticDetailLevel ( " + SL + " )"; /* Stmt erzeugen */
      default: /* Fehlerhafte Definition kennzeichnen */
        if(me) return TSLogg.getMsg("TSUidD09",getName(OT),t);
        return "\t\t"+t;  /* Stmt erzeugen */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef" (2. Version)
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * Spezial-Version fuer GEMEINSAMEN Definitionen mit 'K_Dta'
  * ACHTUNG: Keine Plausi-Pruefungen (nur interne Verwendung)
  * ##crDef.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int t,  /* Kennung des Ausgabe-Type (gemaess 'K_Dta'-Nr) */
   int ix) /* Index der Daten zum Einsetzen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "\t\t"+K_Dta[t]+" ("+getDta(ix)+")"; /* Datenzeile erst. */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef" (3. Version fuer Kontroll-Eintraege)
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me) /* ggf. Meldung liefern wenn 'true' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(n>0) return null; /* keine weitere Zeile mehr */
    switch(OT) { /* verzweigen gemaess Kontrolltyp */
      case(32): /* 'Tr_Watermark' */
        return "\tTr_Watermark ( " + SL + " )"; /* Stmt erzeugen */
      default: /* Fehlerhafte Definition kennzeichnen */
        if(me) return TSLogg.getMsg("TSUidDZZ",getName(OT),n);
        return "\t\t"+OT;  /* Stmt erzeugen */
    } /* Bearbeitung gemaess Objekt-Typ */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crPos"
  * Information-Hiding: Positionswerte als TSPos-Objekt liefern
  * Achtung: Es wird eine (shallow-)Kopie geliefert, sodass die Attribute
  *          dieses Objektes (testweise) modifiziert werden koennen,
  *          ohne das Basisobjekt zu beeinflussen
  * ##crPos.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSPos crPos() /* Positionswerte als Vector liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return null; /* Kennung falls nicht vorhanden */
    return new TSPos(Pos); /* neues Objekt liefern (Kopie) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crQDir"
  * Information-Hiding: Rotationswerte als TSQDir-Objekt liefern
  * ##crQDir.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQDir crQDir() /* Rotation als 'Quaternion' liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return new TSQDir(Dir); /* neues Objekt (Kopie) liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crStatic"
  * Create a 'Static' world-object based on the current object
  *  and insert it to appropriate chain
  * Return error-message or 'null' if sucessful
  * ##crStatic.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crStatic( /* create static world-object */
   TSChain cC, /* object-chain of parent Quad-entry */
   TSQuad  cQ, /* parent Quad-entry */
   String  cN, /* filename of new object */
   int     sl, /* 'StaticDetailLevel' of new object */
   TSRoute cR) /* current Route if 'End'-Position of object is req. */
   {
   /*-----------------------------------------------------------------*/
    TSStatic nO;    /* new 'static' world-object */
    TSPos    cPos;  /* current/intermediate position-value */
    TSQDir   cQDir; /* current/intermediate direction */
    TSShape  cSh;   /* intermediate value */
    TSScIdx  cScI;  /* intermediate value */
    TSSect   cSc;   /* intermediate value */
    String   is,js; /* intermediate value */
    int      i,j;   /* intermediate value */
    double   d;     /* intermediate value */
   /*=================================================================*/
    is = null; /* preset flag: no error */
    cPos = new TSPos(Pos); /* get position of track-object */
    cQDir = new TSQDir(Dir); /* get current direction of track-object */
    if(cR!=null) eoo:{ /* change position/direction to 'end of object' */
      cSh = (TSShape)chgShR(null); /* get reference to connected Shape */
      if(cSh==null) return TSLogg.getMsg("TSUidN33"); /* return with error */
        /* no connected shape found -- print error end term */
      if(cSh.chkMsk(16)) return TSLogg.getMsg("TSUidN34",cSh.chkNme(null));
        /* MainRoute exists -- shape is not valid for this operation */
      cScI = cSh.chgScI(0,null); /* get first sectionIdx-definition */
        /* ANY of the defined sectionIdx-objects may be used */
      if(cScI==null) throw new IllegalStateException( /* definition missing */
         TSLogg.getMsg("Msg904","TSShape("+cSh.chkNme(null)+").TSScIdx==null"));
      if(cScI.adj(true,cQDir,cPos)) /* error -- invalid angle found */
        return TSLogg.getMsg("TSUidN35",cSh.chkNme(null)); /* return error */
        /* Position-value is corrected (offset is added) for section-processing
         * if 'true': invalid angle found  -- section cannot be used for this
         *  operation. Therefore the whole shape is invalid.
         */
      j = cScI.get$Sc(); /* get number of section-definitions */
      for(i=0;i<j;i+=1) { /* process all section-definitions */
        cSc = cScI.chgScR(i,null); /* get connected section-definition */
        d = cSc.getAng(); /* get current angle of section (0 if straight) */
        cPos.toEnd(cQDir,cSc.getLR(),d); /* compute new position */
        if(d!=0.0) cQDir.turn(d); /* and new direction if needed */
      } /* all sections are processed */
      cScI.adj(false,cQDir,cPos); /* back to correct displacement */
      i = cPos.addPosX(0.0); /* check final position and adjust */
      j = cPos.addPosZ(0.0); /* check final position and adjust */
      if(i==0 && j==0) break eoo; /* position valid -- continue */
      /* position is located within an other quad */
      js = cQ.getMsg(1,null,i,j); /* get target-definition (number) */
      cQ = cQ.fndQuad(cR,i,j); /* search for appropriate quad-definition */
      if(cQ==null) return TSLogg.getMsg("TSUidN31",js); /* return with error */
       /* definition not found -- error */
      if((cC=cQ.chgWTab(null,0))!=null) break eoo; /* world-file IS present */
      if(cQ.setNme(true)) is = TSLogg.getMsg("TSUidN32",js); /* set warning */
      cC = new TSChain(); /* create new, empty object-chain */
      cQ.chgWTab(cC,0); /* and store it into quad-definition */
    } /* -eoo- values have been corrected */
    /* now: create new object and insert all definitions
     * cC and cQ may be changed to new Quad */
    nO = new TSStatic(cQ.getOId(),sl); /* create new object */
    nO.setUiD(cQ.getWId()); /* insert next free UID-value */
    nO.setMsk(26); /* mark: 'StaticDetailLevel' is inserted and valid */
    nO.chgNme(cN); /* insert filname of new object */
    nO.setMsk(19); /* mark: 'Filename' is inserted and valid */
    nO.setStF(0x00040080); /* set default value for 'StaticFlags' */
    nO.setMsk(20); /* mark: 'StaticFlags' is inserted and valid */
    nO.setPos(cPos); /* set new position-value */
    nO.setMsk(21); /* mark: 'Position' is inserted and valid */
    nO.setQDir(cQDir); /* set new quaternion (shallow-copy) */
    nO.setMsk(22); /* mark: 'Direction' is inserted and valid */
    nO.clrView(nO.getVNrDef()); /* insert valid 'Default'-view */
    nO.setMsk(25); /* mark: 'ViewDB' is inserted and valid */
    nO.chgQDf(cQ); /* insert backlink to current quad */
    cC.add(nO); /* and insert it into current object-chain */

    return is; /* return flag: 'NO error' or 'warning' */
  }

 /**. <pre>
  *=====================================================================
  * Method "fndTrI" (This dummy-method is normally overlayed)
  * ##fndTrI.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int fndTrI(int i, int j) { return -9; }

 /**. <pre>
  *=====================================================================
  * Method "getCtl" (This dummy-method is normally overlayed)
  * ##getCtl.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl(int i) { return (i<0) ? -1 : 0; }

 /**. <pre>
  *=====================================================================
  * Methode"getItem" (This dummy-method is normally overlayed)
  * ##getItem.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem(int i) { return null; }

 /**. <pre>
  *=====================================================================
  * Methode "getMsg"
  * Verschiedene Informationen in verschiedenen Formen bereitstellen
  * ##getMsg.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getMsg( /* Informationen als Kette bereitstellen */
   int nr) /* Kennung der geforderten Daten sowie Form */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Selection erstellen */
      case(0): /* Standard-Positionsdefinition */
        if(Pos==null) return "0 0 0";
        return Pos.getPos(false); /* Ergebnis liefern */
      case(1): /* Positionsdefinition fuer Dokumentation */
        if(Pos==null) return "{?,?,?}";
        return "{"+Pos.getPos(true)+"}"; /* Ergebnis liefern */
      case(2): /* Standard-Richtungsdefinition */
        if(Dir==null) return "0 0 0 1";
        return Dir.getDir(false); /* Ergebnis liefern */
      case(3): /* Richtungsdefinition fuer Dokumentation */
        if(Dir==null) return "{?,?,?,?}";
        return "{"+Dir.getDir(true)+"}"; /* Ergebnis liefern */
      case(4): /* UiD-Kennung(0) + Quadranden gemaess Rckverkettung */
        if(Uid==null) throw new /* Daten nicht vollstaendig */
          IllegalStateException(TSLogg.getMsg("Msg905","TSUiD.getMsg(4)[UiD]"));
        if(QRef==null) throw new /* Daten nicht vollstaendig */
          IllegalStateException(TSLogg.getMsg("Msg905","TSUiD.getMsg(4)[QRef]"));
        if(!(QRef instanceof TSQuad)) throw new /* Referenz falsch */
          IllegalStateException(TSLogg.getMsg("Msg905","TSUiD.getMsg(4)[QRef!]"));
        return ((TSQuad)QRef).getInf(1) + " " + Uid[0]; /* Quadranten (neu) holen,
          * Nutzerkennung[0] anhaengen und Ergebnis liefern */
      case(5): /* UiD-Kennung(2) + Quadranden gemaess Rckverkettung */
        if(Uid==null) throw new /* Daten nicht vollstaendig */
          IllegalStateException(TSLogg.getMsg("Msg905","TSUiD.getMsg(5)[UiD]"));
        if(QRef==null) throw new /* Daten nicht vollstaendig */
          IllegalStateException(TSLogg.getMsg("Msg905","TSUiD.getMsg(5)[QRef]"));
        if(!(QRef instanceof TSQuad)) throw new /* Referenz falsch */
          IllegalStateException(TSLogg.getMsg("Msg905","TSUiD.getMsg(5)[QRef!]"));
        return ((TSQuad)QRef).getInf(1) + " " + Uid[2]; /* Quadranten (neu) holen,
          * Nutzerkennung[2] anhaengen und Ergebnis liefern */
    } /* gemaess Kennung beendet */
    return TSLogg.getMsg("TSUidM00",nr); /* Dummy-Fehler */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * Diese Methode wird benutzt wenn in der abgeleiteten Klasse
  *  keine Methode 'getName()' definiert ist. Da dies (normalerweise)
  *  nicht der Fall ist, wird diese Methode nur fuer Objekte der
  *  Basisklasse verwendet. Diese haben keinen Namen.
  * ##getName.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return getName(OT); /* Objekt-Typ gemaess gespeicherter Typ-Nr */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName" (statisch)
  * liefern der Bezeichnung eines Objekt-Typs
  * ##getName.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getName( /* Name eines Objekt-Typs liefern */
   int ot) /* gefordertes Objekt-Typ */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(ot) { /* gemaess Typ verzweigen */
      case( 0): return "TrackObj"; /* Bezeichnung liefern */
      case( 1): return "Dyntrack"; /* Bezeichnung liefern */
      case( 2): return "Signal"; /* Bezeichnung liefern */
      case( 3): return "Static"; /* Bezeichnung liefern */
      case( 4): return "Forest"; /* Bezeichnung liefern */
      case( 5): return "Platform"; /* Bezeichnung liefern */
      case( 6): return "Siding"; /* Bezeichnung liefern */
      case( 7): return "Gantry"; /* Bezeichnung liefern */
      case( 8): return "Speedpost"; /* Bezeichnung liefern */
      case( 9): return "CarSpawner"; /* Bezeichnung liefern */
      case(10): return "LevelCr"; /* Bezeichnung liefern */
      case(11): return "Hazard"; /* Bezeichnung liefern */
      case(12): return "Transfer"; /* Bezeichnung liefern */
      case(13): return "CollideObject"; /* Bezeichnung liefern */
      case(14): return "Telepole"; /* Bezeichnung liefern */
      case(15): return "Pickup"; /* Bezeichnung liefern */
      case(32): return "Tr_Watermark"; /* Bezeichnung liefern */
      default: return "<unknown>"; /* Objekt-Typ nicht bekannt */
    } /* Ende switch-Statement */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getOpt"
  * Gesamt-Optionen maskiert liefern
  * Maske '-1' (=0xFFFFFFFF) liefert ALLE Optionen
  * Die gespeicherte Maske wird NICHT veraendert
  * ##getOpt.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getOpt( /* Optionenwerte maskiert liefern */
   int m) /* Maske der geforderten Optionen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Opt&m; /* geforderte Optionen zurueckliefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getSL"
  * Information-Hiding: Return current StaticDetailLevel
  * ##getSL.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getSL() /* get current StaticDetailLevel */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return SL; /* return current StaticDetailLevel */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getUiD"
  * Information-Hiding: aktuelle UID gemaess UiD-Typ liefern
  * ##getUiD.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getUiD( /* UID-Definition liefern */
   int t) /* typ der geforderten UiD */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* Rueckgabewert '-1' wird fuer 'nicht belegte UiD' benutzt */
    if(Uid==null) return -2; /* Speicher existiert noch nicht */
    if(t<0 || t>2) return -3; /* Index ausserhalb */
    return Uid[t]; /* aktuelles Ergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCntC"
  * Increment reference-counter (overall) for node-references within
  *   database. ALL references from database are counted.
  * (using argument'0', reference-counter may be returned only)
  * ('C' means 'complete')
  * ##incCntC.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCntC( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int c; /* intermediate value */
   /*=================================================================*/
    c = CntC; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-CntC); /* must not become negative */
    CntC += inc; /* increment (decrement) reference-counter */
    return c; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCntS"
  * Increment reference-counter (section) for node-references within
  *   database. Only references from section-defintions within database
  *   are counted.
  * (using argument'0', reference-counter may be returned only)
  * ('S' means 'sections')
  * ##incCntS.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCntS( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int c; /* intermediate value */
   /*=================================================================*/
    c = CntS; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-CntS); /* must not become negative */
    CntS += inc; /* increment (decrement) reference-counter */
    return c; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isBefore"
  * Methode zum sortieren der World-Eintraege
  * Diese Methode liefert 'true', wenn das aktuelle Objekt in der
  *  Sortierfolge noch VOR dem GELIEFERTEN Objekt (vO) liegt.
  * Diese Methode wird durch 'TSChain' benutzt und gefordert
  * ##isBefore.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isBefore( /* UiD-Def's vergleichen fuer Sort */
   TSWrld vO)  /* Vergleichsobjekt */
   {
   /*-----------------------------------------------------------------*/
    TSUiD vW; /* intermediate value */
   /*=================================================================*/
    if(!(vO instanceof TSUiD)) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg902","isBefore",1,2));
    vW = (TSUiD)vO; /* Objekt anpassen */
    if(SL<vW.SL) return true; /* kleiner - davor */
    if(SL>vW.SL) return false;  /* groesser - hinter */
    /* StaticDetailLevel ist gleich -- nach OID sortieren. Watermark
     * ist erster Eintrag und wird durch OID==0 gekennzeichnet.
     * OID==0 tritt NUR bei solchen Eintraegen auf. */
    if(OID<vW.OID) return true; /* kleiner - davor */
    if(OID>vW.OID) return false; /* groesser - hinter */
    throw new /* gleicher Eintrag nicht erlaubt -- Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg903","isBefore",1));
  }

 /**. <pre>
  *=====================================================================
  * Methode "isCtl"
  * Pruefung ob ein Control-Eintrag (OT>31) vorliegt
  * ##isCtl.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isCtl() /* auf Control-Eintrag pruefen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return OT>31; /* Status als Antwort liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isEqual"
  * Methode zum pruefen der World-Eintraege auf Gleichheit
  * Diese Methode wird durch 'TSChain' benutzt und gefordert
  * ##isEqual.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isEqual( /* UiD-Def's vergleichen fuer Sort */
   TSWrld vO)  /* Vergleichsobjekt */
   {
   /*-----------------------------------------------------------------*/
    TSUiD vW; /* intermediate value */
   /*=================================================================*/
    if(!(vO instanceof TSUiD)) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg902","equals",1,2));
    vW = (TSUiD)vO; /* Objekt anpassen */
    if(SL!=vW.SL) return false; /* nicht gleich - melden*/
    /* StaticDetailLevel ist gleich -- Objekt-ID? */
    return OID==vW.OID; /* melden ob Eintraege identisch sind */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isOpt"
  * Pruefung ob Option aktiviert
  * Methode liefert 'true' wenn das Optionenbit gesetzt ist
  * ##isOpt.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isOpt( /* Optionenwert auf Option pruefen */
   int nr) /* Nummer der Option */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>31) throw new /* Abbruch Programm mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","isOpt",nr,1));
    nr = 1 << nr; /* Test-Maske fuer Kennungsbit erstellen */
    return (Opt&nr)!=0; /* liefern aktuelles Optionen-Bit */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isRoad"
  * Pruefen ob Eintrag eine Strasse beschreibt
  * Wenn DIESE Methode aktiv wird kann KEINE Strasse vorliegen.
  * Falls der Subtyp die Moeglichkeit einer Strasse vorsieht, wird
  *   diese Methode ueberschrieben.
  * ##isRoad.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isRoad() /* Strassenbeschreibung aktiv ? */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return false; /* Default: Strasse kann NICHT vorliegen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isTrack"
  * pruefen ob World-Eintrag eine Track-Definition ist
  * Wenn DIESE Methode aktiviert wird, liegt KEINE Track-Def. vor.
  * ##isTrack.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isTrack() /* 'World'-Definition pruefen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return false; /* Objekt ist KEIN Track-Objekt */
  }

 /**. <pre>
  *=====================================================================
  * Method "modPos"
  * Modify a supplied Offset-position using the current direction
  * Method returns 'true' if an error is found
  * ##modPos.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean modPos( /* modify offset-position */
   TSPos cP) /* current offset-Position */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Dir==null) return true; /* no direction-value -- report it */
    if(cP==null) throw new IllegalArgumentException( /* systemerror */
      TSLogg.getMsg("Msg901","TSUiD.modPos()","<null>",1));
    cP.mul(Dir); /* modify/adjust value */
    return false; /* return with marker: no error */
  }

 /**. <pre>
  *=====================================================================
  * Methode "nxtUiD"
  * UID-Wert(orginal) mit Maximalwert neu setzen und korrigieren
  * Routine arbeitet auf 'Uid[1]', 'Uid[2]'
  * ##nxtUiD.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int nxtUiD( /* UiD-Kennung neu setzen */
   TSQuad cQ) /* aktuelle Quadrat-Definition */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(cQ==null) return -1; /* Fehler */
    if(Uid==null) return -2; /* Speicher existiert noch nicht */
    Uid[1] = Uid[2] = cQ.getWId(); /* korrigierte UiD-Kng. setzen */
    return Uid[1]; /* Kennung auch liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "renUiD"
  * UID-Wert(neu) mit neue erstellter UiD-Kennung setzen
  * Routine arbeitet auf 'Uid2'
  * Wenn 'nr' negativ ist, wird 'nr' unveraendert zurueckgegeben und
  *   die UiD nicht veraendert
  * Routine arbeitet auf 'Uid[2]'
  * ##renUiD.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int renUiD( /* UiD-Kennung neu numerieren */
   int nr) /* neue zu vergebene UiD-Kennung */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(clrOpt(24)) return nr; /* Option WAR gesetzt -- Ende */
      /* Option muss auf jeden Fall zurueckgesetzt werden */
    if(nr<0) return nr; /* UiD nicht neu vergeben! */
    if(Uid==null) return nr; /* Speicher existiert noch nicht */
    Uid[2] = nr; /* neue UiD-Kennung setzen */
    nr += 1; /* UiD-Kennung ist jetzt vergeben */
    return nr; /* naechster freier Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "setName" (This dummy-method is normally overlayed)
  * ##setName.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean setName(ArrayList cL,int ix,String aP,String... cp)
   { return true; } /* nothing was replaced */

 /**. <pre>
  *=====================================================================
  * Methode "setOpt"
  * Option den Gesamt-Optionen hinzufuegen
  * liefert den Status der Option VOR dem setzen
  * ##setOpt.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean setOpt( /* set selected option */
   int nr) /* number of selected option (0..31) */
   {
   /*-----------------------------------------------------------------*/
    boolean s; /* Arbeitswerte */
   /*=================================================================*/
    if(nr<0 || nr>31) throw new /* terminate with systemerror */
      IllegalArgumentException(TSLogg.getMsg("Msg901","setOpt",nr,1));
    nr = 1 << nr; /* Test-Maske fuer Kennungsbit erstellen */
    s = (Opt & nr)!=0; /* Status des Maskenbits festhalten */
    Opt |= nr; /* neues Maskenbit einsetzen */
    return s; /* Ende -- alter Status liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setOT" (statisch)
  * Objekt-Typ pruefen und liefern.
  * Wird ausschliesslich in 'chgWF()' benutzt!
  * Achtung: Objekttyp ist in kleienen Buchstaben angegeben.
  * ##setOT.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int setOT( /* Subtyp-Kennung pruefen */
   String kw) /* Name des Objekt-Typs */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(kw==null) return -2; /* Ungueltiges Schluesselwort */
    if(kw.equals("trackobj")) return 0; /* Typ-Kennung liefern */
    if(kw.equals("dyntrack")) return 1; /* Typ-Kennung liefern */
    if(kw.equals("signal")) return 2; /* Typ-Kennung liefern */
    if(kw.equals("static")) return 3; /* Typ-Kennung liefern */
    if(kw.equals("forest")) return 4; /* Typ-Kennung liefern */
    if(kw.equals("platform")) return 5; /* Typ-Kennung liefern */
    if(kw.equals("siding")) return 6; /* Typ-Kennung liefern */
    if(kw.equals("gantry")) return 7; /* Typ-Kennung liefern */
    if(kw.equals("speedpost")) return 8; /* Typ-Kennung liefern */
    if(kw.equals("carspawner")) return 9; /* Typ-Kennung liefern */
    if(kw.equals("levelcr")) return 10; /* Typ-Kennung liefern */
    if(kw.equals("hazard")) return 11; /* Typ-Kennung liefern */
    if(kw.equals("transfer")) return 12; /* Typ-Kennung liefern */
    if(kw.equals("collideobject")) return 13; /* Typ-Kennung liefern */
    if(kw.equals("telepole")) return 14; /* Typ-Kennung liefern */
    if(kw.equals("pickup")) return 15; /* Typ-Kennung liefern */
    if(kw.equals("tr_watermark")) return 32; /* Typ-Kennung liefern */
    return -1; /* Kennung fuer unbekannten Objekt-Typ */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setPos"
  * Positionsobjekt speichern
  * ##setPos.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSPos setPos( /* Positionsobjekt speichern */
   TSPos cP) /* neues Positionsobjekt */
   {
   /*-----------------------------------------------------------------*/
    TSPos cPos; /* Original-Wert */
   /*=================================================================*/
    if(cP instanceof TSQPos) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","setPos()","Q",1));
    cPos = Pos; /* Originalwert sichern falls vorhanden */
    Pos = cP; /* neue Position uebertragen */
    return cPos; /* Methode beenden (Originalwert liefern) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setQDir"
  * Richtungsdefinition eines Objektes speichern
  * ##setQDir.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQDir setQDir( /* Richtungswerte speichern */
   TSQDir cD) /* neues Quaternion-Objekt */
   {
   /*-----------------------------------------------------------------*/
    TSQDir cDir; /* Original-Wert */
   /*=================================================================*/
    cDir = Dir; /* Originalwert sichern falls vorhanden */
    Dir = cD; /* neues Quaternion uebertragen */
    return cDir; /* Methode beenden (Originalwert liefern) */
  }

 /**. <pre>
  *=====================================================================
  * Method "setSc" (This dummy-method is normally overlayed)
  * ##setSc.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean setSc(int i, int j, int k) { return true; }

 /**. <pre>
  *=====================================================================
  * Method "setSL"
  * Set new value for 'StaticDetailLevel'.
  * Value is chanded in every case and OLD one is returned.
  * Value can be ONLY resumed if used twice: 'setSL(x=setSL(0));'.
  * Attention: This method marks 'StaticDetailLevel' as 'set explicitely'
  * Attention: New value may be modified to match the allowed range.
  * ##setSL.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int setSL( /* Set new value for 'StaticDetailLevel' */
   int w) /* new value for 'StaticDetailLevel' (0..10) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i  = SL; /* save return/old value */
    if(w<0) w = 0; /* correct range of value */
    if(w>10) w = 10; /* correct range of value */
    SL = w;  /* and insert new one */
    setMsk(26); /* new value is explicitely set */
    return i; /* return old value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setStF"
  * Set new value for 'StaticFlags'
  * Value can be resumed if used twice: 'setStF(x=setStF(0));'
  * ##setStF.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int setStF( /* set new value of 'StaticFlags' */
   int w) /* new value for 'StaticFlags' */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i  = StF; /* save return/old value */
    StF = w; /* and insert new one */
    return i; /* return old value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setUiD"
  * aktuelle UID initialisieren und eintragen
  * Achtung: Eine einmal eingetragene UiD kann hiermit NICHT mehr
  *          ueberschrieben werden
  * ##setUiD.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int setUiD( /* UID-Definition initialisieren */
   int uid) /* Nummer der neuen UiD */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Uid!=null) return Uid[0]; /* UiD-Kennung bereits gesetzt */
    Uid = new int[3]; /* Speicher fuer UiD's holen */
    Uid[0] = Uid[1] = Uid[2] = uid; /* UiD-Kennung eintragen */
    setMsk(0); /* kennzeichnen dass 'UiD' eingetragen wurde */
    return -1; /* UiD erfolgreich erstellt */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return toStr(true); /* Ergebnis zurueckgeben */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSUiD (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr( /* Create String-version of values */
   boolean term) /* add termination ? */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-String */
   /*=================================================================*/
    rs = "TSUiD{" + OID; /* Start of data */
    if(Uid==null) rs += ",<null>"; /* UiD-definition not found */
    else rs += "," + Uid[0] + "(" + Uid[1] + "," + Uid[2] + ")";
    if(QRef!=null) rs += ",<set>,"; /* Referenz vorhanden */
    else rs += ",<null>,"; /* Kennung einfuegen */
    rs += SL + "-" + TSUtil.toHex(Opt,-8) + "-(";
    if(Pos!=null) rs += Pos.getPos(true); /* Werte aufbereiten */
    else rs += "<null>"; /* sonst Kennung einfuegen */
    rs += ")-("; /* Zwischenteil setzen */
    if(Dir!=null) rs += Dir.getDir(true); /* Werte aufbereiten */
    else rs += "<null>"; /* sonst Kennung einfuegen */
    rs += ")-("; /* Zwischenteil setzen */
    if(VId!=null) rs += "OK"; else rs += "<null>";
    rs += "/" + VNr + ")-"; /* add separator */
    rs += super.toStr(); /* add values from 'TSWrld'-part */
    rs += "-" + CntC + "(" + CntS + ")-" + OT;
    if(term) rs += "}"; /* add termination */
    return rs; /* provide result-string */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSTrkObj -- Definition of a TrackObj-world-Entry
 * ##TSTrkObj (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTrkObj extends TSUiD { /* 'World'-Entry-definition: TrackObj */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.01 03.03.2009";
  private static final int      valMsk = 0x07FE005F; /* Lines (valid) */
  private static final int      reqMsk = 0x80280005; /* Lines (req) */
  private static int            addMsk = 0x06000008; /* Lines (add) */
  private static String[]       reqNme = { /* Names of requested Items */
    "UiD","SectionIdx","FileName","Position","QDirection/Matrix3x3"};
 /*-------------------------------------------------------------------*/
  private TSShape               Sh;     /* current Shape-Reference */
  private String                Nme;    /* Filename of the Shape */
  private String                NmeO;   /* orig. Filename of Shape */
  private double                Elv;    /* current Elevation */
  private TSQPos                JNdeP;  /* 'JNodeP'-Definition
                                         * (Quad, Position, Ref.) */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 - 'JNodePosn' is defined
  *        9 - Obj. converted from 'static representation' (e.g. Hidewire)
  *       10 - Create 'static representation' of track
  *       11 -
  *       12 - Name of shape (filename) is modified(NmeO!=Nme)
  *       13 -
  *       14 - Original SectionIdx-value is NOT useable
  *       15 - 'Hidewire' using SectionIdx-value is active
  *       16 - Original filename does not match a valid shape
  *   17..23 - (not used)
  * Definition of 'Entry found' (stored in TSOpt):
  *        0 : UiD
  *        2 : SectionIdx
  *        3 : Elevation
  *        4 : JNodePosn
  *        5 : Config                    (Hidewire)
  *  6 to 16 : not used
  *       17 : CollideFlag
  *       18 : CollideFunction
  *       19 : FileName
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  *       23 : Matrix3x3
  *       24 : MaxVisDistance
  *       25 : VDbId
  *       26 : StaticDetailLevel
  * 27 to 30 : not used
  *       31 : QDirection/Matrix3x3
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.00(S) - Entry not used
  *   0.01(S) - Entry not used
  *   0.02(S) - Definitionstatement of 'CollideFunction'
  *   0.03(S) - Definitionstatement of 'Matrix3x3'
  *   0.04(S) - Definitionstatement of 'MaxVisDistance'
  *   1.00(I) - Data of 'Config'-statement (Hidewire)
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSTrkObj() /* 'World'-Definition (TrackObj) erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Elv = 0.0; /* Default-value of Elevation */
    setOpt(1); /* mark object as Track/Road */
    setOpt(7); /* Object-Type is member of 'MveObj'-set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSTrkObj( /* 'World'-Definition (TrackObj) erstellen */
   int oid, /* aktuelle Object-ID */
   int sl)  /* StaticDetailLevel */
   {
    super(oid,0,sl); /* insert basic values ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Sh    = null; /* no valid Shape-Referenca available */
    NmeO  = Nme = null; /* File/Shape-Name(s) are unknown */
    Elv   = 0.0;  /* Default-value of Elevation */
    JNdeP = null; /* Element noch nicht vorhanden */
    setOpt(1);    /* mark object as Track/Road */
    setOpt(7);    /* Object-Type is member of 'MveObj'-set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create conversion-entry (Static -> TrkObj)
  *=====================================================================
  </pre>*/
  protected TSTrkObj( /* 'World'-Definition (TrackObj) erstellen */
   TSStatic bO) /* Basisobjekt (Static) */
   {
    super(bO,0); /* copy basic values */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Sh    = null; /* no valid Shape-Referenca available */
    NmeO  = Nme = bO.chgNme(null); /* copy filename (=shapename) */
    Elv   = 0.0;  /* Default-value of Elevation */
    JNdeP = null; /* Element noch nicht vorhanden */
    setOpt(1);    /* mark object as Track/Road */
    setOpt(7);    /* Object-Type is member of 'MveObj'-set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "adjHgt"
  * Hoehenwert eines Knotens anpassen
  *   Ergebniswert muss nicht geprueft werden
  * Achtung: Diese Version aktiviert die gleiche Funktion auch fuer das
  *          uebergeordnete Objekt (super.adjHgt())
  * ##adjHgt.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String adjHgt( /* Hoehenwert veraendern */
   double d) /* Korrekturwert der Hoehe */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(!isOpt(8)) return super.adjHgt(d); /* DIREKT weiteren Aufruf */
    if(JNdeP==null) return TSLogg.getKey("TSUidA11");
    JNdeP.addPosY(d); /* Hoehenwert korrigieren */
//    if((i=JNdeP.addPosY(d))!=0) return TSLogg.getMsg("TSUidA12",i);
    return super.adjHgt(d); /* OK -- weiteren Aufruf durchfuehren */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgElv"
  * Aktueller Wert fuer Elevation (Hoehenaenderung) pflegen
  * ACHTUNG: Wert nicht setzen wenn 'w==NaN'
  * ##chgElv.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected double chgElv( /* Elevationwert setzen und/oder liefern */
   double w) /* neuer Wert */
   {
   /*-----------------------------------------------------------------*/
    double v; /* intermediate value */
   /*=================================================================*/
    v  = Elv; /* alten Elevationwert merken */
    if(!Double.isNaN(w)) Elv = w; /* neuen Wert setzen */
    return v; /* alten Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * neuen aktuellen Dateinamen liefern oder aendern
  * wenn w==null: liefern aktuellen Dateinamen (information-Hiding)
  * Achtung: Wenn der Dateiname veraendert wird, werden BEIDE Namen
  *          angepasst (Nme,NmeO)
  * ##chgNme.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* Dateiname neu setzen */
   String w) /* neuen Dateinamen */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = Nme; /* alten Namen merken */
    if(w==null) return s; /* alten Dateinamen liefern */
    NmeO = Nme = w; /* neuer Dateiname (keine Kopie) */
    clrOpt(12); /* merken, dass KEINE Veraenderung mehr vorliegt */
    return s; /* alten Dateinamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgShR"
  * neue aktuelle Shape-Referenz liefern oder aendern
  * wenn sh==null: nur liefern aktuellen Referenz (information-Hiding)
  * ##chgShR.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSShape chgShR( /* Shape-Referenz neu setzen */
   TSShape sh) /* neue Shape-Referenz */
   {
   /*-----------------------------------------------------------------*/
    TSShape csh; /* intermediate value */
   /*=================================================================*/
    csh = Sh; /* alte Shape-Referenz merken */
    if(sh!=null) Sh = sh; /* neue Shape-Referenz setzen */
    return csh; /* alte Referenz liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   boolean c)  /* Kennzeichen setzen wenn Fehler und 'true' */
   {
   /*-----------------------------------------------------------------*/
    String is; /* Arbeitswert */
    int    i;  /* Arbeitswert */
   /*=================================================================*/
    if(t==19) { /* Sonderfall 'FileName'  wegen 'statischer Schiene' */
      if(n==0) return super.crDef(t,0,me,c); /* Ergebnis von Superklasse */
      if (n>1) return null; /* keine weitere Zeile */
      /* n==0 : aktueller Filename (KW=FileName)
       * n==1 : original Filename (KW=TreeTexture)
       * originaler Filename kommt immer NACH dem aktuellen Filenamen zur
       * Ausgabe.
       */
      if(!isOpt(12)) return null; /* kein Unterschied im Namen */
      if(Nme==null) return null; /* keine Zeile verfuegbar */
      return "\t\tTreeTexture ( " + TSUtil.modStr(NmeO) + " )";
    } /* Sonderfall 'FileName' bearbeitet */
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 2): /* 'SectionIdx' */
        if(n>1) return null; /* keine weitere Zeile mehr */
        if(!isOpt(15)) { /* KEIN Sonderfall ('Hidewire' mit SectionIDX-Wert) */
          if(n>0) return null; /* keine weitere Zeile mehr */
          is = "\t\tSectionIdx ( "; /* Basis der Ausgabezeile setzen */
        } else is = "\t\tConfig ( "; /* Default im Fall 'Hidewire' mit SectionIDX-Wert */
        if(Sh==null) { /* Fehler: Shape nicht definiert */
          if(n>0) return null; /* keine weitere Zeile im Fehlerfall */
          if(me) return TSLogg.getMsg("TSUidD11",Nme);
          is = "\t\tSectionIdx ( " + TSUtil.NoVS + " )"; /* Dummy-Wert benutzen */
        } else { /* Shape-Definition ist vorhanden -- gueltig? */
          i = Sh.getNr(false); /* Shape-Nummer holen */
          if(i<0) { /* Shape-Nummer ist nicht verfuegbar */
            if(n>0) return null; /* keine weitere Zeile im Fehlerfall */
            if(me) return TSLogg.getMsg("TSUidD12",Nme,i,0);
            is = "\t\tSectionIdx ( " + TSUtil.NoVS + " )"; /* Dummy-Wert benutzen */
          } else is += i + " )"; /* Shape-Nummer ist verfuegbar -- OK */
        } /* Shape-Kennung/Fehlerkennzeichen erzeugt */
        if(n==1) return "\t\tSectionIdx ( " + getInt(0) + " )";
          /* 'n==1' wird NUR DANN benutzt, wenn Opt(15) gesetzt ist. */
        return is; /* aktuelle Ausgabezeile liefern */
      case( 3): /* 'Elevation' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tElevation (" + TSUtil.putFV(Elv,0) + " )";
      case( 4): /* 'JNodePosn' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        if(!isOpt(8)) { /* Fehler: Nicht definiert */
          if(me) return TSLogg.getMsg("TSUidD14",getUiD(0));
          return "\t\tJNodePosn ( 0 0 0.0 0.0 0.0 )"; /* Dummy-Zeile */
        } /* Item ist fehlerhaft definiert */
        if(JNdeP==null) {  /* Position nicht definiert */
          is = "0 0 0 0 0"; /* syntaktisch richtige, ungueltige Werte ben. */
          if(c) { /* Kennzeichen einfuegen */
            if(me) return TSLogg.getMsg("TSUidD15",getUiD(0));
            is = "? ? 0 0 0"; /* Quadranten-Wert loeschen, damit ungueltig machen */
          } else if(me) return TSLogg.getMsg("TSUidD16",getUiD(0));
        } else { /* gueltige JNodePos-Referenz vorhanden -- weiter pruefen */
          if(JNdeP.noRef()) /* NUR Originalwerte verfuegbar */
           if(me) return TSLogg.getMsg("TSUidD17",getUiD(0));
          is = JNdeP.getPos(0); /* neue korrekte Werte erstellen */
        } /* gueltige JNodePos-Referenz vorhanden */
        return "\t\tJNodePosn ( " + is + " )"; /* Datenzeile liefern */
      case( 5): /* 'Config' */ return null; /* keine Aktion notwendig */
      case(18): /* 'CollideFunction' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return crDef(2,2); /* Ergebnis von Spezial-Version */
      case(23): /* 'Matrix3x3' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return crDef(3,3); /* Ergebnis von Spezial-Version */
      case(24): /* 'MaxVisDistance' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return crDef(4,4); /* Ergebnis von Spezial-Version */
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me,c); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crNdeP"
  * Information-Hiding: Positionsobjekt fuer 'JNodePos' als
  *   TSQPos-Objekt liefern
  * Achtung: Damit die Positionswerte (testweise) modifiziert werden
  *          koennen, wird eine KOPIE erstellt.
  * ##crNdeP.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQPos crNdeP() /* Positionswerte als Vector liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(JNdeP==null) return null; /* Kennung falls nicht vorhanden */
    return new TSQPos(JNdeP); /* neues Objekt liefern (Kopie) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndWrld"
  * suchen und liefern der World-Definition gemaess 'Qx' und 'Qz'
  *    (Funktion wird in das Positionsobjekt delegiert)
  * ACHTUNG: Im Erfolgsfall wird die Quadrat-Referenz eingetragen!!
  * ##fndWrld.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQuad fndWrld( /* World-Definition liefern */
   TreeSet<TSQuad> qdf) /* Alle Quadrat-Definitionen der World-Dateien */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(JNdeP==null) return null; /* Fehler: kein Speicher erstellt */
    return JNdeP.fndWrld(qdf); /* Aktion delegieren */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * 9 : Maske der ZUSAETZLICH gueltigen Schluesselwoerter (TSStatic)
  * ##getCtl.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      case( 9): return 0x00000000; /* keine weiteren 'Keywords' */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(org) return "TrackObj"; /* Objekt-Name im Original liefern */
    if(isOpt(10)) return "Static"; /* 'HW-Objekt' liegt vor */
    return "TrackObj"; /* Objekt-Name liefern (default) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isRoad"
  * Pruefen ob Eintrag eine Strasse beschreibt
  * Wenn Originaleintrag keine Strasse beschreibt wird 'false' geliefert
  * ##isRoad.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isRoad() /* Strassenbeschreibung aktiv ? */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(!isOpt(2)) return false; /* keine Strasse -- kein Vergleich */
    return true; /* jetzt liegt auf jeden Fall eine Strasse vor */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isTrack"
  * pruefen ob World-Eintrag eine Track-Definition ist
  * Wenn DIESE Methode aktiviert wird, liegt EINE Track-Definition vor.
  * ##isTrack.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isTrack() /* 'World'-Definition pruefen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return true; /* 'TrackObj' ist EIN Track-Objekt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "modNme"
  * aktuellen, modifizierten Dateinamen aendern (neu setzen)
  * wenn Argument=null: liefern ORIGINALEN  Name (information-Hiding)
  * Achtung: originaler Shape-Name (NmeO) wird NICHT veraendert
  * ##modNme.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String modNme( /* modifizierten Dateiname neu setzen */
   String s) /* neuen Dateinamen des Shapes */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(s==null) return NmeO; /* originalen Dateinamen liefern */
    Nme = s; /* neuen, modifizierten Dateiname setzen */
    if(NmeO.equalsIgnoreCase(Nme)) return null; /* Namen GLEICH */
    setOpt(12); /* merken, dass Veraenderung erfolgt ist */
    return NmeO; /* Kennzeichen fuer Aktion liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mskAdd"
  * Information-Hiding: 'addMsk' maskieren:
  *  Additionsmaske gemaess argument maskieren
  * Achtung: Methode ist statisch
  * ##mskAdd.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void mskAdd( /* Additions-Maske maskieren */
   int m) /* Maske zum maskieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    addMsk &= m; /* Additionsmaske maskieren */
    return; /* und zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 3): /* 'Elevation' */
        try { Elv = Double.parseDouble( /* Wert aus Message umwandeln */
          TSLogg.getMsg("TSUidX03","",u,t));
        } catch (NumberFormatException e) { /* Fehler in der Zahl */
          Elv = 0.0; /* nicht nur Ziffern */
        } /* nicht nur Ziffern */
        /* Defaultwert als neuen Wert eintragen */
        return "TrackObj("+u+")-Elevation"; /* variabler Teil */
      case(25): /* 'VDbId' */
        clrView(14); /* Default-Kennung ViewSphere setzen */
        return "TrackObj("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "TrackObj("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setName"
  * Namensdefinition fuer Dateiname modifizieren
  * Methode wird zur Aktivierung der 'HW-Objekt'e benoetigt
  * Methode liefert 'true' falls der Name NICHT geaendert wurde
  * Achtung: Eine bereits erfolgte Modifizierung wird AUF JEDEN FALL
  *          zurueckgesetzt.
  * Aufbau der 'Versorgungsliste'(ArrayList):
  *   ix   - (Str) - Bedingter Zugriffspfad, 'null' wenn nicht aktiv
  *   ix+1 - (Str/Pattern) - Vergleichsausdruck fuer Dateinamen oder 'null'
  *   ix+2 - (Str/Str[])   - Ersetzungsausdruck fuer Dateinamen oder 'null'
  * ##setName.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean setName( /* Dateiname modifiziern falls zutreffend */
   TSArrList cL, /* Liste mit Steuerungswerten */
   int       ix, /* Index der Steuerungswerte in Queue */
   String    ap, /* common accesspath or 'null' if not used */
   String... cp) /* arguments of conditional accesspath */
   {
   /*-----------------------------------------------------------------*/
    int     i; /* Laenge */
    Object  o; /* Vergleichsobjekt: String/Pattern/null */
               /* Ersetzungsobjekt: String/String[]/null */
    Matcher m; /* Pruefung fuer regulaeren Ausdruck */
    String  s; /* Arbeitswert */
   /*=================================================================*/
    Nme = NmeO; /* originaler Dateiname wieder aktivieren */
    clrOpt(12); /* Shape-Name ist NICHT MEHR modifiziert */
    if(cL==null) return true; /* Aenderungen NUR zuruecknehmen */

    o = cL.get(ix+1); /* Objekt fuer Vergleich extrahieren */
    if(o!=null) rep:{ /* Ersetzung ist gefordert */
      if(!(o instanceof String)) { /* regulaerer Ausdruck */
        m = ((Pattern)o).matcher(Nme); /* Bearbeitungsobjekt erzeugen */
        if(!m.lookingAt()) break rep; /* 'match' trifft NICHT zu */
        o = cL.get(ix+2); /* get replacement-string(-array) */
        if(o instanceof String[]) { /* more than one argument */
          /* convert new value to select replacement-value */
          if(!chkAnim(false))  s = ((String[])o)[0];
          else if(chkColl(false)) s = ((String[])o)[2];
          else s = ((String[])o)[1];
        } else s = (String)o; /* convert replacement-text */
        Nme = m.replaceAll(s); /* Ersetzungen durchfuehren */
      } else { /* Vergleichstext direkt setzen */
        s = (String)o; /* Vergleichstext konvertieren */
        if(!Nme.toLowerCase().startsWith(s.toLowerCase())) break rep;
        i = s.length(); /* Laenge des Vorlaufs */
        if(Nme.length()>i) Nme = Nme.substring(i); else Nme = "";
        o = cL.get(ix+2); /* get replacement-string(-array) */
        if(o instanceof String[]) { /* more than one argument */
          /* convert new value to select replacement-value */
          if(!chkAnim(false))  s = ((String[])o)[0];
          else if(chkColl(false)) s = ((String[])o)[2];
          else s = ((String[])o)[1];
        } else s = (String)o; /* convert replacement-text */
        if(s!=null) Nme = s + Nme; /* Ersetzungsstring hinzufuegen */
      } /* Ersetzung wurde ggf. durchgefuehrt */
      /* Ersetzung durchgefuehrt -- bedingter Pfad aktivieren */
      if(ap!=null) break rep; /* Allgemeiner Pfad hat Vorrang! */
      s = (String)cL.get(ix); /* bedingter Pfad extrahieren */
      if(s==null) break rep; /* conditional path NOT active */
      s = TSLogg.getMsg(s,cp); /* prepare conditional accesspath */
      Nme = s + Nme; /* and add conditional path to name */
    } /* -rep- Ersetzung wurde gefordert */
    if(ap!=null) Nme = ap + Nme; /* add common accesspath if needed */

    if(NmeO.equalsIgnoreCase(Nme)) return true; /* keine Aenderung */
    setOpt(12); /* Kennung setzen: Shape-Name ist modifiziert */
    return false; /* Name wurde geaendert --- melden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setNdeP"
  * Positionsobjekt fuer 'JNodePos' speichern
  * ##setNdeP.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQPos setNdeP( /* Positionsobjekt speichern */
   TSQPos cP) /* neues Positionsobjekt */
   {
   /*-----------------------------------------------------------------*/
    TSQPos cPos; /* Original-Wert */
   /*=================================================================*/
    cPos = JNdeP; /* Originalwert sichern falls vorhanden */
    JNdeP = cP; /* neue Position uebertragen */
    return cPos; /* Methode beenden (Originalwert liefern) */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTrkObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-String */
   /*=================================================================*/
    rs = toStr(false) + ":'" + Nme + "'/'" + NmeO + "'," +
          Sh.getNr(true) + "," + Elv + ",(";
    if(JNdeP==null) rs += "<null>)}";
    else rs += JNdeP.toStr() + ")}";
    return rs; /* provide result-string */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSDynTrk -- Definition of a DynTrack-world-Entry
 * ##TSDynTrk (Eyecatcher)
 *======================================================================
 </pre>*/
class TSDynTrk extends TSUiD { /* 'World'-Entry-definition: DynTrack */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.6.05 28.10.2011";
  private static final int      valMsk = 0x0672004F; /* Lines (valid) */
  private static final int      reqMsk = 0x00600007; /* Lines (req) */
  private static int            addMsk = 0x06000008; /* Lines (add) */
  private static String[]       reqNme = { /* Names of requested Items */
    "UiD","Tracksections","SectionIdx","Position","QDirection"};
 /*-------------------------------------------------------------------*/
  private double                Elv;    /* current Elevation */
  private TSShL                 Sh;     /* current Path-reference */
  private TSScL[]               Sc;     /* current Section-references */
  private String                Nme;    /* Name of Shape (DynaTrax) */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 - Object converted from 'TrkObj'-definition ('DynaTrax')
  *        9 - Obj. converted from 'static representation' (e.g. Hidewire)
  *       10 - Create 'static representation' of track
  *       11 -
  *       12 - reserved (due to compatibility to TrkObj)
  *       13 -
  *       14 - Original SectionIdx-value is NOT useable (path)
  *       15 - 'Hidewire' using SectionIdx-value is active
  *   16..23 - (not used)
  * Definition of 'Entry found' (stored in TSOpt):
  *        0 : UiD
  *        1 : TrackSections
  *        2 : SectionIdx
  *        3 : Elevation
  *        4 : not used
  *        5 : Config                    (Hidewire)
  *  6 to 16 : not used
  *       17 : CollideFlag
  *       18 : not used
  *       19 : FileName (extension)
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  * 23 to 24 : not used
  *       25 : VDbId
  *       26 : StaticDetailLevel
  * 27 to 30 : not used
  *       31 : QDirection/Matrix3x3
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.00(S) - (Queue) not used
  *   1.00(I) - Data of 'Config'-statement (Hidewire)
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSDynTrk() /* 'World'-Definition (Dyntrack) erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Elv = 0.0;  /* reset elevation */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSDynTrk( /* create 'World'-Definition (Dyntrack) */
   int oid, /* current/new Object-ID */
   int sl)  /* current StaticDetailLevel */
   {
    super(oid,1,sl); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Elv = 0.0;  /* reset elevation */
    Sh  = null; /* no path-reference available */
    Nme = null; /* Shape-Name ('DynaTrax') is still not available */
    Sc  = new TSScL[7]; /* Speicher fuer Section-Ref. erstellen */
    Arrays.fill(Sc,null); /* no valid Section-References exist */
    setOpt(7);  /* Object-Type is member of 'MveObj'-set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create conversion-entry (TrkObj - DynTrk)
  *=====================================================================
  </pre>*/
  protected TSDynTrk( /* 'World'-Definition (Dyntrack) erstellen */
   TSTrkObj bO) /* Basisobjekt (TrkObj) */
   {
    super(bO,1); /* Basiswerte setzen */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Elv = bO.chgElv(Double.NaN); /* transfer elevation if set */
    Sh  = null; /* Path-reference cannot be available */
    Nme = bO.chgNme(null); /* transfer name of shape because
      * 'DynaTrax' may already be recognized */
    Sc  = new TSScL[7]; /* create empty Section-Refereneces */
    Arrays.fill(Sc,null); /* no valid Section-References can exist */
    /* Option-bits 0..7 are already copied from TrkObj (super) */
    if(bO.isOpt(9)) setOpt(9); /* transfer option */
    if(bO.isOpt(10)) setOpt(10); /* transfer option */
    if(bO.isOpt(15)) setOpt(15); /* transfer option */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgElv"
  * Aktueller Wert fuer Elevation (Hoehenaenderung) pflegen
  * ACHTUNG: Wert nicht setzen wenn 'w==NaN'
  * ##chgElv.TSDynTrk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected double chgElv( /* Elevationwert setzen und/oder liefern */
   double w) /* neuer Wert */
   {
   /*-----------------------------------------------------------------*/
    double v; /* intermediate value */
   /*=================================================================*/
    v  = Elv; /* alten Elevationwert merken */
    if(!Double.isNaN(w)) Elv = w; /* neuen Wert setzen */
    return v; /* alten Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * neuen aktuellen Dateinamen ('DynaTrax') liefern oder aendern
  * wenn w==null: liefern aktuellen Dateinamen (information-Hiding)
  * ##chgNme.TSDynTrk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* Dateiname neu setzen */
   String w) /* neuen Dateinamen */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = Nme; /* alten Namen merken */
    if(w!=null) Nme = w; /* neuer Dateiname (keine Kopie) */
    return s; /* alten Dateinamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgScR"
  * neue aktuelle Section-Referenz (Tracksection) liefern oder aendern
  * wenn sc==null: liefern aktuellen Pfadwert (information-Hiding)
  * ##chgScR.TSDynTrk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSScL chgScR( /* Section-Referenz neu setzen */
   int     ix,  /* Index-Wert fuer Eintrag */
   boolean sec, /* zweiter Eintrag zu Index-Wert */
   TSScL   sc)  /* neue Section-Referenz */
   {
   /*-----------------------------------------------------------------*/
    TSScL csc; /* intermediate value */
   /*=================================================================*/
    if(ix<0 || ix>4) return null; /* ungueltiger Index (Plausi) */
    if(Sc==null) return null; /* Referenzspeicher nicht angelegt */
    if(sec) /* Zweite Version -- Index umsetzen */
      if(ix==1) ix = 5; else if(ix==3) ix = 6; else return null;
    csc = Sc[ix]; /* alte Section-Referenz merken */
    if(sc!=null) Sc[ix] = sc; /* neue Section-Referenz setzen */
    return csc; /* alte Referenz liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgShR"
  * neue aktuelle Shape-Referenz (Path) liefern oder aendern
  * wenn pa==null: liefern aktuellen Pfadwert (information-Hiding)
  * ##chgShR.TSDynTrk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSShL chgShR( /* Shape-Referenz neu setzen */
   TSShL pa) /* neue Pfad-Referenz */
   {
   /*-----------------------------------------------------------------*/
    TSShL cpa; /* intermediate value */
   /*=================================================================*/
    cpa = Sh; /* alte Shape-Referenz merken */
    if(pa!=null) Sh = pa; /* neue Shape-Referenz setzen */
    return cpa; /* alte Referenz liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSDynTrk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   boolean c)  /* Kennzeichen setzen wenn Fehler und 'true' */
   {
   /*-----------------------------------------------------------------*/
    String is; /* Arbeitswert */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 1): /* 'TrackSections' */
        if(isOpt(8)) return null; /* Ausgabe wird unterdrueckt */
        if(n>16) return null; /* keine weitere Zeile mehr */
        if(n==0) return "\t\tTrackSections ("; /* erste Zeile */
        if(n==16) return "\t\t)"; /* letzte Zeile */
        if((n%3)==1) return "\t\t\tTrackSection (";
        if((n%3)==0) return "\t\t\t)";
        n /= 3; /* Index des Eintrags berechnen */
        if(Sc[n]==null) /* Eintrag ist nicht belegt */
          return "\t\t\t\tSectionCurve ( "+(n%2)+" ) "+"4294967295 0 0";
        return Sc[n].crDef(4); /* Zeile erzeugen lassen */
      case( 2): /* 'SectionIdx' */
        if(n>1) return null; /* keine weitere Zeile mehr */
        if(!isOpt(15)) { /* KEIN Sonderfall ('Hidewire' mit SectionIDX-Wert) */
          if(n>0) return null; /* keine weitere Zeile mehr */
          is = "\t\tSectionIdx ( "; /* Basis der Ausgabezeile setzen */
        } else is = "\t\tConfig ( ";
          /* Default im Fall 'Hidewire' mit SectionIDX-Wert */
        if(Sh==null) { /* Fehler: Pfad nicht definiert */
          if(n>0) return null; /* keine weitere Zeile im Fehlerfall */
          if(me) return TSLogg.getMsg("TSUidD21",getUiD(0));
          is = "\t\tSectionIdx ( " + TSUtil.NoVS + " )"; /* Dummy-Wert */
        } else is += Sh.getNr(false) + " )"; /* Pfad-Nummer holen */
        if(n==1) return "\t\tSectionIdx ( " + getInt(0) + " )";
          /* 'n==1' wird NUR DANN benutzt, wenn Opt(15) gesetzt ist. */
        return is; /* aktuelle Ausgabezeile liefern */
      case( 3): /* 'Elevation' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tElevation (" + TSUtil.putFV(Elv,0) + " )";
      case( 5): /* 'Config' */ return null; /* keine Aktion notwendig */
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me,c); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "crSc"
  * Create Section-definitions of a 'DynTrk'-object using current
  *  path-definition. This method is needed after a  'Dyntrk'-object
  *  has been converted from a 'TrkObj'-definition.
  * Method returns error-message of 'null'
  * ##crSc.TSDynTrk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crSc( /* create section-definitions */
   TSRoute cRte) /* current route to search for sections */
   {
   /*-----------------------------------------------------------------*/
    Iterator<TSScL> cI;  /* Iterator within section-table */
    TSScL           cSc; /* current local section */
    int             i,j; /* temporary value */
   /*=================================================================*/
    if(Sh==null) return TSLogg.getMsg("TSUidC02"); /* path not available */
    cI = Sh.getScR(); /* get iterator for all section-definitions */
    i = 0; /* preset relative position of section-entry */
    while(cI.hasNext()) { /* another section-definition available within path ? */
      cSc = cI.next(); /* get current section-definition-entry */
      if(cSc.isCurve()!=((i%2)!=0)) i += 1; /* is it curve ? -- skip to slot */
      if(i>4) /* no more slots available -- maximum sections already used */
        return TSLogg.getMsg("TSUidC03",Sh.getNr(true),i); /* return errormessage */
      this.chgScR(i,false,cSc); /* set new tracksection-definition */
      cSc.incCntW(1); /* and count usage */
      if(cSc.isCurve()) { /* section describes a curve */
        j = cSc.getNr(true) + 1; /* get number of second section */
        cSc = cRte.chgScT(j,null); /* get local tracksection from section-table */
        if(cSc==null) /* second section is not available (no curve!!) */
          return TSLogg.getMsg("TSUidC04",Sh.getNr(true),j); /* return errormessage */
        this.chgScR(i,true,cSc); /* set second track-section */
        cSc.incCntW(1); /* and count usage */
      } /* section type was 'curve' */
      i += 1; /* advance to next section-slot */
    } /* and process all part of the path-definition */
    this.setMsk(1); /* mark: 'TrackSection'-entry found (simulate) */
    return null; /* return without error */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * 9 : Maske der ZUSAETZLICH gueltigen Schluesselwoerter
  * ##getCtl.TSDynTrk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      case( 9): return 0x00080000; /* Maske (FileName) liefern */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSDynTrk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSDynTrk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(org) return "Dyntrack"; /* Objekt-Name im Original liefern */
    if(!isOpt(8)) return "Dyntrack"; /* Obj-Name liefern (default) */
    if(isOpt(10)) return "Static"; /* 'HW-Objekt' liegt vor */
    return "TrackObj"; /* Objekt-Name liefern ('DynaTrax') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getVNrDef"
  * Default-Kennung fuer die ViewSphere-ID liefern
  * Moegliche Werte: 0..15 ('15' ist Default)
  * ##getVNrDef.TSDynTrk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getVNrDef() /* VDbId-Kennung liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return 14; /* Kennung fuer dynamische Tracks */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isTrack"
  * pruefen ob World-Eintrag eine Track-Definition ist
  * Wenn DIESE Methode aktiviert wird, liegt EINE Track-Definition vor.
  * ##isTrack.TSDynTrk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isTrack() /* 'World'-Definition pruefen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return true; /* 'Dyntrack' ist EIN Track-Objekt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mskAdd"
  * Information-Hiding: 'addMsk' maskieren:
  *  Additionsmaske gemaess argument maskieren
  * Achtung: Methode ist statisch
  * ##mskAdd.TSDynTrk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void mskAdd( /* Additions-Maske maskieren */
   int m) /* Maske zum maskieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    addMsk &= m; /* Additionsmaske maskieren */
    return; /* und zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSDynTrk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 3): /* 'Elevation' */
        try { Elv = Double.parseDouble( /* Wert aus Message umwandeln */
          TSLogg.getMsg("TSUidX13","",u,t));
        } catch (NumberFormatException e) { /* Fehler in der Zahl */
          Elv = 0.0; /* nicht nur Ziffern */
        } /* nicht nur Ziffern */
        /* Defaultwert als neuen Wert eintragen */
        return "DynTrack("+u+")-Elevation"; /* variabler Teil */
      case(25): /* 'VDbId' */
        clrView(getVNrDef()); /* Default-Kennung ViewSphere setzen */
        return "DynTrack("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "DynTrack("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setName"
  * Dummy-Funktion fuer 'Dynamische Schienen'
  * ACHTUNG: Methodenname ist mit 'TSTrkObj.setName()' identisch
  * Methode liefert 'true' falls der Name NICHT geaendert wurde
  * ##setName.TSDynTrk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean setName( /* Dateiname modifiziern falls zutreffend */
   TSArrList cL, /* Liste mit Steuerungswerten */
   int       ix, /* Index der Steuerungswerte in Queue */
   String    ap, /* common accesspath or 'null' if not used */
   String... cp) /* arguments of conditional accesspath */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(!isOpt(8)) return true; /* KEIN 'DynaTrax-Objekt' */
    /* Namensmodifikation ist HIER nicht moeglich */
    return false; /* Funktion hat IMMER den Namen geaendert */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSDynTrk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-String */
    int    i;  /* temporary value(s) */
   /*=================================================================*/
    rs = toStr(false) + ":" + Sh.getNr(true) + "," + Elv + ",[";
    for(i=0;i<7;i+=1) { /* all Section-values (5+2) */
      if(i>0) rs += ",";
      if(Sc[i]==null) rs += "<>"; /* no valid value -- dummy */
      else rs += Sc[i].getNr(true); /* add section-value */
    } /* compute all section-definitions */
    rs += "]}"; /* add termination */
    return rs; /* provide result-string */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSSignal -- Definition eines 'World'-Eintrags (Signal)
 * ##TSSignal (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSignal extends TSUiD { /* 'World'-Eintrags-Def. (Signal) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.3.07 16.12.2007";
  private static final int      valMsk = 0x1E780001; /* Zeilen (valid) */
  private static final int      reqMsk = 0x08680001; /* Zeilen (req) */
  private static int            addMsk = 0x06000000; /* Zeilen (add) */
  private static String[]       reqNme = { /* Namen der req. Items */
    "UiD","FileName","Position","QDirection","SignalSubObj"};
  protected static final int    K_MaxIt = 32; /* max. Anzahl Items */
 /*-------------------------------------------------------------------*/
  private int                   Msk;    /* Maske der Subobjekte */
  private ArrayList<TSRefC>     SUTab;  /* Tabelle der Signal-Units */
  private String                Nme;    /* Dateiname des Objektes */
  private TSSigSh               SgR;    /* Referenz zu SignalShape */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 -
  *        9 -
  *       10 -
  *       11 -
  *   12..23 - (not used)
  * Definition of 'Entry found' (stored in TSOpt):
  *        0 : UiD
  *  1 to 18 : not used
  *       19 : FileName
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  * 23 to 24 : (not used)
  *       25 : VDbId
  *       26 : StaticDetailLevel
  *       27 : SignalSubObj
  *       28 : SignalUnits
  * 29 to 30 : (not used)
  *       31 : QDirection/Matrix3x3
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.xx(S) - (Queue) not used
  *   1.xx(I) - (Queue) not used
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSignal() /* 'World'-Definition (Signal) erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    Msk   = 0;  /* Default: kein Subobjekt aktiv */
//    SUTab = null; /* noch kein Speicher fuer Signal-Units */
//    Nme   = null; /* Objekt-Name noch nicht vorhanden */
//    SgR   = null; /* keine Verbindung zu Signalshape-Definition */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSignal( /* 'World'-Definition (Signal) erstellen */
   int oid, /* aktuelle Object-ID */
   int sl)  /* StaticDetailLevel */
   {
    super(oid,2,sl); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Msk   = 0;  /* Default: kein Subobjekt aktiv */
    SUTab = null; /* noch kein Speicher fuer Signal-Units */
    Nme   = null; /* Objekt-Name noch nicht vorhanden */
    SgR   = null; /* keine Verbindung zu Signalshape-Definition */
    setOpt(7);  /* Object-Type is member of 'MveObj'-set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addSgI"
  * SignalUnit-Item hinzufuegen
  * Im Fehlerfall wird eine Fehlermeldung geliefert
  * ##addSgI.TSSignal (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String addSgI( /* Signalunit-Definition setzen */
   int su, /* Nummer des Signalunits */
   int nr) /* Nummer der Signalunit-Referenz */
   {
   /*-----------------------------------------------------------------*/
    TSRefC cRef; /* aktuelles Definitionsobjekt */
   /*=================================================================*/
    if(SUTab==null) SUTab = new ArrayList<TSRefC>(K_MaxIt); /* Basis */
    if(SUTab.size()>=K_MaxIt) /* Anzahl der Eintragsdef's falsch */
      return TSLogg.getMsg("TSUidSA1",null,SUTab.size(),K_MaxIt);
    cRef = new TSRefC(nr); /* neues Objekt erstellen */
    cRef.chgIx(su); /* Nummer als Zusatzinformation einsetzen */
    SUTab.add(cRef); /* SignalUnit-Item hinzufuegen */
    return null; /* Funktion erfolgreich -- ohne Fehler zureuck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgMsk"
  * Maske der Signal-Subobjekte setzen oder liefern
  * Wert NUR setzen wenn != 0 --> Loeschen NICHT moeglich
  * ##chgMsk.TSSignal (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int chgMsk( /* Subobjekt-Maske veraendern/lesen */
   int msk) /* neue Maske oder '0') */
   {
   /*-----------------------------------------------------------------*/
    int i; /* alter Wert */
   /*=================================================================*/
    i = Msk; /* aktueller Wert der Maske merken */
    if(msk!=0) Msk = msk; /* neuen Wert setzen */
    return i; /* alten Wert kiefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * neuen aktuellen Dateinamen liefern oder aendern
  * wenn w==null: liefern aktuellen Dateinamen (information-Hiding)
  * ##chgNme.TSSignal (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* Dateiname neu setzen */
   String w) /* neuen Dateinamen */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = Nme; /* alten Namen merken */
    if(w!=null) Nme = w; /* neuen Dateiname setzen (keine Kopie) */
    return s; /* alten Dateinamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgSigS"
  * neue aktuelle Signal-Shape-Referenz liefern oder aendern
  * wenn sh==null: liefern aktuellen Wert (information-Hiding)
  * ##chgSigS.TSSignal (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSSigSh chgSigS( /* Signal-Shape-Referenz neu setzen */
   TSSigSh sh) /* Signal-Shape-Referenz oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSSigSh csh; /* intermediate value */
   /*=================================================================*/
    csh = SgR; /* alte Signal-Shape-Referenz merken */
    if(sh!=null) SgR = sh; /* neue Signal-Shape-Referenz setzen */
    return csh; /* alte Signal-Shape-Referenz liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTrI"
  * Referenz-Verkettung fuer 'TrItem' aendern
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##chgTrI.TSSignal (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC chgTrI( /* Referenzverkettung aendern und liefern */
   int    db, /* Nummer der Datenbank */
   int    ix, /* Index des Eintrags */
   TSRefC rf) /* neue Referenzverkettung oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC  cRef; /* aktuelles Definitionsobjekt */
   /*=================================================================*/
    if(SUTab==null) return null; /* Daten nicht gefuellt */
    if(db!=0) return null; /* Datenbank nicht erlaubt */
    if(ix<0 || ix>=SUTab.size()) return null; /* Fehler kein Element */
    if(rf==null) cRef = SUTab.get(ix); /* Steuerobjekt holen */
    else cRef = SUTab.set(ix,rf); /* Steuerobjekt austauschen */
    return cRef; /* altes Referenzobjekt liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkTrItmT"
  * pruefen ob TrItemTyp zu aktuellem Objekt passt
  * Routine liefert 'true', wenn die Zuordnung NICHT passt
  * ##chkTrItmT.TSSignal (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkTrItmT( /* Objektzuordnung pruefen */
   int ItmT) /* TrItem-Typ (vgl TSTrItm) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return ItmT!=1; /* nur SignalItem erlaubt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSSignal (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   boolean c)  /* Kennzeichen setzen wenn Fehler und 'true' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC cRef; /* aktuelles Definitionsobjekt */
    Object cO;   /* Arbeitswert */
    int    i,j;  /* Arbeitswert */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
//      case(19): /* 'FileName' */
//        if(SgR==null) return super.crDef(t,n,me,c); /* Original */
//        if(n>0) return null; /* keine weitere Zeile mehr */
//        return "\t\tFileName ( "+TSUtil.modStr(SgR.getFNme(false))
//                + " )"; /* Dateiname holen und Stmt erzeugen */
      case(27): /* 'SignalSubObj' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tSignalSubObj ( " + TSUtil.toHex(Msk,8) + " )";
      case(28): /* 'SignalUnits' */
        if(SUTab==null) { /* keine Signal-Units definiert */
          if(me) return TSLogg.getMsg("TSUidD31",getUiD(0));
          if(n>0) return null; /* keine weitere Zeile mehr */
          return "\t\tSignalUnits ( 0 )"; /* Dummy-Rueckgabe */
        } /* KEINE Signal-Units definiert */
        if(n==0) return "\t\tSignalUnits ( " + SUTab.size();
        n -= 1; /* vorbereiten fuer Berechnung */
        j = n / 3; /* Nummer des Eintrags (3 Zeilen pro Eintrag) */
        n %= 3; /* Eintragnummer innerhalb */

        if(j>=SUTab.size()) /* alle Eintraege bearbeitet */
          if(n==0) return "\t\t)"; /* Abschlusszeile */
          else return null; /* keine weitere Zeile mehr */
        cRef = SUTab.get(j); /* aktuelles Steuerobjekt holen */
        if(n==0) return("\t\t\tSignalUnit ( " + /* Zusatznummer einsetzen */
          cRef.chgIx(Integer.MIN_VALUE));
        if(n==2) return "\t\t\t)"; /* Ende des Signalunits */
        n = cRef.chgNr(Integer.MIN_VALUE); /* Original-TrItemId holen */
        if((cO=cRef.chgRef(null))==null) { /* TrItem-Referenz nicht gesetzt */
          if(c) { /* Kennzeichen einfuegen */
            if(me) return TSLogg.getMsg("TSUidD32",null,getUiD(0),j);
            n = -1; /* Kennzeichen einfuegen */
          } else if(me) return TSLogg.getMsg("TSUidD33",null,getUiD(0),j);
        } else n = ((TSTrItm)cO).getNr(false); /* TrItem-Id holen */
        return "\t\t\t\tTrItemId ( 0 " + n + " )";
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me,c); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "fndSU"
  * Search for 'SignalUnit' according to index-number of subobject.
  * ##fndSU.TSSignal (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC fndSU( /* seach for subobject-definition by no. */
   int su) /* subobject-number of requested entry */
   {
   /*-----------------------------------------------------------------*/
    Iterator<TSRefC> cI;   /* iterator for list of subobjects */
    TSRefC           cRef; /* current reference-entry to subobject */
   /*=================================================================*/
    if(SUTab==null) return null; /* table does not exist -- error? */
    cI = SUTab.iterator(); /* check all elements */
    while(cI.hasNext()) { /* more definitions available ? */
      cRef = cI.next(); /* check next reference-object */
      if(cRef==null) throw new IllegalStateException( /* integrity-check */
        TSLogg.getMsg("Msg908","TSRefC(TSTrItem)==null","TSSignal.fndSU()",0));
      if(cRef.chgIx(Integer.MIN_VALUE)==su) return cRef; /* found! */
    } /* process all definitions */
    return null; /* no result -- return with error-marker */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$TrI"
  * Anzahl der TrItems fuer SignalUnit abfragen
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##get$TrI.TSSignal (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int get$TrI( /* Anzahl Signalunit-Definitionen abfragen */
   int db) /* Nummer der Datenbank */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(SUTab==null) return -2; /* Tabelle existiert (noch) nicht */
    if(db!=0) return -4; /* Datenbank-Nummer stimmt nicht */
    return SUTab.size(); /* Anzahl der Definitionen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * ##getCtl.TSSignal (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSSignal (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSSignal (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "Signal"; /* Objekt-Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mskAdd"
  * Information-Hiding: 'addMsk' maskieren:
  *  Additionsmaske gemaess Argument maskieren
  * Achtung: Methode ist statisch
  * ##mskAdd.TSSignal (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void mskAdd( /* Additions-Maske maskieren */
   int m) /* Maske zum maskieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    addMsk &= m; /* Additionsmaske maskieren */
    return; /* und zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen.
  * ##setDef.TSSignal (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(25): /* 'VDbId' */
        clrView(getVNrDef()); /* Default-Kennung ViewSphere setzen */
        return "Signal("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "Signal("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setSUTab"
  * NEUE Tabelle der Signal-Units pruefen und setzen.
  * Methode liefert Fehlermeldung falls Fehler erkannt wird.
  * ##setSUTab.TSSignal (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setSUTab( /* Tabelle Signal-Units ersetzen */
   ArrayList<TSRefC> nT) /* neue SU-Tabelle oder 'null' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nT!=null) { /* Definition angegeben -- pruefen */
      if(nT.size()>=K_MaxIt) /* Anzahl der Eintragsdef's falsch */
        return TSLogg.getMsg("TSUidSA1",null,nT.size(),K_MaxIt);
    } /* Pruefung erfolgreich */
    SUTab = nT; /* neue Tabelle aktivieren */
    return null; /* OHNE Fehlerkennzeichen zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class.
  * ##toStr.TSSignal (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs;   /* result-string */
    TSRefC cRef; /* aktuelles Definitionsobjekt */
//    Object cO;   /* TrItem-Objekt innerhalb von 'TSRefC' */
    int    i;    /* Laufvariable */
   /*=================================================================*/
    rs = toStr(false) + ":'" + Nme + "'," + TSUtil.toHex(Msk,-8);
    if(SUTab!=null) { /* Datenspeicher vorhanden */
      rs += "," + SUTab.size() + "[";
      for(i=0;i<SUTab.size();i+=1) { /* alle definierten Elemente */
        if(i>0) rs += ","; /* Trennzeichen einfuegen */
        cRef = SUTab.get(i); /* aktuelles Definitionsobjekt */
        rs += cRef.chgIx(Integer.MIN_VALUE) + "/" +
               cRef.chgNr(Integer.MIN_VALUE) + "("; /* Ref. hinzufuegen */
        if(cRef.chgRef(null)==null) rs += "<null>)"; /* Ref. fehlt */
        else rs += "<set>)"; /* signalisieren: Wert eingetragen */
      } /* Alle Eintraege einsetzen */
    } else rs += ",0["; /* KEINE Definitionen setzen */
    rs += "]}"; /* Abschluss setzen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSStatic -- Definition eines 'World'-Eintrags (Static)
 * ##TSStatic (Eyecatcher)
 *======================================================================
 </pre>*/
class TSStatic extends TSUiD { /* 'World'-Eintrags-Def. (Static) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.06 22.02.2010";
  private static final int      valMsk = 0x27F80001; /* Zeilen (valid) */
  private static final int      reqMsk = 0x80280001; /* Zeilen (req) */
  private static int            addMsk = 0x06000000; /* Zeilen (add) */
  private static String[]       reqNme = { /* Namen der req. Items */
    "UiD","FileName","Position","QDirection/Matrix3x3"};
 /*-------------------------------------------------------------------*/
  private String                Nme;    /* Dateiname des Objektes */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 -
  *        9 -
  *       10 -
  *       11 -
  *   12..23 - (not used)
  * Definition of 'Entry found' (stored in TSOpt):
  *        0 : UiD
  *  1 to 18 : (not used)
  *       19 : FileName
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  *       23 : Matrix3x3
  *       24 : MaxVisDistance
  *       25 : VDbId
  *       26 : StaticDetailLevel
  * 27 to 28 : (not used)
  *       29 : NoDirLight
  *       30 : (not used)
  *       31 : QDirection/Matrix3x3
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.00(S) - Definitionstatement of 'NoDirLight'
  *   0.01(S) - Entry not used
  *   0.02(S) - Entry not used
  *   0.03(S) - Definitionstatement of 'Matrix3x3'
  *   0.04(S) - Definitionstatement of 'MaxVisDistance'
  *   1.xx(I) - (Queue) not used
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSStatic() /* 'World'-Definition (Static) erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    Nme = null; /* Objekt-Name noch nicht vorhanden */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSStatic( /* 'World'-Definition (Static) erstellen */
   int oid, /* aktuelle Object-ID */
   int sl)  /* StaticDetailLevel */
   {
    super(oid,3,sl); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nme = null; /* Objekt-Name noch nicht vorhanden */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create conversion-entry (Signal - Static)
  *=====================================================================
  </pre>*/
  protected TSStatic( /* create 'World'-Definition (Static) */
   TSSignal bO) /* Basisobjekt (Signal) */
   {
    super(bO,3); /* Basiswerte setzen */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nme = bO.chgNme(null); /* Shape-Name uebertragen */
    clrMsk(27); /* clear existence of 'SignalSubObj' (may be set) */
    clrMsk(28); /* clear existence of 'SignalUnits' (may be set) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * neuen aktuellen Dateinamen liefern oder aendern
  * wenn w==null: liefern aktuellen Dateinamen (information-Hiding)
  * ##chgNme.TSStatic (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* Dateiname neu setzen */
   String w) /* neuen Dateinamen */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = Nme; /* alten Namen merken */
    if(w!=null) Nme = w; /* neuen Dateiname setzen (keine Kopie) */
    return s; /* alten Dateinamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSStatic (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   boolean c)  /* Kennzeichen setzen wenn Fehler und 'true' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(23): /* 'Matrix3x3' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return crDef(3,3); /* Ergebnis von Spezial-Version */
      case(24): /* 'MaxVisDistance' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return crDef(4,4); /* Ergebnis von Spezial-Version */
      case(29): /* 'NoDirLight' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return crDef(5,0); /* Ergebnis von Spezial-Version */
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me,c); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * ##getCtl.TSStatic (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSStatic (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSStatic (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "Static"; /* Objekt-Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mskAdd"
  * Information-Hiding: 'addMsk' maskieren:
  *  Additionsmaske gemaess Argument maskieren
  * Achtung: Methode ist statisch
  * ##mskAdd.TSStatic (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void mskAdd( /* Additions-Maske maskieren */
   int m) /* Maske zum maskieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    addMsk &= m; /* Additionsmaske maskieren */
    return; /* und zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSStatic (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(25): /* 'VDbId' */
        clrView(getVNrDef()); /* Default-Kennung ViewSphere setzen */
        return "Static("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "Static("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSStatic (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return toStr(false) + ":'" + Nme + "'}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSForest -- Definition eines 'World'-Eintrags (Forest)
 * ##TSForest (Eyecatcher)
 *======================================================================
 </pre>*/
class TSForest extends TSUiD { /* 'World'-Eintrags-Def. (Forest) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.2.99 01.03.2006";
  private static final int      valMsk = 0x06F00031; /* Zeilen (valid) */
  private static final int      reqMsk = 0x80200001; /* Zeilen (req) */
  private static int            addMsk = 0x0200003C; /* Zeilen (add) */
  private static String[]       reqNme = { /* Namen der req. Items */
    "UiD","Position","QDirection/Matrix3x3"};
 /*-------------------------------------------------------------------*/
  private String                Nme;    /* Texturname des Objektes */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 - Entry is of type 'yard'
  *        9 - Yard-UserID (UID) is NOT useable
  *       10 -
  *       11 -
  *       12 - reserved for 'filename has been modified'
  *   13..23 - (not used)
  * Definition of 'Entry found' (stored in TSOpt):
  *        0 : UiD
  *        1 : TreeTexture
  *        2 : ScaleRange
  *        3 : Area
  *        4 : Population
  *        5 : TreeSize
  *  6 to 19 : not used
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  *       23 : Matrix3x3
  *       24 : not used
  *       25 : VDbId
  *       26 : StaticDetailLevel
  * 27 to 30 : not used
  *       31 : QDirection/Matrix3x3
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.00(S) - not used
  *   0.01(S) - Definitionstatement of 'ScaleRange'
  *   0.02(S) - Definitionstatement of 'Area'
  *   0.03(S) - Definitionstatement of 'Matrix3x3'
  *   0.04(S) - Definitionstatement of 'Population'
  *   0.05(S) - Definitionstatement of 'TreeSize'
  *   1.xx(I) - (Queue) not used
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSForest() /* 'World'-Definition (Forest) erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSForest( /* 'World'-Definition (Forest) erstellen */
   int oid, /* aktuelle Object-ID */
   int sl)  /* StaticDetailLevel */
   {
    super(oid,4,sl); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nme = null; /* Objekt-Name noch nicht vorhanden */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * neuen aktuellen Texturnamen liefern oder aendern
  * wenn w==null: liefern aktuellen Texturnamen (information-Hiding)
  * ##chgNme.TSForest (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* Texturname neu setzen */
   String w) /* neuen Texturnamen */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = Nme; /* alten Namen merken */
    if(w!=null) Nme = w; /* neuen Texturname setzen (keine Kopie) */
    return s; /* alten Dateinamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSForest (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   boolean c)  /* Kennzeichen setzen wenn Fehler und 'true' */
   {
   /*-----------------------------------------------------------------*/
    String is; /* Arbeitswert */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 1): /* 'TreeTexture' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        is = chgNme(null); /* Texturname holen */
        if(is==null) { /* Fehler: Texturname nicht vorhanden */
          if(me) return TSLogg.getMsg("TSUidD51",getUiD(0));
          is = ""; /* Dummy-Wert benutzen */
        } /* Textur-Name ist OK */
        return "\t\tTreeTexture ( " + TSUtil.modStr(is) + " )";
      case( 2): /* 'ScaleRange' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tScaleRange (" + getDta(1) + ")";
      case( 3): /* 'Area' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tArea (" + getDta(2) + ")";
      case( 4): /* 'Population' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tPopulation (" + getDta(4) + ")";
      case( 5): /* 'TreeSize' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tTreeSize (" + getDta(5) + ")";
      case(23): /* 'Matrix3x3' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return crDef(3,3); /* Ergebnis von Spezial-Version */
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me,c); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * ##getCtl.TSForest (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSForest (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSForest (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "Forest"; /* Objekt-Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mskAdd"
  * Information-Hiding: 'addMsk' maskieren:
  *  Additionsmaske gemaess Argument maskieren
  * Achtung: Methode ist statisch
  * ##mskAdd.TSForest (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void mskAdd( /* Additions-Maske maskieren */
   int m) /* Maske zum maskieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    addMsk &= m; /* Additionsmaske maskieren */
    return; /* und zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSForest (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 2): /* 'ScaleRange' */
        chgDta(1," "+TSLogg.getMsg("TSUidX42",Nme,u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Forest("+u+")-ScaleRange";
      case( 3): /* 'Area' */
        chgDta(2," "+TSLogg.getMsg("TSUidX43",Nme,u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Forest("+u+")-Area";
      case( 4): /* 'Population' */
        chgDta(4," "+TSLogg.getMsg("TSUidX44",Nme,u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Forest("+u+")-Population";
      case( 5): /* 'TreeSize' */
        chgDta(5," "+TSLogg.getMsg("TSUidX45",Nme,u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Forest("+u+")-TreeSize";
      case(25): /* 'VDbId' */
        clrView(getVNrDef()); /* Default-Kennung ViewSphere setzen */
        return "Forest("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "Forest("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSForest (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return toStr(false) + ":'" + Nme + "'}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSPlatform -- Definition eines 'World'-Eintrags (Platform)
 * ##TSPlatform (Eyecatcher)
 *======================================================================
 </pre>*/
class TSPlatform extends TSUiD { /* 'World'-Eintrags-Def. (Platform) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 10.07.2008";
  private static final int      valMsk = 0x06710001; /* Zeilen (valid) */
  private static final int      reqMsk = 0x00610001; /* Zeilen (req) */
  private static int            addMsk = 0x02000000; /* Zeilen (add) */
  private static String[]       reqNme = { /* Namen der req. Items */
    "UiD","TrItemId","Position","QDirection"};
 /*-------------------------------------------------------------------*/
  private int                   ItCnt;  /* Aktuelle Anzahl der TrItems */
  private TSRefC[]              TrItm;  /* TrItem-Referenzen (Nr/Adr) */
 /**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 -
  *        9 -
  *       10 -
  *       11 -
  *   12..23 - (not used)
  * Definition of 'Entry found' (stored in TSOpt):
  *        0 : UiD
  *        1 : PlatformData
  *  2 to 15 : not used
  *       16 : TrItemId
  * 17 to 19 : not used
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  * 23 to 24 : not used
  *       25 : VDbId
  *       26 : StaticDetailLevel
  * 27 to 30 : not used
  *       31 : QDirection/Matrix3x3
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.00(S) - Definitionstatement of 'PlatformData'
  *   1.xx(I) - (Queue) not used
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSPlatform() /* 'World'-Definition (Platform) erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    ItCnt = 0;  /* noch keine Referenzen eingetragen */
    TrItm = null; /* noch keine TrItem-Referenzen moeglich */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSPlatform( /* 'World'-Definition (Platform) erstellen */
   int oid, /* aktuelle Object-ID */
   int sl)  /* StaticDetailLevel */
   {
    super(oid,5,sl); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    ItCnt = 0;  /* noch keine Referenzen eingetragen */
    TrItm = new TSRefC[2]; /* Datenspeicher fuer 2 TrItem-Referenzen */
    TrItm[0] = TrItm[1] = null; /* noch keine Referenzen eingetragen */
    setOpt(7);  /* Object-Type is member of 'MveObj'-set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addTrI"
  * neue TrItem-Referenz hinzufuegen
  * falls Maximum ueberschritten wird Anzahl der Aufrufe geliefert
  * ##addTrI.TSPlatform (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int addTrI( /* neues TrItem hinzufuegen */
   int typ,  /* Typ des TrItems (Datenbank-Nummer) */
   int itnr) /* Nummer der TrItem-Referenz */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    if(typ!=0) return -2; /* nur Schienendatenbank erlaubt */
    if(TrItm==null) return -3; /* Referenzspeicher nicht angelegt */
    i = ItCnt++; /* Index und Anzahl berechnen */
    if(ItCnt>2) return ItCnt; /* Anzahl zu gross -- melden */
    TrItm[i] = new TSRefC(itnr); /* TrItem-Referenz eintragen */
    return 0; /* TrItem erfolgreich gespeichert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTrI"
  * Referenz-Verkettung fuer 'TrItem' aendern
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##chgTrI.TSPlatform (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC chgTrI( /* Referenzverkettung aendern und liefern */
   int    db, /* Nummer der Datenbank */
   int    ix, /* Index des Eintrags */
   TSRefC rf) /* neue Referenzverkettung oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC  cRef; /* aktuelles Definitionsobjekt */
   /*=================================================================*/
    if(TrItm==null) return null; /* Daten nicht gefuellt */
    if(db!=0) return null; /* Datenbank nicht erlaubt */
    if(ix<0 || ix>=TrItm.length) return null; /* Fehler kein Element */
    cRef = TrItm[ix]; /* aktuelles Steuerobjekt merken */
    if(rf!=null) TrItm[ix] = rf; /* Steuerobjekt setzen/austauschen */
    return cRef; /* altes Referenzobjekt liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkTrItmT"
  * pruefen ob TrItemTyp zu aktuellem Objekt passt
  * Routine liefert 'true', wenn die Zuordnung NICHT passt
  * ##chkTrItmT.TSPlatform (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkTrItmT( /* Objektzuordnung pruefen */
   int ItmT) /* TrItem-Typ (vgl TSTrItm) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return ItmT!=2; /* nur PlatformItem erlaubt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSPlatform (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   boolean c)  /* Kennzeichen setzen wenn Fehler und 'true' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC  ref; /* intermediate value */
    TSTrItm cIt; /* Arbeitswert */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 1): /* 'PlatformData' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tPlatformData (" + getDta(0) + ")";
      case(16): /* 'TrItemId' */
        if(n>=Math.min(ItCnt,2)) return null; /* keine weitere Zeile */
        ref = TrItm[n]; /* betroffenes Referenzobjekt holen */
        cIt = (TSTrItm)ref.chgRef(null); /* TrItem-Referenz holen */
        if(cIt==null) { /* Fehler: Referenz nicht definiert */
          n = ref.chgNr(Integer.MIN_VALUE); /* Originalwert verwenden */
          if(c) { /* Kennzeichen einfuegen */
            if(me) return TSLogg.getMsg("TSUidD61",getUiD(0));
            n = -1; /* Dummy-Wert benutzen */
          } else if(me) return TSLogg.getMsg("TSUidD62",getUiD(0));
        } else n = cIt.getNr(false); /* Referenz-ID holen */
        return "\t\tTrItemId ( 0 " + n + " )";
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me,c); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndTrI"
  * Index der TrItem-Definition suchen
  * ACHTUNG: TrItem-Nummern duerfen NICHT DOPPELT auftreten
  * ##fndTrI.TSPlatform (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int fndTrI( /* Index fuer TrItem-Definition suchen */
   int db, /* Nummer der Datenbank */
   int it) /* Wert der TrItem-Nummer */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    if(TrItm==null) return -2; /* Speicher existiert noch nicht */
    if(db!=0) return -4; /* Datenbank-Nummer stimmt nicht */
    for(i=0;i<Math.min(ItCnt,2);i+=1) /* TrItem-Nummer suchen */
      if(TrItm[i].chgNr(Integer.MIN_VALUE)==it) return i;
        /* Nummer gefunden -- Index liefern */
    return -3; /* TrItem-Referenz nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$TrI"
  * Anzahl der definierten TrItem-Referenzen abfragen
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##get$TrI.TSPlatform (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$TrI( /* Anzahl TrItem-Definition abfragen */
   int db) /* Nummer der Datenbank */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(TrItm==null) return -2; /* Tabelle existiert (noch) nicht */
    if(db!=0) return -4; /* Datenbank-Nummer stimmt nicht */
    return Math.min(ItCnt,TrItm.length); /* Anzahl der Def's liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * ##getCtl.TSPlatform (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSPlatform (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSPlatform (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "Platform"; /* Objekt-Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mskAdd"
  * Information-Hiding: 'addMsk' maskieren:
  *  Additionsmaske gemaess Argument maskieren
  * Achtung: Methode ist statisch
  * ##mskAdd.TSPlatform (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void mskAdd( /* Additions-Maske maskieren */
   int m) /* Maske zum maskieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    addMsk &= m; /* Additionsmaske maskieren */
    return; /* und zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSPlatform (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(25): /* 'VDbId' */
        clrView(getVNrDef()); /* Default-Kennung ViewSphere setzen */
        return "Platform("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "Platform("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSPlatform (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
    int    i;  /* Laufvariable */
   /*=================================================================*/
    rs = toStr(false) + ":" + ItCnt + "[";
    if(TrItm!=null) /* Datenspeicher ist vorhanden */
     for(i=0;i<ItCnt;i+=1) { /* alle definierten Elemente */
      if(i>0) rs += ","; /* Trennzeichen einfuegen */
      rs += TrItm[i].chgNr(Integer.MIN_VALUE); /* Nummer hinzufuegen */
    } /* alle Referenzen */
    rs += "]}"; /* Abschluss setzen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSSiding -- Definition eines 'World'-Eintrags (Siding)
 * ##TSSiding (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSiding extends TSUiD { /* 'World'-Eintrags-Def. (Siding) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 10.07.2008";
  private static final int      valMsk = 0x06710001; /* Zeilen (valid) */
  private static final int      reqMsk = 0x00610001; /* Zeilen (req) */
  private static int            addMsk = 0x02000000; /* Zeilen (add) */
  private static String[]       reqNme = { /* Namen der req. Items */
    "UiD","TrItemId","Position","QDirection"};
 /*-------------------------------------------------------------------*/
  private int                   ItCnt;  /* Aktuelle Anzahl der TrItems */
  private TSRefC[]              TrItm;  /* TrItem-Referenzen (Nr/Adr) */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 -
  *        9 -
  *       10 -
  *       11 -
  *   12..23 - (not used)
  * Definition of 'Entry found' (stored in TSOpt):
  *        0 : UiD
  *        1 : SidingData
  *  2 to 15 : not used
  *       16 : TrItemId
  * 17 to 19 : not used
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  * 23 to 24 : not used
  *       25 : VDbId
  *       26 : StaticDetailLevel
  * 27 to 30 : not used
  *       31 : QDirection/Matrix3x3
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.00(S) - Definitionstatement of 'SidingData'
  *   1.xx(I) - (Queue) not used
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSiding() /* 'World'-Definition (Siding) erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    ItCnt = 0;  /* noch keine Referenzen eingetragen */
    TrItm = null; /* noch keine TrItem-Referenzen moeglich */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSiding( /* 'World'-Definition (Siding) erstellen */
   int oid, /* aktuelle Object-ID */
   int sl)  /* StaticDetailLevel */
   {
    super(oid,6,sl); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    ItCnt = 0;  /* noch keine Referenzen eingetragen */
    TrItm = new TSRefC[2]; /* Datenspeicher fuer 2 TrItem-Referenzen */
    TrItm[0] = TrItm[1] = null; /* noch keine Referenzen eingetragen */
    setOpt(7);  /* Object-Type is member of 'MveObj'-set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addTrI"
  * neue TrItem-Referenz hinzufuegen
  * falls Maximum ueberschritten wird Anzahl der Aufrufe geliefert
  * ##addTrI.TSSiding (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int addTrI( /* neues TrItem hinzufuegen */
   int typ,  /* Typ des TrItems (Datenbank-Nummer) */
   int itnr) /* Nummer der TrItem-Referenz */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    if(typ!=0) return -2; /* nur Schienendatenbank erlaubt */
    if(TrItm==null) return -3; /* Referenzspeicher nicht angelegt */
    i = ItCnt++; /* Index und Anzahl berechnen */
    if(ItCnt>2) return ItCnt; /* Anzahl zu gross -- melden */
    TrItm[i] = new TSRefC(itnr); /* TrItem-Referenz eintragen */
    return 0; /* TrItem erfolgreich gespeichert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTrI"
  * Referenz-Verkettung fuer 'TrItem' aendern
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##chgTrI.TSSiding (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC chgTrI( /* Referenzverkettung aendern und liefern */
   int    db, /* Nummer der Datenbank */
   int    ix, /* Index des Eintrags */
   TSRefC rf) /* neue Referenzverkettung oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC  cRef; /* aktuelles Definitionsobjekt */
   /*=================================================================*/
    if(TrItm==null) return null; /* Daten nicht gefuellt */
    if(db!=0) return null; /* Datenbank nicht erlaubt */
    if(ix<0 || ix>=TrItm.length) return null; /* Fehler kein Element */
    cRef = TrItm[ix]; /* aktuelles Steuerobjekt merken */
    if(rf!=null) TrItm[ix] = rf; /* Steuerobjekt setzen/austauschen */
    return cRef; /* altes Referenzobjekt liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkTrItmT"
  * pruefen ob TrItemTyp zu aktuellem Objekt passt
  * Routine liefert 'true', wenn die Zuordnung NICHT passt
  * ##chkTrItmT.TSSiding (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkTrItmT( /* Objektzuordnung pruefen */
   int ItmT) /* TrItem-Typ (vgl TSTrItm) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return ItmT!=3; /* nur SidingItem erlaubt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSSiding (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   boolean c)  /* Kennzeichen setzen wenn Fehler und 'true' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC  ref; /* intermediate value */
    TSTrItm cIt; /* Arbeitswert */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 1): /* 'SidingData' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tSidingData (" + getDta(0) + ")";
      case(16): /* 'TrItemId' */
        if(n>=Math.min(ItCnt,2)) return null; /* keine weitere Zeile */
        ref = TrItm[n]; /* betroffenes Referenzobjekt holen */
        cIt = (TSTrItm)ref.chgRef(null); /* TrItem-Referenz holen */
        if(cIt==null) { /* Fehler: Referenz nicht definiert */
          n = ref.chgNr(Integer.MIN_VALUE); /* Originalwert verwenden */
          if(c) { /* Kennzeichen einfuegen */
            if(me) return TSLogg.getMsg("TSUidD71",getUiD(0));
            n = -1; /* Dummy-Wert benutzen */
          } else if(me) return TSLogg.getMsg("TSUidD72",getUiD(0));
        } else n = cIt.getNr(false); /* Referenz-ID holen */
        return "\t\tTrItemId ( 0 " + n + " )";
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me,c); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndTrI"
  * Index der TrItem-Definition suchen
  * ACHTUNG: TrItem-Nummern duerfen NICHT DOPPELT auftreten
  * ##fndTrI.TSSiding (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int fndTrI( /* Index fuer TrItem-Definition suchen */
   int db, /* Nummer der Datenbank */
   int it) /* Wert der TrItem-Nummer */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    if(TrItm==null) return -2; /* Speicher existiert noch nicht */
    if(db!=0) return -4; /* Datenbank-Nummer stimmt nicht */
    for(i=0;i<Math.min(ItCnt,2);i+=1) /* TrItem-Nummer suchen */
      if(TrItm[i].chgNr(Integer.MIN_VALUE)==it) return i;
        /* Nummer gefunden -- Index liefern */
    return -3; /* TrItem-Referenz nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$TrI"
  * Anzahl der definierten TrItem-Referenzen abfragen
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##get$TrI.TSSiding (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$TrI( /* Anzahl TrItem-Definition abfragen */
   int db) /* Nummer der Datenbank */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(TrItm==null) return -2; /* Tabelle existiert (noch) nicht */
    if(db!=0) return -4; /* Datenbank-Nummer stimmt nicht */
    return Math.min(ItCnt,TrItm.length); /* Anzahl der Def's liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * ##getCtl.TSSiding (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSSiding (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSSiding (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "Siding"; /* Objekt-Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mskAdd"
  * Information-Hiding: 'addMsk' maskieren:
  *  Additionsmaske gemaess Argument maskieren
  * Achtung: Methode ist statisch
  * ##mskAdd.TSSiding (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void mskAdd( /* Additions-Maske maskieren */
   int m) /* Maske zum maskieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    addMsk &= m; /* Additionsmaske maskieren */
    return; /* und zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSSiding (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(25): /* 'VDbId' */
        clrView(getVNrDef()); /* Default-Kennung ViewSphere setzen */
        return "Siding("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "Siding("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSiding (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
    int    i;  /* Laufvariable */
   /*=================================================================*/
    rs = toStr(false) + ":" + ItCnt + "[";
    if(TrItm!=null) /* Datenspeicher ist vorhanden */
     for(i=0;i<ItCnt;i+=1) { /* alle definierten Elemente */
      if(i>0) rs += ","; /* Trennzeichen einfuegen */
      rs += TrItm[i].chgNr(Integer.MIN_VALUE); /* Nummer hinzufuegen */
    } /* alle Referenzen */
    rs += "]}"; /* Abschluss setzen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSGantry -- Definition eines 'World'-Eintrags (Gantry)
 * ##TSGantry (Eyecatcher)
 *======================================================================
 </pre>*/
class TSGantry extends TSUiD { /* 'World'-Eintrags-Def. (Gantry) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.6.03 26.07.2011";
  private static final int      valMsk = 0x06780001; /* Zeilen (valid) */
  private static final int      reqMsk = 0x00680001; /* Zeilen (req) */
  private static int            addMsk = 0x02000000; /* Zeilen (add) */
  private static String[]       reqNme = { /* Namen der req. Items */
    "UiD","FileName","Position","QDirection"};
 /*-------------------------------------------------------------------*/
  private String                Nme;    /* filename of the object */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 -
  *        9 -
  *       10 -
  *       11 -
  *   12..23 - (not used)
  * Definition of 'Entry found' (stored in TSOpt):
  *        0 : UiD
  *  1 to 18 : not used
  *       19 : FileName
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  * 23 to 24 : not used
  *       25 : VDbId
  *       26 : StaticDetailLevel
  * 27 to 30 : not used
  *       31 : QDirection/Matrix3x3
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.xx(S) - (Queue) not used
  *   1.xx(I) - (Queue) not used
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSGantry() /* 'World'-Definition (Gantry) erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSGantry( /* 'World'-Definition (Gantry) erstellen */
   int oid, /* aktuelle Object-ID */
   int sl)  /* StaticDetailLevel */
   {
    super(oid,7,sl); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nme = null; /* Objekt-Name noch nicht vorhanden */
    setOpt(7);  /* Object-Type is member of 'MveObj'-set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create conversion-entry (Static -> Gantry)
  *=====================================================================
  </pre>*/
  protected TSGantry( /* 'World'-Definition (Gantry) erstellen */
   TSStatic bO) /* Basic-object (Static) */
   {
    super(bO,7); /* transfer basic-values */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nme = bO.chgNme(null); /* File-Name als Shape-Name setzen */
    setOpt(7); /* Object-Type is member of 'MveObj'-set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * neuen aktuellen Dateinamen liefern oder aendern
  * wenn w==null: liefern aktuellen Dateinamen (information-Hiding)
  * ##chgName.TSGantry (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* Dateiname neu setzen */
   String w) /* neuen Dateinamen */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = Nme; /* alten Namen merken */
    if(w!=null) Nme = w; /* neuen Dateiname setzen (keine Kopie) */
    return s; /* alten Dateinamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * ##getCtl.TSGantry (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSGantry (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSGantry (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "Gantry"; /* Objekt-Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mskAdd"
  * Information-Hiding: 'addMsk' maskieren:
  *  Additionsmaske gemaess Argument maskieren
  * Achtung: Methode ist statisch
  * ##mskAdd.TSGantry (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void mskAdd( /* Additions-Maske maskieren */
   int m) /* Maske zum maskieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    addMsk &= m; /* Additionsmaske maskieren */
    return; /* und zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSGantry (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(25): /* 'VDbId' */
        clrView(getVNrDef()); /* Default-Kennung ViewSphere setzen */
        return "Gantry("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "Gantry("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSGantry (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return toStr(false) + ":'" + Nme + "'}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSSpeed -- Definition eines 'World'-Eintrags (Speedpost)
 * ##TSSpeed (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSpeed extends TSUiD { /* 'World'-Eintrags-Def. (Speedpost) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 10.07.2008";
  private static final int      valMsk = 0x06790001; /* Zeilen (valid) */
  private static final int      reqMsk = 0x00690003; /* Zeilen (req) */
  private static int            addMsk = 0x02000008; /* Zeilen (add) */
  private static String[]       reqNme = { /* Namen der req. Items */
    "UiD","Speed_Digit_Tex","TrItemId","FileName","Position","QDirection"};
 /*-------------------------------------------------------------------*/
  private int                   ItCnt;  /* aktuelle Anzahl der TrItems */
  private TSRefC[]              TrItm;  /* TrItem-Referenzen (Nr/Adr) */
  private String                Nme;    /* Dateiname des Objektes */
  private String                TNme;   /* Texturname des Objektes */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 -
  *        9 -
  *       10 -
  *       11 -
  *   12..23 - (not used)
  * Definition of 'Entry found' (stored in TSOpt):
  *        0 : UiD
  *        1 : Speed_Digit_Tex
  *        2 : Speed_Sign_Shape
  *        3 : Speed_Text_Size
  *  4 to 15 : not used
  *       16 : TrItemId
  * 17 to 18 : not used
  *       19 : FileName
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  * 23 to 24 : not used
  *       25 : VDbId
  *       26 : StaticDetailLevel
  * 27 to 30 : not used
  *       31 : QDirection/Matrix3x3
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.00(S) - Definitionstatement of 'Speed_Sign_Shape'
  *   0.01(S) - Definitionstatement of 'Speed_Text_Size'
  *   1.xx(I) - (Queue) not used
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSpeed() /* 'World'-Definition (Speedpost) erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    ItCnt = 0;  /* noch keine Referenzen eingetragen */
    TrItm = null; /* noch keine TrItem-Referenzen moeglich */
//    Nme   = null; /* Objekt-Name noch nicht vorhanden */
//    TNme  = null; /* Textur-Name noch nicht vorhanden */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSpeed( /* 'World'-Definition (Speedpost) erstellen */
   int oid, /* aktuelle Object-ID */
   int sl)  /* StaticDetailLevel */
   {
    super(oid,8,sl); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                        /* keine lokalen Variablen */
   /*=================================================================*/
    ItCnt = 0;  /* noch keine Referenzen eingetragen */
    TrItm = new TSRefC[4]; /* Datenspeicher fuer 4 TrItem-Referenzen */
    Arrays.fill(TrItm,null); /* noch keine Referenzen */
    Nme   = null; /* Objekt-Name noch nicht vorhanden */
    TNme  = null; /* Textur-Name noch nicht vorhanden */
    setOpt(7);  /* Object-Type is member of 'MveObj'-set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addTrI"
  * neue TrItem-Referenz hinzufuegen
  * falls Maximum ueberschritten wird Anzahl der Aufrufe geliefert
  * ##addTrI.TSSpeed (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int addTrI( /* neues TrItem hinzufuegen */
   int typ,  /* Typ des TrItems (Datenbank-Nummer) */
   int itnr) /* Nummer der TrItem-Referenz */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    if(typ!=0) return -2; /* nur Schienendatenbank erlaubt */
    if(TrItm==null) return -3; /* Datenspeicher nicht angelegt */
    i = ItCnt++; /* Index und Anzahl berechnen */
    if(ItCnt>4) return ItCnt; /* Anzahl zu gross -- melden */
    TrItm[i] = new TSRefC(itnr); /* TrItem-Referenz eintragen */
    return 0; /* TrItem erfolgreich gespeichert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * neuen aktuellen Dateinamen liefern oder aendern
  * wenn w==null: liefern aktuellen Dateinamen (information-Hiding)
  * ##chgNme.TSSpeed (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* Dateiname neu setzen */
   String w) /* neuen Dateinamen */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = Nme; /* alten Namen merken */
    if(w!=null) Nme = w; /* neuen Dateiname setzen (keine Kopie) */
    return s; /* alten Dateinamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTNme"
  * neuen aktuellen Texturnamen liefern oder aendern
  * wenn w==null: liefern aktuellen Texturnamen (information-Hiding)
  * ##chgTNme.TSSpeed (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgTNme( /* Texturname neu setzen */
   String w) /* neuen Texturnamen */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = TNme; /* alten Namen merken */
    if(w!=null) TNme = w; /* neuen Texturnamen setzen (keine Kopie) */
    return s; /* alten Texturnamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTrI"
  * Referenz-Verkettung fuer 'TrItem' aendern
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##chgTrI.TSSpeed (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC chgTrI( /* Referenzverkettung aendern und liefern */
   int    db, /* Nummer der Datenbank */
   int    ix, /* Index des Eintrags */
   TSRefC rf) /* neue Referenzverkettung oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC  cRef; /* aktuelles Definitionsobjekt */
   /*=================================================================*/
    if(TrItm==null) return null; /* Daten nicht gefuellt */
    if(db!=0) return null; /* Datenbank nicht erlaubt */
    if(ix<0 || ix>=TrItm.length) return null; /* Fehler kein Element */
    cRef = TrItm[ix]; /* aktuelles Steuerobjekt merken */
    if(rf!=null) TrItm[ix] = rf; /* Steuerobjekt setzen/austauschen */
    return cRef; /* altes Referenzobjekt liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkTrItmT"
  * pruefen ob TrItemTyp zu aktuellem Objekt passt
  * Routine liefert 'true', wenn die Zuordnung NICHT passt
  * ##chkTrItmT.TSSpeed (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkTrItmT( /* Objektzuordnung pruefen */
   int ItmT) /* TrItem-Typ (vgl TSTrItm) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return ItmT!=4; /* nur SpeedpostItem erlaubt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSSpeed (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   boolean c)  /* Kennzeichen setzen wenn Fehler und 'true' */
   {
   /*-----------------------------------------------------------------*/
    String  is;  /* Arbeitswert */
    TSRefC  ref; /* intermediate value */
    TSTrItm cIt; /* Arbeitswert */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 1): /* 'Speed_Digit_Tex' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        is = TNme; /* aktuellen Textur-Namen */
        if(is==null) { /* Name nicht gueltig */
          if(me) return TSLogg.getMsg("TSUidD93",getUiD(0));
          is = ""; /* leere Zeichenkette benutzen */
        } /* Name war nicht gueltig */
        return "\t\tSpeed_Digit_Tex ( " + TSUtil.modStr(is) + " )";
      case( 2): /* 'Speed_Sign_Shape' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tSpeed_Sign_Shape (" + getDta(0) + ")";
      case( 3): /* 'Speed_Text_Size' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tSpeed_Text_Size (" + getDta(1) + ")";
      case(16): /* 'TrItemId' */
        if(n>=Math.min(ItCnt,4)) return null; /* keine weitere Zeile */
        ref = TrItm[n]; /* betroffenes Referenzobjekt holen */
        cIt = (TSTrItm)ref.chgRef(null); /* TrItem-Referenz holen */
        if(cIt==null) { /* Fehler: Referenz nicht definiert */
          n = ref.chgNr(Integer.MIN_VALUE); /* Originalwert verwenden */
          if(c) { /* Kennzeichen einfuegen */
            if(me) return TSLogg.getMsg("TSUidD91",getUiD(0));
            n = -1; /* Dummy-Wert benutzen */
          } else if(me) return TSLogg.getMsg("TSUidD92",getUiD(0));
        } else n = cIt.getNr(false); /* Referenz-ID holen */
        return "\t\tTrItemId ( 0 " + n + " )";
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me,c); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndTrI"
  * Index der TrItem-Definition suchen
  * ACHTUNG: TrItem-Nummern duerfen NICHT DOPPELT auftreten
  * ##fndTrI.TSSpeed (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int fndTrI( /* Index fuer TrItem-Definition suchen */
   int db, /* Nummer der Datenbank */
   int it) /* Wert der TrItem-Nummer */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    if(TrItm==null) return -2; /* Speicher existiert noch nicht */
    if(db!=0) return -4; /* Datenbank-Nummer stimmt nicht */
    for(i=0;i<Math.min(ItCnt,4);i+=1) /* TrItem-Nummer suchen */
      if(TrItm[i].chgNr(Integer.MIN_VALUE)==it) return i;
        /* Nummer gefunden -- Index liefern */
    return -3; /* TrItem-Referenz nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$TrI"
  * Anzahl der definierten TrItem-Referenzen abfragen
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##get$TrI.TSSpeed (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$TrI( /* Anzahl TrItem-Definition abfragen */
   int db) /* Nummer der Datenbank */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(TrItm==null) return -2; /* Tabelle existiert (noch) nicht */
    if(db!=0) return -4; /* Datenbank-Nummer stimmt nicht */
    return Math.min(ItCnt,TrItm.length); /* Anzahl der Def's liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * ##getCtl.TSSpeed (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSSpeed (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSSpeed (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "Speedpost"; /* Objekt-Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mskAdd"
  * Information-Hiding: 'addMsk' maskieren:
  *  Additionsmaske gemaess Argument maskieren
  * Achtung: Methode ist statisch
  * ##mskAdd.TSSpeed (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void mskAdd( /* Additions-Maske maskieren */
   int m) /* Maske zum maskieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    addMsk &= m; /* Additionsmaske maskieren */
    return; /* und zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSSpeed (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 3): /* 'Speed_Text_Size' */
        chgDta(2," "+TSLogg.getMsg("TSUidX83",Nme,u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Speedpost("+u+")-Speed_Text_Size";
      case(25): /* 'VDbId' */
        clrView(getVNrDef()); /* Default-Kennung ViewSphere setzen */
        return "Speedpost("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "Speedpost("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSpeed (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
    int    i;  /* Laufvariable */
   /*=================================================================*/
    rs = toStr(false) + ":'" + Nme + "'," + ItCnt + "[";
    if(TrItm!=null) /* Datenspeicher ist vorhanden */
     for(i=0;i<ItCnt;i+=1) { /* alle definierten Elemente */
      if(i>0) rs += ","; /* Trennzeichen einfuegen */
      rs += TrItm[i].chgNr(Integer.MIN_VALUE); /* Nummer hinzufuegen */
    } /* alle Referenzen */
    rs += "]-'" + TNme + "'}"; /* Abschluss setzen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSCarSp -- Definition eines 'World'-Eintrags (CarSpawner)
 * ##TSCarSp (Eyecatcher)
 *======================================================================
 </pre>*/
class TSCarSp extends TSUiD { /* 'World'-Eintrags-Def. (CarSpawner) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 10.07.2008";
  private static final int      valMsk = 0x06710001; /* Zeilen (valid) */
  private static final int      reqMsk = 0x00610001; /* Zeilen (req) */
  private static int            addMsk = 0x02000006; /* Zeilen (add) */
  private static String[]       reqNme = { /* Namen der req. Items */
    "UiD","TrItemId","Position","QDirection"};
 /*-------------------------------------------------------------------*/
  private int                   ItCnt;  /* aktuelle Anzahl der TrItems */
  private TSRefC[]              TrItm;  /* TrItem-Referenzen (Nr/Adr) */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 -
  *        9 -
  *       10 -
  *       11 -
  *   12..23 - (not used)
  * Definition of 'Entry found' (stored in TSOpt):
  *        0 : UiD
  *        1 : CarFrequency
  *        2 : CarAvSpeed
  *  3 to 15 : not used
  *       16 : TrItemId
  * 17 to 19 : not used
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  * 23 to 24 : not used
  *       25 : VDbId
  *       26 : StaticDetailLevel
  * 27 to 30 : not used
  *       31 : QDirection/Matrix3x3
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.00(S) - Definitionstatement of 'CarFrequency'
  *   0.01(S) - Definitionstatement of 'CarAvSpeed'
  *   1.xx(I) - (Queue) not used
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSCarSp() /* 'World'-Definition (CarSpawner) erstellen */
   {
    super(); /*  /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    ItCnt = 0;  /* noch keine Referenzen eingetragen */
    TrItm = null; /* noch keine TrItem-Referenzen moeglich */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSCarSp( /* 'World'-Definition (CarSpawner) erstellen */
   int oid, /* aktuelle Object-ID */
   int sl)  /* StaticDetailLevel */
   {
    super(oid,9,sl); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    ItCnt = 0;  /* noch keine Referenzen eingetragen */
    TrItm = new TSRefC[2]; /* Datenspeicher fuer 2 TrItem-Referenzen */
    TrItm[0] = TrItm[1] = null; /* noch keine Referenzen eingetragen */
    setOpt(7);  /* Object-Type is member of 'MveObj'-set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addTrI"
  * neue TrItem-Referenz hinzufuegen
  * falls Maximum ueberschritten wird Anzahl der Aufrufe geliefert
  * ##addTrI.TSCarSp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int addTrI( /* neues TrItem hinzufuegen */
   int typ,  /* Typ des TrItems (Datenbank-Nummer) */
   int itnr) /* Nummer der TrItem-Referenz */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    if(typ!=1) return -2; /* nur Schienendatenbank erlaubt */
    if(TrItm==null) return -3; /* Referenzspeicher nicht angelegt */
    i = ItCnt++; /* Index und Anzahl berechnen */
    if(ItCnt>2) return ItCnt; /* Anzahl zu gross -- melden */
    TrItm[i] = new TSRefC(itnr); /* TrItem-Referenz eintragen */
    return 0; /* TrItem erfolgreich gespeichert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTrI"
  * Referenz-Verkettung fuer 'TrItem' aendern
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##chgTrI.TSCarSp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC chgTrI( /* Referenzverkettung aendern und liefern */
   int    db, /* Nummer der Datenbank */
   int    ix, /* Index des Eintrags */
   TSRefC rf) /* neue Referenzverkettung oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC  cRef; /* aktuelles Definitionsobjekt */
   /*=================================================================*/
    if(TrItm==null) return null; /* Daten nicht gefuellt */
    if(db!=1) return null; /* Datenbank nicht erlaubt */
    if(ix<0 || ix>=TrItm.length) return null; /* Fehler kein Element */
    cRef = TrItm[ix]; /* aktuelles Steuerobjekt merken */
    if(rf!=null) TrItm[ix] = rf; /* Steuerobjekt setzen/austauschen */
    return cRef; /* altes Referenzobjekt liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkTrItmT"
  * pruefen ob TrItemTyp zu aktuellem Objekt passt
  * Routine liefert 'true', wenn die Zuordnung NICHT passt
  * ##chkTrItmT.TSCarSp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkTrItmT( /* Objektzuordnung pruefen */
   int ItmT) /* TrItem-Typ (vgl TSTrItm) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return ItmT!=5; /* nur CarSpawnerItem erlaubt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSCarSp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   boolean c)  /* Kennzeichen setzen wenn Fehler und 'true' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC  ref; /* intermediate value */
    TSTrItm cIt; /* Arbeitswert */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 1): /* 'CarFrequency' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tCarFrequency (" + getDta(0) + ")";
      case( 2): /* 'CarAvSpeed' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tCarAvSpeed (" + getDta(1) + ")";
      case(16): /* 'TrItemId' */
        if(n>=Math.min(ItCnt,2)) return null; /* keine weitere Zeile */
        ref = TrItm[n]; /* betroffenes Referenzobjekt holen */
        cIt = (TSTrItm)ref.chgRef(null); /* TrItem-Referenz holen */
        if(cIt==null) { /* Fehler: Referenz nicht definiert */
          n = ref.chgNr(Integer.MIN_VALUE); /* Originalwert verwenden */
          if(c) { /* Kennzeichen einfuegen */
            if(me) return TSLogg.getMsg("TSUidDA1",getUiD(0));
            n = -1; /* Dummy-Wert benutzen */
          } else if(me) return TSLogg.getMsg("TSUidDA2",getUiD(0));
        } else n = cIt.getNr(false); /* Referenz-ID holen */
        return "\t\tTrItemId ( 1 " + n + " )";
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me,c); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndTrI"
  * Index der TrItem-Definition suchen
  * ACHTUNG: TrItem-Nummern duerfen NICHT DOPPELT auftreten
  * ##fndTrI.TSCarSp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int fndTrI( /* Index fuer TrItem-Definition suchen */
   int db, /* Nummer der Datenbank */
   int it) /* Wert der TrItem-Nummer */
   {
   /*-----------------------------------------------------------------*/
    int i; /* Laufvariable */
   /*=================================================================*/
    if(TrItm==null) return -2; /* Speicher existiert noch nicht */
    if(db!=1) return -4; /* Datenbank-Nummer stimmt nicht */
    for(i=0;i<Math.min(ItCnt,2);i+=1) /* TrItem-Nummer suchen */
      if(TrItm[i].chgNr(Integer.MIN_VALUE)==it) return i;
        /* Nummer gefunden -- Index liefern */
    return -3; /* TrItem-Referenz nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$TrI"
  * Anzahl der definierten TrItem-Referenzen abfragen
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##get$TrI.TSCarSp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$TrI( /* Anzahl TrItem-Definition abfragen */
   int db) /* Nummer der Datenbank */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(TrItm==null) return -2; /* Tabelle existiert (noch) nicht */
    if(db!=1) return -4; /* Datenbank-Nummer stimmt nicht */
    return Math.min(ItCnt,TrItm.length); /* Anzahl der Def's liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * ##getCtl.TSCarSp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSCarSp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSCarSp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "CarSpawner"; /* Objekt-Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mskAdd"
  * Information-Hiding: 'addMsk' maskieren:
  *  Additionsmaske gemaess Argument maskieren
  * Achtung: Methode ist statisch
  * ##mskAdd.TSCarSp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void mskAdd( /* Additions-Maske maskieren */
   int m) /* Maske zum maskieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    addMsk &= m; /* Additionsmaske maskieren */
    return; /* und zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSCarSp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 1): /* 'CarFrequency' */
        chgDta(0," "+TSLogg.getMsg("TSUidX91","",u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "CarSpawner("+u+")-CarFrequency";
      case( 2): /* 'CarAvSpeed' */
        chgDta(1," "+TSLogg.getMsg("TSUidX92","",u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "CarSpawner("+u+")-CarAvSpeed";
      case(25): /* 'VDbId' */
        clrView(getVNrDef()); /* Default-Kennung ViewSphere setzen */
        return "CarSpawner("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "CarSpawner("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSCarSp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
    int    i;  /* Laufvariable */
   /*=================================================================*/
    rs = toStr(false) + ":" + ItCnt + "[";
    if(TrItm!=null) /* Datenspeicher ist vorhanden */
     for(i=0;i<ItCnt;i+=1) { /* alle definierten Elemente */
      if(i>0) rs += ","; /* Trennzeichen einfuegen */
      rs += TrItm[i].chgNr(Integer.MIN_VALUE); /* Nummer hinzufuegen */
    } /* alle Referenzen */
    rs += "]}"; /* Abschluss setzen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSLevelCr -- Definition eines 'World'-Eintrags (LevelCr)
 * ##TSLevelCr (Eyecatcher)
 *======================================================================
 </pre>*/
class TSLevelCr extends TSUiD { /* 'World'-Eintrags-Def. (LevelCr) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 10.07.2008";
  private static final int      valMsk = 0x06790001; /* Zeilen (valid) */
  private static final int      reqMsk = 0x0069000B; /* Zeilen (req) */
  private static int            addMsk = 0x02000014; /* Zeilen (add) */
  private static String[]       reqNme = { /* Namen der req. Items */
    "UiD","LevelCrParameters","LevelCrData","TrItemId","FileName",
    "Position","QDirection"};
 /*-------------------------------------------------------------------*/
  private int                   ItCntS; /* Anzahl der TrItems (Soll) */
  private int[]                 ItCnt;  /* aktuelle Anzahl der TrItems */
  private TSRefC[][]            TrItm;  /* TrItem-Referenzen (Nr/Adr) */
  private String                Nme;    /* Dateiname des Objektes */
  private int                   DtaOpt; /* Optionen (LevelCrData) */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 -
  *        9 -
  *       10 -
  *       11 -
  *   12..23 - (not used)
  * Definition of 'Entry found' (stored in TSOpt):
  *        0 : UiD
  *        1 : LevelCrParameters
  *        2 : CrashProbability
  *        3 : LevelCrData
  *        4 : LevelCrTiming
  *  5 to 15 : not used
  *       16 : TrItemId
  * 17 to 18 : not used
  *       19 : FileName
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  * 23 to 24 : not used
  *       25 : VDbId
  *       26 : StaticDetailLevel
  * 27 to 30 : not used
  *       31 : QDirection/Matrix3x3
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.00(S) - Definitionstatement of 'LevelCrParamenters'
  *   0.01(S) - Definitionstatement of 'CrashProbability'
  *   0.02(S) - Definitionstatement of 'LevelCrTiming'
  *   1.xx(I) - (Queue) not used
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSLevelCr() /* 'World'-Definition (LevelCr) erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    ItCntS = 0;    /* Sollwert noch nicht gesetzt */
    ItCnt  = null; /* noch kein Datenspeicher */
    TrItm  = null; /* noch keine TrItem-Referenzen moeglich */
//    Nme    = null; /* Objekt-Name noch nicht vorhanden */
//    DtaOpt = 0;    /* Keine Optionen gespeichert */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSLevelCr( /* 'World'-Definition (LevelCr) erstellen */
   int oid, /* aktuelle Object-ID */
   int sl)  /* StaticDetailLevel */
   {
    super(oid,10,sl); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    ItCntS = 0;             /* Sollwert noch nicht gesetzt */
    ItCnt  = new int[2];    /* Speicher fuer Anzahl der Referenzen */
    ItCnt[0] = ItCnt[1] = 0; /* aktuelle Anzahl vorbesetzen */
    TrItm = new TSRefC[2][6]; /* Datenspeicher fuer 6 TrItem-Referenzen */
    for(i=0;i<6;i+=1) TrItm[0][i] = TrItm[1][i] = null; /* entwerten */
    Nme    = null; /* Objekt-Name noch nicht vorhanden */
    DtaOpt = 0;    /* Keine Optionen gespeichert */
    setOpt(7);     /* Object-Type is member of 'MveObj'-set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addTrI"
  * neue TrItem-Referenz hinzufuegen
  * falls Maximum ueberschritten wird Anzahl der Aufrufe geliefert
  * ##addTrI.TSLevelCr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int addTrI( /* neues TrItem hinzufuegen */
   int typ,  /* Typ des TrItems (Datenbank-Nummer) */
   int itnr) /* Nummer der TrItem-Referenz */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    if(typ<0 || typ>1) return -2; /* Syntaxfehler tritt nicht auf */
    if(TrItm==null) return -3; /* Speicher nicht angelegt */
    i = ItCnt[typ]++; /* Index und Anzahl berechnen */
    if(ItCnt[typ]>6) return ItCnt[typ]; /* Anzahl zu gross -- melden */
    TrItm[typ][i] = new TSRefC(itnr); /* TrItem-Referenz eintragen */
    return 0; /* TrItem erfolgreich gespeichert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgItS"
  * aktuellen Soll-Wert fuer TrItem-Anzahl liefern oder aendern
  * wenn w==0: liefern aktueller Wert (information-Hiding)
  * ##chgItS.TSLevelCr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int chgItS( /* Sollwert neu setzen */
   int w) /* neuen Wert */
   {
   /*-----------------------------------------------------------------*/
    int i;   /* intermediate value */
   /*=================================================================*/
    i  = ItCntS; /* alten Wert merken */
    if(w>0) ItCntS = w; /* neuen Wert setzen */
    return i; /* alten Level liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * neuen aktuellen Dateinamen liefern oder aendern
  * wenn w==null: liefern aktuellen Dateinamen (information-Hiding)
  * ##chgNme.TSLevelCr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* Dateiname neu setzen */
   String w) /* neuen Dateinamen */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = Nme; /* alten Namen merken */
    if(w!=null) Nme = w; /* neuen Dateiname setzen (keine Kopie) */
    return s; /* alten Dateinamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTrI"
  * Referenz-Verkettung fuer 'TrItem' aendern
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##chgTrI.TSLevelCr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC chgTrI( /* Referenzverkettung aendern und liefern */
   int    db, /* Nummer der Datenbank */
   int    ix, /* Index des Eintrags */
   TSRefC rf) /* neue Referenzverkettung oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC  cRef; /* aktuelles Definitionsobjekt */
   /*=================================================================*/
    if(TrItm==null) return null; /* Daten nicht gefuellt */
    if(db<0 || db>=2) return null; /* Datenbank-Nummer stimmt nicht */
    if(ix<0 || ix>=TrItm[db].length) return null; /* Fehler kein Element */
    cRef = TrItm[db][ix]; /* aktuelles Steuerobjekt merken */
    if(rf!=null) TrItm[db][ix] = rf; /* Steuerobjekt setzen/austauschen */
    return cRef; /* altes Referenzobjekt liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkItS"
  * Anzahl der TrItems mit Soll vergleichen
  * falls db<0: Sollwert liefern
  * ##chkItS.TSLevelCr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int chkItS( /* Anzahl der TrItems pruefen */
   int nr) /* Typ des TrItems (Datenbank-Nummer) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0) return ItCntS; /* Sonderfunktion: Sollwert liefern */
    if(nr>=2) return -2; /* Datenbank gibt es nicht */
    if(TrItm==null) return -3; /* Speicher nicht angelegt */
    nr = ItCnt[nr]; /* zwischenspeichern */
    if(nr!=ItCntS) return nr; /* Anzahl falsch -- Istwert melden */
    return -1; /* Anzahl passt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkTrItmT"
  * pruefen ob TrItemTyp zu aktuellem Objekt passt
  * Routine liefert 'true', wenn die Zuordnung NICHT passt
  * ##chkTrItmT.TSLevelCr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkTrItmT( /* Objektzuordnung pruefen */
   int ItmT) /* TrItem-Typ (vgl TSTrItm) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return ItmT!=6; /* nur LevelCrItem erlaubt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSLevelCr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   boolean c)  /* Kennzeichen setzen wenn Fehler und 'true' */
   {
   /*-----------------------------------------------------------------*/
    int     i;   /* Arbeitswert */
    TSRefC  ref; /* intermediate value */
    TSTrItm cIt; /* Arbeitswert */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 1): /* 'LevelCrParameters' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tLevelCrParameters (" + getDta(0) + ")";
      case( 2): /* 'CrashProbability' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tCrashProbability (" + getDta(1) + ")";
      case( 3): /* 'LevelCrData */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return("\t\tLevelCrData ( " + TSUtil.toHex(DtaOpt,8) +
               " " + ItCntS + " )"); /* Statement erstellen */
      case( 4): /* 'LevelCrTiming' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tLevelCrTiming (" + getDta(2) + ")";
      case(16): /* 'TrItemId' */
        i = 1; /* Zweiter Teil der TrItem-ID's */
        t = n - Math.min(ItCnt[0],6); /* Rest der Definitionen */
        if(t>=Math.min(ItCnt[1],6)) return null; /* keine weitere Zeile */
        if(t<0) { t = n; i = 0; } /* erster Teil liegt noch vor */
        ref = TrItm[i][t]; /* betroffenes Referenzobjekt holen */
        cIt = (TSTrItm)ref.chgRef(null); /* TrItem-Referenz holen */
        if(cIt==null) { /* Fehler: Referenz nicht definiert */
          n = ref.chgNr(Integer.MIN_VALUE); /* Originalwert verwenden */
          if(c) { /* Kennzeichen einfuegen */
            if(me) return TSLogg.getMsg("TSUidDB1",getUiD(0));
            n = -1; /* Dummy-Wert benutzen */
          } else if(me) return TSLogg.getMsg("TSUidDB2",getUiD(0));
        } else n = cIt.getNr(false); /* Referenz-ID holen */
        return "\t\tTrItemId ( " + i + " " + n + " )";
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me,c); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndTrI"
  * Index der TrItem-Definition suchen
  * ACHTUNG: TrItem-Nummern duerfen NICHT DOPPELT auftreten
  * ##fndTrI.TSLevelCr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int fndTrI( /* Index fuer TrItem-Definition suchen */
   int db, /* Nummer der Datenbank */
   int it) /* Wert der TrItem-Nummer */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    if(TrItm==null) return -2; /* Speicher existiert noch nicht */
    if(db<0 || db>=2) return -4; /* Datenbank-Nummer stimmt nicht */
    for(i=0;i<Math.min(ItCnt[db],6);i+=1) /* TrItem-Nummer suchen */
      if(TrItm[db][i].chgNr(Integer.MIN_VALUE)==it) return i;
        /* Nummer gefunden -- Index liefern */
    return -3; /* TrItem-Referenz nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$TrI"
  * Anzahl der definierten TrItem-Referenzen abfragen
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##get$TrI.TSLevelCr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$TrI( /* Anzahl TrItem-Definition abfragen */
   int db) /* Nummer der Datenbank */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(TrItm==null) return -2; /* Tabelle existiert (noch) nicht */
    if(db<0 || db>=2) return -4; /* Datenbank-Nummer stimmt nicht */
    return Math.min(ItCnt[db],TrItm[db].length); /* Anzahl der Def's */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * ##getCtl.TSLevelCr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSLevelCr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSLevelCr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "LevelCr"; /* Objekt-Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mskAdd"
  * Information-Hiding: 'addMsk' maskieren:
  *  Additionsmaske gemaess Argument maskieren
  * Achtung: Methode ist statisch
  * ##mskAdd.TSLevelCr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void mskAdd( /* Additions-Maske maskieren */
   int m) /* Maske zum maskieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    addMsk &= m; /* Additionsmaske maskieren */
    return; /* und zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSLevelCr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 2): /* 'CrashProbability' */
        chgDta(1," "+TSLogg.getMsg("TSUidXA2",Nme,u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "LevelCr("+u+")-CrashProbability";
      case( 4): /* 'LevelCrTiming' */
        chgDta(3," "+TSLogg.getMsg("TSUidXA4",Nme,u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "LevelCr("+u+")-LevelCrTiming";
      case(25): /* 'VDbId' */
        clrView(getVNrDef()); /* Default-Kennung ViewSphere setzen */
        return "LevelCr("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "LevelCr("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDtaOpt"
  * Wert fuer Datenoptionen aus LevelCrData setzen
  * Alter Wert wird geliefert!
  * ABFRAGE kann durch zweimaligen Aufruf erfolgen:
  *   z.B.: setDtaOpt(i=setDtaOpt(0))
  * ##setDtaOpt.TSLevelCr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int setDtaOpt( /* Wert fuer DatenOptionen setzen */
   int w) /* neuen Wert */
   {
   /*-----------------------------------------------------------------*/
    int i;   /* intermediate value */
   /*=================================================================*/
    i  = DtaOpt; /* alten Wert merken */
    DtaOpt = w; /* neuen Wert setzen */
    return i; /* alten Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSLevelCr (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs;  /* result-string */
    int    i,j; /* intermediate value */
   /*=================================================================*/
    if(ItCnt==null) return toStr(false)+":'"+Nme+"',-1[],-1[])";
    rs = toStr(false)+":'"+Nme+"',"+ItCnt[0]+"[";
    for(i=0;i<Math.min(ItCnt[0],6);i+=1) { /* alle definierten Elemente */
      if(i>0) rs += ","; /* Trennzeichen einfuegen */
      rs += TrItm[0][i].chgNr(Integer.MIN_VALUE); /* Nummer hinzufuegen */
    } /* alle Referenzen */
    rs += "]," + ItCnt[1] + "[";
    for(i=0;i<Math.min(ItCnt[1],6);i+=1) { /* alle definierten Elemente */
      if(i>0) rs += ","; /* Trennzeichen einfuegen */
      rs += TrItm[1][i].chgNr(Integer.MIN_VALUE); /* Nummer hinzufuegen */
    } /* alle Referenzen */
    rs += "]}"; /* Abschluss setzen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSHazard -- Definition eines 'World'-Eintrags (Hazard)
 * ##TSHazard (Eyecatcher)
 *======================================================================
 </pre>*/
class TSHazard extends TSUiD { /* 'World'-Eintrags-Def. (Hazard) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 10.07.2008";
  private static final int      valMsk = 0x06790001; /* Zeilen (valid) */
  private static final int      reqMsk = 0x00690001; /* Zeilen (req) */
  private static int            addMsk = 0x02000000; /* Zeilen (add) */
  private static String[]       reqNme = { /* Namen der req. Items */
    "UiD","TrItemId","FileName","Position","QDirection"};
 /*-------------------------------------------------------------------*/
  private TSRefC                TrItm;  /* TrItem-Referenz (Nr/Adr) */
  private String                Nme;    /* Dateiname des Objektes */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 -
  *        9 -
  *       10 -
  *       11 -
  *   12..23 - (not used)
  * Definition of 'Entry found' (stored in TSOpt):
  *        0 : UiD
  *  1 to 15 : not used
  *       16 : TrItemId
  * 17 to 18 : not used
  *       19 : FileName
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  * 23 to 24 : not used
  *       25 : VDbId
  *       26 : StaticDetailLevel
  * 27 to 30 : not used
  *       31 : QDirection/Matrix3x3
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.xx(S) - (Queue) not used
  *   1.xx(I) - (Queue) not used
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSHazard() /* 'World'-Definition (Hazard) erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    TrItm = null; /* noch keine TrItem-Referenz vorhanden */
//    Nme   = null; /* Objekt-Name noch nicht vorhanden */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSHazard( /* 'World'-Definition (Hazard) erstellen */
   int oid, /* aktuelle Object-ID */
   int sl)  /* StaticDetailLevel */
   {
    super(oid,11,sl); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    TrItm = null; /* noch keine TrItem-Referenz vorhanden */
    Nme   = null; /* Objekt-Name noch nicht vorhanden */
    setOpt(7);    /* Object-Type is member of 'MveObj'-set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addTrI"
  * neue TrItem-Referenz hinzufuegen
  * falls Maximum ueberschritten wird Anzahl der Aufrufe geliefert
  * ##addTrI.TSHazard (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int addTrI( /* neues TrItem hinzufuegen */
   int typ,  /* Typ des TrItems (Datenbank-Nummer) */
   int itnr) /* Nummer der TrItem-Referenz */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(typ!=0) return -2; /* nur Schienendatenbank erlaubt */
    if(TrItm!=null) return 1; /* zu viele Eintraege -- Anzahl zurueck */
    TrItm = new TSRefC(itnr); /* TrItem-Referenz eintragen */
    return 0; /* TrItem erfolgreich gespeichert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * neuen aktuellen Dateinamen liefern oder aendern
  * wenn w==null: liefern aktuellen Dateinamen (information-Hiding)
  * ##chgNme.TSHazard (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* Dateiname neu setzen */
   String w) /* neuen Dateinamen */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = Nme; /* alten Namen merken */
    if(w!=null) Nme = w; /* neuen Dateiname setzen (keine Kopie) */
    return s; /* alten Dateinamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTrI"
  * Referenz-Verkettung fuer 'TrItem' aendern
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##chgTrI.TSHazard (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC chgTrI( /* Referenzverkettung aendern und liefern */
   int    db, /* Nummer der Datenbank */
   int    ix, /* Index des Eintrags */
   TSRefC rf) /* neue Referenzverkettung oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC  cRef; /* aktuelles Definitionsobjekt */
   /*=================================================================*/
    if(db!=0) return null; /* Datenbank nicht erlaubt */
    if(ix!=0) return null; /* Fehler kein Element */
    cRef = TrItm; /* aktuelles Steuerobjekt merken */
    if(rf!=null) TrItm = rf; /* Steuerobjekt setzen/austauschen */
    return cRef; /* altes Referenzobjekt liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkTrItmT"
  * pruefen ob TrItemTyp zu aktuellem Objekt passt
  * Routine liefert 'true', wenn die Zuordnung NICHT passt
  * ##chkTrItmT.TSHazard (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkTrItmT( /* Objektzuordnung pruefen */
   int ItmT) /* TrItem-Typ (vgl TSTrItm) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return ItmT!=7; /* nur HazzardItem erlaubt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSHazard (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   boolean c)  /* Kennzeichen setzen wenn Fehler und 'true' */
   {
   /*-----------------------------------------------------------------*/
    TSTrItm cIt; /* Arbeitswert */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(16): /* 'TrItemId' */
        if(n>=((TrItm==null)?0:1)) return null; /* keine weitere Zeilen */
        cIt = (TSTrItm)TrItm.chgRef(null); /* TrItem-Referenz holen */
        if(cIt==null) { /* Fehler: Referenz nicht definiert */
          n = TrItm.chgNr(Integer.MIN_VALUE); /* Originalwert verwenden */
          if(c) { /* Kennzeichen einfuegen */
            if(me) return TSLogg.getMsg("TSUidDC1",getUiD(0));
            n = -1; /* Dummy-Wert benutzen */
          } else if(me) return TSLogg.getMsg("TSUidDC2",getUiD(0));
        } else n = cIt.getNr(false); /* Referenz-ID holen */
        return "\t\tTrItemId ( 0 " + n + " )";
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me,c); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndTrI"
  * Index der TrItem-Definition suchen
  * ACHTUNG: TrItem-Nummern duerfen NICHT DOPPELT auftreten
  * ##.fndTrI.TSHazard (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int fndTrI( /* Index fuer TrItem-Definition suchen */
   int db, /* Nummer der Datenbank */
   int it) /* Wert der TrItem-Nummer */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(db!=0) return -4; /* Datenbank-Nummer stimmt nicht */
    if(TrItm==null) return -3; /* TrItem-Referenz nicht vorhanden */
    if(TrItm.chgNr(Integer.MIN_VALUE)==it) return 0; /* OK */
      /* Nummer gefunden -- Dummy-Index liefern */
    return -3; /* TrItem-Referenz nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$TrI"
  * Anzahl der definierten TrItem-Referenzen abfragen
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##get$TrI.TSHazard (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$TrI( /* Anzahl TrItem-Definition abfragen */
   int db) /* Nummer der Datenbank */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(db!=0) return -4; /* Datenbank-Nummer stimmt nicht */
    return (TrItm==null)?0:1; /* Anzahl der Definitionen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * ##getCtl.TSHazard (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSHazard (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSHazard (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "Hazard"; /* Objekt-Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mskAdd"
  * Information-Hiding: 'addMsk' maskieren:
  *  Additionsmaske gemaess Argument maskieren
  * Achtung: Methode ist statisch
  * ##mskAdd.TSHazard (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void mskAdd( /* Additions-Maske maskieren */
   int m) /* Maske zum maskieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    addMsk &= m; /* Additionsmaske maskieren */
    return; /* und zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSHazard (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(25): /* 'VDbId' */
        clrView(getVNrDef()); /* Default-Kennung ViewSphere setzen */
        return "Hazard("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "Hazard("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSHazard (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = toStr(false) + ":'" + Nme + "',";
    if(TrItm==null) rs += "0[?]}";
      else rs += "1[" + TrItm.chgNr(Integer.MIN_VALUE) + "]}";
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSTransf -- Definition eines 'World'-Eintrags (Transfer)
 * ##TSTransf (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTransf extends TSUiD { /* 'World'-Eintrags-Def. (Transfer) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.2.99 01.03.2006";
  private static final int      valMsk = 0x06780001; /* Zeilen (valid) */
  private static final int      reqMsk = 0x00680007; /* Zeilen (req) */
  private static int            addMsk = 0x06000000; /* Zeilen (add) */
  private static String[]       reqNme = { /* Namen der req. Items */
    "UiD","Width","Height","FileName","Position","QDirection"};
 /*-------------------------------------------------------------------*/
  private String                Nme;    /* Dateiname des Objektes */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 -
  *        9 -
  *       10 -
  *       11 -
  *   12..23 - (not used)
  * Definition of 'Entry found' (stored in TSOpt):
  *        0 : UiD
  *        1 : Width
  *        2 : Height
  *  3 to 18 : not used
  *       19 : FileName
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  * 23 to 24 : not used
  *       25 : VDbId
  *       26 : StaticDetailLevel
  * 27 to 30 : not used
  *       31 : QDirection/Matrix3x3
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.00(S) - Definitionstatement of 'Width'
  *   0.01(S) - Definitionstatement of 'Height'
  *   1.xx(I) - (Queue) not used
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSTransf() /* 'World'-Definition (Transfer) erstellen */
   {
    super();  /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    Nme = null; /* Objekt-Name noch nicht vorhanden */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSTransf( /* 'World'-Definition (Transfer) erstellen */
   int oid, /* aktuelle Object-ID */
   int sl)  /* StaticDetailLevel */
   {
    super(oid,12,sl); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nme = null; /* Objekt-Name noch nicht vorhanden */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * neuen aktuellen Dateinamen liefern oder aendern
  * wenn w==null: liefern aktuellen Dateinamen (information-Hiding)
  * ##chgNme.TSTransf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* Dateiname neu setzen */
   String w) /* neuen Dateinamen */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = Nme; /* alten Namen merken */
    if(w!=null) Nme = w; /* neuen Dateiname setzen (keine Kopie) */
    return s; /* alten Dateinamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSTransf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   boolean c)  /* Kennzeichen setzen wenn Fehler und 'true' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 1): /* 'Width' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tWidth (" + getDta(0) + ")";
      case( 2): /* 'Height' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tHeight (" + getDta(1) + ")";
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me,c); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * ##getCtl.TSTransf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSTransf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSTransf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "Transfer"; /* Objekt-Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mskAdd"
  * Information-Hiding: 'addMsk' maskieren:
  *  Additionsmaske gemaess Argument maskieren
  * Achtung: Methode ist statisch
  * ##mskAdd.TSTransf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void mskAdd( /* Additions-Maske maskieren */
   int m) /* Maske zum maskieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    addMsk &= m; /* Additionsmaske maskieren */
    return; /* und zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSTransf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 1): /* 'Width' */
        chgDta(0," "+TSLogg.getMsg("TSUidXC1",Nme,u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Transfer("+u+")-Width";
      case( 2): /* 'Height' */
        chgDta(1," "+TSLogg.getMsg("TSUidXC2",Nme,u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Transfer("+u+")-Height";
      case(25): /* 'VDbId' */
        clrView(getVNrDef()); /* Default-Kennung ViewSphere setzen */
        return "Transfer("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "Transfer("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTransf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return toStr(false) + ":'" + Nme + "'}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSColli -- Definition eines 'World'-Eintrags (CollideObject)
 * ##TSColli (Eyecatcher)
 *======================================================================
 </pre>*/
class TSColli extends TSUiD { /* 'World'-Eintrags-Def. (CollideObject) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.2.99 01.03.2006";
  private static final int      valMsk = 0x267E0001; /* Zeilen (valid) */
  private static final int      reqMsk = 0x00680001; /* Zeilen (req) */
  private static int            addMsk = 0x02000000; /* Zeilen (add) */
  private static String[]       reqNme = { /* Namen der req. Items */
    "UiD","FileName","Position","QDirection"};
 /*-------------------------------------------------------------------*/
  private String                Nme;    /* Dateiname des Objektes */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 -
  *        9 -
  *       10 -
  *       11 -
  *   12..23 - (not used)
  * Definition of 'Entry found' (stored in TSOpt):
  *        0 : UiD
  *  1 to 16 : not used
  *       17 : CollideFlag
  *       18 : CollideFunction
  *       19 : FileName
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  * 23 to 24 : not used
  *       25 : VDbId
  *       26 : StaticDetailLevel
  * 27 to 28 : not used
  *       29 : NoDirLight
  *       30 : not used
  *       31 : QDirection/Matrix3x3
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.00(S) - Definitionstatement of 'NoDirLight'
  *   0.01(S) - Entry not used
  *   0.02(S) - Definitionstatement of 'CollideFunction'
  *   1.xx(I) - (Queue) not used
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSColli() /* 'World'-Definition (CollideObject) erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    Nme = null; /* Objekt-Name noch nicht vorhanden */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSColli( /* 'World'-Definition (CollideObject) erstellen */
   int oid, /* aktuelle Object-ID */
   int sl)  /* StaticDetailLevel */
   {
    super(oid,13,sl); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nme = null; /* Objekt-Name noch nicht vorhanden */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * neuen aktuellen Dateinamen liefern oder aendern
  * wenn w==null: liefern aktuellen Dateinamen (information-Hiding)
  * ##chgNme.TSColli (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* Dateiname neu setzen */
   String w) /* neuen Dateinamen */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = Nme; /* alten Namen merken */
    if(w!=null) Nme = w; /* neuen Dateiname setzen (keine Kopie) */
    return s; /* alten Dateinamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSColli (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   boolean c)  /* Kennzeichen setzen wenn Fehler und 'true' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(18): /* 'CollideFunction' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return crDef(2,2); /* Ergebnis von Spezial-Version */
      case(29): /* 'NoDirLight' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return crDef(5,0); /* Ergebnis von Spezial-Version */
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me,c); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * ##getCtl.TSColli (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSColli (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSColli (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "CollideObject"; /* Objekt-Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mskAdd"
  * Information-Hiding: 'addMsk' maskieren:
  *  Additionsmaske gemaess Argument maskieren
  * Achtung: Methode ist statisch
  * ##mskAdd.TSColli (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void mskAdd( /* Additions-Maske maskieren */
   int m) /* Maske zum maskieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    addMsk &= m; /* Additionsmaske maskieren */
    return; /* und zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSColli (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(25): /* 'VDbId' */
        clrView(getVNrDef()); /* Default-Kennung ViewSphere setzen */
        return "CollideObject("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "CollideObject("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSColli (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return toStr(false) + ":'" + Nme + "'}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSTelep -- Definition eines 'World'-Eintrags (Telepole)
 * ##TSTelep (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTelep extends TSUiD { /* 'World'-Eintrags-Def. (Telepole) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 30.09.2008";
  private static final int      valMsk = 0x07200061; /* Zeilen (valid) */
  private static final int      reqMsk = 0x00600001; /* Zeilen (req) */
  private static int            addMsk = 0x02000000; /* Zeilen (add) */
  private static String[]       reqNme = { /* Namen der req. Items */
    "UiD","Position","Direction"};
 /*-------------------------------------------------------------------*/
                            /* no definitions of instance-variables */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 -
  *        9 -
  *       10 -
  *       11 -
  *   12..23 - (not used)
  * Definition of 'Entry found' (stored in TSOpt):
  *        0 : UiD
  *        1 : Population
  *        2 : StartPosition
  *        3 : EndPosition
  *        4 : StartType
  *        5 : EndType
  *        6 : StartDirection
  *        7 : EndDirection
  *        8 : Config
  *        9 : Quality
  * 10 to 20 : not used
  *       21 : Position
  *       22 : Direction
  *       23 : not used
  *       24 : MaxVisDistance
  *       25 : VDbId
  *       26 : StaticDetailLevel
  * 27 to 31 : not used
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.00(S) - Definitionstatement of 'Population'
  *   0.01(S) - Definitionstatement of 'StartPosition'
  *   0.02(S) - Definitionstatement of 'EndPosition'
  *   0.03(S) - Entry not used
  *   0.04(S) - Definitionstatement of 'MaxVisDistance'
  *   0.05(S) - Definitionstatement of 'StartType'
  *   0.06(S) - Definitionstatement of 'EndType'
  *   0.07(S) - Definitionstatement of 'StartDirection'
  *   0.08(S) - Definitionstatement of 'EndDirection'
  *   0.09(S) - Definitionstatement of 'Quality'
  *   0.10(S) - Definitionstatement of 'Direction'
  *   1.00(I) - 'Config'-Number
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSTelep() /* 'World'-Definition (Telepole) erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSTelep( /* 'World'-Definition (Telepole) erstellen */
   int oid, /* aktuelle Object-ID */
   int sl)  /* StaticDetailLevel */
   {
    super(oid,14,sl); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSTelep (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   boolean c)  /* Kennzeichen setzen wenn Fehler und 'true' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 1): /* 'Population' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tPopulation (" + getDta(0) + ")";
      case( 2): /* 'StartPosition' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tStartPosition (" + getDta(1) + ")";
      case( 3): /* 'EndPosition' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tEndPosition (" + getDta(2) + ")";
      case( 4): /* 'StartType' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tStartType (" + getDta(5) + ")";
      case( 5): /* 'EndType' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tEndType (" + getDta(6) + ")";
      case( 6): /* 'StartDirection' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tStartDirection (" + getDta(7) + ")";
      case( 7): /* 'EndDirection' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tEndDirection (" + getDta(8) + ")";
      case( 8): /* 'Config' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tConfig (" + getDta(3) + ")";
      case( 9): /* 'Quality' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tQuality (" + getDta(9) + ")";
      case(22): /* 'Direction' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tDirection (" + getDta(10) + ")";
      case(24): /* 'MaxVisDistance' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return crDef(4,4); /* Ergebnis von Spezial-Version */
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me,c); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * ##getCtl.TSTelep (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSTelep (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSTelep (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "Telepole"; /* Objekt-Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mskAdd"
  * Information-Hiding: 'addMsk' maskieren:
  *  Additionsmaske gemaess Argument maskieren
  * Achtung: Methode ist statisch
  * ##mskAdd.TSTelep (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void mskAdd( /* Additions-Maske maskieren */
   int m) /* Maske zum maskieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    addMsk &= m; /* Additionsmaske maskieren */
    return; /* und zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSTelep (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 1): /* 'Population' */
        chgDta(0," "+TSLogg.getMsg("TSUidXE1","",u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Telepole("+u+")-Population";
      case( 2): /* 'StartPosition' */
        chgDta(1," "+TSLogg.getMsg("TSUidXE2","",u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Telepole("+u+")-StartPosition";
      case( 3): /* 'EndPosition' */
        chgDta(2," "+TSLogg.getMsg("TSUidXE3","",u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Telepole("+u+")-EndPosition";
      case( 4): /* 'StartType' */
        chgDta(5," "+TSLogg.getMsg("TSUidXE4","",u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Telepole("+u+")-StartType";
      case( 5): /* 'EndType' */
        chgDta(6," "+TSLogg.getMsg("TSUidXE5","",u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Telepole("+u+")-EndType";
      case( 6): /* 'StartDirection' */
        chgDta(7," "+TSLogg.getMsg("TSUidXE6","",u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Telepole("+u+")-StartDirection";
      case( 7): /* 'EndDirection' */
        chgDta(8," "+TSLogg.getMsg("TSUidXE7","",u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Telepole("+u+")-EndDirection";
      case( 8): /* 'Config' */
        chgDta(3," "+TSLogg.getMsg("TSUidXE8","",u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Telepole("+u+")-Config";
      case( 9): /* 'Quality' */
        chgDta(9," "+TSLogg.getMsg("TSUidXE9","",u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Telepole("+u+")-Quality";
      case(25): /* 'VDbId' */
        clrView(getVNrDef()); /* Default-Kennung ViewSphere setzen */
        return "Telepole("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "Telepole("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTelep (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return toStr(false) + ":<>}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSPickup -- Definition eines 'World'-Eintrags (Pickup)
 * ##TSPickup (Eyecatcher)
 *======================================================================
 </pre>*/
class TSPickup extends TSUiD { /* 'World'-Eintrags-Def. (Pickup) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 10.07.2008";
  private static final int      valMsk = 0x067B0001; /* Zeilen (valid) */
  private static final int      reqMsk = 0x0069001D; /* Zeilen (req) */
  private static int            addMsk = 0x02000000; /* Zeilen (add) */
  private static String[]       reqNme = { /* Namen der req. Items */
    "UiD","PickupType","PickupAnimData","PickupCapacity","TrItemId",
    "FileName","Position","QDirection"};
 /*-------------------------------------------------------------------*/
  private TSRefC                TrItm;  /* TrItem-Referenzen (Nr/Adr) */
  private String                Nme;    /* Dateiname des Objektes */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 -
  *        9 -
  *       10 -
  *       11 -
  *   12..23 - (not used)
  * Definition of 'Entry found' (stored in TSOpt):
  *        0 : UiD
  *        1 : SpeedRange
  *        2 : PickupType
  *        3 : PickupAnimData
  *        4 : PickupCapacity
  *  5 to 15 : not used
  *       16 : TrItemId
  *       17 : CollideFlag
  *       18 : not used
  *       19 : FileName
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  * 23 to 24 : not used
  *       25 : VDbId
  *       26 : StaticDetailLevel
  * 27 to 30 : not used
  *       31 : QDirection/Matrix3x3
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.00(S) - Definitionstatement of 'SpeedRange'
  *   0.01(S) - Entry not used
  *   0.02(S) - Definitionstatement of 'PickupType'
  *   0.03(S) - Definitionstatement of 'PickupAnimData'
  *   0.04(S) - Definitionstatement of 'PickupCapacity'
  *   1.xx(I) - (Queue) not used
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSPickup() /* 'World'-Definition (Pickup) erstellen */
   {
    super(); /* Basiswerte setzen ---RESTRIKTION--- */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    TrItm = null; /* noch keine TrItem-Referenz vorhanden */
//    Nme   = null; /* Objekt-Name noch nicht vorhanden */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSPickup( /* 'World'-Definition (Pickup) erstellen */
   int oid, /* aktuelle Object-ID */
   int sl)  /* StaticDetailLevel */
   {
    super(oid,15,sl); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    TrItm = null; /* noch keine TrItem-Referenz vorhanden */
    Nme   = null; /* Objekt-Name noch nicht vorhanden */
    setOpt(7);    /* Object-Type is member of 'MveObj'-set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addTrI"
  * neue TrItem-Referenz hinzufuegen
  * falls Maximum ueberschritten wird Anzahl der Aufrufe geliefert
  * ##addTrI.TSPickup (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int addTrI( /* neues TrItem hinzufuegen */
   int typ,  /* Typ des TrItems (Datenbank-Nummer) */
   int itnr) /* Nummer der TrItem-Referenz */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(typ!=0) return -2; /* nur Schienendatenbank erlaubt */
    if(TrItm!=null) return 1; /* zu viele Eintraege -- Anzahl zurueck */
    TrItm = new TSRefC(itnr); /* TrItem-Referenz eintragen */
    return 0; /* TrItem erfolgreich gespeichert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * neuen aktuellen Dateinamen liefern oder aendern
  * wenn w==null: liefern aktuellen Dateinamen (information-Hiding)
  * ##chgNme.TSPickup (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* Dateiname neu setzen */
   String w) /* neuen Dateinamen */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = Nme; /* alten Namen merken */
    if(w!=null) Nme = w; /* neuen Dateiname setzen (keine Kopie) */
    return s; /* alten Dateinamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTrI"
  * Referenz-Verkettung fuer 'TrItem' aendern
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##chgTrI.TSPickup (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC chgTrI( /* Referenzverkettung aendern und liefern */
   int    db, /* Nummer der Datenbank */
   int    ix, /* Index des Eintrags */
   TSRefC rf) /* neue Referenzverkettung oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC  cRef; /* aktuelles Definitionsobjekt */
   /*=================================================================*/
    if(db!=0) return null; /* Datenbank nicht erlaubt */
    if(ix!=0) return null; /* Fehler kein Element */
    cRef = TrItm; /* aktuelles Steuerobjekt merken */
    if(rf!=null) TrItm = rf; /* Steuerobjekt setzen/austauschen */
    return cRef; /* altes Referenzobjekt liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkTrItmT"
  * pruefen ob TrItemTyp zu aktuellem Objekt passt
  * Routine liefert 'true', wenn die Zuordnung NICHT passt
  * ##chkTrItmT.TSPickup (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkTrItmT( /* Objektzuordnung pruefen */
   int ItmT) /* TrItem-Typ (vgl TSTrItm) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return ItmT!=8; /* nur PickupItem erlaubt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSPickup (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   boolean c)  /* Kennzeichen setzen wenn Fehler und 'true' */
   {
   /*-----------------------------------------------------------------*/
    TSTrItm cIt; /* Arbeitswert */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 1): /* 'SpeedRange' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tSpeedRange (" + getDta(0) + ")";
      case( 2): /* 'PickupType' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tPickupType (" + getDta(2) + ")";
      case( 3): /* 'PickupAnimData' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tPickupAnimData (" + getDta(3) + ")";
      case( 4): /* 'PickupCapacity' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tPickupCapacity (" + getDta(4) + ")";
      case(16): /* 'TrItemId' */
        if(n>=((TrItm==null)?0:1)) return null; /* keine weitere Zeilen */
        cIt = (TSTrItm)TrItm.chgRef(null); /* TrItem-Referenz holen */
        if(cIt==null) { /* Fehler: Referenz nicht definiert */
          n = TrItm.chgNr(Integer.MIN_VALUE); /* Originalwert verwenden */
          if(c) { /* Kennzeichen einfuegen */
            if(me) return TSLogg.getMsg("TSUidDG1",getUiD(0));
            n = -1; /* Dummy-Wert benutzen */
          } else if(me) return TSLogg.getMsg("TSUidDG2",getUiD(0));
        } else n = cIt.getNr(false); /* Referenz-ID holen */
        return "\t\tTrItemId ( 0 " + n + " )";
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me,c); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndTrI"
  * Index der TrItem-Definition suchen
  * ACHTUNG: TrItem-Nummern duerfen NICHT DOPPELT auftreten
  * ##fndTrI.TSPickup (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int fndTrI( /* Index fuer TrItem-Definition suchen */
   int db, /* Nummer der Datenbank */
   int it) /* Wert der TrItem-Nummer */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(db!=0) return -4; /* Datenbank-Nummer stimmt nicht */
    if(TrItm==null) return -3; /* TrItem-Referenz nicht vorhanden */
    if(TrItm.chgNr(Integer.MIN_VALUE)==it) return 0; /* OK */
      /* Nummer gefunden -- Dummy-Index liefern */
    return -3; /* TrItem-Referenz nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$TrI"
  * Anzahl der definierten TrItem-Referenzen abfragen
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##get$TrI.TSPickup (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$TrI( /* Anzahl TrItem-Definition abfragen */
   int db) /* Nummer der Datenbank */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(db!=0) return -4; /* Datenbank-Nummer stimmt nicht */
    return (TrItm==null)?0:1; /* Anzahl der Definitionen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * ##getCtl.TSPickup (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSPickup (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSPickup (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "Pickup"; /* Objekt-Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mskAdd"
  * Information-Hiding: 'addMsk' maskieren:
  *  Additionsmaske gemaess Argument maskieren
  * Achtung: Methode ist statisch
  * ##mskAdd.TSPickup (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static void mskAdd( /* Additions-Maske maskieren */
   int m) /* Maske zum maskieren */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    addMsk &= m; /* Additionsmaske maskieren */
    return; /* und zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSPickup (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 1): /* 'SpeedRange' */
        chgDta(0," "+TSLogg.getMsg("TSUidXF1","",u,t)+" ");
          /* Defaultwert als neuen Wert eintragen */
        return "Pickup("+u+")-SpeedRange";
      case(25): /* 'VDbId' */
        clrView(getVNrDef()); /* Default-Kennung ViewSphere setzen */
        return "Pickup("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "Pickup("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSPickup (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = toStr(false) + ":'" + Nme + "',";
    if(TrItm==null) rs += "0[?]}";
      else rs += "1[" + TrItm.chgNr(Integer.MIN_VALUE) + "]}";
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSSnd -- Basic-Definition of a 'Sound'-Entry (common)
 * ##TSSnd (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSnd extends TSWrld { /* 'Sound'-Entry (common) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 25.09.2008";
 /*-------------------------------------------------------------------*/
  private int                   OID;    /* unambigous Object-ID */
  private int[]                 Uid;    /* some UiD-Versions
    * Versions of UID's: 0 - original, 1 - corrected, 2 - new */
  private int                   OT;     /* Object-Type of Entry */
  private int                   SL;     /* StaticDetailLevel */
  private int                   StF;    /* StaticFlags */
  private TSOpts                Opt;    /* Options (see below) */
  private TSPos                 Pos;    /* Position of Obj. within Quad */
  private TSQDir                Dir;    /* QDirection (Quaternion) */
  private TSView                VId;    /* ViewSphere-Reference */
  private int                   VNr;    /* ViewSphere-Number (Flag)
    * 'VNr' is only valid and used if 'VId' is NOT set ('VId==null') */
  private TSSnd                 nxt;    /* next entry with same UiD-val
    * This chain is required to find the proper UID-entry when searching
    * for an UID-entry which connects to a track/road-database-entry.
    * The uid-number in such an entry may be ambigous. When the
    * world-entry is eventually connected to the track/road-db-entry
    * this chain is no longer needed and may be corrupted. */
  private String                Nme;    /* Filename of Object */
  private TSWrld                Chn;    /* Conection to 'TSChain'-chain */
/**. <pre>
  * Used options (stored within field 'Opt'):
  *        0 - Entry is invalid ('Dummy-Entry') Do not handle nor write
  *        1 -
  *        2 -
  *        3 -
  *        4 -
  *        7 - Entry is member of 'MveObj'-set
  *  8 to 23 - Options depend from extended type-definition
  * 24 to 31 - temporary used options
  *       24 - moved to other quad -- do NOT renumber
  *       31 - Entry is already processed
  * Definition of mask 'valMsk' (extended objects):
  *  0 to 14 : not used
  *       15 : Position (Soundsource)
  *       16 : TrItemId
  *       17 : UiD (Soundregion)
  *       18 : not used
  *       19 : FileName
  *       20 : StaticFlags
  *       21 : Position
  *       22 : QDirection
  *       23 : Matrix3x3
  *       24 : not used
  *       25 : VDbId
  *       26 : StaticDetailLevel
  * 27 to 28 : not used
  *       29 : UiD (Soundsource)
  * 30 to 31 : not used
  * The bit-definitions of masks 'reqMsk' and 'addMsk' are similar to
  * this assignment. However, bit 1 to 14 are individually used and
  * bit 31 contains a summary-flag for 'QDirection' and 'Matrix3x3'.
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.xx(S) - (Queue) not used
  *   1.xx(I) - (Queue) not used
  * (Compare to sub-objects(object-class) for additional definitions)
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSnd() /* 'Sound'-Definition (Basis) erstellen */
   {
    super(); /* init 'TSWrld' (2 TSData-Arrays)(--- Restriktion ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    OID = -1;   /* Object-ID ist noch nicht gueltig */
    Uid = null; /* Speicher fuer UId's nicht belegt */
    OT  = -1;   /* Objekt-Typ ist nicht vergeben */
    SL  = -1;   /* Ungueltiger Defaultwert fuer 'StaticDetailLevel' */
//    StF = 0;    /* Defaultwert fuer 'StaticFlags' */
    VNr = -1;   /* Init: VS-Kennung nicht gesetzt */
//    VId = null; /* keine ViewSphere-Referenz */
    Opt = new TSOpts(); /* Optionenspeicher initialisieren */
//    nxt = null; /* keine weitere UiD mit gleichem Wert */
//    Chn = null; /* Initialisierung der TSChain-Kette */
//    Nme = null; /* Objekt-Name noch nicht vorhanden */
//    Pos = null; /* noch keine Positionsdefinition bekannt */
//    Dir = null; /* noch keine Richtungsdefinition bekannt */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSnd( /* neue 'Sound'-Definition (Basis) erstellen */
   int oid, /* aktuelle Object-ID */
   int ot,  /* Objekt-Typ-Kennung */
   int sl)  /* StaticDetailLevel */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    OID = oid; /* Objekt-ID eintragen */
    OT  = ot;  /* Objekt-Typ uebernehmen */
    SL  = sl;  /* aktueller DetailLevel uebertragen */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create copy-entry from template
  *=====================================================================
  </pre>*/
  protected TSSnd( /* neue 'Sound'-Definition (Basis) erstellen */
   TSSnd csnd, /* Datenvorlage */
   int   oid,  /* aktuelle Object-ID */
   int   sl)   /* StaticDetailLevel */
   {
    super(csnd); /* copy values from parent (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    OID = oid;      /* Objekt-ID eintragen */
    Uid = null;     /* Speicher fuer UId's nicht belegt */
    OT  = csnd.OT;  /* Objekt-Typ uebernehmen */
    SL  = sl;       /* aktueller DetailLevel uebertragen */
    StF = csnd.StF; /* 'StaticFlags' uebertragen */
    VNr = -1;       /* Init: VS-Kennung nicht gesetzt */
    VId = null;     /* keine ViewSphere-Referenz (geloescht?) */
    nxt = null;     /* keine weitere UiD mit gleichem Wert */
    Chn = null;     /* Initialisierung der TSChain-Kette */
    Opt = new TSOpts(csnd.Opt); /* init/copy Options */
    Nme = csnd.Nme; /* Objekt-Name aus Vorlage uebernehmen */
    Pos = csnd.Pos; /* Positionsobjekt aus Vorlage uebernehmen */
    Dir = csnd.Dir; /* Richtungsobjekt aus Vorlage uebernehmen */
    clrMsk(25); /* Bit 25 (VDbId) nicht uebernehmen */
//    VNr = csnd.VNr; /* VS-Kennung uebernehmen (falls gesetzt) */
//    VId = csnd.VId; /* ViewSphere-Referenz uebernehmen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "$reNew"
  * Objekt fuer den Wechsel des zugeordneten Quadranten vorbereiten
  *   Alle als 'eindeutig' geforderten Werte korrigieren
  * ##$reNew.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean $reNew( /* Basis der Objekt-Definition korrigieren */
   int oid, /* neue eindeutige Object-ID */
   int uid) /* neue Nutzerkennung */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Uid==null) return true; /* mit Fehler zurueck */
    OID = oid; /* Objekt-ID eintragen */
    Uid[0] = Uid[1] = Uid[2] = uid; /* neue UiD-Kennung eintragen */
    nxt = null; /* keine weitere UiD mit gleichem Wert */
    return false; /* Aktion erfolgreich */
  }

 /**. <pre>
  *=====================================================================
  * Methode "adjHgt"
  * Hoehenwert eines Knotens anpassen
  *   Ergebniswert muss nicht geprueft werden
  * ##adjHgt.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String adjHgt( /* Hoehenwert veraendern */
   double d) /* Korrekturwert der Hoehe */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return TSLogg.getKey("TSSndA01");
    Pos.addPosY(d); /* Hoehenwert korrigieren */
//    if((i=Pos.addPosY(d))!=0) return TSLogg.getMsg("TSSndA02",i);
    return null; /* Methode beenden -- kein Fehler */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chainUiD"
  * doppelte UID-Werte miteinander verketten
  * Der hier definierte Sound wird an des Ende der bei 'cSnd'
  *   begonnenen Kette angehaengt.
  * ##chainUiD.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chainUiD( /* UiD-Kennungen verketten */
   TSSnd cSnd) /* Index der Ende-UiD */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(cSnd==null) return true; /* Fehler -- Kette fehlt */
    if(nxt!=null) return true; /* Fehler -- Kette schon da */
    while(cSnd.nxt!=null) cSnd = cSnd.nxt; /* Verkettung verfolgen */
    cSnd.nxt = this; /* Neuen Eintrag anketten */
    return false; /* Daten erfolgreich gesetzt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgChn"
  * Verkettungswert 'Chn' pflegen (eintragen/aendern oder liefern)
  * Methode wird zur Verwaltung einer 'TSChain'-Kette benutzt
  * ACHTUNG: Obwohl in Wirklichkeit mit Sound-Objekten gearbeitet wird,
  *          werden diese ueber die Superklasse 'TSWrld' adressiert.
  * ##chgChn.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSWrld chgChn( /* sortierte Sound-Kette pflegen */
   TSWrld cS) /* neuerer Sound-Wert oder 'this' */
   {
   /*-----------------------------------------------------------------*/
    TSWrld cSnd; /* aktuelle Sound-Referenz */
   /*=================================================================*/
    cSnd = Chn; /* aktuellen Wert sichern */
    if(cS!=this) Chn = cS; /* neue Sound-Referenz eintragen */
    return cSnd; /* alten/aktuellen Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * neuen aktuellen Dateinamen liefern oder aendern
  * wenn w==null: liefern aktuellen Dateinamen (information-Hiding)
  * ##chgNme.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* Dateiname neu setzen */
   String w) /* neuen Dateinamen */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = Nme; /* alten Namen merken */
    if(w!=null) Nme = w; /* neuen Dateiname setzen (keine Kopie) */
    return s; /* alten Dateinamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgView"
  * Aktuelle ViewSphere Referenz eintragen/aendern oder liefern
  * ##chgView.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSView chgView( /* ViewSphere-Referenz bearbeiten */
   TSView nVS) /* neue ViewSphere-Referenz */
   {
   /*-----------------------------------------------------------------*/
    TSView cVS; /* aktuelle ViewShere-referenz */
   /*=================================================================*/
    cVS = VId; /* aktuelle ViewShere sichern */
    if(nVS!=null) VId = nVS; /* neue ViewSphere-Referenz eintragen */
    return cVS; /* alten/aktuellen Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkSL"
  * Check mask using current 'StaticDetailLevel'
  * ##chkSL.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkSL( /* check value with 'StaticDetailLevel' */
   TSOpts cM) /* Mask to be checked */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return cM.chkMsk(SL); /* test mask and return */
  }

 /**. <pre>
  *=====================================================================
  * Methode "clrOpt"
  * Option aus den Gesamt-Optionen herausloeschen
  * liefert den Status der Option VOR dem Loeschen
  * ##clrOpt.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean clrOpt( /* Optionenwert anpassen */
   int nr) /* Nummer der Option */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Opt.clrMsk(nr); /* Aktion delegieren */
  }

 /**. <pre>
  *=====================================================================
  * Methode "clrView"
  * Aktuelle ViewSphere Referenz loeschen und durch Viewsphere-Kennung
  *   ersetzen. Alte Viewsphere Referenz liefern
  * ##clrView.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSView clrView( /* ViewSphere-Referenz deaktivieren */
   int w) /* Kennung der Viewsphere (0..15) */
   {
   /*-----------------------------------------------------------------*/
    TSView cVS; /* aktuelle ViewShere-referenz */
   /*=================================================================*/
    if(w<0 || w>15) w = 15; /* Default fuer ungueltigen Wert */
    cVS = VId;  /* aktuelle ViewShere sichern */
    VId = null; /* aktuelle ViewSphere-Referenz loeschen */
    VNr = w;    /* Viewsphere-Kennung setzen */
    return cVS; /* alten/aktuellen Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef" (Version 1)
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * Version fuer ALLE GEMEINSAMEN Definitionen
  * ##crDef.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me) /* ggf. Meldung liefern wenn 'true' */
   {
   /*-----------------------------------------------------------------*/
    long     l;   /* Zwischenwert fuer VDbId */
    String   is;  /* Zwischenwert */
   /*=================================================================*/
    if(n>0) return null; /* keine weitere Zeile mehr */
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(19): /* 'FileName' */
        is = chgNme(null); /* Dateiname holen */
        if(is==null) { /* Fehler: Dateiname nicht vorhanden */
          if(me) return TSLogg.getMsg("TSSndD01",getUiD(0));
          is = ""; /* Dummy-Wert benutzen */
        } /* File-Name ist OK */
        return "\t\tFileName ( " + TSUtil.modStr(is) + " )";
      case(20): /* 'StaticFlags' */
        return "\t\tStaticFlags ( " + TSUtil.toHex(StF,8) + " )";
      case(21): /* 'Position' */
        if(Pos!=null)  /* Positionsreferenz vorhanden  -- nutzen */
          return "\t\tPosition (" + Pos.getPos(6,1) + " )";
        if(me) return TSLogg.getMsg("TSSndD02",getUiD(0));
        return "\t\tPosition ( 0.0 0.0 0.0 )"; /* Stmt erzeugen */
      case(22): /* 'QDirection' */
        if(Dir!=null)  /* Directionreferenz vorhanden  -- nutzen */
          return "\t\tQDirection (" + Dir.getDir(9) + " )"; /* Stmt erzeugen */
        if(me) return TSLogg.getMsg("TSSndD03",getUiD(0));
        return "\t\tQDirection ( 0 0 0 1 )"; /* Stmt erzeugen */
      case(25): /* 'VDbId' */
        if(VId!=null) l = VId.getId(); /* aktuelle ID holen */
        else if(VNr>=0) l = TSUtil.NoVS + VNr; /* ID-Kennung */
        else { /* ID ist nicht bekannt */
          if(me) return TSLogg.getKey("TSSndD04");
          l = 4294967295L; /* Dummy-Wert benutzen */
        } /* VDbId ist OK */
        return "\t\tVDbId ( " + l + " )";  /* Stmt erzeugen */
      case(26): /* 'StaticDetailLevel' */
        return "\t\tStaticDetailLevel ( " + SL + " )"; /* Stmt erzeugen */
      default: /* Fehlerhafte Definition kennzeichnen */
        if(me) return TSLogg.getMsg("TSSndD09",getName(OT),t);
        return "\t\t";  /* Stmt erzeugen */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef" (Version 2)
  * Dummy-Definition mit Zusatzwert
  * Version fuer ALLE GEMEINSAMEN Definitionen
  * ##crDef.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   int     z)  /* Zusatzwert fuer Ausgabe */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return crDef(t,n,me); /* allgeine Funktion benutzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crPos"
  * Information-Hiding: Positionswerte als TSPos-Objekt liefern
  * Achtung: Es wird eine (shallow-)Kopie geliefert, sodass die Attribute
  *          dieses Objektes (testweise) modifiziert werden koennen,
  *          ohne das Basisobjekt zu beeinflussen
  * ##crPos.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSPos crPos() /* Positionswerte als Vector liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return null; /* Kennung falls nicht vorhanden */
    return new TSPos(Pos); /* neues Objekt liefern (Kopie) */
  }

 /**. <pre>
  *=====================================================================
  * Method "getCtl" (This dummy-method is normally overlayed)
  * ##getCtl.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl(int i) { return (i<0) ? -1 : 0; }

 /**. <pre>
  *=====================================================================
  * Method "getItem" (This dummy-method is normally overlayed)
  * ##getItem.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem(int i) { return null; }


 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * Diese Methode wird benutzt wenn in der abgeleiteten Klasse
  *  keine Methode 'getName()' definiert ist. Da dies (normalerweise)
  *  nicht der Fall ist, wird diese Methode nur fuer Objekte der
  *  Basisklasse verwendet. Diese haben keinen Namen.
  * ##getName.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return getName(OT); /* Objekt-Typ gemaess gespeicherter Typ-Nr */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName" (statisch)
  * liefern der Bezeichnung eines Objekt-Typs
  * ##getName.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static String getName( /* Name eines Objekt-Typs liefern */
   int ot) /* gefordertes Objekt-Typ */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(ot) { /* gemaess Typ verzweigen */
      case( 0): return "Soundregion"; /* Bezeichnung liefern */
      case( 1): return "Soundsource"; /* Bezeichnung liefern */
      default: return "<unknown>"; /* Objekt-Typ nicht bekannt */
    } /* Ende switch-Statement */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getOpt"
  * Gesamt-Optionen maskiert liefern
  * Maske '-1' (=0xFFFFFFFF) liefert ALLE Optionen
  * Die gespeicherte Maske wird NICHT veraendert
  * ##getOpt.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getOpt( /* Optionenwerte maskiert liefern */
   int m) /* Maske der geforderten Optionen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Opt.getMsk(m); /* Aktion delegieren */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTyp"
  * Information-Hiding: Objekt-Typ liefern
  * ##getTyp.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getTyp() /* Objekt-Typ liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return OT; /* aktuelles Ergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getUiD"
  * Information-Hiding: aktuelle UID gemaess UiD-Typ liefern
  * ##getUiD.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getUiD( /* UID-Definition liefern */
   int t) /* typ der geforderten UiD */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* Rueckgabewert '-1' wird fuer 'nicht belegte UiD' benutzt */
    if(Uid==null) return -2; /* Speicher existiert noch nicht */
    if(t<0 || t>2) return -3; /* Index ausserhalb */
    return Uid[t]; /* aktuelles Ergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isBefore"
  * Methode zum sortieren der Sound-Eintraege
  * Diese Methode wird durch 'TSChain' benutzt und gefordert
  * ##isBefore.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isBefore( /* UiD-Def's vergleichen fuer Sort */
   TSWrld vO)  /* Vergleichsobjekt */
   {
   /*-----------------------------------------------------------------*/
    TSSnd vW; /* intermediate value */
   /*=================================================================*/
    if(!(vO instanceof TSSnd)) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg902","isBefore",1,3));
    vW = (TSSnd)vO; /* Objekt anpassen */
    if(SL<vW.SL) return true; /* kleiner - davor */
    if(SL>vW.SL) return false;  /* groesser - hinter */
    /* StaticDetailLevel ist gleich -- nach OID sortieren. Watermark
     * ist erster Eintrag und wird durch OID==0 gekennzeichnet.
     * OID==0 tritt NUR bei solchen Eintraegen auf. */
    if(OID<vW.OID) return true; /* kleiner - davor */
    if(OID>vW.OID) return false;  /* groesser - hinter */
    throw new /* gleicher Eintrag nicht erlaubt -- Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg903","isBefore",2));
  }

 /**. <pre>
  *=====================================================================
  * Methode "isEqual"
  * Methode zum pruefen der Sound-Eintraege auf Gleichheit
  * Diese Methode wird durch 'TSChain' benutzt und gefordert
  * ##isEqual.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isEqual( /* UiD-Def's vergleichen fuer Sort */
   TSWrld vO)  /* Vergleichsobjekt */
   {
   /*-----------------------------------------------------------------*/
    TSSnd vW; /* intermediate value */
   /*=================================================================*/
    if(!(vO instanceof TSSnd)) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg902","equals",1,3));
    vW = (TSSnd)vO; /* Objekt anpassen */
    if(SL!=vW.SL) return false; /* nicht gleich - melden*/
    /* StaticDetailLevel ist gleich -- Objekt-ID? */
    return OID==vW.OID; /* melden ob Eintraege identisch sind */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isOpt"
  * Pruefung ob Option aktiviert
  * Methode liefert 'true' wenn das Optionenbit gesetzt ist
  * ##isOpt.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isOpt( /* Optionenwert auf Option pruefen */
   int nr) /* Nummer der Option */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Opt.chkMsk(nr); /* Methode delegieren */
  }

 /**. <pre>
  *=====================================================================
  * Methode "nxtUiD"
  * UID-Wert(orginal) mit Maximalwert neu setzen und korrigieren
  * Routine arbeitet auf 'Uid[1]', 'Uid[2]'
  * ##nxtUiD.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int nxtUiD( /* UiD-Kennung neu setzen */
   TSQuad cQ) /* aktuelle Quadrat-Definition */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(cQ==null) return -1; /* Fehler */
    if(Uid==null) return -2; /* Speicher existiert noch nicht */
    Uid[1] = Uid[2] = cQ.getSId(); /* korrigierte UiD-Kng. setzen */
    return Uid[1]; /* Kennung auch liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "renUiD"
  * UID-Wert(neu) mit neu erstellter UiD-Kennung setzen
  * Routine arbeitet auf 'Uid2'
  * Wenn 'nr' negativ ist, wird 'nr' unveraendert zurueckgegeben und
  *   die UiD nicht veraendert
  * Routine arbeitet auf 'Uid[2]'
  * ##renUiD.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int renUiD( /* UiD-Kennung neu numerieren */
   int nr) /* neue zu vergebene UiD-Kennung */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(clrOpt(24)) return nr; /* Option WAR gesetzt -- Ende */
      /* Option muss auf jeden Fall zurueckgesetzt werden */
    if(nr<0) return nr; /* UiD nicht neu vergeben! */
    if(Uid==null) return nr; /* Speicher existiert noch nicht */
    Uid[2] = nr; /* neue UiD-Kennung setzen */
    nr += 1; /* UiD-Kennung ist vergeben */
    return nr; /* naechster moeglicher Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "resOpt"
  * Option(en) aus den Gesamt-Optionen loeschen
  * Methode liefert eine Maske der zurueckgesetzten Optionen
  * ##resOpt.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int resOpt( /* Optionenwert zuruecksetzen */
   int m) /* Maske der geforderten Optionen (bit==1 -> zuruecksetzen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Opt.resMsk(m); /* Aktion delegieren */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setOpt"
  * Option den Gesamt-Optionen hinzufuegen
  * liefert den Status der Option VOR dem setzen
  * ##setOpt.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean setOpt( /* Optionenwert anpassen */
   int nr) /* Nummer der Option */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Opt.setMsk(nr); /* Aktion delegieren */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setOT" (statisch)
  * Objekt-Typ pruefen und liefern
  * Wird ausschliesslich in 'chgSnd()' benutzt!
  * ##setOT.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int setOT( /* Subtyp-Kennung pruefen */
   String kw) /* Name des Objekt-Typs */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(kw==null) return -2; /* Ungueltiges Schluesselwort */
    if(kw.equals("soundregion")) return 0; /* Typ-Kennung liefern */
    if(kw.equals("soundsource")) return 1; /* Typ-Kennung liefern */
    return -1; /* Kennung fuer unbekannten Objekt-Typ */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setPos"
  * Positionsobjekt speichern
  * ##setPos.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSPos setPos( /* Positionsobjekt speichern */
   TSPos cP) /* neues Positionsobjekt */
   {
   /*-----------------------------------------------------------------*/
    TSPos cPos; /* Original-Wert */
   /*=================================================================*/
    if(cP instanceof TSQPos) throw new /* Abbruch mit Systemfehler */
      IllegalArgumentException(TSLogg.getMsg("Msg901","setPos()","Q",1));
    cPos = Pos; /* Originalwert sichern falls vorhanden */
    Pos = cP; /* neue Position uebertragen */
    return cPos; /* Methode beenden (Originalwert liefern) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setQDir"
  * Richtungsdefinition eines Objektes speichern
  * ##setQDir.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQDir setQDir( /* Richtungswerte speichern */
   TSQDir cD) /* neues Quaternion-Objekt */
   {
   /*-----------------------------------------------------------------*/
    TSQDir cDir; /* Original-Wert */
   /*=================================================================*/
    cDir = Dir; /* Originalwert sichern falls vorhanden */
    Dir = cD; /* neues Quaternion uebertragen */
    return cDir; /* Methode beenden (Originalwert liefern) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setSL"
  * Set new value for 'StaticDetailLevel'
  * Value is chandes in every case and OLD one is returned.
  * Value can be ONLY resumed if used twice: 'setSL(x=setSL(0));'
  * Attention: This method marks 'StaticDetailLevel' as 'set explicitely'
  * Attention: New value may be modified to match the allowed range.
  * ##setSL.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int setSL( /* Set new value for 'StaticDetailLevel' */
   int w) /* new value for 'StaticDetailLevel */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i  = SL; /* save return/old value */
    if(w<0) w = 0; /* correct range of value */
    if(w>10) w = 10; /* correct range of value */
    SL = w;  /* and insert new one */
    setMsk(26); /* new value is explicitely set */
    return i; /* return old value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setStF"
  * Set new value for 'StaticFlags'
  * Value can be resumed if used twice: 'setStF(x=setStF(0));'
  * ##setStF.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int setStF( /* set new value of 'StaticFlags' */
   int w) /* new value for 'StaticFlags' */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i  = StF; /* save return/old value */
    StF = w; /* and insert new one */
    return i; /* return old value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setUiD"
  * aktuelle UID initialisieren und eintragen
  * Achtung: Eine einmal eingetragene UiD kann hiermit NICHT mehr
  *          ueberschrieben werden
  * Achtung: UiD-Kennzeichen ist BEREITS eingetragen
  * ##setUiD.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int setUiD( /* UID-Definition initialisieren */
   int uid, /* Nummer der neuen UiD */
   int kng) /* Nummer der Kennung der neuen UiD */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Uid!=null) return Uid[0]; /* UiD-Kennung bereits gesetzt */
    Uid = new int[3]; /* Speicher fuer UiD's holen */
    Uid[0] = Uid[1] = Uid[2] = uid; /* UiD-Kennung eintragen */
    setMsk(kng); /* kennzeichnen dass 'UiD' eingetragen wurde */
    return -1; /* UiD erfolgreich erstellt */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return toStr(true); /* Ergebnis zurueckgeben */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSnd (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr( /* Create String-version of values */
   boolean term) /* Angaben terminieren ? */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = "TSSnd{" + OID; /* Anfang setzen */
    if(Uid==null) rs += ",<null>"; /* UiD nicht vorhanden */
    else rs += "," + Uid[0] + "(" + Uid[1] + "," + Uid[2] + ")";
    rs += "-'"+ Nme + "'-" + TSUtil.toHex(StF,-8) +
          "-" + TSUtil.toHex(Opt.getMsk(-1),-8) + "-(";
    if(Pos!=null) rs += Pos.getPos(true); /* Werte aufbereiten */
    else rs += "<null>"; /* sonst Kennung einfuegen */
    rs += ")-("; /* Zwischenteil setzen */
    if(Dir!=null) rs += Dir.getDir(true); /* Werte aufbereiten */
    else rs += "<null>"; /* sonst Kennung einfuegen */
    rs += ")-("; /* Zwischenteil setzen */
    if(VId!=null) rs += "OK"; else rs += "<null>";
    rs += "/" + VNr + ")-"; /* Zwischenteil */
    rs += super.toStr(); /* Werte aus 'TSWrld' hinzufuegen */
    rs += "-" + SL + "-" + OT;
    if(term) rs += "}"; /* Abschluss setzen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSSRgn -- Definition eines 'Sound'-Eintrags (Soundregion)
 * ##TSSRgn (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSRgn extends TSSnd { /* 'Sound'-Eintrag: SoundRegion */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 20.06.2008";
  private static final int      valMsk = 0x067B0000; /* Zeilen (valid) */
  private static final int      reqMsk = 0x006B0006; /* Zeilen (req) */
  private static int            addMsk = 0x06000000; /* Zeilen (add) */
  private static String[]       reqNme = { /* Namen der req. Items */
    "SoundRegionRoty","SoundregionTrackType","TrItemId","UiD",
    "FileName","Position","QDirection"};
 /*-------------------------------------------------------------------*/
  private int                   Type;   /* Typ-Nummer Soundregion */
  private TStType               TRef;   /* Referenz zu Typ-Eintrag */
  private ArrayList<TSRefC>     TrItm;  /* Tabelle der TrItems (Nr/Adr) */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 -
  *        9 -
  *       10 -
  *       11 -
  *   12..23 - (not used)
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.00(S) - Definitionstatement of 'SoundregionRoty'
  *   1.xx(I) - (Queue) not used
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSRgn() /* 'Sound'-Definition (SoundRegion) erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Type  = -1;   /* noch kein Soundregionstyp zugeordnet */
//    TRef  = null; /* keine Referenz zu ttype-Eintrag erstellt */
//    TrItm = null; /* noch keine TrItem-Referenzen moeglich */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSRgn( /* 'Sound'-Definition (SoundRegion) erstellen */
   int    oid,  /* aktuelle Object-ID */
   int    sl)   /* StaticDetailLevel */
   {
    super(oid,0,sl); /* Basiswerte setzen (---RESTRIKTION---) */
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    Type  = -1;   /* noch kein Soundregionstyp zugeordnet */
    TRef  = null; /* keine Referenz zu ttype-Eintrag erstellt */
    TrItm = new ArrayList<TSRefC>(); /* TrItem-Referenz Tabelle (leer) */
    setOpt(7); /* Object-Type is member of 'MveObj'-set */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addTrI"
  * neue TrItem-Referenz hinzufuegen
  * falls Maximum ueberschritten wird Anzahl der Aufrufe geliefert
  * ##addTrI.TSSRgn (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int addTrI( /* neues TrItem hinzufuegen */
   int typ,  /* Typ des TrItems (Datenbank-Nummer) */
   int itnr) /* Nummer der TrItem-Referenz */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(typ!=0) return -2; /* nur Schienendatenbank erlaubt */
    if(TrItm==null) return -3; /* Referenzspeicher nicht angelegt */
    TrItm.add(new TSRefC(itnr)); /* TrItem-Referenz hinzufuegen */
//    return TrItm.size()-1; /* TrItem erfolgreich gespeichert */
    return 0; /* TrItem erfolgreich gespeichert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTRef"
  * Referenz auf ttype-Element (TStType) veraendern oder abfragen
  * ACHTUNG: Wert nicht setzen wenn 'r==null'
  * ##chgTRef.TSSRgn (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TStType chgTRef( /* ttype-Referenz pflegen */
   TStType r) /* neue Referenz zu ttype-Eintrag */
   {
   /*-----------------------------------------------------------------*/
    TStType v; /* intermediate value */
   /*=================================================================*/
    v  = TRef; /* alte Referenz merken */
    if(r!=null) TRef = r; /* neue Referenz setzen */
    return v; /* alte Referenz liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTrI"
  * Referenz-Verkettung fuer 'TrItem' aendern
  * Achtung: Anzahl/Typ der Argumente wird durch TSUID bedingt!
  * ##chgTrI.TSSRgn (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRefC chgTrI( /* Referenzverkettung aendern und liefern */
   int    db, /* Nummer der Datenbank */
   int    ix, /* Index des Eintrags */
   TSRefC rf) /* neue Referenzverkettung oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC  cRef; /* aktuelles Definitionsobjekt */
   /*=================================================================*/
    if(TrItm==null) return null; /* Daten nicht gefuellt */
    if(db!=0) return null; /* Datenbank nicht erlaubt */
    if(ix<0 || ix>=TrItm.size()) return null; /* Fehler kein Element */
    if(rf==null) cRef = TrItm.get(ix); /* Steuerobjekt holen */
    else cRef = TrItm.set(ix,rf); /* Steuerobjekt austauschen */
    return cRef; /* altes Referenzobjekt liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgType"
  * Nummer des ttype-Elementes veraendern oder abfragen
  * ACHTUNG: Wert nicht setzen wenn 'r<0'
  * ##chgType.TSSRgn (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int chgType( /* Nummer ttype-Element bearbeiten */
   int r) /* neue Referenz zu ttype-Eintrag */
   {
   /*-----------------------------------------------------------------*/
    int v; /* intermediate value */
   /*=================================================================*/
    v  = Type; /* alte Referenz merken */
    if(r>=0) Type = r; /* neue Referenz setzen */
    return v; /* alte Referenz liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkTrItmT"
  * pruefen ob TrItemTyp zu aktuellem Objekt passt
  * Routine liefert 'true', wenn die Zuordnung NICHT passt
  * ##chkTrItmT.TSSRgn (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkTrItmT( /* Objektzuordnung pruefen */
   int ItmT) /* TrItem-Typ (vgl TSTrItm) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return ItmT!=9; /* nur SoundRegionItem erlaubt */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSSRgn (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   int     z)  /* Zusatzwert fuer Ausgabe */
   {
   /*-----------------------------------------------------------------*/
    int     i;   /* intermediate value */
    TSRefC  cRf; /* Aktueller Referenzeintrag (Arbeitswert) */
    TSTrItm cIt; /* Arbeitswert */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case( 1): /* 'SoundregionRoty' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tSoundregionRoty (" + getDta(0) + ")";
      case( 2): /* 'SoundregionTrackType' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        i = Type; /* vorbesetzen: Originalwert verwenden */
        if(TRef==null) { /* Fehler: ttype-Referenz nicht definiert */
          if(me) return TSLogg.getMsg("TSSndD12",getUiD(0));
        } else i = TRef.chgNr(-1); /* ttype-Referenz holen */
        return "\t\tSoundregionTrackType ( " + i + " )";
      case(16): /* 'TrItemId' */
        if(TrItm==null) /* Referenzspeicher nicht angelegt */
          if(me) return TSLogg.getMsg("TSSndD13",getUiD(0));
          else return null; /* keine weiteren Ausgaben */
        if(n>=TrItm.size()) return null; /* keine weitere Zeile */
        cRf = TrItm.get(n); /* zutreffender Referenzeintrag */
        if((cIt=(TSTrItm)cRf.chgRef(null))==null) { /* Fehler: Referenz fehlt */
          if(me) return TSLogg.getMsg("TSSndD11",getUiD(0));
          i = cRf.chgNr(Integer.MIN_VALUE); /* Originalwert verwenden */
        } else i = cIt.getNr(false); /* Referenz-ID holen */
        return "\t\tTrItemId ( 0 " + i + " )";
      case(17): /* 'UiD' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tUiD ( " + getUiD(z) + " )"; /* UiD-Definition */
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndTrI"
  * Index der TrItem-Definition suchen
  * ACHTUNG: TrItem-Nummern duerfen NICHT DOPPELT auftreten
  * ##fndTrI.TSSRgn (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int fndTrI( /* Index fuer TrItem-Definition suchen */
   int db, /* Nummer der Datenbank */
   int it) /* Wert der TrItem-Nummer */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    if(TrItm==null) return -2; /* Speicher existiert noch nicht */
    if(db!=0) return -4; /* Datenbank-Nummer stimmt nicht */
    for(i=0;i<TrItm.size();i+=1) /* TrItem-Nummer suchen */
      if(TrItm.get(i).chgNr(Integer.MIN_VALUE)==it) return i;
        /* Nummer gefunden -- Index liefern */
    return -3; /* TrItem-Referenz nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$TrI"
  * Anzahl der definierten TrItem-Referenzen abfragen
  * Achtung: Anzahl/Typ der Argumente wird durch TSSnd bedingt!
  * ##get$TrI.TSSRgn (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$TrI( /* Anzahl TrItem-Definition abfragen */
   int db) /* Nummer der Datenbank */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(TrItm==null) return -2; /* Tabelle existiert (noch) nicht */
    if(db!=0) return -4; /* Datenbank-Nummer stimmt nicht */
    return TrItm.size(); /* Anzahl der Definitionen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * ##getCtl.TSSRgn (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSSRgn (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSSRgn (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "Soundregion"; /* Objekt-Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSSRgn (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(25): /* 'VDbId' */
        clrView(getVNrDef()); /* Default-Kennung ViewSphere setzen */
        return "Soundregion("+u+")-VDbId";
      case(26): /* 'StaticDetailLevel' */
        return "Soundregion("+u+")-StaticDetailLevel";
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSRgn (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs;  /* result-string */
    int    i,j; /* intermediate value */
   /*=================================================================*/
    rs = toStr(false) + ":";
    if(TrItm!=null) { /* Datenspeicher ist vorhanden */
      rs += TrItm.size() + "[";
      for(i=0;i<TrItm.size();i+=1) { /* alle definierten Elemente */
        if(i>0) rs += ","; /* Trennzeichen einfuegen */
        rs += TrItm.get(i).chgNr(Integer.MIN_VALUE); /* Nr. hinzu */
      } /* alle Referenzen */
    } else rs += "?["; /* Kennung -- kein Datenspeicher */
    rs += "]}"; /* Abschluss setzen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSSSrc -- Definition eines 'Sound'-Eintrags (Soundsource)
 * ##TSSSrc (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSSrc extends TSSnd { /* 'Sound'-Eintrag: Soundsource */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.3.01 05.11.2006";
  private static final int      valMsk = 0x20280000; /* Zeilen (valid) */
  private static final int      reqMsk = 0x20088000; /* Zeilen (req) */
  private static int            addMsk = 0x00000000; /* Zeilen (add) */
  private static String[]       reqNme = { /* Namen der req. Items */
    "Position","FileName","UiD"};
 /*-------------------------------------------------------------------*/
                            /* no definitions of instance-variables */
/**. <pre>
  * Used options (stored within field 'Opt' of super-class):
  *        8 - Position-error: X-value to small
  *        9 - Position-error: X-value to large
  *       10 - Position-error: Z-value to small
  *       11 - Position-error: Z-value to large
  *       12 -
  *   13..23 - (not used)
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.xx(S) - (Queue) not used
  *   1.xx(I) - (Queue) not used
  *=====================================================================
  * Constructor: (1) Default/Standard-Eintrag erstellen
  *=====================================================================
  </pre>*/
  protected TSSSrc() /* 'Sound'-Definition (Soundsource) erstellen */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSSrc( /* 'Sound'-Definition (Soundsource) erstellen */
   int oid, /* aktuelle Object-ID */
   int sl)  /* StaticDetailLevel */
   {
    super(oid,1,sl); /* Basiswerte setzen (---RESTRIKTION---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSSSrc (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     t,  /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me, /* ggf. Meldung liefern wenn 'true' */
   int     z)  /* Zusatzwert fuer Ausgabe */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      case(15): return super.crDef(21,n,me); /* Position (spezial) */
      case(29): /* 'UiD' */
        if(n>0) return null; /* keine weitere Zeile mehr */
        return "\t\tUiD ( " + getUiD(z) + " )"; /* UiD-Definition */
      default: /* alle anderen: gemeinsame Version versuchen */
        return super.crDef(t,n,me); /* Ergebnis von Superklasse */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCtl"
  * Information-Hiding: Liefern eines Kontroll-Ausdrucks gemaess
  *                     Kennnummer
  * 0 : 'reqMsk' - Maske der geforderten Schluesselwoerter
  * 1 : 'valMsk' - Maske der gueltigen Schluesselwoerter
  * 2 : Differenz-Maske zu 'addMsk' liefern
  * ##getCtl.TSSSrc (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCtl( /* Kontroll-Ausdruck evaluieren und liefern */
   int nr) /* Kenn-Nummer des Kontroll-Ausdrucks */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(nr) { /* gemaess Kenn-Nummer verzweigen */
      case( 0): return reqMsk; /* Maske liefern */
      case( 1): return valMsk; /* Maske liefern */
      case( 2): return tstMsk(addMsk); /* aktuelle Differenz-Maske */
      default: if(nr>=0) return 0; /* Default fuer ungueltigen Wert */
    } /* Verzweigung durchgefuehrt */
    return -1; /* default fuer ungueltigen negativen Wert */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getItem"
  * Information-Hiding: aktuellen 'reqNme' liefern
  * ##getItem.TSSSrc (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getItem( /* 'reqNme' gemaess Kennung liefern */
   int nr) /* Kennung des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0 || nr>=reqNme.length) return null; /* kein Ergebnis */
    return reqNme[nr]; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * liefern der Bezeichnung des Objekt-Typs
  * ##getName.TSSSrc (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* Name des Objekt-Typs liefern */
   boolean org) /* Bezeichnung unmodifiziert liefern (true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "Soundsource"; /* Objekt-Name liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDef"
  * Default-Definitionen hinzufuegen
  * ##setDef.TSSSrc (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setDef( /* Default-Definitionen hinzufuegen */
   int t, /* Kennung des Ausgabe-Type (gemaess 'setMsk') */
   int u) /* ID-Nummer (UID) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    switch(t) { /* verzweigen gemaess Typ-Kennung */
      default: return null; /* Fehlerkennung liefern */
        /* alle anderen: Definitionen NICHT hinzufuegbar */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSSrc (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return toStr(false) + ":()}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSView -- Definition eines 'ViewSphere'-Eintrags
 * ##TSView (Eyecatcher)
 *======================================================================
 </pre>*/
class TSView implements Serializable { /* Def. of 'ViewSphere'-entry */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.3.04 26.02.2007";
 /*-------------------------------------------------------------------*/
  private int                   Id;     /* Kennung des Eintrags */
  private int                   Cnt;    /* Zaehler fuer Nutzung */
  private ArrayList<TSView>     Chld;   /* Abhaengige TSView-Defs */
  private TSView                Parnt;  /* Vatereintrag (falls vorh.) */
  private TSView                cpyR;   /* Kopier-Referenz */
  private TSPos                 Pos;    /* Position of TSV-Element */
  private double                R;      /* Radius */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSView() /* create 'ViewSphere'-Definition (Basis) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Id    = -1;   /* No viewSphere-ID assigned */
    Chld  = null; /* No list of dependent viewSphere-entries. The
       * list is created, when the first element should be added
       * to this list. */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSView( /* create 'ViewSphere'-Definition */
   int id) /* new viewSphere-ID */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Id = id; /* store viewsphere-ID */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create copy-entry from template
  *=====================================================================
  </pre>*/
  protected TSView( /* 'ViewSphere'-Definition erstellen (Kopie) */
   TSView cVS) /* Datenvorlage */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* NUR Datenwerte und KEINE Steuerwerte uebernehmen */
    R   = cVS.R;   /* Datenwert aus Vorlage uebernehmen */
    Pos = new TSPos(cVS.Pos); /* Positionsobjekt aus Vorlage setzen */
  }

 /**. <pre>
  *=====================================================================
  * Method "prtView" (test)
  * Method is used for understanding function of 'viewsphere'
  * ##prtView.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected void prtView(ArrayList<String> ETab)
   {
   /*-----------------------------------------------------------------*/
    Iterator<TSView> cI;  /* allgemeiner Tabellen-Iterator */
    TSView           cVS; /* aktuelle TSView-Definition */
    String           msg;
    double           d;
   /*=================================================================*/
    if(Parnt!=null) { /* print difference */
      msg = "VDbId(" + Id + "), Pos=(" + Pos.getPos(true)+ "), R="+R;
      ETab.add(msg); /* add next Message to list */
      msg = "    VDbId(" + Parnt.Id + "), Pos=(" +
            Parnt.Pos.getPos(true) + "), R="+Parnt.R;
      ETab.add(msg); /* add next Message to list */
      d = Parnt.Pos.cmpAbs(Pos,0,0);
      msg = "    Difference = " + d;
      d += R; msg += " -> Distance = " + d;
      d = Parnt.R - d; msg += " (" + d + ")";
      if(d<0) msg += "\t\t<negative>";
      ETab.add(msg); /* add next Message to list */
    } /* message created */

    if(Chld==null) return; /* keine Eintraege -- Ende */
    cI = Chld.iterator(); /* Iterator fuer TSView-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cVS = cI.next(); /* naechstes TSView-Child */
      cVS.prtView(ETab); /* process child */
    } /* alle Child-Definitionen durchsuchen */
    return; /* gesuchte ViewSphere nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "$modPos"
  * Positionswert modifizieren und pruefen, ob Quadrant gewechselt wird
  * Methode liefert 'true' wenn ein Quadrantenwechsel vorliegt
  * Methode wird NUR intern benutzt
  * ##$modPos.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final boolean $modPos( /* Positionswert modifizieren */
   double dx, /* Modifikationswert X */
   double dy, /* Modifikationswert Y (Hoehe) */
   double dz) /* Modifikationswert Z */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return true; /* ViewSphere-Definition NICHT gueltig */
    if(Pos.addPosX(dx)!=0) return true; /* verschieben und pruefen */
    if(Pos.addPosZ(dz)!=0) return true; /* verschieben und pruefen */
    Pos.addPosY(dy); /* Hoehenwert auch veraendern */
    return false; /* Modifikation war erfolgreich */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addVS"
  * Insert and register new child of viewsphere. Update backchain.
  * ##addVS.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean addVS( /* add Child-Definition to current sphere */
   TSView nVS) /* next/new child of current viewsphere */
   {
   /*-----------------------------------------------------------------*/
    boolean created; /* list of child was created */
   /*=================================================================*/
    created = false; /* preset status */
    if(Chld==null) { /* list of childs do not exist -- create it */
      Chld = new ArrayList<TSView>(); /* create empty list of childs */
      created = true; /* remember action */
    } /* existence of child-list */
    Chld.add(nVS); /* add child to end of list */
    nVS.Parnt = this; /* insert parent-reference of new child */
    return created; /* return stus of actions */
  }

 /**. <pre>
  *=====================================================================
  * Methode "adjHgt"
  * Hoehenwert eines Knotens anpassen
  *   Ergebniswert muss nicht geprueft werden
  * ##adjHgt.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String adjHgt( /* Hoehenwert veraendern */
   double d) /* Korrekturwert der Hoehe */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return TSLogg.getKey("TSViewA1");
    Pos.addPosY(d); /* Hoehenwert korrigieren */
//    if((i=Pos.addPosY(d))!=0) return TSLogg.getMsg("TSViewA2",i);
    return null; /* Methode beenden -- kein Fehler */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkPrnt"
  * Check parent-reference. If it is already set, an error is returned.
  * ##chkPrnt.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chkPrnt() /* check parent and return message */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Parnt==null) return null; /* status OK -- return */
    return TSLogg.getMsg("TSViewA0",Id); /* return errormessage */
  }

 /**. <pre>
  *=====================================================================
  * Methode "clrView"
  * nicht mehr aktive ViewSphere-Eintraege entfernen
  * ACHTUNG: ID-Werte werden NICHT neu vergeben!
  * ##clrView.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean clrView( /* ViewSphere-Eintraege bearbeiten */
   ArrayList<String> FT) /* Tabelle fuer Fehlermeldungen */
   {
   /*-----------------------------------------------------------------*/
    Iterator<TSView> cI;  /* allgemeiner Tabellen-Iterator */
    TSView           cVS; /* aktuelle TSView-Definition */
    boolean          st;  /* Status der aktuellen TSView-Definition */
   /*=================================================================*/
    st = false; /* default: ungueltige Definition kennzeichnen */
    if(Cnt>0) { /* Definition wird referenziert */
      if(Pos==null) FT.add(TSLogg.getMsg("TSViewC1",Id));
      else st = true; /* kennzeichnen: Definition benutzt u. gueltig */
    } /* Definition bearbeitet */
    if(Chld==null) return st; /* keine Eintraege -- Ende */
    cI = Chld.iterator(); /* Iterator fuer TSView-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cVS = cI.next(); /* naechstes TSView-Child */
      if(cVS.clrView(FT)) continue; /* Teilkette noch gueltig */
      cI.remove(); /* Ungueltige Teilkette entfernen */
    } /* alle Child-Definitionen durchsuchen */
    if(Chld.isEmpty()) Chld = null; /* Keine Sub-Eintraege mehr */
    else st = true; /* Eintraege bedeuten gueltige Elemente */
    return st; /* aktuellen Status des Eintrags liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "conVS"
  * Connect TSView-chains together.
  * 'this' points to a template-chain, from which a copy should be
  * created. This copy should be connected to 'cVS' as the new basis-
  * TSView. If a Basis-TSView is already specified (cVS!=null), the
  * basis-TSView of the template is merged into the current basis-TSView
  * and 'cVS' becomes the copy of the templates basis-TSView.
  * ##conVS.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSView conVS( /* connect basis of a TSView-chain */
   TSView cVS) /* TSViewsphere-Basis where to become connected */
   {
   /*-----------------------------------------------------------------*/
    TSView           pVS; /* previous TSView-definition */
    double           a;   /* difference of origins (intermediate value) */
    Iterator<TSView> cI;  /* iterator over child-entries */
   /*=================================================================*/
    if(Parnt==null) { /* object is 'basis-viewsphere' -- merge it */
      TSUtil.RetVal = cpyR; /* preset current value */
      if(cpyR!=null) return cVS; /* already connected -- OK */
        /* it should be: cpyR==cVS (may be additionally checked) */
      if(cVS!=null) { /* basis-view already valid -- use it */
        /* basis-view becomes common one, values need to be adjusted */
        if(Pos==null || cVS.Pos==null) throw new /* systemerror -- term */
        IllegalStateException(TSLogg.getMsg("Msg904","TSView(Pos)"));
        a = Pos.cmpAbs(cVS.Pos,0,0); /* compute distance of origins */
        a += R; /* compute minimum radius of sphere */
        if(cVS.R<a) cVS.R = a; /* set minimum radius of sphere */
        /* Attention: Origin is unchanged; 'cVS'-value used */
      } else cVS = new TSView(this); /* no target exist -- use copy */
      TSUtil.RetVal = cpyR = cVS; /* insert/register it as the copy */
      return cVS; /* and return it as the new basis-viewsphere */
    } /* basis-viewsphere is processed (merged/replaced) */

    /* current viewsphere ('this') is connected to an upper one.
     * create copy (if needed) and connect it, too. If a copy
     * already exists(cpyR!=null), the whole chain (up) is correct.
     * way up: 'Retval' is not valid used until now
     */
    TSUtil.RetVal = cpyR; /* preset current value (for way back) */
    if(cpyR!=null) return cVS; /* already connected -- way back */
    cVS = Parnt.conVS(cVS); /* one level up and process it */
    /* now: way back from recursion (high to low chain)
     * 'cVS' may have been changed
     */
    pVS = (TSView)TSUtil.RetVal; /* get upper next view-definition */
    /* new copy-entry must be created and connected to upper
     * TSView-definition (pVS)
     * this -> template (from merge-TSView)
     * cpyR -> identical TSView to template, connected into cVS-chain
     *         and referenced from template
     * cVS  -> Basis-TSView of target-TSView-chain
     * pVS  -> next upper TSView of target-TSView-chain
     */
    if(pVS.Chld==null) pVS.Chld = new ArrayList<TSView>();
      /* create new Child-list if not already present */
    cI = pVS.Chld.iterator(); /* check existend TSView-def's */
    /* check if an existing child is similiar to the template-TSView.
     * then: use this child as a copy of this template.
     * valid here: cpyR==null (needed in case of 'no child')
     */
    while(cI.hasNext()) { /* more childs available */
      cpyR = cI.next(); /* get next TSView-Child */
      if(Pos.cmpAbs(cpyR.Pos,0,0)<0.01) /* positions match */
        if(cpyR.R>=R) break; /* radius useable */
      cpyR = null; /* set marker (no more childs) */
    } /* check all childs for matching values */
    if(cpyR==null) { /* no target exist -- use copy */
      cpyR = new TSView(this); /* create new TSView-definition */
      pVS.addVS(cpyR); /* and insert it into target-chain */
    } /* new TSView-entry was created */
    TSUtil.RetVal = cpyR; /* set current TSView */
    return cVS; /* return current basis-viewsphere-definition */
  }

 /**. <pre>
  *=====================================================================
  * Methode "count"
  * Anzahl der TSView-Definitionen zaehlen (rekursiv), Speicherarrays
  *   optimieren
  * ##count.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int count() /* count Child-Definitions */
   {
   /*-----------------------------------------------------------------*/
    Iterator<TSView> cI; /* TSView-iterator */
    int              c;  /* current counter */
   /*=================================================================*/
    if(Chld==null) return 1; /* no dependancies -- return */
    Chld.trimToSize(); /* optimize storage of childs */
    c = 1; /* init counter */
    cI = Chld.iterator(); /* get iterator of all TSView-childs */
    while(cI.hasNext()) c += cI.next().count(); /* count Childs recursivly */
      /* process all child-definitions of the current viewsphere */
    return c; /* return current counter */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Create line-definitions of a TSView-definion (incomplete)
  * ##crDef.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String[] crDef( /* Create line-definitions (incomplete) */
   String p) /* Prefix of output-lines */
   {
   /*-----------------------------------------------------------------*/
    String lne[]; /* intermediate array */
   /*=================================================================*/
    lne = new String[3]; /* create array for results */
    if(Pos!=null) /* position-reference is available */
      lne[1] = p + "Position (" + Pos.getPos(0,1) + " )";
    else lne[1] = p + "Position ( 0.0 0.0 0.0 )";
    lne[0] = p + "VDbId ( " + Id + " )";
    lne[2] = p + "Radius (" + TSUtil.putFV(R,4) + " )";
    return lne; /* return definition lines */
  }

 /**. <pre>
  *=====================================================================
  * Method "crVS"
  * Kopie einer TSView-Kette erstellen. Falls schon eine Kopie eines
  *   Elementes existiert, wird dieses eingebunden und keine neue
  *   Kopie erzeugt. Es wird IMMER die Referenz auf das Basiselement
  *   der GESAMTEN Kette geliefert. Wenn EIN Element nicht mehr im
  *   aktuellen Quadranten liegt (Position) wird 'null' geliefert.
  * Recursion starts at 'this' and walks UP to basis-entry of
  *   chain of viewsphere-entries. When calling start-entry
  *   (not inside recursion) 'nVS' contains 'null'.
  * Attention: ALL ID-values of new chain-entries are NOT set! (-> '-1')
  * Attention: 'RetVal' is used. (lowermost viewsphere-object)
  * ##crVS.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSView crVS( /* create copy of a viewsphere-chain */
   TSView nVS, /* next child-entry of new/current entry or 'null' */
   double dx,  /* X-modification of new element (or NaN) */
   double dy,  /* Modification-value Y (Height) */
   double dz)  /* Modification-value Z */
   {
   /*-----------------------------------------------------------------*/
    TSView cVS; /* new current TSView-Element */
   /*=================================================================*/
    if(cpyR!=null) cVS = cpyR; /* copy-entry already exists -- use it */
    else { /* create new copy of entry and insert (shifted) values */
      if(Pos==null) return null; /* current viewsphere NOT valid */
      cVS = new TSView(this); /* create copy-entry of current one */
      if(!Double.isNaN(dx)) if(cVS.$modPos(dx,dy,dz)) return null;
        /* shift-function is requested: posiion invalid -- terminate */
      cpyR = cVS; /* register copy of viewshere */
    } /* copy of current viewsphere-entry was created */
    if(nVS==null) TSUtil.RetVal = cVS; /* store lowermost element of new chain */
    else if(nVS.Parnt==null) cVS.addVS(nVS); /* chain entry as child */
      /* Chaining ONLY has to be done, if 'Parnt' of new child is NOT
       * already set. Then a new entry was created. If it is set, the
       * child is already chained to another viewsphere-element.
       */
    if(Parnt!=null) return Parnt.crVS(cVS,dx,dy,dz); /* Recursion */
    return cVS; /* return basis-entry of viewsphere-chain */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndView"
  * geforderten ViewSphere-Eintrag gemaess ID suchen
  * wenn nicht gefunden (oder Fehler) wird 'null' geliefert
  * ##fndView.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSView fndView( /* ViewSphere-Eintrag suchen */
   int id)  /* ID der gesuchten ViewSphere */
   {
   /*-----------------------------------------------------------------*/
    Iterator<TSView> cI;  /* allgemeiner Tabellen-Iterator */
    TSView           cVS; /* aktuelle TSView-Definition */
   /*=================================================================*/
    if(id<0) return null; /* ID kann nicht gefunden werden */
    if(Id==id) return this; /* zutreffenden Eintrag gefunden */
    if(Chld==null) return null; /* keine Eintraege -- Ende */
    cI = Chld.iterator(); /* Iterator fuer TSView-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cVS = cI.next(); /* naechstes TSView-Child */
      if((cVS=cVS.fndView(id))!=null) return cVS; /* gefunden */
    } /* alle Child-Definitionen durchsuchen */
    return null; /* gesuchte ViewSphere nicht gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getId"
  * ID des Eintrags liefern
  * ##getId.TSView (Eyecatcher)
    *=====================================================================
  </pre>*/
  protected long getId() /* ID des ViewSphere-Eintrag liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return (long)Id; /* ID der aktuellen ViewSphere liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getIt"
  * 'Iterator' fuer TSView-Tabellen erzeugen und liefern
  * ##getIt.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected Iterator<TSView> getIt() /* Iterator Child-Tab. liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Chld==null) return null; /* keine Childs definiert */
    return Chld.iterator(); /* Iterator auf Daten liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt"
  * Increment reference-counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = Cnt; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-Cnt); /* must not become negative */
    Cnt += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Methode "mrgVal"
  * Positionsdaten mischen und ggf. Fehlerkennung liefern
  * Die Positionsdaten das aktuellen Objektes muessen den HALBEN
  *   Weg in Richtung des Vergleichsobjektes verschoben werden
  *   Weiterhin wird der Radius um den halben Abstand vergroessert.
  * Methode liefert eine Fehlermeldung oder 'null'
  * ##mrgVal.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String mrgVal( /* Positionsobjekt in Viewsphere bearbeiten */
   TSView cVS) /* Viewsphereobjekt fuer Vergleich */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null || cVS.Pos==null) throw new /* systemerror -- term */
      IllegalStateException(TSLogg.getMsg("Msg904","TSView(Pos)"));
    R += Pos.cmpAbs(cVS.Pos,0,0) / 2; /* neuen Radius berechnen */
      /* Achtung: Die Berechnung muss VOR dem Verschieben erfolgen! */
    return Pos.shftPos(cVS.Pos); /* Positionswerte verschieben und
                                   * ggf. Fehlerkennzeichen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "renID"
  * ID-Kennungen der TSView-Definitionen neu vergeben (rekursiv)
  * ##renID.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int renID( /* ID-Kennungen neu vergeben */
   int nr) /* naechste freie ID */
   {
   /*-----------------------------------------------------------------*/
    Iterator<TSView> cI;  /* allgemeiner Tabellen-Iterator */
    TSView           cVS; /* aktuelle TSView-Definition */
   /*=================================================================*/
    Id = nr++;  /* neue ID setzen und registrieren */
    if(Chld==null) return nr; /* keine weiteren Abhaengigkeiten */
    cI = Chld.iterator(); /* Iterator fuer TSView-Definitionen */
    while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
      cVS = cI.next(); /* naechstes TSView-Child */
      nr = cVS.renID(nr); /* Childs rekursiv bearbeiten */
    } /* alle Child-Definitionen bearbeiten */
    return nr; /* naechste freie ID zurueckgeben */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setPos"
  * Positionsobjekt speichern
  * ##setPos.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSPos setPos( /* Positionsobjekt speichern */
   TSPos cP) /* neues Positionsobjekt */
   {
   /*-----------------------------------------------------------------*/
    TSPos cPos; /* Original-Wert */
   /*=================================================================*/
    cPos = Pos; /* Originalwert sichern falls vorhanden */
    Pos = cP; /* neue Position uebertragen */
    return cPos; /* Methode beenden (Originalwert liefern) */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setRad"
  * Radius-Definition setzen
  * ##setRad.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected double setRad( /* Radius-Definition speichern */
   double r) /* aktueller/neuer Radiuswert */
   {
   /*-----------------------------------------------------------------*/
    double cR; /* intermediate value */
   /*=================================================================*/
    cR = R; /* aktuellen Radiuswert sichern */
    R = r; /* neuen Radiuswert uebernehmen */
    return cR; /* alten Radiuswert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSView (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String           rs;  /* result-string */
    int              i;   /* intermediate value */
    TSView           cVS; /* aktuelle Child-Definition */
    Iterator<TSView> cI;  /* Child-Tabellen-Iterator */
   /*=================================================================*/
    i = 0; /* fuer Umbruch */
    rs = "TSView{"+Id+","+Cnt+","+"(";
    if(Pos!=null) rs += Pos.getPos(true); /* Werte aufbereiten */
    else rs += "<null>"; /* sonst Kennung einfuegen */
    rs += ")"+","+R+"-";
    if(Chld==null) rs += "0["; /* keine Childs */
    else { /* Child-Definitionen vorhanden */
      rs += Chld.size() + "["; /* Vorlauf Schleife */
      cI = Chld.iterator(); /* Iterator fuer TSView-Definitionen */
      cVS = null; /* Steuerung initialisieren */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        if(cVS!=null) rs += ","; /* Trennzeichen einfgen */
        if((rs.length()/TSUtil.ZL)>i) { /* Zeilenumbruch einfuegen */
          i += 1; /* naechster Umbruch vorsehen */
          rs += TSUtil.CRLF + "                ";
        } /* Umbruch-Steuerung erfolgt */
        cVS = cI.next(); /* naechstes TSView-Child */
        rs += cVS.toStr(); /* Child einfuegen */
      } /* alle Child-Definitionen bearbeiten */
    } /* Child-Definitionen waren vorhanden */
    rs += "]}"; /* Abschluss setzen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSSigSh -- Definition eines Signal-Shape-Eintrags
 * ##TSSigSh (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSigSh extends TSOpts { /* Signal-Shape-Eintragsdefinition */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.06 18.02.2010";
 /*-------------------------------------------------------------------*/
  private int                   Cnt;    /* Zaehler fuer Nutzung */
  private String                FNme;   /* Dateiname des Shapes */
  private String                Name;   /* Name/Beschreibung */
  private ArrayList<TSSigSObj>  SRef;   /* Sub-Object-References */
/**. <pre>
  * Used options (stored within mask of 'TSOpt'):
  *  0 to 15 - not used
  *       16 -
  *       17 -
  *       18 - SignalFlags:
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSigSh() /* Signal-Shape-Definition (Basis) erstellen */
   {
    super(); /* Default-Basiseinstellungen (--- Restriktion ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all other variables are initialized by default ('0' / 'null') */
//    Cnt  = 0;    /* Entry is still not used */
//    FNme = null; /* No Shape-Name available */
//    Name = null; /* No description of the signal inserted */
//    SRef = null; /* Shape-Definition contains NO Sub-Objects, so far */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSigSh( /* Signal-Shape-Definition erstellen */
   String fnme, /* Dateiname des Signal-Shapes */
   String nme)  /* Beschreibung des Signal-Shapes */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    FNme = fnme; /* Transfer current filename of Shape */
    Name = nme;  /* and set the description, too */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkFNme"
  * Pruefen, ob Dateiname passt
  * ##chkFNme.TSSigSh (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean chkFNme( /* Eintragsname vergleichen */
   String nme)  /* gesuchter Name */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(FNme==null) return false; /* default fuer: nicht vorhanden */
    return FNme.equalsIgnoreCase(nme); /* Vergleichsergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSSigSh (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String crDef( /* create line-definition */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me) /* ggf. Meldung liefern wenn 'true' */
   {
   /*-----------------------------------------------------------------*/
    String is;  /* Zwischenwert */
   /*=================================================================*/
    switch(n) { /* verzweigen gemaess Zeilennummer */
      case(0): /* 'FileName' */
        is = FNme; /* aktuellen Dateinamen nutzen */
        if(is==null) { /* Fehler: Dateiname nicht vorhanden */
          if(me) return TSLogg.getKey("TSSigSh1");
          is = " "; /* Dummy-Wert benutzen */
        } /* File-Name ist OK */
        return "\t\t" + TSUtil.addStr(is); /* Stmt erzeugen */
      case(1): /* 'Beschreibung' */
        return "\t\t" + TSUtil.addStr(Name); /* Stmt erzeugen */
      default: return null; /* keine weitere Augabezeile */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "get$SO"
  * Get number of Signal-Sub-Objects.
  * Return error-code, if table not available
  * ##get$SO.TSSigSh (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$SO() /* get number of Signal-Sub-Objects */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(SRef==null) return -3; /* Table is NOT available */
    return SRef.size(); /* return current number of objects */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getNme"
  * aktueller Datei-Name holen fuer 'Merge'
  * ##getNme.TSSigSh (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getNme() /* Shape-Dateinamen holen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return FNme; /* Dateinamen des Shape liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getSOT"
  * Get current table of Signal-Sub-Objects.
  * Create table if requested and delete all elements in this case.
  * ##geSOT.TSSigSh (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final ArrayList<TSSigSObj> getSOT( /* get Subobject-array */
   int c) /* Number of SSObjects; 'Create-Marker' if > 0  */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c>0) SRef = new ArrayList<TSSigSObj>(c); /* allocate new table */
      /* Creation is requested -- allocate new Table */
    return SRef; /* return current/new table */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt"
  * Increment reference-counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt.TSSigSh (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = Cnt; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-Cnt); /* must not become negative */
    Cnt += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSigSh (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String    rs;  /* result-string */
    int       i,j; /* intermediate value */
    TSSigSObj cO;  /* current Signal-Sub-Object */
   /*=================================================================*/
    j = 0; /* fuer Umbruch */
    rs = "TSSigSh{'" + FNme + "','" + Name;
    if(SRef==null) rs += "',0["; /* keine Definitionen */
    else { /* Definitionen vorhanden */
      rs += "'," + SRef.size() + "["; /* Vorlauf Schleife */
      for(i=0;i<SRef.size();i+=1) { /* alle Definitionen bearbeiten */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        if((rs.length()/800)>j) { /* Zeilenumbruch einfuegen */
          j += 1; /* naechster Umbruch vorsehen */
          rs += TSUtil.CRLF + "                ";
        } /* Umbruch-Steuerung erfolgt */
        if((cO=SRef.get(i))==null) rs += "<null>";
        else rs += cO.toStr();
      } /* alle Definitionen bearbeiten */
    } /* Definitionen waren vorhanden */
    rs += "]-" + Cnt + "-" + super.toStr() + "}"; /* Abschluss */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSSigSObj -- Definition of a signal-subobject within shape
 * ##TSSigSObj (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSigSObj implements Serializable { /* Subobject of Signal-Shape */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.6.03 17.08.2011";
  protected static final int    Tp_SHead = 1; /* 'Head'-type */
  private static String[]       Types = { /* valid SigSub-Types */
    "DECOR","SIGNAL_HEAD","ANUM_DISPLAY","NUMBER_PLATE",
    "GRADIENT_PLATE","USER1","USER2","USER3","USER4" };
      /* Reihenfolge gemaess TrSim-Programm-Kodierung */
 /*-------------------------------------------------------------------*/
  private int                   Nr;     /* item-number of entry */
  private int                   Typ;    /* Type-ID of signal-subobj. */
  private int                   Opt;    /* options of entry */
  private String                SNme;   /* Name of Subobject */
  private String                Name;   /* Name/Description */
  private TSSigTyp              SRef;   /* refernce to signaltypes */
  private TSRefC                Req;    /* Subobject is requested */
  private ArrayList<TSRefC>     JNRef;  /* JN-References (TSSigSObj) */
/**. <pre>
  * Used options (stored within field 'Opt'):
  *        2 - SignalFlags: OPTIONAL
  *        3 - SignalFlags: DEFAULT
  *        5 - SignalFlags: BACK_FACING
  *        7 - SignalFlags: JN_LINK
  *       11 - SignalFlags:
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSigSObj() /* create Signal-Subobject (Basis) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr    = -1; /* No item-number assigned (marker) */
    Typ   = -1; /* Type of subobject is not defined until now */
    Opt   = 1;  /* initialize option-field */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSigSObj( /* create normal Signal-Subobject-Definition */
   int    nr,   /* item-number of subobject */
   String snme, /* objectname within Signal-Shape */
   String nme)  /* description of subobject from Signal-Shape */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr   = nr;   /* insert item-number of subobject */
    SNme = snme; /* store objectname within Signal-Shape */
    Name = nme;  /* save description of subobject from Signal-Shape */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgReq"
  * Modify or Get reference-definition for 'required link'
  * ##chgReq.TSSigSObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSRefC chgReq( /* modify/get Req-Link-Reference */
   TSRefC req)  /* new reference of the 'required'-Link or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC cR; /* intermediate value */
   /*=================================================================*/
    cR = Req; /* save current value of link-definition */
    if(req!=null) Req = req; /* insert new value if requested */
    return cR; /* and return current/old reference-control */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgSigT"
  * SignalTyp-Tabelle lesen, erstellen oder modifizieren
  * ##chgSigT.TSSigSObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSSigTyp chgSigT( /* SignalTyp-Tabelle modifizieren */
   TSSigTyp st) /* Definition SignalTyp-Eintrags oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSSigTyp cST; /* intermediate value */
   /*=================================================================*/
    cST = SRef; /* alten Wert sichern */
    if(st!=null) SRef = st; /* neue Type-Referenz einsetzen */
    return cST; /* alte/aktuelle Referenz liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTyp"
  * Typ-Definition eines Subobjekt-Eintrags bearbeiten
  * ##chgTyp.TSSigSObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int chgTyp( /* Subobjekt-Typ aendern und liefern */
   int t)  /* neuer Subobjekt-Typ */
   {
   /*-----------------------------------------------------------------*/
    int v; /* intermediate value */
   /*=================================================================*/
    v = Typ; /* alten Datenwert merken */
    if(t>=0) Typ = t; /* neuen Datenwert eintragen */
    return v; /* alten Referenzwert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkSNme"
  * Pruefen, ob Dateiname passt
  * ##chkSNme.TSSigSObj (Eyecatcher)
  *=====================================================================
  </pre>*/
//  protected boolean chkSNme( /* Eintragsname vergleichen */
//   String nme)  /* gesuchter Name */
//   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    if(SNme==null) return false; /* default fuer: nicht vorhanden */
//    return SNme.equalsIgnoreCase(nme); /* Vergleichsergebnis liefern */
//  }

 /**. <pre>
  *=====================================================================
  * Methode "chkTyp"
  * Typ-Definition eines Subobjekt-Eintrags heraussuchen
  * ##chkTyp.TSSigSObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chkTyp( /* Subobjekt-Typ pruefen und liefern */
   String t)  /* geforderter Name des Typs */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    for(i=0;i<Types.length;i+=1) /* alle Typen vergleichen */
      if(Types[i].equalsIgnoreCase(t)) return i; /* gefunden */
    return -1; /* Kennzeichen: NICHT gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSSigSObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me) /* ggf. Meldung liefern wenn 'true' */
   {
   /*-----------------------------------------------------------------*/
    String is; /* intermediate value */
    int    i;  /* intermediate value */
    TSRefC cR; /* intermediate value */
   /*=================================================================*/
    switch(n) { /* Verzweigen gemaess lfd. Nr */
      case(0): /* Subobjekt-Beginn erstellen */
        is = SNme; /* aktuellen Subobjektname nutzen */
        if(is==null) { /* Fehler: Subobjektname nicht vorhanden */
          if(me) return TSLogg.getKey("TSSigSO1");
          is = ""; /* Dummy-Wert benutzen */
        } /* Name ist OK */
        return "\t\t\tSignalSubObj ( " + Nr + " " + TSUtil.addStr(is);
      case(1): /* Subobjekt-Beschreibung erstellen */
        is = Name; /* aktuelle Beschreibung holen */
        if(is==null) { /* Fehler: Beschreibung nicht vorhanden */
          if(me) return TSLogg.getKey("TSSigSO2");
          is = " "; /* Dummy-Wert benutzen */
        } /* Name ist OK */
        return "\t\t\t\t" + TSUtil.addStr(is); /* Stmt erzeugen */
      case(2): /* 'SigSubType' erstellen */
        i = Typ; /* aktuellen SubTyp holen */
        if(i<0) { /* Fehler: SubTyp-Kennung ist nicht gesetzt */
          if(me) return TSLogg.getMsg("TSSigSO3",i);
          i = 1; /* Dummy-Wert benutzen */
        } /* Wert ist OK */
        return "\t\t\t\tSigSubType ( " + Types[i] + " ) "; /* Stmt */
      case(3): /* create 'SigSubJnLinkIf' */
        if(JNRef==null) return null; /* NO JN-References found */
        is = "\t\t\t\tSigSubJnLinkIf ( " + JNRef.size(); /* set number */
        for(i=0;i<JNRef.size();i+=1) { /* add all defined references */
          cR = JNRef.get(i); /* get current JN-Reference-definition */
          if(cR==null) { /* no reference-entry available */
            if(me) return TSLogg.getKey("TSSigSO6");
            is += " 0"; /* insert dummy-value '0' */
          } else if(cR.chgRef(null)==null) { /* JN-reference-address missing */
            if(me) return TSLogg.getKey("TSSigSO4");
            is += " " + cR.chgNr(Integer.MIN_VALUE); /* use original value */
          } else is += " " + ((TSSigSObj)cR.chgRef(null)).getNr();
        } /* add all defined references */
        return is + " ) "; /* Stmt erzeugen */
      case(4): /* 'SignalFlags' erstellen */
        is = ""; /* Start der Optionen-Definitionen */
        if(isOpt(2)) is += " OPTIONAL"; /* Schluesselwort hinzufuegen */
        if(isOpt(3)) is += " DEFAULT"; /* Schluesselwort hinzufuegen */
        if(isOpt(5)) is += " BACK_FACING"; /* Schluesselwort hinzufuegen */
        if(isOpt(7)) is += " JN_LINK"; /* Schluesselwort hinzufuegen */
        if(is.length()==0) return null; /* keine Flags aktiv */
        return "\t\t\t\tSignalFlags (" + is + " ) "; /* Stmt erzeugen */
      case(5): /* create 'SigSubRequires' */
        if(Req==null) return null; /* no required reference active */
        return null; /* definition is not supported -- suppress it */
//        return "\t\t\t\tSigSubRequires ( " + " ) "; /* Stmt erzeugen */
      case(8): /* 'SigSubSType' erstellen */
        if(SRef==null) return null; /* keine Typ-Referenz aktiv */
        is = SRef.getNme(); /* aktuellen Referenznamen holen */
        if(is==null) { /* Fehler: Beschreibung nicht vorhanden */
          if(me) return TSLogg.getKey("TSSigSO5");
          is = ""; /* Dummy-Wert benutzen */
        } /* Name ist OK */
        return "\t\t\t\tSigSubSType ( " + TSUtil.modStr(is) + " ) ";
      case(9): /* Abschluss des Subobjektes erstellen */
        return "\t\t\t) "; /* Stmt erzeugen */
      default: return null; /* keine Augabezeile */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getJNRef"
  * Returns current array of 'JN-Link'-References, which is of
  *   type 'TSRefC'. If it is requested (c>0), it is created even if
  *   it is already available.
  * ##getJNRef.TSSigSObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final ArrayList<TSRefC> getJNRef( /* return reference-list */
   int c) /* expected number of definitions (used for init) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(c>0) JNRef = new ArrayList<TSRefC>(c); /* create it */
    return JNRef; /* reply with (new) Reference-table */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getNr"
  * aktuelle laufende Nummer des Eintrags liefern
  * ##getNr.TSSigSObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getNr() /* laufende Nummer liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Nr; /* aktuelle Nummer liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isOpt"
  * Pruefung ob Option aktiviert
  * ##isOpt.TSSigSObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isOpt( /* Optionenwert auf Option pruefen */
   int opt) /* Optionswert zur Pruefung (Primzahl!) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(opt<2) return false; /* default fuer Fehler */
    return (Opt%opt)==0; /* Auf Optionen pruefen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setOpt"
  * Option den Gesamt-Optionen hinzufuegen
  * liefert den Status der Option VOR dem setzen
  * ##setOpt.TSSigSObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean setOpt( /* Optionenwert anpassen */
   int opt) /* neue Option (Primzahl) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(opt<2) return true; /* Option konnte nicht gesetzt werden */
    if((Opt%opt)==0) return true; /* Option ist bereits gesetzt */
    Opt *= opt; /* neue Option setzen */
    return false; /* Option wurde neu gesetzt */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSigSObj (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String    rs;   /* result-string */
    int       i,j;  /* intermediate value */
    TSRefC    cRef; /* current reference-control */
    TSSigSObj cO;   /* current referenced Signal-Sub-Object */
   /*=================================================================*/
    rs = "TSSigSObj{'" + SNme + "','" + Name + "'," + Opt + "," +
          Typ + ":";
    if(SRef==null) rs += "<null>"; /* keine Definitionen */
    else rs += "'" + SRef.getNme() + "'"; /* Definitionen vorhanden */
    if(Req==null) rs += "-(<NoV>/<null>"; /* no definition available */
    else rs += "-(" + Req.chgNr(Integer.MIN_VALUE) + "/" +
                ((Req.chgRef(null)==null)?"<null>":"<set>");
    if(JNRef==null) rs += ")-0["; /* keine Definitionen */
    else { /* Definitionen vorhanden */
      rs += ")-" + JNRef.size() + "["; /* Vorlauf Schleife */
      for(i=0;i<JNRef.size();i+=1) { /* alle Definitionen bearbeiten */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        cRef = JNRef.get(i); /* get current reference-definiion */
        if(cRef==null) { /* dummy-element */
          rs += "(<NoV>,<null>)"; /* insert default-values */
          continue; /* skip remaining actions */
        } /* skip remaining actions */
        rs += "(" + cRef.chgNr(Integer.MIN_VALUE);
        cO = (TSSigSObj)cRef.chgRef(null); /* extract referenced obj. */
        if(cO==null) rs += ",<null>)"; /* set Dummy */
        else rs += "," + Types[cO.chgTyp(-1)] + ")";
      } /* alle Definitionen bearbeiten */
    } /* Definitionen waren vorhanden */
    rs += "]}"; /* Abschluss setzen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSSigTyp -- Definition of a Signal-Type-Entry
 * ##TSSigTyp (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSigTyp extends TSOpts { /* Signal-Type-Entry */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.06 17.02.2010";
  private static String[]       Types = { /* Signaltypes */
    "Normal","Distance","Repeater","Shunting","Info"};
 /*-------------------------------------------------------------------*/
  private String                Name;   /* current name of signaltype */
  private int                   Typ;    /* ID of Signaltype:
  *                             0=Normal, 1=Distance, 2=Repeater, ... */
  private int                   NCA;    /* 'NumClearAhead'-Definition */
  private int                   Cnt;    /* Usage-counter */
  private double                SInf;   /* current 'SemaphoreInfo' */
  private TSSigLTx              LTxt;   /* current light-texture */
  private TSSigSgL[]            LRef;   /* SignalLight-References */
  private TSSigDrSt[]           DRef;   /* DrawState-References */
  private TSSigAsp[]            ARef;   /* SignalAspect-References */
  private String                Lne;    /* additional line(s) */
/**. <pre>
  * Used options (stored within mask of 'TSOpt'):
  *  0 to 15 - not used
  *       16 - Signal-Script available
  *       17 -
  *       18 - SignalFlags: Semaphore
  *       19 - SignalFlags: No_Gantry
  *       20 - SignalFlags: ABS
  *       21 - SignalFlags: DIR_Display
  *       22 -
  *       31 - Reserved (used for temporary marker)
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSigTyp() /* Signal-Typ-Definition (Basis) erstellen */
   {
    super();  /* set default-values (--- Restriktion ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Typ  = -1;   /* Signaltyp ist NICHT gesetzt */
    NCA  = -1;   /* Wert ist NICHT gesetzt (ungueltiger Wert) */
    SInf = Double.NaN; /* Kennzeichen: Wert nicht gesetzt */
    /* all other variables are initialized by default ('0' / 'null') */

//    Name = null; /* Beschreibung noch nicht gesetzt */
//    LTxt = null; /* Licht-Textur noch nicht eingetragen */
    LRef = null; /* SignalLight-Referenzen noch nicht angelegt */
    DRef = null; /* DrawState-Referenzen noch nicht angelegt */
    ARef = null; /* SignalAspect-Referenzen noch nicht angelegt */
//    Lne  = null; /* no additional line-definitions set */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSigTyp( /* Signal-Typ-Definition erstellen */
   String nme) /* Name des Signal-Typs */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Name = nme;  /* aktuelle Beschreibung uebernehmen */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgAsp"
  * Get and modify entry within SignalAspect-table
  * Replace entry if new value is specified
  * ##chgAsp.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSSigAsp chgAsp( /* change 'SignalAspect'-table */
   int      ix, /* index  of entry */
   TSSigAsp nA) /* new reference or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSSigAsp cA; /* intermediate value */
   /*=================================================================*/
    if(ARef==null) throw new /* systemerror -- terminate */
      IllegalStateException(TSLogg.getMsg("Msg904","TSSigTyp.chgAsp()"));
    if(ix<0 || ix>=ARef.length) throw new IllegalArgumentException(
      TSLogg.getMsg("Msg910","TSSigTyp-Aspect",ix,(ARef.length-1)));
    cA = ARef[ix]; /* save current value of entry */
    if(nA!=null) ARef[ix] = nA; /* and insert new one if requested */
    return cA; /* return current/old reference-value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgLne"
  * Set or Change addiltional line-definitions
  * ##chgLne.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String chgLne( /* modify additional line-definitions */
   String lne) /* new value of line */
   {
   /*-----------------------------------------------------------------*/
    String cL; /* old/current line-value */
   /*=================================================================*/
    cL = Lne; /* save/get current value of line */
    if(lne!=null) Lne = lne; /* transfer value if requested */
    return cL; /* OK - return old/current value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgLTx"
  * Get and modify current entry of Light-Texture
  * Replace entry if new value is specified
  * ##chgLTx.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSSigLTx chgLTx( /* modify current Light-Texture */
   TSSigLTx nT) /* new reference or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSSigLTx cT; /* intermediate value */
   /*=================================================================*/
    cT = LTxt; /* save current value of entry */
    if(nT!=null) LTxt = nT; /* and insert new one if requested */
    return cT; /* return current/old reference-value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgDrSt"
  * Get and modify entry within SignalDrawState-table
  * Replace entry if new value is specified
  * ##chgSgL.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSSigDrSt chgDrSt( /* change 'SignalDrawState'-table */
   int       ix, /* index  of entry */
   TSSigDrSt nD) /* new reference or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSSigDrSt cD; /* intermediate value */
   /*=================================================================*/
    if(DRef==null) throw new /* systemerror -- terminate */
      IllegalStateException(TSLogg.getMsg("Msg904","TSSigTyp.chgDrSt()"));
    if(ix<0 || ix>=DRef.length) throw new IllegalArgumentException(
      TSLogg.getMsg("Msg910","TSSigTyp-DrState",ix,(DRef.length-1)));
    cD = DRef[ix]; /* save current value of entry */
    if(nD!=null) DRef[ix] = nD; /* and insert new one if requested */
    return cD; /* return current/old reference-value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgSgL"
  * Get and modify entry within SignalLight-table
  * Replace entry if new value is specified
  * ##chgSgL.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSSigSgL chgSgL( /* change 'SignalLight'-table */
   int      ix, /* index  of entry */
   TSSigSgL nL) /* new reference or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSSigSgL cL; /* intermediate value */
   /*=================================================================*/
    if(LRef==null) throw new /* systemerror -- terminate */
      IllegalStateException(TSLogg.getMsg("Msg904","TSSigTyp.chgSgL()"));
    if(ix<0 || ix>=LRef.length) throw new IllegalArgumentException(
      TSLogg.getMsg("Msg910","TSSigTyp-Light",ix,(LRef.length-1)));
    cL = LRef[ix]; /* save current value of entry */
    if(nL!=null) LRef[ix] = nL; /* and insert new one if requested */
    return cL; /* return current/old reference-value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgNCA"
  * get or modify 'NumClearAhead'-value
  * ##chgNCA.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int chgNCA( /* change 'NumClearAhead'-value if req. */
   int nV)  /* neu value or 'negative one' */
   {
   /*-----------------------------------------------------------------*/
    int cV; /* intermediate value */
   /*=================================================================*/
    cV = NCA; /* save current value */
    if(nV>=0) NCA = nV; /* and insert new one if requested */
    return cV; /* return current/old reference-value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgSInf"
  * Wert fuer 'SemaphoreInfo' modifizieren oder liefern
  * ##chgSInf.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected double chgSInf( /* 'SemaphoreInfo' modifizieren */
   double Inf)  /* neuer Info-Wert oder 'NaN' */
   {
   /*-----------------------------------------------------------------*/
    double v; /* intermediate value */
   /*=================================================================*/
    v = SInf; /* alten Datenwert merken */
    if(!Double.isNaN(Inf)) SInf = Inf; /* neuen Datenwert eintragen */
    return v; /* alten Referenzwert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTyp"
  * Typ-Kennung der Definition pflegen
  * ##chgTyp.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int chgTyp( /* Typ-Kennung aendern und liefern */
   int t)  /* neue Kennung des Typs */
   {
   /*-----------------------------------------------------------------*/
    int v; /* intermediate value */
   /*=================================================================*/
    v = Typ; /* alten Datenwert merken */
    if(t>=0) Typ = t; /* neuen Datenwert eintragen */
    return v; /* alten Referenzwert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkName"
  * Check supplied name against Signaltype-name
  * Return message if not equal (including case)
  * ##chkName.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chkName( /* check name of entry */
   String nme)  /* name to be compared to */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Name==null) return TSLogg.getMsg("TSSigTC1",nme);
      /* default, if no name of signaltype is defined */
    if(Name.equals(nme)) return null; /* match -- no error found */
    return TSLogg.getMsg("TSSigTC2",Name,nme); /* return message */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkNme"
  * Pruefen, ob Typ-Item passt
  * ##chkNme.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkNme( /* Eintragsname vergleichen */
   String nme)  /* gesuchter Name */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Name==null) return false; /* default fuer: nicht vorhanden */
    return Name.equalsIgnoreCase(nme); /* Vergleichsergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkTyp"
  * Typ-Kennung eines Signal-Typ-Eintrags heraussuchen
  * ##chkTyp.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chkTyp( /* Typ-Kennung pruefen und liefern */
   String t)  /* geforderter Name des Typs */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    for(i=0;i<Types.length;i+=1) /* alle Typen vergleichen */
      if(Types[i].equalsIgnoreCase(t)) return i; /* gefunden */
    return -1; /* Kennzeichen: NICHT gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   int     n,  /* laufende Nummer der Ausgabe-Zeile */
   boolean me) /* ggf. Meldung liefern wenn 'true' */
   {
   /*-----------------------------------------------------------------*/
    String is;  /* Zwischenwert */
   /*=================================================================*/
    switch(n) { /* verzweigen gemaess Zeilennummer */
      case(0): /* 'SignalFnType' */
        if(Typ>=Types.length) is = "" + Typ; /* Nummer einsetzen */
        else is = Types[Typ]; /* Schluesselwort verwenden */
        return "\t\tSignalFnType ( " + is + " ) "; /* Stmt erzeugen */
      case(1): /* 'SignalLightTex' */
        if(LTxt==null) return null; /* keine Lichtreferenz vorhanden */
        return "\t\tSignalLightTex ( "+TSUtil.addStr(LTxt.chgNme(null))+" ) ";
      case(2): /* 'SemaphoreInfo' */
        if(Double.isNaN(SInf)) return null; /* keine Ausgabe */
        is = "" + SInf; /* Wert konvertieren */
        if(is.endsWith(".0")) is = is.substring(0,is.length()-2);
        return "\t\tSemaphoreInfo ( " + is + " ) "; /* Stmt erzeugen */
      case(3): /* 'SignalFlags' */
        is = ""; /* Start der Optionen-Definitionen */
        if(chkMsk(18)) is += " SEMAPHORE"; /* Schluesselwort hinzu */
        if(chkMsk(19)) is += " NO_GANTRY"; /* Schluesselwort hinzu */
        if(chkMsk(20)) is += " ABS";       /* Schluesselwort hinzu */
        if(chkMsk(21)) is += " DIR_DISPLAY"; /* Schluesselwort hinzu */
        if(is.length()==0) return null; /* keine Flags aktiv */
        return "\t\tSignalFlags (" + is + " ) "; /* Stmt erzeugen */
      case(4): /* 'SigFlashDuration' */
        if(!chkMsk(5)) return null; /* nicht definiert -- keine Ausgabe */
        return "\t\tSigFlashDuration (" + Lne + ") "; /* Stmt */
      case(9): /* 'SignalNumClearAhead' */
        if(NCA<0) return null; /* kein Wert aktiv */
        return "\t\tSignalNumClearAhead ( " + NCA + " ) "; /* Stmt */
      default: return null; /* keine weitere Augabezeile */
    } /* Bearbeitung gemaess Typ-Kennung */
  }

 /**. <pre>
  *=====================================================================
  * Method "get$SgA"
  * Get current size of SignalAspect-table
  * Create (another) new table with 'c' empty slots if 'c>0'
  * ##get$SgA.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$SgA( /* get size of SignalAspect-table */
   int c) /* size of new table if requested */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c>=0) { /* create of (new) table requested */
      ARef = new TSSigAsp[c]; /* create storage for SignalAspect-table */
      Arrays.fill(ARef,null); /* and initialize slots with 'null' */
    } /* (new) table was created -- use it */
    if(ARef==null) return -3; /* table was not defined -- report it */
    return ARef.length; /* return length of table */
  }

 /**. <pre>
  *=====================================================================
  * Method "get$SgD"
  * Get current size of SignalDrawState-table
  * Create (another) new table with 'c' empty slots if 'c>0'
  * ##get$SgD.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$SgD( /* get size of SignalDrawState-table */
   int c) /* size of new table if requested */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c>=0) { /* create of (new) table requested */
      DRef = new TSSigDrSt[c]; /* create storage for SignalDrawState-table */
      Arrays.fill(DRef,null); /* and initialize slots with 'null' */
    } /* (new) table was created -- use it */
    if(DRef==null) return -3; /* table was not defined -- report it */
    return DRef.length; /* return length of table */
  }

 /**. <pre>
  *=====================================================================
  * Method "get$SgL"
  * Get current size of SignalLight-table
  * Create (another) new table with 'c' empty slots if 'c>0'
  * ##get$SgL.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int get$SgL( /* get size of SignalLight-table */
   int c) /* size of new table if requested */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c>0) { /* create of (new) table requested */
      LRef = new TSSigSgL[c]; /* create storage for SignalLight-table */
      Arrays.fill(LRef,null); /* and initialize slots with 'null' */
    } /* (new) table was created -- use it */
    if(LRef==null) return -3; /* table was not defined -- report it */
    return LRef.length; /* return length of table */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getNme"
  * aktueller Name holen fuer Auswertung / Logging
  * ACHTUNG: Methode wird in 'getSScr(), 'TSSigSh' und 'TSSigSObj' benutzt
  * ##getNme.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getNme() /* Eintragsnamen holen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Name; /* Eintragsnamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getSigA"
  * Get current array of signalaspect-definitions and create a new one
  *   if requested.
  * If a value >0 is specified for 'c', a new list is created and the
  *   common address of this table is replaced. This occurrs in every
  *   case and an old table is replaced if it already exists.
  * ##getSigA.TSRoute (Eyecatcher)
  *=====================================================================
  </pre>*/
//  protected ArrayList<TSSigAsp> getSigA( /* create/get SignalAspects */
//   int c) /* expected number of entries if 'create' requested */
//   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    if(c>0) ARef = new ArrayList<TSSigAsp>(c); /* create it */
//    return ARef; /* return (new) table of signalaspect-definitions */
//  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt"
  * Increment reference-counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = Cnt; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-Cnt); /* must not become negative */
    Cnt += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSigTyp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs;  /* result-string */
    int    i,j; /* intermediate value */
   /*=================================================================*/
    rs = "TSSigT{"+Types[Typ]+",'"+Name+"'-"+NCA+"-"+SInf+"-"+Cnt+"-(";
    if(LTxt==null) rs += "<null>"; else rs += LTxt.toStr();
    if(LRef==null) rs += ")-0["; /* keine Definitionen */
    else { /* Definitionen vorhanden */
      rs += ")-" + LRef.length + "["; /* Vorlauf Schleife */
      for(i=0;i<LRef.length;i+=1) { /* alle Definitionen bearbeiten */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        if(LRef[i]==null) rs += "<null>";
        else rs += LRef[i].toStr();
      } /* alle Definitionen bearbeiten */
    } /* Definitionen waren vorhanden */
    if(DRef==null) rs += "]-0["; /* keine Definitionen */
    else { /* Definitionen vorhanden */
      rs += "]-" + DRef.length + "["; /* Vorlauf Schleife */
      for(i=0;i<DRef.length;i+=1) { /* alle Definitionen bearbeiten */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        if(DRef[i]==null) rs += "<null>";
        else rs += DRef[i].toStr();
      } /* alle Definitionen bearbeiten */
    } /* Definitionen waren vorhanden */
    if(ARef==null) rs += "]-0["; /* keine Definitionen */
    else { /* Definitionen vorhanden */
      rs += "]-" + ARef.length + "["; /* Vorlauf Schleife */
      for(i=0;i<ARef.length;i+=1) { /* alle Definitionen bearbeiten */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        if(ARef[i]==null) rs += "<null>";
        else rs += ARef[i].toStr();
      } /* alle Definitionen bearbeiten */
    } /* Definitionen waren vorhanden */
    rs += "]-" + super.toStr() + "}";
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSSigSgL -- Definition of a SignalLight-Entry
 *  This entry is referenced from a 'SignalType'-definition.
 * ##TSSigSgL (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSigSgL extends TSOpts { /* SignalLight-Definition */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.5.01 04.06.2011";
 /*-------------------------------------------------------------------*/
  private int                   Nr;     /* current number of entry */
  private int                   Cnt;    /* Usage-counter */
  private TSSigLgt              LRef;   /* SignalLight-texture */
  private TSPos                 Pos;    /* SignalLight-Position */
  private double                R;      /* SignalLight-Radius */
/**. <pre>
  * Used options (stored within mask of 'TSOpt'):
  *  0 to 15 - not used until now (Systemoptions)
  *       16 - SignalFlags: SEMAPHORE_CHANGE
  *       17 -
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSigSgL() /* create SignalLight-Definition (Basis) */
   {
    super();  /* set default-values (--- Restriktion ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr = -1;         /* current entry-number is not valid */
    R  = Double.NaN; /* radius of signallight is unknown */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSigSgL( /* create SignalLight-Definition (normal) */
   int      nr, /* current number of SignalLight-Definition */
   TSSigLgt lr) /* reference to light-texture-definition */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr   = nr; /* save current number of definition */
    LRef = lr; /* save reference to light-texture */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgLRef"
  * Manage reference to signallight-texture definition.
  * ##chgLRef.TSSigSgL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSSigLgt chgLRef( /* modify signallight-texture-ref. */
   TSSigLgt nR)  /* new reference or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSSigLgt oR; /* old reference */
   /*=================================================================*/
    if(LRef==null) return null; /* light-table not available */
    oR = LRef; /* save old/current signallight-texture-reference */
    if(nR!=null) LRef = nR; /* and replace it with new one if needed */
    return oR; /* return old signallight-texture-reference */
  }

 /**. <pre>
  *=====================================================================
  * Method "crDef"
  * Create readeable lines for output of definition.
  * ##crDef.TSSigSgL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Iterator<String> crDef( /* create outputlineblock */
   ArrayList<String> LneT) /* Empty list to be filled (table) */
   {
   /*-----------------------------------------------------------------*/
    String is; /* intermediate string */
   /*=================================================================*/
    /* add 'prefix-line' of output */
    if(LRef==null) { /* error: texture-reference missing */
      LneT.add(TSLogg.getKey("TSSigTL1")); /* set message-line */
      is = " "; /* use Dummy-value */
    } else is = LRef.chgNme(null); /* create texture-reference */
    LneT.add("\t\t\tSignalLight ( " + Nr + " " + TSUtil.addStr(is));

    /* add 'Position'-line */
    if(Pos==null) LneT.add("\t\t\t\tPosition ( 0.0 0.0 0.0 )");
      /* No valid positionvalue -- create dummy-line */
    else LneT.add("\t\t\t\tPosition (" +Pos.getPos(0,1) + " ) ");

    /* add 'Radius'-line */
    is = "\t\t\t\tRadius ("; /* create prefix of outputline */
    if(Double.isNaN(R)) is += " 0.0"; else is += TSUtil.putFV(R,4);
    LneT.add(is + " ) "); /* create current statement */

    /* add output for 'SignalFlags' entry */
    is = ""; /* preset: no options active */
    if(chkMsk(16)) is += " SEMAPHORE_CHANGE"; /* add keyword */
    if(is.length()>0) /* add statement if any option active */
      LneT.add("\t\t\t\tSignalFlags (" + is + " ) "); /* create it */

    /* add suffix of current signallight-definition */
    LneT.add("\t\t\t) "); /* create suffix of light-definition */
    return LneT.iterator(); /* return iterator to outputline-block */
  }

 /**. <pre>
  *=====================================================================
  * Method "getNr"
  * Return current number of entry
  * ##getNr.TSSigSgL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getNr() /* return current number of entry */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Nr; /* return requested value */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt"
  * Increment reference-counter
  * (using argument '0', reference-counter may be returned only)
  * ##incCnt.TSSigSgL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = Cnt; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-Cnt); /* must not become negative */
    Cnt += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "setLPos"
  * Store current position of light-object.
  * ##setLPos.TSSigSgL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSPos setLPos( /* store Position of signallight-object */
   TSPos cP) /* new positionobject */
   {
   /*-----------------------------------------------------------------*/
    TSPos cPos; /* unmodified position-value */
   /*=================================================================*/
    cPos = Pos; /* save current position-reference */
    Pos = cP;   /* and insert new one */
    return cPos; /* return old position-reference */
  }

 /**. <pre>
  *=====================================================================
  * Method "setLRad"
  * Store new radius-value of the signallight-object.
  * ##setLRad.TSSigSgL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean setLRad( /* store radius of light */
   double r)  /* new Radius-value */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    R = r; /* save new Radius-value */
    return false; /* return errormarker (always negative) */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSigSgL (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = "TSSigSgL{" + Nr + "-" + Cnt;
    if(LRef==null) rs += "-(<null>,(";
    else rs += "-('" + LRef.chgNme(null) + "',(";
    if(Pos!=null) rs += Pos.getPos(true); /* add position-values */
    else rs += "<null>"; /* add marker: no position-reference avail. */
    rs += ")," + R + ")-";
    rs += super.toStr() + "}"; /* add suffix of line */
    return rs; /* and return complete result */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSSigDrSt -- Definition of a SignalDrawState-entry.
 *  This entry is references from 'SignalType'-definition(s).
 * ##TSSigDrSt (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSigDrSt implements Serializable { /* Sig.DrawState-Definition */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.5.01 05.06.2011";
 /*-------------------------------------------------------------------*/
  private int                   Nr;     /* current number of entry */
  private int                   Cnt;    /* Usage-counter */
  private String                Name;   /* Name of 'DrawState's */
  private double                SPos;   /* SemPos of 'DrawState's */
  private boolean[]             LOpt;   /* Drawlight-option */
  private TSSigSgL[]            SLi;    /* 'SignalLight' - References */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSigDrSt() /* create SignalDrawState-Definition (Basis) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr   = -1;         /* mark: current number is not valid */
    SPos = Double.NaN; /* Seaphore-Position is not valid */
    /* all other variables are initialized by default ('0' / 'null') */
    LOpt = null;       /* No light-options of 'DrawState's available */
    SLi  = null;       /* No ligth-references available */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSigDrSt( /* create SignalDrawState-Definition */
   int    nr,  /* cruuent number of 'DrawState'-definition */
   String nme) /* Name of 'DrawState'-Definition */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr   = nr;  /* transfer number of 'DrawState'-definition */
    Name = nme; /* transfer current name */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgLight"
  * Modify SignalLight-Reference and return ols one.
  * ATTENTION: Reference is only changed if new value is provided.
  * ##chgLight.TSSigDrSt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSSigSgL chgLight( /* modify 'DrawLight' */
   int      ix, /* cuurent index of entry */
   TSSigSgL nR) /* new reference-value or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSSigSgL cR; /* current reference-value */
   /*=================================================================*/
    if(SLi==null) return null; /* tables are not available -- error */
    if(ix<0 || ix>=SLi.length) throw new /* terminate due to systemerror */
       IllegalArgumentException(TSLogg.getMsg("Msg901","chgLight",ix,0));
    cR = SLi[ix]; /* save current reference-value */
    if(nR!=null) SLi[ix] = nR; /* change current reference if requested */
    return cR; /* return old/current signallight-reference */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgNme"
  * Modify name of 'Drawstate'-definition. Return current/old name.
  * ##chgNme.TSSigDrSt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* modify 'SignalDrawState'-name */
   String nN) /* new name or 'null' */
   {
   /*-----------------------------------------------------------------*/
    String cN; /* current name-value */
   /*=================================================================*/
    cN = Name; /* save current DrawState-name */
    if(nN!=null) Name = nN; /* change current name if requested */
    return cN; /* return old/current name of drawstate-definition */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgSPos"
  * Definition der SemaphorePos modifizieren und liefern
  * ##chgSPos.TSSigDrSt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected double chgSPos( /* SemaphorePos-Eintrag pflegen */
   double w)  /* neuer Positionswert oder 'NaN' */
   {
   /*-----------------------------------------------------------------*/
    double v; /* intermediate value */
   /*=================================================================*/
    v = SPos; /* alten Datenwert merken */
    if(!Double.isNaN(w)) SPos = w; /* neuen Datenwert eintragen */
    return v; /* alten Referenzwert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkNme"
  * Check if name of item matches.
  * ##chkNme.TSSigDrSt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkNme( /* compare name of item */
   String nme) /* requested name to match */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Name==null) return false; /* default: name not available */
    return Name.equalsIgnoreCase(nme); /* return result of compare */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt"
  * Increment reference-counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt.TSSigDrSt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int c; /* current counter-value */
   /*=================================================================*/
    c = Cnt; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-Cnt); /* must not become negative */
    Cnt += inc; /* increment (decrement) reference-counter */
    return c; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "isLOpt"
  * Check option due to number signallight
  * ##isLOpt.TSSigDrSt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isLOpt( /* check light-option */
   int nr) /* number of signallight to be checked */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(SLi==null) return false; /* tables are missing */
    if(nr<0 || nr>=SLi.length) throw new /* terminate due to systemerror */
       IllegalArgumentException(TSLogg.getMsg("Msg901","isLOpt",nr,1));
    return LOpt[nr]; /* return result of check */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isSDef"
  * Definitionstyp (einfach) pruefen und liefern
    Einfache Objektdefinition: SLi.lng==0 und SPos==NaN
  * ##isSDef.TSSigDrSt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isSDef() /* aktuellen Definitionstyp liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(SLi!=null) if(SLi.length>0) return false; /* NICHT einfach */
    if(!Double.isNaN(SPos)) return false; /* DefTyp NICHT einfach */
    return true; /* aktueller Definitionstyp ist 'einfach' */
  }

 /**. <pre>
  *=====================================================================
  * Method "set$SgLi"
  * Create SignalLight-Reference-table and return length of it.
  * Create signallight-option-table with same length.
  * ATTENTION: Tables are only created if the length-value 'c' is
  *            positive. Otherwise both tables must already exist and
  *            only the current length is returned.
  * ##set$SgLi.TSSigDrSt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int set$SgLi( /* create DrawLight-Tables, return length */
   int c)  /* number of entries */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c>0) { /* creation of reference-tables requested */
      if(SLi!=null) return -4; /* tables are already present */
      SLi = new TSSigSgL[c]; /* create SignalLight-References */
      Arrays.fill(SLi,null); /* and initialize table */
      LOpt = new boolean[c]; /* create option-table for lights */
      Arrays.fill(LOpt,false); /* and initialize it */
    } /* tables should be created -- done! */
    if(SLi==null) return -3; /* tables are missing */
    return SLi.length; /* return number of entries within tables */
  }

 /**. <pre>
  *=====================================================================
  * Method "setLOpt"
  * Set signallight-option (flashing) due to signallightnumber.
  * Method returns 'true' if error is encountered.
  * ##setLOpt.TSSigDrSt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean setLOpt( /* activate (set) signallight-option */
   int nr) /* number of signallight-entry to be set */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(SLi==null) return true; /* tables are missing */
    if(nr<0 || nr>=SLi.length) throw new /* terminate due to systemerror */
      IllegalArgumentException(TSLogg.getMsg("Msg901","setLOpt",nr,1));
    LOpt[nr] = true; /* set requested option */
    return false; /* return without error-marker */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSigDrSt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
    int    i;  /* intermediate value */
   /*=================================================================*/
    rs = "TSSigDrSt{" + Nr + ",'" + Name + "'-(" + SPos +
          ")-" + LOpt;
    if(SLi==null) rs += "-0["; /* keine Definitionen */
    else { /* Definitionen vorhanden */
      rs += "-" + SLi.length + "["; /* Vorlauf Schleife */
      for(i=0;i<SLi.length;i+=1) { /* alle Definitionen bearbeiten */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        if(SLi[i]==null) rs += "<null>";
        else rs += SLi[i].getNr();
      } /* alle Definitionen hinzufuegen */
    } /* Definitionen waren vorhanden */
    rs += "]-" + Cnt + "}";
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSSigAsp -- Definition eines SignalAspect-Eintrags
 *  Dieser Eintrag wird von 'SignalType' referenziert
 * ##TSSigAsp (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSigAsp extends TSOpts implements Serializable {
   /* current SignalAspect-Definition of type-entry */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 0.0.00 00.00.2005";
  private static String[]       Types = { /* AspektID-Konstanten */
    "STOP","STOP_AND_PROCEED","RESTRICTING","APPROACH_1","APPROACH_2",
    "APPROACH_3","CLEAR_1","CLEAR_2"};
  private static String[]       TypesD = { /* AspektID-Abstaende */
    "\t\t","\t","\t","\t","\t","\t","\t\t","\t\t"};
 /*-------------------------------------------------------------------*/
  private int                   Nr;     /* Lfd. Nummer des Eintrags */
  private int                   Id;     /* Aspekt-ID */
//  private int                   Cnt;    /* Zaehler fuer Nutzung */
  private int                   Spd;    /* Wert fuer Geschwindigkeit */
  private TSSigDrSt             DrSt;   /* aktueller 'DrawState' */
/**. <pre>
  * Used options (stored within mask of 'TSOpt'):
  *  0 to 15 - not used until now (Systemoptions)
  *       16 - SpeedKPH specified
  *       17 - SpeedMPH specified
  *       18 - SignalFlags: ASAP
  *       19 -
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSigAsp() /* SignalAspect-Definition (Basis) erstellen */
   {
    super();  /* set default-values (--- Restriktion ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr    = -1;   /* laufende Nummer noch nicht vergeben */
    Id    = -1;   /* Aspekt-Kennung ist NICHT gesetzt */
    /* all other variables are initialized by default ('0' / 'null') */
//    Cnt   = 0;    /* Eintrag noch nicht genutzt */
//    Spd   = 0;    /* Geschwindigkeit nicht gesetzt */
//    DrSt  = null; /* keine 'DrawState'-Referenz definiert */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSigAsp( /* SignalAspect-Definition erstellen */
   int       id,  /* Kennung des 'SignalAspect's */
   int       typ, /* Aspect-Nummer des 'SignalAspect's */
   TSSigDrSt st)  /* Referenz zu 'DrawState'-Definition */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr   = id;  /* Laufende Nummer des 'SignalAspect's setzen */
    Id   = typ; /* aktuelle kennung des 'SignalAspect's setzen */
    DrSt = st;  /* Referenz zu aktuellem 'SignalDrawState' setzen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgId"
  * ID-Typ der Typ-Definition pflegen
  * ##chgId.TSSigAsp (Eyecatcher)
  *=====================================================================
  </pre>*/
//  protected int chgId( /* ID-Typ aendern und liefern */
//   int id)  /* neue ID des Eintrags */
//   {
   /*-----------------------------------------------------------------*/
//    int cId; /* intermediate value */
   /*=================================================================*/
//    cId = Id; /* alte Aspekt-Kennung merken */
//    if(id>=0) Id = id; /* neue Aspekt-Kennung eintragen */
//    return cId; /* alte Aspekt-Kennung liefern */
//  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNr"
  * Laufende Nummer des SignalAspekt's aendern
  * ##chgNr.TSSigAsp (Eyecatcher)
  *=====================================================================
  </pre>*/
//  protected int chgNr( /* Lfd. Nummer des 'SinalAspekt's aendern */
//   int nr)  /* neue Nr.ID des Eintrags */
//   {
   /*-----------------------------------------------------------------*/
//    int cNr; /* intermediate value */
   /*=================================================================*/
//    cNr = Nr; /* alte Nummer des Eintrags merken */
//    if(nr>=0) Nr = nr; /* neue Nummer aktivieren */
//    return cNr; /* alte Eintragsnummer liefern */
//  }

 /**. <pre>
  *=====================================================================
  * Methode "chgSpd"
  * Wert fuer Geschwindigkeitsbeschraenkung aendern
  * ##chgSpd.TSSigAsp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int chgSpd( /* Geschwindigkeitswert aendern */
   int spd)  /* neuer Wert fuer Geschwindigkeit */
   {
   /*-----------------------------------------------------------------*/
    int cSpd; /* intermediate value */
   /*=================================================================*/
    cSpd = Spd; /* alter Wert der Geschwindigkeit merken */
    if(spd>=0) Spd = spd; /* neuen Wert aktivieren */
    return cSpd; /* alten Geschwindigkeitswert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkTyp"
  * Aspekt-ID eines Signal-Typ-Eintrags heraussuchen
  * ##chkTyp.TSSigAsp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static int chkTyp( /* Aspekt-Kennung pruefen und liefern */
   String t)  /* geforderter Name des Aspekts */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    for(i=0;i<Types.length;i+=1) /* alle Typen vergleichen */
      if(Types[i].equalsIgnoreCase(t)) return i; /* gefunden */
    return -1; /* Kennzeichen: NICHT gefunden */
  }

 /**. <pre>
  *=====================================================================
  * Method "crDef"
  * Create readeable lines for output of definition.
  * ##crDef.TSSigAsp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Iterator<String> crDef( /* create outputlineblock */
   ArrayList<String> LneT) /* Empty list to be filled (table) */
   {
   /*-----------------------------------------------------------------*/
    String is; /* intermediate string */
   /*=================================================================*/
    /* add 'prefix-line' of output */
    if(Id>=Types.length) is = "" + Id + "\t\t\t";
    else is = Types[Id] + TypesD[Id]; /* create aspect */
    is = "\t\t\tSignalAspect ( " + is;
    if(DrSt==null) { /* no drawstate connected */
      LneT.add(TSLogg.getKey("TSSigTA1")); /* set message-line */
      is += "\" \""; /* use Dummy-Name */
    } else is += TSUtil.addStr(DrSt.chgNme(null)); /* Drawstate-Name */

    if(getMsk(0x00070000)==0) is += "\t) "; /* add line-termination */
    LneT.add(is); /* add new statementline */

    /* add 'SignalFlags'/'SpeedKPH'/SpeedMPH' if needed */
    if(getMsk(0x00070000)!=0) { /* min. one option is set */
      is = ""; /* clear statment for options */
      if(chkMsk(18)) is += " ASAP"; /* add keyword to line */
      if(is.length()>0) is = "SignalFlags (" + is + " ) "; /* Stmt */
      if(chkMsk(16)) is += "SpeedKPH ( " + Spd + " ) "; /* keyword */
      if(chkMsk(17)) is += "SpeedMPH ( " + Spd + " ) "; /* keyword */
      LneT.add("\t\t\t\t" + is); /* add new statementline */
      LneT.add("\t\t\t) "); /* add line-termination (extra line) */
    } /* active option found -- statement added */

    return LneT.iterator(); /* return iterator to outputline-block */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSigAsp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-String */
   /*=================================================================*/
    rs = "TSSigAsp{" + Nr + "-" + Id + ",'";
    if(DrSt==null) rs += "<null>";
    else rs += DrSt.chgNme(null);
    rs += "'-" + Spd + "-" + super.toStr() + "}";
    return rs; /* return result */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSSigLTx -- Definition eines Signal-LightTexture-Eintrags
 * ##TSSigLTx (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSigLTx extends TSOpts { /* Signal-LightTexture-Definition */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 0.0.00 00.00.2005";
 /*-------------------------------------------------------------------*/
  private int                   Cnt;    /* Zaehler fuer Nutzung */
  private float                 top;    /* Textur-Koordionate */
  private float                 left;   /* Textur-Koordionate */
  private float                 bottom; /* Textur-Koordionate */
  private float                 right;  /* Textur-Koordionate */
  private String                Name;   /* Name des Eintrags */
  private String                FNme;   /* Name der Texture-Datei */
/**. <pre>
  * Used options (stored within mask of 'TSOpt'):
  *  0 to 15 - not used
  *       16 -
  *       17 -
  *       31 - Reserviert fuer temporaere Kennzeichnung
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSigLTx() /* Signal-LightTextur-Definition (Basis) */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    top = left = bottom = right = Float.NaN; /* no value assigned */
    /* all other variables are initialized by default ('0' / 'null') */
//    Name = null; /* Referenz-Name noch nicht gesetzt */
//    FNme = null; /* Texture-Dateiname noch nicht gesetzt */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSigLTx( /* Signal-LightTexture-Definition erstellen */
   int    nr,   /* laufende Nummer des Eintrags */
   String name, /* Referenzname der Textur */
   String fnme) /* Dateiname des Lichttextur */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Name = name;  /* aktuellen Referenznamen uebernehmen */
    FNme = fnme;  /* aktuellen Textur-Dateinamen uebernehmen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * Aktueller Name der Signaltextur liefern oder aendern
  * ACHTUNG: Methode wird AUCH in 'TSSigTyp' benutzt
  * ##chgNme.TSSigLTx (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* Name der LightTextur veraendern */
   String nme)  /* neuer Name des Eintrags oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    String cNme; /* intermediate value */
   /*=================================================================*/
    cNme = Name; /* aktueller Name des Eintrags merken */
    if(nme!=null) Name = nme; /* neuen Namen des Eintrags einsetzen */
    return cNme; /* alten Eintragsnamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkNme"
  * Pruefen, ob Textur-Name passt
  * ##chkNme.TSSigLTx (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkNme( /* Eintragsname vergleichen */
   String nme)  /* gesuchter Name */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Name==null) return false; /* default fuer: nicht vorhanden */
    return Name.equalsIgnoreCase(nme); /* Vergleichsergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSSigLTx (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   boolean me) /* ggf. Meldung liefern wenn 'true' */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    if(Float.isNaN(top)) if(me) return TSLogg.getKey("TSSigLT1");
    rs = "\tLightTex ( " + TSUtil.addStr(Name) + "\t" +
          TSUtil.addStr(FNme) + "\t" + top;
    if(rs.endsWith(".0")) rs = rs.substring(0,rs.length()-2);
    rs += " " + left; /* weiteren Wert hinzufuegen */
    if(rs.endsWith(".0")) rs = rs.substring(0,rs.length()-2);
    rs += " " + bottom; /* weiteren Wert hinzufuegen */
    if(rs.endsWith(".0")) rs = rs.substring(0,rs.length()-2);
    rs += " " + right; /* weiteren Wert hinzufuegen */
    if(rs.endsWith(".0")) rs = rs.substring(0,rs.length()-2);
    return rs + " ) "; /* vollstaendiges Statement */
  }

 /**. <pre>
  *=====================================================================
  * Methode "equals"
  * zwei LightTexture-Definitionen vergleichen
  * ACHTUNG: 'Name' wird zum Vergleich NICHT verwendet
  * ##equals.TSSigLTx (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean equals( /* LightTexture-Definitionen vergleichen */
   TSSigLTx cSg) /* zu vergleichender Eintrag */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(!cSg.FNme.equalsIgnoreCase(FNme)) return false;
      /* Dateiname passt nicht -- Eintraege sind ungleich */
    if(cSg.top!=top) return false; /* Wert passt nicht -- ungleich */
    if(cSg.left!=left) return false; /* Wert passt nicht -- ungleich */
    if(cSg.bottom!=bottom) return false; /* Wert falscht -- ungleich */
    if(cSg.right!=right) return false; /* Wert falsch -- ungleich */
    return true; /* Eintraege sind identisch */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt"
  * Increment reference-counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt.TSSigLTx (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = Cnt; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-Cnt); /* must not become negative */
    Cnt += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Methode "incFNme"
  * Textur-Namen zu Liste hinzufuegen
  * Methode liefert 'true' wenn der Name schon in der Liste ist
  * ##incFNme.TSSigLTx (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean incFNme( /* Textur-Namen zu Liste hinzufuegen */
   TSNameSet Txt) /* Liste der Textur-Namen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return !Txt.add(FNme); /* Eintrag hinzufuegen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setPos"
  * Textur-Koordinaten setzen (Wert: 0.0 <= x <= 1.0 )
  * ##setPos.TSSigLTx (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean setPos( /* Textur-Koordinaten setzen */
   double T, /* Texturwert fuer 'top' */
   double L, /* Texturwert fuer 'left' */
   double B, /* Texturwert fuer 'bottom' */
   double R) /* Texturwert fuer 'right' */
   {
   /*-----------------------------------------------------------------*/
    boolean set; /* intermediate value */
   /*=================================================================*/
    set = (!Float.isNaN(top)); /* alter Gueltigkeitswert merken */
    top    = (float)T; /* Wert fuer 'top' setzen */
    left   = (float)L; /* Wert fuer 'left' setzen */
    bottom = (float)B; /* Wert fuer 'bottom' setzen */
    right  = (float)R; /* Wert fuer 'right' setzen */
    return set; /* aktuellen Wert (vor Aktion) liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSigLTx (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSSigLTx{" + Name + "','" + FNme + "'-(" + top + "," +
           left + "," + bottom + "," + right + ")-" + Cnt + "-" +
           super.toStr() + "}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSSigLgt -- Definition eines Signal-Light-Eintrags
 * ##TSSigLgt (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSigLgt extends TSOpts { /* Signal-LightsTab-Definition */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 0.0.00 00.00.2005";
 /*-------------------------------------------------------------------*/
  private int                   Cnt;    /* Zaehler fuer Nutzung */
  private int                   al;     /* Wert fuer 'Alpha' */
  private int                   rt;     /* Wert fuer 'Rot' */
  private int                   gn;     /* Wert fuer 'Gruen' */
  private int                   bl;     /* Wert fuer 'Blau' */
  private String                Name;   /* Name des Eintrags */
/**. <pre>
  * Used options (stored within mask of 'TSOpt'):
  *  0 to 15 - not used
  *       16 -
  *       17 -
  *       31 - Reserviert fuer temporaere Kennzeichnung
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSigLgt() /* Signal-LightsTab-Definition (Basis) */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    al = rt = gn = bl = -1; /* Farbwerte nicht gesetzt */
    /* all other variables are initialized by default ('0' / 'null') */
//    Name = null; /* Licht-Name noch nicht gesetzt */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSigLgt( /* Signal-LightsTab-Definition erstellen */
   int    nr,  /* laufende Nummer des Eintrags */
   String nme) /* Name des Signal-Typs */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Name = nme;  /* aktuellen Lichtnamen uebernehmen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * Aktueller Name der SignalLight-Definition liefern oder aendern
  * ACHTUNG: Methode wird AUCH in 'TSSigTyp' benutzt
  * ##chgNme.TSSigLgt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* Name des SignalLight's veraendern */
   String nme)  /* neuer Name des Eintrags oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    String cNme; /* intermediate value */
   /*=================================================================*/
    cNme = Name; /* aktueller Name des Eintrags merken */
    if(nme!=null) Name = nme; /* neuen Namen des Eintrags einsetzen */
    return cNme; /* alten Eintragsnamen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkNme"
  * Pruefen, ob Typ-Item passt
  * ##chkNme.TSSigLgt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean chkNme( /* Eintragsname vergleichen */
   String nme)  /* gesuchter Name */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Name==null) return false; /* default fuer: nicht vorhanden */
    return Name.equalsIgnoreCase(nme); /* Vergleichsergebnis liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSSigLgt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   boolean me) /* ggf. Meldung liefern wenn 'true' */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    if(al<0) if(me) return TSLogg.getKey("TSSigLi1"); /* Fehler */
    rs = "\tLightsTabEntry ( "+TSUtil.addStr(Name)+"\t"; /* erster Teil */
    if(rs.length()<26) rs += "\t"; /* weiteres Trennzeichen */
    return rs+"colour ( "+al+" "+rt+" "+gn+" "+bl+" )\t) ";
  }

 /**. <pre>
  *=====================================================================
  * Methode "equals"
  * zwei SignalLight-Definitionen vergleichen
  * ACHTUNG: 'Name' wird zum Vergleich NICHT verwendet
  * ##equals.TSSigLgt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean equals( /* SignalLight-Definitionen vergleichen */
   TSSigLgt cSgL) /* zu vergleichender Eintrag */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(al<0) return false; /* Eintrag nicht gueltig -- ungleich */
    if(cSgL.al!=al) return false; /* Wert passt nicht -- ungleich */
    if(cSgL.rt!=rt) return false; /* Wert passt nicht -- ungleich */
    if(cSgL.gn!=gn) return false; /* Wert passt nicht -- ungleich */
    if(cSgL.bl!=bl) return false; /* Wert passt nicht -- ungleich */
    return true; /* Eintraege sind identisch */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt"
  * Increment reference-counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt.TSSigLgt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = Cnt; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-Cnt); /* must not become negative */
    Cnt += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setCol"
  * Farb-Definition des Licht-Eintrags setzen (Wert: 0 <= x <= 255 )
  * ##setCol.TSSigLgt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean setCol( /* Licht-Definition setzen */
   int AL, /* Farbwert fuer 'Alpha' */
   int RT, /* Farbwert fuer 'Rot' */
   int GN, /* Farbwert fuer 'Gruen' */
   int BL) /* Farbwert fuer 'Blau' */
   {
   /*-----------------------------------------------------------------*/
    boolean set; /* intermediate value */
   /*=================================================================*/
    set = (al>=0); /* alter Gueltigkeitswert merken */
    al = AL; /* Wert fuer 'Alpha' setzen */
    rt = RT; /* Wert fuer 'Rot' setzen */
    gn = GN; /* Wert fuer 'Gruen' setzen */
    bl = BL; /* Wert fuer 'Blau' setzen */
    return set; /* aktuellen Wert (vor Aktion) liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSigLgt (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSSigLgt{'" + Name + "'-(" + al + "," + rt + "," + gn +
           "," + bl + ")-" + Cnt + "-" + super.toStr() + "}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSSigFle -- Definition einer Signal-Script-Datei
 * ##TSSigFle (Eyecatcher)
 *======================================================================
 </pre>*/
//class TSSigFle extends TSOpts { /* Signal-Script-Definition */
class TSSigFle implements Serializable { /* Signal-Script-Definition */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.3.04 23.03.2007";
 /*-------------------------------------------------------------------*/
  private String                Name;   /* Name der Script-Datei */
  private HashMap<String,String> Scrs;   /* Script-Definitionen */
/**. <pre>
  * Used options (stored within mask of 'TSOpt'):
  *  0 to 15 - not used
  *       16 -
  *       17 -
  *       31 - Reserviert fuer temporaere Kennzeichnung
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSigFle() /* Signal-Script-Definitionen (Basis) */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all other variables are initialized by default ('0' / 'null') */
//    Name = null; /* Scriptdatei-Name noch nicht gesetzt */
//    Scrs = null; /* Noch keine Scripte bekannt */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSigFle( /* Signal-Scriptdatei-Definition erstellen */
   String nme) /* Name der Signal-Scriptdatei */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Name = nme;  /* aktuellen Dateinamen uebernehmen */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create copy-entry with modified name
  *=====================================================================
  </pre>*/
  protected TSSigFle( /* Signal-Scriptdatei-Definition erstellen */
   TSSigFle cFle, /* Signalscriptdatei-Definition als Datenvorlage */
   int      ext)  /* Anzahl der Erweiterungszeichen (0..15) */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
    String Ext; /* Erweiterungszeichen */
   /*=================================================================*/
    ext = Math.min(ext,15); /* maximale Erweiterungslaenge */
    Ext = "$$$$$$$$$$$$$$$".substring(0,ext); /* Erweiterung setzen */
    Name = cFle.Name; /* Original-Dateiname uebernehmen */
    ext = Name.lastIndexOf("."); /* letztes Trennzeichen suchen */
    if(ext<0) Name = Name + Ext; /* Erweiterung am Ende durchfuehren */
     else  Name = Name.substring(0,ext) + Ext + Name.substring(ext);
      /* Erweiterungszeichen VOR Endung (immer da! z.B. '.') einfuegen */
    Scrs = cFle.Scrs; /* Script-Definitionen uebernehmen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crDef"
  * Zeilendefinition(en) fuer die Ausgabe erzeugen
  * ##crDef.TSSigFle (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crDef( /* Zeilendefinition eines Typs erzeugen */
   boolean me) /* ggf. Meldung liefern wenn 'true' */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = Name; /* create copy for modifications and error */
    if(Name==null) /* error 'name' not defined */
      if(me) return TSLogg.getKey("TSSigFi1"); /* return message */
      else rs = ""; /* set null-name (valid name) */
    return "\tScriptFile ( " + TSUtil.modStr(rs) + " )";
      /* create definition and return it */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getFile"
  * aktueller Scriptdatei-Name als Dateidefinition liefern
  * ##getFile.TSSigFle (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected File getFile( /* Dateidefinition fuer Scriptfile */
   TSRoute cR, /* aktuelle Routendefinition */
   int     nr) /* Nummer des Basisverzeichnisses (vgl. 'TSRoute') */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Name==null) return null; /* kein Name -- kein Ergebnis */
    return cR.getFile(nr,Name); /* Dateireferenz liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSigFle (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
//    return "TSSigFle{'" + Name + "'-" + super.toStr() + "}";
    return "TSSigFle{'" + Name + "}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSSigCDef -- Definition einer Signal-Modifikations-Anweisung
 * ##TSSigCDef (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSigCDef implements Serializable { /* Signal-Modifications */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.09 10.11.2010";
 /*-------------------------------------------------------------------*/
  private String                sName;  /* Filename of source-object */
  private String                zName;  /* Filename of target-object */
  private TSSigSh               Shape;  /* Shape-Definition of target */
  private TSPos                 Offs;   /* Offset of new shape */
  private ArrayList<TSSigCDefE> Anw;    /* Modification-Command(s) */
  private boolean               StObj;  /* Static-Object if 'true' */
/**. <pre>
  * Action ??? is indicated by:
  * Action = Replace signal-definition with another one
  *    sName = source-signal          zName = destination-signal
  *    Anw - contains conversion-commands (minumum one)
  *    StObj==false - signal is referred
  * Action = Replace signal-definition with static object
  *    sName = source-signal          zName = name of static object
  *    Anw - contains EMPTY LIST of conversion-commands
  *    StObj==false - signal is referred
  * Action = Delete signal-definition
  *    sName = source-signal          zName = source-signal
  *    Anw==null - NO list of conversion-commands available
  *    StObj==false - signal is referred
  * Action = Replace signal-object (static) with another one
  *    sName = source-object          zName = destination-object
  *    Anw - contains EMPTY LIST of conversion-commands
  *    StObj==true - static signal-object is referred
  * Action = Delete signal-object (static)
  *    sName = source-object          zName = source-object
  *    Anw==null - NO list of conversion-commands available
  *    StObj==true - static signal-object is referred
  * Attention: 'sName' and 'zName' may contain the same contents, if
  *            the name of the signal/object should not change.
  ======================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSigCDef() /* Signal-Aenderungs-Definition (Basis) */
   {
    super(); /* Default-Basiseinstellungen (--- Restriktion ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all other variables are initialized by default ('0' / 'null') */
//    sName = null; /* Quellobjekt-Name noch nicht gesetzt */
//    zName = null; /* Zielobjekt-Name noch nicht gesetzt */
//    Shape = null; /* Shape-Definition noch nicht gesetzt */
//    Offs  = null; /* No offset defined -- '0 0 0' assumed */
//    Anw   = null; /* No command-list exists */
//    StObj = false; /* No static object is referred */
   }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSigCDef( /* Signal-Aenderungs-Definition erstellen */
   String  nme, /* Name of Signal-Definition (Filename/Shape) */
   boolean SO)  /* defeinition refers to static object if 'true' */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    sName = zName = nme;  /* aktuellen Dateinamen uebernehmen */
    StObj = SO; /* set reference-type */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgSigS"
  * Modify/Set current Shape-Reference of signal (target)
  * ##chgSigS.TSSigCDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSSigSh chgSigS( /* modify/set Shape-Reference (target) */
   TSSigSh cSh) /* new Shape-Reference or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSSigSh cS; /* intermediate value */
   /*=================================================================*/
    cS = Shape; /* save current value */
    if(cSh!=null) Shape = cSh; /* and replace it if requested */
    return cS; /* return old/current reference-value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crPos"
  * Information-Hiding: Positionswerte als TSPos-Objekt liefern
  * Achtung: Es wird eine (shallow-)Kopie geliefert, sodass die Attribute
  *          dieses Objektes (testweise) modifiziert werden koennen,
  *          ohne das Basisobjekt zu beeinflussen
  * ##crPos.TSSigCDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSPos crPos() /* Positionswerte als Vector liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Offs==null) return null; /* Kennung falls nicht vorhanden */
    return new TSPos(Offs); /* neues Objekt liefern (Kopie) */
  }

 /**. <pre>
  *=====================================================================
  * Method "getCmdT"
  * Create and/or return current list of modification-commands
  * Attention: - List is overwitten if it already exists
  *            - Method may return 'null' if no list exits
  * ##getCmdT.TSSigCDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSSigCDefE> getCmdT( /* return list of commands */
   int c) /* create list for 'c' elements if 'c>0' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c>0) Anw = new ArrayList<TSSigCDefE>(c); /* create list */
    return Anw; /* return current List of Modifications */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getNme"
  * Ziel-/Quell-Name der Signaldefinition liefern
  * ##getNme.TSSigCDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getNme( /* Name des Signals liefern */
   boolean orig) /* Quell-Name der Signal-Definition falls 'true' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(orig) return sName; /* Original-Name liefern */
    return zName; /* neuen Shape-Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "isStatic"
  * Check and return type of object
  * Method returns 'true' if a static signal-object is referenced
  * ##isStatic.TSSigCDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isStatic() /* return type of referred object */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return StObj; /* return type of reference */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setNme"
  * Ziel-Name der Signaldefinition setzen
  * ##setNme.TSSigCDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setNme( /* Neuer Name des Signals speichern */
   String nme) /* Name der Signal-Definition (Shape) */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = zName; /* alte Signaldefinition merken */
    zName = nme; /* neuen ZielNamen uebernehmen */
    return rs; /* und alten Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setPos"
  * Positionsobjekt speichern
  * ##setPos.TSSigCDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSPos setPos( /* Positionsobjekt speichern */
   TSPos cP) /* neues Positionsobjekt */
   {
   /*-----------------------------------------------------------------*/
    TSPos cPos; /* Original-Wert */
   /*=================================================================*/
    cPos = Offs; /* Originalwert sichern falls vorhanden */
    Offs = cP; /* neue (Offset-)Position uebertragen */
    return cPos; /* Methode beenden (Originalwert liefern) */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSigCDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
    int    i;  /* intermediate value */
   /*=================================================================*/
    rs = "TSSigCDef{'"+sName+"'->'"+zName+"'("+StObj;
    if(Anw==null) rs += ")-?[";
    else { /* commandlist is allocated -- print it */
      rs += ")-" + Anw.size() + "[";
      for(i=0;i<Anw.size();i+=1) { /* alle Sub-Definitionen anzeigen */
        if(i>0) rs += ","; /* Trennzeichen einfuegen */
        rs += "" + i + "(" + Anw.get(i).toStr() + ")";
      } /* Alle Sub-Eintraege */
    } /* commandlist is allocated */
    rs += "]}"; /* Abschluss hinzufuegen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSSigCDefE -- Kommando-Eintrag einer Signal-Aenderung
 *   Definition eines Steuereintrags in der Kommando-Kette
 * ##TSSigCDefE (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSigCDefE implements Serializable { /* Kdo-Eintrag Signal-Aend. */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.3.08 15.01.2008";
 /*-------------------------------------------------------------------*/
  private char                  cBef;   /* aktueller Aenderungsbefehl */
  private int                   zNr;    /* Argument: Subobjekt 'dst' */
                                        /* Argument: Dst-Opt-Maske */
  private int                   sNr;    /* Argument: Subobjekt 'src' */
                                        /* Argument: Src-Opt-Maske */
  private int                   vMsk;   /* Argument: Opt-Maske */
  private String                Name;   /* Argument: Signaltype-Name */
  private boolean               Opt;    /* Zusatzoption des Befehls */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSSigCDefE() /* Eintrag Signal-Aenderungs-Definition (Basis) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    cBef = '#';   /* Dummy-Befehl setzen */
    /* all other variables are initialized by default ('0' / 'null') */
//    zNr  = 0;     /* noch KEIN gueltiger Wert */
//    sNr  = 0;     /* noch KEIN gueltiger Wert */
//    vMsk = 0;     /* noch KEIN gueltiger Wert */
//    Name = null;  /* noch kein Wert gesetzt */
//    Opt  = false; /* Option ist NICHT gesetzt */
   }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSSigCDefE( /* Eintrag Signal-Aenderungs-Definition erst. */
   char    bf,   /* Befehlskennung */
   int     nrz,  /* Nummer Ziel-Subobjekt / Zielmaske Optionen */
   int     nrs,  /* Nummer Source-Subobjekt / Quellmaske Optionen */
   int     vmsk, /* Vergleichsmaske Optionen */
   String  stn,  /* Signaltype-Name (neu) */
   boolean zo)   /* aktuelle Zusatzoption */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    cBef = bf;   /* aktuellen Befehl setzen */
    zNr  = nrz;  /* Argument speichern */
    sNr  = nrs;  /* Argument speichern */
    vMsk = vmsk; /* Argument speichern */
    Name = stn;  /* Argument speichern */
    Opt  = zo;   /* Zusatzoption eintragen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCBef"
  * aktuelle Aenderungsanweisung liefern
  * ##getCBef.TSSigCDefE (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected char getCBef() /* aktueller Anweisung liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return cBef; /* Kennzeichen der Aenderung liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCMsk"
  * aktuelle Aenderungsanweisung (v-Maske) liefern
  * ##getCMsk.TSSigCDefE (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCMsk() /* aktueller Anweisung (v-Maske) liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return vMsk; /* Kennzeichen der Aenderung liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCsNr"
  * aktuelle Aenderungsanweisung (Quell-Nummer) liefern
  * ##getCsNr.TSSigCDefE (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCsNr() /* aktueller Anweisung (Quell-Nummer) liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return sNr; /* Kennzeichen der Aenderung liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCzNr"
  * aktuelle Aenderungsanweisung (Ziel-Nummer) liefern
  * ##getCzNr.TSSigCDefE (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getCzNr() /* aktueller Anweisung (Ziel-Nummer) liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return zNr; /* Kennzeichen der Aenderung liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getCNme"
  * aktuelle Aenderungsanweisung (Script-Name) liefern
  * ##getCNme.TSSigCDefE (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getCNme() /* aktueller Anw. (Script-Name) liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Name; /* Kennzeichen der Aenderung liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getOpt"
  * aktuellen Wert der Zusatzoption liefern
  * ##getOpt.TSSigCDefE (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean getOpt() /* aktuelle Zusatzoption liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Opt; /* Wert der Zusatzoption liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSigCDefE (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSSigCDefE{'" + Character.toString(cBef) +
           "'," + zNr + "," + sNr + "," + vMsk + ",'" +
           ((Name==null)?"<null>":Name) + "'}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TStType -- Definition eines Sound-Eintrags aus 'ttype.dat'
 * ##TStType (Eyecatcher)
 *======================================================================
 </pre>*/
class TStType implements Serializable { /* Sound-Eintrag 'ttype.dat' */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 0.0.00 00.00.2005";
 /*-------------------------------------------------------------------*/
  private int                   Nr;     /* Nummer/ID des Eintrags */
  private int                   Cnt;    /* Zaehler fuer Nutzung */
  private String                Name;   /* Beschreibung des Sounds */
  private String                FNme1;  /* Filename des Sounds */
  private String                FNme2;  /* Filename des Sounds */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TStType() /* 'ttype'-Sound-Eintrag (Basis) erstellen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr    = -1;   /* Eintragsnummer entwerten */
    /* all other variables are initialized by default ('0' / 'null') */
//    Cnt   = 0;    /* Eintrag noch nicht genutzt */
//    Name  = null; /* Beschreibung noch nicht gesetzt */
//    FNme1 = null; /* Dateiname ist noch nicht gesetzt */
//    FNme2 = null; /* Dateiname ist noch nicht gesetzt */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TStType( /* 'ttype'-Sound-Eintrag erstellen */
   int    nr,  /* Nummer des Eintrags */
   String nme, /* Beschreibung des Sounds */
   String fn1, /* Dateiname1 des Sounds */
   String fn2) /* Dateiname2 des Sounds */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr    = nr;  /* Nummer des Eintrags setzen */
    Name  = nme; /* aktuelle Beschreibung uebernehmen */
    FNme1 = fn1; /* aktuellen Dateinamen uebernehmen */
    FNme2 = fn2; /* aktuellen Dateinamen uebernehmen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNr"
  * aktuelle ID des ttype-Eintrags liefern oder aendern
  * ##chgNr.TStType (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int chgNr( /* ID des ttype-Eintrags liefern/aendern */
   int nr) /* neue ID oder Wert<0 */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = Nr; /* aktuelle Id sichern */
    if(nr>=0) Nr = nr; /* neue Id einsetzen falls gefordert */
    return i; /* aktuellen Wert (vor Aktion) liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crLine"
  * Zeilendefinition fuer die Ausgabe erzeugen
  * ##crLine.TStType (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String crLine( /* Zeilendefinition eines Typs erzeugen */
   int wl) /* Laenge des ersten Wertes */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
    int    i;  /* intermediate value */
   /*=================================================================*/
    rs = "TrackType ( " + TSUtil.addStr(Name); /* minimale Laenge */
    i = Math.max(wl,rs.length()); /* neue Laenge erstellen */
    rs += "                              "; /* max. Fuellwert */
    i = Math.min(i,rs.length()); /* neue Laenge erstellen */
    rs = rs.substring(0,i); /* Ausgabe kuerzen */
    rs += TSUtil.addStr(FNme1) + " " + TSUtil.addStr(FNme2) + " ) ";
    return rs; /* und liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "equals"
  * Datenwerte von ttype-Eintraegen vergleichen
  * Eintraege sind gleich, wenn die 'FName'n uebereinstimmen
  * ##equals.TStType (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean equals( /* ttype-Eintraege vergleichen */
   TStType cTp) /* Eintrag zum Vergleichen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(!FNme1.equalsIgnoreCase(cTp.FNme1)) return false;
    if(!FNme2.equalsIgnoreCase(cTp.FNme2)) return false;
    return true; /* Eintragsdefinitionen stimmen */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getNme"
  * Datenstring gemaess Auswahl liefern
  * ##getNme.TStType (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getNme( /* FName liefern */
   int nr) /* Selektion des Namens */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr==0) return Name; /* String gefordert -- liefern */
    if(nr==1) return FNme1; /* String gefordert -- liefern */
    if(nr==2) return FNme2; /* String gefordert -- liefern */
    return ""; /* Default -- Nullkette liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt"
  * Increment reference-counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt.TStType (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = Cnt; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-Cnt); /* must not become negative */
    Cnt += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TStType (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TStType{'"+Name+"','"+FNme1+"','"+FNme2+"',"+Cnt+"}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSAct -- Definition of a Activity
 * ##TSAct (Eyecatcher)
 *======================================================================
 </pre>*/
class TSAct extends TSData { /* Activity-Entry (Main-Entry=Control) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.03 23.07.2009";
 /*-------------------------------------------------------------------*/
  private String                FNme;   /* Filename of activity */
  private String                Name;   /* Name of activity */
  private long                  State;  /* state of last modification */
  private String[]              Desc;   /* 'Description'-memory */
  private String[]              Brief;  /* 'Briefing'-memory */
  private String                PatID;  /* current 'Path-ID' */
  private TSPath                Path;   /* current Path-reference */
  private String                TNme;   /* Name of 'Traffic'-definition */
  private TSTrf                 TRef;   /* current traffic-reference */
  private TSXtSrv               Serv;   /* Player-Service-Definition */
  private ArrayList<TSXtSrv>    TrfT;   /* Traffic-Service-Definition */
  private TreeSet<TSActEv>      EvntT;  /* 'Event'-definition-Table */
  private ArrayList<TSActAO>    ActObj; /* 'ActivityObjects'-Table */
  private ArrayList<TSActSZ>    RSZne;  /* 'RestrictedSpeedZone' */
  private ArrayList<TSRefC>     SgRef;  /* References to 'FailedSignal' */
  private ArrayList<TSRefC>     PNPWt;  /* 'PlatformNumPassengersWaiting' */
  private ArrayList<TSRefC>     TrI08;  /* 'PickupTrItemData'-Ref. */
/**. <pre>
  * Options defined in optionsmask of 'TSOpts':
  *   0 - Serial-number found
  *   1 - 'Route-ID'-definition found
  *   2 - 'Name'-definition found
  *   3 - 'Description'-definition found
  *   4 - 'Briefing'-definition found
  *   5 - 'CompleteActivity'-definition found
  *   6 - 'Type'-definition found
  *   7 - 'Mode'-definition found
  *   8 - 'StartTime'-definition found
  *   9 - 'Season'-definition found
  *  10 - 'Weather'-definition found
  *  11 - 'PathID'-definition found
  *  12 - 'StartingSpeed'-definition found
  *  13 - 'Duration'-definition found
  *  14 - 'Difficulty'-definition found
  *  15 - 'Animals'-definition found
  *  16 - 'Workers'-definition found
  *  17 - 'FuelWater'-definition found
  *  18 - 'FuelCoal'-definition found
  *  19 - 'FuelDiesel'-definition found
  *  20 - 'Traffic_Definition'-definition found
  *  21 - 'Events'-definition found
  *  22 - 'ActivityObjects'-definition found
  *  23 - 'ActivityRestrictedSpeedZones'-definition found
  *  24 - 'ActivityFailedSignals'-definition found
  *  25 - 'PlatformNumPassengersWaiting'-definition found
  *  26 - 'PickupTrItemData'-definition found
  *  27 -
  *  28 - Sever error found within 'Activity-Definition'
  *  29 - Traffic-table was resorted due to 'Start-Time'
  *  30 - Error within 'StationStop'-assignment of player-service
  *  31 - Reserved for temporary usage
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.00(S) - current Route-ID
  *   1.00(I) - Serial-Number of activity
  *   1.01(I) - 
  *   1.02(I) - Value of 'CompleteActivity' (0/1)
  *   1.03(I) - Value of 'Type' (0..?)
  *   1.04(I) - Value of 'Mode' (0..?)
  *   1.05(I) - Value of 'StartTime' ((h*60+m)*60+s)
  *   1.06(I) - Value of 'Season' (0..3)
  *   1.07(I) - Value of 'Weather' (0..2)
  *   1.08(I) - Value of 'Duration' (h*60+m)
  *   1.09(I) - Value of 'Difficulty' (0..2)
  *   1.10(I) - Value of 'Animals' (0..100)
  *   1.11(I) - Value of 'Workers' (0..100)
  *   1.12(I) - Value of 'FuelWater' (0..100)
  *   1.13(I) - Value of 'FuelCoal' (0..100)
  *   1.14(I) - Value of 'FuelDiesel' (0..100)
  *   1.15(I) - Value of 'NextServiceUID'
  *   1.16(I) - Value of 'NextActivityObjectUID'
  *=====================================================================
  * Constructor: (1) create default-entry
  *=====================================================================
  </pre>*/
  protected TSAct()  /* create definition of a 'Activity' (Basis) */
   {
    super();  /* initialize 'TSData' (2 Arrays) (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    setInt(0,-1); /* set dummy-value for Serial-Number */
//    Name   = null; /* Name der Aktivitaet ist noch nicht gesetzt */
    State  = Long.MIN_VALUE; /* State of modification is not known */
//    PatID  = null; /* Pfad-Kennung noch nicht spezifiziert */
//    Path   = null; /* noch keine Pfad-Referenz eingetragen */
    Brief  = null; /* Beschreibung(en) noch nicht verfuegbar */
    Desc   = null; /* Beschreibung(en) noch nicht verfuegbar */
    /* all other variables are initialized by default ('0' / 'null') */
//    TNme   = null; /* Name of 'Traffic' is not known */
//    TRef   = null; /* no Traffic-Reference available */
//    Serv   = null; /* no Player-Service available */
//    TrfT   = null; /* no 'Traffic-Services'-references used */
//    ActObj = null; /* no 'ActivityObjects'-references used */
//    EvntT  = null; /* no 'Event'-references used */
//    RSZne  = null; /* no 'RestrictedSpeedZone'-references used */
//    SgRef  = null; /* no 'FailedSignal'-references used */
//    PNPWt  = null; /* no 'PlatformNumPassengersWaiting'-references used */
//    TrI08  = null; /* no 'PickupTrItemData'-references used */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) create standard-entry
  *=====================================================================
  </pre>*/
  protected TSAct( /* create definition of a 'Activity' */
   String fn,  /* filename of the activity */
   File   dat) /* Reference to concerned file */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    FNme  = fn;                 /* copy current filename */
    State = dat.lastModified(); /* get date and store it */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * neuen aktuellen Namen/File-Namen liefern oder aendern
  * wenn w==null: liefern aktuellen Namen (information-Hiding)
  * ##chgNme.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* selektierter Name neu setzen */
   String w)  /* neue Namensdefinition */
   {
   /*-----------------------------------------------------------------*/
    String s; /* intermediate value */
   /*=================================================================*/
    s = Name; /* alten Namen merken */
    if(w!=null) Name = w; /* neuen Namen setzen (keine Kopie) */
    return s; /* alten Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgPat"
  * aktuelle Pfad-Referenz lesen oder modifizieren
  * ##chgPat.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSPath chgPat( /* Pfad-Referenz pflegen */
   TSPath cP) /* Definition der Pfad-Referenz oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSPath cPat; /* intermediate value */
   /*=================================================================*/
    cPat = Path; /* alten Wert sichern */
    if(cP!=null) Path = cP; /* neue Referenz einsetzen */
    return cPat; /* alten/aktuellen Referenzwert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgPNme"
  * neuen aktuellen Pfad-Namen liefern oder aendern
  * wenn w==null: liefern aktuellen Namen (information-Hiding)
  * ##chgPNme.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgPNme( /* aktuellen Pfad-Namen setzen/liefern */
   String w) /* neue Namensdefinition */
   {
   /*-----------------------------------------------------------------*/
    String s; /* intermediate value */
   /*=================================================================*/
    s = PatID; /* alten Namen merken */
    if(w!=null) PatID = w; /* neuen Namen setzen (keine Kopie) */
    return s; /* alten Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTNme"
  * Replace or return name of current Traffic-Definition.
  * If no new name provided (a==null) the current name is not changed.
  *   (Information-Hiding)
  * ##chgTNme.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgTNme( /* set/return current name of traffic */
   String a) /* Argument: new Traffic-Name or 'null' */
   {
   /*-----------------------------------------------------------------*/
    String s; /* intermediate value */
   /*=================================================================*/
    s = TNme; /* save current traffic-name */
    if(a!=null) TNme = a; /* replace name if requested */
    return s; /* return current/old traffic-name */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgSrv"
  * aktuelle Player-Service-Definition lesen oder modifizieren
  * ##chgSrv.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSXtSrv chgSrv( /* Player-Service-Definition pflegen */
   TSXtSrv cS) /* Definition des Player-Service oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSXtSrv cSrv; /* intermediate value */
   /*=================================================================*/
    cSrv = Serv; /* alten Wert sichern */
    if(cS!=null) Serv = cS; /* neuen Player-Service einsetzen */
    return cSrv; /* alte/aktuelle Definition liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgTrf"
  * Change current traffic-reference or return current value
  * ##chgTrf.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSTrf chgTrf( /* manage traffic-reference */
   TSTrf cT) /* definition of new traffic-service or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSTrf cTrf; /* intermediate value */
   /*=================================================================*/
    cTrf = TRef; /* save old reference to traffic */
    if(cT!=null) TRef = cT; /* insert new reference if requested */
    return cTrf; /* return old/current reference */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkDate"
  * Compare File-Date to stored one. Return stored date if greater(newer)
  * Return marker (negative-value or 0) otherwise
  * ##chkDate.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final long chkDate( /* compare file-dates */
   long vDate) /* file-date to compare */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    vDate += 120000; /* add tollerance-value (2 min) */
    if(State>vDate) return State; /* return current date as newer */
    return State-vDate; /* return negative (or 0-)marker-value */
  }

 /**. <pre>
  *=====================================================================
  * Method "crDef"
  * Create an output-line for writing an 'Activity'-file
  * ##crDef.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Iterator<String> crDef( /* create output-line-block */
   int               t,    /* type-number of output-line-block */
   ArrayList<String> LneT) /* Empty list to be filled (table) */
   {
   /*-----------------------------------------------------------------*/
    String is; /* intermediate value */
    int    i;  /* intermediate value */
   /*=================================================================*/
    switch(t) { /* process due to type of output */
      case( 1): /* 'Route-ID' */
        is = getDta(0); /* get current value (must be present) */
        is = TSUtil.modStr(is); /* create valid String */
        LneT.add("\t\tRouteID ( " + is + " )"); /* set output-line */
        break; /* output-line-block is fully processed and created */
      case( 2): /* 'Name' */
        is = Name; /* get current value (must be present) */
        is = TSUtil.modStr(is); /* create valid String */
        LneT.add("\t\tName ( " + is + " )"); /* set output-line */
        break; /* output-line-block is fully processed and created */
      case( 3): /* 'Description' */
        is = "\t\tDescription ( "; /* set prefix of first line */
        for(i=0;i<Desc.length-1;i+=1) { /* process all (but last) lines */
          LneT.add(is + TSUtil.addStr(Desc[i]) + "+"); /* set line */
          is = "\t\t\t"; /* set prefix of following lines */
        } /* process all lines */
        LneT.add(is + TSUtil.addStr(Desc[Desc.length-1]) + " )");
          /* set last (or only) output-line of block */
        break; /* output-line-block is fully processed and created */
      case( 4): /* 'Briefing' */
        is = "\t\tBriefing ( "; /* set prefix of first line */
        for(i=0;i<Brief.length-1;i+=1) { /* process all (but last) lines */
          LneT.add(is + TSUtil.addStr(Brief[i]) + "+"); /* set line */
          is = "\t\t\t"; /* set prefix of following lines */
        } /* process all lines */
        LneT.add(is + TSUtil.addStr(Brief[Brief.length-1]) + " )");
          /* set last (or only) output-line of block */
        break; /* output-line-block is fully processed and created */
      case( 5): /* 'CompleteActivity' */
        LneT.add("\t\tCompleteActivity ( " + getInt(2) + " )");
        break; /* output-line-block is fully processed and created */
      case( 6): /* 'Type' */
        LneT.add("\t\tType ( " + getInt(3) + " )"); /* set output-line */
        break; /* output-line-block is fully processed and created */
      case( 7): /* 'Mode' */
        LneT.add("\t\tMode ( " + getInt(4) + " )"); /* set output-line */
        break; /* output-line-block is fully processed and created */
      case( 8): /* 'StartTime' */
        i = getInt(5); /* get current 'StartTime' in seconds */
        is = "\t\tStartTime ( " + (i/3600); /* set hours */
        i %= 3600; /* compute remaining time */
        is += " " + (i/60); /* set minutes */
        i %= 60; /* compute remaining time */
        LneT.add(is + " " + i + " )"); /* set output-line */
        break; /* output-line-block is fully processed and created */
      case( 9): /* 'Season' */
        LneT.add("\t\tSeason ( " + getInt(6) + " )"); /* set line */
        break; /* output-line-block is fully processed and created */
      case(10): /* 'Weather' */
        LneT.add("\t\tWeather ( " + getInt(7) + " )"); /* set line */
        break; /* output-line-block is fully processed and created */
      case(11): /* 'PathID' */
        is = PatID; /* get current value (must be present) */
        is = TSUtil.modStr(is); /* create valid String */
        LneT.add("\t\tPathID ( " + is + " )"); /* set output-line */
        break; /* output-line-block is fully processed and created */
      case(12): /* 'StartingSpeed' */
        LneT.add("\t\tStartingSpeed ( 0 )"); /* set output-line */
        break; /* output-line-block is fully processed and created */
      case(13): /* 'Duration' */
        i = getInt(8); /* get current 'Duration' in minutes */
        is = "\t\tDuration ( " + (i/60); /* set hours */
        i %= 60; /* compute remaining time */
        LneT.add(is + " " + i + " )"); /* set output-line */
        break; /* output-line-block is fully processed and created */
      case(14): /* 'Difficulty' */
        LneT.add("\t\tDifficulty ( " + getInt(9) + " )"); /* set line */
        break; /* output-line-block is fully processed and created */
      case(15): /* 'Animals' */
        LneT.add("\t\tAnimals ( " + getInt(10) + " )"); /* set line */
        break; /* output-line-block is fully processed and created */
      case(16): /* 'Workers' */
        LneT.add("\t\tWorkers ( " + getInt(11) + " )"); /* set line */
        break; /* output-line-block is fully processed and created */
      case(17): /* 'FuelWater' */
        LneT.add("\t\tFuelWater ( " + getInt(12) + " )"); /* set line */
        break; /* output-line-block is fully processed and created */
      case(18): /* 'FuelCoal' */
        LneT.add("\t\tFuelCoal ( " + getInt(13) + " )"); /* set line */
        break; /* output-line-block is fully processed and created */
      case(19): /* 'FuelDiesel' */
        LneT.add("\t\tFuelDiesel ( " + getInt(14) + " )"); /* set line */
        break; /* output-line-block is fully processed and created */
      default: /* definition has error(s) -- return message */
        LneT.add(TSLogg.getMsg("TSActC01",t)); /* set error-line */
        LneT.add("\t\t'"+t+"'"); /* set output-line */
    } /* process line due to type-id */
    return LneT.iterator(); /* return iterator to outputline-block */
  }

 /**. <pre>
  *=====================================================================
  * Method "fndEvnt"
  * Search for an 'Event'-entry using its number and register its
  *   address if it could be found
  * Method returns the found event-entry in order to permit additional
  *   checks.
  * ##fndEvnt.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSActEv fndEvnt( /* seach for referenced Event-definition */
   TSRefC rf) /* Reference to Event-Access-Control */
   {
   /*-----------------------------------------------------------------*/
    TSActEv           cEv; /* current event-item */
    Iterator<TSActEv> cI;  /* iterator for all entries */
    int               i;   /* intermediate value */
   /*=================================================================*/
    if(EvntT==null) return null; /* Event-table not available */
    if(rf==null) return null; /* access-control NOT specified */
    cI = EvntT.iterator(); /* get iterator for search */
    i = rf.chgNr(Integer.MIN_VALUE); /* get ID of requested item */
    while(cI.hasNext()) { /* more valid entries? */
      cEv = cI.next(); /* get next event-definition */
      if(cEv==null) continue; /* definition missing -- skip it */
      if(cEv.chgID(Integer.MIN_VALUE)!=i) continue; /* NOT found */
      /* referenced event-definition found */
      rf.chgRef(cEv); /* insert address of connected event-item */
      return cEv; /* and return it */
    } /* search all defined event-entries */
    return null; /* no appropriate entry found */
  }

 /**. <pre>
  *=====================================================================
  * Method "fndSrv"
  * Find special service within list of all service-definitions.
  * Return list of StationStops of service if found.
  * ##fndSrv.TSTrf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final ArrayList<TSStStp> fndSrv( /* find service within list */
   String nme) /* Name of requested service (key-form) */
   {
   /*-----------------------------------------------------------------*/
    Iterator<TSXtSrv> SrvI; /* Iterator for Traffic-Service-Def's */
    TSXtSrv           cSrv; /* current service-definition */
   /*=================================================================*/
    if(TrfT==null) return null; /* no service defined -- return */
    SrvI = TrfT.iterator(); /* create iterator for all services */
    while(SrvI.hasNext()) { /* more -Service-Definitions available? */
      cSrv = SrvI.next(); /* get extended Service-Definition */
      if(cSrv==null) continue; /* skip if not present */
      if(!nme.equalsIgnoreCase(cSrv.getName())) continue;
        /* service-definition does not match requested one */
      return cSrv.getStp(0); /* return requested list of 'StationStops' */
    } /* -while- check all available service-definitions */
    return null; /* return marker -- service not found */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getAObj"
  * Returns current array of 'ActivityObject'-References,
  *   which is of type 'TSActAO'. If it is requested (c>0), it is
  *   created even if it is already available.
  * ##getAObj.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSActAO> getAObj( /* return reference-array */
   int c) /* expected number of definitions (used for init) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(c>0) ActObj = new ArrayList<TSActAO>(c); /* create it */
    return ActObj; /* reply with (new) Reference-table */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getEvT"
  * Returns current array of 'Event'-References,
  *   which is of type 'TSActEv'. If it is requested ('true'), it is
  *   created even if it is already available.
  * ##getEvT.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TreeSet<TSActEv> getEvT( /* return reference-array */
   boolean cr) /* create new table in every case if true' */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(cr) EvntT = new TreeSet<TSActEv>(); /* create it */
    return EvntT; /* reply with (new) Reference-table */
  }

 /**. <pre>
  *=====================================================================
  * Method "getName"
  * Returns current file-name of the object
  * If argument equals 'false' the file-name is returned modified to be
  *   used as a key (lowerCase and without suffix)
  * ##getName.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* get (modified) filename of the object */
   boolean mde) /* mode of filename */
   {
   /*-----------------------------------------------------------------*/
    String cNme; /* intermediate value */
   /*=================================================================*/
    if(mde) return FNme; /* return filename unmodified */
    cNme = FNme.toLowerCase(); /* process name for key-usage */
    cNme = cNme.substring(0,cNme.indexOf(".act")); /* delete suffix */
    return cNme; /* return filename using key-form */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getPNPWt"
  * Returns current array of 'PlatformNumPassengersWaiting'-References,
  *   which is of type 'TSRefC'. If it is requested (c>0), it is
  *   created even if it is already available.
  * ##getPNPWt.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSRefC> getPNPWt( /* return reference-array */
   int c) /* expected number of definitions (used for init) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(c>0) PNPWt = new ArrayList<TSRefC>(c); /* create it */
    return PNPWt; /* reply with (new) Reference-table */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getRSZne"
  * Returns current array of 'RestrictedSpeedZone'-References, which
  *   is of type 'TSActSZ'. If it is requested (c>0), it is created
  *   even if it is already available.
  * ##getRSZne.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSActSZ> getRSZne(  /* return reference-array */
   int c) /* expected number of definitions (used for init) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(c>0) RSZne = new ArrayList<TSActSZ>(c); /* create it */
    return RSZne; /* reply with (new) Reference-table */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getSigR"
  * Returns current array of 'FailedSignal'-References, which is of
  *   type 'TSRefC'. If it is requested (c>0), it is created even if
  *   it is already available.
  * ##getSigR.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSRefC> getSigR( /* return 'FailedSignal'-array */
   int c) /* expected number of definitions (used for init) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(c>0) SgRef = new ArrayList<TSRefC>(c); /* create it */
    return SgRef; /* reply with (new) Reference-table */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTrfT"
  * Returns current array of 'Traffic-Service'-References, which is of
  *   type 'TSXtSrv'. If it is requested (c>0), it is created even if
  *   it is already available.
  * ##getTrfT.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSXtSrv> getTrfT( /* return reference-array */
   int c) /* expected number of definitions (used for init) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(c>0) TrfT = new ArrayList<TSXtSrv>(c); /* create it */
    return TrfT; /* reply with (new) Reference-table */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTrI08"
  * Returns current array of 'PickupTrItemData'-References, which is of
  *   type 'TSRefC'. If it is requested (c>0), it is created even if
  *   it is already available.
  * ##getTrI08.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSRefC> getTrI08( /* return reference-array */
   int c) /* expected number of definitions (used for init) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(c>0) TrI08 = new ArrayList<TSRefC>(c); /* create it */
    return TrI08; /* reply with (new) Reference-table */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setBrief"
  * neuen Wert fuer 'Briefing' setzen
  * ##setBrief.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String[] setBrief( /* selektierte Werte neu eintragen */
   String[] w) /* neue Inhalt fuer Speicher */
   {
   /*-----------------------------------------------------------------*/
    String[] s; /* intermediate value */
   /*=================================================================*/
    s = Brief; /* alte Werte merken */
    Brief = w; /* neue Werte eintragen */
    return s; /* alte Werte liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setDesc"
  * neuen Wert fuer 'Description'* setzen
  * ##setDesc.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String[] setDesc( /* selektierte Werte neu eintragen */
   String[] w) /* neue Inhalt fuer Speicher */
   {
   /*-----------------------------------------------------------------*/
    String[] s; /* intermediate value */
   /*=================================================================*/
    s = Desc; /* alte Werte merken */
    Desc = w; /* neue Werte eintragen */
    return s; /* alte Werte liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSAct (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String skip = TSUtil.CRLF + "                "; /* next line */
   /*-----------------------------------------------------------------*/
    Iterator<TSActEv> EvI;    /* current event-iterator */
    String            rs;     /* result-String */
    int               i,j,jl; /* intermediate value */
   /*=================================================================*/
    rs = "TSAct{'" + FNme + "','"; /* Basisteil */
    if(Name==null) rs += "<null>"; else rs += Name;

    if(Desc==null) rs += "'-0("; /* keine Beschreibung */
    else { /* Beschreibungswerte definiert */
      rs += "'-" + Desc.length + "("; /* Vorlauf setzen */
      for(i=0;i<Desc.length;i+=1) { /* alle Eintraege hinzufuegen */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        rs += TSUtil.CRLF + "                " + TSUtil.addStr(Desc[i]);
      } /* alle Definitionen hinzufuegen */
      rs += skip; /* skip to new line */
    } /* Definitionen waren vorhanden */
    if(Brief==null) rs += ")-0("; /* keine Beschreibung */
    else { /* Beschreibungswerte definiert */
      rs += ")-" + Brief.length + "("; /* Vorlauf setzen */
      for(i=0;i<Brief.length;i+=1) { /* alle Eintraege hinzufuegen */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        rs += TSUtil.CRLF + "                " + TSUtil.addStr(Brief[i]);
      } /* alle Definitionen hinzufuegen */
      rs += skip; /* skip to new line */
    } /* Definitionen waren vorhanden */
    rs += ")-'"; /* Abschluss hinzufuegen */
    if(PatID==null) rs += "<null>"; else rs += PatID;
    rs += "'("; /* Trennung zu Referenz */
    if(Path==null) rs += "<null>"; else rs += "<set>";
    rs += ")-"; /* Abschluss hinzufuegen */
    j = 0; jl = rs.length(); /* fuer Umbruch */
    if(Serv==null) rs += "<null>"; else rs += Serv.toStr();
    if(TrfT==null) rs += "-0("; /* keine Eintraege */
    else { /* Eintraege koennen existieren -- Vorlauf setzen */
      rs += "-" + skip + TrfT.size() + "("; /* Vorlauf setzen */
      for(i=0;i<TrfT.size();i+=1) { /* alle Eintraege hinzufuegen */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        if(((rs.length()-jl)/TSUtil.ZL)>j) { /* Zeilenumbruch einfuegen */
          rs += skip; j += 1; /* naechster Umbruch vorsehen */
        } /* Umbruch-Steuerung erfolgt */
        rs += TrfT.get(i).toStr(); /* Definition hinzufuegen */
      } /* alle Definitionen hinzufuegen */
    } /* Definitionen waren vorhanden */
    if(EvntT==null) rs += ")-0("; /* keine Eintraege */
    else { /* Eintraege koennen existieren -- Vorlauf setzen */
      rs += ")-" + skip + EvntT.size() + "("; /* Vorlauf setzen */
      EvI = EvntT.iterator(); /* get iterator for all events */
      for(i=0;EvI.hasNext();i+=1) { /* alle Eintraege hinzufuegen */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        if(((rs.length()-jl)/TSUtil.ZL)>j) { /* Zeilenumbruch einfuegen */
          rs += skip; j += 1; /* naechster Umbruch vorsehen */
        } /* Umbruch-Steuerung erfolgt */
        rs += ""+i+":"+EvI.next().toStr(); /* Definition hinzufuegen */
      } /* alle Definitionen hinzufuegen */
    } /* Definitionen waren vorhanden */
    if(ActObj==null) rs += ")-0("; /* keine Eintraege */
    else { /* Eintraege koennen existieren -- Vorlauf setzen */
      rs += ")-" + skip + ActObj.size() + "("; /* Vorlauf setzen */
      for(i=0;i<ActObj.size();i+=1) { /* alle Eintraege hinzufuegen */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        if(((rs.length()-jl)/TSUtil.ZL)>j) { /* Zeilenumbruch einfuegen */
          rs += skip; j += 1; /* naechster Umbruch vorsehen */
        } /* Umbruch-Steuerung erfolgt */
        rs += ActObj.get(i).toStr(); /* Definition hinzufuegen */
      } /* alle Definitionen hinzufuegen */
    } /* Definitionen waren vorhanden */
    if(RSZne==null) rs += ")-0("; /* keine Eintraege */
    else { /* Eintraege koennen existieren -- Vorlauf setzen */
      rs += ")-" + skip + RSZne.size() + "("; /* Vorlauf setzen */
      for(i=0;i<RSZne.size();i+=1) { /* alle Eintraege hinzufuegen */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        if(((rs.length()-jl)/TSUtil.ZL)>j) { /* Zeilenumbruch einfuegen */
          rs += skip; j += 1; /* naechster Umbruch vorsehen */
        } /* Umbruch-Steuerung erfolgt */
        rs += RSZne.get(i).toStr(); /* Definition hinzufuegen */
      } /* alle Definitionen hinzufuegen */
    } /* Definitionen waren vorhanden */
    if(SgRef==null) rs += ")-0("; /* keine Eintraege */
    else { /* Eintraege koennen existieren -- Vorlauf setzen */
      rs += ")-" + skip + SgRef.size() + "("; /* Vorlauf setzen */
      for(i=0;i<SgRef.size();i+=1) { /* alle Eintraege hinzufuegen */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        if(((rs.length()-jl)/TSUtil.ZL)>j) { /* Zeilenumbruch einfuegen */
          rs += skip; j += 1; /* naechster Umbruch vorsehen */
        } /* Umbruch-Steuerung erfolgt */
        rs += SgRef.get(i).toStr(); /* Definition hinzufuegen */
      } /* alle Definitionen hinzufuegen */
    } /* Definitionen waren vorhanden */
    if(PNPWt==null) rs += ")-0("; /* keine Eintraege */
    else { /* Eintraege koennen existieren -- Vorlauf setzen */
      rs += ")-" + skip + PNPWt.size() + "("; /* Vorlauf setzen */
      for(i=0;i<PNPWt.size();i+=1) { /* alle Eintraege hinzufuegen */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        if(((rs.length()-jl)/TSUtil.ZL)>j) { /* Zeilenumbruch einfuegen */
          rs += skip; j += 1; /* naechster Umbruch vorsehen */
        } /* Umbruch-Steuerung erfolgt */
        rs += PNPWt.get(i).toStr(); /* Definition hinzufuegen */
      } /* alle Definitionen hinzufuegen */
    } /* Definitionen waren vorhanden */
    if(TrI08==null) rs += ")-0("; /* keine Eintraege */
    else { /* Eintraege koennen existieren -- Vorlauf setzen */
      rs += ")-" + skip + TrI08.size() + "("; /* Vorlauf setzen */
      for(i=0;i<TrI08.size();i+=1) { /* alle Eintraege hinzufuegen */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        if(((rs.length()-jl)/TSUtil.ZL)>j) { /* Zeilenumbruch einfuegen */
          rs += skip; j += 1; /* naechster Umbruch vorsehen */
        } /* Umbruch-Steuerung erfolgt */
        rs += TrI08.get(i).toStr(); /* Definition hinzufuegen */
      } /* alle Definitionen hinzufuegen */
    } /* Definitionen waren vorhanden */
    rs += ")-" + skip + super.toStr() + "}";
    return rs; /* Ergebnis zurueckgeben */
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSActAO -- Attribute-defininition within a Activity
 *   Type: ActivityObject
 * ##TSActAO (Eyecatcher)
 *======================================================================
 </pre>*/
class TSActAO extends TSOpts { /* Activity: (ActivityObject) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 29.01.2009";
 /*-------------------------------------------------------------------*/
  private TSTrain               Trn;    /* 'Train_config'-definition */
  private int                   ID;     /* ID of object */
  private int                   Dir;    /* Direction (0..359) */
  private TSQPos                Pos;    /* Position of object */
/**. <pre>
  * Used options (stored within mask of 'TSOpt'):
  *        0 - Objecttype is: 'WagonsList'
  *        1 -
  *        2 -
  *  3 to 14 - not used
  *       15 - 'Train_Config'-definition found
  *       16 - 'Direction'-definition found
  *       17 - 'ID'-definition found
  *       18 - 'Tile'-definition found (Position)
  *       19 -
  *       20 -
  *       21 -
  *       31 - Reserved for temporary usage
  *=====================================================================
  * Constructor: (1) create default-entry
  *=====================================================================
  </pre>*/
  protected TSActAO() /* Definition of 'ActivityObject' */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    ID  = Integer.MIN_VALUE; /* mark ID as 'not set' */
    Dir = Integer.MIN_VALUE; /* no 'Direction'-value inserted */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgDir"
  * Change value of 'Direction' or only 'return it'
  * ##chgDir.TSActAO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int chgDir( /* change value of 'Direction' */
   int nV) /* new value of direction (0..359) */
   {
   /*-----------------------------------------------------------------*/
    int cV; /* original value */
   /*=================================================================*/
    cV = Dir; /* save original value if existent */
    if(nV!=Integer.MIN_VALUE) Dir = nV; /* set new value if requested */
    return cV; /* return with old value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgTrn"
  * Replace definiton of train if requested, else only return it
  * ##chgTrn.TSActAO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSTrain chgTrn( /* replace train-definition */
   TSTrain cT) /* new train-definition */
   {
   /*-----------------------------------------------------------------*/
    TSTrain oT; /* original value of definition */
   /*=================================================================*/
    oT = Trn; /* save original value if existent */
    if(cT!=null) Trn = cT; /* set new train-definition if requested */
    return oT; /* return with old value */
  }

 /**. <pre>
  *=====================================================================
  * Method "crDef"
  * Create output-line due to requested type
  * ##crDef.TSActAO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String crDef( /* create output-line */
   int t) /* type-number of output-line */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    switch(t) { /* create line due to type */
      case( 0): /* Type is 'WagonsList' */
        return "\t\t\t\tObjectType ( WagonsList )"; /* return line */
      case(16): /* Type is 'Direction' */
        return "\t\t\t\tDirection ( " + Dir + " )"; /* return line */
      case(17): /* Type is 'ID' */
        return "\t\t\t\tID ( " + ID + " )"; /* return line */
      case(18): /* Type is 'Tile' */
        if(Pos==null) return "\t\t\t\tTile ( ? ? ? ? )"; /* dummy */
        return "\t\t\t\tTile ( " + Pos.getPos(4) + " )";
      default: /* unknown type -- return dummy */
        return "\t\t\t\tUnknown_Type("+t+")"; /* return with dummy */
    } /* line was created */
  }

 /**. <pre>
  *=====================================================================
  * Method "fndWrld"
  * Search world-definiton of position-value and insert it
  * Method returns an error-marker or 'null' if no error
  * ##fndWrld.TSActAO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String fndWrld( /* process position-value */
   TreeSet<TSQuad> QDf) /* List of defined quad-objects */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return "? ? ? ?"; /* report unknown error */
    if(Pos.fndWrld(QDf)!=null) return null; /* quad found -- OK */
    return Pos.getPos(4); /* return error-marker */
  }

 /**. <pre>
  *=====================================================================
  * Methode "maxID"
  * Check 'Service-ID' of object an return current maximum
  * ##maxID.TSActAO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int maxID( /* get current maximum of ID-value */
   int v)  /* ID-value to compare */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    return Math.max(v,ID); /* return requested value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setID"
  * Store new 'Service-ID' of object
  * Current value is overwritten in any case. However, old value is
  *   returned.
  * ##setID.TSActAO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int setID( /* replace ID-value of object */
   int v)  /* new ID-value */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = ID; /* save original value */
    ID = v; /* set new value */
    return i; /* and return original value */
  }

 /**. <pre>
  *=====================================================================
  * Method "setPos"
  * Replace position-reference.
  * Current value is overwritten in any case. However, old value is
  *   returned.
  * ##setPos.TSActAO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSQPos setPos( /* store position-values */
   TSQPos cP) /* new position-object */
   {
   /*-----------------------------------------------------------------*/
    TSQPos oP; /* original position of object */
   /*=================================================================*/
    oP = Pos; /* save original value if existent */
    Pos = cP; /* set new position */
    return oP; /* return with old position */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSActAO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = "TSActAO{" + ID + "," + Dir + ",";
    if(Pos==null) rs += "<null>"; else rs += Pos.toStr();
    rs += ","; /* add separator */
    if(Trn==null) rs += "<null>"; else rs += Trn.toStr();
    rs += super.toStr() + "}"; /* terminate definition */
    return rs; /* return result */
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSActEv -- Attribute-defininition within a Activity
 *   Type: Events     ('Activity-Event')
 * ##TSActEv (Eyecatcher)
 *======================================================================
 </pre>*/
class TSActEv extends TSOpts implements Comparable<TSActEv> { /* Event */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 02.07.2009";
  protected static final int    TMsk = 0x0006FC01; /* Time-Keywords */
  protected static final int    LMsk = 0x001AFC02; /* Location-Keywords */
  protected static final int    AMsk = 0x01E3FFEC; /* Action-Keywords */
  protected static final int[]  modMsk = { /* modify of validation */
    0x0FFFFC00,0x0FFFFC00,0x0E1EFC00,0x0E3EFC00,0x0FFFFC00, /* 0..4 */
    0x0E5FFC00,0x0E9FFC00,0x0F9FFC00,0x0E9EFC00,0x0F9EFC00}; /* 5..9 */
    /* modify validation-mask due to 'type of event' ('and' mask and clear
     * all validation-bits which are no longer valid) */
  protected static final String[] typNme = { /* type-names of events */
    "EventTypeTime","EventTypeLocation","EventTypeAllStops",
    "EventTypePickUpPassengers","****","EventTypeReachSpeed",
    "EventTypePickUpWagons","EventTypeDropOffWagonsAtLocation",
    "EventTypeAssembleTrain","EventTypeAssembleTrainAtLocation"};
  protected static final String[] actNme = { /* names of result-ID */
    "IncActLevel","DecActLevel","ActivateEvent","RestoreActLevel",
    "DisplayMessage","ActivitySuccess","ActivityFail",
    "StartIgnoringSpeedLimits","StopIgnoringSpeedLimits"};
 /*-------------------------------------------------------------------*/
  private int                   Typ;    /* Type-number of event */
  private int                   ID;     /* ID of event */
  private int                   Lvl;    /* initial Activation_Level */
  private int                   Tme;    /* Timer-Value */
  private double                Spd;    /* Speed-value */
  private boolean               ToS;    /* 'TriggerOnStop'-value */
  private String                Name;   /* Name of event */
  private TSQPos                Pos;    /* Location of object
    * Attention: 'Height'-value of position is used for 'Radius' (int) */
  private String[]              Text;   /* Text-definitions (3):
    * contains: Trigger-Text YES, Trigger-Text NO, Task-Description */
  private ArrayList<TSRefC>     Rslt;   /* 'Outcomes'-Table
    * (table can hold a maximum of 4 action-entries) */
  private ArrayList<TSRefC>     WgnT;   /* Wagon-List
    * Attention: A element of this list may contain a reference to a
    *   'SidingItem' (number and reference) OR a Track-definition with
    *   'SidingItem'-number '== -1' and Reference contains the
    *   track-description (name) */
  private TSRefC                StStp;  /* Number/Reference to station */
  private TSRefC                Itm;    /* Siding-Item */
/**. <pre>
  * Options used within optionsmask of 'TSOpt':
  *   (Assignment 0..24 is also used within validation-mask of events)
  *   0 'EventTypeTime'
  *   1 'EventTypeLocation'
  *   2 'EventTypeAllStops'
  *   3 'EventTypePickUpPassengers'
  *   4 Aufnahme machen
  *   5 'EventTypeReachSpeed'
  *   6 'EventTypePickUpWagons'
  *   7 'EventTypeDropOffWagonsAtLocation'
  *   8 'EventTypeAssembleTrain'
  *   9 'EventTypeAssembleTrainAtLocation'
  *      bitnumber also defines 'type of event' (until here)
  *  10 'ID'
  *  11 'Activation_Level'
  *  12 'Outcomes'
  *  13 'TextToDisplayOnCompletionIfTriggered'
  *  14 'TextToDisplayOnCompletionIfNotTriggered'
  *  15 'TextToDisplayDescriptionOfTask'
  *  16 'Reversable_Event'
  *  17 'Name'
  *  18 'Time'
  *  19 'Location'
  *  20 'TriggerOnStop'
  *  21 'StationStop'
  *  22 'Speed'
  *  23 'Wagon_List'
  *  24 'SidingItem'
  *      (This assignment is also used within validation-mask of events)
  *  31 Reserved for temporary usage
  * Within 'Outcomes' the following 'Action-ID' is used:
  *   0 'IncActLevel' (<nr>)
  *   1 'DecActLevel' (<nr>)
  *   2 'ActivateEvent' (<nr>)
  *   3 'RestoreActLevel' (<nr>)
  *   4 'DisplayMessage' (<msg+>)
  *   5 'ActivitySuccess'
  *   6 'ActivityFail' (<msg>)
  *   7 'StartIgnoringSpeedLimits'
  *   8 'StopIgnoringSpeedLimits'
  *  'Action-ID' is stored in 'ix'-field of TSRefC-class
  *=====================================================================
  * Constructor: (1) create default-entry
  *=====================================================================
  </pre>*/
  protected TSActEv() /* Definition of 'Event'(Activity) */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    Typ   = Integer.MIN_VALUE; /* type is NOT initialized */
    ID    = Integer.MIN_VALUE; /* mark value as NOT SET */
    Lvl   = Integer.MIN_VALUE; /* mark value as NOT SET */
    Tme   = Integer.MIN_VALUE; /* mark value as NOT SET */
    Spd   = Double.NaN; /* mark value as NOT SET */
//    ToS   = false;      /* preset 'TriggerOnStop' to '0' */
//    Name  = null; /* Name of event is NOT inserted */
//    Pos   = null; /* no reference to 'Location' inserted */
//    WgnT  = null; /* no 'Wagon_List'-references exist */
//    StStp = null; /* no 'StationStop' referenced */
//    Itm   = null; /* no 'SidingItem' referenced */
    Text  = new String[3]; /* create storage for descriptions */
    Arrays.fill(Text,null); /* no values inserted */
    Rslt  = new ArrayList<TSRefC>(4); /* create table for actions */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) create standard-entry
  *=====================================================================
  </pre>*/
  protected TSActEv( /* Definition of 'Event'(Activity) */
   int t) /* number of event-type */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    Typ = t;   /* set number of event */
    setMsk(t); /* and mark keyword as present */
  }

 /**. <pre>
  *=====================================================================
  * Methode "addRslt"
  * Add an entry to the 'Result'-Table ('Outcomes')
  * Return new 'current size' of table (<=4)
  * No entry will be added if 'cV==null' (information-Hiding)
  * ##addRslt.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int addRslt( /* add entry to 'Result'-table. */
   TSRefC nR) /* new value of 'Outcomes'- definition */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(Rslt==null) throw new /* systemerror -- terminate */
      IllegalStateException(TSLogg.getMsg("Msg904","TSActEv.addRslt()"));
    if(nR!=null) Rslt.add(nR); /* add new entry to table */
    return Rslt.size(); /* return current size of table */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgID"
  * Change value of event-ID or only 'return it'
  * ##chgID.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int chgID( /* change value of event-ID */
   int nV) /* new value of ID */
   {
   /*-----------------------------------------------------------------*/
    int cV; /* original value */
   /*=================================================================*/
    cV = ID; /* save original value if existent */
    if(nV!=Integer.MIN_VALUE) ID = nV; /* set new value if requested */
    return cV; /* return with old value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgLvl"
  * Change value of 'Activation_Level' or only 'return it'
  * ##chgLvl.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int chgLvl( /* change value of 'Activation_Level' */
   int nV) /* new value of level */
   {
   /*-----------------------------------------------------------------*/
    int cV; /* original value */
   /*=================================================================*/
    cV = Lvl; /* save original value if existent */
    if(nV!=Integer.MIN_VALUE) Lvl = nV; /* set new value if requested */
    return cV; /* return with old value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * Change name of event or return it
  * No change of Name will occur if 'cV==null' (information-Hiding)
  * ##chgNme.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String chgNme( /* change current name of event */
   String nV) /* new value of 'name'-definition */
   {
   /*-----------------------------------------------------------------*/
    String cV; /* current value */
   /*=================================================================*/
    cV = Name; /* save original value if existent */
    if(nV!=null) Name = nV; /* set new value if requested */
    return cV; /* return with old value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgSpd"
  * Change 'Speed'-value or return it
  * No change of data will occur if 'cV==NaN' (information-Hiding)
  * ##chgSpd.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double chgSpd( /* change current 'Speed'-value */
   double nV) /* new value of 'Speed'-definition */
   {
   /*-----------------------------------------------------------------*/
    double cV; /* current value */
   /*=================================================================*/
    cV = Spd; /* save original value if existent */
    if(!Double.isNaN(nV)) Spd = nV; /* set new value if requested */
    return cV; /* return with old value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgStStp"
  * Modify or return 'StationStop'-reference
  * ##chgStStp.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSRefC chgStStp( /* modify 'StationStop'-reference */
   TSRefC nR) /* new reference to 'StationStop' or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC cR; /* old reference */
   /*=================================================================*/
    cR  = StStp; /* store original value */
    if(nR!=null) StStp = nR; /* insert new reference if valid */
    return cR; /* return original value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgTme"
  * Change 'Timer'-value or only 'return it'
  * ##chgTme.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int chgTme( /* change 'Timer'-value */
   int nT) /* new 'Timer'-value */
   {
   /*-----------------------------------------------------------------*/
    int cT; /* original value */
   /*=================================================================*/
    cT = Tme; /* save original value if existent */
    if(nT!=Integer.MIN_VALUE) Tme = nT; /* set new value if requested */
    return cT; /* return with old value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTxt"
  * Change text-definitions ('Trigger-Text',...)  or return it
  * No change of text will occur if 'cV==null' (information-Hiding)
  * ##chgTxt.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String chgTxt( /* change current text-definition */
   int    nr, /* number of text-definition */
   String nV) /* new value of text-definition */
   {
   /*-----------------------------------------------------------------*/
    String cV; /* current value */
   /*=================================================================*/
    if(Text==null) throw new /* systemerror -- terminate */
      IllegalStateException(TSLogg.getMsg("Msg904","TSActEv.chgTxt()"));
    if(nr<0 || nr>=Text.length) throw new /* systemerror -- terminate */
      IllegalArgumentException(TSLogg.getMsg("Msg901","chgTxt()",nr,1));
    cV = Text[nr]; /* save original value if existent */
    if(nV!=null) Text[nr] = nV; /* set new value if requested */
    return cV; /* return with old value */
  }

 /**. <pre>
  *=====================================================================
  * Method "compareTo"
  * Method is used to sort Elements
  * Attention: Name of this Methode is requested by Interface
  *           'Comparable'. Results need NOT be 0,1,-1
  * Note: This class has a natural ordering that is
  *       inconsistent with equals.
  * ##compareTo.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  public final int compareTo( /* compare Definitions for sorting */
   TSActEv vE)  /* compare-object (Event) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(vE.ID==Integer.MIN_VALUE) return 0; /* value NOT set */
      /* Attention: if ID-value not set, the specified element
       * equals 'all other elements'. The list CANNOT contain an
       * element, which ID is NOT set. */
    return ID-vE.ID; /* compare and return result */
  }

 /**. <pre>
  *=====================================================================
  * Method "crDef"
  * Create an output-line-block due to requested type
  * Attention: Function 21 (Type 'StationStop') also refers to global
  *            field 'TSUtil.RetVal', which must contain the
  *            'StationStop'-table of the 'Player-Service'.
  * ##crDef.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Iterator<String> crDef( /* create output-line-block */
   int               t,    /* type-number of output-line-block */
   ArrayList<String> LneT, /* Empty list to be filled (table) */
   String            prfx) /* prefix of the definition lines */
   {
   /*-----------------------------------------------------------------*/
    Iterator<TSRefC> cI;   /* iterator of 'Outcomes'-entries */
    TSRefC           cR;   /* current 'Outcomes'-entry */
    TSActEv          cEv;  /* referenced event-entry */
    TSStStp          cStp; /* current 'StationStop'-definition */
    TSTrItm03        cIt;  /* current 'SidingItem' */
    String[]         cL;   /* referenced message-array */
    String           s;    /* intermediate value */
    int              i,j;  /* intermediate value */
    ArrayList<TSStStp> StpT; /* 'StationStop'-table (got from 'RetVal') */
   /*=================================================================*/
    switch(t) { /* create line-block due to type */
      case(10): /* Type is 'ID' */
        LneT.add(prfx + "ID ( " + ID + " )"); /* create line and add it */
        break; /* output-line-block is fully processed and created */
      case(11): /* Type is 'Activation_Level' */
        LneT.add(prfx + "Activation_Level ( " + Lvl + " )");
        break; /* output-line-block is fully processed and created */
      case(12): /* Type is 'Outcomes' */
        LneT.add(prfx + "Outcomes ( "); /* set first line of block */
        cI = Rslt.iterator(); /* get iterator of all results */
        j = -1; /* preset number of entry (first number is '0') */
        while(cI.hasNext()) { /* process all 'Outcomes'-entries */
          cR = cI.next(); /* get next 'Outcomes'-entry */
          j += 1; /* advance number to next entry */
          switch(i=cR.chgIx(Integer.MIN_VALUE)) { /* type of result */
            case(0): /* Result is 'IncActLevel' */
              cEv = (TSActEv)cR.chgRef(null); /* get reference */
              if(cEv==null) { /* reference not established */
                i = cR.chgNr(Integer.MIN_VALUE); /* original */
                LneT.add(TSLogg.getMsg("TSActEC1",""+j,i)); /* errormessage */
              } else i = cEv.ID; /* get ID of referenced event */
              LneT.add(prfx + "\tIncActLevel ( " + i + " )");
              break; /* result-lines are fully processed */
            case(1): /* Result is 'DecActLevel' */
              cEv = (TSActEv)cR.chgRef(null); /* get reference */
              if(cEv==null) { /* reference not established */
                i = cR.chgNr(Integer.MIN_VALUE); /* original */
                LneT.add(TSLogg.getMsg("TSActEC2",""+j,i)); /* errormessage */
              } else i = cEv.ID; /* get ID of referenced event */
              LneT.add(prfx + "\tDecActLevel ( " + i + " )");
              break; /* result-lines are fully processed */
            case(2): /* Result is 'ActivateEvent' */
              cEv = (TSActEv)cR.chgRef(null); /* get reference */
              if(cEv==null) { /* reference not established */
                i = cR.chgNr(Integer.MIN_VALUE); /* original */
                LneT.add(TSLogg.getMsg("TSActEC3",""+j,i)); /* errormessage */
              } else i = cEv.ID; /* get ID of referenced event */
              LneT.add(prfx + "\tActivateEvent ( " + i + " )");
              break; /* result-lines are fully processed */
            case(3): /* Result is 'RestoreActLevel' */
              cEv = (TSActEv)cR.chgRef(null); /* get reference */
              if(cEv==null) { /* reference not established */
                i = cR.chgNr(Integer.MIN_VALUE); /* original */
                LneT.add(TSLogg.getMsg("TSActEC4",""+j,i)); /* errormessage */
              } else i = cEv.ID; /* get ID of referenced event */
              LneT.add(prfx + "\tRestoreActLevel ( " + i + " )");
              break; /* result-lines are fully processed */
            case(4): /* Result is 'DisplayMessage' */
              cL = (String[])cR.chgRef(null); /* get reference */
              if(cL==null) { /* reference not established */
                LneT.add(TSLogg.getMsg("TSActEC5",j)); /* errormessage */
                cL = new String[1]; /* create dummy-message */
                cL[0] = TSLogg.getKey("TSActEC6"); /* set default-text */
              } /* message-reference was not valid */
              s = prfx + "\tDisplayMessage ( "; /* set prefix of first line */
              for(i=0;i<cL.length-1;i+=1) { /* process all (but last) lines */
                LneT.add(s + TSUtil.addStr(cL[i]) + "+"); /* set line */
                s = prfx + "\t\t"; /* set prefix of following lines */
              } /* process all lines */
              LneT.add(s + TSUtil.addStr(cL[cL.length-1]) + " )");
                /* set last (or only) output-line of block */
              break; /* result-lines are fully processed */
            case(5): /* Result is 'ActivitySuccess' */
              LneT.add(prfx + "\tActivitySuccess (  )");
              break; /* result-lines are fully processed */
            case(6): /* Result is 'ActivityFail' */
              s = (String)cR.chgRef(null); /* get reference */
              if(s==null) { /* reference not established */
                LneT.add(TSLogg.getMsg("TSActEC7",j)); /* errormessage */
                s = TSLogg.getKey("TSActEC8"); /* set dummy-message */
                /* Attention: Message is also used within 'TSUtil.chkAct()' */
              } /* no message specified */
              LneT.add(prfx + "\tActivityFail ( " + TSUtil.modStr(s) + " )");
              break; /* result-lines are fully processed */
            case(7): /* Result is 'StartIgnoringSpeedLimits' */
              LneT.add(prfx + "\tStartIgnoringSpeedLimits (  )");
              break; /* result-lines are fully processed */
            case(8): /* Result is 'StopIgnoringSpeedLimits' */
              LneT.add(prfx + "\tStopIgnoringSpeedLimits (  )");
              break; /* result-lines are fully processed */
            default: /* unknown result-ID */
              LneT.add(TSLogg.getMsg("TSActEC9",""+j,i)); /* errormessage */
          } /* -switch- process line due to type of result */
        } /* -while- process all 'Outcomes'-entries */
        LneT.add(prfx + ")"); /* set last line of block */
        break; /* output-line-block is fully processed and created */
      case(13): /* Type is 'TextToDisplayOnCompletionIfTriggered' */
        LneT.add(prfx + "TextToDisplayOnCompletionIfTriggered ( " +
               TSUtil.modStr(Text[0]) + " )"); /* create line */
        break; /* output-line-block is fully processed and created */
      case(14): /* Type is 'TextToDisplayOnCompletionIfNotTriggered' */
        LneT.add(prfx + "TextToDisplayOnCompletionIfNotTriggered ( " +
               TSUtil.modStr(Text[1]) + " )"); /* create line */
        break; /* output-line-block is fully processed and created */
      case(15): /* Type is 'TextToDisplayDescriptionOfTask' */
        LneT.add(prfx + "TextToDisplayDescriptionOfTask ( " +
               TSUtil.modStr(Text[2]) + " )"); /* create line */
        break; /* output-line-block is fully processed and created */
      case(16): /* Type is 'Reversable_Event' */
        LneT.add(prfx + "Reversable_Event ( )"); /* create line */
        break; /* output-line-block is fully processed and created */
      case(17): /* Type is 'Name' */
        LneT.add(prfx + "Name ( " + TSUtil.modStr(Name) + " )");
        break; /* output-line-block is fully processed and created */
      case(18): /* Type is 'Time' */
        LneT.add(prfx + "Time ( " + Tme + " )"); /* create line */
        break; /* output-line-block is fully processed and created */
      case(19): /* Type is 'Location' */
        LneT.add(prfx + "Location (" + Pos.getPos(5) + " )");
        break; /* output-line-block is fully processed and created */
      case(20): /* Type is 'TriggerOnStop' */
        LneT.add(prfx + "TriggerOnStop ( "+(ToS?"1":"0")+" )"); /* create line */
        break; /* output-line-block is fully processed and created */
      case(21): /* Type is 'StationStop' */
        if(StStp==null) throw new IllegalStateException( /* integrity? */
          TSLogg.getMsg("Msg908","StStp==null","TSActEv.crDef(21)",0));
        cStp = (TSStStp)StStp.chgRef(null); /* get reference */
        if(cStp==null) { /* no reference established */
          i = StStp.chgNr(Integer.MIN_VALUE); /* original value */
          LneT.add(TSLogg.getMsg("TSActECA",i)); /* errormessage */
        } else { /* get ID of referenced StationStop */
          StpT = (ArrayList<TSStStp>)TSUtil.RetVal; /* get special argument */
          if(StpT==null) throw new IllegalStateException( /* integrity? */
            TSLogg.getMsg("Msg908","StpT==null","TSActEv.crDef(21)",1));
          i = StpT.indexOf(cStp); /* get relative number of entry */
          if(i<0) { /* entry is NOT found within table */
            i = StStp.chgNr(Integer.MIN_VALUE); /* original value */
            LneT.add(TSLogg.getMsg("TSActECB",i)); /* errormessage */
          } /* 'StationStop'-entry missing */
        } /* get relative ID of referenced StationStop */
        LneT.add(prfx + "\tStationStop ( " + i + " )");
        break; /* output-line-block is fully processed and created */
      case(22): /* Type is 'Speed' */
        LneT.add(prfx + "Speed (" + TSUtil.putFV(Spd,0) + " )");
        break; /* output-line-block is fully processed and created */
      case(23): /* Type is 'Wagon_List' */
        LneT.add(prfx + "Wagon_List ( "); /* set first line of block */
        cI = WgnT.iterator(); /* get iterator of all definitions */
        j = -1; /* preset number of entry (first number is '0') */
        while(cI.hasNext()) { /* process all 'Wagon_List'-entries */
          cR = cI.next(); /* get next 'Wagon_List'-entry */
          j += 1; /* advance number to next entry */
          LneT.add(prfx + "\tUiD ( " + /* create output-line and add it */
            (((long)cR.chgIx(Integer.MIN_VALUE))&4294967295L) + " )");
          i = cR.chgNr(Integer.MIN_VALUE); /* get number of 'SidingItem' */
          if(i==-1) { /* no 'SidingItem' specified -- use 'Description ' */
            LneT.add(prfx + "\tSidingItem ( 4294967295 )");
            s = (String)cR.chgRef(null); /* get reference to description */
            LneT.add(prfx + "\tDescription ( " + TSUtil.modStr(s) + " )");
          } else { /* 'SidingItem' specified -- process it */
            cIt = (TSTrItm03)cR.chgRef(null); /* get reference */
            if(cIt==null) /* reference not established */
              LneT.add(TSLogg.getMsg("TSActECC",""+j,i)); /* errormessage */
            else i = cIt.getNr(false); /* get ID of referenced object */
            LneT.add(prfx + "\tSidingItem ( " + i + " )");
          } /* all values of this definition are processed */
        } /* -while- process all 'Wagon_List'-entries */
        LneT.add(prfx + ")"); /* set last line of block */
        break; /* output-line-block is fully processed and created */
      case(24): /* Type is 'SidingItem' */
        cIt = (TSTrItm03)Itm.chgRef(null); /* get reference */
        if(cIt==null) { /* reference not established */
          i = Itm.chgNr(Integer.MIN_VALUE); /* original */
          LneT.add(TSLogg.getMsg("TSActECD",i)); /* errormessage */
        } else i = cIt.getNr(false); /* get ID of referenced event */
        LneT.add(prfx + "SidingItem ( " + i + " )");
        break; /* output-line-block is fully processed and created */
      default: /* unknown type -- return dummy */
        LneT.add(TSLogg.getMsg("TSActECZ",t)); /* errormessage */
    } /* -switch- line-block was created due to type */
    return LneT.iterator(); /* return iterator for result */
  }

 /**. <pre>
  *=====================================================================
  * Method "fndTrI"
  * Search TrItem-Database for TrItem-reference within 'Itm'.
  *   Register result within 'cRef'-entry if found.
  * Method returns the connected TrItem-element to enable further
  *   checking.
  * Method also stores current TrItem-NUMBER to 'RetVal' for error-
  *   processing if requested element is not found.
  * ##fndTrI.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSTrItm fndTrI( /* search for TrItem-definition */
   TSRoute cR) /* reference to current route (base) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(Itm==null) return null; /* TrItem-reference not available */
    TSUtil.RetVal = new Integer(Itm.chgNr(Integer.MIN_VALUE));
     /* set current reference-number (for error) */
    return cR.fndTrI(0,Itm); /* search for TrItem and return it */
  }

 /**. <pre>
  *=====================================================================
  * Method "fndWrld"
  * Search world-definiton of 'Location'-value and insert it
  * Method returns an error-marker or 'null' if no error
  * ##fndWrld.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String fndWrld( /* process 'Location'-value */
   TreeSet<TSQuad> QDf) /* List of defined quad-objects */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return "? ? ? ? ?"; /* report unknown error */
    if(Pos.fndWrld(QDf)!=null) return null; /* quad found -- OK */
    return Pos.getPos(5); /* return error-marker */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getAct" (static)
  * Get name of an action due to its ID ('Outcomes')
  * ##getAct.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final String getAct( /* get name of action-ID */
   int id) /* action-id to be resolved */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(id<0 || id>8) return "Unknown("+id+")"; /* return dummy-value */
    return actNme[id]; /* return requested definition */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getRslt"
  * Get an iterator for the 'Result'-Table ('Outcomes')
  * ##getRslt.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Iterator<TSRefC> getRslt() /* get iterator */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(Rslt==null) throw new /* systemerror -- terminate */
      IllegalStateException(TSLogg.getMsg("Msg904","TSActEv.getRslt()"));
    return Rslt.iterator(); /* return requested iterator */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getTyp"
  * Returns type of eevent to be used as an output-line
  * ##getTyp.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getTyp( /* get type of event as output */
   String prfx) /* prefix of the definition line */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    return prfx + typNme[Typ] + " ( )"; /* return line */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getWgn"
  * Returns current array of 'Wagon_List'-References, which is of
  *   type 'TSRefC'. If it is requested (c>0), it is created even if
  *   it is already available.
  * ##getWgn.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final ArrayList<TSRefC> getWgn( /* return reference-array */
   int c) /* expected number of definitions (used for init) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(c>0) WgnT = new ArrayList<TSRefC>(c); /* create it */
    return WgnT; /* reply with (new) Reference-table */
  }

 /**. <pre>
  *=====================================================================
  * Method "setItm"
  * Set 'SidingItem'-reference.
  * Return number of (old) reference if already set
  * Attention: TrItem-reference is modified in any case
  * ##setItm.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int setItm( /* set and modify item-reference */
   TSRefC nR) /* new reference to 'SidingItem' or 'null' */
   {
   /*-----------------------------------------------------------------*/
    int r; /* old TrItem-number (return-value) */
   /*=================================================================*/
    r = Integer.MIN_VALUE; /* set default for return */
    if(Itm!=null) r = Itm.chgNr(Integer.MIN_VALUE); /* get number */
    Itm = nR; /* insert 'new reference' / 'null' in any case */
    return r; /* return number of connected TrItem */
  }

 /**. <pre>
  *=====================================================================
  * Method "setPos"
  * Replace 'Location'-reference.
  * Current value is overwritten in any case. However, old value is
  *   returned.
  * ##setPos.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSQPos setPos( /* store position-values */
   TSQPos cP) /* new position-object */
   {
   /*-----------------------------------------------------------------*/
    TSQPos oP; /* original position of object */
   /*=================================================================*/
    oP = Pos; /* save original value if existent */
    Pos = cP; /* set new position */
    return oP; /* return with old position */
  }

 /**. <pre>
  *=====================================================================
  * Method "setToS"
  * Activate 'TriggerOnStop'.
  * Current value is overwritten in any case. However, old value is
  *   returned.
  * ##setToS.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean setToS() /* activate 'TriggerOnStop' */
   {
   /*-----------------------------------------------------------------*/
    boolean oV; /* original value of switch */
   /*=================================================================*/
    oV = ToS; /* save original value if existent */
    ToS = true; /* activate 'TriggerOnStop' */
    return oV; /* return previous value */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSActEv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String skip = TSUtil.CRLF + "                "; /* next line */
   /*-----------------------------------------------------------------*/
    String rs;     /* result, intermediate result */
    TSRefC cRef;   /* current reference-entry */
    int    i,j,jl; /* intermediate value */
   /*=================================================================*/
    rs = "TSActEv{" + Typ + ",'"; /* beginning */
    if(Name==null) rs += "<null>"; else rs += Name;
    rs+= "'," + ID + "(" + Lvl + "),('"; /* next values */
    if(Text[0]==null) rs += "<null>"; else rs += Text[0];
    rs += "','"; /* separator */
    if(Text[1]==null) rs += "<null>"; else rs += Text[1];
    rs += "','"; /* separator */
    if(Text[2]==null) rs += "<null>"; else rs += Text[2];
    rs += "',("; /* next separator */
    jl = rs.length(); /* newline-control */
    for(i=0;i<Rslt.size();i+=1) { /* add all results ('Outcomes') */
      if(i>0) rs += ","; /* add separator */
      cRef = Rslt.get(i); /* get current entry and process it */
      rs += cRef.chgIx(Integer.MIN_VALUE) + "(";
      if((j=cRef.chgNr(Integer.MIN_VALUE))<0) /* not set */
        rs += "?,"; else rs += j + ",";
      if(cRef.chgRef(null)==null) /* not set */
        rs += "<null>)"; else rs += "<set>)";
    } /* process all entries */
    j = 0; /* newline-control */
    if(WgnT==null) rs += ")-0("; /* keine Eintraege */
    else { /* entries may exist -- set prefix */
      rs += ")-" + skip + WgnT.size() + "("; /* add prefix */
      for(i=0;i<WgnT.size();i+=1) { /* add ALL entries */
        if(i>0) rs += ","; /* insert separator */
        if(((rs.length()-jl)/TSUtil.ZL)>j) { /* newline needed? */
          rs += skip; j += 1; /* insert skip to new line */
        } /* newline-control handled */
        rs += WgnT.get(i).toStr(); /* add object-definition */
      } /* add ALL object-definitions */
    } /* definitions found */
    rs += ")," + skip; /* add next separator */
    if(Itm==null) rs += "<null>"; else rs += Itm.toStr();
    if(StStp==null) rs += ",<null>"; else rs += "," + StStp.toStr();
    if(Tme==Integer.MIN_VALUE) rs += ",(<NoTme>"; else rs += ",("+Tme;
    if(Pos==null) rs += "),<null>"; else rs += ")," + Pos.toStr();
    rs += "," + super.toStr() + "}"; /* terminate definition */
    return rs; /* return result */
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSActSZ -- Attribute-defininition within a Activity
 *   Type: ActivityRestrictedSpeedZone
 * ##TSActSZ (Eyecatcher)
 *======================================================================
 </pre>*/
class TSActSZ implements Serializable { /* Activity: (RestrSpeedZone) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.03 19.06.2009";
 /*-------------------------------------------------------------------*/
  private TSQPos[]              Pos;    /* start/end of speed-zone */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) create default-entry
  *=====================================================================
  </pre>*/
  protected TSActSZ() /* Definition of 'ActivityRestrictedSpeedZone' */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    Pos = new TSQPos[2]; /* create array of position-values */
    Pos[0] = null; /* start of 'RestrictedSpeedZone' is not defined */
    Pos[1] = null; /* end of 'RestrictedSpeedZone' is not defined */
  }

 /**. <pre>
  *=====================================================================
  * Method "getPos"
  * Get position-object due to type-number
  * ##getPos.TSActSZ (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQPos getPos( /* get position-value */
   int pt) /* number of position-type */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(Pos==null) throw new /* terminate program with systemerror */
      IllegalStateException(TSLogg.getMsg("Msg904","TSActSZ.getPos()"));
    if(pt<0 || pt>1) return null; /* object not locatable */
    return Pos[pt]; /* return object or 'null' */
  }

 /**. <pre>
  *=====================================================================
  * Method "isComplete"
  * Check if all reqired definitions are present
  * Method returns 'false' if the definition is complete
  * ##isComplete.TSActSZ (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isComplete() /* check if definiton is complete */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(Pos==null) throw new /* terminate program with systemerror */
      IllegalStateException(TSLogg.getMsg("Msg904","TSActSZ.isComplete()"));
    return Pos[0]==null || Pos[1]==null; /* return result */
  }

 /**. <pre>
  *=====================================================================
  * Method "setPos"
  * Store position-object due to type-number
  * Attention: 'RetVal' is used!
  * ##setPos.TSActSZ (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setPos( /* store position-values */
   int    pt, /* number of position-type */
   TSQPos cP) /* new position-object */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(pt<0 || pt>1) return TSLogg.getMsg("TSActSP0",pt);
    if(Pos==null) return TSLogg.getMsg("TSActSP1",pt);
    TSUtil.RetVal = Pos[pt]; /* save original value if existent */
    Pos[pt] = cP; /* set new position */
    return null; /* return without error-marker */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSActSZ (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = "TSActSZ{"; /* beginning */
    if(Pos==null) rs += "(<null>,<null>)"; /* position not init */
    else { /* Pos-array is defined */
      if(Pos[0]==null) rs += "<null>"; else rs += Pos[0].toStr();
      rs += ","; /* add separator */
      if(Pos[1]==null) rs += "<null>"; else rs += Pos[1].toStr();
    } /* Pos-array is defined */
    rs += "}"; /* terminate definition */
    return rs; /* return result */
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSPath -- Definition einer Pfad-Definition fuer Activities
 * ##TSPath (Eyecatcher)
 *======================================================================
 </pre>*/
class TSPath extends TSData { /* Activity-Pfad-Eintrag */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.3.09 20.04.2007";
  protected static final int    reqMsk = 0x000003D3; /* Zeilen (req) */
  protected static String[]     reqNme = { /* Namen der req. Items */
    "Serial","TrackPDPs","TrPathName","Name","TrPathStart",
    "TrPathEnd","TrPathNodes"};
 /*-------------------------------------------------------------------*/
  private int                   Flag;   /* Flag-Definitionen */
  private int                   Cnt;    /* Zaehler fuer Referenzen */
  private String                FNme;   /* Name of the path-file */
  private ArrayList<TSPatPDP>   PDPs;   /* PDP-Definitionen */
  private ArrayList<TSPatNde>   Ndes;   /* Node-Definitionen */
/**. <pre>
  * Options defined in optionsmask of 'TSOpts':
  *    0 - entry 'Serial' was found, processed and stored
  *    1 - 'PDP'-table stored
  *    2 -
  *    3 -
  *    4 - entry 'TrPathName' was found, processed and stored
  *    5 - entry 'TrPathFlags' was found, processed and stored
  *    6 - entry 'Name' was found, processed and stored
  *    7 - entry 'TrPathStart' was found, processed and stored
  *    8 - entry 'TrPathEnd' was found, processed and stored
  *    9 - 'PathNode'-table stored (table contains elements)
  *   10 -
  *   11 -
  *   12 -
  *   13 -
  *   14 -
  *   15 -
  *   16 - Error found within 'Path-Definition'
  *   17 - Hoehenwert in (min. einem) PDP-Eintrag veraendert
  *   18 - PDP-table contains 'null'-entries (min. one)
  *   19 -
  *   31 - Reserviert fuer temporaere Kennzeichnung
  * Flag-Definitionen (soweit bekannt):
  *   4 -
  *   5 - Pfad ist vom Spieler nicht befahrbar
  *  Wenn KEIN Bit gesetzt ist, werden Flag-Definitionen nicht angegeben.
  *
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.0(S) - Name des Pfades 'TrPathName'
  *   0.1(S) - Pfad-Name (Anzeigename) 'Name'
  *   0.2(S) - Start-Bezeichnung des Pfades 'TrPathStart'
  *   0.3(S) - End-Bezeichnung des Pfades 'TrPathEnd'
  *   1.0(I) - Serial-Nummer des Pfades
  *   Der 'TrPathName' entspricht immer dem Dateinamen (ohne Endung)
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSPath() /* Pfad-Definition (Basis) erstellen */
   {
    super();  /* 'TSData' setzen (2 Arrays) (--- Restriktion ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    /* Serial-Nummer ist Default auf 'MIN_VALUE' gesetzt */
    /* all other variables are initialized by default ('0' / 'null') */
//    Flag = 0;    /* keine Flags definiert */
//    Cnt  = 0;    /* noch keine Referenz zum zaehlen */
//    PDPs = null; /* noch keine PDP-Definitionen vorhanden */
//    Ndes = null; /* noch keine Node-Definitionen vorhanden */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSPath( /* Pfad-Definition erstellen */
   String fn) /* Dateiname des Pfades */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    FNme = fn; /* store current name of the file */
  }

 /**. <pre>
  *=====================================================================
  * Method "getName"
  * Returns current file-name of the object
  * If argument equals 'false' the file-name is returned modified to be
  *   used as a key (lowerCase and without suffix)
  * ##getName.TSPath (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* get (modified) filename of the object */
   boolean mde) /* mode of filename */
   {
   /*-----------------------------------------------------------------*/
    String cNme; /* intermediate value */
   /*=================================================================*/
    if(mde) return FNme; /* return filename unmodified */
    cNme = FNme.toLowerCase(); /* process name for key-usage */
    cNme = cNme.substring(0,cNme.indexOf(".pat")); /* delete suffix */
    return cNme; /* return filename using key-form */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getPDP"
  * Aktuelles Array fuer TrackPDP's setzen oder liefern
  * Wenn der Speicher noch nicht angelegt ist, wird er ggf.ohne
  *   aktuelle Elemente generiert (falls gefordert)
  * ##getPDP.TSPath (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSPatPDP> getPDP( /* Array der PDP-Def's liefern */
   int c) /* Anzahl der PDP-Definitionen (init) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(PDPs==null && c>0) PDPs = new ArrayList<TSPatPDP>(c); /* erst */
    return PDPs; /* Elemente-Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getPNde"
  * Aktuelles Array fuer TrackPathNode's setzen oder liefern
  * Wenn der Speicher noch nicht angelegt ist, wird er ggf.ohne
  *   aktuelle Elemente generiert (falls gefordert)
  * ##getPNde.TSPath (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSPatNde> getPNde( /* Array der TrackPathNode's */
   int c) /* Anzahl der TrackPathNode's (init) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Ndes==null && c>0) Ndes = new ArrayList<TSPatNde>(c); /* erst. */
    return Ndes; /* Elemente-Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt"
  * Increment reference-counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt.TSPath (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = Cnt; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-Cnt); /* must not become negative */
    Cnt += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "setFlag"
  * Set new flag-value for path-definition.
  * Value is chanded in every case and OLD one is returned.
  * Value can be ONLY resumed if used twice:
  *   e.g.: setFlag(i=setFlag(0))
  * ##setFlag.TSPath (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int setFlag( /* Wert fuer Flag-Definitionen setzen */
   int w) /* neuen Wert */
   {
   /*-----------------------------------------------------------------*/
    int i;   /* intermediate value */
   /*=================================================================*/
    i  = Flag; /* alten Wert merken */
    Flag = w; /* neuen Wert setzen */
    return i; /* alten Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSPath (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String   rs;   /* result-string */
    int      i;    /* intermediate value */
    TSPatPDP cPDP; /* aktuelles PDP-Element */
    TSPatNde cNde; /* aktuelles PathNode-Element */
    Iterator cI;   /* allgemeiner Tabellen-Iterator */
   /*=================================================================*/
    i = 0; /* fuer Umbruch */
    rs = "TSPath{'" + FNme + "'-" + Cnt + "-" + Flag; /* Basisteil */
    if(PDPs==null) rs += "-0("; /* keine Pfad-Punkte */
    else { /* PDP-Eintraege existieren */
      rs += "-" + PDPs.size() + "("; /* Vorlauf setzen */
      cI = PDPs.iterator(); /* Iterator fuer PDP-Definitionen */
      cPDP = null; /* Steuerung initialisieren */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        if(cPDP!=null) rs += ","; /* Trennzeichen einfgen */
        if((rs.length()/TSUtil.ZL)>i) { /* Zeilenumbruch einfuegen */
          i += 1; /* naechster Umbruch vorsehen */
          rs += TSUtil.CRLF + "                ";
        } /* Umbruch-Steuerung erfolgt */
        cPDP = (TSPatPDP)cI.next(); /* naechstes PDP-Element */
        if(cPDP==null) rs += "<null>"; /* mark invalid slot */
        else rs += cPDP.toStr(); /* Element-Definition hinzufuegen */
      } /* alle Definitionen hinzufuegen */
    } /* Definitionen waren vorhanden */
    if(Ndes==null) rs += ")-0("; /* keine PathNodes */
    else { /* PathNode-Eintraege existieren */
      rs += ")-" + Ndes.size() + "("; /* Vorlauf setzen */
      cI = Ndes.iterator(); /* Iterator fuer PathNode-Definitionen */
      cNde = null; /* Steuerung initialisieren */
      while(cI.hasNext()) { /* Weitere Definitionen vorhanden */
        if(cNde!=null) rs += ","; /* Trennzeichen einfgen */
        if((rs.length()/TSUtil.ZL)>i) { /* Zeilenumbruch einfuegen */
          i += 1; /* naechster Umbruch vorsehen */
          rs += TSUtil.CRLF + "                ";
        } /* Umbruch-Steuerung erfolgt */
        cNde = (TSPatNde)cI.next(); /* naechstes PathNode-Element */
        rs += cNde.toStr(); /* Element-Definition hinzufuegen */
      } /* alle Definitionen hinzufuegen */
    } /* Definitionen waren vorhanden */
    rs += ")-" + super.toStr() + "}"; /* Abschluss der Klasseninstanz */
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSPatPDP -- Pathpoint-definitions (PDP) of a path.
 *                   (PDP = Path-Definition-Point)
 * Attention: Syntactically invalid entries remain in the list of
 *            Pathpoint-entries. However, they are marked as
 *            'null'-entries.
 * ##TSPatPDP (Eyecatcher)
 *======================================================================
 </pre>*/
class TSPatPDP implements Serializable { /* PDP-Eintrag eines Pfades */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 11.08.2008";
  protected static double       chkTol = 0.5; /* Toleranz */
 /*-------------------------------------------------------------------*/
  private int                   Ix;     /* Index-Nummer des Eintrags */
  private int                   Typ;    /* Typ-Kennung des Eintrags */
  private int                   Opt;    /* Subtyp oder Optionen */
  private int                   Cnt;    /* Zaehler fuer Referenzen */
  private TSQPos                Pos;    /* Position (incl. Quad) + Ref */
  private TSVector              Nde;    /* reference to tdb-Node */
  private boolean               corrY;  /* Hoehenwert veraendert ? */
/**. <pre>
  * PDP-Typen: Typ    Opt    Bedeutung
  *             2      0     Junction-Node
  *             1      1     Startpunkt/Endpunkt/Wendepunkt
  *             1      x     ?
  =====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSPatPDP() /* PDP-Pfad-Definition (Basis) erstellen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Ix    = -1;    /* Index noch nicht bekannt */
    /* all other variables are initialized by default ('0' / 'null') */
//    Typ   = 0;     /* PDP-Typ nicht gesetzt */
//    Opt   = 0;     /* PDP-Optionen (Subtyp) nicht gesetzt */
//    Cnt   = 0;     /* noch keine Referenz zum zaehlen */
//    Pos   = null;  /* noch keine Positionsdefinition vorhanden */
//    Nde   = null;  /* noch keine Node-Referenz definiert */
//    corrY = false; /* Hoehenwert wurde NICHT angepasst */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSPatPDP( /* create PDP-Path-definion */
   int    ix, /* Index-Number of entry */
   TSQPos cP, /* Positionsdefinition (incl. Quad) */
   int    t,  /* new PDP-type */
   int    o)  /* new PDP-options */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Ix  = ix; /* insert current index */
    Pos = cP; /* insert definition of position */
    Typ = t;  /* activate this PDP-type */
    Opt = o;  /* and insert options */
  }

 /**. <pre>
  *=====================================================================
  * Methode "adjHgt"
  * Hoehenwert eines Knotens anpassen
  *   Ergebniswert muss nicht geprueft werden
  * ##adjHgt.TSPatPDP (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String adjHgt( /* Hoehenwert veraendern */
   double d) /* Korrekturwert der Hoehe */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return TSLogg.getKey("TSPatA01");
    if(d!=0.0) corrY = true; /* Hoehenwert wurde veraendert */
    Pos.addPosY(d); /* Hoehenwert korrigieren */
//    if((i=Pos.addPosY(d))!=0) return TSLogg.getMsg("TSPatA02",i);
    return null; /* Methode beenden -- kein Fehler */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNr"
  * Nummer des PDP-Eintrages abfragen oder aendern
  * ##chgNr.TSPatPDP (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int chgNr( /* Nummer des PDP-Eintrages aendern */
   int nr)  /* neue Nr.ID des Eintrags */
   {
   /*-----------------------------------------------------------------*/
    int cNr; /* intermediate value */
   /*=================================================================*/
    cNr = Ix; /* alten Index des Eintrags merken */
    if(nr>=0) Ix = nr; /* neuen Index eintragen */
    return cNr; /* alte Nummer liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkPos"
  * Check position-definition and add quad-reference if valid.
  * ##chkPos.TSPatPDP (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chkPos( /* check position and complete it */
   TreeSet<TSQuad> QDf) /* List of defined quad-objects */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return TSLogg.getKey("TSPatP01"); /* mark error */
    if(Pos.fndWrld(QDf)!=null) return null; /* match found -- OK */
    return TSLogg.getMsg("TSPatP02",Pos.getPos(0)); /* return message */
  }

 /**. <pre>
  *=====================================================================
  * Method "crDef"
  * Create Output-line of Pathpoint-definition
  * ##crDef.TSPatPDP (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Iterator<String> crDef( /* create output-line-block */
   ArrayList<String> LneT) /* Empty list to be filled (table) */
   {
   /*-----------------------------------------------------------------*/
    String is; /* intermediate value */
   /*=================================================================*/
    if(Nde==null) { /* TrNode-Reference is NOT set (error?) */
      if(Typ==2) LneT.add(TSLogg.getMsg("TSPatP23",Ix)); /* add msg */
      if(Pos==null) { /* error: position-reference not found */
        LneT.add(TSLogg.getMsg("TSPatP21",Ix)); /* add msg to line-blk */
        is = "0 0 0 0 0"; /* insert and use Dummy-value */
      } else { /* Positionsreference available -- use it */
        if(Pos.noRef()) LneT.add(TSLogg.getMsg("TSPatP22",Ix));
          /* original positionvalues availabe ONLY -- add message */
        is = Pos.getPos(0); /* get target-position */
      } /* Positionsreference was available */
    } else is = Nde.getPos(); /* Reference to TrackNode is available */
      /* get correct position (incl. Quad) */
    LneT.add("\tTrackPDP ( " + is + " " + Typ + " " + Opt + " )");
      /* add requested output-line */
    return LneT.iterator(); /* return iterator for result */
  }

 /**. <pre>
  *=====================================================================
  * Methode "crPos"
  * Information-Hiding: Positionswerte als TSQPos-Objekt liefern
  * Achtung: Es wird eine (shallow-)Kopie geliefert, sodass die Attribute
  *          dieses Objektes (testweise) modifiziert werden koennen,
  *          ohne das Basisobjekt zu beeinflussen
  * ##crPos.TSPatPDP (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQPos crPos() /* Positionswerte als Vector liefern */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Pos==null) return null; /* Positionswerte NICHT verfuegbar */
    return new TSQPos(Pos); /* Objekt-Kopie liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "fndNde"
  * Node-Referenz (aus Track-Nodes) suchen und registrieren
  * Im Fehlerfall wird die gespeicherte Referenz NICHT veraendert
  * ##fndNde.TSPatPDP (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String fndNde( /* TrackNode-Definition suchen */
   TSRoute cR) /* aktuelle Routenreferenz */
   {
   /*-----------------------------------------------------------------*/
    TreeSet<TSQuad>    QDf;       /* Quadrat-Definitionen */
    Iterator<TSVector> cI;        /* iterator to all vector-nodes */
    TSVector           cNde,aNde; /* current nodes to be checked */
    String             s;         /* intermediate error-message */
    double             a,av,h,hv; /* distances to be compared */
   /*=================================================================*/
    QDf = cR.chgQDf(null); /* List if quad-definitions available? */
    if(QDf==null) return TSLogg.getKey("TSPatP11"); /* systemerror */
    if((s=chkPos(QDf))!=null) return s; /* check if position valid */
    if(Typ!=2) return null; /* search done -- no error found */

    /* Jetzt: Referenz auf Junction-Point vorhanden -- aufloesen */
    cI = cR.getIt(4); /* Iterator auf Node-Definitionen liefern */
    if(cI==null) return TSLogg.getKey("TSPatP12"); /* Fehler liefern */
    aNde = null;   /* KEINE gueltige Node gespeichert */
    av   = chkTol; /* Vergleichsabstand vorbesetzen */
    hv   = 0.0; /* Hoehendifferenz vorbesetzen */
    while(cI.hasNext()) { /* Alle Eintraege durchsuchen */
      cNde = cI.next(); /* aktuelles Element holen */
      if((a=cNde.cmpAbs(Pos))>=av) continue; /* passt nicht */
      h = cNde.cmpAbs(null) - Pos.getPosY(); /* Hoehendifferenz holen */
      if(Math.abs(h)>10*chkTol) continue; /* Hoehenabstand zu gross */
      hv = h;      /* neuer Korrekturwert(Hoehe) merken */
      av = a;      /* neuer Vergleichswert merken */
      aNde = cNde; /* und Node registrieren */
    } /* alle Track-Nodes pruefen */
    if(aNde==null) return TSLogg.getMsg("TSPatP13",Pos.getPos(0));
      /* KEINE Referenz zu Node gefunden -- Fehler zurueck */
    /* Referenz zu Node gefunden -- registrieren */
    Nde = aNde; /* Referenz registrieren */
    if(Math.abs(hv)<=chkTol) return null; /* OKAY -- zurueck */
    Pos.addPosY(hv); /* neuen, korrigierten Hoehenwert setzen */
    corrY = true; /* merken dass Hoehenwert veraendert wurde */
    return null; /* ohne Fehlermeldung zurueck */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt"
  * Increment reference-counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt.TSPatPDP (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = Cnt; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-Cnt); /* must not become negative */
    Cnt += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Methode "isCorr"
  * Pruefen, ob Hoehenwert veraendert wurde
  * ##isCorr.TSPatPDP (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean isCorr() /* Hoehenwert pruefen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return corrY; /* aktuellen Wert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setPos"
  * neues Positionsobjektes speichern/ersetzen (unbedingt)
  * ##setPos.TSPatPDP (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSQPos setPos( /* Positionsobjekt speichern */
   TSQPos cP) /* neues Positionsobjekt */
   {
   /*-----------------------------------------------------------------*/
    TSQPos cPos; /* Original-Wert */
   /*=================================================================*/
    cPos = Pos; /* Originalwert sichern falls vorhanden */
    Pos = cP; /* neue Position uebertragen */
    return cPos; /* Methode beenden (Originalwert liefern) */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSPatPDP (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = "TSPatPDP{" + Ix + "," + Typ + "," + Opt + ",(";
    if(Pos!=null) rs += Pos.toStr() + "),"; /* Position hinzufuegen */
    else rs += "<null>),"; /* Keine Position vorhanden */
    rs += (Nde!=null) + "," + corrY + "}";
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Klasse TSPatNde -- Node-Definition of a path (PathNode)
 * ##TSPatNde (Eyecatcher)
 *======================================================================
 </pre>*/
class TSPatNde implements Serializable { /* Node-Eintrag fuer Pfade */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.06 23.10.2009";
 /*-------------------------------------------------------------------*/
  private int                   Ix;     /* Index-Number of entry */
  private int                   Opt;    /* Flag-Definitions */
  private int                   Cnt;    /* Reference-counter */
  private TSRefC                Nxt;    /* reference to next Node */
  private TSRefC                Alt;    /* reference to altern. Node */
  private TSPatPDP              Ref;    /* PDP-Reference (Address) */
/**. <pre>
  * Flag-Definitions (as far as known and used):
  *  0 - PDP-Referenz ist Wendepunkt
  *  3 - 'Anderer Ausgang' verwendet
  *  4 - Optionaler Routenabschnitt
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSPatNde() /* create Node-Definition (Basis) of path */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Ix   = -1;   /* Index is not known -- invalidate it */
    /* all other variables are initialized by default ('0' / 'null') */
//    Opt  = 0;    /* Flag-Definitions are not set */
//    Cnt  = 0;    /* no reference to this node */
//    Nxt  = null; /* insert dummy-reference (Next) */
//    Alt  = null; /* insert dummy-reference (Alternate) */
//    Ref  = null; /* no PDP-Reference known */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create standard-entry
  *=====================================================================
  </pre>*/
  protected TSPatNde( /* create Node-Definition of path */
   int    ix,  /* new Index-Number of entry */
   int    fLg, /* current Flag-definitions */
   TSRefC nxt, /* reference to next Node */
   TSRefC alt) /* reference to alternate Node */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Ix  = ix;  /* insert current index-number */
    Opt = fLg; /* store Flag-values as options */
    Nxt = nxt; /* insert reference to next Node */
    Alt = alt; /* insert reference to alternate Node */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNr"
  * Nummer des TrackPathNode-Eintrages abfragen oder aendern
  * ##chgNr.TSPatNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int chgNr( /* Nummer des TrackpathNode-Eintrages aendern */
   int nr)  /* neue Nr.ID des Eintrags */
   {
   /*-----------------------------------------------------------------*/
    int cNr; /* intermediate value */
   /*=================================================================*/
    cNr = Ix; /* alten Index des Eintrags merken */
    if(nr>=0) Ix = nr; /* neuen Index eintragen */
    return cNr; /* alte Nummer liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgPDP"
  * PDP-Referenz lesen oder modifizieren
  * ##chgPDP.TSPatNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSPatPDP chgPDP( /* TrackPDP-Referenz modifizieren */
   TSPatPDP cP) /* Definition PDP-Eintrags oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSPatPDP cPDP; /* intermediate value */
   /*=================================================================*/
    cPDP = Ref; /* alten Wert sichern */
    if(cP!=null) Ref = cP; /* neue Referenz einsetzen */
    return cPDP; /* alte Referenz liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkNxt"
  * Check reference of NEXT/ALTERNATE PathNode and return affected
  *   PathNode if reference is valid.
  * ##chkNxt.TSPatNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSPatNde chkNxt( /* check PathNode-reference */
   boolean nxt)  /* select connection: 'true' = 'Nxt' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC cRef; /* affected connection */
   /*=================================================================*/
    cRef = nxt ? Nxt : Alt; /* select affected connection */
    if(cRef==null) return null; /* no valid connection -- no check */
    return (TSPatNde)cRef.chgRef(null); /* return referenced PathNode */
      /* or 'null' if no valid PathNode is referenced (due to error) */
  }

 /**. <pre>
  *=====================================================================
  * Method "crDef"
  * Create Output-line of PathNode-definition
  * ##crDef.TSPatNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Iterator<String> crDef( /* create output-line-block */
   ArrayList<String> LneT) /* Empty list to be filled (table) */
   {
   /*-----------------------------------------------------------------*/
    String   is;   /* result-line */
    TSPatNde cNde; /* referenced Node */
   /*=================================================================*/
    is = "\t\tTrPathNode ( " + TSUtil.toHex(Opt,8) + " "; /* first part */
    if(Nxt==null) is += "4294967295 "; /* no reference to next Node */
    else { /* valid reference -- format it */
      if((cNde=(TSPatNde)Nxt.chgRef(null))==null) { /* Ref. not found */
        LneT.add(TSLogg.getMsg("TSPatN01",Ix)); /* add msg to line-block */
        is += Nxt.chgNr(Integer.MIN_VALUE); /* insert default-value */
      } else is += cNde.chgNr(-1); /* insert correct Index of Node */
      is += " "; /* add separator to output-line */
    } /* valid reference is created */
    if(Alt==null) is += "4294967295 "; /* no reference to alt. Node */
    else { /* valid reference -- format it */
      if((cNde=(TSPatNde)Alt.chgRef(null))==null) { /* Ref. not found */
        LneT.add(TSLogg.getMsg("TSPatN02",Ix)); /* add msg to line-block */
        is += Alt.chgNr(Integer.MIN_VALUE); /* insert default-value */
      } else is += cNde.chgNr(-1); /* insert correct Index of Node */
      is += " "; /* add separator to output-line */
    } /* valid reference is created */
    if(Ref==null) { /* Error: Reference not available */
      LneT.add(TSLogg.getMsg("TSPatN03",Ix)); /* add msg to line-block */
      is += "0"; /* insert dummy-value into output-line */
    } else is += Ref.chgNr(-1); /* insert reference-number */
    LneT.add(is + " )"); /* add requested output-line */
    return LneT.iterator(); /* return iterator for result */
  }

 /**. <pre>
  *=====================================================================
  * Method "fndNxt"
  * Resolve reference-address of NEXT/ALTERNATE PathNode and store it.
  * If the requested node cannot be found an errormessage is returned.
  *   (otherwise 'null')
  * ##fndNxt.TSPatNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String fndNxt( /* Resolve reference-address */
   boolean             nxt,  /* select connection: 'true' = 'Nxt' */
   ArrayList<TSPatNde> PNde) /* List of PathNode-definitions */
   {
   /*-----------------------------------------------------------------*/
    TSRefC             cRef;  /* affected connection */
    TSPatNde           cPNde; /* current TrackpathNode */
    Iterator<TSPatNde> cI;    /* current iterator */
    int                nr;    /* requested index of Node */
   /*=================================================================*/
    cRef = nxt ? Nxt : Alt; /* select affected connection */
    if(cRef==null) return null; /* Reference is not valid -- OK */
    nr = cRef.chgNr(Integer.MIN_VALUE); /* get req. index for search */
    cI = PNde.iterator(); /* Iterator of all entries */
    while(cI.hasNext()) { /* another node-entry available ? */
      cPNde = cI.next(); /* get current TrackpathNode */
      if(cPNde==null) throw new IllegalStateException(
        TSLogg.getMsg("Msg908","TSPatNde==null","TSPatNde.fndNxt()",0));
      if(cPNde.chgNr(-1)==nr) { /* Node found - register it  */
        cRef.chgRef(cPNde); /* insert referenced TrackPathNode */
        cPNde.incCnt(1); /* increment ref.-counter of referenced Node */
        return null; /* return with marker "no error" */
      } /* referenced Node found */
    } /* search all entries */
    return TSLogg.getMsg(nxt?"TSPatF01":"TSPatF02",nr); /* error-msg */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt"
  * Increment reference-counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt.TSPatNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = Cnt; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-Cnt); /* must not become negative */
    Cnt += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSPatNde (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = "TSPatNde{" + Ix + "," + Opt; /* begin of entry */
    rs += ",(Nxt=(" + ((Nxt==null) ? "-1,false" :
      (Nxt.chgNr(Integer.MIN_VALUE) + "," + (Nxt.chgRef(null)!=null)));
    rs += "),(Alt=(" + ((Alt==null) ? "-1,false" :
      (Alt.chgNr(Integer.MIN_VALUE) + "," + (Alt.chgRef(null)!=null)));
    rs += "),(PDP=" + (Ref!=null) + ")}";
    return rs; /* Ergebnis zurueckgeben */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSSrv -- Definition of a Service-Definition for Activities
 * ##TSSrv (Eyecatcher)
 *======================================================================
 </pre>*/
class TSSrv extends TSData { /* Service-Definition */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.6.05 14.08.2012";
  protected static final int    reqMsk = 0x0000003F; /* Zeilen (req) */
  protected static String[]     reqNme = { /* Names of req. Items */
    "Serial","Name","Train_Config","PathID","MaxWheelAcceleration",
    "Efficiency"};
 /*-------------------------------------------------------------------*/
  private String                FNme;   /* Filename of Service-file */
  private String                Name;   /* Name of service */
  private String                PNme;   /* Name of path-definition */
  private long                  State;  /* state of last modification */
  private int                   Cnt;    /* Reference-count */
  private ArrayList<TSStop>     Stop;   /* List of 'StationStop's */
  private TSPath                Path;   /* Reference to current path */
  private TSTrain               Train;  /* Reference to current train */
/**. <pre>
  * Options used within optionmask of 'TSOpt':
  *    0 - entry 'Serial' was found, processed and stored
  *    1 - entry 'Name' was found, processed and stored
  *    2 - entry 'Train_Config' was found, processed and stored
  *    3 - entry 'PathID' was found, processed and stored
  *    4 - entry 'MaxWheelAcceleration' was found, processed and stored
  *    5 - entry 'Efficiency' was found, processed and stored
  *    6 - entry 'TimeTable' was found, processed and stored
  *    7 - entry 'StartingSpeed' was found, processed and stored
  *    8 - entry 'EndingSpeed' was found, processed and stored
  *    9 - entry 'StartInWorld' was found, processed and stored
  *   10 - entry 'EndInWorld' was found, processed and stored
  *   11 - min one 'StationStop'-entry was successfully defined
  *   12 -
  *   13 -
  *   16 - Severe error found within 'Service-Definition'
  *   17 - Error found within connected path-definition
  *   18 - Referenced Path-definition not found
  *   19 - StationStop-table was resorted due to 'SkipCount'
  *   20 - Error(s) found within connected 'StationStop'-definition(s)
  *   21 -
  *   22 -
  *   23 -
  *   24 - connected path cannot be used by player
  *   31 - reserved for temporary usage
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.xx(S) - (Queue) not used
  *   1.00(I) - Serial-Nummber of Service
  *   1.01(I) - 
  *   1.02(I) - Argument for 'StartInWorld'
  *   1.03(I) - Argument for 'EndInWorld'
  *   2.00(F) - 'MaxWheelAcceleration'
  *   2.01(F) - 'Efficiency'
  *   2.02(F) - 'StartingSpeed'
  *   2.03(F) - 'EndingSpeed'
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSSrv() /* create Service-Definition (Basis) */
   {
    super(3);  /* 'TSData' uses 3 Arrays (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    /* Serial-Nummer is set to 'MIN_VALUE' by default */
//    Name  = null; /* Name of service is not set */
//    PNme  = null; /* No path-name available */
    State = Long.MIN_VALUE; /* State of modification is not known */
    /* all other variables are initialized by default ('0' / 'null') */
//    Cnt   = 0;    /* Service is not referenced until now */
//    Stop  = null; /* No list of 'StationStop' inserted */
//    Path  = null; /* No reference to current path known */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSSrv( /* create Service-Definition */
   String fn,  /* Filename of new service */
   File   dat) /* Reference to concerned file */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    FNme  = fn;                 /* transfer current filename */
    State = dat.lastModified(); /* get date and store it */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * neuen aktuellen Namen/File-Namen liefern oder aendern
  * wenn w==null: liefern aktuellen Namen (information-Hiding)
  * ##chgNme.TSSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* selektierter Name neu setzen */
   String w)  /* neue Namensdefinition */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = Name; /* alten Namen merken */
    if(w!=null) Name = w; /* neuen Namen setzen (keine Kopie) */
    return s; /* alten Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgPat"
  * aktuelle Pfad-Referenz lesen oder modifizieren
  * ##chgPat.TSSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSPath chgPat( /* Pfad-Referenz pflegen */
   TSPath cP) /* Definition der Pfad-Referenz oder 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSPath cPat; /* intermediate value */
   /*=================================================================*/
    cPat = Path; /* alten Wert sichern */
    if(cP!=null) Path = cP; /* neue Referenz einsetzen */
    return cPat; /* alten/aktuellen Referenzwert liefern */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgPNme"
  * neuen aktuellen Pfad-Namen liefern oder aendern
  * wenn w==null: liefern aktuellen Namen (information-Hiding)
  * ##chgPNme.TSSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgPNme( /* aktuellen Pfad-Namen setzen/liefern */
   String w) /* neue Namensdefinition */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = PNme; /* alten Namen merken */
    if(w!=null) PNme = w; /* neuen Namen setzen (keine Kopie) */
    return s; /* alten Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgTrn"
  * Manage current entry for train-definition. Insert or get reference.
  * If arument is 'null' reference is returned only.(information-Hiding)
  * ##chgTrn.TSSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSTrain chgTrn( /* manage reference to current train */
   TSTrain t) /* new train-reference or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSTrain cT; /* current train-reference */
   /*=================================================================*/
    cT = Train; /* save reference to current entry */
    if(t!=null) Train = t; /* insert new reference if requested */
    return cT; /* return current/old reference to train */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkDate"
  * Compare File-Date to stored one. Return stored date if greater(newer)
  * Return marker (negative-value or 0) otherwise
  * ##chkDate.TSSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final long chkDate( /* compare file-dates */
   long vDate) /* file-date to compare */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    vDate += 120000; /* add tollerance-value (2 min) */
    if(State>vDate) return State; /* return current date as newer */
    return State-vDate; /* return negative (or 0-)marker-value */
  }

 /**. <pre>
  *=====================================================================
  * Method "crDef"
  * Create an output-line-block for whole 'Service'-Definition
  * ##crDef.TSSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Iterator<String> crDef( /* create output-line-block */
   ArrayList<String> LneT, /* Empty list to be filled (table) */
   String            prfx) /* prefix of the definition lines */
   {
   /*-----------------------------------------------------------------*/
    String s; /* intermediate value */
    int    i; /* intermediate value */
    double d; /* intermediate value */
   /*=================================================================*/
    if(chkMsk(0)) /* Serial-Numner is defined */
      LneT.add(prfx + "Serial ( " + getInt(0) + " )"); /* set line */
    if(chkMsk(1)) { /* Outputblock 'Name' is requested */
      s = Name; /* get name of service */
      if(s==null) { /* error: Name of service is NOT defined */
        LneT.add(TSLogg.getKey("TSSrvC11")); /* add message to line-block */
        s = " "; /* and set dummy-value */
      } /* Name-definition was OK */
      LneT.add(prfx + "Name ( " + TSUtil.modStr(s) + " )"); /* set line */
    } /* outputblock was requested */
    if(chkMsk(2)) { /* Outputblock 'Train_Config' is requested */
      s = " "; /* preset name of consist in case of error */
      if(Train==null) /* systemerror -- no consist connected */
        LneT.add(TSLogg.getKey("TSSrvC21")); /* add message to line-block */
      else { /* reference to consist is available */
        s = Train.getName(true); /* get name of consist */
        if(Train.chkMsk(0)) /* consist is not available (not found) */
          LneT.add(TSLogg.getMsg("TSSrvC22",s)); /* add message to line-block */
      } /* consist-reference was available */
      LneT.add(prfx+"Train_Config ( "+TSUtil.modStr(s)+" )"); /* set line */
    } /* outputblock was requested */
    if(chkMsk(3)) { /* Outputblock 'PathID' is requested */
      if(Path!=null) s = Path.getDta(0); /* get name of path-definition */
      else s = null; /* set marker: no reference available */
      if(s==null) { /* error: path-name is not known */
        s = PNme; /* set original name of path-definition */
        if(s==null) { /* error: original path-name is not used, TOO */
          LneT.add(TSLogg.getKey("TSSrvC31")); /* add message */
          s = " "; /* and set dummy-value */
        } else LneT.add(TSLogg.getKey("TSSrvC32")); /* add message */
      } /* Name-definition was OK */
      LneT.add(prfx+"PathID ( "+TSUtil.modStr(s)+" )"); /* set line */
    } /* outputblock was requested */
    if(chkMsk(4)) { /* Outputblock 'MaxWheelAcceleration' is requested */
      d = getFlt(2,0); /* preset current output-value */
      if(Double.isNaN(d)) { /* error: invalid value */
        LneT.add(TSLogg.getKey("TSSrvC41")); /* add message to line-block */
        d = 0.0; /* and set dummy-value */
      } /* output-valiue is valid */
      LneT.add(prfx+"MaxWheelAcceleration ("+TSUtil.putFV(d,0)+" )");
    } /* outputblock was requested */
    if(chkMsk(5)) { /* Outputblock 'Efficiency' is requested */
      d = getFlt(2,1); /* preset current output-value */
      if(Double.isNaN(d)) { /* error: invalid value */
        LneT.add(TSLogg.getKey("TSSrvC51")); /* add message to line-block */
        d = 0.0; /* and set dummy-value */
      } /* output-valiue is valid */
      LneT.add(prfx+"Efficiency ("+TSUtil.putFV(d,3)+" )"); /* set line */
    } /* outputblock was requested */
    if(chkMsk(6)) { /* Outputblock 'TimeTable' is requested */
      LneT.add(prfx + "TimeTable ("); /* add first line of block */
      if(chkMsk(7)) { /* Outputblock 'StartingSpeed' is requested */
        d = getFlt(2,2); /* preset current output-value */
        if(Double.isNaN(d)) { /* error: invalid value */
          LneT.add(TSLogg.getKey("TSSrvC71")); /* add message to line-block */
          d = 0.0; /* and set dummy-value */
        } /* output-valiue is valid */
        LneT.add(prfx+"\tStartingSpeed ("+TSUtil.putFV(d,0)+" )");
      } /* outputblock was requested */
      if(chkMsk(8)) { /* Outputblock 'EndingSpeed' is requested */
        d = getFlt(2,3); /* preset current output-value */
        if(Double.isNaN(d)) { /* error: invalid value */
          LneT.add(TSLogg.getKey("TSSrvC81")); /* add message to line-block */
          d = 0.0; /* and set dummy-value */
        } /* output-valiue is valid */
        LneT.add(prfx+"\tEndingSpeed ("+TSUtil.putFV(d,0)+" )");
      } /* outputblock was requested */
      if(chkMsk(9)) { /* Outputblock 'StartInWorld' is requested */
        i = getInt(2); /* preset current output-value */
        if(i== Integer.MIN_VALUE) { /* error: invalid value */
          LneT.add(TSLogg.getKey("TSSrvC91")); /* add message to line-block */
          i = 0; /* and set dummy-value */
        } /* output-valiue is valid */
        LneT.add(prfx + "\tStartInWorld ( " + i + " )"); /* set line */
      } /* outputblock was requested */
      if(chkMsk(10)) { /* Outputblock 'EndInWorld' is requested */
        i = getInt(3); /* preset current output-value */
        if(i== Integer.MIN_VALUE) { /* error: invalid value */
          LneT.add(TSLogg.getKey("TSSrvCA1")); /* add message to line-block */
          i = 0; /* and set dummy-value */
        } /* output-valiue is valid */
        LneT.add(prfx + "\tEndInWorld ( " + i + " )"); /* set line */
      } /* outputblock was requested */
      s = prfx + "\t\t"; /* set new prefix for output-line */
      if(chkMsk(11)) /* Outputblock 'StationStop' is requested */
       for(i=0;i<Stop.size();i+=1) { /* process all StationStop, add lines */
        LneT.add(prfx + "\tStationStop ("); /* set first line of 'StationStop' */
        Stop.get(i).crDef(LneT,i,"-TimeTable",s); /* add 'StationStop'-def. */
        LneT.add(prfx + "\t)"); /* and add last line of block */
      } /* process all StationStop-definitions and add lines */
      LneT.add(prfx + ")"); /* add last line of 'TimeTable'-block */
    } /* outputblock was requested */
    return LneT.iterator(); /* return iterator for result */
  }

 /**. <pre>
  *=====================================================================
  * Method "getName"
  * Returns current file-name of the object
  * If argument equals 'false' the file-name is returned modified to be
  *   used as a key (lowerCase and without suffix)
  * ##getName.TSSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* get (modified) filename of the object */
   boolean mde) /* mode of filename */
   {
   /*-----------------------------------------------------------------*/
    String cNme; /* intermediate value */
   /*=================================================================*/
    if(mde) return FNme; /* return filename unmodified */
    cNme = FNme.toLowerCase(); /* process name for key-usage */
    cNme = cNme.substring(0,cNme.indexOf(".srv")); /* delete suffix */
    return cNme; /* return filename using key-form */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getStp"
  * Aktuelles Array fuer Haltepunkte liefern und ggf. (neu) erstellen
  * Wenn fuer 'c' ein Wert 'groesser 0' angegeben wird, wird die
  *   Tabelle neu angelegt. Dies erfolgt AUCH, wenn die Tabelle
  *   bereits existiert!
  * ##getStp.TSSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSStop> getStp( /* HP-Liste liefern */
   int c) /* erwartete Anzahl der Definitionen (init) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(c>0) Stop = new ArrayList<TSStop>(c); /* neu anlegen */
    return Stop; /* (neue) Haltepunkt-Tabelle liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt"
  * Increment reference-counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt.TSSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = Cnt; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-Cnt); /* must not become negative */
    Cnt += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs;  /* result-string */
    int    i,j; /* intermediate value */
    TSStop cSt; /* aktuelle Definition fuer Haltepunkt */
   /*=================================================================*/
    j = 0; /* fuer Umbruch */
    rs = "TSSrv{'" + FNme + "'-" + Cnt + "-'"; /* Basisteil */
    if(Name==null) rs += "<null>"; else rs += Name;
    rs += "','"; /* Zwischenteil einfuegen */
    if(PNme==null) rs += "<null>"; else rs += PNme;
    rs += "','"; /* Zwischenteil einfuegen */
    if(Train==null) rs += "<null>"; else rs += Train.getName(true);
    if(Stop==null) rs += "'-0("; /* keine Haltepunkte */
    else { /* Haltepunkt-Eintraege koennen existieren */
      rs += "'-" + Stop.size() + "("; /* Vorlauf setzen */
      for(i=0;i<Stop.size();i+=1) { /* alle Eintraege hinzufuegen */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        if((rs.length()/TSUtil.ZL)>j) { /* Zeilenumbruch einfuegen */
          j += 1; /* naechster Umbruch vorsehen */
          rs += TSUtil.CRLF + "                ";
        } /* Umbruch-Steuerung erfolgt */
        if((cSt=Stop.get(i))==null) rs += "<null>";
        else rs += cSt.toStr(); /* Haltepunkt aufbereiten */
      } /* alle Definitionen hinzufuegen */
    } /* Definitionen waren vorhanden */
    rs += ")-" + super.toStr() + "}"; /* Abschluss setzen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSStop -- Definition of stops within stations
 * Attention: This class is used for 'services' ONLY
 * ##TSStop (Eyecatcher)
 *======================================================================
 </pre>*/
class TSStop implements Serializable,Comparable<TSStop>{ /* Stops (S) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.06 27.11.2009";
 /*-------------------------------------------------------------------*/
  private int                   SkCnt;  /* Station-SkipCount */
  private double                Dist;   /* Station-DownDistance */
  private TSRefC                PfID;   /* Platform-reference */
  private boolean               DErr;   /* Error within distance-val. */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSStop() /* create 'StationStop'-definition (Basis) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    SkCnt = Integer.MIN_VALUE; /* no valid value inserted */
    Dist  = Double.NaN;        /* no valid value inserted */
    /* all other variables are initialized by default ('0' / 'null') */
//    PfID  = null;              /* clear platform-reference */
//    DErr  = false;             /* No error marked */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSStop( /* create 'StationStop'-definition */
   int    id,  /* Kennung des Bahnsteigs */
   int    sc,  /* Skip-Zaehler der Bahnsteige */
   double dst) /* Abstandswert */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    SkCnt = sc;  /* gelieferter Wert uebernehmen */
    Dist  = dst; /* gelieferter Wert uebernehmen */
    PfID  = new TSRefC(id);  /* create reference-object for platform */
    DErr  = false;             /* No error marked */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgID"
  * Replace TrItem-Database for TrItem-reference within 'PfID'.
  * Method returns the old platform-reference
  * Method also stores new TrItem-NUMBER to 'RetVal' for error-
  *   processing.
  * --- Method is NOT referenced until now. (marked by 'XXX...') ---
  * ##chgID.TSStop (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSRefC XXXchgID( /* replace current Platform-ID */
   TSTrItm cIt) /* new TrItem-element or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSRefC cId; /* current Platform-Reference */
    int    i;   /* intermediate value */
   /*=================================================================*/
    cId = PfID; /* save current platform-reference */
    if(cIt!=null) { /* replacement of reference is requested */
      i = cIt.getNr(false); /* get number of TrItem-definition */
      PfID = new TSRefC(i); /* build new reference */
      PfID.chgRef(cIt); /* and insert reference-value, too */
      TSUtil.RetVal = new Integer(i); /* set new reference-number */
    } /* replacement was requested */
    return cId; /* return current/old platform-reference */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkDist"
  * Check distance if it is ascending.
  * Return marker (negative value) if this not valid.
  * Attention: If this method is called using 'Double.NaN' as the
  *             argument, the current distance is returned.
  * ##chkDist.TSStop (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double chkDist( /* check current distance-value */
   double d) /* value to be compared to distance */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(Double.isNaN(d)) return Dist; /* return current distance */
    DErr = false; /* preset: No error marked */
    if(Dist>d) return Dist; /* return with new distance-value */
    DErr = true; /* mark distance-value as 'NOT CORRECT' */
    return -d; /* return with marker */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkID"
  * Compare Numbers of Platform-ID
  * Method returns '0' if ID-number is equal (else difference)
  * (Also compare to methode 'Comparable.compareTo()')
  * Attention: if this method is called using '0' as the argument,
  *            the current 'PlatformID' is returned.
  * ##chkID.TSStop (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int chkID( /* check number of platform-ID */
   int cNr) /* number of platform-ID */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(PfID==null) return Integer.MIN_VALUE; /* not found --> not equal */
    return PfID.chgNr(Integer.MIN_VALUE)-cNr; /* check equality */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkSkip"
  * Check 'Skip-Value' if it is ascending.
  * Return marker (negative value) if this not valid.
  * Attention: if this method is called using '0' as the argument,
  *            the current 'Skip-Value' is returned (because the current
  *            value is always >=0).
  * ##chkSkip.TSStop (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int chkSkip( /* check current 'Skip-Value' */
   int w) /* value to be compared to 'Skip-Value' */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    return (SkCnt<=w) ? -w : SkCnt; /* result with marker */
  }

 /**. <pre>
  *=====================================================================
  * Method "compareTo"
  * Method is used to sort Elements
  * Attention: Name of this Methode is requested by Interface
  *           'Comparable'. Results need NOT be 0,1,-1
  * Note: This class has a natural ordering that is
  *       inconsistent with equals.
  * ##compareTo.TSStop (Eyecatcher)
  *=====================================================================
  </pre>*/
  public final int compareTo( /* compare Definitions for sorting */
   TSStop vH) /* compare-object */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return SkCnt-vH.SkCnt; /* compare and return result */
  }

 /**. <pre>
  *=====================================================================
  * Method "crDef" (Version S)
  * Create an output-line-block as a 'Service-version'
  * Method returns number of created error-messages
  * ##crDef.TSStop (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int crDef( /* create output-line-block */
   ArrayList<String> LneT, /* Empty list to be filled (table) */
   int               nr,   /* number 'StationStop'-entry (used with msg) */
   String            msg,  /* prefix of the message-lines */
   String            prfx) /* prefix of the definition lines */
   {
   /*-----------------------------------------------------------------*/
    int     i,c; /* intermediate value, counter */
    double  d;   /* intermediate value */
    TSTrItm cIt; /* intermediate value */
   /*=================================================================*/
    c = 0; /* preset: no messages created */
    /* 'PlatformStartID' */
    if(PfID==null) { /* no reference available -- report it */
      LneT.add(TSLogg.getMsg("TSStop1",msg,nr)); /* add error-message */
      i = 0; /* and set dummy-value for platform */
      c += 1; /* count error-message */
    } else if((cIt=(TSTrItm)PfID.chgRef(null))==null) { /* Original */
      i = PfID.chgNr(Integer.MIN_VALUE); /* get original value */
      LneT.add(TSLogg.getMsg("TSStop2",msg,nr,i)); /* add error-message */
      c += 1; /* count error-message */
    } else i = cIt.getNr(false); /* get current value from platform */
    LneT.add(prfx + "PlatformStartID ( " + i + " )"); /* set next line */
    /* 'DistanceDownPath' */
    d = Dist; /* get default-Value */
    if(Double.isNaN(d)) { /* error: invalid value found */
      LneT.add(TSLogg.getMsg("TSStop3",msg,nr)); /* add error-message */
      c += 1; /* count error-message */
      d = 0.0; /* and set dummy-value */
    } /* stored value is valid -- use it */
    LneT.add(prfx + "DistanceDownPath (" + TSUtil.putFV(d,0) + " )");
    /* 'SkipCount' */
    i = SkCnt; /* get default-Value */
    if(i==Integer.MIN_VALUE) { /* error: invalid value found */
      LneT.add(TSLogg.getMsg("TSStop4",msg,nr)); /* add error-message */
      c += 1; /* count error-message */
      i = 0; /* and set dummy-value */
    } /* stored value is valid -- use it */
    LneT.add(prfx + "SkipCount ( " + i + " )"); /* set next line */
    return c; /* return number of messages */
  }

 /**. <pre>
  *=====================================================================
  * Method "crDef" (Version A/T)
  * Create an output-line-block due to requested type
  * ##crDef.TSStop (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int crDef( /* create output-line-block */
   ArrayList<String> LneT, /* Empty list to be filled (table) */
   int               nr,   /* number 'StationStop'-entry (used with msg) */
   String            prfx) /* prefix of the definition lines */
   {
   /*-----------------------------------------------------------------*/
    int     i,c; /* intermediate value, counter */
    double  d;   /* intermediate value */
    TSTrItm cIt; /* intermediate value */
   /*=================================================================*/
    c = 0; /* preset: no messages created */
    /* 'SkipCount' */
    i = SkCnt; /* get default-Value */
    if(i==Integer.MIN_VALUE) { /* error: invalid value found */
      LneT.add(TSLogg.getMsg("TSStop4","",nr)); /* add error-message */
      c += 1; /* count error-message */
      i = 0; /* and set dummy-value */
    } /* stored value is valid -- use it */
    LneT.add(prfx + "SkipCount ( " + i + " )"); /* set next line */
    /* 'DistanceDownPath' */
    d = Dist; /* get default-Value */
    if(Double.isNaN(d)) { /* error: invalid value found */
      LneT.add(TSLogg.getMsg("TSStop3","",nr)); /* add error-message */
      c += 1; /* count error-message */
      d = 0.0; /* and set dummy-value */
    } /* stored value is valid -- use it */
    LneT.add(prfx + "DistanceDownPath (" + TSUtil.putFV(d,0) + " )");
    /* 'PlatformStartID' */
    if(PfID==null) { /* no reference available -- report it */
      LneT.add(TSLogg.getMsg("TSStop1","",nr)); /* add error-message */
      c += 1; /* count error-message */
      i = 0; /* and set dummy-value for platform */
    } else if((cIt=(TSTrItm)PfID.chgRef(null))==null) { /* Original */
      i = PfID.chgNr(Integer.MIN_VALUE); /* get original value */
      LneT.add(TSLogg.getMsg("TSStop2","",nr,i)); /* add error-message */
      c += 1; /* count error-message */
    } else i = cIt.getNr(false); /* get current value from platform */
    LneT.add(prfx + "PlatformStartID ( " + i + " )"); /* set next line */
    return c; /* return number of messages */
  }

 /**. <pre>
  *=====================================================================
  * Method "fndTrI"
  * Search TrItem-Database for TrItem-reference within 'PfID'.
  *   Register result within 'cRef'-entry if found.
  * Method returns the connected TrItem-element to enable further
  *   checking.
  * Method also stores current TrItem-NUMBER to 'RetVal' for error-
  *   processing if requested element is not found.
  * ##fndTrI.TSStop (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSTrItm fndTrI( /* search for TrItem-definition */
   TSRoute cR) /* reference to current route (base) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(PfID==null) return null; /* TrItem-reference not available */
    TSUtil.RetVal = new Integer(PfID.chgNr(Integer.MIN_VALUE));
     /* set current reference-number (for error) */
    return cR.fndTrI(0,PfID); /* search for TrItem and return it */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSStop (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = "TSStop{";
    rs += (PfID==null) ? "<null>" : PfID.chgNr(Integer.MIN_VALUE);
    rs += "," + Dist + "," + SkCnt;
    rs += (PfID==null)?",<null>}":",<"+(PfID.chgRef(null)!=null)+">}";
    return rs; /* Ergebnis zurueckgeben */
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSTrf -- Definition einer Traffic-Definition fuer Activities
 * ##TSTrf (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTrf extends TSData { /* Traffic-definition */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.03 14.07.2009";
 /*-------------------------------------------------------------------*/
  private String                FNme;   /* Filename of traffic-file */
  private String                Name;   /* Traffic-Name */
  private long                  State;  /* state of last modification */
  private int                   Cnt;    /* Reference-count */
  private ArrayList<TSXtSrv>    Serv;   /* List of (ext.) services */
/**. <pre>
  * Used options (stored within mask of 'TSOpt'):
  *        0 - entry 'Serial' was found, processed and stored
  *        1 -
  *        2 -
  *  3 to 15 - not used
  *       16 - Severe error found within 'Traffic-Definition'
  *       17 - Error found within a connected service-definition
  *       18 - Error within 'StationStop'-assignment of traffic-definition
  *       19 - Service-table was resorted due to 'Start-Time'
  *       20 -
  *       31 - reserved for temporary usage
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.xx(S) - (Queue) not used
  *   1.00(I) - Serial-Number of Traffic
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSTrf() /* create Traffic-Definition (Basis) */
   {
    super();  /* set 'TSData' (2 Arrays) (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    /* Serial-Nummer is set to 'MIN_VALUE' by default */
//    FNme  = null; /* No File-Name of traffic available */
//    Name  = null; /* Name of traffic is not set */
    State = Long.MIN_VALUE; /* State of modification is not known */
    /* all other variables are initialized by default ('0' / 'null') */
//    Cnt   = 0;    /* Traffic is not referenced until now */
//    Serv  = null; /* No list of services inserted */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSTrf( /* create Traffic-Definition */
   String fn,  /* Filename of new traffic-definition */
   File   dat) /* Reference to concerned file */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    FNme  = fn;                 /* transfer current filename */
    State = dat.lastModified(); /* get date and store it */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgNme"
  * neuen aktuellen Namen/File-Namen liefern oder aendern
  * wenn w==null: liefern aktuellen Namen (information-Hiding)
  * ##chgNme.TSTrf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chgNme( /* selektierter Name neu setzen */
   String w)  /* neue Namensdefinition */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
   /*=================================================================*/
    s = Name; /* alten Namen merken */
    if(w!=null) Name = w; /* neuen Namen setzen (keine Kopie) */
    return s; /* alten Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkDate"
  * Compare File-Date to stored one. Return stored date if greater(newer)
  * Return marker (negative-value or 0) otherwise
  * ##chkDate.TSTrf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final long chkDate( /* compare file-dates */
   long vDate) /* file-date to compare */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    vDate += 120000; /* add tollerance-value (2 min) */
    if(State>vDate) return State; /* return current date as newer */
    return State-vDate; /* return negative (or 0-)marker-value */
  }

 /**. <pre>
  *=====================================================================
  * Method "getName"
  * Returns current file-name of the object
  * If argument equals 'false' the file-name is returned modified to be
  *   used as a key (lowerCase and without suffix)
  * ##getName.TSTrf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName( /* get (modified) filename of the object */
   boolean mde) /* mode of filename */
   {
   /*-----------------------------------------------------------------*/
    String cNme; /* intermediate value */
   /*=================================================================*/
    if(mde) return FNme; /* return filename unmodified */
    cNme = FNme.toLowerCase(); /* process name for key-usage */
    cNme = cNme.substring(0,cNme.indexOf(".trf")); /* delete suffix */
    return cNme; /* return filename using key-form */
  }

 /**. <pre>
  *=====================================================================
  * Method "fndSrv"
  * Find special service within list of all service-definitions.
  * Return list of StationStops of service if found.
  * ##fndSrv.TSTrf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final ArrayList<TSStStp> fndSrv( /* find service within list */
   String nme) /* Name of requested service (key-form) */
   {
   /*-----------------------------------------------------------------*/
    Iterator<TSXtSrv> SrvI; /* Iterator for Traffic-Service-Def's */
    TSXtSrv           cSrv; /* current service-definition */
   /*=================================================================*/
    if(Serv==null) return null; /* no service defined -- return */
    SrvI = Serv.iterator(); /* create iterator for all services */
    while(SrvI.hasNext()) { /* more -Service-Definitions available? */
      cSrv = SrvI.next(); /* get extended Service-Definition */
      if(cSrv==null) continue; /* skip if not present */
      if(!nme.equalsIgnoreCase(cSrv.getName())) continue;
        /* service-definition does not match requested one */
      return cSrv.getStp(0); /* return requested list of 'StationStops' */
    } /* -while- check all available service-definitions */
    return null; /* return marker -- service not found */
  }

 /**. <pre>
  *=====================================================================
  * Method "getSrv"
  * Get current list of (extended) service-definitions. Create it, if
  *   neccessary.
  * If the argumnent ('c') specifies a positive value (c>0) an new
  *   table is created and inserted. A potentially existing table is
  *   overwritten in this case.
  * ##getSrv.TSTrf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSXtSrv> getSrv( /* get service-list */
   int c) /* expected number of entries within this list (init) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(c>0) Serv = new ArrayList<TSXtSrv>(c); /* create it */
    return Serv; /* return new/current service-table */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt"
  * Increment reference-counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt.TSTrf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = Cnt; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-Cnt); /* must not become negative */
    Cnt += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTrf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String  rs;   /* result-string */
    int     i,j;  /* intermediate value */
    TSXtSrv cSrv; /* aktuelle Definition Traffic-Service */
   /*=================================================================*/
    j = 0; /* fuer Umbruch */
    rs = "TSTrf{'" + FNme + "'-" + Cnt + "-'"; /* Basisteil */
    if(Name==null) rs += "<null>"; else rs += Name;
    if(Serv==null) rs += "'-0("; /* keine Haltepunkte */
    else { /* Haltepunkt-Eintraege koennen existieren */
      rs += "'-" + Serv.size() + "("; /* Vorlauf setzen */
      for(i=0;i<Serv.size();i+=1) { /* alle Eintraege hinzufuegen */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        if((rs.length()/TSUtil.ZL)>j) { /* Zeilenumbruch einfuegen */
          j += 1; /* naechster Umbruch vorsehen */
          rs += TSUtil.CRLF + "                ";
        } /* Umbruch-Steuerung erfolgt */
        if((cSrv=(TSXtSrv)Serv.get(i))==null) rs += "<null>";
        else rs += cSrv.toStr();
      } /* alle Definitionen hinzufuegen */
    } /* Definitionen waren vorhanden */
    rs += ")-" + super.toStr() + "}"; /* Abschluss setzen */
    return rs; /* Ergebnis zurueckgeben */
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSXtSrv -- Definition of an 'extended' Service-Definition.
 * This definition is used to store traffic-services which are used
 *   within traffic- and activity-definitions.
 * Type of service: 'A' or 'T' or 'A/T'
 * ##TSXtSrv (Eyecatcher)
 *======================================================================
 </pre>*/
class TSXtSrv implements Serializable,Comparable<TSXtSrv> { /* Xt-Srv */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.03 23.07.2009";
 /*-------------------------------------------------------------------*/
  private String                Name;   /* Service-Name (File) */
    /* This 'Name' equals the file-name of the service WITHOUT suffix. */
  private int                   Time;   /* 'Start-Time' of service */
  private int                   UiD;    /* ID-number of service (A) */
  private TSSrv                 Srv;    /* reference to service (S) */
  private ArrayList<TSStStp>    Stop;   /* 'StationStop'-entries */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSXtSrv() /* create extended Service-Definition (Basis) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
//    Name = null; /* name of service is still not inserted */
    Time = Integer.MIN_VALUE; /* Start-Zeitpunkt ist noch ungueltig */
    UiD  = Integer.MIN_VALUE; /* ID-number not set for activity */
    /* all other variables are initialized by default ('0' / 'null') */
//    Srv  = null; /* no reference to 'master-service' */
//    Stop = null; /* no list of 'StationStop'-entries available */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSXtSrv( /* create extended service-definition */
   String nme) /* current name of (extended) service */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    Name = nme; /* store name of service */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgSrv"
  * Manage reference to master-service-definition. Change or return it.
  * ##chgSrv.TSXtSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSSrv chgSrv( /* manage reference to master-service */
   TSSrv cs) /* reference to master-service or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSSrv cSrv; /* intermediate value */
   /*=================================================================*/
    cSrv = Srv; /* get current reference */
    if(cs!=null) Srv = cs; /* insert new reference if requested */
    return cSrv; /* return 'old current reference' */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkID"
  * Check 'Service-UID' of the current object. Return error-marker if
  *   the correct value was not encountered.
  * Attention: Due to positive values for UID, you can get the current
  *            UID, if a negative argument is specified.
  * ##chkID.TSXtSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int chkID( /* check service-uid of current obj. */
   int v)  /* ID-value to compare */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    return (UiD!=v) ? UiD : Integer.MIN_VALUE; /* return ID or marker */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkTime"
  * Check current 'Start-Time' for ascending values
  * Attention: Due to positive values for time, you can get the current
  *            time-value, if a negative argument is specified.
  * ##chkTime.TSXtSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int chkTime( /* check current 'Start-Time' */
   int t) /* Compare-value to current time */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    return (Time<t) ? -t : Time; /* get maximum (marked if error) */
  }

 /**. <pre>
  *=====================================================================
  * Method "compareTo"
  * Method is used to sort Elements
  * Attention: Name of this Methode is requested by Interface
  *           'Comparable'. Results need NOT be 0,1,-1
  * Note: This class has a natural ordering that is
  *       inconsistent with equals.
  * ##compareTo.TSXtSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  public final int compareTo( /* compare Definitions for sorting */
   TSXtSrv vS) /* compare-object */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Time-vS.Time; /* compare and return result */
  }

 /**. <pre>
  *=====================================================================
  * Method "crDef"
  * Create an output-line-block for whole 'Service'-Definition (A/T)
  * ##crDef.TSXtSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Iterator<String> crDef( /* create output-line-block */
   ArrayList<String> LneT, /* Empty list to be filled (table) */
   boolean           trf,  /* 'Traffic'-version if set (else 'Activity') */
   String            prfx) /* prefix of the definition lines */
   {
   /*-----------------------------------------------------------------*/
    String s;   /* intermediate value */
    int    i,j; /* intermediate value */
   /*=================================================================*/
    if(Srv==null) LneT.add(TSLogg.getKey("TSXSrvC1"));
      /* NO reference to service -- report that name may be incorrect */
    s = Name; /* get name of service */
    if(s==null) { /* error: Name of service is NOT defined */
      s = "Service"+Time; /* and create dummy-value from time */
      LneT.add(TSLogg.getMsg("TSXSrvC2",s)); /* add message */
    } /* Name-definition was OK */
    s = prfx + "Service_Definition ( " + TSUtil.modStr(s);
      /* set correct format of service-name, creat first part of line */
    if(Time<0) { /* Start-Time of service is not valid */
      LneT.add(TSLogg.getKey("TSXSrvC3")); /* add message to line-block */
      s += " 0"; /* add dummy-value */
    } else s += " " + Time; /* add start-time of service */
    if(Stop!=null) j = Stop.size(); /* get number of entries */
    else { /* error while creating StationStop-entries */
      LneT.add(TSLogg.getKey("TSXSrvC4")); /* add message to line-block */
      j = 0; /* no 'StationStop'-entry available */
    } /* error at StationStops */
    if(trf && j==0) { /* no following lines */
      LneT.add(s + " )"); /* set single line and */
      return LneT.iterator(); /* return iterator for result */
    } /* all lines are generated */
    LneT.add(s); /* set first line of output-block */
    if(!trf) { /* Activity-version -- insert UID-value */
      i = UiD; /* get default-Value */
      if(i==Integer.MIN_VALUE) { /* error: invalid value found */
        LneT.add(TSLogg.getKey("TSXSrvC5")); /* add error-message */
        i = 0; /* and set dummy-value */
      } /* stored value is valid -- use it */
      LneT.add(prfx + "\tUiD ( " + i + " )"); /* set next line */
    } /* UID-definition was requested */
    s = prfx + "\t"; /* set new prefix for output-line */
    /* Outputblock 'StationStop' is requested */
    for(i=0;i<j;i+=1) /* process all StationStop, add lines */
      Stop.get(i).crDef(LneT,trf,i,s); /* add 'StationStop'-def. */
    LneT.add(prfx + ")"); /* add last line of service-definition */
    return LneT.iterator(); /* return iterator for result */
  }

 /**. <pre>
  *=====================================================================
  * Method "fndTrf"
  * Correlate A-version of a 'Xt-Service' with it's T-version. If a
  *   'match is found the values are copied to the A-version.
  * Returns the 'StationStop'-table of the connected service(T) if
  *   correlation was successful (else 'null')
  * Attention: In order to select the correct traffic-entry Time-value
  *		must match, too.
  * ##fndTrf.TSXtSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSStStp> fndTrf( /* find 'Xt-Service'-correlation */
   TSTrf cTrf) /* current Traffic-definition */
   {
   /*-----------------------------------------------------------------*/
    Iterator<TSXtSrv> SrvI; /* Iterator of traffic-service-table */
    TSXtSrv           cSrv; /* current Traffic-Service-element */
   /*=================================================================*/
    if(UiD==Integer.MIN_VALUE) return null; /* No A-version - no match */
    SrvI = cTrf.getSrv(0).iterator(); /* get iterator of table */
    while(SrvI.hasNext()) { /* all 'Traffic-Service's processed ? */
      cSrv = SrvI.next(); /* get next correlationobject (T) */
      if(!cSrv.Name.equalsIgnoreCase(this.Name)) continue;
        /* services do not match('Name') -- try next one */
      if(this.Time!=cSrv.Time) continue; /* 'Start-Time' do not match */
      /* match found -- extend object */
      this.Srv = cSrv.Srv; /* copy value from traffic-version */
      return cSrv.Stop; /* signal success */
    } /* check all correlation-objects */
    return null; /* no match found -- signal it */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getName"
  * aktuellen Namen liefern
  * ##getName.TSXtSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String getName() /* Service-Name holen */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Name; /* aktuellen Namen liefern */
  }

 /**. <pre>
  *=====================================================================
  * Method "getStp"
  * Get current list of 'StationStop'-definitions. Create it, if
  *   neccessary.
  * If the argumnent ('c') specifies a positive value (c>0) an new
  *   table is created and inserted. A potentially existing table is
  *   overwritten in this case.
  * ##getStp.TSXtSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected ArrayList<TSStStp> getStp( /* get StationStop-list */
   int c) /* expected number of entries within this list (init) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    if(c>0) Stop = new ArrayList<TSStStp>(c); /* create it */
    return Stop; /* return new/current 'StationStop'-table */
  }

 /**. <pre>
  *=====================================================================
  * Method "setTime"
  * Store new 'Start-Time' of service.
  * Current value is overwritten in any case and a marker is returned,
  *   if the new value overwrites a valid value.
  * ##setTime.TSXtSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected boolean setTime( /* set new 'Start-Time' of service */
   int z)  /* new 'Start-Time'-value of (ext.) service */
   {
   /*-----------------------------------------------------------------*/
    boolean rslt; /* result: value replaced */
   /*=================================================================*/
    rslt = (Time!=Integer.MIN_VALUE); /* value already set ? */
    Time = z; /* set new value */
    return rslt; /* return flag */
  }

 /**. <pre>
  *=====================================================================
  * Methode "setID"
  * Store new 'Service-ID' of object
  * Current value is overwritten in any case and a marker is returned,
  *   if the new value overwrites a valid value.
  * ##setID.TSXtSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean setID( /* set ID-value of service */
   int v)  /* new ID-value */
   {
   /*-----------------------------------------------------------------*/
    boolean rslt; /* result: values replaced */
   /*=================================================================*/
    rslt = (UiD!=Integer.MIN_VALUE); /* value already set? */
    UiD = v; /* set new value */
    return rslt; /* return flag */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSXtSrv (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String  rs;  /* result-string */
    int     i;   /* intermediate value */
    TSStStp cSt; /* current definition of StationStop */
   /*=================================================================*/
    rs = "TSXtSrv{'"; /* set prefix of result */
    if(Name==null) rs += "<null>"; else rs += Name;
    rs += "'-" + Math.max(Time,0); /* Zeitpunkt hinzufuegen */
    if(Stop==null) rs += "-0("; /* keine Haltepunkte */
    else { /* Haltepunkt-Eintraege koennen existieren */
      rs += "-" + Stop.size() + "("; /* Vorlauf setzen */
      for(i=0;i<Stop.size();i+=1) { /* alle Eintraege hinzufuegen */
        if(i>0) rs += ","; /* Trennzeichen einfgen */
        if((cSt=Stop.get(i))==null) rs += "<null>";
        else rs += cSt.toStr(); /* Daten aufbereiten */
      } /* alle Definitionen hinzufuegen */
    } /* Definitionen waren vorhanden */
    rs += "),(" + (Srv!=null) + ")}"; /* set suffix */
    return rs; /* and return result */
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSStStp -- Definition of traffic-'StationStop'
 * Attention: Normally, this class stores stops referenced from
 *            'Traffic'-Definitions. Aditionally this class may be used
 *            to store stops referenced from 'Activity'-Definitions.
 *            Then, additional fields may contain valid contends.
 * This object may be filled using 'getTrfDef()'-method
 * ##TSStStp (Eyecatcher)
 *======================================================================
 </pre>*/
class TSStStp implements Serializable,Comparable<TSStStp>{ /* Stops */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.05 11.12.2009";
 /*-------------------------------------------------------------------*/
  private int                   ATime;  /* Arrival-time */
  private int                   DTime;  /* Departure-time */
  private boolean               Trf;    /* Traffic-Version valid ? */
  /* additional definitions used with 'Activity-Version': */
  private double                Eff;    /* current effectivity */
  /* basic-values used to correlate with service: */
  private TSStop                Stp;    /* reference to service-version */
  private int                   PfID;   /* Platform-reference */
  private int                   SkCnt;  /* Station-SkipCount */
  private double                Dist;   /* Station-DownDistance */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSStStp() /* create 'StationStop'-definition (Basis) */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    ATime = Integer.MIN_VALUE; /* Arrivaltime is still invalid */
    DTime = Integer.MIN_VALUE; /* Departuretime is still invalid */
//    Trf   = false;             /* mark: no 'Traffic-Version' */
    Eff   = Double.NaN;        /* no valid value inserted */
    PfID  = Integer.MIN_VALUE; /* clear platform-number */
    SkCnt = Integer.MIN_VALUE; /* mark entry as invalid */
    Dist  = Double.NaN;        /* no valid value inserted */
//    Stp   = null;              /* no service-version connected */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry (Version T)
  *=====================================================================
  </pre>*/
  protected TSStStp( /* create 'StationStop'-definition */
   int    at,  /* arrivel-time */
   int    dt,  /* departure-time */
   int    id,  /* platform-ID */
   int    sc,  /* 'Skip-Counter' */
   double dst) /* distance-value */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    ATime = at;   /* copy value and store it */
    DTime = dt;   /* copy value and store it */
    SkCnt = sc;   /* copy value and store it */
    Dist  = dst;  /* copy value and store it */
    PfID  = id;   /* copy value and store it */
    Trf   = true; /* mark 'Traffic-Version' */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create Standard-Entry (Version A)
  *=====================================================================
  </pre>*/
  protected TSStStp( /* create 'StationStop'-definition */
   double eff, /* Effektivitaet */
   int    id,  /* platform-ID */
   int    sc,  /* 'Skip-Counter' */
   double dst) /* distance-value */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    Eff   = eff; /* copy value and store it */
    SkCnt = sc;  /* copy value and store it */
    Dist  = dst; /* copy value and store it */
    PfID  = id;  /* copy value and store it */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (4) Create Entry (Version T) from Service-version (S)
  *=====================================================================
  </pre>*/
  protected TSStStp( /* create 'StationStop'-definition */
   TSStop cSt) /* Service-version as template */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    SkCnt = cSt.chkSkip(0);   /* get value and store it */
    Dist  = cSt.chkDist(0.0); /* get value and store it */
    PfID  = cSt.chkID(0);     /* get value and store it */
    Stp   = cSt;              /* store connected Service */
    Trf   = true;             /* mark 'Traffic-Version' */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (5) Create correlated Entry (Version A) from Version (T)
  *=====================================================================
  </pre>*/
  protected TSStStp( /* create 'StationStop'-definition (A) */
   TSStStp cStp) /* Traffic-version as template */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    ATime = cStp.ATime; /* get value and store it */
    DTime = cStp.DTime; /* get value and store it */
    Trf   = cStp.Trf;   /* transfer version of template */
    Eff   = 0.75;       /* set default-value, mark version A active */
    SkCnt = cStp.SkCnt; /* get value and store it */
    Dist  = cStp.Dist;  /* get value and store it */
    PfID  = cStp.PfID;  /* get value and store it */
    Stp   = cStp.Stp;   /* get connected Service and store it */
      /* Attention: service may not be available ('null') */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkSkip"
  * Check 'Skip-Value' if it is ascending.
  * Return marker (negative value) if this not valid.
  * Attention: if this method is called using '0' as the argument,
  *            the current 'Skip-Value' is returned (because the current
  *            value is always positive).
  * ##chkSkip.TSStop (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int chkSkip( /* check current 'Skip-Value' */
   int w) /* value to be compared to 'Skip-Value' */
   {
   /*-----------------------------------------------------------------*/
                                             /* no local definitions */
   /*=================================================================*/
    return (SkCnt<=w) ? -w : SkCnt; /* result with marker */
  }

 /**. <pre>
  *=====================================================================
  * Method "compareTo"
  * Method is used to sort Elements
  * Attention: Name of this Methode is requested by Interface
  *           'Comparable'. Results need NOT be 0,1,-1
  * Note: This class has a natural ordering that is
  *       inconsistent with equals.
  * ##compareTo.TSStStp (Eyecatcher)
  *=====================================================================
  </pre>*/
  public final int compareTo( /* compare Definitions for sorting */
   TSStStp vH) /* compare-object */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return SkCnt-vH.SkCnt; /* compare and return result */
  }

 /**. <pre>
  *=====================================================================
  * Method "corrS"
  * Correlate A/T-version of a 'StationStop' with it's S-version. If a
  *   'match is found both entries are connected together.
  *   If the current entry is already correlated, it cannot be
  *   correlated again.
  * Attention: Method uses and modifies 'RetVal'
  * Returns '0' if correlation was successful. However an errormessage
  *   may be created.
  * Returns >0 if this (traffic-)record is an additional entry.
  * Returns <0 if a traffic-definiton is missing.
  * ##corrS.TSStStp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int corrS( /* correlate 'StationStop'-versions */
   TSStop cSt) /* 'StationStop'-entry (S) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    TSUtil.RetVal = null; /* preset: no error found */
    if((i=cSt.chkSkip(0)-SkCnt)!=0) return i; /* no match -- try next */
    if(Stp!=null) if(Stp!=cSt) throw new /* already correlated */
      IllegalStateException(TSLogg.getMsg("Msg907","TSStStp.corrS()",
        Stp.toStr()+"!=null")); /* terminate with message */
    /* match found -- check and connect together */
    if((i=cSt.chkID(PfID))!=0) /* invalid configuration -- set message */
      TSUtil.RetVal = TSLogg.getMsg("TSStStpA",""+SkCnt,""+PfID,""+Dist,
        (Trf ? ""+ATime : "?"),(Trf ? ""+DTime : "?"),""+(PfID+i));
//      TSUtil.RetVal = TSLogg.getMsg("TSStStpA",getVal(false),PfID+i);
    Dist = cSt.chkDist(Double.NaN); /* synchronize distance-values */
    Stp = cSt; /* set refernce to service-version of entry
      * and mark that correlation occurred */
    return 0; /* signal success */
  }

 /**. <pre>
  *=====================================================================
  * Method "corrT"
  * Correlate A-version of a 'StationStop' with it's T-version. If a
  *   'match is found the time-values are copied to the A-version.
  * Attention: Method uses and modifies 'RetVal'
  * Returns '0' if correlation was successful. However an errormessage
  *   may be created.
  * Returns >0 if this record is an additional entry.
  * Returns <0 if a traffic-definiton is missing.
  * ##corrT.TSStStp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int corrT( /* correlate 'StationStop'-versions */
   TSStStp cStp) /* StationStop (version T) to correlate */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    TSUtil.RetVal = null; /* preset: no error found */
    if((i=cStp.SkCnt-SkCnt)!=0) return i; /* no match -- try next */
    if(!cStp.Trf) throw new /* no traffic-object -- Systemerror */
      IllegalStateException(TSLogg.getMsg("Msg907","TSStStp.corrT()",
        "Traffic==false")); /* terminate with message */
    if(Double.isNaN(Eff)) throw new /* No A-version -- Systemerror */
      IllegalStateException(TSLogg.getMsg("Msg907","TSStStp.corrT()",
        "Version(A)==false")); /* terminate with message */
    if(Stp!=null) if(Stp!=cStp.Stp) throw new /* already correlated */
      IllegalStateException(TSLogg.getMsg("Msg907","TSStStp.corrT()",
        Stp.toStr()+"!=null")); /* terminate with message */
    /* match found -- extend object */
    if(this.PfID!=cStp.PfID) /* invalid configuration -- set message */
      TSUtil.RetVal = TSLogg.getMsg("TSStStpB",""+SkCnt,""+PfID,""+Dist,
        (Trf ? ""+ATime : "?"),(Trf ? ""+DTime : "?"),""+(cStp.PfID));
//      TSUtil.RetVal = TSLogg.getMsg("TSStStpB",getVal(false),cStp.PfID);
    this.ATime = cStp.ATime; /* copy value */
    this.DTime = cStp.DTime; /* copy value */
    this.Trf   = true;       /* mark 'Traffic-Version' active */
    this.Dist  = cStp.Dist;  /* synchronize distance-values */
    this.PfID  = cStp.PfID;  /* synchronize value in case of error */
    this.Stp   = cStp.Stp;   /* copy connected service, too */
    return 0; /* signal success */
  }

 /**. <pre>
  *=====================================================================
  * Method "crDef" (Version A/T)
  * Create an output-line-block due to requested type
  * ##crDef.TSStStp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int crDef( /* create output-line-block */
   ArrayList<String> LneT, /* Empty list to be filled (table) */
   boolean           trf,  /* 'Traffic'-version if set (else 'Activity') */
   int               nr,   /* number 'StationStop'-entry (used with msg) */
   String            prfx) /* prefix of the definition lines */
   {
   /*-----------------------------------------------------------------*/
    int     i,c; /* intermediate value, counter */
    double  d;   /* intermediate value */
   /*=================================================================*/
    c = 0; /* preset: no messages created */
    if(trf) { /* creation of 'Traffic'-version requested */
      if(!Trf) { /* traffic-version of object is NOT available */
        LneT.add(TSLogg.getMsg("TSStStp1",nr)); /* add error-message */
        c += 1; /* count error-message */
      } /* traffic-definition requested but not available */
      /* 'ArrivalTime' */
      i = ATime; /* get default-Value */
      if(i==Integer.MIN_VALUE) { /* error: invalid value found */
        /* traffic-version of object is also NOT available */
        LneT.add(TSLogg.getMsg("TSStStp2",nr)); /* add error-message */
        c += 1; /* count error-message */
        i = 0; /* and set dummy-value */
      } /* stored value is valid -- use it */
      LneT.add(prfx + "ArrivalTime ( " + i + " )"); /* set next line */
      /* 'DepartTime' */
      i = DTime; /* get default-Value */
      if(i==Integer.MIN_VALUE) { /* error: invalid value found */
        LneT.add(TSLogg.getMsg("TSStStp3",nr)); /* add error-message */
        c += 1; /* count error-message */
        i = 0; /* and set dummy-value */
      } /* stored value is valid -- use it */
      LneT.add(prfx + "DepartTime ( " + i + " )"); /* set next line */
    } else { /* creation of 'Activity'-version requested */
      /* 'Efficiency' */
      d = Eff; /* get default-Value */
      if(Double.isNaN(d)) { /* error: invalid value found */
        /* activity-version of object is also NOT available */
        LneT.add(TSLogg.getMsg("TSStStp4",nr)); /* add error-message */
        LneT.add(TSLogg.getMsg("TSStStp5",nr)); /* add error-message */
        c += 2; /* count error-message */
        d = 0.0; /* and set dummy-value */
      } /* stored value is valid -- use it */
      LneT.add(prfx + "Efficiency (" + TSUtil.putFV(d,2) + " )");
    } /* 'Activity'-version was requested */

    if(Stp!=null) return c+Stp.crDef(LneT,nr,prfx); /* lines from service */

    /* use stored values if reference to service-definiton (S) is not available */
    LneT.add(TSLogg.getMsg("TSStStp6",nr)); /* add error-message */
    c += 1; /* count error-message */
    /* 'SkipCount' */
    i = SkCnt; /* get default-Value */
    if(i==Integer.MIN_VALUE) i = 0; /* invalid -- set dummy-value */
    LneT.add(prfx + "SkipCount ( " + i + " )"); /* set next line */
    /* 'DistanceDownPath' */
    d = Dist; /* get default-Value */
    if(Double.isNaN(d)) d = 0.0;  /* invalid -- set dummy-value */
    LneT.add(prfx + "DistanceDownPath (" + TSUtil.putFV(d,0) + " )");
    /* 'PlatformStartID' */
    i = PfID; /* get default-Value */
    if(i==Integer.MIN_VALUE) i = 0; /* invalid -- set dummy-value */
    LneT.add(prfx + "PlatformStartID ( " + i + " )"); /* set next line */
    return c; /* return number of messages */
  }

 /**. <pre>
  *=====================================================================
  * Method "crSrv"
  * Return the service-version of the StationStop-entry
  * ##crSrv.TSStStp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSStop crSrv() /* create service-version */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return new TSStop(PfID,SkCnt,Dist); /* return new definition */
  }

 /**. <pre>
  *=====================================================================
  * Method "getVal" (Version S/T)
  * Convert a StationStop-Definition to a String (Errormessage).
  * --- Method is NOT referenced until now. (marked by 'XXX...') ---
  * ##getVal.TSStStp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String XXXgetVal( /* convert StationStop-definition */
   boolean srv) /* use 'service'-version if 'true' */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = "" + PfID + " " + Dist + " " + SkCnt;
    if(srv) return rs; /* do not add traffic-values */
    rs += " (";
    rs += Trf ? ""+ATime+" "+DTime : "? ?";
    rs += ")"; /* add termination */
    return rs; /* return result */
  }

 /**. <pre>
  *=====================================================================
  * Method "mark"
  * Mark a definition as 'invalid' (false) or check status (true)
  * ##mark.TSStStp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean mark( /* check/mark status of entry */
   boolean chk) /* check status if 'true' (else mark it) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(chk) return SkCnt==Integer.MIN_VALUE; /* return current status */
    SkCnt = Integer.MIN_VALUE; /* invalidate entry */
    return true; /* return result */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSStStp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-string */
   /*=================================================================*/
    rs = "TSStStp{" + PfID + "," + Dist + "," + SkCnt +
          ",<" + (Stp!=null) + ">";
    if(Trf) rs += ",T(" + ATime + "," + DTime + ")";
    if(!Double.isNaN(Eff)) rs += ",A(" + Eff + ")";
    rs += "}";
    return rs; /* Ergebnis zurueckgeben */
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSTrain -- Train-definition used within activity/consist
 * ##TSTrain (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTrain extends TSData { /* Train-definition (consist) */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.6.05 17.08.2012";
 /*-------------------------------------------------------------------*/
  private String                FNme;   /* Filename of Consist */
    /* Attention: filename contains NO suffix ('.con') */
  private String                Name;   /* Name of Train */
  private int                   Cnt;    /* Reference-count */
  private ArrayList<TSRefC>     TOT;    /* Train-object-definitions */
    /* Attention: 'TSRefC' is missused to hold 'Train-Object'-
     *            definitions. It is defined like this:
     *
     *            Nr  - Number of UID
     *            Ix  - Options using 'Prime-Method'
     *            Adr - File-/Directory-Name of train-object
     *                  (reference is to String[2])
     *
     *            Options are:
     *              2 - no Adr-field available
     *              3 - 'Engine' instead of 'Waggon'
     *              5 - 'Flip'-option found
     *
     *            Adr[0] points to 'filename'
     *            Adr[1] points to 'directory'
     */
/**. <pre>
  * Used options (stored within mask of 'TSOpt'):
  *        0 - Entry is a static one (used for activities)
  *        1 - Entry is NOT FULLY defined. (*.con not found)
  *        2 - Entry contains error(s) -- not fully available
  *  3 to 15 - not used
  *       16 -
  *       17 -
  *       18 -
  *       19 -
  *       20 - 'Name'-definition found
  *       21 - 'Serial'-definition found
  *       22 - 'MaxVelocity'-definition found
  *       23 - 'NextWagonUID'-definition found
  *       24 - 'Durability'-definition found
  *       25 -
  *       26 -
  *       30 - Reserved for temporary usage
  *       31 - Reserved for temporary usage
  * Index-Definitions from 'TSData' (<queue>.<element>):
  *   0.00(S) - Definition of 'MaxVelocity'
  *   0.01(S) - Definition of 'Durability'
  *   1.00(I) - Serial-Number of train-definiton
  *   1.01(I) - UID of next Wagon (NextWagonUID)
  *   2.00(F) - Maximum speed of train (MaxVelocity)
  *   2.01(F) - Maximum acceleration of train (MaxVelocity)
  *=====================================================================
  * Constructor: (1) create default-version of instance
  *=====================================================================
  </pre>*/
  protected TSTrain() /* create train-definition (Basis) */
   {
    super(3);  /* set 'TSData' (3 Arrays) (--- restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Cnt = 1; /* Normally one reference to file already exists */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) create standard-version of instance
  *=====================================================================
  </pre>*/
  protected TSTrain( /* create train-definition */
   String fn) /* filename of train (consist) (without suffix) */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    FNme = fn; /* copy specified filename */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgNme"
  * Set new name of train-definition or return current one
  * If (tn==null) no changes are performed; current value is returned.
  * ##chgNme.TSTrain (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String chgNme( /* change/return current name */
   String tn)  /* new name of train-definition */
   {
   /*-----------------------------------------------------------------*/
    String s; /* intermediate value */
   /*=================================================================*/
    s = Name; /* save original name */
    if(tn!=null) Name = tn; /* replace name if requested */
    return s; /* return with original value */
  }

 /**. <pre>
  *=====================================================================
  * Method "crTrn"
  * Create a file-version of the current Train
  * ##crTrn.TSTrain (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Iterator<String> crTrn( /* create Train-definition */
   ArrayList<String> LneT, /* Empty list to be filled (table) */
   String            prfx) /* prefix of the definition lines */
   {
   /*-----------------------------------------------------------------*/
    Iterator<TSRefC>  cI;  /* iterator for all 'Engine'/'Wagon' */
    TSRefC            cR;  /* current train-object ('Engine'/'Wagon') */
    String[]          cS;  /* current name-references */
    String            s,u; /* intermediate value */
    int               opt; /* options of Train-object */
   /*=================================================================*/
    if(TOT==null) return null; /* no valid definition exists */
    if(chkMsk(0)) LneT.add(prfx + "TrainCfg ( \"\"");
      /* definiton is used for activities */
    else LneT.add(prfx + "TrainCfg ( " + TSUtil.modStr(FNme));

    if(chkMsk(20)) LneT.add(prfx + "\tName ( " + TSUtil.modStr(Name) + " )");
    if(chkMsk(21)) LneT.add(prfx + "\tSerial ( " + getInt(0) + " )");
    if(chkMsk(22)) LneT.add(prfx + "\tMaxVelocity (" + getDta(0) + ")");
    if(chkMsk(23)) LneT.add(prfx + "\tNextWagonUID ( " + getInt(1) + " )");
    if(chkMsk(24)) LneT.add(prfx + "\tDurability (" + getDta(1) + ")");
    cI = TOT.iterator(); /* get iterator for all train-objects */
    while(cI.hasNext()) { /* process all train-objects */
      cR = cI.next(); /* get current Train-object */
      opt = cR.chgIx(Integer.MIN_VALUE); /* get options of object */
      if((opt%2)==0) continue; /* no name avilable -- ignore */
      cS = (String[])cR.chgRef(null); /* get current address-field */
      s = ((opt%3)==0) ? "Engine" : "Wagon"; /* set type of entry */
      LneT.add(prfx + "\t" + s + " ("); /* create first line of object */
      u = prfx + "\t\tUID ( " + cR.chgNr(Integer.MIN_VALUE) + " )";
      s = prfx + "\t\t" + s + "Data ( " + TSUtil.modStr(cS[0]) +
                  " " + TSUtil.modStr(cS[1]) + " )";
      if((opt%3)==0) { /* entry-type is 'Engine' */
        if((opt%5)==0) LneT.add(prfx + "\t\tFlip ( )"); /* additional line */
        LneT.add(u); /* add line with UID-value */
        LneT.add(s); /* add resource-description */
      } else { /* entry-type is 'Wagon' -- set UiD/Flip */
        LneT.add(s); /* add resource-description */
        LneT.add(u); /* add line with UID-value */
        if((opt%5)==0) LneT.add(prfx + "\t\tFlip ( )"); /* additional line */
      } /* entry-type was 'Wagon' */
      LneT.add(prfx + "\t)"); /* create last line of object */
    } /* -while- process all train-objects */
    LneT.add(prfx + ")"); /* create last line */
    return LneT.iterator(); /* return with correct Train-definition */
  }

 /**. <pre>
  *=====================================================================
  * Method "getFile"
  * Returns current complete file-name as file-definition.
  * Suffix is added to create the complete path.
  * ##getFile.TSTrain (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final File getFile( /* create and return complete path */
   File dir) /* directory which contains file */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return new File(dir,FNme+".con"); /* create and return definition */
  }

 /**. <pre>
  *=====================================================================
  * Method "getName"
  * Returns current file-name of the object (without suffix)
  * If argument equals 'false' the file-name is returned modified to be
  *   used as a key (lowerCase)
  * ##getName.TSTrain (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getName( /* get (modified) name of the train */
   boolean mde) /* mode of filename */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(mde) return FNme; /* return filename unmodified */
    return FNme.toLowerCase(); /* return filename-key */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTObjT"
  * Returns current array of 'Train-Object'-References, which is of
  *   type 'TSRefC'. If it is requested ('c>0'), it is created even if
  *   it is already available.
  * ##getTObjT.TSTrain (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final ArrayList<TSRefC> getTObjT( /* return reference-array */
   int c) /* create new array if 'c>0' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c>0) TOT = new ArrayList<TSRefC>(c); /* create it */
    return TOT; /* reply with (new) Reference-table */
  }

 /**. <pre>
  *=====================================================================
  * Method "getPath"
  * Returns file-object denoting path to a engine/waggon
  * ##getPath.TSTrain (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final File getPath( /* return file to engine/waggon */
   TSRefC cT, /* current Train-Object */
   File   cP) /* basic path to be added (may be 'null') */
   {
   /*-----------------------------------------------------------------*/
    int      opt; /* option-values */
    String[] cR;  /* path-references */
    String   cN;  /* current filename */
   /*=================================================================*/
    if(cT==null) throw new IllegalArgumentException( /* no argument */
      TSLogg.getMsg("Msg901","TSTrain.getPath()","<null>",1));
    opt = cT.chgIx(Integer.MIN_VALUE); /* get options of Train-object */
    if((opt%2)==0) return null; /* no path avilable -- error */
    cR = (String[])cT.chgRef(null); /* get current address-field */
    if((opt%3)==0) cN = cR[0] + ".eng"; /* name of engine */
     else cN = cR[0] + ".wag"; /* build full file-name */
    cP = new File(cP,cR[1]); /* add or create directory-reference */
    cP = new File(cP,cN); /* add file-reference */
    return cP; /* reply with File-reference to object */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt"
  * Increment reference-counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt.TSTrain (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt( /* change reference-counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int i; /* intermediate value */
   /*=================================================================*/
    i = Cnt; /* save current value of reference-counter */
    if(inc<0) inc = Math.max(inc,-Cnt); /* must not become negative */
    Cnt += inc; /* increment (decrement) reference-counter */
    return i; /* return value before modification */
  }


 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTrain (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String           rs;     /* result-String */
    int              i,j,jl; /* intermediate values */
    Iterator<TSRefC> cI;     /* iterator for 'Train-Object's */
   /*=================================================================*/
    rs = "TSTrain{'"; /* beginning */
    if(FNme==null) rs += "<null>"; else rs += FNme;
    rs += "','"; /* separator between names */
    if(Name==null) rs += "<null>"; else rs += Name;

    j = 0; jl = rs.length(); /* fuer Umbruch */
    if(TOT==null) rs += "'-0("; /* keine Eintraege */
    else { /* Eintraege koennen existieren */
      rs += "'-" + TOT.size() + "("; /* Vorlauf setzen */
      cI = TOT.iterator(); /* get new Iterator */
      i = 0; /* initialize number of record */
      while(cI.hasNext()) { /* process all entries */
        if(i>0) rs += ","; /* add separator */
        if(((rs.length()-jl)/TSUtil.ZL)>j) { /* Zeilenumbruch einfuegen */
          j += 1; /* naechster Umbruch vorsehen */
          rs += TSUtil.CRLF + "                ";
        } /* Umbruch-Steuerung erfolgt */
        rs += cI.next().toStr(); /* add definition to result */
        i += 1; /* increase number of processed records */
      } /* alle Definitionen hinzufuegen */
    } /* Definitionen waren vorhanden */
    rs += ")-" + TSUtil.CRLF + "                " + super.toStr() + "}";
    return rs; /* Ergebnis zurueckgeben */
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class ObjLst -- List of Object-definitions (route-reference-list)
 *                 (used to store '*.ref'-file)
 * ##TSObjLst (Eyecatcher)
 *======================================================================
 </pre>*/
class TSObjLst { /* List of Object-descriptions */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.5.01 06.06.2011";
 /*-------------------------------------------------------------------*/
  private String                Name;   /* Class-descripion of obj */
  private TreeMap<String,TSObjDef> ObjT; /* Table of objects */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSObjLst() /* Create Route-object-definition-list (Dummy) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all other variables are initialized by default ('0' / 'null') */
//    Name = null; /* name of route-object-class is unknown */
//    ObjT = null; /* no list of route-objects defined */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSObjLst( /* Create Route-object-definition-list */
   String cn) /* name of route-object-class */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Name = cn; /* Store name of route-object-class */
    ObjT = new TreeMap<String,TSObjDef>(); /* create list */
  }

 /**. <pre>
  *=====================================================================
  * Method "add"
  * Add an Entry to the classlist of route-reference-objects.
  * Method returns 'false if an error is found.
  * ##add.TSObjLst (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean add( /* add a entry */
   TSObjDef cE) /* entry to be inserted */
   {
   /*-----------------------------------------------------------------*/
    String cS; /* key of new reference-object */
   /*=================================================================*/
    if(cE==null) return false; /* entry not available -- do not use */
    cS = cE.getKey(); /* get key-value from object */
    if(ObjT.containsKey(cS)) return false; /* already present */
    cE.chgRef(this); /* insert backchain into current object-def. */
    ObjT.put(cS,cE); /* and insert it into List */
    return true; /* return marker: successfull added */
  }

 /**. <pre>
  *=====================================================================
  * Method "getName"
  * Returns the current Class-description of this table
  * ##getName.TSObjLst (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getName() /* return current description */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Name; /* return current class-description */
  }

 /**. <pre>
  *=====================================================================
  * Method "getIt"
  * Returns an Iterator to all values of this table
  * ##getIt.TSObjLst (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Iterator<TSObjDef> getIt() /* return table-iterator */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(ObjT==null) return null; /* table not available -- error */
    if(ObjT.size()==0) return null; /* no objects -- report it */
    return ObjT.values().iterator(); /* return new iterator */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSObjLst (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String             rs; /* result-String */
    Iterator<TSObjDef> cI; /* current element-definition */
   /*=================================================================*/
    rs = "TSObjLst{'" + Name + "',"; /* beginning */
    if(ObjT==null) rs += "<null>"; else rs += ObjT.size();
    rs += "}"; /* end of definition */
    cI = ObjT.values().iterator(); /* all elements within list */
    while(cI.hasNext()) { /* add all object-definitions */
      rs += TSUtil.CRLF + "          "; /* skip line and add space */
      rs += cI.next().toStr(); /* add current object-definition */
    } /* process all definitions */
    return rs; /* Ergebnis zurueckgeben */
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class ObjDef -- Object-definition due to route-reference-list
 *                 (used to store '*.ref'-entry)
 * ##TSObjDef (Eyecatcher)
 *======================================================================
 </pre>*/
class TSObjDef extends TSOpts { /* Object-definiton of route-ref.-list */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.5.01 06.06.2011";
  protected static final int    ObjMsk = 0x711F0F9F; /* valid opts */
 /*-------------------------------------------------------------------*/
  private int                   OT;     /* Object-Type of Entry
    * compare this type-value to 'TSUiD'-Definition */
  private String                Desc;   /* Object-description */
  private String                Shape;  /* File-name of Shape-obj. */
  private TSObjLst              ClRef;  /* back-ref to class-descript. */
/**. <pre>
  * Used options (stored within mask of 'TSOpts'):
  *      0 - 'Class'-Definition was successfully processed
  *      1 - 'Description'-Definition was successfully processed
  *      2 - 'Filename'-Definition was successfully processed
  *      3 - 'Shadow'-Definition was successfully processed
  *      4 - 'Align'-Definition was successfully processed
  *   5..6 - not used until now (must be reset)
  *      7 - 'PickupType'-Definition was successfully processed
  *      8 - 'StoreMatrix'-Definition was successfully processed
  *      9 - 'NoDirLight'-Definition was successfully processed
  *     10 - 'TunnelEntrance'-Definition was successfully processed
  *     11 - 'AnimShape'-Definition was successfully processed
  * 12..15 - not used until now (must be reset)
  *     16 - Keyword 'None' registered (Shadow)
  *     17 - Keyword 'Round' registered (Shadow)
  *     18 - Keyword 'Rect' registered (Shadow)
  *     19 - Keyword 'TreeLine' registered (Shadow)
  *     20 - Keyword 'Dynamic' registered (Shadow)
  *     21 -
  *     22 -
  *     23 -
  *     24 - Keyword 'None' registered (Align)
  *     25 - Keyword '' registered (Align)
  *     26 -
  *     27 - Entry is a dummy one -- do not write
  *     28 - Keyword '_FUEL_DIESEL_' registered (PickupType)
  *     29 - Keyword '_FUEL_WATER_' registered (PickupType)
  *     30 - Keyword '_FUEL_COAL_' registered (PickupType)
  *     31 - Synthetical filename-definition used
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSObjDef() /* Create Route-object-definition (Dummy) */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    OT    = -1;   /* Object-Type is still NOT KNOWN */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSObjDef( /* Create Route-object-definition */
   int      cO,  /* options/values of definition */
   int      ot,  /* current object-type */
   String   cSh, /* new Shape-name of route-object (filename) */
   String   cD)  /* description of new route-object */
   {
    super(cO);   /* set option-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    OT    = ot;   /* set current object-type of entry */
    Desc  = cD;   /* transfer current description of object */
    Shape = cSh;  /* set shape-name of route-object */
    ClRef = null; /* no back-reference to current classlist avail */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgRef"
  * Manages the backchain to classlist to be used with 'TSObjLst'.
  * ##chgRef.TSObjDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSObjLst chgRef( /* change backchain-reference */
   TSObjLst nR) /* new reference to classlist or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSObjLst cR; /* current reference to classlist */
   /*=================================================================*/
    cR = ClRef; /* save current class-reference */
    if(nR!=null) ClRef = nR; /* chacge backchain if requested */
    return cR; /* and return old / current backchain-value */
  }

 /**. <pre>
  *=====================================================================
  * Method "crDef"
  * Create an output-line-set for writing a Reference-Object
  * ##crDef.TSObjDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Iterator<String> crDef( /* create output-line-block */
   ArrayList<String> LneT) /* Empty list to be filled (table) */
   {
   /*-----------------------------------------------------------------*/
    String is; /* intermediate value */
   /*=================================================================*/
    if(OT<0) return null; /* no valid object-definition */
    LneT.add(TSUiD.getName(OT) + " ("); /* set first output-line */
    if(chkMsk(2)) { /* 'Filename' present -- write it */
      if(!chkMsk(31)) /* DO NOT use synthetical name */
        LneT.add("\tFileName ( " + TSUtil.modStr(Shape) + " )");
    } /* requested line was created with/without errors */
    if(chkMsk(0)) { /* 'Class'-Definition present -- write it */
      is = ClRef.getName(); /* get current class-description */
      LneT.add("\tClass ( " + TSUtil.addStr(is) + " )"); /* next line */
    } /* requested line was created with/without errors */
    if(chkMsk(3)) { /* 'Shadow'-Definition present -- write it */
      is = ""; /* preset 'unknown value' */
      if(chkMsk(16)) is = "None"; /* set requested value */
      if(chkMsk(17)) is = "Round"; /* set requested value */
      if(chkMsk(18)) is = "Rect"; /* set requested value */
      if(chkMsk(19)) is = "Treeline"; /* set requested value */
      if(chkMsk(20)) is = "Dynamic"; /* set requested value */
      LneT.add("\tShadow ( " + is + " )"); /* create line */
    } /* requested line was created with/without errors */
    if(chkMsk(4)) { /* 'Align'-Definition present -- write it */
      is = ""; /* preset 'unknown value' */
      if(chkMsk(24)) is = "None"; /* set requested value */
      LneT.add("\tAlign ( " + is + " )"); /* create line */
    } /* requested line was created with/without errors */
    if(chkMsk(7)) { /* 'PickupType'-Definition present -- write it */
      is = ""; /* preset 'unknown value' */
      if(chkMsk(28)) is = "_FUEL_DIESEL_"; /* set requested value */
      if(chkMsk(29)) is = "_FUEL_WATER_"; /* set requested value */
      if(chkMsk(30)) is = "_FUEL_COAL_"; /* set requested value */
      LneT.add("\tPickupType ( " + is + " )"); /* create line */
    } /* requested line was created with/without errors */
    if(chkMsk(8)) /* 'StoreMatrix'-definition present -- write it */
      LneT.add("\tStoreMatrix ()"); /* create line */
    if(chkMsk(9)) /* 'NoDirLight'-definition present -- write it */
      LneT.add("\tNoDirLight ()"); /* create line */
    if(chkMsk(10)) /* 'TunnelEntrance'-definition present -- write it */
      LneT.add("\tTunnelEntrance ()"); /* create line */
    if(chkMsk(11)) /* 'AnimShape'-definition present -- write it */
      LneT.add("\tAnimShape ()"); /* create line */
    if(chkMsk(1)) /* 'Description' present -- write it */
      LneT.add("\tDescription ( " + TSUtil.addStr(Desc) + " )");
    LneT.add(")"); /* add last line to output-block */
    return LneT.iterator(); /* return iterator to outputline-block */
  }

 /**. <pre>
  *=====================================================================
  * Method "getKey"
  * Returns the current objectkey to be used with 'TSObjLst'.
  * ##getKey.TSObjDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getKey() /* return current object-key */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(!chkMsk(2)) return null; /* no valid filename exists */
    return TSUtil.DF2.format(OT)+Shape.toLowerCase(); /* build key */
  }

 /**. <pre>
  *=====================================================================
  * Method "getName"
  * Returns the current filename(shape) of the object
  * ##getName.TSObjDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getName() /* return current filename/key */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(chkMsk(31)) return null; /* no valid filename exists */
    return Shape; /* return current filename */
  }

 /**. <pre>
  *=====================================================================
  * Method "refers"
  * Checks if current object is part of referenced List
  * Method returns 'false' if match is found
  *   (otherwise 'true': no match, error, ... )
  * ##refers.TSObjDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean refers( /* check current object to list */
   TSNameSet NmeL) /* Name-List of concerned objects */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Shape==null) return true; /* entry has error -- report it */
    return !NmeL.contains(Shape); /* return state of entry */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSObjDef (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* result-String */
   /*=================================================================*/
    rs = "TSObjDef{" + TSUiD.getName(OT) + ":'" + Shape +
          "'(" + OT + ")-'" + Desc + "'-"; /* beginning */
    rs += super.toStr(); /* add option-definitions */
    rs += "}"; /* end of definition */
    return rs; /* Ergebnis zurueckgeben */
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSFile -- Compress, decompress, reduce or expand of a file
 *  Reduce     - change normal format to tokenized version [UT]->[UB]
 *  Expand     - change tokenized format to normal version [UB]->[UT]
 *  Compress   - use zlib-algorithm to compress tokenized format
 *  Uncompress - uncompress data to tokenized format [CB]->[UB]
 *   Uncompress/Expand is done step by step while reading data
 *   Reduce is done step by step while writing data
 *     (Write data to file is executed before file is closed)
 *   Compress is executed before file is closed
 * ##TSFile (Eyecatcher)
 *======================================================================
 </pre>*/
class TSFile { /* Decompress, Compress, Expand or Reduce files */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.7.00 15.05.2012";
  protected static int          OB_Len = 32768; /* initial Output-Area */
 /*-------------------------------------------------------------------*/
  private static final int      OSize  = 100; /* size of Reduce-buffer */
  private static final int      MaxLen = 500; /* max. length of line */
 /*-------------------------------------------------------------------*/
  private static final DecimalFormatSymbols fFS = /* Format-object */
    new DecimalFormatSymbols(Locale.US);       /* for float-Formats */
  private static final DecimalFormat   DF2 = new DecimalFormat("00");
  private static final DecimalFormat[] dF = { /* Format-Objects */
    new DecimalFormat("#######0.0#"      ,fFS),
    new DecimalFormat("#######0.0##"     ,fFS),
    new DecimalFormat("#######0.0###"    ,fFS),
    new DecimalFormat("#######0.0####"   ,fFS),
    new DecimalFormat("#######0.0#####"  ,fFS),
    new DecimalFormat("#######0.0######" ,fFS),
    new DecimalFormat("#######0.0#######",fFS)};
  private static final DecimalFormat[] xF = { /* Format-Objects */
    new DecimalFormat("#######0.00"      ,fFS),
    new DecimalFormat("#######0.000"     ,fFS),
    new DecimalFormat("#######0.0000"    ,fFS),
    new DecimalFormat("#######0.00000"   ,fFS),
    new DecimalFormat("#######0.000000"  ,fFS),
    new DecimalFormat("#######0.0000000" ,fFS),
    new DecimalFormat("#######0.00000000",fFS)};
  private static final DecimalFormat[] sF = { /* Format-Objects */
    new DecimalFormat("0.0#E0"      ,fFS),
    new DecimalFormat("0.0##E0"     ,fFS),
    new DecimalFormat("0.0###E0"    ,fFS),
    new DecimalFormat("0.0####E0"   ,fFS),
    new DecimalFormat("0.0#####E0"  ,fFS),
    new DecimalFormat("0.0######E0" ,fFS),
    new DecimalFormat("0.0#######E0",fFS)};
  private static final float[]  F = /* border-values for format-select */
    {1e-2f,1e-3f,1e-4f,1e-5f,1e-6f,1e-7f,1e-8f};
  private static final byte[]   FlePfx = "SIMISA@".getBytes();
    /* start (first part) of File-ID  (byte-version) */
  private static final String   FL1[] = {"UT","UB","CT","CB"};
  private static final String   FL2[] = {"UW","AW","UA","AA"};
  private static final String   Mkr0 = "\u0100"; /* special marker */
  private static final String   Mkr1 = "\u0101"; /* special marker */
 /*-------------------------------------------------------------------*/
  protected static final TSFleTok tok1 = new TSFleTok(1,"Comment",true);
    /* create comment-record 'Comment' -- special comment-definition */
  protected static final int    IN  = 0;   /* Input, unknown format */
  protected static final int    IUT = 128; /* Input, UT-Format */
  protected static final int    IUB = 129; /* Input, UB-Format */
  protected static final int    ICT = 130; /* Input, CT-Format */
  protected static final int    ICB = 131; /* Input, CB-Format */
  protected static final int    OUT = 8;   /* Output, UT-Format */
    /* Attention: Also used for 'change mode to output' */
  protected static final int    OUB = 9;   /* Output, UB-Format */
  protected static final int    OCT = 10;  /* Output, CT-Format */
  protected static final int    OCB = 11;  /* Output, CB-Format */
  protected static final int    IU  = 16;  /* Input, unicode */
  protected static final int    IA  = 17;  /* Input, ascii */
  protected static final int    OU  = 24;  /* Output, unicode */
  protected static final int    OA  = 25;  /* Output, ascii */
  protected static final int    OUA = 28;  /* Output, unicode,append */
  protected static final int    OAA = 29;  /* Output, ascii,append */
 /*-------------------------------------------------------------------*/
  private static final int      IO_rqf = 128; /* Mask: format requ. */
  private static final int      IO_bio = 16;  /* Mask: buffered IO */
  private static final int      IO_out =  8;  /* Mask: Output */
  private static final int      IO_app =  4;  /* Mask: Append */
  private static final int      IO_cpr =  2;  /* Mask: Compressed */
  private static final int      IO_bin =  1;  /* Mask: ASCII/binary */
  private static final int      IO_Msk =  3;  /* Mask: file-format */
 /*-------------------------------------------------------------------*/
  private File                  Fle;    /* current used file-def. */
  private int                   cMde;   /* last used I/O-Mode */
  private int                   mode;   /* Accessmode(interface):
    * -2 - file is 'open binary input' (byte-stream)
    * -1 - file is 'open character input' (Unicode?)
    *  0 - file is closed (again)
    *  1 - file is 'open character output' (Unicode?) [UT]/[CT]
    *  2 - file is 'open binary output' (byte-stream) [UB]/[CB]
    */
 /*-------------------------------------------------------------------*/
  /* Variables, which must be available independend from methods: */
  private String                FNme;   /* Filename (fully-qual.) */
  private String                EMsg;   /* Errormessage or 'null' */
  private BufferedReader        Rdr;    /* Reader uncompressed */
  private BufferedWriter        Wtr;    /* Writer uncompressed */
  private InputStream           IS;     /* Reader compressed */
  private OutputStream          OS;     /* Writer compressed */
  private TSByteArrIO           BIO;    /* binary IO-control */
  private int                   Pos;    /* curr. char-position (buffer) */
  private int                   cP;     /* output: current position at 'DtaO'
                                         * input : current shift-level */
    /* Attention: This value ONLY differs from 'ItS.size()' when one or
     *            more 'virtual token'(s) is/are active. Such a token
     *            is NOT counted within shift-level of the line.
     *            This field is ONLY used, if (uncompressed) binary
     *            input is expanded.
     */
  private Stack<TSFleStack>     ItS;    /* Iteration-Storage-Stack */
  private TSFleStack            cItS;   /* current Iteration-Storage */
  private ArrayList<String>     DtaI;   /* Input-buffer (expand) */
  private String                DtaO;   /* Output-buffer (reduce) */
  private StringBuilder         DtaB;   /* Data-Fragements (reduce) */
  private TSBuf                 cB;     /* Parser for input-buffer */
    /* Attention: This field is NOT used by TSFile. Applications may use
     *            it to support methods with its current input-buffer.
     */
  private int                   cRep;   /* used with Reduce/Expand */
  private int                   rc,rl;  /* statistics (counter, length) */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSFile() /* Create File-control (Dummy) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* Initialize required objects */
    mode = 0;    /* Init-Accessmode (File is closed) */
    /* initialize objects, which may be asynchously requested */
    cMde = -1; /* File was not opened till now
      * Attention: This value marks file to be NOT BUFFERED
      */
    rc = rl = 0; /* no records read/written; max. record-length */
    /* allocate variables */
    DtaB = new StringBuilder(OSize); /* create 'Reduce'-buffer */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSFile( /* Create File-control */
   File dat) /* File-Definition */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Fle = dat; /* store File-Definition */
    FNme = Fle.getAbsolutePath(); /* store fully qualified Filename */
    /* Initialize required objects */
    BIO = new TSByteArrIO(OB_Len); /* create buffer-storage for I/O */
    DtaB = new StringBuilder(OSize); /* create 'Reduce'-buffer */

    mode = 0;    /* Init-Accessmode (File is closed) */
    /* initialize objects, which may be asynchously requested */
    cMde = -1; /* File was not opened till now */
    rc = rl = 0; /* no records read/written; max. record-length */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgBuf"
  * Modify or read current inputbuffer-reference
  * This field/method is NOT used by TSFile. Applications may use this
  *   field to support methods with its current input-buffer
  * ##chgBuf.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSBuf chgBuf( /* change storage of input-buffer */
   TSBuf nB) /* new input-buffer or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSBuf oB; /* old value for inputbuffer */
   /*=================================================================*/
    oB = cB; /* save current inputbuffer */
    if(nB!=null) cB = nB; /* replace current inputbuffer if requested */
    return oB; /* returns current/old address of inputbuffer */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkFKng" (Dummy for extended classes)
  * Check File-Identifier for current type of file
  *  First Argument (String):
  *    null   - provide full key for write
  *             returns 'null' if key not available due to error(s)
  *             else returns the requested file-id
  *    <>null - check provided file-id
  *             returns 'null' if the check succeeds
  *             else returns an error-message (result <> null)
  *  Form of file-id must be of the type specified with the second
  *    argument. If this type is not supported an error is returned
  *    in every case.
  * THIS dummy-function returns an error in every case, because
  *   - normally - it is overwritten.
  * ##chkFKng.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String chkFKng(String s, boolean t) { return s; }

 /**. <pre>
  *=====================================================================
  * Method "close"
  * Close reader/writer again
  * Method returns error-message or 'null'
  * ##close.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String close() /* Close Reader/Writer again */
   {
   /*-----------------------------------------------------------------*/
    int     p;   /* temporary bufferpointer */
    String  is;  /* temporary bufferstring */
    boolean cpr; /* compress is active (if 'true') */
   /*=================================================================*/
    EMsg = null; /* clear current error-message */
    if(Fle==null) return TSLogg.getKey("TSFleC01"); /* no active file */
    is = null; /* preset error-message to 'no error' */
    cpr = (cMde&IO_cpr)!=0; /* set request-flag (compress) */

    switch(mode) { /* close file according to current mode */
      case(-1): /* 'Input character' (CT/UT) is active */
        /* this mode is also used if 'no file-ID' is used */
        try { Rdr.close(); /* close input-file */
        } catch (IOException e) { is = e.toString(); /* set error */ }
        break;
      case(-2): /* 'binary input' (CB/UB) is active */
        try { IS.close(); /* close input-file */
        } catch (IOException e) { is = e.toString(); /* set error */ }
        break;
      case( 0): break; /* ignore command if already close */
      case( 1): /* 'Output character' (CT/UT) is active */
        /* this mode is also used if 'no file-ID' is used */
        try { Wtr.close(); /* close output-file and flush internal bfr */
        } catch (IOException e) { /* error within close -- terminate */
          try {OS.close();} catch (IOException E) { }
          mode = 0; /* mark file as closed (mode) */
          return e.toString(); /* return error-message */
        } /* error while close */

        p = 14; /* preset number of bytes to be skipped */
        if(BIO.getInt(1,0)>248) p += 2; /* control-byte found (x'FF') -- skip sequence too */

        if(cpr) { /* compress is requested ('CT') */
          BIO.putByte(70,p); /* change '@' to 'F' within prefix */
          p += 2; /* advance to next relevant position */
          BIO.putInt(BIO.size()-16-p,4,p); /* preliminary insert length (size()-32) */

          is = new String(BIO.getBytes(4,p)); /* resolve new value as string */
          if((is=BIO.putString(is,p))!=null) { /* insert it again using correct format */
            try {OS.close();} catch (IOException e) { }
            mode = 0; /* mark file as closed (mode) */
            return is; /* return error-message */
          } /* error encountered while 'insert length-field' */
        } else p += 2; /* compressed output was requested */
        p += 16; /* compute overall length of prefix */

        if((is=BIO.writeTo(OS,p))!=null) { /* write (new) prefix from buffer to file */
          try {OS.close();} catch (IOException e) { }
          mode = 0; /* mark file as closed (mode) */
          return is; /* return error-message */
        } /* Error encountered -- close file and terminate */

        if(cpr) OS = new DeflaterOutputStream(OS); /* change outputstream to compress implicitely */

        is = BIO.writeTo(OS); /* write buffer to file -- set errror */
        try { OS.close(); /* close output-file */
        } catch (IOException e) { /* error found -- handle it */
          if(is==null) is = e.toString(); /* set error */
        } /* establish error if needed and NOT already set */
        break;

      case( 2): /* 'binary output' (CB/UB) is active */

// TSUtil.Lg.Log("Msg010","...("+ItS.size()+")-->"+"buffer='"+BIO.toString()+"'");

        if(cpr) { /* output must be compressed, too */
          BIO.putByte(70,7); /* change '@' to 'F' within prefix */
          BIO.putInt(BIO.size()-16,4,8); /* and insert length of
            * whole data into byte 8 to 11. Do not count prefix of 16 bytes.
            */
        } /* compressed output is requested */
        if((is=BIO.writeTo(OS,16))!=null) { /* write prefix from buffer to file */
          try {OS.close();} catch (IOException e) { }
          mode = 0; /* mark file as closed (mode) */
          return is; /* return error-message */
        } /* Error encountered -- close file and terminate */

        if(cpr) OS = new DeflaterOutputStream(OS); /* compress implicitely */

        mode = 0; /* mark file as closed (mode) */
        if((is=BIO.writeTo(OS))!=null) { /* write all remaining data to file */
          try {OS.close();} catch (IOException e) { }
          return is; /* return error-message */
        } /* Error encountered */

        is = null; /* preset error-message to 'no error' */
        try { OS.close(); /* close output-file */
        } catch (IOException e) { is = e.toString(); /* set error */ }

        if(ItS.size()==0) break; /* File is fully created */
        return TSLogg.getMsg("TSFleC02",ItS.size()); /* return error-message */
      default: /* invalid mode -- provide error-message */
        return TSLogg.getMsg("TSFleC11",mode); /* return error-message */
    } /* close of file is executed */
    mode = 0; /* mark file as closed (mode) */
    return is; /* return with/without error */
  }

 /**. <pre>
  *=====================================================================
  * Method "Expand"
  * Process token-definitions and create lines of data.
  * Attention: - Method is ONLY used when 'input' is active.
  *            - Binary file is completely loaded into memory.
  *            - 'cP' is (mis)used as 'current-shift-level', which
  *              differs from value 'ItS.size()'.
  * ##Expand.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final boolean Expand() /* build a expanded line (min 1) */
   {
   /*-----------------------------------------------------------------*/
    TSFleTok cT;    /* temporary Tokendefinition */
    String   cL;    /* current output-Line */
    int      i,k;   /* work */
    long     j;     /* work */
    String   is;    /* work */
    boolean  CRLF;  /* CRLF is requested */
    boolean  retry; /* retry processing of current value */
   /*=================================================================*/
    cL = ""; /* initialize current line */
    LL:do { /* do until one line is fully provided */

      if(cItS.chkPos(Pos)<=0) { /* end of buffer of current token reached ? */
        do { /* loop until no more 'virtual token' active */
          retry = false; /* preset: processing do not need to be retried */
          while(cItS.chkOpt(0)) if(cItS.advDef()) break;
            /* skip optional entries, break if end is reached.
             * 'if(cItS.chkAdv(true))' is not needed because 'opt' is set.
             */

          if(cItS.chkFlg3()) cL = skpLne(cL,true); /* LF-requested, save buffer */
            /* If a surrounding token activated a 'virtual token', Flag5 CANNOT
             * be true with this type-definition. So, the line can be skipped
             * only once using the type-definition of the 'virtual token'.
             */

          if((is=cItS.isEOT())!=null) { /* items are still required -- error */
            /* 'isEOT()' skips 'until-end'-condition if appropriate */ 
            EMsg = TSLogg.getMsg("TSFleE01",cItS.getName(),is); /* error-message */
            return true; /* signal error and return */
          } /* no required item found -- signal error and return */

          /* EOT is active! However, if the current token is a 'virtual token',
           * this must be left and the surroundng token must be processed
           * in the same way until a surrounding token, which is NO
           * 'virtual token' reaches EOT.
           */
          if(cItS.isVT()) { /* 'virtual token' is at EOT -- release it */
            try { cItS = ItS.pop(); /* get old token-environment */
            } catch (EmptyStackException e) { /* underflow -- no further action */
              EMsg = TSLogg.getMsg("TSFleE02",e.toString()); /* error-message */
              return true; /* signal error and return */
            } /* no valid token-environment available -- signal error and return */
            /* Attention: DO NOT decrease 'cP' because of 'virtual token' */
            retry = true; /* processing must be retried */
          } /* current token was a virtual one */
        } while(retry); /* processing was NOT fully complete -- retry it */

        CRLF = cItS.setLF(true); /* last newLine-Status 'End of Embedded Token' is used */
          /* No longer needed status is set to 'true' */
        try { cItS = ItS.pop(); /* get old token-environment */
        } catch (EmptyStackException e) { /* underflow -- no further action */
          return false; /* return WITHOUT ERROR (no line written = EOF) */
          /* The outermost environment-definition DOES NOT contain a valid token-environment.
           * It is ONLY used to control the whole file. So, no line is returned with this
           * definition.
           */
        } /* outermost token-environment available -- terminate expand completely */
        cP -= 1; /* adjust current shift-level of the outputline */

        if(cL.length()==0) cL = getPrfx(false); /* init line with prefix if missing */
        if(CRLF) { /* CRLF after previous token required */
          cL += ")"; /* mark end of (previous) token */
          break LL; /* create current line and return */
        } /* mark end of (previous) token and terminate */

        cL += ") "; /* mark end of (previous) token and continue */
      } else { /* now: current token is NOT fully processed */

// TSUtil.Lg.Msg("Msg010",getPrfx(false)+"("+ItS.size()+")--> Pos="+Pos+
//        ", zPos="+cItS.chkPos(0)+", TTyp="+cItS.getKey().toString()+
//        ", TNme='"+cItS.getName()+ "', Act="+TSUtil.toHex(cItS.getCmd(false),-4)+
//        ", cL='"+cL+"'");

        /* process token -- 1) check for comment */
        if(cItS.isCmt()) { /* comment is active and must be processed */
          i = (int)getInt(2); /* get length of comment-string ('Pos' is inc.) */
          is = getString(i); /* get string itself ('Pos' is incremented) */
          if(is==null) return true; /* error found -- break */
// TSUtil.Lg.Msg("Msg010",getPrfx(false)+"("+ItS.size()+")--> Laenge="+i+", is='"+is+"'");

          while((i=is.indexOf("\r\n"))>=0) { /* 'CRLF' available -- process it */
            cL += is.substring(0,i); /* add part of comment */
            DtaI.add(cL); /* add current line to end of FIFO-buffer */
            cL = ""; /* reset current line after writing */
            is = is.substring(i+2); /* delete part of comment (incl. break-chars) */
          } /* comment-string was processed */
          cL += is + ") "; /* terminate-comment-statement */

          CRLF = false; /* set default 'current token still valid' */
          if(cItS.chkAdv(false)) /* check if 'advance' definition to next
                                  * 'requested item' is now requested. */
            CRLF = cItS.advDef(); /* advance definition to next 'requested item' now */
          if(CRLF) { /* current token no longer valid -- token is processed */
            try { cItS = ItS.pop(); /* get old token-environment */
            } catch (EmptyStackException e) { /* underflow -- no further action */
              EMsg = TSLogg.getMsg("TSFleE11",e.toString()); /* error-message */
              return true; /* signal error and return */
            } /* no token-environment available -- signal error and return */
            /* Attention: DO NOT decrease 'cP' because of 'comment' */
          }
          break LL; /* create current line and return */
        } /* comment was processed */

        /* if next token/type to be processed is 'optional' and if it matches all
         * preconditions of this position, it must be changed to 'requested' in order to
         * be processed correctly.
         */
        while(cItS.chkOpt(Pos)) cItS.advDef(); /* skip unusable optionals */
          /* advance definition to next 'requested item' if 'optional' item cannot be used.
           * Attention: - 'Pos' must not equal '0', because not all preconditions are
           *              checked in this case.
           *            - 'Optional'-Attribute is cleared, if type-specification is
           *              applicable.
           */

// TSUtil.Lg.Msg("Msg010",getPrfx(false)+"("+ItS.size()+")--> Pos="+Pos+
//        ", zPos="+cItS.chkPos(0)+", Act="+TSUtil.toHex(cItS.getCmd(false),-4));

        /* process token -- 2) process due to current type-definition */
        if(cL.length()==0) cL = getPrfx(false); /* init line with prefix if missing */
        do { /* loop until processing was successful */
          retry = false; /* preset: processing do not need to be retried */
          cT = null; /* preset: no new token activated */
          switch(i=cItS.getCmd(true)) { /* check due to current step */
            case( 0): /* step: 'Embedded Token' */
              i = (int)getInt(4); /* get number of new token */
              cT = getTok(i); /* get current token-definition */

// TSUtil.Lg.Msg("Msg010",getPrfx(false)+"("+ItS.size()+")--> Pos="+Pos+
//        ", zPos="+cItS.chkPos(0)+", '"+(cT==null?"<null>":cT.toStr())+
//        "', cL='"+cL+"'");

              if(cT==null) { /* Token is NOT defined in table */
                /* (requested) Token is NOT defined in table  -- terminate? */
                if(cItS.isOpt()) { /* token (was) NOT required -- try next */
                  cItS.advDef(); /* skip optional entry, advance to next 'item'.
                    * 'if(cItS.chkAdv(false))' is not needed because 'opt' is set.
                    */
                  Pos -= BIO.unRead(4); /* switch back before number of token */

// TSUtil.Lg.Msg("Msg010",getPrfx(false)+"("+ItS.size()+")--> Pos="+Pos+
//       ", zPos="+cItS.chkPos(0)+", Act="+TSUtil.toHex(cItS.getCmd(false),-5)+", cL='"+cL+"'");

                  retry = true; /* processing must be retried */
                  break; /* current step is successfully processed */
                } /* type-definition was optional */
                EMsg = TSLogg.getMsg("TSFleE21",""+i,Pos,cItS.chkPos(0));
                return true; /* set 'end of data' and mark error */
              } /* Systemerror found */

              if(cItS.clrFlg2()) cL = skpLne(cL,false); /* skip to next line due to request */
              if(!cT.isCmt()) break; /* current step is successfully processed */

              /* new token is a comment -- special handling needed */
              ItS.push(cItS); /* save current environment to stack */
                /* number of elements is incremented. So 'size()' is level */
                /* Attention: DO NOT increase 'cP' because of 'comment' */

              cItS = new TSFleStack(cT); /* create new environment */
                /* Attention: New value for 'current command' is established
                 *            Values are transfered to counter 1 & 2
                 *
                 * Attention: 'label' contains REAL comment-keyword */

              i = (int)getInt(4); /* get length of token ('Pos' is incremented) */
              cItS.setPos(Pos+i); /* compute and store pointer to buffer-end of current token */
              i = BIO.read(); /* get label-length (= keyword-length) */
              Pos += 1; /* adjust pointer due to length read */
              if(i<0) { /* EOF found within comment -- error within comment */
                EMsg = TSLogg.getMsg("TSFleE12",i); /* create error-message */
                return true; /* set 'end of data' and mark error */
              } /* read-error found */
              if(i==0) is = cT.getName(); /* no label -- use default-keyword */
              else { /* read real keyword from label-definition */
                is = getString(i); /* read label and increment pointer */
                  /* ATTENTION: Label MUST NOT contain blank/quotes/backslash/... */
                if(is==null) return true; /* error found -- break */
              } /* requested keyword is now available */
              cL += is + " ("; /* add name of current token (and start of token) */
              continue LL; /* current step is successfully processed -- get next data */
            case( 1): /* step: Process 'UInt' */
              if(cItS.clrFlg2()) cL = skpLne(cL,false); /* skip to next line due to request */
              if(cItS.clrFlg4()) { /* first value must be stored -- process different */
                /* Attention: FIRST converted value of this type clears flag */
                j = getInt(4); /* extract next value, only unsigned values */
                cRep = (int)j; /* remember value if requested */
                is = "" + j + " "; /* set value to current line */
              } else is = getUInt$(cItS.getRep(Pos)); /* extract all requested
                * values. if 'until-end' is requested, the number is computed
                * from the distance to EOT. */
              cL += is; /* add value(s) to current line */
              break; /* current step is successfully processed */
            case( 2): /* step: Process 'SInt' */
              if(cItS.clrFlg2()) cL = skpLne(cL,false); /* skip to next line due to request */
              EMsg = null; /* clear current error-message */
              if(cItS.clrFlg4()) { /* first value must be stored -- process different */
                /* Attention: FIRST converted value of this type clears flag */
                cRep = (int)getInt(4); /* extract next value, only unsigned values */
                is = "" + cRep + " "; /* set value to current line */
              } else is = getInt$(cItS.getRep(Pos)); /* extract all requested
                * values. if 'until-end' is requested, the number is computed
                * from the distance to EOT. */
              if(EMsg!=null) return true; /* error found -- break */
              cL += is; /* add value(s) to current line */
              break; /* current step is successfully processed */
            case( 3): /* step: 'Process 'String' */
              if(cItS.clrFlg2()) cL = skpLne(cL,false); /* skip to next line due to request */
              is = getString$(cItS.chkFlg4()); /* extract all requested values */
              if(EMsg!=null) return true; /* error found -- break */
              cL += is; /* add value to current line */
              break; /* current step is successfully processed */
            case( 4): /* step: Process 'Hex(2)' */
            case( 5): /* step: Process 'Hex(4)' */
            case( 6): /* step: Process 'Hex(8)' */
              if(cItS.clrFlg2()) cL = skpLne(cL,false); /* skip to next line due to request */
              is = getHex$(cItS.getRep(Pos),2<<(i-4),cItS.chkFlg4()); /* extract all
                * requested values. if 'until-end' is requested, the number is computed
                * from the distance to EOT. */
              cL += is; /* add value(s) to current line */
              break; /* current step is successfully processed */
            case( 7): /* step: Process 'Float(2)' */
            case( 8): /* step: Process 'Float(3)' */
            case( 9): /* step: Process 'Float(4)' */
            case(11): /* step: Process 'Float(6)' */
            case(13): /* step: Process 'Float(8)' */
              if(cItS.clrFlg2()) cL = skpLne(cL,false); /* skip to next line due to request */
              i = cItS.chkFlg4() ? 5-i : i-5; /* compute number of digits and add marker */
              is = getFloat$(cItS.getRep(Pos),i); /* extract all requested
                * values. if 'until-end' is requested, the number is computed
                * from the distance to EOT. */
              if(EMsg!=null) return true; /* error found -- break */
              cL += is; /* add value(s) to current line */
              break; /* current step is successfully processed */
            case(10): /* step: Process 'Time-Format' */
              /* Attention: Step will be repeated until all values are processed.
               */
              j = getInt(4); /* extract next (unsigned) value */
              if(cItS.chkFlg4()) is = " "; /* seconds are NOT needed */
              else { /* seconds must be shown */
                i = (int)(j % 60); /* extract seconds from time-value */
                is = ":" + DF2.format(i) + " "; /* set value to current line */
              } /* seconds are shown */
              j /= 60; /* delete seconds and compute remaining-time-value */
              i = (int)(j % 60); /* extract minutes from time-value */
              is = DF2.format(i) + is; /* set value to current line */
              j /= 60; /* delete minutes and compute remaining-time-value */
              cL += DF2.format(j) + ":" + is; /* set hours to current line */
              break; /* current step is successfully processed */
            case(12): /* step: Process 'Loop-Definition' */
              /* create a 'virtual token' - definition and activate it. Transfer the current
               * item to the first type-definition of the new token.
               */
              i = cItS.getCnt(); /* get number of virtual token (number is NEGATIVE). */
              cT = getTok(i); /* get new token-definition */

// TSUtil.Lg.Msg("Msg010",getPrfx(false)+"("+ItS.size()+")--> Pos="+Pos+
//        ", zPos="+cItS.chkPos(0)+", '"+(cT==null?"<null>":cT.toStr())+
//        "', cL='"+cL+"'");

              if(cT==null) { /* Token is NOT defined in table */
                /* (requested) Token is NOT defined in table  -- terminate */
                EMsg = TSLogg.getMsg("TSFleE13",cL,i,Pos); /* error-message */
                return true; /* signal error and return */
              } /* virtual token was NOT found -- Error */

              if(cItS.chkAdv(false)) /* check if 'advance' definition to next
                                      * 'requested item' is now requested. */
                cItS.advDef(); /* advance definition to next 'requested item' now */
              cItS.clrFlg1(cRep); /* process new entry if 'repeat-value' is changed */

// TSUtil.Lg.Msg("Msg010",getPrfx(false)+"("+ItS.size()+")--> Pos="+Pos+
//        ", zPos="+cItS.chkPos(0)+", Loop='"+cItS.toStr()+"'");

              ItS.push(cItS); /* save current environment to stack */
                /* number of elements is incremented. So size() is dbg-level */
                /* Attention: DO NOT increase 'cP' because of 'virtual token' */
              cItS = new TSFleStack(cT,cItS.chkPos(0)); /* create new (virtual) environment */
                /* Attention: New 'first type-definition' is established.
                 *            No data (like tokendefiniton) is created for virtual token.
                 */
              retry = true; /* processing must be retried with new definition */
              break; /* current step is successfully processed */
            case(14): /* step: Process 'Bytes' */
              if(cItS.clrFlg2()) cL = skpLne(cL,false); /* skip to next line due to request */
              if((is=cItS.clrFlg4_EE(Pos,64))!=null) cL += is;
                /* Compute remaining number of values if requested and add number
                 * to target. */
              cL += "" + BIO.read() + " "; /* extract ONE requested values. */
              Pos += 1; /* increment current position */
                /* Attention: 'getRep()' will return a wrong value in case
                 *            'until-end'-condition is active. So, repeat step
                 *            until all values are processed.
                 */
              break; /* current step is successfully processed */
            case(15): /* step: Process 'String(split)' */
              is = getString$(true); /* extract all requested values */
              if(EMsg!=null) return true; /* error found -- break */
              /* line is provided -- split it if needed */
              k = cItS.getCnt(); /* get maximum line-length from item-def. */
// TSUtil.Lg.Msg("Msg010",getPrfx(false)+"("+ItS.size()+")--> Pos="+Pos+
//        ", zPos="+cItS.chkPos(0)+", cLine='"+cL+"', Data='"+is+
//        "', MaxLen="+k+", TNme='"+cItS.getName()+"'");
              while(is.length()>k) { /* string is too long -- split it */
                i = is.substring(0,k).lastIndexOf("\\n"); /* search for 'LF' */
                if(i<1) { /* no 'linefeed' found -- try normal 'whitechar' */
                  for(i=k;i>0;i-=1) /* search for previous Whitespace */
                    if(Character.isWhitespace(is.charAt(i))) break;
                      /* curr. position contains Whitespace - signal it */
                  if(i<1) break; /* split is no longer active */
                    /* no split-position found -- DO NOT split string */
                } else i += 2; /* include 'linefeed' into string */

                cL += is.substring(0,i) + "\"+"; /* add value to current line */
                DtaI.add(cL); /* add current line to end of FIFO-buffer */
                is = "\"" + is.substring(i); /* remove part already written */
                cL = getPrfx(true); /* set new prefix to line */
              } /* line is splitted as requested */
              cL += is; /* provide rest of string as result */
              break; /* current step is successfully processed */
            default: /* no valid step defined -- EOT-reached */
              if(!cItS.isVT()) { /* token, which reached EOT, was NOT a virtual one */
                EMsg = TSLogg.getMsg("TSFleE22",cL,cItS.getName(), /* error-message */
                       TSUtil.toHex(cItS.getCmd(false),-4),""+i,""+Pos);
                return true; /* signal error and return */
              } /* token, which reached EOT, was NOT a virtual one -- error */
              /* NOW: virtual token has reached EOT -- release it */
              try { cItS = ItS.pop(); /* get old token-environment */
              } catch (EmptyStackException e) { /* underflow -- no further action */
                EMsg = TSLogg.getMsg("TSFleE02",e.toString()); /* error-message */
                return true; /* signal error and return */
              } /* no token-environment available -- signal error and return */
              /* Attention: DO NOT decrease 'cP' because of 'virtual token' */
              retry = true; /* processing must be retried with new definition */
          } /* -switch- process due to current type-definition */
        } while(retry); /* processing was NOT complete -- retry it */

// TSUtil.Lg.Msg("Msg010",getPrfx(false)+"("+ItS.size()+")--> Pos="+Pos+", cL='"+cL+"'");

        CRLF = !cItS.chkFlg4(); /* get last newLine-Status 'End of Embedded Token' */
           /* state must be transfered to 'Embedded Token' */

        if(cItS.chkAdv(false)) { /* check if 'advance' definition to next
                                  * 'requested item' is now requested. */
          if(cItS.chkFlg3()) cL = skpLne(cL,true); /* LF-requested, save buffer */
          cItS.advDef(); /* advance definition to next 'requested item' now */
        } /* 'advance to next 'requested item' was requested */

        cItS.clrFlg1(cRep); /* process new entry if 'repeat-value' is changed */

        if(cT!=null) { /* valid token found -- embedded token starts here */
          /* Attention: new token is NOT a comment. */
          ItS.push(cItS); /* save current environment to stack */
            /* number of elements is incremented. */
          cP += 1; /* adjust current shift-level of the outputline */

          cItS = new TSFleStack(cT); /* create new environment */
            /* Attention: New value for 'current command' is established
             *            Values are transfered to counter 1 & 2 */
          cItS.setLF(CRLF); /* transfer last newLine-Status 'End of Embedded Token' */
          cL += cT.getName() + " "; /* add name of current token */
          i = (int)getInt(4); /* get length of token ('Pos' is incremented) */
          cItS.setPos(Pos+i); /* compute and store pointer to buffer-end of current token */
          i = BIO.read(); /* get optional label-length */
          Pos += 1; /* adjust pointer due to length read */
          if(i>0) { /* Label defined -- process it */
            is = getString(i); /* read label */
              /* ATTENTION: Label MUST NOT contain blank/quotes/backslash/... */
            if(is==null) return true; /* error found -- break */
            cL += is + " "; /* and add it to current line */
          } /* Label is processed */
          cL += "( "; /* Processing of token starts here */
        } /* new token-definition has been created */ 
      } /* token was NOT fully processed */

    } while(cL.length()<MaxLen); /* -LL- loop until at least ONE complete line is provided */

    /* current line is complete -- create it and return */
    if(cL.endsWith(" ")) cL = cL.substring(0,cL.length()-1);
    DtaI.add(cL); /* add current line to end of FIFO-buffer */
    return false; /* OK -- return without error */
  }

 /**. <pre>
  *=====================================================================
  * Method "getData"
  * Read next line
  * Next line is provided from file or buffer
  * If buffer is empty is is filled with decompressed data from file
  * if an error is found: EMsg is set and 'null' is returned
  * ##getData.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getData() /* read new line of data */
   {
   /*-----------------------------------------------------------------*/
    String is; /* Work-buffer */
   /*=================================================================*/
    EMsg = null; /* clear current error-message */
    if(Fle==null) { /* no active file definition */
      EMsg = TSLogg.getKey("TSFleD01"); /* set error-message */
      return null; /* return and signal error */
    } /* no active file -- return and signal error */
    if(mode>=0) { /* file is opened for output or close */
      EMsg = TSLogg.getMsg("TSFleD02",FNme,mode); /* set error-message */
      return null; /* return and signal error */
    } /* return and signal error */

    if(mode<-1) { /* 'binary input' is neccessary  (mode = '-2') */
      /* does buffer contain lines ? */
      if(DtaI.size()==0) { /* no data in line-buffer -- fill it */
        /* expand/decompress until next line(s) is provided */
        if(Expand()) return null; /* return and signal error */
      } /* line-buffer is filled (?) */
      if(DtaI.size()==0)  return null; /* still no lines -- EOF */

      is = DtaI.remove(0); /* get next/first line from buffer */
      rl = Math.max(rl,is.length()); /* compute max read record-length */
      rc += 1; /* and count record */
      return is; /* return new data */
    } /* Decompress is neccessary */

    /* file only need to be read */
    try {is = Rdr.readLine(); /* get next line from file */
    } catch (IOException e) { /* Input-error ? */
      System.err.println(e.toString());
      EMsg = TSLogg.getMsg("TSFleD03",FNme); /* create Message */
      return null; /* set 'end of data' and mark error */
    } /* Input-error occurred */
    if(is==null) return null; /* EOF found -- signal it */
    rl = Math.max(rl,is.length()); /* compute max read record-length */
    rc += 1; /* and count record */
    return is; /* return new data */
  }

 /**. <pre>
  *=====================================================================
  * Method "getErr"
  * Get active error-message ('null' if none)
  * ##getErr.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getErr() /* get current error-message */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return EMsg; /* provide error-message or 'null' */
  }

 /**. <pre>
  *=====================================================================
  * Method "getFloat"
  * Get 4 Byte from file, use as FLOAT and convert them to STRING
  * ##getFloat.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final String getFloat( /* read float-value and convert it */
   int c) /* number of relevant digits in mantissa (2..8,-2..-8) */
   {
   /*-----------------------------------------------------------------*/
    String s; /* result-string */
    int    i; /* temp. value */
    float  f; /* temp. value */
   /*=================================================================*/
    i = (int)getInt(4); /* get next Int-value from buffer */
    f = Float.intBitsToFloat(i); /* convert value to float */
    if(Float.isNaN(f)) return "NaN"; /* invalid number -- mark it */
    if(f==0.0) return "0"; /* simple value */
    i = Math.abs(c) - 2; /* compute index to array */
    if(Math.abs(f)<F[i] || Math.abs(f)>=1E8) /* select format */
      s = sF[i].format(f); /* format float to string */
    else if(c>0) s = dF[i].format(f); /* format float to string */
      else s = xF[i].format(f); /* format float to string */

// TSUtil.Lg.Msg("Msg010","Convert Float --> Source = '" + f +
//               "', Result = '" + s + "'");
    i = s.indexOf('.'); /* get position of decimal point */
    if(i<0) return s; /* no decimal point -- OK */
    if(s.endsWith(".0")) return s.substring(0,i); /* OK */
    return s; /* provide result */
  }

 /**. <pre>
  *=====================================================================
  * Method "getFloat$"
  * Get 'rep' x float-value from file using 'getFloat()'
  * ##getFloat$.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final String getFloat$( /* read float-values and convert */
   int rep, /* number of values */
   int rd)  /* number of relevant digits in mantissa (+ marker) */
   {
   /*-----------------------------------------------------------------*/
    StringBuilder s; /* result */
   /*=================================================================*/
    s = new StringBuilder(); /* initialize result */
    while(--rep>=0) { /* add all requested value(s) */
      s.append(getFloat(rd)); /* extract and add next value to line */
      s.append(' '); /* add delimiter to line */
    } /* -while- process all values */
    return s.toString(); /* provide result */
  }

 /**. <pre>
  *=====================================================================
  * Method "getHex$"
  * Get 'rep' x UINT from file and convert to 'hexadecimal'-String
  * ##getHex$.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final String getHex$( /* read integer and convert */
   int     rep, /* number of values */
   int     len, /* number of valid digits (2,4,8) */
   boolean up)  /* result should use uppercase character */
   {
   /*-----------------------------------------------------------------*/
    int    i;    /* temp. value(s) */
    String rs,s; /* result-string */
   /*=================================================================*/
    rs = ""; /* initialize result */
    while(--rep>=0) { /* add all requested value(s) */
      i = (int)getInt(4); /* extract next value */
      s = "0000000"+Integer.toHexString(i); /* convert to hexadecimal */
      rs += s.substring(s.length()-len) + " "; /* add value to string */
    } /* -while- process all values */
    return up ? rs.toUpperCase() : rs; /* change result to uppercase */
  }

 /**. <pre>
  *=====================================================================
  * Method "getInt"
  * Get 'Integer'/'Unsigned Integer' ('len' Byte) from buffer as 'long'.
  * Method uses current inputbuffer and increments position-pointer.
  * ##getInt.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final long getInt( /* read long-Integer from buffer */
   int len) /* length of input-field (1..8) */
   {
   /*-----------------------------------------------------------------*/
    long j; /* result */
   /*=================================================================*/
    j = BIO.getInt(len); /* get next Int-value from buffer */
      /* Attention: If an error occurrs, whole program is terminated */
    Pos += len; /* and increment current position */
    return j;   /* provide caller with result */
  }

 /**. <pre>
  *=====================================================================
  * Method "getInt$"
  * Get 'rep' x int-value from file using 'getInt()'
  * Convert SIGNED values to String and concatenate them
  *   (separated with ' ')
  * ##getInt$.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final String getInt$( /* read Integer-values and convert */
   int rep) /* number of values */
   {
   /*-----------------------------------------------------------------*/
    int    i; /* temp. value(s) */
    String s; /* result */
   /*=================================================================*/
    s = ""; /* initialize result */
    while(--rep>=0) { /* add all requested value(s) */
      i = (int)getInt(4); /* extract next value, i is signed */
      s += i + " "; /* add value(s) to current line */
    } /* -while- process all values */
    return s; /* provide result */
  }

 /**. <pre>
  *=====================================================================
  * Method "getItem"
  * Extract next item and provide it in String-format.
  *   Surrrounding quotes are deleted if present.
  * If no item is found, 'null' is returned.
  * Method operates on 'DtaO' and uses pointer 'cP'
  *  (compare to 'remark' within method 'reduce').
  * If 'empty remaining string' is found, 'Mkr0' is returned.
  * If string-fragment was successfully stored, 'Mkr0' is returned.
  * If a valid 'empty string' is found, 'Mkr1' is returned.
  *
  * Testing for 'special values' is possible! (rv!=null)
  *  In this case 'null' is returned if match is found
  *   and the found original values otherwise.
  *
  * ATTENTION: '(' and')' is a valid seperator. So, these chars can
  *            only be skipped using 'request special value'.
  * Attention: This method uses global 'Reduce'-buffer 'DtaB' to support
  *            input-records which are split among more than one line.
  * ##getItem.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final String getItem( /* get next String-Value */
   String rv) /* requested value or 'null' */
   {
   /*-----------------------------------------------------------------*/
    String        s;   /* temporary string */
    int           i,j; /* temp. value(s) */
    char          cc;  /* current character to be processed */
    boolean       esc; /* escape-character found */
    boolean       rep; /* repeat action because of fragmented string */
   /*=================================================================*/
    nxtC:{ /* block is used for 'break' */
      for(j=DtaO.length();cP<j;cP+=1) /* until end-of-line */
        if(!Character.isWhitespace(DtaO.charAt(cP))) break nxtC;
          /* position contains no Whitespace - signal it */
      return Mkr0; /* return marker for 'empty (remaining) string' */
    } /* -nxtC- skip to first valid character -- position found */

    if(rv!=null) { /* special value requested */
      /* Attention: 'special value' must not be a 'quoted string' */
      i = cP + rv.length(); /* compute position due to length */
      if(i>j) return rv; /* error -- string does not fit */
      s = DtaO.substring(cP,i); /* extract string to compare */
      if(!s.equalsIgnoreCase(rv)) return s; /* return string as an error-signal */
      cP = i; /* skip valid characters */
      return null; /* return with no error */
    } /* request for special characters was active */

    /* 'cP' points to first valid character */
    if(DtaO.charAt(cP)=='"') { /* String contain quotes */
      do { /* process ALL string-segments on current line */
        rep = false; /* preset: no MORE string-segments on current line */
        cP += 1; /* skip quote-character */
        for(i=cP,esc=false;i<j;i+=1) { /* check termination */
          cc = DtaO.charAt(i); /* get current char */
          if(cc=='\\') { /* escape-character found */
            if(esc) DtaB.append(cc); /* already found -- set '\' */
            esc = !esc; /* set/reset current escape-marker */
            continue; /* -for- character fully processed */
          } /* escape-character was found */
          if(cc=='"') { /* EOS-marker found (EOS='end of string') */
            esc = !esc; /* set/reset current escape-marker */
            if(esc) break; /* -for- EOS found -- terminate check */
          } /* eos-character was found */
          if(esc) { /* illegal escape-sequence found ? */
            esc = false; /* reset current escape-marker */
            switch(cc) { /* check if valid escape-sequence */
              case('r'): cc = '\r'; break; /* replace with valid character */
              case('n'): cc = '\n'; break; /* replace with valid character */
              case('t'): cc = '\t'; break; /* replace with valid character */
              default: DtaB.append('\\'); /* do not change sequence -- add esc again */
            } /* check if valid escape-sequence */
          } /* illegal escape-sequence found ? */
          DtaB.append(cc); /* transfer current character (ggf.: '"' */
        } /* -for- check and copy characters */
        if(i>=j) return null; /* second quote is missed -- signal error */
        cP = i + 1; /* set continuation if successful */

        if(cP<j) { /* characters are still available -- test for splitted string
          * A string may consist of more than one segments, which are connected
          * using a single '+'-character. Each of these segments are surrounded
          * with quotes and they MAY be located on different lines. However, no
          * other definitions can interrupt this sequence of string-segments. */
          for(i=cP;i<j;i+=1) /* until end-of-line */
            if(!Character.isWhitespace(DtaO.charAt(i))) break;
              /* position contains no Whitespace - signal it */
          if(i<j) /* another valid character found on the line */
            if(DtaO.charAt(i)=='+') { /* marker for splitted line found -- handle it */
              cP = i + 1; /* set continuation if successful */

              cntC:{ /* block is used for 'break' */
                for(i=cP;i<j;i+=1) /* until end-of-line */
                  if(!Character.isWhitespace(DtaO.charAt(i))) break cntC;
                    /* position contains no Whitespace - signal it */
                 return Mkr0; /* empty string -- return marker for 'fragment stored' */
              } /* -cntC- skip to first valid character -- position found */

              if(DtaO.charAt(i)!='"') return null; /* no valid continuation found */
              cP = i; /* change continuation if successful */
              rep = true; /* process next string-segment of current line */
            } /* record-fragment was handled successfully */
        } /* no fragment defined -- use complete result */
      } while(rep); /* process all string-segments on current line (if present) */

      s = DtaB.toString(); /* create result without error */
      DtaB.setLength(0); /* clear current data-fragment */
      if(s.length()==0) s = Mkr1; /* replace empty string with special marker */
      return s; /* provide result without error */
    } /* String was surrounded by quotes */

    if(DtaB.length()>0) return null; /* error -- invalid continuation */

    /* maximum length of string is already set -> initial-value */
    i = cP; /* save start-position of string */
    while(cP<j) { /* search for 'end of string' (EOS) */
      cc = DtaO.charAt(cP); /* extract character to be checked */
      if(Character.isWhitespace(cc)) break; /* EOS found */
      if("()\"".indexOf(cc)>=0) break; /* term-character found */
      cP += 1; /* valid character -- skip it */
    } /* check all characters until EOS */
    return DtaO.substring(i,cP); /* extract string-value and return it */
  }

 /**. <pre>
  *=====================================================================
  * Method "getMode"
  * Provides caller with last used I/O-mode, modified as requested.
  * Attention: I/O-Mode is masked to reflect binary/compress ONLY.
  * ##getMode.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getMode( /* provide last used I/O-Mode (mod) */
   int md) /* requested modifications */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if((cMde&IO_bio)!=0) return (cMde & IO_bin) | md; /* I/O-mode */
    return (cMde & IO_Msk) | md; /* provide last used I/O-mode */
  }

 /**. <pre>
  *=====================================================================
  * Method "getPath"
  * Returns current (complete / fully-qualified) filename as stored.
  * ##getPath.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getPath() /* returns filename */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return FNme; /* return current fully-qualified filename */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getPrfx"
  * Returns a prefix-definition of an output-line as String using
  *   iteration-counter as basis. This method uses the current
  *   shift-level as basis.
  *   'cP' is (mis)used as 'current-shift-level', which differs from
  *     value 'ItS.size()'.
  * ##getPrfx.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final String getPrfx( /* return line-prefix */
   boolean ext) /* extend length if requested ('true) */
   {
   /*-----------------------------------------------------------------*/
    char[] t; /* temporary array */
    int    i; /* length of requested prefix */
   /*=================================================================*/
    if(cP==0) return ""; /* no object -- return default */
    i = cP; /* get requested size of prefix */
    if(ext) i += 1; /* extended size should be used */
    if(i<1) return ""; /* no iteration -- return default */
    t = new char[i]; /* create array of requested length */
    Arrays.fill(t,'\t'); /* fill it with requested character */
    return new String(t); /* convert to String and return */
  }

 /**. <pre>
  *=====================================================================
  * Method "getStat"
  * Get statistic-values of current I/O
  * Attention: values are valid even if file is already closed
  *            values are initialized when file is opened (again)
  * ##getStat.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getStat( /* get current statistic-values */
   boolean c) /* return 'counter' if 'true' (else 'length') */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c) return rc; /* return current record-counter */
    return rl; /* provide maximum record-length */
  }

 /**. <pre>
  *=====================================================================
  * Method "getString"
  * Read Unicode-String from binary file.
  * ATTENTION: + No additional Blank is added.
  *            + If input-data is not fully available, up to 5 retries
  *               are scheduled.
  *            + Data may be read from 'file' or 'IO-buffer' (due to IS).
  *            + Position-pointer 'Pos' is adjusted.
  * ##getString.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final String getString( /* get String from file */
   int len) /* length of requested string */
   {
   /*-----------------------------------------------------------------*/
    int    i,p,r,bl1,bl2; /* intermediate values */
    String s;             /* result-string */
   /*=================================================================*/
    EMsg = null; /* clear current error-message */
    if(len==0) return ""; /* return unstored valid string */
    s = BIO.getString(len); /* get requested string from buffer */
    if(s==null) { /* result not available -- propagate error */
      EMsg = TSLogg.getMsg("TSFleM31",Pos,len); /* error-message */
      return null; /* not enough data available */
    } /* not enough data available */
    i = s.length(); /* get correct length of result */
    Pos += i * 2; /* increment current position */
    if(i==len) return s; /* stringlength matches -- return result */
    EMsg = TSLogg.getMsg("TSFleM32",""+Pos,i,len); /* error-message */
    return null; /* not enough data available */
  }

 /**. <pre>
  *=====================================================================
  * Method "getString$"
  * Get one String-definition and surround it with quotes if needed or
  *   requested.
  * ##getString$.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final String getString$( /* read String and process it */
   boolean add) /* add quotes ('"') in every case (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    int    i; /* length of string */
    String s; /* result */
   /*=================================================================*/
    EMsg = null; /* clear current error-message */
    i = (int)getInt(2); /* get length of string ('Pos' is inc.) */
    s = getString(i); /* get string itself ('Pos' is incremented) */
    if(s==null) return null; /* error found -- break */
    if(add) return TSUtil.addStr(s) + " "; /* add quotes in any case */
    return TSUtil.modStr(s) + " "; /* surround with quotes if necessary */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTok" (Dummy for extended classes)
  * Provide requested token due to token-number.
  * This dummy-version, which should be overwritten, returns an error.
  * ##getTok.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSFleTok getTok(int i) { return null; }

 /**. <pre>
  *=====================================================================
  * Method "getTok" (Dummy for extended classes)
  * Provide requested token due to token-name.
  * This dummy-version, which should be overwritten, returns an error.
  * ##getTok.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSFleTok getTok(String s) { return null; }

 /**. <pre>
  *=====================================================================
  * Method "getTyp" (Dummy for extended classes).
  * Provides current identifier-type (if available).
  * This dummy-version, which should be overwritten, returns a
  *   default-value (0).
  * ##getTyp.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected int getTyp() { return 0; }

 /**. <pre>
  *=====================================================================
  * Method "getUInt$"
  * Get 'rep' x unsigned int-value from file using 'getInt()'
  * Convert unsigned values to String and concatenate them
  * ##getUInt$.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final String getUInt$( /* read Integer and convert them */
   int rep) /* number of values */
   {
   /*-----------------------------------------------------------------*/
    long   j; /* temporary result */
    String s; /* result */
   /*=================================================================*/
    s = ""; /* initialize result */
    while(--rep>=0) { /* add all requested value(s) */
      j = getInt(4); /* extract next value, only unsigned values */
      s += j + " "; /* add value(s) to current line */
    } /* -while- process all values */
    return s; /* provide result */
  }

 /**. <pre>
  *=====================================================================
  * Method "open"
  * Open file and create Reader or Writer
  * If 'Input' is requested (or special option):
  *    check input-mode of file (in this case 'iom'-argument is modified)
  *  All modes/formats are supported for 'input'!
  * The following I/O-ID's are used:
  *     IN  = 0(00)   Input, unknown format
  *     IUT = 128(80) Input, UT-Format (format is requested)
  *     IUB = 129(81) Input, UB-Format (format is requested)
  *     ICT = 130(82) Input, CT-Format (format is requested)
  *     ICB = 131(83) Input, CB-Format (format is requested)
  *     OUT = 8(08)   Output, UT-Format
  *     OUB = 9(09)   Output, UB-Format
  *     OCT = 10(0A)  Output, CT-Format
  *     OCB = 11(0B)  Output, CB-Format
  *     IU  = 16(10)  Input, unicode
  *     IA  = 17(11)  Input, ascii
  *     OU  = 24(18)  Output, unicode
  *     OA  = 25(19)  Output, ascii
  *     OUA = 28(1C)  Output, unicode,append
  *     OAA = 29(1D)  Output, ascii,append
  * This includes the following flags:
  *     IO_bin = x01  ASCII(=Binary) (else: Unicode=Text)
  *     IO_cpr = x02  Compress
  *     IO_app = x04  Append   (if 'buffered-I/O')
  *     IO_out = x08  Output
  *     IO_bio = x10  Buffered-IO (no File-ID)
  *     IO_rqf = x80  format requested with input
  *   and masks:
  *     IO_Msk = x03  mask file-format from IO-command
  *
  * Method returns an error-message or 'null' if no error
  * Attention: ALL Parameters are checked in any case!
  *            If 'binary input' is requested the COMPLETE file is also
  *               loaded into memory. Buffer-methods must then be
  *               used to access the data.
  * ##open.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String open( /* open file */
   int iom) /* requested 'Input'/'Output' - Mode */
   {
   /*-----------------------------------------------------------------*/
    InputStreamReader ISR; /* unicode-reader */
    TSFleTok          cT;    /* token to initialize iterationbuffer */
    String            is;  /* temp. value(s) */
    int               i,j,sio; /* temp. value(s) */
    char[]            cPrfx; /* character prefix for input */
    boolean           out;   /* output-mode specified (if 'true') */
    boolean           bio;   /* buffered-I/O specified (if 'true') */
    boolean           bin;   /* use binary mode (if 'true') */
   /*=================================================================*/
    EMsg = null; /* clear current error-message */
    sio = iom;      /* save IO-mode for checking */
    iom &= ~IO_rqf; /* and remove flag for 'requested format' */
    if(iom<0 || iom>31) return TSLogg.getMsg("TSFleO01",iom); /* error */
    if(Fle==null) return TSLogg.getKey("TSFleO02"); /* no active file */
    if(mode!=0) /* file is ALREADY open -- return with error */
      return TSLogg.getMsg("TSFleO03",mode); /* return error-message */
    bio = (iom&IO_bio)!=0; /* set request-flag (buffered IO) */
    out = (iom&IO_out)!=0; /* set request-flag (output) */
    bin = (iom%2)==1; /* set request-flag (binary plain/compressed) */

    if(out) { /* Output requested -- open file in output-mode */
      if(Fle.exists()) if(Fle.isDirectory()) /* directory! */
        /* File-definition describes a directory-entry -- return error */
        return TSLogg.getMsg("TSFleO11",FNme); /* return error-message */

      if(bio) { /* normal 'buffered-I/O' requested (no file-ID) */
        iom &= ~IO_cpr; /* Attention: compress is not allowed */
        if(bin) /* unicode NOT requested */
          try {Wtr = new BufferedWriter(new FileWriter(Fle,(iom&IO_app)!=0));
          } catch (IOException e) { /* IO-error received */
            return TSLogg.getMsg("TSFleO12",FNme,e.toString());
          } /* Exception definition/opening file */
        else  /* unicode IS requested */
          try {Wtr = new BufferedWriter(new OutputStreamWriter(
               new FileOutputStream(Fle,(iom&IO_app)!=0),"UnicodeLittle"));
          } catch (FileNotFoundException e) { /* file not found */
            return TSLogg.getMsg("TSFleO13",FNme,e.toString());
          } catch (UnsupportedEncodingException e) { /* invalid coding */
            return TSLogg.getMsg("TSFleO14",FNme,e.toString());
          } /* Exception definition/opening file */
        mode = 1; /* /* set interface-mode to 'output character' */
        cMde = iom; /* set active IO-mode */
        return null; /* file is open -- no error */
      } /* Output is 'buffered-I/O' (no file-ID) */

      is = chkFKng(null,bin); /* get current file-identifier, format available ? */
      if(is==null) return TSLogg.getMsg("TSFleO04",FNme,prtMode()); /* return error */
          /* terminate open because requested file-identifier could not be provided */

      if(bin) { /* Output' should be reduced/binary */
        /* use 'UB'-format or 'CB'-format for output */
        /* 'Reduce'/'binary output' has to be done in memory, because whole
         * length of data is not known */

        try { OS = new FileOutputStream(Fle); /* open file for 'raw output' */
        } catch (FileNotFoundException e) { /* parent-folder not found, file locked */
          return TSLogg.getMsg("TSFleO16",FNme,e.toString()); /* return error */
        } /* File-error found -- output-file could be created */
        /* Attention: Output-file is NOT used until it should be closed. */

        BIO.write("SIMISA@@@@@@@@@@"); /* write first 16 bytes into outputbuffer */
          /* Attention: format 'UB' is assumed -- must be changed if needed */
        is += "\r\n"; /* add CRLF */
        BIO.write(is); /* and append current file-identifier to outputbuffer */

        cItS = new TSFleStack(); /* Init 'dummy-token' and create Iterationsbuffer */
        ItS  = new Stack<TSFleStack>(); /* alloc. Storage for Iterations */
          /* Attention: current shift-level is NOT needed (no textual output-lines) */
        cItS.setPos(BIO.size()); /* set current position (start), Length is handled by 'BIO' */
        rc = 1;  /* Header is already written (formerly) */
        rl = 30; /* register length of header as max. record-length */

        mode = 2; /* /* set interface-mode to 'binary output' (plain/compressed) */
        cMde = iom; /* set active IO-mode */
        return null; /* file is open -- no error */
      } /* 'binary Output' was requested (plain/compressed) */

      /* 'character output should be done -- initialize it */
        /* use 'UT'-format or 'CT'-format for output */
//      iom &= ~IO_cpr; /* Attention: compress is not allowed */
//        /* only 'UT'-format is really used instead of 'CT'-format */

//      try { Wtr = new BufferedWriter(new OutputStreamWriter( /* Writer */
//                  new FileOutputStream(Fle),"UnicodeLittle"));
//      } catch (FileNotFoundException e) { /* parent-folder not found */
//        return TSLogg.getMsg("TSFleO21",FNme,e.toString()); /* return error-message */
//      } catch (UnsupportedEncodingException e) { /* invalid coding found */
//        return TSLogg.getMsg("TSFleO22",FNme,e.toString()); /* return error-message */
//      } /* File-error found */

      try { OS = new FileOutputStream(Fle); /* open physical file to check errors */
      } catch (FileNotFoundException e) { /* parent-folder not found */
        return TSLogg.getMsg("TSFleO21",FNme,e.toString()); /* return error-message */
      } /* File-error found */
      /* Attention: + File is physically written when 'close of file' is processed.
       *               So, open output and write data to IO-buffer-class, which
       *               is  defined as an 'Outputstream' (TSByteArrIO).
       *            + Optional 'compress' is executed, when the byte-buffer is
       *               written to the physical file.
       *            + However, Output to buffer is DIRECTLY translated into bytes.
       */
      try { Wtr = new BufferedWriter(new OutputStreamWriter(BIO,"UnicodeLittle"));
      } catch (UnsupportedEncodingException e) { /* invalid coding found */
        return TSLogg.getMsg("TSFleO22",FNme,e.toString()); /* return error-message */
      } /* File-error found */

      try {Wtr.write(is); /* write file-identifier */
      } catch (IOException e) { /* output-error occurred */
        return TSLogg.getMsg("TSFleO24",FNme,e.toString()); /* return error-message */
      } /* Error encountered */
      try {Wtr.newLine(); /* write CRLF */
      } catch (IOException e) { /* output-error occurred */
        return TSLogg.getMsg("TSFleO25",FNme,e.toString());
      } /* Error encountered */
      try {Wtr.newLine(); /* write CRLF (blank line) */
      } catch (IOException e) { /* output-error occurred */
        return TSLogg.getMsg("TSFleO25",FNme,e.toString());
      } /* Error encountered */
      rc = 2;  /* Header + Blank line is already written (formerly) */
      rl = 30; /* register length of header as max. record-length */
      mode = 1; /* /* set interface-mode to 'output character' */
      cMde = iom; /* remember last mode */
      return null; /* file is open -- no error */
    } /* 'Output' was requested */


    /* Open file for INPUT and check Input-mode */
    if(!Fle.exists()) return TSLogg.getMsg("TSFleO31",FNme); /* File not found */
    if(Fle.isDirectory()) return TSLogg.getMsg("TSFleO32",FNme); /* File is folder */

    if(bio) { /* NORMAL input-'buffered-I/O' requested (no file-ID) */
      /* Attention: I/O-Mode is 'character' in this case  */
      if(bin) /* unicode NOT requested */
        try { Rdr = new BufferedReader(new FileReader(Fle));
        } catch (FileNotFoundException e) { /* IO-error received */
          return TSLogg.getMsg("TSFleO33",FNme,e.toString());
        } /* Exception definition/opening file */
      else  /* unicode IS requested */
        try {Rdr = new BufferedReader(new InputStreamReader(
          new FileInputStream(Fle),"UTF-16"));
        } catch (FileNotFoundException e) { /* file not found */
          return TSLogg.getMsg("TSFleO34",FNme,e.toString());
        } catch (UnsupportedEncodingException e) { /* invalid coding */
          return TSLogg.getMsg("TSFleO35",FNme,e.toString());
        } /* Exception definition/opening file */
      mode = -1; /* set interface-mode to 'input character' */
      cMde = iom; /* set active IO-mode */
      return null; /* file is open -- no error */
    } /* Input is 'buffered-I/O' (no file-ID) */

    /* file should contain file-ID, mode = UT,UB,CT,CB */
    try {IS = new FileInputStream(Fle); /* open raw input */
    } catch (FileNotFoundException e) { /* IO-error received */
      /* error should NOT occur due to previous testing */
      return TSLogg.getMsg("TSFleO36",FNme,e.toString());
    } /* Exception definition/opening file */

    /* 1) read prefix of 16 bytes end check for error */
    try {i = BIO.readFrom(IS,16); /* read 16 bytes into buffer */
    } catch (IOException e) { /* IO-error received */
      try { IS.close(); } catch (IOException E) { }
      return TSLogg.getMsg("TSFleO37",FNme,e.toString());
    } /* Exception definition/opening file */
    if(i!=16) { /* not enough data available */
      try { IS.close(); } catch (IOException E) { }
      return TSLogg.getMsg("TSFleO38",FNme,i); /* read-error found -- return message */
    } /* not enough data available */
    /* current Read-pointer: 0 */

    iom &= ~(IO_bin|IO_cpr); /* reset 'binary'/'compress'-request if specified */
    cItS = new TSFleStack(); /* Init 'dummy-token' and create Iterationsbuffer */
      /* Attention: setPos()-method becomes valid */
    if(Arrays.equals(BIO.getBytes(7),FlePfx)) { /* type-ID match -> file is binary */
      iom |= IO_bin; /* insert 'binary'-request (Format = xB) */

      if((i=BIO.read())==64) { /* filetype 'UB' found (buffer[7]=='@') */
        cItS.setPos((int)(Fle.length() - 32)); /* init source-length of file */
        BIO.skip(4); /* skip length-field if it is not used */
      } else { /* handle filetype 'CB' */
        if(i!=70) { /* check if filetype 'CB' (buffer[7]=='F') */
          try { IS.close(); } catch (IOException E) { }
          return TSLogg.getMsg("TSFleO39",FNme,i); /* read-error found -- return message */
        } /* invalid filetype received */
//        IS = new InflaterInputStream(IS); /* decompress implicitely when reading */
        IS = new TSDeCompInputStream(IS,1024); /* decompress implicitely when reading */
        cItS.setPos((i=(int)BIO.getInt(4) - 16)); /* init source-length of file (Pos=8) */
        ((TSDeCompInputStream)IS).readSize(i,TSByteArrIO.ReadLoop); /* create new internal read-buffersize */
        iom |= IO_cpr; /* insert 'compress'-request (Format = Cx) */
      } /* filetype is successfully processed */
      /* current Read-pointer: 12 */
// TSUtil.Lg.Msg("Msg010","(0)--> FileLength="+cItS.chkPos(0));

      /* common part for input, which must be decompressed/checked (byte 16..31) */
      try {i = BIO.readFrom(IS,16); /* read next 16 bytes into buffer */
      } catch (IOException e) { /* IO-error received */
        try { IS.close(); } catch (IOException E) { }
        return TSLogg.getMsg("TSFleO3A",FNme,e.toString());
      } /* Exception definition/opening file */
      if(i!=16) { /* not enough data available */
        try { IS.close(); } catch (IOException E) { }
        return TSLogg.getMsg("TSFleO3B",FNme,i); /* read-error found -- return message */
      } /* not enough data available */
      BIO.skip(4); /* skip rest of File-ID-prefix -- current Read-pointer: 16 */

 if(TSUtil.PrMsk.chkMsk(31)) { /* Test-output required: Print file-id */
        is = ""; /* initialize output-string */
        for(i=16;i<32;i+=1) is += TSUtil.toHex((int)BIO.getInt(1,i),-2);
          /* add current char to output */
        TSUtil.Lg.Msg("Msg010","File-ID='"+is+"'");
 }

      for(i=31;i>15;i-=1) if(!Character.isWhitespace((int)BIO.getInt(1,i))) break;
        /* search for logical end; skip all ' ', '\n' or '\r' character */
        /* Attention; Read-pointer is NOT modified */
      is = new String(BIO.getBytes(i-15)); /* convert file-ID to string */
      while(is.length()<14) is += '_'; /* expand ID to correct length */
      /* Attention: current Read-pointer is NOT defined (between 32 and 16) */

      /* preset control-values for reading data properly (binary) */
      DtaI = new ArrayList<String>(); /* create input-buffer for expand */
      Pos = 0; /* set start-position */
        /* max. Position (cItS.setPos()) is already set */
      ItS  = new Stack<TSFleStack>(); /* alloc. Storage for Iterations */
      cP   = 0;  /* initialize current shift-level */
      mode = -2; /* set interface-mode to 'binary input' */
    } else { /* file was successfully opened binary -- now check unicode version */
      /* ID-part of input-file is NOT binary -> use UNICODE */
      try { IS.close(); } catch (IOException e) { System.err.println(e.toString()); }

      /* now: file contains an unicode-text in every case */
      try { ISR = new InputStreamReader(new FileInputStream(Fle),"UTF-16");
        /* type of endian is read from file */
      } catch (FileNotFoundException e) { /* unicode file not found */
        return TSLogg.getMsg("TSFleO41",FNme,e.toString());
      } catch (UnsupportedEncodingException e) { /* unsupported codeset! */
        return TSLogg.getMsg("TSFleO42",FNme,e.toString()); /* open-file-error found */
      } /* Exception at OPEN */

      cPrfx = new char[16]; /* allocate input-buffer for first test */
      try {i = ISR.read(cPrfx,0,16); /* read first part of file-identifier */
      } catch (IOException e) { /* handle read-error */
        try {ISR.close();} catch (IOException E) { } /* close unicode file */
        return TSLogg.getMsg("TSFleO43",FNme,e.toString()); /* read-error found -- return message */
      } /* Exception while reading */
      if(i!=16) { /* not enough data available */
        try {ISR.close();} catch (IOException e) { } /* close unicode file */
        return TSLogg.getMsg("TSFleO44",FNme,i); /* read-error found -- return message */
      } /* not enough data available */

      if((new String(cPrfx,0,8)).equals("SIMISA@F")) { /* type-ID match -> file is compr. */
        try {ISR.close();} catch (IOException e) { } /* close unicode file */

        try {IS = new FileInputStream(Fle); /* read binary again */
        } catch (FileNotFoundException e) { }  /* third time -- no error tested */
        try {i = IS.read(); } catch (IOException e) {} /* read first byte again -- no error */
        j = 31; /* preset number of bytes to be skipped */
        if(i>248) j += 2; /* control-byte found (x'FF') -- skip sequence too */
        try {IS.skip(j);} catch (IOException e) { /* skip already read bytes */
          System.err.println(e.toString()); /* error number 45 is reserved */ }

        try { Rdr = new BufferedReader(new InputStreamReader( /* compressed unicode */
                    new InflaterInputStream(IS),"UTF-16LE"));
          /* read compressed unicode, type of endian is fixed */
        } catch (UnsupportedEncodingException e) { /* unsupported codeset! */
          try {IS.close();} catch (IOException E) { } /* close file again */
          return TSLogg.getMsg("TSFleO45",FNme,e.toString()); /* open-file-error found */
        } /* Exception at OPEN */

        i = (int)TSByteArrIO.getInt(4,(new String(cPrfx,8,4)).getBytes(),0) - 16;
          /* get length-field from data, init source-length of file */
        cItS.setPos(i); /* and insert it into master control-record */
        iom |= IO_cpr; /* insert 'compress'-request (Format = Cx) */
      } else Rdr = new BufferedReader(ISR); /* now: reader is buffered */
        /* file is NOT compressed -- use plain read */
      /* input-mode of unicode-file is (successfully) set */
      is = "SIMISA@@@@@@@@@@"; /* set fixed part of file-ID (both cases) */

      /* file is ready for reading */
      try {is += Rdr.readLine(); /* read rest of file-identifier */
      } catch (IOException e) { /* handle read-error */
        close(); /* error -- close file again ('TSFile.close()') */
        return TSLogg.getMsg("TSFleO46",FNme,e.toString()); /* read-error found */
      } /* Exception while reading */
      is = is.trim(); /* remove additional blanks if provided */ 
      while(is.length()<30) is += "_"; /* correct File-ID if needed */

      /* preset control-values for reading data properly (unicode) */

      mode = -1; /* /* set interface-mode to 'input character' */
    } /* Unicode-version was processed */

    BIO.reInit(); /* reinitialize buffer-pointer, delete all data (32 bytes min.) */
      /* Attention: All data, which is deleted, is NOT included within length-count
       *              of file, which is stored in 'cItS.Pos'. */
    bin = (iom%2)==1; /* re-establish request-flag (binary plain/compressed) */
      /* current value within 'iom' may be modified */

    if((sio&IO_rqf)!=0) /* format is requested -- check it */
      if((i=sio&~IO_rqf)!=iom) { /* requested format was NOT found */
        close(); /* error -- close file again ('TSFile.close()') */
        return TSLogg.getMsg("TSFleO3C",FNme,i,iom);
      } /* format was successfully checked */

    if((is=chkFKng(is,bin))!=null) { /* check current file-identifier */
      /* file-identifier is not acceptable */
      close(); /* error -- close file again ('TSFile.close()') */
      return TSLogg.getMsg(bin?"TSFleO3Z":"TSFleO4Z",is,FNme);
        /* invalid file-ID found -- return message */
    } /* error within ID of file */

    rc = 1;  /* Header is already read (formerly) */
    rl = 30; /* register length of header as max. record-length */
    cMde = iom; /* set active IO-mode */

    if(bin) { /* binary input -- load complete file into buffer */
      /* Attention: Load is needed because file must be read
       *            'forward' and 'backward' (unRead()) */
      j = cItS.chkPos(BIO.size()); /* compute length of remaining data */
      try { i = BIO.readFrom(IS,j); /* read complete file */
        /* Attention: File is uncompressed during read if needed. However,
         * the requested length is the overall length of the uncompressed
         * (but tokenized) file.
         */
      } catch (IOException e) { /* error occurred while reading */
        close(); /* error -- close file again ('TSFile.close()') */
        return TSLogg.getMsg("TSFleO3D",FNme,e.toString()); /* error */
      } /* Error encountered */
      if(i==j) return null; /* successfully loaded -- no further checking */
      close(); /* error -- close file again ('TSFile.close()') */
      return TSLogg.getMsg("TSFleO3E",FNme,i,j); /* error */
    } /* file was successfully loaded */

    /* now: character-input used -- check for CRLF-lines */
    if(!Rdr.markSupported()) return null; /* no mark possible -- return without error */
    try { Rdr.mark(256); /* mark position in case of 'line is not empty' */
      is = Rdr.readLine(); /* get next line which should be blank */
    } catch (IOException e) { /* handle read-error */
      close(); /* error -- close file again ('TSFile.close()') */
      return TSLogg.getMsg("TSFleO47",FNme,e.toString()); /* read-error found */
    } /* Exception while reading */
    rc = 2;  /* Header + Blank line is already read (formerly) */
    if(is.trim().length()==0) return null; /* empty line -- return without error */

    try { Rdr.reset(); /* 'line is not empty' -- must be read again */
    } catch (IOException e) { /* handle read-error */
      close(); /* error -- close file again ('TSFile.close()') */
      return TSLogg.getMsg("TSFleO47",FNme,e.toString()); /* read-error found */
    } /* Exception while reading */
    rc = 1;  /* ONLY Header is already read (formerly) */
    return null; /* return without error (in any case) */
  }

 /**. <pre>
  *=====================================================================
  * Method "prtMode"
  * Return format of file according to current IO-mode.
  * ##prtMde.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String prtMode() /* create format-identifier */
   {
   /*-----------------------------------------------------------------*/
    int i; /* save-value for current IO-mode */
   /*=================================================================*/
    if(cMde<0) return "??"; /* File was NOT opened until now */
    if((cMde&IO_bio)!=0) { /* ascii/unicode is active -- handle it */
      i = (cMde & IO_app) >> 1; /* extract append-mode */
      i |= cMde & IO_bin;       /* and insert unicode-flag */
      return TSFile.FL2[i]; /* return description due to number */
    } /* ascii/unicode was active */
    i = cMde & IO_Msk; /* create number of format */
    return TSFile.FL1[i]; /* return description due to number */
  }

 /**. <pre>
  *=====================================================================
  * Method "putData"
  * Write line to file
  * Do Compress and/or Reduce if requested
  * Method returns error-message or 'null' if no error
  * ##putData.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String putData( /* write line to file */
   String dta) /* line to be written */
   {
   /*-----------------------------------------------------------------*/
    int dl; /* length of data */
   /*=================================================================*/
    EMsg = null; /* clear current error-message */
    if(Fle==null) return TSLogg.getKey("TSFleD11"); /* no active file */
    if(mode<=0) /* file is opened for input or close */
      return TSLogg.getMsg("TSFleD12",FNme,mode); /* return error-message */
    dl = 0; /* preset: output-line is not used (write empty line) */
    if(dta!=null) dl = dta.length(); /* compute current length of data */

    if(mode==2) { /* binary output -- Reduce neccessary */
      /* ATTENTION: Data is NOT REALLY written, but buffered in
       * memory only. Writing will occur, before the file is closed.
       */
      if(dl==0) dta = ""; /* no valid data -- write empty line */
      if(Reduce(dta)) return EMsg; /* return error */

    } else { /* file has to be written ONLY, no reduce/compress */
      if(dl>0) /* valid data available -- write it */
        try { Wtr.write(dta,0,dl); /* write record */
        } catch (IOException e) { /* write-error occurred */
          System.err.println(e.toString()); /* write-error -- return msg */
          return TSLogg.getMsg("TSFleD13",FNme);
        } /* Exception while writing */
      try { Wtr.newLine(); /* write CRLF */
      } catch (IOException e) { /* write-error occurred */
        System.err.println(e.toString()); /* write-error -- return msg */
        return TSLogg.getMsg("TSFleD14",FNme);
      } /* Exception while writing */
    } /* data was written */

    rl = Math.max(rl,dl); /* compute max written record-length */
    rc += 1; /* and count record */
    return null; /* OK -- Write was successfull */
  }

 /**. <pre>
  *=====================================================================
  * Method "Reduce"
  * Reduce Data-Definition to token-format.
  * Attention: - Method is ONLY used when 'output' is active.
  *            - Variable 'cP' is also used for inpt with different
  *                meaning.
  * ##Reduce.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean Reduce( /* Reduce lines to token-format */
   String lne) /* current line */
   {
   /*-----------------------------------------------------------------*/
    TSFleTok cT; /* temporary Tokendefinition */
    String   is; /* intermediate value */
    int      i;  /* intermediate value */
    long     j;  /* intermediate value */
    float    f;  /* intermediate value */
    char     cc; /* intermediate value */
    boolean  retry; /* retry processing of current value */
   /*=================================================================*/
// TSUtil.Lg.Log("Msg010","...("+ItS.size()+")-->" + "Daten='" + lne + "'");

    DtaO = lne + " "; /* set current line for reduce */
    cP   = 0;         /* and start-Position */

    CL:while(cP<DtaO.length()) { /* process all Items on current line */
      if(cItS.isCmt()) cmt:{ /* comment is active and must be processed */
// TSUtil.Lg.Msg("Msg010",TSUtil.setPrfx(ItS.size())+"("+ItS.size()+")-->"+
//               " Dta='"+DtaO+"'("+cP+")");
        while(cP<DtaO.length()) { /* process all character of the line */
          cc = DtaO.charAt(cP++); /* get current char */
          if(cc=='(') cItS.runCnt(true); /* open-bracket found -- register it */
          if(cc==')') /* close-bracket found -- register it */
            if(cItS.runCnt(false)) { /* register bracket and check counter */
              /* as per counter current comment terminates now */
              is = DtaB.toString(); /* convert current comment to string */
              DtaB.setLength(0); /* and clear current buffer again */
              if((EMsg=BIO.putString(is,true))!=null) return true;
                /* set String and return if error */
              cP -= 1; /* comment has terminated -- terminate token, too */
                /* back before last 'closing bracket' -- getItem() returns "".
                 * NO 'advance' needed because token contains NO type-defs.
                 */
              break cmt; /* current step is successfully processed */
            } /* comment terminated -- post-processing done */
          DtaB.append(cc); /* transfer current character to buffer */
        } /* -while- process all characters of the line */
        /* comment switches to new line insert 'CRLF' as marker */
        DtaB.append('\r'); /* insert first separator */
        DtaB.append('\n'); /* insert second separator */
        return false; /* comment continues -- get next record */
      } /* -cmt- comment was processed */

      is = getItem(null); /* get next Item from line (=DtaO) */
      if(is==null) { /* no item -- set message and return error */
        EMsg = TSLogg.getKey("TSFleR01"); /* error-message */
        return true; /* signal error and return */
      } /* item missing -- signal error and return */
      if(is.equals(Mkr0)) return false; /* (empty) data-fragment is stored */

      /* is contains 'current item' from input-line (or 'Mkr1') */
      if(is.length()==0) { /* no valid item found -- terminate token ? */
        is = getItem(")"); /* test if token terminates correctly */
        if(is!=null) { /* no terminator -- terminate method */
          EMsg = TSLogg.getMsg("TSFleR02",is); /* error-message */
          return true; /* signal error and return */
        } /* no VALID item found -- signal error and return */

        /* The current 'requested' item (due to state of 'cItS') was NOT found.
         * So, if it was optional, it can be skipped. It can also be skipped if
         * it contains the 'until-end'-condition and was triggered for a minimum
         * of one time. Then, NO REMAINING item must be present, or the token
         * was NOT fully processed.
         */

// TSUtil.Lg.Msg("Msg010",TSUtil.setPrfx(ItS.size())+"("+ItS.size()+")-->"+
//   "Pos="+cItS.chkPos(0)+", zPos="+BIO.size()+", TTyp="+cItS.getKey().toString()+
//   ", TNme='"+cItS.getName()+", Act="+TSUtil.toHex(cItS.getCmd(false),-4));

        do { /* loop until no more 'virtual token' active */
          retry = false; /* preset: processing do not need to be retried */
          while(cItS.chkOpt(0)) if(cItS.advDef()) break;
            /* skip optional entries, break if end is reached.
             * 'if(cItS.chkAdv(true))' is not needed because 'opt' is set.
             */

          if((is=cItS.isEOT())!=null) { /* items are still required -- error */
            /* 'isEOT()' skips 'until-end'-condition if appropriate */
            EMsg = TSLogg.getMsg("TSFleR03",cItS.getName(),is); /* error-message */
            return true; /* signal error and return */
          } /* no required item found -- signal error and return */

          /* EOT is active! However, if the current token is a 'virtual token',
           * this must be left and the surroundng token must be processed
           * in the same way until a surrounding token, which is NO
           * 'virtual token' reaches EOT.
           */
          if(cItS.isVT()) { /* 'virtual token' is at EOT -- release it */
            try { cItS = ItS.pop(); /* get old token-environment */
            } catch (EmptyStackException e) { /* underflow -- no further action */
              EMsg = TSLogg.getMsg("TSFleR07",e.toString()); /* error-message */
              return true; /* signal error and return */
            } /* no valid token-environment available -- signal error and return */
            retry = true; /* processing must be retried */
          } /* current token was a virtual one */
        } while(retry); /* processing was NOT fully complete -- retry it */

        i = cItS.chkPos(0); /* get current position of length-field */
        j = BIO.size() - i - 4; /* compute length of current token */
        if((EMsg=BIO.putInt(j,4,i))!=null) return true; /* set Length-Field */

        try { cItS = ItS.pop(); /* get old token-environment */
        } catch (EmptyStackException e) { /* underflow -- no further action */
          EMsg = TSLogg.getMsg("TSFleR04", e.toString()); /* error-message */
          return true; /* signal error and return */
        } /* no token-environment available -- signal error and return */
      } else { /* valid item available -- process it */
        if(is.equals(Mkr1)) is = ""; /* create correct itemvalue */
        do { /* loop until processing was successful */
          cT    = null;  /* preset: no new token activated */
          retry = false; /* preset: processing do not need to be retried */

// TSUtil.Lg.Msg("Msg010",TSUtil.setPrfx(ItS.size())+"("+ItS.size()+")--> Pos="+cItS.chkPos(0)+
//        ", zPos="+BIO.size()+", TTyp="+cItS.getKey().toString()+
//        ", TNme='"+cItS.getName()+ "', Act="+TSUtil.toHex(cItS.getCmd(false),-4)+
//        ", is='"+is+"'("+cP+")");
// TSUtil.Lg.Msg("Msg010",TSUtil.setPrfx(ItS.size())+"("+ItS.size()+")--> Buffer='"+
//        BIO.toString()+"'");

          switch(i=cItS.getCmd(true)) { /* check due to current step */
            case( 0): /* step: 'Embedded Token' */
              if(is.startsWith("_")) cT = tok1; /* get valid token-definition using special item */
                /* start of 'Comment' was found -- any keyword possible */
              else cT = getTok(is); /* get next token-definition using current item */
              if(cT==null) {  /* Token is NOT defined in table -- terminate ? */
                /* (requested) Token is NOT defined in table  -- terminate? */
                if(cItS.chkOpt(0)) { /* token NOT required -- try next */
                  cItS.advDef(); /* skip optional entry, advance to next 'item'.
                    * 'if(cItS.chkAdv(false))' is not needed because 'opt' is set and
                    * 'suspend' is not used.
                    */

// TSUtil.Lg.Msg("Msg010",TSUtil.setPrfx(ItS.size())+"("+ItS.size()+")--> Pos="+cItS.chkPos(0)+
//        ", zPos="+BIO.size()+ ", Act="+TSUtil.toHex(cItS.getCmd(false),-4)+", is='"+is+"'");

                  retry = true; /* processing must be retried */
                  break; /* current step is successfully processed */
                } /* type-definition was optional */
                EMsg = TSLogg.getMsg("TSFleR11",is,DtaO); /* error-message */
                return true; /* signal error and return */
              } /* Token was NOT defined in Table */

              if(!cT.isCmt()) break; /* current step is successfully processed */
                /* new token will be activated AFTER 'advance' of current type-def. */
                /* current step is successfully processed */

              /* new token is a comment -- special handling needed */
              ItS.push(cItS); /* save current environment to stack */
                /* number of elements is incremented. So size() is level */
              cItS = new TSFleStack(cT); /* create new environment */
                /* Attention: New 'first type-definition' is established */
              if((EMsg=BIO.putInt(cItS.getKey().longValue(),4))!=null) return true;
                /* set tokennumber to buffer and return if error */
              cItS.setPos(BIO.size()); /* save new Postion of length-field */
              if((EMsg=BIO.putInt(0,4))!=null) return true; /* insert '0' */
                /* REAL length-value of token will be inserted later */

              /* Attention: 'label' must get the REAL comment-keyword */
              i = is.length(); /* compute length of comment-keyword */
              if(i<2 || i>255) { /* invalid length-value */
                EMsg = TSLogg.getMsg("TSFleR05",i); /* error-message */
                return true; /* signal error and return */
              } /* invalid length-value -- signal error and return */
              if((EMsg=BIO.putInt(i,1))!=null) return true;
                /* set length-field of label/keyword and return if error */
              if((EMsg=BIO.putString(is,false))!=null) return true;
                /* convert and set keyword as label -- no length-field is written */

              is = getItem("("); /* test if token starts correctly */
              if(is!=null) { /* no token for start -- return error */
                if(is.equals(Mkr0)) { /* '(' missing on current line */
                  EMsg = TSLogg.getMsg("TSFleR08",BIO.size()); /* error-message */
                  return true; /* signal error and return */
                } /* '(' missing on current line */
                EMsg = TSLogg.getMsg("TSFleR06",is); /* error-message */
                return true; /* signal error and return */
              } /* token is misbuild -- signal error and return */
              continue CL; /* current step is successfully processed -- get next data */

            case( 1): /* step: Process 'UInt' */
            case( 2): /* step: Process 'SInt' */
              /* reduce 'Int/Uint' value, repeat 'until counter expired' / 'until end'. */
              if(is.charAt(0)=='+') is = is.substring(1); /* delete trailing '+' */
              try {j = Long.parseLong(is); /* convert value from String to Int/UInt */
              } catch (NumberFormatException e) { /* error in number-definition */
                EMsg = TSLogg.getMsg("TSFleR21",is,e.toString()); /* error-message */
                return true; /* signal error and return */
              } /* convert value from String to Int/UInt */
              if((EMsg=BIO.putInt(j,4))!=null) return true;
                /* set UInt/SInt-number and return if error */
              if(cItS.clrFlg4()) cRep = (int)j; /* remember value if requested */
                /* Attention: FIRST converted value of this type clears flag */
              break; /* current step is successfully processed */
            case( 3): /* step: 'Process 'String' */
              /* reduce 'String' value, repeat 'until counter expired' / 'until end'. */
              if((EMsg=BIO.putString(is,true))!=null) return true;
                /* set String and return if error */
//              if(cItS.clrFlg4()); /* NOT USED */
              break; /* current step is successfully processed */
            case( 4): /* step: Process 'Hex(2)' */
            case( 5): /* step: Process 'Hex(4)' */
            case( 6): /* step: Process 'Hex(8)' */
              /* reduce 'hexadecimal' value, repeat 'until counter expired' / 'until end'. */
              try {j = Long.parseLong(is,16); /* convert value from String to Int/UInt */
              } catch (NumberFormatException e) { /* error in number-definition */
                EMsg = TSLogg.getMsg("TSFleR22",is,e.toString()); /* error-message */
                return true; /* signal error and return */
              } /* convert value from String to Int/UInt */
              if((EMsg=BIO.putInt(j,4))!=null) return true;
                /* set new number and return if error */
//              if(cItS.clrFlg4()); /* NOT USED */
              break; /* current step is successfully processed */
            case( 7): /* step: Process 'Float(2)' */
            case( 8): /* step: Process 'Float(3)' */
            case( 9): /* step: Process 'Float(4)' */
            case(11): /* step: Process 'Float(6)' */
            case(13): /* step: Process 'Float(8)' */
              /* reduce 'float' value, repeat 'until counter expired' / 'until end'. */
              try {f = Float.parseFloat(is); /* convert value from String to float */
              } catch (NumberFormatException e) { /* error in number-definition */
                EMsg = TSLogg.getMsg("TSFleR23",is,e.toString()); /* error-message */
                return true; /* signal error and return */
              } /* convert value from String to float */
              j = Float.floatToIntBits(f); /* change it to Int-value */
              if((EMsg=BIO.putInt(j,4))!=null) return true;
                /* set Float as UInt-number and return if error */
//              if(cItS.clrFlg4()); /* NOT USED */
              break; /* current step is successfully processed */
            case(10): /* step: Process 'Time-Format' */
              i = is.indexOf(":"); /* search for first separator */
              if(i!=2) { /* correct format is NOT provided */
                EMsg = TSLogg.getMsg("TSFleR31",is,i); /* error-message */
                return true; /* signal error and return */
              } /* convert value from String to Int/UInt */
              try {j = Long.parseLong(is.substring(0,2)); /* convert first part of value */
              } catch (NumberFormatException e) { /* error in number-definition */
                EMsg = TSLogg.getMsg("TSFleR32",is,e.toString()); /* error-message */
                return true; /* signal error and return */
              } /* convert value from String to Int/UInt */
              i = is.indexOf(":",3); /* search for second separator */
              if(i<0) i = is.length(); /* second separator need not to be present */
              if(i!=5) { /* correct format is NOT provided */
                EMsg = TSLogg.getMsg("TSFleR33",is,i); /* error-message */
                return true; /* signal error and return */
              } /* convert value from String to Int/UInt */
              j *= 60; /* convert current value (hrs to mins) */
              try {j += Long.parseLong(is.substring(3,5)); /* convert second part of value */
              } catch (NumberFormatException e) { /* error in number-definition */
                EMsg = TSLogg.getMsg("TSFleR34",is,e.toString()); /* error-message */
                return true; /* signal error and return */
              } /* convert value from String to Int/UInt */
              j *= 60; /* convert current value (mins to secs) */
              if((i=is.length())>5) { /* seconds have been specified -- compute them */
                /* Attention: Flag 4 should be set, if this format is found */
                if(i!=8) { /* correct format is NOT provided */
                  EMsg = TSLogg.getMsg("TSFleR35",is,i); /* error-message */
                  return true; /* signal error and return */
                } /* convert value from String to Int/UInt */
                try {j += Long.parseLong(is.substring(6)); /* convert last part of value */
                } catch (NumberFormatException e) { /* error in number-definition */
                  EMsg = TSLogg.getMsg("TSFleR36",is,e.toString()); /* error-message */
                  return true; /* signal error and return */
                } /* convert value from String to Int/UInt */
              } /* seconds were registered */ 
              if((EMsg=BIO.putInt(j,4))!=null) return true;
                /* set UInt/SInt-number and return if error */
              break; /* current step is successfully processed */
            case(12): /* step: Process 'Loop-Definition' */
              /* create a 'virtual token' - definition and activate it. Transfer the current
               * item to the first type-definition of the new token.
               */
              i = cItS.getCnt(); /* get number of virtual token (number is NEGATIVE). */
              cT = getTok(i); /* get new token-definition */

// TSUtil.Lg.Msg("Msg010",TSUtil.setPrfx(ItS.size())+"("+ItS.size()+")--> Pos="+Pos+
//        ", zPos="+cItS.chkPos(0)+", '"+(cT==null?"<null>":cT.toStr())+
//        "', is='"+is+"'");

              if(cT==null) { /* Token is NOT defined in table */
                /* (requested) Token is NOT defined in table  -- terminate */
                EMsg = TSLogg.getMsg("TSFleR13",is,i,Pos); /* error-message */
                return true; /* signal error and return */
              } /* virtual token was NOT found -- Error */
              if(cItS.chkAdv(false)) /* check if 'advance' definition to next
                                      * 'requested item' is now requested. */
                cItS.advDef(); /* advance definition to next 'requested item' now */
              cItS.clrFlg1(cRep); /* process new entry if 'repeat-value' is changed */
              ItS.push(cItS); /* save current environment to stack */
                /* number of elements is incremented. So size() is level */
              cItS = new TSFleStack(cT,cItS.chkPos(0)); /* create new (virtual) environment */
                /* Attention: New 'first type-definition' is established.
                 *            No data (like tokendefiniton) is created for virtual token.
                 */
              retry = true; /* processing must be retried with new definition */
              break; /* current step is successfully processed */
            case(14): /* step: Process 'Byte' */
              /* reduce 'Byte' value, repeat 'until counter expired' / 'until end'. */
              if(is.charAt(0)=='+') is = is.substring(1); /* delete trailing '+' */
              try {j = Long.parseLong(is); /* convert value from String to Byte */
              } catch (NumberFormatException e) { /* error in number-definition */
                EMsg = TSLogg.getMsg("TSFleR24",is,e.toString()); /* error-message */
                return true; /* signal error and return */
              } /* convert value from String to Byte */
              if(cItS.clrFlg4_RE((int)j)) break; /* insert into repeat-counter if requested */
              if((EMsg=BIO.putInt(j,1))!=null) return true;
                /* set Byte-number and return if error */
              break; /* current step is successfully processed */
            case(15): /* step: Process 'String(split)' */
              /* reduce ONE (splitted) 'String' value. */
              if((EMsg=BIO.putString(is,true))!=null) return true;
                /* set String and return if error */
              break; /* current step is successfully processed */
            default: /* no valid step defined -- EOT-reached */
              if(!cItS.isVT()) { /* token, which reached EOT, was NOT a virtual one */
                EMsg = TSLogg.getMsg("TSFleR12",is,i,Pos); /* error-message */
                return true; /* signal error and return */
              } /* token, which reached EOT, was NOT a virtual one -- error */
              /* NOW: virtual token has reached EOT -- release it */
              try { cItS = ItS.pop(); /* get old token-environment */
              } catch (EmptyStackException e) { /* underflow -- no further action */
                EMsg = TSLogg.getMsg("TSFleR07",e.toString()); /* error-message */
                return true; /* signal error and return */
              } /* no token-environment available -- signal error and return */
              retry = true; /* processing must be retried with new definition */
          } /* -switch- process due to current type-definition */
        } while(retry); /* processing was NOT complete -- retry it */

        /* if ALREADY SUCCESSFUL processed token/type was 'optional' it must
         *  be changed to 'requested' in order to correctly processed. */
        cItS.chkOpt(-100000); /* change 'optional' to 'requested'
          * Attention: Using '-100000' as argument, all preconditions are met
          *            in any case. */
        if(cItS.chkAdv(false)) /* check if 'advance' definition to next
                                * 'requested item' is now requested. */
          cItS.advDef(); /* advance definition to next 'requested item' now */
        cItS.clrFlg1(cRep); /* process new entry if 'repeat-value' is changed */
// if(cItS.clrFlg1(cRep)) /* process new entry if 'repeat-value' is changed */
//   TSUtil.Lg.Msg("Msg010",TSUtil.setPrfx(ItS.size())+"("+ItS.size()+")--> Data='"+cItS.toStr()+"'");

        if(cT!=null) { /* valid token found -- embedded token starts here */
          ItS.push(cItS); /* save current environment to stack */
            /* number of elements is incremented. So size() is level */
          cItS = new TSFleStack(cT); /* create new environment */
            /* Attention: New 'first type-definition' is established */
          if((EMsg=BIO.putInt(cItS.getKey().longValue(),4))!=null) return true;
            /* set tokennumber to buffer and return if error */
          cItS.setPos(BIO.size()); /* save new Postion of length-field */
          if((EMsg=BIO.putInt(0,4))!=null) return true; /* insert '0' */
            /* REAL length-value of token will be inserted later */
          is = getItem(null); /* get optional label from line */
          if(is==null) return true; /* no token -- error */
          if(is.equals(Mkr1)) is = ""; /* create correct itemvalue */
          if((i=is.length())>255) { /* invalid length-value */
            EMsg = TSLogg.getMsg("TSFleR05",i); /* error-message */
            return true; /* signal error and return */
          } /* invalid length-value -- signal error and return */
          if((EMsg=BIO.putInt(i,1))!=null) return true;
            /* set length-field of label and return if error */
          if(i>0) /* label was found -- process it */
            if((EMsg=BIO.putString(is,false))!=null) return true;
            /* convert and set label -- no length-field is written */
          is = getItem("("); /* test if token starts correctly */
          if(is!=null) { /* no token for start -- return error */
            if(is.equals(Mkr0)) { /* '(' missing on current line */
              EMsg = TSLogg.getMsg("TSFleR08",BIO.size()); /* error-message */
              return true; /* signal error and return */
            } /* '(' missing on current line */
            EMsg = TSLogg.getMsg("TSFleR06",is); /* error-message */
            return true; /* signal error and return */
          } /* toke is misbuild -- signal error and return */
        } /* new token-definition has been created */ 
      } /* valid item is successfully processed */

    } /* -CL- process all Items from current line */
    return false; /* no error */
  }

 /**. <pre>
  *=====================================================================
  * Method "setBuffer"
  * Replace current (binary) IO-Buffer with external one.
  * Remark: This method is ONLY successful, if the file is NOT
  *         already opened.
  * ##setBuffer.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean setBuffer( /* replace binary-IO-Buffer */
   TSByteArrIO cIO) /* new external buffer for IO-actions */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(mode!=0) return true; /* file is open -- return error */
    BIO = cIO; /* establish nominal buffer-storage for I/O */
    BIO.reInit(); /* reinitialize buffer-pointer, delete all data */
    return false; /* buffer changed -- return without error-marker */
  }

 /**. <pre>
  *=====================================================================
  * Method "setTyp" (Dummy for extended classes).
  * Activate an identifier-type for writing.
  * This dummy-version, which should be overwritten, returns an error.
  * ##setTyp.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setTyp(int id) { return TSLogg.getMsg("TSFle0X3",".???",id,0); }

 /**. <pre>
  *=====================================================================
  * Methode "skpLne"
  * Save the current buffer to the inputqueue and provides a new
  *   buffer which is correctly initialized.
  * ##getPrfx.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final String skpLne( /* save current buffer */
   String  cB,  /* current buffer to be saved */
   boolean noI) /* DO NOT init buffer with prefix (if 'true') */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(cB.endsWith(" ")) cB = cB.substring(0,cB.length()-1);
    DtaI.add(cB); /* add current line to end of FIFO-buffer */
    if(noI) return ""; /* do not init -- return empty String */
    return getPrfx(false); /* return correctly initialized buffer */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSFile{'"+FNme+"'-("+cMde+")--'"+mode+"',"+Pos+"}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSFileS -- Compress, decompress, reduce or expand of a S-file
 * ##TSFileS (Eyecatcher)
 *======================================================================
 </pre>*/
class TSFileS extends TSFile { /* (De-)Compress of S-files */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.7.00 01.05.2012";
 /*-------------------------------------------------------------------*/
  private static final String   FKngU = /* Identifier for S-file */
    /* UNICODE-ID */            "SIMISA@@@@@@@@@@JINX0s1t______";
  private static final String   FKngB = "JINX0s1b______"; /* BIN-ID */
 /*-------------------------------------------------------------------*/
  private static HashMap<String,TSFleTok>  cmp; /* Keymap for Compr. */
  private static HashMap<Integer,TSFleTok> dec; /* Keymap for Decompr. */
  private static TSFleTok       tok;    /* create entry for keymaps */
 /**. <pre>
  *=====================================================================
  * Constructor: (0) Create static definitions
  *=====================================================================
  </pre>*/
  static { /* Perform static initialisations */
    cmp = new HashMap<String,TSFleTok>();  /* create table for compr. */
    dec = new HashMap<Integer,TSFleTok>(); /* create table for decompr. */
    /* insert comment-definition */
    tok = new TSFleTok(0,"_Skip",true); /* special comment-token */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     /* compatibility rules -- decode old form of comment, too */
    tok = TSFile.tok1; /* global definition for comment-token */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */

    /* insert all definitions; Basis = 0x0000xxxx (0) */
    tok = new TSFleTok(2,"point",'\u003B'); /* 3 x Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(3,"vector",'\u003B'); /* 3 x Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(5,"normals",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(6,"normal_idxs",'\u0811','\u4021');
      /* unsigned integer value of number of groups (=x),
       * x*y unsigned integer values */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(7,"points",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(8,"uv_point",'\u002B'); /* 2 x Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(9,"uv_points",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(10,"colour",'\u0048'); /* 4 x Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(11,"colours",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(13,"image",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(14,"images",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(15,"texture",'\u0021','\u0018','\u0016');
      /* two unsigned integer values, one (single) float value,
       * one hexadecimal integer value */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(16,"textures",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(17,"light_material",'\u0016','\u0041','\u0018');
      /*  Hex(8) + 4 x UInt + Float(6) (modified due to *.bnf-file) */
//    tok = new TSFleTok(17,"light_material",'\u0016','\u0048','\u0001');
      /* hexfloatuint: one hexadecimal integer values, one or more (single) float values,
       * unsigned integer values until end */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(18,"light_materials",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(19,"linear_key",'\u0011','\u000B'); /* UInt + 3 x Float(6) */
      /* uintfloat: one or more unsigned integer values,
       * (single) float values until end  */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(20,"tcb_key",'\u0011','\u000B'); /* UInt + 9 x Float(6) */
      /* uintfloat: one or more unsigned integer values,
       * (single) float values until end  */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(21,"linear_pos",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(22,"tcb_pos",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(23,"slerp_rot",'\u0011','\u000B'); /* UInt + 4 x Float(6) */
      /* uintfloat: one or more unsigned integer values,
       * (single) float values until end  */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(24,"tcb_rot",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(25,"controllers",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(26,"anim_node",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(27,"anim_nodes",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(28,"animation",'\u0021','\u2000'); /* 2 x UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(29,"animations",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(31,"lod_controls",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(32,"lod_control",'\u2020'); /* 2 x Token */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
//    tok = new TSFleTok(33,"distance_levels_header",'\u0011','\u801B'); /* *.bnf-file */
    tok = new TSFleTok(33,"distance_levels_header",'\u0011','\u800B');
      /* uintfloat: one or more unsigned integer values,
       * (single) float values until end  (0..) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(34,"distance_level_header",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(35,"dlevel_selection",'\u001B'); /* Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(36,"distance_levels",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(37,"distance_level",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(38,"sub_objects",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(39,"sub_object",'\u2000'); /* 4 x Token */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(40,"sub_object_header",
      '\u0016','\u0022','\u0026','\u2010','\u8820','\uA820','\u1001');
      /* mixed03: one hexadecimal integer value, two signed integer values,
       * two hexadecimal integer values, one REQUESTED embedded token,
       * one optional embedded token (no NL follows),
       * one optional embedded token (no NL follows),
       * one unsigned integer value */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(41,"geometry_info",'\u00A1','\u2000'); /* 10 x UInt + 2 x Token */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(42,"geometry_nodes",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(43,"geometry_node",'\u0051','\u2000'); /* 5 x UInt + Token */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(44,"geometry_node_map",'\u0811','\u4012');
      /* unsigned integer value of number of groups (=x),
       * x*y signed integer values */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(45,"cullable_prims",'\u0031'); /* 3 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(46,"vtx_state",'\u0016','\u0011','\u0012','\u0011','\u0016','\u8002');
      /* mixed01: one hexadecimal integer value, one unsigned integer value,
       * one signed integer value, one unsigned integer value,
       * one hexadecimal integer value, signed integer values until end (0..) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(47,"vtx_states",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
//    tok = new TSFleTok(48,"vertex",'\u0016','\u0021','\u0026','\u2810','\u9008'); /* *.bnf-file */
    tok = new TSFleTok(48,"vertex",
      '\u0016','\u0021','\u0026','\u2810','\u8820','\u8820','\u9008');
      /* mixed04: one hexadecimal integer value, two unsigned integer values,
       * two hexadecimal integer values, one REQUESTED embedded token (no NL follows),
       * one optional embedded token (no NL follows),
       * one optional embedded token (no NL follows),
       * one (single) float value (until end) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(49,"vertex_uvs",'\u0811','\u4011');
      /* unsigned integer value of number of groups (=x),
       * x*y unsigned integer values */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(50,"vertices",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(51,"vertex_set",'\u0031'); /* 3 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(52,"vertex_sets",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(53,"primitives",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(54,"prim_state",'\u0016','\u0011','\u2810','\u0018','\u0012','\u8001');
      /* mixed02: one hexadecimal integer value, one unsigned integer value,  '\u8401'
       * one requested embedded token (no NL follows),
       * one (single) float value, one signed integer value,
       * unsigned integer values until end */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(55,"prim_states",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(56,"prim_state_idx",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(58,"point_list",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(223),tok); /* comatibility rules: decode old token, too */
    tok = new TSFleTok(59,"indexed_line_list",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(222),tok); /* comatibility rules: decode old token, too */
    tok = new TSFleTok(60,"indexed_trilist",'\u2000'); /* 3 x Token */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(61,"tex_idxs",'\u0811','\u4011');
      /* unsigned integer value of number of groups (=x),
       * x*y unsigned integer values */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(63,"vertex_idxs",'\u0811','\u4011');
      /* unsigned integer value of number of groups (=x),
       * x*y unsigned integer values */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(64,"flags",'\u0811','\u4016');
      /* unsigned integer value of number of groups (=x),
       * x*y hexadecimal integer values */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(65,"matrix",'\u00C8'); /* 12 x Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(66,"matrices",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(67,"hierarchy",'\u0811','\u4012');
      /* unsigned integer value of number of groups (=x),
       * x*y signed integer values */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(68,"volumes",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(69,"vol_sphere",'\u2810','\u101B');
      /* tokfloat: Token(no NL follows) + Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
//    tok = new TSFleTok(70,"Shape_header",'\u0016','\u8016'); /* Hex(8) + Hex(8) */
    tok = new TSFleTok(70,"Shape_header",'\u0006'); /* Hex(8)'s (2 x Hex(8)) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(71,"Shape",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(72,"shader_names",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(74,"texture_filter_names",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(76,"sort_vectors",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(79,"light_model_cfgs",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(80,"light_model_cfg",'\u0016','\u2000'); /* Hex(8) + Token */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(81,"uv_ops",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    /* Attention: 'uv_opcopy'(221) changed to 'uvop_copy'(82) */
    tok = new TSFleTok(82,"uvop_copy",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(221),tok); /* comatibility rules: decode old token, too */
    tok = new TSFleTok(83,"uv_op_share",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(212),tok); /* comatibility rules: decode old token, too */
    tok = new TSFleTok(84,"uv_op_copy",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(85,"uv_op_uniformscale",'\u0021','\u000B'); /* 2 x UInt + Float(6) */
      /* uintfloat: one or more unsigned integer values,
       * (single) float values until end  */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(217),tok); /* comatibility rules: decode old token, too */
    tok = new TSFleTok(86,"uv_op_user_uniformscale",'\u0031'); /* 3 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(220),tok); /* comatibility rules: decode old token, too */
    tok = new TSFleTok(87,"uv_op_nonuniformescale",'\u0021','\u000B'); /* 2 x UInt + 2 x Float(6) */
      /* uintfloat: one or more unsigned integer values,
       * (single) float values until end  */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(209),tok); /* comatibility rules: decode old token, too */
    tok = new TSFleTok(88,"uv_op_user_nonuniformscale",'\u0031'); /* 3 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(218),tok); /* comatibility rules: decode old token, too */
    tok = new TSFleTok(89,"uv_op_transform",'\u0021','\u000B'); /* 2 x UInt + 6 x Float(6) */
      /* uintfloat: one or more unsigned integer values,
       * (single) float values until end  */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(216),tok); /* comatibility rules: decode old token, too */
    tok = new TSFleTok(90,"uv_op_user_transform",'\u0021','\u8011'); /* 2 x UInt + UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(219),tok); /* comatibility rules: decode old token, too */
    tok = new TSFleTok(92,"uv_op_reflectmap",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(210),tok); /* comatibility rules: decode old token, too */
    tok = new TSFleTok(93,"uv_op_reflectmapfull",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(211),tok); /* comatibility rules: decode old token, too */
    tok = new TSFleTok(94,"uv_op_spheremap",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(214),tok); /* comatibility rules: decode old token, too */
    tok = new TSFleTok(95,"uv_op_spheremapfull",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(215),tok); /* comatibility rules: decode old token, too */
    tok = new TSFleTok(96,"uv_op_specularmap",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(213),tok); /* comatibility rules: decode old token, too */
    tok = new TSFleTok(97,"uv_op_embossbump",'\u0021','\u000B'); /* 2 x UInt + Float(6) */
      /* uintfloat: one or more unsigned integer values,
       * (single) float values until end  */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(208),tok); /* comatibility rules: decode old token, too */
    tok = new TSFleTok(104,"subobject_shaders",'\u0811','\u4011');
      /* unsigned integer value of number of groups (=x),
       * x*y unsigned integer values */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(105,"subobject_light_cfgs",'\u0811','\u4011');
      /* unsigned integer value of number of groups (=x),
       * x*y unsigned integer values */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(106,"Shape_named_data",'\u2000'); /* 2 x Token */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(107,"Shape_named_data_header",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(108,"Shape_named_geometry",'\u0013','\u0011','\u2000');
       /* String + UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(109,"Shape_geom_ref",'\u0001'); /* 5 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(125,"named_filter_mode",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(129,"named_shader",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
  }
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSFileS() /* create file-control for S-file (Dummy) */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSFileS( /* create file-control for S-file */
   File dat) /* File-definition */
   {
    super(dat); /* set Values using parent (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkFKng"
  * Check File-Identifier for current type of file
  * if argument is 'null' the full key is provided (for write)
  * ##chkFKng.TSFileS (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String chkFKng( /* process file-identifier */
   String  K, /* current value or 'null' */
   boolean t) /* Type of header (true-> binary(14 bytes)) */
   {
   /*-----------------------------------------------------------------*/
    String cK; /* current Key */
   /*=================================================================*/
    cK = t ? FKngB : FKngU; /* select requested file-IDentifier */
    if(K==null) return cK; /* provide requested file-ID */
    /* check file-identifier */
    if(K.equals(cK)) return null; /* identifier is OK */
    if(K.length()<8) return TSLogg.getMsg("TSFle0S2",K); /* message */
    return TSLogg.getMsg("TSFle0S1",K); /* provide error-message */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTok" (version 'expand')
  * Get current definition of token from table (key=number)
  * ##getTok.TSFileS (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSFleTok getTok( /* read token-definition from table */
   int nr) /* Number is key of token */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0) nr = Math.max(-32,nr); /* use allowed range */ 
    else nr &= 0x0FFFFFF; /* mask number (3 bytes = 0..16777215 */
      /* allow a 'special request' marked by a negative key */
    return dec.get(new Integer(nr)); /* provide Token */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTok" (version 'reduce')
  * Get current definition of token from table (key=name)
  * ##getTok.TSFileS (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSFleTok getTok( /* read token-definition from table */
   String nme) /* Name is key of token */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    nme = nme.toLowerCase(); /* lower chars (new String is build) */
    return cmp.get(nme); /* provide Token */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSFileS (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSFileS{"+super.toStr()+",'"+FKngU+"','"+FKngB+"'}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSFileT -- Reduce or expand of a T-file
 * T-Files are not compressed (or decompressed)
 * ##TSFileT (Eyecatcher)
 *======================================================================
 </pre>*/
class TSFileT extends TSFile { /* (De-)Compress of T-files */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.7.00 01.05.2012";
 /*-------------------------------------------------------------------*/
  private static final String   FKngU = /* Identifier for T-file */
    /* UNICODE-ID */            "SIMISA@@@@@@@@@@JINX0txt______";
  private static final String   FKngB = "JINX0t6b______"; /* BIN-ID */
 /*-------------------------------------------------------------------*/
  private static HashMap<String,TSFleTok>  cmp; /* Keymap for Compr. */
  private static HashMap<Integer,TSFleTok> dec; /* Keymap for Decompr. */
  private static TSFleTok       tok;    /* create entry for keymaps */
 /**. <pre>
  *=====================================================================
  * Constructor: (0) Create static definitions
  *=====================================================================
  </pre>*/
  static { /* Perform static initialisations */
    cmp = new HashMap<String,TSFleTok>();  /* create table for compr. */
    dec = new HashMap<Integer,TSFleTok>(); /* create table for decompr. */
    /* insert comment-definition */
    tok = new TSFleTok(0,"_Skip",true); /* special comment-token */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     /* compatibility rules -- decode old form of comment, too */
    tok = TSFile.tok1; /* global definition for comment-token */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */

    /* insert all definitions; Basis = 0x0000xxxx (0) */
    tok = new TSFleTok(136,"terrain",'\u2000');  /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(137,"terrain_errthreshold_scale",'\u001B'); /* Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(138,"terrain_alwaysselect_maxdist",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(139,"terrain_samples",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(140,"terrain_nsamples",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(141,"terrain_sample_rotation",'\u001B'); /* Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(142,"terrain_sample_floor",'\u0019'); /* Float(4) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(143,"terrain_sample_scale",'\u001D'); /* Float(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(144,"terrain_sample_size",'\u0019'); /* Float(4) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(145,"terrain_sample_fbuffer",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(146,"terrain_sample_ybuffer",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(147,"terrain_sample_ebuffer",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(148,"terrain_sample_nbuffer",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(149,"terrain_sample_cbuffer",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(150,"terrain_sample_dbuffer",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(151,"terrain_shaders",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(152,"terrain_shader",'\u0013','\u2000'); /* String + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(153,"terrain_texslots",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(154,"terrain_texslot",'\u0013','\u0021'); /* String + 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(155,"terrain_uvcalcs",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(156,"terrain_uvcalc",'\u0031','\u0008');
      /* uintfloat: one or more unsigned integer values,
       * (single) float values until end  */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(157,"terrain_patches",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(158,"terrain_patchsets",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(159,"terrain_patchset",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(160,"terrain_patchset_distance",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(161,"terrain_patchset_npatches",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(163,"terrain_patchset_patches",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(164,"terrain_patchset_patch",'\u0016','\r'); /* \u000D */
      /* hexfloat: one or more hexadecimal integer values,
       * (single) float values until end */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(251,"terrain_water_height_offset",'\u0008'); /* Float(3)s */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(281,"terrain_sample_asbuffer",'\u181E','\u000C');
      /* buffer: signed integer value of length-1 of buffer (=x),
       * x byte values, hexadecimal integer values until end (n*8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(282,"terrain_sample_usbuffer",'\u181E','\u000C');
      /* buffer: signed integer value of length-1 of buffer (=x),
       * x byte values, hexadecimal integer values until end (n*8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(-1,null,'\u1086'); /* 8 x Hex(8) */
     dec.put(tok.getKey(),tok);  /* insert for accessability */ /* VT: 0 */
  }
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSFileT() /* create file-control for T-file (Dummy) */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSFileT( /* create file-control for T-file */
   File dat) /* File-definition */
   {
    super(dat); /* set Values using parent (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkFKng"
  * Check File-Identifier for current type of file
  * if argument is 'null' the full key is provided (for write)
  * ##chkFKng.TSFileT (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String chkFKng( /* process file-identifier */
   String  K, /* current value or 'null' */
   boolean t) /* Type of header (true-> binary(14 bytes)) */
   {
   /*-----------------------------------------------------------------*/
    String cK; /* current Key */
   /*=================================================================*/
    cK = t ? FKngB : FKngU; /* select requested file-IDentifier */
    if(K==null) return cK; /* provide requested file-ID */
    /* check file-identifier */
    if(K.equals(cK)) return null; /* identifier is OK */
    return TSLogg.getMsg("TSFle0T1",K); /* provide error-message */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTok" (version 'expand')
  * Get current definition of token from table (key=number)
  * ##getTok.TSFileT (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSFleTok getTok( /* read token-definition from table */
   int nr) /* Number is key of token */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0) nr = Math.max(-32,nr); /* use allowed range */ 
    else nr &= 0x0FFFFFF; /* mask number (3 bytes = 0..16777215 */
      /* allow a 'special request' marked by a negative key */
    return dec.get(new Integer(nr)); /* provide Token */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTok" (version 'reduce')
  * Get current definition of token from table (key=name)
  * ##getTok.TSFileT (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSFleTok getTok( /* read token-definition from table */
   String nme) /* Name is key of token */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    nme = nme.toLowerCase(); /* lower chars (new String is build) */
    return cmp.get(nme); /* provide Token */
  }

 /**. <pre>
  *=====================================================================
  * Method "open"
  * Open file and create Writer.
  * Method returns an error-message or 'null' if no error.
  * This method extends 'open'-function from TSFile-class if output-
  *   mode is requested. The original 'open'-function from
  *   TSFile-class is still available.
  * ##open.TSFileT (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String open( /* open T-file for output */
   boolean cmp) /* 'Reduced' requested (if 'true') */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return super.open(cmp ? TSFile.OUB : TSFile.OUT);
      /* use super-class function to open file */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSFileT (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSFileT{"+super.toStr()+",'"+FKngU+"','"+FKngB+"'}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSFileW -- Compress, decompress, reduce or expand of a W-file
 * ##TSFileW (Eyecatcher)
 *======================================================================
 </pre>*/
class TSFileW extends TSFile { /* (De-)Compress of W-files */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.7.00 01.05.2012";
 /*-------------------------------------------------------------------*/
  private static final String   FKngU = /* Identifier for W-file */
    /* UNICODE-ID */            "SIMISA@@@@@@@@@@JINX0w0t______";
  private static final String   FKngB = "JINX0w0b______"; /* BIN-ID */
 /*-------------------------------------------------------------------*/
  private static HashMap<String,TSFleTok>  cmp; /* Keymap for Compr. */
  private static HashMap<Integer,TSFleTok> dec; /* Keymap for Decompr. */
  private static TSFleTok       tok;    /* create entry for keymaps */
 /**. <pre>
  *=====================================================================
  * Constructor: (0) Create static definitions
  *=====================================================================
  </pre>*/
  static { /* Perform static initialisations */
    cmp = new HashMap<String,TSFleTok>();  /* create table for compr. */
    dec = new HashMap<Integer,TSFleTok>(); /* create table for decompr. */
    /* insert comment-definition */
    tok = new TSFleTok(0,"_Skip",true); /* special comment-token */
     dec.put(tok.getKey(),tok); /* insert for decompress */
     dec.put(new Integer(262144),tok); /* insert for decompress */
     /* compatibility rules -- decode old form(s) of comment, too */
    tok = TSFile.tok1; /* global definition for comment-token */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */

    /* insert all definitions; Basis = 0x0004xxxx (262144) */
    tok = new TSFleTok(262147,"Static",'\u2000'); /* Token(s) 3 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262149,"TrackObj",'\u2000'); /* Token(s) 5 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262150,"Dyntrack",'\u2000'); /* Token(s) 6 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262152,"Forest",'\u2000'); /* Token(s) 8 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262153,"Telepole",'\u2000'); /* Token(s) 9 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262155,"CollideObject",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 11 */
    tok = new TSFleTok(262161,"Signal",'\u2000'); /* Token(s) 17 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262200,"Gantry",'\u2000'); /* Token(s) 56 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262201,"CarSpawner",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 57 */
    tok = new TSFleTok(262203,"Pickup",'\u2000'); /* Token(s) 59 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262204,"Platform",'\u2000'); /* Token(s) 60 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262205,"Siding",'\u2000'); /* Token(s) 61 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262206,"LevelCr",'\u2000'); /* Token(s) 62 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262207,"Transfer",'\u2000'); /* Token(s) 63 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262208,"Speedpost",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 64 */
    tok = new TSFleTok(262209,"Hazard",'\u2000'); /* Token(s) 65 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262219,"Tr_Worldfile",'\uA000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 75 */
    tok = new TSFleTok(262220,"Tr_Watermark",'\u0012'); /* SInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 76 */
    tok = new TSFleTok(262239,"FileName",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 95 */
    tok = new TSFleTok(262241,"Position",'\u0039'); /* 3 x Float(4) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 97 */
    tok = new TSFleTok(262242,"Direction",'\u003B'); /* 3 x Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 98 */
    tok = new TSFleTok(262243,"MaxVisDistance",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 99 */
    tok = new TSFleTok(262244,"Quality",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 100 */
    tok = new TSFleTok(262245,"StaticDetailLevel",'\u0012'); /* SInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 101 */
    tok = new TSFleTok(262248,"StaticFlags",'\u0016'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 104 */
    tok = new TSFleTok(262249,"CollideFlags",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 105 */
    tok = new TSFleTok(262250,"CollideFunction",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 106 */
    tok = new TSFleTok(262252,"UiD",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 108 */
    tok = new TSFleTok(262253,"TrackSections",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 109 */
    tok = new TSFleTok(262254,"TrackSection",'\u2010','\u0011','\u1028');
      /* tokuintfloat: Token(no NL follows) + UInt + 2 x Float(3) */
      /* one requested embedded token (no NL follows),
       * one unsigned integer value,
       * one or more (single) float values, optional embedded token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 110 */
    tok = new TSFleTok(262263,"SectionIdx",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 119 */
    tok = new TSFleTok(262264,"SectionCurve",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 120 */
    tok = new TSFleTok(262268,"JNodePosn",'\u0022','\u0039'); /* 2 x SInt + 3 x Float(4) */
//    tok = new TSFleTok(262268,"JNodePosn",'\u0022','\u0009');
      /* sintfloat: one or more signed integer values, (single) float values until end */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 124 */
    tok = new TSFleTok(262302,"SignalSubObj",'\u0016'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 158 */
    tok = new TSFleTok(262330,"SignalUnits",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 186 */
//    tok = new TSFleTok(262331,"SignalUnit",'\u0011','\u2000'); /* UInt + Token(s) */
    tok = new TSFleTok(262331,"SignalUnit",'\u0011','\u2010'); /* UInt + Token */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 187 */
    tok = new TSFleTok(262337,"Elevation",'\u001B'); /* Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 193 */
    tok = new TSFleTok(262344,"Population",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 200 */
    tok = new TSFleTok(262345,"Area",'\u0028'); /* 2 x Float(3) 201 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262347,"ScaleRange",'\u0028'); /* 2 x Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 203 */
    tok = new TSFleTok(262348,"StartPosition",'\u0038'); /* 3 x Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 204 */
    tok = new TSFleTok(262349,"EndPosition",'\u0038'); /* 3 x Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 205 */
    tok = new TSFleTok(262350,"StartType",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 206 */
    tok = new TSFleTok(262351,"EndType",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 207 */
    tok = new TSFleTok(262421,"StartDirection",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 277 */
    tok = new TSFleTok(262422,"EndDirection",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 278 */
//    tok = new TSFleTok(262423,"ViewDbSphere",'\u2020','\uA000'); /* 2 x Token + Token(s) */
    tok = new TSFleTok(262423,"ViewDbSphere",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 279 */
    tok = new TSFleTok(262424,"Radius",'\u001B'); /* Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 280 */
    tok = new TSFleTok(262425,"NoDirLight",'\u8011'); /* UInt(o) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 281 */
    tok = new TSFleTok(262427,"VDbId",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 283 */
    tok = new TSFleTok(262428,"VDbIdCount",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 284 */
    tok = new TSFleTok(262442,"Matrix3x3",'\u009B'); /* 9 x Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 298 */
    tok = new TSFleTok(262766,"TrItemId",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 622 */
    tok = new TSFleTok(262789,"QDirection",'\u004B'); /* 4 x Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 645 */
    tok = new TSFleTok(262935,"Config",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 791 */
    tok = new TSFleTok(262950,"PlatformName",'\u0023'); /* 2 x String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 806 */
    tok = new TSFleTok(262951,"PlatformData",'\u0016'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 807 */
    tok = new TSFleTok(262955,"SpeedRange",'\u0028'); /* 2 x Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 811 */
    tok = new TSFleTok(262956,"PickupType",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 812 */
    tok = new TSFleTok(262957,"PickupAnimData",'\u0011','\u0018'); /* UInt + Float(3) */
//    tok = new TSFleTok(262957,"PickupAnimData",'\u0011','\u0008');
      /* uintfloat: one or more unsigned integer values,
       * (single) float values until end  */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 813 */
    tok = new TSFleTok(262958,"PickupCapacity",'\u0028'); /* 2 x Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 814 */
    tok = new TSFleTok(262960,"CarFrequency",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 816 */
    tok = new TSFleTok(262961,"CarAvSpeed",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 817 */
    tok = new TSFleTok(262963,"SidingName",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 819 */
    tok = new TSFleTok(262964,"SidingData",'\u0016'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 820 */
    tok = new TSFleTok(262966,"LevelCrParameters",'\u0028'); /* 2 x Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 822 */
    tok = new TSFleTok(262967,"LevelCrData",'\u0016','\u0011'); /* Hex(8) + UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 823 */
    tok = new TSFleTok(262968,"LevelCrTiming",'\u0038'); /* 3 x Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 824 */
    tok = new TSFleTok(262975,"Speed_Sign_Shape",'\u0811','\u404B');
      /* (n=)UInt + 4n x Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 831 */
    tok = new TSFleTok(262978,"Speed_Digit_Tex",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 834 */
    tok = new TSFleTok(262983,"Speed_Text_Size",'\u0037'); /* 3 x Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 839 */
    tok = new TSFleTok(262996,"Width",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 852 */
    tok = new TSFleTok(262997,"Height",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 853 */
    tok = new TSFleTok(262998,"TreeTexture",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 854 */
    tok = new TSFleTok(262999,"TreeSize",'\u0028'); /* 2 x Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 855 */
    tok = new TSFleTok(263000,"Birds",'\u8012'); /* SInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 856 */
    tok = new TSFleTok(263375,"CrashProbability",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1231 */
  }
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSFileW() /* create file-control for W-file (Dummy) */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSFileW( /* create file-control for W-file */
   File dat) /* File-definition */
   {
    super(dat); /* set Values using parent (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkFKng"
  * Check File-Identifier for current type of file
  * if argument is 'null' the full key is provided (for write)
  * ##chkFKng.TSFileW (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String chkFKng( /* process file-identifier */
   String  K, /* current value or 'null' */
   boolean t) /* Type of header (true-> binary(14 bytes)) */
   {
   /*-----------------------------------------------------------------*/
    String cK; /* current Key */
   /*=================================================================*/
    cK = t ? FKngB : FKngU; /* select requested file-IDentifier */
    if(K==null) return cK; /* provide requested file-ID */
    /* check file-identifier */
    if(K.equals(cK)) return null; /* identifier is OK */
    return TSLogg.getMsg("TSFle0W1",K); /* provide error-message */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTok" (version 'expand')
  * Get current definition of token from table (key=number)
  * ##getTok.TSFileW (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSFleTok getTok( /* read token-definition from table */
   int nr) /* Number is key of token */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0) nr = Math.max(-32,nr); /* use allowed range */ 
    else nr &= 0x0FFFFFF; /* mask number (3 bytes = 0..16777215 */
      /* allow a 'special request' marked by a negative key */
    return dec.get(new Integer(nr)); /* provide Token */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTok" (version 'reduce')
  * Get current definition of token from table (key=name)
  * ##getTok.TSFileW (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSFleTok getTok( /* read token-definition from table */
   String nme) /* Name is key of token */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    nme = nme.toLowerCase(); /* lower chars (new String is build) */
    return cmp.get(nme); /* provide Token */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSFileW (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSFileW{"+super.toStr()+",'"+FKngU+"','"+FKngB+"'}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSFileX -- Common access to different files.
 *   This class provides access to different TS-Files in the same way
 *     as access to S-/T- or W-Files is used.
 *   Input : File-ID is read and checked.
 *   Output: Correct File-ID is added automatically.
 *   File-Sub-Type(input) is preserved -- class may be reused for output.
 * Attention: -Some filetypes are ONLY written using UT-Format. However,
 *                all other formats are possible and explicitely supported.
 *                This includes the possibility, that a file is written
 *                in a compressed format, which cannot successfully
 *                loaded into MS-simulator. However, this is stated
 *                within filetype-definition.
 *            - Filetypes, which contain more than one File-Identifier,
 *                (e.g. '*.trk') must be handled by a seperate class.
 * ##TSFileX (Eyecatcher)
 *=======================================================================
 </pre>*/
class TSFileX extends TSFile { /* Access of different TSfiles */
 /*-------------------------------------------------------------------*/
  public  static final String   IdStr = " 3.7.00 15.09.2012";
 /*-------------------------------------------------------------------*/
  protected static final int    FT$gts =  6; /* Filetype-ID: 'gts.dat' */
  protected static final int    FT$lts =  7; /* Filetype-ID: 'lts.dat' */
  protected static final int    FT$idx =  8; /* Filetype-ID: 'idx.dat' */
  protected static final int    FT$ws  =  9; /* Filetype-ID: '*.ws' */
  protected static final int    FT$xdb = 10; /* Filetype-ID: '*.?db' */
  protected static final int    FT$xit = 11; /* Filetype-ID: '*.?it' */
  protected static final int    FT$sig = 12; /* Filetype-ID: 'sigcfg.' */
  protected static final int    FT$act = 13; /* Filetype-ID: '*.act' */
  protected static final int    FT$pat = 14; /* Filetype-ID: '*.pat' */
  protected static final int    FT$srv = 15; /* Filetype-ID: '*.srv' */
  protected static final int    FT$trf = 16; /* Filetype-ID: '*.trf' */
  protected static final int    FT$sms = 17; /* Filetype-ID: '*.sms' */
  protected static final int    FT$env = 18; /* Filetype-ID: '*.env' */
  protected static final int    FT$ssc = 19; /* Filetype-ID: 'ssc.dat' */
  protected static final int    FT$ttp = 20; /* Filetype-ID: !'*.ttp' */
  protected static final int    FT$car = 21; /* Filetype-ID: !'car.dat' */
  protected static final int    FT$tgp = 22; /* Filetype-ID: !'for.dat' */
  protected static final int    FT$gty = 23; /* Filetype-ID: 'gtry.dat' */
  protected static final int    FT$spp = 24; /* Filetype-ID: 'spp.dat' */
  protected static final int    FT$tpl = 25; /* Filetype-ID: 'tpl.dat' */
  protected static final int    FT$haz = 26; /* Filetype-ID: '*.haz' */
  protected static final int    FT$mkr = 27; /* Filetype-ID: '*.mkr' */
  protected static final int    FT$ref = 28; /* Filetype-ID: '*.ref' */
  protected static final int    FT$con = 29; /* Filetype-ID: '*.con' */
  protected static final int    FT$shc = 30; /* Filetype-ID: '*.sd' */
 /*-------------------------------------------------------------------*/
  private static final HashMap<String,TSFleTok>[]  cmpLst;
   /* Keymap-definitions for compression/reduce of various files. */
  private static final HashMap<Integer,TSFleTok>[] decLst;
   /* Keymap-definitions for decompression/expand of various files. */
  private static final String[][] FDef = { /* Identifier for files
     * FDef[][0] = File-ID - Version T (30 chars)
     * FDef[][1] = File-ID - Version B (14 chars) ('null' if not available)
     * FDef[][2] = short ID of filetype
     * FDef[][3] = long ID/description of filetype
     * FDef[][4] = regular expression for selecting filename(s)
     */
    /* [ 0] - entry reserved - */    {null,null,null,null,null},
    /* [ 1] - entry reserved - */    {null,null,null,null,null},
    /* [ 2] - entry reserved - */    {null,null,null,null,null},
    /* [ 3] - entry reserved - */    {null,null,null,null,null},
    /* [ 4] - entry reserved - */    {null,null,null,null,null},
    /* [ 5] - entry reserved - */    {null,null,null,null,null},
    /* tsection.dat(global) */       {"SIMISA@@@@@@@@@@JINX0F0t______",
    /* [ 6] */         "JINX0F0b______","gts","TS(global)","tsection\\.dat"},
    /* tsection.dat(local) */        {"SIMISA@@@@@@@@@@JINX0T0t______",
    /* [ 7] */         "JINX0T0b______","lts","TS(local)","tsection\\.dat"},
    /* (lo_)td_idx.dat */            {"SIMISA@@@@@@@@@@JINX0D0t______",
    /* [ 8] */         "JINX0D0b______","idx.dat","Index",".*td_idx\\.dat"},
    /* Sound (.ws) */                {"SIMISA@@@@@@@@@@JINX0W0t______",
    /* [ 9] */         "JINX0W0b______","ws","WorldSound",".+\\.ws"},
    /* Track-DB (.tdb,.rdb) */       {"SIMISA@@@@@@@@@@JINX0T0t______",
    /* [10] */         "JINX0T0b______","xdb","Track-DB",".+\\.[rt]db"},
    /* Attention: MSTS cannot read compressed/tokenized file-format */
    /* TrItem-DB (.tit,.rit) */      {"SIMISA@@@@@@@@@@JINX0T0t______",
    /* [11] */         "JINX0T0b______","xit","Track-IT",".+\\.[rt]it"},
    /* Attention: MSTS cannot read compressed/tokenized file-format */
    /* Signal (Sigcfg.dat) */        {"SIMISA@@@@@@@@@@JINX0G0t______",
    /* [12] */         "JINX0G0b______","SigC","SignalCfg",".+cfg\\.dat"},
    /* Activity (.act) */            {"SIMISA@@@@@@@@@@JINX0a0t______",
    /* [13] */         "JINX0a0b______","act","Activity",".+\\.act"},
    /* Path (.pat) */                {"SIMISA@@@@@@@@@@JINX0P0t______",
    /* [14] */         "JINX0P0b______","pat","Path",".+\\.pat"},
    /* Services (.srv) */            {"SIMISA@@@@@@@@@@JINX0v0t______",
    /* [15] */         "JINX0v0b______","srv","Service",".+\\.srv"},
    /* Traffic (.trf) */             {"SIMISA@@@@@@@@@@JINX0f0t______",
    /* [16] */         "JINX0f0b______","trf","Traffic",".+\\.trf"},
    /* Sound (.sms) */               {"SIMISA@@@@@@@@@@JINX0x1t______",
    /* [17] */         "JINX0x1b______","sms","SMS",".+\\.sms"},
    /* Environment (.env) */         {"SIMISA@@@@@@@@@@JINX0w0t______",
    /* [18] */         "JINX0w0b______","env","Environment",".+\\.env"},
    /* Attention: MSTS cannot read compressed/tokenized file-format */
    /* Sound (SSource.dat) */        {"SIMISA@@@@@@@@@@JINX0Z1t______",
    /* [19] */         "JINX0Z1b______","ssrc","SoundSrc","SSource\\.dat"},
    /* Sound (TType.dat) */          {"SIMISA@@@@@@@@@@JINX0t1t______",
    /* [20]! */        null,"ttp","TType","TType\\.dat"},
    /* Attention: File can OLNY be written using UT-format */
    /* Car (Carspawn.dat) */         {"SIMISA@@@@@@@@@@JINX0v1t______",
    /* [21]! */        null,"cars","CarSpwn","CarSpawn\\.dat"},
    /* Attention: File can OLNY be written using UT-format */
    /* Tree (Forests.dat) */         {"SIMISA@@@@@@@@@@JINX0F0t______",
    /* [22]! */        null,"tgrp","Forest","Forests\\.dat"},
    /* Attention: File can OLNY be written using UT-format */
    /* Gantry (Gantry.dat) */        {"SIMISA@@@@@@@@@@JINX0g0t______",
    /* [23] */         "JINX0g0b______","gtry","Gantry","Gantry\\.dat"},
    /* Obj (Speedpost.dat) */        {"SIMISA@@@@@@@@@@JINX0t1t______",
    /* [24] */         "JINX0t1b______","spp","Speedpost","Speedpost\\.dat"},
    /* Obj (Telepole.dat) */         {"SIMISA@@@@@@@@@@JINX0r1t______",
    /* [25] */         "JINX0r1b______","tpol","TelePole","TelePole\\.dat"},
    /* Hazard (.haz) */              {"SIMISA@@@@@@@@@@JINX0h0t______",
    /* [26] */         "JINX0h0b______","haz","Hazard",".+\\.haz"},
    /* Marker (.mkr) */              {"SIMISA@@@@@@@@@@JINX0I0t______",
    /* [27] */         "JINX0I0b______","mkr","Marker",".+\\.mkr"},
    /* Reference (.ref) */           {"SIMISA@@@@@@@@@@JINX0r1t______",
    /* [28] */         "JINX0r1b______","ref","Reference",".+\\.ref"},
    /* Consist (.con) */             {"SIMISA@@@@@@@@@@JINX0D0t______",
    /* [29] */         "JINX0D0b______","con","Consist",".+\\.con"},
    /* Attention: MSTS cannot read compressed/tokenized file-format */
    /* ShapeCtl (.sd) */             {"SIMISA@@@@@@@@@@JINX0t1t______",
    /* [30] */         "JINX0t1b______","shc","ShapeCtl",".+\\.sd"}};
  private static final int      minIx = 6; /* minimum value of index */
  private static final int      NrRef = FDef.length; /* count of filetypes */
 /*-------------------------------------------------------------------*/
  private static HashMap<String,TSFleTok>  cmp; /* Keymap for Compr. */
  private static HashMap<Integer,TSFleTok> dec; /* Keymap for Decompr. */
  private static TSFleTok       tok;   /* create entry for keymaps */
  private static final TSFleTok tok1 = TSFile.tok1; /* global definition */
    /* access comment-record 'Comment' -- special comment-definition */
  /*-------------------------------------------------------------------*/
  private HashMap<String,TSFleTok>  ccmp; /* Keymap for Compression */
  private HashMap<Integer,TSFleTok> cdec; /* Keymap for Decompression */
  private String                FKngU; /* Text-Identifier(s) for file */
  private String                FKngB; /* BINARY-ID's of file */
  private String                Type;  /* current type of file */
 /**. <pre>
  *=====================================================================
  * Constructor: (0) Create static definitions
  *=====================================================================
  </pre>*/
  static { /* Perform static initialisations */
    cmpLst = (HashMap<String,TSFleTok>[])(new HashMap[NrRef]);
      /* create list of tables for compress/reduce of files */
    decLst = (HashMap<Integer,TSFleTok>[])(new HashMap[NrRef]);
      /* create list of tables for decompress/expand of files */
    Arrays.fill(cmpLst,null); /* preset all entries to 'invalid' */
    Arrays.fill(decLst,null); /* preset all entries to 'invalid' */

    /* -6- create definitions for type 'gts': 'global tsection.dat' */
    cmpLst[FT$gts] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'global tsection.dat'. */
    decLst[FT$gts] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'global tsection.dat'. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
      /* decompress not supported -- use '_Skip' instead */
    /* insert definitions with Basis: 0x0004xxxx (262144) */
    tok = new TSFleTok(262239,"FileName",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 95 */
    tok = new TSFleTok(262253,"Tracksections",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 109 */
    tok = new TSFleTok(262254,"Tracksection",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 110 */
    tok = new TSFleTok(262255,"TrackShapes",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 111 */
    tok = new TSFleTok(262256,"TrackShape",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 112 */
    tok = new TSFleTok(262257,"TunnelShape",'\u8011'); /* UInt(o) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 113 */
    tok = new TSFleTok(262258,"RoadShape",'\u8011'); /* UInt(o) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 114 */
    tok = new TSFleTok(262259,"CrossoverShape",'\u8011'); /* UInt(o) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 115 */
    tok = new TSFleTok(262260,"ManualJunctionShape");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 116 */
    tok = new TSFleTok(262261,"SectionSize",'\u0018','\u001B'); /* Float(3) + Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 117 */
    tok = new TSFleTok(262263,"SectionIdx",'\u0811','\u004B','\u4011');
       /* UInt(=x) + 4 x Float(6) + 1*x x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 119 */
    tok = new TSFleTok(262264,"SectionCurve",'\u002B'); /* 2 x Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 120 */
    tok = new TSFleTok(262265,"SectionSkew",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 121 */
    tok = new TSFleTok(262266,"XoverPts",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 122 */
    tok = new TSFleTok(262267,"XoverPt",'\u003B'); /* 3 x Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 123 */
    tok = new TSFleTok(262385,"WaterScoop",'\u8011'); /* UInt(o) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 241 */
    tok = new TSFleTok(262821,"MainRoute",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 677 */
    tok = new TSFleTok(262822,"NumPaths",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 678 */
    tok = new TSFleTok(262823,"ClearanceDist",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 679 */

    /* -7- create definitions for type 'lts': 'local tsection.dat' */
    cmpLst[FT$lts] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'local tsection.dat'. */
    decLst[FT$lts] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'local tsection.dat'. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert definitions with Basis: 0x0004xxxx (262144) */
    tok = new TSFleTok(262253,"Tracksections",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 109 */
    tok = new TSFleTok(262254,"Tracksection",'\u2810','\u0011','\u1029');
       /* Token + UInt + 2 x Float(4) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 110 */
    tok = new TSFleTok(262263,"SectionIdx",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 119 */
    tok = new TSFleTok(262264,"SectionCurve",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 120 */
    tok = new TSFleTok(263190,"TrackPath",'\u0001'); /* UInt(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1046 */

    /* -8- create definitions for type 'idx': '(lo_)td_idx.dat' */
    cmpLst[FT$idx] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of '(lo_)td_idx.dat'-file. */
    decLst[FT$idx] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of '(lo_)td_idx.dat'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert definitions with Basis: 0x0000xxxx (0) */
    tok = new TSFleTok(132,"Terrain_Desc",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(134,"Terrain_Desc_Size",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(135,"Terrain_Desc_Tiles",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    /* insert definitions with Basis: 0x0004xxxx (262144) */
    tok = new TSFleTok(262334,"Depth",'\u0012'); /* SInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 190 */
    tok = new TSFleTok(262335,"TdFile",'\u0022'); /* 2 x SInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 191 */

    /* -9- create definitions for type 'ws': '*.ws = WorldSound' */
    cmpLst[FT$ws] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of '*.ws'-file. */
    decLst[FT$ws] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of '*.ws'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert definitions with Basis: 0x0004xxxx (262144) */
    tok = new TSFleTok(262211,"Soundsource",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 67 */
    tok = new TSFleTok(262212,"Soundregion",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 68 */
    tok = new TSFleTok(262232,"Tr_Worldsoundfile",'\uA000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 88 */
    tok = new TSFleTok(262239,"FileName",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 95 */
    tok = new TSFleTok(262241,"Position",'\u0039'); /* 3 x Float(4) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 97 */
    tok = new TSFleTok(262248,"StaticFlags",'\u0016'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 104 */
    tok = new TSFleTok(262252,"UiD",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 108 */
    tok = new TSFleTok(262427,"VDbId",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 283 */
    tok = new TSFleTok(262766,"TrItemId",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 622 */
    tok = new TSFleTok(262789,"QDirection",'\u004B'); /* 4 x Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 645 */
    tok = new TSFleTok(263007,"SoundregionTrackType",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 863 */
    tok = new TSFleTok(263008,"SoundregionRoty",'\u001B'); /* Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 864 */

    /* -10- create definitions for type 'xdb': '*.?db = track/road-database' */
    /* Attention: File CANNOT be compressed/tokenized  (not accepted) */
    cmpLst[FT$xdb] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'track/road-database'. */
    decLst[FT$xdb] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'track/road-database'. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert definitions with Basis: 0x0004xxxx (262144) */
    tok = new TSFleTok(262252,"UiD",'\u0022','\u0021','\u0022','\u006B');
      /* 2 x SInt + 2 x UInt + 2 x SInt + 6 x Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 108 */
    tok = new TSFleTok(262269,"TrackNodes",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 125 */
    tok = new TSFleTok(262270,"TrackNode",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 126 */
    tok = new TSFleTok(262271,"TrPins",'\u0021','\u2000'); /* 2 x UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 127 */
    tok = new TSFleTok(262272,"TrPin",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 128 */
    tok = new TSFleTok(262273,"TrVectorNode",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 129 */
    tok = new TSFleTok(262274,"TrJunctionNode",'\u0031'); /* 3 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 130 */
    tok = new TSFleTok(262278,"TrEndNode",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 134 */
    tok = new TSFleTok(262281,"TrVectorSections",'\u0811','\u401C');
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 137 */
    tok = new TSFleTok(-1,null,'\u0021','\u0022','\u0031','\u0014','\u0022','\u006B');
      /* 2 x UInt + 2 x SInt + 3 x UInt + Hex(2) + 2 x SInt + 6 x Float(6) */
     dec.put(tok.getKey(),tok); /* insert for accessability */ /* VT: 0 */
    tok = new TSFleTok(262284,"TrSignalType",'\u0016','\u0011','\u001B','\u0013');
      /* Hex(8) + UInt + Float(6) + String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 140 */
    tok = new TSFleTok(262285,"TrSignalDirs",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 141 */
    tok = new TSFleTok(262286,"TrSignalDir",'\u0041'); /* 4 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 142 */
    tok = new TSFleTok(262764,"TrItemRefs",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 620 */
    tok = new TSFleTok(262765,"TrItemRef",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 621 */
    tok = new TSFleTok(262766,"TrItemId",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 622 */
    tok = new TSFleTok(262767,"TrItemSData",'\u0018','\u0016'); /* Float(3) + Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 623 */
    tok = new TSFleTok(262768,"TrItemPData",'\u002B','\u0022'); /* 2 x Float(6) + 2 x SInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 624 */
    tok = new TSFleTok(262769,"TrItemRData",'\u003B','\u0022'); /* 3 x Float(6) + 2 x SInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 625 */
    tok = new TSFleTok(262770,"TrItemSRData",'\u0021','\u001B'); /* 2 UInt + Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 626 */
    tok = new TSFleTok(262771,"TrItemTable",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 627 */
    tok = new TSFleTok(262772,"EmptyItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 628 */
    tok = new TSFleTok(262773,"SignalItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 629 */
    tok = new TSFleTok(262774,"PickupItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 630 */
    tok = new TSFleTok(262775,"PlatformItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 631 */
    tok = new TSFleTok(262776,"HazzardItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 632 */
    tok = new TSFleTok(262777,"CarSpawnerItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 633 */
    tok = new TSFleTok(262778,"SidingItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 634 */
    tok = new TSFleTok(262779,"LevelCrItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 635 */
    tok = new TSFleTok(262780,"SpeedPostItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 636 */
    tok = new TSFleTok(262781,"SoundRegionItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 637 */
    tok = new TSFleTok(262782,"CrossoverItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 638 */
    tok = new TSFleTok(262950,"PlatformName",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 806 */
    tok = new TSFleTok(262952,"PlatformTrItemData",'\u0016','\u0011'); /* Hex(8) + UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 808 */
    tok = new TSFleTok(262953,"PlatformMinWaitingTime",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 809 */
    tok = new TSFleTok(262954,"PlatformNumPassengersWaiting",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 810 */
    tok = new TSFleTok(262959,"PickupTrItemData",'\u0011','\u0016'); /* UInt + Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 815 */
    tok = new TSFleTok(262963,"SidingName",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 819 */
    tok = new TSFleTok(262965,"SidingTrItemData",'\u0016','\u0011'); /* Hex(8) + UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 821 */
    tok = new TSFleTok(262972,"SpeedpostTrItemData",'\u0011','\u000B'); /* UInt + Float(6)s */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 828 */
    tok = new TSFleTok(262985,"CrossoverTrItemData",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 841 */
    tok = new TSFleTok(263106,"Station",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 962 */
    tok = new TSFleTok(263316,"Serial",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1172 */
    tok = new TSFleTok(263376,"TrackDB",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1232 */

    /* -11- create definitions for type 'xit': '*.?it = track/road-itbase' */
    /* Attention: File CANNOT be compressed/tokenized  (not accepted) */
    cmpLst[FT$xit] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'track/road-itbase'. */
    decLst[FT$xit] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'track/road-itbase'. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert definitions with Basis: 0x0004xxxx (262144) */
    tok = new TSFleTok(262284,"TrSignalType",'\u0016','\u0011','\u001B','\u0013');
      /* Hex(8) + UInt + Float(6) + String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 140 */
    tok = new TSFleTok(262285,"TrSignalDirs",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 141 */
    tok = new TSFleTok(262287,"TrSignalRDir",'\u003B','\u0022','\u001B');
      /* 3 x Float(6) + 2 x SInt + Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 143 */
    tok = new TSFleTok(262766,"TrItemId",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 622 */
    tok = new TSFleTok(262767,"TrItemSData",'\u0018','\u0016'); /* Float(3) + UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 623 */
    tok = new TSFleTok(262768,"TrItemPData",'\u002B','\u0002');
      /* floatsint: one or more (single) float values,
       * signed integer values until end */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 624 */
    tok = new TSFleTok(262769,"TrItemRData",'\u003B','\u0002');
      /* floatsint: one or more (single) float values,
       * signed integer values until end */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 625 */
    tok = new TSFleTok(262770,"TrItemSRData",'\u0021','\u000B');
      /* uintfloat: one or more unsigned integer values,
       * (single) float values until end  */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 626 */
    tok = new TSFleTok(262771,"TrItemTable",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 627 */
    tok = new TSFleTok(262772,"EmptyItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 628 */
    tok = new TSFleTok(262773,"SignalItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 629 */
    tok = new TSFleTok(262774,"PickupItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 630 */
    tok = new TSFleTok(262775,"PlatformItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 631 */
    tok = new TSFleTok(262776,"HazzardItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 632 */
    tok = new TSFleTok(262777,"CarSpawnerItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 633 */
    tok = new TSFleTok(262778,"SidingItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 634 */
    tok = new TSFleTok(262779,"LevelCrItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 635 */
    tok = new TSFleTok(262780,"SpeedPostItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 636 */
    tok = new TSFleTok(262781,"SoundRegionItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 637 */
    tok = new TSFleTok(262782,"CrossoverItem",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 638 */
    tok = new TSFleTok(262950,"PlatformName",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 806 */
    tok = new TSFleTok(262952,"PlatformTrItemData",'\u0016','\u0011');
      /* hexuint: one or more hexadecimal integer values,
       * one or more unsigned integer values, Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 808 */
    tok = new TSFleTok(262953,"PlatformMinWaitingTime",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 809 */
    tok = new TSFleTok(262954,"PlatformNumPassengersWaiting",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 810 */
    tok = new TSFleTok(262959,"PickupTrItemData",'\u0011','\u0016');
      /* uinthex: one or more unsigned integer values,
       * one or more hexadecimal integer values */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 815 */
    tok = new TSFleTok(262963,"SidingName",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 819 */
    tok = new TSFleTok(262965,"SidingTrItemData",'\u0016','\u0011');
      /* hexuint: one or more hexadecimal integer values,
       * one or more unsigned integer values, Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 821 */
    tok = new TSFleTok(262972,"SpeedpostTrItemData",'\u0011','\u000B'); /* UInt + Float(6)s */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 828 */
    tok = new TSFleTok(262985,"CrossoverTrItemData",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 841 */
    tok = new TSFleTok(263106,"Station",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 962 */

    /* -12- create definitions for type 'sig': 'SigCfg.dat' */
    cmpLst[FT$sig] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'SigCfg.dat'-file. */
    decLst[FT$sig] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'SigCfg.dat'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert definitions with Basis: 0x0000xxxx (0) */
    tok = new TSFleTok(10,"colour",'\u0041'); /* 4 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    /* insert all definitions; Basis = 0x0004xxxx (262144) */
    tok = new TSFleTok(262241,"Position",'\u0037'); /* 3 x Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 97 */
    tok = new TSFleTok(262289,"SignalFlags",'\u0003'); /* String(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 145 */
    tok = new TSFleTok(262293,"LightsTab",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 149 */
    tok = new TSFleTok(262294,"LightsTabEntry",'\u0813','\u0810'); /* String + Token */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 150 */
    tok = new TSFleTok(262295,"LightTextures",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 151 */
    tok = new TSFleTok(262296,"LightTex",'\u0823','\u0047'); /* 2 x String + 4 x Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 152 */
    tok = new TSFleTok(262297,"SignalLightTex",'\u0813'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 153 */
    tok = new TSFleTok(262298,"SignalTypes",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 154 */
    tok = new TSFleTok(262299,"SignalType",'\u0013','\u2000'); /* String + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 155 */
    tok = new TSFleTok(262300,"SignalFnType",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 156 */
    tok = new TSFleTok(262301,"SignalSubObjs",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 157 */
    tok = new TSFleTok(262302,"SignalSubObj",'\u0011','\u0013','\u0813','\u2000');
      /* UInt + 2 x String + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 158 */
    tok = new TSFleTok(262303,"SignalShapes",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 159 */
    tok = new TSFleTok(262304,"SignalShape",'\u2013','\u2813','\u2000');
      /* String + String + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 160 */
    tok = new TSFleTok(262307,"SignalLights",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 163 */
    tok = new TSFleTok(262308,"SignalLight",'\u0011','\u0813','\u2000');
      /* UInt + String + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 164 */
    tok = new TSFleTok(262309,"SignalDrawStates",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 165 */
    tok = new TSFleTok(262310,"SignalDrawState",'\u0011','\u0813','\uA000');
      /* UInt + String + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 166 */
    tok = new TSFleTok(262311,"SignalAspects",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 167 */
    tok = new TSFleTok(262312,"SignalAspect",'\u0013','\u0813','\uA000'); /* 2 x String + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 168 */
    tok = new TSFleTok(262313,"DrawLights",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 169 */
    tok = new TSFleTok(262314,"DrawLight",'\u0011','\u8800'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 170 */
    tok = new TSFleTok(262315,"SemaphoreInfo",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 171 */
    tok = new TSFleTok(262316,"SemaphorePos",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 172 */
    tok = new TSFleTok(262320,"SignalNumClearAhead",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 176 */
    tok = new TSFleTok(262321,"SigSubType",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 177 */
    tok = new TSFleTok(262322,"SigSubSType",'\u0813'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 178 */
    tok = new TSFleTok(262324,"SigFlashDuration",'\''); /* \u0027 2 x Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 180 */
    tok = new TSFleTok(262325,"SigSubJnLinkIf",'\u0001'); /* UInt(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 181 */
    tok = new TSFleTok(262326,"ScriptFiles",'\u8800'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 182 */
    tok = new TSFleTok(262327,"ScriptFile",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 183 */
    tok = new TSFleTok(262328,"SpeedMPH",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 184 */
    tok = new TSFleTok(262329,"SpeedKPH",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 185 */
    tok = new TSFleTok(262424,"Radius",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 280 */

    /* -13- create definitions for type 'act': '*.act = Activity' */
    cmpLst[FT$act] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'Activity'-file. */
    decLst[FT$act] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'Activity'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert all definitions; Basis = 0x0004xxxx (262144) */
    tok = new TSFleTok(262157,"Wagon",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 13 */
    tok = new TSFleTok(262158,"Engine",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 14 */
    tok = new TSFleTok(262228,"Tr_Activity_File",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 84 */
    tok = new TSFleTok(262229,"Tr_Activity_Header",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 85 */
    tok = new TSFleTok(262234,"TrainCfg",'\u0013','\uA000'); /* String + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 90 */
    tok = new TSFleTok(262242,"Direction",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 98 */
    tok = new TSFleTok(262252,"UiD",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 108 */
    tok = new TSFleTok(262343,"Speed",'\u001B'); /* Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 199 */
    tok = new TSFleTok(262348,"StartPosition",'\u0022','\u0028'); /* 2 x SInt + 2 x Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 204 */
    tok = new TSFleTok(262349,"EndPosition",'\u0022','\u0028'); /* 2 x SInt + 2 x Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 205 */
    tok = new TSFleTok(262433,"Type",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 289 */
    tok = new TSFleTok(262502,"MaxVelocity",'\u002B'); /* 2 x Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 358 */
    tok = new TSFleTok(262758,"FuelWater",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 614 */
    tok = new TSFleTok(262759,"FuelCoal",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 615 */
    tok = new TSFleTok(262760,"FuelDiesel",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 616 */
    tok = new TSFleTok(262774,"PickupItem",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 630 */
    tok = new TSFleTok(262778,"SidingItem",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 634 */
    tok = new TSFleTok(262786,"WagonData",'\u0023'); /* 2 x String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 642 */
    tok = new TSFleTok(262787,"EngineData",'\u0023'); /* 2 x String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 643 */
    tok = new TSFleTok(262793,"Flip");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 649 */
    tok = new TSFleTok(262795,"NextWagonUID",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 651 */
    tok = new TSFleTok(262796,"Durability",'\u001B'); /* Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 652 */
    tok = new TSFleTok(262951,"PlatformData",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 807 */
    tok = new TSFleTok(262954,"PlatformNumPassengersWaiting",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 810 */
    tok = new TSFleTok(262959,"PickupTrItemData",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 815 */
    tok = new TSFleTok(263050,"RouteID",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 906 */
    tok = new TSFleTok(263051,"Name",'\u0813'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 907 */
    tok = new TSFleTok(263052,"Description",'\u078F'); /* String(+) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 908 */
    tok = new TSFleTok(263086,"PathID",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 942 */
    tok = new TSFleTok(263087,"Mode",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 943 */
    tok = new TSFleTok(263088,"Briefing",'\u078F'); /* String(+) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 944 */
    tok = new TSFleTok(263093,"StartingSpeed",'\u001B'); /* Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 949 */
    tok = new TSFleTok(263095,"Season",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 951 */
    tok = new TSFleTok(263096,"Weather",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 952 */
    tok = new TSFleTok(263097,"StartTime",'\u0001'); /* UInts */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 953 */
    tok = new TSFleTok(263100,"Workers",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 956 */
    tok = new TSFleTok(263100,"Animals",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 955 */
    tok = new TSFleTok(263103,"Difficulty",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 959 */
    tok = new TSFleTok(263107,"ID",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 963 */
    tok = new TSFleTok(263116,"ActivityObjects",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 972 */
    tok = new TSFleTok(263117,"ActivityObject",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 973 */
    tok = new TSFleTok(263118,"ActivityRestrictedSpeedZones",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 974 */
    tok = new TSFleTok(263119,"ActivityRestrictedSpeedZone",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 975 */
    tok = new TSFleTok(263120,"ActivityFailedSignals",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 976 */
    tok = new TSFleTok(263121,"ActivityFailedSignal",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 977 */
    tok = new TSFleTok(263122,"Tile",'\u0022','\u002B'); /* 2 x SInt + 2 x Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 978 */
    tok = new TSFleTok(263123,"ObjectType",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 979 */
    tok = new TSFleTok(263124,"Events",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 980 */
    tok = new TSFleTok(263125,"Location",'\u0022','\u002B','\u0011');
      /* 2 x SInt + 2 x Float(6) + UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 981 */
    tok = new TSFleTok(263127,"Outcomes",'\uA000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 983 */
    tok = new TSFleTok(263129,"TextToDisplayOnCompletionIfTriggered",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 985 */
    tok = new TSFleTok(263130,"TextToDisplayOnCompletionIfNotTriggered",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 986 */
    tok = new TSFleTok(263131,"TextToDisplayDescriptionOfTask",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 987 */
    tok = new TSFleTok(263138,"Time",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 994 */
    tok = new TSFleTok(263140,"Traffic_Definition",'\u0013','\uA000'); /* String + Tokens */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 996 */
    tok = new TSFleTok(263141,"Service_Definition",'\u0013','\u0017','\uA000'); 
      /* String + Float(0) + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 997 */
    tok = new TSFleTok(263142,"Train_Config",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 998 */
    tok = new TSFleTok(263143,"Reversable_Event");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 999 */
    tok = new TSFleTok(263146,"TriggerOnStop",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1002 */
    tok = new TSFleTok(263147,"CompleteActivity",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1003 */
    tok = new TSFleTok(263148,"IncActLevel",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1004 */
    tok = new TSFleTok(263149,"DecActLevel",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1005 */
    tok = new TSFleTok(263150,"ActivateEvent",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1006 */
    tok = new TSFleTok(263151,"RestoreActLevel",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1007 */
    tok = new TSFleTok(263152,"DisplayMessage",'\u096F'); /* String(+) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1008 */
    tok = new TSFleTok(263154,"ActivitySuccess");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1010 */
    tok = new TSFleTok(263155,"ActivityFail",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1011 */
    tok = new TSFleTok(263156,"StartIgnoringSpeedLimits");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1012 */
    tok = new TSFleTok(263157,"StopIgnoringSpeedLimits");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1013 */
    tok = new TSFleTok(263158,"Activation_Level",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1014 */
    tok = new TSFleTok(263159,"EventCategoryLocation",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1015 */
    tok = new TSFleTok(263160,"EventCategoryTime",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1016 */
    tok = new TSFleTok(263161,"EventCategoryAction",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1017 */
    tok = new TSFleTok(263162,"EventTypeLocation");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1018 */
    tok = new TSFleTok(263163,"EventTypeTime");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1019 */
    tok = new TSFleTok(263164,"NextServiceUID",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1020 */
    tok = new TSFleTok(263165,"NextActivityObjectUID",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1021 */
    tok = new TSFleTok(263166,"EventTypeAllStops");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1022 */
    tok = new TSFleTok(263167,"EventTypePickUpPassengers");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1023 */
    tok = new TSFleTok(263168,"EventTypePickUp");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1024 */
    tok = new TSFleTok(263169,"EventTypeReachSpeed");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1025 */
    tok = new TSFleTok(263170,"EventTypePickUpWagons");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1026 */
    tok = new TSFleTok(263171,"EventTypeDropOffWagonsAtLocation");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1027 */
    tok = new TSFleTok(263172,"EventTypeAssembleTrain");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1028 */
    tok = new TSFleTok(263173,"EventTypeAssembleTrainAtLocation");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1029 */
    tok = new TSFleTok(263174,"Wagon_List",'\uA000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1030 */
    tok = new TSFleTok(263178,"StationStop",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1034 */
    tok = new TSFleTok(263179,"PlatformStartID",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1035 */
    tok = new TSFleTok(263181,"ArrivalTime",'\u0017'); /* Float(0) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1037 */
    tok = new TSFleTok(263183,"DepartTime",'\u0017'); /* Float(0) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1039 */
    tok = new TSFleTok(263184,"DistanceDownPath",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1040 */
    tok = new TSFleTok(263185,"Efficiency",'\u0017'); /* Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1041 */
    tok = new TSFleTok(263186,"SkipCount",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1042 */
    tok = new TSFleTok(263311,"Duration",'\u0001'); /* UInts */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1167 */
    tok = new TSFleTok(263316,"Serial",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1172 */
    tok = new TSFleTok(263372,"Player_Traffic_Definition",'\u0017','\uA000'); 
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1228 */
    tok = new TSFleTok(263373,"Player_Service_Definition",'\u0013','\u2000'); 
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1229 */
    tok = new TSFleTok(263374,"Tr_Activity",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1230 */

    /* -14- create definitions for type 'pat': '*.pat = Path' */
    cmpLst[FT$pat] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'Path'-file. */
    decLst[FT$pat] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'Path'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert all definitions; Basis = 0x0004xxxx (262144) */
    tok = new TSFleTok(263051,"Name",'\u0813'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 907 */
    tok = new TSFleTok(263187,"TrackPDPs",'\uA000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1043 */
    tok = new TSFleTok(263188,"TrackPDP",'\u0022','\u003B','\u0021');
      /* 2 x SInt + 3 x Float(6) + 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1044 */
    tok = new TSFleTok(263190,"TrackPath",'\uA000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1046 */
    tok = new TSFleTok(263191,"TrPathName",'\u0813'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1047 */
    tok = new TSFleTok(263192,"TrPathStart",'\u0813'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1048 */
    tok = new TSFleTok(263193,"TrPathEnd",'\u0813'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1049 */
    tok = new TSFleTok(263196,"TrPathNodes",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1052 */
    tok = new TSFleTok(263197,"TrPathNode",'\u0016','\u0031'); /* Hex(8) + 3 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1053 */
    tok = new TSFleTok(263198,"TrPathFlags",'\u0816'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1054 */
    tok = new TSFleTok(263316,"Serial",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1172 */

    /* -15- create definitions for type 'srv': '*.srv = Service' */
    cmpLst[FT$srv] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'Service'-file. */
    decLst[FT$srv] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'Service'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert all definitions; Basis = 0x0004xxxx (262144) */
    tok = new TSFleTok(262420,"MaxWheelAcceleration",'\u0019'); /* Float(4) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 276 */
    tok = new TSFleTok(263051,"Name",'\u0813'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 907 */
    tok = new TSFleTok(263086,"PathID",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 942 */
    tok = new TSFleTok(263093,"StartingSpeed",'\u001B'); /* Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 949 */
    tok = new TSFleTok(263094,"EndingSpeed",'\u001B'); /* Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 950 */
    tok = new TSFleTok(263141,"Service_Definition",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 997 */
    tok = new TSFleTok(263142,"Train_Config",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 998 */
    tok = new TSFleTok(263175,"TimeTable",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1031 */
    tok = new TSFleTok(263176,"StartInWorld",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1032 */
    tok = new TSFleTok(263177,"EndInWorld",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1033 */
    tok = new TSFleTok(263178,"StationStop",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1034 */
    tok = new TSFleTok(263179,"PlatformStartID",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1035 */
    tok = new TSFleTok(263184,"DistanceDownPath",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1040 */
    tok = new TSFleTok(263185,"Efficiency",'\u0017'); /* Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1041 */
    tok = new TSFleTok(263186,"SkipCount",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1042 */
    tok = new TSFleTok(263316,"Serial",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1172 */

    /* -16- create definitions for type 'trf': '*.trf = Traffic' */
    cmpLst[FT$trf] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'Traffic'-file. */
    decLst[FT$trf] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'Traffic'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert all definitions; Basis = 0x0004xxxx (262144) */
    tok = new TSFleTok(263140,"Traffic_Definition",'\u0013','\u2000'); /* String + Tokens */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 996 */
    tok = new TSFleTok(263141,"Service_Definition",'\u0013','\u0017','\uA000'); 
      /* String + Float(0) + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 997 */
    tok = new TSFleTok(263179,"PlatformStartID",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1035 */
    tok = new TSFleTok(263181,"ArrivalTime",'\u0017'); /* Float(0) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1037 */
    tok = new TSFleTok(263183,"DepartTime",'\u0017'); /* Float(0) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1039 */
    tok = new TSFleTok(263184,"DistanceDownPath",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1040 */
    tok = new TSFleTok(263186,"SkipCount",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1042 */
    tok = new TSFleTok(263316,"Serial",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1172 */

    /* -17- create definitions for type 'sms': '*.sms = Sound' */
    cmpLst[FT$sms] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'Sound'-file. */
    decLst[FT$sms] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'Sound'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    tok = new TSFleTok(0,"Skip",true); /* alternate comment */
     cmp.put(tok.getName().toLowerCase(),tok); /* compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    /* insert all definitions; Basis = 0x0004xxxx (262144) */
    tok = new TSFleTok(262231,"Tr_SMS",'\uA000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 87 */
    tok = new TSFleTok(262986,"TrackType",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 842 */
    tok = new TSFleTok(262992,"Distance",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 848 */
    tok = new TSFleTok(263199,"ScalabiltyGroup",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1055 */
    tok = new TSFleTok(263200,"Streams",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1056 */
    tok = new TSFleTok(263201,"Stream",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1057 */
    tok = new TSFleTok(263202,"Triggers",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1058 */
    tok = new TSFleTok(263203,"Discrete_Trigger",'\u1011','\u1800'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1059 */
    tok = new TSFleTok(263204,"Variable_Trigger",'\u0013','\u1011','\u9800');
      /* String + UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1060 */
    tok = new TSFleTok(263205,"Initial_Trigger",'\u0800'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1061 */
    tok = new TSFleTok(263206,"Dist_Travelled_Trigger",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1062 */
    tok = new TSFleTok(263207,"Random_Trigger",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1063 */
    tok = new TSFleTok(263208,"Delay_Min_Max",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1064 */
    tok = new TSFleTok(263209,"Volume_Min_Max",'\''); /* \u0027 2 x Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1065 */
    tok = new TSFleTok(263210,"Dist_Min_Max",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1066 */
    tok = new TSFleTok(263221,"PlayOneShot",'\u1011','\u1800'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1077 */
    tok = new TSFleTok(263223,"File",'\u0813','\u0012','\u8800');
      /* String + SInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1079 */
    tok = new TSFleTok(263224,"SelectionMethod",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1080 */
    tok = new TSFleTok(263227,"StartLoop",'\u0011','\u0800'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1083 */
    tok = new TSFleTok(263228,"StartLoopRelease",'\u0011','\u0800'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1084 */
    tok = new TSFleTok(263229,"ReleaseLoopRelease");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1085 */
    tok = new TSFleTok(263231,"EnableTrigger",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1087 */
    tok = new TSFleTok(263232,"DisableTrigger",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1088 */
    tok = new TSFleTok(263233,"Volume",'\u0017'); /* Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1089 */
    tok = new TSFleTok(263234,"Stereo");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1090 */
    tok = new TSFleTok(263236,"Priority",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1092 */
    tok = new TSFleTok(263238,"Ignore3d");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1094 */
    tok = new TSFleTok(263239,"VolumeCurve",'\u0013','\u2000'); /* String + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1095 */
    tok = new TSFleTok(263246,"CurvePoints",'\u0811','\u4027'); /* UInt + 2 x Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1102 */
    tok = new TSFleTok(263247,"Granularity",'\u0017'); /* Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1103 */
    tok = new TSFleTok(263248,"Activation",'\u8800'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1104 */
    tok = new TSFleTok(263249,"Deactivation",'\u8800'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1105 */
    tok = new TSFleTok(263250,"PassengerCam");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1106 */
    tok = new TSFleTok(263251,"CabCam");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1107 */
    tok = new TSFleTok(263252,"ExternalCam");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1108 */

    /* -18- create definitions for type 'env': '*.env = Environment' */
    /* Attention: File CANNOT be compressed/tokenized (token missing) */
    cmpLst[FT$env] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'Environment'-file. */
    decLst[FT$env] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'Environment'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert all definitions; Basis = 0x0000xxxx (0) */
    tok = new TSFleTok(153,"terrain_texslots",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(154,"terrain_texslot",'\u0013','\u0021'); /* String + 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(155,"terrain_uvcalcs",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(156,"terrain_uvcalc",'\u0031','\u0008'); /* 3 x UInt + Float(3)s */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(169,"world",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(170,"world_shader",'\u0013','\uA000'); /* String + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(171,"world_anim_shader",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(172,"world_anim_shader_framelen",'\u0018'); /* Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(173,"world_anim_shader_frames",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(174,"world_anim_shader_frame",'\uA000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(175,"world_anim_shader_frame_uvtiles",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(176,"world_anim_shader_frame_uvscroll",'\u0011','\u0019');
      /* UInt + Float(4) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(177,"world_anim_shader_frame_uvstamp",'\u0049'); /* 4 x Float(4) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(178,"world_fog_distance",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(179,"world_fog_day_colour",'\u0016'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(180,"world_fog_night_colour",'\u0016'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(181,"world_sky",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(182,"world_sky_layers",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(183,"world_sky_nlayers_behind_satellites",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(184,"world_sky_layer",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(185,"world_sky_layer_fadein",'\u002A'); /* 2 x Time */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(186,"world_sky_layer_fadeout",'\u002A'); /* 2 x Time */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(187,"world_sky_layer_top",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(188,"world_sky_layer_top_nfaces",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(189,"world_sky_layer_top_radius",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(190,"world_sky_layer_top_height",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(191,"world_sky_layer_edge",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(192,"world_sky_layer_edge_steps",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(193,"world_sky_layer_edge_step_height",'\u0018'); /* Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(194,"world_sky_layer_edge_step_radius",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(195,"world_sky_horizon",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(196,"world_sky_satellites",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(197,"world_sky_satellite",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(198,"world_sky_satellite_low_scale",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(199,"world_sky_satellite_high_scale",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(200,"world_sky_satellite_rise_time",'\u001A'); /* Time */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(201,"world_sky_satellite_dir_rise_colour",'\u0016'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(202,"world_sky_satellite_dir_high_colour",'\u0016'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(203,"world_sky_satellite_dir_set_colour",'\u0016'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(204,"world_sky_satellite_amb_rise_colour",'\u0016'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(205,"world_sky_satellite_amb_high_colour",'\u0016'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(206,"world_sky_satellite_amb_set_colour",'\u0016'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(207,"world_sky_satellite_rise_position",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(208,"world_sky_satellite_set_time",'\u001A'); /* Time */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(210,"world_sky_satellite_light");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(211,"world_sky_satellite_fog",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(212,"world_water",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(213,"world_water_wave_height",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(214,"world_water_wave_speed",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(215,"world_water_layers",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(216,"world_water_layer",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(217,"world_water_layer_height",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(218,"world_water_layer_sky_reflection",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(219,"world_precipitation",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(220,"world_precipitation_type",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(223,"world_precipitation_density",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(225,"world_precipitation_speed",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(229,"world_wind",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(230,"world_wind_layers",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(231,"world_wind_layer",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(232,"world_wind_layer_maxheight",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(233,"world_wind_layer_direction",'\u0032'); /* 3 x SInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(234,"world_wind_layer_speed",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(235,"world_wind_layer_turbulencep",'\u0017'); /* Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    /* Attention: The following definition is NOT included in 'mstoken' */
    tok = new TSFleTok(290,"world_water_terrain_patch_map",'\u0011','\u0813'); /* UInt + String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */

    /* -19- create definitions for type 'ssc': '*.dat = SoundSource' */
    cmpLst[FT$ssc] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'SoundSource'-file. */
    decLst[FT$ssc] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'SoundSource'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert all definitions; Basis = 0x0004xxxx (262144) */
    tok = new TSFleTok(262239,"FileName",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 95 */
    tok = new TSFleTok(262251,"Sound",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 107 */
    tok = new TSFleTok(263051,"Name",'\u0813'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 907 */

    /* -20- create definitions for type 'ttp': '*.ttp = Noise' */
    /* Attention: File CANNOT be compressed/tokenized */

    /* -21- create definitions for type 'car': '*.dat = CarSpawner' */
    /* Attention: File CANNOT be compressed/tokenized */

    /* -22- create definitions for type 'tgp': '*.dat = Forests' */
    /* Attention: File CANNOT be compressed/tokenized */

    /* -23- create definitions for type 'gty': '*.dat = Gantry' */
    cmpLst[FT$gty] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'Gantry'-file. */
    decLst[FT$gty] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'Gantry'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert all definitions; Basis = 0x0004xxxx (262144) */
    tok = new TSFleTok(262223,"Tr_GantryFile",'\uA000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 79 */
    tok = new TSFleTok(262239,"FileName",'\u0813'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 95 */
    tok = new TSFleTok(262936,"Separation",'\u0019'); /* Float4) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 792 */
    tok = new TSFleTok(262987,"Style",'\u0016'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 843 */
    tok = new TSFleTok(262988,"GantrySets",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 844 */
    tok = new TSFleTok(262989,"GantrySet",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 845 */
    tok = new TSFleTok(262990,"GantryTable",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 846 */
    tok = new TSFleTok(262991,"GantryTableEntry",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 847 */
    tok = new TSFleTok(262992,"Distance",'\u0017'); /* Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 848 */
    tok = new TSFleTok(263051,"Name",'\u0813'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 907 */

    /* -24- create definitions for type 'spp': '*.dat = Speedpost' */
    cmpLst[FT$spp] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'Speedpost'-file. */
    decLst[FT$spp] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'Speedpost'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert all definitions; Basis = 0x0004xxxx (262144) */
    tok = new TSFleTok(262974,"Speedpost_Set",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 830 */
    tok = new TSFleTok(262975,"Speed_Sign_Shape",'\u0013','\u8811','\u8009');
      /* String + UInt + Float(4)s */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 831 */
    tok = new TSFleTok(262976,"Speed_Warning_Sign_Shape",'\u0013','\u8811','\u8009');
      /* String + UInt + Float(4)s */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 832 */
    tok = new TSFleTok(262977,"Speed_Resume_Sign_Shape",'\u0013','\u8811','\u8009');
      /* String + UInt + Float(4)s */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 833 */
    tok = new TSFleTok(262978,"Speed_Digit_Tex",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 834 */
    tok = new TSFleTok(262979,"Milepost_Shape",'\u0013','\u8811','\u8009');
      /* String + UInt + Float(4)s */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 835 */
    tok = new TSFleTok(262980,"Milepost_Digit_Tex",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 836 */
    tok = new TSFleTok(262981,"Restricted_Shape",'\u0013','\u8811','\u8009');
      /* String + (optional) UInt + Float(4)s */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 837 */
    tok = new TSFleTok(262982,"End_Restricted_Shape",'\u0013','\u8811','\u8009');
      /* String + (optional) UInt + Float(4)s */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 838 */
    tok = new TSFleTok(262983,"Speed_Text_Size",'\u0037'); /* 3 x Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 839 */
    tok = new TSFleTok(262984,"Milepost_Text_Size",'\u0037'); /* 3 x Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 840 */
    tok = new TSFleTok(263051,"Name",'\u0813'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 907 */

    /* -25- create definitions for type 'tpl': '*.dat = TelePole' */
    cmpLst[FT$tpl] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'TelePole'-file. */
    decLst[FT$tpl] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'TelePole'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert all definitions; Basis = 0x0004xxxx (262144) */
    tok = new TSFleTok(262239,"FileName",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 95 */
    tok = new TSFleTok(262352,"Wire",'\u0038'); /* 3 x Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 208 */
    tok = new TSFleTok(262426,"Shadow",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 282 */
    tok = new TSFleTok(262933,"TPoleConfigData",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 789 */
    tok = new TSFleTok(262934,"TPoleConfig",'\u0011','\u2000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 790 */
    tok = new TSFleTok(262936,"Separation",'\u0019'); /* Float4) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 792 */

    /* -26- create definitions for type 'haz': '*.haz = Hazard' */
    cmpLst[FT$haz] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'Hazard'-file. */
    decLst[FT$haz] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'Hazard'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert definitions with Basis: 0x0004xxxx (262144) */
    tok = new TSFleTok(262219,"Tr_Worldfile",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 75 */
    tok = new TSFleTok(262239,"FileName",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 95 */
    tok = new TSFleTok(262343,"Speed",'\u0017'); /* Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 199 */
    tok = new TSFleTok(262992,"Distance",'\u0017'); /* Float(2) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 848 */
    tok = new TSFleTok(263001,"Idle_Key",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 857 */
    tok = new TSFleTok(263002,"Idle_Key2",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 858 */
    tok = new TSFleTok(263003,"Surprise_Key_Left",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 859 */
    tok = new TSFleTok(263004,"Surprise_Key_Right",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 860 */
    tok = new TSFleTok(263005,"Success_Scarper_Key",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 861 */
    tok = new TSFleTok(263006,"Fail_Scarper_Key",'\u0021'); /* 2 x UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 862 */
    tok = new TSFleTok(263100,"Workers",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 956 */

    /* -27- create definitions for type 'mkr': '*.mkr = Marker' */
    cmpLst[FT$mkr] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'Marker-file'. */
    decLst[FT$mkr] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'Marker-file'. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert definitions with Basis: 0x0004xxxx (262144) */
    tok = new TSFleTok(262813,"Marker",'\u082B','\u0013','\u0011');
      /* floatstruint: 2 x Float(6) + String + UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 669 */

    /* -28- create definitions for type 'ref': '*.ref = Reference' */
    cmpLst[FT$ref] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'Reference'-file. */
    decLst[FT$ref] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'Reference'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert all definitions; Basis = 0x0004xxxx (262144) */
    tok = new TSFleTok(262147,"Static",'\u2000'); /* Token(s) 3 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262150,"Dyntrack",'\u2000'); /* Token(s) 6 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262152,"Forest",'\u2000'); /* Token(s) 8 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262153,"Telepole",'\u2000'); /* Token(s) 9 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262200,"Gantry",'\u2000'); /* Token(s) 56 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262201,"CarSpawner",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 57 */
    tok = new TSFleTok(262203,"Pickup",'\u2000'); /* Token(s) 59 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262204,"Platform",'\u2000'); /* Token(s) 60 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262205,"Siding",'\u2000'); /* Token(s) 61 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262206,"LevelCr",'\u2000'); /* Token(s) 62 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262207,"Transfer",'\u2000'); /* Token(s) 63 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262208,"Speedpost",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 64 */
    tok = new TSFleTok(262209,"Hazard",'\u2000'); /* Token(s) 65 */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    tok = new TSFleTok(262239,"FileName",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 95 */
    tok = new TSFleTok(262246,"StoreMatrix");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 102 */
    tok = new TSFleTok(262332,"Class",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 188 */
    tok = new TSFleTok(262333,"Align",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 189 */
    tok = new TSFleTok(262338,"TunnelEntrance");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 194 */
    tok = new TSFleTok(262425,"NoDirLight",'\u8011'); /* UInt(o) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 281 */
    tok = new TSFleTok(262426,"Shadow",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 282 */
    tok = new TSFleTok(262956,"PickupType",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 812 */
    tok = new TSFleTok(263052,"Description",'\u0813'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 908 */

    /* -29- create definitions for type 'con': '*.con = Consist' */
    cmpLst[FT$con] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'Consist'-file. */
    decLst[FT$con] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'Consist'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert all definitions; Basis = 0x0004xxxx (262144) */
    tok = new TSFleTok(262157,"Wagon",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 13 */
    tok = new TSFleTok(262158,"Engine",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 14 */
    tok = new TSFleTok(262159,"Train",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 15 */
    tok = new TSFleTok(262234,"TrainCfg",'\u0013','\u2000'); /* String + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 90 */
    tok = new TSFleTok(262252,"UiD",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 108 */
    tok = new TSFleTok(262502,"MaxVelocity",'\u082B'); /* 2 x Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 358 */
    tok = new TSFleTok(262786,"WagonData",'\u0023'); /* 2 x String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 642 */
    tok = new TSFleTok(262787,"EngineData",'\u0023'); /* 2 x String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 643 */
    tok = new TSFleTok(262793,"Flip"); /* -none- */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 649 */
    tok = new TSFleTok(262795,"NextWagonUID",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 651 */
    tok = new TSFleTok(262796,"Durability",'\u081B'); /* Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 652 */
    tok = new TSFleTok(263051,"Name",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 907 */
    tok = new TSFleTok(263316,"Serial",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1172 */

    /* -30- create definitions for type 'shc': '*.sd = ShapeCtl' */
    cmpLst[FT$shc] = cmp = new HashMap<String,TSFleTok>();
      /* create table for compress of 'ShapeCtl'-file. */
    decLst[FT$shc] = dec = new HashMap<Integer,TSFleTok>();
      /* create table for decompress of 'ShapeCtl'-file. */
    cmp.put(tok1.getName().toLowerCase(),tok1); /* compress */
    dec.put(tok1.getKey(),tok1); /* insert for decompress */
    /* insert all definitions; Basis = 0x0000xxxx (0) */
    tok = new TSFleTok(71,"Shape",'\u0013','\uA000'); /* String + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */
    /* insert all definitions; Basis = 0x0004xxxx (262144) */
    tok = new TSFleTok(262937,"ESD_Bounding_Box",'\u8008'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 793 */
    tok = new TSFleTok(262938,"ESD_Tunnel",'\u0001'); /* UInt's */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 794 */
    tok = new TSFleTok(262939,"ESD_Complex_Box",'\r'); /* Float(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 795 */
    tok = new TSFleTok(262940,"ESD_Complex",'\u0011','\uA000'); /* UInt + Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 796 */
    tok = new TSFleTok(262941,"ESD_Sphere",'\u004D'); /* 4 x Float(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 797 */
    tok = new TSFleTok(262942,"ESD_Alternative_Texture",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 798 */
    tok = new TSFleTok(262944,"ESD_Detail_Level",'\u0012'); /* SInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 800 */
    tok = new TSFleTok(262945,"ESD_No_Visual_Obstruction");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 801 */
    tok = new TSFleTok(262946,"ESD_Snapable");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 802 */
    tok = new TSFleTok(262947,"ESD_Software_Dlev",'\u0012'); /* SInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 803 */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSFileX() /* create file-control (Dummy) */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* Initialize required objects */
    Type  = "?"; /* set type to 'unknown' */
    /* all (other) values are set to 'null'/0 by default */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSFileX( /* create file-control for file-access */
   int  ix,  /* index of file-ID */
   File dat) /* File-definition */
   {
    super(dat); /* set Values using parent (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Type  = "?"; /* set type to 'unknown' (default) */
    if(ix<minIx || ix>=NrRef) return; /* invalid index -- do not init. */
    /* Initialize required objects */
    FKngU = FDef[ix][0]; /* activate appropriate ID (T) */
    FKngB = FDef[ix][1]; /* activate appropriate ID (B) */
    Type  = FDef[ix][2]; /* activate appropriate file-type */
    ccmp  = cmpLst[ix];  /* activate appropriate compress-def's */
    cdec  = decLst[ix];  /* activate appropriate decompress-def's */
    /* all (other) values are set to 'null'/0 by default */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkFKng"
  * Check File-Identifier for current type of file.
  * If argument is 'null', the full key is provided (for write).
  * ##chkFKng.TSFileX (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String chkFKng( /* process file-identifier */
   String  K, /* current value or 'null' for delivery-request */
   boolean t) /* Type of header (true-> binary(14 bytes)) */
   {
   /*-----------------------------------------------------------------*/
    String cK; /* current Key */
   /*=================================================================*/
    cK = t ? FKngB : FKngU; /* select requested file-Identifier */
    if(cK==null)  return K; /* format NOT supported -- error */
      /* An error will also be re turned if class is not initialized */
    if(K==null) return(cK); /* provide requested file-ID */
    /* check file-identifier */
    if(K.equals(cK)) return(null); /* identifier is OK */
    if(K.length()<8) return TSLogg.getMsg("TSFle0X4",K,Type);
    return TSLogg.getMsg("TSFle0X1",K,Type); /* return Message */
  }

 /**. <pre>
  *=====================================================================
  * Method "getDesc"
  * Get description of referenced file-(-type) according to 
  *   unambigous number. (datattype='false')
  * Returns default 'regular expression' to select files if
  *   datattype(dt) is 'true'.
  * If index/number is NOT valid, 'null' is returned.
  * ##getDesc.TSFileX (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final static String getDesc( /* return description */
   int     nr, /* unambigous number of file(-type) */
   boolean dt) /* type of requested data */ 
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<minIx || nr>=NrRef) return null; /* invalid number */
    return FDef[nr][dt?4:3]; /* return requested data */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTok" (version 'expand')
  * Get current definition of token from table (key=number)
  * ##getTok.TSFileX (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSFleTok getTok( /* read token-definition from table */
   int nr) /* Number is key of token */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(FKngU==null) return null; /* class not initialized -- error */
    if(nr<0) nr = Math.max(-32,nr); /* use allowed range */ 
    else nr &= 0x0FFFFFF; /* mask number (3 bytes = 0..16777215 */
      /* allow a 'special request' marked by a negative key */
    return cdec.get(new Integer(nr)); /* provide Token from curr. map */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTok" (version 'reduce')
  * Get current definition of token from table (key=name)
  * ##getTok.TSFileX (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSFleTok getTok( /* read token-definition from table */
   String nme) /* Name is key of token */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(FKngU==null) return null; /* class not initialized -- error */
    nme = nme.toLowerCase(); /* lower chars (new String is build) */
//    if(ccmp.get(nme)==null) throw new  /* Token not implemented */
//      IllegalStateException(TSLogg.getMsg("Msg907","getTok.TSFileX",nme));
    return ccmp.get(nme); /* provide Token from current map */
  }

 /**. <pre>
  *=====================================================================
  * Method "open"
  * Open file and create Reader or Writer.
  * If 'input' is requested: check input-mode of file
  *  All modes/formats are supported for 'input'!
  * Method returns an error-message or 'null' if no error.
  * This method overwrites 'open'-function from TSFile-class.
  * !!! ONLY UT-format is used as output for THIS filetype!!!
  * ATTENTION: Within open-processing 'chkFKng()' is called.
  * ##open.TSFileX (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String open( /* open 'normal' text-file */
   boolean out) /* 'Output' requested (if 'true') */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(FKngU==null) return TSLogg.getMsg("TSFle0X2",Type); /* error */
    if(out) return super.open(TSFile.OUT); /* use super-class function */
    return super.open(TSFile.IN); /* use super-class function */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build an String-representation of all values of this class.
  * ##toStr.TSFileX (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* get string-Representation */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    return "TSFileX{"+super.toStr() + ",'" +
           FKngU + "','" + FKngB + "','" + Type + "'}";
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSFile$trk -- Common access to '*.trk'-files
 * This class provides access to TS route-control-files in the same
 *     way as access to S-/T- or W-Files is used.
 * Input: File-ID is read and checked.
 * Output: Correct File-ID is added automatically.
 * Attention: File is NORMALLY written using UT-Format. However, all
 *            other formats are possible and supported.
 * ##TSFile$trk (Eyecatcher)
 *=======================================================================
 </pre>*/
class TSFile$trk extends TSFile { /* Access of '*.trk'-files */
 /*-------------------------------------------------------------------*/
  public  static final String   IdStr = " 3.7.00 01.05.2012";
 /*-------------------------------------------------------------------*/
  private static final String[] FKngU = { /* Identifier for '.trk'-file */
    "SIMISA@@@@@@@@@@JINX0r0t______","SIMISA@@@@@@@@@@JINX0r1t______"};
    /* valid UNICODE-ID's of '*.trk'-file(s) */
  private static final String[] FKngB = { /* BINARY-ID's of '.trk'-file */
    "JINX0r0b______","JINX0r1b______"};
 /*-------------------------------------------------------------------*/
  private static HashMap<String,TSFleTok>  cmp; /* Keymap for Compr. */
  private static HashMap<Integer,TSFleTok> dec; /* Keymap for Decompr. */
  private static TSFleTok       tok;    /* create entry for keymaps */
 /*-------------------------------------------------------------------*/
  private int                   IdT; /* current ID-Type (-1,0..1) */
 /**. <pre>
  *=====================================================================
  * Constructor: (0) Create static definitions
  *=====================================================================
  </pre>*/
  static { /* Perform static initialisations */
    cmp = new HashMap<String,TSFleTok>();  /* create table for compr. */
    dec = new HashMap<Integer,TSFleTok>(); /* create table for decompr. */
    /* insert comment-definition */
    tok = TSFile.tok1; /* global definition for comment-token */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */

    /* insert all definitions; Basis = 0x0004xxxx (262144) */
    tok = new TSFleTok(262227,"Tr_RouteFile",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 83 */
    tok = new TSFleTok(263050,"RouteID",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 906 */
    tok = new TSFleTok(263051,"Name",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 907 */
    tok = new TSFleTok(263052,"Description",'\u078F'); /* String(+) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 908 */
    tok = new TSFleTok(262235,"Graphic",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 91 */
    tok = new TSFleTok(263076,"LoadingScreen",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 932 */
    tok = new TSFleTok(262239,"FileName",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 95 */
    tok = new TSFleTok(263053,"Electrified",'\u0016'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 909 */
    tok = new TSFleTok(263054,"Mountains",'\u0016'); /* Hex(8) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 910 */
    tok = new TSFleTok(263055,"OverheadWireHeight",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 911 */
    tok = new TSFleTok(263056,"PassengerRuleSet",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 912 */
    tok = new TSFleTok(263057,"FreightRuleSet",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 913 */
    tok = new TSFleTok(263058,"SignalSet",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 914 */
    tok = new TSFleTok(262989,"GantrySet",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 845 */
    tok = new TSFleTok(263059,"TrackGauge",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 915 */
    tok = new TSFleTok(263060,"Era",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 916 */
    tok = new TSFleTok(262342,"SpeedLimit",'\u0019'); /* Float(4) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 198 */
    tok = new TSFleTok(263061,"Environment",'\u2000'); /* Token(s) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 917 */
    tok = new TSFleTok(263062,"SpringClear",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 918 */
    tok = new TSFleTok(263063,"SpringRain",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 919 */
    tok = new TSFleTok(263064,"SpringSnow",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 920 */
    tok = new TSFleTok(263065,"SummerClear",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 921 */
    tok = new TSFleTok(263066,"SummerRain",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 922 */
    tok = new TSFleTok(263067,"SummerSnow",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 923 */
    tok = new TSFleTok(263068,"AutumnClear",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 924 */
    tok = new TSFleTok(263069,"AutumnRain",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 925 */
    tok = new TSFleTok(263070,"AutumnSnow",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 926 */
    tok = new TSFleTok(263071,"WinterClear",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 927 */
    tok = new TSFleTok(263072,"WinterRain",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 928 */
    tok = new TSFleTok(263073,"WinterSnow",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 929 */
    tok = new TSFleTok(263074,"TerrainErrorScale",'\u0018'); /* Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 930 */
    tok = new TSFleTok(263075,"RouteStart",'\u0022','\u0028'); /* 2 x SInt + 2 x Float(3) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 931 */
    tok = new TSFleTok(263077,"MilepostUnitsMiles");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 933 */
    tok = new TSFleTok(263078,"MilepostUnitsKilometers");
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 934 */
    tok = new TSFleTok(263079,"MaxLineVoltage",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 935 */
    tok = new TSFleTok(263080,"DefaultSignalSMS",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 936 */
    tok = new TSFleTok(263081,"DefaultCrossingSMS",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 937 */
    tok = new TSFleTok(263082,"DefaultWaterTowerSMS",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 938 */
    tok = new TSFleTok(263083,"DefaultCoalTowerSMS",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 939 */
    tok = new TSFleTok(263084,"DefaultDieselTowerSMS",'\u0013'); /* String */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 940 */
    tok = new TSFleTok(263085,"TempRestrictedSpeed",'\u001B'); /* Float(6) */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 941 */
    tok = new TSFleTok(263380,"GravityScale",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1236 */
    tok = new TSFleTok(263381,"DerailScale",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1237 */
    tok = new TSFleTok(263382,"TimetableTollerance",'\u0011'); /* UInt */
     cmp.put(tok.getName().toLowerCase(),tok); /* insert for compress */
     dec.put(tok.getKey(),tok); /* insert for decompress */ /* 1238 */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSFile$trk() /* create file-control (Dummy) */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* Initialize required objects */
    IdT = -1; /* no identifier-type known */
    /* all (other) values are set to 'null'/0 by default */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSFile$trk( /* create file-control for file-access */
   File dat) /* File-definition */
   {
    super(dat); /* set Values using parent (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* Initialize required objects */
    IdT = -1; /* no identifier-type known */
    /* all (other) values are set to 'null'/0 by default */
  }

 /**====================================================================
  * Method "chkFKng"
  * Check File-Identifier for current type of file.
  * If argument is 'null', the full key is provided (for write).
  * ##chkFKng.TSFile$trk (Eyecatcher)
  ====================================================================*/
  protected final String chkFKng( /* process file-identifier */
   String  K, /* current value or 'null' for delivery-request */
   boolean t) /* Type of header (true-> binary(14 bytes)) */
   {
   /*-----------------------------------------------------------------*/
    String[] cK; /* current Key-Array */
   /*=================================================================*/
    if(K==null) { /* provide requested file-ID */
      if(IdT<0) return null; /* file-ID is not valid -- signal it */
      return t ? FKngB[IdT] : FKngU[IdT];
        /* select requested file-IDentifier and return it */
    } /* provide file-ID was requested */

    /* check file-identifier */
    cK = t ? FKngB : FKngU; /* select file-IDentifier-Array */
    for(IdT=0;IdT<cK.length;IdT+=1) /* all available file-ID's */
      if(K.equals(cK[IdT])) return null; /* identifier is OK */
    IdT = -1; /* invalidate identifier-type */
    if(K.length()<8) return TSLogg.getMsg("TSFle0X4",K,"trk");
    return TSLogg.getMsg("TSFle0X1",K,".trk"); /* return Message */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTok" (version 'expand')
  * Get current definition of token from table (key=number)
  * ##getTok.TSFile$trk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSFleTok getTok( /* read token-definition from table */
   int nr) /* Number is key of token */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(nr<0) nr = Math.max(-32,nr); /* use allowed range */ 
    else nr &= 0x0FFFFFF; /* mask number (3 bytes = 0..16777215 */
      /* allow a 'special request' marked by a negative key */
    return dec.get(new Integer(nr)); /* provide Token */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTok" (version 'reduce')
  * Get current definition of token from table (key=name)
  * ##getTok.TSFile$trk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSFleTok getTok( /* read token-definition from table */
   String nme) /* Name is key of token */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    nme = nme.toLowerCase(); /* lower chars (new String is build) */
    return cmp.get(nme); /* provide Token */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTyp"
  * Provides current identifier-type (if available).
  * ##getTyp.TSFile$trk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getTyp() /* provides current ID */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    return IdT; /* answer with current ID or '-1' */
  }

 /**. <pre>
  *=====================================================================
  * Method "setTyp"
  * Activate an identifier-type for writing.
  * Method provides an error-Message or 'null' if no error.
  * ##setTyp.TSFile$trk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String setTyp( /* provides/establishes current ID */
   int id) /* new type */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    if(id<0 || id>=FKngU.length) /* id has invalid range */
      return TSLogg.getMsg("TSFle0X3",".trk",id,FKngU.length-1);
    IdT = id; /* activate new ID */
    return null; /* return: no error */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build an String-representation of all values of this class.
  * ##toStr.TSFile$trk (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* get string-Representation */
   {
   /*-----------------------------------------------------------------*/
    String rs; /* String for result */
    int    i;  /* temp value (indices) */
   /*=================================================================*/
    rs = "TSFile$trk{" + super.toStr() + "-" + FKngU.length + "[";
    for(i=0;i<FKngU.length;i+=1) { /* check all Identifier-Types */
      if(i>0) rs += ","; /* insert separator */
      rs += "'" + FKngU[i] + "'('" +  FKngB[i] + "')"; /* add file-ID */
    } /* check all Identifier-Types */
    rs += "]-'.trk'(" + IdT + ")}";
    return rs; /* return result */
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSFile$td -- Common access to '.td' files
 *   This class provides access to '.td'/'.tdl' TS-Files in the same
 *     way as access to S-/T- or W-Files is used.
 *   Input: File-ID is read and checked.
 *   Output: Correct File-ID is added automatically.
 * Attention: File is written using UB-Format. No other format is
 *            supported.
 * ##TSFile$td (Eyecatcher)
 *=======================================================================
 </pre>*/
class TSFile$td extends TSFile { /* Access of '.td'/'.tdl'-Files */
 /*-------------------------------------------------------------------*/
  public  static final String   IdStr = " 3.7.00 01.05.2012";
 /*-------------------------------------------------------------------*/
//  private static final String   FKngU = /* Identifier for .tdx-file */
//    /* UNICODE-ID */            "SIMISA@@@@@@@@@@JINX0d1t______";
  private static final String   FKngB = "JINX0d1b______"; /* BIN-ID */
  private static final byte[]   Prfx  = /* prefix for '*.td'/'*.tdl' */
                    {-124,0,0,0,-1,-1,-1,-1,0,-121,0,0,0,-1,-1,-1,-1,0};
 /*-------------------------------------------------------------------*/
  private TSByteArrIO           BIO;    /* current binary IO-buffer */
  private int                   EoP;    /* start-position of data
                                         * (End of Prefix)  */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSFile$td() /* create file-control (Dummy) */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all (other) values are set to 'null'/0 by default */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSFile$td( /* create file-control for file-access */
   File dat) /* File-definition */
   {
    super(dat); /* set Values using parent (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all (other) values are set to 'null'/0 by default */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkFKng"
  * Check File-Identifier for current type of file.
  * If argument is 'null', the full key is provided (for write).
  * ##chkFKng.TSFile$td (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String chkFKng( /* process file-identifier */
   String  K, /* current value or 'null' for delivery-request */
   boolean t) /* Type of header (true-> binary(14 bytes)) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
//    String cK; /* current Key */
   /*=================================================================*/
    if(!t) return K; /* format is NOT supported -- return error */
    if(K==null) return(FKngB); /* provide requested file-ID */
    if(K.equals(FKngB)) return(null); /* identifier is OK */
    if(K.length()<8) return TSLogg.getMsg("TSFle0X4",K,".td(l)");
    return TSLogg.getMsg("TSFle0X1",K,".td(l)"); /* return Message */

//    cK = t ? FKngB : FKngU; /* select requested file-IDentifier */
//    if(K==null) return(cK); /* provide requested file-ID */
//    /* check file-identifier */
//    if(K.equals(cK)) return(null); /* identifier is OK */
//    if(K.length()<8) return TSLogg.getMsg("TSFle0X4",K,".td(l)");
//    return TSLogg.getMsg("TSFle0X1",K,".td(l)"); /* return Message */
  }

 /**. <pre>
  *=====================================================================
  * Method "close"
  * This method completes the file-structure and closes the file.
  *
  * Attention: File must be opened for 'output', which is checked
  *   using value of 'EoP', which must be greater than '14'.
  * This method overwrites 'close'-function from TSFile-class.
  * ##close.TSFile$td (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String close() /* finalize and close file */
   {
   /*-----------------------------------------------------------------*/
    int i; /* current length of file */
   /*=================================================================*/
    if(EoP<14) throw new /* terminate (systemerror) */
      IllegalStateException(TSLogg.getMsg("Msg904","TSFile$td.close()"));

    /* complete file-struecture of created file */
    i = BIO.size() - 54; /* compute length of whole file without prefix */
    BIO.putInt(i,4,EoP); /* and insert it to buffer */
    i += 5; /* compute second value */
    BIO.putInt(i,4,EoP-5); /* and insert it, too */
    i += 9; /* compute third value */
    BIO.putInt(i,4,EoP-14); /* and insert it */

    /* now: write file and close it */
    return super.close(); /* close file again using 'TSFile'-class */
  }

 /**. <pre>
  *=====================================================================
  * Method "load"
  * Open '.td'/'.tdl'-file for input and establish 'BIO' as IO-buffer.
  *   Load complete file into binary buffer and close file again.
  * Attention: This method ALSO skips a prefix of 18 bytes within
  *            buffer just read.
  * ##load.TSFile$td (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String load( /* load complete '.td'/'.tdl'-file */
   TSByteArrIO cB) /* binary IO-buffer */
   {
   /*-----------------------------------------------------------------*/
    String s; /* current message */
   /*=================================================================*/
    if(super.setBuffer(cB)) throw new /* terminate (systemerror) */
      IllegalStateException(TSLogg.getMsg("Msg904","TSFile$td.load()"));
    BIO = cB; /* save current I/O-buffer (not used until now) */
    if((s=super.open(TSFile.IUB))!=null) return s; /* error ? */
      /* open input, read and check format and read complete file into
       * memory -- return message if error was found
       */
    cB.skip(18); /* skip prefix of (already read) data */
    return super.close(); /* close input-file again */
      /* and return 'null' if file was successfully loaded */
  }

 /**. <pre>
  *=====================================================================
  * Method "open"
  * Open file for OUTPUT and create Writer.
  * Write file-ID using mode UB (file is a binary object)
  *
  * Method returns an error-message or 'null' if no error.
  * ATTENTION: - Within open-processing 'chkFKng()' is called.
  *            - This method is ONLY used for OUTPUT. Open-Input is
  *               implemented into 'load'-call.
  * ##open.TSFile$td (Eyecatcher)
  *=====================================================================
  </pre>*/
  public final String open( /* open '.td'/'.tdl'-file for output */
   TSByteArrIO cB) /* binary IO-buffer */
   {
   /*-----------------------------------------------------------------*/
    String s; /* current message */
   /*=================================================================*/
    if(super.setBuffer(cB)) throw new /* terminate (systemerror) */
      IllegalStateException(TSLogg.getMsg("Msg904","TSFile$td.open()"));
    BIO = cB; /* save current I/O-buffer */
    s = super.open(TSFile.OUB); /* open UB-Output, write file-ID */
    if(s!=null) return s; /* error was found -- terminate method */
    BIO.putBytes(Prfx); /* write prefix of file, */
    EoP = BIO.size(); /* save start-position of data */
    BIO.putInt(-1,4); /* and write temorary length of file */
    return null; /* OK, file is operational */
  }

 /**. <pre>
  *=====================================================================
  * Method "open"
  * This method-call blocks super-class function 'open'.
  * Method throws an exception to terminate with a systemerror.
  * This method overwrites 'open'-function from TSFile-class.
  * ##open.TSFile$td (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String open( /* open 'TSFile' */
   int iom) /* requested 'Input'/'Output' - Mode */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    throw new IllegalStateException( /* method NOT valid here */
      TSLogg.getMsg("Msg906","TSFile$td.open(int)"));
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build an String-representation of all values of this class.
  * ##toStr.TSFile$td (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* get string-Representation */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    return "TSFile$td{"+super.toStr()+",'"+FKngB+"'}";
//    return "TSFile$td{"+super.toStr()+",'"+FKngU+"','"+FKngB+"'}";
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSFleTok -- Definition of a file-token-pattern.
 * TSFleTok-definition are used to code or decode token of various
 *   files.
 *
 * A token, as it is used within the data-files, consist of:
 *   - a token-ID (unsigned int(4-LittleEndian))
 *   - a length-field (unsigned int(4-LE))
 *   - a label-length-field (unsigned byte)
 *   - an optional label (unicode-string) if label-length > 0
 *   - various number of token-items (including complete other token)
 *       until length is exhausted
 *
 * Each token contains a list of 'type-definitions', which selects
 *   the datatype, which is expected to be used. So every sequence
 *   of data-items can be defined. Such a data-item can be:
 *    + UInt   - an unsigned integer-value
 *    + SInt   - a signed integer-value
 *    + String - a string of any length (0..65535)
 *    + Hex    - an unsigned integer-value expressed as a hexadecimal
 *    + Float  - a floatingpoint-value of single precision
 *    + Byte   - a signed byte-value with decimal format
 *    + Time   - a unsigned integer which specifies a time-value
 *    + Loop   - an item to control 'virtual token' (see down)
 *
 *   Float- and Hex-values can be formatted to different
 *   sizes/precisions. However, 4 bytes are used to store them.
 * A 'type-definitions' also contains some options, which define the
 *   relationship between such definitons. It also states, if such
 *   a type is 'optional' and can be omitted.
 * Data-items of the same type can be grouped together within a
 *   single 'type-definition'. Then, the 'Repeat-value' is set to a
 *   value greater than '1'. Even the feature 'until end' can be
 *   expressed by using '0' as the repeat-value. If this feature is
 *   used, the data-item must be the last one within the itemlist.
 * If a 'type-definition' is marked as 'optional', the 'Repeat-value'
 *   changes to a 'Precondition'. This condition defines the minimum
 *   number of items that must follow, so that the current optional
 *   item can be present.
 *   Attention: An optional entry with a precondition of '0' is processed
 *              as a 'until-end'-definition (normally NOT optional) which
 *              DOES NOT require an existend item.
 * A token also contains some attributes, which describe the
 *   relationship to other token. Such an attribute marks the token as
 *   a 'comment'-token, which changes the way how items are parsed.
 *   (Until now, this is the only attribute.)
 *
 * A token may also be a 'Virtual Token', which is a set/group of
 *   type-definitions which are NEITHER surrounded by brackets nor
 *   prefixed by a tokenname and / or label.
 *   Together with a 'Loop'-item, it is possible to define a repeated
 *   set of different type-definitions.
 *   A 'Virtual Token' is marked by a negative key-number and is ONLY
 *   included in the 'decompress'-list of the tokens.
 *   Attention: A 'virtual token' MUST NOT contain features like
 *              'until end' because these features prevend the token
 *              from terminating after a fixed number of steps. Then,
 *              the surrounding token never becomes active again.
 * ##TSFleTok (Eyecatcher)
 *======================================================================
 </pre>*/
class TSFleTok implements Serializable { /* File-Token-Definitions */
 /*-------------------------------------------------------------------*/
  public  static final String IdStr = " 3.7.00 06.05.2012";
 /*-------------------------------------------------------------------*/
  private final int           Id;     /* ID-number of Token */
  private final boolean       Cmt;    /* current Token is 'comment' */
  private final String        Name;   /* Name of Token */
  private final char[]        TypS;   /* Sequence of Types */
    /* Remark to 'Comment (Cmt):
     *         On every position within the data, where a token may
     *           start, a comment-token may be inserted und must be
     *           recognized.
     * Defintion of a type-entry ('TypS'):
     *   Datatype is 'char' so 16 bits are available (due to unicode).
     *   Definition-schema 0:
     *     0..3   - Type of entry (see below)
     *     4..10  - Repeat-value (0..127) / Precondition
     *              if 'Value==0' then ==> Repeat type until end of token
     *    11 (F4) - Option depends on type of entry (see below)
     *    12 (F3) - Option: Switch to new line before advance (expand)
     *    13 (F2) - Option: Switch to new line before type-def. (expand)
     *    14 (F1) - Option: Multiply repeat-value with group-counter
     *    15      - Option: Type is optional ('Precondition' used)
     *   Definition-schema 1:
     *     0..3   - Type of entry (12)
     *     4..8   - Repeat-value (0..31)
     *              if 'Value==0' then ==> Repeat type until end of token
     *     9..13  - Relative Number (rN) of virtual Token-definition (0..31)
     *              Real number of virtual Token-definition is: -1 - rN
     *    14 (F1) - Option: Multiply repeat-value with group-counter
     *    15      - Option: Type is optional ('Precondition' used)
     *   Definition-schema 2:
     *     0..3   - Type of entry (15)
     *     4..14  - maximum length of line (0..2047)
     *    15      - Option: Type is optional ('Precondition' is set to '1')
     * Types of entries are (definition-schema is 0=default):
     *    0 - Embedded Token
     *          Option (F4): Suppress CRLF after embedded token (expand)
     *    1 - UInt
     *          Option (F4): Establish FIRST UInt-value as group-counter
     *    2 - SInt
     *          Option (F4): Establish FIRST SInt-value as group-counter
     *    3 - String
     *          Option (F4): Add Quotes around String in any case
     *    4 - Hex(2)
     *          Option (F4): Use uppercase character within hex-value
     *    5 - Hex(4)
     *          Option (F4): Use uppercase character within hex-value
     *    6 - Hex(8)
     *          Option (F4): Use uppercase character within hex-value
     *    7 - Float(2)
     *          Option (F4): Extend mantisse to requested number of digits
     *    8 - Float(3)
     *          Option (F4): Extend mantisse to requested number of digits
     *    9 - Float(4)
     *          Option (F4): Extend mantisse to requested number of digits
     *   10 - Time-Format (xx:xx:xx = UInt)
     *          Option (F4): DO NOT include seconds within time (expand)
     *   11 - Float(6)
     *          Option (F4): Extend mantisse to requested number of digits
     *   12 - Loop-Control (uses definition-schema 1)
     *          No variable option available
     *   13 - Float(8)
     *          Option (F4): Extend mantisse to requested number of digits
     *   14 - Byte-Integer
     *          Option (F4): Load repeat-counter with provided value (+1)
     *   15 - (One) Splittable String (uses definition-schema 2)
     *          No variable option available
     * Attention: If 'Precondition' is active, the optional item
     *            itself must be included within count. So, if (e.g)
     *            ONE another item should follow the optional one, the
     *            precondition must be set to '2'.
     */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSFleTok() /* Create Dummy-Definition of Token */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* Attention: Due to attribute 'final' ALL varaiables must be
     *            explicitely initialized.
     */
    Id   = 16777216;    /* store dummy (invalid) token-definition */
    Name = null;        /* set name of keyword */
    Cmt  = false;       /* token-definition is NOT a comment */
    TypS = new char[1]; /* initialize to default type-array */
    TypS[0] = '\u0000'; /* initialize to 'Embedded token until end' */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Basic-Entry (complete)
  *=====================================================================
  </pre>*/
  protected TSFleTok( /* create Token-Definition for files */
   int     id,  /* ID-Value of Token */
   String  nme, /* Token-name */
   boolean cmt, /* 'true' if token is a 'Comment-Definition' */
   char... td)  /* type-definitions of this token */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Id   = id;  /* store provided values into token-definition */
    Name = nme; /* set name of keyword */
    Cmt  = cmt; /* transfer comment-option */
    TypS = td;  /* transfer current type-definitions */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create Extended-Entry (option default to 'false')
  *=====================================================================
  </pre>*/
  protected TSFleTok( /* create Token-Definition for files */
   int     id,  /* ID-Value of Token */
   String  nme, /* Token-name */
   char... td)  /* type-definitions of this token */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Id   = id;    /* store provided values into token-definition */
    Name = nme;   /* set name of keyword */
    Cmt  = false; /* token-definition is NOT a comment */
    TypS = td;    /* transfer current type-definitions */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (4) Create entry from template
  *=====================================================================
  </pre>*/
  protected TSFleTok( /* create Token-Definition for files */
   TSFleTok cT) /* current Token-template */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Id   = cT.Id;   /* copy provided values into token-definition */
    Name = cT.Name; /* copy name of keyword */
    Cmt  = cT.Cmt;  /* copy comment-option */
    TypS = cT.TypS; /* copy current type-definitions */
  }

 /**. <pre>
  *=====================================================================
  * Method "getKey"
  * Provide current key as Integer-Object.
  * (Method is also used for initialization)
  * ##getKey.TSFleTok (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Integer getKey() /* provide current key */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return new Integer(Id); /* return ID as an Integer-object */
  }

 /**. <pre>
  *=====================================================================
  * Method "getName"
  * Answer request for current name of token.
  * (Method is also used for initialization)
  * ##getName.TSFleTok (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getName() /* request for name of token */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    return Name; /* return name of token or 'null' */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTyp"
  * Provide current/new type-definition from list.
  * ##getTyp..TSFleTok (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getTyp( /* get or modify value */
   int ix) /* index of selected element */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(ix<0 || ix>=TypS.length) return -1; /* index out of order */
    return (int)(TypS[ix]); /* return selected value as 'int' */
  }

 /**. <pre>
  *=====================================================================
  * Method "isCmt"
  * Returns Info if Token describes a 'Comment'.
  * ##isCmt.TSFleTok (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean isCmt() /* Token describes a comment */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Cmt; /* return value as per flag */
  }

 /**. <pre>
  *=====================================================================
  * Method "isVT"
  * Returns Info if definition is a 'Virtual Token'.
  * A'virtual token' is a set of type-definitions, which are NEITHER
  *  surrounded by brackets nor prefixed by a tokenname and / or label.
  * A'virtual token' is marked by a negative key.
  * ##isVT.TSFleTok (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean isVT() /* 'Virtual Token'? */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Id<0; /* return value as per token-ID */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSFleTok (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSFleTok{"+Id+",'"+Name+"','"+Cmt+"',"+TypS.length+"[]}";
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSFleStack - Hold iteration-values for expand/reduce
 * This class is used to save values if expand/reduce enters an
 *   embeded or a virtual token. So no restriction about 'size' is
 *   given.
 * This class also holds a counter, which is filled with the
 *   values from the connected token-definition and which can be
 *   modified independently. This includes a reload with a new value.
 *
 * The state of this class describes the NEXT item, which is required
 * from input and must be processed. Such an item may also be a new
 * 'embedded token'. If it was found, the state of this class can be
 * 'advanced' to the next type-definition of the current token
 * (or to EOT).
 * ##TSFleStack (Eyecatcher)
 *======================================================================
 </pre>*/
class TSFleStack extends TSFleTok { /* stack for expand/reduce */
 /*-------------------------------------------------------------------*/
  public    static final String IdStr = " 3.7.00 07.05.2012";
 /*-------------------------------------------------------------------*/
  private int                   Ix;     /* index to current type-def. */
  private int                   Pos;    /* Targetposition of length */
    /* This value ALSO may contain the 'length of the file'. However,
     * the length of the file-ID is NOT included.
     * So, this value defines the number of bytes/charcters to be read
     * after 'open' until EOF is reached.
     */
  private int                   Cmd;    /* current item-type (0..15) */
  private int                   Cnt1;   /* current repeat-counter */
  private int                   Cnt2;   /* private internal counter */
    /* normally, this counter is used as a bracket-counter */
  private boolean               LF;     /* current 'Linefeed'-Status */
  private boolean               Opt;    /* current type-def. is optional */
  private boolean               Flg1;   /* Option: 'Multiply Repeat' (14) */
  private boolean               Flg2;   /* Option: 'NL before exec' (13) */
  private boolean               Flg3;   /* Option: 'NL before advance' (12) */
  private boolean               Flg4;   /* Option depends on type-Def.  (11) */
                                        /* Option(0): 'Suppress NL' (11) */
                                        /* Option(1): 'Set Group-Counter' (11) */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSFleStack() /* create and initialize values */
   {
    super(); /* initialize default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* Attention: The selected values correspond directly to the
     *            default elements of class 'TSFleTok', which are
     *            initialized with the above 'super'-statement.
     */
    Ix   = 0;     /* Meaning: default type-definition active */
    Pos  = -1;    /* marker: no input available  (must be inserted) */
    Cmd  = 0;     /* Meaning: 'Embedded Token' required */
    Cnt1 = 0;     /* initialize counter to 'until end' */
    Cnt2 = 0;     /* preset second counter/value with '0' */
    LF   = true;  /* default: insert CRLF after Token */
    Opt  = false; /* default: item is NOT optional (15) */
    Flg1 = false; /* set optionflag (14) to default */
    Flg2 = false; /* set optionflag (13) to default */
    Flg3 = false; /* set optionflag (12) to default */
    Flg4 = false; /* set optionflag (11) to default */
    /* all (other) values are set to 'null'/0 by default */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSFleStack( /* initialize values from token */
   TSFleTok cT) /* copy values from current token */
   {
    super(cT); /* transfer basic values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Pos  = -1;    /* marker: no input available */
    Cmd  = -1;    /* Meaning: no item-type specified */
    Cnt1 = 0;     /* initialize counter to 'until end' */
    Cnt2 = cT.isCmt()?1:0; /* init second counter/value with '0'/'1' */
    LF   = true;  /* default: insert CRLF after Token */
    Opt  = false; /* default: item is NOT optional (15) */
    Flg1 = false; /* set optionflag (14) to default */
    Flg2 = false; /* set optionflag (13) to default */
    Flg3 = false; /* set optionflag (12) to default */
    Flg4 = false; /* set optionflag (11) to default */

    Ix  = cT.getTyp(0); /* get first type-definition from array */
    if(-1==Ix) return;  /* no valid type-definition -- use default */
    Cmd = Ix & 0x0F;    /* extract type item to be processed */
    Ix >>= 4;           /* remove already processed part of value */
    Opt = (Ix&0x0800)!=0; /* transfer 'optional'-attribute  (preset) */
    switch(Cmd) { /* transfer values due to selected scheme */
      case(12): /* scheme 1 is used */
        Cnt1 = Ix & 0x01F; /* load counter with initial value (0..31) */
        Flg1 = (Ix&0x0400)!=0; /* transfer optionflag from type-definition */
        Ix >>= 5;   /* remove already processed part of value */
        Cnt2 = -1 - (Ix & 0x01F); /* load counter from extended item (0..31) */
                                  /* compute number of virtual token */
        break; /* scheme-definition is successfully processed */
      case(15): /* scheme 2 is used */
        Cnt1 = 1;           /* initialize repeat-counter to 'one item' */
        Cnt2 = Ix & 0x07FF; /* load counter from extended item (0..2047) */
        break; /* scheme-definition is successfully processed */
      default: /* scheme 0 (default-scheme) is used */
        Cnt1 = Ix & 0x07F;  /* load counter with initial value (0..127) */
        Flg1 = (Ix&0x0400)!=0; /* transfer optionflag from type-definition */
        Flg2 = (Ix&0x0200)!=0; /* transfer optionflag from type-definition */
        Flg3 = (Ix&0x0100)!=0; /* transfer optionflag from type-definition */
        Flg4 = (Ix&0x0080)!=0; /* transfer optionflag from type-definition */
    } /* values are load due to appropriate scheme */
    Ix  = 0; /* select/establish FIRST type-definition */
    if(!Opt || Cnt1!=0) return; /* 'until end' is NOT optional */
    Opt  = false; /* remove optional-attribute */
    Cnt1 = -1;    /* and simulate a present item */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create Special Loop-Entry ('Virtual Token')
  *
  * This method is used to create a 'virtual token'-definition which
  *  is used to realize repeatable groups of items. Such a token can
  *  neither be a 'comment' nor be followed by a LF.
  *=====================================================================
  </pre>*/
  protected TSFleStack( /* initialize values from token */
   TSFleTok cT, /* copy values from current token */
   int      cP) /* position value from previous Stack-element */
   {
    super(cT); /* transfer basic values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Pos  = cP;    /* End-Position do not change */
    Cmd  = -1;    /* Meaning: no item-type specified */
    Cnt1 = 0;     /* initialize counter to 'until end' */
    Cnt2 = 0;     /* init second counter/value with '0' */
    LF   = false; /* default: DO NOT insert CRLF after Token */
    Opt  = false; /* default: item is NOT optional (15) */
    Flg1 = false; /* set optionflag (14) to default */
    Flg2 = false; /* set optionflag (13) to default */
    Flg3 = false; /* set optionflag (12) to default */
    Flg4 = false; /* set optionflag (11) to default */

    Ix  = cT.getTyp(0); /* get first type-definition from new array */
    if(-1==Ix) return;  /* no valid type-definition -- use default */
    Cmd = Ix & 0x0F;    /* extract type item to be processed */
    Ix >>= 4;           /* remove already processed part of value */
    Opt = (Ix&0x0800)!=0; /* transfer 'optional'-attribute  (preset) */
    switch(Cmd) { /* transfer values due to selected scheme */
      case(12): /* scheme 1 is used */
        Cnt1 = Ix & 0x01F; /* load counter with initial value (0..31) */
        Flg1 = (Ix&0x0400)!=0; /* transfer optionflag from type-definition */
        Ix >>= 5;   /* remove already processed part of value */
        Cnt2 = -1 - (Ix & 0x01F); /* load counter from extended item (0..31) */
                                  /* compute number of virtual token */
        break; /* scheme-definition is successfully processed */
      case(15): /* scheme 2 is used */
        Cnt1 = 1;           /* initialize repeat-counter to 'one item' */
        Cnt2 = Ix & 0x07FF; /* load counter from extended item (0..2047) */
        break; /* scheme-definition is successfully processed */
      default: /* scheme 0 (default-scheme) is used */
        Cnt1 = Ix & 0x07F;  /* load counter with initial value (0..127) */
        Flg1 = (Ix&0x0400)!=0; /* transfer optionflag from type-definition */
        Flg2 = (Ix&0x0200)!=0; /* transfer optionflag from type-definition */
        Flg3 = (Ix&0x0100)!=0; /* transfer optionflag from type-definition */
        Flg4 = (Ix&0x0080)!=0; /* transfer optionflag from type-definition */
    } /* values are load due to appropriate scheme */
    Ix  = 0; /* select/establish FIRST type-definition */
    if(!Opt || Cnt1!=0) return; /* 'until end' is NOT optional */
    Opt  = false; /* remove optional-attribute */
    Cnt1 = -1;    /* and simulate a present item */
  }

 /**. <pre>
  *=====================================================================
  * Method "advDef"
  * Advance to next type-definition and set new values.
  * Method returns 'true', if EOT (End-Of-Token) is (already) reached.
  * ##advDef.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean advDef() /* advance type-definition */
   {
   /*-----------------------------------------------------------------*/
    int cTD; /* current (raw) type-definition */
   /*=================================================================*/
    if(Ix<0) return true; /* EOT already reached -- signal it */
    Ix += 1; /* advance to next entry */

    Cnt2 = super.isCmt()?1:0; /* preset second counter/value with '0'/'1' */
    Opt  = false; /* default: item is NOT optional (15) */
    Flg1 = false; /* set optionflag (14) to default */
    Flg2 = false; /* set optionflag (13) to default */
    Flg3 = false; /* set optionflag (12) to default */
    Flg4 = false; /* set optionflag (11) to default */

    cTD = super.getTyp(Ix); /* get next type-definition from array */
    if(-1==cTD) { /* EOT reached now -- invalidate definition */
      Ix   = -1;    /* set marker to EOT (End-Of-Token) */
      Cmd  = -1;    /* Meaning: no item-type specified */
      Cnt1 = 0;     /* initialize counter to 'until end' */
      return true;  /* EOT reached -- signal it */
    } /* EOT reached -- definition now shows this */

    /* split new type-definition and set new values */
    Cmd  = cTD & 0x0F;  /* extract type-item to be processed (0..15) */
    cTD >>= 4;          /* remove already processed part of value */
    Opt  = (cTD&0x0800)!=0; /* transfer 'optional'-attribute  (preset) */
    switch(Cmd) { /* transfer values due to selected scheme */
      case(12): /* scheme 1 is used */
        Cnt1 = cTD & 0x01F; /* load counter with initial value (0..31) */
        Flg1 = (cTD&0x0400)!=0; /* transfer optionflag from type */
        cTD >>= 5;   /* remove already processed part of value */
        Cnt2 = -1 - (cTD & 0x01F); /* load counter from extended item (0..31) */
                                   /* compute number of virtual token */
        break; /* scheme-definition is successfully processed */
      case(15): /* scheme 2 is used */
        Cnt1 = 1;            /* initialize repeat-counter to 'one item' */
        Cnt2 = cTD & 0x07FF; /* load counter from extended item (0..2047) */
        break; /* scheme-definition is successfully processed */
      default: /* scheme 0 (default-scheme) is used */
        Cnt1 = cTD & 0x07F; /* load counter with initial value (0..127) */
        Flg1 = (cTD&0x0400)!=0; /* transfer optionflag from type */
        Flg2 = (cTD&0x0200)!=0; /* transfer optionflag from type */
        Flg3 = (cTD&0x0100)!=0; /* transfer optionflag from type */
        Flg4 = (cTD&0x0080)!=0; /* transfer optionflag from type */
    } /* values are load due to appropriate scheme */
    if(!Opt || Cnt1!=0) return false; /* 'until end' is NOT optional */
      /* Cmd==15 ==> Cnt1!=0, So, 'Opt' is NOT changed */
    Opt  = false; /* remove optional-attribute */
    Cnt1 = -1;    /* and simulate a present item */
    return false; /* new definition is complete */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkAdv"
  * Check if advance to next type-definition should be done.
  * Method returns 'true', if 'advDef' could be tried. However, this
  *   is also returned if EOT (End-Of-Token) is already reached.
  * If 'skp' is set(true), type-definition may be advanced to next one
  *   even if 'until-end'-attribute is active or the (valid) counter
  *   is NOT expired.
  * Attention: If method returns 'true', the internal counter may not
  *            be modified.
  * ##chkAdv.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean chkAdv( /* check advance of type-definition */
   boolean skp) /* advance even if 'until end' is active  (if 'true') */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Ix<0) return true; /* EOT already reached -- try advance */

    if(Opt) return true; /* internal counter NOT valid -- advance */
    Cnt1 -= 1; /* register call to advance-check-method */
    if(skp) return true; /* skip is requested -- advance in any case */
    if(Cnt1==0) return true; /* counter has expired -- 'advance now */
    return false; /* DO NOT try advance */
      /* 'until end' is active(<0) or counter has NOT expired(>0) */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkFlg2"
  * Examine current Flag-Definition (do not change) and return state.
  * Meaning: 'Switch to NL before type-definition is used'
  * Attention: Method is used if the flag MUST NOT be reset within
  *            first argument.
  * ##chkFlg2.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean chkFlg2() /* examine current value of flag */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Flg2; /* return current state of flag */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkFlg3"
  * Examine current Flag-Definition (do not change) and return state.
  * Meaning: 'Switch to NL before advance to next type'
  * Attention: Method is used if the flag MUST NOT be reset within
  *            first argument.
  * ##chkFlg3.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean chkFlg3() /* examine current value of flag */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Flg3; /* return current state of flag */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkFlg4"
  * Examine current Flag-Definition (do not change) and return state.
  * Meaning: 'Option depends on type of entry'
  * Attention: Method is used if the flag MUST NOT be reset within
  *            first argument.
  * ##chkFlg4.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean chkFlg4() /* examine current value of flag */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Flg4; /* return current state of flag */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkOpt"
  * Check current type-definion if it is an optional one.
  * Method returns 'true' if the current type-definition is an optional
  *   one but the preconditions are NOT met, so that it cannot be
  *   used.
  * If all preconditions are met, the 'optional'-attribute is reset and
  *   'false' is returned.
  * If method returns 'false' the current type-definition should be
  *   used. Else it should be skipped.
  * Attention: If 'cP==0' a special request is scheduled, which returns
  *            the current state of the 'Opt'-flag.
  * ##chkOpt.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean chkOpt( /* check current type-definition */
   int cP) /* relative position to be checked to */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(cP==0) return Opt; /* return current condition */

    if(!Opt) return false; /* current type IS NOT optional -- use it */
    /* current type-definition is optional -- use it? */
    cP = (Pos - cP) / 4; /* compute number of Items until EOT */
    /* Attention: Minimal allowed value for 'Cnt1' is '1' */
    if(cP<Cnt1) return true; /* remaining items missing -- Do NOT
      * use current (optional) type-definiton */
    Opt  = false; /* clear flag (change to: 'ONE item required' */
    Cnt1 = 1;     /* change value of counter to required value */
    return false; /* current type should be processed/used */
  }

 /**. <pre>
  *=====================================================================
  * Method "chkPos"
  * Check current position relative to provided value.
  * If '0' is used as the argument, the original, unmodified value is
  *   returned.
  * ##chkPos.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int chkPos( /* check current position */
   int cP) /* relative position to be checked to */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Pos - cP; /* compute distance as result */
  }

 /**. <pre>
  *=====================================================================
  * Method "clrFlg1"
  * Process 'repeat-counter' if current Flag-Definition request this.
  *   Reset flag and return previous state.
  * Meaning: 'Multiply repeat-value with group-counter'
  * ##clrFlg1.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean clrFlg1( /* process current value of flag */
   int mv) /* value to used within multiply (may be '0') */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(!Flg1) return false; /* function is NOT requested */
    if(Opt) return false; /* value cannot be applied to current def. */
    Cnt1 *= mv;   /* insert requested factor into repeat-value */
    if(Cnt1==0) Opt = true; /* no requested items --> type is optional */
    Flg1 = false; /* clear current flag (no repeat of action) */
    return true;  /* return old state of flag */
  }

 /**. <pre>
  *=====================================================================
  * Method "clrFlg2"
  * Clear current Flag-Definition and return PREVIOUS state.
  * Meaning: 'Switch to NL before type-definition is used'
  * ##clrFlg2.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean clrFlg2() /* clear current value of flag */
   {
   /*-----------------------------------------------------------------*/
    boolean cS; /* current/previous state of flag */
   /*=================================================================*/
    cS   = Flg2;  /* save current state of flag */
    Flg2 = false; /* clear current flag in any case */
    return cS; /* return current/old state of flag */
  }

 /**. <pre>
  *=====================================================================
  * Method "clrFlg4"
  * Clear current Flag-Definition and return PREVIOUS state.
  * This is the common version with NO special actions and used with
  *   either 'Expand' or 'Reduce'.
  * Meaning: 'Option depends on type of entry'
  * ##clrFlg4.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean clrFlg4() /* clear current value of flag */
   {
   /*-----------------------------------------------------------------*/
    boolean cS; /* current/previous state of flag */
   /*=================================================================*/
    cS   = Flg4;  /* save current state of flag */
    Flg4 = false; /* clear current flag in any case */
    return cS; /* return current/old state of flag */
  }

 /**. <pre>
  *=====================================================================
  * Method "clrFlg4_EE" (Version: Type14-Expand)
  * Clear current Flag-Definition and return number of items.
  * Add aditional actions needed for type-definition.
  * Meaning: 'Option depends on type of entry'
  * ##clrFlg4_EE.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String clrFlg4_EE( /* clear current value of flag */
   int cP, /* current position within token */
   int mx) /* value of maximum number of items */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(!Flg4) return null; /* flag already clear -- no action */
    Flg4 = false; /* clear current flag in any case */
    cP = (Pos - cP) % mx; /* compute maximum number of Bytes until EOT */
    Cnt1 = cP; /*  and load repeat-counter of current function */
    return "" + cP + " "; /* return converted value to be inserted */
  }

 /**. <pre>
  *=====================================================================
  * Method "clrFlg4_RE" (Version: Type14-Reduce)
  * Clear current Flag-Definition and return PREVIOUS state.
  * Add aditional actions needed for type-definition.
  * Meaning: 'Option depends on type of entry'
  * ##clrFlg4_RE.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean clrFlg4_RE( /* clear current value of flag */
   int rc) /* value of repeat-counter to be loaded */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(!Flg4) return false; /* flag already clear -- no action */
    Flg4 = false; /* clear current flag in any case */
    Cnt1 = ++rc; /* load repeat-counter of current function */
    return true; /* return old state of flag */
  }

 /**. <pre>
  *=====================================================================
  * Method "getCmd"
  * Resolve current item-type.
  * Attention: If 'cmd' is NOT set, the whole type-definition is
  *            returned (if possible). (used for debugging purposes)
  * ##getCmd.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getCmd( /* resolve current item-type */
   boolean cmd) /* return current item-number ONLY (if true) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(cmd) return Cmd; /* return current item-number (0..15) */
    if(Ix<0) return -1; /* current index is NOT valid -- return dummy */
    return super.getTyp(Ix); /* return complete type-definition */
  }

 /**. <pre>
  *=====================================================================
  * Method "getCnt"
  * Return current value of alternate counter.
  * ##getCnt.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getCnt() /* get alternate-counter */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Cnt2; /* return value of alternate counter */
  }

 /**. <pre>
  *=====================================================================
  * Method "getRep"
  * Return number of items of same type to be resolved from buffer.
  * Reset internal counter to '0'.
  * If 'until-end'-function is active, number is computed as distance
  *  to EOT.
  * ##getRep.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getRep( /* get number of remaining items */
   int cP) /* current position (if 'until-end' is requested) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    cP = (Pos - cP) / 4; /* compute item-count until EOT */
    if(Cnt1<=0) return cP; /* 'until-end'-function req. -- return it */
    /* fix number requested -- check if possible */
    if(Cnt1<cP) cP = Cnt1; /* compute number of available items */
    Cnt1 -= cP - 1; /* clear number of resolved items */
      /* 'advDef()' will decrement 'Cnt1' again (set to '0') and 'advance' */
    return cP; /* and return number to be resolved */
  }

 /**. <pre>
  *=====================================================================
  * Method "isEOT"
  * Check if token is completely processed.
  * Return current type-definiton if it is NOT.
  * ##isEOT.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String isEOT() /* check if EOT reached */
   {
   /*-----------------------------------------------------------------*/
    int i; /* temporary value for compare */
   /*=================================================================*/
    if(!Opt) /* internal counter is valid -- process it */
      if(Cnt1<0) advDef(); /* advance if 'until end' active */
      /* Attention: 'until end' must be used at a minimum of 'once' or
       *            it is not considered as this attribute. (0->neg,)
       */
    if(Ix<0) return null; /* EOT already reached -- signal it */
    return TSUtil.toHex(super.getTyp(Ix),-5); /* current type-def. */
  }

 /**. <pre>
  *=====================================================================
  * Method "isOpt"
  * Check current type-definion if it is (as per definition) an
  *   optional one.
  * Attention: The 'Optional'-attribute may be modified due to
  *            external conditions. So, the original attribute-setting
  *            is again extracted and returned.
  * ##isOpt.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean isOpt() /* check current type-definition */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Ix<0) return false; /* current index is NOT valid -- return dummy */
    return (super.getTyp(Ix)&0x08000)!=0; /* return original condition */
  }

 /**. <pre>
  *=====================================================================
  * Method "runCnt"
  * Handle alternate counter. Increment / decrement it, and test if it
  *   terminates.
  * ##runCnt.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean runCnt( /* modify alternate-counter */
   boolean inc) /* increment counter if 'true' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(inc) Cnt2 += 1; /* req. mode: increment alternate counter */
    else    Cnt2 -= 1; /* req. mode: decrement alternate counter */
    return Cnt2<=0;    /* check current counter and return result */
  }

 /**. <pre>
  *=====================================================================
  * Method "setLF"
  * Set new value of current 'Linefeed'-Status and return previous one.
  * ##setLF.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean setLF( /* set new 'Linefeed'-Status */
   boolean nS) /* new state to be established */
   {
   /*-----------------------------------------------------------------*/
    boolean cS; /* current state of flag */
   /*=================================================================*/
    cS = LF; /* save current state of flag */
    LF = nS; /* transfer new state in an case */
    return cS; /* return current/old state of flag */
  }

 /**. <pre>
  *=====================================================================
  * Method "setPos"
  * Set new value of input-position and return previous one.
  * ##setPos.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int setPos( /* set new value of input-position */
   int nV) /* new value  */
   {
   /*-----------------------------------------------------------------*/
    int cV; /* current value */
   /*=================================================================*/
    cV = Pos;  /* save current value */
    Pos = nV;  /* set new value in any case */
    return cV; /* return previous value */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build an String-representation of all values of this class
  * ##toStr.TSFleStack (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* get string-Representation */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    return "TSFleStack{"+super.toStr()+",("+Pos+"),"+Cmd+",Opt="+Opt+
           ",F1="+Flg1+",F2="+Flg2+",F3="+Flg3+",F4="+Flg4+
           ","+Cnt1+","+Cnt2+"}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSDeCompInputStream -- Decompress data while reading.
 * Attention: This class replaces class 'InflaterInputStream', which
 *           provides a too small input-buffer. However, not all
 *           methods of the original class are also implemented within
 *           the replacement-class.
 * ##TSDeCompInputStream (Eyecatcher)
 *======================================================================
 </pre>*/
class TSDeCompInputStream extends FilterInputStream { /* decompr. data */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.7.00 18.06.2012";
 /*-------------------------------------------------------------------*/
  private Inflater              cInf;   /* current Inflater */
  private volatile byte[]       buffer; /* dynamic data-buffer */
  private volatile byte[]       sglBuf; /* I/O-buffer of 'read()' */
  private boolean               closed; /* stream is already closed */
  private boolean               eof;    /* input-stream reached EOF */
 /* Following definition(s) from 'FilterInputStream' are used within
  * the methods of this class:
  protected volatile InputStream in;    current inputstream
  */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSDeCompInputStream( /* create IO-Stream for decompress */
   InputStream IS) /* current inputstream */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    this(IS,512); /* transfer to 'standard-constructor' */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSDeCompInputStream( /* create IO-Stream for decompress */
   InputStream IS, /* current inputstream */
   int         bl) /* initial Length of (internal) IO-Buffer */
   {
    super(IS); /* establish 'FilterInputStream' (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(IS==null) throw new IllegalArgumentException( /* no stream */
       TSLogg.getMsg("Msg901","TSDeCompInputStream()","<null>",1));
    if(bl<0) throw new IllegalArgumentException( /* invalid length */
       TSLogg.getMsg("Msg901","TSDeCompInputStream()",bl,2));
    buffer = new byte[bl]; /* create IO-buffer */
    sglBuf = new byte[1];  /* create IO-buffer for 'read()' */
    cInf   = new Inflater(); /* use default-version of decompressor */
    closed = false; /* preset: inputstream is active */
    eof    = false; /* preset: input-data is still available */
    /* all other control-values are already initialized to '0' */
  }

 /**. <pre>
  *=====================================================================
  * Method "close"
  * Closes this input stream and releases any system resources
  *   associated with the stream.
  * @exception IOException if an I/O error has occurred
  * ##close.TSDeCompInputStream (Eyecatcher)
  *=====================================================================
  </pre>*/
  public void close() /* close stream and release resources */
   throws IOException {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    if(closed) return; /* stream is already closed */
    cInf.end(); /* stop inflater-process */
    super.close(); /* and close underlying stream */
    closed = true; /* action done */
    return; /* return requested value */
  }

 /**. <pre>
  *=====================================================================
  * Method "read"
  * Return single uncompressed byte from input.
  * @exception IOException if an I/O error has occurred
  * ##read.TSDeCompInputStream (Eyecatcher)
  *=====================================================================
  </pre>*/
  public int read() /* read single uncompressed byte */
   throws IOException {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    if(closed) throw new IOException( /* systemerror: stream closed */
       TSLogg.getMsg("Msg917","TSDeCompInputStream(1)"));
    return (read(sglBuf,0,1)<0) ? -1 : sglBuf[0] & 0xff;
      /* extract requested value  and return it */
  }

 /**. <pre>
  *=====================================================================
  * Method "read"
  * Reads uncompressed data into an array of bytes
  * @exception IOException if an I/O error has occurred
  * ##read.TSDeCompInputStream (Eyecatcher)
  *=====================================================================
  </pre>*/
  public int read(  /* read uncompressed byte int byte-array */
   byte[] io,  /* destination-array */
   int    off, /* position within destination */
   int    len) /* number of requested bytes */
   throws IOException {
   /*-----------------------------------------------------------------*/
    int n; /* number of bytes received */
   /*=================================================================*/
    if(closed) throw new IOException( /* systemerror: stream closed */
       TSLogg.getMsg("Msg917","TSDeCompInputStream(2)"));
    if(io==null) throw new IllegalArgumentException( /* no buffer */
       TSLogg.getMsg("Msg901","TSDeCompInputStream()","<null>",1));
    if(off<0 || off>=io.length) throw new IllegalArgumentException(
       TSLogg.getMsg("Msg901","TSDeCompInputStream()",off,2));
    if(len<0 || len>io.length-off) throw new IllegalArgumentException(
       TSLogg.getMsg("Msg901","TSDeCompInputStream()",len,3));
    if(len==0) return 0; /* valid situation: do not read */

    try { /* try to get data from uncompressed inputstream */
      while((n=cInf.inflate(io,off,len))==0) { /* no data received -- look for reason */
        if(cInf.finished() || cInf.needsDictionary()) { /* error/eof found */
          eof = true; /* no more raw input from input-data-stream */
          return -1;  /* and return EOF of complete input */
        } /* condition received */
        if(cInf.needsInput()) { /* provide inflater with raw data */
          n = super.read(buffer,0,buffer.length); /* get raw data */
          if(n<0) throw new EOFException( /* error reading raw data */
            TSLogg.getMsg("Msg917","TSDeCompInputStream(3)"));
          cInf.setInput(buffer,0,n); /* transfer data to inflater */
        } /* raw data was missing */
      } /* -while- until new data is available */
      return n; /* return number of bytes copied to target */
    } catch (DataFormatException e) {  throw new ZipException(
      TSLogg.getMsg("Msg916","TSDeCompInputStream()",e.toString()));
      /* terminate program with systemerror due to exception */
    } /* exception found -- treminate */
  }

 /**. <pre>
  *=====================================================================
  * Method "readSize"
  * Change size of internal buffer, which is used for providing
  *   data to the Inflater.
  * The internal buffersize is computed according to:
  *   - Select integer n from (1..30) so that 2**n > (sz/sf) >= 2**(n-1)
  *   - Use max(2**n, 512) as internal buffersize.
  * ##readSize.TSDeCompInputStream (Eyecatcher)
  *=====================================================================
  </pre>*/
  public int readSize( /* change internal buffersize */
   int sz, /* size-basisvalue (0 < sz < 1073741824 */
   int sf) /* size-factor (must be >=1) */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    if(closed) return -1; /* stream is already closed */
    sf = Math.max(1,sf); /* asure valid value for factor */
    sz = Math.max(512,sz&0xBFFFFFFF); /* mininum size required */
      /* the value must be less than 1073741824 (because of 'while') */
    sz /= sf; /* compute requested minimum size of buffer */
    sf = 1; /* initialize target-value */
    while(sf<sz) sf <<= 1; /* find next allowed value */
    sf = Math.max(512,sf); /* minimum factory-value must be met */
    sz = buffer.length; /* save original length of buffer */
    buffer = new byte[sf]; /* create new IO-buffer */
    return sz; /* return old length of buffer */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSByteArrIO -- dynamic 'ByteArray'-Buffer for input and output.
 * Although this class uses write/read-methods to fill/recover the data
 *   within the buffer, it really uses copy operations to do the job.
 * This class also contains some (static) methods to change
 *     buffer-contents.
 * Attention: This class was created using source-file of class
 *            'ByteArrayOutputStream'.
 *
 * Method-definition:
 *   'write' means: from source to BUFFER
 *            add new data at position 'count' within buffer
 *   'read'  means: from BUFFER to destination
 *            copy data, beginning at position 'cpos'/'0', to target
 * But...
 *   'writeTo'  means: from BUFFER to file (Outputstream/File)
 *               copy data, beginning at current position ('cpos')
 *   'readFrom' means: from file (Inputstream/File) to Buffer
 *               copy data, append it at end of buffer
 * ##TSByteArrIO (Eyecatcher)
 *======================================================================
 </pre>*/
class TSByteArrIO extends OutputStream
                  implements Serializable { /* control Buffer-IO */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.7.00 02.05.2012";
 /*-------------------------------------------------------------------*/
  protected static int          ReadLoop = 100; /* number of reReads */
 /*-------------------------------------------------------------------*/
  private int                   count;  /* length of valid data */
  private int                   cPos;   /* current read-position */
  private int                   mark;   /* currently marked position */
  private volatile byte[]       buffer; /* dynamic data-buffer */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSByteArrIO() /* Create Dummy-Definition IO-Stream */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    this(120); /* initialize using default-buffersize */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSByteArrIO( /* create extended IO-Stream */
   int bl) /* initial Length of IO-Buffer */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(bl<0) throw new IllegalArgumentException( /* invalid length */
       TSLogg.getMsg("Msg901","TSByteArrIO()",bl,1));
    buffer = new byte[bl]; /* create IO-buffer */
    mark   = -1;           /* no position marked */
    /* all other control-values are already initialized to '0' */
  }

 /**. <pre>
  *=====================================================================
  * Method "available"
  * Returns the number of bytes that can be read from this buffer
  *   without blocking.
  * ##available.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  public synchronized final int available() /* return available bytes */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    return count - cPos; /* return requested value */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgBuffer"
  * Establish new/larger internal byte-buffer.
  * ##chgBuffer.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final void chgBuffer( /* modify internal Byte-Buffer */
   int len) /* requested length (minimum) */
   {
   /*-----------------------------------------------------------------*/
    byte[] newBuffer; /* new buffer */
   /*=================================================================*/
    newBuffer = new byte[Math.max(buffer.length<<1,len)];
    System.arraycopy(buffer,0,newBuffer,0,count);
    buffer = newBuffer; /* activate new IO-buffer */
  }

 /**. <pre>
  *=====================================================================
  * Method "getBytes"
  * Get Sub-Array of current buffer and return it.
  * Offset is taken from current input-position, which is incremented.
  * ##getBytes.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final byte[] getBytes( /* get subarray from Byte-Array */
   int len) /* length of requested array */
   {
   /*-----------------------------------------------------------------*/
    byte[] rs; /* result of method */
   /*=================================================================*/
    rs = getBytes(len,cPos); /* use alternate version to get result */
    cPos += len; /* advance current pointer after result */
    return rs; /* provide result (no error) */
  }

 /**. <pre>
  *=====================================================================
  * Method "getBytes" (2. version)
  * Get Sub-Array of current buffer and return it.
  * Attention: Input-position is NOT modified.
  * ##getBytes.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final byte[] getBytes( /* get subarray from Byte-Array */
   int len, /* length of requested array */
   int pos) /* Position of source-value within input-buffer */
   {
   /*-----------------------------------------------------------------*/
    byte[] rs; /* result of method */
   /*=================================================================*/
    if(len<1) throw new IllegalArgumentException(
      TSLogg.getMsg("Msg901","TSByteArrIO.getBytes()",len,1));
      /* invalid length -- terminate with systemerror */
    if(pos<0 || (pos+len)>count) throw new IllegalStateException(
      TSLogg.getMsg("Msg907","TSByteArrIO.getBytes()","Index"));
      /* too less buffer -- terminate with systemerror */

    rs = new byte[len]; /* create result-array */
    System.arraycopy(buffer,pos,rs,0,len); /* copy requested data */
    return rs; /* provide result (no error) */
  }

 /**. <pre>
  *=====================================================================
  * Method "getInt"
  * Get Integer-value from Byte-Array as 'long' assuming LE-Format
  *   (Little Endian).
  * Method terminates program, if error occurred.
  * Attention: Input-position is NOT modified.
  * ##getInt.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final long getInt( /* read Integer from Byte-Array */
   int len, /* length of input-field (1..8) */
   int pos) /* Position of source-value within input-buffer */
   {
   /*-----------------------------------------------------------------*/
    long l; /* intermediate value */
    int  p; /* temporary value (position-pointer) */
   /*=================================================================*/
    if(len<1 || len>8) throw new IllegalArgumentException(
      TSLogg.getMsg("Msg901","TSByteArrIO.getInt()",len,1));
    p = pos + len; /* compute end-position+1 (right to left) */
    if(pos<0 || p>count) throw new IllegalStateException(
      TSLogg.getMsg("Msg907","TSByteArrIO.getInt()","Index"));
      /* too less buffer -- terminate with systemerror */
    l = 0; /* init result */
    while(--len>=0) l = (l << 8) | (long)(buffer[--p]) & 0x0FF;
      /* set next part of value */
    return l; /* provide result (no error) */
  }

 /**. <pre>
  *=====================================================================
  * Method "getInt" (2. version)
  * Get Integer-value from Byte-Array as 'long' assuming LE-Format
  *   (Little Endian).
  * Offset is taken from current input-position, which is incremented.
  * ##getInt.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final long getInt( /* read Integer from Byte-Array */
   int len) /* length of input-field (1..8) */
   {
   /*-----------------------------------------------------------------*/
    int p; /* temporary position-pointer */
   /*=================================================================*/
    p = cPos; /* save current position-pointer */
    cPos += len; /* and advance current pointer after result */
    return getInt(len,p); /* use primary version to provide result */
  }

 /**. <pre>
  *=====================================================================
  * Method "getInt" (static version)
  * Get back Integer-value from Byte-Array as 'long' assuming LE-Format
  *   (Little Endian).
  * Method terminates program, if error occurred.
  * ##getInt.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final long getInt( /* read Integer from Byte-Array */
   int    len, /* length of input-field (1..8) */
   byte[] src, /* data-area is source */
   int    ofs) /* offset in array */
   {
   /*-----------------------------------------------------------------*/
    long l; /* intermediate value */
   /*=================================================================*/
    if(len<1 || len>8) throw new IllegalArgumentException(
      TSLogg.getMsg("Msg901","TSByteArrIO.getInt()",len,1));
    if(src==null) throw new IllegalArgumentException(
      TSLogg.getMsg("Msg901","TSByteArrIO.getInt()","null",2));
    ofs += len; /* compute end-position+1 (right to left) */
    if(ofs<len || ofs>src.length) throw new IllegalStateException(
      TSLogg.getMsg("Msg907","TSByteArrIO.getInt()","Dst-Index"));
      /* too less buffer -- terminate with systemerror */
    l = 0; /* init result */
    while(--len>=0) l = (l << 8) | (long)(src[--ofs]) & 0x0FF;
      /* set next part of value */
    return l; /* provide result (no error) */
  }

 /**. <pre>
  *=====================================================================
  * Method "getString"
  * Read Unicode-String from byte-array-buffer.
  * If an error is found, 'null' is returned.
  * ##getString.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getString( /* get String from buffer */
   int len) /* length of requested string */
   {
   /*-----------------------------------------------------------------*/
    String s; /* result, value is propagated to target! */
   /*=================================================================*/
    if(len<1) throw new IllegalArgumentException(
      TSLogg.getMsg("Msg901","TSByteArrIO.getString()",len,1));
    len *= 2; /* compute number of (requested) bytes within buffer */
    if(available()<len) return null; /* not enough data -- error */

    try { s = new String(buffer,cPos,len,"UTF-16LE");
    } catch (UnsupportedEncodingException e) {
      return null; /* error found -- terminate */
    } /* extract and convert, return 'null' if error occurrs */

    cPos += len; /* skip bytes which were converted */
    return s; /* return result */
  }

 /**. <pre>
  *=====================================================================
  * Method "mark"
  * Handle control of position -- mark it.
  * Returns 'false', if NO position was already marked.
  * Attention: This method is copied from (and requested by) source of
  *            class 'ByteArrayInputStream'/'ByteArrayOutputStream'.
  * --- Method is NOT referenced until now. (marked by 'XXX...') ---
  * ##mark.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected synchronized final boolean XXXmark( /* store current pos. */
   boolean clr) /* do not set but clear marker (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    boolean marked; /* position already marked */
   /*=================================================================*/
    marked = (mark>=0); /* position already marked? */
    mark = cPos; /* store current position as marker in any case */
    if(clr) reset(true); /* clear requested -- clear marker again */
    return marked; /* provide result: position was already marked ? */
  }

 /**. <pre>
  *=====================================================================
  * Method "putByte"
  * Write/Modify byte to/within output-buffer.
  * Returns error-message if request fails ('null' if no error)
  * Attention: method CANNOT add new bytes to buffer. It is only used
  *   to modify already written bytes. If a byte must be ADDED to the
  *   buffer, method 'write(byte)' should be used.
  * This method equals 'putInt(val,1,pos)'.
  * ##putByte.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String putByte( /* write/put byte to output-buffer */
   int val, /* value to be written (last 8 bit) */
   int pos) /* Position of target-value within output-buffer */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    if(pos<0 || pos>=count) /* no space in dest-buffer */
      return TSLogg.getMsg("TSFleM43",pos,size());

    buffer[pos] = (byte)(val & 0x0FF); /* copy byte to output-buffer */
    return null; /* return with NO error */
  }

 /**. <pre>
  *=====================================================================
  * Method "putBytes"
  * Add a Sub-Array of Bytes to current buffer and return length.
  * Offset is taken from current output-position, which is incremented.
  * ##putBytes.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int putBytes( /* add subarray of bytes */
   byte[] src) /* source of data */
   {
   /*-----------------------------------------------------------------*/
    int len,p; /* length of source, position-pointer */
   /*=================================================================*/
    len = src.length; /* get requested length of data */
    p = count + len; /* compute overall length of result */
    if(p>buffer.length) chgBuffer(p); /* extend buffer */

    System.arraycopy(src,0,buffer,count,len); /* copy requested data */
    count = p; /* set new length of valid data */
    return len; /* provide result (length of data) */
  }

 /**. <pre>
  *=====================================================================
  * Method "putInt"
  * Write/Add Integer/unsigned Integer to output-buffer using LE-Format.
  * New data is (completely) added to output-buffer.
  * Returns error-message if request fails ('null' if no error).
  * ##putInt.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String putInt( /* write Integer to output-buffer */
   long val, /* value to be written (UINT requests long) */
   int  len) /* Number of significant bytes (1,2,4,8) */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    return putInt(val,len,count); /* add integer to end of buffer */
      /* use alternative version to write data */
  }

 /**. <pre>
  *=====================================================================
  * Method "putInt" (2. version)
  * Write/Modify Integer/unsigned Integer to/within output-buffer using
  *   LE-Format(little endian)
  * Returns error-message if request fails ('null' if no error)
  *
  * New data is added to the buffer, if the target-field, which should
  *   be replaced, reaches beyond the border of valid data. However,
  *   the target field must start within (at end of) valid data.
  * ##putInt.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String putInt( /* write Integer to output-buffer */
   long val, /* value to be written (UINT requests long) */
   int  len, /* Number of significant bytes (1,2,4,8) */
   int  pos) /* Position of target-value within output-buffer */
   {
   /*-----------------------------------------------------------------*/
    int p; /* position-pointer / max length of result */
   /*=================================================================*/
    if(len<1 || len>8) /* invalid value -- signal error */
      return TSLogg.getMsg("TSFleM41",len); /* return error-message */
    if(pos<0 || pos>count) /* invalid target-definition in dest-buffer */
      return TSLogg.getMsg("TSFleM42",pos,count);

    p = pos + len; /* compute overall length of result */
    if(p>buffer.length) chgBuffer(p); /* extend buffer */
    if(p>count) count = p; /* adjust length of data after target-field */

    for(p=0;p<len;p+=1) { /* write/transfer all bytes */
      buffer[pos++] = (byte)(val & 0x0FF); /* transfer byte */
        /* copy byte to buffer (low order bits only) */
      val >>= 8; /* and get next byte into position */
    } /* write all requested bytes to buffer */
    return null; /* return with NO error */
  }

 /**. <pre>
  *=====================================================================
  * Method "putInt" (static version)
  * Write/Modify Integer/unsigned Integer to/within target-array using
  *   LE-Format(little endian)
  * Returns error-message if request fails ('null' if no error).
  * --- Method is NOT referenced until now. (marked by 'XXX...') ---
  * ##putInt.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final String XXXputInt( /* write Integer to target-array */
   long   val, /* value to be written (UINT requests long) */
   int    len, /* Number of significant bytes (1,2,4,8) */
   byte[] dst, /* target-array */
   int    pos) /* Position of target-value within target-array */
   {
   /*-----------------------------------------------------------------*/
    int p; /* temp. value (position-pointer) */
   /*=================================================================*/
    if(dst==null) /* no array defined */
      return TSLogg.getKey("TSFleM45"); /* return error-message */
    if(len<1 || len>8) /* invalid value -- signal error */
      return TSLogg.getMsg("TSFleM41",len); /* return error-message */
    if(pos<0 || (pos+len)>dst.length) /* no space in dest-buffer */
      return TSLogg.getMsg("TSFleM44",pos+len,dst.length);

    for(p=0;p<len;p+=1) { /* write all bytes */
      dst[pos++] = (byte)(val & 0x0FF); /* copy byte to target-array */
      val >>= 8; /* and get next byte into position */
    } /* write all requested bytes to buffer */
    return null; /* return with NO error */
  }

 /**. <pre>
  *=====================================================================
  * Method "putString"
  * Convert(add) Unicode-String to output-buffer ('Label' or data)
  * Returns error-message if request fails ('null' if no error)
  * If 'data' is written, a length-field (short) is inserted before
  *   the Unicode-String.
  * ##putString.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String putString( /* put String to Byte-Array */
   String  s,   /* String to convert */
   boolean nol) /* String is NOT a label (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    String is; /* Error-Message */
   /*=================================================================*/
    if(nol) /* not a label -- write length-field */
      if((is=putInt(s.length(),2))!=null) return is; /* add length */
        /* add lengthfield and set length of string, return if error */
    return putString(s,count); /* add string to end of buffer */
      /* use alternative version to write data */
  }

 /**. <pre>
  *=====================================================================
  * Method "putString" (2. version)
  * Convert(replace) Unicode-String within output-buffer.
  * Returns error-message if request fails ('null' if no error)
  *
  * New data is added to the buffer, if the target-field, which should
  *   be replaced, reaches beyond the border of valid data. However,
  *   the target field must start within (at end of) valid data.
  * ##putString.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String putString( /* put String to Byte-Array */
   String s,   /* String to insert */
   int    pos) /* Position of target-value within target-array */
   {
   /*-----------------------------------------------------------------*/
    int    p;   /* position-pointer */
    byte[] buf; /* result of 'convert string' */
   /*=================================================================*/
    if(pos<0 || pos>count) /* invalid target-definition in dest-buffer */
      return TSLogg.getMsg("TSFleM52",pos,count);

    try { buf = s.getBytes("UTF-16LE"); /* convert string */
    } catch (UnsupportedEncodingException e) { /* invalid code */
      return TSLogg.getMsg("TSFleM51",s,e.toString());
        /* return error-message (include systemmessage) */
    } /* Exception at convert */

    p = pos + buf.length; /* compute overall length of result */
    if(p>buffer.length) chgBuffer(p); /* extend buffer */
    if(p>count) count = p; /* adjust length of data after target-field */

    System.arraycopy(buf,0,buffer,pos,buf.length); /* copy data */
    return null; /* return and signal 'no error' */
  }

 /**. <pre>
  *=====================================================================
  * Method "read"
  * Read byte (copy) from buffer and locate it into an integer.
  * This method is requested by abstract class 'InputStream'.
  * ##read.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  public synchronized int read() /* read byte from buffer to integer */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    if(cPos>=count) return -1; /* EOF reached -- return marker */
    return (int)(buffer[cPos++]) & 0x0FF; /* get byte, convert and return */
      /* number of next input-position is also computed */
  }

 /**. <pre>
  *=====================================================================
  * Method "read"
  * Read/Copy part of the buffer to target-area due to specified length.
  * --- Method is NOT referenced until now. (marked by 'XXX...') ---
  * ##read.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected synchronized final int XXXread( /* copy buffer to target */
   byte[] tgt, /* target-area to be filled */
   int    len) /* length of buffer to be copied */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    if(count-cPos<len) len = count - cPos; /* use max. available data */
    if(len>tgt.length) throw new IllegalStateException(
      TSLogg.getMsg("Msg907","TSByteArrIO.read(byte[])","Length"));
      /* too less buffer -- terminate with systemerror */
    System.arraycopy(buffer,cPos,tgt,0,len); /* copy buffer to target */
    cPos += len; /* and advance pointer */
    return len; /* return number of actually copied bytes */
  }

 /**. <pre>
  *=====================================================================
  * Method "readFrom"
  * Read data from an inputstream and copy them to the byte-array-buffer
  *  appending them.
  * If needed, the size of the buffer is expanded.
  * ##readFrom.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  public synchronized int readFrom( /* copy data and append */
   InputStream in,  /* current Stream to read from */
   int         len) /* maximum length of data requested */
   throws IOException {
   /*-----------------------------------------------------------------*/
    int i,n,r; /* number of bytes read */
   /*=================================================================*/
    n = count + len; /* compute overall length of result */
    if(n>buffer.length) chgBuffer(n); /* extend buffer */

    r = ReadLoop; /* maximum number of retries */
    n = len; /* save requested length of read bytes */
    do { /* read until all data is available */
      if(--r<0) break; /* maximum number of retries met -- return */
      i = in.read(buffer,count,len);  /* get data from file */
      if(i<0) return i; /* EOF found -- return EOF (-1) */
      count += i; /* compute new target-position */
      len   -= i; /* and remaining length */
    } while(len>0); /* repeat until done */
    return n - len; /* provide number of read bytes */
  }

 /**. <pre>
  *=====================================================================
  * Method "readFrom"
  * Read complete sourcefile and copy it to byte-array-buffer
  *   appending it
  * Returns error-message if request fails ('null' if no error).
  * --- Method is NOT referenced until now. (marked by 'XXX...') ---
  * ##readFrom.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String XXXreadFrom( /* copy file into buffer */
   File dat) /* definition of sourcefile */
   {
   /*-----------------------------------------------------------------*/
    FileInputStream IS;        /* filereader to buffer */
    String          Msg;       /* current error-message or 'null' */
    int             fl,cl,r,i; /* current length of file, temp-length */
   /*=================================================================*/
    if(dat==null) return TSLogg.getKey("TSFleM61");
    try { IS = new FileInputStream(dat); /* open inputfile */
    } catch (FileNotFoundException e) { /* file not found -- return error */
      return TSLogg.getMsg("TSFleM62",dat.getAbsolutePath(),e.toString());
    } /* open-error */
    Msg = null; /* preset: no error */
    cl = fl = (int)dat.length(); /* get length = number of bytes to be copied */
    i = fl + count; /* compute minimum length of buffer */
    if(i>buffer.length) chgBuffer(i); /* extend buffer if needed */

    r = ReadLoop; /* maximum number of retries */
    do { /* read until all data is available */
      if(--r<0) { /* maximum number of retries met -- return */
        Msg = TSLogg.getMsg("TSFleM66",dat.getAbsolutePath(),
              fl,fl-cl); /* create error-message as marker */
        break; /* not enough data available */
      } /* not enough data available */
      try { i = IS.read(buffer,count,cl); /* read complete file to buffer */
      } catch (IOException e) { /* error occurred while reading */
        Msg = TSLogg.getMsg("TSFleM63",dat.getAbsolutePath(),
              e.toString()); /* create error-message as marker */
        break; /* not enough data available */
      } /* read-error */
      if(i<0) { /* EOF found -- handle it */
        Msg = TSLogg.getMsg("TSFleM67",dat.getAbsolutePath(),
              fl,fl-cl); /* create error-message as marker */
        break; /* not enough data available */
      } /* not enough data available */
      count += i; /* compute new target-position */
      cl    -= i; /* and remaining length */
    } while(cl>0); /* repeat until done */
    try { IS.close(); /* close inputfile again */
    } catch (IOException e) { /* close-error -- message? */
      if(Msg==null) Msg = TSLogg.getMsg("TSFleM64",
        dat.getAbsolutePath(),e.toString()); /* create error-message */
    } /* close-error */
    if(cl>0 && Msg==null) Msg = TSLogg.getMsg("TSFleM65",
       dat.getAbsolutePath(),fl,fl-cl); /* set message if needed */
    return Msg; /* return with error-marker */
  }

 /**. <pre>
  *=====================================================================
  * Method "reInit"
  * Clear buffer and reset any pointer.
  * Attention: the current buffer is neither changed nor deleted.
  * ##reInit.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected synchronized void reInit() /* reset complete definition */
    {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    count = 0;  /* no valid data within buffer */
    cPos  = 0;  /* reset current read-position */
    mark  = -1; /* no position marked */
  }

 /**. <pre>
  *=====================================================================
  * Method "reset"
  * Handle control of position. (reset position to saved value)
  * Returns 'false', if function was successful.
  * Attention: This method is copied from (and requested by) source of
  *            class 'ByteArrayInputStream'/'ByteArrayOutputStream'.
  * ##reset.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected synchronized final boolean reset( /* reset position */
   boolean clr) /* clear marker-position if 'true' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(mark<0) return true; /* pointer could not be modified */
    cPos = mark; /* reset pointer to last 'mark'-position */
    if(clr) mark = -1; /* clear current marker */
    return false; /* provide result: position modified */
  }

 /**. <pre>
  *=====================================================================
  * Method "rewind"
  * Reset current input-position to start of data-buffer.
  * Attention: If 'squeeze' has been used, some data within the
  *            input-buffer may already be lost.
  * --- Method is NOT referenced until now. (marked by 'XXX...') ---
  * ##rewind.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  public synchronized void XXXrewind() /* rewind input (-pointer) */
    {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    cPos = 0;  /* reset current read-position */
    mark = -1; /* no position marked */
  }

 /**. <pre>
  *=====================================================================
  * Method "size"
  * Returns the current size of the valid data within the buffer.
  * ##size.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int size() /* return size of the buffer */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    return count; /* return requested value */
  }

 /**. <pre>
  *=====================================================================
  * Method "skip"
  * Skips <code>n</code> bytes of input from this byte-array. Fewer
  * bytes might be skipped if the end of the buffer is reached.
  * The actual number <code>k</code>
  * of bytes to be skipped is equal to the smaller
  * of <code>n</code> and  <code>count-pos</code>.
  * The value <code>k</code> is returned.
  * Attention: This method is copied from (and requested by) source of
  *            class 'ByteArrayInputStream'/'ByteArrayOutputStream'.
  * ##skip.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected synchronized final long skip( /* skip bytes of input */
   long n) /* number of input-bytes to be skipped */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    if(cPos+n>count) n = count - cPos; /* use smaller one */
    if(n<0) return 0; /* minimum value of bytes to be skipped */
    cPos += n; /* compute new 'already read bytes' */
    return n; /* return number of bytes really skipped */
  }

 /**. <pre>
  *=====================================================================
  * Method "squeeze"
  * Removes already read elements from the buffer and compacts it.
  * Attention: This method must not be called, if this class is used
  *            as a write-buffer or data may be lost.
  * --- Method is NOT referenced until now. (marked by 'XXX...') ---
  * ##squeeze.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected synchronized final boolean XXXsqueeze( /* reorganize buffer */
   int env) /* size of environment around 'cPos'-value */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    if(env<0) return true; /* invalid value -- report error */
    env = cPos - env; /* compute lower bound of environment */
    if(env<=0) return false; /* buffer is already compact */
    count -= env; /* compute new length of VALID bytes */
    cPos -= env;  /* establish new read-position */
    if(mark>=0) mark -= env; /* correct marker-position */
      /* Attention: marker-position may be lost, if environment
       *            is too small.
       */
    System.arraycopy(buffer,env,buffer,0,count);
    return false; /* reorganize was successfully  done */
  }

 /**. <pre>
  *=====================================================================
  * Method "unRead"
  * Free already read data from the buffer and make them available for
  *   read again.
  * ##unRead.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int unRead( /* unread data for reread */
   int len) /* length of data to be read again */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    if(len<1) return 0; /* no action required */
    if(len>cPos) len = cPos; /* maximum data to be freed */
    cPos -= len; /* make data available -- decrease valid length */
    return len; /* provide number of actually used bytes */
  }

 /**. <pre>
  *=====================================================================
  * Method "write"
  * Write byte (copy), which is located within an integer, into buffer
  *   and add it to the already buffered data.
  * If needed, the size of the buffer is expanded.
  * This method is requested by abstract class 'OutputStream'.
  * ##write.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  public synchronized void write( /* write byte (from integer) to bfr */
   int cByte) /* current byte to be written */
   {
   /*-----------------------------------------------------------------*/
    int nc; /* temporary value (new count-value) */
   /*=================================================================*/
    nc = count + 1; /* compute number of requested bytes */
    if(nc>buffer.length) chgBuffer(nc); /* extend buffer */
    buffer[count] = (byte)(cByte & 0x0FF); /* set new byte */
    count = nc; /* set new counter of valid bytes */
  }

 /**. <pre>
  *=====================================================================
  * Method "write"
  * Write/Copy data from a string-value into the byte-array-buffer
  *   and append it.
  * If needed, the size of the buffer is expanded.
  * ##write.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  public synchronized int write( /* write data to buffer and append */
   String s) /* String to be appended after convert */
   {
   /*-----------------------------------------------------------------*/
    int    p;   /* temp. value (position-pointer) */
    byte[] buf; /* result of 'convert string' */
   /*=================================================================*/
    buf = s.getBytes(); /* convert string to binary */
      /* Attention: No error can occur */
    p = count + buf.length; /* compute overall length of result */
    if(p>buffer.length) chgBuffer(p); /* extend buffer */
    System.arraycopy(buf,0,buffer,count,buf.length);
    count = p; /* set new counter of valid bytes */
    return buf.length; /* return length of appended data */
  }

 /**. <pre>
  *=====================================================================
  * Method "writeTo"
  * Writes the (remaining) contents of this byte-array-buffer to
  * the specified output stream argument, as if by calling the output
  * stream's write method using
  * <code>out.write(buffer,cPos,count-cPos)</code>.
  * Attention: This method is copied from source of class
  *            'ByteArrayOutputStream'. However, it is still modified
  *            and returns an error-message or 'null'. It DO NOT
  *            throws an error-condition.
  * ##writeTo.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  public synchronized final String writeTo( /* write remaining buffer */
   OutputStream out) /* current Stream to write buffer */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    try { out.write(buffer,cPos,count-cPos); /* write buffer as a file */
    } catch (IOException e) { /* error occurred while writing */
      return TSLogg.getMsg("TSFleM73",e.toString()); /* error-message */
    } /* write-error -- terminate function */
    cPos = count; /* write successful -- advance pointer */
    return null; /* return without error-marker */
  }

 /**. <pre>
  *=====================================================================
  * Method "writeTo"
  * Copy part of this byte array buffer to the specified outputstream
  *   argument, as if by calling the output stream's write method
  *   using <code>out.write(buffer,cPos,len)</code>.
  * ##writeTo.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected synchronized final String writeTo( /* copy part of buffer */
   OutputStream out, /* current Stream to write buffer */
   int          len) /* length of outputarea to write */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    if(len<0) return TSLogg.getMsg("TSFleM71",len); /* error-message */
    if(cPos+len>count) return TSLogg.getMsg("TSFleM72",len,count);

    try { out.write(buffer,cPos,len); /* write requested buffer */
    } catch (IOException e) { /* error occurred while writing */
      return TSLogg.getMsg("TSFleM73",e.toString()); /* error-message */
    } /* write-error -- terminate function */
    cPos += len; /* write successful -- advance pointer */
    return null; /* return without error-marker */
  }

 /**. <pre>
  *=====================================================================
  * Method "writeTo"
  * Read complete buffer and write it to targetfile.
  * Returns error-message if request fails ('null' if no error).
  * --- Method is NOT referenced until now. (marked by 'XXX...') ---
  * ##writeTo.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String XXXwriteTo( /* copy complete buffer to file */
   File dat) /* definition of targetfile */
   {
   /*-----------------------------------------------------------------*/
    FileOutputStream OS;  /* writer to file */
    String           Msg; /* current error-message or 'null' */
   /*=================================================================*/
    if(dat==null) return TSLogg.getKey("TSFleM81");
    try { OS = new FileOutputStream(dat);
    } catch (FileNotFoundException e) { /* file not found/created */
      return TSLogg.getMsg("TSFleM82",dat.getAbsolutePath(),
        e.toString()); /* return with error-message */
    } /* open-errorr */
    Msg = null; /* preset: no error */
    try { OS.write(buffer,0,count); /* write complete buffer */
    } catch (IOException e) { /* error occurred while writing */
      Msg = TSLogg.getMsg("TSFleM83",dat.getAbsolutePath(),
            e.toString()); /* create error-message as marker */
    } /* write-error */
    try { OS.close(); /* close outputfile again */
    } catch (IOException e) { /* close-error -- message? */
      if(Msg==null) Msg = TSLogg.getMsg("TSFleM84",
        dat.getAbsolutePath(),e.toString()); /* create error-message */
    } /* close-error */
    return Msg; /* return with/without error-marker */
  }

 /**. <pre>
  *=====================================================================
  * Method "toString"
  * Returns the current value of the IO-buffer.
  * ##toString.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  public final String toString() /* get value of IO-Buffer */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    return new String(buffer,0,count); /* get IO-buffer */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build an String-representation of all values of this class.
  * ##toStr.TSByteArrIO (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* get string-Representation */
   {
   /*-----------------------------------------------------------------*/
                                           /* no local definitions */
   /*=================================================================*/
    return "TSByteArrIO{"+count+","+cPos+","+mark+"}";
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSTexture -- Compress, decompress, read or write a texture-file
 * Attention: Output is NOT supported until now!!
 * ##TSTexture (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTexture implements Serializable { /* Handle Texture-files */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.6.05 01.01.2012";
 /*-------------------------------------------------------------------*/
  private static final byte[]   FlePfx1 = "SIMISA@".getBytes();
    /* start (first part) of File-ID  (byte-version) */
  private static final byte[]   FlePfx2 = "@@@@".getBytes();
    /* second part of File-ID  (byte-version) */
 /*-------------------------------------------------------------------*/
  protected static final int    IN = -1; /* input,(un)commpressed */
  protected static final int    OB =  0; /* output,uncompressed */
  protected static final int    OC =  1; /* output,compressed */
 /*-------------------------------------------------------------------*/
  private File                  Fle;    /* current used file-def. */
  private String                FNme;   /* Filename (fully-q) */
  private String                EMsg;   /* Errormessage or 'null' */
  private int                   mode;   /* Accessmode:
    * 0 - file is closed (again)
    * 2 - file is 'uncompressed input'
    * 3 - file is 'compressed input'
    * 4 - file is 'uncompressed output'
    * 5 - file is 'compressed output'
    */
  private int                   rc,rl;  /* statistics (counter, length) */
  private int                   Len;    /* Length of file */
  private TSByteArrIO           BIO;    /* binary IO-buffer */
  private InputStream           IS;     /* binary Reader */
/**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSTexture() /* Create Texture-File-control (Dummy) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* Initialize required objects */
    mode = 0;    /* Init-Accessmode (File is closed) */
    /* initialize objects, which may be asynchously requested */
    Len  = -1;   /* length of file is not known */
    /* allocate variables */
    BIO = new TSByteArrIO(250); /* create new intermediate buffer */
    /* all other variables are initialized by default ('0' / 'null') */
  }

/**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry 
  *=====================================================================
  </pre>*/
  protected TSTexture( /* Create Texture-File-control */
   File dat, /* File-Definition */
   int  iom) /* IO-Mode */
   {
    this(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
    int    i;  /* intermediate value */
    byte[] tB; /* temporary byte-buffer */
   /*=================================================================*/
    Fle = dat; /* store File-Definition */
    FNme = Fle.getAbsolutePath(); /* store fully qualified Filename */
    EMsg = null; /* clear current error-message */
    if(iom<-1 || iom>1) { /* argument is invalid */
      EMsg = TSLogg.getMsg("TSTxtO01",iom); /* set errormessage */
      return; /* terminate constructor */
    } /* error within argument */

    if(iom>=0) { /* Output requested -- open file in output-mode */
      if(Fle.exists()) if(Fle.isDirectory()) { /* directory! */
        /* File-definition describes a directory-entry -- return error */
        EMsg = TSLogg.getMsg("TSTxtO02",FNme); /* set error-message */
        return; /* terminate constructor */
      } /* error within file-definition */

      EMsg = TSLogg.getMsg("TSTxtO11",iom); /* set errormessage */

      mode = iom + 4; /* set mode to 'output' */
      rc = 1;  /* Header is already written (formerly) */
      rl = 16; /* register length of header as max. record-length */
      return; /* file is open -- no error */
    } /* 'Output' was requested */

    /* Open file for input and check Input-mode */
    if(!Fle.exists()) { /* File not found */
      EMsg = TSLogg.getMsg("TSTxtO21",FNme); /* set error-message */
      return; /* terminate constructor */
    } /* error within file-definition */
    if(Fle.isDirectory()) { /* File is folder */
      EMsg = TSLogg.getMsg("TSTxtO22",FNme); /* set error-message */
      return; /* terminate constructor */
    } /* error within file-definition */

    try {IS = new FileInputStream(Fle); /* open raw input (binary) */
    } catch (FileNotFoundException e) { /* IO-error received */
      /* error should NOT occur due to previous testing */
      EMsg = TSLogg.getMsg("TSTxtO23",FNme,e.toString()); /* set error-message */
      return; /* terminate constructor */
    } /* Exception definition/opening file */

    try {i = BIO.readFrom(IS,16); /* read 16 bytes into buffer */
    } catch (IOException e) { /* IO-error received */
      try { IS.close(); } catch (IOException E) { }
      EMsg = TSLogg.getMsg("TSTxtO24",FNme,e.toString()); /* set error-message */
      return; /* /* read-error found -- terminate constructor */
    } /* Exception definition/opening file */
    if(i!=16) { /* not enough data available */
      try { IS.close(); } catch (IOException E) { }
      EMsg = TSLogg.getMsg("TSTxtO25",FNme,i); /* set error-message */
      return; /* /* read-error found -- terminate constructor */
    } /* not enough data available */

    /* relative read-position is '0' */
    tB = BIO.getBytes(7); /* get start of File-ID from buffer */
    if(!Arrays.equals(tB,FlePfx1)) { /* invalid type-ID */
      EMsg = TSLogg.getMsg("TSTxtO26",FNme,new String(tB));
      return; /* /* read-error found -- terminate constructor */
    } /* data is not valid */

    if((i=BIO.read())==64) { /* filetype 'uncompressed' found (buffer[7]=='@') */
      /* Attention: Read-Pointer is advanced in every case */
      /* process 'read' only */
      Len = (int)(Fle.length() - 16); /* init source-length of file */
      IS = new BufferedInputStream(IS); /* use buffered input */
      mode = 2; /* set mode to 'uncompressed input' */
      BIO.skip(4); /* skip length-field of file-ID */
    } else { /* handle filetype 'CB' */
      /* 'decompress' and 'read' has to be done */
      if(i!=70) ; /* check if filetype 'compressed' (buffer[7]=='F') */
      Len = (int)BIO.getInt(4); /* init source-length of file */
      IS = new BufferedInputStream(new InflaterInputStream(IS));
        /* use buffered input and decompress implicitely */
      mode = 3; /* set mode to 'compressed input' */
    } /* filetype is successfully processed */

    tB = BIO.getBytes(4); /* get last part of File-ID from buffer */
    if(!Arrays.equals(tB,FlePfx2)) { /* invalid type-ID */
      EMsg = TSLogg.getMsg("TSTxtO27",FNme,new String(tB));
      return; /* /* read-error found -- terminate constructor */
    } /* data is not valid */


  }

 /**. <pre>
  *=====================================================================
  * Method "close"
  * Close reader/writer again
  * Method returns error-message or 'null'
  * ##close.TSTexture (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String close() /* Close Reader/Writer again */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    EMsg = null; /* clear current error-message */
    if(Fle==null) return TSLogg.getKey("TSTxtC01"); /* no active file */

    switch(mode) { /* close file according to current mode */
      case(0): break; /* ignore command if already close */
      case(2): /* uncompressed input is active */
      case(3): /* compressed input is active */
        try { IS.close(); /* close input-file */
        } catch (IOException e) { System.err.println(e.toString()); }
        break;
      case(4): /* uncompressed output is active */
      case(5): /* compressed output is active */
        break;
      default: /* invalid mode -- provide error-message */
        return TSLogg.getMsg("TSTxtC11",mode); /* return error-message */
    } /* close of file is executed */
    mode = 0; /* mark file as closed (mode) */
    return null; /* return without error */
  }

 /**. <pre>
  *=====================================================================
  * Method "getErr"
  * Get active error-message ('null' if none)
  * ##getErr.TSTexture (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getErr() /* get current error-message */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return EMsg; /* provide error-message or 'null' */
  }

 /**. <pre>
  *=====================================================================
  * Method "getStat"
  * Get statistic-values of current I/O
  * Attention: values are valid even if file is already closed
  *            values are initialized when file is opened (again)
  * ##getStat.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getStat( /* get current statistic-values */
   boolean c) /* return 'counter' if 'true' (else 'length') */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(c) return rc; /* return current record-counter */
    return rl; /* provide maximum record-length */
  }

 /**. <pre>
  *=====================================================================
  * Method "read"
  * Read whole file into buffer and return it ('null' if none)
  * ##read.TSTexture (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final byte[] read() /* read whole file */
   {
   /*-----------------------------------------------------------------*/
    int    i;   /* Length of file read */
    byte[] buf; /* input-buffer */
   /*=================================================================*/
    buf = new byte[Len]; /* allocate buffer for input */
    try {i = IS.read(buf); /* read whole file */
    } catch (IOException e) { /* handle read-error */
      System.err.println(e.toString());
      close(); /* try close of file */
      EMsg = TSLogg.getMsg("TSTxtO24",FNme); /* set error-message */
      return null; /* /* read-error found -- return marker */
    } /* Exception while reading */
    rl += i; /* compute bytes already read */
    rc += 1; /* compute number of calls to read-method */
    return buf; /* provide buffer */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTexture (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSTexture{'"+FNme+"',"+Len+",("+mode+")}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSFleMask -- Filter filenames while scanning through a
 *  directory
 * Attention: Interface 'FileFilter' is used to get all folders from
 *  an directory.
 * ##TSFleMask (Eyecatcher)
 *=====================================================================
 </pre>*/
class TSFleMask implements FilenameFilter,FileFilter { /* select names */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 12.01.2009";
 /*-------------------------------------------------------------------*/
  private Pattern               FP;     /* current File-Pattern */
  private boolean               Dir;    /* include directory ? */
  private String                Err;    /* pending Error-Message */
/**. <pre>
  *=====================================================================
  * Constructor: (1) Create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSFleMask() /* Create Filterdefinition (Dummy) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Err = TSLogg.getKey("TSFMask0"); /* initialization-error */
    /* all other variables are initialized by default ('0' / 'null') */
  }

/**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSFleMask( /* Create Filterdefinition */
   boolean dir, /* include directories if 'true' */
   String  fp)  /* Pattern for File-Selection (regular expression) */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Err = null; /* preset: no error */
    Dir = dir;  /* store directory-status */
    try { FP = Pattern.compile(fp,Pattern.CASE_INSENSITIVE);
     } catch (PatternSyntaxException p) { /* error in compile */
      Err = TSLogg.getMsg("TSFMask1",fp,p.getDescription());
        /* create error-Message and store it as marker */
      FP = null; /* invalidate pattern */
    } /* Selection-definition contains error(s) */
  }

 /**. <pre>
  *=====================================================================
  * Method "accept" (FilenameFilter)
  * Check filename and select it as valid or not
  * Attention: Method is requested by interface 'FilenameFilter'
  * ##accept.TSFleMask (Eyecatcher)
  *=====================================================================
  </pre>*/
  public final boolean accept( /* select filename for inclusion */
   File   prt,  /* definition of parent-directory */
   String Name) /* Filename to be checked */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(FP==null) return false; /* no valid selection possible */
    if(new File(prt,Name).isDirectory()) return Dir;
      /*  create ref. to file/directory and use Dir-status as marker */
    /* 'Name' is 'filename'*/
    if(FP.matcher(Name).matches()) return true; /* include it */
    return false; /* default: do NOT include */
  }

 /**. <pre>
  *=====================================================================
  * Method "accept" (FileFilter)
  * Check path and accept if directory
  * Attention: Method is requested by interface 'FileFilter'
  * ##accept.TSFleMask (Eyecatcher)
  *=====================================================================
  </pre>*/
  public final boolean accept( /* select filename for inclusion */
   File cF)  /* definition of the selected path */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return cF.isDirectory(); /* accept directories ONLY */
  }

 /**. <pre>
  *=====================================================================
  * Method "convert" (static)
  * Convert Filename-Mask to regular expression
  * Usage:
  *      result = TSFleMask.convert(source,false);
  *   check result -- if NOT valid: get error-message
  *      if(result==null) message = TSFleMask.convert(source,true);
  * ##convert.TSFleMask (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected static final String convert( /* convert filename-mask */
   String  Name, /* Filename-mask to be converted */
   boolean err)  /* provide error-message if applicable */
   {
   /*-----------------------------------------------------------------*/
    char[] tfn;  /* temporary storage of result */
    char   cch;  /* current character */
    int    i,j,k;
   /*=================================================================*/
    k = Name.length(); /* Length of pattern */
    if(Name.endsWith("*.*")) k -= 2; /* skip last 2 chars */
      /* On Windows, a pattern ending with '*.*' is equal to '*' */
    tfn = new char[k+k]; /* allocate temporary result */
    j = 0; /* and initialize index */
    for(i=0;i<k;i+=1) { /* process all charcters */
      cch = Name.charAt(i); /* get current character */
      if(cch=='*') tfn[j++] = '.'; /* add prefix for '*' */
      else if(cch=='?') cch = '.'; /* replace with new one */
      else if(".()[]+".indexOf(cch)>=0) tfn[j++] = '\\'; /* add 'escape' */
      else if("\\/<>|:\"".indexOf(cch)>=0) { /* character is invalid */
        if(err) return TSLogg.getMsg("TSFMask2",Name,""+cch);
          /* create error-Message and return it */
        return null; /* signal error */
      } /* selection contains an error */
      tfn[j++] = cch; /* set current char to result (additionally) */
    } /* process all characters */
    return new String(tfn,0,j); /* return valid result */
  }

 /**. <pre>
  *=====================================================================
  * Method "getErr"
  * Get active error-message (or 'null' if none)
  * ##getErr.TSFleMask (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getErr() /* get current error-message */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Err; /* provide error-message or 'null' */
  }

 /**. <pre>
  *=====================================================================
  * Method "modify"
  * Modify an input-string due to current pattern
  * ##modify.TSFleMask (Eyecatcher)
  *=====================================================================
  </pre>*/
  public final String modify( /* modify string due to pattern */
   String src,  /* definition of the source-line */
   String rep)  /* definition of the replacement-pattern */
   {
   /*-----------------------------------------------------------------*/
    Matcher m; /* internal-line-represantation */
   /*=================================================================*/
    if(FP==null) return null; /* no modification possible */
    m = FP.matcher(src); /* compare to data-line */
    if(!m.lookingAt()) return null; /* 'match' is NOT successful */
    return m.replaceAll(rep); /* return result (modified line) */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSFleMask (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSFleMask{"+FP.toString()+"-"+Dir+"-"+(Err==null)+"}";
  }

 /*===================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSBuf -- Bufferobject and checking-methods
 * This class handles a buffer and provides token from within this
 *   buffer. The current pointer is hidden from outside. So this class
 *   comply with the principle of 'information-hiding'.
 *
 * This class uses three different modes:
 *  single (s): Buffer is filled once when created;
 *                no refill of buffer possible.
 *  line   (l): 'TSFile' is specified when class is instanced;
 *                Buffer may be refilled with next input-record
 *                using a special method. ('getNext()') Modification
 *                and rewrite of current data-buffer is supported.
 *  file   (f): 'TSFile' is specified when class is instanced; Buffer
 *                is refilled automatically when current end is reached.
 *                This mode is marked with 'Mde'=='true'.
 *
 * Remark: If no additional input is available due to current mode,
 *         EOF will be generated in any case.
 * Attention: 'Buf' is the current input-buffer and 'Lne' is the
 *             save-value of this data. 'Lne' is updated only, when
 *             there is new VALID data for 'buf'. So, this string
 *             contains the last valid data, even if 'buf' is set to
 *             'null' due to an error. However, it must be assured
 *             that all changes of the content of 'buf' are reflected
 *             within 'Lne', too.
 * Attention: this class refers to classes: TSUtil, TSFile, TSLogg
 * ##TSBuf (Eyecatcher)
 *======================================================================
 </pre>*/
class TSBuf implements Serializable { /* definition of a bufferobject */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.6.05 15.01.2012";
  private static final String[] DefArr = {""}; /* empty array */
 /*-------------------------------------------------------------------*/
  private String                Buf;    /* current buffer */
  private String                Lne;    /* current buffer (save) */
  private int                   Pos;    /* Position-Pointer */
  private int                   SveP;   /* Save of Position-Pointer */
  private int                   BrC;    /* Bracket-counter */
  private int                   SveB;   /* Save of Bracket-counter */
  private boolean               Mde;    /* current 'mode' */
  private TSFile                Rdr;    /* Default-Reader */
  private TSFile                Wtr;    /* Default-Writer */
  private String                EMsg;   /* current error-message */
  private boolean               Usr;    /* current user-flag */
    /* Attention: This field is NOT used by TSBuf. Applications may use
     *            it, to extend capabilities of class.
     */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSBuf() /* create Basis-Definition */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Mde  = false; /* set mode to: 'single-line' */
    SveP = -1;    /* value is NOT valid ('mark' NOT active) */
    EMsg = TSLogg.getKey("TSBuf001"); /* set default-message */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) create Standard-Entry ('single'-mode)
  *=====================================================================
  </pre>*/
  protected TSBuf( /* create standard-definition */
   String val) /* initial contents of buffer */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Mde  = false; /* set mode to: 'single-line' */
    Buf  = val;   /* set initial contend */
    Lne  = val;   /* save initial contend */
    Pos  = 0;     /* adjust pointer to start */
    SveP = -1;    /* value is NOT valid ('mark' NOT active) */
    Rdr  = null;  /* no reader specified */
    Wtr  = null;  /* no writer specified */
    BrC  = 0;     /* initialize bracket-counter (for comments) */
    EMsg = null;  /* no error registered */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) Create TSFile-entry ('file'-mode)
  *=====================================================================
  </pre>*/
  protected TSBuf( /* create extended-definition (File-version) */
   TSFile R) /* reader to fill buffer again */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Mde  = true; /* set mode to: 'file' */
    Buf  = null; /* no buffer defined (first line marker) */
    Lne  = null; /* no 'buffer-save' defined */
    Pos  = 0;    /* adjust pointer to start */
    SveP = -1;   /* value is NOT valid ('mark' NOT active) */
    Rdr  = R;    /* store default reader */
    Wtr  = null; /* no writer specified */
    BrC  = 0;    /* initialize bracket-counter (for comments) */
    EMsg = null; /* no error registered */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (4) Create TSFile-entry ('line'-mode and update)
  *=====================================================================
  </pre>*/
  protected TSBuf( /* create extended-definition (line-version) */
   TSFile R, /* reader to fill buffer again */
   TSFile W) /* writer to save modified data (or 'null') */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Mde  = false; /* set mode to: 'line' */
    Buf  = null;  /* no buffer defined (first line marker) */
    Lne  = null;  /* no 'buffer-save' defined */
      /* 'Lne==null' is used as a marker, so that NO 'write of Data'
       * occurrs, when method 'getNext()' is used.
       */
    Pos  = 0;     /* adjust pointer to start */
    SveP = -1;    /* value is NOT valid ('mark' NOT active) */
    Rdr  = R;     /* store default reader */
    Wtr  = W;     /* store writer if (really) specified */
    BrC  = 0;     /* initialize bracket-counter (for comments) */
    EMsg = null;  /* no error registered */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Method "advPtr" (s,l)
  * Advance current pointer to point to argument. Returns 'false' if
  *   argument is NOT found and then the pointer is not changed.
  * Method can only be used when '(single-)line'-mode is active
  * Attention: Keyword should be specified using 'lowercase'-characters
  *            or NO match will occur
  * ##advPtr.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean advPtr( /* advance pointer to keyword */
   String cKw) /* current keyword to search for (lowercase) */
   {
   /*-----------------------------------------------------------------*/
    int p; /* new position for buffer-pointer */
   /*=================================================================*/
    if(Mde) throw new /* function not allowed if 'file'-mode used */
      IllegalStateException(TSLogg.getMsg("Msg903","TSBuf.advPtr()",0));
    if(cKw==null) throw new /* argument is requested */
      IllegalStateException(TSLogg.getMsg("Msg903","TSBuf.advPtr()",1));
    if(Buf==null) return false; /* buffer not valid -- report it */
    if(Pos==Buf.length()) return false; /* no remaining chars */
    if((p=Buf.toLowerCase().indexOf(cKw,Pos))<0) return false;
      /* kewword not found -- report it */
    Pos = p; /* set new continuation */
    return true; /* new position was successfully established */
  }

 /**. <pre>
  *=====================================================================
  * Methode "charAt"
  * Provide current character and advance char-pointer if requested
  * Attention: This method does NOT fill the buffer. If EOL is
  *            reached '\n' is returned.
  * ##charAt.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final char charAt( /* provide current character */
   boolean skp) /* increment position beyond character if 'true' */
   {
   /*-----------------------------------------------------------------*/
    char cc; /* intermediate value */
   /*=================================================================*/
    if(Buf==null) return '\n'; /* signal end-of-line */
    if(Pos>=Buf.length()) return '\n'; /* signal end-of-line */
    if(nxtChar()) return '\n'; /* no more valid chars -- signal it */
    cc = Buf.charAt(Pos); /* save current character */
    if(skp) Pos += 1; /* skip current character */
    return cc; /* provide result */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkComment"
  * Check, if provided token does not signal a comment.
  * If the start of a comment is found, 'false' is returned.
  * ##chkComment.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final boolean chkComment( /* check for comment */
   String s) /* keyword (token) to be checked */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(s.equalsIgnoreCase("skip")) return false; /* comment found */
    if(s.equalsIgnoreCase("comment")) return false; /* comment found */
    if(s.charAt(0)=='_') return false; /* comment found */
    return true; /* no comment found -- signal it */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chkSep"
  * Check, if next character contains a whitespace as seperator.
  * Attention: If this method returns 'true', the position-pointer is
  *            NOT incremented in every case.
  * ##chkSep.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean chkSep( /* check if whitespace */
   boolean skp) /* increment position beyond character if 'true' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Buf==null) return true; /* signal end-of-line */
    if(Pos>=Buf.length()) return true; /* signal end-of-line */
    if(!Character.isWhitespace(Buf.charAt(Pos))) return true;
      /* check if whitespace and return if unsuccessful */
    if(skp) Pos += 1; /* skip current character */
    return false; /* signal success */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getArr"
  * Holen vollstaendige Version eines String-Arrays
  *         *** Routine akzeptiert Kommentare und uebergeht diese ***
  * Ergebnis: Returnwert EMsg      Bedeutung
  *           <>null     null      Datenwert
  *           null       null      Datei-/Zeilenende erreicht
  *           null       <>null    Fehlermeldung
  * ##getArr.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String[] getArr() /* read complete String-Array */
   {
   /*-----------------------------------------------------------------*/
    ArrayList<String> StrLst; /* temporary list of text-lines */
    String            s;      /* intermediate value */
    boolean           StrT;   /* separator allowed */
   /*=================================================================*/
    StrLst = new ArrayList<String>(); /* create temporary list */
    StrT = true; /* token for connection of lines NOT allowed */
    while(true) { /* process all description-lines */
      s = getVal(5); /* get value of argument */
      if(s==null) return null; /* error found within current input */
      if(s.length()==0) break; /* all lines processed */
      if(s.equals("+")) { /* separator found */
        if(StrT) { /* separator not allowed! */
          EMsg = TSLogg.getMsg("TSBuf061",StrLst.size()); /* error */
          return null; /* return error-flag */
        } /* separator was NOT allowed */
        StrT = true; /* separator no longer allowed */
      } else { /* NO single character found (separator) */
        StrLst.add(s); /* save description-line */
        StrT = false; /* separator now valid */
      } /* valid line found */
    } /* process all lines of description */
    if(StrLst.isEmpty()) return DefArr; /* return 'dummy-array' */
    if(StrT) { /* list terminates incorrect */
      EMsg = TSLogg.getMsg("TSBuf062",StrLst.size()); /* error-msg */
      return null; /* return error-flag */
    } /* separator was NOT allowed */
    return StrLst.toArray(new String[0]); /* convert list and return */
  }

 /**. <pre>
  *=====================================================================
  * Method "getBrL"
  * ##getBrL.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getBrL() /* returns current Bracket-Counter/Level */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return BrC; /* return result */
  }

 /**. <pre>
  *=====================================================================
  * Method "getErr"
  * ##getErr.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getErr() /* returns current error-message */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return EMsg; /* return result */
  }

 /**. <pre>
  *=====================================================================
  * Method "getErr" (2. version)
  * ##getErr.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getErr( /* returns current error-message */
   String msg) /* default-error-message if no message set */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(EMsg==null) EMsg = msg; /* set deault-message if needed */
    return EMsg; /* return result */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getFV"
  * Holen der naechsten Float-Zahl als Double-Value
  *         *** Routine akzeptiert Kommentare und uebergeht diese ***
  * Ergebnis: EMsg      Returnwert    Bedeutung
  *           null      ...           Datenwert
  *           <>null    NaN           Datei-/Zeilenende erreicht
  *           <>null    1e99          no number to convert (L=0)
  *           <>null    2e99          convert-error (illegal chars)
  *           <>null    3e99          Fehler aus 'getVal()'
  * ##getFV.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final double getFV() /* naechste Zahl holen */
   {
   /*-----------------------------------------------------------------*/
    String s; /* intermediate value */
    double f; /* intermediate value */
   /*=================================================================*/
    while(true) { /* immer wieder versuchen */
      s = getVal(3); /* naechstes Wort holen */
        /* EMsg wird durch 'getVal()' gesetzt */
      if(s==null) { /* error from 'getVal()' received */
        if(EMsg!=null) return 3e99; /* errormessage already set */
        EMsg = TSLogg.getKey("TSBuf031"); /* set new message */
        return Double.NaN; /* Dateiende erhalten */
      } /* check error from 'getVal()' */
      if(s.length()==0) { /* no valid value found */
        EMsg = TSLogg.getMsg("TSBuf032",Pos); /* set new message */
        return 1e99; /* Wert nicht gefunden */
      } /* check if valid string */
      if(chkComment(s)) break; /* no comment found -- continue */
      /* Kommentar-Beginn gefunden -- Kommentar uebergehen */
      /* skip 'whitespace' and read new line if requested */
      if(nxtChar()) /* naechster Satz (LZ uebergehen) */
        if(getNxt(false)) { /* error -- return with flag */
          /* 'Buf==null' if result == 'true' */
          if(EMsg!=null) return 3e99; /* errormessage already set */
          EMsg = TSLogg.getKey("TSBuf031"); /* set new message */
          return Double.NaN; /* Dateiende erhalten */
        } /* error found during read */
      if(Buf.charAt(Pos)!='(') { /* required char not found */
        EMsg = TSLogg.getMsg("TSBuf032",Pos); /* set new message */
        return 1e99; /* Wert nicht gefunden */
      } /* check if valid string */
      BrC += 1; /* Klammer-Level erhoehen */
      Pos += 1; /* Zeichen uebergehen */
      if(!skpFwd(BrC)) continue; /* keinen Fehler bei Suche */
      if(EMsg!=null) return 3e99; /* errormessage already set */
      EMsg = TSLogg.getKey("TSBuf031"); /* set new message */
      return Double.NaN; /* Dateiende erhalten */
    } /* gueltiges Schluesselwort suchen */

    if(s.charAt(0)=='+') s = s.substring(1); /* Zeichen weg */
    try { f = Double.parseDouble(s); /* cnvert number */
    } catch (NumberFormatException e) { /* error within number */
      EMsg = TSLogg.getMsg("TSBuf033",s,Pos); /* set new message */
      return 2e99; /* more than valid digits found -- terminate */
    } /* more than valid digits found */
    if(!Double.isNaN(f)) return f; /* OK -- return value */
    EMsg = TSLogg.getMsg("TSBuf033",s,Pos); /* set new message */
    return 2e99; /* invalid value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getHV"
  * Extrahieren des naechsten numerischen Hex-Wertes
  *         *** Routine akzeptiert Kommentare und uebergeht diese ***
  * Ergebnis: EMsg      Returnwert    Bedeutung
  *           null      ...           Datenwert
  *           <>null    0             Datei-/Zeilenende erreicht
  *           <>null    -1            no number to convert (L=0)
  *           <>null    -2            Konvertierungsfehler
  *           <>null    -3            Fehler aus 'getVal()'
  *           <>null    -4            Laengen-Fehler des Wertes
  * ##getHV.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getHV( /* numerischen Hex-Wert extrahieren */
   int wl) /* Laenge des Hex-Wertes (2,4,8) */
   {
   /*-----------------------------------------------------------------*/
    String s;  /* intermediate value */
    int    i;  /* intermediate value */
   /*=================================================================*/
    while(true) { /* immer wieder versuchen */
      s = getVal(3); /* naechstes Wort holen */
        /* EMsg wird durch 'getVal()' gesetzt */
      if(s==null) { /* error from 'getVal()' received */
        if(EMsg!=null) return -3; /* errormessage already set */
        EMsg = TSLogg.getKey("TSBuf021"); /* set new message */
        return 0; /* Dateiende erhalten */
      } /* check error from 'getVal()' */
      if(s.length()==0) { /* no valid value found */
        EMsg = TSLogg.getMsg("TSBuf022",Pos); /* set new message */
        return -1; /* Wert nicht gefunden */
      } /* check if valid string */
      if(chkComment(s)) break; /* no comment found -- continue */
      /* Kommentar-Beginn gefunden -- Kommentar uebergehen */
      /* skip 'whitespace' and read new line if requested */
      if(nxtChar()) /* naechster Satz (LZ uebergehen) */
        if(getNxt(false)) { /* error -- return with flag */
          /* 'Buf==null' if result == 'true' */
          if(EMsg!=null) return -3; /* errormessage already set */
          EMsg = TSLogg.getKey("TSBuf021"); /* set new message */
          return 0; /* Dateiende erhalten */
        } /* error found during read */
      if(Buf.charAt(Pos)!='(') { /* required char not found */
        EMsg = TSLogg.getMsg("TSBuf022",Pos); /* set new message */
        return -1; /* Wert nicht gefunden */
      } /* check if valid string */
      BrC += 1; /* Klammer-Level erhoehen */
      Pos += 1; /* Zeichen uebergehen */
      if(!skpFwd(BrC)) continue; /* keinen Fehler bei Suche */
      if(EMsg!=null) return -3; /* errormessage already set */
      EMsg = TSLogg.getKey("TSBuf021"); /* set new message */
      return 0; /* Dateiende erhalten */
    } /* gueltiges Schluesselwort suchen */

    if((i=s.length())!=wl) { /* required stringlength not found */
      EMsg = TSLogg.getMsg("TSBuf024",s,wl,i); /* set new message */
      return -4; /* Laenge fuer Hexwert falsch */
    } /* Laenge fuer Hexwert falsch */
    try { i = (int)Long.parseLong(s,16); /* Zahl konvertieren */
    } catch (NumberFormatException e) { /* Fehler in der Zahl */
      EMsg = TSLogg.getMsg("TSBuf023",s,Pos,0); /* set new message */
      return -2; /* nicht nur gueltige Zeichen */
    } /* nicht nur gueltige Zeichen */
    return i; /* Wert zurueckgeben */
  }

 /**. <pre>
  *=====================================================================
  * Methode "getKE"
  * Extrahieren des naechsten Schluesselwortes (Keyword-Expression)
  *  !!Kommentare werden erkannt und uebergangen!!
  * Pruefung auf Ausdruck (mit folgender Klammer) moeglich
  * Ergebnis: (in Pruefungsreihenfolge):
  *   Returnwert EMsg      Bedeutung
  *    <>null     null      Datenwert
  *    String-Length==0     KEIN Schluesselwort-Ausdruck gef.
  *    null       null      Datei-/Zeilenende erreicht
  *    null       <>null    Fehlermeldung
  * ##getKE.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getKE( /* Schluesselwort extrahieren */
   boolean exp) /* Expression gesucht (Klammer folgt) */
   {
   /*-----------------------------------------------------------------*/
    String s; /* intermediate value */
   /*=================================================================*/
    while(true) { /* get keyword and skip comments if found */
      s = getVal(exp?2:1); /* get next token (keyword) */
        /* 'getVal()' activates error-marker due to result */
      if(s==null) return null; /* EOF found / errormessage created */
      if(s.length()==0) return s; /* no keyword found -- signal it */
      if(chkComment(s)) break; /* no comment found -- continue */
      /* Kommentar-Beginn gefunden -- Kommentar uebergehen */
      /* skip 'whitespace' and read new line if requested */
      if(nxtChar()) /* naechster Satz (LZ uebergehen) */
        if(getNxt(false)) return null; /* error -- return with flag */
      if(Buf.charAt(Pos)!='(') break; /* Kommentar nicht gefunden */
      BrC += 1; /* Klammer-Level erhoehen */
      Pos += 1; /* Zeichen uebergehen */
      if(skpFwd(BrC)) return null; /* Dateiende/Fehler bei Suche */
    } /* skip comments */

    if(exp) { /* expression must follow '(' needed */
      /* skip 'whitespace' and read new line if requested */
      if(nxtChar()) /* naechster Satz (LZ uebergehen) */
        if(getNxt(false)) return null; /* error -- return with flag */
      if(Buf.charAt(Pos)!='(') { /* Syntxfehler gefunden */
        EMsg = TSLogg.getMsg("TSBuf051",s);
        return null; /* return error-flag */
      } /* Syntxfehler gefunden */
      BrC += 1; /* Klammer registrieren */
      Pos += 1; /* und uebergehen */
    } /* Ausdruck erfolgreich geprueft */
    return s; /* return extracted keyword */
  }

 /**. <pre>
  *=====================================================================
  * Method "getLne"
  * Method returns 'Line-data' starting at position 'p'
  * Line-data is a copy of buffer-data
  * Line-data is ONLY changed, if reading of file succeeds
  * ##getLne.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getLne( /* returns valid buffer-data */
   int p) /* start-position */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Lne==null) return ""; /* Line was never filled with data */
    if(p<=0) return Lne; /* return result completely */
    if(p>=Lne.length()) return ""; /* no result available */
    return Lne.substring(p); /* return partitial line */
  }

 /**. <pre>
  *=====================================================================
  * Method "getNext" (s,l)
  * Write back current line if possible and requested.
  * Read line from input-file and provide it as 'inputline'.
  * Flush-function is executed in every case (set pointer to EOL)
  * If 'mde' is set, method ends after flush-function.
  * This method is ONLY valid if 'line'-mode is active.
  *
  * Return-conditions :
  *   Returnvalue EMsg      Meaning
  *    false      null      Data was sucessfully read/skipped
  *    true       null      EOF was reached
  *    true       <>null    EMsg contains errormessage
  * Attention: This method does NOT check, if previous buffer is
  *            valid and fully processed. However, because 'Buf' may be
  *            'null' due to search for next valid token, the save-value
  *            'Lne' must be written. It must be assured that all changes
  *            of the content of 'buf' must be reflected within 'Lne',
  *            too.
  * ##getNext.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean getNext( /* read next inputline from input */
   boolean mde) /* input-mode: 'flush only' if 'true' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    EMsg = null; /* preset error-switch */
    if(Mde) throw new /* function not allowed if 'file'-mode used */
      IllegalStateException(TSLogg.getMsg("Msg903","TSBuf.getNext()",0));
    if(Rdr==null) throw new /* function not allowed if 'single-line'-mode used */
      IllegalStateException(TSLogg.getMsg("Msg903","TSBuf.getNext()",1));

    if(Buf!=null) Pos = Buf.length(); /* set pointer to EOL */
    if(mde) return false; /* 'flush'-function executed -- back */

    if(Wtr!=null && Lne!=null) { /* Write requested -- write line */
      EMsg = Wtr.putData(Lne); /* write line and get error-message */
      if(EMsg!=null) return true; /* error occurred -- signal it */
//      Lne = null; /* data written, do not write again */
    } /* write-back of data executed */
    SveP = -1; /* Buf may change -- invalidate buffer-marker */
    Buf = Rdr.getData(); /* read next line into buffer */
    if(Buf==null) { /* error found during read */
      EMsg = Rdr.getErr(); /* get current error-message */
      if(EMsg==null) return true; /* EOF reached -- signal it */
      EMsg = TSLogg.getMsg("TSBuf071",EMsg); /* modify message */
      return true; /* return error-flag */
    } /* error while reading */
    Pos = 0;   /* set pointer to start of line */
    Lne = Buf; /* buffer valid -- save contend */
    return false; /* signal: NO error */
  }

 /**. <pre>
  *=====================================================================
  * Method "getNV"
  * Extract and return the next numeric value from inputline. Use a
  * 'long'-value in order to handle unsigned integers.
  * Comments -- refer to extended version
  * ##getNV.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final long getNV() /* extract and return integer-value */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return this.getNV(false); /* use extended version */
  }

 /**. <pre>
  *=====================================================================
  * Method "getNV" (extended version)
  * Extrahieren des naechsten numerischen Wertes
  * Achtung: nur ganzahlige Werte (+/-) erlaubt!!
  *         *** Routine akzeptiert Kommentare und uebergeht diese ***
  * ACHTUNG: 'Unsigned-Integer'-Werte werden unterstuetzt
  * Ergebnis: EMsg      Returnwert    Bedeutung
  *           null      ...           Datenwert
  *           <>null    0             Datei-/Zeilenende erreicht
  *           <>null    -1            no number to convert (L=0)
  *           <>null    -2            Konvertierungsfehler
  *           <>null    -3            Fehler aus 'getVal()'
  * ##getNV.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final long getNV( /* numerischer Wert extrahieren */
   boolean m) /* mark beginning of extracted value */
   {
   /*-----------------------------------------------------------------*/
    String s;  /* extracted string */
    long   i;  /* intermediate value */
   /*=================================================================*/
    while(true) { /* immer wieder versuchen */
      s = getVal(m ? 33 : 3); /* get next token, mark if needed */
        /* EMsg wird durch 'getVal()' gesetzt */
      if(s==null) { /* error from 'getVal()' received */
        if(EMsg!=null) return -3; /* errormessage already set */
        EMsg = TSLogg.getKey("TSBuf011"); /* set new message */
        return 0; /* Dateiende erhalten */
      } /* check error from 'getVal()' */
      if(s.length()==0) { /* no valid value found */
        EMsg = TSLogg.getMsg("TSBuf012",Pos); /* set new message */
        return -1; /* Wert nicht gefunden */
      } /* check if valid string */
      if(chkComment(s)) break; /* no comment found -- continue */
      /* Kommentar-Beginn gefunden -- Kommentar uebergehen */
      /* skip 'whitespace' and read new line if requested */
      if(nxtChar()) /* naechster Satz (LZ uebergehen) */
        if(getNxt(false)) { /* error -- return with flag */
          /* 'Buf==null' if result == 'true' */
          if(EMsg!=null) return -3; /* errormessage already set */
          EMsg = TSLogg.getKey("TSBuf011"); /* set new message */
          return 0; /* Dateiende erhalten */
        } /* error found during read */
      if(Buf.charAt(Pos)!='(') { /* required char not found */
        EMsg = TSLogg.getMsg("TSBuf012",Pos); /* set new message */
        return -1; /* Wert nicht gefunden */
      } /* check if valid string */
      BrC += 1; /* Klammer-Level erhoehen */
      Pos += 1; /* Zeichen uebergehen */
      if(!skpFwd(BrC)) continue; /* keinen Fehler bei Suche */
      if(EMsg!=null) return -3; /* errormessage already set */
      EMsg = TSLogg.getKey("TSBuf011"); /* set new message */
      return 0; /* Dateiende erhalten */
    } /* gueltiges Schluesselwort suchen */

    if(s.charAt(0)=='+') s = s.substring(1); /* Zeichen weg */
    try { i = Long.parseLong(s); /* Zahl konvertieren */
    } catch (NumberFormatException e) { /* error within number */
      EMsg = TSLogg.getMsg("TSBuf013",s,Pos); /* set new message */
      return -2; /* more than digits found -- terminate */
    } /* error within number -- more than digits found */
    return i; /* Wert zurueckgeben */
  }

 /**. <pre>
  *=====================================================================
  * Method "getNxt" ((s,l),f)
  * Read date from S-/T-/W-file or ..-file using 'file'-mode. Read them
  *   into 'buf' and skip empty lines if requested.
  * Keep old data and add new one if marker is set.
  *
  * No new data is read if (single-)line-mode is active. So,
  *   EOF is returned.
  * ##getNxt.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final boolean getNxt( /* receive next line from file */
   boolean skp) /* DO NOT skip empty lines (if 'true') */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(!Mde) { /* line-mode active: EOF -- no more lines */
      EMsg = Buf = null; /* set result to EOF */
      SveP = -1; /* invalidate buffer-marker */
      return true; /* and signal it */
      /* last data is still available within 'Lne' */
    } /* no active reader available */
    /* Attention: file-mode ONLY defined for TSFile-reader */
    do { /* READ until line is valid (min. 1 new line) */
      Buf = Rdr.getData(); /* read S/T/W/..-file */
      EMsg = Rdr.getErr(); /* get current errormessage */
        /* errorflag is cleared by 'getData()'. So, 'EMsg' contains
         * valid data in every case (normal/error) */
      if(Buf==null) return true; /* 'EMsg' contains errorflag (message/EOF) */
      Pos = 0; /* set pointer to start of line */
      if(skp) break; /* DO NOT skip empty lines */
    } while(nxtChar()); /* check if empty and read again (modify 'Pos') */
    if(SveP>=0) { /* marker is set -- ADD new data to buffer */
      /* current buffer is available in 'Lne' */
      Buf = Lne + Buf; /* add data to buffer */
      Pos += Lne.length(); /* set pointer to correct position */
    } /* data was added to the old buffer */
    Lne = Buf; /* save contend, if buffer valid */
    return false; /* valid line found, pointer ok */
  }

 /**. <pre>
  *=====================================================================
  * Method "getPrnt"
  * Method returns 'Line-data' surrounded with single-quotes.
  * Line-data is a copy of buffer-data.
  * Line-data is ONLY changed, if reading of file succeeds.
  * Attention: A leading blanc is added to seperate the data-fragments.
  * ##getPrnt.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getPrnt() /* returns modified line-data */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Lne==null) return " ''"; /* Line was never filled with data */
    return " '" + Lne + "'"; /* return requested line */
  }

 /**. <pre>
  *=====================================================================
  * Method "getStat"
  * Get statistic-values of current I/O  (independend of mode)
  *  Method uses appropriate i/o-function due to current mode
  * Attention: values are valid even if file is already closed
  *            values are initialized (again) when file is opened
  * ##getStat.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int getStat( /* get current statistic-values */
   boolean c) /* return 'counter' if 'true' (else 'length') */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Rdr!=null) return Rdr.getStat(c); /* use TSFile-version */
    /* ONLY 'single-line-mode' has 'Rdr==null' */
    if(c) return 0; /* single-line-mode: record is no. 0 */
    if(Buf==null) return -1; /* buffer not valid -- signal it */
    return Buf.length(); /* provide current buffer-length */
  }

 /**. <pre>
  *=====================================================================
  * Method "getTail" (s,l)
  * Extrahieren des Rest-Wertes in String-Form
  * Achtung: Diese Methode ist NUR fuer den Zeilenmodus erlaubt.
  * Ergebnis: Returnwert EMsg      Bedeutung
  *           <>null     null      Datenwert
  *           null       null      Zeilenende erreicht
  * ##getTail.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getTail( /* get remaining part of line */
   boolean skp) /* skip 'whitespace' if requested (true) */
   {
   /*-----------------------------------------------------------------*/
    int p; /* current position within argument */
   /*=================================================================*/
    if(Mde) throw new /* function not allowed if 'file'-mode used */
      IllegalStateException(TSLogg.getMsg("Msg903","TSBuf.getTail()",0));
    EMsg = null; /* signal: no error */
    /* if requested: skip 'whitespace', signal error if no more char */
    if(skp) if(nxtChar()) return null; /* error -- return with flag */

    p = Pos; /* save current position for 'remaining characters' */
    Pos = Buf.length(); /* set 'EOL reached' */
    return Buf.substring(p); /* return remaining characters of line */
  }

 /**. <pre>
  *=====================================================================
  * Method "getUsr"
  * Get current state of user-flag.
  * This field/method is NOT used by TSBuf itself. Applications may use
  *   this field, to extend the capabilities of the class.
  * ##getUsr.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean getUsr() /* return current user-flag */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return Usr; /* returns current state of flag */
  }

 /**. <pre>
  *=====================================================================
  * Method "getVal"
  * Get next value returning a 'string'. If value STARTS with quotes,
  *   these surrounding quotes are deleted and all occurrences of '\"'
  *   are changed to '"'. However, all following chars of the value
  *   are NOT changed. The result-value ends when a
  *   'termination-character' is found (outside a quoted string).
  * Attention: If 'file'-mode is active, the (first) quoted string
  *            is not fully processed and EOF of the line is reached
  *            a new record is read into storage and searching for
  *            'end-of-string' continues.
  * Result: Return-value EMsg      Meaning
  *         <>null       null      valid data
  *         null         null      EOF/EOL (end-of-file/line) reached
  *         null         <>null    error-message (*)
  * (*): If 'line'-mode is active, NO error-message can be returned.
  * ##getVal.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String getVal( /* get net value from buffer */
   int opt) /* Options:  2 - convert to lower case
             *           3 - ':' is valid term-char
             *           5 - no concatenated 'quoted string' allowed
             *               (do not accept 'internal quoted strings')
             *           7 - ')' und '(' are NO term-chars
             *          11 - set marker to begin of value
             */
   {
   /*-----------------------------------------------------------------*/
    String        s;   /* result as 'String' */
    StringBuilder e;   /* result */
    int           p,b; /* current length of buffer, bracket-level */
    char          cc;  /* current char to examine */
    boolean       t;   /* termination-character ':' active? */
    boolean       esc; /* 'escape-character ('\')' was found if true */
   /*=================================================================*/
    /* skip 'whitespace' and read new line if requested */
    if(nxtChar()) /* skip space(s) -- valid character available? */
      if(getNxt(false)) return null; /* error -- return with flag */

    /* Now: 'Pos' points to first valid character (nonblank) */
    if((opt%11)==0) { SveP = Pos; SveB = BrC; } /* set marker if req. */
    e = new StringBuilder(); /* preset result to 'empty string' */
    esc = false; /* preset: no escape-character found */
    if(Buf.charAt(Pos)=='"') { /* 'external quoted string' found */
      Pos += 1; /* skip open-quote */
      rep1:do { /* quoted string may consist of more than one part */
        for(p=Buf.length();Pos<p;Pos+=1) { /* check termination */
          cc = Buf.charAt(Pos); /* get current char */
          if(cc=='\\') { /* escape-character found */
            if(esc) e.append(cc); /* already found -- set '\' */
            esc = !esc; /* set/reset current escape-marker */
            continue; /* -for- character fully processed */
          } /* escape-character was found */
          if(cc=='"') { /* eos-marker found (eos='end of string') */
            esc = !esc; /* set/reset current escape-marker */
            if(esc) break rep1; /* -while- eos found -- terminate check */
          } /* eos-character was found */
          if(esc) { /* illegal escape-sequence found ? */
            esc = false; /* reset current escape-marker */
            switch(cc) { /* check if valid escape-sequence */
              case('r'): cc = '\r'; break; /* replace with valid character */
              case('n'): cc = '\n'; break; /* replace with valid character */
              case('t'): cc = '\t'; break; /* replace with valid character */
              default: e.append('\\'); /* do not change sequence -- add esc again */
            } /* check if valid escape-sequence */
          } /* illegal escape-sequence found ? */
          e.append(cc); /* transfer current character (ggf.: '"' */
        } /* -for- check and copy characters */
        /* no termination-character found (p==Pos), string continues */
        /* 'getNxt()' reads new line and sets 'Pos'-value.
         * blank lines are NOT skipped */
        if(getNxt(true)) { /* error --  set message and return with flag */
          if(EMsg==null) EMsg = TSLogg.getMsg("TSBuf082"); /* error */
          return null; /* error -- return with flag/message */
        } /* error -- return with flag/message */
      } while(true); /* -rep1- check all parts of the string */
      /* pointer 'Pos' still points to termination-character (due to 'break') */
      Pos += 1; /* skip close-quote */
    } else { /* no 'external quoted String' found */
      t = (opt%3)==0; /* set flag: check additional term-chars */
      b = (opt%7)==0 ? 0 : -1; /* set flag: open bracket was NOT found */
        /* set flag (otherwise): brackets are additional term-chars -- check it */
      for(p=Buf.length();Pos<p;Pos+=1) { /* check termination */
        cc = Buf.charAt(Pos); /* get current char */
        if(Character.isWhitespace(cc)) break; /* blank found */
        if(t) if(cc==':') break; /* valid termination-char found */
        if(cc==')') { /* termination-char 'closing bracket' found */
          if(b<=0) break; /* valid termination-char found */
          b -= 1; /* count closing bracket: termination char may become valid */
        } /* special processing of termination-char */
        if(cc=='(') { /* termination-char 'open bracket' found */
          if(b<0) break; /* valid termination-char found in every case */
          b += 1; /* count open bracket: 'closing bracket' is no termination-char */
        } /* special processing of termination-char */
        if(cc=='"') { /* 'internal quoted string' follows */
          if((opt%5)==0) break; /* 'internal quoted string' not allowed */
          e.append(cc); /* copy start of string */
          Pos += 1; /* skip open-quote */
          rep2:do { /* quoted string may consist of more than one part */
            for(p=Buf.length();Pos<p;Pos+=1) { /* check termination */
              cc = Buf.charAt(Pos); /* get current char */
              if(cc=='\\') { /* escape-character found */
                if(esc) e.append(cc); /* already found -- set '\' */
                esc = !esc; /* set/reset current escape-marker */
                continue; /* -for- character fully processed */
              } /* escape-character was found */
              if(cc=='"') { /* eos-marker found (eos='end of string') */
                esc = !esc; /* set/reset current escape-marker */
                if(esc) break rep2; /* -while- eos found -- terminate check */
              } /* eos-character was found */
              if(esc) { /* illegal escape-sequence found ? */
                esc = false; /* reset current escape-marker */
                switch(cc) { /* check if valid escape-sequence */
                  case('r'): cc = '\r'; break; /* replace with valid character */
                  case('n'): cc = '\n'; break; /* replace with valid character */
                  case('t'): cc = '\t'; break; /* replace with valid character */
                  default: e.append('\\'); /* do not change sequence -- add esc again */
                } /* check if valid escape-sequence */
              } /* illegal escape-sequence found ? */
              e.append(cc); /* transfer current character (ggf.: '"' */
            } /* -for- check and copy characters */
            /* no termination-character found (p==Pos), string continues */
            /* 'getNxt()' reads new line and sets 'Pos'-value.
             * blank lines are NOT skipped */
            if(getNxt(true)) { /* error --  set message and return with flag */
              if(EMsg==null) EMsg = TSLogg.getMsg("TSBuf082"); /* error */
              return null; /* error -- return with flag/message */
            } /* error -- return with flag/message */
          } while(true); /* -rep2- check all parts of the string */
          /* termination-character ('"' still in 'cc') must be added */
          /* 'close-quote' is skipped when next for-loop is done */
        } /* Sub-string (starting with '"') is processed */
        e.append(cc); /* no termination-character -- copy it */
      } /* -for- check and copy characters */
    } /* input (no 'external quoted String') processed */

    s = e.toString(); /* convert result to 'String' */
    if((opt%2)==0) s = s.toLowerCase(); /* convert result if requested */
    return s; /* and return result as a single string */
  }

 /**. <pre>
  *=====================================================================
  * Method "length"
  * Name of method is requested by class 'String'
  * This method provides the length of the CURRENT line. This may
  *   include 'Whitespace'-characters.
  * Attention: If a default-reader is available, the current line may
  *            change unknown to the user of this method.
  * ##length.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int length() /* returns length of buffer */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(Buf==null) return -1; /* buffer not valid -- signal it */
    return Buf.length(); /* return result */
  }

 /**. <pre>
  *=====================================================================
  * Method "mark"
  * Handle control of position -- mark it.
  * Returns 'false', if NO position was already marked.
  * ##mark.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean mark( /* store current position */
   boolean clr) /* do not set but clear marker (if 'true') */
   {
   /*-----------------------------------------------------------------*/
    boolean marked; /* position already marked */
   /*=================================================================*/
    marked = (SveP>=0); /* position already marked? */
    SveP = Pos; /* store current position as marker in any case */
    SveB = BrC; /* store current bracket-level in any case */
    if(clr) reset(true); /* clear requested -- clear marker again */
    return marked; /* provide result: position was already marked ? */
  }

 /**. <pre>
  *=====================================================================
  * Method "modData" ((s),l)
  * Modify dataline, insert changes (before current pointer).
  * If 'mark' is active, all data between marker-position and current
  *   pointer ('Pos') is deleted.
  * Only values, which are already read from line, may be changed.
  * Method can ONLY be used when '(single-)line'-mode is active
  * ##modData.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean modData( /* modify current line */
   String dta) /* new data to be inserted */
   {
   /*-----------------------------------------------------------------*/
    int l; /* length of buffer */
   /*=================================================================*/
    if(Mde) throw new /* function not allowed if 'file'-mode used */
      IllegalStateException(TSLogg.getMsg("Msg903","TSBuf.modData()",0));
    if(Buf==null) return true; /* buffer not valid -- do not change */
    l = (SveP<0) ? Pos : SveP; /* set length of first part */
    Lne = Buf.substring(0,l); /* set first part of data */
    if(dta!=null) Lne += dta; /* add new data-string */
    l = Lne.length(); /* save new value of 'Pos' */
    if(Pos<Buf.length()) Lne += Buf.substring(Pos); /* add remaining data */
    Pos = l; /* set new 'current pointer' */
    Buf = Lne; /* activate contend of new valid buffer */
    return false; /* data was changed successfully */
  }

 /**. <pre>
  *=====================================================================
  * Utility-method "nxtChar" (private)
  * Checks characters within 'Buf' and starting at position 'Pos' if
  * they are 'Whitespace'-characters. Adjust pointer 'Pos' to first
  * character, which do NOT fullfill this condition.
  * If NO such character is found until end-of-line, 'Pos' is set to
  * bufferlength and 'true' is returned. Otherwise 'false' is returned.
  * Attention: - The current position-pointer 'Pos' is NOT checked.
  *            - ONLY current buffer is used (no read)
  * ##nxtChar.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final boolean nxtChar() /* skip 'whiteChar' */
   {
   /*-----------------------------------------------------------------*/
    int l; /* length of buffer */
   /*=================================================================*/
    if(Buf==null) return true; /* buffer not valid -- signal it */
    for(l=Buf.length();Pos<l;Pos+=1) /* until end-of-line */
      if(!Character.isWhitespace(Buf.charAt(Pos))) return false;
        /* position contains no Whitespace - signal it */
    return true; /* no other character found */
  }

 /**. <pre>
  *=====================================================================
  * Method "reset"
  * Handle control of position.
  * Returns 'false', if function was successful.
  * ##reset.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean reset( /* reset position to saved value */
   boolean clr) /* clear marker-position if 'true' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(SveP<0) return true; /* pointer could not be modified */
    Pos = SveP; /* reset pointer to last 'mark'-position */
    BrC = SveB; /* reset bracket-level to corresponding value */
    if(clr) SveP = -1; /* clear current marker */
    return false; /* provide result: position modified */
  }

 /**. <pre>
  *=====================================================================
  * Method "setUsr"
  * Set or Reset state of current user-flag.
  * This field/method is NOT used by TSBuf itself. Applications may use
  *   this field, to extend the capabilities of the class.
  * ##setUsr.TSFile (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean setUsr( /* modify current user-flag */
   boolean nS) /* new state of user-flag */
   {
   /*-----------------------------------------------------------------*/
    boolean cS; /* current state of user-flag */
   /*=================================================================*/
    cS = Usr;  /* save current state of flag */
    Usr = nS;  /* replace current state with new one */
    return cS; /* returns current/old state of flag */
  }

 /**. <pre>
  *=====================================================================
  * Method "skpFwd"
  * skip (key)words until specified bracket is closed
  * returns 'true' if EOF/error found
  * ##skpFwd.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean skpFwd( /* skip vals until target-lvl reached */
   int lv) /* target-level of brackets */
   {
   /*-----------------------------------------------------------------*/
    char   cc; /* current character for testing */
    String is; /* intermediate value */
   /*=================================================================*/
    if(lv<=0) return true; /* invalid value -- skip function */
    if(BrC<lv) return false; /* requested level already active */
    do { /* bis Dateiende oder Klammerlevel stimmt */
      do { /* alle Woerter uebergehen */
        is = getVal(5); /* naechstes Wort holen */
          /* EMsg wird ggf. durch 'getVal()' gesetzt */
        if(is==null) return true; /* EOF/error found */
          /* Attention: EMsg is not FULLY correct. However, 'true'
           * signals an error */
      } while(is.length()>0); /* Woerter gefunden */
      if(Pos>=Buf.length()) continue; /* Klammer kann NICHT folgen.
        * Diese Abfrage ist notwendig da, 'is.length()==0' auch durch
        * eine LEERE Kette erzeugt werden kann und nicht nur durch
        * einen FEHLENDEN Wert.
        */
      cc = Buf.charAt(Pos); /* aktuelles Zeichen holen */
      Pos += 1; /* Zeichen uebergehen */
      if(cc=='(') BrC += 1; /* neue Klammer geoeffnet */
      if(cc==')') BrC -= 1; /* Klammer geschlossen */
    } while(BrC>=lv); /* until target-level reached */
    return false; /* Level reached -- no error */
  }

 /**. <pre>
  *=====================================================================
  * Method "skpFwd" (Version 2)
  * skip (key)words until (next) bracket is closed
  * returns 'true' if EOF/error found
  * ##skpFwd.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean skpFwd() /* skip vals until target-lvl reached */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return skpFwd(BrC); /* use current level */
  }

 /**. <pre>
  *=====================================================================
  * Methode "skpVal"
  * Extrahieren der naechsten Werte bis zur schliessenden Klammer
  *  und liefern der Gesamt-Kette in String-Form.
  * Als Trennzeichen wird ' ' verwendet! Mehrere Trennzeichen der
  *  Originalzeile werden ggf. durch EIN ' ' ersetzt.
  * Wenn KEIN Trennzeichen vorhanden ist, wird auch KEINES eingesetzt.
  * Attention: The last closing bracket is NOT skipped!
  * Ergebnis: Returnwert EMsg      Bedeutung
  *           <>null     null      Datenwert
  *           null       null      Datei-/Zeilenende erreicht
  *           null       <>null    Fehlermeldung
  * ##skpVal.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String skpVal( /* get vals until target-lvl reached */
   int lv) /* target-level of brackets */
   {
   /*-----------------------------------------------------------------*/
    String e,is; /* result */
    int    i;    /* intermediate value(s) */
    char   cc;   /* current character for testing */
   /*=================================================================*/
    if(lv<=0) return "*LV-error(skpVal())*"; /* invalid value -- error */
    e = ""; /* initialize result */
    while(true) { /* loop until EOF or correct Bracket-Level */
      while(true) { /* skip all words */
        i = Pos; /* save position */
        /* skip 'whitespace' and read new line if requested */
        if(nxtChar()) /* skip whitespace, signal if new record needed */
          if(getNxt(false)) return null; /* error -- return with flag */
          else i = -1; /* add separator if not already done */
        if(i!=Pos) if(!e.endsWith(" ")) e += " "; /* separator requested */
        is = getVal(5); /* get next word */
          /* EMsg will be updated from 'getVal()' */
        if(is==null) return null; /* EOF/error found */
        if(is.length()==0) break; /* no valid word found */
        /* now: length()>0 */
        /* check if word starts a comment */
        if(!chkComment(is)) { /* comment found -- skip it recursive */
          is = skpVal(BrC+1); /* get comment within next brackets */
            /* an open bracket must directly follow this word */
          if(is==null) return null; /* error found -- signal it */
        } else e += TSUtil.modStr(is); /* add current (valid) word to result */
      } /* loop to skip all valid words */

      if(Pos>=Buf.length()) continue; /* following bracket not possible
        * Diese Abfrage ist notwendig da, 'is.length()==0' auch durch
        * eine LEERE Kette erzeugt werden kann und nicht nur durch
        * einen FEHLENDEN Wert.
        */
      cc = Buf.charAt(Pos); /* get next character */
      if(cc==')') { /* Bracket closed again */
        if(BrC<=lv) return e; /* Level reached -- return result */
        BrC -= 1; /* decrement counter again */
      } /* Bracket was closed */
      if(cc=='(') BrC += 1; /* open bracket? -- count it */
      Pos += 1; /* skip character if it is processed */
      e += Character.toString(cc); /* add character too */
    } /* process all expressions */
  }

 /**. <pre>
  *=====================================================================
  * Methode "skpVal" (Version 2)
  * Extrahieren der naechsten Werte bis zur schliessenden Klammer
  *  und liefern der Gesamt-Kette in String-Form.
  * Dokumentation: vgl. Version 1
  * ##skpVal.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String skpVal() /* get vals until target-lvl reached */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return skpVal(BrC); /* use current level */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSBuf (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSBuf{" + Mde +"-'" + Buf + "'(" + Pos + "(" + SveP +
           "))-" + BrC + "-" + ((EMsg==null)?"<true>":"<false>") + "}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSTemp -- definitions/methods for temporary objects
 * This class contains all definitions which may be used from
 *  common methods as a temporay value. All such definitions are merged
 *  into this class. So NOT ALL definitions are used in every case.
 * This class is also used to supply a common datastorage used with
 *  recursions. Therefore it replaces some static values and groups
 *  them into a single structure.
 * The following assignments are valid:
 * - Method 'TSUtil.Zusi' uses
 *   + (TSOpts)		 TSTemp
 *   + (int)		 Nr
 *   + (TSTrNde)	 TrNde
 * - Class 'TSFrame' uses
 *   + (TSOpts)		 TSTemp
 *   + (String)		 FNme
 * - Method 'TSUtil.getTDF()'/'TSUtil.getTD()' uses
 *   + (TSRoute)		 Rte
 *   + (BufferedInputStream)	 bI
 *   + (int)			 Nr		type of tile (hi/lo)
 *   + (int)			 z1		counter
 *   + (int)			 z2		counter
 *   + (int)			 z3		counter
 *   + (int)			 z4		counter
 *   + (int)			 z5		counter
 *
 * All 'manipulating methods' are included in the above usage.
 *
 * ATTENTION: This class uses definitions from class 'TSOpts' to
 *		implement an optionmask. Therefore class 'TSTemp'
 *		extends class 'TSOpts'. Interface 'Serializable' is
 *		also derivated from this class.
 * ##TSTemp (Eyecatcher)
 *======================================================================
 </pre>*/
class TSTemp extends TSOpts { /* temporary object for ALL methods */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.00 11.02.2009";
 /*-------------------------------------------------------------------*/
  private int                   Nr;     /* Number(ID) of object */
  private int                   z1;     /* counter 1 */
  private int                   z2;     /* counter 2 */
  private int                   z3;     /* counter 3 */
  private int                   z4;     /* counter 4 */
  private int                   z5;     /* counter 5 */
  private TSTrNde               TrNde;  /* Reference to TrNode */
  private String                FName;  /* File-Function-name */
  private TSRoute               Rte;    /* current route-definition */
  private BufferedInputStream   bI;     /* reading of control-bytes */
/**. <pre>
  * Used options (stored within mask of 'TSOpt'):
  *  0 to 31 - not used
  *=====================================================================
  * Constructor: (1) create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSTemp() /* create Basis-Definition */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Nr    = Integer.MIN_VALUE; /* no value defined */
    /* all other variables are initialized by default ('0' / 'null') */
//    z1    = 0;                 /* counter contains no value */
//    z2    = 0;                 /* counter contains no value */
//    z3    = 0;                 /* counter contains no value */
//    z4    = 0;                 /* counter contains no value */
//    z5    = 0;                 /* counter contains no value */
//    TrNde = null;              /* no reference defined */
//    FName = null;              /* no 'String' defined */
//    Rte   = null;              /* no current value available */
//    bI    = null;              /* no current value available */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) create 'TSFrame'-Entry
  *=====================================================================
  </pre>*/
  protected TSTemp( /* create special entry-definition */
   int    msk, /* initial value of option-class */
   String nme) /* value of function */
   {
    super(msk);  /* set value of parent-class (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    FName = nme;               /* transfer current name */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) create 'TD'-Entry
  *=====================================================================
  </pre>*/
  protected TSTemp( /* create special entry-definition */
   TSRoute cR, /* current route-definition */
   int     t)  /* type of tile-definitions */
   {
    this();  /* initialize to default (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Rte = cR; /* copy current route-definition */
    Nr  = t;  /* insert type of tiles */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (3) create 'TD'-Entry
  *=====================================================================
  </pre>*/
  protected TSTemp( /* create special entry-definition */
   TSRoute cR, /* current route-definition */
   int     t,  /* type of tile-definitions */
   int     c)  /* length of I/O-area (counter 1) */
   {
    this();  /* initialize to default (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Rte = cR; /* copy current route-definition */
    Nr  = t;  /* insert type of tiles */
    z1  = c;  /* preset counter with start-value */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (4) create 'Zusi'-Entry
  *=====================================================================
  </pre>*/
  protected TSTemp( /* create special entry-definition */
   TSTrNde cN, /* current TrackNode-definition */
   int     id) /* id-value of entry */
   {
    this();  /* initialize to default (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    TrNde = cN; /* copy current tracknode-definition */
    Nr    = id; /* insert current id-number */
  }

 /**. <pre>
  *=====================================================================
  * Method "$init"
  * Initialize all values of this structure (again)
  * ##$init.TSTemp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final void $init() /* initialize structure */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    super.$init(0);            /* initialize all upper classes */
    Nr    = Integer.MIN_VALUE; /* no value defined */
    z1    = 0;                 /* counter contains no value */
    z2    = 0;                 /* counter contains no value */
    z3    = 0;                 /* counter contains no value */
    z4    = 0;                 /* counter contains no value */
    z5    = 0;                 /* counter contains no value */
    TrNde = null;              /* no reference defined */
    FName = null;              /* no 'String' defined */
    Rte   = null;              /* no current value available */
    bI    = null;              /* no current value available */
    return; /* return again */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgFNme"
  * Get/Update File-/Function-name
  * ##chgFNme.TSTemp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String chgFNme( /* get/replace name */
   String nS) /* new value or 'null' if no change must occur */
   {
   /*-----------------------------------------------------------------*/
    String cS; /* intermediate value */
   /*=================================================================*/
    cS = FName; /* save original name */
    if(nS!=null) FName = nS; /* set new name if requested (no copy) */
    return cS; /* return original name */
  }

 /**. <pre>
  *=====================================================================
  * Method "chgNr"
  * Get/Update Number-value (e.g. TrNde-Number)
  * Attention: positive AND negative numbers are supported
  * ##chgNr.TSTemp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int chgNr( /* get/update number-value */
   int nr) /* new value or 'Integer.MIN_VALUE' if no change */
   {
   /*-----------------------------------------------------------------*/
    int cNr; /* old value */
   /*=================================================================*/
    cNr = Nr; /* save original value */
    if(nr!=Integer.MIN_VALUE) Nr = nr; /* set new value if requested */
    return cNr; /* return original value */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgRte"
  * Get/Update ccurrent route-definition
  * ATTENTION: Value is NOT changed if argument is 'null'
  * ##chgRte.TSTemp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected TSRoute chgRte( /* modify current route-connection */
   TSRoute cR) /* new route-definition or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSRoute cRte; /* current(old value of route */
   /*=================================================================*/
    cRte = Rte; /* save current reference to route */
    if(cR!=null) Rte = cR; /* and modify it if requested */
    return cRte; /* return current/old refernce to route */
  }

 /**. <pre>
  *=====================================================================
  * Methode "chgTrN"
  * Get/Update TrackNode-Reference
  * Attention: Delete of reference is NOT possible
  * ##chgTrN.TSTemp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final TSTrNde chgTrN( /* manage Reference to Track-Node */
   TSTrNde trn)  /* new reference or 'null' */
   {
   /*-----------------------------------------------------------------*/
    TSTrNde cTrN; /* intermediate value */
   /*=================================================================*/
    cTrN = TrNde; /* save original reference */
    if(trn!=null) TrNde = trn; /* replace reference if requested */
    return cTrN; /* return original reference */
  }

 /**. <pre>
  *=====================================================================
  * Method "Close"
  * Open inputstream and check for error
  * ##Close.TSTemp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String Close() /* close inputstream */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(bI==null) return TSLogg.getKey("TSTmp001"); /* error */
    try { bI.close(); /* close .td/.tdl - file */
    } catch (IOException e) { /* error occurred during operation */
      bI = null; /* clear file (although error occurrs) */
      return e.toString(); /* return with error-message as marker */
    } /* OK -- file closed sucessfully */
    bI = null; /* clear file */
    return null; /* return without marker -- no error */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt1"
  * Increment temporary counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt1.TSTemp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt1( /* change/read temporary counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int c; /* current value of counter */
   /*=================================================================*/
    c = z1; /* save current value of counter */
    if(inc<0) inc = Math.max(inc,-c); /* must not become negative */
    z1 += inc; /* increment (decrement) counter */
    return c; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "incCnt2"
  * Increment temporary counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt2.TSTemp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt2( /* change/read temporary counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int c; /* current value of counter */
   /*=================================================================*/
    c = z2; /* save current value of counter */
    if(inc<0) inc = Math.max(inc,-c); /* must not become negative */
    z2 += inc; /* increment (decrement) counter */
    return c; /* return value before modification */
  }
 /**. <pre>
  *=====================================================================
  * Method "incCnt3"
  * Increment temporary counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt3.TSTemp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt3( /* change/read temporary counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int c; /* current value of counter */
   /*=================================================================*/
    c = z3; /* save current value of counter */
    if(inc<0) inc = Math.max(inc,-c); /* must not become negative */
    z3 += inc; /* increment (decrement) counter */
    return c; /* return value before modification */
  }
 /**. <pre>
  *=====================================================================
  * Method "incCnt4"
  * Increment temporary counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt4.TSTemp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt4( /* change/read temporary counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int c; /* current value of counter */
   /*=================================================================*/
    c = z4; /* save current value of counter */
    if(inc<0) inc = Math.max(inc,-c); /* must not become negative */
    z4 += inc; /* increment (decrement) counter */
    return c; /* return value before modification */
  }
 /**. <pre>
  *=====================================================================
  * Method "incCnt5"
  * Increment temporary counter
  * (using argument'0', reference-counter may be returned only)
  * ##incCnt5.TSTemp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final int incCnt5( /* change/read temporary counter */
   int inc) /* 'Increment-Value' (may be negative) */
   {
   /*-----------------------------------------------------------------*/
    int c; /* current value of counter */
   /*=================================================================*/
    c = z5; /* save current value of counter */
    if(inc<0) inc = Math.max(inc,-c); /* must not become negative */
    z5 += inc; /* increment (decrement) counter */
    return c; /* return value before modification */
  }

 /**. <pre>
  *=====================================================================
  * Method "Open"
  * Open inputstream and check for error
  * ##Open.TSTemp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String Open( /* open inputstream from file */
   File dat) /* Reference to inputfile */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    try { bI = new BufferedInputStream(new FileInputStream(dat));
    } catch (FileNotFoundException e) { /* File not found */
      return e.toString(); /* return with error-message as marker */
    } /* OK -- file opened sucessfully */
    return null; /* return without marker -- no error */
  }

 /**. <pre>
  *=====================================================================
  * Method "Read"
  * Read input (String) from inputstream
  * ##Read.TSTemp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String Read( /* read string from inputstream */
   byte[] dst, /* destination of inputdata */
   int    len) /* length of required input */
   {
   /*-----------------------------------------------------------------*/
    int c; /* number of bytes read */
   /*=================================================================*/
    if(bI==null) return TSLogg.getKey("TSTmp001"); /* error */
    try { c = bI.read(dst,0,len); /* read data from inputstream */
    } catch (IOException e) { /* error occurred while reading */
      return e.toString(); /* return with error-message as marker */
    } /* OK -- data read sucessfully */
    if(c<len) return TSLogg.getMsg("TSTmp002",null,c,len);
    return null; /* return without marker -- no error */
  }

 /**. <pre>
  *=====================================================================
  * Method "Read"
  * Read input (Integer) from inputstream
  * ##Read.TSTemp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Integer Read() /* read byte from inputstream */
   throws IOException /* exception is send to caller */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    if(bI==null) return -2; /* return error-marker */
    return bI.read(); /* read byte from inputstream and return it */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSTemp (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSTemp{" + Nr + ",TrN=" + ((TrNde==null)?"<null>":"<set>") +
           "," + z1 + "," + z2 + "," + z3 + "," + z4 + "," + z5 +
           ",Rte=" + ((Rte==null)?"<null>":"<set>") +
           ",bInp=" + ((bI==null)?"<null>":"<set>") +
           ",FNme=" + ((FName==null)?"<null>":("'"+FName+"'")) +
           "}";
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSNameSet -- controls set of names
 * This class implements a 'Set' of names. Lower case characters are
 *  used to ensure uniqueness. The names themselves are NOT changed.
 * This class differs from a normal 'Set', that notation of the names
 *  is NOT considered.
 * This class also may be used as a 'FilenameFilter'. So, the results
 *  of a file-search may be filtered by the names included in this set.
 * ##TSNameSet (Eyecatcher)
 *======================================================================
 </pre>*/
class TSNameSet extends HashMap<String,String> /* NameList */
                implements FilenameFilter { /* select filenames */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.06 28.10.2009";
 /*-------------------------------------------------------------------*/
  private boolean               Dir;    /* include directory ? */
  private String                suffix; /* required suffix of file */
 /* 'HashMap' contains NO definition(s) which may be used within
  * the methods of this class.
  */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSNameSet() /* create Basis-Definition */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Dir    = true; /* directories are included */
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSNameSet( /* create extended Definition */
   boolean d, /* include directories? */
   String  s) /* suffix for filefilter */
   {
    super(); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Dir    = d; /* store status regarding directories */
    suffix = s; /* store required suffix of files (may be 'null')
      * Attention: If 'suffix' contains UpperCase-characters, it will
      *            NOT match in any case. */
  }

 /**. <pre>
  *=====================================================================
  * Method "accept"
  * Check filename and select it as valid or not
  * Attention: Method is requested by interface 'FilenameFilter'
  * ##accept.TSNameSet (Eyecatcher)
  *=====================================================================
  </pre>*/
  public final boolean accept( /* select filename for inclusion */
   File   prt,  /* definition of parent-directory */
   String name) /* filename to be checked */
   {
   /*-----------------------------------------------------------------*/
    String is; /* intermediate name */
   /*=================================================================*/
    if((new File(prt,name)).isDirectory()) return Dir; /* include? */
    /* now: 'name' is 'filename'*/
    is = name.toLowerCase(); /* prepare name for checking */
    if(suffix!=null) if(!is.endsWith(suffix)) return false;
      /* specified suffix of name do not match -- do not use it */
    return super.containsKey(is); /* return required flag */
  }

 /**. <pre>
  *=====================================================================
  * Method "add"
  * Add an Name-Entry to the namelist
  * ##add.TSNameSet (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean add( /* add a name-entry */
   String nS) /* new name of entry */
   {
   /*-----------------------------------------------------------------*/
    String cS; /* intermediate value */
   /*=================================================================*/
    if(nS==null) return false; /* name not available -- do not use */
    cS = nS.toLowerCase(); /* create key-value */
    if(super.containsKey(cS)) return false; /* already present */
    super.put(cS,nS); /* insert new name-entry */
    return true; /* signal: entry was inserted */
  }

 /**. <pre>
  *=====================================================================
  * Method "contains"
  * Checks if a value is present in the namelist using its key
  * ##contains.TSNameSet (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final boolean contains( /* returns flag of presence */
   String nS) /* name of entry */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return super.containsKey(nS.toLowerCase()); /* return req. flag */
  }

 /**. <pre>
  *=====================================================================
  * Method "iterator"
  * Returns an iterator for all values of the namelist.
  * Because 'values()' returns a 'view', 'remove()' is still valid.
  * --- Method is NOT referenced until now. (marked by 'XXX...') ---
  * ##iterator.TSNameSet (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Iterator<String> XXXiterator() /* return an iterator */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return super.values().iterator(); /* return requested value */
  }

 /**. <pre>
  *=====================================================================
  * Method "keyIterator"
  * Returns an iterator for all keys of the namelist.
  * Because 'keySet()' returns a 'view', 'remove()' is still valid.
  * Attention: If 'sort' is requested (nos==false), the view-attribute
  *            is no longer valid.
  * ##keyIterator.TSNameSet (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Iterator<String> keyIterator( /* return an iterator */
   boolean nos) /* do not request 'sort' if 'true' */
   {
   /*-----------------------------------------------------------------*/
    ArrayList<String> Keys; /* List of Keys to be sorted */
   /*=================================================================*/
    if(nos) return super.keySet().iterator(); /* return requested value */
    Keys = new ArrayList<String>(super.keySet()); /* get list of keys */
    Collections.sort(Keys); /* sort them */
    return Keys.iterator(); /* and return requested iterator */
  }

 /**. <pre>
  *=====================================================================
  * Method "setFilter"
  * Modifies or activates the FilenameFilter-function.
  * This method establishes a new directory-flag and a suffix for the
  *   filename. If 's==null' the suffix-value is invalidated.
  * ##setFilter.TSNameSet (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final void setFilter( /* modifies 'filenamefilter' */
   boolean d, /* new value of directory-mode */
   String  s) /* new suffix of the filename or 'null' */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    Dir    = d; /* activate new directory-flag */
    suffix = s; /* change suffix or invalidate it */
    return; /* method is OK */
  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSCopySet -- controls copy-actions for files
 * This class is used to store a copy-misson for files. The source-
 * directory and the files are part of this class while the destination
 * is specified when the action takes place.
 * This class extends 'TSNameSet' to asure, that all files are copied
 * only once.
 * ##TSCopySet (Eyecatcher)
 *======================================================================
 </pre>*/
class TSCopySet extends TSNameSet { /* copy files */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.06 21.01.2010";
 /*-------------------------------------------------------------------*/
  private File                  src;    /* source-dir. of file(s) */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSCopySet() /* create Basis-Definition */
   {
    super(false,null); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    /* all other variables are initialized by default ('0' / 'null') */
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSCopySet( /* create extended Definition */
   File s) /* name/path of input-directory */
   {
    super(false,null); /* set default-values (--- Restriction ---) */
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    src = s; /* set name of directory used for input of files */
  }

 /**. <pre>
  *=====================================================================
  * Method "cpyFle"
  * Copies all files included in this Set from source-directory, which
  * is also specified by this Set, to a 'Destination-directory' which
  * is specified as a file-definition.
  * If argument 's' is not null, this string is added to ALL filenames,
  *   which are selected.
  * This method returns a list of (error-)messages which is an iterator
  *   to the specified ArrayList of strings.
  * Attention: Copy of a file is suppressed, if the target-file
  *            already exits.
  * ##cpyFle.TSCopySet (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final Iterator<String> cpyFle( /* copy files */
   File   dst,  /* File-definition of the destination-directory */
   String s,    /* additional suffix of the filename(s) or 'null' */
   ArrayList<String> LneT) /* Empty list to be filled (table) */
   {
   /*-----------------------------------------------------------------*/
    Runtime        rt;    /* current Runtime-Environment */
    Process        aPr;   /* process of execution */
    BufferedReader PrOut; /* Message-Reader (responses) */
    File           sdat,ddat; /* intermediate files */
    int            i;   /* intermediate value */
    String         cmd; /* start of DOS-command */
    String[]       fl;  /* list of affected files */
   /*=================================================================*/
    if(src==null) { /* source was NOT specified */
      LneT.add(TSLogg.getKey("TSCpyC01")); /* add error-message */
      return LneT.iterator(); /* return iterator for result */
    } /* source was NOT specified */
    if(dst==null) { /* destination is not specified correctly */
      LneT.add(TSLogg.getKey("TSCpyC02")); /* add error-message */
      return LneT.iterator(); /* return iterator for result */
    } /* destination is not specified correctly */
    if(!dst.exists()) dst.mkdirs(); /* create target-directory, if needed */
    if(!dst.isDirectory()) { /* destination is not a directory */
      LneT.add(TSLogg.getMsg("TSCpyC03",dst.getAbsolutePath()));
      return LneT.iterator(); /* return iterator for result */
    } /* destination is not a directory */

    if(TSUtil.OSName.indexOf("98")>=0) cmd = "command.com /c copy \"";
    else if(TSUtil.OSName.equalsIgnoreCase("windows me")) /* Win-ME! */
      cmd = "command.com /c copy \"";
    else cmd = "cmd /c copy \""; /* all other Windows-OS */
    rt = Runtime.getRuntime(); /* get runtime-environment */

    /* Attention: Attributes of SOURCE-Directory must be OK. */
    fl = src.list((FilenameFilter)this); /* list affected files */
    for(String fn : fl) { /* process all entries */
      if(s!=null) fn += s; /* add new suffix of file (if requested) */
      sdat = new File(src,fn); /* create full source-filename */
      if(sdat.isDirectory()) /* Name refers to directory */
        LneT.add(TSLogg.getMsg("TSCpyC11",sdat.getAbsolutePath()));
      else { /* entry refers to filename -- process it */
        /* Attention: list of filenames is already filtered!!
         *            However, because of additional suffix, source-file
         *            may not exist
         */
        if(!sdat.exists()) { /* source-file is missing -- skip it */
          LneT.add(TSLogg.getMsg("TSCpyC12",sdat.getAbsolutePath()));
          continue; /* skip file and use next one */
        } /* source-file not found */
        ddat = new File(dst,fn); /* create target-filename */
        if(ddat.exists()) continue; /* file may exist -- do not change */
        fn = cmd + sdat.getAbsolutePath() + "\" \"" +
          ddat.getAbsolutePath() + "\" "; /* create copy - command */
        try { /* try to execute external command */
          aPr = rt.exec(fn); /* do it */
          PrOut = new BufferedReader( /* get reader for responses */
            new InputStreamReader(aPr.getInputStream()));
          while((fn=PrOut.readLine())!=null) { /* lines present? */
            LneT.add(TSLogg.getMsg("TSCpyC13",sdat.getAbsolutePath(),fn));
          } /* response-lines present */
          i = aPr.waitFor(); /* wait until command finished and get return-code */
        } catch (Exception e) { /* error found while command-exec */
          LneT.add(TSLogg.getMsg("TSCpyC14",sdat.getAbsolutePath(),e.toString()));
          i = 20; /* set special return-code */
        } /* error occurred */
        if(i>0) /* error occurred while executing */
          LneT.add(TSLogg.getMsg("TSCpyC15",sdat.getAbsolutePath(),i));
      } /* entry was file */
    } /* process all definitions */
    return LneT.iterator(); /* return iterator for result */
  }

 /**. <pre>
  *=====================================================================
  * Method "toStr"
  * Build a string-representation of all values of this class
  * ##toStr.TSCopySet (Eyecatcher)
  *=====================================================================
  </pre>*/
  protected final String toStr() /* Create String-version of values */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    return "TSCopySet{'" + src + "'," + this.size() + "}";
  }

 /**==================================================================*/
}


/**. <pre>
 *======================================================================
 * ##+ (Eyecatcher)
 *    OBJEKT-Definitionen fuer TS-Objekte (Dialog-Klassen)
 *=====================================================================
 </pre>*/

/**. <pre>
 *======================================================================
 * Class TSUtilDlg -- Definition and control of a selection-dialog
 * ##TSUtilDlg (Eyecatcher)
 *======================================================================
 </pre>*/
class TSUtilDlg implements Serializable { /* control of options */
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.4.03 11.05.2009";
 /*-------------------------------------------------------------------*/
  protected static int          Dbg; /* Debug-Level for Dialog */
 /*-------------------------------------------------------------------*/
                            /* no definitions of instance-variables */
 /**. <pre>
  *=====================================================================
  * Constructor: (1) Create default-entry
  *=====================================================================
  </pre>*/
  protected TSUtilDlg() /* Constructor wird NICHT genutzt */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
  }

 /**. <pre>
  *=====================================================================
  * Hauptprogramm TSUtilDlg
  *
  *
  * ##main.TSUtilDlg (Eyecatcher)
  *=====================================================================
  </pre>*/
  public static final void main( /* Start des Haupt-Programms (Dialog) */
   String[] args) /* Aufruf-Parameter */
   {
   /*-----------------------------------------------------------------*/
    SynchronousQueue<ArrayList<String>> Que; /* input-queue */
    TSFrame              Win; /* get all arguments for command */
    Dimension            dim; /* current dimension of 'screen' */
    ArrayList<String>    cC;  /* current command-list */
    String[]             nC;  /* command for execute */
    File                 cF;  /* read/write of profile */
    BufferedInputStream  bI;  /* read of profile */
    BufferedOutputStream bO;  /* write of profile */
    TSBuf                cB;  /* current input-buffer for arguments */
    String               is;  /* intermediate value, Env. active? */
   /*=================================================================*/
    /* Phase --0--: Steuerkonstanten zuruecksetzen */
    is = TSLogg.getKey("Version"); /* Versions-Kennung holen */
    if(!is.equals(TSUtil.Version)) { /* Message-Datei passt nicht */
      if(is.indexOf("****")>=0) is = "?.?.??"; /* Message fehlt */
      TSLogg.Print("Msg999",TSUtil.Version,is); /* Beschreibung */
      System.out.println(); /* Leerzeile hinzufuegen */
    } /* Meldungs-datei passte nicht */

    Dbg = 0; /* preset: no debug active */
    if(args.length>0) LD:{ /* check if debug required */
      cB = new TSBuf(args[0]); /* get current Input */
      if(cB.length()==0) break LD; /* no option specified */
      if(cB.length()>1) TSLogg.Print("TSDlg910",cB.getLne(0));
      Dbg = "0123456".indexOf(cB.charAt(false)); /* get new debug-level */
      if(Dbg<0) TSLogg.Print("TSDlg911",cB.getLne(0));
      Dbg = Math.max(0,Dbg); /* no negative value */
    } /* -LD- check of Debug */
    TSFrame.cLg = null; /* preset: no Log-file specified */
    if(args.length>1) LF:{ /* check if log-file specified */
      if(args[1].equals("+")) break LF; /* file NOT specified */
      cF = new File(args[1]); /* input is name of a file */
      if(cF.isDirectory()) { /* Log-file is directory */
        TSLogg.Print("TSDlg921",cF.getAbsolutePath()); /* errormessage */
        break LF; /* do not use specification */
      } /* invalid log-file */
      TSFrame.cLg = cF.getAbsolutePath(); /* store unchangeable log-file */
      cF = cF.getParentFile(); /* get parent directory */
      if(!cF.exists()) { /* Log-directory does not exist */
        TSLogg.Print("TSDlg922",cF.getAbsolutePath()); /* errormessage */
        TSFrame.cLg = null; /* back to: no Log-file specified */
        break LF; /* do not use specification */
      } /* log-file not found */
      if(cF.isDirectory()) break LF; /* OK -- use specification */
      TSLogg.Print("TSDlg923",cF.getAbsolutePath()); /* errormessage */
      TSFrame.cLg = null; /* back to: no Log-file specified */
    } /* -LF- check of Log-file */
    TSFrame.cR = null; /* preset: no route specified */
    if(args.length>2) RF:{ /* check if route specified */
      cF = new File(args[2]); /* input is name of a directory */
      if(!cF.exists()) { /* route does not exist */
        TSLogg.Print("TSDlg931",cF.getAbsolutePath()); /* errormessage */
        break RF; /* do not use specification */
      } /* log-file not found */
      if(!cF.isDirectory()) { /* route is NOT a directory */
        TSLogg.Print("TSDlg932",cF.getAbsolutePath()); /* errormessage */
        break RF; /* do not use specification */
      } /* invalid log-file */
      TSFrame.cR = cF.getAbsolutePath(); /* store unchangeable route */
    } /* -RF- check of route */

    /* get profile of 'TSUtilDlg' */
    TSFrame.AppProp = new Properties(); /* get Property-definition */
    is = System.getenv("APPDATA"); /* get Directory for application */
    cF = new File(is,"TsUtilDlg.xml"); /* create File-Name (compiler) */
    if(is!=null) { /* Environment-reference exists */
      try { bI = new BufferedInputStream(new FileInputStream(cF));
        TSFrame.AppProp.loadFromXML(bI); /* load stored Data */
        bI.close(); /* and close file again */
      } catch (FileNotFoundException e) { /* file not found - was not created */
      } catch (IOException e) { } /* IO-error within file */
    } /* Environment-path was available */

    Que = new SynchronousQueue<ArrayList<String>>(); /* create Input-Queue */
    Win = new TSFrame(Que); /* create window for comunication */
    Win.pack();
    dim = Win.getToolkit().getScreenSize(); /* get current size of screen */
    dim.width -= Win.getWidth(); /* compute remaining width */
    dim.height -= Win.getHeight(); /* compute remaining wheight */
    Win.setLocation(dim.width/2,dim.height/2);
      /* compute position of new window */
    Win.setVisible(true);
    try {cC = Que.take(); /* get next Command from Queue */
      } catch(InterruptedException e) {cC = null;};
    Win.setVisible(false);
    Win.dispose();

    if(cC==null) System.exit(5); /* no command selected */
    if(cC.isEmpty()) System.exit(4); /* no command selected */

    /* write back current profile for next call */
    if(is!=null) { /* Environment-reference exists */
      try { bO = new BufferedOutputStream(new FileOutputStream(cF));
        TSFrame.AppProp.storeToXML(bO, /* write profile again */
          TSLogg.getMsg("TSDlg099",TSUtil.Version,TSUtil.SpVers));
        bO.close(); /* and close file again */
      } catch (IOException e) { } /* IO-Fehler in Datei */
    } /* Environment-path was available */

    /* OK -- execute command */
    nC = cC.toArray(new String[0]); /* create array of command-token */
    System.out.println(); /* Leerzeile hinzufuegen */

    if(Dbg>1) { /* print created command */
      Iterator<String> cI = cC.iterator();
      System.out.println("Erzeugte Daten:");
      while(cI.hasNext()) System.out.println("Token= '"+cI.next()+"'");
    } /* Debug was requested */
    if(Dbg>4) System.exit(0); /* Do not execute command */
    TSUtil.main(nC); /* call TSUtil to execute the command */
    System.out.println(); /* Leerzeile hinzufuegen */
//    System.exit(0); /* System beenden */

  }

 /**==================================================================*/
}

/**. <pre>
 *======================================================================
 * Class TSFrame
 * Control of I/O-Dialog to get the arguments for creating a call to the
 *  TSUtil-main-function. Extension to screen-definition.
 * ##TSFrame (Eyecatcher)
 *======================================================================
 </pre>*/
class TSFrame extends JFrame /* handle IO to screen */
  implements ActionListener,ItemListener {
 /*-------------------------------------------------------------------*/
  protected static final String IdStr = " 3.7.00 18.06.2012";
  private static final TSTemp[] Cmds = { /* TSUtil-Functions */
    new TSTemp(0x00000009,"ichk"),    new TSTemp(0x00000109,"cvrt"),
    new TSTemp(0x00000011,"move"),    new TSTemp(0x00000029,"merge"),
    new TSTemp(0x00000009,"clrdb"),   new TSTemp(0x00000009,"filter"),
    new TSTemp(0x00000000,"version"), new TSTemp(0x00000009,"rendb"),
    new TSTemp(0x00000011,"adjh"),    new TSTemp(0x00000068,"fcpy"),
    new TSTemp(0x00000068,"fmgr"),    new TSTemp(0x00000009,"shftdyn"),
    new TSTemp(0x00000019,"mveobj"),  new TSTemp(0x00000009,"cmp"),
    new TSTemp(0x00000009,"unc"),     new TSTemp(0x00000061,"dcpy"),
    new TSTemp(0x00000009,"world"),   new TSTemp(0x00000000,"tsconv"),
    new TSTemp(0x00000089,"chgsig"),  new TSTemp(0x00000001,"srchsig"),
    new TSTemp(0x00000001,"zusi"),    new TSTemp(0x0000000B,"chkup"),
    new TSTemp(0x00000003,"cmkr"),    new TSTemp(0x00000003,"shift"),
    new TSTemp(0x00000001,"testsig")};
  private static final String   PNme01 = "TSUtil.LogFle";
  private static final String   PNme02 = "TSUtil.GlOFle";
  private static final String   PNme03 = "TSUtil.LocOFle";
  private static final String   PNme04 = "TSUtil.Routes";
  private static final String   PNme05 = "TSUtil.AdDir1";
  private static final String   PNme06 = "TSUtil.AdDir2";
  private static final String   PNme07 = "TSUtil.Cvrt_B";
  private static final String   PNme12 = "TSUtil.GlOption";
  private static final String   PNme13 = "TSUtil.LocOption";
 /*-------------------------------------------------------------------*/
  protected static Properties   AppProp; /* Application-Prop. */
  protected static String       cLg; /* current Log-file */
  protected static String       cR;  /* current route */
 /*-------------------------------------------------------------------*/
  private SynchronousQueue<ArrayList<String>> Que; /* Input-Queue */
  private ArrayList<String>     rslt; /* result of IO */
  private ButtonGroup           BG1,BG2;  /* Buttongroup(s) */
  private JRadioButton          RB;  /* radiobutton Log-file */
  private JCheckBox             CB1,CB2,CB3,CB4,CB5,CB6,CB7;
  private JLabel                L1,L2,L3,L4,L5,L6,L7,L9; /* Label(s) */
  private JTextField            T1,T2,T3; /* input-fields */
  private TSTemp                cSel; /* current Selection */
  private String                cD; /* working-directory */
  private String                is; /* intermediate value */
/**. <pre>
  * Used options (stored within mask of 'TSTemp'):
  *      0 - Enable route-selection
  *      1 - Use 'file-reference' instead of 'route-reference'
  *      2 - not used until now
  *      3 - Enable local optionfile
  *      4 - Enable additional input
  *      5 - Enable additional directory 1 (position AFTER route)
  *      6 - Enable additional directory 2
  *      7 - Enable additional directory 1 (position BEFORE route)
  *      8 - Enable '-b'-reference
  *  9..31 - not used until now
  *=====================================================================
  * Constructor: (1) create Default-Entry
  *=====================================================================
  </pre>*/
  protected TSFrame() /* create Basis-Definition */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
  }

 /**. <pre>
  *=====================================================================
  * Constructor: (2) Create Standard-Entry
  *=====================================================================
  </pre>*/
  protected TSFrame( /* create standard-definition */
   SynchronousQueue<ArrayList<String>> que) /* Input-Queue */
   {
    super(TSLogg.getMsg("TSDlg000",TSUtil.Version)); /* init. window */
   /*-----------------------------------------------------------------*/
    Container    Scr;  /* contend of the screeen */
    Font         dF;   /* default-Font of the system */
    JPanel       cP,aP; /* current panel(s) */
    JRadioButton cRB;  /* current radiobutton */
    JButton      cB;   /* current Button(s) */
    int          i,j;  /* intermediate value */
   /*=================================================================*/
    cD = System.getProperty("user.dir"); /* working-dir */
//    dF = new Font(null,Font.PLAIN,14); /* create new Default-Font */
    Que = que; /* make queue available */
    rslt = new ArrayList<String>(); /* create result-array (empty) */
    try { UIManager.setLookAndFeel( /* set default */
      "com.sun.java.swing.plaf.windows.WindowsLookAndFeel");
    } catch (UnsupportedLookAndFeelException e) {
      System.err.println(e.toString());
    } catch (ClassNotFoundException e) {
      System.err.println(e.toString());
    } catch (InstantiationException e) {
      System.err.println(e.toString());
    } catch (IllegalAccessException e) {
      System.err.println(e.toString());
    }
    j = 0;
    if(TSUtilDlg.Dbg==4 || TSUtilDlg.Dbg==5) j = DebugGraphics.LOG_OPTION;
    if(TSUtilDlg.Dbg>5) { /* create debug-definitions */
      j = DebugGraphics.FLASH_OPTION; /* switch on flashing of object */
      DebugGraphics.setFlashCount(2); /* no of flashes per object */
      DebugGraphics.setFlashTime(30); /* timeconstant of flash */
    } /* Debug-values are established */
    Scr = getContentPane(); /* establish access to screen */
    Scr.setLayout(new BoxLayout(Scr,BoxLayout.Y_AXIS)); /* init layout */
    /* add select of a function */
    cSel = Cmds[0]; /* preset selection */
    cP = new JPanel(); /* get Panels for Radiobutton */
    if(TSUtilDlg.Dbg>3) { cP.setDebugGraphicsOptions(j); /* debug */
      RepaintManager.currentManager(cP).setDoubleBufferingEnabled(false);}
    cP.setLayout(new GridLayout(3,9)); /* init layout */
    BG1 = new ButtonGroup(); /* create basis for selection */
    for(i=0;i<Cmds.length;i+=1) { /* insert all commands */
      cRB = new JRadioButton(Cmds[i].chgFNme(null),i==0);
//      cRB.setFont(dF); /* activate new Font */
      cRB.setActionCommand(cRB.getText()); /* set action-ID */
      cRB.addActionListener(this); /* use event of this class */
      cP.add(cRB); /* add it to current panel */
      BG1.add(cRB); /* and add it to selection-group */
    } /* insert all commands */
    Scr.add(cP); /* add element to background */

    /* select global options (including log-file) */
    cP = new JPanel(); /* get Panels for 'global input' */
    if(TSUtilDlg.Dbg>3) { cP.setDebugGraphicsOptions(j); /* debug */
      RepaintManager.currentManager(cP).setDoubleBufferingEnabled(false);}
    cP.setLayout(new BoxLayout(cP,BoxLayout.Y_AXIS)); /* init layout */
    cP.setBorder(BorderFactory.createEtchedBorder());
    aP = new JPanel(); /* get Panels for 'inputline' */
    aP.add(new JLabel(TSLogg.getKey("TSDlg001"))); /* label */
    is = AppProp.getProperty(PNme12); /* initial value */
    if(is==null) is = ""; /* use empty field */
    T1 = new JTextField(is,50); /* set inputarea (global) */
    aP.add(T1); /* add inputarea to line */
    cP.add(aP); /* set first part */
    aP = new JPanel(); /* get Panels for 'log-file' */
    aP.add(new JLabel(TSLogg.getKey("TSDlg002"))); /* label */
    BG2 = new ButtonGroup(); /* create basis for selection */
    RB = new JRadioButton("None",false); /* create button */
    aP.add(RB); /* add it to current panel */
    BG2.add(RB); /* and add it to selection-group */
    cRB = new JRadioButton("\"TSUtil.log\"",cLg==null);
    cRB.setActionCommand("Log"); /* set action-ID */
    aP.add(cRB); /* add it to current panel */
    BG2.add(cRB); /* and add it to selection-group */
    cRB = new JRadioButton(TSLogg.getKey("TSDlg003"),cLg!=null);
    cRB.setActionCommand("LSel"); /* set action-ID */
    cRB.addActionListener(this); /* use event of this class */
    aP.add(cRB); /* add it to current panel */
    BG2.add(cRB); /* and add it to selection-group */
    is = AppProp.getProperty(PNme01); /* initial name */
    if(is==null) is = cD; /* use same Directory */
    if(cLg!=null) is = cLg; /* set fixed location */
    L1 = new JLabel(is); /* will be filled */
    L1.setBorder(BorderFactory.createLineBorder(Color.BLACK,2));
    L1.setPreferredSize(new Dimension(236,24));
    aP.add(L1); /* add it to sub-panel (flow) */
    cP.add(aP); /* set next part */
    aP = new JPanel(); /* get Panels for 'optionfile' */
    CB1 = new JCheckBox(TSLogg.getKey("TSDlg004"),false);
    CB1.addItemListener(this); /* use event of this class */
    aP.add(CB1); /* add Check-object to panel */
    is = AppProp.getProperty(PNme02); /* initial name */
    if(is==null) is = cD; /* use same Directory */
    L2 = new JLabel(is); /* will be filled */
    L2.setBorder(BorderFactory.createLineBorder(Color.BLACK,2));
    L2.setPreferredSize(new Dimension(400,24));
    aP.add(L2); /* add it to sub-panel (flow) */
    cP.add(aP); /* set next part */
    Scr.add(cP); /* add element to background */

    /* select local options */
    cP = new JPanel(); /* get Panels for 'local input' */
    if(TSUtilDlg.Dbg>3) { cP.setDebugGraphicsOptions(j); /* debug */
      RepaintManager.currentManager(cP).setDoubleBufferingEnabled(false);}
    cP.setLayout(new BoxLayout(cP,BoxLayout.Y_AXIS)); /* init layout */
    cP.setBorder(BorderFactory.createEtchedBorder());
    aP = new JPanel(); /* get Panels for 'inputline' */
    aP.add(new JLabel(TSLogg.getKey("TSDlg005"))); /* label */
    is = AppProp.getProperty(PNme13); /* initial value */
    if(is==null) is = ""; /* use empty field */
    T2 = new JTextField(is,50); /* set inputarea (local) */
    aP.add(T2); /* add inputarea to line */
    cP.add(aP); /* set first part */
    aP = new JPanel(); /* get Panels for 'optionfile' */
    CB2 = new JCheckBox(TSLogg.getKey("TSDlg004"),false);
    CB2.addItemListener(this); /* use event of this class */
    aP.add(CB2); /* add Check-object to panel */
    is = AppProp.getProperty(PNme03); /* initial name */
    if(is==null) is = cD; /* use same Directory */
    L3 = new JLabel(is); /* will be filled */
    L3.setBorder(BorderFactory.createLineBorder(Color.BLACK,2));
    L3.setPreferredSize(new Dimension(398,24));
    aP.add(L3); /* add it to sub-panel (flow) */
    cP.add(aP); /* set next part */
    aP = new JPanel(); /* get Panels for '-b'.option(cvrt) */
    CB7 = new JCheckBox(TSLogg.getKey("TSDlg011"),false);
    CB7.addItemListener(this); /* use event of this class */
    aP.add(CB7); /* add Check-object to panel */
    is = AppProp.getProperty(PNme07); /* initial name */
    if(is==null) is = cD; /* use same Directory */
    L7 = new JLabel(is); /* will be filled */
    L7.setBorder(BorderFactory.createLineBorder(Color.BLACK,2));
    L7.setPreferredSize(new Dimension(382,24));
    aP.add(L7); /* add it to sub-panel (flow) */
    cP.add(aP); /* set next part */
    Scr.add(cP); /* add element to background */

    /* select route-definition */
    cP = new JPanel(); /* get Panels for 'route-input' */
    if(TSUtilDlg.Dbg>3) { cP.setDebugGraphicsOptions(j); /* debug */
      RepaintManager.currentManager(cP).setDoubleBufferingEnabled(false);}
    CB3 = new JCheckBox("",false); /* will be inserted */
    CB3.addItemListener(this); /* use event of this class */
    cP.add(CB3); /* add Check-object to panel */
    is = AppProp.getProperty(PNme04); /* initial name */
    if(is==null) is = cD; /* use same Directory */
    L4 = new JLabel(is); /* will be filled */
    L4.setBorder(BorderFactory.createLineBorder(Color.BLACK,2));
    L4.setPreferredSize(new Dimension(390,24));
    cP.add(L4); /* set next part */
    Scr.add(cP); /* add element to background */

    /* select additional arguments */
    cP = new JPanel(); /* get Panels for 'additional' */
    if(TSUtilDlg.Dbg>3) { cP.setDebugGraphicsOptions(j); /* debug */
      RepaintManager.currentManager(cP).setDoubleBufferingEnabled(false);}
    cP.setLayout(new BoxLayout(cP,BoxLayout.Y_AXIS)); /* init layout */
    cP.setBorder(BorderFactory.createEtchedBorder());
    aP = new JPanel(); /* get Panels for 'inputline' */
    CB4 = new JCheckBox(TSLogg.getKey("TSDlg007"),false);
    CB4.addItemListener(this); /* use event of this class */
    aP.add(CB4); /* add Check-object to panel */
    T3 = new JTextField(46); /* set inputarea */
    aP.add(T3); /* add inputarea to line */
    cP.add(aP); /* set first part */
    aP = new JPanel(); /* get Panels for 'additional-file' */
    CB5 = new JCheckBox(TSLogg.getKey("TSDlg008"),false);
    CB5.addItemListener(this); /* use event of this class */
    aP.add(CB5); /* add Check-object to panel */
    is = AppProp.getProperty(PNme05); /* initial name */
    if(is==null) is = cD; /* use same Directory */
    L5 = new JLabel(is); /* will be filled */
    L5.setBorder(BorderFactory.createLineBorder(Color.BLACK,2));
    L5.setPreferredSize(new Dimension(402,24));
    aP.add(L5); /* add it to sub-panel (flow) */
    cP.add(aP); /* set next part */
    aP = new JPanel(); /* get Panels for 'additional-file' */
    CB6 = new JCheckBox(TSLogg.getKey("TSDlg009"),false);
    CB6.addItemListener(this); /* use event of this class */
    aP.add(CB6); /* add Check-object to panel */
    is = AppProp.getProperty(PNme06); /* initial name */
    if(is==null) is = cD; /* use same Directory */
    L6 = new JLabel(is); /* will be filled */
    L6.setBorder(BorderFactory.createLineBorder(Color.BLACK,2));
    L6.setPreferredSize(new Dimension(402,24));
    aP.add(L6); /* add it to sub-panel (flow) */
    cP.add(aP); /* set next part */
    Scr.add(cP); /* add element to background */

    /* set message-output and buttons */
    cP = new JPanel(); /* get Panels for 'message' */
    if(TSUtilDlg.Dbg>3) { cP.setDebugGraphicsOptions(j); /* debug */
      RepaintManager.currentManager(cP).setDoubleBufferingEnabled(false);}
    L9 = new JLabel(""); /* will be filled */
    L9.setBorder(BorderFactory.createLoweredBevelBorder());
    L9.setPreferredSize(new Dimension(360,24));
    cP.add(L9); /* set next part */
    cB = new JButton(TSLogg.getKey("TSDlg023")); /* Button */
    cB.setActionCommand("Can"); /* set action-ID */
    cB.addActionListener(this); /* use event of this class */
    cP.add(cB); /* insert label as a button */
    cB = new JButton("OK"); /* Button */
    cB.addActionListener(this); /* use event of this class */
    cP.add(cB); /* insert label as a button */
    Scr.add(cP); /* add element to background */

    setDyn(); /* activate new dynamic selections */

    /* add Windows-Listener to close the frame */
    addWindowListener(new TSWinEvt()); /* close window if requested */
  }

 /**. <pre>
  *=====================================================================
  * Methode "actionPerformed"
  * ##actionPerformed.TSFrame (Eyecatcher)
  *=====================================================================
  </pre>*/
  public final void actionPerformed( /*  */
   ActionEvent Ev) /* current event to handle */
   {
   /*-----------------------------------------------------------------*/
    File   cF; /* current selected file */
    String cC; /* current action-command */
    int    i;  /* intermediate value */
   /*=================================================================*/
    L9.setText(""); /* clear error */
    cC = Ev.getActionCommand(); /* get current selected action */
    if(cC.equals("Can")) { /* cancel was selected */
      try{ Que.put(rslt); /* send message: terminate */
        } catch(InterruptedException e) {};
      return; /* function processed */
    }
    for(i=0;i<Cmds.length;i+=1) /* check all function-selections */
     if(Cmds[i].chgFNme(null).equals(cC)) { /* selection found */
      if(cSel.chkMsk(1)) { /* File may be selected, reset to dir */
        cC = AppProp.getProperty(PNme04); /* initial name */
        if(cC==null) cC = cD; /* use same Directory */
        L4.setText(cC); /* reset Route-Path */
      } /* File may be selected, so reset to directory */
      cSel = Cmds[i]; /* activate current selection */
      setDyn(); /* activate new dynamic selections */
      return; /* action event successfully processed */
    } /* check all possible selections */

    if(cC.equals("LSel")) { /* new Logfile was selected */
      if(cLg==null) getFile(L1,RB,false); /* get new file */
      else L9.setText(TSLogg.getKey("TSDlg103")); /* set message */
    } else if(cC.equals("OK")) { /* check input and terminate */
      cC = BG2.getSelection().getActionCommand(); /* get current action */
      if(cLg!=null) rslt.add("-l"+cLg); /* add new Token */
      else if(cC.equals("LSel")) setFN(L1,"-l",PNme01);
        /* Log-file is selected -- processs and add to tokenlist */
      else if(cC.equals("Log")) rslt.add("-l");
        /* add token to use 'TSUtil.log' */
      if(CB1.isSelected()) setFN(L2,"-@",PNme02);
        /* optionfile(global) active -- processs and add to tokenlist */
      cC = T1.getText(); /* current input for global options */
      AppProp.setProperty(PNme12,cC); /* insert value into property-table */
      if((cC=split(cC))!=null) { /* error within tokenizing */
        rslt.clear(); /* nothing saved */
        L9.setText(cC); /* set error-message */
        return; /* display it again */
      } /* error within global options */
      cC = BG1.getSelection().getActionCommand();
      rslt.add(cC); /* add new Token */
      if(cSel.chkMsk(3) && CB2.isSelected()) setFN(L3,"-@",PNme03);
        /* optionfile(local) active -- processs and add to tokenlist */
      if(cSel.chkMsk(8) && CB7.isSelected()) setFN(L7,"-b",PNme07);
        /* '-b'-option active -- proccess and add to tokenlist */
      cC = T2.getText(); /* current input for local options */
      AppProp.setProperty(PNme13,cC); /* insert value into property-table */
      if((cC=split(cC))!=null) { /* error within tokenizing */
        rslt.clear(); /* nothing saved */
        L9.setText(cC); /* set error-message */
        return; /* display it again */
      } /* error within global options */
      if(cSel.chkMsk(7) && CB5.isSelected()) setFN(L5,"",PNme05);
        /* add additional File no. 1 if requested */
      if(cSel.chkMsk(0) && CB3.isSelected()) setFN(L4,"",PNme04);
        /* process Route-definition and add if requested */
      if(cSel.chkMsk(4) && CB4.isSelected()) { /* input allowed? */
        cC = T3.getText(); /* current input for 'additional values' */
        if((cC=split(cC))!=null) { /* error within tokenizing */
          rslt.clear(); /* nothing saved */
          L9.setText(cC); /* set error-message */
          return; /* display it again */
        } /* error within global options */
      } /* input is allowed */
      if(cSel.chkMsk(5) && CB5.isSelected()) setFN(L5,"",PNme05);
        /* add additional File no. 1 if requested */
      if(cSel.chkMsk(6) && CB6.isSelected()) setFN(L6,"",PNme06);
        /* add additional File no. 2 if requested */

      try{ Que.put(rslt); /* send message and execute */
        } catch(InterruptedException e) {};
    } else L9.setText(TSLogg.getMsg("TSDlg102",cC));
      /* error -- print message, do nothing */
  }

 /**. <pre>
  *=====================================================================
  * Method "getFile"
  * ##getFile.TSFrame (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final void getFile( /* get requested Filename and set it */
   JLabel        cL, /* Label which contains the file-name */
   JToggleButton R,  /* reference if selection fails */
   boolean       dir) /* only directories selectable ? */
   {
   /*-----------------------------------------------------------------*/
    JFileChooser fc; /* inputwindow for filename */
    File         cF; /* current selected file */
   /*=================================================================*/
    cF = new File(cL.getText()); /* get current filename within label */
    fc = new JFileChooser(cF); /* create dialog-window */
    fc.setDialogTitle(TSLogg.getKey(dir?"TSDlg022":"TSDlg021"));
    fc.setDialogType(JFileChooser.CUSTOM_DIALOG); /* set type */
    fc.setMultiSelectionEnabled(false); /* only ONE file to select */
    if(dir) fc.setFileSelectionMode(JFileChooser.DIRECTORIES_ONLY);
    if(fc.showOpenDialog(this)!=JFileChooser.APPROVE_OPTION) {
      /* get new filename and return if cancel */
      if(R==null) return; /* no action -- return immediately */
      R.doClick(); /* select a second time (switchoff/ select another) */
      return; /* cancel fully processed */
    } /* cancel was selected */
    cF = fc.getSelectedFile(); /* get new filename */
    cL.setText(cF.getAbsolutePath()); /* insert new filepath */
  }

 /**. <pre>
  *=====================================================================
  * Methode "itemStateChanged"
  * ##itemStateChanged.TSFrame (Eyecatcher)
  *=====================================================================
  </pre>*/
  public final void itemStateChanged( /*  */
   ItemEvent Ev) /* current event to handle */
   {
   /*-----------------------------------------------------------------*/
    final JCheckBox cCB; /* currently selected Checkbox */
   /*=================================================================*/
    L9.setText(""); /* clear error */
    if(Ev.getStateChange()!=ItemEvent.SELECTED) return;
    cCB = (JCheckBox)Ev.getSource(); /* get selected Checkbox */
    SwingUtilities.invokeLater( new Runnable() { public void run()
      { /* Attention: Due to Bug (ID=6924233) extra thread is used */
    if(cCB==CB1) getFile(L2,CB1,false); /* global optionfile */
    else if(cCB==CB2) getFile(L3,CB2,false); /* local optionfile */
    else if(cCB==CB3) getFile(L4,CB3,!cSel.chkMsk(1)); /* route-select */
    else if(cCB==CB4) ; /* no action required */
    else if(cCB==CB5) getFile(L5,CB5,true); /* directory-select */
    else if(cCB==CB6) getFile(L6,CB6,true); /* directory-select */
    else if(cCB==CB7) getFile(L7,CB7,false); /* '-b'-optionfile */
    else L9.setText(TSLogg.getKey("TSDlg101"));
      /* error -- print message, do nothing */
      }}); /* extra thread ends here */
  }

 /**. <pre>
  *=====================================================================
  * Method "setDyn"
  * ##setDyn.TSFrame (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final void setDyn() /* set dynamic attributes of the fields */
   {
   /*-----------------------------------------------------------------*/
                                            /* no local definitions */
   /*=================================================================*/
    CB3.setEnabled(cSel.chkMsk(0)); /* control Route-selection */
    CB2.setEnabled(cSel.chkMsk(3)); /* control local optionfile */
    CB4.setEnabled(cSel.chkMsk(4)); /* control additional input */
    CB5.setEnabled(cSel.chkMsk(5)||cSel.chkMsk(7)); /* add. directory */
    CB6.setEnabled(cSel.chkMsk(6)); /* control add. directory */
    CB7.setEnabled(cSel.chkMsk(8)); /* control '-b'-optionfile */
    if(cSel.chkMsk(1)) CB3.setText(TSLogg.getKey("TSDlg010"));
    else CB3.setText(TSLogg.getKey("TSDlg006"));
  }

 /**. <pre>
  *=====================================================================
  * Method "setFN"
  * ##setFN.TSFrame (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final void setFN( /* set Filename-Token */
   JLabel cL, /* Label which contains the file-name */
   String Id, /* ID of Token */
   String cP) /* name of property */
   {
   /*-----------------------------------------------------------------*/
    File   cF; /* current selected file */
    String cC; /* current File-Name */
   /*=================================================================*/
    cC = cL.getText(); /* get name of file/dir */
    cF = new File(cC); /* translate it to file */
    if(!cF.isDirectory()) cF = cF.getParentFile(); /* change to dir */
    AppProp.setProperty(cP,cF.getAbsolutePath());
      /* insert new directory into property-table */
    cC = Id + cC; /* add ID of Statement */
    rslt.add(cC); /* add new Token */
    return; /* return from method */
  }

 /**. <pre>
  *=====================================================================
  * Method "split"
  * This method removes quotes if token is surrounded by them
  * ##split.TSFrame (Eyecatcher)
  *=====================================================================
  </pre>*/
  private final String split( /* tokenize string */
   String s) /* string contains commands separated by 'whitechar' */
   {
   /*-----------------------------------------------------------------*/
    StringBuilder t; /* temporary storage */
    int  p,b,f; /* pointer to command-string */
    int  m;   /* current mode (refer to method for assignment) */
    char cc;  /* current char to examine */
   /*=================================================================*/
    t = new StringBuilder(s); /* convert data to mutable object */
    b = m = 0; /* set mode to 'search for start' */
    f = -2; /* initialize to invalid value */
    for(p=0;p<t.length();p+=1) { /* check all character */
      cc = t.charAt(p); /* get current char */
      switch(m) { /* check character due to mode */
        case(0): /* mode is: 'search for start' */
          if(Character.isWhitespace(cc)) break; /* blank found */
          if(cc=='"') m = 3; /* set mode to 'quoted string' (external) */
          else m = 1; /* set mode to 'UNquoted string' */
          b = p; /* mark beginning */
          break; /* mode was: 'search for start' */
        case(1): /* mode is: 'UNquoted string' */
          if(cc=='"') m = 2; /* set mode to 'internal quoted string' */
          if(!Character.isWhitespace(cc)) break; /* continue */
            /* 'unquoted string' continues (perhaps with 'int quoted'*/
          /* 'whitechar' found -- store complete unquoted string */
          m = 0; /* set mode to 'search for start' */
          rslt.add(t.substring(b,p)); /* set next token */
          b = p; /* mark beginning of new token */
          break; /* mode was: 'UNquoted string' */
        case(2): /* mode is: 'internal quoted string' */
          if(cc=='\\') f = p; /* mark presence of '\' */
          if(cc!='"') break; /* string continues */
          if((f+1)==p) break; /* '\"' has been found -- continue */
          m = 1; /* set mode to 'UNquoted string' */
          break; /* mode was: ' internal quoted string' */
        case(3): /* mode is: 'quoted string' (external) */
          if(cc=='\\') f = p; /* mark presence of '\' */
          if(cc!='"') break; /* string continues */
          if((f+1)==p) { /* '\"' has been found */
            t.deleteCharAt(f); /* delete '\' from data */
            p = f; /* move pointer back one character */
            f = -2; /* set to invalid value */
            break; /* string continues */
          } /* '\" has been processed */
          rslt.add(t.substring(b+1,p)); /* set next token */
            /* do not store quotes (=> b+1) */
          m = 0; /* set mode to 'search for start' */
          break; /* mode was: 'quoted string' */
      }  /* check character due to mode */
    } /* process all character */
    if(m>1) return TSLogg.getMsg("TSDlg111",t.substring(b));
    if(m==1) rslt.add(t.substring(b)); /* set last token */
    return null; /* no error found */
  }

  /**. <pre>
   *====================================================================
   * Sub-Class "TSWinEvt"
   *
   * ##TSWinEvt.TSFrame (Eyecatcher)
   *====================================================================
   </pre>*/
  class TSWinEvt extends WindowAdapter { /* Window/Frame-events */
   /*-----------------------------------------------------------------*/
                            /* no definitions of instance-variables */
   /**. <pre>
    *===================================================================
    * Constructor: (1) create default-entry
    *===================================================================
    </pre>*/
    protected TSWinEvt() /*  */
     {
     /*---------------------------------------------------------------*/
                                            /* no local definitions */
     /*===============================================================*/
    }

   /**. <pre>
    *===================================================================
    * Methode "windowClosing"
    * ##windowClosing.TSWinEvt.TSFrame (Eyecatcher)
    *===================================================================
    </pre>*/
    public final void windowClosing( /* window will be closed */
     WindowEvent Ev) /* Event-definition */
     {
     /*---------------------------------------------------------------*/
                                            /* no local definitions */
     /*===============================================================*/
      L6.setText(""); /* clear error */
      try{ Que.put(rslt); /* send message: terminate */
        } catch(InterruptedException e) {};
    }

   /*=================================================================*/
  }

 /**==================================================================*/
}

// class X { protected X() {throw new Error("Debug-Message");}}

 